/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/map","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(K){for(var e=[],P=0,O=K.length;P<O;P++)e[P]=te[K[P]];return e};define(te[133],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function P(m,d,c){const a=O(m,d);if(a!==-1)return m[a]}e.$db=P;function O(m,d,c=m.length-1){for(let a=c;a>=0;a--){const $=m[a];if(d($))return a}return-1}e.$eb=O;function s(m,d){const c=M(m,d);return c===-1?void 0:m[c]}e.$fb=s;function M(m,d,c=0,a=m.length){let $=c,E=a;for(;$<E;){const g=Math.floor(($+E)/2);d(m[g])?$=g+1:E=g}return $-1}e.$gb=M;function I(m,d){const c=S(m,d);return c===m.length?void 0:m[c]}e.$hb=I;function S(m,d,c=0,a=m.length){let $=c,E=a;for(;$<E;){const g=Math.floor(($+E)/2);d(m[g])?E=g:$=g+1}return $}e.$ib=S;function h(m,d,c=0,a=m.length){const $=S(m,d,c,a);return $===m.length?-1:$}e.$jb=h;class l{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(l.assertInvariants){if(this.d){for(const a of this.e)if(this.d(a)&&!d(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const c=M(this.e,d,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$kb=l;function b(m,d){if(m.length===0)return;let c=m[0];for(let a=1;a<m.length;a++){const $=m[a];d($,c)>0&&(c=$)}return c}e.$lb=b;function w(m,d){if(m.length===0)return;let c=m[0];for(let a=1;a<m.length;a++){const $=m[a];d($,c)>=0&&(c=$)}return c}e.$mb=w;function p(m,d){return b(m,(c,a)=>-d(c,a))}e.$nb=p;function f(m,d){if(m.length===0)return-1;let c=0;for(let a=1;a<m.length;a++){const $=m[a];d($,m[c])>0&&(c=a)}return c}e.$ob=f;function y(m,d){for(const c of m){const a=d(c);if(a!==void 0)return a}}e.$pb=y}),define(te[134],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function P(I,S){const h=Object.create(null);for(const l of I){const b=S(l);let w=h[b];w||(w=h[b]=[]),w.push(l)}return h}e.$I=P;function O(I,S){const h=[],l=[];for(const b of I)S.has(b)||h.push(b);for(const b of S)I.has(b)||l.push(b);return{removed:h,added:l}}e.$J=O;function s(I,S){const h=[],l=[];for(const[b,w]of I)S.has(b)||h.push(w);for(const[b,w]of S)I.has(b)||l.push(w);return{removed:h,added:l}}e.$K=s;class M{constructor(){this.a=new Map}add(S,h){let l=this.a.get(S);l||(l=new Set,this.a.set(S,l)),l.add(h)}delete(S,h){const l=this.a.get(S);l&&(l.delete(h),l.size===0&&this.a.delete(S))}forEach(S,h){const l=this.a.get(S);l&&l.forEach(h)}get(S){const h=this.a.get(S);return h||new Set}}e.$L=M}),define(te[135],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=e.$Ms=e.$Ls=e.$Ks=void 0;function P(S,h){const l=Math.pow(10,h);return Math.round(S*l)/l}class O{constructor(h,l,b,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=P(Math.max(Math.min(1,w),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}e.$Ks=O;class s{constructor(h,l,b,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.l=P(Math.max(Math.min(1,b),0),3),this.a=P(Math.max(Math.min(1,w),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,b=h.g/255,w=h.b/255,p=h.a,f=Math.max(l,b,w),y=Math.min(l,b,w);let m=0,d=0;const c=(y+f)/2,a=f-y;if(a>0){switch(d=Math.min(c<=.5?a/(2*c):a/(2-2*c),1),f){case l:m=(b-w)/a+(b<w?6:0);break;case b:m=(w-l)/a+2;break;case w:m=(l-b)/a+4;break}m*=60,m=Math.round(m)}return new s(m,d,c,p)}static i(h,l,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?h+(l-h)*6*b:b<1/2?l:b<2/3?h+(l-h)*(2/3-b)*6:h}static toRGBA(h){const l=h.h/360,{s:b,l:w,a:p}=h;let f,y,m;if(b===0)f=y=m=w;else{const d=w<.5?w*(1+b):w+b-w*b,c=2*w-d;f=s.i(c,d,l+1/3),y=s.i(c,d,l),m=s.i(c,d,l-1/3)}return new O(Math.round(f*255),Math.round(y*255),Math.round(m*255),p)}}e.$Ls=s;class M{constructor(h,l,b,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.v=P(Math.max(Math.min(1,b),0),3),this.a=P(Math.max(Math.min(1,w),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,b=h.g/255,w=h.b/255,p=Math.max(l,b,w),f=Math.min(l,b,w),y=p-f,m=p===0?0:y/p;let d;return y===0?d=0:p===l?d=((b-w)/y%6+6)%6:p===b?d=(w-l)/y+2:d=(l-b)/y+4,new M(Math.round(d*60),m,p,h.a)}static toRGBA(h){const{h:l,s:b,v:w,a:p}=h,f=w*b,y=f*(1-Math.abs(l/60%2-1)),m=w-f;let[d,c,a]=[0,0,0];return l<60?(d=f,c=y):l<120?(d=y,c=f):l<180?(c=f,a=y):l<240?(c=y,a=f):l<300?(d=y,a=f):l<=360&&(d=f,a=y),d=Math.round((d+m)*255),c=Math.round((c+m)*255),a=Math.round((a+m)*255),new O(d,c,a,p)}}e.$Ms=M;class I{static fromHex(h){return I.Format.CSS.parseHex(h)||I.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof O)this.rgba=h;else if(h instanceof s)this.i=h,this.rgba=s.toRGBA(h);else if(h instanceof M)this.j=h,this.rgba=M.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&O.equals(this.rgba,h.rgba)&&s.equals(this.hsla,h.hsla)&&M.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=I.k(this.rgba.r),l=I.k(this.rgba.g),b=I.k(this.rgba.b),w=.2126*h+.7152*l+.0722*b;return P(w,4)}static k(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(h){const l=this.getRelativeLuminance(),b=h.getRelativeLuminance();return l>b?(l+.05)/(b+.05):(b+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),b=h.getRelativeLuminance();return l>b}isDarkerThan(h){const l=this.getRelativeLuminance(),b=h.getRelativeLuminance();return l<b}lighten(h){return new I(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new I(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:b,b:w,a:p}=this.rgba;return new I(new O(l,b,w,p*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new I(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const l=h.rgba,b=this.rgba.a,w=l.a,p=b+w*(1-b);if(p<1e-6)return I.transparent;const f=this.rgba.r*b/p+l.r*w*(1-b)/p,y=this.rgba.g*b/p+l.g*w*(1-b)/p,m=this.rgba.b*b/p+l.b*w*(1-b)/p;return new I(new O(f,y,m,p))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:b,b:w,a:p}=this.rgba;return new I(new O(h.rgba.r-p*(h.rgba.r-l),h.rgba.g-p*(h.rgba.g-b),h.rgba.b-p*(h.rgba.b-w),1))}flatten(...h){const l=h.reduceRight((b,w)=>I.o(w,b));return I.o(this,l)}static o(h,l){const b=1-h.rgba.a;return new I(new O(b*l.rgba.r+h.rgba.a*h.rgba.r,b*l.rgba.g+h.rgba.a*h.rgba.g,b*l.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=I.Format.CSS.format(this)),this.u}static getLighterColor(h,l,b){if(h.isLighterThan(l))return h;b=b||.5;const w=h.getRelativeLuminance(),p=l.getRelativeLuminance();return b=b*(p-w)/p,h.lighten(b)}static getDarkerColor(h,l,b){if(h.isDarkerThan(l))return h;b=b||.5;const w=h.getRelativeLuminance(),p=l.getRelativeLuminance();return b=b*(w-p)/w,h.darken(b)}static{this.white=new I(new O(255,255,255,1))}static{this.black=new I(new O(0,0,0,1))}static{this.red=new I(new O(255,0,0,1))}static{this.blue=new I(new O(0,0,255,1))}static{this.green=new I(new O(0,255,0,1))}static{this.cyan=new I(new O(0,255,255,1))}static{this.lightgrey=new I(new O(211,211,211,1))}static{this.transparent=new I(new O(0,0,0,0))}}e.$Ns=I,function(S){let h;(function(l){let b;(function(w){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}w.formatRGB=p;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}w.formatRGBA=f;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}w.formatHSL=y;function m(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}w.formatHSLA=m;function d(t){const u=t.toString(16);return u.length!==2?"0"+u:u}function c(t){return`#${d(t.rgba.r)}${d(t.rgba.g)}${d(t.rgba.b)}`}w.formatHex=c;function a(t,u=!1){return u&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${d(t.rgba.r)}${d(t.rgba.g)}${d(t.rgba.b)}${d(Math.round(t.rgba.a*255))}`}w.formatHexA=a;function $(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}w.format=$;function E(t){const u=t.length;if(u===0||t.charCodeAt(0)!==35)return null;if(u===7){const r=16*g(t.charCodeAt(1))+g(t.charCodeAt(2)),i=16*g(t.charCodeAt(3))+g(t.charCodeAt(4)),n=16*g(t.charCodeAt(5))+g(t.charCodeAt(6));return new S(new O(r,i,n,1))}if(u===9){const r=16*g(t.charCodeAt(1))+g(t.charCodeAt(2)),i=16*g(t.charCodeAt(3))+g(t.charCodeAt(4)),n=16*g(t.charCodeAt(5))+g(t.charCodeAt(6)),o=16*g(t.charCodeAt(7))+g(t.charCodeAt(8));return new S(new O(r,i,n,o/255))}if(u===4){const r=g(t.charCodeAt(1)),i=g(t.charCodeAt(2)),n=g(t.charCodeAt(3));return new S(new O(16*r+r,16*i+i,16*n+n))}if(u===5){const r=g(t.charCodeAt(1)),i=g(t.charCodeAt(2)),n=g(t.charCodeAt(3)),o=g(t.charCodeAt(4));return new S(new O(16*r+r,16*i+i,16*n+n,(16*o+o)/255))}return null}w.parseHex=E;function g(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=l.CSS||(l.CSS={}))})(h=S.Format||(S.Format={}))}(I||(e.$Ns=I={}))}),define(te[55],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.$6g=e.$5g=void 0;function P(I){return(S,h,l)=>{let b=null,w=null;if(typeof l.value=="function"?(b="value",w=l.value):typeof l.get=="function"&&(b="get",w=l.get),!w)throw new Error("not supported");l[b]=I(w,h)}}function O(I,S,h){let l=null,b=null;if(typeof h.value=="function"?(l="value",b=h.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",b=h.get),!b)throw new Error("not supported");const w=`$memoize$${S}`;h[l]=function(...p){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,p)}),this[w]}}e.$5g=O;function s(I,S,h){return P((l,b)=>{const w=`$debounce$${b}`,p=`$debounce$result$${b}`;return function(...f){this[p]||(this[p]=h?h():void 0),clearTimeout(this[w]),S&&(this[p]=S(this[p],...f),f=[this[p]]),this[w]=setTimeout(()=>{l.apply(this,f),this[p]=h?h():void 0},I)}})}e.$6g=s;function M(I,S,h){return P((l,b)=>{const w=`$throttle$timer$${b}`,p=`$throttle$result$${b}`,f=`$throttle$lastRun$${b}`,y=`$throttle$pending$${b}`;return function(...m){if(this[p]||(this[p]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[p]=S(this[p],...m)),this[y])return;const d=this[f]+I;d<=Date.now()?(this[f]=Date.now(),l.apply(this,[this[p]]),this[p]=h?h():void 0):(this[y]=!0,this[w]=setTimeout(()=>{this[y]=!1,this[f]=Date.now(),l.apply(this,[this[p]]),this[p]=h?h():void 0},d-Date.now()))}})}e.$7g=M}),define(te[14],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?$.isErrorNoTelemetry(t)?new $(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(u=>{u(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=P,e.$V=new P;function O(g){e.$V.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=O;function s(g){if(!g||typeof g!="object")return!1;const t=g;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=s;function M(g){l(g)||e.$V.onUnexpectedError(g)}e.$Y=M;function I(g){l(g)||e.$V.onUnexpectedExternalError(g)}e.$Z=I;function S(g){if(g instanceof Error){const{name:t,message:u}=g,r=g.stacktrace||g.stack;return{$isError:!0,name:t,message:u,stack:r,noTelemetry:$.isErrorNoTelemetry(g)}}return g}e.$1=S;const h="Canceled";function l(g){return g instanceof b?!0:g instanceof Error&&g.name===h&&g.message===h}e.$2=l;class b extends Error{constructor(){super(h),this.name=this.message}}e.$3=b;function w(){const g=new Error(h);return g.name=g.message,g}e.$4=w;function p(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.$5=p;function f(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.$6=f;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=y;function m(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.$8=m;class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=d;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=c;class a extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=a;class $ extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof $)return t;const u=new $;return u.message=t.message,u.stack=t.stack,u}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=$;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$ab=E}),define(te[23],ie([0,1,14,133]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.$4b=e.CompareResult=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.top=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function s(F,W=0){return F[F.length-(1+W)]}e.$qb=s;function M(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$rb=M;function I(F,W,q=(V,re)=>V===re){if(F===W)return!0;if(!F||!W||F.length!==W.length)return!1;for(let V=0,re=F.length;V<re;V++)if(!q(F[V],W[V]))return!1;return!0}e.$sb=I;function S(F,W){const q=F.length-1;W<q&&(F[W]=F[q]),F.pop()}e.$tb=S;function h(F,W,q){return l(F.length,V=>q(F[V],W))}e.$ub=h;function l(F,W){let q=0,V=F-1;for(;q<=V;){const re=(q+V)/2|0,$e=W(re);if($e<0)q=re+1;else if($e>0)V=re-1;else return re}return-(q+1)}e.$vb=l;function b(F,W,q){if(F=F|0,F>=W.length)throw new TypeError("invalid index");const V=W[Math.floor(W.length*Math.random())],re=[],$e=[],de=[];for(const ue of W){const be=q(ue,V);be<0?re.push(ue):be>0?$e.push(ue):de.push(ue)}return F<re.length?b(F,re,q):F<re.length+de.length?de[0]:b(F-(re.length+de.length),$e,q)}e.$wb=b;function w(F,W){const q=[];let V;for(const re of F.slice(0).sort(W))!V||W(V[0],re)!==0?(V=[re],q.push(V)):V.push(re);return q}e.$xb=w;function*p(F,W){let q,V;for(const re of F)V!==void 0&&W(V,re)?q.push(re):(q&&(yield q),q=[re]),V=re;q&&(yield q)}e.$yb=p;function f(F,W){for(let q=0;q<=F.length;q++)W(q===0?void 0:F[q-1],q===F.length?void 0:F[q])}e.$zb=f;function y(F,W,q){const V=[];function re(ue,be,me){if(be===0&&me.length===0)return;const Se=V[V.length-1];Se&&Se.start+Se.deleteCount===ue?(Se.deleteCount+=be,Se.toInsert.push(...me)):V.push({start:ue,deleteCount:be,toInsert:me})}let $e=0,de=0;for(;;){if($e===F.length){re($e,0,W.slice(de));break}if(de===W.length){re($e,F.length-$e,[]);break}const ue=F[$e],be=W[de],me=q(ue,be);me===0?($e+=1,de+=1):me<0?(re($e,1,[]),$e+=1):me>0&&(re($e,0,[be]),de+=1)}return V}e.$Ab=y;function m(F,W,q){const V=y(F,W,q),re=[],$e=[];for(const de of V)re.push(...F.slice(de.start,de.start+de.deleteCount)),$e.push(...de.toInsert);return{removed:re,added:$e}}e.$Bb=m;function d(F,W,q){if(q===0)return[];const V=F.slice(0,q).sort(W);return a(F,W,V,q,F.length),V}e.top=d;function c(F,W,q,V,re){return q===0?Promise.resolve([]):new Promise(($e,de)=>{(async()=>{const ue=F.length,be=F.slice(0,q).sort(W);for(let me=q,Se=Math.min(q+V,ue);me<ue;me=Se,Se=Math.min(Se+V,ue)){if(me>q&&await new Promise(Ie=>setTimeout(Ie)),re&&re.isCancellationRequested)throw new P.$3;a(F,W,be,me,Se)}return be})().then($e,de)})}e.$Db=c;function a(F,W,q,V,re){for(const $e=q.length;V<re;V++){const de=F[V];if(W(de,q[$e-1])<0){q.pop();const ue=(0,O.$ib)(q,be=>W(de,be)<0);q.splice(ue,0,de)}}}function $(F){return F.filter(W=>!!W)}e.$Eb=$;function E(F){let W=0;for(let q=0;q<F.length;q++)F[q]&&(F[W]=F[q],W+=1);F.length=W}e.$Fb=E;function g(F,W,q){F.splice(q,0,F.splice(W,1)[0])}e.$Gb=g;function t(F){return!Array.isArray(F)||F.length===0}e.$Hb=t;function u(F){return Array.isArray(F)&&F.length>0}e.$Ib=u;function r(F,W=q=>q){const q=new Set;return F.filter(V=>{const re=W(V);return q.has(re)?!1:(q.add(re),!0)})}e.$Jb=r;function i(F){const W=new Set;return q=>{const V=F(q);return W.has(V)?!1:(W.add(V),!0)}}e.$Kb=i;function n(F,W){return F.length>0?F[0]:W}e.$Lb=n;function o(F,W){return F.length>0?F[F.length-1]:W}e.$Mb=o;function k(F,W,q=(V,re)=>V===re){let V=0;for(let re=0,$e=Math.min(F.length,W.length);re<$e&&q(F[re],W[re]);re++)V++;return V}e.$Nb=k;function A(F){return[].concat(...F)}e.$Ob=A;function D(F,W){let q=typeof W=="number"?F:0;typeof W=="number"?q=F:(q=0,W=F);const V=[];if(q<=W)for(let re=q;re<W;re++)V.push(re);else for(let re=q;re>W;re--)V.push(re);return V}e.$Pb=D;function v(F,W,q){return F.reduce((V,re)=>(V[W(re)]=q?q(re):re,V),Object.create(null))}e.$Qb=v;function C(F,W){return F.push(W),()=>L(F,W)}e.$Rb=C;function L(F,W){const q=F.indexOf(W);if(q>-1)return F.splice(q,1),W}e.$Sb=L;function T(F,W,q){const V=F.slice(0,W),re=F.slice(W);return V.concat(q,re)}e.$Tb=T;function z(F,W){let q;if(typeof W=="number"){let V=W;q=()=>{const re=Math.sin(V++)*179426549;return re-Math.floor(re)}}else q=Math.random;for(let V=F.length-1;V>0;V-=1){const re=Math.floor(q()*(V+1)),$e=F[V];F[V]=F[re],F[re]=$e}}e.$Ub=z;function se(F,W){const q=F.indexOf(W);q>-1&&(F.splice(q,1),F.unshift(W))}e.$Vb=se;function ee(F,W){const q=F.indexOf(W);q>-1&&(F.splice(q,1),F.push(W))}e.$Wb=ee;function ae(F,W){for(const q of W)F.push(q)}e.$Xb=ae;function ne(F,W){return Array.isArray(F)?F.map(W):W(F)}e.$Yb=ne;function oe(F){return Array.isArray(F)?F:[F]}e.$Zb=oe;function G(F){return F[Math.floor(Math.random()*F.length)]}e.$1b=G;function J(F,W,q){const V=U(F,W),re=F.length,$e=q.length;F.length=re+$e;for(let de=re-1;de>=V;de--)F[de+$e]=F[de];for(let de=0;de<$e;de++)F[de+V]=q[de]}e.$2b=J;function B(F,W,q,V){const re=U(F,W);let $e=F.splice(re,q);return $e===void 0&&($e=[]),J(F,re,V),$e}e.$3b=B;function U(F,W){return W<0?Math.max(W+F.length,0):Math.min(W,F.length)}var N;(function(F){function W($e){return $e<0}F.isLessThan=W;function q($e){return $e<=0}F.isLessThanOrEqual=q;function V($e){return $e>0}F.isGreaterThan=V;function re($e){return $e===0}F.isNeitherLessOrGreaterThan=re,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(N||(e.CompareResult=N={}));function H(F,W){return(q,V)=>W(F(q),F(V))}e.$4b=H;function Q(...F){return(W,q)=>{for(const V of F){const re=V(W,q);if(!N.isNeitherLessOrGreaterThan(re))return re}return N.neitherLessOrGreaterThan}}e.$5b=Q;const x=(F,W)=>F-W;e.$6b=x;const ce=(F,W)=>(0,e.$6b)(F?1:0,W?1:0);e.$7b=ce;function Y(F){return(W,q)=>-F(W,q)}e.$8b=Y;class R{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let q=this.c;for(;q<this.g.length&&W(this.g[q]);)q++;const V=q===this.c?null:this.g.slice(this.c,q);return this.c=q,V}takeFromEndWhile(W){let q=this.d;for(;q>=0&&W(this.g[q]);)q--;const V=q===this.d?null:this.g.slice(q+1,this.d+1);return this.d=q,V}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const q=this.g.slice(this.c,this.c+W);return this.c+=W,q}}e.$9b=R;class j{static{this.empty=new j(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(q=>(W(q),!0))}toArray(){const W=[];return this.iterate(q=>(W.push(q),!0)),W}filter(W){return new j(q=>this.iterate(V=>W(V)?q(V):!0))}map(W){return new j(q=>this.iterate(V=>q(W(V))))}some(W){let q=!1;return this.iterate(V=>(q=W(V),!q)),q}findFirst(W){let q;return this.iterate(V=>W(V)?(q=V,!1):!0),q}findLast(W){let q;return this.iterate(V=>(W(V)&&(q=V),!0)),q}findLastMaxBy(W){let q,V=!0;return this.iterate(re=>((V||N.isGreaterThan(W(re,q)))&&(V=!1,q=re),!0)),q}}e.$0b=j}),define(te[136],ie([0,1,14]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xc=e.$wc=e.$vc=e.$uc=e.ok=void 0;function O(h,l){if(!h)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=O;function s(h,l="Unreachable"){throw new Error(l)}e.$uc=s;function M(h){if(!h)throw new P.$ab("Assertion Failed")}e.$vc=M;function I(h){if(!h()){debugger;h(),(0,P.$Y)(new P.$ab("Assertion Failed"))}}e.$wc=I;function S(h,l){let b=0;for(;b<h.length-1;){const w=h[b],p=h[b+1];if(!l(w,p))return!1;b++}return!0}e.$xc=S}),define(te[49],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function P(O){const s=this;let M=!1,I;return function(){return M||(M=!0,I=O.apply(s,arguments)),I}}e.$bb=P}),define(te[68],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(O){function s(E){return E&&typeof E=="object"&&typeof E[Symbol.iterator]=="function"}O.is=s;const M=Object.freeze([]);function I(){return M}O.empty=I;function*S(E){yield E}O.single=S;function h(E){return s(E)?E:S(E)}O.wrap=h;function l(E){return E||M}O.from=l;function b(E){return!E||E[Symbol.iterator]().next().done===!0}O.isEmpty=b;function w(E){return E[Symbol.iterator]().next().value}O.first=w;function p(E,g){for(const t of E)if(g(t))return!0;return!1}O.some=p;function f(E,g){for(const t of E)if(g(t))return t}O.find=f;function*y(E,g){for(const t of E)g(t)&&(yield t)}O.filter=y;function*m(E,g){let t=0;for(const u of E)yield g(u,t++)}O.map=m;function*d(...E){for(const g of E)for(const t of g)yield t}O.concat=d;function c(E,g,t){let u=t;for(const r of E)u=g(u,r);return u}O.reduce=c;function*a(E,g,t=E.length){for(g<0&&(g+=E.length),t<0?t+=E.length:t>E.length&&(t=E.length);g<t;g++)yield E[g]}O.slice=a;function $(E,g=Number.POSITIVE_INFINITY){const t=[];if(g===0)return[t,E];const u=E[Symbol.iterator]();for(let r=0;r<g;r++){const i=u.next();if(i.done)return[t,O.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return u}}]}O.consume=$})(P||(e.Iterable=P={}))}),define(te[44],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function I(t,u=!1){let r=0;const i=t.length;let n="",o=0,k=16,A=0;function D(ee){let ae=0,ne=0;for(;ae<ee;){const oe=t.charCodeAt(r);if(oe>=48&&oe<=57)ne=ne*16+oe-48;else if(oe>=65&&oe<=70)ne=ne*16+oe-65+10;else if(oe>=97&&oe<=102)ne=ne*16+oe-97+10;else break;r++,ae++}return ae<ee&&(ne=-1),ne}function v(ee){r=ee,n="",o=0,k=16,A=0}function C(){const ee=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return A=3,t.substring(ee,r);let ae=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;ae=r}else A=3;return t.substring(ee,ae)}function L(){let ee="",ae=r;for(;;){if(r>=i){ee+=t.substring(ae,r),A=2;break}const ne=t.charCodeAt(r);if(ne===34){ee+=t.substring(ae,r),r++;break}if(ne===92){if(ee+=t.substring(ae,r),r++,r>=i){A=2;break}switch(t.charCodeAt(r++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:{const G=D(4);G>=0?ee+=String.fromCharCode(G):A=4;break}default:A=5}ae=r;continue}if(ne>=0&&ne<=31)if(h(ne)){ee+=t.substring(ae,r),A=2;break}else A=6;r++}return ee}function T(){if(n="",A=0,o=r,r>=i)return o=i,k=17;let ee=t.charCodeAt(r);if(S(ee)){do r++,n+=String.fromCharCode(ee),ee=t.charCodeAt(r);while(S(ee));return k=15}if(h(ee))return r++,n+=String.fromCharCode(ee),ee===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),k=14;switch(ee){case 123:return r++,k=1;case 125:return r++,k=2;case 91:return r++,k=3;case 93:return r++,k=4;case 58:return r++,k=6;case 44:return r++,k=5;case 34:return r++,n=L(),k=10;case 47:{const ae=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!h(t.charCodeAt(r));)r++;return n=t.substring(ae,r),k=12}if(t.charCodeAt(r+1)===42){r+=2;const ne=i-1;let oe=!1;for(;r<ne;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,oe=!0;break}r++}return oe||(r++,A=1),n=t.substring(ae,r),k=13}return n+=String.fromCharCode(ee),r++,k=16}case 45:if(n+=String.fromCharCode(ee),r++,r===i||!l(t.charCodeAt(r)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=C(),k=11;default:for(;r<i&&z(ee);)r++,ee=t.charCodeAt(r);if(o!==r){switch(n=t.substring(o,r),n){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return n+=String.fromCharCode(ee),r++,k=16}}function z(ee){if(S(ee)||h(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ee;do ee=T();while(ee>=12&&ee<=15);return ee}return{setPosition:v,getPosition:()=>r,scan:u?se:T,getToken:()=>k,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>A}}e.$Im=I;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function w(t,u){const r=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function A(D,v,C,L){o.value=D,o.offset=v,o.length=C,o.type=L,o.colonOffset=void 0,n=o}try{$(t,{onObjectBegin:(D,v)=>{if(u<=D)throw i;n=void 0,k=u>D,r.push("")},onObjectProperty:(D,v,C)=>{if(u<v||(A(D,v,C,"property"),r[r.length-1]=D,u<=v+C))throw i},onObjectEnd:(D,v)=>{if(u<=D)throw i;n=void 0,r.pop()},onArrayBegin:(D,v)=>{if(u<=D)throw i;n=void 0,r.push(0)},onArrayEnd:(D,v)=>{if(u<=D)throw i;n=void 0,r.pop()},onLiteralValue:(D,v,C)=>{if(u<v||(A(D,v,C,g(D)),u<=v+C))throw i},onSeparator:(D,v,C)=>{if(u<=v)throw i;if(D===":"&&n&&n.type==="property")n.colonOffset=v,k=!1,n=void 0;else if(D===","){const L=r[r.length-1];typeof L=="number"?r[r.length-1]=L+1:(k=!0,r[r.length-1]=""),n=void 0}}})}catch(D){if(D!==i)throw D}return{path:r,previousNode:n,isAtPropertyKey:k,matches:D=>{let v=0;for(let C=0;v<D.length&&C<r.length;C++)if(D[v]===r[C]||D[v]==="*")v++;else if(D[v]!=="**")return!1;return v===D.length}}}e.$Jm=w;function p(t,u=[],r=M.DEFAULT){let i=null,n=[];const o=[];function k(D){Array.isArray(n)?n.push(D):i!==null&&(n[i]=D)}return $(t,{onObjectBegin:()=>{const D={};k(D),o.push(n),n=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const D=[];k(D),o.push(n),n=D,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:k,onError:(D,v,C)=>{u.push({error:D,offset:v,length:C})}},r),n[0]}e.$Km=p;function f(t,u=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function o(D){return i.children.push(D),D}$(t,{onObjectBegin:D=>{i=o({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,v,C)=>{i=o({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:v,length:C,parent:i})},onObjectEnd:(D,v)=>{i.length=D+v-i.offset,i=i.parent,n(D+v)},onArrayBegin:(D,v)=>{i=o({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,v)=>{i.length=D+v-i.offset,i=i.parent,n(D+v)},onLiteralValue:(D,v,C)=>{o({type:g(D),offset:v,length:C,parent:i,value:D}),n(v+C)},onSeparator:(D,v,C)=>{i.type==="property"&&(D===":"?i.colonOffset=v:D===","&&n(v))},onError:(D,v,C)=>{u.push({error:D,offset:v,length:C})}},r);const A=i.children[0];return A&&delete A.parent,A}e.$Lm=f;function y(t,u){if(!t)return;let r=t;for(const i of u)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$Mm=y;function m(t){if(!t.parent||!t.parent.children)return[];const u=m(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;u.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&u.push(r)}return u}e.$Nm=m;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const u=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(u[r.children[0].value]=d(i))}return u}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Om=d;function c(t,u,r=!1){return u>=t.offset&&u<t.offset+t.length||r&&u===t.offset+t.length}e.$Pm=c;function a(t,u,r=!1){if(c(t,u,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=u;n++){const o=a(i[n],u,r);if(o)return o}return t}}e.$Qm=a;function $(t,u,r=M.DEFAULT){const i=I(t,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Q){return Q?x=>Q(x,i.getTokenOffset(),i.getTokenLength()):()=>!0}const k=n(u.onObjectBegin),A=o(u.onObjectProperty),D=n(u.onObjectEnd),v=n(u.onArrayBegin),C=n(u.onArrayEnd),L=o(u.onLiteralValue),T=o(u.onSeparator),z=n(u.onComment),se=o(u.onError),ee=r&&r.disallowComments,ae=r&&r.allowTrailingComma;function ne(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:ee||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(Q){case 12:case 13:ee?oe(10):z();break;case 16:oe(1);break;case 15:case 14:break;default:return Q}}}function oe(Q,x=[],ce=[]){if(se(Q),x.length+ce.length>0){let Y=i.getToken();for(;Y!==17;){if(x.indexOf(Y)!==-1){ne();break}else if(ce.indexOf(Y)!==-1)break;Y=ne()}}}function G(Q){const x=i.getTokenValue();return Q?L(x):A(x),ne(),!0}function J(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(oe(2),Q=0)}catch{oe(2)}L(Q);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return ne(),!0}function B(){return i.getToken()!==10?(oe(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(T(":"),ne(),H()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function U(){k(),ne();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||oe(4,[],[]),T(","),ne(),i.getToken()===2&&ae)break}else Q&&oe(6,[],[]);B()||oe(4,[],[2,5]),Q=!0}return D(),i.getToken()!==2?oe(7,[2],[]):ne(),!0}function N(){v(),ne();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||oe(4,[],[]),T(","),ne(),i.getToken()===4&&ae)break}else Q&&oe(6,[],[]);H()||oe(4,[],[4,5]),Q=!0}return C(),i.getToken()!==4?oe(8,[4],[]):ne(),!0}function H(){switch(i.getToken()){case 3:return N();case 1:return U();case 10:return G(!0);default:return J()}}return ne(),i.getToken()===17?r.allowEmptyContent?!0:(oe(4,[],[]),!1):H()?(i.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$Rm=$;function E(t,u){const r=I(t),i=[];let n,o=0,k;do switch(k=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:o!==k&&i.push(t.substring(o,k)),u!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,u)),o=r.getPosition();break}while(n!==17);return i.join("")}e.$Sm=E;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Tm=g}),define(te[137],ie([0,1,44]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tS=e.$sS=e.$rS=e.$qS=void 0;function O(l,b,w){let p,f,y,m,d;if(b){for(m=b.offset,d=m+b.length,y=m;y>0&&!h(l,y-1);)y--;let k=d;for(;k<l.length&&!h(l,k);)k++;f=l.substring(y,k),p=I(f,w)}else f=l,p=0,y=0,m=0,d=l.length;const c=S(w,l);let a=!1,$=0,E;w.insertSpaces?E=M(" ",w.tabSize||4):E="	";const g=(0,P.$Im)(f,!1);let t=!1;function u(){return c+M(E,p+$)}function r(){let k=g.scan();for(a=!1;k===15||k===14;)a=a||k===14,k=g.scan();return t=k===16||g.getTokenError()!==0,k}const i=[];function n(k,A,D){!t&&A<d&&D>m&&l.substring(A,D)!==k&&i.push({offset:A,length:D-A,content:k})}let o=r();if(o!==17){const k=g.getTokenOffset()+y,A=M(E,p);n(A,y,k)}for(;o!==17;){let k=g.getTokenOffset()+g.getTokenLength()+y,A=r(),D="";for(;!a&&(A===12||A===13);){const C=g.getTokenOffset()+y;n(" ",k,C),k=g.getTokenOffset()+g.getTokenLength()+y,D=A===12?u():"",A=r()}if(A===2)o!==1&&($--,D=u());else if(A===4)o!==3&&($--,D=u());else{switch(o){case 3:case 1:$++,D=u();break;case 5:case 12:D=u();break;case 13:a?D=u():D=" ";break;case 6:D=" ";break;case 10:if(A===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?D=" ":A!==5&&A!==17&&(t=!0);break;case 16:t=!0;break}a&&(A===12||A===13)&&(D=u())}const v=g.getTokenOffset()+y;n(D,k,v),o=A}return i}e.$qS=O;function s(l,b){const w=JSON.stringify(l,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?w.replace(/\r\n|\r|\n/g,b.eol):w}e.$rS=s;function M(l,b){let w="";for(let p=0;p<b;p++)w+=l;return w}function I(l,b){let w=0,p=0;const f=b.tabSize||4;for(;w<l.length;){const y=l.charAt(w);if(y===" ")p++;else if(y==="	")p+=f;else break;w++}return Math.floor(p/f)}function S(l,b){for(let w=0;w<b.length;w++){const p=b.charAt(w);if(p==="\r")return w+1<b.length&&b.charAt(w+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return l&&l.eol||`
`}e.$sS=S;function h(l,b){return`\r
`.indexOf(l.charAt(b))!==-1}e.$tS=h}),define(te[138],ie([0,1,44,137]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yS=e.$xS=e.$wS=e.$vS=e.$uS=void 0;function s(l,b,w){return M(l,b,void 0,w)}e.$uS=s;function M(l,b,w,p,f){const y=b.slice(),m=[],d=(0,P.$Lm)(l,m);let c,a;for(;y.length>0&&(a=y.pop(),c=(0,P.$Mm)(d,y),c===void 0&&w!==void 0);)typeof a=="string"?w={[a]:w}:w=[w];if(c)if(c.type==="object"&&typeof a=="string"&&Array.isArray(c.children)){const $=(0,P.$Mm)(c,[a]);if($!==void 0)if(w===void 0){if(!$.parent)throw new Error("Malformed AST");const E=c.children.indexOf($.parent);let g,t=$.parent.offset+$.parent.length;if(E>0){const u=c.children[E-1];g=u.offset+u.length}else g=c.offset+1,c.children.length>1&&(t=c.children[1].offset);return I(l,{offset:g,length:t-g,content:""},p)}else return I(l,{offset:$.offset,length:$.length,content:JSON.stringify(w)},p);else{if(w===void 0)return[];const E=`${JSON.stringify(a)}: ${JSON.stringify(w)}`,g=f?f(c.children.map(u=>u.children[0].value)):c.children.length;let t;if(g>0){const u=c.children[g-1];t={offset:u.offset+u.length,length:0,content:","+E}}else c.children.length===0?t={offset:c.offset+1,length:0,content:E}:t={offset:c.offset+1,length:0,content:E+","};return I(l,t,p)}}else if(c.type==="array"&&typeof a=="number"&&Array.isArray(c.children))if(w!==void 0){const $=`${JSON.stringify(w)}`;let E;if(c.children.length===0||a===0)E={offset:c.offset+1,length:0,content:c.children.length===0?$:$+","};else{const g=a===-1||a>c.children.length?c.children.length:a,t=c.children[g-1];E={offset:t.offset+t.length,length:0,content:","+$}}return I(l,E,p)}else{const $=a,E=c.children[$];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===$){const t=c.children[$-1],u=t.offset+t.length,r=c.offset+c.length;g={offset:u,length:r-2-u,content:""}}else g={offset:E.offset,length:c.children[$+1].offset-E.offset,content:""};return I(l,g,p)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${c.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return I(l,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(w)},p)}}e.$vS=M;function I(l,b,w){let p=S(l,b),f=b.offset,y=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;f>0&&!(0,O.$tS)(p,f-1);)f--;for(;y<p.length&&!(0,O.$tS)(p,y);)y++}const m=(0,O.$qS)(p,{offset:f,length:y-f},w);for(let c=m.length-1;c>=0;c--){const a=m[c];p=S(p,a),f=Math.min(f,a.offset),y=Math.max(y,a.offset+a.length),y+=a.content.length-a.length}const d=l.length-(p.length-y)-f;return[{offset:f,length:d,content:p.substring(f,y)}]}e.$wS=I;function S(l,b){return l.substring(0,b.offset)+b.content+l.substring(b.offset+b.length)}e.$xS=S;function h(l,b){const w=b.slice(0).sort((f,y)=>{const m=f.offset-y.offset;return m===0?f.length-y.length:m});let p=l.length;for(let f=w.length-1;f>=0;f--){const y=w[f];if(y.offset+y.length<=p)l=S(l,y);else throw new Error("Overlapping edit");p=y.offset}return l}e.$yS=h}),define(te[84],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=P}),define(te[2],ie([0,1,23,134,49,68]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=void 0;const I=!1;let S=null;class h{constructor(){this.b=new Map}static{this.a=0}c(v){let C=this.b.get(v);return C||(C={parent:null,source:null,isSingleton:!1,value:v,idx:h.a++},this.b.set(v,C)),C}trackDisposable(v){const C=this.c(v);C.source||(C.source=new Error().stack)}setParent(v,C){const L=this.c(v);L.parent=C}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,C){const L=C.get(v);if(L)return L;const T=v.parent?this.f(this.c(v.parent),C):v;return C.set(v,T),T}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,L])=>L.source!==null&&!this.f(L,v).isSingleton).map(([L])=>L).flat()}computeLeakingDisposables(v=10,C){let L;if(C)L=C;else{const ae=new Map,ne=[...this.b.values()].filter(G=>G.source!==null&&!this.f(G,ae).isSingleton);if(ne.length===0)return;const oe=new Set(ne.map(G=>G.value));if(L=ne.filter(G=>!(G.parent&&oe.has(G.parent))),L.length===0)throw new Error("There are cyclic diposable chains!")}if(!L)return;function T(ae){function ne(G,J){for(;G.length>0&&J.some(B=>typeof B=="string"?B===G[0]:G[0].match(B));)G.shift()}const oe=ae.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return ne(oe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),oe.reverse()}const z=new O.$L;for(const ae of L){const ne=T(ae);for(let oe=0;oe<=ne.length;oe++)z.add(ne.slice(0,oe).join(`
`),ae)}L.sort((0,P.$4b)(ae=>ae.idx,P.$6b));let se="",ee=0;for(const ae of L.slice(0,v)){ee++;const ne=T(ae),oe=[];for(let G=0;G<ne.length;G++){let J=ne[G];J=`(shared with ${z.get(ne.slice(0,G+1).join(`
`)).size}/${L.length} leaks) at ${J}`;const U=z.get(ne.slice(0,G).join(`
`)),N=(0,O.$I)([...U].map(H=>T(H)[G]),H=>H);delete N[ne[G]];for(const[H,Q]of Object.entries(N))oe.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${H}`);oe.unshift(J)}se+=`


==================== Leaking disposable ${ee}/${L.length}: ${ae.value.constructor.name} ====================
${oe.join(`
`)}
============================================================

`}return L.length>v&&(se+=`


... and ${L.length-v} more leaking disposables

`),{leaks:L,details:se}}}e.$$b=h;function l(D){S=D}if(e.$_b=l,I){const D="__is_disposable_tracked__";l(new class{trackDisposable(v){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[D]||console.log(C)},3e3)}setParent(v,C){if(v&&v!==g.None)try{v[D]=!0}catch{}}markAsDisposed(v){if(v&&v!==g.None)try{v[D]=!0}catch{}}markAsSingleton(v){}})}function b(D){return S?.trackDisposable(D),D}e.$ac=b;function w(D){S?.markAsDisposed(D)}e.$bc=w;function p(D,v){S?.setParent(D,v)}function f(D,v){if(S)for(const C of D)S.setParent(C,v)}function y(D){return S?.markAsSingleton(D),D}e.$cc=y;function m(D){return typeof D.dispose=="function"&&D.dispose.length===0}e.$dc=m;function d(D){if(M.Iterable.is(D)){const v=[];for(const C of D)if(C)try{C.dispose()}catch(L){v.push(L)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(D)?[]:D}else if(D)return D.dispose(),D}e.$ec=d;function c(D){for(const v of D)m(v)&&v.dispose();return[]}e.$fc=c;function a(...D){const v=$(()=>d(D));return f(D,v),v}e.$gc=a;function $(D){const v=b({dispose:(0,s.$bb)(()=>{w(v),D()})});return v}e.$hc=$;class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return p(v,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}}e.$ic=E;class g{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,b(this),p(this.q,this)}dispose(){w(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$jc=g;class t{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&p(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&p(v,null),v}}e.$kc=t;class u{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$lc=u;class r{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(v){let C=v;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,w(this))},this}}e.$mc=r;class i{constructor(){this.a=new Map}acquire(v,...C){let L=this.a.get(v);L||(L={counter:0,object:this.b(v,...C)},this.a.set(v,L));const{object:T}=L,z=(0,s.$bb)(()=>{--L.counter===0&&(this.c(v,L.object),this.a.delete(v))});return L.counter++,{object:T,dispose:z}}}e.$nc=i;class n{constructor(v){this.a=v}async acquire(v,...C){const L=this.a.acquire(v,...C);try{return{object:await L.object,dispose:()=>L.dispose()}}catch(T){throw L.dispose(),T}}}e.$oc=n;class o{constructor(v){this.object=v}dispose(){}}e.$pc=o;function k(D){const v=new E;try{D(v)}finally{v.dispose()}}e.$qc=k;class A{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,C,L=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||this.a.get(v)?.dispose(),this.a.set(v,C)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$rc=A}),define(te[101],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=void 0;class P{static{this.Undefined=new P(void 0)}constructor(M){this.element=M,this.next=P.Undefined,this.prev=P.Undefined}}class O{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let M=this.a;for(;M!==P.Undefined;){const I=M.next;M.prev=P.Undefined,M.next=P.Undefined,M=I}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,I){const S=new P(M);if(this.a===P.Undefined)this.a=S,this.b=S;else if(I){const l=this.b;this.b=S,S.prev=l,l.next=S}else{const l=this.a;this.a=S,S.next=l,l.prev=S}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==P.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==P.Undefined&&M.next!==P.Undefined){const I=M.prev;I.next=M.next,M.next.prev=I}else M.prev===P.Undefined&&M.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):M.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):M.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==P.Undefined;)yield M.element,M=M.next}}e.$sc=O}),define(te[33],ie([0,1]),function(K,e){"use strict";var P,O,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.Touch=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;function M(d,c,a){let $=d.get(c);return $===void 0&&($=a,d.set(c,$)),$}e.$vi=M;function I(d){const c=[];return d.forEach((a,$)=>{c.push(`${$} => ${a}`)}),`Map(${d.size}) {${c.join(", ")}}`}e.$wi=I;function S(d){const c=[];return d.forEach(a=>{c.push(a)}),`Set(${d.size}) {${c.join(", ")}}`}e.$xi=S;class h{constructor(c,a){this.uri=c,this.value=a}}class l{static{this.a=c=>c.toString()}constructor(c,a){this[P]="ResourceMap",c instanceof l?(this.b=new Map(c.b),this.c=a??l.a):(this.b=new Map,this.c=c??l.a)}set(c,a){return this.b.set(this.c(c),new h(c,a)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,a){typeof a<"u"&&(c=c.bind(a));for(const[$,E]of this.b)c(E.value,E.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$yi=l;class b{constructor(c,a){this[O]="ResourceSet",!c||typeof c=="function"?this.a=new l(c):(this.a=new l(a),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,a){this.a.forEach(($,E)=>c.call(a,E,E,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zi=b;var w;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class p{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,a=0){const $=this.a.get(c);if($)return a!==0&&this.j($,a),$.value}set(c,a,$=0){let E=this.a.get(c);if(E)E.value=a,$!==0&&this.j(E,$);else{switch(E={key:c,value:a,next:void 0,previous:void 0},$){case 0:this.h(E);break;case 1:this.g(E);break;case 2:this.h(E);break;default:this.h(E);break}this.a.set(c,E),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const a=this.a.get(c);if(a)return this.a.delete(c),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,a){const $=this.e;let E=this.b;for(;E;){if(a?c.bind(a)(E.value,E.key,this):c(E.value,E.key,this),this.e!==$)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const c=this,a=this.e;let $=this.b;const E={[Symbol.iterator](){return E},next(){if(c.e!==a)throw new Error("LinkedMap got modified during iteration.");if($){const g={value:$.key,done:!1};return $=$.next,g}else return{value:void 0,done:!0}}};return E}values(){const c=this,a=this.e;let $=this.b;const E={[Symbol.iterator](){return E},next(){if(c.e!==a)throw new Error("LinkedMap got modified during iteration.");if($){const g={value:$.value,done:!1};return $=$.next,g}else return{value:void 0,done:!0}}};return E}entries(){const c=this,a=this.e;let $=this.b;const E={[Symbol.iterator](){return E},next(){if(c.e!==a)throw new Error("LinkedMap got modified during iteration.");if($){const g={value:[$.key,$.value],done:!1};return $=$.next,g}else return{value:void 0,done:!0}}};return E}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let a=this.b,$=this.size;for(;a&&$>c;)this.a.delete(a.key),a=a.next,$--;this.b=a,this.d=$,a&&(a.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const a=c.next,$=c.previous;if(!a||!$)throw new Error("Invalid list");a.previous=$,$.next=a}c.next=void 0,c.previous=void 0,this.e++}j(c,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(c===this.b)return;const $=c.next,E=c.previous;c===this.c?(E.next=void 0,this.c=E):($.previous=E,E.next=$),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(a===2){if(c===this.c)return;const $=c.next,E=c.previous;c===this.b?($.previous=void 0,this.b=$):($.previous=E,E.next=$),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((a,$)=>{c.push([$,a])}),c}fromJSON(c){this.clear();for(const[a,$]of c)this.set(a,$)}}e.$Ai=p;class f extends p{constructor(c,a=1){super(),this.k=c,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,a=2){return super.get(c,a)}peek(c){return super.get(c,0)}set(c,a){return super.set(c,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bi=f;class y{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let a=this.a.get(c)||0;return a===0?!1:(a--,a===0?this.a.delete(c):this.a.set(c,a),!0)}has(c){return this.a.has(c)}}e.$Ci=y;class m{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[a,$]of c)this.set(a,$)}clear(){this.a.clear(),this.b.clear()}set(c,a){this.a.set(c,a),this.b.set(a,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const a=this.a.get(c);return a===void 0?!1:(this.a.delete(c),this.b.delete(a),!0)}forEach(c,a){this.a.forEach(($,E)=>{c.call(a,$,E,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Di=m}),define(te[85],ie([0,1,33]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=e.$gl=void 0;const O=new P.$Bi(1e4);function s(l){return h(l,"NFC",O)}e.$gl=s;const M=new P.$Bi(1e4);function I(l){return h(l,"NFD",M)}e.$hl=I;const S=/[^\u0000-\u0080]/;function h(l,b,w){if(!l)return l;const p=w.get(l);if(p)return p;let f;return S.test(l)?f=l.normalize(b):f=l,w.set(l,f),f}e.$il=function(){const l=/[\u0300-\u036f]/g;return function(b){return I(b).replace(l,"")}}()}),define(te[139],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.rot=e.$Gl=void 0;function P(S,h,l){return Math.min(Math.max(S,h),l)}e.$Gl=P;function O(S,h){return(h+S%h)%h}e.rot=O;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Il=s;class M{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jl=M;class I{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const l=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Kl=I}),function(){function K(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function I(h){M.push(h,Date.now())}function S(){const h=[];for(let l=0;l<M.length;l+=2)h.push({name:M[l],startTime:M[l+1]});return h}return{mark:I,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const I of performance.getEntriesByType("mark"))M.push({name:I.name,startTime:Math.round(s+I.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=P(O))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var O in P)(typeof exports=="object"?exports:K)[O]=P[O]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function P(O){if(e[O])return e[O].exports;var s=e[O]={i:O,l:!1,exports:{}};return K[O].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=K,P.c=e,P.d=function(O,s,M){P.o(O,s)||Object.defineProperty(O,s,{enumerable:!0,get:M})},P.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},P.t=function(O,s){if(1&s&&(O=P(O)),8&s||4&s&&typeof O=="object"&&O&&O.__esModule)return O;var M=Object.create(null);if(P.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:O}),2&s&&typeof O!="string")for(var I in O)P.d(M,I,function(S){return O[S]}.bind(null,I));return M},P.n=function(O){var s=O&&O.__esModule?function(){return O.default}:function(){return O};return P.d(s,"a",s),s},P.o=function(O,s){return Object.prototype.hasOwnProperty.call(O,s)},P.p="",P(P.s=0)}([function(K,e,P){(function(O){var s;e=K.exports=ce,s=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],h=e.src=[],l=0,b=l++;h[b]="0|[1-9]\\d*";var w=l++;h[w]="[0-9]+";var p=l++;h[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=l++;h[f]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var y=l++;h[y]="("+h[w]+")\\.("+h[w]+")\\.("+h[w]+")";var m=l++;h[m]="(?:"+h[b]+"|"+h[p]+")";var d=l++;h[d]="(?:"+h[w]+"|"+h[p]+")";var c=l++;h[c]="(?:-("+h[m]+"(?:\\."+h[m]+")*))";var a=l++;h[a]="(?:-?("+h[d]+"(?:\\."+h[d]+")*))";var $=l++;h[$]="[0-9A-Za-z-]+";var E=l++;h[E]="(?:\\+("+h[$]+"(?:\\."+h[$]+")*))";var g=l++,t="v?"+h[f]+h[c]+"?"+h[E]+"?";h[g]="^"+t+"$";var u="[v=\\s]*"+h[y]+h[a]+"?"+h[E]+"?",r=l++;h[r]="^"+u+"$";var i=l++;h[i]="((?:<|>)?=?)";var n=l++;h[n]=h[w]+"|x|X|\\*";var o=l++;h[o]=h[b]+"|x|X|\\*";var k=l++;h[k]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[c]+")?"+h[E]+"?)?)?";var A=l++;h[A]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[a]+")?"+h[E]+"?)?)?";var D=l++;h[D]="^"+h[i]+"\\s*"+h[k]+"$";var v=l++;h[v]="^"+h[i]+"\\s*"+h[A]+"$";var C=l++;h[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=l++;h[L]="(?:~>?)";var T=l++;h[T]="(\\s*)"+h[L]+"\\s+",S[T]=new RegExp(h[T],"g");var z=l++;h[z]="^"+h[L]+h[k]+"$";var se=l++;h[se]="^"+h[L]+h[A]+"$";var ee=l++;h[ee]="(?:\\^)";var ae=l++;h[ae]="(\\s*)"+h[ee]+"\\s+",S[ae]=new RegExp(h[ae],"g");var ne=l++;h[ne]="^"+h[ee]+h[k]+"$";var oe=l++;h[oe]="^"+h[ee]+h[A]+"$";var G=l++;h[G]="^"+h[i]+"\\s*("+u+")$|^$";var J=l++;h[J]="^"+h[i]+"\\s*("+t+")$|^$";var B=l++;h[B]="(\\s*)"+h[i]+"\\s*("+u+"|"+h[k]+")",S[B]=new RegExp(h[B],"g");var U=l++;h[U]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var N=l++;h[N]="^\\s*("+h[A]+")\\s+-\\s+("+h[A]+")\\s*$";var H=l++;h[H]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)s(Q,h[Q]),S[Q]||(S[Q]=new RegExp(h[Q]));function x(X,le){if(X instanceof ce)return X;if(typeof X!="string"||X.length>M||!(le?S[r]:S[g]).test(X))return null;try{return new ce(X,le)}catch{return null}}function ce(X,le){if(X instanceof ce){if(X.loose===le)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ce))return new ce(X,le);s("SemVer",X,le),this.loose=le;var fe=X.trim().match(le?S[r]:S[g]);if(!fe)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Re=+Ee;if(Re>=0&&Re<I)return Re}return Ee}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=x,e.valid=function(X,le){var fe=x(X,le);return fe?fe.version:null},e.clean=function(X,le){var fe=x(X.trim().replace(/^[=v]+/,""),le);return fe?fe.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(X){return s("SemVer.compare",this.version,this.loose,X),X instanceof ce||(X=new ce(X,this.loose)),this.compareMain(X)||this.comparePre(X)},ce.prototype.compareMain=function(X){return X instanceof ce||(X=new ce(X,this.loose)),R(this.major,X.major)||R(this.minor,X.minor)||R(this.patch,X.patch)},ce.prototype.comparePre=function(X){if(X instanceof ce||(X=new ce(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var le=0;do{var fe=this.prerelease[le],Ee=X.prerelease[le];if(s("prerelease compare",le,fe,Ee),fe===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ee)return R(fe,Ee)}while(++le)},ce.prototype.inc=function(X,le){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,le,fe,Ee){typeof fe=="string"&&(Ee=fe,fe=void 0);try{return new ce(X,fe).inc(le,Ee).version}catch{return null}},e.diff=function(X,le){if(q(X,le))return null;var fe=x(X),Ee=x(le);if(fe.prerelease.length||Ee.prerelease.length){for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==Ee[Re])return"pre"+Re;return"prerelease"}for(var Re in fe)if((Re==="major"||Re==="minor"||Re==="patch")&&fe[Re]!==Ee[Re])return Re},e.compareIdentifiers=R;var Y=/^[0-9]+$/;function R(X,le){var fe=Y.test(X),Ee=Y.test(le);return fe&&Ee&&(X=+X,le=+le),fe&&!Ee?-1:Ee&&!fe?1:X<le?-1:X>le?1:0}function j(X,le,fe){return new ce(X,fe).compare(new ce(le,fe))}function F(X,le,fe){return j(X,le,fe)>0}function W(X,le,fe){return j(X,le,fe)<0}function q(X,le,fe){return j(X,le,fe)===0}function V(X,le,fe){return j(X,le,fe)!==0}function re(X,le,fe){return j(X,le,fe)>=0}function $e(X,le,fe){return j(X,le,fe)<=0}function de(X,le,fe,Ee){var Re;switch(le){case"===":typeof X=="object"&&(X=X.version),typeof fe=="object"&&(fe=fe.version),Re=X===fe;break;case"!==":typeof X=="object"&&(X=X.version),typeof fe=="object"&&(fe=fe.version),Re=X!==fe;break;case"":case"=":case"==":Re=q(X,fe,Ee);break;case"!=":Re=V(X,fe,Ee);break;case">":Re=F(X,fe,Ee);break;case">=":Re=re(X,fe,Ee);break;case"<":Re=W(X,fe,Ee);break;case"<=":Re=$e(X,fe,Ee);break;default:throw new TypeError("Invalid operator: "+le)}return Re}function ue(X,le){if(X instanceof ue){if(X.loose===le)return X;X=X.value}if(!(this instanceof ue))return new ue(X,le);s("comparator",X,le),this.loose=le,this.parse(X),this.semver===be?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(X,le){return R(le,X)},e.major=function(X,le){return new ce(X,le).major},e.minor=function(X,le){return new ce(X,le).minor},e.patch=function(X,le){return new ce(X,le).patch},e.compare=j,e.compareLoose=function(X,le){return j(X,le,!0)},e.rcompare=function(X,le,fe){return j(le,X,fe)},e.sort=function(X,le){return X.sort(function(fe,Ee){return e.compare(fe,Ee,le)})},e.rsort=function(X,le){return X.sort(function(fe,Ee){return e.rcompare(fe,Ee,le)})},e.gt=F,e.lt=W,e.eq=q,e.neq=V,e.gte=re,e.lte=$e,e.cmp=de,e.Comparator=ue;var be={};function me(X,le){if(X instanceof me)return X.loose===le?X:new me(X.raw,le);if(X instanceof ue)return new me(X.value,le);if(!(this instanceof me))return new me(X,le);if(this.loose=le,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Se(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ie(X,le,fe,Ee,Re,Fe,Oe,ze,We,Z,he,ge,ye){return((le=Se(fe)?"":Se(Ee)?">="+fe+".0.0":Se(Re)?">="+fe+"."+Ee+".0":">="+le)+" "+(ze=Se(We)?"":Se(Z)?"<"+(+We+1)+".0.0":Se(he)?"<"+We+"."+(+Z+1)+".0":ge?"<="+We+"."+Z+"."+he+"-"+ge:"<="+ze)).trim()}function je(X,le){for(var fe=0;fe<X.length;fe++)if(!X[fe].test(le))return!1;if(le.prerelease.length){for(fe=0;fe<X.length;fe++)if(s(X[fe].semver),X[fe].semver!==be&&X[fe].semver.prerelease.length>0){var Ee=X[fe].semver;if(Ee.major===le.major&&Ee.minor===le.minor&&Ee.patch===le.patch)return!0}return!1}return!0}function ve(X,le,fe){try{le=new me(le,fe)}catch{return!1}return le.test(X)}function we(X,le,fe,Ee){var Re,Fe,Oe,ze,We;switch(X=new ce(X,Ee),le=new me(le,Ee),fe){case">":Re=F,Fe=$e,Oe=W,ze=">",We=">=";break;case"<":Re=W,Fe=re,Oe=F,ze="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(X,le,Ee))return!1;for(var Z=0;Z<le.set.length;++Z){var he=le.set[Z],ge=null,ye=null;if(he.forEach(function(Ce){Ce.semver===be&&(Ce=new ue(">=0.0.0")),ge=ge||Ce,ye=ye||Ce,Re(Ce.semver,ge.semver,Ee)?ge=Ce:Oe(Ce.semver,ye.semver,Ee)&&(ye=Ce)}),ge.operator===ze||ge.operator===We||(!ye.operator||ye.operator===ze)&&Fe(X,ye.semver)||ye.operator===We&&Oe(X,ye.semver))return!1}return!0}ue.prototype.parse=function(X){var le=this.loose?S[G]:S[J],fe=X.match(le);if(!fe)throw new TypeError("Invalid comparator: "+X);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new ce(fe[2],this.loose):this.semver=be},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(X){return s("Comparator.test",X,this.loose),this.semver===be||(typeof X=="string"&&(X=new ce(X,this.loose)),de(X,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(X,le){if(!(X instanceof ue))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new me(X.value,le),ve(this.value,fe,le);if(X.operator==="")return fe=new me(this.value,le),ve(X.semver,fe,le);var Ee=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Fe=this.semver.version===X.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),ze=de(this.semver,"<",X.semver,le)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),We=de(this.semver,">",X.semver,le)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return Ee||Re||Fe&&Oe||ze||We},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(X){var le=this.loose;X=X.trim(),s("range",X,le);var fe=le?S[N]:S[U];X=X.replace(fe,Ie),s("hyphen replace",X),X=X.replace(S[B],"$1$2$3"),s("comparator trim",X,S[B]),X=(X=(X=X.replace(S[T],"$1~")).replace(S[ae],"$1^")).split(/\s+/).join(" ");var Ee=le?S[G]:S[J],Re=X.split(" ").map(function(Fe){return function(Oe,ze){return s("comp",Oe),Oe=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function(ge,ye){s("caret",ge,ye);var Ce=ye?S[oe]:S[ne];return ge.replace(Ce,function(Ue,Le,Te,Be,qe){var He;return s("caret",ge,Ue,Le,Te,Be,qe),Se(Le)?He="":Se(Te)?He=">="+Le+".0.0 <"+(+Le+1)+".0.0":Se(Be)?He=Le==="0"?">="+Le+"."+Te+".0 <"+Le+"."+(+Te+1)+".0":">="+Le+"."+Te+".0 <"+(+Le+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=Le==="0"?Te==="0"?">="+Le+"."+Te+"."+Be+qe+" <"+Le+"."+Te+"."+(+Be+1):">="+Le+"."+Te+"."+Be+qe+" <"+Le+"."+(+Te+1)+".0":">="+Le+"."+Te+"."+Be+qe+" <"+(+Le+1)+".0.0"):(s("no pr"),He=Le==="0"?Te==="0"?">="+Le+"."+Te+"."+Be+" <"+Le+"."+Te+"."+(+Be+1):">="+Le+"."+Te+"."+Be+" <"+Le+"."+(+Te+1)+".0":">="+Le+"."+Te+"."+Be+" <"+(+Le+1)+".0.0"),s("caret return",He),He})}(he,Z)}).join(" ")}(Oe,ze),s("caret",Oe),Oe=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function(ge,ye){var Ce=ye?S[se]:S[z];return ge.replace(Ce,function(Ue,Le,Te,Be,qe){var He;return s("tilde",ge,Ue,Le,Te,Be,qe),Se(Le)?He="":Se(Te)?He=">="+Le+".0.0 <"+(+Le+1)+".0.0":Se(Be)?He=">="+Le+"."+Te+".0 <"+Le+"."+(+Te+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=">="+Le+"."+Te+"."+Be+qe+" <"+Le+"."+(+Te+1)+".0"):He=">="+Le+"."+Te+"."+Be+" <"+Le+"."+(+Te+1)+".0",s("tilde return",He),He})}(he,Z)}).join(" ")}(Oe,ze),s("tildes",Oe),Oe=function(We,Z){return s("replaceXRanges",We,Z),We.split(/\s+/).map(function(he){return function(ge,ye){ge=ge.trim();var Ce=ye?S[v]:S[D];return ge.replace(Ce,function(Ue,Le,Te,Be,qe,He){s("xRange",ge,Ue,Le,Te,Be,qe,He);var xe=Se(Te),Qe=xe||Se(Be),tt=Qe||Se(qe);return Le==="="&&tt&&(Le=""),xe?Ue=Le===">"||Le==="<"?"<0.0.0":"*":Le&&tt?(Qe&&(Be=0),tt&&(qe=0),Le===">"?(Le=">=",Qe?(Te=+Te+1,Be=0,qe=0):tt&&(Be=+Be+1,qe=0)):Le==="<="&&(Le="<",Qe?Te=+Te+1:Be=+Be+1),Ue=Le+Te+"."+Be+"."+qe):Qe?Ue=">="+Te+".0.0 <"+(+Te+1)+".0.0":tt&&(Ue=">="+Te+"."+Be+".0 <"+Te+"."+(+Be+1)+".0"),s("xRange return",Ue),Ue})}(he,Z)}).join(" ")}(Oe,ze),s("xrange",Oe),Oe=function(We,Z){return s("replaceStars",We,Z),We.trim().replace(S[H],"")}(Oe,ze),s("stars",Oe),Oe}(Fe,le)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Fe){return!!Fe.match(Ee)})),Re=Re.map(function(Fe){return new ue(Fe,le)})},me.prototype.intersects=function(X,le){if(!(X instanceof me))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ee){return X.set.some(function(Re){return Re.every(function(Fe){return Ee.intersects(Fe,le)})})})})},e.toComparators=function(X,le){return new me(X,le).set.map(function(fe){return fe.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},me.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new ce(X,this.loose));for(var le=0;le<this.set.length;le++)if(je(this.set[le],X))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(X,le,fe){var Ee=null,Re=null;try{var Fe=new me(le,fe)}catch{return null}return X.forEach(function(Oe){Fe.test(Oe)&&(Ee&&Re.compare(Oe)!==-1||(Re=new ce(Ee=Oe,fe)))}),Ee},e.minSatisfying=function(X,le,fe){var Ee=null,Re=null;try{var Fe=new me(le,fe)}catch{return null}return X.forEach(function(Oe){Fe.test(Oe)&&(Ee&&Re.compare(Oe)!==1||(Re=new ce(Ee=Oe,fe)))}),Ee},e.validRange=function(X,le){try{return new me(X,le).range||"*"}catch{return null}},e.ltr=function(X,le,fe){return we(X,le,"<",fe)},e.gtr=function(X,le,fe){return we(X,le,">",fe)},e.outside=we,e.prerelease=function(X,le){var fe=x(X,le);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(X,le,fe){return X=new me(X,fe),le=new me(le,fe),X.intersects(le)},e.coerce=function(X){if(X instanceof ce)return X;if(typeof X!="string")return null;var le=X.match(S[C]);return le==null?null:x((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,P(1))},function(K,e){var P,O,s=K.exports={};function M(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function S(d){if(P===setTimeout)return setTimeout(d,0);if((P===M||!P)&&setTimeout)return P=setTimeout,setTimeout(d,0);try{return P(d,0)}catch{try{return P.call(null,d,0)}catch{return P.call(this,d,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:M}catch{P=M}try{O=typeof clearTimeout=="function"?clearTimeout:I}catch{O=I}})();var h,l=[],b=!1,w=-1;function p(){b&&h&&(b=!1,h.length?l=h.concat(l):w=-1,l.length&&f())}function f(){if(!b){var d=S(p);b=!0;for(var c=l.length;c;){for(h=l,l=[];++w<c;)h&&h[w].run();w=-1,c=l.length}h=null,b=!1,function(a){if(O===clearTimeout)return clearTimeout(a);if((O===I||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(a);try{O(a)}catch{try{return O.call(null,a)}catch{return O.call(this,a)}}}(d)}}function y(d,c){this.fun=d,this.array=c}function m(){}s.nextTick=function(d){var c=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)c[a-1]=arguments[a];l.push(new y(d,c)),l.length!==1||b||S(f)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=m,s.addListener=m,s.once=m,s.off=m,s.removeListener=m,s.removeAllListeners=m,s.emit=m,s.prependListener=m,s.prependOnceListener=m,s.listeners=function(d){return[]},s.binding=function(d){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(d){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[140],ie([0,1]),function(K,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class O{constructor(S,h,l){this.level=S,this.key=h,this.value=l,this.forward=[]}}const s=void 0;class M{constructor(S,h=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new O(this.c,s,s)}get size(){return this.f}clear(){this.e=new O(this.c,s,s)}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,h){return M.h(this,S,h,this.comparator)&&(this.f+=1),this}delete(S){const h=M.k(this,S,this.comparator);return h&&(this.f-=1),h}forEach(S,h){let l=this.e.forward[0];for(;l;)S.call(h,l.value,l.key,this),l=l.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",h=this.e.forward[0];for(;h;)S+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return S}static g(S,h,l){let b=S.e;for(let w=S.d-1;w>=0;w--)for(;b.forward[w]&&l(b.forward[w].key,h)<0;)b=b.forward[w];if(b=b.forward[0],b&&l(b.key,h)===0)return b}static h(S,h,l,b){const w=[];let p=S.e;for(let f=S.d-1;f>=0;f--){for(;p.forward[f]&&b(p.forward[f].key,h)<0;)p=p.forward[f];w[f]=p}if(p=p.forward[0],p&&b(p.key,h)===0)return p.value=l,!1;{const f=M.j(S);if(f>S.d){for(let y=S.d;y<f;y++)w[y]=S.e;S.d=f}p=new O(f,h,l);for(let y=0;y<f;y++)p.forward[y]=w[y].forward[y],w[y].forward[y]=p;return!0}}static j(S,h=.5){let l=1;for(;Math.random()<h&&l<S.c;)l+=1;return l}static k(S,h,l){const b=[];let w=S.e;for(let p=S.d-1;p>=0;p--){for(;w.forward[p]&&l(w.forward[p].key,h)<0;)w=w.forward[p];b[p]=w}if(w=w.forward[0],!w||l(w.key,h)!==0)return!1;for(let p=0;p<S.d&&b[p].forward[p]===w;p++)b[p].forward[p]=w.forward[p];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$nr=M}),define(te[69],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(M){return new O(M)}constructor(M){this.c=P&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ad=O}),define(te[3],ie([0,1,14,49,2,101,69]),function(K,e,P,O,s,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.Event=void 0;const S=!1,h=!1;var l;(function(D){D.None=()=>s.$jc.None;function v(de){if(h){const{onDidAddListener:ue}=de,be=y.create();let me=0;de.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),ue?.()}}}function C(de,ue){return J(de,()=>{},0,void 0,!0,void 0,ue)}D.defer=C;function L(de){return(ue,be=null,me)=>{let Se=!1,Ie;return Ie=de(je=>{if(!Se)return Ie?Ie.dispose():Se=!0,ue.call(be,je)},null,me),Se&&Ie.dispose(),Ie}}D.once=L;function T(de,ue,be){return oe((me,Se=null,Ie)=>de(je=>me.call(Se,ue(je)),null,Ie),be)}D.map=T;function z(de,ue,be){return oe((me,Se=null,Ie)=>de(je=>{ue(je),me.call(Se,je)},null,Ie),be)}D.forEach=z;function se(de,ue,be){return oe((me,Se=null,Ie)=>de(je=>ue(je)&&me.call(Se,je),null,Ie),be)}D.filter=se;function ee(de){return de}D.signal=ee;function ae(...de){return(ue,be=null,me)=>{const Se=(0,s.$gc)(...de.map(Ie=>Ie(je=>ue.call(be,je))));return G(Se,me)}}D.any=ae;function ne(de,ue,be,me){let Se=be;return T(de,Ie=>(Se=ue(Se,Ie),Se),me)}D.reduce=ne;function oe(de,ue){let be;const me={onWillAddFirstListener(){be=de(Se.fire,Se)},onDidRemoveLastListener(){be?.dispose()}};ue||v(me);const Se=new $(me);return ue?.add(Se),Se.event}function G(de,ue){return ue instanceof Array?ue.push(de):ue&&ue.add(de),de}function J(de,ue,be=100,me=!1,Se=!1,Ie,je){let ve,we,X,le=0,fe;const Ee={leakWarningThreshold:Ie,onWillAddFirstListener(){ve=de(Fe=>{le++,we=ue(we,Fe),me&&!X&&(Re.fire(we),we=void 0),fe=()=>{const Oe=we;we=void 0,X=void 0,(!me||le>1)&&Re.fire(Oe),le=0},typeof be=="number"?(clearTimeout(X),X=setTimeout(fe,be)):X===void 0&&(X=0,queueMicrotask(fe))})},onWillRemoveListener(){Se&&le>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,ve.dispose()}};je||v(Ee);const Re=new $(Ee);return je?.add(Re),Re.event}D.debounce=J;function B(de,ue=0,be){return D.debounce(de,(me,Se)=>me?(me.push(Se),me):[Se],ue,void 0,!0,void 0,be)}D.accumulate=B;function U(de,ue=(me,Se)=>me===Se,be){let me=!0,Se;return se(de,Ie=>{const je=me||!ue(Ie,Se);return me=!1,Se=Ie,je},be)}D.latch=U;function N(de,ue,be){return[D.filter(de,ue,be),D.filter(de,me=>!ue(me),be)]}D.split=N;function H(de,ue=!1,be=[],me){let Se=be.slice(),Ie=de(we=>{Se?Se.push(we):ve.fire(we)});me&&me.add(Ie);const je=()=>{Se?.forEach(we=>ve.fire(we)),Se=null},ve=new $({onWillAddFirstListener(){Ie||(Ie=de(we=>ve.fire(we)),me&&me.add(Ie))},onDidAddFirstListener(){Se&&(ue?setTimeout(je):je())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return me&&me.add(ve),ve.event}D.buffer=H;function Q(de,ue){return(me,Se,Ie)=>{const je=ue(new ce);return de(function(ve){const we=je.evaluate(ve);we!==x&&me.call(Se,we)},void 0,Ie)}}D.chain=Q;const x=Symbol("HaltChainable");class ce{constructor(){this.f=[]}map(ue){return this.f.push(ue),this}forEach(ue){return this.f.push(be=>(ue(be),be)),this}filter(ue){return this.f.push(be=>ue(be)?be:x),this}reduce(ue,be){let me=be;return this.f.push(Se=>(me=ue(me,Se),me)),this}latch(ue=(be,me)=>be===me){let be=!0,me;return this.f.push(Se=>{const Ie=be||!ue(Se,me);return be=!1,me=Se,Ie?Se:x}),this}evaluate(ue){for(const be of this.f)if(ue=be(ue),ue===x)break;return ue}}function Y(de,ue,be=me=>me){const me=(...ve)=>je.fire(be(...ve)),Se=()=>de.on(ue,me),Ie=()=>de.removeListener(ue,me),je=new $({onWillAddFirstListener:Se,onDidRemoveLastListener:Ie});return je.event}D.fromNodeEventEmitter=Y;function R(de,ue,be=me=>me){const me=(...ve)=>je.fire(be(...ve)),Se=()=>de.addEventListener(ue,me),Ie=()=>de.removeEventListener(ue,me),je=new $({onWillAddFirstListener:Se,onDidRemoveLastListener:Ie});return je.event}D.fromDOMEventEmitter=R;function j(de){return new Promise(ue=>L(de)(ue))}D.toPromise=j;function F(de){const ue=new $;return de.then(be=>{ue.fire(be)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}D.fromPromise=F;function W(de,ue){return ue(void 0),de(be=>ue(be))}D.runAndSubscribe=W;function q(de,ue){let be=null;function me(Ie){be?.dispose(),be=new s.$ic,ue(Ie,be)}me(void 0);const Se=de(Ie=>me(Ie));return(0,s.$hc)(()=>{Se.dispose(),be?.dispose()})}D.runAndSubscribeWithStore=q;class V{constructor(ue,be){this._observable=ue,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};be||v(me),this.emitter=new $(me),be&&be.add(this.emitter)}beginUpdate(ue){this.f++}handlePossibleChange(ue){}handleChange(ue,be){this.g=!0}endUpdate(ue){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function re(de,ue){return new V(de,ue).emitter.event}D.fromObservable=re;function $e(de){return ue=>{let be=0,me=!1;const Se={beginUpdate(){be++},endUpdate(){be--,be===0&&(de.reportChanges(),me&&(me=!1,ue()))},handlePossibleChange(){},handleChange(){me=!0}};return de.addObserver(Se),de.reportChanges(),{dispose(){de.removeObserver(Se)}}}}D.fromObservableLight=$e})(l||(e.Event=l={}));class b{static{this.all=new Set}static{this.f=0}constructor(v){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${v}_${b.f++}`,b.all.add(this)}start(v){this.g=new I.$ad,this.listenerCount=v}stop(){if(this.g){const v=this.g.elapsed();this.durations.push(v),this.elapsedOverall+=v,this.invocationCount+=1,this.g=void 0}}}e.$cd=b;let w=-1;function p(D){const v=w;return w=D,{dispose(){w=v}}}e.$dd=p;class f{constructor(v,C=Math.random().toString(18).slice(2,5)){this.threshold=v,this.name=C,this.g=0}dispose(){this.f?.clear()}check(v,C){const L=this.threshold;if(L<=0||C<L)return;this.f||(this.f=new Map);const T=this.f.get(v.value)||0;if(this.f.set(v.value,T+1),this.g-=1,this.g<=0){this.g=L*.5;let z,se=0;for(const[ee,ae]of this.f)(!z||se<ae)&&(z=ee,se=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${se}):`),console.warn(z)}return()=>{const z=this.f.get(v.value)||0;this.f.set(v.value,z-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(v){this.value=v}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class d{constructor(v){this.value=v,this.id=m++}}const c=2,a=(D,v)=>{if(D instanceof d)v(D);else for(let C=0;C<D.length;C++){const L=D[C];L&&v(L)}};class ${constructor(v){this.w=0,this.f=v,this.g=w>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const v=this.t;queueMicrotask(()=>{a(v,C=>C.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(v,C,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$jc.None;if(this.m)return s.$jc.None;C&&(v=v.bind(C));const T=new d(v);let z,se;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=y.create(),z=this.g.check(T.stack,this.w+1)),S&&(T.stack=se??y.create()),this.t?this.t instanceof d?(this.u??=new g,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const ee=(0,s.$hc)(()=>{z?.(),this.x(T)});return L instanceof s.$ic?L.add(ee):Array.isArray(L)&&L.push(ee),ee},this.q}x(v){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const C=this.t,L=C.indexOf(v);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,C[L]=void 0;const T=this.u.current===this;if(this.w*c<=C.length){let z=0;for(let se=0;se<C.length;se++)C[se]?C[z++]=C[se]:T&&(this.u.end--,z<this.u.i&&this.u.i--);C.length=z}}y(v,C){if(!v)return;const L=this.f?.onListenerError||P.$Y;if(!L){v.value(C);return}try{v.value(C)}catch(T){L(T)}}z(v){const C=v.current.t;for(;v.i<v.end;)this.y(C[v.i++],v.value);v.reset()}fire(v){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,v);else{const C=this.u;C.enqueue(this,v,this.t.length),this.z(C)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ed=$;const E=()=>new g;e.$fd=E;class g{constructor(){this.i=-1,this.end=0}enqueue(v,C,L){this.i=0,this.end=L,this.current=v,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends ${async fireAsync(v,C,L){if(this.t)for(this.h||(this.h=new M.$sc),a(this.t,T=>this.h.push([T.value,v]));this.h.size>0&&!C.isCancellationRequested;){const[T,z]=this.h.shift(),se=[],ee={...z,token:C,waitUntil:ae=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");L&&(ae=L(ae,T)),se.push(ae)}};try{T(ee)}catch(ae){(0,P.$Y)(ae);continue}Object.freeze(se),await Promise.allSettled(se).then(ae=>{for(const ne of ae)ne.status==="rejected"&&(0,P.$Y)(ne.reason)})}}}e.$gd=t;class u extends ${get isPaused(){return this.h!==0}constructor(v){super(v),this.h=0,this.s=new M.$sc,this.A=v?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const v=Array.from(this.s);this.s.clear(),super.fire(this.A(v))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(v){this.w&&(this.h!==0?this.s.push(v):super.fire(v))}}e.$hd=u;class r extends u{constructor(v){super(v),this.k=v.delay??100}fire(v){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(v)}}e.$id=r;class i extends ${constructor(v){super(v),this.h=[],this.k=v?.merge}fire(v){this.hasListeners()&&(this.h.push(v),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$jd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(v){const C={event:v,listener:null};this.h.push(C),this.g&&this.m(C);const L=()=>{this.g&&this.o(C);const T=this.h.indexOf(C);this.h.splice(T,1)};return(0,s.$hc)((0,O.$bb)(L))}j(){this.g=!0,this.h.forEach(v=>this.m(v))}k(){this.g=!1,this.h.forEach(v=>this.o(v))}m(v){v.listener=v.event(C=>this.f.fire(C))}o(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.f.dispose()}}e.$kd=n;class o{constructor(v,C,L,T){this.f=new s.$ic;const z=this.f.add(new n),se=this.f.add(new s.$rc);function ee(ae){se.set(ae,z.add(T(ae)))}for(const ae of v)ee(ae);this.f.add(C(ae=>{ee(ae)})),this.f.add(L(ae=>{se.deleteAndDispose(ae)})),this.event=z.event}dispose(){this.f.dispose()}}e.$ld=o;class k{constructor(){this.f=[]}wrapEvent(v){return(C,L,T)=>v(z=>{const se=this.f[this.f.length-1];se?se.push(()=>C.call(L,z)):C.call(L,z)},void 0,T)}bufferEvents(v){const C=[];this.f.push(C);const L=v();return this.f.pop(),C.forEach(T=>T()),L}}e.$md=k;class A{constructor(){this.f=!1,this.g=l.None,this.h=s.$jc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(v){this.g=v,this.f&&(this.h.dispose(),this.h=v(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$nd=A}),define(te[22],ie([0,1,3]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.CancellationToken=void 0;const O=Object.freeze(function(S,h){const l=setTimeout(S.bind(h),0);return{dispose(){clearTimeout(l)}}});var s;(function(S){function h(l){return l===S.None||l===S.Cancelled||l instanceof M?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}S.isCancellationToken=h,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new P.$ed),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$od=I}),define(te[141],ie([0,1,22]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=void 0;class O{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$od,h=this.b(S.token);return this.a={promise:h,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$ge=O;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const h=JSON.stringify(S);return this.b!==h&&(this.b=h,this.a=this.c(S)),this.a}}e.$he=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const h=this.b(S);return this.a.set(S,h),h}}e.$ie=M}),define(te[56],ie([0,1,14,2]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=void 0;function s(E){const g=E;return g?typeof g.read=="function":!1}e.$pd=s;function M(E){const g=E;return g?[g.on,g.pause,g.resume,g.destroy].every(t=>typeof t=="function"):!1}e.$qd=M;function I(E){const g=E;return g?M(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$rd=I;function S(E,g){return new h(E,g)}e.$sd=S;class h{constructor(g,t){this.e=g,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(t=>t(g))}h(g){this.c.error.length===0?(0,P.$Y)(g):this.c.error.slice(0).forEach(t=>t(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,t){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(g,t){if(this.a.destroyed)return;let u;switch(g){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const r=u.indexOf(t);r>=0&&u.splice(r,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(E,g){const t=[];let u;for(;(u=E.read())!==null;)t.push(u);return g(t)}e.$td=l;function b(E,g,t){const u=[];let r;for(;(r=E.read())!==null&&u.length<t;)u.push(r);return r===null&&u.length>0?g(u):{read:()=>{if(u.length>0)return u.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return E.read()}}}e.$ud=b;function w(E,g){return new Promise((t,u)=>{const r=[];p(E,{onData:i=>{g&&r.push(i)},onError:i=>{g?u(i):t(void 0)},onEnd:()=>{t(g?g(r):void 0)}})})}e.$vd=w;function p(E,g,t){E.on("error",u=>{t?.isCancellationRequested||g.onError(u)}),E.on("end",()=>{t?.isCancellationRequested||g.onEnd()}),E.on("data",u=>{t?.isCancellationRequested||g.onData(u)})}e.$wd=p;function f(E,g){return new Promise((t,u)=>{const r=new O.$ic,i=[],n=A=>{if(i.push(A),i.length>g)return r.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},o=A=>(r.dispose(),u(A)),k=()=>(r.dispose(),t({stream:E,buffer:i,ended:!0}));r.add((0,O.$hc)(()=>E.removeListener("error",o))),E.on("error",o),r.add((0,O.$hc)(()=>E.removeListener("end",k))),E.on("end",k),r.add((0,O.$hc)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$xd=f;function y(E,g){const t=S(g);return t.end(E),t}e.$yd=y;function m(){const E=S(()=>{throw new Error("not supported")});return E.end(),E}e.$zd=m;function d(E){let g=!1;return{read:()=>g?null:(g=!0,E)}}e.$Ad=d;function c(E,g,t){const u=S(t);return p(E,{onData:r=>u.write(g.data(r)),onError:r=>u.error(g.error?g.error(r):r),onEnd:()=>u.end()}),u}e.$Bd=c;function a(E,g,t){let u=!1;return{read:()=>{const r=g.read();return u?r:(u=!0,r!==null?t([E,r]):E)}}}e.$Cd=a;function $(E,g,t){let u=!1;const r=S(t);return p(g,{onData:i=>u?r.write(i):(u=!0,r.write(t([E,i]))),onError:i=>r.error(i),onEnd:()=>{u||(u=!0,r.write(E)),r.end()}}),r}e.$Dd=$}),define(te[17],ie([0,1,84,56]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=void 0;const s=typeof Buffer<"u",M=new P.$T(()=>new Uint8Array(256));let I,S;class h{static alloc(C){return s?new h(Buffer.allocUnsafe(C)):new h(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new h(C)}static fromString(C,L){return!(L?.dontUseNodeBuffer||!1)&&s?new h(Buffer.from(C)):(I||(I=new TextEncoder),new h(I.encode(C)))}static fromByteArray(C){const L=h.alloc(C.length);for(let T=0,z=C.length;T<z;T++)L.buffer[T]=C[T];return L}static concat(C,L){if(typeof L>"u"){L=0;for(let se=0,ee=C.length;se<ee;se++)L+=C[se].byteLength}const T=h.alloc(L);let z=0;for(let se=0,ee=C.length;se<ee;se++){const ae=C[se];T.set(ae,z),z+=ae.byteLength}return T}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=h.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(C,L){return new h(this.buffer.subarray(C,L))}set(C,L){if(C instanceof h)this.buffer.set(C.buffer,L);else if(C instanceof Uint8Array)this.buffer.set(C,L);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),L);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return p(this.buffer,C)}writeUInt32BE(C,L){f(this.buffer,C,L)}readUInt32LE(C){return y(this.buffer,C)}writeUInt32LE(C,L){m(this.buffer,C,L)}readUInt8(C){return d(this.buffer,C)}writeUInt8(C,L){c(this.buffer,C,L)}indexOf(C,L=0){return l(this.buffer,C instanceof h?C.buffer:C,L)}}e.$Ed=h;function l(v,C,L=0){const T=C.byteLength,z=v.byteLength;if(T===0)return 0;if(T===1)return v.indexOf(C[0]);if(T>z-L)return-1;const se=M.value;se.fill(C.length);for(let oe=0;oe<C.length;oe++)se[C[oe]]=C.length-oe-1;let ee=L+C.length-1,ae=ee,ne=-1;for(;ee<z;)if(v[ee]===C[ae]){if(ae===0){ne=ee;break}ee--,ae--}else ee+=Math.max(C.length-ae,se[v[ee]]),ae=C.length-1;return ne}e.$Fd=l;function b(v,C){return v[C+0]<<0>>>0|v[C+1]<<8>>>0}e.$Gd=b;function w(v,C,L){v[L+0]=C&255,C=C>>>8,v[L+1]=C&255}e.$Hd=w;function p(v,C){return v[C]*2**24+v[C+1]*2**16+v[C+2]*2**8+v[C+3]}e.$Id=p;function f(v,C,L){v[L+3]=C,C=C>>>8,v[L+2]=C,C=C>>>8,v[L+1]=C,C=C>>>8,v[L]=C}e.$Jd=f;function y(v,C){return v[C+0]<<0>>>0|v[C+1]<<8>>>0|v[C+2]<<16>>>0|v[C+3]<<24>>>0}e.$Kd=y;function m(v,C,L){v[L+0]=C&255,C=C>>>8,v[L+1]=C&255,C=C>>>8,v[L+2]=C&255,C=C>>>8,v[L+3]=C&255}e.$Ld=m;function d(v,C){return v[C]}e.$Md=d;function c(v,C,L){v[L]=C}e.$Nd=c;function a(v){return O.$td(v,C=>h.concat(C))}e.$Od=a;function $(v){return O.$Ad(v)}e.$Pd=$;function E(v){return O.$vd(v,C=>h.concat(C))}e.$Qd=E;async function g(v){return v.ended?h.concat(v.buffer):h.concat([...v.buffer,await E(v.stream)])}e.$Rd=g;function t(v){return O.$yd(v,C=>h.concat(C))}e.$Sd=t;function u(v){return O.$Bd(v,{data:C=>typeof C=="string"?h.fromString(C):h.wrap(C)},C=>h.concat(C))}e.$Td=u;function r(v){return O.$sd(C=>h.concat(C),v)}e.$Ud=r;function i(v,C){return O.$Cd(v,C,L=>h.concat(L))}e.$Vd=i;function n(v,C){return O.$Dd(v,C,L=>h.concat(L))}e.$Wd=n;function o(v){let C=0,L=0,T=0;const z=new Uint8Array(Math.floor(v.length/4*3)),se=ae=>{switch(L){case 3:z[T++]=C|ae,L=0;break;case 2:z[T++]=C|ae>>>2,C=ae<<6,L=3;break;case 1:z[T++]=C|ae>>>4,C=ae<<4,L=2;break;default:C=ae<<2,L=1}};for(let ae=0;ae<v.length;ae++){const ne=v.charCodeAt(ae);if(ne>=65&&ne<=90)se(ne-65);else if(ne>=97&&ne<=122)se(ne-97+26);else if(ne>=48&&ne<=57)se(ne-48+52);else if(ne===43||ne===45)se(62);else if(ne===47||ne===95)se(63);else{if(ne===61)break;throw new SyntaxError(`Unexpected base64 character ${v[ae]}`)}}const ee=T;for(;L>0;)se(0);return h.wrap(z).slice(0,ee)}e.$Xd=o;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:v},C=!0,L=!1){const T=L?A:k;let z="";const se=v.byteLength%3;let ee=0;for(;ee<v.byteLength-se;ee+=3){const ae=v[ee+0],ne=v[ee+1],oe=v[ee+2];z+=T[ae>>>2],z+=T[(ae<<4|ne>>>4)&63],z+=T[(ne<<2|oe>>>6)&63],z+=T[oe&63]}if(se===1){const ae=v[ee+0];z+=T[ae>>>2],z+=T[ae<<4&63],C&&(z+="==")}else if(se===2){const ae=v[ee+0],ne=v[ee+1];z+=T[ae>>>2],z+=T[(ae<<4|ne>>>4)&63],z+=T[ne<<2&63],C&&(z+="=")}return z}e.$Yd=D}),define(te[26],ie([0,1,141,84]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hf=e.$gf=e.$ff=e.$ef=e.GraphemeBreakType=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=void 0;function s(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}e.$le=s;const M=/{(\d+)}/g;function I(Z,...he){return he.length===0?Z:Z.replace(M,function(ge,ye){const Ce=parseInt(ye,10);return isNaN(Ce)||Ce<0||Ce>=he.length?ge:he[Ce]})}e.$me=I;const S=/{([^}]+)}/g;function h(Z,he){return Z.replace(S,(ge,ye)=>he[ye]??ge)}e.$ne=h;function l(Z){return Z.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$oe=l;function b(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$pe=b;function w(Z,he){let ge=0;const ye=he.charCodeAt(0);for(let Ce=Z.length-1;Ce>=0;Ce--)Z.charCodeAt(Ce)===ye&&ge++;return ge}e.$qe=w;function p(Z,he,ge="\u2026"){return Z.length<=he?Z:`${Z.substr(0,he)}${ge}`}e.$re=p;function f(Z,he=" "){const ge=y(Z,he);return m(ge,he)}e.$se=f;function y(Z,he){if(!Z||!he)return Z;const ge=he.length;if(ge===0||Z.length===0)return Z;let ye=0;for(;Z.indexOf(he,ye)===ye;)ye=ye+ge;return Z.substring(ye)}e.$te=y;function m(Z,he){if(!Z||!he)return Z;const ge=he.length,ye=Z.length;if(ge===0||ye===0)return Z;let Ce=ye,Ue=-1;for(;Ue=Z.lastIndexOf(he,Ce-1),!(Ue===-1||Ue+ge!==Ce);){if(Ue===0)return"";Ce=Ue}return Z.substring(0,Ce)}e.$ue=m;function d(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$ve=d;function c(Z){return Z.replace(/\*/g,"")}e.$we=c;function a(Z,he,ge={}){if(!Z)throw new Error("Cannot create regex from empty string");he||(Z=b(Z)),ge.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ye="";return ge.global&&(ye+="g"),ge.matchCase||(ye+="i"),ge.multiline&&(ye+="m"),ge.unicode&&(ye+="u"),new RegExp(Z,ye)}e.$xe=a;function $(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}e.$ye=$;function E(Z){return Z.split(/\r\n|\r|\n/)}e.$ze=E;function g(Z){for(let he=0,ge=Z.length;he<ge;he++){const ye=Z.charCodeAt(he);if(ye!==32&&ye!==9)return he}return-1}e.$Ae=g;function t(Z,he=0,ge=Z.length){for(let ye=he;ye<ge;ye++){const Ce=Z.charCodeAt(ye);if(Ce!==32&&Ce!==9)return Z.substring(he,ye)}return Z.substring(he,ge)}e.$Be=t;function u(Z,he=Z.length-1){for(let ge=he;ge>=0;ge--){const ye=Z.charCodeAt(ge);if(ye!==32&&ye!==9)return ge}return-1}e.$Ce=u;function r(Z,he,ge){const ye=[];let Ce=0;for(const Ue of Z.matchAll(he)){if(ye.push(Z.slice(Ce,Ue.index)),Ue.index===void 0)throw new Error("match.index should be defined");Ce=Ue.index+Ue[0].length,ye.push(ge(Ue[0],...Ue.slice(1),Ue.index,Z,Ue.groups))}return ye.push(Z.slice(Ce)),Promise.all(ye).then(Ue=>Ue.join(""))}e.$De=r;function i(Z,he){return Z<he?-1:Z>he?1:0}e.$Ee=i;function n(Z,he,ge=0,ye=Z.length,Ce=0,Ue=he.length){for(;ge<ye&&Ce<Ue;ge++,Ce++){const Be=Z.charCodeAt(ge),qe=he.charCodeAt(Ce);if(Be<qe)return-1;if(Be>qe)return 1}const Le=ye-ge,Te=Ue-Ce;return Le<Te?-1:Le>Te?1:0}e.$Fe=n;function o(Z,he){return k(Z,he,0,Z.length,0,he.length)}e.$Ge=o;function k(Z,he,ge=0,ye=Z.length,Ce=0,Ue=he.length){for(;ge<ye&&Ce<Ue;ge++,Ce++){let Be=Z.charCodeAt(ge),qe=he.charCodeAt(Ce);if(Be===qe)continue;if(Be>=128||qe>=128)return n(Z.toLowerCase(),he.toLowerCase(),ge,ye,Ce,Ue);D(Be)&&(Be-=32),D(qe)&&(qe-=32);const He=Be-qe;if(He!==0)return He}const Le=ye-ge,Te=Ue-Ce;return Le<Te?-1:Le>Te?1:0}e.$He=k;function A(Z){return Z>=48&&Z<=57}e.$Ie=A;function D(Z){return Z>=97&&Z<=122}e.$Je=D;function v(Z){return Z>=65&&Z<=90}e.$Ke=v;function C(Z,he){return Z.length===he.length&&k(Z,he)===0}e.$Le=C;function L(Z,he){const ge=he.length;return he.length>Z.length?!1:k(Z,he,0,ge)===0}e.$Me=L;function T(Z,he){const ge=Math.min(Z.length,he.length);let ye;for(ye=0;ye<ge;ye++)if(Z.charCodeAt(ye)!==he.charCodeAt(ye))return ye;return ge}e.$Ne=T;function z(Z,he){const ge=Math.min(Z.length,he.length);let ye;const Ce=Z.length-1,Ue=he.length-1;for(ye=0;ye<ge;ye++)if(Z.charCodeAt(Ce-ye)!==he.charCodeAt(Ue-ye))return ye;return ge}e.$Oe=z;function se(Z){return 55296<=Z&&Z<=56319}e.$Pe=se;function ee(Z){return 56320<=Z&&Z<=57343}e.$Qe=ee;function ae(Z,he){return(Z-55296<<10)+(he-56320)+65536}e.$Re=ae;function ne(Z,he,ge){const ye=Z.charCodeAt(ge);if(se(ye)&&ge+1<he){const Ce=Z.charCodeAt(ge+1);if(ee(Ce))return ae(ye,Ce)}return ye}e.$Se=ne;function oe(Z,he){const ge=Z.charCodeAt(he-1);if(ee(ge)&&he>1){const ye=Z.charCodeAt(he-2);if(se(ye))return ae(ye,ge)}return ge}class G{get offset(){return this.e}constructor(he,ge=0){this.c=he,this.d=he.length,this.e=ge}setOffset(he){this.e=he}prevCodePoint(){const he=oe(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=ne(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$Te=G;class J{get offset(){return this.c.offset}constructor(he,ge=0){this.c=new G(he,ge)}nextGraphemeLength(){const he=le.getInstance(),ge=this.c,ye=ge.offset;let Ce=he.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ue=ge.offset,Le=he.getGraphemeBreakType(ge.nextCodePoint());if(we(Ce,Le)){ge.setOffset(Ue);break}Ce=Le}return ge.offset-ye}prevGraphemeLength(){const he=le.getInstance(),ge=this.c,ye=ge.offset;let Ce=he.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ue=ge.offset,Le=he.getGraphemeBreakType(ge.prevCodePoint());if(we(Le,Ce)){ge.setOffset(Ue);break}Ce=Le}return ye-ge.offset}eol(){return this.c.eol()}}e.$Ue=J;function B(Z,he){return new J(Z,he).nextGraphemeLength()}e.$Ve=B;function U(Z,he){return new J(Z,he).prevGraphemeLength()}e.$We=U;function N(Z,he){he>0&&ee(Z.charCodeAt(he))&&he--;const ge=he+B(Z,he);return[ge-U(Z,ge),ge]}e.$Xe=N;function H(Z){const he=new J(Z);let ge=0;for(;!he.eol();)ge++,he.nextGraphemeLength();return ge}e.$Ye=H;let Q;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ce(Z){return Q||(Q=x()),Q.test(Z)}e.$Ze=ce;const Y=/^[\t\n\r\x20-\x7E]*$/;function R(Z){return Y.test(Z)}e.$1e=R,e.$2e=/[\u2028\u2029]/;function j(Z){return e.$2e.test(Z)}e.$3e=j;function F(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}e.$4e=F;function W(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}e.$5e=W;function q(Z,he){if(Z.length<he)return Z;const ge=/\b/g;let ye=0;for(;ge.test(Z)&&!(Z.length-ge.lastIndex<he);)ye=ge.lastIndex,ge.lastIndex+=1;return Z.substring(ye).replace(/^\s/,"")}e.$6e=q;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,re=/\x1b\].*?\x07/g;function $e(Z){return Z&&(Z=Z.replace(V,"").replace(re,"")),Z}e.$7e=$e,e.$8e=String.fromCharCode(65279);function de(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}e.$9e=de;function ue(Z){return de(Z)?Z.substr(1):Z}e.$0e=ue;function be(Z,he){if(!Z||!he||Z.length<he.length)return!1;const ge=he.length,ye=Z.toLowerCase();let Ce=0,Ue=-1;for(;Ce<ge;){const Le=ye.indexOf(he[Ce],Ue+1);if(Le<0)return!1;Ue=Le,Ce++}return!0}e.$$e=be;function me(Z,he=!1){return Z?(he&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}e.$_e=me;function Se(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}e.$af=Se;function Ie(Z,he=1){if(he===0)return"";let ge=-1;do ge=Z.indexOf(`
`,ge+1),he--;while(he>0&&ge>=0);return ge===-1?Z:(Z[ge-1]==="\r"&&ge--,Z.substr(0,ge))}e.$bf=Ie;function je(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}e.$cf=je;function ve(Z){return le.getInstance().getGraphemeBreakType(Z)}e.$df=ve;function we(Z,he){return Z===0?he!==5&&he!==7:Z===2&&he===3?!1:Z===4||Z===2||Z===3||he===4||he===2||he===3?!0:!(Z===8&&(he===8||he===9||he===11||he===12)||(Z===11||Z===9)&&(he===9||he===10)||(Z===12||Z===10)&&he===10||he===5||he===13||he===7||Z===1||Z===13&&he===14||Z===6&&he===6)}var X;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(X||(e.GraphemeBreakType=X={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=fe()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const ge=this.d,ye=ge.length/3;let Ce=1;for(;Ce<=ye;)if(he<ge[3*Ce])Ce=2*Ce;else if(he>ge[3*Ce+1])Ce=2*Ce+1;else return ge[3*Ce+2];return 0}}function fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ee(Z,he){if(Z===0)return 0;const ge=Re(Z,he);if(ge!==void 0)return ge;const ye=new G(he,Z);return ye.prevCodePoint(),ye.offset}e.$ef=Ee;function Re(Z,he){const ge=new G(he,Z);let ye=ge.prevCodePoint();for(;Fe(ye)||ye===65039||ye===8419;){if(ge.offset===0)return;ye=ge.prevCodePoint()}if(!W(ye))return;let Ce=ge.offset;return Ce>0&&ge.prevCodePoint()===8205&&(Ce=ge.offset),Ce}function Fe(Z){return 127995<=Z&&Z<=127999}var Oe;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$ff="\xA0";class ze{static{this.c=new O.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$he(he=>{function ge(He){const xe=new Map;for(let Qe=0;Qe<He.length;Qe+=2)xe.set(He[Qe],He[Qe+1]);return xe}function ye(He,xe){const Qe=new Map(He);for(const[tt,nt]of xe)Qe.set(tt,nt);return Qe}function Ce(He,xe){if(!He)return xe;const Qe=new Map;for(const[tt,nt]of He)xe.has(tt)&&Qe.set(tt,nt);return Qe}const Ue=this.c.value;let Le=he.filter(He=>!He.startsWith("_")&&He in Ue);Le.length===0&&(Le=["_default"]);let Te;for(const He of Le){const xe=ge(Ue[He]);Te=Ce(Te,xe)}const Be=ge(Ue._common),qe=ye(Be,Te);return new ze(qe)})}static getInstance(he){return ze.d.get(Array.from(he))}static{this.e=new O.$T(()=>Object.keys(ze.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return ze.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$gf=ze;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(he){return We.e().has(he)}static get codePoints(){return We.e()}}e.$hf=We}),define(te[57],ie([0,1,26]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=void 0;function O(c){return s(c,0)}e.$oi=O;function s(c,a){switch(typeof c){case"object":return c===null?M(349,a):Array.isArray(c)?h(c,a):l(c,a);case"string":return S(c,a);case"boolean":return I(c,a);case"number":return M(c,a);case"undefined":return M(937,a);default:return M(617,a)}}e.$pi=s;function M(c,a){return(a<<5)-a+c|0}e.$qi=M;function I(c,a){return M(c?433:863,a)}function S(c,a){a=M(149417,a);for(let $=0,E=c.length;$<E;$++)a=M(c.charCodeAt($),a);return a}e.$ri=S;function h(c,a){return a=M(104579,a),c.reduce(($,E)=>s(E,$),a)}function l(c,a){return a=M(181387,a),Object.keys(c).sort().reduce(($,E)=>($=S(E,$),s(c[E],$)),a)}class b{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=s(a,this.g),this.g}}e.$si=b;var w;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function p(c,a,$=32){const E=$-a,g=~((1<<E)-1);return(c<<a|(g&c)>>>E)>>>0}function f(c,a=0,$=c.byteLength,E=0){for(let g=0;g<$;g++)c[a+g]=E}function y(c,a,$="0"){for(;c.length<a;)c=$+c;return c}function m(c,a=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):y((c>>>0).toString(16),a/4)}e.$ti=m;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const $=a.length;if($===0)return;const E=this.p;let g=this.r,t=this.u,u,r;for(t!==0?(u=t,r=-1,t=0):(u=a.charCodeAt(0),r=0);;){let i=u;if(P.$Pe(u))if(r+1<$){const n=a.charCodeAt(r+1);P.$Qe(n)?(r++,i=P.$Re(u,n)):i=65533}else{t=u;break}else P.$Qe(u)&&(i=65533);if(g=this.w(E,g,i),r++,r<$)u=a.charCodeAt(r);else break}this.r=g,this.u=t}w(a,$,E){return E<128?a[$++]=E:E<2048?(a[$++]=192|(E&1984)>>>6,a[$++]=128|(E&63)>>>0):E<65536?(a[$++]=224|(E&61440)>>>12,a[$++]=128|(E&4032)>>>6,a[$++]=128|(E&63)>>>0):(a[$++]=240|(E&1835008)>>>18,a[$++]=128|(E&258048)>>>12,a[$++]=128|(E&4032)>>>6,a[$++]=128|(E&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=d.g,$=this.q;for(let k=0;k<64;k+=4)a.setUint32(k,$.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)a.setUint32(k,p(a.getUint32(k-12,!1)^a.getUint32(k-32,!1)^a.getUint32(k-56,!1)^a.getUint32(k-64,!1),1),!1);let E=this.h,g=this.l,t=this.m,u=this.n,r=this.o,i,n,o;for(let k=0;k<80;k++)k<20?(i=g&t|~g&u,n=1518500249):k<40?(i=g^t^u,n=1859775393):k<60?(i=g&t|g&u|t&u,n=2400959708):(i=g^t^u,n=3395469782),o=p(E,5)+i+r+n+a.getUint32(k*4,!1)&4294967295,r=u,u=t,t=p(g,30),g=E,E=o;this.h=this.h+E&4294967295,this.l=this.l+g&4294967295,this.m=this.m+t&4294967295,this.n=this.n+u&4294967295,this.o=this.o+r&4294967295}}e.$ui=d}),define(te[70],ie([0,1,26]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(O||(O={})),function(s){const M="error",I="warning",S="warn",h="info",l="ignore";function b(p){return p?P.$Le(M,p)?s.Error:P.$Le(I,p)||P.$Le(S,p)?s.Warning:P.$Le(h,p)?s.Info:s.Ignore:s.Ignore}s.fromValue=b;function w(p){switch(p){case s.Error:return M;case s.Warning:return I;case s.Info:return h;default:return l}}s.toString=w}(O||(O={})),e.default=O}),define(te[142],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$bd=Symbol("MicrotaskDelay")}),define(te[58],ie([0,1,23,26]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const y=f.charCodeAt(0),m=this.b.charCodeAt(this.c);return y-m}value(){return this.b[this.c]}}e.$Ch=s;class M{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,O.$Fe)(f,this.b,0,f.length,this.c,this.d):(0,O.$He)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Dh=M;class I{constructor(f=!0,y=!0){this.f=f,this.g=y}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let y=f.length-1;y>=0;y--,this.c--){const m=this.b.charCodeAt(y);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,O.$Fe)(f,this.b,0,f.length,this.d,this.e):(0,O.$He)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Eh=I;var S;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(S||(S={}));class h{constructor(f,y){this.f=f,this.g=y,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,O.$Ge)(f,this.c.scheme);if(this.d[this.e]===2)return(0,O.$Ge)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,O.$Ee)(f,this.c.query);if(this.d[this.e]===5)return(0,O.$Ee)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fh=h;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(b||(b={}));class w{static forUris(f=()=>!1,y=()=>!1){return new w(new h(f,y))}static forPaths(f=!1){return new w(new I(void 0,!f))}static forStrings(){return new w(new s)}static forConfigKeys(){return new w(new M)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,y){if(y){const m=y.slice(0);(0,P.$Ub)(m);for(const d of m)this.set(d,f)}else{const m=f.slice(0);(0,P.$Ub)(m);for(const d of m)this.set(d[0],d[1])}}set(f,y){const m=this.b.reset(f);let d;this.c||(this.c=new l,this.c.segment=m.value());const c=[];for(d=this.c;;){const $=m.cmp(d.segment);if($>0)d.left||(d.left=new l,d.left.segment=m.value()),c.push([-1,d]),d=d.left;else if($<0)d.right||(d.right=new l,d.right.segment=m.value()),c.push([1,d]),d=d.right;else if(m.hasNext())m.next(),d.mid||(d.mid=new l,d.mid.segment=m.value()),c.push([0,d]),d=d.mid;else break}const a=d.value;d.value=y,d.key=f;for(let $=c.length-1;$>=0;$--){const E=c[$][1];E.updateHeight();const g=E.balanceFactor();if(g<-1||g>1){const t=c[$][0],u=c[$+1][0];if(t===1&&u===1)c[$][1]=E.rotateLeft();else if(t===-1&&u===-1)c[$][1]=E.rotateRight();else if(t===1&&u===-1)E.right=c[$+1][1]=c[$+1][1].rotateRight(),c[$][1]=E.rotateLeft();else if(t===-1&&u===1)E.left=c[$+1][1]=c[$+1][1].rotateLeft(),c[$][1]=E.rotateRight();else throw new Error;if($>0)switch(c[$-1][0]){case-1:c[$-1][1].left=c[$][1];break;case 1:c[$-1][1].right=c[$][1];break;case 0:c[$-1][1].mid=c[$][1];break}else this.c=c[0][1]}}return a}get(f){return this.d(f)?.value}d(f){const y=this.b.reset(f);let m=this.c;for(;m;){const d=y.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(y.hasNext())y.next(),m=m.mid;else break}return m}has(f){const y=this.d(f);return!(y?.value===void 0&&y?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,y){const m=this.b.reset(f),d=[];let c=this.c;for(;c;){const a=m.cmp(c.segment);if(a>0)d.push([-1,c]),c=c.left;else if(a<0)d.push([1,c]),c=c.right;else if(m.hasNext())m.next(),d.push([0,c]),c=c.mid;else break}if(c){if(y?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const a=this.f(c.right);if(a.key){const{key:$,value:E,segment:g}=a;this.e(a.key,!1),c.key=$,c.value=E,c.segment=g}}else{const a=c.left??c.right;if(d.length>0){const[$,E]=d[d.length-1];switch($){case-1:E.left=a;break;case 0:E.mid=a;break;case 1:E.right=a;break}}else this.c=a}for(let a=d.length-1;a>=0;a--){const $=d[a][1];$.updateHeight();const E=$.balanceFactor();if(E>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),d[a][1]=$.rotateLeft()):E<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),d[a][1]=$.rotateRight()),a>0)switch(d[a-1][0]){case-1:d[a-1][1].left=d[a][1];break;case 1:d[a-1][1].right=d[a][1];break;case 0:d[a-1][1].mid=d[a][1];break}else this.c=d[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const y=this.b.reset(f);let m=this.c,d;for(;m;){const c=y.cmp(m.segment);if(c>0)m=m.left;else if(c<0)m=m.right;else if(y.hasNext())y.next(),d=m.value||d,m=m.mid;else break}return m&&m.value||d}findSuperstr(f){return this.g(f,!1)}g(f,y){const m=this.b.reset(f);let d=this.c;for(;d;){const c=m.cmp(d.segment);if(c>0)d=d.left;else if(c<0)d=d.right;else if(m.hasNext())m.next(),d=d.mid;else return d.mid?this.h(d.mid):y?d.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[y,m]of this)f(m,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const y=[];return this.j(f,y),y[Symbol.iterator]()}j(f,y){f&&(f.left&&this.j(f.left,y),f.value&&y.push([f.key,f.value]),f.mid&&this.j(f.mid,y),f.right&&this.j(f.right,y))}_isBalanced(){const f=y=>{if(!y)return!0;const m=y.balanceFactor();return m<-1||m>1?!1:f(y.left)&&f(y.right)};return f(this.c)}}e.$Gh=w}),define(te[12],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=void 0;function P(g){return typeof g=="string"}e.$if=P;function O(g){return Array.isArray(g)&&g.every(t=>P(t))}e.$jf=O;function s(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.$kf=s;function M(g){const t=Object.getPrototypeOf(Uint8Array);return typeof g=="object"&&g instanceof t}e.$lf=M;function I(g){return typeof g=="number"&&!isNaN(g)}e.$mf=I;function S(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.$nf=S;function h(g){return g===!0||g===!1}e.$of=h;function l(g){return typeof g>"u"}e.$pf=l;function b(g){return!w(g)}e.$qf=b;function w(g){return l(g)||g===null}e.$rf=w;function p(g,t){if(!g)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$sf=p;function f(g){if(w(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.$tf=f;function y(...g){const t=[];for(let u=0;u<g.length;u++){const r=g[u];if(w(r))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);t.push(r)}return t}e.$uf=y;const m=Object.prototype.hasOwnProperty;function d(g){if(!s(g))return!1;for(const t in g)if(m.call(g,t))return!1;return!0}e.$vf=d;function c(g){return typeof g=="function"}e.$wf=c;function a(...g){return g.length>0&&g.every(c)}e.$xf=a;function $(g,t){const u=Math.min(g.length,t.length);for(let r=0;r<u;r++)E(g[r],t[r])}e.$yf=$;function E(g,t){if(P(t)){if(typeof g!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(g instanceof t)return}catch{}if(!w(g)&&g.constructor===t||t.length===1&&t.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$zf=E}),define(te[71],ie([0,1,12]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=void 0;const O=Object.create(null);function s(S,h){if((0,P.$if)(h)){const l=O[h];if(l===void 0)throw new Error(`${S} references an unknown codicon: ${h}`);h=l}return O[S]=h,{id:S}}function M(){return O}e.$Mj=M;function I(){return Object.values(e.$Oj)}e.$Nj=I,e.$Oj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package_:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,12]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=void 0;function O(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const a=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,E])=>{a[$]=E&&typeof E=="object"?O(E):E}),a}e.$Um=O;function s(c){if(!c||typeof c!="object")return c;const a=[c];for(;a.length>0;){const $=a.shift();Object.freeze($);for(const E in $)if(M.call($,E)){const g=$[E];typeof g=="object"&&!Object.isFrozen(g)&&!(0,P.$lf)(g)&&a.push(g)}}return c}e.$Vm=s;const M=Object.prototype.hasOwnProperty;function I(c,a){return S(c,a,new Set)}e.$Wm=I;function S(c,a,$){if((0,P.$rf)(c))return c;const E=a(c);if(typeof E<"u")return E;if(Array.isArray(c)){const g=[];for(const t of c)g.push(S(t,a,$));return g}if((0,P.$kf)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const g={};for(const t in c)M.call(c,t)&&(g[t]=S(c[t],a,$));return $.delete(c),g}return c}function h(c,a,$=!0){return(0,P.$kf)(c)?((0,P.$kf)(a)&&Object.keys(a).forEach(E=>{E in c?$&&((0,P.$kf)(c[E])&&(0,P.$kf)(a[E])?h(c[E],a[E],$):c[E]=a[E]):c[E]=a[E]}),c):a}e.$Xm=h;function l(c,a){if(c===a)return!0;if(c==null||a===null||a===void 0||typeof c!=typeof a||typeof c!="object"||Array.isArray(c)!==Array.isArray(a))return!1;let $,E;if(Array.isArray(c)){if(c.length!==a.length)return!1;for($=0;$<c.length;$++)if(!l(c[$],a[$]))return!1}else{const g=[];for(E in c)g.push(E);g.sort();const t=[];for(E in a)t.push(E);if(t.sort(),!l(g,t))return!1;for($=0;$<g.length;$++)if(!l(c[g[$]],a[g[$]]))return!1}return!0}e.$Ym=l;function b(c){const a=new Set;return JSON.stringify(c,($,E)=>{if((0,P.$kf)(E)||Array.isArray(E)){if(a.has(E))return"[Circular]";a.add(E)}return E})}e.$Zm=b;function w(c,a){const $=Object.create(null);return!c||!a||Object.keys(a).forEach(g=>{const t=c[g],u=a[g];l(t,u)||($[g]=u)}),$}e.$1m=w;function p(c,a){const $=a.toLowerCase(),E=Object.keys(c).find(g=>g.toLowerCase()===$);return E?c[E]:c[a]}e.$2m=p;function f(c,a){const $=Object.create(null);for(const[E,g]of Object.entries(c))a(E,g)&&($[E]=g);return $}e.$3m=f;function y(c){let a=[];for(;Object.prototype!==c;)a=a.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return a}e.$4m=y;function m(c){const a=[];for(const $ of y(c))typeof c[$]=="function"&&a.push($);return a}e.$5m=m;function d(c,a){const $=g=>function(){const t=Array.prototype.slice.call(arguments,0);return a(g,t)},E={};for(const g of c)E[g]=$(g);return E}e.$6m=d}),define(te[102],ie([0,1,71]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Pj=e.ThemeColor=void 0;var O;(function(I){function S(h){return h&&typeof h=="object"&&typeof h.id=="string"}I.isThemeColor=S})(O||(e.ThemeColor=O={}));function s(I){return{id:I}}e.$Pj=s;var M;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function h(a){const $=S.exec(a.id);if(!$)return h(P.$Oj.error);const[,E,g]=$,t=["codicon","codicon-"+E];return g&&t.push("codicon-modifier-"+g.substring(1)),t}I.asClassNameArray=h;function l(a){return h(a).join(" ")}I.asClassName=l;function b(a){return"."+h(a).join(".")}I.asCSSSelector=b;function w(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||O.isThemeColor(a.color))}I.isThemeIcon=w;const p=new RegExp(`^\\$\\((${I.iconNameExpression}(?:${I.iconModifierExpression})?)\\)$`);function f(a){const $=p.exec(a);if(!$)return;const[,E]=$;return{id:E}}I.fromString=f;function y(a){return{id:a}}I.fromId=y;function m(a,$){let E=a.id;const g=E.lastIndexOf("~");return g!==-1&&(E=E.substring(0,g)),$&&(E=`${E}~${$}`),{id:E}}I.modify=m;function d(a){const $=a.id.lastIndexOf("~");if($!==-1)return a.id.substring($+1)}I.getModifier=d;function c(a,$){return a.id===$.id&&a.color?.id===$.color?.id}I.isEqual=c})(M||(e.ThemeIcon=M={}))}),define(te[31],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(s){return P.test(s)}e.$2f=O,e.$3f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let h=0;h<S.length;h++)S[h]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),I=[];for(let S=0;S<256;S++)I.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let h=0,l="";return l+=I[M[h++]],l+=I[M[h++]],l+=I[M[h++]],l+=I[M[h++]],l+="-",l+=I[M[h++]],l+=I[M[h++]],l+="-",l+=I[M[h++]],l+=I[M[h++]],l+="-",l+=I[M[h++]],l+=I[M[h++]],l+="-",l+=I[M[h++]],l+=I[M[h++]],l+=I[M[h++]],l+=I[M[h++]],l+=I[M[h++]],l+=I[M[h++]],l}}()}),define(te[143],ie([0,1,72,45,49]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HS=void 0;async function M(I,S){if(await new Promise((b,w)=>{const p=O.createReadStream(I),f=P.createHash("sha1");p.pipe(f);const y=(0,s.$bb)((m,d)=>{p.removeAllListeners(),f.removeAllListeners(),m?w(m):b(d)});p.once("error",y),p.once("end",y),f.once("error",y),f.once("data",m=>y(void 0,m.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$HS=M}),define(te[144],ie([0,1,27]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(I){const S=I.replace(/\-/g,":").toLowerCase();return!O.has(S)}function M(){const I=(0,P.networkInterfaces)();for(const S in I){const h=I[S];if(h){for(const{mac:l}of h)if(s(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Fm=M}),define(te[86],ie([0,1,27,58,31,144]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Gm=new class{c(l){return this.a||(this.a=O.$Gh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,b=0;const w=(0,P.networkInterfaces)();for(const p in w){const f=w[p];if(f)for(const{mac:y,internal:m}of f)m||(b+=1,this.c(y.toUpperCase())&&(l+=1))}this.b=b>0?l/b:0}return this.b}};let I;async function S(l){return I||(I=(async()=>await h(l)||s.$3f())()),I}e.$Hm=S;async function h(l){try{const b=await new Promise((p,f)=>{K(["crypto"],p,f)}),w=(0,M.$Fm)();return b.createHash("sha256").update(w,"utf8").digest("hex")}catch(b){l(b);return}}}),define(te[103],ie([0,1,87]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=void 0;function O(S,h,l,b=1){let w=!1;return new Promise(p=>{const f=setTimeout(()=>{if(!w)return w=!0,p(0)},l);s(S,h,b,y=>{if(!w)return w=!0,clearTimeout(f),p(y)})})}e.$5f=O;function s(S,h,l,b){if(h===0)return b(0);const w=new P.Socket;w.once("connect",()=>(I(w),s(S+l,h-1,l,b))),w.once("data",()=>{}),w.once("error",p=>(I(w),p.code!=="ECONNREFUSED"?s(S+l,h-1,l,b):b(S))),w.connect(S,"127.0.0.1")}e.$6f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,h,l,b="127.0.0.1"){let w=!1,p,f=1;const y=P.createServer({pauseOnConnect:!0});function m(d,c){w||(w=!0,y.removeAllListeners(),y.close(),p&&clearTimeout(p),c(d))}return new Promise(d=>{p=setTimeout(()=>{m(0,d)},l),y.on("listening",()=>{m(S,d)}),y.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&f<h?(S++,f++,y.listen(S,b)):m(0,d)}),y.on("close",()=>{m(0,d)}),y.listen(S,b)})}e.$7f=M;function I(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(h){console.error(h)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function P(h){const l=new Set;if(Array.isArray(h))for(const b of h)typeof b=="string"&&l.add(b);return Array.from(l)}function O(){const h=e();return h?Array.from(h):[]}function s(h){if(process.platform!=="win32")return;const l=e();if(l)if(typeof h=="string")l.add(h.toLowerCase());else for(const b of P(h))s(b)}function M(h){if(typeof h!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let b;for(const w of l){if(h.indexOf(w)!==0)continue;const f=h.indexOf("\\",w.length);if(f===-1)continue;const y=h.substring(w.length,f);if(y){b=y;break}}return b}function I(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:O,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:I,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[145],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LS=e.$KS=void 0,e.$KS="vscode:contextmenu",e.$LS="vscode:onCloseContextMenu"}),define(te[146],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SS=void 0;class P{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$SS=P}),define(te[38],ie([0,1,15,14]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MS=void 0;class s{constructor(){this.a=new WeakMap}on(I,S){const h=(l,...b)=>{this.b(I,l)&&S(l,...b)};return this.a.set(S,h),P.ipcMain.on(I,h),this}once(I,S){return P.ipcMain.once(I,(h,...l)=>{this.b(I,h)&&S(h,...l)}),this}handle(I,S){return P.ipcMain.handle(I,(h,...l)=>this.b(I,h)?S(h,...l):Promise.reject(`Invalid channel '${I}' or sender for ipcMain.handle() usage.`)),this}removeHandler(I){return P.ipcMain.removeHandler(I),this}removeListener(I,S){const h=this.a.get(S);return h&&(P.ipcMain.removeListener(I,h),this.a.delete(S)),this}b(I,S){if(!I||!I.startsWith("vscode:"))return(0,O.$Y)(`Refused to handle ipcMain event for channel '${I}' because the channel is unknown.`),!1;const h=S.senderFrame,l=h.url;if(!l||l==="about:blank")return!0;let b="unknown";try{b=new URL(l).host}catch{return(0,O.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a malformed URL '${l}'.`),!1}return b!=="vscode-app"?((0,O.$Y)(`Refused to handle ipcMain event for channel '${I}' because of a bad origin of '${b}'.`),!1):h.parent!==null?((0,O.$Y)(`Refused to handle ipcMain event for channel '${I}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.$MS=new s}),define(te[147],ie([0,1,15,38,145]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NS=void 0;function M(){O.$MS.on(s.$KS,(S,h,l,b,w)=>{const p=I(S,b,l);p.popup({window:P.BrowserWindow.fromWebContents(S.sender)??void 0,x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{p&&S.sender.send(s.$LS,h)}})})}e.$NS=M;function I(S,h,l){const b=new P.Menu;return l.forEach(w=>{let p;w.type==="separator"?p=new P.MenuItem({type:w.type}):Array.isArray(w.submenu)?p=new P.MenuItem({submenu:I(S,h,w.submenu),label:w.label}):p=new P.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(f,y,m)=>S.sender.send(h,w.id,m)}),b.append(p)}),b}}),define(te[148],ie([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(te[149],ie([0,1,148]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=void 0;const O=60,s=O*60,M=s*24,I=M*7,S=M*30,h=M*365;function l(w,p,f,y){typeof w!="number"&&(w=w.getTime());const m=Math.round((new Date().getTime()-w)/1e3);if(m<-30)return(0,P.localize)(0,null,l(new Date().getTime()+m*1e3,!1));if(!y&&m<30)return(0,P.localize)(1,null);let d;return m<O?(d=m,p?d===1?f?(0,P.localize)(2,null,d):(0,P.localize)(3,null,d):f?(0,P.localize)(4,null,d):(0,P.localize)(5,null,d):d===1?f?(0,P.localize)(6,null,d):(0,P.localize)(7,null,d):f?(0,P.localize)(8,null,d):(0,P.localize)(9,null,d)):m<s?(d=Math.floor(m/O),p?d===1?f?(0,P.localize)(10,null,d):(0,P.localize)(11,null,d):f?(0,P.localize)(12,null,d):(0,P.localize)(13,null,d):d===1?f?(0,P.localize)(14,null,d):(0,P.localize)(15,null,d):f?(0,P.localize)(16,null,d):(0,P.localize)(17,null,d)):m<M?(d=Math.floor(m/s),p?d===1?f?(0,P.localize)(18,null,d):(0,P.localize)(19,null,d):f?(0,P.localize)(20,null,d):(0,P.localize)(21,null,d):d===1?f?(0,P.localize)(22,null,d):(0,P.localize)(23,null,d):f?(0,P.localize)(24,null,d):(0,P.localize)(25,null,d)):m<I?(d=Math.floor(m/M),p?d===1?(0,P.localize)(26,null,d):(0,P.localize)(27,null,d):d===1?(0,P.localize)(28,null,d):(0,P.localize)(29,null,d)):m<S?(d=Math.floor(m/I),p?d===1?f?(0,P.localize)(30,null,d):(0,P.localize)(31,null,d):f?(0,P.localize)(32,null,d):(0,P.localize)(33,null,d):d===1?f?(0,P.localize)(34,null,d):(0,P.localize)(35,null,d):f?(0,P.localize)(36,null,d):(0,P.localize)(37,null,d)):m<h?(d=Math.floor(m/S),p?d===1?f?(0,P.localize)(38,null,d):(0,P.localize)(39,null,d):f?(0,P.localize)(40,null,d):(0,P.localize)(41,null,d):d===1?f?(0,P.localize)(42,null,d):(0,P.localize)(43,null,d):f?(0,P.localize)(44,null,d):(0,P.localize)(45,null,d)):(d=Math.floor(m/h),p?d===1?f?(0,P.localize)(46,null,d):(0,P.localize)(47,null,d):f?(0,P.localize)(48,null,d):(0,P.localize)(49,null,d):d===1?f?(0,P.localize)(50,null,d):(0,P.localize)(51,null,d):f?(0,P.localize)(52,null,d):(0,P.localize)(53,null,d))}e.$5l=l;function b(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$6l=b}),define(te[150],ie([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,23,12,150]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=void 0;function M(w,p){return p&&(w.stack||w.stacktrace)?s.localize(0,null,S(w),I(w.stack)||I(w.stacktrace)):S(w)}function I(w){return Array.isArray(w)?w.join(`
`):w}function S(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?s.localize(1,null,w.message):w.message||s.localize(2,null)}function h(w=null,p=!1){if(!w)return s.localize(3,null);if(Array.isArray(w)){const f=P.$Eb(w),y=h(f[0],p);return f.length>1?s.localize(4,null,y,f.length):y}if(O.$if(w))return w;if(w.detail){const f=w.detail;if(f.error)return M(f.error,p);if(f.exception)return M(f.exception,p)}return w.stack?M(w,p):w.message?w.message:s.localize(5,null)}e.$li=h;function l(w){const p=w;return p instanceof Error&&Array.isArray(p.actions)}e.$mi=l;function b(w,p){let f;return typeof w=="string"?f=new Error(w):f=w,f.actions=p,f}e.$ni=b}),define(te[151],ie([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(te[152],ie([0,1,151]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;function O(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$lp=O}),define(te[153],ie([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,153]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let O=!1,s=!1,M=!1,I=!1,S=!1,h=!1,l=!1,b=!1,w=!1,p=!1,f,y=e.$f,m=e.$f,d,c;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?a=e.$g.vscode.process:typeof process<"u"&&(a=process);const $=typeof a?.versions?.electron=="string",E=$&&a?.type==="renderer";if(typeof navigator=="object"&&!E)c=navigator.userAgent,O=c.indexOf("Windows")>=0,s=c.indexOf("Macintosh")>=0,b=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=c.indexOf("Linux")>=0,p=c?.indexOf("Mobi")>=0,h=!0,f=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$f,y=f,m=navigator.language;else if(typeof a=="object"){O=a.platform==="win32",s=a.platform==="darwin",M=a.platform==="linux",I=M&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,l=$,w=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$f,y=e.$f;const A=a.env.VSCODE_NLS_CONFIG;if(A)try{const D=JSON.parse(A),v=D.availableLanguages["*"];f=D.locale,m=D.osLocale,y=v||e.$f,d=D._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var g;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(g||(e.Platform=g={}));function t(A){switch(A){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let u=0;s?u=1:O?u=3:M&&(u=2),e.$i=O,e.$j=s,e.$k=M,e.$l=I,e.$m=S,e.$n=l,e.$o=h,e.$p=h&&typeof e.$g.importScripts=="function",e.$q=b,e.$r=p,e.$s=w,e.$t=u,e.$u=c,e.$v=y;var r;(function(A){function D(){return e.$v}A.value=D;function v(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}A.isDefaultVariant=v;function C(){return e.$v==="en"}A.isDefault=C})(r||(e.Language=r={})),e.$w=f,e.$x=m,e.$y=d,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const A=[];e.$g.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let C=0,L=A.length;C<L;C++){const T=A[C];if(T.id===v.data.vscodeScheduleAsyncWork){A.splice(C,1),T.callback();return}}});let D=0;return v=>{const C=++D;A.push({id:C,callback:v}),e.$g.postMessage({vscodeScheduleAsyncWork:C},"*")}}return A=>setTimeout(A)})();var i;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||b?2:O?1:3;let n=!0,o=!1;function k(){if(!o){o=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,n=new Uint16Array(A.buffer)[0]===(2<<8)+1}return n}e.$C=k,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.$2d=e.env=e.cwd=void 0;let O;if(typeof P.$g.vscode<"u"&&typeof P.$g.vscode.process<"u"){const s=P.$g.vscode.process;O={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$2d=O.platform,e.$3d=O.arch}),define(te[9],ie([0,1,35]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.sep=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;const O=65,s=97,M=90,I=122,S=46,h=47,l=92,b=58,w=63;class p extends Error{constructor(u,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=u.indexOf(".")!==-1?"property":"argument";let k=`The "${u}" ${o} ${n} of type ${r}`;k+=`. Received type ${typeof i}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,u){if(t===null||typeof t!="object")throw new p(u,"Object",t)}function y(t,u){if(typeof t!="string")throw new p(u,"string",t)}const m=P.$2d==="win32";function d(t){return t===h||t===l}function c(t){return t===h}function a(t){return t>=O&&t<=M||t>=s&&t<=I}function $(t,u,r,i){let n="",o=0,k=-1,A=0,D=0;for(let v=0;v<=t.length;++v){if(v<t.length)D=t.charCodeAt(v);else{if(i(D))break;D=h}if(i(D)){if(!(k===v-1||A===1))if(A===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const C=n.lastIndexOf(r);C===-1?(n="",o=0):(n=n.slice(0,C),o=n.length-1-n.lastIndexOf(r)),k=v,A=0;continue}else if(n.length!==0){n="",o=0,k=v,A=0;continue}}u&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${t.slice(k+1,v)}`:n=t.slice(k+1,v),o=v-k-1;k=v,A=0}else D===S&&A!==-1?++A:A=-1}return n}function E(t,u){f(u,"pathObject");const r=u.dir||u.root,i=u.base||`${u.name||""}${u.ext||""}`;return r?r===u.root?`${r}${i}`:`${r}${t}${i}`:i}e.$4d={resolve(...t){let u="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],y(o,"path"),o.length===0)continue}else u.length===0?o=P.cwd():(o=P.env[`=${u}`]||P.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==u.toLowerCase()&&o.charCodeAt(2)===l)&&(o=`${u}\\`));const k=o.length;let A=0,D="",v=!1;const C=o.charCodeAt(0);if(k===1)d(C)&&(A=1,v=!0);else if(d(C))if(v=!0,d(o.charCodeAt(1))){let L=2,T=L;for(;L<k&&!d(o.charCodeAt(L));)L++;if(L<k&&L!==T){const z=o.slice(T,L);for(T=L;L<k&&d(o.charCodeAt(L));)L++;if(L<k&&L!==T){for(T=L;L<k&&!d(o.charCodeAt(L));)L++;(L===k||L!==T)&&(D=`\\\\${z}\\${o.slice(T,L)}`,A=L)}}}else A=1;else a(C)&&o.charCodeAt(1)===b&&(D=o.slice(0,2),A=2,k>2&&d(o.charCodeAt(2))&&(v=!0,A=3));if(D.length>0)if(u.length>0){if(D.toLowerCase()!==u.toLowerCase())continue}else u=D;if(i){if(u.length>0)break}else if(r=`${o.slice(A)}\\${r}`,i=v,v&&u.length>0)break}return r=$(r,!i,"\\",d),i?`${u}\\${r}`:`${u}${r}`||"."},normalize(t){y(t,"path");const u=t.length;if(u===0)return".";let r=0,i,n=!1;const o=t.charCodeAt(0);if(u===1)return c(o)?"\\":t;if(d(o))if(n=!0,d(t.charCodeAt(1))){let A=2,D=A;for(;A<u&&!d(t.charCodeAt(A));)A++;if(A<u&&A!==D){const v=t.slice(D,A);for(D=A;A<u&&d(t.charCodeAt(A));)A++;if(A<u&&A!==D){for(D=A;A<u&&!d(t.charCodeAt(A));)A++;if(A===u)return`\\\\${v}\\${t.slice(D)}\\`;A!==D&&(i=`\\\\${v}\\${t.slice(D,A)}`,r=A)}}}else r=1;else a(o)&&t.charCodeAt(1)===b&&(i=t.slice(0,2),r=2,u>2&&d(t.charCodeAt(2))&&(n=!0,r=3));let k=r<u?$(t.slice(r),!n,"\\",d):"";return k.length===0&&!n&&(k="."),k.length>0&&d(t.charCodeAt(u-1))&&(k+="\\"),i===void 0?n?`\\${k}`:k:n?`${i}\\${k}`:`${i}${k}`},isAbsolute(t){y(t,"path");const u=t.length;if(u===0)return!1;const r=t.charCodeAt(0);return d(r)||u>2&&a(r)&&t.charCodeAt(1)===b&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let u,r;for(let o=0;o<t.length;++o){const k=t[o];y(k,"path"),k.length>0&&(u===void 0?u=r=k:u+=`\\${k}`)}if(u===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&d(r.charCodeAt(0))){++n;const o=r.length;o>1&&d(r.charCodeAt(1))&&(++n,o>2&&(d(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<u.length&&d(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.$4d.normalize(u)},relative(t,u){if(y(t,"from"),y(u,"to"),t===u)return"";const r=e.$4d.resolve(t),i=e.$4d.resolve(u);if(r===i||(t=r.toLowerCase(),u=i.toLowerCase(),t===u))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===l;)o--;const k=o-n;let A=0;for(;A<u.length&&u.charCodeAt(A)===l;)A++;let D=u.length;for(;D-1>A&&u.charCodeAt(D-1)===l;)D--;const v=D-A,C=k<v?k:v;let L=-1,T=0;for(;T<C;T++){const se=t.charCodeAt(n+T);if(se!==u.charCodeAt(A+T))break;se===l&&(L=T)}if(T!==C){if(L===-1)return i}else{if(v>C){if(u.charCodeAt(A+T)===l)return i.slice(A+T+1);if(T===2)return i.slice(A+T)}k>C&&(t.charCodeAt(n+T)===l?L=T:T===2&&(L=3)),L===-1&&(L=0)}let z="";for(T=n+L+1;T<=o;++T)(T===o||t.charCodeAt(T)===l)&&(z+=z.length===0?"..":"\\..");return A+=L,z.length>0?`${z}${i.slice(A,D)}`:(i.charCodeAt(A)===l&&++A,i.slice(A,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const u=e.$4d.resolve(t);if(u.length<=2)return t;if(u.charCodeAt(0)===l){if(u.charCodeAt(1)===l){const r=u.charCodeAt(2);if(r!==w&&r!==S)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(a(u.charCodeAt(0))&&u.charCodeAt(1)===b&&u.charCodeAt(2)===l)return`\\\\?\\${u}`;return t},dirname(t){y(t,"path");const u=t.length;if(u===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(u===1)return d(n)?t:".";if(d(n)){if(r=i=1,d(t.charCodeAt(1))){let A=2,D=A;for(;A<u&&!d(t.charCodeAt(A));)A++;if(A<u&&A!==D){for(D=A;A<u&&d(t.charCodeAt(A));)A++;if(A<u&&A!==D){for(D=A;A<u&&!d(t.charCodeAt(A));)A++;if(A===u)return t;A!==D&&(r=i=A+1)}}}}else a(n)&&t.charCodeAt(1)===b&&(r=u>2&&d(t.charCodeAt(2))?3:2,i=r);let o=-1,k=!0;for(let A=u-1;A>=i;--A)if(d(t.charCodeAt(A))){if(!k){o=A;break}}else k=!1;if(o===-1){if(r===-1)return".";o=r}return t.slice(0,o)},basename(t,u){u!==void 0&&y(u,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(t.length>=2&&a(t.charCodeAt(0))&&t.charCodeAt(1)===b&&(r=2),u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let k=u.length-1,A=-1;for(o=t.length-1;o>=r;--o){const D=t.charCodeAt(o);if(d(D)){if(!n){r=o+1;break}}else A===-1&&(n=!1,A=o+1),k>=0&&(D===u.charCodeAt(k)?--k===-1&&(i=o):(k=-1,i=A))}return r===i?i=A:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=r;--o)if(d(t.charCodeAt(o))){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let u=0,r=-1,i=0,n=-1,o=!0,k=0;t.length>=2&&t.charCodeAt(1)===b&&a(t.charCodeAt(0))&&(u=i=2);for(let A=t.length-1;A>=u;--A){const D=t.charCodeAt(A);if(d(D)){if(!o){i=A+1;break}continue}n===-1&&(o=!1,n=A+1),D===S?r===-1?r=A:k!==1&&(k=1):r!==-1&&(k=-1)}return r===-1||n===-1||k===0||k===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:E.bind(null,"\\"),parse(t){y(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return d(n)?(u.root=u.dir=t,u):(u.base=u.name=t,u);if(d(n)){if(i=1,d(t.charCodeAt(1))){let L=2,T=L;for(;L<r&&!d(t.charCodeAt(L));)L++;if(L<r&&L!==T){for(T=L;L<r&&d(t.charCodeAt(L));)L++;if(L<r&&L!==T){for(T=L;L<r&&!d(t.charCodeAt(L));)L++;L===r?i=L:L!==T&&(i=L+1)}}}}else if(a(n)&&t.charCodeAt(1)===b){if(r<=2)return u.root=u.dir=t,u;if(i=2,d(t.charCodeAt(2))){if(r===3)return u.root=u.dir=t,u;i=3}}i>0&&(u.root=t.slice(0,i));let o=-1,k=i,A=-1,D=!0,v=t.length-1,C=0;for(;v>=i;--v){if(n=t.charCodeAt(v),d(n)){if(!D){k=v+1;break}continue}A===-1&&(D=!1,A=v+1),n===S?o===-1?o=v:C!==1&&(C=1):o!==-1&&(C=-1)}return A!==-1&&(o===-1||C===0||C===1&&o===A-1&&o===k+1?u.base=u.name=t.slice(k,A):(u.name=t.slice(k,o),u.base=t.slice(k,A),u.ext=t.slice(o,A))),k>0&&k!==i?u.dir=t.slice(0,k-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(m){const t=/\\/g;return()=>{const u=P.cwd().replace(t,"/");return u.slice(u.indexOf("/"))}}return()=>P.cwd()})();e.$5d={resolve(...t){let u="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:g();y(n,"path"),n.length!==0&&(u=`${n}/${u}`,r=n.charCodeAt(0)===h)}return u=$(u,!r,"/",c),r?`/${u}`:u.length>0?u:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===h,r=t.charCodeAt(t.length-1)===h;return t=$(t,!u,"/",c),t.length===0?u?"/":r?"./":".":(r&&(t+="/"),u?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let u;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(u===void 0?u=i:u+=`/${i}`)}return u===void 0?".":e.$5d.normalize(u)},relative(t,u){if(y(t,"from"),y(u,"to"),t===u||(t=e.$5d.resolve(t),u=e.$5d.resolve(u),t===u))return"";const r=1,i=t.length,n=i-r,o=1,k=u.length-o,A=n<k?n:k;let D=-1,v=0;for(;v<A;v++){const L=t.charCodeAt(r+v);if(L!==u.charCodeAt(o+v))break;L===h&&(D=v)}if(v===A)if(k>A){if(u.charCodeAt(o+v)===h)return u.slice(o+v+1);if(v===0)return u.slice(o+v)}else n>A&&(t.charCodeAt(r+v)===h?D=v:v===0&&(D=0));let C="";for(v=r+D+1;v<=i;++v)(v===i||t.charCodeAt(v)===h)&&(C+=C.length===0?"..":"/..");return`${C}${u.slice(o+D)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const u=t.charCodeAt(0)===h;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===h){if(!i){r=n;break}}else i=!1;return r===-1?u?"/":".":u&&r===1?"//":t.slice(0,r)},basename(t,u){u!==void 0&&y(u,"ext"),y(t,"path");let r=0,i=-1,n=!0,o;if(u!==void 0&&u.length>0&&u.length<=t.length){if(u===t)return"";let k=u.length-1,A=-1;for(o=t.length-1;o>=0;--o){const D=t.charCodeAt(o);if(D===h){if(!n){r=o+1;break}}else A===-1&&(n=!1,A=o+1),k>=0&&(D===u.charCodeAt(k)?--k===-1&&(i=o):(k=-1,i=A))}return r===i?i=A:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===h){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let u=-1,r=0,i=-1,n=!0,o=0;for(let k=t.length-1;k>=0;--k){const A=t.charCodeAt(k);if(A===h){if(!n){r=k+1;break}continue}i===-1&&(n=!1,i=k+1),A===S?u===-1?u=k:o!==1&&(o=1):u!==-1&&(o=-1)}return u===-1||i===-1||o===0||o===1&&u===i-1&&u===r+1?"":t.slice(u,i)},format:E.bind(null,"/"),parse(t){y(t,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return u;const r=t.charCodeAt(0)===h;let i;r?(u.root="/",i=1):i=0;let n=-1,o=0,k=-1,A=!0,D=t.length-1,v=0;for(;D>=i;--D){const C=t.charCodeAt(D);if(C===h){if(!A){o=D+1;break}continue}k===-1&&(A=!1,k=D+1),C===S?n===-1?n=D:v!==1&&(v=1):n!==-1&&(v=-1)}if(k!==-1){const C=o===0&&r?1:o;n===-1||v===0||v===1&&n===k-1&&n===o+1?u.base=u.name=t.slice(C,k):(u.name=t.slice(C,n),u.base=t.slice(C,k),u.ext=t.slice(n,k))}return o>0?u.dir=t.slice(0,o-1):r&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.$5d.win32=e.$4d.win32=e.$4d,e.$5d.posix=e.$4d.posix=e.$5d,e.$6d=m?e.$4d.normalize:e.$5d.normalize,e.$7d=m?e.$4d.isAbsolute:e.$5d.isAbsolute,e.$8d=m?e.$4d.join:e.$5d.join,e.$9d=m?e.$4d.resolve:e.$5d.resolve,e.$0d=m?e.$4d.relative:e.$5d.relative,e.$$d=m?e.$4d.dirname:e.$5d.dirname,e.$_d=m?e.$4d.basename:e.$5d.basename,e.$ae=m?e.$4d.extname:e.$5d.extname,e.$be=m?e.$4d.format:e.$5d.format,e.$ce=m?e.$4d.parse:e.$5d.parse,e.$de=m?e.$4d.toNamespacedPath:e.$5d.toNamespacedPath,e.sep=m?e.$4d.sep:e.$5d.sep,e.$fe=m?e.$4d.delimiter:e.$5d.delimiter}),define(te[32],ie([0,1,9,4,26,12]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=void 0;function I(o){return o===47||o===92}e.$Af=I;function S(o){return o.replace(/[\\/]/g,P.$5d.sep)}e.$Bf=S;function h(o){return o.indexOf("/")===-1&&(o=S(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Cf=h;function l(o,k=P.$5d.sep){if(!o)return"";const A=o.length,D=o.charCodeAt(0);if(I(D)){if(I(o.charCodeAt(1))&&!I(o.charCodeAt(2))){let C=3;const L=C;for(;C<A&&!I(o.charCodeAt(C));C++);if(L!==C&&!I(o.charCodeAt(C+1))){for(C+=1;C<A;C++)if(I(o.charCodeAt(C)))return o.slice(0,C+1).replace(/[\\/]/g,k)}}return k}else if(c(D)&&o.charCodeAt(1)===58)return I(o.charCodeAt(2))?o.slice(0,2)+k:o.slice(0,2);let v=o.indexOf("://");if(v!==-1){for(v+=3;v<A;v++)if(I(o.charCodeAt(v)))return o.slice(0,v+1)}return""}e.$Df=l;function b(o){if(!O.$i||!o||o.length<5)return!1;let k=o.charCodeAt(0);if(k!==92||(k=o.charCodeAt(1),k!==92))return!1;let A=2;const D=A;for(;A<o.length&&(k=o.charCodeAt(A),k!==92);A++);return!(D===A||(k=o.charCodeAt(A+1),isNaN(k)||k===92))}e.$Ef=b;const w=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(o,k=O.$i){const A=k?w:p;return!(!o||o.length===0||/^\s+$/.test(o)||(A.lastIndex=0,A.test(o))||k&&f.test(o)||o==="."||o===".."||k&&o[o.length-1]==="."||k&&o.length!==o.trim().length||o.length>255)}e.$Ff=y;function m(o,k,A){const D=o===k;return!A||D?D:!o||!k?!1:(0,s.$Le)(o,k)}e.$Gf=m;function d(o,k,A,D=P.sep){if(o===k)return!0;if(!o||!k||k.length>o.length)return!1;if(A){if(!(0,s.$Me)(o,k))return!1;if(k.length===o.length)return!0;let C=k.length;return k.charAt(k.length-1)===D&&C--,o.charAt(C)===D}return k.charAt(k.length-1)!==D&&(k+=D),o.indexOf(k)===0}e.$Hf=d;function c(o){return o>=65&&o<=90||o>=97&&o<=122}e.$If=c;function a(o,k){return O.$i&&o.endsWith(":")&&(o+=P.sep),(0,P.$7d)(o)||(o=(0,P.$8d)(k,o)),o=(0,P.$6d)(o),O.$i?(o=(0,s.$ue)(o,P.sep),o.endsWith(":")&&(o+=P.sep)):(o=(0,s.$ue)(o,P.sep),o||(o=P.sep)),o}e.$Jf=a;function $(o){const k=(0,P.$6d)(o);return O.$i?o.length>3?!1:E(k)&&(o.length===2||k.charCodeAt(2)===92):k===P.$5d.sep}e.$Kf=$;function E(o,k=O.$i){return k?c(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$Lf=E;function g(o,k=O.$i){return E(o,k)?o[0]:void 0}e.$Mf=g;function t(o,k,A){return k.length>o.length?-1:o===k?0:(A&&(o=o.toLowerCase(),k=k.toLowerCase()),o.indexOf(k))}e.$Nf=t;function u(o){const k=o.split(":");let A,D,v;for(const C of k){const L=Number(C);(0,M.$mf)(L)?D===void 0?D=L:v===void 0&&(v=L):A=A?[A,C].join(":"):C}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:D!==void 0?D:void 0,column:v!==void 0?v:D!==void 0?1:void 0}}e.$Of=u;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(o,k,A=8){let D="";for(let C=0;C<A;C++){let L;C===0&&O.$i&&!k&&(A===3||A===4)?L=i:L=r,D+=L.charAt(Math.floor(Math.random()*L.length))}let v;return k?v=`${k}-${D}`:v=D,o?(0,P.$8d)(o,v):v}e.$Pf=n}),define(te[73],ie([0,1,4]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.TerminateResponseCode=e.Source=void 0;var O;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(O||(e.Source=O={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...h){const l=h.reduce((p,f)=>(p[f]=!0,p),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(p=>!l[p]).forEach(p=>{for(let f=0;f<b.length;f++)if(p.search(b[f])!==-1){delete S[p];break}})}e.$rl=M;function I(S){S&&(delete S.DEBUG,P.$j&&delete S.DYLD_LIBRARY_PATH,P.$k&&delete S.LD_PRELOAD)}e.$sl=I}),define(te[7],ie([0,1,9,4]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,I=/^\/\//;function S(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const b="",w="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,k,A,D,v=!1){typeof n=="object"?(this.scheme=n.scheme||b,this.authority=n.authority||b,this.path=n.path||b,this.query=n.query||b,this.fragment=n.fragment||b):(this.scheme=h(n,v),this.authority=o||b,this.path=l(this.scheme,k||b),this.query=A||b,this.fragment=D||b,S(this,v))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:k,path:A,query:D,fragment:v}=n;return o===void 0?o=this.scheme:o===null&&(o=b),k===void 0?k=this.authority:k===null&&(k=b),A===void 0?A=this.path:A===null&&(A=b),D===void 0?D=this.query:D===null&&(D=b),v===void 0?v=this.fragment:v===null&&(v=b),o===this.scheme&&k===this.authority&&A===this.path&&D===this.query&&v===this.fragment?this:new d(o,k,A,D,v)}static parse(n,o=!1){const k=p.exec(n);return k?new d(k[2]||b,r(k[4]||b),r(k[5]||b),r(k[7]||b),r(k[9]||b),o):new d(b,b,b,b,b)}static file(n){let o=b;if(O.$i&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const k=n.indexOf(w,2);k===-1?(o=n.substring(2),n=w):(o=n.substring(2,k),n=n.substring(k)||w)}return new d("file",o,n,b,b)}static from(n,o){return new d(n.scheme,n.authority,n.path,n.query,n.fragment,o)}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return O.$i&&n.scheme==="file"?k=f.file(P.$4d.join(E(n,!0),...o)).path:k=P.$5d.join(n.path,...o),n.with({path:k})}toString(n=!1){return g(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const o=new d(n);return o._formatted=n.external??null,o._fsPath=n._sep===m?n.fsPath??null:null,o}}else return n}}e.URI=f;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Rf=y;const m=O.$i?1:void 0;class d extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?g(this,!0):(this._formatted||(this._formatted=g(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function a(i,n,o){let k,A=-1;for(let D=0;D<i.length;D++){const v=i.charCodeAt(D);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||n&&v===47||o&&v===91||o&&v===93||o&&v===58)A!==-1&&(k+=encodeURIComponent(i.substring(A,D)),A=-1),k!==void 0&&(k+=i.charAt(D));else{k===void 0&&(k=i.substr(0,D));const C=c[v];C!==void 0?(A!==-1&&(k+=encodeURIComponent(i.substring(A,D)),A=-1),k+=C):A===-1&&(A=D)}}return A!==-1&&(k+=encodeURIComponent(i.substring(A))),k!==void 0?k:i}function $(i){let n;for(let o=0;o<i.length;o++){const k=i.charCodeAt(o);k===35||k===63?(n===void 0&&(n=i.substr(0,o)),n+=c[k]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function E(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,O.$i&&(o=o.replace(/\//g,"\\")),o}e.$Sf=E;function g(i,n){const o=n?$:a;let k="",{scheme:A,authority:D,path:v,query:C,fragment:L}=i;if(A&&(k+=A,k+=":"),(D||A==="file")&&(k+=w,k+=w),D){let T=D.indexOf("@");if(T!==-1){const z=D.substr(0,T);D=D.substr(T+1),T=z.lastIndexOf(":"),T===-1?k+=o(z,!1,!1):(k+=o(z.substr(0,T),!1,!1),k+=":",k+=o(z.substr(T+1),!1,!0)),k+="@"}D=D.toLowerCase(),T=D.lastIndexOf(":"),T===-1?k+=o(D,!1,!0):(k+=o(D.substr(0,T),!1,!0),k+=D.substr(T))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const T=v.charCodeAt(1);T>=65&&T<=90&&(v=`/${String.fromCharCode(T+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const T=v.charCodeAt(0);T>=65&&T<=90&&(v=`${String.fromCharCode(T+32)}:${v.substr(2)}`)}k+=o(v,!0,!1)}return C&&(k+="?",k+=o(C,!1,!1)),L&&(k+="#",k+=n?L:a(L,!1,!1)),k}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(u)?i.replace(u,n=>t(n)):i}}),define(te[154],ie([0,1,7]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Op=e.$Np=e.$Mp=void 0;function O(l){const b=l;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.$Mp=O;function s(l){const b=[];let w;try{const p=JSON.parse(l.arguments),f=p[p.length-1];f&&f.__$stack&&(p.pop(),w=f.__$stack),b.push(...p)}catch{b.push("Unable to log remote console arguments",l.arguments)}return{args:b,stack:w}}e.$Np=s;function M(l){if(typeof l!="string")return M(s(l).stack);const b=l;if(b){const w=I(b),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(p&&p.length===4)return{uri:P.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Op=M;function I(l){if(!l)return l;const b=l.indexOf(`
`);return b===-1?l:l.substring(0,b)}function S(l,b){const{args:w,stack:p}=s(l),f=typeof w[0]=="string"&&w.length===1;let y=I(p);y&&(y=`(${y.trim()})`);let m=[];if(typeof w[0]=="string"?y&&f?m=[`%c[${b}] %c${w[0]} %c${y}`,h("blue"),h(""),h("grey")]:m=[`%c[${b}] %c${w[0]}`,h("blue"),h(""),...w.slice(1)]:m=[`%c[${b}]%`,h("blue"),...w],y&&!f&&m.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,m)}e.log=S;function h(l){return`color: ${l}`}}),define(te[74],ie([0,1,17,7]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=e.$9g=e.$8g=void 0;function s(h){return JSON.stringify(h,I)}e.$8g=s;function M(h){let l=JSON.parse(h);return l=S(l),l}e.$9g=M;function I(h,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function S(h,l=0){if(!h||l>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return O.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof P.$Ed||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let b=0;b<h.length;++b)h[b]=S(h[b],l+1);else for(const b in h)Object.hasOwnProperty.call(h,b)&&(h[b]=S(h[b],l+1))}return h}e.$0g=S}),define(te[13],ie([0,1,14,4,7]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.Schemas=void 0;var M;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$Tf="vscode-tkn",e.$Uf="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b){this.f=`${b}/${M.vscodeRemoteResource}`}set(b,w,p){this.a[b]=w,this.b[b]=p}setConnectionToken(b,w){this.c[b]=w}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(d){return P.$Y(d),b}const w=b.authority;let p=this.a[w];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const f=this.b[w],y=this.c[w];let m=`path=${encodeURIComponent(b.path)}`;return typeof y=="string"&&(m+=`&${e.$Uf}=${encodeURIComponent(y)}`),s.URI.from({scheme:O.$o?this.d:M.vscodeRemoteResource,authority:`${p}:${f}`,path:this.f,query:m})}}e.$Vf=new I,e.$Wf="vs/../../extensions",e.$Xf="vs/../../node_modules",e.$Yf="vs/../../node_modules.asar",e.$Zf="vs/../../node_modules.asar.unpacked";class S{static{this.a="vscode-app"}asBrowserUri(b){const w=this.b(b,K);return this.uriToBrowserUri(w)}uriToBrowserUri(b){return b.scheme===M.vscodeRemote?e.$Vf.rewrite(b):b.scheme===M.file&&(O.$m||O.$p&&O.$g.origin===`${M.vscodeFileResource}://${S.a}`)?b.with({scheme:M.vscodeFileResource,authority:b.authority||S.a,query:null,fragment:null}):b}asFileUri(b){const w=this.b(b,K);return this.uriToFileUri(w)}uriToFileUri(b){return b.scheme===M.vscodeFileResource?b.with({scheme:M.file,authority:b.authority!==S.a?b.authority:null,query:null,fragment:null}):b}b(b,w){return s.URI.isUri(b)?b:s.URI.parse(w.toUrl(b))}}e.$1f=new S;var h;(function(l){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(b.get("3"));const w="vscode-coi";function p(y){let m;typeof y=="string"?m=new URL(y).searchParams:y instanceof URL?m=y.searchParams:s.URI.isUri(y)&&(m=new URL(y.toString(!0)).searchParams);const d=m?.get(w);if(d)return b.get(d)}l.getHeadersFromQuery=p;function f(y,m,d){if(!globalThis.crossOriginIsolated)return;const c=m&&d?"3":d?"2":"1";y instanceof URLSearchParams?y.set(w,c):y[w]=c}l.addSearchParam=f})(h||(e.COI=h={}))}),define(te[19],ie([0,1,32,13,9,4,26,7]),function(K,e,P,O,s,M,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.DataUri=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=void 0;function h(f){return(0,S.$Sf)(f,!0)}e.$8f=h;class l{constructor(y){this.a=y}compare(y,m,d=!1){return y===m?0:(0,I.$Ee)(this.getComparisonKey(y,d),this.getComparisonKey(m,d))}isEqual(y,m,d=!1){return y===m?!0:!y||!m?!1:this.getComparisonKey(y,d)===this.getComparisonKey(m,d)}getComparisonKey(y,m=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,m,d=!1){if(y.scheme===m.scheme){if(y.scheme===O.Schemas.file)return P.$Hf(h(y),h(m),this.a(y))&&y.query===m.query&&(d||y.fragment===m.fragment);if((0,e.$mg)(y.authority,m.authority))return P.$Hf(y.path,m.path,this.a(y),"/")&&y.query===m.query&&(d||y.fragment===m.fragment)}return!1}joinPath(y,...m){return S.URI.joinPath(y,...m)}basenameOrAuthority(y){return(0,e.$eg)(y)||y.authority}basename(y){return s.$5d.basename(y.path)}extname(y){return s.$5d.extname(y.path)}dirname(y){if(y.path.length===0)return y;let m;return y.scheme===O.Schemas.file?m=S.URI.file(s.$$d(h(y))).path:(m=s.$5d.dirname(y.path),y.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),m="/")),y.with({path:m})}normalizePath(y){if(!y.path.length)return y;let m;return y.scheme===O.Schemas.file?m=S.URI.file(s.$6d(h(y))).path:m=s.$5d.normalize(y.path),y.with({path:m})}relativePath(y,m){if(y.scheme!==m.scheme||!(0,e.$mg)(y.authority,m.authority))return;if(y.scheme===O.Schemas.file){const a=s.$0d(h(y),h(m));return M.$i?P.$Bf(a):a}let d=y.path||"/";const c=m.path||"/";if(this.a(y)){let a=0;for(const $=Math.min(d.length,c.length);a<$&&!(d.charCodeAt(a)!==c.charCodeAt(a)&&d.charAt(a).toLowerCase()!==c.charAt(a).toLowerCase());a++);d=c.substr(0,a)+d.substr(a)}return s.$5d.relative(d,c)}resolvePath(y,m){if(y.scheme===O.Schemas.file){const d=S.URI.file(s.$9d(h(y),m));return y.with({authority:d.authority,path:d.path})}return m=P.$Cf(m),y.with({path:s.$5d.resolve(y.path,m)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,m){return y===m||y!==void 0&&m!==void 0&&(0,I.$Le)(y,m)}hasTrailingPathSeparator(y,m=s.sep){if(y.scheme===O.Schemas.file){const d=h(y);return d.length>P.$Df(d).length&&d[d.length-1]===m}else{const d=y.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,m=s.sep){return(0,e.$ng)(y,m)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,m=s.sep){let d=!1;if(y.scheme===O.Schemas.file){const c=h(y);d=c!==void 0&&c.length===P.$Df(c).length&&c[c.length-1]===m}else{m="/";const c=y.path;d=c.length===1&&c.charCodeAt(c.length-1)===47}return!d&&!(0,e.$ng)(y,m)?y.with({path:y.path+"/"}):y}}e.$9f=l,e.$0f=new l(()=>!1),e.$$f=new l(f=>f.scheme===O.Schemas.file?!M.$k:!0),e.$_f=new l(f=>!0),e.$ag=e.$0f.isEqual.bind(e.$0f),e.$bg=e.$0f.isEqualOrParent.bind(e.$0f),e.$cg=e.$0f.getComparisonKey.bind(e.$0f),e.$dg=e.$0f.basenameOrAuthority.bind(e.$0f),e.$eg=e.$0f.basename.bind(e.$0f),e.$fg=e.$0f.extname.bind(e.$0f),e.$gg=e.$0f.dirname.bind(e.$0f),e.$hg=e.$0f.joinPath.bind(e.$0f),e.$ig=e.$0f.normalizePath.bind(e.$0f),e.$jg=e.$0f.relativePath.bind(e.$0f),e.$kg=e.$0f.resolvePath.bind(e.$0f),e.$lg=e.$0f.isAbsolutePath.bind(e.$0f),e.$mg=e.$0f.isEqualAuthority.bind(e.$0f),e.$ng=e.$0f.hasTrailingPathSeparator.bind(e.$0f),e.$og=e.$0f.removeTrailingPathSeparator.bind(e.$0f),e.$pg=e.$0f.addTrailingPathSeparator.bind(e.$0f);function b(f,y){const m=[];for(let d=0;d<f.length;d++){const c=y(f[d]);f.some((a,$)=>$===d?!1:(0,e.$bg)(c,y(a)))||m.push(f[d])}return m}e.$qg=b;var w;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function y(m){const d=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach($=>{const[E,g]=$.split(":");E&&g&&d.set(E,g)});const a=m.path.substring(0,m.path.indexOf(";"));return a&&d.set(f.META_DATA_MIME,a),d}f.parseMetaData=y})(w||(e.DataUri=w={}));function p(f,y,m){if(y){let d=f.path;return d&&d[0]!==s.$5d.sep&&(d=s.$5d.sep+d),f.with({scheme:m,authority:y,path:d})}return f.with({scheme:m})}e.$rg=p}),define(te[8],ie([0,1,22,14,3,2,19,4,142]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.$3g=e.$2g=e.Promises=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function l(R){return!!R&&typeof R.then=="function"}e.$sg=l;function b(R){const j=new P.$od,F=R(j.token),W=new Promise((q,V)=>{const re=j.token.onCancellationRequested(()=>{re.dispose(),j.dispose(),V(new O.$3)});Promise.resolve(F).then($e=>{re.dispose(),j.dispose(),q($e)},$e=>{re.dispose(),j.dispose(),V($e)})});return new class{cancel(){j.cancel()}then(q,V){return W.then(q,V)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.$tg=b;function w(R,j,F){return new Promise((W,q)=>{const V=j.onCancellationRequested(()=>{V.dispose(),W(F)});R.then(W,q).finally(()=>V.dispose())})}e.$ug=w;function p(R,j){return new Promise((F,W)=>{const q=j.onCancellationRequested(()=>{q.dispose(),W(new O.$3)});R.then(F,W).finally(()=>q.dispose())})}e.$vg=p;async function f(R){let j=-1;const F=R.map((W,q)=>W.then(V=>(j=q,V)));try{return await Promise.race(F)}finally{R.forEach((W,q)=>{q!==j&&W.cancel()})}}e.$wg=f;function y(R,j,F){let W;const q=setTimeout(()=>{W?.(void 0),F?.()},j);return Promise.race([R.finally(()=>clearTimeout(q)),new Promise(V=>W=V)])}e.$xg=y;function m(R){return new Promise((j,F)=>{const W=R();l(W)?W.then(j,F):j(W)})}e.$yg=m;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const F=()=>{if(this.b=null,this.f)return;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(F,F).then(W)})}return new Promise((F,W)=>{this.b.then(F,W)})}return this.a=j(),new Promise((F,W)=>{this.a.then(q=>{this.a=null,F(q)},q=>{this.a=null,W(q)})})}dispose(){this.f=!0}}e.$zg=d;class c{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$Ag=c;class a{constructor(){this.a=new Map}queue(j,F){const q=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(j)===q&&this.a.delete(j)});return this.a.set(j,q),q}}e.$Bg=a;const $=(R,j)=>{let F=!0;const W=setTimeout(()=>{F=!1,j()},R);return{isTriggered:()=>F,dispose:()=>{clearTimeout(W),F=!1}}},E=R=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,R())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class g{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,F=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((q,V)=>{this.d=q,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=F===h.$bd?E(W):$(F,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Cg=g;class t{constructor(j){this.a=new g(j),this.b=new d}trigger(j,F){return this.a.trigger(()=>this.b.queue(j),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dg=t;class u{constructor(){this.a=!1,this.b=new Promise((j,F)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eg=u;class r extends u{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$Fg=r;function i(R,j){return j?new Promise((F,W)=>{const q=setTimeout(()=>{V.dispose(),F()},R),V=j.onCancellationRequested(()=>{clearTimeout(q),V.dispose(),W(new O.$3)})}):b(F=>i(R,F))}e.$Gg=i;function n(R,j=0){const F=setTimeout(R,j);return(0,M.$hc)(()=>clearTimeout(F))}e.$Hg=n;function o(R){const j=[];let F=0;const W=R.length;function q(){return F<W?R[F++]():null}function V(re){re!=null&&j.push(re);const $e=q();return $e?$e.then(V):Promise.resolve(j)}return Promise.resolve(null).then(V)}e.$Ig=o;function k(R,j=W=>!!W,F=null){let W=0;const q=R.length,V=()=>{if(W>=q)return Promise.resolve(F);const re=R[W++];return Promise.resolve(re()).then(de=>j(de)?Promise.resolve(de):V())};return V()}e.$Jg=k;function A(R,j=W=>!!W,F=null){if(R.length===0)return Promise.resolve(F);let W=R.length;const q=()=>{W=-1;for(const V of R)V.cancel?.()};return new Promise((V,re)=>{for(const $e of R)$e.then(de=>{--W>=0&&j(de)?(q(),V(de)):W===0&&V(F)}).catch(de=>{--W>=0&&(q(),re(de))})})}e.$Kg=A;class D{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new s.$ed}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((F,W)=>{this.f.push({factory:j,c:F,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const F=j.factory();F.then(j.c,j.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Lg=D;class v extends D{constructor(){super(1)}}e.$Mg=v;class C{constructor(){this.a=new J,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$Ng=C;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new N;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,F=I.$0f){const W=F.getComparisonKey(j);let q=this.a.get(W);if(!q){q=new v;const V=this.f++,re=s.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(V),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$rc),this.d.set(V,re),this.a.set(W,q)}return q}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Og=L;class T{constructor(j,F){this.a=-1,typeof j=="function"&&typeof F=="number"&&this.setIfNotSet(j,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},F)}setIfNotSet(j,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},F))}}e.$Pg=T;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,F){this.cancel(),this.a=setInterval(()=>{j()},F)}}e.$Qg=z;class se{constructor(j,F){this.b=-1,this.a=j,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rg=se;class ee{constructor(j,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=j,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sg=ee;class ae extends se{constructor(j,F){super(j,F),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$Tg=ae;class ne extends M.$jc{constructor(j,F){super(),this.g=j,this.h=F,this.a=[],this.b=this.B(new M.$kc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of j)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ug=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Vg=R=>{(0,S.$A)(()=>{if(j)return;const F=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.$Vg=(R,j)=>{const F=requestIdleCallback(R,typeof j=="number"?{timeout:j}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(F))}}}}();class oe{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.$Vg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Wg=oe;async function G(R,j,F){let W;for(let q=0;q<F;q++)try{return await R()}catch(V){W=V,await i(j)}throw W}e.$Xg=G;class J{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,F,W){return this.a={taskId:j,cancel:()=>W?.(),promise:F},F.then(()=>this.d(j),()=>this.d(j)),F}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let F,W;const q=new Promise((V,re)=>{F=V,W=re});this.b={run:j,promise:q,promiseResolve:F,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yg=J;class B{constructor(j,F=()=>Date.now()){this.d=j,this.f=F,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$Zg=B;var U;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(U||(U={}));class N{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,F)=>{this.a=j,this.b=F})}complete(j){return new Promise(F=>{this.a(j),this.d={outcome:0,value:j},F()})}error(j){return new Promise(F=>{this.b(j),this.d={outcome:1,value:j},F()})}cancel(){return this.error(new O.$3)}}e.$1g=N;var H;(function(R){async function j(W){let q;const V=await Promise.all(W.map(re=>re.then($e=>$e,$e=>{q||(q=$e)})));if(typeof q<"u")throw q;return V}R.settled=j;function F(W){return new Promise(async(q,V)=>{try{await W(q,V)}catch(re){V(re)}})}R.withAsyncBody=F})(H||(e.Promises=H={}));var Q;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(Q||(Q={}));class x{static fromArray(j){return new x(F=>{F.emitMany(j)})}static fromPromise(j){return new x(async F=>{F.emitMany(await j)})}static fromPromises(j){return new x(async F=>{await Promise.all(j.map(async W=>F.emitOne(await W)))})}static merge(j){return new x(async F=>{await Promise.all(j.map(async W=>{for await(const q of W)F.emitOne(q)}))})}static{this.EMPTY=x.fromArray([])}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new s.$ed,queueMicrotask(async()=>{const F={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(j(F)),this.j()}catch(W){this.k(W)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(j,F){return new x(async W=>{for await(const q of j)W.emitOne(F(q))})}map(j){return x.map(this,j)}static filter(j,F){return new x(async W=>{for await(const q of j)F(q)&&W.emitOne(q)})}filter(j){return x.filter(this,j)}static coalesce(j){return x.filter(j,F=>!!F)}coalesce(){return x.coalesce(this)}static async toPromise(j){const F=[];for await(const W of j)F.push(W);return F}toPromise(){return x.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$2g=x;class ce extends x{constructor(j,F){super(F),this.l=j}cancel(){this.l.cancel()}}e.$3g=ce;function Y(R){const j=new P.$od,F=R(j.token);return new ce(j,async W=>{const q=j.token.onCancellationRequested(()=>{q.dispose(),j.dispose(),W.reject(new O.$3)});try{for await(const V of F){if(j.token.isCancellationRequested)return;W.emitOne(V)}q.dispose(),j.dispose()}catch(V){q.dispose(),j.dispose(),W.reject(V)}})}e.$4g=Y}),define(te[104],ie([0,1,23,8,32,33,9,4,26]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0;function l(){return Object.create(null)}e.$lj=l,e.$mj="**",e.$nj="/";const b="[/\\\\]",w="[^/\\\\]",p=/\//g;function f(J,B){switch(J){case 0:return"";case 1:return`${w}*?`;default:return`(?:${b}|${w}+${b}${B?`|${b}${w}+`:""})*?`}}function y(J,B){if(!J)return[];const U=[];let N=!1,H=!1,Q="";for(const x of J){switch(x){case B:if(!N&&!H){U.push(Q),Q="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":H=!0;break;case"]":H=!1;break}Q+=x}return Q&&U.push(Q),U}e.$oj=y;function m(J){if(!J)return"";let B="";const U=y(J,e.$nj);if(U.every(N=>N===e.$mj))B=".*";else{let N=!1;U.forEach((H,Q)=>{if(H===e.$mj){if(N)return;B+=f(2,Q===U.length-1)}else{let x=!1,ce="",Y=!1,R="";for(const j of H){if(j!=="}"&&x){ce+=j;continue}if(Y&&(j!=="]"||!R)){let F;j==="-"?F=j:(j==="^"||j==="!")&&!R?F="^":j===e.$nj?F="":F=(0,h.$pe)(j),R+=F;continue}switch(j){case"{":x=!0;continue;case"[":Y=!0;continue;case"}":{const W=`(?:${y(ce,",").map(q=>m(q)).join("|")})`;B+=W,x=!1,ce="";break}case"]":{B+="["+R+"]",Y=!1,R="";break}case"?":B+=w;continue;case"*":B+=f(1);continue;default:B+=(0,h.$pe)(j)}}Q<U.length-1&&(U[Q+1]!==e.$mj||Q+2<U.length)&&(B+=b)}N=H===e.$mj})}return B}const d=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Bi(1e4),u=function(){return!1},r=function(){return null};function i(J,B){if(!J)return r;let U;typeof J!="string"?U=J.pattern:U=J,U=U.trim();const N=`${U}_${!!B.trimForExclusions}`;let H=t.get(N);if(H)return n(H,J);let Q;return d.test(U)?H=k(U.substr(4),U):(Q=c.exec(o(U,B)))?H=A(Q[1],U):(B.trimForExclusions?$:a).test(U)?H=D(U,B):(Q=E.exec(o(U,B)))?H=v(Q[1].substr(1),U,!0):(Q=g.exec(o(U,B)))?H=v(Q[1],U,!1):H=C(U),t.set(N,H),n(H,J)}function n(J,B){if(typeof B=="string")return J;const U=function(N,H){return(0,s.$Hf)(N,B.base,!S.$k)?J((0,h.$te)(N.substr(B.base.length),I.sep),H):null};return U.allBasenames=J.allBasenames,U.allPaths=J.allPaths,U.basenames=J.basenames,U.patterns=J.patterns,U}function o(J,B){return B.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function k(J,B){return function(U,N){return typeof U=="string"&&U.endsWith(J)?B:null}}function A(J,B){const U=`/${J}`,N=`\\${J}`,H=function(x,ce){return typeof x!="string"?null:ce?ce===J?B:null:x===J||x.endsWith(U)||x.endsWith(N)?B:null},Q=[J];return H.basenames=Q,H.patterns=[B],H.allBasenames=Q,H}function D(J,B){const U=oe(J.slice(1,-1).split(",").map(ce=>i(ce,B)).filter(ce=>ce!==r),J),N=U.length;if(!N)return r;if(N===1)return U[0];const H=function(ce,Y){for(let R=0,j=U.length;R<j;R++)if(U[R](ce,Y))return J;return null},Q=U.find(ce=>!!ce.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const x=U.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return x.length&&(H.allPaths=x),H}function v(J,B,U){const N=I.sep===I.$5d.sep,H=N?J:J.replace(p,I.sep),Q=I.sep+H,x=I.$5d.sep+J;let ce;return U?ce=function(Y,R){return typeof Y=="string"&&(Y===H||Y.endsWith(Q)||!N&&(Y===J||Y.endsWith(x)))?B:null}:ce=function(Y,R){return typeof Y=="string"&&(Y===H||!N&&Y===J)?B:null},ce.allPaths=[(U?"*/":"./")+J],ce}function C(J){try{const B=new RegExp(`^${m(J)}$`);return function(U){return B.lastIndex=0,typeof U=="string"&&B.test(U)?J:null}}catch{return r}}function L(J,B,U){return!J||typeof B!="string"?!1:T(J)(B,void 0,U)}e.$pj=L;function T(J,B={}){if(!J)return u;if(typeof J=="string"||z(J)){const U=i(J,B);if(U===r)return u;const N=function(H,Q){return!!U(H,Q)};return U.allBasenames&&(N.allBasenames=U.allBasenames),U.allPaths&&(N.allPaths=U.allPaths),N}return ae(J,B)}e.$qj=T;function z(J){const B=J;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.$rj=z;function se(J){return J.allBasenames||[]}e.$sj=se;function ee(J){return J.allPaths||[]}e.$tj=ee;function ae(J,B){const U=oe(Object.getOwnPropertyNames(J).map(ce=>ne(ce,J[ce],B)).filter(ce=>ce!==r)),N=U.length;if(!N)return r;if(!U.some(ce=>!!ce.requiresSiblings)){if(N===1)return U[0];const ce=function(j,F){let W;for(let q=0,V=U.length;q<V;q++){const re=U[q](j,F);if(typeof re=="string")return re;(0,O.$sg)(re)&&(W||(W=[]),W.push(re))}return W?(async()=>{for(const q of W){const V=await q;if(typeof V=="string")return V}return null})():null},Y=U.find(j=>!!j.allBasenames);Y&&(ce.allBasenames=Y.allBasenames);const R=U.reduce((j,F)=>F.allPaths?j.concat(F.allPaths):j,[]);return R.length&&(ce.allPaths=R),ce}const H=function(ce,Y,R){let j,F;for(let W=0,q=U.length;W<q;W++){const V=U[W];V.requiresSiblings&&R&&(Y||(Y=(0,I.$_d)(ce)),j||(j=Y.substr(0,Y.length-(0,I.$ae)(ce).length)));const re=V(ce,Y,j,R);if(typeof re=="string")return re;(0,O.$sg)(re)&&(F||(F=[]),F.push(re))}return F?(async()=>{for(const W of F){const q=await W;if(typeof q=="string")return q}return null})():null},Q=U.find(ce=>!!ce.allBasenames);Q&&(H.allBasenames=Q.allBasenames);const x=U.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return x.length&&(H.allPaths=x),H}function ne(J,B,U){if(B===!1)return r;const N=i(J,U);if(N===r)return r;if(typeof B=="boolean")return N;if(B){const H=B.when;if(typeof H=="string"){const Q=(x,ce,Y,R)=>{if(!R||!N(x,ce))return null;const j=H.replace("$(basename)",()=>Y),F=R(j);return(0,O.$sg)(F)?F.then(W=>W?J:null):F?J:null};return Q.requiresSiblings=!0,Q}}return N}function oe(J,B){const U=J.filter(ce=>!!ce.basenames);if(U.length<2)return J;const N=U.reduce((ce,Y)=>{const R=Y.basenames;return R?ce.concat(R):ce},[]);let H;if(B){H=[];for(let ce=0,Y=N.length;ce<Y;ce++)H.push(B)}else H=U.reduce((ce,Y)=>{const R=Y.patterns;return R?ce.concat(R):ce},[]);const Q=function(ce,Y){if(typeof ce!="string")return null;if(!Y){let j;for(j=ce.length;j>0;j--){const F=ce.charCodeAt(j-1);if(F===47||F===92)break}Y=ce.substr(j)}const R=N.indexOf(Y);return R!==-1?H[R]:null};Q.basenames=N,Q.patterns=H,Q.allBasenames=N;const x=J.filter(ce=>!ce.basenames);return x.push(Q),x}function G(J,B){return(0,P.$sb)(J,B,(U,N)=>typeof U=="string"&&typeof N=="string"?U===N:typeof U!="string"&&typeof N!="string"?U.base===N.base&&U.pattern===N.pattern:!1)}e.$uj=G}),define(te[46],ie([0,1,23,32,9,4,19,26]),function(K,e,P,O,s,M,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mA=e.$lA=e.$kA=e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=void 0;function h(i,n){const{os:o,tildify:k,relative:A}=n;if(A){const C=l(i,A,o);if(typeof C=="string")return C}let D=i.fsPath;if(o===1&&!M.$i?D=D.replace(/\//g,"\\"):o!==1&&M.$i&&(D=D.replace(/\\/g,"/")),o!==1&&k?.userHome){const C=k.userHome.fsPath;let L;i.scheme!==k.userHome.scheme&&i.path.startsWith(s.$5d.sep)?L=k.userHome.with({path:i.path}).fsPath:L=i.fsPath,D=p(L,C,o)}return(o===1?s.$4d:s.$5d).normalize(b(D,o===1))}e.$dA=h;function l(i,n,o){const k=o===1?s.$4d:s.$5d,A=o===3?I.$0f:I.$_f,D=n.getWorkspace(),v=(0,P.$Lb)(D.folders);if(!v)return;i.scheme!==v.uri.scheme&&i.path.startsWith(s.$5d.sep)&&(i=v.uri.with({path:i.path}));const C=n.getWorkspaceFolder(i);if(!C)return;let L;if(A.isEqual(C.uri,i)?L="":L=A.relativePath(C.uri,i)??"",L&&(L=k.normalize(L)),D.folders.length>1&&!n.noPrefix){const T=C.name?C.name:A.basenameOrAuthority(C.uri);L=L?`${T} \u2022 ${L}`:T}return L}function b(i,n=M.$i){return(0,O.$Lf)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$eA=b;let w=Object.create(null);function p(i,n,o=M.OS){if(o===1||!i||!n)return i;let k=w.original===n?w.normalized:void 0;k||(k=n,M.$i&&(k=(0,O.$Bf)(k)),k=`${(0,S.$ue)(k,s.$5d.sep)}${s.$5d.sep}`,w={original:n,normalized:k});let A=i;return M.$i&&(A=(0,O.$Bf)(A)),(o===3?A.startsWith(k):(0,S.$Me)(A,k))?`~/${A.substr(k.length)}`:i}e.$fA=p;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$gA=f;const y="\u2026",m="\\\\",d="~";function c(i,n=s.sep){const o=new Array(i.length);let k=!1;for(let A=0;A<i.length;A++){const D=i[A];if(D===""){o[A]=`.${n}`;continue}if(!D){o[A]=D;continue}k=!0;let v="",C=D;C.indexOf(m)===0?(v=C.substr(0,C.indexOf(m)+m.length),C=C.substr(C.indexOf(m)+m.length)):C.indexOf(n)===0?(v=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf(d)===0&&(v=C.substr(0,C.indexOf(d)+d.length),C=C.substr(C.indexOf(d)+d.length));const L=C.split(n);for(let T=1;k&&T<=L.length;T++)for(let z=L.length-T;k&&z>=0;z--){k=!1;let se=L.slice(z,z+T).join(n);for(let ee=0;!k&&ee<i.length;ee++)if(ee!==A&&i[ee]&&i[ee].indexOf(se)>-1){const ae=z+T===L.length,ne=z>0&&i[ee].indexOf(n)>-1?n+se:se,oe=i[ee].endsWith(ne);k=!ae||oe}if(!k){let ee="";(L[0].endsWith(":")||v!=="")&&(z===1&&(z=0,T++,se=L[0]+n+se),z>0&&(ee=L[0]+n),ee=v+ee),z>0&&(ee=ee+y+n),ee=ee+se,z+T<L.length&&(ee=ee+n+y),o[A]=ee}}k&&(o[A]=D)}return o}e.$hA=c;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function $(i,n=Object.create(null)){const o=[];let k=!1,A="";for(const D of i)if(D==="$"||k&&D==="{")A&&o.push({value:A,type:a.TEXT}),A="",k=!0;else if(D==="}"&&k){const v=n[A];if(typeof v=="string")v.length&&o.push({value:v,type:a.VARIABLE});else if(v){const C=o[o.length-1];(!C||C.type!==a.SEPARATOR)&&o.push({value:v.label,type:a.SEPARATOR})}A="",k=!1}else A+=D;return A&&!k&&o.push({value:A,type:a.TEXT}),o.filter((D,v)=>{if(D.type===a.SEPARATOR){const C=o[v-1],L=o[v+1];return[C,L].every(T=>T&&(T.type===a.VARIABLE||T.type===a.TEXT)&&T.value.length>0)}return!0}).map(D=>D.value).join("")}e.$iA=$;function E(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$jA=E;function g(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$kA=g;function t(i){return i.replace(/&/g,"&&")}e.$lA=t;function u(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const o=r(i.substring(0,n));return{name:o.name,parentPath:o.parentPath+i.substring(n)}}}return r(i)}e.$mA=u;function r(i){const n=i.indexOf("/")!==-1?s.$5d:s.$4d,o=n.basename(i),k=n.dirname(i);return o.length?{name:o,parentPath:k}:{name:k,parentPath:""}}}),define(te[155],ie([0,1,17,7]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0;function s(w){return w.toJSON()}class M{constructor(p){this.a=p}transformIncoming(p){const f=this.a.transformIncoming(p);return f===p?p:s(O.URI.from(f))}transformOutgoing(p){const f=this.a.transformOutgoing(p);return f===p?p:s(O.URI.from(f))}transformOutgoingURI(p){const f=this.a.transformOutgoing(p);return f===p?p:O.URI.from(f)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Am=M,e.$Bm=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function I(w,p,f){if(!w||f>200)return null;if(typeof w=="object"){if(w instanceof O.URI)return p.transformOutgoing(w);for(const y in w)if(Object.hasOwnProperty.call(w,y)){const m=I(w[y],p,f+1);m!==null&&(w[y]=m)}}return null}function S(w,p){const f=I(w,p,0);return f===null?w:f}e.$Cm=S;function h(w,p,f,y){if(!w||y>200)return null;if(typeof w=="object"){if(w.$mid===1)return f?O.URI.revive(p.transformIncoming(w)):p.transformIncoming(w);if(w instanceof P.$Ed)return null;for(const m in w)if(Object.hasOwnProperty.call(w,m)){const d=h(w[m],p,f,y+1);d!==null&&(w[m]=d)}}return null}function l(w,p){const f=h(w,p,!1,0);return f===null?w:f}e.$Dm=l;function b(w,p){const f=h(w,p,!0,0);return f===null?w:f}e.$Em=b}),define(te[21],ie([0,1,45,27,156,8,32,85,9,4,19,7]),function(K,e,P,O,s,M,I,S,h,l,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(ne){ne[ne.UNLINK=0]="UNLINK",ne[ne.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function f(ne,oe=p.UNLINK,G){if((0,I.$Kf)(ne))throw new Error("rimraf - will refuse to recursively delete root");return oe===p.UNLINK?m(ne):y(ne,G)}async function y(ne,oe=(0,I.$Pf)((0,O.tmpdir)())){try{try{await P.promises.rename(ne,oe)}catch(G){return G.code==="ENOENT"?void 0:m(ne)}m(oe).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function m(ne){return(0,s.promisify)(P.rm)(ne,{recursive:!0,force:!0,maxRetries:3})}function d(ne){if((0,I.$Kf)(ne))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(ne,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function c(ne,oe){return E(await(oe?a(ne):(0,s.promisify)(P.readdir)(ne)))}async function a(ne){try{return await(0,s.promisify)(P.readdir)(ne,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const oe=[],G=await c(ne);for(const J of G){let B=!1,U=!1,N=!1;try{const H=await e.Promises.lstat((0,h.$8d)(ne,J));B=H.isFile(),U=H.isDirectory(),N=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}oe.push({name:J,isFile:()=>B,isDirectory:()=>U,isSymbolicLink:()=>N})}return oe}function $(ne){return E(P.readdirSync(ne))}e.readdirSync=$;function E(ne){return ne.map(oe=>typeof oe=="string"?l.$j?(0,S.$gl)(oe):oe:(oe.name=l.$j?(0,S.$gl)(oe.name):oe.name,oe))}async function g(ne){const oe=await c(ne),G=[];for(const J of oe)await u.existsDirectory((0,h.$8d)(ne,J))&&G.push(J);return G}function t(ne,oe=1e3){return new Promise(G=>{let J=!1;const B=setInterval(()=>{J||(J=!0,P.access(ne,U=>{J=!1,U&&(clearInterval(B),G(void 0))}))},oe)})}e.whenDeleted=t;var u;(function(ne){async function oe(B){let U;try{if(U=await e.Promises.lstat(B),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(l.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw H}throw N}}ne.stat=oe;async function G(B){try{const{stat:U,symbolicLink:N}=await ne.stat(B);return U.isFile()&&N?.dangling!==!0}catch{}return!1}ne.existsFile=G;async function J(B){try{const{stat:U,symbolicLink:N}=await ne.stat(B);return U.isDirectory()&&N?.dangling!==!0}catch{}return!1}ne.existsDirectory=J})(u||(e.SymlinkSupport=u={}));const r=new M.$Og;function i(ne,oe,G){return r.queueFor(w.URI.file(ne),b.$$f).queue(()=>{const J=D(G);return new Promise((B,U)=>k(ne,oe,J,N=>N?U(N):B()))})}let n=!0;function o(ne){n=ne}e.configureFlushOnWrite=o;function k(ne,oe,G,J){if(!n)return P.writeFile(ne,oe,{mode:G.mode,flag:G.flag},J);P.open(ne,G.flag,G.mode,(B,U)=>{if(B)return J(B);P.writeFile(U,oe,N=>{if(N)return P.close(U,()=>J(N));P.fdatasync(U,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),o(!1)),P.close(U,Q=>J(Q))))})})}function A(ne,oe,G){const J=D(G);if(!n)return P.writeFileSync(ne,oe,{mode:J.mode,flag:J.flag});const B=P.openSync(ne,J.flag,J.mode);try{P.writeFileSync(B,oe);try{P.fdatasyncSync(B)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),o(!1)}}finally{P.closeSync(B)}}e.writeFileSync=A;function D(ne){return ne?{mode:typeof ne.mode=="number"?ne.mode:438,flag:typeof ne.flag=="string"?ne.flag:"w"}:{mode:438,flag:"w"}}async function v(ne,oe,G=6e4){if(ne!==oe)try{l.$i&&typeof G=="number"?await C(ne,oe,Date.now(),G):await(0,s.promisify)(P.rename)(ne,oe)}catch(J){if(ne.toLowerCase()!==oe.toLowerCase()&&J.code==="EXDEV"||ne.endsWith("."))await L(ne,oe,{preserveSymlinks:!1}),await f(ne,p.MOVE);else throw J}}async function C(ne,oe,G,J,B=0){try{return await(0,s.promisify)(P.rename)(ne,oe)}catch(U){if(U.code!=="EACCES"&&U.code!=="EPERM"&&U.code!=="EBUSY")throw U;if(Date.now()-G>=J)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${U}`),U;if(B===0){let N=!1;try{const{stat:H}=await u.stat(oe);H.isFile()||(N=!0)}catch{}if(N)throw U}return await(0,M.$Gg)(Math.min(100,B*10)),C(ne,oe,G,J,B+1)}}async function L(ne,oe,G){return z(ne,oe,{root:{source:ne,target:oe},options:G,handledSourcePaths:new Set})}const T=511;async function z(ne,oe,G){if(G.handledSourcePaths.has(ne))return;G.handledSourcePaths.add(ne);const{stat:J,symbolicLink:B}=await u.stat(ne);if(B){if(G.options.preserveSymlinks)try{return await ae(ne,oe,G)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(B.dangling)return}return J.isDirectory()?se(ne,oe,J.mode&T,G):ee(ne,oe,J.mode&T)}async function se(ne,oe,G,J){await e.Promises.mkdir(oe,{recursive:!0,mode:G});const B=await c(ne);for(const U of B)await z((0,h.$8d)(ne,U),(0,h.$8d)(oe,U),J)}async function ee(ne,oe,G){await e.Promises.copyFile(ne,oe),await e.Promises.chmod(oe,G)}async function ae(ne,oe,G){let J=await e.Promises.readlink(ne);(0,I.$Hf)(J,G.root.source,!l.$k)&&(J=(0,h.$8d)(G.root.target,J.substr(G.root.source.length+1))),await e.Promises.symlink(J,oe)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(ne,oe,G,J,B)=>new Promise((U,N)=>{P.read(ne,oe,G,J,B,(H,Q,x)=>H?N(H):U({bytesRead:Q,buffer:x}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(ne,oe,G,J,B)=>new Promise((U,N)=>{P.write(ne,oe,G,J,B,(H,Q,x)=>H?N(H):U({bytesWritten:Q,buffer:x}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(ne){try{return await e.Promises.access(ne),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return g}get writeFile(){return i}get rm(){return f}get rename(){return v}get copy(){return L}}}),define(te[105],ie([0,1,45,9,4,26,21]),function(K,e,P,O,s,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.$Tp=void 0;function S(p){if(s.$k)return p;const f=(0,O.$$d)(p);if(p===f)return p;const y=((0,O.$_d)(p)||p).toLowerCase();try{const d=(0,I.readdirSync)(f).filter(c=>c.toLowerCase()===y);if(d.length===1){const c=S(f);if(c)return(0,O.$8d)(c,d[0])}else if(d.length>1){const c=d.indexOf(y);if(c>=0){const a=S(f);if(a)return(0,O.$8d)(a,d[c])}}}catch{}return null}e.$Tp=S;async function h(p){if(s.$k)return p;const f=(0,O.$$d)(p);if(p===f)return p;const y=((0,O.$_d)(p)||p).toLowerCase();try{const d=(await I.Promises.readdir(f)).filter(c=>c.toLowerCase()===y);if(d.length===1){const c=await h(f);if(c)return(0,O.$8d)(c,d[0])}else if(d.length>1){const c=d.indexOf(y);if(c>=0){const a=await h(f);if(a)return(0,O.$8d)(a,d[c])}}}catch{}return null}e.$Up=h;async function l(p){try{return await I.Promises.realpath(p)}catch{const y=w(p);return await I.Promises.access(y,P.constants.R_OK),y}}e.$Vp=l;function b(p){try{return P.realpathSync(p)}catch{const y=w(p);return P.accessSync(y,P.constants.R_OK),y}}e.$Wp=b;function w(p){return(0,M.$ue)((0,O.$6d)(p),O.sep)}}),define(te[106],ie([0,1,27,9,21]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=void 0;const M=/^\d+$/,I=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var h;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(h||(h={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class w{constructor(g,t,u){this.exePath=g,this.displayName=t,this.a=u}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:E=!1}={}){return E?l===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:g=!1}={}){const t=p({useAlternateBitness:E});if(!t)return null;const u=O.$8d(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(u))return null;let r=-1,i=null;for(const k of await s.Promises.readdir(u)){let A=-1;if(g){const v=k.indexOf("-");if(v<0)continue;const C=k.substring(0,v);if(!M.test(C)||k.substring(v+1)!=="preview")continue;A=parseInt(C,10)}else{if(!M.test(k))continue;A=parseInt(k,10)}if(A<=r)continue;const D=O.$8d(u,k,"pwsh.exe");await s.SymlinkSupport.existsFile(D)&&(i=D,r=A)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",o=g?" Preview":"";return new w(i,`PowerShell${o}${n}`,!0)}async function y({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const g=O.$8d(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:t,pwshMsixName:u}=E?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(g))if(t.test(r)){const i=O.$8d(g,r,"pwsh.exe");return new w(i,u)}return null}function m(){const E=O.$8d(P.homedir(),".dotnet","tools","pwsh.exe");return new w(E,".NET Core PowerShell Global Tool")}function d(){const E=O.$8d(process.env.windir,l===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(E,"Windows PowerShell",!0)}async function*c(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await y(),E&&(yield E),E=m(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await y({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=d(),E&&(yield E)}async function*a(){for await(const E of c())await E.exists()&&(yield E)}e.$pl=a;async function $(){for await(const E of a())return E;return null}e.$ql=$}),define(te[88],ie([0,1,9,4,35,73,12,21]),function(K,e,P,O,s,M,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$ul=e.$tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function h(w=s.env){return w.comspec||"cmd.exe"}e.$tl=h;function l(w){let p=[],f=!1;const y=function(m){if(f){p.push(m);return}(!w.send(m,c=>{if(c&&console.error(c),f=!1,p.length>0){const a=p.slice(0);p=[],a.forEach($=>y($))}})||O.$i)&&(f=!0)};return{send:y}}e.$ul=l;var b;(function(w){async function p(f,y,m){if(P.$7d(f))return f;if(y===void 0&&(y=s.cwd()),P.$$d(f)!=="."||(m===void 0&&I.$if(s.env.PATH)&&(m=s.env.PATH.split(P.$fe)),m===void 0||m.length===0))return P.$8d(y,f);async function c(a){if(await S.Promises.exists(a)){let $;try{$=await S.Promises.stat(a)}catch(E){E.message.startsWith("EACCES")&&($=await S.Promises.lstat(a))}return $?!$.isDirectory():!1}return!1}for(const a of m){let $;if(P.$7d(a)?$=P.$8d(a,f):$=P.$8d(y,a,f),await c($))return $;let E=$+".com";if(await c(E)||(E=$+".exe",await c(E)))return E}return P.$8d(y,f)}w.findExecutable=p})(b||(e.win32=b={}))}),define(te[107],ie([0,1,47,13]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;function s(I){return new Promise((S,h)=>{let l;const b=new Map;function w(f,y,m,d,c){const a=b.get(y);if(f===I||a){const $={name:p(m),cmd:m,pid:f,ppid:y,load:d,mem:c};b.set(f,$),f===I&&(l=$),a&&(a.children||(a.children=[]),a.children.push($),a.children.length>1&&(a.children=a.children.sort((E,g)=>E.pid-g.pid)))}}function p(f){const y=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,d=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,a=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(d.exec(f))return"electron-crash-reporter";if(c.exec(f))return"winpty-agent";if(a.exec(f))return"conpty-agent";let E=$.exec(f);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?y.exec(f)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const g=/[a-zA-Z-]+\.js/g;let t="";do E=g.exec(f),E&&(t+=E+" ");while(E);return t&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${t})`:m.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,m)=>{K(["@vscode/windows-process-tree"],y,m)}).then(y=>{y.getProcessList(I,m=>{if(!m){h(new Error(`Root process ${I} not found`));return}y.getProcessCpuUsage(m,d=>{const c=new Map;d.forEach(a=>{const $=f(a.commandLine||"");c.set(a.pid,{name:p($),cmd:$,pid:a.pid,ppid:a.ppid,load:a.cpu||0,mem:a.memory||0})}),l=c.get(I),l?(c.forEach(a=>{const $=c.get(a.ppid);$&&($.children||($.children=[]),$.children.push(a))}),c.forEach(a=>{a.children&&(a.children=a.children.sort(($,E)=>$.pid-E.pid))}),S(l)):h(new Error(`Root process ${I} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let f=function(){let y=[l];const m=[];for(;y.length;){const c=y.shift();c&&(m.push(c.pid),c.children&&(y=y.concat(c.children)))}let d=JSON.stringify(O.$1f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+m.join(" "),(0,P.exec)(d,{},(c,a,$)=>{if(c||$)h(c||new Error($.toString()));else{const E=a.toString().split(`
`);for(let g=0;g<m.length;g++){const t=b.get(m[g]);t.load=parseFloat(E[g])}if(!l){h(new Error(`Root process ${I} not found`));return}S(l)}})};(0,P.exec)("which ps",{},(y,m,d)=>{if(y||d)if(process.platform!=="linux")h(y||new Error(d.toString()));else{const c=JSON.stringify(O.$1f.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(c,{},(a,$,E)=>{a||E?h(a||new Error(E.toString())):(M($,w),f())})}else{const c=m.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${c} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},($,E,g)=>{$||g&&!g.includes("screen size is bogus")?h($||new Error(g.toString())):(M(E,w),process.platform==="linux"?f():l?S(l):h(new Error(`Root process ${I} not found`)))})}})}})}e.$rr=s;function M(I,S){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=I.toString().split(`
`);for(const b of l){const w=h.exec(b.trim());w&&w.length===6&&S(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(te[108],ie([0,1,27,4,106,88]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=void 0;async function I(w,p){return w===1?O.$i?b():M.$tl(p):h(w,p)}e.$vl=I;let S=null;function h(w,p){if(O.$k&&w===2||O.$j&&w===3)return"/bin/bash";if(!S){let f;if(O.$i)f="/bin/bash";else{if(f=p.SHELL,!f)try{f=(0,P.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}S=f}return S}let l=null;async function b(){return l||(l=(await(0,s.$ql)()).exePath),l}});var ke=this&&this.__decorate||function(K,e,P,O){var s=arguments.length,M=s<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,P):O,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(K,e,P,O);else for(var S=K.length-1;S>=0;S--)(I=K[S])&&(M=(s<3?I(M):s>3?I(e,P,M):I(e,P))||M);return s>3&&M&&Object.defineProperty(e,P,M),M};define(te[42],ie([0,1,23,8,17,22,55,14,3,2,74,26,12]),function(K,e,P,O,s,M,I,S,h,l,b,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.ProxyChannel=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.RequestInitiator=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0;var f;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(f||(f={}));function y(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(m||(m={}));function d(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(c||(c={}));function a(B){let U=0;for(let N=0;;N+=7){const H=B.read(1);if(U|=(H.buffer[0]&127)<<N,!(H.buffer[0]&128))return U}}const $=r(0);function E(B,U){if(U===0){B.write($);return}let N=0;for(let Q=U;Q!==0;Q=Q>>>7)N++;const H=s.$Ed.alloc(N);for(let Q=0;U!==0;Q++)H.buffer[Q]=U&127,U=U>>>7,U>0&&(H.buffer[Q]|=128);B.write(H)}class g{constructor(U){this.b=U,this.a=0}read(U){const N=this.b.slice(this.a,this.a+U);return this.a+=N.byteLength,N}}e.$$g=g;class t{constructor(){this.a=[]}get buffer(){return s.$Ed.concat(this.a)}write(U){this.a.push(U)}}e.$_g=t;var u;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(u||(u={}));function r(B){const U=s.$Ed.alloc(1);return U.writeUInt8(B,0),U}const i={Undefined:r(u.Undefined),String:r(u.String),Buffer:r(u.Buffer),VSBuffer:r(u.VSBuffer),Array:r(u.Array),Object:r(u.Object),Uint:r(u.Int)},n=typeof Buffer<"u";function o(B,U){if(typeof U>"u")B.write(i.Undefined);else if(typeof U=="string"){const N=s.$Ed.fromString(U);B.write(i.String),E(B,N.byteLength),B.write(N)}else if(n&&Buffer.isBuffer(U)){const N=s.$Ed.wrap(U);B.write(i.Buffer),E(B,N.byteLength),B.write(N)}else if(U instanceof s.$Ed)B.write(i.VSBuffer),E(B,U.byteLength),B.write(U);else if(Array.isArray(U)){B.write(i.Array),E(B,U.length);for(const N of U)o(B,N)}else if(typeof U=="number"&&(U|0)===U)B.write(i.Uint),E(B,U);else{const N=s.$Ed.fromString(JSON.stringify(U));B.write(i.Object),E(B,N.byteLength),B.write(N)}}e.$ah=o;function k(B){switch(B.read(1).readUInt8(0)){case u.Undefined:return;case u.String:return B.read(a(B)).toString();case u.Buffer:return B.read(a(B)).buffer;case u.VSBuffer:return B.read(a(B));case u.Array:{const N=a(B),H=[];for(let Q=0;Q<N;Q++)H.push(k(B));return H}case u.Object:return JSON.parse(B.read(a(B)).toString());case u.Int:return a(B)}}e.$bh=k;class A{constructor(U,N,H=null,Q=1e3){this.h=U,this.j=N,this.k=H,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(U,N){this.b.set(U,N),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const N=this.o([U.type]);this.k?.logOutgoing(N,0,1,d(U.type));return}case 201:case 202:case 204:case 203:{const N=this.o([U.type,U.id],U.data);this.k?.logOutgoing(N,U.id,1,d(U.type),U.data);return}}}o(U,N=void 0){const H=new t;return o(H,U),o(H,N),this.p(H.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const N=new g(U),H=k(N),Q=k(N),x=H[0];switch(x){case 100:return this.k?.logIncoming(U.byteLength,H[1],1,`${y(x)}: ${H[2]}.${H[3]}`,Q),this.s({type:x,id:H[1],channelName:H[2],name:H[3],arg:Q});case 102:return this.k?.logIncoming(U.byteLength,H[1],1,`${y(x)}: ${H[2]}.${H[3]}`,Q),this.t({type:x,id:H[1],channelName:H[2],name:H[3],arg:Q});case 101:return this.k?.logIncoming(U.byteLength,H[1],1,`${y(x)}`),this.u({type:x,id:H[1]});case 103:return this.k?.logIncoming(U.byteLength,H[1],1,`${y(x)}`),this.u({type:x,id:H[1]})}}s(U){const N=this.b.get(U.channelName);if(!N){this.v(U);return}const H=new M.$od;let Q;try{Q=N.call(this.j,U.name,U.arg,H.token)}catch(Y){Q=Promise.reject(Y)}const x=U.id;Q.then(Y=>{this.m({id:x,data:Y,type:201})},Y=>{Y instanceof Error?this.m({id:x,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.m({id:x,data:Y,type:203})}).finally(()=>{ce.dispose(),this.d.delete(U.id)});const ce=(0,l.$hc)(()=>H.cancel());this.d.set(U.id,ce)}t(U){const N=this.b.get(U.channelName);if(!N){this.v(U);return}const H=U.id,x=N.listen(this.j,U.name,U.arg)(ce=>this.m({id:H,data:ce,type:204}));this.d.set(U.id,x)}u(U){const N=this.d.get(U.id);N&&(N.dispose(),this.d.delete(U.id))}v(U){let N=this.g.get(U.channelName);N||(N=[],this.g.set(U.channelName,N));const H=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:U,timeoutTimer:H})}w(U){const N=this.g.get(U);if(N){for(const H of N)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$ec)(this.d.values()),this.d.clear()}}e.$ch=A;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class v{constructor(U,N=null){this.l=U,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$ed,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=N}getChannel(U){const N=this;return{call(H,Q,x){return N.a?Promise.reject(new S.$3):N.m(U,H,Q,x)},listen(H,Q){return N.a?h.Event.None:N.o(U,H,Q)}}}m(U,N,H,Q=M.CancellationToken.None){const x=this.g++,Y={id:x,type:100,channelName:U,name:N,arg:H};if(Q.isCancellationRequested)return Promise.reject(new S.$3);let R;return new Promise((F,W)=>{if(Q.isCancellationRequested)return W(new S.$3);const q=()=>{const de=ue=>{switch(ue.type){case 201:this.f.delete(x),F(ue.data);break;case 202:{this.f.delete(x);const be=new Error(ue.data.message);be.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,be.name=ue.data.name,W(be);break}case 203:this.f.delete(x),W(ue.data);break}};this.f.set(x,de),this.p(Y)};let V=null;this.b===c.Idle?q():(V=(0,O.$tg)(de=>this.u()),V.then(()=>{V=null,q()}));const re=()=>{V?(V.cancel(),V=null):this.p({id:x,type:101}),W(new S.$3)},$e=Q.onCancellationRequested(re);R=(0,l.$gc)((0,l.$hc)(re),$e),this.d.add(R)}).finally(()=>{R.dispose(),this.d.delete(R)})}o(U,N,H){const Q=this.g++,ce={id:Q,type:102,channelName:U,name:N,arg:H};let Y=null;const R=new h.$ed({onWillAddFirstListener:()=>{Y=(0,O.$tg)(F=>this.u()),Y.then(()=>{Y=null,this.d.add(R),this.p(ce)})},onDidRemoveLastListener:()=>{Y?(Y.cancel(),Y=null):(this.d.delete(R),this.p({id:Q,type:103}))}}),j=F=>R.fire(F.data);return this.f.set(Q,j),R.event}p(U){switch(U.type){case 100:case 102:{const N=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(N,U.id,0,`${y(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const N=this.q([U.type,U.id]);this.j?.logOutgoing(N,U.id,0,y(U.type));return}}}q(U,N=void 0){const H=new t;return o(H,U),o(H,N),this.r(H.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const N=new g(U),H=k(N),Q=k(N),x=H[0];switch(x){case 200:return this.j?.logIncoming(U.byteLength,0,0,d(x)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,H[1],0,d(x),Q),this.t({type:H[0],id:H[1],data:Q})}}t(U){if(U.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$ec)(this.d.values()),this.d.clear()}}e.$dh=v,ke([I.$5g],v.prototype,"onDidInitializePromise",null);class C{get connections(){const U=[];return this.f.forEach(N=>U.push(N)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new h.$ed,this.onDidAddConnection=this.g.event,this.h=new h.$ed,this.onDidRemoveConnection=this.h.event,this.j=new l.$ic,this.j.add(U(({protocol:N,onDidClientDisconnect:H})=>{const Q=h.Event.once(N.onMessage);this.j.add(Q(x=>{const ce=new g(x),Y=k(ce),R=new A(N,Y),j=new v(N);this.a.forEach((W,q)=>R.registerChannel(q,W));const F={channelServer:R,channelClient:j,ctx:Y};this.f.add(F),this.g.fire(F),this.j.add(H(()=>{R.dispose(),j.dispose(),this.f.delete(F),this.h.fire(F)}))}))}))}getChannel(U,N){const H=this;return{call(Q,x,ce){let Y;if((0,p.$wf)(N)){const j=(0,P.$1b)(H.connections.filter(N));Y=j?Promise.resolve(j):h.Event.toPromise(h.Event.filter(H.onDidAddConnection,N))}else Y=N.routeCall(H,Q,x);const R=Y.then(j=>j.channelClient.getChannel(U));return T(R).call(Q,x,ce)},listen(Q,x){if((0,p.$wf)(N))return H.k(U,N,Q,x);const ce=N.routeEvent(H,Q,x).then(Y=>Y.channelClient.getChannel(U));return T(ce).listen(Q,x)}}}k(U,N,H,Q){const x=this;let ce;const Y=new h.$ed({onWillAddFirstListener:()=>{ce=new l.$ic;const R=new h.$kd,j=new Map,F=q=>{const re=q.channelClient.getChannel(U).listen(H,Q),$e=R.add(re);j.set(q,$e)},W=q=>{const V=j.get(q);V&&(V.dispose(),j.delete(q))};x.connections.filter(N).forEach(F),h.Event.filter(x.onDidAddConnection,N)(F,void 0,ce),x.onDidRemoveConnection(W,void 0,ce),R.event(Y.fire,Y,ce),ce.add(R)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return Y.event}registerChannel(U,N){this.a.set(U,N);for(const H of this.f)H.channelServer.registerChannel(U,N)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$eh=C;class L{constructor(U,N,H=null){const Q=new t;o(Q,N),U.send(Q.buffer),this.a=new v(U,H),this.d=new A(U,N,H)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,N){this.d.registerChannel(U,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fh=L;function T(B){return{call(U,N,H){return B.then(Q=>Q.call(U,N,H))},listen(U,N){const H=new h.$nd;return B.then(Q=>H.input=Q.listen(U,N)),H.event}}}e.$gh=T;function z(B){let U=!1;return{call(N,H,Q){return U?B.call(N,H,Q):(0,O.$Gg)(0).then(()=>U=!0).then(()=>B.call(N,H,Q))},listen(N,H){if(U)return B.listen(N,H);const Q=new h.$nd;return(0,O.$Gg)(0).then(()=>U=!0).then(()=>Q.input=B.listen(N,H)),Q.event}}}e.$hh=z;class se{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const N of U.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await h.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$ih=se;var ee;(function(B){function U(x,ce,Y){const R=x,j=Y&&Y.disableMarshalling,F=new Map;for(const W in R)H(W)&&F.set(W,h.Event.buffer(R[W],!0,void 0,ce));return new class{listen(W,q,V){const re=F.get(q);if(re)return re;if(Q(q)){const $e=R[q];if(typeof $e=="function")return $e.call(R,V)}throw new S.$_(`Event not found: ${q}`)}call(W,q,V){const re=R[q];if(typeof re=="function"){if(!j&&Array.isArray(V))for(let $e=0;$e<V.length;$e++)V[$e]=(0,b.$0g)(V[$e]);return re.apply(R,V)}throw new S.$_(`Method not found: ${q}`)}}}B.fromService=U;function N(x,ce){const Y=ce&&ce.disableMarshalling;return new Proxy({},{get(R,j){if(typeof j=="string")return ce?.properties?.has(j)?ce.properties.get(j):Q(j)?function(F){return x.listen(j,F)}:H(j)?x.listen(j):async function(...F){let W;ce&&!(0,p.$rf)(ce.context)?W=[ce.context,...F]:W=F;const q=await x.call(j,W);return Y?q:(0,b.$0g)(q)};throw new S.$_(`Property not found: ${String(j)}`)}})}B.toService=N;function H(x){return x[0]==="o"&&x[1]==="n"&&w.$Ke(x.charCodeAt(2))}function Q(x){return/^onDynamic/.test(x)&&w.$Ke(x.charCodeAt(9))}})(ee||(e.ProxyChannel=ee={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ne(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const U=B.toString();if(U!=="[object Object]")return U}return B}function oe(B){return Array.isArray(B)?B.map(ne):ne(B)}function G(B,U,N,H,Q,x,ce){ce=oe(ce);const Y=ae[Q],R=Y[H%Y.length];let j=[`%c[${B}]%c[${String(U).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(x)?(j=j.concat(ce),j.push(")")):j.push(ce),console.log.apply(console,j)}class J{constructor(U,N){this.d=U,this.f=N,this.a=0,this.b=0}logOutgoing(U,N,H,Q,x){this.b+=U,G(this.d,this.b,U,N,H,Q,x)}logIncoming(U,N,H,Q,x){this.a+=U,G(this.f,this.a,U,N,H,Q,x)}}e.$jh=J}),define(te[157],ie([0,1,17,3,42]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QS=e.$PS=void 0;class M{constructor(h){this.a=h,this.onMessage=O.Event.fromDOMEventEmitter(this.a,"message",l=>P.$Ed.wrap(l.data)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$PS=M;class I extends s.$fh{constructor(h,l){const b=new M(h);super(b,l),this.b=b}dispose(){this.b.disconnect(),super.dispose()}}e.$QS=I}),define(te[109],ie([0,1,17,3,2,42]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e.$lh=e.ProtocolConstants=e.$kh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function k(D,v){if(!n.has(D)){const C=String(++o);n.set(D,C)}return n.get(D)}function A(D,v,C,L){if(!i.enableDiagnostics)return;const T=k(D,v);if(L instanceof P.$Ed||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const z=P.$Ed.alloc(L.byteLength);z.set(L),i.records.push({timestamp:Date.now(),id:T,label:v,type:C,buff:z})}else i.records.push({timestamp:Date.now(),id:T,label:v,type:C,data:L})}i.traceSocketEvent=A})(S||(e.SocketDiagnostics=S={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let l=null;function b(){return l||(l=P.$Ed.alloc(0)),l}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return b();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const v=this.a[0];return o&&(this.a.shift(),this.b-=n),v}if(this.a[0].byteLength>n){const v=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),v}const k=P.$Ed.alloc(n);let A=0,D=0;for(;n>0;){const v=this.a[D];if(v.byteLength>n){const C=v.slice(0,n);k.set(C,A),A+=n,o&&(this.a[D]=v.slice(n),this.b-=n),n-=n}else k.set(v,A),A+=v.byteLength,o?(this.a.shift(),this.b-=v.byteLength):D++,n-=v.byteLength}return k}}e.$kh=w;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function f(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class m{constructor(n,o,k,A){this.type=n,this.id=o,this.ack=k,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends s.$jc{constructor(n){super(),this.f=this.B(new O.$ed),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new w,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,A=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new m(k,A,D,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=P.$Ed.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(o,n.data)}g(n,o){const k=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,k}h(){const n=P.$Ed.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class a extends s.$jc{constructor(n){super(),this.f=new O.$ed,this.onMessage=this.f.event,this.g=new O.$ed,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new c(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$lh=a;class $ extends M.$fh{static fromSocket(n,o){return new $(new a(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,k=null){super(n,o,k),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$mh=$;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$ed({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$nh=E;class g{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,k=this.a;for(;k;)n[o++]=k.data,k=k.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new g(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class u{static{this.a=10}static{this.b=null}static getInstance(){return u.b||(u.b=new u),u.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<u.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=u.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+u.a)*1e3;let k=0;for(let A=0;A<u.a;A++)n-this.c[A]<=o&&k++;return 1-k/u.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??u.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$ic,this.o=n.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,b());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,b());this.p.write(n)}sendResume(){const n=new m(8,0,0,b());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new s.$ic,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,b());this.p.write(n);const o=this.b.toArray();for(let k=0,A=o.length;k<A;k++)this.p.write(o[k]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new m(6,0,0,b())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let k=0,A=o.length;k<A;k++)this.p.write(o[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const k=new m(1,o,this.h,n);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(n){const o=new m(2,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,k=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(o>=2e4&&k>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:k});return}const D=Math.max(2e4-o,2e4-k,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,b());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,b());this.p.write(n)}}e.$oh=r}),define(te[158],ie([0,1,38,17,3,2,42,146]),function(K,e,P,O,s,M,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TS=void 0;function h(b,w){const p=s.Event.fromNodeEventEmitter(P.$MS,w,(y,m)=>({event:y,message:m})),f=s.Event.filter(p,({event:y})=>y.sender.id===b);return s.Event.map(f,({message:y})=>y&&O.$Ed.wrap(y))}class l extends I.$eh{static{this.b=new Map}static d(){const w=s.Event.fromNodeEventEmitter(P.$MS,"vscode:hello",({sender:p})=>p);return s.Event.map(w,p=>{const f=p.id;l.b.get(f)?.dispose();const m=new s.$ed;l.b.set(f,(0,M.$hc)(()=>m.fire()));const d=h(f,"vscode:message"),c=s.Event.any(s.Event.signal(h(f,"vscode:disconnect")),m.event);return{protocol:new S.$SS(p,d),onDidClientDisconnect:c}})}constructor(){super(l.d())}}e.$TS=l}),define(te[110],ie([0,1,38,3,31,157]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VS=e.$US=void 0;class I extends M.$QS{constructor(l,b){super({addEventListener:(w,p)=>l.addListener(w,p),removeEventListener:(w,p)=>l.removeListener(w,p),postMessage:w=>l.postMessage(w),start:()=>l.start(),close:()=>l.close()},b)}}e.$US=I;async function S(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,s.$3f)();h.webContents.send("vscode:createMessageChannel",l);const b=O.Event.fromNodeEventEmitter(P.$MS,"vscode:createMessageChannelResult",(p,f)=>({nonce:f,port:p.ports[0]})),{port:w}=await O.Event.toPromise(O.Event.once(O.Event.filter(b,p=>p.nonce===l)));return w}e.$VS=S}),define(te[159],ie([0,1,47,8,17,22,154,14,3,2,37,88,73,42]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;class y extends f.$ch{constructor(c){super({send:a=>{try{process.send?.(a.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",a=>s.$Ed.wrap(Buffer.from(a,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Qp=y;class m{constructor(c,a){this.i=c,this.j=a,this.c=new Set,this.g=new Map,this.h=new h.$ed,this.onDidProcessExit=this.h.event;const $=a&&a.timeout?a.timeout:6e4;this.b=new O.$Cg($),this.d=null,this.f=null}getChannel(c){const a=this;return{call($,E,g){return a.k(c,$,E,g)},listen($,E){return a.l(c,$,E)}}}k(c,a,$,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(S.$4());this.b.cancel();const g=this.n(c),t=(0,O.$tg)(i=>g.call(a,$,i)),u=E.onCancellationRequested(()=>t.cancel()),r=(0,l.$hc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{u.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,a,$){if(!this.b)return h.Event.None;this.b.cancel();let E;const g=new h.$ed({onWillAddFirstListener:()=>{E=this.n(c).listen(a,$)(g.fire,g),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],a=Object.create(null);a.env={...(0,b.$Um)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(a.env={...a.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(a.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$sl)(a.env),this.d=(0,P.fork)(this.i,c,a);const $=new h.$ed;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,I.$Mp)(n)){(0,I.log)(n,`IPC Library: ${this.j.serverName}`);return}$.fire(s.$Ed.wrap(Buffer.from(n,"base64")))});const g=this.j.useQueue?(0,w.$ul)(this.d):this.d,t=n=>this.d&&this.d.connected&&g.send(n.buffer.toString("base64")),u=$.event,r={send:t,onMessage:u};this.f=new f.$dh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",i),this.c.forEach(k=>(0,l.$ec)(k)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(c){let a=this.g.get(c);return a||(a=this.m.getChannel(c),this.g.set(c,a)),a}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Rp=m}),define(te[111],ie([0,1,8,3,2,74,12]),function(K,e,P,O,s,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.StorageState=e.$Po=e.StorageHint=void 0;var S;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function h(p){const f=p;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$Po=h;var l;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(l||(e.StorageState=l={}));class b extends s.$jc{static{this.a=100}constructor(f,y=Object.create(null)){super(),this.r=f,this.s=y,this.b=this.B(new O.$hd),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new P.$Dg(b.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((y,m)=>this.w(m,y)),f.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(f,y){if(this.c===l.Closed)return;let m=!1;(0,I.$rf)(y)?m=this.f.delete(f):this.f.get(f)!==y&&(this.f.set(f,y),m=!0),m&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,y){const m=this.f.get(f);return(0,I.$rf)(m)?y:m}getBoolean(f,y){const m=this.get(f);return(0,I.$rf)(m)?y:m==="true"}getNumber(f,y){const m=this.get(f);return(0,I.$rf)(m)?y:parseInt(m,10)}getObject(f,y){const m=this.get(f);return(0,I.$rf)(m)?y:(0,M.$9g)(m)}async set(f,y,m=!1){if(this.c===l.Closed)return;if((0,I.$rf)(y))return this.delete(f,m);const d=(0,I.$kf)(y)||Array.isArray(y)?(0,M.$8g)(y):String(y);if(this.f.get(f)!==d)return this.f.set(f,d),this.j.set(f,d),this.h.delete(f),this.b.fire({key:f,external:m}),this.D()}async delete(f,y=!1){if(!(this.c===l.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:y}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Qo=b;class w{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((y,m)=>this.a.set(m,y)),f.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Ro=w}),define(te[160],ie([0,1,8,3,33,9,21]),function(K,e,P,O,s,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fT=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return O.Event.None}static{this.a=2e3}static{this.b=256}constructor(b,w=Object.create(null)){this.g=b,this.h=w,this.c=(0,M.$_d)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,w=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(f=>w.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${w.size} rows`),w}async updateItems(b){const w=await this.f;return this.j(w,b)}j(b,w){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${w.insert?(0,s.$wi)(w.insert):"0"}), delete(${w.delete?(0,s.$xi)(w.delete):"0"})`),this.t(b,()=>{const p=w.insert,f=w.delete;if(p&&p.size>0){const y=[];y.push([]);let m=0;p.forEach((d,c)=>{let a=y[m];a.length>S.b&&(m++,a=[],y.push(a)),a.push(c,d)}),y.forEach(d=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(d.length/2).fill("(?,?)").join(",")}`,c=>c.run(d),()=>{const c=[];let a=0;return p.forEach(($,E)=>{c.push(E),a+=$.length}),`Keys: ${c.join(", ")} Length: ${a}`})})}if(f&&f.size){const y=[];y.push([]);let m=0;f.forEach(d=>{let c=y[m];c.length>S.b&&(m++,c=[],y.push(c)),c.push(d)}),y.forEach(d=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(d.length).fill("?").join(",")})`,c=>c.run(d),()=>{const c=[];return f.forEach(a=>{c.push(a)}),`Keys: ${c.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const b=await this.f;return this.q(b,"VACUUM")}async close(b){this.d.trace(`[storage ${this.c}] close()`);const w=await this.f;return this.k(w,b)}k(b,w){return new Promise((p,f)=>{b.db.close(y=>(y&&this.o(b,`[storage ${this.c}] close(): ${y}`),this.g===S.IN_MEMORY_PATH?p():!b.isErroneous&&!b.isInMemory?this.l().then(p,m=>(this.d.error(`[storage ${this.c}] backup(): ${m}`),p())):typeof w=="function"?I.Promises.unlink(this.g).then(()=>this.p(this.g).then(m=>{const d=()=>this.k(m,void 0);return this.j(m,{insert:w()}).then(()=>d(),c=>(d(),Promise.reject(c)))})).then(p,f):f(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return I.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const w=await this.f,p=await this.r(w,b?"PRAGMA integrity_check":"PRAGMA quick_check"),f=b?p.integrity_check:p.quick_check;return w.isErroneous?`${f} (last error: ${w.lastError})`:w.isInMemory?`${f} (in-memory!)`:f}async n(b,w=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${w})`);try{return await this.p(b)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&w)return await(0,P.$Gg)(S.a),this.n(b,!1);try{await I.Promises.unlink(b);try{await I.Promises.rename(this.m(b),b,!1)}catch{}return await this.p(b)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(S.IN_MEMORY_PATH)}}}o(b,w){b.isErroneous=!0,b.lastError=w,this.d.error(w)}p(b){return new Promise((w,p)=>{new Promise((f,y)=>{K(["@vscode/sqlite3"],f,y)}).then(f=>{const y={db:new(this.d.isTracing?f.verbose().Database:f.Database)(b,m=>m?y.db&&m.code!=="SQLITE_CANTOPEN"?y.db.close(()=>p(m)):p(m):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>w(y),d=>y.db.close(()=>p(d)))),isInMemory:b===S.IN_MEMORY_PATH};y.db.on("error",m=>this.o(y,`[storage ${this.c}] Error (event): ${m}`)),this.d.isTracing&&y.db.on("trace",m=>this.d.trace(`[storage ${this.c}] Trace (event): ${m}`))},p)})}q(b,w){return new Promise((p,f)=>{b.db.exec(w,y=>y?(this.o(b,`[storage ${this.c}] exec(): ${y}`),f(y)):p())})}r(b,w){return new Promise((p,f)=>{b.db.get(w,(y,m)=>y?(this.o(b,`[storage ${this.c}] get(): ${y}`),f(y)):p(m))})}s(b,w){return new Promise((p,f)=>{b.db.all(w,(y,m)=>y?(this.o(b,`[storage ${this.c}] all(): ${y}`),f(y)):p(m))})}t(b,w){return new Promise((p,f)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),w(),b.db.run("END TRANSACTION",y=>y?(this.o(b,`[storage ${this.c}] transaction(): ${y}`),f(y)):p())})})}u(b,w,p,f){const y=b.db.prepare(w),m=d=>{this.o(b,`[storage ${this.c}] prepare(): ${d} (${w}). Details: ${f()}`)};y.on("error",m),p(y),y.finalize(d=>{d&&m(d),y.removeListener("error",m)})}}e.$fT=S;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(b){b&&typeof b.logTrace=="function"&&process.env[h.a]&&(this.b=b.logTrace),b&&typeof b.logError=="function"&&(this.c=b.logError)}get isTracing(){return!!this.b}trace(b){this.b?.(b)}error(b){this.c?.(b)}}}),define(te[161],ie([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(te[162],ie([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[163],ie([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(te[164],ie([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(te[165],ie([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(te[166],ie([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[167],ie([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(te[168],ie([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(te[169],ie([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[170],ie([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[171],ie([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[172],ie([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[173],ie([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[174],ie([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(te[175],ie([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(te[176],ie([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(te[177],ie([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[178],ie([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[179],ie([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[180],ie([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[181],ie([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[182],ie([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(te[183],ie([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(te[184],ie([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[185],ie([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[186],ie([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[187],ie([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(te[188],ie([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[189],ie([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[190],ie([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[191],ie([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(te[192],ie([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[193],ie([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[194],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9T=e.$8T=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$8T=P;function O(s){return s&&s.hasOwnProperty("workspace")}e.$9T=O}),define(te[195],ie([0,1,7]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p5b=e.$o5b=e.$n5b=void 0;function O(I){return typeof I?.backupFolder=="string"}e.$n5b=O;function s(I){let S=[];try{Array.isArray(I.workspaces)&&(S=I.workspaces.map(h=>({workspace:{id:h.id,configPath:P.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return S}e.$o5b=s;function M(I){let S=[];try{Array.isArray(I.folders)&&(S=I.folders.map(h=>({folderUri:P.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return S}e.$p5b=M}),define(te[196],ie([0,1,14,164]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.TokenType=void 0;var s;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...l){switch(l.length){case 1:return(0,O.localize)(0,null,l[0]);case 2:return(0,O.localize)(1,null,l[0],l[1]);case 3:return(0,O.localize)(2,null,l[0],l[1],l[2]);default:return}}const I=(0,O.localize)(3,null),S=(0,O.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return b.isTripleEq?"===":"==";case 4:return b.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return b.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return b.lexeme;case 18:return b.lexeme;case 19:return b.lexeme;case 20:return"EOF";default:throw(0,P.$6)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const w=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:w})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const w=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:w})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const w=this.d,p=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:p};this.g.push({offset:w,lexeme:p,additionalInfo:b}),this.f.push(f)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const w=this.c.substring(this.d,this.e),p=h.b.get(w);p?this.k(p):this.f.push({type:17,lexeme:w,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,w=!1,p=!1;for(;;){if(b>=this.c.length){this.e=b,this.l(S);return}const y=this.c.charCodeAt(b);if(w)w=!1;else if(y===47&&!p){b++;break}else y===91?p=!0:y===92?w=!0:y===93&&(p=!1);b++}for(;b<this.c.length&&h.a.has(this.c.charCodeAt(b));)b++;this.e=b;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ei=h}),define(te[197],ie([0,1,3,2]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0;class s{constructor(){this.a=new P.$ed,this.b=new P.$ed,this.c=new P.$ed,this.d=new P.$ed}static{this.ChannelName="extensionhostdebugservice"}call(S,h,l){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(S,h,l){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$An=s;class M extends O.$jc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,h,l){this.b.call("attach",[S,h,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,h){this.b.call("terminate",[S,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,h){return this.b.call("openExtensionDevelopmentHostWindow",[S,h])}}e.$Bn=M}),define(te[198],ie([0,1,149,55,13,9,35,19,7]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=void 0,e.$7l=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,M.$$d)(s.$1f.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,M.$8d)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,S.$hg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$hg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,P.$6l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$8d)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$hg)(h.URI.file((0,M.$8d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$hg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$hg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$hg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=I.env.VSCODE_PORTABLE;return f?h.URI.file((0,M.$8d)(f,"argv.json")):(0,S.$hg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,M.$8d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,M.$9d)(f):(0,M.$6d)((0,M.$8d)(s.$1f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,M.$9d)(f)):h.URI.file((0,M.$8d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,M.$9d)(f);const y=I.env.VSCODE_EXTENSIONS;if(y)return y;const m=I.env.VSCODE_PORTABLE;return m?(0,M.$8d)(m,"extensions"):(0,S.$hg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(y=>/^[^:/?#]+?:\/\//.test(y)?h.URI.parse(y):h.URI.file((0,M.$6d)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,M.$6d)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$7l.test(f))}get extensionLogLevel(){const f=[];for(const y of this.args.log||[]){const m=e.$7l.exec(y);m&&m[1]&&m[2]&&f.push([m[1],m[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,S.$hg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=I.env.VSCODE_PORTABLE;return f?h.URI.file((0,M.$8d)(f,"policy.json")):(0,S.$hg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,y,m){this.a=f,this.b=y,this.c=m,this.editSessionId=this.args.editSessionId}}e.$8l=l,ke([O.$5g],l.prototype,"appRoot",null),ke([O.$5g],l.prototype,"userHome",null),ke([O.$5g],l.prototype,"userDataPath",null),ke([O.$5g],l.prototype,"appSettingsHome",null),ke([O.$5g],l.prototype,"tmpDir",null),ke([O.$5g],l.prototype,"cacheHome",null),ke([O.$5g],l.prototype,"stateResource",null),ke([O.$5g],l.prototype,"userRoamingDataHome",null),ke([O.$5g],l.prototype,"userDataSyncHome",null),ke([O.$5g],l.prototype,"sync",null),ke([O.$5g],l.prototype,"machineSettingsResource",null),ke([O.$5g],l.prototype,"workspaceStorageHome",null),ke([O.$5g],l.prototype,"localHistoryHome",null),ke([O.$5g],l.prototype,"keyboardLayoutResource",null),ke([O.$5g],l.prototype,"argvResource",null),ke([O.$5g],l.prototype,"isExtensionDevelopment",null),ke([O.$5g],l.prototype,"untitledWorkspacesHome",null),ke([O.$5g],l.prototype,"builtinExtensionsPath",null),ke([O.$5g],l.prototype,"extensionsPath",null),ke([O.$5g],l.prototype,"extensionDevelopmentLocationURI",null),ke([O.$5g],l.prototype,"extensionDevelopmentKind",null),ke([O.$5g],l.prototype,"extensionTestsLocationURI",null),ke([O.$5g],l.prototype,"debugExtensionHost",null),ke([O.$5g],l.prototype,"logLevel",null),ke([O.$5g],l.prototype,"extensionLogLevel",null),ke([O.$5g],l.prototype,"serviceMachineIdResource",null),ke([O.$5g],l.prototype,"disableTelemetry",null),ke([O.$5g],l.prototype,"disableWorkspaceTrust",null),ke([O.$5g],l.prototype,"useInMemorySecretStorage",null),ke([O.$5g],l.prototype,"policyFile",null);function b(p,f){return w(p["inspect-extensions"],p["inspect-brk-extensions"],5870,f,p.debugId,p.extensionEnvironment)}e.$9l=b;function w(p,f,y,m,d,c){const $=Number(f||p)||(m?null:y),E=$?!!f:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:$,break:E,debugId:d,env:g}}e.$0l=w}),define(te[112],ie([0,1,307,4,167]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$wl=["tunnel","serve-web"],e.$xl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(m,d,c=I){const a=m.find(o=>o.length>0&&o[0]!=="-"),$={},E=["_"],g=[],t={};let u;for(const o in d){const k=d[o];k.type==="subcommand"?o===a&&(u=k):(k.alias&&($[o]=k.alias),k.type==="string"||k.type==="string[]"?(E.push(o),k.deprecates&&E.push(...k.deprecates)):k.type==="boolean"&&(g.push(o),k.deprecates&&g.push(...k.deprecates)),k.global&&(t[o]=k))}if(u&&a){const o=t;for(const v in u.options)o[v]=u.options[v];const k=m.filter(v=>v!==a),A=c.getSubcommandReporter?c.getSubcommandReporter(a):void 0,D=S(k,o,A);return{[a]:D,_:[]}}const r=P(m,{string:E,boolean:g,alias:$}),i={},n=r;i._=r._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(const o in d){const k=d[o];if(k.type==="subcommand")continue;k.alias&&delete n[k.alias];let A=n[o];if(k.deprecates)for(const D of k.deprecates)n.hasOwnProperty(D)&&(A||(A=n[D],A&&c.onDeprecatedOption(D,k.deprecationMessage||(0,s.localize)(37,null,o))),delete n[D]);if(typeof A<"u"){if(k.type==="string[]"){if(Array.isArray(A)||(A=[A]),!k.allowEmptyValue){const D=A.filter(v=>v.length>0);D.length!==A.length&&(c.onEmptyValue(o),A=D.length>0?D:void 0)}}else k.type==="string"&&(Array.isArray(A)?(A=A.pop(),c.onMultipleValues(o,A)):!A&&!k.allowEmptyValue&&(c.onEmptyValue(o),A=void 0));i[o]=A,k.deprecationMessage&&c.onDeprecatedOption(o,k.deprecationMessage)}delete n[o]}for(const o in n)c.onUnknownOption(o);return i}e.$yl=S;function h(m,d){let c="";return d.args&&(Array.isArray(d.args)?c=` <${d.args.join("> <")}>`:c=` <${d.args}>`),d.alias?`-${d.alias} --${m}${c}`:`--${m}${c}`}function l(m,d){const c=[];for(const a in m){const $=m[a],E=h(a,$);c.push([E,$.description])}return b(c,d)}e.$zl=l;function b(m,d){const a=m.reduce((g,t)=>Math.max(g,t[0].length),12)+2+1;if(d-a<25)return m.reduce((g,t)=>g.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const $=d-a-1,E=[];for(const g of m){const t=g[0],u=p(g[1],$),r=w(a-t.length-2);E.push("  "+t+r+u[0]);for(let i=1;i<u.length;i++)E.push(w(a)+u[i])}return E}function w(m){return" ".repeat(m)}function p(m,d){const c=[];for(;m.length;){const a=m.length<d?m.length:m.lastIndexOf(" ",d),$=m.slice(0,a).trim();m=m.slice(a),c.push($)}return c}function f(m,d,c,a,$){const E=process.stdout.isTTY&&process.stdout.columns||80,g=$?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${m} ${c}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${d} [${(0,s.localize)(40,null)}]${g}`),t.push(""),$?.noPipe!==!0&&(O.$i?t.push((0,s.localize)(41,null,d)):t.push((0,s.localize)(42,null,d)),t.push(""));const u={},r=[];for(const i in a){const n=a[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let o=u[n.cat];o||(u[n.cat]=o={}),o[i]=n}}for(const i in u){const n=i,o=u[n];o&&(t.push(M[n]),t.push(...l(o,E)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...b(r.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}e.$Al=f;function y(m,d){return`${m||(0,s.localize)(44,null)}
${d||(0,s.localize)(45,null)}
${process.arch}`}e.$Bl=y}),define(te[199],ie([0,1,87,197,112]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w5b=void 0;class M extends O.$An{constructor(S){super(),this.f=S}call(S,h,l){return h==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(S,h,l)}async g(S,h){const l=(0,s.$yl)(S,s.$xl);l.debugRenderer=h;const b=l.extensionDevelopmentPath;if(!b)return{success:!1};const[w]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!h)return{success:!0};const p=w.win;if(!p)return{success:!0};const f=p.webContents.debugger;let y=f.isAttached()?1/0:0;const m=(0,P.createServer)(d=>{y++===0&&f.attach();let c=!1;const a=g=>{c||d.write(JSON.stringify(g)+"\0")},$=(g,t,u,r)=>a({method:t,params:u,sessionId:r});p.on("close",()=>{f.removeListener("message",$),d.end(),c=!0}),f.addListener("message",$);let E=Buffer.alloc(0);d.on("data",g=>{E=Buffer.concat([E,g]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let u;try{const r=E.slice(0,t).toString("utf8");E=E.slice(t+1),u=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}f.sendCommand(u.method,u.params,u.sessionId).then(r=>a({id:u.id,sessionId:u.sessionId,result:r})).catch(r=>a({id:u.id,sessionId:u.sessionId,error:{code:0,message:r.message}}))}}),d.on("error",g=>{console.error("error on cdp pipe:",g)}),d.on("close",()=>{c=!0,--y===0&&f.detach()})});return await new Promise(d=>m.listen(0,d)),p.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.$w5b=M}),define(te[63],ie([0,1,308,168,112]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.$Dl=e.$Cl=void 0;function M(w,p){const f=($,E)=>{console.warn((0,O.localize)(0,null,$,E))},y=$=>{console.warn((0,O.localize)(1,null,$))},m=($,E)=>{console.warn((0,O.localize)(2,null,$,E))},d=$=>({onUnknownOption:E=>{s.$wl.includes($)||console.warn((0,O.localize)(3,null,E,$))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:m,getSubcommandReporter:s.$wl.includes($)?d:void 0}),c={onUnknownOption:$=>{console.warn((0,O.localize)(4,null,$))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:m,getSubcommandReporter:d},a=(0,s.$yl)(w,s.$xl,p?c:void 0);return a.goto&&a._.forEach($=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test($),(0,O.localize)(5,null))),a}function I(w){const p=w.findIndex(f=>!/^-/.test(f));if(p>-1)return[...w.slice(0,p),...w.slice(p+1)]}function S(w){let[,...p]=w;process.env.VSCODE_DEV&&(p=I(p)||[]);const f=!b(process.env);return M(p,f)}e.$Cl=S;function h(w){let[,,...p]=w;return process.env.VSCODE_DEV&&(p=I(p)||[]),M(p,!0)}e.$Dl=h;function l(w,...p){const f=w.indexOf("--");return f===-1?w.push(...p):w.splice(f,0,...p),w}e.$El=l;function b(w){return w.VSCODE_CLI==="1"}e.$Fl=b}),function(){"use strict";function K(e,P,O){function s(I,S){const h=M(I,S),l=[h];return e.isAbsolute(h)||l.unshift(O),e.resolve(...l)}function M(I,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,S);const b=I["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(w,"AppData","Roaming")}break;case"darwin":l=e.join(P.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,S)}return{getUserDataPath:s}}if(typeof define=="function")define(te[200],ie([113,27,35]),function(e,P,O){return K(e,P,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=K(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[89],ie([0,1,27,198,200]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=void 0;class M extends O.$8l{constructor(l,b){super(l,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(l,b.nameShort)},b)}}e.$$l=M;function I(h,l){return(0,O.$0l)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,l,h.extensionEnvironment)}e.$_l=I;function S(h,l){return(0,O.$0l)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,l,h.extensionEnvironment)}e.$am=S}),define(te[201],ie([0,1,45,27,32]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=void 0;function M(I){const S=(0,s.$Pf)((0,O.tmpdir)());try{return(0,P.writeFileSync)(S,""),I&&console.log(`Marker file for --wait created: ${S}`),S}catch(h){I&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.$Y6b=M}),define(te[202],ie([0,1,12,170]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function s(I,S,h,l){try{M(I,S,h,l)}catch(b){I.error(b?.message??b)}return S}e.$mp=s;function M(I,S,h,l){const b=(w,p,f)=>{const y=w[p];if((0,P.$if)(y)){const m=y,d=m.length;if(d>1&&m[0]==="%"&&m[d-1]==="%"){const c=m.substr(1,d-2);let a=h[c];a===void 0&&l&&(a=l[c]);const $=typeof a=="string"?a:a?.message,E=l?.[c],g=typeof E=="string"?E:E?.message;if(!$){g||I.warn(`[${S.name}]: ${(0,O.localize)(0,null,c)}`);return}if(f&&(p==="title"||p==="category")&&g&&g!==$){const t={value:$,original:g};w[p]=t}else w[p]=$}}else if((0,P.$kf)(y))for(const m in y)y.hasOwnProperty(m)&&(m==="commands"?b(y,m,!0):b(y,m,f));else if(Array.isArray(y))for(let m=0;m<y.length;m++)b(y,m,f)};for(const w in S)S.hasOwnProperty(w)&&b(S,w)}}),define(te[203],ie([0,1,19,70,172,204]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function h(c){return c=c.trim(),c==="*"||I.test(c)}e.$Ao=h;function l(c){if(!h(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=c.match(I);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$Bo=l;function b(c){if(!c)return null;const a=c.majorBase,$=c.majorMustEqual,E=c.minorBase;let g=c.minorMustEqual;const t=c.patchBase;let u=c.patchMustEqual;c.hasCaret&&(a===0||(g=!1),u=!1);let r=0;if(c.preRelease){const i=S.exec(c.preRelease);if(i){const[,n,o,k]=i;r=Date.UTC(Number(n),Number(o)-1,Number(k))}}return{majorBase:a,majorMustEqual:$,minorBase:E,minorMustEqual:g,patchBase:t,patchMustEqual:u,isMinimum:c.hasGreaterEquals,notBefore:r}}e.$Co=b;function w(c,a,$){let E;typeof c=="string"?E=b(l(c)):E=c;let g;a instanceof Date?g=a.getTime():typeof a=="string"&&(g=new Date(a).getTime());let t;if(typeof $=="string"?t=b(l($)):t=$,!E||!t)return!1;const u=E.majorBase,r=E.minorBase,i=E.patchBase;let n=t.majorBase,o=t.minorBase,k=t.patchBase;const A=t.notBefore;let D=t.majorMustEqual,v=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?u>n?!0:u<n?!1:r>o?!0:r<o||g&&g<A?!1:i>=k:(u===1&&n===0&&(!D||!v||!C)&&(n=1,o=0,k=0,D=!0,v=!1,C=!1),u<n?!1:u>n?!D:r<o?!1:r>o?!v:i<k?!1:i>k?!C:!(g&&g<A))}e.$Do=w;function p(c,a,$,E,g){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([O.default.Error,s.localize(0,null)]),t;if(typeof E.name!="string")return t.push([O.default.Error,s.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([O.default.Error,s.localize(2,null,"version")]),t;if(!E.engines)return t.push([O.default.Error,s.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([O.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!d(E.extensionDependencies))return t.push([O.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!d(E.activationEvents))return t.push([O.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([O.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([O.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([O.default.Error,s.localize(9,null,"main")]),t;{const i=(0,P.$hg)($,E.main);(0,P.$bg)(i,$)||t.push([O.default.Warning,s.localize(10,null,i.path,$.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([O.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,P.$hg)($,E.browser);(0,P.$bg)(i,$)||t.push([O.default.Warning,s.localize(12,null,i.path,$.path)])}}if(!M.valid(E.version))return t.push([O.default.Error,s.localize(13,null)]),t;const u=[];if(!f(c,a,E,g,u))for(const i of u)t.push([O.default.Error,i]);return t}e.$Eo=p;function f(c,a,$,E,g){return E||typeof $.main>"u"&&typeof $.browser>"u"?!0:m(c,a,$.engines.vscode,g)}e.$Fo=f;function y(c,a,$){return c==="*"||m(a,$,c)}e.$Go=y;function m(c,a,$,E=[]){const g=b(l($));if(!g)return E.push(s.localize(14,null,$)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return E.push(s.localize(15,null,$)),!1}else if(!g.majorMustEqual)return E.push(s.localize(16,null,$)),!1;return w(c,a,g)?!0:(E.push(s.localize(17,null,c,$)),!1)}function d(c){if(!Array.isArray(c))return!1;for(let a=0,$=c.length;a<$;a++)if(typeof c[a]!="string")return!1;return!0}}),define(te[205],ie([0,1,17,31]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=void 0;async function s(M,I,S){let h=S&&S.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const b=(await I.readFile(M.serviceMachineIdResource)).value.toString();h=(0,O.$2f)(b)?b:null}catch{h=null}if(!h){h=(0,O.$3f)();try{await I.writeFile(M.serviceMachineIdResource,P.$Ed.fromString(h))}catch{}}return S?.store("storage.serviceMachineId",h,-1,1),h}e.$1o=s}),define(te[75],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class P{constructor(s,M=[],I=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=I}}e.$xh=P}),define(te[206],ie([0,1,75]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.InstantiationType=void 0;const O=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,h,l){h instanceof P.$xh||(h=new P.$xh(h,[],!!l)),O.push([S,h])}e.$lr=M;function I(){return O}e.$mr=I}),define(te[207],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;class P{constructor(M,I){this.key=M,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$3p=P;class O{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const I of this.a.values())I.outgoing.size===0&&M.push(I);return M}insertEdge(M,I){const S=this.lookupOrInsertNode(M),h=this.lookupOrInsertNode(I);S.outgoing.set(h.key,h),h.incoming.set(S.key,S)}removeNode(M){const I=this.b(M);this.a.delete(I);for(const S of this.a.values())S.outgoing.delete(I),S.incoming.delete(I)}lookupOrInsertNode(M){const I=this.b(M);let S=this.a.get(I);return S||(S=new P(I,M),this.a.set(I,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[I,S]of this.a)M.push(`${I}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,I]of this.a){const S=new Set([M]),h=this.c(I,S);if(h)return h}}c(M,I){for(const[S,h]of M.outgoing){if(I.has(S))return[...I,S].join(" -> ");I.add(S);const l=this.c(h,I);if(l)return l;I.delete(S)}}}e.$4p=O}),define(te[6],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e._util=void 0;var P;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function S(h){return h[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=S})(P||(e._util=P={})),e.$zh=s("instantiationService");function O(I,S,h){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:I,index:h}):(S[P.DI_DEPENDENCIES]=[{id:I,index:h}],S[P.DI_TARGET]=S)}function s(I){if(P.serviceIds.has(I))return P.serviceIds.get(I);const S=function(h,l,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(S,h,b)};return S.toString=()=>I,P.serviceIds.set(I,S),S}e.$Ah=s;function M(I){return I}e.$Bh=M}),define(te[64],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q5b=void 0,e.$q5b=(0,P.$Ah)("backupMainService")}),define(te[18],ie([0,1,12,7,6]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.ConfigurationTarget=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,s.$Ah)("configurationService");function M(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}e.$8h=M;function I(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}e.$9h=I;var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function h(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$0h=h;function l(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}e.$$h=l;function b(c,a){const $=Object.create(null);for(const E in c)w($,E,c[E],a);return $}e.$_h=b;function w(c,a,$,E){const g=a.split("."),t=g.pop();let u=c;for(let r=0;r<g.length;r++){const i=g[r];let n=u[i];switch(typeof n){case"undefined":n=u[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${a} as ${g.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}u=n}if(typeof u=="object"&&u!==null)try{u[t]=$}catch{E(`Ignoring ${a} as ${g.join(".")} is ${JSON.stringify(u)}`)}else E(`Ignoring ${a} as ${g.join(".")} is ${JSON.stringify(u)}`)}e.$ai=w;function p(c,a){const $=a.split(".");f(c,$)}e.$bi=p;function f(c,a){const $=a.shift();if(a.length===0){delete c[$];return}if(Object.keys(c).indexOf($)!==-1){const E=c[$];typeof E=="object"&&!Array.isArray(E)&&(f(E,a),Object.keys(E).length===0&&delete c[$])}}function y(c,a,$){function E(u,r){let i=u;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const g=a.split("."),t=E(c,g);return typeof t>"u"?$:t}e.$ci=y;function m(c,a,$){Object.keys(a).forEach(E=>{E!=="__proto__"&&(E in c?P.$kf(c[E])&&P.$kf(a[E])?m(c[E],a[E],$):$&&(c[E]=a[E]):c[E]=a[E])})}e.$di=m;function d(c){return c.replace(/[\[\]]/g,"")}e.$ei=d}),define(te[114],ie([0,1,4,26,196,6,163,14]),function(K,e,P,O,s,M,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.ContextKeyExprType=e.$Fi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",P.$j),h.set("isLinux",P.$k),h.set("isWindows",P.$i),h.set("isWeb",P.$o),h.set("isMacNative",P.$j&&!P.$o),h.set("isEdge",P.$G),h.set("isFirefox",P.$E),h.set("isChrome",P.$D),h.set("isSafari",P.$F);function l(Y,R){if(h.get(Y)!==void 0)throw(0,S.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(Y,R)}e.$Fi=l;const b=Object.prototype.hasOwnProperty;var w;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const p={regexParsingWithErrorRecovery:!0},f=(0,I.localize)(0,null),y=(0,I.localize)(1,null),m=(0,I.localize)(2,null),d=(0,I.localize)(3,null),c=(0,I.localize)(4,null),a=(0,I.localize)(5,null),$=(0,I.localize)(6,null),E=(0,I.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=p){this.k=R,this.d=new s.$Ei,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const F=this.D(),W=F.type===17?a:void 0;throw this.h.push({message:c,offset:F.offset,lexeme:s.$Ei.getLexeme(F),additionalInfo:W}),g.c}return j}catch(j){if(j!==g.c)throw j;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const j=this.o();R.push(j)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const j=this.s();R.push(j)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,d),j?.negate()}case 17:return this.z(),L.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const j=this.l();return this.A(1,d),j}case 17:{const j=R.lexeme;if(this.z(),this.y(9)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==10)throw this.B("REGEX",W);const q=W.lexeme,V=q.lastIndexOf("/"),re=V===q.length-1?void 0:this.w(q.substring(V+1));let $e;try{$e=new RegExp(q.substring(1,V),re)}catch{throw this.B("REGEX",W)}return ne.create(j,$e)}switch(W.type){case 10:case 19:{const q=[W.lexeme];this.z();let V=this.D(),re=0;for(let me=0;me<W.lexeme.length;me++)W.lexeme.charCodeAt(me)===40?re++:W.lexeme.charCodeAt(me)===41&&re--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:re++;break;case 1:re--;break;case 10:case 18:for(let me=0;me<V.lexeme.length;me++)V.lexeme.charCodeAt(me)===40?re++:W.lexeme.charCodeAt(me)===41&&re--}if(re<0)break;q.push(s.$Ei.getLexeme(V)),this.z(),V=this.D()}const $e=q.join(""),de=$e.lastIndexOf("/"),ue=de===$e.length-1?void 0:this.w($e.substring(de+1));let be;try{be=new RegExp($e.substring(1,de),ue)}catch{throw this.B("REGEX",W)}return t.regex(j,be)}case 18:{const q=W.lexeme;this.z();let V=null;if(!(0,O.$le)(q)){const re=q.indexOf("/"),$e=q.lastIndexOf("/");if(re!==$e&&re>=0){const de=q.slice(re+1,$e),ue=q[$e+1]==="i"?"i":"";try{V=new RegExp(de,ue)}catch{throw this.B("REGEX",W)}}}if(V===null)throw this.B("REGEX",W);return ne.create(j,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const W=this.u();return t.notIn(j,W)}switch(this.D().type){case 3:{this.z();const W=this.u();if(this.x().type===18)return t.equals(j,W);switch(W){case"true":return t.has(j);case"false":return t.not(j);default:return t.equals(j,W)}}case 4:{this.z();const W=this.u();if(this.x().type===18)return t.notEquals(j,W);switch(W){case"true":return t.not(j);case"false":return t.has(j);default:return t.notEquals(j,W)}}case 5:return this.z(),ee.create(j,this.u());case 6:return this.z(),ae.create(j,this.u());case 7:return this.z(),z.create(j,this.u());case 8:return this.z(),se.create(j,this.u());case 13:return this.z(),t.in(j,this.u());default:return t.has(j)}}case 20:throw this.h.push({message:$,offset:R.offset,lexeme:"",additionalInfo:E}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,j){if(this.C(R))return this.z();throw this.B(j,this.D())}B(R,j,F){const W=(0,I.localize)(8,null,R,s.$Ei.getLexeme(j)),q=j.offset,V=s.$Ei.getLexeme(j);return this.h.push({message:W,offset:q,lexeme:V,additionalInfo:F}),g.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Gi=g;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(R){return k.create(R)}static equals(R,j){return A.create(R,j)}static notEquals(R,j){return C.create(R,j)}static regex(R,j){return ne.create(R,j)}static in(R,j){return D.create(R,j)}static notIn(R,j){return v.create(R,j)}static not(R){return L.create(R)}static and(...R){return J.create(R,null,!0)}static or(...R){return B.create(R,null,!0)}static greater(R,j){return z.create(R,j)}static greaterEquals(R,j){return se.create(R,j)}static smaller(R,j){return ee.create(R,j)}static smallerEquals(R,j){return ae.create(R,j)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$Hi=t;function u(Y){const R=new g({regexParsingWithErrorRecovery:!1});return Y.map(j=>(R.parse(j),R.lexingErrors.length>0?R.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,I.localize)(9,null,F.additionalInfo):(0,I.localize)(10,null),offset:F.offset,length:F.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.$Ii=u;function r(Y,R){const j=Y?Y.substituteConstants():void 0,F=R?R.substituteConstants():void 0;return!j&&!F?!0:!j||!F?!1:j.equals(F)}e.$Ji=r;function i(Y,R){return Y.cmp(R)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return o.INSTANCE}}e.$Ki=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return n.INSTANCE}}e.$Li=o;class k{static create(R,j=null){const F=h.get(R);return typeof F=="boolean"?F?o.INSTANCE:n.INSTANCE:new k(R,j)}constructor(R,j){this.key=R,this.c=j,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:N(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=h.get(this.key);return typeof R=="boolean"?R?o.INSTANCE:n.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Mi=k;class A{static create(R,j,F=null){if(typeof j=="boolean")return j?k.create(R,F):L.create(R,F);const W=h.get(R);return typeof W=="boolean"?j===(W?"true":"false")?o.INSTANCE:n.INSTANCE:new A(R,j,F)}constructor(R,j,F){this.c=R,this.d=j,this.f=F,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:H(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=h.get(this.c);if(typeof R=="boolean"){const j=R?"true":"false";return this.d===j?o.INSTANCE:n.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Ni=A;class D{static create(R,j){return new D(R,j)}constructor(R,j){this.d=R,this.f=j,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:H(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const j=R.getValue(this.f),F=R.getValue(this.d);return Array.isArray(j)?j.includes(F):typeof F=="string"&&typeof j=="object"&&j!==null?b.call(j,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Oi=D;class v{static create(R,j){return new v(R,j)}constructor(R,j){this.d=R,this.f=j,this.type=11,this.c=D.create(R,j)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Pi=v;class C{static create(R,j,F=null){if(typeof j=="boolean")return j?L.create(R,F):k.create(R,F);const W=h.get(R);return typeof W=="boolean"?j===(W?"true":"false")?n.INSTANCE:o.INSTANCE:new C(R,j,F)}constructor(R,j,F){this.c=R,this.d=j,this.f=F,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:H(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=h.get(this.c);if(typeof R=="boolean"){const j=R?"true":"false";return this.d===j?n.INSTANCE:o.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Qi=C;class L{static create(R,j=null){const F=h.get(R);return typeof F=="boolean"?F?n.INSTANCE:o.INSTANCE:new L(R,j)}constructor(R,j){this.c=R,this.d=j,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:N(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=h.get(this.c);return typeof R=="boolean"?R?n.INSTANCE:o.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$Ri=L;function T(Y,R){if(typeof Y=="string"){const j=parseFloat(Y);isNaN(j)||(Y=j)}return typeof Y=="string"||typeof Y=="number"?R(Y):n.INSTANCE}class z{static create(R,j,F=null){return T(j,W=>new z(R,W,F))}constructor(R,j,F){this.c=R,this.d=j,this.f=F,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:H(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Si=z;class se{static create(R,j,F=null){return T(j,W=>new se(R,W,F))}constructor(R,j,F){this.c=R,this.d=j,this.f=F,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:H(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Ti=se;class ee{static create(R,j,F=null){return T(j,W=>new ee(R,W,F))}constructor(R,j,F){this.c=R,this.d=j,this.f=F,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:H(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$Ui=ee;class ae{static create(R,j,F=null){return T(j,W=>new ae(R,W,F))}constructor(R,j,F){this.c=R,this.d=j,this.f=F,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:H(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Vi=ae;class ne{static create(R,j){return new ne(R,j)}constructor(R,j){this.d=R,this.f=j,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const j=this.f?this.f.source:"",F=R.f?R.f.source:"";return j<F?-1:j>F?1:0}equals(R){if(R.type===this.type){const j=this.f?this.f.source:"",F=R.f?R.f.source:"";return this.d===R.d&&j===F}return!1}substituteConstants(){return this}evaluate(R){const j=R.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$Wi=ne;class oe{static create(R){return new oe(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new oe(this.c.map(R))}negate(){return this.c}}e.$Xi=oe;function G(Y){let R=null;for(let j=0,F=Y.length;j<F;j++){const W=Y[j].substituteConstants();if(Y[j]!==W&&R===null){R=[];for(let q=0;q<j;q++)R[q]=Y[q]}R!==null&&(R[j]=W)}return R===null?Y:R}class J{static create(R,j,F){return J.d(R,j,F)}constructor(R,j){this.expr=R,this.c=j,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let j=0,F=this.expr.length;j<F;j++){const W=i(this.expr[j],R.expr[j]);if(W!==0)return W}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let j=0,F=this.expr.length;j<F;j++)if(!this.expr[j].equals(R.expr[j]))return!1;return!0}return!1}substituteConstants(){const R=G(this.expr);return R===this.expr?this:J.create(R,this.c,!1)}evaluate(R){for(let j=0,F=this.expr.length;j<F;j++)if(!this.expr[j].evaluate(R))return!1;return!0}static d(R,j,F){const W=[];let q=!1;for(const V of R)if(V){if(V.type===1){q=!0;continue}if(V.type===0)return n.INSTANCE;if(V.type===6){W.push(...V.expr);continue}W.push(V)}if(W.length===0&&q)return o.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(i);for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];for(;W.length>1;){const V=W[W.length-1];if(V.type!==9)break;W.pop();const re=W.pop(),$e=W.length===0,de=B.create(V.expr.map(ue=>J.create([ue,re],null,F)),null,$e);de&&(W.push(de),W.sort(i))}if(W.length===1)return W[0];if(F){for(let V=0;V<W.length;V++)for(let re=V+1;re<W.length;re++)if(W[V].negate().equals(W[re]))return n.INSTANCE;if(W.length===1)return W[0]}return new J(W,j)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const j of this.expr)R.push(...j.keys());return R}map(R){return new J(this.expr.map(j=>j.map(R)),null)}negate(){if(!this.c){const R=[];for(const j of this.expr)R.push(j.negate());this.c=B.create(R,this,!0)}return this.c}}e.$Yi=J;class B{static create(R,j,F){return B.d(R,j,F)}constructor(R,j){this.expr=R,this.c=j,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let j=0,F=this.expr.length;j<F;j++){const W=i(this.expr[j],R.expr[j]);if(W!==0)return W}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let j=0,F=this.expr.length;j<F;j++)if(!this.expr[j].equals(R.expr[j]))return!1;return!0}return!1}substituteConstants(){const R=G(this.expr);return R===this.expr?this:B.create(R,this.c,!1)}evaluate(R){for(let j=0,F=this.expr.length;j<F;j++)if(this.expr[j].evaluate(R))return!0;return!1}static d(R,j,F){let W=[],q=!1;if(R){for(let V=0,re=R.length;V<re;V++){const $e=R[V];if($e){if($e.type===0){q=!0;continue}if($e.type===1)return o.INSTANCE;if($e.type===9){W=W.concat($e.expr);continue}W.push($e)}}if(W.length===0&&q)return n.INSTANCE;W.sort(i)}if(W.length!==0){if(W.length===1)return W[0];for(let V=1;V<W.length;V++)W[V-1].equals(W[V])&&(W.splice(V,1),V--);if(W.length===1)return W[0];if(F){for(let V=0;V<W.length;V++)for(let re=V+1;re<W.length;re++)if(W[V].negate().equals(W[re]))return o.INSTANCE;if(W.length===1)return W[0]}return new B(W,j)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const j of this.expr)R.push(...j.keys());return R}map(R){return new B(this.expr.map(j=>j.map(R)),null)}negate(){if(!this.c){const R=[];for(const j of this.expr)R.push(j.negate());for(;R.length>1;){const j=R.shift(),F=R.shift(),W=[];for(const q of ce(j))for(const V of ce(F))W.push(J.create([q,V],null,!1));R.unshift(B.create(W,null,!1))}this.c=B.create(R,this,!0)}return this.c}}e.$Zi=B;class U extends k{static{this.d=[]}static all(){return U.d.values()}constructor(R,j,F){super(R,null),this.f=j,typeof F=="object"?U.d.push({...F,key:R}):F!==!0&&U.d.push({key:R,description:F,type:j!=null?typeof j:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return A.create(this.key,R)}notEqualsTo(R){return C.create(this.key,R)}}e.$1i=U,e.$2i=(0,M.$Ah)("contextKeyService");function N(Y,R){return Y<R?-1:Y>R?1:0}function H(Y,R,j,F){return Y<j?-1:Y>j?1:R<F?-1:R>F?1:0}function Q(Y,R){if(Y.type===0||R.type===1)return!0;if(Y.type===9)return R.type===9?x(Y.expr,R.expr):!1;if(R.type===9){for(const j of R.expr)if(Q(Y,j))return!0;return!1}if(Y.type===6){if(R.type===6)return x(R.expr,Y.expr);for(const j of Y.expr)if(Q(j,R))return!0;return!1}return Y.equals(R)}e.$3i=Q;function x(Y,R){let j=0,F=0;for(;j<Y.length&&F<R.length;){const W=Y[j].cmp(R[F]);if(W<0)return!1;W===0&&j++,F++}return j===Y.length}function ce(Y){return Y.type===9?Y.expr:[Y]}}),define(te[90],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=e.$fm=e.ID=void 0,e.ID="diagnosticsService",e.$fm=(0,P.$Ah)(e.ID);function O(M){return!!M.hostName&&!!M.errorMessage}e.$gm=O;class s{async getPerformanceInfo(I,S){return{}}async getSystemInfo(I,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,S){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$hm=s}),define(te[91],ie([0,1,19,70,165,6,46,4,37]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rA=e.$qA=e.ConfirmResult=e.$pA=e.$oA=e.$nA=void 0,e.$nA=(0,M.$Ah)("dialogService");var l;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(l||(l={}));class b{a(d){return this.d(d,l.Confirmation)}b(d){return this.d(d,l.Prompt)}c(d){return this.d(d,l.Input)}d(d,c){const a=[];switch(c){case l.Confirmation:{const $=d;$.primaryButton?a.push($.primaryButton):a.push((0,s.localize)(0,null)),$.cancelButton?a.push($.cancelButton):a.push((0,s.localize)(1,null));break}case l.Prompt:{const $=d;Array.isArray($.buttons)&&$.buttons.length>0&&a.push(...$.buttons.map(E=>E.label)),$.cancelButton&&($.cancelButton===!0?a.push((0,s.localize)(2,null)):typeof $.cancelButton=="string"?a.push($.cancelButton):$.cancelButton.label?a.push($.cancelButton.label):a.push((0,s.localize)(3,null))),a.length===0&&a.push((0,s.localize)(4,null));break}case l.Input:{const $=d;$.primaryButton?a.push($.primaryButton):a.push((0,s.localize)(5,null)),$.cancelButton?a.push($.cancelButton):a.push((0,s.localize)(6,null));break}}return a}e(d){if(typeof d=="string")return d;if(typeof d=="number")return d===O.default.Info?"info":d===O.default.Error?"error":d===O.default.Warning?"warning":"none"}async f(d,c,a){const $=[...d.buttons??[]];return d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&$.push(d.cancelButton),{result:await $[c]?.run({checkboxChecked:a}),checkboxChecked:a}}}e.$oA=b,e.$pA=(0,M.$Ah)("fileDialogService");var w;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(w||(e.ConfirmResult=w={}));const p=10;function f(m){const d=[];return d.push(...m.slice(0,p).map(c=>typeof c=="string"?c:(0,P.$eg)(c))),m.length>p&&(m.length-p===1?d.push((0,s.localize)(7,null)):d.push((0,s.localize)(8,null,m.length-p))),d.push(""),d.join(`
`)}e.$qA=f;function y(m,d){const c=(0,h.$Um)(m);let a=(c.buttons??[]).map(t=>(0,I.$kA)(t)),$=(m.buttons||[]).map((t,u)=>u),E=0,g=c.cancelId??a.length-1;if(a.length>1){const t=typeof g=="number"?a[g]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&a.length>1&&g!==1){a.splice(g,1),a.splice(1,0,t);const u=$[g];$.splice(g,1),$.splice(1,0,u),g=1}S.$k&&a.length>1&&(a=a.reverse(),$=$.reverse(),E=a.length-1,typeof t=="string"&&(g=E-1))}else if(S.$i&&typeof t=="string"&&a.length>1&&g!==a.length-1){a.splice(g,1),a.push(t);const u=$[g];$.splice(g,1),$.push(u),g=a.length-1}}return c.buttons=a,c.defaultId=E,c.cancelId=g,c.noLink=!0,c.title=c.title||d.nameLong,{options:c,buttonIndeces:$}}e.$rA=y}),define(te[115],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wT=e.$vT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$uT=e.$tT=void 0,e.$tT=(0,P.$Ah)("encryptionService"),e.$uT=(0,P.$Ah)("encryptionMainService");var O;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(O||(e.PasswordStoreCLIOption=O={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$vT=M;function I(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$wT=I}),define(te[36],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=void 0,e.$Hh=(0,P.$Ah)("environmentService"),e.$Ih=(0,P.$Bh)(e.$Hh)}),define(te[116],ie([0,1,169,6]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Yn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0,e.$Ln="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Mn=new RegExp(e.$Ln),e.$Nn="__web_extension",e.$On="skipWalkthrough",e.$Pn="extensionsSync",e.$Qn="dependecyOrPackExtensionInstall";function s(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Rn=s;function M(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Sn=M;function I(a,$){switch(a){case 3:return $==="x64"?"win32-x64":$==="ia32"?"win32-ia32":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Tn=I;function S(a,$){return $==="web"&&!a.includes("web")}e.$Un=S;function h(a,$,E){return S($,E)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===E?!0:l(E).includes(a)}e.$Vn=h;function l(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Wn=l;function b(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$Xn=b;var w;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var f;(function(a){a.Install="install",a.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var y;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.$Yn=(0,O.$Ah)("extensionGalleryService");var m;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var d;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(d||(e.ExtensionSignaturetErrorCode=d={}));class c extends Error{constructor($,E){super($),this.code=E,this.name=E}}e.$Zn=c,e.$1n=(0,O.$Ah)("extensionManagementService"),e.$2n="extensionsIdentifiers/disabled",e.$3n="extensionsIdentifiers/enabled",e.$4n=(0,O.$Ah)("IGlobalExtensionEnablementService"),e.$5n=(0,O.$Ah)("IExtensionTipsService"),e.$6n=(0,P.localize)(0,null),e.$7n={value:e.$6n,original:"Extensions"},e.$8n={value:(0,P.localize)(1,null),original:"Preferences"}}),define(te[208],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ykb=void 0,e.$Ykb=(0,P.$Ah)("extensionUrlTrustService")}),define(te[209],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M5b=e.$L5b=void 0,e.$L5b=(0,P.$Ah)("extensionHostStarter"),e.$M5b="extensionHostStarter"}),define(te[117],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Wb=e.$6Wb=e.$5Wb=void 0,e.$5Wb=(0,P.$Ah)("externalTerminal"),e.$6Wb="Terminal.app",e.$7Wb=(0,P.$Ah)("externalTerminal")}),define(te[210],ie([0,1,47,13,9,4,73,21,88,173,117]),function(K,e,P,O,s,M,I,S,h,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q5b=e.$P5b=e.$O5b=void 0;const w=l.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends p{static{this.b="cmd.exe"}openTerminal(E,g){return this.spawnTerminal(P,E,h.$tl(),g)}spawnTerminal(E,g,t,u){const r=g.windowsExec||f.getDefaultTerminalWindows();u&&u[1]===":"&&(u=u[0].toUpperCase()+u.substr(1));const i=s.$_d(r,".exe").toLowerCase();if(i==="cmder")return E.spawn(r,u?[u]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return r.indexOf(" ")>=0&&n.push('""'),n.push(r),i==="wt"&&n.push("-d ."),new Promise((o,k)=>{const A=d(process),D=E.spawn(t,n,{cwd:u,env:A});D.on("error",k),D.on("exit",()=>o())})}runInTerminal(E,g,t,u,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,o)=>{const k=`"${g} - ${w}"`,A=`""${t.join('" "')}" & pause"`,D=Object.assign({},d(process),u);Object.keys(D).filter(z=>D[z]===null).forEach(z=>delete D[z]);const v={cwd:g,env:D,windowsVerbatimArguments:!0};let C,L;s.$_d(i,".exe")==="wt"?(C=i,L=["-d",".",f.b,"/c",A]):(C=f.b,L=["/c","start",k,"/wait",i,"/c",A]),P.spawn(C,L,v).on("error",z=>{o(c(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.$O5b=f;class y extends p{static{this.b="/usr/bin/osascript"}openTerminal(E,g){return this.spawnTerminal(P,E,g)}runInTerminal(E,g,t,u,r){const i=r.osxExec||b.$6Wb;return new Promise((n,o)=>{if(i===b.$6Wb||i==="iTerm.app"){const k=i===b.$6Wb?"TerminalHelper":"iTermHelper",D=[O.$1f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",E||w,"-w",g];for(const L of t)D.push("-a"),D.push(L);if(u){const L=Object.assign({},d(process),u);for(const T in L){const z=L[T];z===null?(D.push("-u"),D.push(T)):(D.push("-e"),D.push(`${T}=${z}`))}}let v="";const C=P.spawn(y.b,D);C.on("error",L=>{o(c(L))}),C.stderr.on("data",L=>{v+=L.toString()}),C.on("exit",L=>{if(L===0)n(void 0);else if(v){const T=v.split(`
`,1);o(new Error(T[0]))}else o(new Error(l.localize(1,null,k,L)))})}else o(new Error(l.localize(2,null,i)))})}spawnTerminal(E,g,t){const u=g.osxExec||b.$6Wb;return new Promise((r,i)=>{const n=["-a",u];t&&n.push(t);const o=d(process),k=E.spawn("/usr/bin/open",n,{cwd:t,env:o});k.on("error",i),k.on("exit",()=>r())})}}e.$P5b=y;class m extends p{static{this.b=l.localize(3,null)}openTerminal(E,g){return this.spawnTerminal(P,E,g)}runInTerminal(E,g,t,u,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((n,o)=>{const k=[];i.then(A=>{A.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const D=`${a(t)}; echo; read -p "${m.b}" -n1;`;k.push(`''${D}''`);const v=Object.assign({},d(process),u);Object.keys(v).filter(z=>v[z]===null).forEach(z=>delete v[z]);const C={cwd:g,env:v};let L="";const T=P.spawn(A,k,C);T.on("error",z=>{o(c(z))}),T.stderr.on("data",z=>{L+=z.toString()}),T.on("exit",z=>{if(z===0)n(void 0);else if(L){const se=L.split(`
`,1);o(new Error(se[0]))}else o(new Error(l.localize(4,null,A,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!M.$k)m.d=Promise.resolve("xterm");else{const E=await S.Promises.exists("/etc/debian_version");m.d=new Promise(g=>{E?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return m.d}spawnTerminal(E,g,t){const u=g.linuxExec?Promise.resolve(g.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{u.then(n=>{const o=d(process),k=E.spawn(n,[],{cwd:t,env:o});k.on("error",i),k.on("exit",()=>r())})})}}e.$Q5b=m;function d($){const E={...$.env};return(0,I.$rl)(E),E}function c($){return"errno"in $&&$.errno==="ENOENT"&&"path"in $&&typeof $.path=="string"?new Error(l.localize(5,null,$.path)):$}function a($){let E="";for(const g of $)g.indexOf(" ")>=0?E+='"'+g+'"':E+=g,E+=" ";return E}}),define(te[16],ie([0,1,58,9,26,12,7,175,6,4,13]),function(K,e,P,O,s,M,I,S,h,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileKind=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileOperationResult=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileChangeType=e.$jk=e.FileOperation=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileSystemProviderErrorCode=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$6j=e.$5j=void 0,e.$5j=(0,h.$Ah)("fileService");function w(N){return N.create===!0}e.$6j=w;var p;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var f;(function(N){N[N.Readonly=1]="Readonly",N[N.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var y;(function(N){N[N.None=0]="None",N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileAtomicWrite=32768]="FileAtomicWrite",N[N.FileAtomicDelete=65536]="FileAtomicDelete",N[N.FileClone=131072]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function m(N){return!!(N.capabilities&2)}e.$7j=m;function d(N){return!!(N.capabilities&8)}e.$8j=d;function c(N){return!!(N.capabilities&131072)}e.$9j=c;function a(N){return!!(N.capabilities&4)}e.$0j=a;function $(N){return!!(N.capabilities&16)}e.$$j=$;function E(N){return m(N)?!!(N.capabilities&16384):!1}e.$_j=E;function g(N){return m(N)?!!(N.capabilities&32768):!1}e.$ak=g;function t(N){return!!(N.capabilities&65536)}e.$bk=t;function u(N){return!!(N.capabilities&2048)}e.$ck=u;var r;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsStorageQuota="EntryExceedsStorageQuota",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class i extends Error{static create(H,Q){const x=new i(H.toString(),Q);return k(x,Q),x}constructor(H,Q){super(H),this.code=Q}}e.$dk=i;function n(N,H){return i.create(N,H)}e.$ek=n;function o(N){return N||n((0,S.localize)(0,null),r.Unknown)}e.$fk=o;function k(N,H){return N.name=H?`${H} (FileSystemError)`:"FileSystemError",N}e.$gk=k;function A(N){if(!N)return r.Unknown;if(N instanceof i)return N.code;const H=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!H)return r.Unknown;switch(H[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$hk=A;function D(N){if(N instanceof se)return N.fileOperationResult;switch(A(N)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$ik=D;var v;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(v||(e.FileOperation=v={}));class C{constructor(H,Q,x){this.resource=H,this.operation=Q,this.target=x}isOperation(H){return this.operation===H}}e.$jk=C;var L;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class T{constructor(H,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const x=new Map;for(const ce of H){const Y=x.get(ce.type);switch(Y?Y.push([ce.resource,ce]):x.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,Y]of x)switch(ce){case 1:this.a=P.$Gh.forUris(()=>Q),this.a.fill(Y);break;case 0:this.b=P.$Gh.forUris(()=>Q),this.b.fill(Y);break;case 2:this.c=P.$Gh.forUris(()=>Q),this.c.fill(Y);break}}contains(H,...Q){return this.d(H,{includeChildren:!1},...Q)}affects(H,...Q){return this.d(H,{includeChildren:!0},...Q)}d(H,Q,...x){if(!H)return!1;const ce=x.length>0;return!!((!ce||x.includes(1))&&(this.a?.get(H)||Q.includeChildren&&this.a?.findSuperstr(H))||(!ce||x.includes(0))&&(this.b?.get(H)||Q.includeChildren&&this.b?.findSuperstr(H))||(!ce||x.includes(2))&&(this.c?.findSubstr(H)||Q.includeChildren&&this.c?.findSuperstr(H)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$kk=T;function z(N,H,Q){return!N||!H||N===H||H.length>N.length?!1:(H.charAt(H.length-1)!==O.sep&&(H+=O.sep),Q?(0,s.$Me)(N,H):N.indexOf(H)===0)}e.$lk=z;class se extends Error{constructor(H,Q,x){super(H),this.fileOperationResult=Q,this.options=x}}e.$mk=se;class ee extends se{constructor(H,Q,x,ce){super(H,Q,ce),this.fileOperationResult=Q,this.size=x}}e.$nk=ee;class ae extends se{constructor(H,Q,x){super(H,2,x),this.stat=Q}}e.$ok=ae;var ne;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$rk="files.associations",e.$sk="files.exclude",e.$tk="files.readonlyInclude",e.$uk="files.readonlyExclude",e.$vk="files.readonlyFromPermissions";var oe;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(oe||(e.FileKind=oe={})),e.$wk="";function G(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.$xk=G;async function J(N,H){if(!H.hasProvider(I.URI.from({scheme:N.scheme})))return new Promise(Q=>{const x=H.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===N.scheme&&ce.added&&(x.dispose(),Q())})})}e.$yk=J;class B{static{this.KB=1024}static{this.MB=B.KB*B.KB}static{this.GB=B.MB*B.KB}static{this.TB=B.GB*B.KB}static formatSize(H){return(0,M.$mf)(H)||(H=0),H<B.KB?(0,S.localize)(1,null,H.toFixed(0)):H<B.MB?(0,S.localize)(2,null,(H/B.KB).toFixed(2)):H<B.GB?(0,S.localize)(3,null,(H/B.MB).toFixed(2)):H<B.TB?(0,S.localize)(4,null,(H/B.GB).toFixed(2)):(0,S.localize)(5,null,(H/B.TB).toFixed(2))}}e.$zk=B;function U(N){const H=typeof N=="string"||N?.scheme===b.Schemas.vscodeRemote;return typeof N!="string"&&N?.scheme===b.Schemas.file?1024*B.MB:H?10*B.MB:l.$o?50*B.MB:1024*B.MB}e.$Ak=U}),define(te[211],ie([0,1,17,50,14,3,2,56,7,31,16]),function(K,e,P,O,s,M,I,S,h,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=void 0,e.$3M="localFilesystem";class w extends I.$jc{constructor(f,y){super(),this.a=f,this.b=y,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$ed),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$ed),this.onDidWatchError=this.g.event,this.h=(0,l.$3f)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,y){const{buffer:m}=await this.a.call("readFile",[f,y]);return m}readFileStream(f,y,m){const d=(0,S.$sd)(a=>P.$Ed.concat(a.map($=>P.$Ed.wrap($))).buffer),c=new I.$ic;return c.add(this.a.listen("readFileStream",[f,y])(a=>{if(a instanceof P.$Ed)d.write(a.buffer);else{if(a==="end")d.end();else{let $;if(a instanceof Error)$=a;else{const E=a;$=(0,b.$ek)(E.message??(0,O.$li)(E),E.code??b.FileSystemProviderErrorCode.Unknown)}d.error($),d.end()}c.dispose()}})),c.add(m.onCancellationRequested(()=>{d.error((0,s.$4)()),d.end(),c.dispose()})),d}writeFile(f,y,m){return this.a.call("writeFile",[f,P.$Ed.wrap(y),m])}open(f,y){return this.a.call("open",[f,y])}close(f){return this.a.call("close",[f])}async read(f,y,m,d,c){const[a,$]=await this.a.call("read",[f,y,c]);return m.set(a.buffer.slice(0,$),d),$}write(f,y,m,d,c){return this.a.call("write",[f,y,P.$Ed.wrap(m),d,c])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,y){return this.a.call("delete",[f,y])}rename(f,y,m){return this.a.call("rename",[f,y,m])}copy(f,y,m){return this.a.call("copy",[f,y,m])}cloneFile(f,y){return this.a.call("cloneFile",[f,y])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const y=f;this.f.fire(y.map(m=>({resource:h.URI.revive(m.resource),type:m.type})))}else{const y=f;this.g.fire(y)}}))}watch(f,y){const m=(0,l.$3f)();return this.a.call("watch",[this.h,m,f,y]),(0,I.$hc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$4M=w}),define(te[118],ie([0,1,17,14,176,16]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;async function I(b,w,p,f,y,m){let d;try{await S(b,w,p,f,y,m)}catch(c){d=c}finally{d&&y.errorTransformer&&(d=y.errorTransformer(d)),typeof d<"u"&&p.error(d),p.end()}}e.$Bp=I;async function S(b,w,p,f,y,m){h(m);const d=await b.open(w,{create:!1});try{h(m);let c=0,a=0,$=y&&typeof y.length=="number"?y.length:void 0,E=P.$Ed.alloc(Math.min(y.bufferSize,typeof $=="number"?$:y.bufferSize)),g=y&&typeof y.position=="number"?y.position:0,t=0;do a=await b.read(d,g,E.buffer,t,E.byteLength-t),g+=a,t+=a,c+=a,typeof $=="number"&&($-=a),t===E.byteLength&&(await p.write(f(E)),E=P.$Ed.alloc(Math.min(y.bufferSize,typeof $=="number"?$:y.bufferSize)),t=0);while(a>0&&(typeof $!="number"||$>0)&&h(m)&&l(c,y));if(t>0){let u=t;typeof $=="number"&&(u=Math.min(t,$)),p.write(f(E.slice(0,u)))}}catch(c){throw(0,M.$fk)(c)}finally{await b.close(d)}}function h(b){if(b.isCancellationRequested)throw(0,O.$4)();return!0}function l(b,w){if(typeof w?.limits?.size=="number"&&b>w.limits.size)throw(0,M.$ek)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[76],ie([0,1,104,2,9,4,7,16]),function(K,e,P,O,s,M,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=void 0;function h(c){return c.recursive===!0}e.$Dp=h;class l extends O.$jc{static{this.a=5}constructor(a,$,E,g){super(),this.h=a,this.j=$,this.m=E,this.n=g,this.c=this.B(new O.$kc),this.f=void 0,this.g=0}s(){const a=new O.$ic;this.c.value=a,this.b=this.r(a),this.b.setVerboseLogging(this.m),a.add(this.b.onDidChangeFile($=>this.h($))),a.add(this.b.onDidLogMessage($=>this.j($))),a.add(this.b.onDidError($=>this.t($)))}t(a){this.n.restartOnError?this.g<l.a&&this.f?(this.w(`restarting watcher after error: ${a}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${a}`):this.w(a)}u(a){this.g++,this.s(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.m=a,await this.b?.setVerboseLogging(a)}w(a){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${a}`})}y(a){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Ep=l;class b extends l{constructor(a,$,E){super(a,$,E,{type:"node.js",restartOnError:!1})}}e.$Fp=b;class w extends l{constructor(a,$,E){super(a,$,E,{type:"universal",restartOnError:!0})}}e.$Gp=w;function p(c){return c.map(a=>({type:a.type,resource:I.URI.file(a.path)}))}e.$Hp=p;function f(c){const a=new d;for(const $ of c)a.processEvent($);return a.coalesce()}e.$Ip=f;function y(c,a){return typeof a=="string"&&!a.startsWith(P.$mj)&&!(0,s.$7d)(a)?{base:c,pattern:a}:a}e.$Jp=y;function m(c,a){const $=[];for(const E of a)$.push((0,P.$qj)(y(c,E)));return $}e.$Kp=m;class d{constructor(){this.a=new Set,this.b=new Map}c(a){return M.$k?a.path:a.path.toLowerCase()}processEvent(a){const $=this.b.get(this.c(a));let E=!1;if($){const g=$.type,t=a.type;$.path!==a.path&&(a.type===2||a.type===1)?E=!0:g===1&&t===2?(this.b.delete(this.c(a)),this.a.delete($)):g===2&&t===1?$.type=0:g===1&&t===0||($.type=t)}else E=!0;E&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],$=[];return Array.from(this.a).filter(E=>E.type!==2?(a.push(E),!1):!0).sort((E,g)=>E.path.length-g.path.length).filter(E=>$.some(g=>(0,S.$lk)(E.path,g,!M.$k))?!1:($.push(E.path),!0)).concat(a)}}}),define(te[212],ie([0,1,45,8,22,32,2,85,9,4,105,21,76]),function(K,e,P,O,s,M,I,S,h,l,b,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0;class f extends I.$jc{static{this.a=100}static{this.b=75}constructor(d,c,a,$){super(),this.m=d,this.n=c,this.r=a,this.s=$,this.c=this.B(new O.$Ug({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.n(E))),this.f=this.B(new O.$Tg(E=>this.z(E),f.b)),this.g=(0,p.$Kp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,p.$Kp)(this.m.path,this.m.includes):void 0,this.j=new s.$od,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const c=await w.Promises.stat(d);this.B(await this.w(d,c.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let c=d.path;try{c=await w.Promises.realpath(d.path),d.path===c&&(c=await(0,b.$Up)(d.path)??d.path),d.path!==c&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${c})`)}catch{}return c}async w(d,c){if(l.$j&&(0,M.$Hf)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$jc.None;const a=new s.$od(this.j.token),$=new I.$ic;try{const E=(0,h.$_d)(d),g=(0,P.watch)(d);$.add((0,I.$hc)(()=>{g.removeAllListeners(),g.close()})),this.G(`Started watching: '${d}'`);const t=new Set;if(c)try{for(const r of await w.Promises.readdir(d))t.add(r)}catch(r){this.D(r)}const u=new Map;$.add((0,I.$hc)(()=>{for(const[,r]of u)r.dispose();u.clear()})),g.on("error",(r,i)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${r}, ${i})`),this.dispose()}),g.on("change",(r,i)=>{if(a.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${i}`);let n="";if(i&&(n=i.toString(),l.$j&&(n=(0,S.$gl)(n))),!(!n||r!=="change"&&r!=="rename"))if(c)if(r==="rename"){u.get(n)?.dispose();const o=setTimeout(async()=>{if(u.delete(n),n===E&&!await w.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,h.$8d)(d,n));if(a.token.isCancellationRequested)return;let A;k?t.has(n)?A=0:(A=1,t.add(n)):(t.delete(n),A=2),this.y({path:(0,h.$8d)(this.m.path,n),type:A})},f.a);u.set(n,(0,I.$hc)(()=>clearTimeout(o)))}else{let o;t.has(n)?o=0:(o=1,t.add(n)),this.y({path:(0,h.$8d)(this.m.path,n),type:o})}else if(r==="rename"||n!==E){const o=setTimeout(async()=>{const k=await w.Promises.exists(d);a.token.isCancellationRequested||(k?(this.y({path:this.m.path,type:0},!0),$.add(await this.w(d,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);$.clear(),$.add((0,I.$hc)(()=>clearTimeout(o)))}else this.y({path:this.m.path,type:0},!0)})}catch(E){await w.Promises.exists(d)&&!a.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${E.toString()})`)}return(0,I.$hc)(()=>{a.dispose(!0),$.dispose()})}y(d,c=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),!c&&this.g.some(a=>a(d.path))?this.s&&this.G(` >> ignored (excluded) ${d.path}`):!c&&this.h&&this.h.length>0&&!this.h.some(a=>a(d.path))?this.s&&this.G(` >> ignored (not included) ${d.path}`):this.f.work(d))}z(d){const c=(0,p.$Ip)(d);if(c.length>0){if(this.s)for(const $ of c)this.G(`>> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.path}`);this.c.work(c)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(l.$k)return w.Promises.exists(d);try{const c=(0,h.$_d)(d);return(await w.Promises.readdir((0,h.$$d)(d))).some($=>$===c)}catch(c){return this.G(c),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Xp=f;async function y(m,d,c,a,$=512){const E=await w.Promises.open(m,"r"),g=Buffer.allocUnsafe($),t=new s.$od(a);let u,r=!1;const i={path:m,excludes:[],recursive:!1},n=new f(i,o=>{(async()=>{for(const{type:k}of o)if(k===0){if(r)return;r=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:A}=await w.Promises.read(E,g,0,$,null);if(!A||t.token.isCancellationRequested)break;d(g.slice(0,A))}}catch(A){u=new Error(A),t.dispose(!0)}finally{r=!1}}})()});return await n.ready,c(),new Promise((o,k)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await w.Promises.close(E)}catch(A){u=new Error(A)}u?k(u):o()})})}e.$Yp=y}),define(te[213],ie([0,1,3,104,2,4,212]),function(K,e,P,O,s,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class S extends s.$jc{constructor(){super(...arguments),this.a=this.B(new P.$ed),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$ed),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(l){const b=this.j(l),w=b.filter(f=>{const y=this.c.get(f.path);return y?!(0,O.$uj)(y.request.excludes,f.excludes)||!(0,O.$uj)(y.request.includes,f.includes):!0}),p=Array.from(this.c.values()).filter(({request:f})=>!b.find(y=>y.path===f.path&&(0,O.$uj)(y.excludes,f.excludes)&&(0,O.$uj)(y.includes,f.includes))).map(({request:f})=>f.path);w.length&&this.m(`Request to start watching: ${w.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const f of p)this.h(f);for(const f of w)this.g(f)}g(l){const b=new I.$Xp(l,p=>this.a.fire(p),p=>this.b.fire(p),this.f),w={request:l,instance:b};this.c.set(l.path,w)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const b=this.c.get(l);b&&(this.c.delete(l),b.instance.dispose())}j(l){const b=new Map;for(const w of l){const p=M.$k?w.path:w.path.toLowerCase();b.set(p,w)}return Array.from(b.values())}async setVerboseLogging(l){this.f=l;for(const[,b]of this.c)b.instance.setVerboseLogging(l)}m(l){this.f&&this.b.fire({type:"trace",message:this.n(l)})}n(l,b){return b?`[File Watcher (node.js)] ${l} (path: ${b.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$Zp=S}),define(te[214],ie([0,1,76,213]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class s extends P.$Fp{constructor(I,S,h){super(I,S,h),this.s()}r(I){return I.add(new O.$Zp)}}e.$1p=s}),define(te[215],ie([0,1,13,42,159,76]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class I extends M.$Gp{constructor(h,l,b){super(h,l,b),this.s()}r(h){const l=h.add(new s.$Rp(P.$1f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(l.onDidProcessExit(({code:b,signal:w})=>this.t(`terminated by itself with code ${b}, signal: ${w}`))),O.ProxyChannel.toService((0,O.$hh)(l.getChannel("watcher")))}}e.$Sp=I}),define(te[92],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class P{constructor(...s){this.a=new Map;for(const[M,I]of s)this.set(M,I)}set(s,M){const I=this.a.get(s);return this.a.set(s,M),I}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$yh=P}),define(te[216],ie([0,1,8,14,2,75,207,6,92,101]),function(K,e,P,O,s,M,I,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;const b=!1;class w extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class p{constructor(d=new h.$yh,c=!1,a,$=b){this.f=d,this.g=c,this.h=a,this.i=$,this.o=new Set,this.f.set(S.$zh,this),this._globalGraph=$?a?._globalGraph??new I.$4p(E=>E):void 0}createChild(d){return new p(d,this.g,this,this.i)}invokeFunction(d,...c){const a=y.traceInvocation(this.i,d);let $=!1;try{return d({get:g=>{if($)throw(0,O.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(g,a);if(!t)throw new Error(`[invokeFunction] unknown service '${g}'`);return t}},...c)}finally{$=!0,a.stop()}}createInstance(d,...c){let a,$;return d instanceof M.$xh?(a=y.traceCreation(this.i,d.ctor),$=this.j(d.ctor,d.staticArguments.concat(c),a)):(a=y.traceCreation(this.i,d),$=this.j(d,c,a)),a.stop(),$}j(d,c=[],a){const $=S._util.getServiceDependencies(d).sort((t,u)=>t.index-u.index),E=[];for(const t of $){const u=this.m(t.id,a);u||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(u)}const g=$.length>0?$[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${c.length} static arguments`);const t=g-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,g)}return Reflect.construct(d,c.concat(E))}k(d,c){if(this.f.get(d)instanceof M.$xh)this.f.set(d,c);else if(this.h)this.h.k(d,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const c=this.f.get(d);return!c&&this.h?this.h.l(d):c}m(d,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const a=this.l(d);return a instanceof M.$xh?this.q(d,a,c.branch(d,!0)):(c.branch(d,!1),a)}q(d,c,a){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,c,a)}finally{this.o.delete(d)}}r(d,c,a){const $=new I.$4p(t=>t.id.toString());let E=0;const g=[{id:d,desc:c,_trace:a}];for(;g.length;){const t=g.pop();if($.lookupOrInsertNode(t),E++>1e3)throw new w($);for(const u of S._util.getServiceDependencies(t.desc.ctor)){const r=this.l(u.id);if(r||this.u(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(u.id)),r instanceof M.$xh){const i={id:u.id,desc:r,_trace:t._trace.branch(u.id,!0)};$.insertEdge(t,i),g.push(i)}}}for(;;){const t=$.roots();if(t.length===0){if(!$.isEmpty())throw new w($);break}for(const{data:u}of t){if(this.l(u.id)instanceof M.$xh){const i=this.s(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this.k(u.id,i)}$.removeNode(u)}}return this.l(d)}s(d,c,a=[],$,E){if(this.f.get(d)instanceof M.$xh)return this.t(d,c,a,$,E);if(this.h)return this.h.s(d,c,a,$,E);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(d,c,a=[],$,E){if($){const g=new p(void 0,this.g,this,this.i);g.c=String(d);const t=new Map,u=new P.$Wg(()=>{const r=g.j(c,a,E);for(const[i,n]of t){const o=r[i];if(typeof o=="function")for(const k of n)o.apply(r,k)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!u.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let k=t.get(i);return k||(k=new l.$sc,t.set(i,k)),(D,v,C)=>{const L=k.push([D,v,C]);return(0,s.$hc)(L)}}if(i in r)return r[i];const n=u.value;let o=n[i];return typeof o!="function"||(o=o.bind(n),r[i]=o),o},set(r,i,n){return u.value[i]=n,!0},getPrototypeOf(r){return c.prototype}})}else return this.j(c,a,E)}u(d,c){if(c&&console.warn(d),this.g)throw new Error(d)}}e.$5p=p;var f;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(f||(f={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,c){return d?new y(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(d,c){return d?new y(1,c.name):y.c}static{this.f=0}constructor(d,c){this.type=d,this.name=c,this.g=Date.now(),this.h=[]}branch(d,c){const a=new y(3,d.toString());return this.h.push([d,c,a]),a}stop(){const d=Date.now()-this.g;y.f+=d;let c=!1;function a(E,g){const t=[],u=new Array(E+1).join("	");for(const[r,i,n]of g.h)if(i&&n){c=!0,t.push(`${u}CREATES -> ${r}`);const o=a(E+1,n);o&&t.push(o)}else t.push(`${u}uses -> ${r}`);return t.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(d>2||c)&&y.all.add($.join(`
`))}}e.$6p=y}),define(te[217],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$itb=e.IssueType=void 0;var O;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(O||(e.IssueType=O={})),e.$itb=(0,P.$Ah)("issueService")}),define(te[5],ie([0,1,50,3,57,2,33,4,19,12,7,114,6]),function(K,e,P,O,s,M,I,S,h,l,b,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.log=e.$7i=e.LogLevel=e.$6i=e.$5i=e.$4i=void 0,e.$4i=(0,p.$Ah)("logService"),e.$5i=(0,p.$Ah)("loggerService");function f(){return new Date().toISOString()}function y(D){return(0,l.$mf)(D)}e.$6i=y;var m;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$7i=m.Info;function d(D,v,C){switch(v){case m.Trace:D.trace(C);break;case m.Debug:D.debug(C);break;case m.Info:D.info(C);break;case m.Warning:D.warn(C);break;case m.Error:D.error(C);break;case m.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=d;function c(D,v=!1){let C="";for(let L=0;L<D.length;L++){let T=D[L];if(T instanceof Error&&(T=(0,P.$li)(T,v)),typeof T=="object")try{T=JSON.stringify(T)}catch{}C+=(L>0?" ":"")+T}return C}class a extends M.$jc{constructor(){super(...arguments),this.b=e.$7i,this.c=this.B(new O.$ed),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==m.Off&&this.b<=v}}e.$9i=a;class $ extends a{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...C){this.f(m.Trace)&&this.g(m.Trace,c([v,...C],!0))}debug(v,...C){this.f(m.Debug)&&this.g(m.Debug,c([v,...C]))}info(v,...C){this.f(m.Info)&&this.g(m.Info,c([v,...C]))}warn(v,...C){this.f(m.Warning)&&this.g(m.Warning,c([v,...C]))}error(v,...C){if(this.f(m.Error))if(v instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=v.stack,this.g(m.Error,c(L))}else this.g(m.Error,c([v,...C]))}flush(){}}e.$0i=$;class E extends a{constructor(v=e.$7i){super(),this.setLevel(v),this.g=!S.$i}trace(v,...C){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,v,...C):console.log(`[main ${f()}]`,v,...C))}debug(v,...C){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,v,...C):console.log(`[main ${f()}]`,v,...C))}info(v,...C){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,v,...C):console.log(`[main ${f()}]`,v,...C))}warn(v,...C){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,v,...C):console.warn(`[main ${f()}]`,v,...C))}error(v,...C){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,v,...C):console.error(`[main ${f()}]`,v,...C))}dispose(){}flush(){}}e.$$i=E;class g extends a{constructor(v=e.$7i,C=!0){super(),this.g=C,this.setLevel(v)}trace(v,...C){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...C):console.log(v,...C))}debug(v,...C){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...C):console.log(v,...C))}info(v,...C){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...C):console.log(v,...C))}warn(v,...C){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...C):console.log(v,...C))}error(v,...C){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...C):console.error(v,...C))}dispose(){}flush(){}}e.$_i=g;class t extends a{constructor(v,C=e.$7i){super(),this.g=v,this.setLevel(C)}trace(v,...C){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(v),...C])}debug(v,...C){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(v),...C])}info(v,...C){this.f(m.Info)&&this.g.log(m.Info,[this.h(v),...C])}warn(v,...C){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(v),...C])}error(v,...C){this.f(m.Error)&&this.g.log(m.Error,[this.h(v),...C])}h(v){return typeof v=="string"?v:(0,P.$li)(v,this.f(m.Trace))}dispose(){}flush(){}}e.$aj=t;class u extends a{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const C of this.g)C.setLevel(v);super.setLevel(v)}trace(v,...C){for(const L of this.g)L.trace(v,...C)}debug(v,...C){for(const L of this.g)L.debug(v,...C)}info(v,...C){for(const L of this.g)L.info(v,...C)}warn(v,...C){for(const L of this.g)L.warn(v,...C)}error(v,...C){for(const L of this.g)L.error(v,...C)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose()}}e.$bj=u;class r extends M.$jc{constructor(v,C,L){if(super(),this.h=v,this.j=C,this.b=new I.$yi,this.c=this.B(new O.$ed),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$ed),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$ed),this.onDidChangeVisibility=this.g.event,L)for(const T of L)this.b.set(T.resource,{logger:void 0,info:T})}m(v){return(0,l.$if)(v)?[...this.b.values()].find(C=>C.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,C){const L=this.n(v),T=(0,l.$if)(v)?v:C?.id??(0,s.$oi)(L.toString()).toString(16);let z=this.b.get(L)?.logger;const se=C?.logLevel==="always"?m.Trace:C?.logLevel;z||(z=this.s(L,se??this.getLogLevel(L)??this.h,{...C,id:T}));const ee={logger:z,info:{resource:L,id:T,logLevel:se,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(ee.info),this.b.set(L,ee),z}n(v){return(0,l.$if)(v)?(0,h.$hg)(this.j,`${v}.log`):v}setLogLevel(v,C){if(b.URI.isUri(v)){const L=v,T=C,z=this.b.get(L);z&&T!==z.info.logLevel&&(z.info.logLevel=T===this.h?void 0:T,z.logger?.setLevel(T),this.b.set(z.info.resource,z),this.f.fire([L,T]))}else{this.h=v;for(const[L,T]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,C){const L=this.m(v);L&&C!==!L.info.hidden&&(L.info.hidden=!C,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,C]))}getLogLevel(v){let C;return v&&(C=this.b.get(v)?.info.logLevel),C??this.h}registerLogger(v){const C=this.b.get(v.resource);C?C.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const C=this.b.get(v);C&&(C.logger&&C.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$cj=r;class i{constructor(){this.onDidChangeLogLevel=new O.$ed().event}setLevel(v){}getLevel(){return m.Info}trace(v,...C){}debug(v,...C){}info(v,...C){}warn(v,...C){}error(v,...C){}critical(v,...C){}dispose(){}flush(){}}e.$dj=i;class n extends i{}e.$ej=n;function o(D){if(D.verbose)return m.Trace;if(typeof D.logLevel=="string"){const v=A(D.logLevel.toLowerCase());if(v!==void 0)return v}return e.$7i}e.$fj=o;function k(D){switch(D){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$gj=k;function A(D){switch(D){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$hj=A,e.$ij=new w.$1i("logLevel",k(m.Info))});var _=this&&this.__param||function(K,e){return function(P,O){e(P,O,K)}};define(te[218],ie([0,1,15,4,5]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J5b=void 0;const M=P.safeStorage;let I=class{constructor(h){this.a=h,P.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(M.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(h){let l;try{if(l=JSON.parse(h),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const b=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const w=M.decryptString(b);return this.a.trace("[EncryptionMainService] Decrypted value."),w}catch(b){throw this.a.error(b),b}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(O.$i)return Promise.resolve("dpapi");if(O.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const h=M.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(O.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(O.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$J5b=I,e.$J5b=I=ke([_(0,s.$4i)],I)}),define(te[219],ie([0,1,23,8,14,3,2,9,76,5]),function(K,e,P,O,s,M,I,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class b extends I.$jc{constructor(p,f){super(),this.a=p,this.b=f,this.c=this.B(new M.$ed),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$ed),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$Dg(0)),this.w=[],this.y=this.B(new O.$Dg(0))}watch(p,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(p,f):this.z(p,f)}n(p,f){const y={path:this.H(p),excludes:f.excludes,includes:f.includes,recursive:f.recursive},m=(0,P.$Rb)(this.j,y);return this.r(),(0,I.$hc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,s.$Y)(p))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$Hp)(f)),f=>this.G(f),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const f of this.j)(0,h.$Dp)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const f of this.j)(0,h.$Dp)(f)&&p.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,f){const y={path:this.H(p),excludes:f.excludes,includes:f.includes,recursive:!1},m=(0,P.$Rb)(this.w,y);return this.C(),(0,I.$hc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,s.$Y)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,h.$Hp)(p)),p=>this.G(p),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,S.$6d)(p.fsPath)}}e.$Lp=b}),define(te[220],ie([0,1,23,8,17,22,3,57,68,2,58,13,65,19,56,174,16,118,5,14]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;let E=class extends l.$jc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new I.$ed),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$ed),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$ed),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$ed),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$ed),this.onDidFilesChange=this.X.event,this.Y=this.B(new I.$ed),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new O.$Og)}registerProvider(t,u){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const r=new l.$ic;return this.h.set(t,u),this.c.fire({added:!0,scheme:t,provider:u}),r.add(u.onDidChangeFile(i=>this.X.fire(new d.$kk(i,!this.S(u))))),typeof u.onDidWatchError=="function"&&r.add(u.onDidWatchError(i=>this.Y.fire(new Error(i)))),r.add(u.onDidChangeCapabilities(()=>this.g.fire({provider:u,scheme:t}))),(0,l.$hc)(()=>{this.c.fire({added:!1,scheme:t,provider:u}),this.h.delete(t),(0,l.$ec)(r)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const u=[];this.f.fire({scheme:t,join(r){u.push(r)}}),!this.h.has(t)&&await O.Promises.settled(u)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,u){const r=this.h.get(t.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return h.Iterable.map(this.h,([t,u])=>({scheme:t,capabilities:u.capabilities}))}async j(t){if(!(0,f.$lg)(t))throw new d.$mk((0,m.localize)(0,null,this.rb(t)),8);await this.activateProvider(t.scheme);const u=this.h.get(t.scheme);if(!u){const r=new $.$_;throw r.message=(0,m.localize)(1,null,t.toString()),r}return u}async m(t){const u=await this.j(t);if((0,d.$0j)(u)||(0,d.$7j)(u)||(0,d.$$j)(u))return u;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const u=await this.j(t);if((0,d.$0j)(u)||(0,d.$7j)(u))return u;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,u){try{return await this.s(t,u)}catch(r){throw(0,d.$hk)(r)===d.FileSystemProviderErrorCode.FileNotFound?new d.$mk((0,m.localize)(2,null,this.rb(t)),1):(0,d.$fk)(r)}}async s(t,u){const r=await this.j(t),i=this.S(r),n=u?.resolveTo,o=u?.resolveSingleChildDescendants,k=u?.resolveMetadata,A=await r.stat(t);let D;return this.t(r,t,A,void 0,!!k,(v,C)=>(D||(D=b.$Gh.forUris(()=>!i),D.set(t,!0),n&&D.fill(!0,n)),D.get(v.resource)||D.findSuperstr(v.resource.with({query:null,fragment:null}))?!0:v.isDirectory&&o?C===1:!1))}async t(t,u,r,i,n,o){const{providerExtUri:k}=this.R(t),A={resource:u,name:k.basename(u),isFile:(r.type&d.FileType.File)!==0,isDirectory:(r.type&d.FileType.Directory)!==0,isSymbolicLink:(r.type&d.FileType.SymbolicLink)!==0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:!!((r.permissions??0)&d.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((r.permissions??0)&d.FilePermission.Locked),etag:(0,d.$xk)({mtime:r.mtime,size:r.size}),children:void 0};if(A.isDirectory&&o(A,i)){try{const D=await t.readdir(u),v=await O.Promises.settled(D.map(async([C,L])=>{try{const T=k.joinPath(u,C),z=n?await t.stat(T):{type:L};return await this.t(t,T,z,D.length,n,o)}catch(T){return this.b.trace(T),null}}));A.children=(0,P.$Eb)(v)}catch(D){this.b.trace(D),A.children=[]}return A}return A}async resolveAll(t){return O.Promises.settled(t.map(async u=>{try{return{stat:await this.s(u.resource,u.options),success:!0}}catch(r){return this.b.trace(r),{stat:void 0,success:!1}}}))}async stat(t){const u=await this.j(t),r=await u.stat(t);return this.t(u,t,r,void 0,!0,()=>!1)}async exists(t){const u=await this.j(t);try{return!!await u.stat(t)}catch{return!1}}async canCreateFile(t,u){try{await this.u(t,u)}catch(r){return r}return!0}async u(t,u){if(!u?.overwrite&&await this.exists(t))throw new d.$mk((0,m.localize)(3,null,this.rb(t)),3,u)}async createFile(t,u=s.$Ed.fromString(""),r){await this.u(t,r);const i=await this.writeFile(t,u);return this.r.fire(new d.$jk(t,0,i)),i}async writeFile(t,u,r){const i=this.pb(await this.n(t),t),{providerExtUri:n}=this.R(i);try{await this.w(i,t,r)||await this.U(i,n.dirname(t));let k;if((0,d.$7j)(i)&&!(u instanceof s.$Ed))if((0,y.$qd)(u)){const A=await(0,y.$xd)(u,3);A.ended?k=s.$Ed.concat(A.buffer):k=A}else k=(0,y.$ud)(u,A=>s.$Ed.concat(A),3);else k=u;if(!(0,d.$0j)(i)||(0,d.$7j)(i)&&k instanceof s.$Ed)await this.gb(i,t,r,k);else{const A=k instanceof s.$Ed?(0,s.$Pd)(k):k;r?.atomic!==!1&&r?.atomic?.postfix?await this.bb(i,t,(0,f.$hg)((0,f.$gg)(t),`${(0,f.$eg)(t)}${r.atomic.postfix}`),r,A):await this.cb(i,t,r,A)}this.r.fire(new d.$jk(t,4))}catch(o){throw new d.$mk((0,m.localize)(4,null,this.rb(t),(0,d.$fk)(o).toString()),(0,d.$ik)(o),r)}return this.resolve(t,{resolveMetadata:!0})}async w(t,u,r){const i=!!r?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,m.localize)(5,null,this.rb(u)));if(!!r?.atomic){if(!(t.capabilities&32768))throw new Error((0,m.localize)(6,null,this.rb(u)));if(i)throw new Error((0,m.localize)(7,null,this.rb(u)))}let o;try{o=await t.stat(u)}catch{return}if(o.type&d.FileType.Directory)throw new d.$mk((0,m.localize)(8,null,this.rb(u)),0,r);if(this.qb(u,o),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==d.$wk&&typeof o.mtime=="number"&&typeof o.size=="number"&&r.mtime<o.mtime&&r.etag!==(0,d.$xk)({mtime:r.mtime,size:o.size}))throw new d.$mk((0,m.localize)(9,null),3,r);return o}async readFile(t,u,r){const i=await this.m(t);return u?.atomic?this.z(i,t,u,r):this.C(i,t,u,r)}async z(t,u,r,i){return new Promise((n,o)=>{this.ab.queueFor(u,this.R(t).providerExtUri).queue(async()=>{try{const k=await this.C(t,u,r,i);n(k)}catch(k){o(k)}})})}async C(t,u,r,i){const n=await this.D(t,u,{...r,preferUnbuffered:!0},i);return{...n,value:await(0,s.$Qd)(n.value)}}async readFileStream(t,u,r){const i=await this.m(t);return this.D(i,t,u,r)}async D(t,u,r,i){const n=new M.$od(i),o=this.J(u,r).then(A=>A,A=>{throw n.dispose(!0),A});let k;try{return typeof r?.etag=="string"&&r.etag!==d.$wk&&await o,r?.atomic&&(0,d.$_j)(t)||!((0,d.$0j)(t)||(0,d.$$j)(t))||(0,d.$7j)(t)&&r?.preferUnbuffered?k=this.I(t,u,r):(0,d.$$j)(t)?k=this.G(t,u,n.token,r):k=this.H(t,u,n.token,r),k.on("end",()=>n.dispose()),k.on("error",()=>n.dispose()),{...await o,value:k}}catch(A){throw k&&await(0,y.$vd)(k),this.F(A,u,r)}}F(t,u,r){const i=(0,m.localize)(10,null,this.rb(u),(0,d.$fk)(t).toString());return t instanceof d.$ok?new d.$ok(i,t.stat,r):t instanceof d.$nk?new d.$nk(i,t.fileOperationResult,t.size,t.options):new d.$mk(i,(0,d.$ik)(t),r)}G(t,u,r,i=Object.create(null)){const n=t.readFileStream(u,i,r);return(0,y.$Bd)(n,{data:o=>o instanceof s.$Ed?o:s.$Ed.wrap(o),error:o=>this.F(o,u,i)},o=>s.$Ed.concat(o))}H(t,u,r,i=Object.create(null)){const n=(0,s.$Ud)();return(0,c.$Bp)(t,u,n,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.F(o,u,i)},r),n}I(t,u,r){const i=(0,y.$sd)(n=>s.$Ed.concat(n));return(async()=>{try{let n;r?.atomic&&(0,d.$_j)(t)?n=await t.readFile(u,{atomic:!0}):n=await t.readFile(u),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.L(u,n.byteLength,r),i.end(s.$Ed.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async J(t,u){const r=await this.resolve(t,{resolveMetadata:!0});if(r.isDirectory)throw new d.$mk((0,m.localize)(11,null,this.rb(t)),0,u);if(typeof u?.etag=="string"&&u.etag!==d.$wk&&u.etag===r.etag)throw new d.$ok((0,m.localize)(12,null),r,u);return this.L(t,r.size,u),r}L(t,u,r){if(typeof r?.limits?.size=="number"&&u>r.limits.size)throw new d.$nk((0,m.localize)(13,null,this.rb(t)),7,u,r)}async canMove(t,u,r){return this.M(t,u,"move",r)}async canCopy(t,u,r){return this.M(t,u,"copy",r)}async M(t,u,r,i){if(t.toString()!==u.toString())try{const n=r==="move"?this.pb(await this.n(t),t):await this.m(t),o=this.pb(await this.n(u),u);await this.Q(n,t,o,u,r,i)}catch(n){return n}return!0}async move(t,u,r){const i=this.pb(await this.n(t),t),n=this.pb(await this.n(u),u),o=await this.N(i,t,n,u,"move",!!r),k=await this.resolve(u,{resolveMetadata:!0});return this.r.fire(new d.$jk(t,o==="move"?2:3,k)),k}async copy(t,u,r){const i=await this.m(t),n=this.pb(await this.n(u),u),o=await this.N(i,t,n,u,"copy",!!r),k=await this.resolve(u,{resolveMetadata:!0});return this.r.fire(new d.$jk(t,o==="copy"?3:2,k)),k}async N(t,u,r,i,n,o){if(u.toString()===i.toString())return n;const{exists:k,isSameResourceWithDifferentPathCase:A}=await this.Q(t,u,r,i,n,o);if(k&&!A&&o&&await this.del(i,{recursive:!0}),await this.U(r,this.R(r).providerExtUri.dirname(i)),n==="copy"){if(t===r&&(0,d.$8j)(t))await t.copy(u,i,{overwrite:o});else{const D=await this.resolve(u);D.isDirectory?await this.P(t,D,r,i):await this.O(t,u,r,i)}return n}else return t===r?(await t.rename(u,i,{overwrite:o}),n):(await this.N(t,u,r,i,"copy",o),await this.del(u,{recursive:!0}),"copy")}async O(t,u,r,i){if((0,d.$0j)(t)&&(0,d.$0j)(r))return this.ib(t,u,r,i);if((0,d.$0j)(t)&&(0,d.$7j)(r))return this.ob(t,u,r,i);if((0,d.$7j)(t)&&(0,d.$0j)(r))return this.mb(t,u,r,i);if((0,d.$7j)(t)&&(0,d.$7j)(r))return this.kb(t,u,r,i)}async P(t,u,r,i){await r.mkdir(i),Array.isArray(u.children)&&await O.Promises.settled(u.children.map(async n=>{const o=this.R(r).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),r,o):this.O(t,n.resource,r,o)}))}async Q(t,u,r,i,n,o){let k=!1;if(t===r){const{providerExtUri:D,isPathCaseSensitive:v}=this.R(t);if(v||(k=D.isEqual(u,i)),k&&n==="copy")throw new Error((0,m.localize)(14,null,this.rb(u),this.rb(i)));if(!k&&D.isEqualOrParent(i,u))throw new Error((0,m.localize)(15,null,this.rb(u),this.rb(i)))}const A=await this.exists(i);if(A&&!k){if(!o)throw new d.$mk((0,m.localize)(16,null,this.rb(u),this.rb(i)),4);if(t===r){const{providerExtUri:D}=this.R(t);if(D.isEqualOrParent(u,i))throw new Error((0,m.localize)(17,null,this.rb(u),this.rb(i)))}}return{exists:A,isSameResourceWithDifferentPathCase:k}}R(t){const u=this.S(t);return{providerExtUri:u?f.$0f:f.$_f,isPathCaseSensitive:u}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const u=this.pb(await this.j(t),t);await this.U(u,t);const r=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$jk(t,0,r)),r}async U(t,u){const r=[],{providerExtUri:i}=this.R(t);for(;!i.isEqual(u,i.dirname(u));)try{if(!((await t.stat(u)).type&d.FileType.Directory))throw new Error((0,m.localize)(18,null,this.rb(u)));break}catch(n){if((0,d.$hk)(n)!==d.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(i.basename(u)),u=i.dirname(u)}for(let n=r.length-1;n>=0;n--){u=i.joinPath(u,r[n]);try{await t.mkdir(u)}catch(o){if((0,d.$hk)(o)!==d.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,u){try{await this.W(t,u)}catch(r){return r}return!0}async W(t,u){const r=this.pb(await this.j(t),t),i=!!u?.useTrash;if(i&&!(r.capabilities&4096))throw new Error((0,m.localize)(19,null,this.rb(t)));const n=u?.atomic;if(n&&!(r.capabilities&65536))throw new Error((0,m.localize)(20,null,this.rb(t)));if(i&&n)throw new Error((0,m.localize)(21,null,this.rb(t)));let o;try{o=await r.stat(t)}catch{}if(o)this.qb(t,o);else throw new d.$mk((0,m.localize)(22,null,this.rb(t)),1);if(!!!u?.recursive){const A=await this.resolve(t);if(A.isDirectory&&Array.isArray(A.children)&&A.children.length>0)throw new Error((0,m.localize)(23,null,this.rb(t)))}return r}async del(t,u){const r=await this.W(t,u),i=!!u?.useTrash,n=!!u?.recursive,o=u?.atomic??!1;await r.delete(t,{recursive:n,useTrash:i,atomic:o}),this.r.fire(new d.$jk(t,1))}async cloneFile(t,u){const r=await this.j(t),i=this.pb(await this.n(u),u);if(r===i&&this.R(r).providerExtUri.isEqual(t,u))return;if(r===i&&(0,d.$9j)(r))return r.cloneFile(t,u);await this.U(i,this.R(i).providerExtUri.dirname(u));const n=this.ab.queueFor(t,this.R(r).providerExtUri);return r===i&&(0,d.$8j)(r)?n.queue(()=>r.copy(t,u,{overwrite:!0})):n.queue(()=>this.O(r,t,i,u))}watch(t,u={recursive:!1,excludes:[]}){const r=new l.$ic;let i=!1,n=()=>{i=!0};return r.add((0,l.$hc)(()=>n())),(async()=>{try{const o=await this.$(t,u);i?(0,l.$ec)(o):n=()=>(0,l.$ec)(o)}catch(o){this.b.error(o)}})(),r}async $(t,u){const r=await this.j(t),i=(0,S.$oi)([this.R(r).providerExtUri.getComparisonKey(t),u]);let n=this.Z.get(i);return n||(n={count:0,disposable:r.watch(t,u)},this.Z.set(i,n)),n.count+=1,(0,l.$hc)(()=>{n&&(n.count--,n.count===0&&((0,l.$ec)(n.disposable),this.Z.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,l.$ec)(t.disposable);this.Z.clear()}async bb(t,u,r,i,n){await this.cb(t,r,i,n);try{await t.rename(r,u,{overwrite:!0})}catch(o){try{await t.delete(r,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async cb(t,u,r,i){return this.ab.queueFor(u,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,y.$qd)(i)||(0,y.$rd)(i)?await this.db(t,n,i):await this.eb(t,n,i)}catch(o){throw(0,d.$fk)(o)}finally{await t.close(n)}})}async db(t,u,r){let i=0,n;if((0,y.$rd)(r)){if(r.buffer.length>0){const o=s.$Ed.concat(r.buffer);await this.fb(t,u,o,o.byteLength,i,0),i+=o.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((o,k)=>{(0,y.$wd)(n,{onData:async A=>{n.pause();try{await this.fb(t,u,A,A.byteLength,i,0)}catch(D){return k(D)}i+=A.byteLength,setTimeout(()=>n.resume())},onError:A=>k(A),onEnd:()=>o()})})}async eb(t,u,r){let i=0,n;for(;(n=r.read())!==null;)await this.fb(t,u,n,n.byteLength,i,0),i+=n.byteLength}async fb(t,u,r,i,n,o){let k=0;for(;k<i;){const A=await t.write(u,n+k,r.buffer,o+k,i-k);k+=A}}async gb(t,u,r,i){return this.ab.queueFor(u,this.R(t).providerExtUri).queue(()=>this.hb(t,u,r,i))}async hb(t,u,r,i){let n;i instanceof s.$Ed?n=i:(0,y.$qd)(i)?n=await(0,s.$Qd)(i):(0,y.$rd)(i)?n=await(0,s.$Rd)(i):n=(0,s.$Od)(i),await t.writeFile(u,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1,atomic:r?.atomic??!1})}async ib(t,u,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.jb(t,u,r,i))}async jb(t,u,r,i){let n,o;try{n=await t.open(u,{create:!1}),o=await r.open(i,{create:!0,unlock:!1});const k=s.$Ed.alloc(this.a);let A=0,D=0,v=0;do v=await t.read(n,A,k.buffer,D,k.byteLength-D),await this.fb(r,o,k,v,A,D),A+=v,D+=v,D===k.byteLength&&(D=0);while(v>0)}catch(k){throw(0,d.$fk)(k)}finally{await O.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async kb(t,u,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.lb(t,u,r,i))}async lb(t,u,r,i){return r.writeFile(i,await t.readFile(u),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(t,u,r,i){return this.ab.queueFor(i,this.R(r).providerExtUri).queue(()=>this.nb(t,u,r,i))}async nb(t,u,r,i){const n=await r.open(i,{create:!0,unlock:!1});try{const o=await t.readFile(u);await this.fb(r,n,s.$Ed.wrap(o),o.byteLength,0,0)}catch(o){throw(0,d.$fk)(o)}finally{await r.close(n)}}async ob(t,u,r,i){const n=await(0,s.$Qd)(this.H(t,u,M.CancellationToken.None));await this.gb(r,i,void 0,n)}pb(t,u){if(t.capabilities&2048)throw new d.$mk((0,m.localize)(24,null,this.rb(u)),6);return t}qb(t,u){if((u.permissions??0)&d.FilePermission.Readonly)throw new d.$mk((0,m.localize)(25,null,this.rb(t)),6)}rb(t){return t.scheme===w.Schemas.file?t.fsPath:t.toString(!0)}};e.$Cp=E,e.$Cp=E=ke([_(0,a.$4i)],E)}),define(te[93],ie([0,1,45,309,8,33,17,3,32,2,9,4,19,56,21,178,16,118,219,50,215,214]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0,(()=>{try{(0,O.gracefulify)(P)}catch(u){console.error(`Error enabling graceful-fs: ${(0,$.$li)(u)}`)}})();class t extends a.$Lp{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=S.Event.None,this.N=new M.$yi(n=>p.$$f.getComparisonKey(n)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,w.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async o=>{try{let k;o.isSymbolicLink()?k=(await this.stat((0,p.$hg)(r,o.name))).type:k=this.M(o),n.push([o.name,k])}catch(k){this.a.trace(k)}})),n}catch(i){throw this.eb(i)}}M(r,i){let n;return i?.dangling?n=d.FileType.Unknown:r.isFile()?n=d.FileType.File:r.isDirectory()?n=d.FileType.Directory:n=d.FileType.Unknown,i&&(n|=d.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const o=new s.$Eg;return this.N.set(r,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$hc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const o=this.H(r);return await y.Promises.readFile(o)}catch(o){throw this.eb(o)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const o=(0,f.$sd)(k=>I.$Ed.concat(k.map(A=>I.$Ed.wrap(A))).buffer);return(0,c.$Bp)(this,r,o,k=>k.buffer,{...i,bufferSize:256*1024},n),o}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.Q(r,(0,p.$hg)((0,p.$gg)(r),`${(0,p.$eg)(r)}${n.atomic.postfix}`),i,n):this.R(r,i,n)}async Q(r,i,n,o){await this.R(i,n,o);try{await this.rename(i,r,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}async R(r,i,n){let o;try{const k=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(k)){if(!n.overwrite)throw(0,d.$ek)((0,m.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,d.$ek)((0,m.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(k){throw await this.fb(r,k)}finally{typeof o=="number"&&await this.close(o)}}static{this.X=!0}static configureFlushOnWrite(r){t.X=r}async open(r,i){const n=this.H(r);let o;(0,d.$6j)(i)&&(o=await this.O(r));let k;try{if((0,d.$6j)(i)&&i.unlock)try{const{stat:D}=await y.SymlinkSupport.stat(n);D.mode&128||await y.Promises.chmod(n,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let A;if((0,d.$6j)(i)){if(w.$i)try{await y.Promises.truncate(n,0),A="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}A||(A="w")}else A="r";k=await y.Promises.open(n,A)}catch(A){throw o?.dispose(),(0,d.$6j)(i)?await this.fb(r,A):this.eb(A)}if(this.S.set(k,0),(0,d.$6j)(i)&&this.W.set(k,r),o){const A=this.U.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${n})`),this.U.set(k,o),A&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${n})`),A.dispose())}return k}async close(r){const i=this.U.get(r);try{if(this.S.delete(r),this.W.delete(r)&&t.X)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.eb(n)}finally{i&&(this.U.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.U.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,o,k){const A=this.Y(r,i);let D=null;try{D=(await y.Promises.read(r,n,o,k,A)).bytesRead}catch(v){throw this.eb(v)}finally{this.Z(r,A,D)}return D}Y(r,i){return i===this.S.get(r)?null:i}Z(r,i,n){const o=this.S.get(r);typeof o=="number"&&(typeof i=="number"||(typeof n=="number"?this.S.set(r,o+n):this.S.delete(r)))}async write(r,i,n,o,k){return(0,s.$Xg)(()=>this.$(r,i,n,o,k),100,3)}async $(r,i,n,o,k){const A=this.Y(r,i);let D=null;try{D=(await y.Promises.write(r,n,o,k,A)).bytesWritten}catch(v){throw await this.fb(this.W.get(r),v)}finally{this.Z(r,A,D)}return D}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(i){throw this.eb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,b.$8d)((0,b.$$d)(n),`${(0,b.$_d)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,o)}else try{await y.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let k=!1;try{const{stat:A,symbolicLink:D}=await y.SymlinkSupport.stat(n);k=A.isDirectory()&&!D}catch{}if(k)await y.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.eb(n)}}async rename(r,i,n){const o=this.H(r),k=this.H(i);if(o!==k)try{await this.ab(r,i,"move",n.overwrite),await y.Promises.rename(o,k)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,m.localize)(2,null,(0,b.$_d)(o),(0,b.$_d)((0,b.$$d)(k)),A.toString()))),this.eb(A)}}async copy(r,i,n){const o=this.H(r),k=this.H(i);if(o!==k)try{await this.ab(r,i,"copy",n.overwrite),await y.Promises.copy(o,k,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,m.localize)(3,null,(0,b.$_d)(o),(0,b.$_d)((0,b.$$d)(k)),A.toString()))),this.eb(A)}}async ab(r,i,n,o){const k=this.H(r),A=this.H(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,h.$Gf)(k,A,!0)),D){if(n==="copy")throw(0,d.$ek)((0,m.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const C=await this.L(r);if(!C)throw(0,d.$ek)((0,m.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(i);if(L){if(!o)throw(0,d.$ek)((0,m.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);C.type&d.FileType.File&&L.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.bb(r,i,!1)}async bb(r,i,n){const o=this.H(r),k=this.H(i),A=!!(this.capabilities&1024);if((0,h.$Gf)(o,k,!A))return;const D=new l.$ic;try{const[v,C]=await Promise.all([this.O(r),this.O(i)]);D.add(v),D.add(C),n&&await y.Promises.mkdir((0,b.$$d)(k),{recursive:!0}),await y.Promises.copyFile(o,k)}catch(v){if(v.code==="ENOENT"&&!n)return this.bb(r,i,!0);throw this.eb(v)}finally{D.dispose()}}t(r,i,n){return new E.$Sp(o=>r(o),o=>i(o),n)}F(r,i,n){return new g.$1p(o=>r(o),o=>i(o),n)}eb(r){if(r instanceof d.$dk)return r;let i=r,n;switch(r.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=d.FileSystemProviderErrorCode.Unknown;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.$ek)(i,n)}async fb(r,i){let n=this.eb(i);if(r&&n.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.H(r));o.mode&128||(n=(0,d.$ek)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$2p=t}),define(te[221],ie([0,1,3,93,2,17,56,22]),function(K,e,P,O,s,M,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=void 0;class h extends s.$jc{constructor(w,p){super(),this.a=w,this.b=p,this.F=new Map,this.G=new Map}call(w,p,f){const y=this.c(w);switch(p){case"stat":return this.g(y,f[0]);case"readdir":return this.h(y,f[0]);case"open":return this.r(y,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(y,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(y,f[0],f[1],f[2]);case"rename":return this.z(y,f[0],f[1],f[2]);case"copy":return this.C(y,f[0],f[1],f[2]);case"cloneFile":return this.D(y,f[0],f[1]);case"mkdir":return this.w(y,f[0]);case"delete":return this.y(y,f[0],f[1]);case"watch":return this.I(y,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${p} not found`)}listen(w,p,f){const y=this.c(w);switch(p){case"fileChange":return this.H(y,f[0]);case"readFileStream":return this.m(y,f[0],f[1])}throw new Error(`Unknown event ${p}`)}g(w,p){const f=this.f(w,p,!0);return this.a.stat(f)}h(w,p){const f=this.f(w,p);return this.a.readdir(f)}async j(w,p,f){const y=this.f(w,p,!0),m=await this.a.readFile(y,f);return M.$Ed.wrap(m)}m(w,p,f){const y=this.f(w,p,!0),m=new S.$od,d=new P.$ed({onDidRemoveLastListener:()=>{m.cancel()}}),c=this.a.readFileStream(y,f,m.token);return(0,I.$wd)(c,{onData:a=>d.fire(M.$Ed.wrap(a)),onError:a=>d.fire(a),onEnd:()=>{d.fire("end"),d.dispose(),m.dispose()}}),d.event}n(w,p,f,y){const m=this.f(w,p);return this.a.writeFile(m,f.buffer,y)}r(w,p,f){const y=this.f(w,p,!0);return this.a.open(y,f)}s(w){return this.a.close(w)}async t(w,p,f){const y=M.$Ed.alloc(f),m=0,d=await this.a.read(w,p,y.buffer,m,f);return[y,d]}u(w,p,f,y,m){return this.a.write(w,p,f.buffer,y,m)}w(w,p){const f=this.f(w,p);return this.a.mkdir(f)}y(w,p,f){const y=this.f(w,p);return this.a.delete(y,f)}z(w,p,f,y){const m=this.f(w,p),d=this.f(w,f);return this.a.rename(m,d,y)}C(w,p,f,y){const m=this.f(w,p),d=this.f(w,f);return this.a.copy(m,d,y)}D(w,p,f){const y=this.f(w,p),m=this.f(w,f);return this.a.cloneFile(y,m)}H(w,p){const f=new P.$ed({onWillAddFirstListener:()=>{this.F.set(p,this.L(w,f))},onDidRemoveLastListener:()=>{(0,s.$ec)(this.F.get(p)),this.F.delete(p)}});return f.event}async I(w,p,f,y,m){const d=this.F.get(p);if(d){const c=this.f(w,y),a=d.watch(f,c,m);this.G.set(p+f,a)}}async J(w,p){const f=w+p,y=this.G.get(f);y&&((0,s.$ec)(y),this.G.delete(f))}dispose(){super.dispose();for(const[,w]of this.G)w.dispose();this.G.clear();for(const[,w]of this.F)w.dispose();this.F.clear()}}e.$xr=h;class l extends s.$jc{constructor(w,p,f,y){super(),this.c=w,this.f=f,this.g=y,this.a=new Map,this.b=this.B(new O.$2p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h(w){const p=this.B(new P.$ed);this.B(p.event(f=>{w.fire(f.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(f=>p.fire(f))),this.B(this.b.onDidWatchError(f=>w.fire(f)))}j(w){}m(w){}watch(w,p,f){const y=this.m(this.g);return Array.isArray(y)&&(f.excludes=[...f.excludes,...y]),this.a.set(w,this.b.watch(p,f)),(0,s.$hc)(()=>{(0,s.$ec)(this.a.get(w)),this.a.delete(w)})}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),super.dispose()}}e.$yr=l}),define(te[222],ie([0,1,15,177,4,7,16,9,221,155]),function(K,e,P,O,s,M,I,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R5b=void 0;class b extends h.$xr{constructor(f,y,m){super(f,y),this.M=m}c(f){return l.$Bm}f(f,y){return M.URI.revive(y)}async y(f,y,m){if(!m.useTrash)return super.y(f,y,m);const d=this.f(f,y),c=(0,S.$6d)(d.fsPath);try{await P.shell.trashItem(c)}catch{throw(0,I.$ek)(s.$i?(0,O.localize)(0,null,(0,S.$_d)(c)):(0,O.localize)(1,null,(0,S.$_d)(c)),I.FileSystemProviderErrorCode.Unknown)}}L(f,y){return new w(f,y,this.b,this.M)}}e.$R5b=b;class w extends h.$yr{watch(f,y,m){if(m.recursive)throw(0,I.$ek)("Recursive file watching is not supported from main process for performance reasons.",I.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,m)}}}),define(te[223],ie([0,1,5]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S2b=void 0;class O extends P.$0i{constructor(M=P.$7i){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(I=>{this.n?.setLevel(I)}))}set logger(M){this.n=M;for(const{level:I,message:S}of this.m)(0,P.log)(M,I,S);this.m=[]}g(M,I){this.n?(0,P.log)(this.n,M,I):this.getLevel()<=M&&this.m.push({level:M,message:I})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$S2b=O}),define(te[224],ie([0,1,7,3,5,2]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=void 0;class I extends s.$cj{constructor(w,p,f,y,m){super(p,f,y),this.r=w,this.t=m,this.B(m.listen("onDidChangeLogLevel",w)(d=>{(0,s.$6i)(d)?super.setLogLevel(d):super.setLogLevel(P.URI.revive(d[0]),d[1])})),this.B(m.listen("onDidChangeVisibility",w)(([d,c])=>super.setVisibility(P.URI.revive(d),c))),this.B(m.listen("onDidChangeLoggers",w)(({added:d,removed:c})=>{for(const a of d)super.registerLogger({...a,resource:P.URI.revive(a.resource)});for(const a of c)super.deregisterLogger(a.resource)}))}createConsoleMainLogger(){return new s.$aj({log:(w,p)=>{this.t.call("consoleLog",[w,p])}})}registerLogger(w){super.registerLogger(w),this.t.call("registerLogger",[w,this.r])}deregisterLogger(w){super.deregisterLogger(w),this.t.call("deregisterLogger",[w,this.r])}setLogLevel(w,p){super.setLogLevel(w,p),this.t.call("setLogLevel",[w,p])}setVisibility(w,p){super.setVisibility(w,p),this.t.call("setVisibility",[this.n(w),p])}s(w,p,f){return new S(this.t,w,p,f,this.r)}static setLogLevel(w,p,f){return w.call("setLogLevel",[p,f])}}e.$Zq=I;class S extends s.$0i{constructor(w,p,f,y,m){super(y?.logLevel==="always"),this.r=w,this.s=p,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[p,y,m]).then(()=>{this.u(this.n),this.m=!0})}g(w,p){const f=[[w,p]];this.m?this.u(f):this.n.push(...f)}u(w){this.r.call("log",[this.s,w])}}class h{constructor(w,p){this.a=w,this.b=p}listen(w,p){const f=this.b(w);switch(p){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(m=>this.c(m,f)),removed:[...y.removed].map(m=>this.c(m,f))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,y=>[f.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$6i)(y)?y:[f.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${p}`)}async call(w,p,f){const y=this.b(w);switch(p){case"setLogLevel":return(0,s.$6i)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(P.URI.revive(y.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,y)))}throw new Error(`Call not found: ${p}`)}c(w,p){return{...w,resource:p.transformOutgoingURI(w.resource)}}}e.$1q=h;class l extends M.$jc{constructor(w,p){super(),p.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(f=>p.call("setLogLevel",[f]))),p.call("getRegisteredLoggers").then(f=>{for(const y of f)w.registerLogger({...y,resource:P.URI.revive(y.resource)})}),this.B(p.listen("onDidChangeVisibility")(([f,y])=>w.setVisibility(P.URI.revive(f),y))),this.B(p.listen("onDidChangeLoggers")(({added:f,removed:y})=>{for(const m of f)w.registerLogger({...m,resource:P.URI.revive(m.resource)});for(const m of y)w.deregisterLogger(m.resource)}))}}e.$2q=l}),define(te[225],ie([0,1,2,5]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;class s extends P.$jc{constructor(I,S=[]){super(),this.a=new O.$bj([I,...S]),this.B(I.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...S){this.a.trace(I,...S)}debug(I,...S){this.a.debug(I,...S)}info(I,...S){this.a.info(I,...S)}warn(I,...S){this.a.warn(I,...S)}error(I,...S){this.a.error(I,...S)}flush(){this.a.flush()}}e.$iN=s}),define(te[226],ie([0,1,33,7,5]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P6b=void 0;class M{constructor(S){this.b=S,this.a=new P.$yi}listen(S,h,l){switch(h){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(S,h,l){switch(h){case"createLogger":this.c(O.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(O.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,s.$6i)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(O.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(O.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:O.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(O.URI.revive(l[0]))}throw new Error(`Call not found: ${h}`)}c(S,h,l){this.a.set(S,this.b.createLogger(S,h,l))}d(S,h){let l=console.log;switch(S){case s.LogLevel.Error:l=console.error;break;case s.LogLevel.Warning:l=console.warn;break;case s.LogLevel.Info:l=console.info;break}l.call(console,...h)}e(S,h){const l=this.a.get(S);if(!l)throw new Error("Create the logger before logging");for(const[b,w]of h)(0,s.log)(l,b,w)}}e.$P6b=M}),define(te[227],ie([0,1,16,5]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=void 0;var s;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(s||(s={}));async function M(l,b,w,p,f){try{const y=await new Promise((d,c)=>{K(["@vscode/spdlog"],d,c)});y.setFlushOn(s.Trace);const m=await y.createAsyncRotatingLogger(l,b,w,p);return f?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(y){console.error(y)}return null}function I(l,b,w){switch(b){case O.LogLevel.Trace:l.trace(w);break;case O.LogLevel.Debug:l.debug(w);break;case O.LogLevel.Info:l.info(w);break;case O.LogLevel.Warning:l.warn(w);break;case O.LogLevel.Error:l.error(w);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function S(l,b){switch(b){case O.LogLevel.Trace:l.setLevel(s.Trace);break;case O.LogLevel.Debug:l.setLevel(s.Debug);break;case O.LogLevel.Info:l.setLevel(s.Info);break;case O.LogLevel.Warning:l.setLevel(s.Warning);break;case O.LogLevel.Error:l.setLevel(s.Error);break;case O.LogLevel.Off:l.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class h extends O.$0i{constructor(b,w,p,f,y){super(),this.m=[],this.setLevel(y),this.n=this.s(b,w,p,f),this.B(this.onDidChangeLogLevel(m=>{this.r&&S(this.r,m)}))}async s(b,w,p,f){const y=p?6:1,m=30/y*P.$zk.MB,d=await M(b,w,m,y,f);if(d){this.r=d,S(this.r,this.getLevel());for(const{level:c,message:a}of this.m)I(this.r,c,a);this.m=[]}}g(b,w){this.r?I(this.r,b,w):this.getLevel()<=b&&this.m.push({level:b,message:w})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$0M=h}),define(te[228],ie([0,1,31,5,227]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0;class M extends O.$cj{s(S,h,l){return new s.$0M((0,P.$3f)(),S.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,h)}}e.$$M=M}),define(te[66],ie([0,1,33,3,6,5,228]),function(K,e,P,O,s,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e6b=e.$d6b=void 0,e.$d6b=(0,s.$Bh)(M.$5i);class S extends I.$$M{constructor(){super(...arguments),this.u=new P.$yi}createLogger(l,b,w){w!==void 0&&this.u.set(this.n(l),w);try{return super.createLogger(l,b)}catch(p){throw this.u.delete(this.n(l)),p}}registerLogger(l,b){b!==void 0&&this.u.set(l.resource,b),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const b=[];for(const w of super.getRegisteredLoggers())l===this.u.get(w.resource)&&b.push(w);return b}getOnDidChangeLogLevelEvent(l){return O.Event.filter(this.onDidChangeLogLevel,b=>(0,M.$6i)(b)||this.w(b[0],l))}getOnDidChangeVisibilityEvent(l){return O.Event.filter(this.onDidChangeVisibility,([b])=>this.w(b,l))}getOnDidChangeLoggersEvent(l){return O.Event.filter(O.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(p=>this.w(p.resource,l)),removed:[...b.removed].filter(p=>this.w(p.resource,l))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(l){for(const[b,w]of this.u)w===l&&this.deregisterLogger(b)}w(l,b){const w=this.u.get(l);return w===void 0||w===b}dispose(){super.dispose(),this.u.clear()}}e.$e6b=S}),define(te[229],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=e.$95b=e.$85b=e.$75b=void 0;function P(I){return I.submenu!==void 0}e.$75b=P;function O(I){return I.id==="vscode.menubar.separator"}e.$85b=O;function s(I){return I.uri!==void 0}e.$95b=s;function M(I){return!P(I)&&!O(I)&&!s(I)}e.$05b=M}),define(te[39],ie([0,1,3,68,2,6]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=void 0,e.$9m=(0,M.$Ah)("policy");class I extends s.$jc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$ed),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const b=Object.keys(this.f).length;return this.f={...l,...this.f},b!==Object.keys(this.f).length&&await this.j(l),O.Iterable.reduce(this.g.entries(),(w,[p,f])=>({...w,[p]:f}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(l,[b,w])=>({...l,[b]:{definition:w,value:this.g.get(b)}}),{})}}e.$0m=I;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$$m=S}),define(te[230],ie([0,1,8,3,68,12,16,5,39]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=void 0;function l(w,p){const f=[];for(const y of new Set(s.Iterable.concat(w.keys(),p.keys())))w.get(y)!==p.get(y)&&f.push(y);return f}let b=class extends h.$0m{constructor(p,f,y){super(),this.m=p,this.n=f,this.s=y,this.c=this.B(new P.$Dg(500));const m=O.Event.filter(f.onDidFilesChange,d=>d.affects(p));this.B(f.watch(p)),this.B(m(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const p=new Map;try{const f=await this.n.readFile(this.m),y=JSON.parse(f.value.toString());if(!(0,M.$kf)(y))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(y))this.f[m]&&p.set(m,y[m])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return p}async w(){const p=await this.u(),f=l(this.g,p);this.g=p,f.length>0&&this.h.fire(f)}};e.$86b=b,e.$86b=b=ke([_(1,I.$5j),_(2,S.$4i)],b)}),define(te[231],ie([0,1,3,2,39]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=e.$I6b=void 0;class M{constructor(h){this.b=h,this.a=new O.$ic}listen(h,l){switch(l){case"onDidChange":return P.Event.map(this.b.onDidChange,b=>b.reduce((w,p)=>({...w,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(h,l,b){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$I6b=M;class I extends s.$0m{constructor(h,l){super(),this.a=l;for(const b in h){const{definition:w,value:p}=h[b];this.f[b]=w,p!==void 0&&this.g.set(b,p)}this.a.listen("onDidChange")(b=>{for(const w in b){const p=b[w];p===null?this.g.delete(w):this.g.set(w,p)}this.h.fire(Object.keys(b))})}async j(h){const l=await this.a.call("updatePolicyDefinitions",h);for(const b in l)this.g.set(b,l[b])}}e.$J6b=I}),define(te[232],ie([0,1,39,8,310,2,5]),function(K,e,P,O,s,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=void 0;let S=class extends P.$0m{constructor(l,b){super(),this.m=l,this.n=b,this.a=new O.$zg,this.b=this.B(new M.$kc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((b,w)=>{try{this.b.value=(0,s.createWatcher)(this.n,l,p=>{this.t(p),b()})}catch(p){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),w(p)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const b in l){const w=l[b];w===void 0?this.g.delete(b):this.g.set(b,w)}this.h.fire(Object.keys(l))}};e.$76b=S,e.$76b=S=ke([_(0,I.$4i)],S)}),define(te[77],ie([0,1,4,35]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.$g.vscode<"u"&&typeof P.$g.vscode.context<"u"){const M=P.$g.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[24],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=void 0,e.$jj=(0,P.$Ah)("productService"),e.$kj="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,72,5,24]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K5b=void 0;let M=class{constructor(S,h){this.b=S,this.c=h,this.a=new Map}async isExtensionUrlTrusted(S,h){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const l=/^(.*)#([^#]+)$/.exec(h);if(!l)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,b,w]=l;let p=this.a.get(S);if(!p){if(p=this.b.trustedExtensionUrlPublicKeys[S],!p||p.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.a.set(S,[...p])}const f=Buffer.from(decodeURIComponent(w),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const y=f.slice(0,6),m=f.readUIntBE(0,6),d=Date.now()-m;if(d<0||d>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const c=f.slice(6),a=P.createVerify("SHA256");a.write(y),a.write(Buffer.from(b)),a.end();for(let $=0;$<p.length;$++){let E=p[$];if(E!==null){if(typeof E=="string")try{E=P.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),p[$]=E}catch(g){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${$+1} for ${S}:`,g),p[$]=null;continue}if(a.verify(E,c))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};e.$K5b=M,e.$K5b=M=ke([_(0,s.$jj),_(1,O.$4i)],M)}),define(te[234],ie([0,1,8,5]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W5b=void 0;let s=class{constructor(I,S,h){this.a=I,this.b=S,this.c=h}async inspect(I){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$Gg)(I);const h=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const I=this.a.webContents.debugger;I.attach(),await I.sendCommand("Profiler.enable")}async e(){const I=this.a.webContents.debugger;await I.sendCommand("Profiler.disable"),I.detach()}};e.$W5b=s,e.$W5b=s=ke([_(2,O.$4i)],s)}),define(te[78],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z5b=void 0,e.$Z5b=(0,P.$Ah)("protocolMainService")}),define(te[43],ie([0,1,136,12]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;class s{constructor(){this.a=new Map}add(I,S){P.ok(O.$if(I)),P.ok(O.$kf(S)),P.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,S)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$7m=new s}),define(te[235],ie([0,1,3,43]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$8m={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new P.$ed,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,l){this.a[s(h)]=l,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const I=new M;O.$7m.add(e.$8m.JSONContribution,I)}),define(te[59],ie([0,1,23,3,12,162,18,235,43]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ConfigurationScope=e.$_m=e.EditPresentationTypes=void 0;var l;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$_m={Configuration:"base.contributions.configuration"};var b;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b||(e.ConfigurationScope=b={})),e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn="vscode://schemas/settings/resourceLanguage",e.$hn="vscode://schemas/settings/configurationDefaults";const w=h.$7m.as(S.$8m.JSONContribution);class p{constructor(){this.h=new Set,this.i=new O.$ed,this.onDidSchemaChange=this.i.event,this.j=new O.$ed,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.$gn,this.g),this.v()}registerConfiguration(t,u=!0){this.registerConfigurations([t],u)}registerConfigurations(t,u=!0){const r=new Set;this.n(t,u,r),w.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const u=new Set;this.o(t,u),w.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:u})}updateConfigurations({add:t,remove:u}){const r=new Set;this.o(u,r),this.n(t,!1,r),w.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const u=new Set;this.k(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}k(t,u){const r=[];for(const{overrides:i,source:n}of t)for(const o in i)if(u.add(o),e.$jn.test(o)){const k=this.a.get(o),A=k?.valuesSources??new Map;if(n)for(const L of Object.keys(i[o]))A.set(L,n);const D={...k?.value||{},...i[o]};this.a.set(o,{source:n,value:D,valuesSources:A});const v=(0,I.$ei)(o),C={type:"object",default:D,description:M.localize(1,null,v),$ref:e.$gn,defaultDefaultValue:D,source:s.$if(n)?void 0:n,defaultValueSource:n};r.push(...m(o)),this.d[o]=C,this.b.properties[o]=C}else{this.a.set(o,{value:i[o],source:n});const k=this.d[o];k&&(this.w(o,k),this.r(o,k))}this.m(r)}deregisterDefaultConfigurations(t){const u=new Set;this.l(t,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:!0})}l(t,u){for(const{overrides:r,source:i}of t)for(const n in r){const o=this.a.get(n),k=s.$if(i)?i:i?.id,A=s.$if(o?.source)?o?.source:o?.source?.id;if(k===A)if(u.add(n),this.a.delete(n),e.$jn.test(n))delete this.d[n],delete this.b.properties[n];else{const D=this.d[n];D&&(this.w(n,D),this.r(n,D))}}this.u()}deltaConfiguration(t){let u=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),u=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),u=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:u})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const u of t)this.h.add(u);this.u()}n(t,u,r){t.forEach(i=>{this.p(i,u,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,u){const r=i=>{if(i.properties)for(const n in i.properties){u.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,u=!0,r,i,n=3,o){n=s.$rf(t.scope)?n:t.scope;const k=t.properties;if(k)for(const D in k){const v=k[D];if(u&&$(D,v)){delete k[D];continue}if(v.source=r,v.defaultDefaultValue=k[D].default,this.w(D,v),e.$jn.test(D)?v.scope=void 0:(v.scope=s.$rf(v.scope)?n:v.scope,v.restricted=s.$rf(v.restricted)?!!i?.includes(D):v.restricted),k[D].hasOwnProperty("included")&&!k[D].included){this.f[D]=k[D],delete k[D];continue}else this.d[D]=k[D],k[D].policy?.name&&this.e.set(k[D].policy.name,D);!k[D].deprecationMessage&&k[D].markdownDeprecationMessage&&(k[D].deprecationMessage=k[D].markdownDeprecationMessage),o.add(D)}const A=t.allOf;if(A)for(const D of A)this.p(D,u,r,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const u=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(u)};u(t)}r(t,u){switch(e.$an.properties[t]=u,u.scope){case 1:e.$bn.properties[t]=u;break;case 2:e.$cn.properties[t]=u;break;case 6:e.$dn.properties[t]=u;break;case 3:e.$en.properties[t]=u;break;case 4:e.$fn.properties[t]=u;break;case 5:e.$fn.properties[t]=u,this.g.properties[t]=u;break}}s(t,u){switch(delete e.$an.properties[t],u.scope){case 1:delete e.$bn.properties[t];break;case 2:delete e.$cn.properties[t];break;case 6:delete e.$dn.properties[t];break;case 3:delete e.$en.properties[t];break;case 4:case 5:delete e.$fn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const u=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$gn};this.w(u,r),e.$an.properties[u]=r,e.$bn.properties[u]=r,e.$cn.properties[u]=r,e.$dn.properties[u]=r,e.$en.properties[u]=r,e.$fn.properties[u]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$gn};e.$an.patternProperties[e.$in]=t,e.$bn.patternProperties[e.$in]=t,e.$cn.patternProperties[e.$in]=t,e.$dn.patternProperties[e.$in]=t,e.$en.patternProperties[e.$in]=t,e.$fn.patternProperties[e.$in]=t,this.i.fire()}w(t,u){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$pf(i)&&(i=u.defaultDefaultValue,n=void 0),s.$pf(i)&&(i=c(u.type)),u.default=i,u.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.$in=`^(${f})+$`,e.$jn=new RegExp(e.$in);function m(g){const t=[];if(e.$jn.test(g)){let u=y.exec(g);for(;u?.length;){const r=u[1].trim();r&&t.push(r),u=y.exec(g)}}return(0,P.$Jb)(t)}e.$kn=m;function d(g){return g.reduce((t,u)=>`${t}[${u}]`,"")}e.$ln=d;function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$mn=c;const a=new p;h.$7m.add(e.$_m.Configuration,a);function $(g,t){return g.trim()?e.$jn.test(g)?M.localize(7,null,g):a.getConfigurationProperties()[g]!==void 0?M.localize(8,null,g):t.policy?.name&&a.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,g,t.policy?.name,a.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$nn=$;function E(){const g=[],t=a.getConfigurationProperties();for(const u of Object.keys(t))g.push([u,t[u].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.$on=E}),define(te[119],ie([0,1,23,3,44,2,33,37,12,7,18,59,43]),function(K,e,P,O,s,M,I,S,h,l,b,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function f(u){return Object.isFrozen(u)?u:S.$Vm(u)}class y{constructor(r={},i=[],n=[],o){this.b=r,this.c=i,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new m("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,b.$ci)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),o=i?this.rawConfiguration.getOverrideValue(r,i):void 0,k=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:o,merged:k}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,b.$ci)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return P.$Jb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return P.$Jb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=S.$Um(this.contents),n=S.$Um(this.overrides),o=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const A of r)if(k.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(i,A.contents);for(const D of A.overrides){const[v]=n.filter(C=>P.$sb(C.identifiers,D.identifiers));v?(this.h(v.contents,D.contents),v.keys.push(...D.keys),v.keys=P.$Jb(v.keys)):n.push(S.$Um(D))}for(const D of A.keys)o.indexOf(D)===-1&&o.push(D)}return new y(i,o,n,k.every(A=>A instanceof y)?void 0:k)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const o of P.$Jb([...Object.keys(this.contents),...Object.keys(i)])){let k=this.contents[o];const A=i[o];A&&(typeof k=="object"&&typeof A=="object"?(k=S.$Um(k),this.h(k,A)):k=A),n[o]=k}return new y(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&h.$kf(r[n])&&h.$kf(i[n])){this.h(r[n],i[n]);continue}r[n]=S.$Um(i[n])}}i(r){let i=null,n=null;const o=k=>{k&&(n?this.h(n,k):n=S.$Um(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===r?i=k.contents:k.identifiers.includes(r)&&o(k.contents);return o(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,b.$bi)(this.contents,r),w.$jn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$sb(n.identifiers,(0,w.$kn)(r))),1))}j(r,i,n){(0,b.$ai)(this.contents,r,i,o=>console.error(o)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),w.$jn.test(r)&&this.overrides.push({identifiers:(0,w.$kn)(r),keys:Object.keys(this.contents[r]),contents:(0,b.$_h)(this.contents[r],o=>console.error(o))})}}e.$pn=y;class m{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!h.$rf(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:o,overrides:k,restricted:A,hasExcludedProperties:D}=this.h(r,i);this.b=new y(n,o,k,D?[r]:void 0),this.c=A||[]}g(r){let i={},n=null,o=[];const k=[],A=[];function D(C){Array.isArray(o)?o.push(C):n!==null&&(o[n]=C)}const v={onObjectBegin:()=>{const C={};D(C),k.push(o),o=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{o=k.pop()},onArrayBegin:()=>{const C=[];D(C),k.push(o),o=C,n=null},onArrayEnd:()=>{o=k.pop()},onLiteralValue:D,onError:(C,L,T)=>{A.push({error:C,offset:L,length:T})}};if(r)try{s.$Rm(r,v),i=o[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(r,i){const n=p.$7m.as(w.$_m.Configuration).getConfigurationProperties(),o=this.i(r,n,!0,i);r=o.raw;const k=(0,b.$_h)(r,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),A=Object.keys(r),D=this.j(r,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:k,keys:A,overrides:D,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(r,i,n,o){let k=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:k};const A={},D=[];for(const v in r)if(w.$jn.test(v)&&n){const C=this.i(r[v],i,!1,o);A[v]=C.raw,k=k||C.hasExcludedProperties,D.push(...C.restricted)}else{const C=i[v],L=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&D.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(L===void 0||o.scopes===void 0||o.scopes.includes(L))&&!(o.skipRestricted&&C?.restricted))?A[v]=r[v]:k=!0}return{raw:A,restricted:D,hasExcludedProperties:k}}j(r,i){const n=[];for(const o of Object.keys(r))if(w.$jn.test(o)){const k={};for(const A in r[o])k[A]=r[o][A];n.push({identifiers:(0,w.$kn)(o),keys:Object.keys(k),contents:(0,b.$_h)(k,i)})}return n}}e.$qn=m;class d extends M.$jc{constructor(r,i,n,o){super(),this.c=r,this.f=i,this.g=o,this.b=this.B(new O.$ed),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&n.isEqual(k.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$rn=d;class c{constructor(r,i,n,o,k,A,D,v,C,L,T,z,se){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=o,this.d=k,this.f=A,this.g=D,this.h=v,this.i=C,this.j=L,this.k=T,this.l=z,this.m=se}get value(){return f(this.c)}n(r,i,n){const o=r.inspect(i,n);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(r,i,n,o,k=new y,A=new y,D=new I.$yi,v=new y,C=new I.$yi){this.c=r,this.d=i,this.f=n,this.g=o,this.h=k,this.i=A,this.j=D,this.l=v,this.m=C,this.a=null,this.b=new I.$yi,this.n=null}getValue(r,i,n){return this.q(r,i,n).getValue(r)}updateValue(r,i,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new y,this.m.set(n.resource,o))):o=this.l,i===void 0?o.removeValue(r):o.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const o=this.q(r,i,n),k=this.u(i.resource,n),A=i.resource?this.m.get(i.resource)||this.l:this.l,D=new Set;for(const v of o.overrides)for(const C of v.identifiers)o.getOverrideValue(r,C)!==void 0&&D.add(C);return new c(r,i,o.getValue(r),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,k||void 0,A)}keys(r){const i=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:o,updated:k,removed:A}=g(this.c,r);i=[...o,...k,...A]}for(const o of i)for(const k of(0,w.$kn)(o)){const A=this.c.getKeysForOverrideIdentifier(k),D=r.getKeysForOverrideIdentifier(k),v=[...D.filter(C=>A.indexOf(C)===-1),...A.filter(C=>D.indexOf(C)===-1),...A.filter(C=>!S.$Ym(this.c.override(k).getValue(C),r.override(k).getValue(C)))];n.push([k,v])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:o}=g(this.d,r),k=[...i,...n,...o];return k.length&&this.updatePolicyConfiguration(r),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:o,overrides:k}=g(this.applicationConfiguration,r),A=[...i,...n,...o];return A.length&&this.updateApplicationConfiguration(r),{keys:A,overrides:k}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:k}=g(this.localUserConfiguration,r),A=[...i,...n,...o];return A.length&&this.updateLocalUserConfiguration(r),{keys:A,overrides:k}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:o,overrides:k}=g(this.remoteUserConfiguration,r),A=[...i,...n,...o];return A.length&&this.updateRemoteUserConfiguration(r),{keys:A,overrides:k}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:o,overrides:k}=g(this.workspaceConfiguration,r),A=[...i,...n,...o];return A.length&&this.updateWorkspaceConfiguration(r),{keys:A,overrides:k}}compareAndUpdateFolderConfiguration(r,i){const n=this.p.get(r),{added:o,updated:k,removed:A,overrides:D}=g(n,i),v=[...o,...k,...A];return(v.length||!n)&&this.updateFolderConfiguration(r,i),{keys:v,overrides:D}}compareAndDeleteFolderConfiguration(r){const i=this.p.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:o,removed:k,overrides:A}=g(i,void 0);return{keys:[...n,...o,...k],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,i,n){let o=this.r(i,n);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(o=o.merge(this.d)),o}r({resource:r},i){let n=this.s();if(i&&r){const o=i.getFolder(r);o&&(n=this.t(o.uri)||n);const k=this.m.get(r);k&&(n=n.merge(k))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let i=this.b.get(r);if(!i){const n=this.s(),o=this.j.get(r);o?(i=n.merge(o),this.b.set(r,i)):i=n}return i}u(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:o,keys:k}=this.j.get(i);return r.push([i,{contents:n,overrides:o,keys:k}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}w(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o))),[...i.values()]}static parse(r){const i=this.x(r.defaults),n=this.x(r.policy),o=this.x(r.application),k=this.x(r.user),A=this.x(r.workspace),D=r.folders.reduce((v,C)=>(v.set(l.URI.revive(C[0]),this.x(C[1])),v),new I.$yi);return new a(i,n,o,k,new y,A,D,new y,new I.$yi)}static x(r){return new y(r.contents,r.keys,r.overrides)}}e.$sn=a;function $(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const r=new Set,i=new Map;for(const o of u)o.keys.forEach(k=>r.add(k)),o.overrides.forEach(([k,A])=>{const D=(0,I.$vi)(i,k,new Set);A.forEach(v=>D.add(v))});const n=[];return i.forEach((o,k)=>n.push([k,[...o.values()]])),{keys:[...r.values()],overrides:n}}e.$tn=$;class E{constructor(r,i,n,o){this.change=r,this.f=i,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of r.keys)this.affectedKeys.add(k);for(const[,k]of r.overrides)for(const A of k)this.affectedKeys.add(A);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,o=this.d.indexOf(n);if(o<0)return!1;const k=o+n.length;if(k>=this.d.length)return!1;const A=this.d.charCodeAt(k);if(A!==this.b&&A!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,v=this.g.getValue(r,i,this.h);return!S.$Ym(D,v)}return!0}}e.$un=E;function g(u,r){const{added:i,removed:n,updated:o}=t(r?.rawConfiguration,u?.rawConfiguration),k=[],A=u?.getAllOverrideIdentifiers()||[],D=r?.getAllOverrideIdentifiers()||[];if(r){const v=D.filter(C=>!A.includes(C));for(const C of v)k.push([C,r.getKeysForOverrideIdentifier(C)])}if(u){const v=A.filter(C=>!D.includes(C));for(const C of v)k.push([C,u.getKeysForOverrideIdentifier(C)])}if(r&&u){for(const v of A)if(D.includes(v)){const C=t({contents:u.getOverrideValue(void 0,v)||{},keys:u.getKeysForOverrideIdentifier(v)},{contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)});k.push([v,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:n,updated:o,overrides:k}}function t(u,r){const i=u?r?u.keys.filter(k=>r.keys.indexOf(k)===-1):[...u.keys]:[],n=r?u?r.keys.filter(k=>u.keys.indexOf(k)===-1):[...r.keys]:[],o=[];if(u&&r){for(const k of r.keys)if(u.keys.indexOf(k)!==-1){const A=(0,b.$ci)(r.contents,k),D=(0,b.$ci)(u.contents,k);S.$Ym(A,D)||o.push(k)}}return{added:i,removed:n,updated:o}}}),define(te[236],ie([0,1,23,3,2,37,12,119,59,5,39,43]),function(K,e,P,O,s,M,I,S,h,l,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=void 0;class p extends s.$jc{constructor(){super(...arguments),this.a=this.B(new O.$ed),this.onDidChangeConfiguration=this.a.event,this.b=new S.$pn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.$7m.as(h.$_m.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:c})=>this.c(Array.from(d),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,c){this.h(d,w.$7m.as(h.$_m.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new S.$pn;const d=w.$7m.as(h.$_m.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,c){const a=this.f();for(const $ of d){const E=a[$],g=c[$];E!==void 0?this.b.addValue($,E):g?this.b.addValue($,g.default):this.b.removeValue($)}}}e.$vn=p;class f{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new S.$pn}async initialize(){return this.configurationModel}}e.$wn=f;let y=class extends s.$jc{get configurationModel(){return this.b}constructor(d,c,a){super(),this.c=d,this.f=c,this.g=a,this.a=this.B(new O.$ed),this.onDidChangeConfiguration=this.a.event,this.b=new S.$pn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const c={},a=[],$=w.$7m.as(h.$_m.Configuration).getConfigurationProperties();for(const E of d){const g=$[E];if(!g){a.push(E);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}a.push(E),c[g.policy.name]={type:g.type}}}return(0,I.$vf)(c)||await this.f.updatePolicyDefinitions(c),a}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const c=w.$7m.as(h.$_m.Configuration).getPolicyConfigurations(),a=(0,P.$Eb)(d.map($=>c.get($)));this.m(a,!0)}m(d,c){this.g.trace("PolicyConfiguration#update",d);const a=w.$7m.as(h.$_m.Configuration).getConfigurationProperties(),$=[],E=this.b.isEmpty();for(const g of d){const t=a[g]?.policy?.name;if(t){const u=this.f.getPolicyValue(t);(E?u!==void 0:!(0,M.$Ym)(this.b.getValue(g),u))&&$.push([g,u])}else this.b.getValue(g)!==void 0&&$.push([g,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const g=this.b;this.b=new S.$pn;for(const t of g.keys)this.b.setValue(t,g.getValue(t));for(const[t,u]of $)u===void 0?this.b.removeValue(t):this.b.setValue(t,u);c&&this.a.fire(this.b)}}};e.$xn=y,e.$xn=y=ke([_(1,b.$9m),_(2,l.$4i)],y)}),define(te[237],ie([0,1,8,3,2,19,18,119,236,39]),function(K,e,P,O,s,M,I,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=void 0;class b extends s.$jc{constructor(p,f,y,m){super(),this.j=p,this.h=this.B(new O.$ed),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$vn),this.c=y instanceof l.$$m?new h.$wn:this.B(new h.$xn(this.b,y,m)),this.f=this.B(new S.$rn(this.j,{},M.$$f,f)),this.a=new S.$sn(this.b.configurationModel,this.c.configurationModel,new S.$pn,new S.$pn),this.g=this.B(new P.$Rg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:c})=>this.n(d,c))),this.B(this.c.onDidChangeConfiguration(d=>this.r(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,f,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$sn(p,f,new S.$pn,y)}getConfigurationData(){return this.a.toData()}getValue(p,f){const y=typeof p=="string"?p:void 0,m=(0,I.$8h)(p)?p:(0,I.$8h)(f)?f:{};return this.a.getValue(y,m,void 0)}updateValue(p,f,y,m){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.m(p)}m(p){const f=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(p);this.s(y,f,2)}n(p,f){const y=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(p,f);this.s(m,y,7)}r(p){const f=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(p);this.s(y,f,7)}s(p,f,y){const m=new S.$un(p,{data:f},this.a);m.source=y,m.sourceConfig=this.t(y),this.h.fire(m)}t(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$yn=b}),define(te[238],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W6b=e.$V6b=e.$U6b=void 0,e.$U6b="request",e.$V6b="remoteResourceHandler";class P{async routeCall(s,M,I){if(M!==e.$U6b)throw new Error(`Call not found: ${M}`);const S=I[0];if(S?.authority){const h=s.connections.find(l=>l.ctx===S.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$W6b=P}),define(te[239],ie([0,1,14,6]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.RemoteAuthorityResolverErrorCode=e.$Kk=e.$Jk=e.RemoteConnectionType=e.$Ik=void 0,e.$Ik=(0,O.$Ah)("remoteAuthorityResolverService");var s;(function(b){b[b.WebSocket=0]="WebSocket",b[b.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.$Jk=M;class I{constructor(w,p){this.host=w,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Kk=I;var S;(function(b){b.Unknown="Unknown",b.NotAvailable="NotAvailable",b.TemporarilyNotAvailable="TemporarilyNotAvailable",b.NoResolverFound="NoResolverFound",b.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class h extends P.$_{static isNotAvailable(w){return w instanceof h&&w._code===S.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof h&&w._code===S.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof h&&w._code===S.NoResolverFound}static isInvalidAuthority(w){return w instanceof h&&w._code===S.InvalidAuthority}static isHandled(w){return w instanceof h&&w.isHandled}constructor(w,p=S.Unknown,f){super(w),this._message=w,this._code=p,this._detail=f,this.isHandled=p===S.NotAvailable&&f===!0,Object.setPrototypeOf(this,h.prototype)}}e.$Lk=h;function l(b){const w=b.indexOf("+");return w===-1?b:b.substring(0,w)}e.$Mk=l}),define(te[60],ie([0,1,13]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=void 0;function O(l){return l.scheme===P.Schemas.vscodeRemote?l.authority:void 0}e.$Nk=O;function s(l){if(!l)return;const b=l.indexOf("+");return b<0?l:l.substr(0,b)}e.$Ok=s;function M(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$Pk=M;function I(l){const{host:b,port:w}=h(l);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:w}}e.$Qk=I;function S(l,b){let{host:w,port:p}=h(l);return typeof p>"u"&&(p=b),{host:w,port:p}}e.$Rk=S;function h(l){const b=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const w=l.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const p=l.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:l,port:void 0}}}),define(te[120],ie([0,1,26,6,60]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.TargetPlatform=e.ExtensionType=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=void 0,e.$Ol="extensions.user.cache",e.$Pl="extensions.builtin.cache",e.$Ql="undefined_publisher",e.$Rl=["ui","workspace","web"];function M(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$Sl=M,e.$Tl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(I||(e.ExtensionType=I={}));var S;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class h{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,c){if(typeof d>"u"||d===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof d=="string"||typeof c=="string"){const a=typeof d=="string"?d:d.value,$=typeof c=="string"?c:c.value;return P.$Le(a,$)}return d._lower===c._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Ul=h;class l{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const c of d)this.add(c)}add(d){this.c.add(h.toKey(d))}delete(d){return this.c.delete(h.toKey(d))}has(d){return this.c.has(h.toKey(d))}}e.$Vl=l;class b{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(h.toKey(d))}get(d){return this.c.get(h.toKey(d))}has(d){return this.c.has(h.toKey(d))}set(d,c){this.c.set(h.toKey(d),c)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Wl=b;function w(m){return p(m)}e.$Xl=w;function p(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$Yl=p;function f(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$Zl=f;function y(m,d){if(d){const c=`onResolveRemoteAuthority:${(0,s.$Ok)(d)}`;return!!m.activationEvents?.includes(c)}return!1}e.$1l=y,e.$2l=(0,O.$Ah)("IBuiltinExtensionsScannerService")}),define(te[240],ie([0,1,8,17,22,14,3,2,65,69,31,109,239,60]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.PersistentConnectionEventType=e.$Yk=e.$Xk=e.$Wk=e.ConnectionType=void 0;const y=30*1e3;var m;(function(Y){Y[Y.Management=1]="Management",Y[Y.ExtensionHost=2]="ExtensionHost",Y[Y.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function d(Y){switch(Y){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function c(Y){const R=new s.$od;return setTimeout(()=>R.cancel(),Y),R.token}function a(Y,R){if(Y.isCancellationRequested||R.isCancellationRequested)return s.CancellationToken.Cancelled;const j=new s.$od;return Y.onCancellationRequested(()=>j.cancel()),R.onCancellationRequested(()=>j.cancel()),j.token}class ${get didTimeout(){return this.c==="timedout"}constructor(R){this.c="pending",this.d=new S.$ic,this.promise=new Promise((j,F)=>{this.f=j,this.g=F}),R.isCancellationRequested?this.h():this.d.add(R.onCancellationRequested(()=>this.h()))}registerDisposable(R){this.c==="pending"?this.d.add(R):R.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(R))}reject(R){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(R))}}function E(Y,R){const j=new $(R);return j.registerDisposable(Y.onControlMessage(F=>{const W=JSON.parse(F.toString()),q=U(W);q?j.reject(q):j.resolve(W)})),j.promise}function g(Y,R,j,F,W,q,V,re){const $e=new $(re),de=l.$ad.create(!1);return Y.info(`Creating a socket (${V})...`),h.mark(`code/willCreateSocket/${q}`),R.connect(j,F,W,V).then(ue=>{$e.didTimeout?(h.mark(`code/didCreateSocketError/${q}`),Y.info(`Creating a socket (${V}) finished after ${de.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(h.mark(`code/didCreateSocketOK/${q}`),Y.info(`Creating a socket (${V}) was successful after ${de.elapsed()} ms.`),$e.resolve(ue))},ue=>{h.mark(`code/didCreateSocketError/${q}`),Y.info(`Creating a socket (${V}) returned an error after ${de.elapsed()} ms.`),Y.error(ue),$e.reject(ue)}),$e.promise}function t(Y,R){const j=new $(R);return Y.then(F=>{j.didTimeout||j.resolve(F)},F=>{j.didTimeout||j.reject(F)}),j.promise}async function u(Y,R,j,F){const W=x(Y,R);Y.logService.trace(`${W} 1/6. invoking socketFactory.connect().`);let q;try{q=await g(Y.logService,Y.remoteSocketFactoryService,Y.connectTo,(0,f.$Pk)(Y),`reconnectionToken=${Y.reconnectionToken}&reconnection=${Y.reconnectionProtocol?"true":"false"}`,d(R),`renderer-${d(R)}-${Y.reconnectionToken}`,F)}catch(ue){throw Y.logService.error(`${W} socketFactory.connect() failed or timed out. Error:`),Y.logService.error(ue),ue}Y.logService.trace(`${W} 2/6. socketFactory.connect() was successful.`);let V,re;Y.reconnectionProtocol?(Y.reconnectionProtocol.beginAcceptReconnection(q,null),V=Y.reconnectionProtocol,re=!1):(V=new w.$oh({socket:q}),re=!0),Y.logService.trace(`${W} 3/6. sending AuthRequest control message.`);const $e=await t(Y.signService.createNewMessage((0,b.$3f)()),F),de={type:"auth",auth:Y.connectionToken||"00000000000000000000",data:$e.data};V.sendControl(O.$Ed.fromString(JSON.stringify(de)));try{const ue=await E(V,a(F,c(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(Y.logService.trace(`${W} 4/6. received SignRequest control message.`),!await t(Y.signService.validate($e,ue.signedData),F)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const me=await t(Y.signService.sign(ue.data),F),Se={type:"connectionType",commit:Y.commit,signedData:me,desiredConnectionType:R};return j&&(Se.args=j),Y.logService.trace(`${W} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(O.$Ed.fromString(JSON.stringify(Se))),{protocol:V,ownsProtocol:re}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(Y.logService.error(`${W} the handshake timed out. Error:`),Y.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(Y.logService.error(`${W} received error control message when negotiating connection. Error:`),Y.logService.error(ue)),re&&B(V),ue}}async function r(Y,R,j,F){const W=Date.now(),q=x(Y,R),{protocol:V,ownsProtocol:re}=await u(Y,R,j,F),$e=new $(F);return $e.registerDisposable(V.onControlMessage(de=>{const ue=JSON.parse(de.toString()),be=U(ue);be?(Y.logService.error(`${q} received error control message when negotiating connection. Error:`),Y.logService.error(be),re&&B(V),$e.reject(be)):(Y.reconnectionProtocol?.endAcceptReconnection(),Y.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ce(W)}!`),$e.resolve({protocol:V,firstMessage:ue}))})),$e.promise}async function i(Y,R){const{protocol:j}=await r(Y,1,void 0,R);return{protocol:j}}async function n(Y,R,j){const{protocol:F,firstMessage:W}=await r(Y,2,R,j),q=W&&W.debugPort;return{protocol:F,debugPort:q}}async function o(Y,R,j){const F=Date.now(),W=x(Y,3),{protocol:q}=await u(Y,3,R,j);return Y.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${ce(F)}!`),q}async function k(Y,R,j){const{connectTo:F,connectionToken:W}=await Y.addressProvider.getAddress();return{commit:Y.commit,quality:Y.quality,connectTo:F,connectionToken:W,reconnectionToken:R,reconnectionProtocol:j,remoteSocketFactoryService:Y.remoteSocketFactoryService,signService:Y.signService,logService:Y.logService}}async function A(Y,R,j){return v(Y,async F=>{const{protocol:W}=await i(F,s.CancellationToken.None);return new G(Y,R,j,F.reconnectionToken,W)})}e.$Wk=A;async function D(Y,R){return v(Y,async j=>{const{protocol:F,debugPort:W}=await n(j,R,s.CancellationToken.None);return new J(Y,R,j.reconnectionToken,F,W)})}e.$Xk=D;async function v(Y,R){for(let F=1;;F++)try{const W=(0,b.$3f)(),q=await k(Y,W,null);return await R(q)}catch(W){if(F<5)Y.logService.error(`[remote-connection][attempt ${F}] An error occurred in initial connection! Will retry... Error:`),Y.logService.error(W);else throw Y.logService.error(`[remote-connection][attempt ${F}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Y.logService.error(W),oe.triggerPermanentFailure(0,0,p.$Lk.isHandled(W)),W}}async function C(Y,R,j){const F=await k(Y,(0,b.$3f)(),null);return await o(F,{host:R,port:j},s.CancellationToken.None)}e.$Yk=C;function L(Y){return(0,P.$tg)(R=>new Promise((j,F)=>{const W=setTimeout(j,Y*1e3);R.onCancellationRequested(()=>{clearTimeout(W),j()})}))}var T;(function(Y){Y[Y.ConnectionLost=0]="ConnectionLost",Y[Y.ReconnectionWait=1]="ReconnectionWait",Y[Y.ReconnectionRunning=2]="ReconnectionRunning",Y[Y.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Y[Y.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class z{constructor(R,j){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.type=0}}e.$Zk=z;class se{constructor(R,j,F,W){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.durationSeconds=F,this.c=W,this.type=1}skipWait(){this.c.cancel()}}e.$1k=se;class ee{constructor(R,j,F){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.attempt=F,this.type=2}}e.$2k=ee;class ae{constructor(R,j,F){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.attempt=F,this.type=4}}e.$3k=ae;class ne{constructor(R,j,F,W){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.attempt=F,this.handled=W,this.type=3}}e.$4k=ne;class oe extends S.$jc{static triggerPermanentFailure(R,j,F){this._permanentFailure=!0,this.f=R,this.g=j,this.h=F,this.j.forEach(W=>W.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(R=>R.y())}static debugPauseSocketWriting(){this.j.forEach(R=>R.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||oe._permanentFailure}constructor(R,j,F,W,q){super(),this.t=R,this.u=j,this.reconnectionToken=F,this.protocol=W,this.w=q,this.m=this.B(new I.$ed),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(W.onSocketClose(V=>{const re=Q(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${re} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${re} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${re} received socket close event.`),this.y()})),this.B(W.onSocketTimeout(V=>{const re=Q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),oe.j.push(this),this.B((0,S.$hc)(()=>{const V=oe.j.indexOf(this);V>=0&&oe.j.splice(V,1)})),this.n&&this.D(oe.f,oe.g,oe.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const R=Q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const W=F<j.length?j[F]:j[j.length-1];try{if(W>0){const V=L(W);this.m.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W,V)),this.u.logService.info(`${R} waiting for ${W} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this.u.logService.info(`${R} resolving connection...`);const q=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${R} connecting to ${q.connectTo}...`),await this.G(q,c(y)),this.u.logService.info(`${R} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(q){if(q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this.u.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(p.$Lk.isTemporarilyNotAvailable(q)){this.u.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((q.code==="ETIMEDOUT"||q.code==="ENETUNREACH"||q.code==="ECONNREFUSED"||q.code==="ECONNRESET")&&q.syscall==="connect"){this.u.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if((0,M.$2)(q)){this.u.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(q);continue}if(q instanceof p.$Lk){this.u.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,p.$Lk.isHandled(q));break}this.u.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(q),this.C(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!this.n&&!this.s)}C(R,j,F){this.w?oe.triggerPermanentFailure(R,j,F):this.D(R,j,F)}D(R,j,F){this.m.fire(new ne(this.reconnectionToken,R,j,F)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5k=oe;class G extends oe{constructor(R,j,F,W,q){super(1,R,W,q,!0),this.client=this.B(new w.$mh(q,{remoteAuthority:j,clientId:F},R.ipcLogger))}async G(R,j){await i(R,j)}}e.$6k=G;class J extends oe{constructor(R,j,F,W,q){super(2,R,F,W,!1),this.H=j,this.debugPort=q}async G(R,j){await n(R,this.H,j)}}e.$7k=J;function B(Y){try{Y.acceptDisconnect();const R=Y.getSocket();Y.dispose(),R.dispose()}catch(R){(0,M.$Y)(R)}}function U(Y){if(Y&&Y.type==="error"){const R=new Error(`Connection error: ${Y.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function N(Y,R){for(;Y.length<R;)Y+=" ";return Y}function H(Y,R){return`[remote-connection][${N(d(Y),13)}][${R.substr(0,5)}\u2026]`}function Q(Y,R,j){return`${H(Y,R)}[${j?"reconnect":"initial"}]`}function x(Y,R){return`${Q(R,Y.reconnectionToken,!!Y.reconnectionProtocol)}[${Y.connectTo}]`}function ce(Y){return`${Date.now()-Y} ms`}}),define(te[241],ie([0,1,2,6]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=void 0,e.$Sk=(0,O.$Ah)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(I,S){return this.a[I]??=[],this.a[I].push(S),(0,P.$hc)(()=>{const h=this.a[I]?.indexOf(S);typeof h=="number"&&h>=0&&this.a[I]?.splice(h,1)})}b(I){return(this.a[I.type]||[]).find(h=>h.supports(I))}connect(I,S,h,l){const b=this.b(I);if(!b)throw new Error(`No socket factory found for ${I}`);return b.connect(I,S,h,l)}}e.$Tk=s}),define(te[242],ie([0,1,27,47,21,113]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=void 0;let I;async function S(f=!1){return(I===void 0||f)&&(I=h()),I}e.$V5b=S;async function h(){const f=l();if(f===void 0)return!1;if(f>=22e3){const y=w();if(y)return new Promise(m=>{O.execFile(y,["--status"],d=>m(!d))})}else{const y=p();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function l(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(f)return parseInt(f[3])}function b(f){const y=process.env.SystemRoot;if(y){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(y,m?"Sysnative":"System32",f)}}function w(){return b("wsl.exe")}function p(){return b("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,14,2,182,59,6,5,43]),function(K,e,P,O,s,M,I,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Ho=(0,S.$Ah)("requestService");class b{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?g[t]="*****":g[t]=this.b[t];this.a=g}return this.a}}class w extends s.$jc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,M.localize)(0,null),when:h.$ij.isEqualTo((0,h.$gj)(h.LogLevel.Trace)).serialize()})}async c(g,t,u){const r=`${g} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new b(t.headers??{}));try{const i=await u();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,O.$8)(i)),i}}}e.$Io=w;function p(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Jo=p;function f(E){return E.res.statusCode===204}e.$Ko=f;async function y(E){return f(E)?null:(await(0,P.$Qd)(E.stream)).toString()}e.$Lo=y;async function m(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);return y(E)}e.$Mo=m;async function d(E){if(!p(E))throw new Error("Server returned "+E.res.statusCode);if(f(E))return null;const t=(await(0,P.$Qd)(E.stream)).toString();try{return JSON.parse(t)}catch(u){throw u.message+=`:
`+t,u}}e.$No=d;function c(E){$(E)}e.$Oo=c;let a;function $(E){const g=l.$7m.as(I.$_m.Configuration),t=a;a={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0}}},g.updateConfigurations({add:[a],remove:t?[t]:[]})}$(1)}),define(te[243],ie([0,1,17,22]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=void 0;class s{constructor(S){this.a=S}listen(S,h){throw new Error("Invalid listen")}call(S,h,l,b=O.CancellationToken.None){switch(h){case"request":return this.a.request(l[0],b).then(async({res:w,stream:p})=>{const f=await(0,P.$Qd)(p);return[{statusCode:w.statusCode,headers:w.headers},f]});case"resolveProxy":return this.a.resolveProxy(l[0])}throw new Error("Invalid call")}}e.$Kq=s;class M{constructor(S){this.a=S}async request(S,h){const[l,b]=await this.a.call("request",[S],h);return{res:l,stream:(0,P.$Sd)(b)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$Lq=M}),define(te[244],ie([0,1,245,12]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;function s(I,S){return I.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:I.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(I,S,h={}){const l=(0,P.parse)(I),b=h.proxyUrl||s(l,S);if(!b)return null;const w=(0,P.parse)(b);if(!/^https?:$/.test(w.protocol||""))return null;const p={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,O.$of)(h.strictSSL)?h.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((f,y)=>{K(["http-proxy-agent"],f,y)}))(p):new(await new Promise((f,y)=>{K(["https-proxy-agent"],f,y)}))(p)}e.$Mq=M}),define(te[246],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=e.$g6b=e.$f6b=void 0,e.$f6b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$g6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$h6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(te[94],ie([0,1,47,9,183,22,50,14,4,31,108,63,8,139]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=void 0;let y;async function m(c,a,$,E){return $["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.$Fl)(E)&&!$["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.$Fl)(E)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=p.Promises.withAsyncBody(async(g,t)=>{const u=new M.$od;let r=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,f.$Gl)(i,1,120)*1e3);const n=setTimeout(()=>{u.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{g(await d(a,u.token))}catch(o){!(0,S.$2)(o)&&!u.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,I.$li)(o)))):g({})}finally{clearTimeout(n),u.dispose()}})),y)}e.$Ll=m;async function d(c,a){const $=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",$);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",E);const g=(0,l.$3f)().replace(/-/g,"").substr(0,12),t=new RegExp(g+"({.*})"+g),u={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",u);const r=await(0,b.$vl)(h.OS,u);return c.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(a.isCancellationRequested)return n(new S.$3);const o=(0,O.$_d)(r);let k,A;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(k=`& '${process.execPath}' ${D} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,A=["-Login","-Command"]):o==="nu"?(k=`^'${process.execPath}' ${D} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,A=["-i","-l","-c"]):(k=`'${process.execPath}' ${D} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?A=["-ic"]:A=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),k);const v=(0,P.spawn)(r,[...A,k],{detached:!0,stdio:["ignore","pipe","pipe"],env:u});a.onCancellationRequested(()=>(v.kill(),n(new S.$3))),v.on("error",T=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,I.$li)(T)),n(T)});const C=[];v.stdout.on("data",T=>C.push(T));const L=[];v.stderr.on("data",T=>L.push(T)),v.on("close",(T,z)=>{const se=Buffer.concat(C).toString("utf8");c.trace("getUnixShellEnvironment#raw",se);const ee=Buffer.concat(L).toString("utf8");if(ee.trim()&&c.trace("getUnixShellEnvironment#stderr",ee),T||z)return n(new Error((0,s.localize)(2,null,T,z)));const ae=t.exec(se),ne=ae?ae[1]:"{}";try{const oe=JSON.parse(ne);$?oe.ELECTRON_RUN_AS_NODE=$:delete oe.ELECTRON_RUN_AS_NODE,E?oe.ELECTRON_NO_ATTACH_CONSOLE=E:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",oe),i(oe)}catch(oe){c.error("getUnixShellEnvironment#errorCaught",(0,I.$li)(oe)),n(oe)}})})}}),define(te[247],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h2b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const I=String(P.a++);return this.b.set(I,M),{id:I,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const I=this.b.get(s.id);if(!I)return!1;this.b.delete(s.id);try{return I.validate(M)==="ok"}catch{return!1}finally{I.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$h2b=P}),define(te[95],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=void 0,e.$Uk="signService",e.$Vk=(0,P.$Ah)(e.$Uk)}),define(te[248],ie([0,1,247]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=void 0;class O extends P.$h2b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(I=>new I.signer().sign(M))}h(){return new Promise((M,I)=>K(["vsda"],M,I))}}e.$66b=O}),define(te[34],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=e.$_M=void 0,e.$_M=(0,P.$Ah)("stateReadService"),e.$aN=(0,P.$Ah)("stateService")}),define(te[121],ie([0,1,8,17,2,12,36,16,5]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.$cN=e.$bN=e.SaveStrategy=void 0;var l;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class b extends s.$jc{constructor(y,m,d,c){super(),this.h=y,this.j=d,this.m=c,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=m===0?void 0:this.B(new P.$Dg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.j.error(y)}}getItem(y,m){const d=this.a[y];return(0,M.$rf)(d)?m:d}setItem(y,m){this.setItems([{key:y,data:m}])}setItems(y){let m=!1;for(const{key:d,data:c}of y)this.a[d]!==c&&((0,M.$rf)(c)?(0,M.$pf)(this.a[d])||(this.a[d]=void 0,m=!0):(this.a[d]=c,m=!0));m&&this.r()}removeItem(y){(0,M.$pf)(this.a[y])||(this.a[y]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.m.writeFile(this.h,O.$Ed.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(m){this.j.error(m)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$bN=b;let w=class extends s.$jc{constructor(y,m,d,c){super(),this.a=this.B(new b(m.stateResource,y,d,c))}async init(){await this.a.init()}getItem(y,m){return this.a.getItem(y,m)}};e.$cN=w,e.$cN=w=ke([_(1,I.$Hh),_(2,h.$4i),_(3,S.$5j)],w);class p extends w{setItem(y,m){this.a.setItem(y,m)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$dN=p}),define(te[122],ie([0,1,4,35,31]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=void 0;function M(h){if(P.$t===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function I(h,l,b,w,p,f,y,m){const d=Object.create(null);d["common.machineId"]=f,d.sessionID=(0,s.$3f)()+Date.now(),d.commitHash=w,d.version=p,d["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,P.$h)(P.$t),d["common.nodePlatform"]=O.$2d,d["common.nodeArch"]=b,d["common.product"]=m||"desktop",y&&(d["common.msftInternal"]=y);let c=0;const a=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),P.$l&&(d["common.snap"]="true");const $=M(l);return $&&(d["common.platformDetail"]=$),d}e.$9n=I;function S(h){const l=O.env.USERDNSDOMAIN;if(!l)return!1;const b=l.toLowerCase();return h.some(w=>b===w)}e.$0n=S}),define(te[25],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0,e.$8k=(0,P.$Ah)("telemetryService"),e.$9k=(0,P.$Ah)("customEndpointTelemetryService"),e.$0k="telemetry.currentSessionDate",e.$$k="telemetry.firstSessionDate",e.$_k="telemetry.lastSessionDate",e.$al="telemetry.machineId",e.$bl="telemetry",e.$cl="telemetry.telemetryLevel",e.$dl="telemetry.enableCrashReporter",e.$el="telemetry.enableTelemetry";var O;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[249],ie([0,1,27,8,44,13,9,4,7,86,21,107,90,16,24,25]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=void 0;const d=new Map;async function c(t,u){const r=`${t}::${u.join(":")}`,i=d.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,k=new Map,A=2e4;function D(C,L,T,z){const se=L.substring(C.length+1);return O.Promises.withAsyncBody(async ee=>{let ae;try{ae=await b.Promises.readdir(L,{withFileTypes:!0})}catch{ee();return}if(z.count>=A){z.count+=ae.length,z.maxReached=!0,ee();return}let ne=ae.length;if(ne===0){ee();return}let oe=ae;z.count+ae.length>A&&(z.maxReached=!0,ne=A-z.count,oe=ae.slice(0,ne)),z.count+=ae.length;for(const G of oe)if(G.isDirectory()){if(T.includes(G.name)||await D(C,(0,I.$8d)(L,G.name),T,z),--ne===0){ee();return}}else{const J=G.name.lastIndexOf(".");if(J>=0){const B=G.name.substring(J+1);B&&o.set(B,(o.get(B)??0)+1)}for(const B of n)B.relativePathPattern?.test(se)!==!1&&B.filePattern.test(G.name)&&k.set(B.tag,(k.get(B.tag)??0)+1);if(--ne===0){ee();return}}})}const v=O.Promises.withAsyncBody(async C=>{const L={count:0,maxReached:!1};await D(t,t,u,L);const T=await E(t);C({configFiles:a(k),fileTypes:a(o),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:T})});return d.set(r,v),v}e.$sr=c;function a(t){return Array.from(t.entries(),([u,r])=>({name:u,count:r})).sort((u,r)=>r.count-u.count)}function $(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/f.$zk.GB).toFixed(2)}GB (${(P.freemem()/f.$zk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$Gm.value()*100)}%`},u=P.cpus();return u&&u.length>0&&(t.cpus=`${u[0].model} (${u.length} x ${u[0].speed})`),t}e.$tr=$;async function E(t){try{const u=new Map,r=(0,I.$8d)(t,".vscode","launch.json"),i=await b.Promises.readFile(r),n=[],o=(0,s.$Km)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$Tm)(o)==="object"&&o.configurations)for(const k of o.configurations){const A=k.type;A&&(u.has(A)?u.set(A,u.get(A)+1):u.set(A,1))}return a(u)}catch{return[]}}e.$ur=E;let g=class{constructor(u,r){this.c=u,this.d=r}f(u){const r=[];return r.push(`OS Version:       ${u.os}`),r.push(`CPUs:             ${u.cpus}`),r.push(`Memory (System):  ${u.memory}`),r.push(`VM:               ${u.vmHint}`),r.join(`
`)}g(u){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const i=P.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/f.$zk.GB).toFixed(2)}GB (${(P.freemem()/f.$zk.GB).toFixed(2)}GB free)`),S.$i||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(l.$Gm.value()*100)}%`),r.push(`Screen Reader:    ${u.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${u.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(u.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(u,r){return Promise.all([(0,w.$rr)(u.mainPID),this.k(u)]).then(async i=>{let[n,o]=i,k=this.m(u,n);return r.forEach(A=>{if((0,p.$gm)(A))k+=`
${A.errorMessage}`,o+=`
${A.errorMessage}`;else if(k+=`

Remote: ${A.hostName}`,A.processes&&(k+=`
${this.m(u,A.processes)}`),A.workspaceMetadata){o+=`
|  Remote: ${A.hostName}`;for(const D of Object.keys(A.workspaceMetadata)){const v=A.workspaceMetadata[D];let C=`${v.fileCount} files`;v.maxFilesReached&&(C=`more than ${C}`),o+=`|    Folder (${D}): ${C}`,o+=this.h(v)}}}),{processInfo:k,workspaceInfo:o}})}async getSystemInfo(u,r){const{memory:i,vmHint:n,os:o,cpus:k}=$(),A={os:o,memory:i,cpus:k,vmHint:n,processArgs:`${u.mainArguments.join(" ")}`,gpuStatus:u.gpuFeatureStatus,screenReader:`${u.screenReader?"yes":"no"}`,remoteData:r};return S.$i||(A.load=`${P.loadavg().map(D=>Math.round(D)).join(", ")}`),S.$k&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(u,r){const i=[];return(0,w.$rr)(u.mainPID).then(async n=>(i.push(""),i.push(this.g(u)),i.push(""),i.push(this.m(u,n)),u.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(u))),r.forEach(o=>{if((0,p.$gm)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(u,o.processes)),o.workspaceMetadata)for(const k of Object.keys(o.workspaceMetadata)){const A=o.workspaceMetadata[k];let D=`${A.fileCount} files`;A.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${k}): ${D}`),i.push(this.h(A))}}),i.push(""),i.push(""),i.join(`
`)))}h(u){const r=[];let n=0;const o=(v,C)=>{const L=` ${v}(${C})`;n+L.length>60?(r.push(k),k="|                 ",n=k.length):n+=L.length,k+=L};let k="|      File types:";const A=10,D=u.fileTypes.length>A?A:u.fileTypes.length;for(let v=0;v<D;v++){const C=u.fileTypes[v];o(C.name,C.count)}if(r.push(k),u.configFiles.length>=0&&(k="|      Conf files:",n=0,u.configFiles.forEach(v=>{o(v.name,v.count)}),r.push(k)),u.launchConfigFiles.length>0){let v="|      Launch Configs:";u.launchConfigFiles.forEach(C=>{const L=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;v+=L}),r.push(v)}return r.join(`
`)}j(u){const r=Math.max(...Object.keys(u).map(i=>i.length));return Object.keys(u).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${u[i]}`).join(`
                  `)}k(u){const r=[],i=[];return u.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(o=>{const k=h.URI.revive(o);if(k.scheme===M.Schemas.file){const A=k.fsPath;i.push(c(A,["node_modules",".git"]).then(D=>{let v=`${D.fileCount} files`;D.maxFilesReached&&(v=`more than ${v}`),r.push(`|    Folder (${(0,I.$_d)(A)}): ${v}`),r.push(this.h(D))}).catch(D=>{r.push(`|      Error: Unable to collect workspace stats for folder ${A} (${D.toString()})`)}))}else r.push(`|    Folder (${k.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(u,r){const i=new Map;u.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),u.pidToNames.forEach(({pid:o,name:k})=>i.set(o,k));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(u.mainPID,i,n,r,0),n.join(`
`)}n(u,r,i,n,o){const k=o===0;let A;k?A=n.pid===u?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?A=r.get(n.pid):A=`${"  ".repeat(o)} ${n.name}`;const D=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(D/f.$zk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(n.children)&&n.children.forEach(v=>this.n(u,r,i,v,o+1))}async getWorkspaceFileExtensions(u){const r=new Set;for(const{uri:i}of u.folders){const n=h.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const o=n.fsPath;try{(await c(o,["node_modules",".git"])).fileTypes.forEach(A=>r.add(A.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(u){for(const{uri:r}of u.folders){const i=h.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const o=await c(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":u.telemetryId,rendererSessionId:u.rendererSessionId}),o.fileTypes.forEach(k=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:u.rendererSessionId,type:k.name,count:k.count})}),o.launchConfigFiles.forEach(k=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:u.rendererSessionId,type:k.name,count:k.count})}),o.configFiles.forEach(k=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:u.rendererSessionId,type:k.name,count:k.count})})}catch{}}}};e.$vr=g,e.$vr=g=ke([_(0,m.$8k),_(1,y.$jj)],g)}),define(te[250],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=e.$k6b=void 0;class P{constructor(M){this.b=M}listen(M,I){throw new Error(`Event not found: ${I}`)}call(M,I,{eventName:S,data:h}){return this.b.forEach(l=>l.log(S,h)),Promise.resolve(null)}}e.$k6b=P;class O{constructor(M){this.b=M}log(M,I){return this.b.call("log",{eventName:M,data:I}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$l6b=O}),define(te[52],ie([0,1,37,12,3,18,60,122,25]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$$n=l;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$_n=b,e.$ao=new b;class w{async publicLog(n,o,k){}async publicLogError(n,o,k){}}e.$bo=w,e.$co="telemetry",e.$do="extensionTelemetryLog",e.$eo={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(k,A)=>{const D=k?new Set([...k.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:D}},1e3,!0)(k=>{k.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$0h)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$fo=p;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.$go=f;function y(i,n){return!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$ho=y;function m(i){const n=i.getValue(h.$cl),o=i.getValue(h.$dl);if(i.getValue(h.$el)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$io=m;function d(i){const n={},o={},k={};$(i,k);for(let A in k){A=A.length>150?A.substr(A.length-149):A;const D=k[A];typeof D=="number"?o[A]=D:typeof D=="boolean"?o[A]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${D.length}`),n[A]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(n[A]=D)}return{properties:n,measurements:o}}e.$jo=d;const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(i){if(!i)return"none";const n=(0,I.$Ok)(i);return c.has(n)?n:"other"}e.$ko=a;function $(i,n,o=0,k){if(i)for(const A of Object.getOwnPropertyNames(i)){const D=i[A],v=k?k+A:A;Array.isArray(D)?n[v]=(0,P.$Zm)(D):D instanceof Date?n[v]=D.toISOString():(0,O.$kf)(D)?o<2?$(D,n,o+1,v+"."):n[v]=(0,P.$Zm)(D):n[v]=D}}function E(i,n){const o=i.msftInternalDomains||[],k=n.getValue("telemetry.internalTesting");return(0,S.$0n)(o)||k}e.$lo=E;function g(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$mo=g;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const k=[];for(const C of n)for(;;){const L=C.exec(i);if(!L)break;k.push([L.index,C.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(o="";;){const C=D.exec(i);if(!C)break;const L=k.some(([T,z])=>C.index<z&&T<D.lastIndex);!A.test(C[0])&&!L&&(o+=i.substring(v,C.index)+"<REDACTED: user-file-path>",v=D.lastIndex)}return v<i.length&&(o+=i.substr(v)),o}function u(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function r(i,n){return(0,P.$Wm)(i,o=>{if(o instanceof l||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let k=o.replaceAll("%20"," ");k=t(k,n);for(const A of n)k=k.replace(A,"");return k=u(k),k}})}e.$no=r}),define(te[123],ie([0,1,26,116,120,4,7,14,35,52]),function(K,e,P,O,s,M,I,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;function b(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$Ge)(r.id,i.id)===0}e.$oo=b;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,n,o)}static parse(i){const n=w.exec(i);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?b(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$po=p;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=f.exec(r);return i&&i[1]?[d(i[1]),i[2]]:[d(r),void 0]}e.$qo=y;function m(r,i){return`${r}.${i}`}e.$ro=m;function d(r){return r.toLowerCase()}e.$so=d;function c(r,i){return d(m(r??s.$Ql,i))}e.$to=c;function a(r,i){const n=[],o=k=>{for(const A of n)if(A.some(D=>b(i(D),i(k))))return A;return null};for(const k of r){const A=o(k);A?A.push(k):n.push([k])}return n}e.$uo=a;function $(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$vo=$;function E(r){return{id:new l.$$n(r.identifier.id),name:new l.$$n(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$wo=E,e.$xo=new s.$Ul("pprice.better-merge");function g(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const k=o.shift();if(k&&n.every(A=>!b(A.identifier,{id:k}))){const A=r.filter(D=>b(D.identifier,{id:k}));A.length===1&&(n.push(A[0]),o.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$yo=g;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){i.debug("Error while getting the os-release file.",(0,S.$8)(k))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u(r,i){const n=await t(r,i),o=(0,O.$Tn)(n?"alpine":M.$t,h.$3d);return i.debug("ComputeTargetPlatform:",o),o}e.$zo=u}),define(te[251],ie([0,1,205,52]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;async function s(M,I,S,h,l,b,w){const p={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${I.nameShort})`};if((0,O.$go)(I,S)&&(0,O.$io)(h)===3){const f=await(0,P.$1o)(S,l,b);p["X-Market-User-Id"]=f,p["VSCode-SessionId"]=w.machineId||f}return p}e.$2o=s}),define(te[252],ie([0,1,2,37,4,26,184,18,59,77,24,43,25,52]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,a,$){this.k=a,this.l=$,this.d={},this.i=new P.$ic,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.$pe)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$pe)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(p.$cl)||E.affectsConfiguration(p.$el)||E.affectsConfiguration(p.$dl))&&this.m()}))}setExperimentProperty(c,a){this.d[c]=a}m(){let c=(0,f.$io)(this.k);const a=this.l.enabledTelemetryLevels;if(a){this.h=this.sendErrorTelemetry?a.error:!1;const $=a.usage?3:a.error?2:0;c=Math.min(c,$)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,a,$){this.g<a||($=(0,O.$Xm)($,this.d),$=(0,f.$no)($,this.j),$=(0,O.$Xm)($,this.c),this.b.forEach(E=>E.log(c,$)))}publicLog(c,a){this.n(c,3,a)}publicLog2(c,a){this.publicLog(c,a)}publicLogError(c,a){this.h&&this.n(c,2,a)}publicLogError2(c,a){this.publicLogError(c,a)}};e.$Pq=y,e.$Pq=y=ke([_(1,S.$7h),_(2,b.$jj)],y);function m(){const d=(0,I.localize)(0,null,l.default.nameLong),c=l.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),a=s.$o?"":(0,I.localize)(3,null),$=(0,I.localize)(4,null),E=(0,I.localize)(5,null),g=(0,I.localize)(6,null),t=(0,I.localize)(7,null),u=`
|       | ${$} | ${E} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,I.localize)(8,null);return`
${d} ${c} ${a}

&nbsp;

${t}
${u}

&nbsp;

${r}
`}w.$7m.as(h.$_m.Configuration).registerConfiguration({id:p.$bl,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[p.$cl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.$7m.as(h.$_m.Configuration).registerConfiguration({id:p.$bl,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[p.$el]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,I.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,I.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${p.$cl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[253],ie([0,1,4,86,25]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=void 0;async function M(I,S){let h=I.getItem(s.$al);return(typeof h!="string"||P.$j&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,O.$Hm)(S.error.bind(S))),h}e.$N6b=M}),define(te[254],ie([0,1,25,253]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=void 0;async function s(M,I){const S=await(0,O.$N6b)(M,I);return M.setItem(P.$al,S),S}e.$O6b=s}),define(te[124],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(te[255],ie([0,1,4,124]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;const s=new Map([[O.EnvironmentVariableMutatorType.Append,"APPEND"],[O.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[O.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(b){this.collections=b,this.a=new Map,this.b=new Map,b.forEach((w,p)=>{this.d(w,p);const f=w.map.entries();let y=f.next();for(;!y.done;){const m=y.value[1],d=y.value[0];let c=this.a.get(d);if(c||(c=[],this.a.set(d,c)),c.length>0&&c[0].type===O.EnvironmentVariableMutatorType.Replace){y=f.next();continue}const a={extensionIdentifier:p,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};a.scope||delete a.scope,c.unshift(a),y=f.next()}})}async applyToProcessEnvironment(b,w,p){let f;P.$i&&(f={},Object.keys(b).forEach(y=>f[y.toLowerCase()]=y));for(const[y,m]of this.getVariableMap(w)){const d=P.$i&&f[y.toLowerCase()]||y;for(const c of m){const a=p?await p(c.value):c.value;if(c.options?.applyAtProcessCreation??!0)switch(c.type){case O.EnvironmentVariableMutatorType.Append:b[d]=(b[d]||"")+a;break;case O.EnvironmentVariableMutatorType.Prepend:b[d]=a+(b[d]||"");break;case O.EnvironmentVariableMutatorType.Replace:b[d]=a;break}if(c.options?.applyAtShellIntegration??!1){const $=`VSCODE_ENV_${s.get(c.type)}`;b[$]=(b[$]?b[$]+":":"")+y+"="+this.c(a)}}}}c(b){return b.replaceAll(":","\\x3a")}diff(b,w){const p=new Map,f=new Map,y=new Map;if(b.getVariableMap(w).forEach((m,d)=>{const c=this.getVariableMap(w).get(d),a=S(m,c);a&&p.set(d,a)}),this.getVariableMap(w).forEach((m,d)=>{const c=b.getVariableMap(w).get(d),a=S(m,c);a&&y.set(d,a)}),this.getVariableMap(w).forEach((m,d)=>{const c=b.getVariableMap(w).get(d),a=h(m,c);a&&f.set(d,a)}),!(p.size===0&&f.size===0&&y.size===0))return{added:p,changed:f,removed:y}}getVariableMap(b){const w=new Map;for(const p of this.a.values()){const f=p.filter(y=>I(y,b));f.length>0&&w.set(f[0].variable,f)}return w}getDescriptionMap(b){const w=new Map;for(const p of this.b.values()){const f=p.filter(y=>I(y,b,!0));for(const y of f)w.set(y.extensionIdentifier,y.description)}return w}d(b,w){if(!b.descriptionMap)return;const p=b.descriptionMap.entries();let f=p.next();for(;!f.done;){const y=f.value[1],m=f.value[0];let d=this.b.get(m);d||(d=[],this.b.set(m,d));const c={extensionIdentifier:w,scope:y.scope,description:y.description};c.scope||delete c.scope,d.push(c),f=p.next()}}}e.$fr=M;function I(l,b,w=!1){return l.scope?!!(l.scope.workspaceFolder&&b?.workspaceFolder&&l.scope.workspaceFolder.index===b.workspaceFolder.index):w?b===l.scope:!0}function S(l,b){if(!b)return l;const w=new Set;b.forEach(f=>w.add(f.extensionIdentifier));const p=[];return l.forEach(f=>{w.has(f.extensionIdentifier)||p.push(f)}),p.length===0?void 0:p}function h(l,b){if(!b)return;const w=new Map;b.forEach(f=>w.set(f.extensionIdentifier,f));const p=[];return l.forEach(f=>{const y=w.get(f.extensionIdentifier);y&&(f.type!==y.type||f.value!==y.value||f.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&p.push(y)}),p.length===0?void 0:p}}),define(te[256],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.$cr=e.$br=e.$ar=e.$_q=void 0;function P(h){return[...h.entries()]}e.$_q=P;function O(h){return h?[...h.entries()]:[]}e.$ar=O;function s(h){return new Map(h)}e.$br=s;function M(h){return new Map(h??[])}e.$cr=M;function I(h){return Array.from(h.entries()).map(l=>[l[0],P(l[1].map),O(l[1].descriptionMap)])}e.$dr=I;function S(h){return new Map(h.map(l=>[l[0],{map:s(l[1]),descriptionMap:M(l[2])}]))}e.$er=S}),define(te[257],ie([0,1,8,22,3,2,5]),function(K,e,P,O,s,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;let S=class extends M.$jc{constructor(l,b){super(),this.h=b,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$ed),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,M.$hc)(()=>{for(const w of this.f.values())(0,M.$ec)(w)}))}createRequest(l){return new Promise((b,w)=>{const p=++this.a;this.c.set(p,b),this.g.fire({requestId:p,...l});const f=new O.$od;(0,P.$Gg)(this.b,f.token).then(()=>w(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,M.$hc)(()=>f.cancel())])})}acceptReply(l,b){const w=this.c.get(l);w?(this.c.delete(l),(0,M.$ec)(this.f.get(l)||[]),this.f.delete(l),w(b)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$3q=S,e.$3q=S=ke([_(1,I.$4i)],S)}),define(te[125],ie([0,1,6,114,43]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Vq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Uq=void 0,e.$Uq=new O.$1i("terminalTabFocusMode",!1,!0);var M;(function(g){g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var I;(function(g){g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationProfileLinux="terminal.integrated.automationProfile.linux",g.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",g.AutomationProfileWindows="terminal.integrated.automationProfile.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsDefaultColor="terminal.integrated.tabs.defaultColor",g.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.TabStopWidth="terminal.integrated.tabStopWidth",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorStyleInactive="terminal.integrated.cursorStyleInactive",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.TerminalTitleSeparator="terminal.integrated.tabs.separator",g.TerminalTitle="terminal.integrated.tabs.title",g.TerminalDescription="terminal.integrated.tabs.description",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.ConfirmOnKill="terminal.integrated.confirmOnKill",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.TabFocusMode="terminal.integrated.tabFocusMode",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoEnabled="terminal.integrated.localEchoEnabled",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",g.HideOnStartup="terminal.integrated.hideOnStartup",g.CustomGlyphs="terminal.integrated.customGlyphs",g.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover",g.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",g.AutoReplies="terminal.integrated.autoReplies",g.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",g.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",g.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",g.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",g.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",g.EnableImages="terminal.integrated.enableImages",g.SmoothScrolling="terminal.integrated.smoothScrolling",g.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",g.FocusAfterRun="terminal.integrated.focusAfterRun",g.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",g.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",g.DevMode="terminal.integrated.developer.devMode"})(I||(e.TerminalSettingId=I={}));var S;(function(g){g.PowerShell="pwsh",g.Bash="bash",g.Fish="fish",g.Sh="sh",g.Csh="csh",g.Ksh="ksh",g.Zsh="zsh"})(S||(e.PosixShellType=S={}));var h;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(h||(e.WindowsShellType=h={}));var l;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence",g[g.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var b;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.PtyHostWindow="ptyHostWindow",g.Logger="logger",g.Heartbeat="heartbeat"})(b||(e.TerminalIpcChannels=b={}));var w;(function(g){g.Cwd="cwd",g.InitialCwd="initialCwd",g.FixedDimensions="fixedDimensions",g.Title="title",g.ShellType="shellType",g.HasChildProcesses="hasChildProcesses",g.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",g.OverrideDimensions="overrideDimensions",g.FailedShellIntegrationActivation="failedShellIntegrationActivation",g.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.$Vq=(0,P.$Ah)("ptyService");var p;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var f;(function(g){g[g.Panel=1]="Panel",g[g.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var y;(function(g){g.TerminalView="view",g.Editor="editor"})(y||(e.TerminalLocationString=y={}));var m;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var d;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var c;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var a;(function(g){g[g.Off=0]="Off",g[g.FinalTerm=1]="FinalTerm",g[g.VSCode=2]="VSCode"})(a||(e.ShellIntegrationStatus=a={}));var $;(function(g){g[g.Unknown=0]="Unknown",g[g.Shutdown=1]="Shutdown",g[g.Process=2]="Process",g[g.User=3]="User",g[g.Extension=4]="Extension"})($||(e.TerminalExitReason=$={})),e.$Wq={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const u=this.b(t.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$7m.add(e.$Wq.Backend,new E),e.$Xq=(0,P.$Ah)("localPtyService"),e.$Yq=(0,P.$Ah)("terminalLogService")}),define(te[258],ie([0,1,71,7,186,102]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=e.$4q=void 0;function I(p,f){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...p.map(m=>({name:m.profileName,description:S(m)}))),f&&y.push(...f.map(m=>({name:m.title,description:h(m)}))),{values:y.map(m=>m.name),markdownDescriptions:y.map(m=>m.description)}}e.$4q=I;function S(p){let f=`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:P.$Oj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?f+=`
- args: "${p.args}"`:f+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(f+=`
- overrideName: ${p.overrideName}`),p.color&&(f+=`
- color: ${p.color}`),p.env&&(f+=`
- env: ${JSON.stringify(p.env)}`),f}function h(p){return`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:P.$Oj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function l(p,f){if(!p&&!f)return!0;if(typeof p=="string"&&typeof f=="string")return p===f;if(Array.isArray(p)&&Array.isArray(f)){if(p.length!==f.length)return!1;for(let y=0;y<p.length;y++)if(p[y]!==f[y])return!1;return!0}return!1}e.$5q=l;function b(p,f){if(!p&&!f)return!0;if(!p||!f)return!1;if(M.ThemeIcon.isThemeIcon(p)&&M.ThemeIcon.isThemeIcon(f))return p.id===f.id&&p.color===f.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof f=="object"&&"light"in f&&"dark"in f){const y=p,m=f;if((O.URI.isUri(y.light)||w(y.light))&&(O.URI.isUri(y.dark)||w(y.dark))&&(O.URI.isUri(m.light)||w(m.light))&&(O.URI.isUri(m.dark)||w(m.dark)))return y.light.path===m.light.path&&y.dark.path===m.dark.path}if(O.URI.isUri(p)&&O.URI.isUri(f)||w(p)||w(f)){const y=p,m=f;return y.path===m.path&&y.scheme===m.scheme}return!1}e.$6q=b;function w(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$7q=w}),define(te[259],ie([0,1,71,4,185,59,43,258]),function(K,e,P,O,s,M,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.$9q=e.$8q=void 0,e.$8q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$9q={type:"string",enum:Array.from((0,P.$Nj)(),d=>d.id),markdownEnumDescriptions:Array.from((0,P.$Nj)(),d=>`$(${d.id})`)};const h={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$9q},color:{description:(0,s.localize)(3,null),...e.$8q},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},b={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function w(d){const c=d===2?"linux":d===1?"osx":"windows";return(0,s.localize)(7,null,(0,O.$h)(d),'```json\n"terminal.integrated.profile.'+c+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:w(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:w(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:w(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...h}},{type:"null"},l]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){I.$7m.as(M.$_m.Configuration).registerConfiguration(p),m()}e.$0q=f;let y;function m(d,c){const a=I.$7m.as(M.$_m.Configuration);let $;d&&($=(0,S.$4q)(d?.profiles,c));const E=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:d?.os===3?$?.values:void 0,markdownEnumDescriptions:d?.os===3?$?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:d?.os===2?$?.values:void 0,markdownEnumDescriptions:d?.os===2?$?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:d?.os===1?$?.values:void 0,markdownEnumDescriptions:d?.os===1?$?.markdownDescriptions:void 0}}},a.updateConfigurations({add:[y],remove:E?[E]:[]})}e.$$q=m}),define(te[260],ie([0,1,27,13,37,9,4,35,26,12,21,124,256,255]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=e.$gr=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$gr=y;async function m(i,n,o,k=S.env,A=b.Promises.exists){if(M.$7d(i))return await A(i)?i:void 0;if(n===void 0&&(n=S.cwd()),M.$$d(i)!=="."){const L=M.$8d(n,i);return await A(L)?L:void 0}const v=(0,s.$2m)(k,"PATH");if(o===void 0&&(0,l.$if)(v)&&(o=v.split(M.$fe)),o===void 0||o.length===0){const L=M.$8d(n,i);return await A(L)?L:void 0}for(const L of o){let T;if(M.$7d(L)?T=M.$8d(L,i):T=M.$8d(n,L,i),await A(T))return T;if(I.$i){let z=T+".com";if(await A(z)||(z=T+".exe",await A(z)))return z}}const C=M.$8d(n,i);return await A(C)?C:void 0}e.$hr=m;function d(i,n,o,k,A){const D=I.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||D)return;const v=i.args,C=S.$2d==="win32"?M.$_d(i.executable).toLowerCase():M.$_d(i.executable),L=M.$$d(O.$1f.asFileUri("").fsPath);let T;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),I.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!v||u(v)?T=$.get(a.WindowsPwsh):t(v)&&(T=$.get(a.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,h.$me)(T[T.length-1],L,""),{newArgs:T,envMixin:z}):void 0;k.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(C){case"bash":return!v||v.length===0?T=$.get(a.Bash):r(v)&&(z.VSCODE_SHELL_LOGIN="1",c(n,z),T=$.get(a.Bash)),T?(T=[...T],T[T.length-1]=(0,h.$me)(T[T.length-1],L),{newArgs:T,envMixin:z}):void 0;case"fish":{const se=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=M.$8d(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${se}:${ee}`,c(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!v||u(v)?T=$.get(a.Pwsh):t(v)&&(T=$.get(a.PwshLogin)),T?(T=[...T],T[T.length-1]=(0,h.$me)(T[T.length-1],L,""),{newArgs:T,envMixin:z}):void 0;case"zsh":{if(!v||v.length===0?T=$.get(a.Zsh):r(v)?(T=$.get(a.ZshLogin),c(n,z)):(v===$.get(a.Zsh)||v===$.get(a.ZshLogin))&&(T=v),!T)return;T=[...T],T[T.length-1]=(0,h.$me)(T[T.length-1],L);let se;try{se=P.userInfo().username}catch{se="unknown"}const ee=M.$8d(P.tmpdir(),`${se}-${A.applicationName}-zsh`);z.ZDOTDIR=ee;const ae=o?.ZDOTDIR??P.homedir()??"~";z.USER_ZDOTDIR=ae;const ne=[];return ne.push({source:M.$8d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$8d(ee,".zshrc")}),ne.push({source:M.$8d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$8d(ee,".zprofile")}),ne.push({source:M.$8d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$8d(ee,".zshenv")}),ne.push({source:M.$8d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$8d(ee,".zlogin")}),{newArgs:T,envMixin:z,filesToCopy:ne}}}k.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$ir=d;function c(i,n){if(I.$j&&i.environmentVariableCollections){const o=(0,p.$er)(i.environmentVariableCollections),A=new f.$fr(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),D=[];if(A)for(const v of A)v.type===w.EnvironmentVariableMutatorType.Prepend&&D.push(v.value);D.length>0&&(n.VSCODE_PATH_PREFIX=D.join(""))}}var a;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(a||(a={}));const $=new Map;$.set(a.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),$.set(a.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),$.set(a.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),$.set(a.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),$.set(a.Zsh,["-i"]),$.set(a.ZshLogin,["-il"]),$.set(a.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],g=["-nol","-nologo"];function t(i){return typeof i=="string"?E.includes(i.toLowerCase()):i.length===1&&E.includes(i[0].toLowerCase())||i.length===2&&(E.includes(i[0].toLowerCase())||E.includes(i[1].toLowerCase()))&&(g.includes(i[0].toLowerCase())||g.includes(i[1].toLowerCase()))}function u(i){return typeof i=="string"?g.includes(i.toLowerCase()):i.length===0||i?.length===1&&g.includes(i[0].toLowerCase())}function r(i){return i==="string"&&E.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&E.includes(i[0].toLowerCase())}}),define(te[261],ie([0,1,47,71,9,4,12,21,106,260,113]),function(K,e,P,O,s,M,I,S,h,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;let w,p=!0;function f(n,o,k,A,D=process.env,v,C,L,T){return v=v||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$i?y(k,v,D,C,A.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:A.getValue("terminal.integrated.profiles.windows"),typeof o=="string"?o:A.getValue("terminal.integrated.defaultProfile.windows"),T,L):u(v,C,k,n&&typeof n=="object"?{...n}:A.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof o=="string"?o:A.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,L,D)}e.$jr=f;async function y(n,o,k,A,D,v,C,L,T){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),se=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let ee=!1;(0,l.$gr)()>=16299&&(ee=!0),await a(L);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:O.$Oj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${se}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.$Oj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${se}\\cmd.exe`,icon:O.$Oj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.$Oj.terminalBash,isAutoDetected:!0});const oe=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${se}\\cmd.exe`,args:["/K",oe],requiresPath:process.env.CMDER_ROOT?oe:{path:oe,isUnsafe:!0},isAutoDetected:!0})}r(v,ae);const ne=await m(ae.entries(),C,o,k,A,T);if(n&&D)try{const oe=await g(`${se}\\${ee?"wsl":"bash"}.exe`,C);for(const G of oe)(!v||!(G.profileName in v))&&ne.push(G)}catch{p&&(A?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return ne}async function m(n,o,k,A=process.env,D,v){const C=[];for(const[L,T]of n)C.push(d(L,T,o,k,A,D,v));return(await Promise.all(C)).filter(L=>!!L)}async function d(n,o,k,A,D=process.env,v,C){if(o===null)return;let L,T,z;if("source"in o&&!("path"in o)){const ne=w?.get(o.source);if(!ne)return;L=ne.paths,T=o.args||ne.args,o.icon?z=c(o.icon):ne.icon&&(z=ne.icon)}else L=Array.isArray(o.path)?o.path:[o.path],T=M.$i||Array.isArray(o.args)?o.args:void 0,z=c(o.icon);let se;if(C){const ne=L.map(G=>typeof G=="string"?G:G.path),oe=await C(ne);se=new Array(L.length);for(let G=0;G<L.length;G++)typeof L[G]=="string"?se[G]=oe[G]:se[G]={path:oe[G],isUnsafe:!0}}else se=L.slice();let ee;if(o.requiresPath){let ne;if((0,I.$if)(o.requiresPath)?ne=o.requiresPath:(ne=o.requiresPath.path,o.requiresPath.isUnsafe&&(ee=ne)),!await A.existsFile(ne))return}const ae=await i(n,k,se,A,D,T,o.env,o.overrideName,o.isAutoDetected,ee);if(!ae){v?.debug("Terminal profile not validated",n,L);return}return ae.isAutoDetected=o.isAutoDetected,ae.icon=z,ae.color=o.color,ae}function c(n){return typeof n=="string"?{id:n}:n}async function a(n){if(w&&!n)return;const[o,k]=await Promise.all([$(),n||E()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:o,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:k,icon:O.$Oj.terminalPowershell})}async function $(){const n=new Set,o=await(0,l.$hr)("git.exe");if(o){const D=(0,b.dirname)(o);n.add((0,b.resolve)(D,"../.."))}function k(D,v){v&&D.add(v)}k(n,process.env.ProgramW6432),k(n,process.env.ProgramFiles),k(n,process.env["ProgramFiles(X86)"]),k(n,`${process.env.LocalAppData}\\Program`);const A=[];for(const D of n)A.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return A.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),A.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),A}async function E(){const n=[];for await(const o of(0,h.$pl)())n.push(o.exePath);return n}async function g(n,o){const k=[],A=await new Promise((C,L)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,z)=>{if(T)return L("Problem occurred when getting wsl distros");C(z)})});if(!A)return[];const D=new RegExp(/[\r?\n]/),v=A.split(D).filter(C=>C.trim().length>0&&C!=="");for(const C of v){if(C===""||C.startsWith("docker-desktop"))continue;const L=`${C} (WSL)`,T={profileName:L,path:n,args:["-d",`${C}`],isDefault:L===o,icon:t(C),isAutoDetected:!1};k.push(T)}return k}function t(n){return n.includes("Ubuntu")?O.$Oj.terminalUbuntu:n.includes("Debian")?O.$Oj.terminalDebian:O.$Oj.terminalLinux}async function u(n,o,k,A,D,v,C,L){const T=new Map;if(k){const z=(await n.readFile("/etc/shells")).toString(),se=(v||z.split(`
`)).map(ae=>{const ne=ae.indexOf("#");return ne===-1?ae:ae.substring(0,ne)}).filter(ae=>ae.trim().length>0),ee=new Map;for(const ae of se){let ne=(0,s.$_d)(ae),oe=ee.get(ne)||0;oe++,oe>1&&(ne=`${ne} (${oe})`),ee.set(ne,oe),T.set(ne,{path:ae,isAutoDetected:!0})}}return r(A,T),await m(T.entries(),D,n,L,o,C)}function r(n,o){if(n)for(const[k,A]of Object.entries(n))A===null||typeof A!="object"||!("path"in A)&&!("source"in A)?o.delete(k):(A.icon=A.icon||o.get(k)?.icon,o.set(k,A))}async function i(n,o,k,A,D,v,C,L,T,z){if(k.length===0)return Promise.resolve(void 0);const se=k.shift();if(se==="")return i(n,o,k,A,D,v,C,L,T);const ee=typeof se!="string"&&se.isUnsafe,ae=typeof se=="string"?se:se.path,ne={profileName:n,path:ae,args:v,env:C,overrideName:L,isAutoDetected:T,isDefault:n===o,isUnsafePath:ee,requiresUnsafePath:z};if((0,s.$_d)(ae)===ae){const G=D.PATH?D.PATH.split(s.$fe):void 0,J=await(0,l.$hr)(ae,void 0,G,void 0,A.existsFile);return J?(ne.path=J,ne.isFromPath=!0,ne):i(n,o,k,A,D,v)}return await A.existsFile((0,s.$6d)(ae))?ne:i(n,o,k,A,D,v,C,L,T)}}),define(te[262],ie([0,1,3,2,4,42,18,5,224,94,257,125,259,261,108,69]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;var d;(function(a){a[a.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let c=class extends O.$jc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor($,E,g,t){super(),this.M=$,this.N=E,this.O=g,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$ed),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$ed),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$ed),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$ed),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$ed),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$ed),this.onProcessData=this.D.event,this.F=this.B(new P.$ed),this.onProcessReady=this.F.event,this.G=this.B(new P.$ed),this.onProcessReplay=this.G.event,this.H=this.B(new P.$ed),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$ed),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$ed),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$ed),this.onProcessExit=this.L.event,(0,p.$0q)(),this.B(this.M),this.B((0,O.$hc)(()=>this.W())),this.j=this.B(new b.$3q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,l.$Ll)(this.N,this.O,{_:[]},process.env)}catch($){return this.O.error("ptyHost was unable to resolve shell environment",$),{}}}U(){const $=this.M.start(),E=$.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B($.onDidProcessExit(u=>{this.u.fire(u.code),!this.m&&!this.q.isDisposed&&(this.n<=d.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${u.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const t=M.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(u=>this.D.fire(u))),this.B(t.onProcessReady(u=>this.F.fire(u))),this.B(t.onProcessExit(u=>this.L.fire(u))),this.B(t.onDidChangeProperty(u=>this.J.fire(u))),this.B(t.onProcessReplay(u=>this.G.fire(u))),this.B(t.onProcessOrphanQuestion(u=>this.H.fire(u))),this.B(t.onDidRequestDetach(u=>this.I.fire(u))),this.B(new h.$2q(this.P,E.getChannel(w.TerminalIpcChannels.Logger))),this.a=$,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async u=>{u.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[$,t]}async createProcess($,E,g,t,u,r,i,n,o,k,A){const D=setTimeout(()=>this.$(),w.HeartbeatConstants.CreateProcessTimeout),v=await this.f.createProcess($,E,g,t,u,r,i,n,o,k,A);return clearTimeout(D),v}updateTitle($,E,g){return this.f.updateTitle($,E,g)}updateIcon($,E,g,t){return this.f.updateIcon($,E,g,t)}attachToProcess($){return this.f.attachToProcess($)}detachFromProcess($,E){return this.f.detachFromProcess($,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start($){return this.f.start($)}shutdown($,E){return this.f.shutdown($,E)}input($,E){return this.f.input($,E)}processBinary($,E){return this.f.processBinary($,E)}resize($,E,g){return this.f.resize($,E,g)}clearBuffer($){return this.f.clearBuffer($)}acknowledgeDataEvent($,E){return this.f.acknowledgeDataEvent($,E)}setUnicodeVersion($,E){return this.f.setUnicodeVersion($,E)}getInitialCwd($){return this.f.getInitialCwd($)}getCwd($){return this.f.getCwd($)}async getLatency(){const $=new m.$ad,E=await this.f.getLatency();return $.stop(),[{label:"ptyhostservice<->ptyhost",latency:$.elapsed()},...E]}orphanQuestionReply($){return this.f.orphanQuestionReply($)}installAutoReply($,E){return this.f.installAutoReply($,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply($){return this.f.uninstallAutoReply($)}getDefaultSystemShell($){return this.g?.getDefaultSystemShell($)??(0,y.$vl)($??s.OS,process.env)}async getProfiles($,E,g,t=!1){const u=await this.S();return(0,f.$jr)(E,g,t,this.N,u,void 0,this.O,this.bb.bind(this,$))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath($,E){return this.f.getWslPath($,E)}getRevivedPtyNewId($,E){return this.f.getRevivedPtyNewId($,E)}setTerminalLayoutInfo($){return this.f.setTerminalLayoutInfo($)}async getTerminalLayoutInfo($){return this.g?.getTerminalLayoutInfo($)}async requestDetachInstance($,E){return this.f.requestDetachInstance($,E)}async acceptDetachInstanceReply($,E){return this.f.acceptDetachInstanceReply($,E)}async freePortKillProcess($){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess($)}async serializeTerminalState($){return this.f.serializeTerminalState($)}async reviveTerminalProcesses($,E,g){return this.f.reviveTerminalProcesses($,E,g)}async refreshProperty($,E){return this.f.refreshProperty($,E)}async updateProperty($,E,g){return this.f.updateProperty($,E,g)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X($){this.ab(),this.s=setTimeout(()=>this.Y(),$?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb($,E){return this.j.createRequest({workspaceId:$,originalText:E})}async acceptPtyHostResolvedVariables($,E){this.j.acceptReply($,E)}};e.$kr=c,e.$kr=c=ke([_(1,I.$7h),_(2,S.$4i),_(3,S.$5i)],c)}),define(te[79],ie([0,1,15,3,2,4,18,6,34]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=e.$T5b=void 0;const l="#FFFFFF",b="#1E1E1E",w="#000000",p="#FFFFFF",f="theme",y="themeBackground",m="windowSplash";e.$T5b=(0,S.$Ah)("themeMainService");let d=class extends s.$jc{constructor(a,$){super(),this.b=a,this.c=$,this.a=this.B(new O.$ed),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const a=this.getColorScheme();if(a.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return a.dark?w:p;let $=this.b.getItem(y,null);if(!$)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":$=l;break;case"hc-black":$=w;break;case"hc-light":$=p;break;default:$=b}return M.$j&&$.toUpperCase()===b&&($="#171717"),$}saveWindowSplash(a,$){this.b.setItems([{key:f,data:$.baseTheme},{key:y,data:$.colorInfo.background},{key:m,data:$}]),typeof a=="number"&&this.f(a,$)}f(a,$){for(const E of P.BrowserWindow.getAllWindows())if(E.id===a){E.setBackgroundColor($.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(m)}};e.$U5b=d,e.$U5b=d=ke([_(0,h.$aN),_(1,I.$7h)],d)}),define(te[126],ie([0,1,3,18,6,5]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.ProvidedOnAutoForward=e.$Xz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Wz=e.$Vz=void 0,e.$Vz=(0,s.$Ah)("tunnelService"),e.$Wz=(0,s.$Ah)("sharedTunnelsService");var I;(function(d){d.Http="http",d.Https="https"})(I||(e.TunnelProtocol=I={}));var S;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(S||(e.TunnelPrivacyId=S={}));function h(d){return!!d.forwardPort}e.$Xz=h;var l;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function b(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const c=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(c)return{address:c[1],port:+c[2]}}e.$Yz=b,e.$Zz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(d){return e.$Zz.indexOf(d)>=0}e.$1z=w,e.$2z=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(d){return e.$2z.indexOf(d)>=0}e.$3z=p;function f(d,c,a,$){if(a===1)return!1;if(a===2&&p(c)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(E?.length===4&&parseInt(E[1])>=18)return!1}return d<1024}e.$4z=f;class y{constructor(c,a,$){this.remoteAddress=c,this.localAddress=a,this.b=$,this.a=new P.$ed,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$5z=y;let m=class{constructor(c,a){this.j=c,this.k=a,this.a=new P.$ed,this.onTunnelOpened=this.a.event,this.b=new P.$ed,this.onTunnelClosed=this.b.event,this.c=new P.$ed,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const c=this.k.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(c){return this.f=c,c?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(c){this.g=c.elevation,this.h=c.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const c=[],a=Array.from(this.e.values());for(const $ of a){const E=Array.from($.values());for(const g of E){const t=await g.value;t&&typeof t!="string"&&c.push(t)}}return c}async dispose(){for(const c of this.e.values()){for(const{value:a}of c.values())await a.then($=>typeof $!="string"?$?.dispose():void 0);c.clear()}this.e.clear()}setEnvironmentTunnel(c,a,$,E,g){this.p(c,a,Promise.resolve({tunnelRemoteHost:c,tunnelRemotePort:a,localAddress:$,privacy:E,protocol:g,dispose:()=>Promise.resolve()}))}async getExistingTunnel(c,a){(p(c)||w(c))&&(c=e.$Zz[0]);const $=this.r(c,a);if($)return++$.refcount,$.value}openTunnel(c,a,$,E,g,t=!1,u,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${$} on local port ${g}.`);const i=this.f??c;if(!i)return;if(a||(a="localhost"),E||(E=this.l),this.f&&this.i.has($)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,a,$,E,g,t,u,r);return n?n.then(o=>{if(o){if(typeof o=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(a,$),o}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(a,$);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(o);return(o.tunnelRemoteHost!==a||o.tunnelRemotePort!==$)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),u&&o.privacy!==u&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(c){return{tunnelRemotePort:c.tunnelRemotePort,tunnelRemoteHost:c.tunnelRemoteHost,tunnelLocalPort:c.tunnelLocalPort,localAddress:c.localAddress,privacy:c.privacy,protocol:c.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${c.tunnelRemoteHost}:${c.tunnelRemotePort} `);const a=this.e.get(c.tunnelRemoteHost);if(a){const $=a.get(c.tunnelRemotePort);$&&($.refcount--,await this.o(c.tunnelRemoteHost,c.tunnelRemotePort,$))}}}}async o(c,a,$){if($.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${c}:${a}.`);const E=$.value.then(async g=>{g&&typeof g!="string"&&(await g.dispose(!0),this.b.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this.e.has(c)&&this.e.get(c).delete(a),E}}async closeTunnel(c,a){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${c}:${a} `);const $=this.e.get(c);if($&&$.has(a)){const E=$.get(a);E.refcount=0,await this.o(c,a,E)}}p(c,a,$){this.e.has(c)||this.e.set(c,new Map),this.e.get(c).set(a,{refcount:1,value:$})}async q(c,a){const $=this.e.get(c);if($){const E=$.get(a),g=E?await E.value:void 0;(!g||typeof g=="string")&&$.delete(a),$.size===0&&this.e.delete(c)}}r(c,a){const $=[c];w(c)?($.push(...e.$Zz),$.push(...e.$2z)):p(c)&&$.push(...e.$2z);const E=$.map(g=>this.e.get(g));for(const g of E){const t=g?.get(a);if(t)return t}}canTunnel(c){return!!b(c)}t(c,a,$,E,g,t,u){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${$} on local port ${E}.`);const r=$;this.i.add(r);const i=E===void 0?$:E,n={elevationRequired:g?this.isPortPrivileged(i):!1},o={remoteAddress:{host:a,port:$},localAddressPort:E,privacy:t,public:t?t!==S.Private:void 0,protocol:u},k=c.forwardPort(o,n);return k?(this.p(a,$,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),k}};e.$6z=m,e.$6z=m=ke([_(0,M.$4i),_(1,O.$7h)],m)}),define(te[48],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MT=e.$LT=e.DisablementReason=e.UpdateType=e.StateType=void 0;var O;(function(I){I.Uninitialized="uninitialized",I.Idle="idle",I.Disabled="disabled",I.CheckingForUpdates="checking for updates",I.AvailableForDownload="available for download",I.Downloading="downloading",I.Downloaded="downloaded",I.Updating="updating",I.Ready="ready"})(O||(e.StateType=O={}));var s;(function(I){I[I.Setup=0]="Setup",I[I.Archive=1]="Archive",I[I.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(I){I[I.NotBuilt=0]="NotBuilt",I[I.DisabledByEnvironment=1]="DisabledByEnvironment",I[I.ManuallyDisabled=2]="ManuallyDisabled",I[I.MissingConfiguration=3]="MissingConfiguration",I[I.InvalidConfiguration=4]="InvalidConfiguration",I[I.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$LT={Uninitialized:{type:"uninitialized"},Disabled:I=>({type:"disabled",reason:I}),Idle:(I,S)=>({type:"idle",updateType:I,error:S}),CheckingForUpdates:I=>({type:"checking for updates",explicit:I}),AvailableForDownload:I=>({type:"available for download",update:I}),Downloading:I=>({type:"downloading",update:I}),Downloaded:I=>({type:"downloaded",update:I}),Updating:I=>({type:"updating",update:I}),Ready:I=>({type:"ready",update:I})},e.$MT=(0,P.$Ah)("updateService")}),define(te[263],ie([0,1,4,187,59,43]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$7m.as(s.$_m.Configuration).registerConfiguration({id:"update",order:15,title:(0,O.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,O.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,O.localize)(2,null),(0,O.localize)(3,null),(0,O.localize)(4,null),(0,O.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,O.localize)(6,null),deprecationMessage:(0,O.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,O.localize)(8,null),description:(0,O.localize)(9,null),included:P.$i&&!P.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,O.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[264],ie([0,1,3,48]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=e.$m6b=void 0;class s{constructor(S){this.a=S}listen(S,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(S,h,l){switch(h){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${h}`)}}e.$m6b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$ed,this.onStateChange=this.a.event,this.b=O.$LT.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$n6b=M}),define(te[40],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=void 0,e.$Bk=(0,P.$Ah)("IUriIdentityService")}),define(te[265],ie([0,1,40,206,16,19,140,3,2]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class l{static{this._clock=0}constructor(p){this.uri=p,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let b=class{constructor(p){this.g=p,this.c=new h.$ic,this.f=2**16;const f=new Map,y=m=>{let d=f.get(m.scheme);return d===void 0&&(d=p.hasProvider(m)&&!this.g.hasCapability(m,1024),f.set(m.scheme,d)),d};this.c.add(S.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(m=>{f.delete(m.scheme)})),this.extUri=new M.$9f(y),this.d=new I.$nr((m,d)=>this.extUri.compare(m,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,M.$ig)(p));const f=this.d.get(p);return f?f.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new l(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((y,m)=>y[1].time<m[1].time?1:y[1].time>m[1].time?-1:0);l._clock=0,this.d.clear();const f=this.f*.5;for(let y=0;y<f;y++)this.d.set(p[y][0],p[y][1].touch())}};e.$or=b,e.$or=b=ke([_(0,s.$5j)],b),(0,O.$lr)(P.$Bk,b,1)}),define(te[127],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AT=void 0,e.$AT=(0,P.$Ah)("urlService")}),define(te[266],ie([0,1,7]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=e.$v6b=e.$u6b=void 0;class O{constructor(S){this.a=S}listen(S,h){throw new Error(`Event not found: ${h}`)}call(S,h,l){switch(h){case"handleURL":return this.a.handleURL(P.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${h}`)}}e.$u6b=O;class s{constructor(S){this.a=S}handleURL(S,h){return this.a.call("handleURL",[S.toJSON(),h])}}e.$v6b=s;class M{constructor(S,h){this.a=S,this.b=h}async routeCall(S,h,l,b){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(l)&&l.length>0){const w=P.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",w.toString(!0)),w.query){const p=/\bwindowId=(\d+)/.exec(w.query);if(p){const f=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,w.toString(!0));const y=new RegExp(`window:${f}`),m=S.connections.find(d=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",d.ctx),y.test(d.ctx)));if(m)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",w.toString(!0)),m;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",w.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",w.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,h,l,b)}routeEvent(S,h){throw new Error(`Event not found: ${h}`)}}e.$w6b=M}),define(te[267],ie([0,1,8,2,7,24]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CT=e.$BT=void 0;class I extends O.$jc{constructor(){super(...arguments),this.a=new Set}open(l,b){const w=[...this.a.values()];return(0,P.$Jg)(w.map(p=>()=>p.handleURL(l,b)),void 0,!1).then(p=>p||!1)}registerHandler(l){return this.a.add(l),(0,O.$hc)(()=>this.a.delete(l))}}e.$BT=I;let S=class extends I{constructor(l){super(),this.b=l}create(l){let{authority:b,path:w,query:p,fragment:f}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&w&&w.indexOf("/")!==0&&(w=`/${w}`),s.URI.from({scheme:this.b.urlProtocol,authority:b,path:w,query:p,fragment:f})}};e.$CT=S,e.$CT=S=ke([_(0,M.$jj)],S)}),define(te[268],ie([0,1,15,8,3,2,4,7]),function(K,e,P,O,s,M,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x6b=void 0;class h{constructor(b,w,p,f,y,m){if(this.f=w,this.g=m,this.a=[],this.b=0,this.c=M.$jc.None,this.d=new M.$ic,b&&(m.trace("ElectronURLListener initialUrisToHandle:",b.map(a=>a.originalUrl)),this.a=b),I.$i){const a=f.isBuilt?[]:[`"${f.appRoot}"`];a.push("--open-url","--"),P.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,a)}const d=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(a,$)=>({event:a,url:$})),({event:a,url:$})=>(a.preventDefault(),$));this.d.add(d(a=>{const $=this.h(a);$&&this.f.open($,{originalUrl:a})})),p.getWindows().filter(a=>a.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(p.onDidSignalReadyWindow)(this.i,this,this.d))}h(b){try{return S.URI.parse(b)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const w of this.a)await this.f.open(w.uri,{originalUrl:w.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",w.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",w.originalUrl),b.push(w));b.length!==0&&(this.a=b,this.c=(0,O.$Hg)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.$x6b=h}),define(te[269],ie([0,1,3,2,16,56,58,17,12,33]),function(K,e,P,O,s,M,I,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=void 0;class b extends O.$jc{get capabilities(){return this.g.capabilities&-5}constructor(p,f,y,m,d,c){super(),this.f=p,this.g=f,this.h=y,this.j=m,this.m=c,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$ed),this.onDidChangeFile=this.a.event,this.b=I.$Gh.forUris(()=>!(this.capabilities&1024)),this.c=new l.$zi(a=>d.extUri.getComparisonKey(this.s(a))),this.n(),this.B(m.onDidChangeProfiles(()=>this.n())),this.B(this.g.onDidChangeFile(a=>this.r(a)))}n(){this.c.clear();for(const p of this.j.profiles)this.c.add(p.settingsResource),this.c.add(p.keybindingsResource),this.c.add(p.tasksResource),this.c.add(p.extensionsResource)}watch(p,f){this.b.set(p,p);const y=this.g.watch(this.s(p),f);return(0,O.$hc)(()=>{this.b.delete(p),y.dispose()})}stat(p){return this.g.stat(this.s(p))}mkdir(p){return this.g.mkdir(this.s(p))}rename(p,f,y){return this.g.rename(this.s(p),this.s(f),y)}readFile(p){return this.g.readFile(this.s(p),{atomic:!0})}readFileStream(p,f,y){const m=(0,M.$sd)(d=>S.$Ed.concat(d.map(c=>S.$Ed.wrap(c))).buffer);return(async()=>{try{const d=await this.readFile(p);m.end(d)}catch(d){m.error(d),m.end()}})(),m}readdir(p){return this.g.readdir(this.s(p))}writeFile(p,f,y){return this.c.has(p)&&!(0,h.$kf)(y.atomic)&&(0,s.$ak)(this.g)&&(y={...y,atomic:{postfix:".vsctmp"}}),this.g.writeFile(this.s(p),f,y)}delete(p,f){return this.g.delete(this.s(p),f)}copy(p,f,y){if((0,s.$8j)(this.g))return this.g.copy(this.s(p),this.s(f),y);throw new Error("copy not supported")}r(p){const f=[];for(const y of p){if(y.resource.scheme!==this.f)continue;const m=this.t(y.resource);this.b.findSubstr(m)&&f.push({resource:m,type:y.type})}f.length&&(this.m.debug("User data changed"),this.a.fire(f))}s(p){return p.with({scheme:this.f})}t(p){return p.with({scheme:this.h})}}e.$96b=b}),define(te[270],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=void 0,e.$Q6b="utilityProcessWorker"}),define(te[271],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=void 0,e.$y6b=(0,P.$Ah)("webviewManagerService")}),define(te[272],ie([0,1,15,2,13,7]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=void 0;class I extends O.$jc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,h)}b(h,l){try{const b=M.URI.parse(h.url),w=I.a.get(b.path);if(typeof w=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${w}`,f=s.$1f.asFileUri(p);return l({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$z6b=I}),define(te[80],ie([0,1,4]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VD=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=void 0,e.$OD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function O(b){return!!b.workspaceUri}e.$PD=O;function s(b){return!!b.folderUri}e.$QD=s;function M(b){return!!b.fileUri}e.$RD=M;function I(b){const w=S(b),p=b.getValue("window.menuBarVisibility");return p==="default"||w==="native"&&p==="compact"||P.$j&&P.$m?"classic":p}e.$SD=I;function S(b){if(P.$o)return"custom";const w=b.getValue("window");if(w){if(P.$j&&w.nativeTabs===!0||P.$j&&w.nativeFullScreen===!1)return"native";const y=w.titleBarStyle;if(y==="native"||y==="custom")return y}return P.$k?"native":"custom"}e.$TD=S;function h(b){return!(!P.$i||P.$o||S(b)==="native")}e.$UD=h;function l(b=0){return Math.pow(1.2,b)}e.$VD=l}),define(te[128],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$94b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var O;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(O||(e.UnloadReason=O={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$94b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var I;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(I||(e.WindowError=I={}))}),define(te[30],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$l5b=void 0,e.$l5b=(0,P.$Ah)("windowsMainService");var O;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(O||(e.OpenContext=O={}))}),define(te[273],ie([0,1,15,23,4,7,21,18,63,6,5,127,30]),function(K,e,P,O,s,M,I,S,h,l,b,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$65b=e.$55b=e.ID=void 0,e.ID="launchMainService",e.$55b=(0,l.$Ah)(e.ID);let f=class{constructor(m,d,c,a){this.a=m,this.b=d,this.c=c,this.d=a}async start(m,d){this.a.trace("Received data from other instance: ",m,d),s.$j&&P.app.focus({steal:!0});const c=this.e(m);if(c.length){let a=Promise.resolve();if(this.b.getWindowCount()===0){const $=(0,O.$Lb)(await this.b.openEmptyWindow({context:4}));$&&(a=$.ready())}a.then(()=>{for(const{uri:$,originalUrl:E}of c)this.c.open($,{originalUrl:E})})}else return this.f(m,d)}e(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,O.$Eb)(m._urls.map(d=>{try{return{uri:M.URI.parse(d),originalUrl:d}}catch{return null}})):[]}async f(m,d){const c=(0,h.$Fl)(d)?0:4;let a=[];const $=m.wait&&m.waitMarkerFilePath?M.URI.file(m.waitMarkerFilePath):void 0,E=m.remote||void 0,g={context:c,cli:m,userEnv:d,waitMarkerFileURI:$,remoteAuthority:E,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,g);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let t=!1;if(m["new-window"]||m["unity-launch"]||g.forceProfile||g.forceTempProfile)t=!0;else if(m["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)a=await this.b.open({...g,forceNewWindow:!0,forceEmpty:!0});else{const u=this.b.getLastActiveWindow();u?(this.b.openExistingWindow(u,g),a=[u]):a=await this.b.open({...g,forceEmpty:!0})}}else a=await this.b.open({...g,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if($&&a.length===1&&a[0])return Promise.race([a[0].whenClosedOrLoaded,(0,I.whenDeleted)($.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$65b=f,e.$65b=f=ke([_(0,b.$4i),_(1,p.$l5b),_(2,w.$AT),_(3,S.$7h)],f)}),define(te[274],ie([0,1,15,3,2,272,30]),function(K,e,P,O,s,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;let S=class extends s.$jc{constructor(l){super(),this.b=l,this.a=this.B(new O.$ed),this.onFoundInFrame=this.a.event,this.B(new M.$z6b)}async setIgnoreMenuShortcuts(l,b){let w;if(typeof l.windowId=="number"){const{windowId:p}=l,f=this.b.getWindowById(p);if(!f?.win)throw new Error(`Invalid windowId: ${p}`);w=f.win.webContents}else{const{webContentsId:p}=l;if(w=P.webContents.fromId(p),!w)throw new Error(`Invalid webContentsId: ${p}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts(b)}async findInFrame(l,b,w,p){const y=this.c(l,b);if(typeof y.findInFrame=="function"){y.findInFrame(w,{findNext:p.findNext,forward:p.forward});const m=(d,c)=>{c.finalUpdate&&(this.a.fire(c),y.removeListener("found-in-frame",m))};y.on("found-in-frame",m)}}async stopFindInFrame(l,b,w){const f=this.c(l,b);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(w.keepSelection?"keepSelection":"clearSelection")}c(l,b){const w=this.b.getWindowById(l.windowId);if(!w?.win)throw new Error(`Invalid windowId: ${l}`);const p=w.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===b);if(!p)throw new Error(`Unknown frame: ${b}`);return p}};e.$A6b=S,e.$A6b=S=ke([_(0,I.$l5b)],S)}),define(te[275],ie([0,1,8,3,2]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=void 0;class M extends s.$jc{constructor({onDidOpenWindow:S,onDidFocusWindow:h,getActiveWindowId:l}){super(),this.a=this.B(new s.$ic),O.Event.latch(O.Event.any(S,h))(this.f,this,this.a),this.b=(0,P.$tg)(()=>l()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$G6b=M}),define(te[29],ie([0,1,191,9,58,19,7,6,13]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.WorkbenchState=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0,e.$Jh=(0,S.$Ah)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&I.URI.isUri(n.uri)}e.$Kh=l;function b(i){return typeof i?.id=="string"&&!l(i)&&!p(i)}e.$Lh=b,e.$Mh={id:"ext-dev"},e.$Nh={id:"empty-window"};function w(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.$_d)(i)}:n?e.$Mh:e.$Nh;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$Oh=w;function p(i){const n=i;return typeof n?.id=="string"&&I.URI.isUri(n.configPath)}e.$Ph=p;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:I.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:I.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.$Qh=f;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Rh=m;function d(i){const n=i;return!!(n&&typeof n=="object"&&I.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Sh=d;class c{constructor(n,o,k,A,D){this.h=n,this.j=k,this.k=A,this.l=D,this.c=s.$Gh.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Gh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Th=c;class a{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$hg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Uh=a;function $(i){return new a({uri:i,index:0,name:(0,M.$dg)(i)},{uri:i.toString()})}e.$Vh=$,e.$Wh="code-workspace",e.$Xh=`.${e.$Wh}`,e.$Yh=[{name:(0,P.localize)(0,null),extensions:[e.$Wh]}],e.$Zh="workspace.json";function E(i,n){return M.$$f.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$1h=E;function g(i){let n;return I.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$2h=g,e.$3h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$3h}e.$4h=t;function u(i,n){return!E(i,n)&&!g(i)}e.$5h=u;function r(i){return(typeof i=="string"?(0,O.$ae)(i):(0,M.$fg)(i))===e.$Xh}e.$6h=r}),define(te[61],ie([0,1,15,8,57,46,2,85,4,21,166,91,6,5,24,29]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y5b=e.$x5b=void 0,e.$x5b=(0,p.$Ah)("dialogMainService");let d=class{constructor(a,$){this.d=a,this.e=$,this.a=new Map,this.b=new Map,this.c=new O.$Mg}pickFileFolder(a,$){return this.f({...a,pickFolders:!0,pickFiles:!0,title:(0,b.localize)(0,null)},$)}pickFolder(a,$){return this.f({...a,pickFolders:!0,title:(0,b.localize)(1,null)},$)}pickFile(a,$){return this.f({...a,pickFiles:!0,title:(0,b.localize)(2,null)},$)}pickWorkspace(a,$){const E=(0,b.localize)(3,null),g=(0,M.$kA)((0,b.localize)(4,null)),t=m.$Yh;return this.f({...a,pickFiles:!0,title:E,filters:t,buttonLabel:g},$)}async f(a,$){const E={title:a.title,buttonLabel:a.buttonLabel,filters:a.filters,defaultPath:a.defaultPath};(typeof a.pickFiles=="boolean"||typeof a.pickFolders=="boolean")&&(E.properties=void 0,a.pickFiles&&a.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",a.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&E.properties.push("treatPackageAsDirectory");const g=await this.showOpenDialog(E,($||P.BrowserWindow.getFocusedWindow())??void 0);if(g&&g.filePaths&&g.filePaths.length>0)return g.filePaths}g(a){if(a){let $=this.b.get(a.id);return $||($=new O.$Mg,this.b.set(a.id,$)),$}else return this.c}showMessageBox(a,$){return this.g($).queue(async()=>{const{options:E,buttonIndeces:g}=(0,w.$rA)(a,this.e);let t;return $?t=await P.dialog.showMessageBox($,E):t=await P.dialog.showMessageBox(E),{response:g[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(a,$){const E=this.j(a,$);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g($).queue(async()=>{let g;return $?g=await P.dialog.showSaveDialog($,a):g=await P.dialog.showSaveDialog(a),g.filePath=this.h(g.filePath),g})}finally{(0,I.$ec)(E)}}h(a){return a&&h.$j&&(a=(0,S.$gl)(a)),a}i(a){return a.map($=>this.h($))}async showOpenDialog(a,$){a.defaultPath&&(await l.Promises.exists(a.defaultPath)||(a.defaultPath=void 0));const E=this.j(a,$);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g($).queue(async()=>{let g;return $?g=await P.dialog.showOpenDialog($,a):g=await P.dialog.showOpenDialog(a),g.filePaths=this.i(g.filePaths),g})}finally{(0,I.$ec)(E)}}j(a,$){if(!$)return I.$jc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",a);let E=this.a.get($.id);E||(E=new Set,this.a.set($.id,E));const g=(0,s.$oi)(a);if(!E.has(g))return this.d.trace("[DialogMainService]: new file dialog lock created",a),E.add(g),(0,I.$hc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",a),E?.delete(g),E?.size===0&&this.a.delete($.id)})}};e.$y5b=d,e.$y5b=d=ke([_(0,f.$4i),_(1,y.$jj)],d)}),define(te[276],ie([0,1,3,2,74,29]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j6b=void 0;class I extends O.$jc{static{this.a=100}constructor(h,l){super(),this.f=h,this.g=l,this.b=this.B(new P.$ed),this.c=new Map,this.h(l.applicationStorage,this.b)}h(h,l){this.B(P.Event.debounce(h.onDidChangeStorage,(b,w)=>(b?b.push(w):b=[w],b),I.a)(b=>{b.length&&l.fire(this.j(b,h))}))}j(h,l){const b=new Map,w=new Set;return h.forEach(p=>{const f=l.get(p.key);typeof f=="string"?b.set(p.key,f):w.add(p.key)}),{changed:Array.from(b.entries()),deleted:Array.from(w.values())}}listen(h,l,b){switch(l){case"onDidChangeStorage":{const w=b.profile?(0,s.$0g)(b.profile):void 0;if(!w)return this.b.event;let p=this.c.get(w.id);return p||(p=this.B(new P.$ed),this.h(this.g.profileStorage(w),p),this.c.set(w.id,p)),p.event}}throw new Error(`Event not found: ${l}`)}async call(h,l,b){const w=b.profile?(0,s.$0g)(b.profile):void 0,p=(0,M.$Qh)(b.workspace),f=await this.m(w,p);switch(l){case"getItems":return Array.from(f.items.entries());case"updateItems":{const y=b;if(y.insert)for(const[m,d]of y.insert)f.set(m,d);y.delete?.forEach(m=>f.delete(m));break}case"optimize":return f.optimize();case"isUsed":{const y=b.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${l}`)}}async m(h,l){let b;l?b=this.g.workspaceStorage(l):h?b=this.g.profileStorage(h):b=this.g.applicationStorage;try{await b.init()}catch(w){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":h?"profile":"application"} storage due to ${w}`)}return b}}e.$j6b=I}),define(te[41],ie([0,1,57,3,2,19,7,188,36,16,6,5,29,33,40,8,31,26,12]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.ProfileResourceType=void 0;var $;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&I.URI.isUri(n.location)&&I.URI.isUri(n.globalStorageHome)&&I.URI.isUri(n.settingsResource)&&I.URI.isUri(n.keybindingsResource)&&I.URI.isUri(n.tasksResource)&&I.URI.isUri(n.snippetsHome)&&I.URI.isUri(n.extensionsResource))}e.$Ck=E,e.$Dk=(0,b.$Ah)("IUserDataProfilesService");function g(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:I.URI.revive(i.location).with({scheme:n}),globalStorageHome:I.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:I.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:I.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:I.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:I.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:I.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:I.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Ek=g;function t(i,n,o,k,A,D){return{id:i,name:n,location:o,isDefault:!1,shortName:A?.shortName,globalStorageHome:D&&A?.useDefaultFlags?.globalState?D.globalStorageHome:(0,M.$hg)(o,"globalStorage"),settingsResource:D&&A?.useDefaultFlags?.settings?D.settingsResource:(0,M.$hg)(o,"settings.json"),keybindingsResource:D&&A?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,M.$hg)(o,"keybindings.json"),tasksResource:D&&A?.useDefaultFlags?.tasks?D.tasksResource:(0,M.$hg)(o,"tasks.json"),snippetsHome:D&&A?.useDefaultFlags?.snippets?D.snippetsHome:(0,M.$hg)(o,"snippets"),extensionsResource:D&&A?.useDefaultFlags?.extensions?D.extensionsResource:(0,M.$hg)(o,"extensions.json"),cacheHome:(0,M.$hg)(k,i),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$Fk=t;let u=class extends s.$jc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,k,A){super(),this.t=n,this.u=o,this.w=k,this.y=A,this.f=!0,this.h=this.B(new O.$ed),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$ed),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$ed),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$ed),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$yi,emptyWindows:new Map},this.profilesHome=(0,M.$hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,a.$if)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}o.push(t((0,M.$eg)(D.location),D.name,D.location,this.g,{shortName:D.shortName,useDefaultFlags:D.useDefaultFlags},n))}}catch(D){this.y.error(D)}const k=new f.$yi,A=new Map;if(o.length)try{const D=this.Q();if(D.workspaces)for(const[v,C]of Object.entries(D.workspaces)){const L=I.URI.parse(v),T=o.find(z=>z.id===C);T&&k.set(L,T)}if(D.emptyWindows)for(const[v,C]of Object.entries(D.emptyWindows)){const L=o.find(T=>T.id===C);L&&A.set(v,L)}}catch(D){this.y.error(D)}this.z={profiles:o,workspaces:k,emptyWindows:A}}return this.z}D(){const n=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",k=new RegExp(`${(0,c.$pe)(o)}\\s(\\d+)`);let A=0;for(const v of this.profiles){const C=k.exec(v.name),L=C?parseInt(C[1]):0;A=L>A?L:A}const D=`${o} ${A+1}`;return this.createProfile((0,P.$oi)((0,d.$3f)()).toString(16),D,{transient:!0},n)}async createNamedProfile(n,o,k){return this.createProfile((0,P.$oi)((0,d.$3f)()).toString(16),n,o,k)}async createProfile(n,o,k,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(n,o,k);return A&&await this.setProfileForWorkspace(A,D),D}async F(n,o,k){if(!(0,a.$if)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(o);return A||(A=(async()=>{try{const D=this.profiles.find(L=>L.name===o||L.id===n);if(D)return D;const v=t(n,o,(0,M.$hg)(this.profilesHome,n),this.g,k,this.defaultProfile);await this.u.createFolder(v.location);const C=[];return this.j.fire({profile:v,join(L){C.push(L)}}),await m.Promises.settled(C),this.I([v],[],[]),v}finally{this.r.delete(o)}})(),this.r.set(o,A)),A}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(A=>A.id===n.id);if(!k)throw new Error(`Profile '${n.name}' does not exist`);return k=t(k.id,o.name??k.name,k.location,this.g,{shortName:o.shortName??k.shortName,transient:o.transient??k.isTransient,useDefaultFlags:o.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(A=>A.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const k=[];this.m.fire({profile:o,join(A){k.push(A)}});try{await Promise.allSettled(k)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(A){(0,l.$ik)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(A=>A.id===o.id);if(!k)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,k)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n);return I.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(n){return(0,p.$Kh)(n)?n.uri:(0,p.$Ph)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,k){const A=[...this.profiles,...n],D=[];this.s.profiles=[];for(let v of A)v.isDefault||o.some(C=>v.id===C.id)||(v=k.find(C=>v.id===C.id)??v,v.isTransient?this.s.profiles.push(v):D.push({location:v.location,name:v.name,shortName:v.shortName,useDefaultFlags:v.useDefaultFlags}));this.P(D),this.z=void 0,this.J(n,o,k)}J(n,o,k){this.h.fire({added:n,removed:o,updated:k,all:this.profiles})}L(n,o,k){k=o?.isTransient?!0:k,k||this.L(n,void 0,!0);const A=this.G(n),D=k?this.s:this.C;I.URI.isUri(A)?(D.workspaces.delete(A),o&&D.workspaces.set(A,o)):(D.emptyWindows.delete(A),o&&D.emptyWindows.set(A,o)),k||this.M()}M(){const n={};for(const[k,A]of this.C.workspaces.entries())n[k.toString()]=A.id;const o={};for(const[k,A]of this.C.emptyWindows.entries())o[k.toString()]=A.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},k=this.D();if(n.workspaces)for(const[D,v]of Object.entries(n.workspaces)){const C=I.URI.parse(v);o[D]=this.w.extUri.isEqual(C,k.location)?k.id:this.w.extUri.basename(C)}const A={};if(n.emptyWindows)for(const[D,v]of Object.entries(n.emptyWindows)){const C=I.URI.parse(v);A[D]=this.w.extUri.isEqual(C,k.location)?k.id:this.w.extUri.basename(C)}return{workspaces:o,emptyWindows:A}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Gk=u,e.$Gk=u=ke([_(0,h.$Hh),_(1,l.$5j),_(2,y.$Bk),_(3,w.$4i)],u);class r extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Hk=r}),define(te[81],ie([0,1,8,17,2,3,33,7,116,123,16,6,5,41,40,12,14,25]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.ExtensionsProfileScanningErrorCode=void 0;var a;(function(u){u.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",u.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(a||(e.ExtensionsProfileScanningErrorCode=a={}));class $ extends Error{constructor(r,i){super(r),this.code=i}}e.$ip=$,e.$jp=(0,w.$Ah)("IExtensionsProfileScannerService");let E=class extends s.$jc{constructor(r,i,n,o,k,A){super(),this.j=r,this.m=i,this.n=n,this.r=o,this.s=k,this.t=A,this.b=this.B(new M.$ed),this.onAddExtensions=this.b.event,this.c=this.B(new M.$ed),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$ed),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$ed),this.onDidRemoveExtensions=this.g.event,this.h=new I.$yi}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],o=[];try{return await this.u(i,k=>{const A=[];for(const D of k)r.some(([v])=>(0,l.$oo)(v.identifier,D.identifier)&&v.manifest.version!==D.version)?n.push(D):A.push(D);for(const[D,v]of r){const C=A.findIndex(T=>(0,l.$oo)(T.identifier,D.identifier)&&T.version===D.manifest.version),L={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:v};C===-1?(o.push(L),A.push(L)):A.splice(C,1,L)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),A}),o.length&&this.c.fire({extensions:o,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),o}catch(k){throw o.length&&this.c.fire({extensions:o,error:k,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:k,profileLocation:i}),k}}async updateMetadata(r,i){const n=[];return await this.u(i,o=>{const k=[];for(const A of o){const D=r.find(([v])=>(0,l.$oo)(v.identifier,A.identifier)&&v.manifest.version===A.version);D&&(A.metadata={...A.metadata,...D[1]},n.push(A)),k.push(A)}return k}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,o=>{const k=[];for(const A of o)(0,l.$oo)(A.identifier,r.identifier)?n.push(A):k.push(A);return n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(r,i,n){return this.F(r).queue(async()=>{let o=[],k;try{const A=await this.m.readFile(r);k=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,b.$ik)(A)!==1)throw A;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(k=await this.D()),!k&&n?.bailOutWhenFileNotFound)throw new $((0,d.$8)(A),"ERROR_PROFILE_NOT_FOUND")}if(k){Array.isArray(k)||this.w(r);let A=!1;for(const D of k){g(D)||this.w(r);let v;if((0,m.$if)(D.relativeLocation)&&D.relativeLocation)v=this.z(D.relativeLocation);else if((0,m.$if)(D.location))v=this.z(D.location),A=!0,D.relativeLocation=D.location,D.location=v.toJSON();else{v=S.URI.revive(D.location);const C=this.y(v);C&&(A=!0,D.relativeLocation=C)}o.push({identifier:D.identifier,location:v,version:D.version,metadata:D.metadata})}A&&await this.m.writeFile(r,O.$Ed.fromString(JSON.stringify(k)))}if(i){o=i(o);const A=o.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(r,O.$Ed.fromString(JSON.stringify(A)))}return o})}w(r){const i=new $(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(k){if((0,b.$ik)(k)===1)return;throw k}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const k=JSON.parse(n);Array.isArray(k)&&k.every(A=>g(A))?o=k:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",k)}catch(k){this.t.error(k)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$Ed.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(k){if((0,b.$ik)(k)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw k}try{await this.m.del(r)}catch(k){(0,b.$ik)(k)!==1&&this.t.error(k)}try{await this.m.del(i)}catch(k){(0,b.$ik)(k)!==1&&this.t.error(k)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$Mg,this.h.set(r,i)),i}};e.$kp=E,e.$kp=E=ke([_(1,b.$5j),_(2,f.$Dk),_(3,y.$Bk),_(4,c.$8k),_(5,p.$4i)],E);function g(u){return(0,m.$kf)(u)&&(0,h.$Xn)(u.identifier)&&(t(u.location)||(0,m.$if)(u.location)&&u.location)&&((0,m.$pf)(u.relativeLocation)||(0,m.$if)(u.relativeLocation))&&u.version&&(0,m.$if)(u.version)}function t(u){return u?(0,m.$if)(u.path)&&(0,m.$if)(u.scheme):!1}}),define(te[129],ie([0,1,23,8,37,17,14,44,152,2,13,9,4,19,204,70,12,7,171,36,123,120,203,16,6,5,24,3,74,81,41,40,202]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g,t,u,r,i,n,o,k,A,D,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.Translations=void 0;var L;(function(oe){function G(J,B){if(J===B)return!0;const U=Object.keys(J),N=new Set;for(const H of Object.keys(B))N.add(H);if(U.length!==N.size)return!1;for(const H of U){if(J[H]!==B[H])return!1;N.delete(H)}return N.size===0}oe.equals=G})(L||(e.Translations=L={})),e.$np=(0,r.$Ah)("IExtensionsScannerService");let T=class extends l.$jc{constructor(G,J,B,U,N,H,Q,x,ce,Y,R,j){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=J,this.r=B,this.s=U,this.t=N,this.u=H,this.w=Q,this.y=x,this.z=ce,this.C=Y,this.D=R,this.F=j,this.g=this.B(new o.$ed),this.onDidChangeCache=this.g.event,this.h=(0,f.$hg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ee,this.s,this.h)),this.m=this.B(this.F.createInstance(ee,this.s,this.h)),this.n=this.B(this.F.createInstance(se,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$zo)(this.w,this.y)),this.G}async scanAllExtensions(G,J,B){const[U,N]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(J)]),H=B?await this.scanExtensionsUnderDevelopment(G,[...U,...N]):[];return this.L(U,N,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const J=[];J.push(this.M(!!G.useCache,G.language)),J.push(this.N(G.language,!!G.checkControlFile));const[B,U]=await Promise.all(J);return this.J([...B,...U],0,G,!1)}async scanUserExtensions(G){const J=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const B=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(J,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,B),N=G.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let H;try{H=await N.scanExtensions(U)}catch(Q){if(Q instanceof A.$ip&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await N.scanExtensions(U);else throw Q}return H=await this.J(H,1,G,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(G,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===b.Schemas.file).map(async U=>{const N=await this.P(U,!1,1,!0,G.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(N)).map(Q=>(Q.type=J.find(x=>(0,E.$oo)(x.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,N)))}))).flat();return this.J(B,"development",G,!0)}return[]}async scanExistingExtension(G,J,B){const U=await this.P(G,!1,J,!0,B.language,!0,void 0),N=await this.n.scanExtension(U);return!N||!B.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(G,J,B){const U=await this.P(G,!1,J,!0,B.language,!0,void 0),N=await this.n.scanOneOrMultipleExtensions(U);return this.J(N,J,B,!0)}async scanMetadata(G){const J=(0,f.$hg)(G,"package.json"),B=(await this.w.readFile(J)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(G,J){const B=(0,f.$hg)(G,"package.json"),U=(await this.w.readFile(B)).value.toString(),N=JSON.parse(U);J.isMachineScoped=J.isMachineScoped||void 0,J.isBuiltin=J.isBuiltin||void 0,N.__metadata={...N.__metadata,...J},await this.w.writeFile((0,f.$hg)(G,"package.json"),M.$Ed.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof A.$ip&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$Ed.fromString(JSON.stringify([])))}catch(J){(0,u.$ik)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$8)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,J,B,U){return B.includeAllVersions||(G=this.L(J===0?G:void 0,J===1?G:void 0,J==="development"?G:void 0,await this.getTargetPlatform(),U)),B.includeInvalid||(G=G.filter(N=>N.isValid)),G.sort((N,H)=>{const Q=w.$_d(N.location.fsPath),x=w.$_d(H.location.fsPath);return Q<x?-1:Q>x?1:0})}L(G,J,B,U,N){const H=(x,ce,Y)=>{if(x.isValid&&!ce.isValid)return!1;if(x.isValid===ce.isValid){if(N&&y.gt(x.manifest.version,ce.manifest.version))return this.y.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(y.eq(x.manifest.version,ce.manifest.version)){if(x.type===0)return this.y.debug(`Skipping extension ${ce.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===U)return this.y.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return Y?this.y.warn(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`),!0},Q=new g.$Wl;return G?.forEach(x=>{const ce=Q.get(x.identifier.id);(!ce||H(ce,x,!1))&&Q.set(x.identifier.id,x)}),J?.forEach(x=>{const ce=Q.get(x.identifier.id);if(!ce&&G&&x.type===0){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!ce||H(ce,x,!1))&&Q.set(x.identifier.id,x)}),B?.forEach(x=>{const ce=Q.get(x.identifier.id);(!ce||H(ce,x,!0))&&Q.set(x.identifier.id,x),Q.set(x.identifier.id,x)}),[...Q.values()]}async M(G,J){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0),N=await(G&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",N.length),N}async N(G,J){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const U=J?await this.O():{},N=[],H=c.URI.file(w.$6d(w.$8d(b.$1f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of B){const ce=U[x.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":N.push((0,f.$hg)(H,x.name));break;default:N.push(c.URI.file(ce));break}}const Q=await Promise.all(N.map(async x=>this.n.scanExtension(await this.P(x,!1,0,!0,G,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,P.$Eb)(Q)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,J,B,U,N,H,Q){const x=await this.f(N??p.$v),ce=await this.Q(G),Y=J&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,R=Y?await this.Q(Y):void 0;return new z(G,ce,Y,R,J,Q,B,U,H,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,N,x)}async Q(G){try{const J=await this.w.stat(G);if(typeof J.mtime=="number")return J.mtime}catch{}}};e.$op=T,e.$op=T=ke([_(4,D.$Dk),_(5,A.$jp),_(6,u.$5j),_(7,i.$4i),_(8,$.$Hh),_(9,n.$jj),_(10,v.$Bk),_(11,r.$zh)],T);class z{constructor(G,J,B,U,N,H,Q,x,ce,Y,R,j,F,W,q){this.location=G,this.mtime=J,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=U,this.profile=N,this.profileScanOptions=H,this.type=Q,this.excludeObsolete=x,this.validate=ce,this.productVersion=Y,this.productDate=R,this.productCommit=j,this.devMode=F,this.language=W,this.translations=q}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,J){return(0,f.$ag)(G.location,J.location)&&G.mtime===J.mtime&&(0,f.$ag)(G.applicationExtensionslocation,J.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&G.profile===J.profile&&s.$Ym(G.profileScanOptions,J.profileScanOptions)&&G.type===J.type&&G.excludeObsolete===J.excludeObsolete&&G.validate===J.validate&&G.productVersion===J.productVersion&&G.productDate===J.productDate&&G.productCommit===J.productCommit&&G.devMode===J.devMode&&G.language===J.language&&L.equals(G.translations,J.translations)}}e.$pp=z;let se=class extends l.$jc{constructor(G,J,B,U,N){super(),this.f=G,this.g=J,this.h=B,this.j=U,this.m=N}async scanExtensions(G){const J=G.profile?await this.r(G):await this.n(G);let B={};if(G.excludeObsolete&&G.type===1)try{const U=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(U)}catch{}return(0,d.$vf)(B)?J:J.filter(U=>!B[E.$po.create(U).toString()])}async n(G){const J=await this.j.resolve(G.location);if(!J.children?.length)return[];const B=await Promise.all(J.children.map(async U=>{if(!U.isDirectory||G.type===1&&(0,f.$eg)(U.resource).indexOf(".")===0)return null;const N=new z(U.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(N)}));return(0,P.$Eb)(B).sort((U,N)=>U.location.path<N.location.path?-1:1)}async r(G){let J=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){J=J.filter(U=>!U.metadata?.isApplicationScoped);const B=await this.s(G.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,G);J.push(...B)}return J}async s(G,J,B){const U=await this.g.scanProfileExtensions(G,B.profileScanOptions);if(!U.length)return[];const N=await Promise.all(U.map(async H=>{if(J(H)){const Q=new z(H.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Q,H.metadata)}return null}));return(0,P.$Eb)(N)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,f.$hg)(G.location,"package.json"))){const J=await this.scanExtension(G);return J?[J]:[]}else return await this.scanExtensions(G)}catch(J){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,I.$8)(J)),[]}}async scanExtension(G,J){try{let B=await this.scanExtensionManifest(G.location);if(B){B.publisher||(B.publisher=g.$Ql),J=J??B.__metadata,delete B.__metadata;const U=(0,E.$to)(B.publisher,B.name),N=J?.id?{id:U,uuid:J.id}:{id:U},H=J?.isSystem?0:G.type,Q=H===0||!!J?.isBuiltin;B=await this.t(G.location,B,z.createNlsConfiguration(G));const x={type:H,identifier:N,manifest:B,location:G.location,isBuiltin:Q,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return G.validate?this.validate(x,G):x}}catch(B){G.type!==0&&this.m.error(B)}return null}validate(G,J){let B=!0;const U=(0,t.$Eo)(J.productVersion,J.productDate,J.location,G.manifest,G.isBuiltin);for(const[N,H]of U)N===m.default.Error&&(B=!1,this.m.error(this.z(J.location,H)));return G.isValid=B,G.validations=U,G}async scanExtensionManifest(G){const J=(0,f.$hg)(G,"package.json");let B;try{B=(await this.j.readFile(J)).value.toString()}catch(N){return(0,u.$ik)(N)!==1&&this.m.error(this.z(G,(0,a.localize)(0,null,J.path,N.message))),null}let U;try{U=JSON.parse(B)}catch{const H=[];(0,S.$Km)(B,H);for(const Q of H)this.m.error(this.z(G,(0,a.localize)(1,null,J.path,Q.offset,Q.length,(0,h.$lp)(Q.error))));return null}return(0,S.$Tm)(U)!=="object"?(this.m.error(this.z(G,(0,a.localize)(2,null,J.path))),null):U}async t(G,J,B){const U=await this.u(G,J,B);if(U)try{const N=[],H=await this.w(U.default,N);if(N.length>0)return N.forEach(x=>{this.m.error(this.z(G,(0,a.localize)(3,null,U.default?.path,(0,h.$lp)(x.error))))}),J;if((0,S.$Tm)(U)!=="object")return this.m.error(this.z(G,(0,a.localize)(4,null,U.default?.path))),J;const Q=U.values||Object.create(null);return(0,C.$mp)(this.m,J,Q,H)}catch{}return J}async u(G,J,B){const U=(0,f.$hg)(G,"package.nls.json"),N=(ce,Y)=>{Y.forEach(R=>{this.m.error(this.z(G,(0,a.localize)(5,null,ce?.path,(0,h.$lp)(R.error))))})},H=ce=>{this.m.error(this.z(G,(0,a.localize)(6,null,ce?.path)))},Q=`${J.publisher}.${J.name}`,x=B.translations[Q];if(x)try{const ce=c.URI.file(x),Y=(await this.j.readFile(ce)).value.toString(),R=[],j=(0,S.$Km)(Y,R);return R.length>0?(N(ce,R),{values:void 0,default:U}):(0,S.$Tm)(j)!=="object"?(H(ce),{values:void 0,default:U}):{values:j.contents?j.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let Y;try{Y=await this.y(G,B)}catch{return}if(!Y.localized)return{values:void 0,default:Y.original};try{const R=(await this.j.readFile(Y.localized)).value.toString(),j=[],F=(0,S.$Km)(R,j);return j.length>0?(N(Y.localized,j),{values:void 0,default:Y.original}):(0,S.$Tm)(F)!=="object"?(H(Y.localized),{values:void 0,default:Y.original}):{values:F,default:Y.original}}catch{return{values:void 0,default:Y.original}}}}async w(G,J){if(G)try{const B=(await this.j.readFile(G)).value.toString();return(0,S.$Km)(B,J)}catch{}}y(G,J){return new Promise((B,U)=>{const N=H=>{const Q=(0,f.$hg)(G,`package.nls.${H}.json`);this.j.exists(Q).then(x=>{x&&B({localized:Q,original:(0,f.$hg)(G,"package.nls.json")});const ce=H.lastIndexOf("-");ce===-1?B({localized:(0,f.$hg)(G,"package.nls.json"),original:null}):(H=H.substring(0,ce),N(H))})};if(J.devMode||J.pseudo||!J.language)return B({localized:(0,f.$hg)(G,"package.nls.json"),original:null});N(J.language)})}z(G,J){return`[${G.path}]: ${J}`}};se=ke([_(1,A.$jp),_(2,v.$Bk),_(3,u.$5j),_(4,i.$4i)],se);let ee=class extends se{constructor(G,J,B,U,N,H,Q){super(J,U,N,H,Q),this.G=G,this.H=B,this.D=this.B(new O.$Dg(3e3)),this.F=this.B(new o.$ed),this.onDidChangeCache=this.F.event}async scanExtensions(G){const J=this.M(G),B=await this.I(J);if(this.C=G,B&&B.input&&z.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",G.location.toString()),this.D.trigger(()=>this.L()),B.result.map(N=>(N.location=c.URI.revive(N.location),N));const U=await super.scanExtensions(G);return await this.J(J,{input:G,result:U}),U}async I(G){try{const J=await this.j.readFile(G),B=JSON.parse(J.value.toString());return{result:B.result,input:(0,k.$0g)(B.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",G.path,(0,I.$8)(J))}return null}async J(G,J){try{await this.j.writeFile(G,M.$Ed.fromString(JSON.stringify(J)))}catch(B){this.m.debug("Error while writing the extension cache file:",G.path,(0,I.$8)(B))}}async L(){if(!this.C)return;const G=this.M(this.C),J=await this.I(G);if(!J)return;const B=J.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$Ym(U,B))try{this.m.info("Invalidating Cache",B,U),await this.j.del(G),this.F.fire()}catch(N){this.m.error(N)}}M(G){const J=this.N(G);return this.h.extUri.joinPath(J.cacheHome,G.type===0?g.$Pl:g.$Ol)}N(G){return G.type===0?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(G.location,J.extensionsResource))??this.G:this.H.defaultProfile}};ee=ke([_(2,D.$Dk),_(3,A.$jp),_(4,v.$Bk),_(5,u.$5j),_(6,i.$4i)],ee);function ae(oe,G){const J=(0,E.$ro)(oe.manifest.publisher,oe.manifest.name);return{id:J,identifier:new g.$Ul(J),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:G,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$qp=ae;class ne extends T{constructor(G,J,B,U,N,H,Q,x,ce,Y,R,j){super(G,J,(0,f.$hg)(B,".vscode-oss-dev","extensions","control.json"),U,N,H,Q,x,ce,Y,R,j),this.R=(async()=>{if(p.$y)try{const F=await this.w.readFile(c.URI.file(p.$y));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(G){return this.R}}e.$rp=ne}),define(te[277],ie([0,1,5,41,40,25,81,16,36,7]),function(K,e,P,O,s,M,I,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;let b=class extends I.$kp{constructor(p,f,y,m,d,c){super(l.URI.file(p.extensionsPath),f,y,m,d,c)}};e.$hN=b,e.$hN=b=ke([_(0,h.$Ih),_(1,S.$5j),_(2,O.$Dk),_(3,s.$Bk),_(4,M.$8k),_(5,P.$4i)],b)}),define(te[278],ie([0,1,7,36,81,129,16,6,5,24,40,41]),function(K,e,P,O,s,M,I,S,h,l,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=void 0;let p=class extends M.$rp{constructor(y,m,d,c,a,$,E,g){super(P.URI.file(a.builtinExtensionsPath),P.URI.file(a.extensionsPath),a.userHome,y.defaultProfile,y,m,d,c,a,$,E,g)}};e.$K6b=p,e.$K6b=p=ke([_(0,w.$Dk),_(1,s.$jp),_(2,I.$5j),_(3,h.$4i),_(4,O.$Ih),_(5,l.$jj),_(6,b.$Bk),_(7,S.$zh)],p)}),define(te[279],ie([0,1,15,2,13,9,4,58,7,31,38,36,5,41]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z6b=void 0;let y=class extends O.$jc{constructor(d,c,a){super(),this.c=d,this.f=a,this.a=S.$Gh.forPaths(!I.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(d.appRoot),this.addValidFileRoot(d.extensionsPath),this.addValidFileRoot(c.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(d.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:d}=P.session;d.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(c,a)=>this.j(c,a)),d.protocol.interceptFileProtocol(s.Schemas.file,(c,a)=>this.h(c,a)),this.B((0,O.$hc)(()=>{d.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(d){const c=(0,M.$6d)(d);return this.a.get(c)?O.$jc.None:(this.a.set(c,!0),(0,O.$hc)(()=>this.a.delete(c)))}h(d,c){const a=h.URI.parse(d.url);return this.f.error(`Refused to load resource ${a.fsPath} from ${s.Schemas.file}: protocol (original URL: ${d.url})`),c({error:-3})}j(d,c){const a=this.m(d);let $;return this.c.crossOriginIsolated&&((0,M.$_d)(a)==="workbench.html"||(0,M.$_d)(a)==="workbench-dev.html"?$=s.COI.CoopAndCoep:$=s.COI.getHeadersFromQuery(d.url)),this.a.findSubstr(a)?c({path:a,headers:$}):this.b.has((0,M.$ae)(a).toLowerCase())?c({path:a}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${a} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),c({error:-3}))}m(d){const c=h.URI.parse(d.url),a=s.$1f.uriToFileUri(c);return(0,M.$6d)(a.fsPath)}createIPCObjectUrl(){let d;const c=h.URI.from({scheme:"vscode",path:(0,l.$3f)()}),a=c.toString(),$=async()=>d;return b.$MS.handle(a,$),this.f.trace(`IPC Object URL: Registered new channel ${a}.`),{resource:c,update:E=>d=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${a}.`),b.$MS.removeHandler(a)}}}};e.$Z6b=y,e.$Z6b=y=ke([_(0,w.$Ih),_(1,f.$Dk),_(2,p.$4i)],y)}),define(te[96],ie([0,1,8,3,2,65,12,111,6,41]),function(K,e,P,O,s,M,I,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Uo=e.$To=e.$So=void 0,e.$So="__$__isNewStorageMarker",e.$To="__$__targetStorageMarker",e.$Uo=(0,h.$Ah)("storageService");var b;(function(a){a[a.NONE=0]="NONE",a[a.SHUTDOWN=1]="SHUTDOWN"})(b||(e.WillSaveStateReason=b={}));var w;(function(a){a[a.APPLICATION=-1]="APPLICATION",a[a.PROFILE=0]="PROFILE",a[a.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var p;(function(a){a[a.USER=0]="USER",a[a.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function f(a){const $=a.get(e.$To);if($)try{return JSON.parse($)}catch{}return Object.create(null)}e.$Vo=f;class y extends s.$jc{static{this.a=60*1e3}constructor($={flushInterval:y.a}){super(),this.m=$,this.b=this.B(new O.$hd),this.c=this.B(new O.$hd),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$ed),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Rg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$kc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,E,g){return O.Event.filter(this.b.event,t=>t.scope===$&&(E===void 0||t.key===E),g)}n(){this.j.value=(0,P.$Vg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$ec)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,E){const{key:g,external:t}=E;if(g===e.$To){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:g,target:this.J($)[g],external:t})}w($){this.f.fire({reason:$})}get($,E,g){return this.P(E)?.get($,g)}getBoolean($,E,g){return this.P(E)?.getBoolean($,g)}getNumber($,E,g){return this.P(E)?.getNumber($,g)}getObject($,E,g){return this.P(E)?.getObject($,g)}storeAll($,E){this.y(()=>{for(const g of $)this.store(g.key,g.value,g.scope,g.target,E)})}store($,E,g,t,u=!1){if((0,I.$rf)(E)){this.remove($,g,u);return}this.y(()=>{this.z($,g,t),this.P(g)?.set($,E,u)})}remove($,E,g=!1){this.y(()=>{this.z($,E,void 0),this.P(E)?.delete($,g)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,E){const g=[],t=this.J($);for(const u of Object.keys(t))t[u]===E&&g.push(u);return g}z($,E,g,t=!1){const u=this.J(E);typeof g=="number"?u[$]!==g&&(u[$]=g,this.P(E)?.set(e.$To,JSON.stringify(u),t)):typeof u[$]=="number"&&(delete u[$],this.P(E)?.set(e.$To,JSON.stringify(u),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const E=this.P($);return E?f(E):Object.create(null)}isNew($){return this.getBoolean(e.$So,$)===!0}async flush($=b.NONE){this.f.fire({reason:$});const E=this.P(-1),g=this.P(0),t=this.P(1);switch($){case b.NONE:await P.Promises.settled([E?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await P.Promises.settled([E?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return c($,E,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,E){return this.w(b.NONE),(0,l.$Ck)($)?this.R($,E):this.S($,E)}M($,E){return!($.id===E.id||m(E)&&m($))}N($,E,g){this.y(()=>{const t=new Set;for(const[u,r]of $)t.add(u),E.get(u)!==r&&this.u(g,{key:u,external:!0});for(const[u]of E.items)t.has(u)||this.u(g,{key:u,external:!0})})}}e.$Wo=y;function m(a){return a.isDefault||!!a.useDefaultFlags?.globalState}e.$Xo=m;class d extends y{constructor(){super(),this.U=this.B(new S.$Qo(new S.$Ro,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Qo(new S.$Ro,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Qo(new S.$Ro,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Yo=d;async function c(a,$,E,g,t,u){const r=L=>{try{return JSON.parse(L)}catch{return L}},i=new Map,n=new Map;a.forEach((L,T)=>{i.set(T,L),n.set(T,r(L))});const o=new Map,k=new Map;$.forEach((L,T)=>{o.set(T,L),k.set(T,r(L))});const A=new Map,D=new Map;E.forEach((L,T)=>{A.set(T,L),D.set(T,r(L))}),console.group(g!==t?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const v=[];if(i.forEach((L,T)=>{v.push({key:T,value:L})}),console.table(v),console.groupEnd(),console.log(n),g!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];o.forEach((T,z)=>{L.push({key:z,value:T})}),console.table(L),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${u})`);const C=[];A.forEach((L,T)=>{C.push({key:T,value:L})}),console.table(C),console.groupEnd(),console.log(D)}e.$Zo=c}),define(te[280],ie([0,1,23,8,3,2,9,69,7,21,111,160,5,96,25,29,13]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e5b=e.$d5b=e.$c5b=e.$b5b=void 0;class c extends M.$jc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$ed),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$ed),this.onDidCloseStorage=this.c.event,this.f=this.B(new b.$Qo(new b.$Ro,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new O.$1g,this.whenInit=this.h.p,this.j=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===b.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(f.$So);i===void 0?r.set(f.$So,!0):i&&r.set(f.$So,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=b.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$ad(!1);await this.w(),r.stop(),r.elapsed()>c.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([o,k])=>({key:o,length:k.length})),(o,k)=>k.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=b.StorageState.Closed,await this.f.close()}}class a extends c{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,I.$8d)(this.z.globalStorageHome.with({scheme:d.Schemas.file}).fsPath,a.y)}constructor(r,i,n,o){super(n,o),this.z=r,this.C=i}async t(){return new b.$Qo(new w.$fT(this.path??w.$fT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}class $ extends a{constructor(r,i,n,o){super(r,i,n,o)}}e.$b5b=$;class E extends a{constructor(r,i,n,o){super(i.defaultProfile,r,n,o)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$$k,void 0)===void 0&&r.set(y.$$k,new Date().toUTCString());const n=r.get(y.$0k,void 0),o=new Date().toUTCString();r.set(y.$_k,typeof n>"u"?null:n),r.set(y.$0k,o)}}e.$c5b=E;class g extends c{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,I.$8d)(this.F.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,this.C.id,g.y)}constructor(r,i,n,o,k){super(n,k),this.C=r,this.D=i,this.F=o}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new b.$Qo(new w.$fT(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:w.$fT.IN_MEMORY_PATH,wasCreated:!0};const r=(0,I.$8d)(this.F.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,this.C.id),i=(0,I.$8d)(r,g.y);return await l.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,m.$Kh)(this.C)?i={folder:this.C.uri.toString()}:(0,m.$Ph)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,I.$8d)(r,g.z);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$d5b=g;class t extends c{get path(){}async t(){return new b.$Qo(new b.$Ro,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.$e5b=t}),define(te[281],ie([0,1,3,2,96]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M6b=void 0;class M extends O.$jc{constructor(S,h,l){super(),this.b=S,this.c=h,this.f=l;const b=this.B(new O.$kc);this.a=this.B(new P.$ed({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new O.$ic;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,l)=>(h?h.push(l.key):h=[l.key],h),100)(h=>this.h(h))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(h,l)=>{h||(h=new Map);let b=h.get(l.profile.id);return b||h.set(l.profile.id,b={profile:l.profile,keys:[],storage:l.storage}),b.keys.push(l.key),h},100)(h=>this.j(h))),S}h(S){const h=S.includes(s.$To)?[this.c.defaultProfile]:[],l=[];if(S=S.filter(b=>b!==s.$To),S.length){const b=(0,s.$Vo)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:S.map(w=>({key:w,scope:0,target:b[w]}))})}this.m(h,l)}j(S){const h=[],l=new Map;for(const[b,w]of S.entries()){w.keys.includes(s.$To)&&h.push(w.profile);const p=w.keys.filter(f=>f!==s.$To);if(p.length){const f=(0,s.$Vo)(w.storage.storage);l.set(b,{profile:w.profile,changes:p.map(y=>({key:y,scope:0,target:f[y]}))})}}this.m(h,[...l.values()])}m(S,h){(S.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:S})}listen(S,h,l){switch(h){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${h}`)}async call(S,h){throw new Error(`Call not found: ${h}`)}}e.$M6b=M}),define(te[282],ie([0,1,7,36,16,5,34,40,41,12,121]),function(K,e,P,O,s,M,I,S,h,l,b){"use strict";var w,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=e.$eN=void 0;let f=class extends h.$Gk{static{w=this}static{this.a="profileAssociationsMigration"}constructor(c,a,$,E,g){super($,E,a,g),this.U=c,this.W=$}O(){return this.U.getItem(w.b,[]).map(a=>({...a,location:(0,l.$if)(a.location)?this.w.extUri.joinPath(this.profilesHome,a.location):P.URI.revive(a.location)}))}Q(){const c=this.U.getItem(w.c,{});return this.U.getItem(w.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$eN=f,e.$eN=f=w=ke([_(0,I.$_M),_(1,S.$Bk),_(2,O.$Ih),_(3,s.$5j),_(4,M.$4i)],f);let y=p=class extends f{constructor(c,a,$,E,g){super(c,a,$,E,g),this.$=c}P(c){c.length?this.$.setItem(p.b,c.map(a=>({...a,location:this.w.extUri.basename(a.location)}))):this.$.removeItem(p.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(p.c,c):this.$.removeItem(p.c)}Q(){const c="workspaceAndProfileInfo",a=this.$.getItem(c,void 0);if(a){this.$.removeItem(c);const E=a.reduce((g,{workspace:t,profile:u})=>(g[P.URI.revive(t).toString()]=P.URI.revive(u).toString(),g),{});this.$.setItem(p.c,{workspaces:E})}const $=super.Q();return this.$.getItem(p.a,!1)||(this.R($),this.$.setItem(p.a,!0)),$}};e.$fN=y,e.$fN=y=p=ke([_(0,I.$aN),_(1,S.$Bk),_(2,O.$Ih),_(3,s.$5j),_(4,M.$4i)],y);let m=class extends y{constructor(c,a,$,E){super(new b.$dN(0,a,E,$),c,a,$,E)}async init(){return await this.$.init(),super.init()}};e.$gN=m,e.$gN=m=ke([_(0,S.$Bk),_(1,O.$Ih),_(2,s.$5j),_(3,M.$4i)],m)}),define(te[53],ie([0,1,36,16,6,5,40,41,282,34]),function(K,e,P,O,s,M,I,S,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g5b=e.$f5b=void 0,e.$f5b=(0,s.$Bh)(S.$Dk);let b=class extends h.$fN{constructor(p,f,y,m,d){super(p,f,y,m,d)}getAssociatedEmptyWindows(){const p=[];for(const f of this.C.emptyWindows.keys())p.push({id:f});return p}};e.$g5b=b,e.$g5b=b=ke([_(0,l.$aN),_(1,I.$Bk),_(2,P.$Ih),_(3,O.$5j),_(4,M.$4i)],b)}),define(te[130],ie([0,1,19,7,29]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B5b=e.$A5b=e.$z5b=void 0;async function M(h,l,b){for(const p of h){const f=p.openedWorkspace;if((0,s.$Ph)(f)){const y=await b(f);if(y){if(y.folders.some(m=>P.$$f.isEqualOrParent(l,m.uri)))return p}else if(P.$$f.isEqualOrParent(l,f.configPath))return p}}const w=h.filter(p=>(0,s.$Kh)(p.openedWorkspace)&&P.$$f.isEqualOrParent(l,p.openedWorkspace.uri));if(w.length)return w.sort((p,f)=>-(p.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.$z5b=M;function I(h,l){for(const b of h)if((0,s.$Ph)(b.openedWorkspace)&&P.$$f.isEqual(b.openedWorkspace.configPath,l)||(0,s.$Kh)(b.openedWorkspace)&&P.$$f.isEqual(b.openedWorkspace.uri,l))return b}e.$A5b=I;function S(h,l){const b=w=>l.some(p=>P.$$f.isEqual(O.URI.file(p),O.URI.file(w)));for(const w of h)if(w.config?.extensionDevelopmentPath?.some(p=>b(p)))return w}e.$B5b=S}),define(te[97],ie([0,1,32,44,138,46,13,9,4,19,7,6,60,29]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gU=e.$fU=e.$eU=e.$dU=e.$cU=e.$bU=e.$aU=e.$_T=e.$$T=e.$0T=void 0,e.$0T=(0,w.$Ah)("workspacesService");function y(D){return D.hasOwnProperty("workspace")}e.$$T=y;function m(D){return D.hasOwnProperty("folderUri")}e.$_T=m;function d(D){return D.hasOwnProperty("fileUri")}e.$aU=d;function c(D){return a(D)||$(D)}e.$bU=c;function a(D){const v=D;return typeof v?.path=="string"&&(!v.name||typeof v.name=="string")}function $(D){const v=D;return typeof v?.uri=="string"&&(!v.name||typeof v.name=="string")}function E(D,v,C,L,T){if(D.scheme!==L.scheme)return{name:C,uri:D.toString(!0)};let z=v?void 0:T.relativePath(L,D);if(z!==void 0)z.length===0?z=".":h.$i&&(z=g(z));else if(D.scheme===I.Schemas.file)z=D.fsPath,h.$i&&(z=g(z));else if(T.isEqualAuthority(D.authority,L.authority))z=D.path;else return{name:C,uri:D.toString(!0)};return{name:C,path:z}}e.$cU=E;function g(D){return D=(0,M.$eA)(D),(0,P.$Ef)(D)||(D=(0,P.$Bf)(D)),D}function t(D,v,C){const L=[],T=new Set,z=C.dirname(v);for(const se of D){let ee;if(a(se))se.path&&(ee=C.resolvePath(z,se.path));else if($(se))try{ee=b.URI.parse(se.uri),ee.path[0]!==S.$5d.sep&&(ee=ee.with({path:S.$5d.sep+ee.path}))}catch(ae){console.warn(ae)}if(ee){const ae=C.getComparisonKey(ee);if(!T.has(ae)){T.add(ae);const ne=se.name||C.basenameOrAuthority(ee);L.push(new f.$Uh({uri:ee,name:ne,index:L.length},se))}}}return L}e.$dU=t;function u(D,v,C,L,T){const z=r(v,D),se=T.dirname(v),ee=T.dirname(L),ae=[];for(const J of z.folders){const B=a(J)?T.resolvePath(se,J.path):b.URI.parse(J.uri);let U;C?U=!1:U=!a(J)||(0,S.$7d)(J.path),ae.push(E(B,U,J.name,ee,T))}const ne={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},oe=s.$vS(D,["folders"],ae,ne);let G=s.$yS(D,oe);return(0,l.$mg)(z.remoteAuthority,(0,p.$Nk)(L))&&(G=s.$yS(G,s.$uS(G,["remoteAuthority"],ne))),G}e.$eU=u;function r(D,v){const C=O.$Km(v);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(L=>c(L));else throw new Error(`${D} looks like an invalid workspace file.`);return C}function i(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function n(D){return typeof D.folderUri=="string"}function o(D){return typeof D.fileUri=="string"}function k(D,v){const C={workspaces:[],files:[]};if(D){const L=function(z,se){for(let ee=0;ee<z.length;ee++)try{se(z[ee],ee)}catch(ae){v.warn(`Error restoring recent entry ${JSON.stringify(z[ee])}: ${ae.toString()}. Skip entry.`)}},T=D;Array.isArray(T.entries)&&L(T.entries,z=>{const se=z.label,ee=z.remoteAuthority;i(z)?C.workspaces.push({label:se,remoteAuthority:ee,workspace:{id:z.workspace.id,configPath:b.URI.parse(z.workspace.configPath)}}):n(z)?C.workspaces.push({label:se,remoteAuthority:ee,folderUri:b.URI.parse(z.folderUri)}):o(z)&&C.files.push({label:se,remoteAuthority:ee,fileUri:b.URI.parse(z.fileUri)})})}return C}e.$fU=k;function A(D){const v={entries:[]};for(const C of D.workspaces)m(C)?v.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):v.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of D.files)v.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return v}e.$gU=A}),define(te[98],ie([0,1,72,13,4,19]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u5b=e.$t5b=e.$s5b=e.$r5b=void 0,e.$r5b=128/4;function I(l){function b(){let w=l.scheme===O.Schemas.file?(0,M.$8f)(l):l.toString();return s.$k||(w=w.toLowerCase()),(0,P.createHash)("md5").update(w).digest("hex")}return{id:b(),configPath:l}}e.$s5b=I;function S(l,b){function w(){if(l.scheme!==O.Schemas.file)return(0,P.createHash)("md5").update(l.toString()).digest("hex");if(!b)return;let f;return s.$k?f=b.ino:s.$j?f=b.birthtime.getTime():s.$i&&(typeof b.birthtimeMs=="number"?f=Math.floor(b.birthtimeMs):f=b.birthtime.getTime()),(0,P.createHash)("md5").update(l.fsPath).update(f?String(f):"").digest("hex")}const p=w();if(typeof p=="string")return{id:p,uri:l}}e.$t5b=S;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$u5b=h}),define(te[99],ie([0,1,72,87,27,283,17,14,3,2,9,4,31,42,109]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0;class m{traceSocketEvent(v,C){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,C)}constructor(v,C=""){this.f=!0,this.debugLabel=C,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,S.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const C=L=>{this.traceSocketEvent("read",L),v(I.$Ed.wrap(L))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(v){const C=L=>{v({type:0,hadError:L,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(v){const C=()=>{v()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,S.$Y)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,S.$Y)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$ph=m;var d;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var c;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(c||(c={}));class a extends l.$jc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,C){this.socket.traceSocketEvent(v,C)}constructor(v,C,L,T){super(),this.f=this.B(new h.$ed),this.g=this.B(new h.$ed),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:L?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new $(this,C,L,T,this.f,(z,se)=>this.m(z,se))),this.B(this.a.onError(z=>{console.error(z),(0,S.$Y)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new y.$kh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let C=0;for(;C<v.byteLength;)this.a.writeMessage(v.slice(C,Math.min(C+262144,v.byteLength))),C+=262144}m(v,C){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let L=2;v.byteLength<126?L+=0:v.byteLength<2**16?L+=2:L+=8;const T=I.$Ed.alloc(L);if(C?T.writeUInt8(194,0):T.writeUInt8(130,0),v.byteLength<126)T.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){T.writeUInt8(126,1);let z=1;T.writeUInt8(v.byteLength>>>8&255,++z),T.writeUInt8(v.byteLength>>>0&255,++z)}else{T.writeUInt8(127,1);let z=1;T.writeUInt8(0,++z),T.writeUInt8(0,++z),T.writeUInt8(0,++z),T.writeUInt8(0,++z),T.writeUInt8(v.byteLength>>>24&255,++z),T.writeUInt8(v.byteLength>>>16&255,++z),T.writeUInt8(v.byteLength>>>8&255,++z),T.writeUInt8(v.byteLength>>>0&255,++z)}this.socket.write(I.$Ed.concat([T,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),L=C.readUInt8(0),T=(L&128)>>>7,z=(L&64)>>>6,se=C.readUInt8(1),ee=(se&128)>>>7,ae=se&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(ae===126?2:0)+(ae===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),L=C.readUInt8(1),T=(L&128)>>>7;let z=L&127,se=1;z===126?z=C.readUInt8(++se)*2**8+C.readUInt8(++se):z===127&&(z=C.readUInt8(++se)*0+C.readUInt8(++se)*0+C.readUInt8(++se)*0+C.readUInt8(++se)*0+C.readUInt8(++se)*2**24+C.readUInt8(++se)*2**16+C.readUInt8(++se)*2**8+C.readUInt8(++se));let ee=0;T&&(ee=C.readUInt8(++se)*2**24+C.readUInt8(++se)*2**16+C.readUInt8(++se)*2**8+C.readUInt8(++se)),this.j.state=3,this.j.readLen=z,this.j.mask=ee,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(C,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$qh=a;class $ extends l.$jc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$Ed.alloc(0)}constructor(v,C,L,T,z,se){super(),this.n=v,this.r=z,this.s=se,this.a=this.B(new h.$ed),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$ed),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$ed),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new E(this.n,T,L,{windowBits:15})),this.f=this.B(new g(this.n,{windowBits:15})),this.B(this.b.onError(ee=>this.a.fire(ee))),this.B(this.f.onError(ee=>this.a.fire(ee)))):(this.b=null,this.f=null)}writeMessage(v){this.g.push(v),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const v=this.g.shift();if(this.f){const C=await this.w(this.f,v);this.s(C,!0)}else this.s(v,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,C){return new Promise((L,T)=>{v.write(C),v.flush(z=>L(z))})}acceptFrame(v,C,L){this.h.push({data:v,isCompressed:C,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const C=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,C,L){return new Promise((T,z)=>{v.write(C),L&&v.write(I.$Ed.fromByteArray([0,0,255,255])),v.flush(se=>T(se))})}}class E extends l.$jc{get recordedInflateBytes(){return this.j?I.$Ed.concat(this.f):I.$Ed.alloc(0)}constructor(v,C,L,T){super(),this.h=v,this.j=C,this.a=this.B(new h.$ed),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(T),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(I.$Ed.wrap(z))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent("zlibInflateWrite",v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=I.$Ed.concat(this.g);this.g.length=0,v(C)})}}class g extends l.$jc{constructor(v,C){super(),this.g=v,this.a=this.B(new h.$ed),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(I.$Ed.wrap(L))})}write(v){this.g.traceSocketEvent("zlibDeflateWrite",v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=I.$Ed.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),v(C)})}}function t(D,v){if(v===0)return;const C=D.byteLength>>>2;for(let ae=0;ae<C;ae++){const ne=D.readUInt32BE(ae*4);D.writeUInt32BE(ne^v,ae*4)}const L=C*4,T=D.byteLength-L,z=v>>>24&255,se=v>>>16&255,ee=v>>>8&255;T>=1&&D.writeUInt8(D.readUInt8(L)^z,L),T>=2&&D.writeUInt8(D.readUInt8(L+1)^se,L+1),T>=3&&D.writeUInt8(D.readUInt8(L+2)^ee,L+2)}e.$rh=process.env.XDG_RUNTIME_DIR;const u={[2]:107,[1]:103};function r(){const D=(0,p.$3f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const v=process.platform!=="darwin"&&e.$rh?e.$rh:(0,s.tmpdir)(),C=(0,b.$8d)(v,`vscode-ipc-${D}.sock`);return n(C),C}e.$sh=r;function i(D,v,C){const L=(0,P.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${C}-${v}-sock`;const T=C.substr(0,4),z=v.substr(0,6),se=L.substr(0,8);let ee;return process.platform!=="darwin"&&e.$rh&&!process.env.VSCODE_PORTABLE?ee=(0,b.$8d)(e.$rh,`vscode-${se}-${T}-${z}.sock`):ee=(0,b.$8d)(D,`${T}-${z}.sock`),n(ee),ee}e.$th=i;function n(D){const v=u[w.$t];typeof v=="number"&&D.length>=v&&console.warn(`WARNING: IPC handle "${D}" is longer than ${v} chars, try a shorter --user-data-dir`)}class o extends f.$eh{static b(v){const C=h.Event.fromNodeEventEmitter(v,"connection");return h.Event.map(C,L=>({protocol:new y.$lh(new m(L,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(L,"close"))}))}constructor(v){super(o.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$uh=o;function k(D){return new Promise((v,C)=>{const L=(0,O.createServer)();L.on("error",C),L.listen(D,()=>{L.removeListener("error",C),v(new o(L))})})}e.$vh=k;function A(D,v){return new Promise((C,L)=>{const T=(0,O.createConnection)(D,()=>{T.removeListener("error",L),C(y.$mh.fromSocket(new m(T,`ipc-client${v}`),v))});T.once("error",L)})}e.$wh=A}),define(te[28],ie([0,1,55,9,4,99,36,89,6]),function(K,e,P,O,s,M,I,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$4b=e.$04b=void 0,e.$04b=(0,h.$Bh)(I.$Hh);class l extends S.$$l{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,O.$8d)(this.userDataPath,"clp")}get backupHome(){return(0,O.$8d)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$th)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,O.$8d)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const w in process.env)if(w.endsWith("_VSCODE_SNAP_ORIG")){const p=w.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[w]?process.env[p]=process.env[w]:delete process.env[p]}}}restoreSnapExportedVariables(){if(s.$k)for(const w in this.d)process.env[w]=this.d[w],delete this.d[w]}}e.$$4b=l,ke([P.$5g],l.prototype,"cachedLanguagesPath",null),ke([P.$5g],l.prototype,"backupHome",null),ke([P.$5g],l.prototype,"mainIPCHandle",null),ke([P.$5g],l.prototype,"mainLockfile",null),ke([P.$5g],l.prototype,"disableUpdates",null),ke([P.$5g],l.prototype,"crossOriginIsolated",null),ke([P.$5g],l.prototype,"codeCachePath",null),ke([P.$5g],l.prototype,"useCodeCache",null)}),define(te[284],ie([0,1,72,32,13,9,4,19,21,195,18,28,34,16,5,194,29,98]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$v5b=void 0;let $=class{static{a=this}static{this.a="backupWorkspaces"}constructor(g,t,u,r){this.j=g,this.k=t,this.l=u,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$$f,this.i={isEqual:(i,n)=>(0,O.$Gf)(i,n,!I.$k)}}async initialize(){const g=this.m.getItem(a.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(g.emptyWindows),this.d=await this.u((0,l.$o5b)(g)),this.e=await this.v((0,l.$p5b)(g)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.$qk.OFF}q(){return this.s()===f.$qk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.$qk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(g,t){this.d.some(r=>g.workspace.id===r.workspace.id)||(this.d.push(g),this.C());const u=(0,M.$8d)(this.c,g.workspace.id);return t?this.t(u,t).then(()=>u):u}async t(g,t){if(await h.Promises.exists(g)&&await this.z(g),await h.Promises.exists(t))try{await h.Promises.rename(t,g,!1)}catch(u){this.l.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}registerFolderBackup(g){return this.e.some(t=>this.h.isEqual(g.folderUri,t.folderUri))||(this.e.push(g),this.C()),(0,M.$8d)(this.c,this.D(g))}registerEmptyWindowBackup(g){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,g.backupFolder))||(this.g.push(g),this.C()),(0,M.$8d)(this.c,g.backupFolder)}async u(g){if(!Array.isArray(g))return[];const t=new Set,u=[];for(const r of g){const i=r.workspace;if(!(0,d.$Ph)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$8d)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?u.push(r):await this.z(n):await this.x(n)}}return u}async v(g){if(!Array.isArray(g))return[];const t=[],u=new Set;for(const r of g){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!u.has(n)){u.add(n);const o=(0,M.$8d)(this.c,this.D(r));await this.B(o)?i.scheme!==s.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(r):await this.z(o):await this.x(o)}}return t}async w(g){if(!Array.isArray(g))return[];const t=[],u=new Set;for(const r of g){const i=r.backupFolder;if(typeof i!="string")return[];if(!u.has(i)){u.add(i);const n=(0,M.$8d)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(g){try{await h.Promises.rm(g,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let g=(0,c.$u5b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,g.id));)g=(0,c.$u5b)();return{backupFolder:g.id}}async z(g){const t=this.y(),u=(0,M.$8d)(this.c,t.backupFolder);try{await h.Promises.rename(g,u,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const g=[];for(const t of this.d)await this.A(t)&&g.push(t);for(const t of this.e)await this.A(t)&&g.push(t);return g}A(g){let t;return(0,l.$n5b)(g)?t=(0,M.$8d)(this.c,g.backupFolder):(0,m.$8T)(g)?t=(0,M.$8d)(this.c,this.D(g)):t=(0,M.$8d)(this.c,g.workspace.id),this.B(t)}async B(g){try{const t=await h.Promises.readdir(g);for(const u of t)try{if((await h.Promises.readdir((0,M.$8d)(g,u))).length>0)return!0}catch{}}catch{}return!1}C(){const g={workspaces:this.d.map(({workspace:t,remoteAuthority:u})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return u&&(r.remoteAuthority=u),r}),folders:this.e.map(({folderUri:t,remoteAuthority:u})=>{const r={folderUri:t.toString()};return u&&(r.remoteAuthority=u),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:u})=>{const r={backupFolder:t};return u&&(r.remoteAuthority=u),r})};this.m.setItem(a.a,g)}D(g){const t=g.folderUri;let u;return t.scheme===s.Schemas.file?u=I.$k?t.fsPath:t.fsPath.toLowerCase():u=t.toString().toLowerCase(),(0,P.createHash)("md5").update(u).digest("hex")}};e.$v5b=$,e.$v5b=$=a=ke([_(0,w.$04b),_(1,b.$7h),_(2,y.$4i),_(3,p.$aN)],$)}),define(te[20],ie([0,1,15,38,8,3,2,4,35,12,6,5,34,28]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$a5b=e.LifecycleMainPhase=e.ShutdownReason=e.$_4b=void 0,e.$_4b=(0,b.$Ah)("lifecycleMainService");var m;(function(a){a[a.QUIT=1]="QUIT",a[a.KILL=2]="KILL"})(m||(e.ShutdownReason=m={}));var d;(function(a){a[a.Starting=1]="Starting",a[a.Ready=2]="Ready",a[a.AfterWindowOpen=3]="AfterWindowOpen",a[a.Eventually=4]="Eventually"})(d||(e.LifecycleMainPhase=d={}));let c=class extends I.$jc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor($,E,g){super(),this.F=$,this.G=E,this.H=g,this.c=this.B(new M.$ed),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$ed),this.onWillShutdown=this.f.event,this.g=this.B(new M.$ed),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$ed),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const $=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.t===0&&this.L(1))};P.app.addListener("before-quit",$);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$j)&&P.app.quit()};P.app.addListener("window-all-closed",E),P.app.once("will-quit",g=>{this.S("Lifecycle#app.on(will-quit) - begin"),g.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",$),P.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L($){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const g=[];return this.f.fire({reason:$,join(t,u){E.trace(`Lifecycle#onWillShutdown - begin '${t}'`),g.push(u.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(g)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase($){if($<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===$)return;this.S(`lifecycle (main): phase changed (value: ${$})`),this.n=$;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when($){if($<=this.n)return;let E=this.C.get($);E||(E=new s.$Eg,this.C.set($,E)),await E.wait()}registerWindow($){const E=new I.$ic;this.t++,E.add($.onWillLoad(t=>this.g.fire({window:$,workspace:t.workspace,reason:t.reason})));const g=(0,l.$tf)($.win);g.on("close",t=>{const u=$.id;if(this.r.has(u)){this.r.delete(u);return}this.S(`Lifecycle#window.on('close') - window ID ${$.id}`),t.preventDefault(),this.unload($,1).then(r=>{if(r){this.r.delete(u);return}this.r.add(u),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${u}`),this.h.fire($),$.close()})}),g.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${$.id}`),this.t--,E.dispose(),this.t===0&&(!S.$j||this.j)&&this.L(1)})}async reload($,E){await this.unload($,3)||$.reload(E)}unload($,E){const g=this.z.get($.id);if(g)return g;const t=this.M($,E).finally(()=>{this.z.delete($.id)});return this.z.set($.id,t),t}async M($,E){if(!$.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${$.id}`);const g=this.j?2:E,t=await this.P($,g);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${$.id})`),this.N(t)):(await this.Q($,g),!1)}N($){return $?(this.O(!0),this.j=!1,!0):!1}O($){this.w&&(this.w($),this.w=void 0,this.u=void 0)}P($,E){return new Promise(g=>{const t=this.s++,u=`vscode:ok${t}`,r=`vscode:cancel${t}`;O.$MS.once(u,()=>{g(!1)}),O.$MS.once(r,()=>{g(!0)}),$.send("vscode:onBeforeUnload",{okChannel:u,cancelChannel:r,reason:E})})}Q($,E){return new Promise(g=>{const u=`vscode:reply${this.s++}`;O.$MS.once(u,()=>g()),$.send("vscode:onWillUnload",{replyChannel:u,reason:E})})}quit($){return this.R($).then(E=>{if(!E&&$)try{if(S.$i){const g=(0,h.cwd)();g!==process.cwd()&&process.chdir(g)}}catch(g){this.F.error(g)}return E})}R($){return this.S(`Lifecycle#quit() - begin (willRestart: ${$})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):($&&this.G.setItem(y.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S($){this.H.args["enable-smoke-test-driver"]?this.F.info($):this.F.trace($)}setRelaunchHandler($){this.D=$}async relaunch($){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if($?.addArgs&&E.push(...$.addArgs),$?.removeArgs)for(const u of $.removeArgs){const r=E.indexOf(u);r>=0&&E.splice(r,1)}const g=()=>{this.D?.handleRelaunch($)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:E}))};P.app.once("quit",g),await this.quit(!0)&&P.app.removeListener("quit",g)}async kill($){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Gg)(1e3),(async()=>{for(const E of P.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let g;E.webContents&&!E.webContents.isDestroyed()?g=new Promise(t=>E.once("closed",t)):g=Promise.resolve(),E.destroy(),await g}})()]),P.app.exit($)}};e.$a5b=c,e.$a5b=c=y=ke([_(0,w.$4i),_(1,p.$aN),_(2,f.$04b)],c)}),define(te[285],ie([0,1,4,3,2,6,20]),function(K,e,P,O,s,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$35b=e.$25b=void 0,e.$25b=(0,M.$Ah)("keyboardLayoutMainService");let S=class extends s.$jc{constructor(b){super(),this.a=this.B(new O.$ed),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((w,p)=>{K(["native-keymap"],w,p)});this.c=h(b),P.$s||b.onDidChangeKeyboardLayout(()=>{this.c=h(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$35b=S,e.$35b=S=ke([_(0,I.$_4b)],S);function h(l){const b=l.getKeyMap(),w=l.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:w}}}),define(te[286],ie([0,1,245,8,17,14,12,18,36,94,5,51,244,283]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=e.$Nq=void 0;let y=class extends w.$Io{constructor(a,$,E,g){super(g),this.m=a,this.n=$,this.r=E,this.s(),this.B(a.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const a=this.m.getValue("http");this.f=a?.proxy,this.g=!!a?.proxyStrictSSL,this.h=a?.proxyAuthorization}async request(a,$){const{f:E,g}=this;let t;try{t=await(0,l.$Ll)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$8)(i)))}const u={...process.env,...t},r=a.agent?a.agent:await(0,p.$Mq)(a.url||"",u,{proxyUrl:E,strictSSL:g});return a.agent=r,a.strictSSL=g,this.h&&(a.headers={...a.headers||{},"Proxy-Authorization":this.h}),this.c(a.isChromiumNetwork?"electron":"node",a,()=>d(a,$))}async resolveProxy(a){}};e.$Nq=y,e.$Nq=y=ke([_(0,S.$7h),_(1,h.$Ih),_(2,b.$4i),_(3,b.$5i)],y);async function m(c){return((0,P.parse)(c.url).protocol==="https:"?await new Promise((E,g)=>{K(["https"],E,g)}):await new Promise((E,g)=>{K(["http"],E,g)})).request}async function d(c,a){return O.Promises.withAsyncBody(async($,E)=>{const g=(0,P.parse)(c.url),t=c.getRawRequest?c.getRawRequest(c):await m(c),u={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,I.$of)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(u.auth=c.user+":"+c.password);const r=t(u,i=>{const n=(0,I.$mf)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)d({...c,url:i.headers.location,followRedirects:n-1},a).then($,E);else{let o=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,f.createGunzip)())),$({res:i,stream:(0,s.$Td)(o)})}});r.on("error",E),c.timeout&&r.setTimeout(c.timeout),c.isChromiumNetwork&&r.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&r.write(c.data),r.end(),a.onCancellationRequested(()=>{r.abort(),E(new M.$3)})})}e.$Oq=d}),define(te[287],ie([0,1,15,286]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;function s(I){return P.net.request}class M extends O.$Nq{request(S,h){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},h)}}e.$56b=M}),define(te[82],ie([0,1,7,49,3,2,36,16,6,20,5,96,280,41,53,40,13]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k5b=e.$j5b=e.$i5b=e.$h5b=void 0,e.$h5b=(0,h.$Ah)("storageMainService");let c=class extends M.$jc{constructor(E,g,t,u,r,i){super(),this.c=E,this.f=g,this.g=t,this.h=u,this.j=r,this.m=i,this.a=void 0,this.b=this.B(new s.$ed),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(E=>{E.window.profile&&this.profileStorage(E.window.profile).init(),E.workspace&&this.workspaceStorage(E.workspace).init()})),this.B(this.h.onWillShutdown(E=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=E.reason,E.join("applicationStorage",this.applicationStorage.close());for(const[,g]of this.t)E.join("profileStorage",g.close());for(const[,g]of this.w)E.join("workspaceStorage",g.close())})),this.B(this.g.onWillCreateProfile(E=>{E.join((async()=>{await this.j.exists(E.profile.globalStorageHome)||await this.j.createFolder(E.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(E=>{const g=this.t.get(E.profile.id);g&&E.join(g.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const E=new p.$c5b(this.n(),this.g,this.c,this.j);return this.B((0,O.$bb)(E.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),E}profileStorage(E){if((0,w.$Xo)(E))return this.applicationStorage;let g=this.t.get(E.id);if(!g){this.c.trace(`StorageMainService: creating profile storage (${E.name})`),g=this.B(this.u(E)),this.t.set(E.id,g);const t=this.B(g.onDidChangeStorage(u=>this.b.fire({...u,storage:g,profile:E})));this.B((0,O.$bb)(g.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${E.name})`),this.t.delete(E.id),t.dispose()}))}return g}u(E){return this.a===2?new p.$e5b(this.c,this.j):new p.$b5b(E,this.n(),this.c,this.j)}workspaceStorage(E){let g=this.w.get(E.id);return g||(this.c.trace(`StorageMainService: creating workspace storage (${E.id})`),g=this.B(this.y(E)),this.w.set(E.id,g),this.B((0,O.$bb)(g.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${E.id})`),this.w.delete(E.id)}))),g}y(E){return this.a===2?new p.$e5b(this.c,this.j):new p.$d5b(E,this.n(),this.c,this.f,this.j)}isUsed(E){const g=P.URI.file(E);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(P.URI.file(t.path),g))return!0;return!1}};e.$i5b=c,e.$i5b=c=ke([_(0,b.$4i),_(1,I.$Hh),_(2,y.$f5b),_(3,l.$_4b),_(4,S.$5j),_(5,m.$Bk)],c),e.$j5b=(0,h.$Ah)("applicationStorageMainService");let a=class extends w.$Wo{constructor(E,g){super(),this.s=E,this.U=g,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(E){if(E===-1)return this.U.applicationStorage.storage}Q(E){if(E===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$k5b=a,e.$k5b=a=ke([_(0,f.$Dk),_(1,e.$h5b)],a)}),define(te[288],ie([0,1,15,22,3,57,2,31,115,5,82,30]),function(K,e,P,O,s,M,I,S,h,l,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m5b=void 0;var p;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let f=class extends I.$jc{constructor(m,d,c,a){super(),this.g=m,this.h=d,this.j=c,this.m=a,this.a="proxy-credentials://",this.b=void 0,this.c=p.Initial,this.f=void 0,this.n()}n(){const m=s.Event.fromNodeEventEmitter(P.app,"login",(d,c,a,$,E)=>({event:d,webContents:c,req:a,authInfo:$,callback:E}));this.B(m(this.r,this))}async r({event:m,authInfo:d,req:c,callback:a}){if(!d.isProxy)return;if(!this.b&&this.c===p.LoginDialogShown&&c.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let $;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),$=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(d);try{$=await this.b}finally{this.b=void 0}}a($?.username,$?.password)}async s(m){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const d=await this.t(m);if(d)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),d;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(m){this.g.trace("auth#doResolveProxyCredentials - enter",m);const d=String((0,M.$oi)({scheme:m.scheme,host:m.host,port:m.port}));let c,a;try{const t=this.m.get(this.a+d,-1);if(t){const u=JSON.parse(await this.j.decrypt(t));c=u.username,a=u.password}}catch(t){this.g.error(t)}if(this.c!==p.StoredCredentialsUsed&&typeof c=="string"&&typeof a=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=p.StoredCredentialsUsed,{username:c,password:a};const $=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!$){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${$.id} to handle proxy login`);const E={authInfo:m,username:this.f?.username??c,password:this.f?.password??a,replyChannel:`vscode:proxyAuthResponse:${(0,S.$3f)()}`};$.sendWhenReady("vscode:openProxyAuthenticationDialog",O.CancellationToken.None,E),this.c=p.LoginDialogShown;const g=await new Promise(t=>{const u=async(r,i,n)=>{if(i===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${$.id}`),$.win?.webContents.off("ipc-message",u),n){const o={username:n.username,password:n.password};try{if(n.remember){const k=await this.j.encrypt(JSON.stringify(o));this.m.store(this.a+d,k,-1,1)}else this.m.remove(this.a+d,-1)}catch(k){this.g.error(k)}t({username:o.username,password:o.password})}else t(void 0)};$.win?.webContents.on("ipc-message",u)});return this.f=g,g}};e.$m5b=f,e.$m5b=f=ke([_(0,l.$4i),_(1,w.$l5b),_(2,h.$uT),_(3,b.$j5b)],f)}),define(te[289],ie([0,1,87,27,103,99,8,2,4,18,5,24,240,241,95,126,17]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=e.$36b=e.$26b=e.$16b=void 0;async function c(t,u,r,i,n){let o;for(let k=3;k&&(o?.dispose(),o=await new a(t,u,r,i,n).waitForReady(),!(n&&s.$6f[n]||!s.$6f[o.tunnelLocalPort]));k--);return o}class a extends S.$jc{constructor(u,r,i,n,o){super(),this.m=r,this.n=o,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=u,this.b=P.createServer(),this.c=new I.$Eg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const u=this.n??this.tunnelRemotePort,r=(0,m.$3z)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$7f)(u,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(u){u.pause();const r=(0,m.$1z)(this.tunnelRemoteHost)||(0,m.$3z)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.$Yk)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&u.write(o.buffer),u.on("end",()=>{u.localAddress&&this.j.delete(u.localAddress),n.end()}),u.on("close",()=>n.end()),u.on("error",()=>{u.localAddress&&this.j.delete(u.localAddress),n instanceof M.$ph?n.socket.destroy():n.end()}),n instanceof M.$ph?this.t(u,n):this.s(u,n),u.localAddress&&this.j.set(u.localAddress,()=>{u.end(),n.end()})}s(u,r){r.onClose(()=>u.destroy()),r.onEnd(()=>u.end()),r.onData(i=>u.write(i.buffer)),u.on("data",i=>r.write(d.$Ed.wrap(i))),u.resume()}t(u,r){const i=r.socket;i.on("end",()=>u.end()),i.on("close",()=>u.end()),i.on("error",()=>{u.destroy()}),i.pipe(u),u.pipe(i)}}e.$16b=a;let $=class extends m.$6z{constructor(u,r,i,n,o){super(r,o),this.u=u,this.v=i,this.w=n}isPortPrivileged(u){return(0,m.$4z)(u,this.l,h.OS,O.release())}s(u,r,i,n,o,k,A,D){const v=this.r(r,i);if(v)return++v.refcount,v.value;if((0,m.$Xz)(u))return this.t(u,r,i,o,k,A,D);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${o}.`);const C={commit:this.w.commit,quality:this.w.quality,addressProvider:u,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=c(C,n,r,i,o);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,L),L}}};e.$26b=$,e.$26b=$=ke([_(0,f.$Sk),_(1,b.$4i),_(2,y.$Vk),_(3,w.$jj),_(4,l.$7h)],$);let E=class extends ${constructor(u,r,i,n,o){super(u,r,i,n,o)}};e.$36b=E,e.$36b=E=ke([_(0,f.$Sk),_(1,b.$4i),_(2,y.$Vk),_(3,w.$jj),_(4,l.$7h)],E);let g=class extends S.$jc{constructor(u,r,i,n,o){super(),this.b=u,this.c=r,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(u,r,i,n,o,k,A,D,v){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${k}.`),!this.a.has(u)){const C=new E(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(u,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(u))})}return this.a.get(u).openTunnel(r,i,n,o,k,A,D,v)}};e.$46b=g,e.$46b=g=ke([_(0,f.$Sk),_(1,b.$4i),_(2,w.$jj),_(3,y.$Vk),_(4,l.$7h)],g)}),define(te[100],ie([0,1,8,22,3,18,28,20,5,24,51,48]),function(K,e,P,O,s,M,I,S,h,l,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p6b=e.$o6b=void 0;function p(y,m,d){return`${d.updateUrl}/api/update/${y}/${m}/${d.commit}`}e.$o6b=p;let f=class{get state(){return this.b}d(m){this.j.info("update#setState",m.type),this.b=m,this.c.fire(m)}constructor(m,d,c,a,$,E){this.f=m,this.g=d,this.h=c,this.i=a,this.j=$,this.k=E,this.b=w.$LT.Uninitialized,this.c=new s.$ed,this.onStateChange=this.c.event,m.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(w.$LT.Disabled(0));return}if(this.h.disableUpdates){this.d(w.$LT.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(w.$LT.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.g.getValue("update.mode"),d=this.m(m);if(!d){this.d(w.$LT.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(d),!this.a){this.d(w.$LT.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(w.$LT.Idle(this.q())),m==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,c=>this.j.error(c))}m(m){return m==="none"?void 0:this.k.quality}n(m=60*60*1e3){return(0,P.$Gg)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(m){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(m)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(m){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},O.CancellationToken.None)).res.statusCode===204}catch(d){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(d);return}}async _applySpecificUpdate(m){}q(){return 1}r(){}};e.$p6b=f,e.$p6b=f=ke([_(0,S.$_4b),_(1,M.$7h),_(2,I.$04b),_(3,b.$Ho),_(4,h.$4i),_(5,l.$jj)],f)}),define(te[290],ie([0,1,15,55,3,2,18,28,20,5,24,51,25,48,100]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=void 0;let m=class extends y.$p6b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(c,a)=>a)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(c,a,$)=>({url:a,version:$,productVersion:$}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(c,a,$,E)=>({releaseNotes:a,version:$,productVersion:$,date:E}))}constructor(c,a,$,E,g,t,u){super(c,a,E,g,t,u),this.z=$,this.u=new M.$ic,c.setRelaunchHandler(this)}handleRelaunch(c){return c?.addArgs||c?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(c){this.j.error("UpdateService error:",c);const a=this.state.type==="checking for updates"&&this.state.explicit?c:void 0;this.d(f.$LT.Idle(1,a))}s(c){let a;this.k.darwinUniversalAssetId?a=this.k.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const $=(0,y.$o6b)(a,c,this.k);try{P.autoUpdater.setFeedURL({url:$})}catch(E){this.j.error("Failed to set update feed URL",E);return}return $}t(c){this.d(f.$LT.CheckingForUpdates(c)),P.autoUpdater.checkForUpdates()}E(c){this.state.type==="checking for updates"&&this.d(f.$LT.Downloading(c))}F(c){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:c.version}),this.d(f.$LT.Ready(c)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$LT.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$q6b=m,ke([O.$5g],m.prototype,"v",null),ke([O.$5g],m.prototype,"w",null),ke([O.$5g],m.prototype,"x",null),ke([O.$5g],m.prototype,"y",null),e.$q6b=m=ke([_(0,h.$_4b),_(1,I.$7h),_(2,p.$8k),_(3,S.$04b),_(4,w.$Ho),_(5,l.$4i),_(6,b.$jj)],m)}),define(te[291],ie([0,1,47,45,8,3,9,28,20,5,25,48]),function(K,e,P,O,s,M,I,S,h,l,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s6b=void 0;let p=class{get state(){return this.a}d(m){this.g.info("update#setState",m.type),this.a=m,this.b.fire(m)}constructor(m,d,c){if(this.f=m,this.g=c,this.a=w.$LT.Uninitialized,this.b=new M.$ed,this.onStateChange=this.b.event,d.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(w.$LT.Idle(this.k())),this.h(30*1e3).then(void 0,a=>this.g.error(a))}h(m=60*60*1e3){return(0,s.$Gg)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(m){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(m)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(m){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(m){}};p=ke([_(0,h.$_4b),_(1,S.$04b),_(2,l.$4i)],p);let f=class extends p{constructor(m,d,c,a,$,E){super(c,a,$),this.o=m,this.p=d,this.q=E;const g=(0,O.watch)(I.$$d(this.o)),t=M.Event.fromNodeEventEmitter(g,"change",(n,o)=>o),u=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(u,(n,o)=>o,2e3)(()=>this.checkForUpdates(!1));c.onWillShutdown(()=>{i.dispose(),g.close()})}m(){this.d(w.$LT.CheckingForUpdates(!1)),this.u().then(m=>{m?this.d(w.$LT.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$LT.Idle(2)))},m=>{this.g.error(m),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$LT.Idle(2,m.message||m))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+I.$_d(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const m=await new Promise((c,a)=>(0,O.realpath)(`${I.$$d(this.o)}/current`,($,E)=>$?a($):c(E))),d=I.$_d(m);return this.p!==d}isLatestVersion(){return this.u().then(void 0,m=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$s6b=f,e.$s6b=f=ke([_(2,h.$_4b),_(3,S.$04b),_(4,l.$4i),_(5,b.$8k)],f)}),define(te[292],ie([0,1,2,20,53,29,8,30]),function(K,e,P,O,s,M,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=void 0;let h=class extends P.$jc{constructor(b,w,p){super(),this.a=w,this.b=p,this.B(b.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(b.onBeforeCloseWindow(f=>this.c(f))),this.B(new I.$Rg(()=>this.g(),30*1e3)).schedule()}async c(b){const w=this.f(b),p=this.a.getProfileForWorkspace(w);p?.isTransient&&(this.a.unsetWorkspace(w,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,M.$Oh)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const w=this.b.getWindows().map(p=>this.f(p));for(const p of b)w.some(f=>f.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$L6b=h,e.$L6b=h=ke([_(0,O.$_4b),_(1,s.$f5b),_(2,S.$l5b)],h)}),define(te[62],ie([0,1,15,2,3,5,311,8,13,30,70,25,20,73,37,4,131]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$F5b=e.$E5b=void 0;function a(g){return typeof g.responseWindowId=="number"}let $=class extends O.$jc{static{c=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(c.b.values())}constructor(t,u,r){super(),this.t=t,this.u=u,this.w=r,this.c=String(++c.a),this.f=this.B(new s.$ed),this.onStdout=this.f.event,this.g=this.B(new s.$ed),this.onStderr=this.g.event,this.h=this.B(new s.$ed),this.onMessage=this.h.event,this.j=this.B(new s.$ed),this.onExit=this.j.event,this.m=this.B(new s.$ed),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(t,u){let r;switch(this.s?.correlationId?r=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`,u){case b.default.Error:this.t.error(r);break;case b.default.Warning:this.t.warn(r);break;case b.default.Info:this.t.trace(r);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",b.default.Error),!1):!0}start(t){const u=this.C(t);return u&&t.payload&&this.postMessage(t.payload),u}C(t){if(!this.z())return!1;this.s=t;const u=`${this.s.type}-${this.c}`,r=h.$1f.asFileUri("bootstrap-fork.js").fsPath,i=this.s.args??[],n=this.s.execArgv??[],o=this.s.allowLoadingUnsignedLibraries,k=this.s.forceAllocationsToV8Sandbox,A="pipe",D=this.D(t);return this.y("creating new...",b.default.Info),this.n=P.utilityProcess.fork(r,i,{serviceName:u,env:D,execArgv:n,allowLoadingUnsignedLibraries:o,forceAllocationsToV8Sandbox:k,stdio:A}),this.F(this.n,this.s,u),!0}D(t){const u=t.env?{...t.env}:{...(0,y.$Um)(process.env)};u.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(u.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),u.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,m.$i&&((0,d.isUNCAccessRestrictionsDisabled)()?u.NODE_DISABLE_UNC_ACCESS_CHECKS="1":u.NODE_UNC_HOST_ALLOWLIST=(0,d.getUNCHostAllowlist)().join("\\")),(0,f.$sl)(u);for(const r of Object.keys(u))u[r]=String(u[r]);return u}F(t,u,r){if(t.stdout){const i=new I.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new I.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.r=t.pid,typeof t.pid=="number"&&c.b.set(t.pid,{pid:t.pid,name:a(u)?`${u.type} [${u.responseWindowId}]`:u.type}),this.y("successfully created",b.default.Info)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.y(`received exit event with code ${i}`,b.default.Info),this.j.fire({pid:this.r,code:i,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.y(`crashed with code ${i.exitCode} and reason '${i.reason}'`,b.default.Error),this.u.publicLog2("utilityprocesscrash",{type:u.type,reason:i.reason,code:i.exitCode}),this.m.fire({pid:this.r,code:i.exitCode,reason:i.reason}),this.G())}))}once(t,u){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),u())}))}postMessage(t,u){this.n&&this.n.postMessage(t,u)}connect(t){const{port1:u,port2:r}=new P.MessageChannelMain;return this.postMessage(t,[r]),u}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",b.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",b.default.Info),this.n.kill()?(this.y("successfully killed the process",b.default.Info),this.G()):this.y("unable to kill the process",b.default.Warning)}G(){typeof this.r=="number"&&c.b.delete(this.r),this.n=void 0}async waitForExit(t){this.n&&(this.y("waiting to exit...",b.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$Gg)(t)]),this.n&&(this.y(`did not exit within ${t}ms, will kill it now...`,b.default.Info),this.kill()))}};e.$E5b=$,e.$E5b=$=c=ke([_(0,M.$4i),_(1,w.$8k),_(2,p.$_4b)],$);let E=class extends ${constructor(t,u,r,i){super(t,r,i),this.H=u}start(t){const u=this.H.getWindowById(t.responseWindowId);if(!u?.win||u.win.isDestroyed()||u.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",b.default.Error),!0;if(!super.C(t))return!1;this.I(u.win,t);const i=this.connect(t.payload);return u.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}I(t,u){u.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$F5b=E,e.$F5b=E=ke([_(0,M.$4i),_(1,l.$l5b),_(2,w.$8k),_(3,p.$_4b)],E)}),define(te[293],ie([0,1,14,5,20,8,62,30,25]),function(K,e,P,O,s,M,I,S,h){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$N5b=void 0;let b=class{static{l=this}static{this.a=0}constructor(p,f,y,m){this.d=p,this.f=f,this.g=y,this.h=m,this.b=new Map,this.c=!1,this.f.onWillShutdown(d=>{this.c=!0,d.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(p){const f=this.b.get(p);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(p){return this.i(p).onStdout}onDynamicStderr(p){return this.i(p).onStderr}onDynamicMessage(p){return this.i(p).onMessage}onDynamicExit(p){return this.i(p).onExit}async createExtensionHost(){if(this.c)throw(0,P.$4)();const p=String(++l.a),f=new I.$F5b(this.d,this.g,this.h,this.f);return this.b.set(p,f),f.onExit(({pid:y,code:m,signal:d})=>{this.d.info(`Extension host with pid ${y} exited with code: ${m}, signal: ${d}.`),setTimeout(()=>{f.dispose(),this.b.delete(p)})}),{id:p}}async start(p,f){if(this.c)throw(0,P.$4)();this.i(p).start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:p})}async enableInspectPort(p){if(this.c)throw(0,P.$4)();const f=this.b.get(p);return f?f.enableInspectPort():!1}async kill(p){if(this.c)throw(0,P.$4)();const f=this.b.get(p);f&&f.kill()}async _killAllNow(){for(const[,p]of this.b)p.kill()}async _waitForAllExit(p){const f=[];for(const[,y]of this.b)f.push(y.waitForExit(p));return M.Promises.settled(f).then(()=>{})}};e.$N5b=b,e.$N5b=b=l=ke([_(0,O.$4i),_(1,s.$_4b),_(2,S.$l5b),_(3,h.$8k)],b)}),define(te[294],ie([0,1,38,8,2,28,20,5,41,39,66,62,52,89,12,246,24]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i6b=void 0;let c=class extends s.$jc{constructor($,E,g,t,u,r,i,n){super(),this.c=$,this.f=E,this.g=g,this.h=t,this.j=u,this.m=r,this.n=i,this.r=n,this.a=new O.$Eg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$MS.on(m.$g6b.request,($,E)=>this.t($,E,m.$g6b.response)),P.$MS.on(m.$h6b.request,($,E)=>this.t($,E,m.$h6b.response)),this.B(this.h.onWillShutdown(()=>this.u()))}async t($,E,g){this.j.trace(`[SharedProcess] onWindowConnection for: ${g}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(g);if($.sender.isDestroyed())return t.close();$.sender.postMessage(g,E,[t])}u(){this.j.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(m.$f6b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const $=new O.$1g;this.b?this.b.once(m.$f6b.initDone,()=>$.complete()):P.$MS.once(m.$f6b.initDone,()=>$.complete()),await $.p,this.j.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const $=new O.$1g;this.b?this.b.once(m.$f6b.ipcReady,()=>$.complete()):P.$MS.once(m.$f6b.ipcReady,()=>$.complete()),await $.p,this.j.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new w.$E5b(this.j,p.$ao,this.h));const $=(0,f.$am)(this.f.args,this.f.isBuilt);let E;$.port&&(E=["--nolazy"],$.break?E.push(`--inspect-brk=${$.port}`):E.push(`--inspect=${$.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:E,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.r.quality!=="stable"})}D(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),policiesData:this.n.serialize()}}async connect($){return await this.z,(0,y.$tf)(this.b).connect($)}};e.$i6b=c,e.$i6b=c=ke([_(1,M.$04b),_(2,h.$Dk),_(3,I.$_4b),_(4,S.$4i),_(5,b.$d6b),_(6,l.$9m),_(7,d.$jj)],c)}),define(te[295],ie([0,1,28,89,20,5,52,62,110,38,2,3,37,18,13]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T6b=void 0;let m=class extends b.$jc{constructor(c,a,$,E,g){super(),this.f=c,this.g=a,this.h=$,this.j=E,this.m=g,this.a=void 0,this.b=new w.$ed,this.onRequestConnection=this.b.event,this.c=new w.$ed,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$MS.on("vscode:createPtyHostMessageChannel",(t,u)=>this.r(t,u)),this.B((0,b.$hc)(()=>{l.$MS.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$E5b(this.m,I.$ao,this.j);const c=(0,O.$_l)(this.h.args,this.h.isBuilt),a=c.port?["--nolazy",`--inspect${c.break?"-brk":""}=${c.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:a,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const $=this.a.connect(),E=new h.$US($,"ptyHost"),g=new b.$ic;return g.add(E),g.add((0,b.$hc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:g,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const c={...(0,p.$Um)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},a=this.g.getValue("terminal.integrated.developer.ptyHost.latency");a&&typeof a=="number"&&(c.VSCODE_LATENCY=String(a));const $=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return $&&typeof $=="number"&&(c.VSCODE_STARTUP_DELAY=String($)),this.h.restoreSnapExportedVariables(),c}r(c,a){this.b.fire();const $=this.a.connect();if(c.sender.isDestroyed()){$.close();return}c.sender.postMessage("vscode:createPtyHostMessageChannelResult",a,[$])}};e.$T6b=m,e.$T6b=m=ke([_(1,f.$7h),_(2,P.$04b),_(3,s.$_4b),_(4,M.$4i)],m)}),define(te[296],ie([0,1,2,6,5,30,62,25,57,3,8,20]),function(K,e,P,O,s,M,I,S,h,l,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S6b=e.$R6b=void 0,e.$R6b=(0,O.$Ah)("utilityProcessWorker");let p=class extends P.$jc{constructor(m,d,c,a){super(),this.b=m,this.c=d,this.f=c,this.g=a,this.a=new Map}async createWorker(m){const d=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${d})`);const c=this.h(m);this.a.has(c)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${d})`),this.disposeWorker(m));const a=new f(this.b,this.c,this.f,this.g,m);if(!a.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(c,a);const $=new b.$1g;return l.Event.once(a.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(c),$.complete({reason:E})}),$.p}h(m){return(0,h.$oi)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const d=this.h(m),c=this.a.get(d);c&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),c.kill(),this.a.delete(d))}};e.$S6b=p,e.$S6b=p=ke([_(0,s.$4i),_(1,M.$l5b),_(2,S.$8k),_(3,w.$_4b)],p);let f=class extends P.$jc{constructor(m,d,c,a,$){super(),this.c=m,this.f=d,this.g=c,this.h=a,this.j=$,this.a=this.B(new l.$ed),this.onDidTerminate=this.a.event,this.b=new I.$F5b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(m=>this.a.fire({code:m.code,signal:m.signal}))),this.B(this.b.onCrash(m=>this.a.fire({code:m.code,signal:"ECRASH"})))}spawn(){const d=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:d,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};f=ke([_(0,s.$4i),_(1,M.$l5b),_(2,S.$8k),_(3,w.$_4b)],f)}),define(te[297],ie([0,1,15,2,4,19,7,18,20,5,34,30,128,29]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=e.$D6b=e.$C6b=void 0;let m=class extends O.$jc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(g,t,u,r,i){super(),this.g=g,this.h=t,this.j=u,this.m=r,this.n=i,this.b=d(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(g=>this.u(g)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(g=>{g.newCount-g.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(g=>this.u(g))}s(){this.f=!0,this.t()}t(){const g=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&g.add(t.lastActiveWindow.uiState.display))}const u=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);u&&(t.lastPluginDevelopmentHostWindow=this.w(u),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(g.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!u.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):g.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(g.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):g.add(n.uiState.display)),n}));const r=a(t);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(g){if(this.j.quitRequested)return;const t=this.w(g);g.isExtensionDevelopmentHost&&!g.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!g.isExtensionDevelopmentHost&&g.openedWorkspace&&this.b.openedWindows.forEach(u=>{const r=(0,f.$Ph)(g.openedWorkspace)&&u.workspace?.id===g.openedWorkspace.id,i=(0,f.$Kh)(g.openedWorkspace)&&u.folderUri&&M.$$f.isEqual(u.folderUri,g.openedWorkspace.uri);(r||i)&&(u.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(g){return{windowId:g.id,workspace:(0,f.$Ph)(g.openedWorkspace)?g.openedWorkspace:void 0,folderUri:(0,f.$Kh)(g.openedWorkspace)?g.openedWorkspace.uri:void 0,backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.serializeWindowState()}}getNewWindowState(g){const t=this.z(g),u=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||u?.restoreFullscreen),r||(t.mode=1)}return t}z(g){const t=this.g.getLastActiveWindow();if(!g.extensionTestsPath){if(g.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const k=g.workspace;if((0,f.$Ph)(k)){const D=this.state.openedWindows.filter(v=>v.workspace&&v.workspace.id===k.id).map(v=>v.uiState);if(D.length)return D[0]}if((0,f.$Kh)(k)){const D=this.state.openedWindows.filter(v=>v.folderUri&&M.$$f.isEqual(v.folderUri,k.uri)).map(v=>v.uiState);if(D.length)return D[0]}else if(g.backupPath){const D=this.state.openedWindows.filter(v=>v.backupPath===g.backupPath).map(v=>v.uiState);if(D.length)return D[0]}const A=this.c||this.state.lastActiveWindow;if(!t&&A)return A.uiState}let u;const r=P.screen.getAllDisplays();if(r.length===1)u=r[0];else{if(s.$j){const k=P.screen.getCursorScreenPoint();u=P.screen.getDisplayNearestPoint(k)}!u&&t&&(u=P.screen.getDisplayMatching(t.getBounds())),u||(u=P.screen.getPrimaryDisplay()||r[0])}let i=(0,p.$94b)();i.x=Math.round(u.bounds.x+u.bounds.width/2-i.width/2),i.y=Math.round(u.bounds.y+u.bounds.height/2-i.height/2);const n=this.n.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const k=t.serializeWindowState();k.mode===3?i.mode=3:i=k,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.C(i)),i.hasDefaultState=!0,i}C(g){if(this.g.getWindows().length===0)return g;g.x=typeof g.x=="number"?g.x:0,g.y=typeof g.y=="number"?g.y:0;const t=this.g.getWindows().map(u=>u.getBounds());for(;t.some(u=>u.x===g.x||u.y===g.y);)g.x+=30,g.y+=30;return g}};e.$C6b=m,e.$C6b=m=y=ke([_(0,w.$l5b),_(1,b.$aN),_(2,h.$_4b),_(3,l.$4i),_(4,S.$7h)],m);function d(E){const g={openedWindows:[]},t=E||{openedWindows:[]};return t.lastActiveWindow&&(g.lastActiveWindow=c(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(g.lastPluginDevelopmentHostWindow=c(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(g.openedWindows=t.openedWindows.map(u=>c(u))),g}e.$D6b=d;function c(E){const g={uiState:E.uiState};return E.backupPath&&(g.backupPath=E.backupPath),E.remoteAuthority&&(g.remoteAuthority=E.remoteAuthority),E.folder&&(g.folderUri=I.URI.parse(E.folder)),E.workspaceIdentifier&&(g.workspace={id:E.workspaceIdentifier.id,configPath:I.URI.parse(E.workspaceIdentifier.configURIPath)}),g}function a(E){return{lastActiveWindow:E.lastActiveWindow&&$(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&$(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(g=>$(g))}}e.$E6b=a;function $(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(te[54],ie([0,1,15,3,44,2,13,9,19,21,193,64,61,28,6,5,53,130,29,97,98]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D5b=e.$C5b=void 0,e.$C5b=(0,y.$Ah)("workspacesManagementMainService");let g=class extends M.$jc{constructor(u,r,i,n,o){super(),this.g=u,this.h=r,this.j=i,this.m=n,this.n=o,this.a=this.B(new O.$ed),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new O.$ed),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const u=(await l.Promises.readdir(this.c.with({scheme:I.Schemas.file}).fsPath)).map(r=>(0,h.$hg)(this.c,r,a.$Zh));for(const r of u){const i=(0,E.$s5b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(u){u.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${u}).`)}}resolveLocalWorkspace(u){return this.r(u,r=>l.Promises.readFile(r,"utf8"))}r(u,r){if(this.s(u)&&u.scheme===I.Schemas.file)try{const i=r(u.fsPath);return i instanceof Promise?i.then(n=>this.t(u,n),n=>{}):this.t(u,i)}catch{return}}s(u){return(0,a.$1h)(u,this.g)||(0,a.$6h)(u)}t(u,r){try{const i=this.u(u,r),n=(0,E.$s5b)(u);return{id:n.id,configPath:n.configPath,folders:(0,$.$dU)(i.folders,n.configPath,h.$$f),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(u,r){const i=(0,s.$Km)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,$.$bU)(n));else throw new Error(`${u.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(u,r){const{workspace:i,storedWorkspace:n}=this.w(u,r),o=i.configPath.fsPath;return await l.Promises.mkdir((0,S.$$d)(o),{recursive:!0}),await l.Promises.writeFile(o,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(u=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,h.$hg)(this.c,i),o=(0,h.$hg)(n,a.$Zh),k=[];for(const A of u)k.push((0,$.$cU)(A.uri,!0,A.name,n,h.$$f));return{workspace:(0,E.$s5b)(o),storedWorkspace:{folders:k,remoteAuthority:r}}}async getWorkspaceIdentifier(u){return(0,E.$s5b)(u)}isUntitledWorkspace(u){return(0,a.$1h)(u.configPath,this.g)}async deleteUntitledWorkspace(u){this.isUntitledWorkspace(u)&&(await this.y(u),this.j.isEnabled()&&this.j.unsetWorkspace(u),this.a.fire(u))}async y(u){const r=(0,h.$8f)(u.configPath);try{await l.Promises.rm((0,S.$$d)(r));const i=(0,S.$8d)(this.g.workspaceStorageHome.with({scheme:I.Schemas.file}).fsPath,u.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,S.$8d)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==u.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(u,r,i){if(!u||!u.win||!u.isReady||!await this.z(u,r,i))return;const o=await this.C(u,(0,E.$s5b)(i));if(o)return this.b.fire({window:u,workspace:o.workspace}),o}async z(u,r,i){return i?(0,a.$Ph)(u.openedWorkspace)&&h.$$f.isEqual(u.openedWorkspace.configPath,i)?!1:(0,c.$A5b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,b.localize)(0,null)],message:(0,b.localize)(1,null,(0,h.$eg)(i)),detail:(0,b.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(u,r){if(!u.config)return;u.focus();let i;return u.config.extensionDevelopmentPath||(u.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:u.remoteAuthority},u.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:u.remoteAuthority})),(0,a.$Ph)(u.openedWorkspace)&&this.isUntitledWorkspace(u.openedWorkspace)&&await this.deleteUntitledWorkspace(u.openedWorkspace),u.config.workspace=r,u.config.backupPath=i,{workspace:r,backupPath:i}}};e.$D5b=g,e.$D5b=g=ke([_(0,f.$04b),_(1,m.$4i),_(2,d.$f5b),_(3,w.$q5b),_(4,p.$x5b)],g)}),define(te[132],ie([0,1,15,38,22,6,30,29,54,12,5,62]),function(K,e,P,O,s,M,I,S,h,l,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I5b=e.$H5b=e.ID=void 0,e.ID="diagnosticsMainService",e.$H5b=(0,M.$Ah)(e.ID);let p=class{constructor(y,m,d){this.a=y,this.b=m,this.c=d}async getRemoteDiagnostics(y){const m=this.a.getWindows();return(await Promise.all(m.map(async c=>{const a=c.remoteAuthority;if(!a)return;const $=`vscode:getDiagnosticInfoResponse${c.id}`,E={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(c):void 0};return new Promise(g=>{c.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:$,args:E}),O.$MS.once($,(t,u)=>{u||g({hostName:a,errorMessage:`Unable to resolve connection to '${a}'.`}),g(u)}),setTimeout(()=>{g({hostName:a,errorMessage:`Connection to '${a}' could not be established`})},5e3)})}))).filter(c=>!!c)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const d of P.BrowserWindow.getAllWindows()){const c=this.a.getWindowById(d.id);c?y.push(await this.d(c)):y.push(this.e(d))}const m=[];for(const{pid:d,name:c}of w.$E5b.getAll())m.push({pid:d,name:c});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:m,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(y){const m=await this.f(y),d=(0,l.$tf)(y.win);return this.e(d,m,y.remoteAuthority)}e(y,m=[],d){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:m,remoteAuthority:d}}async f(y){const m=[],d=y.openedWorkspace;if((0,S.$Kh)(d))m.push(d.uri);else if((0,S.$Ph)(d)){const c=await this.b.resolveLocalWorkspace(d.configPath);c&&c.folders.forEach($=>{m.push($.uri)})}return m}};e.$I5b=p,e.$I5b=p=ke([_(0,I.$l5b),_(1,h.$C5b),_(2,b.$4i)],p)}),define(te[67],ie([0,1,47,15,27,156,55,3,2,13,9,4,7,105,86,21,103,181,61,28,6,20,5,24,79,30,29,54,17,242,234]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g,t,u,r,i,n,o,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.$X5b=void 0,e.$X5b=(0,E.$Ah)("nativeHostMainService");let v=class extends h.$jc{constructor(L,T,z,se,ee,ae,ne,oe){super(),this.a=L,this.b=T,this.c=z,this.f=se,this.g=ee,this.h=ae,this.j=ne,this.m=oe,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,G=>G.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:G,x:J,y:B})=>({windowId:G.id,x:J,y:B})),({windowId:G})=>!!this.a.getWindowById(G)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-maximize",(G,J)=>J.id),G=>!!this.a.getWindowById(G)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-unmaximize",(G,J)=>J.id),G=>!!this.a.getWindowById(G)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-blur",(G,J)=>J.id),G=>!!this.a.getWindowById(G)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),G=>!!G),G=>G.id),S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-focus",(G,J)=>J.id),G=>!!this.a.getWindowById(G))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(O.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.n=this.B(new S.$ed),this.onDidChangePassword=this.n.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(O.screen,"display-metrics-changed",(G,J,B)=>B),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),S.Event.fromNodeEventEmitter(O.screen,"display-added"),S.Event.fromNodeEventEmitter(O.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(T=>({id:T.id,workspace:T.openedWorkspace??(0,n.$Oh)(T.backupPath,T.isExtensionDevelopmentHost),title:T.win?.getTitle()??"",filename:T.getRepresentedFilename(),dirty:T.isDocumentEdited()}))}async getWindowCount(L){return this.a.getWindowCount()}async getActiveWindowId(L){const T=O.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(L,T,z){return Array.isArray(T)?this.r(L,T,z):this.s(L,T)}async r(L,T,z=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:L,urisToOpen:T,cli:this.f.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async s(L,T){await this.a.openEmptyWindow({context:5,contextWindowId:L},T)}async toggleFullScreen(L){this.C(L)?.toggleFullScreen()}async handleTitleDoubleClick(L){this.C(L)?.handleTitleDoubleClick()}async isMaximized(L){const T=this.C(L);return T?.win?T.win.isMaximized():!1}async maximizeWindow(L){const T=this.C(L);T?.win&&T.win.maximize()}async unmaximizeWindow(L){const T=this.C(L);T?.win&&T.win.unmaximize()}async minimizeWindow(L){const T=this.C(L);T?.win&&T.win.minimize()}async updateWindowControls(L,T){const z=this.C(L);z&&z.updateWindowControls(T)}async focusWindow(L,T){T&&typeof T.windowId=="number"&&(L=T.windowId),this.C(L)?.focus({force:T?.force??!1})}async setMinimumSize(L,T,z){const se=this.C(L);if(se?.win){const[ee,ae]=se.win.getSize(),[ne,oe]=se.win.getMinimumSize(),[G,J]=[T??ne,z??oe],[B,U]=[Math.max(ee,G),Math.max(ae,J)];(ne!==G||oe!==J)&&se.win.setMinimumSize(G,J),(ee!==B||ae!==U)&&se.win.setSize(B,U)}}async saveWindowSplash(L,T){this.j.saveWindowSplash(L,T)}async installShellCommand(L){const{source:T,target:z}=await this.t();try{const{symbolicLink:se}=await m.SymlinkSupport.stat(T);if(se&&!se.dangling){const ee=await(0,f.$Vp)(T);if(z===ee)return}await m.Promises.unlink(T)}catch(se){if(se.code!=="ENOENT")throw se}try{await m.Promises.symlink(z,T)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:ee}=await this.showMessageBox(L,{type:"info",message:(0,c.localize)(0,null,this.h.nameShort),buttons:[(0,c.localize)(1,null),(0,c.localize)(2,null)]});if(ee===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${T}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ae)}catch{throw new Error((0,c.localize)(3,null,T))}}}async uninstallShellCommand(L){const{source:T}=await this.t();try{await m.Promises.unlink(T)}catch(z){switch(z.code){case"EACCES":{const{response:se}=await this.showMessageBox(L,{type:"info",message:(0,c.localize)(4,null,this.h.nameShort),buttons:[(0,c.localize)(5,null),(0,c.localize)(6,null)]});if(se===0)try{const ee=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ee)}catch{throw new Error((0,c.localize)(7,null,T))}break}case"ENOENT":break;default:throw z}}}async t(){const L=(0,b.$9d)(this.f.appRoot,"bin","code"),T=`/usr/local/bin/${this.h.applicationName}`;if(!await m.Promises.exists(L))throw new Error((0,c.localize)(8,null,L));return{source:T,target:L}}async showMessageBox(L,T){return this.b.showMessageBox(T,this.u(L))}async showSaveDialog(L,T){return this.b.showSaveDialog(T,this.u(L))}async showOpenDialog(L,T){return this.b.showOpenDialog(T,this.u(L))}u(L){const T=this.C(L);if(T?.win)return T.win}async pickFileFolderAndOpen(L,T){const z=await this.b.pickFileFolder(T);z&&await this.w(await Promise.all(z.map(async se=>await m.SymlinkSupport.existsDirectory(se)?{folderUri:p.URI.file(se)}:{fileUri:p.URI.file(se)})),T,L)}async pickFolderAndOpen(L,T){const z=await this.b.pickFolder(T);z&&await this.w(z.map(se=>({folderUri:p.URI.file(se)})),T,L)}async pickFileAndOpen(L,T){const z=await this.b.pickFile(T);z&&await this.w(z.map(se=>({fileUri:p.URI.file(se)})),T,L)}async pickWorkspaceAndOpen(L,T){const z=await this.b.pickWorkspace(T);z&&await this.w(z.map(se=>({workspaceUri:p.URI.file(se)})),T,L)}async w(L,T,z){await this.a.open({context:3,contextWindowId:z,cli:this.f.args,urisToOpen:L,forceNewWindow:T.forceNewWindow})}async showItemInFolder(L,T){O.shell.showItemInFolder(T)}async setRepresentedFilename(L,T){this.C(L)?.setRepresentedFilename(T)}async setDocumentEdited(L,T){this.C(L)?.setDocumentEdited(T)}async openExternal(L,T){return this.f.unsetSnapExportedVariables(),O.shell.openExternal(T),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(L,T){return O.shell.trashItem(T)}async isAdmin(){let L;return w.$i?L=(await new Promise((T,z)=>{K(["native-is-elevated"],T,z)}))():L=process.getuid?.()===0,L}async writeElevated(L,T,z,se){const ee=await new Promise((ae,ne)=>{K(["@vscode/sudo-prompt"],ae,ne)});return new Promise((ae,ne)=>{const oe=[`"${this.z}"`];se?.unlock&&oe.push("--file-chmod"),oe.push("--file-write",`"${T.fsPath}"`,`"${z.fsPath}"`);const G={name:this.h.nameLong.replace("-",""),icns:w.$j&&this.f.isBuilt?(0,b.$8d)((0,b.$$d)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};ee.exec(oe.join(" "),G,(J,B,U)=>{B&&this.g.trace(`[sudo-prompt] received stdout: ${B}`),U&&this.g.trace(`[sudo-prompt] received stderr: ${U}`),J?ne(J):ae(void 0)})})}async isRunningUnderARM64Translation(){return w.$k||w.$i?!1:O.app.runningUnderARM64Translation}get z(){return w.$i?this.f.isBuilt?(0,b.$8d)((0,b.$$d)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,b.$8d)(this.f.appRoot,"scripts","code-cli.bat"):w.$k?this.f.isBuilt?(0,b.$8d)((0,b.$$d)(process.execPath),"bin",`${this.h.applicationName}`):(0,b.$8d)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,b.$8d)(this.f.appRoot,"bin","code"):(0,b.$8d)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$Gm.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return w.$i&&(0,A.$V5b)()}async killProcess(L,T,z){process.kill(T,z)}async readClipboardText(L,T){return O.clipboard.readText(T)}async writeClipboardText(L,T,z){return O.clipboard.writeText(T,z)}async readClipboardFindText(L){return O.clipboard.readFindText()}async writeClipboardFindText(L,T){return O.clipboard.writeFindText(T)}async writeClipboardBuffer(L,T,z,se){return O.clipboard.writeBuffer(T,Buffer.from(z.buffer),se)}async readClipboardBuffer(L,T){return k.$Ed.wrap(O.clipboard.readBuffer(T))}async hasClipboard(L,T,z){return O.clipboard.has(T,z)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){O.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){O.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){O.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){O.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){O.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,T){this.C(L)?.updateTouchBar(T)}async notifyReady(L){this.C(L)?.setReady()}async relaunch(L,T){return this.c.relaunch(T)}async reload(L,T){const z=this.C(L);if(z){if((0,n.$Ph)(z.openedWorkspace)){const se=z.openedWorkspace.configPath;if(se.scheme===l.Schemas.file&&(await this.m.resolveLocalWorkspace(se))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.c.reload(z,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,T){const z=this.C(T);if(z?.win)return z.win.close()}async quit(L){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.c.quit()}async exit(L,T){await this.c.kill(T)}async resolveProxy(L,T){return this.C(L)?.win?.webContents?.session?.resolveProxy(T)}findFreePort(L,T,z,se,ee=1){return(0,d.$5f)(T,z,se,ee)}async openDevTools(L,T){const z=this.C(L);z?.win&&z.win.webContents.openDevTools(T)}async toggleDevTools(L){const T=this.C(L);T?.win&&T.win.webContents.toggleDevTools()}async sendInputEvent(L,T){const z=this.C(L);z?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&z.win.webContents.sendInputEvent(T)}async profileRenderer(L,T,z){const se=this.C(L);if(!se||!se.win)throw new Error;return await new D.$W5b(se.win,T,this.g).inspect(z)}async windowsGetStringRegKey(L,T,z,se){if(!w.$i)return;const ee=await new Promise((ae,ne)=>{K(["@vscode/windows-registry"],ae,ne)});try{return ee.GetStringRegKey(T,z,se)}catch{return}}C(L){if(typeof L=="number")return this.a.getWindowById(L)}};e.$Y5b=v,ke([I.$5g],v.prototype,"z",null),e.$Y5b=v=ke([_(0,i.$l5b),_(1,a.$x5b),_(2,g.$_4b),_(3,$.$04b),_(4,t.$4i),_(5,u.$jj),_(6,r.$T5b),_(7,o.$C5b)],v)}),define(te[298],ie([0,1,15,38,27,2,13,4,107,179,90,132,61,28,5,67,77,24,78,80,32,34,62,22,7,30,8]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g,t,u,r,i,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$15b=void 0;const k="issue.processExplorerWindowState";let A=class{static{o=this}static{this.a="#1E1E1E"}constructor(C,L,T,z,se,ee,ae,ne,oe,G,J){this.g=C,this.h=L,this.i=T,this.j=z,this.k=se,this.l=ee,this.m=ae,this.n=ne,this.o=oe,this.p=G,this.q=J,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){O.$MS.on("vscode:listProcesses",async C=>{const L=[];try{L.push({name:(0,l.localize)(0,null),rootProcess:await(0,h.$rr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,b.$gm)(z)?L.push({name:z.hostName,rootProcess:z}):z.processes&&L.push({name:z.hostName,rootProcess:z.processes})})}catch(T){this.i.error(`Listing processes failed: ${T}`)}this.t(C,"vscode:listProcessesResponse",L)}),O.$MS.on("vscode:workbenchCommand",(C,L)=>{const{id:T,from:z,args:se}=L;let ee;switch(z){case"processExplorer":ee=this.f;break;default:throw new Error(`Unexpected command source: ${z}`)}ee?.webContents.send("vscode:runAction",{id:T,from:z,args:se})}),O.$MS.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),O.$MS.on("vscode:pidToNameRequest",async C=>{const L=await this.k.getMainDiagnostics(),T=[];for(const z of L.windows)T.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:se}of t.$E5b.getAll())T.push([z,se]);this.t(C,"vscode:pidToNameResponse",T)})}async openReporter(C){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const L=new M.$ic,T=L.add(this.n.createIPCObjectUrl()),z=this.v(this.c,700,800);this.b=this.u(z,T,{backgroundColor:C.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),T.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:d.default}),this.b.loadURL(I.$1f.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(C){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const L=new M.$ic,T=L.add(this.n.createIPCObjectUrl()),z=this.p.getItem(k,void 0),se=D(z)?z:this.v(this.f,800,500);this.d=this.u(se,T,{backgroundColor:C.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),T.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:d.default}),this.d.loadURL(I.$1f.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const ee=()=>{if(!this.d)return;const ae=this.d.getSize(),ne=this.d.getPosition();if(!ae||!ne)return;const oe={width:ae[0],height:ae[1],x:ne[0],y:ne[1]};this.p.setItem(k,oe)};this.d.on("moved",ee),this.d.on("resized",ee)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await P.contentTracing.stopRecording(`${(0,E.$Pf)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,C),buttons:[(0,l.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,L)}async $getSystemInfo(){const[C,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,L)}async $getPerformanceInfo(){try{const[C,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,L)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.b);return C===0}return!1}async $getIssueReporterUri(C){if(!this.c)throw new Error("Issue reporter window not available");const L=this.q.getWindowById(this.c.id);if(!L)throw new Error("Window not found");const T=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return n.Promises.withAsyncBody(async(z,se)=>{const ee=new u.$od;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",ee.token,{replyChannel:T,extensionId:C}),O.$MS.once(T,(ae,ne)=>{z(r.URI.parse(ne))});try{await(0,n.$Gg)(5e3),ee.cancel(),se(new Error("Timed out waiting for issue reporter URI"))}finally{O.$MS.removeHandler(T)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,L,...T){C.sender.isDestroyed()||C.sender.send(L,...T)}u(C,L,T,z){const se=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:T.title,backgroundColor:T.backgroundColor||o.a,webPreferences:{preload:I.$1f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,$.$VD)(T.zoomLevel),sandbox:!0},alwaysOnTop:T.alwaysOnTop,experimentalDarkMode:!0});return se.setMenuBarVisibility(!1),se}v(C,L,T){let z;const se=P.screen.getAllDisplays();if(se.length===1)z=se[0];else{if(S.$j){const ne=P.screen.getCursorScreenPoint();z=P.screen.getDisplayNearestPoint(ne)}!z&&C&&(z=P.screen.getDisplayMatching(C.getBounds())),z||(z=P.screen.getPrimaryDisplay()||se[0])}const ee=z.bounds,ae={width:L,height:T,x:ee.x+ee.width/2-L/2,y:ee.y+ee.height/2-T/2};return ee.width>0&&ee.height>0&&(ae.x<ee.x&&(ae.x=ee.x),ae.y<ee.y&&(ae.y=ee.y),ae.x>ee.x+ee.width&&(ae.x=ee.x),ae.y>ee.y+ee.height&&(ae.y=ee.y),ae.width>ee.width&&(ae.width=ee.width),ae.height>ee.height&&(ae.height=ee.height)),ae}};e.$15b=A,e.$15b=A=o=ke([_(1,f.$04b),_(2,y.$4i),_(3,b.$fm),_(4,w.$H5b),_(5,p.$x5b),_(6,m.$X5b),_(7,a.$Z5b),_(8,c.$jj),_(9,g.$aN),_(10,i.$l5b)],A);function D(v){return typeof v!="object"||v===null?!1:"x"in v&&"y"in v&&"width"in v&&"height"in v}}),define(te[299],ie([0,1,22,18,28,20,5,67,24,51,25,48,100]),function(K,e,P,O,s,M,I,S,h,l,b,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r6b=void 0;let f=class extends p.$p6b{constructor(m,d,c,a,$,E,g,t){super(m,d,a,$,E,t),this.e=c,this.u=g}s(m){return(0,p.$o6b)(`linux-${process.arch}`,m,this.k)}t(m){this.a&&(this.d(w.$LT.CheckingForUpdates(m)),this.i.request({url:this.a},P.CancellationToken.None).then(l.$No).then(d=>{!d||!d.url||!d.version||!d.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!m}),this.d(w.$LT.Idle(1))):this.d(w.$LT.AvailableForDownload(d))}).then(void 0,d=>{this.j.error(d),this.e.publicLog2("update:notAvailable",{explicit:!!m});const c=m?d.message||d:void 0;this.d(w.$LT.Idle(1,c))}))}async o(m){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):m.update.url&&this.u.openExternal(void 0,m.update.url),this.d(w.$LT.Idle(1))}};e.$r6b=f,e.$r6b=f=ke([_(0,M.$_4b),_(1,O.$7h),_(2,b.$8k),_(3,s.$04b),_(4,l.$Ho),_(5,I.$4i),_(6,S.$X5b),_(7,h.$jj)],f)}),define(te[300],ie([0,1,47,45,27,8,22,55,9,7,143,21,18,28,16,20,5,67,24,51,25,48,100]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t6b=void 0;async function u(o,k=1e3){for(;!o();)await(0,M.$Gg)(k)}let r;function i(){return typeof r>"u"&&(r=O.existsSync(h.$8d(h.$$d(process.execPath),"unins000.exe"))?0:1),r}let n=class extends t.$p6b{get cachePath(){const k=h.$8d((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return w.Promises.mkdir(k,{recursive:!0}).then(()=>k)}constructor(k,A,D,v,C,L,T,z,se){super(k,A,v,C,L,se),this.u=D,this.v=T,this.w=z,k.setRelaunchHandler(this)}handleRelaunch(k){return k?.addArgs||k?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(g.$LT.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(k){let A="win32";return process.arch!=="ia32"&&(A+=`-${process.arch}`),i()===1?A+="-archive":this.k.target==="user"&&(A+="-user"),(0,t.$o6b)(A,k,this.k)}t(k){this.a&&(this.d(g.$LT.CheckingForUpdates(k)),this.i.request({url:this.a},I.CancellationToken.None).then($.$No).then(A=>{const D=i();return!A||!A.url||!A.version||!A.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!k}),this.d(g.$LT.Idle(D)),Promise.resolve(null)):D===1?(this.d(g.$LT.AvailableForDownload(A)),Promise.resolve(null)):(this.d(g.$LT.Downloading(A)),this.C(A.version).then(()=>this.B(A.version).then(v=>w.Promises.exists(v).then(C=>{if(C)return Promise.resolve(v);const L=A.url,T=A.hash,z=`${v}.tmp`;return this.i.request({url:L},I.CancellationToken.None).then(se=>this.v.writeFile(l.URI.file(z),se.stream)).then(T?()=>(0,b.$HS)(z,A.hash):()=>{}).then(()=>w.Promises.rename(z,v,!1)).then(()=>v)})).then(v=>{const C=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:v},C?this.k.target==="user"?this.p():this.d(g.$LT.Downloaded(A)):this.d(g.$LT.Ready(A))})))}).then(void 0,A=>{this.j.error(A),this.u.publicLog2("update:notAvailable",{explicit:!!k});const D=k?A.message||A:void 0;this.d(g.$LT.Idle(i(),D))}))}async o(k){k.update.url&&this.w.openExternal(void 0,k.update.url),this.d(g.$LT.Idle(i()))}async B(k){const A=await this.cachePath;return h.$8d(A,`CodeSetup-${this.k.quality}-${k}.exe`)}async C(k=null){const A=k?L=>!new RegExp(`${this.k.quality}-${k}\\.exe$`).test(L):()=>!0,D=await this.cachePath,C=(await w.Promises.readdir(D)).filter(A).map(async L=>{try{await w.Promises.unlink(h.$8d(D,L))}catch{}});await Promise.all(C)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const k=this.state.update;this.d(g.$LT.Updating(k));const A=await this.cachePath;this.e.updateFilePath=h.$8d(A,`CodeSetup-${this.k.quality}-${k.version}.flag`),await w.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(g.$LT.Idle(i()))});const v=`${this.k.win32MutexName}-ready`,C=await new Promise((L,T)=>{K(["@vscode/windows-mutex"],L,T)});u(()=>C.isActive(v)).then(()=>this.d(g.$LT.Ready(k)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?O.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(k){if(this.state.type!=="idle")return;const A=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown"};this.d(g.$LT.Downloading(D)),this.e={packagePath:k},A?this.k.target==="user"?this.p():this.d(g.$LT.Downloaded(D)):this.d(g.$LT.Ready(D))}};e.$t6b=n,ke([S.$5g],n.prototype,"cachePath",null),e.$t6b=n=ke([_(0,m.$_4b),_(1,p.$7h),_(2,E.$8k),_(3,f.$04b),_(4,$.$Ho),_(5,d.$4i),_(6,y.$5j),_(7,c.$X5b),_(8,a.$jj)],n)}),define(te[301],ie([0,1,15,8,22,50,3,2,13,9,65,4,7,189,64,18,61,28,63,16,20,5,24,78,251,82,25,102,79,80,30,29,54,128,135,39,34,53,66,23]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g,t,u,r,i,n,o,k,A,D,v,C,L,T,z,se,ee,ae,ne){"use strict";var oe;Object.defineProperty(e,"__esModule",{value:!0}),e.$B6b=void 0;var G;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(G||(G={}));let J=class extends S.$jc{static{oe=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.m}get lastFocusTime(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const U=this.R.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&U?U:this.R.getProfileForWorkspace(this.config.workspace??(0,v.$Oh)(this.backupPath,this.isExtensionDevelopmentHost))??this.R.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(U,N,H,Q,x,ce,Y,R,j,F,W,q,V,re,$e,de,ue,be,me,Se){super(),this.N=N,this.O=H,this.P=Q,this.Q=x,this.R=ce,this.S=Y,this.U=R,this.W=j,this.X=F,this.Y=W,this.Z=q,this.$=V,this.ab=re,this.bb=$e,this.db=de,this.eb=ue,this.fb=be,this.gb=me,this.hb=Se,this.b=this.B(new I.$ed),this.onWillLoad=this.b.event,this.c=this.B(new I.$ed),this.onDidSignalReady=this.c.event,this.f=this.B(new I.$ed),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new I.$ed),this.onDidClose=this.g.event,this.h=this.B(new I.$ed),this.onDidDestroy=this.h.event,this.n=-1,this.u=void 0,this.w=void 0,this.D=!1,this.F=[],this.G=[],this.H=void 0,this.I=void 0,this.J=this.B(this.fb.createIPCObjectUrl()),this.M=!1,this.ib=0;{const[Ie,je]=this.sb(U.state);this.s=Ie,this.N.trace("window#ctor: using window state",Ie);const ve=this.s.mode===0||this.s.mode===3,we=this.X.getValue("window"),X={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.Y.getBackgroundColor(),minWidth:A.$OD.WIDTH,minHeight:A.$OD.HEIGHT,show:!ve,title:this.eb.nameLong,webPreferences:{preload:h.$1f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.J.resource.toString()}`],v8CacheOptions:this.P.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,A.$VD)(we?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};w.$k?X.icon=(0,l.$8d)(this.P.appRoot,"resources/linux/code.png"):w.$i&&!this.P.isBuilt&&(X.icon=(0,l.$8d)(this.P.appRoot,"resources/win32/code_150x150.png")),w.$j&&!this.zb()&&(X.fullscreenable=!1),w.$j&&(X.acceptFirstMouse=!0,we?.clickThroughInactive===!1&&(X.acceptFirstMouse=!1));const le=w.$j&&we?.nativeTabs===!0;le&&(X.tabbingIdentifier=this.eb.nameShort);const fe=(0,A.$TD)(this.X)==="custom";if(fe&&(X.titleBarStyle="hidden",w.$j||(X.frame=!1),(0,A.$UD)(this.X))){const Ee=this.Y.getWindowSplash()?.colorInfo.titleBarBackground??this.Y.getBackgroundColor(),Re=T.$Ns.fromHex(Ee).isDarker()?"#FFFFFF":"#000000";X.titleBarOverlay={height:29,color:Ee,symbolColor:Re},this.D=!0}if((0,b.mark)("code/willCreateCodeBrowserWindow"),this.m=new P.BrowserWindow(X),(0,b.mark)("code/didCreateCodeBrowserWindow"),this.j=this.m.id,w.$j&&fe&&this.m.setSheetOffset(22),fe&&(w.$i&&(0,A.$UD)(this.X)||w.$j)){const Ee=this.hb.getItem(oe.a);Ee&&this.updateWindowControls({height:Ee})}w.$i&&fe&&this.m.hookWindowMessage(278,()=>{const[Re,Fe]=this.m.getPosition(),Oe=P.screen.getCursorScreenPoint(),ze=Oe.x-Re,We=Oe.y-Fe;return(()=>!(ze>30&&We>=0&&We<=Math.max(this.m.getBounds().height*.15,35)))()||(this.m.setEnabled(!1),this.m.setEnabled(!0),this.f.fire({x:ze,y:We})),0}),(w.$j||w.$i)&&je&&(!le||P.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(Ee=>typeof Ee=="number")&&this.m.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),ve&&((0,b.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.s.mode===3&&this.vb(!0),this.m.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this.n=Date.now()}this.P.args["open-devtools"]===!0&&this.m.webContents.openDevTools(),this.pb(),this.Db(),this.jb()}setRepresentedFilename(U){w.$j?this.m.setRepresentedFilename(U):this.z=U}getRepresentedFilename(){return w.$j?this.m.getRepresentedFilename():this.z}setDocumentEdited(U){w.$j&&this.m.setDocumentEdited(U),this.C=U}isDocumentEdited(){return w.$j?this.m.isDocumentEdited():!!this.C}focus(U){w.$j&&U?.force&&P.app.focus({steal:!0}),this.m&&(this.m.isMinimized()&&this.m.restore(),this.m.focus())}setReady(){for(this.N.trace(`window#load: window reported ready (id: ${this.j})`),this.ib=2;this.F.length;)this.F.pop()(this);this.c.fire()}ready(){return new Promise(U=>{if(this.isReady)return U(this);this.F.push(U)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(U=>{function N(){H.dispose(),Q.dispose(),U()}const H=this.onDidClose(()=>N()),Q=this.onWillLoad(()=>N())})}jb(){this.m.on("unresponsive",()=>this.mb(1)),this.m.webContents.on("render-process-gone",(N,H)=>this.mb(2,{...H})),this.m.webContents.on("did-fail-load",(N,H,Q)=>this.mb(3,{reason:Q,exitCode:H})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.on("closed",()=>{this.g.fire(),this.dispose()}),this.m.webContents.on("did-finish-load",()=>{this.L&&(this.r=this.L,this.L=void 0)}),this.m.on("focus",()=>{this.n=Date.now()}),this.m.on("maximize",N=>{this.r&&(this.r.maximized=!0),P.app.emit("browser-window-maximize",N,this.m)}),this.m.on("unmaximize",N=>{this.r&&(this.r.maximized=!1),P.app.emit("browser-window-unmaximize",N,this.m)}),this.m.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.m.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.B(this.X.onDidChangeConfiguration(N=>this.pb(N))),this.B(this.Z.onDidDeleteUntitledWorkspace(N=>this.ob(N)));const U=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:U},async(N,H)=>{const Q=await this.lb();H({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,Q)})})}lb(){return this.kb||(this.kb=(0,r.$2o)(this.eb.version,this.eb,this.P,this.X,this.S,this.U,this.ab)),this.kb}async mb(U,N){switch(U){case 2:this.N.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.N.error("CodeWindow: detected unresponsive");break;case 3:this.N.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:U,reason:N?.reason,code:N?.exitCode}),U){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.P.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.db.quit();return}if(U===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:Q}=await this.bb.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null),(0,f.localize)(2,null)],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),checkboxLabel:this.r?.workspace?(0,f.localize)(5,null):void 0},this.m);if(H!==2){const x=H===0;await this.nb(x,Q)}}else if(U===2){let H;N?H=(0,f.localize)(7,null,N.reason,N.exitCode??"<unknown>"):H=(0,f.localize)(6,null);const{response:Q,checkboxChecked:x}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,f.localize)(8,null):(0,f.localize)(9,null),(0,f.localize)(10,null)],message:H,detail:this.r?.workspace?(0,f.localize)(11,null):(0,f.localize)(12,null),checkboxLabel:this.r?.workspace?(0,f.localize)(13,null):void 0},this.m),ce=Q===0;await this.nb(ce,x)}break}}async nb(U,N){const H=this.r?.workspace;if(N&&H)try{const Q=this.W.workspaceStorage(H);await Q.init(),Q.delete("memento/workbench.parts.editor"),await Q.close()}catch(Q){this.N.error(Q)}if(this.h.fire(),this.m?.destroy(),U&&this.r){let Q,x;(0,v.$Kh)(H)?Q={folderUri:H.uri}:(0,v.$Ph)(H)?Q={workspaceUri:H.configPath}:x=!0,(0,ne.$Lb)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.P.args,_:[]},urisToOpen:Q?[Q]:void 0,forceEmpty:x,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}ob(U){this.r?.workspace?.id===U.id&&(this.r.workspace=void 0)}pb(U){if(!U||U.affectsConfiguration("window.menuBarVisibility")){const N=this.Ab();N!==this.t&&(this.t=N,this.Bb(N))}if(!U||U.affectsConfiguration("http.proxy")){let N=(this.X.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.H||H!==this.I)){this.H=N,this.I=H;const Q=N||"",x=H?`${H},<local>`:"<local>";this.N.trace(`Setting proxy to '${Q}', bypassing '${x}'`),this.m.webContents.session.setProxy({proxyRules:Q,proxyBypassRules:x,pacScript:""})}}}addTabbedWindow(U){w.$j&&U.win&&this.m.addTabbedWindow(U.win)}load(U,N=Object.create(null)){this.N.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!N.isReload||!this.$.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.eb.nameLong)),this.qb(U,N),this.ib===0?this.r=U:this.L=U,this.ib=1,this.m.loadURL(h.$1f.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.P.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.M;this.M=!0,!this.P.isBuilt&&!this.P.extensionTestsLocationURI&&this.B(new O.$Rg(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:U.workspace,reason:N.isReload?3:H?2:1})}qb(U,N){const H=(this.r??this.L)?.userEnv;if(H){const Q=(0,a.$Fl)(H)&&!(0,a.$Fl)(U.userEnv),x=this.isExtensionDevelopmentHost;(Q||x)&&(U.userEnv={...H,...U.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(U.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(U["disable-extensions"]=N.disableExtensions),U.fullscreen=this.isFullScreen,U.maximized=this.m.isMaximized(),U.partsSplash=this.Y.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),U.perfMarks=(0,b.getMarks)(),this.J.update(U)}async reload(U){const N=Object.assign({},this.r);N.workspace=await this.rb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&U&&(N.verbose=U.verbose,N.debugId=U.debugId,N.extensionEnvironment=U.extensionEnvironment,N["inspect-extensions"]=U["inspect-extensions"],N["inspect-brk-extensions"]=U["inspect-brk-extensions"],N["extensions-dir"]=U["extensions-dir"]),N.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.Q.serialize(),N.continueOn=this.P.continueOn,N.profiles={all:this.R.profiles,profile:this.profile||this.R.defaultProfile,home:this.R.profilesHome},N.logLevel=this.O.getLogLevel(),N.loggers={window:this.O.getRegisteredLoggers(this.id),global:this.O.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:U?.["disable-extensions"]})}async rb(U){if((0,v.$Ph)(U.workspace)){const N=U.workspace.configPath;if(N.scheme===h.Schemas.file&&!await this.S.exists(N))return}else if((0,v.$Kh)(U.workspace)){const N=U.workspace.uri;if(N.scheme===h.Schemas.file&&!await this.S.exists(N))return}return U.workspace}serializeWindowState(){if(!this.m)return(0,L.$94b)();if(this.isFullScreen){let H;try{H=P.screen.getDisplayMatching(this.getBounds())}catch{}const Q=(0,L.$94b)();return{mode:3,display:H?H.id:void 0,width:this.s.width||Q.width,height:this.s.height||Q.height,x:this.s.x||0,y:this.s.y||0}}const U=Object.create(null);let N;if(!w.$j&&this.m.isMaximized()?N=0:N=1,N===0?U.mode=0:U.mode=1,N===1||N===0){let H;N===1?H=this.getBounds():H=this.m.getNormalBounds(),U.x=H.x,U.y=H.y,U.width=H.width,U.height=H.height}return U}updateWindowControls(U){if(U.height&&this.hb.setItem(oe.a,U.height),w.$i&&this.D)this.m.setTitleBarOverlay({color:U.backgroundColor?.trim()===""?void 0:U.backgroundColor,symbolColor:U.foregroundColor?.trim()===""?void 0:U.foregroundColor,height:U.height?U.height-1:void 0});else if(w.$j&&U.height!==void 0){const N=(U.height-15)/2;N?this.m.setWindowButtonPosition({x:N,y:N}):this.m.setWindowButtonPosition(null)}}sb(U){(0,b.mark)("code/willRestoreCodeWindowState");let N=!1;if(U)try{const H=P.screen.getAllDisplays();N=H.length>1,U=this.tb(U,H)}catch(H){this.N.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[U||(0,L.$94b)(),N]}tb(U,N){if(this.N.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,U),typeof U.x!="number"||typeof U.y!="number"||typeof U.width!="number"||typeof U.height!="number"){this.N.trace("window#validateWindowState: unexpected type of state values");return}if(U.width<=0||U.height<=0){this.N.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const x=this.ub(N[0]);if(x){let ce=function(){!U||typeof U.x!="number"||typeof U.y!="number"||!x||(U.x<x.x&&(U.x=x.x),U.y<x.y&&(U.y=x.y))};this.N.trace("window#validateWindowState: 1 monitor working area",x),ce(),U.width>x.width&&(U.width=x.width),U.height>x.height&&(U.height=x.height),U.x>x.x+x.width-128&&(U.x=x.x+x.width-U.width),U.y>x.y+x.height-128&&(U.y=x.y+x.height-U.height),ce()}return U}if(U.display&&U.mode===3){const x=N.find(ce=>ce.id===U.display);if(x&&typeof x.bounds?.x=="number"&&typeof x.bounds?.y=="number"){this.N.trace("window#validateWindowState: restoring fullscreen to previous display");const ce=(0,L.$94b)(3);return ce.x=x.bounds.x,ce.y=x.bounds.y,ce}}let H,Q;try{H=P.screen.getDisplayMatching({x:U.x,y:U.y,width:U.width,height:U.height}),Q=this.ub(H)}catch{}if(H&&Q&&U.x+U.width>Q.x&&U.y+U.height>Q.y&&U.x<Q.x+Q.width&&U.y<Q.y+Q.height)return this.N.trace("window#validateWindowState: multi-monitor working area",Q),U}ub(U){if(U.workArea.width>0&&U.workArea.height>0)return U.workArea;if(U.bounds.width>0&&U.bounds.height>0)return U.bounds}getBounds(){const[U,N]=this.m.getPosition(),[H,Q]=this.m.getSize();return{x:U,y:N,width:H,height:Q}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(U){this.zb()?this.wb(U):this.yb(U),this.sendWhenReady(U?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Bb(this.t,!1)}get isFullScreen(){return w.$j&&typeof this.u=="boolean"?this.u:this.m.isFullScreen()||this.m.isSimpleFullScreen()}wb(U){this.m.isSimpleFullScreen()&&this.m.setSimpleFullScreen(!1),this.xb(U)}xb(U){w.$j&&(this.u=U,this.w=new O.$1g,Promise.race([this.w.p,(0,O.$Gg)(1e3)]).finally(()=>this.u=void 0)),this.m.setFullScreen(U)}yb(U){this.m.isFullScreen()&&this.xb(!1),this.m.setSimpleFullScreen(U),this.m.webContents.focus()}zb(){const U=this.X.getValue("window");return!U||typeof U.nativeFullScreen!="boolean"||U.nativeTabs?!0:U.nativeFullScreen!==!1}isMinimized(){return this.m.isMinimized()}Ab(){let U=(0,A.$SD)(this.X);return["visible","toggle","hidden"].indexOf(U)<0&&(U="classic"),U}Bb(U,N=!0){w.$j||(U==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,f.localize)(14,null)),U==="hidden"?setTimeout(()=>{this.Cb(U)}):this.Cb(U))}Cb(U){const N=this.isFullScreen;switch(U){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(w.$j)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.m.minimize();break;case"None":break;case"Maximize":default:this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}else this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}close(){this.m?.close()}sendWhenReady(U,N,...H){this.isReady?this.send(U,...H):this.ready().then(()=>{N.isCancellationRequested||this.send(U,...H)})}send(U,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.N.warn(`Sending IPC message to channel '${U}' for window that is destroyed`);return}try{this.m.webContents.send(U,...N)}catch(H){this.N.warn(`Error sending IPC message to channel '${U}' of window ${this.j}: ${(0,M.$li)(H)}`)}}}updateTouchBar(U){w.$j&&this.G.forEach((N,H)=>{const Q=U[H];N.segments=this.Fb(Q)})}Db(){if(w.$j){for(let U=0;U<10;U++){const N=this.Eb();this.G.push(N)}this.m.setTouchBar(new P.TouchBar({items:this.G}))}}Eb(U=[]){const N=this.Fb(U),H=new P.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:Q=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:H.segments[Q].id,from:"touchbar"})}});return H}Fb(U=[]){return U.map(H=>{let Q;H.icon&&!o.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===h.Schemas.file&&(Q=P.nativeImage.createFromPath(p.URI.revive(H.icon.dark).fsPath),Q.isEmpty()&&(Q=void 0));let x;return typeof H.title=="string"?x=H.title:x=H.title.value,{id:H.id,label:Q?void 0:x,icon:Q}})}dispose(){super.dispose(),this.O.deregisterLoggers(this.id),this.m=null}};e.$B6b=J,e.$B6b=J=oe=ke([_(1,g.$4i),_(2,ae.$d6b),_(3,c.$04b),_(4,z.$9m),_(5,ee.$f5b),_(6,$.$5j),_(7,i.$j5b),_(8,i.$h5b),_(9,m.$7h),_(10,k.$T5b),_(11,C.$C5b),_(12,y.$q5b),_(13,n.$8k),_(14,d.$x5b),_(15,E.$_4b),_(16,t.$jj),_(17,u.$Z5b),_(18,D.$l5b),_(19,se.$aN)],J)}),define(te[83],ie([0,1,15,23,8,3,46,2,13,4,19,7,21,192,6,20,5,82,97,29,54,33]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$_5b=e.$$5b=void 0,e.$$5b=(0,y.$Ah)("workspacesHistoryMainService");let u=class extends S.$jc{static{t=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(i,n,o,k){super(),this.f=i,this.g=n,this.h=o,this.j=k,this.c=this.B(new M.$ed),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Dg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const A of i)if((0,a.$$T)(A))!this.g.isUntitledWorkspace(A.workspace)&&!this.u(n,A.workspace)&&n.push(A);else if((0,a.$_T)(A))this.w(n,A.folderUri)||n.push(A);else{const D=this.y(o,A.fileUri),v=A.fileUri.scheme===h.Schemas.file&&t.F.indexOf((0,b.$eg)(A.fileUri))>=0;!D&&!v&&(o.push(A),l.$i&&A.fileUri.scheme===h.Schemas.file&&P.app.addRecentDocument(A.fileUri.fsPath))}const k=await this.n({workspaces:n,files:o});n=k.workspaces,o=k.files,n.length>t.a&&(n.length=t.a),o.length>t.a&&(o.length=t.a),await this.s({workspaces:n,files:o}),this.c.fire(),l.$j&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(i){const n=D=>{const v=this.t(D);for(const C of i)if(b.$$f.isEqual(C,v))return!1;return!0},o=await this.getRecentlyOpened(),k=o.workspaces.filter(n),A=o.files.filter(n);(k.length!==o.workspaces.length||A.length!==o.files.length)&&(await this.s({files:A,workspaces:k}),this.c.fire(),l.$j&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(i){const n=new g.$yi(A=>b.$$f.getComparisonKey(A));if(i?.workspaces)for(const A of i.workspaces)n.set(this.t(A),A);const o=new g.$yi(A=>b.$$f.getComparisonKey(A));if(i?.files)for(const A of i.files)o.set(this.t(A),A);const k=await this.r();for(const A of k.workspaces){const D=n.get(this.t(A));D?D.label=D.label??A.label:n.set(this.t(A),A)}for(const A of k.files){const D=o.get(this.t(A));D?D.label=D.label??A.label:o.set(this.t(A),A)}return{workspaces:[...n.values()],files:[...o.values()]}}async r(){await this.j.whenReady;let i;const n=this.j.get(t.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,a.$fU)(i,this.f)}async s(i){await this.j.whenReady,this.j.store(t.b,JSON.stringify((0,a.$gU)(i)),-1,1)}t(i){return(0,a.$_T)(i)?i.folderUri:(0,a.$aU)(i)?i.fileUri:i.workspace.configPath}u(i,n){return!!i.find(o=>(0,a.$$T)(o)&&o.workspace.id===n.id)}w(i,n){return!!i.find(o=>(0,a.$_T)(o)&&b.$$f.isEqual(o.folderUri,n))}y(i,n){return!!i.find(o=>b.$$f.isEqual(o.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){l.$i&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!l.$i)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const A of P.app.getJumpListSettings().removedItems){const D=A.args;if(D){const v=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);v&&n.push(w.URI.parse(v[2]))}}await this.removeRecentlyOpened(n);let o=!1;const k=(0,O.$Eb)((await this.getRecentlyOpened()).workspaces.slice(0,t.D).map(A=>{const D=(0,a.$$T)(A)?A.workspace:A.folderUri,{title:v,description:C}=this.J(D,A.label);let L;return w.URI.isUri(D)?L=`--folder-uri "${D.toString()}"`:(o=!0,L=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:v.substr(0,255),description:C.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));k.length>0&&i.push({type:"custom",name:o?(0,f.localize)(2,null):(0,f.localize)(3,null),items:k})}i.push({type:"recent"});try{const n=P.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(i,n){if(n)return{title:(0,I.$mA)(n).name,description:n};if(w.URI.isUri(i))return{title:(0,b.$eg)(i),description:this.L(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let o=(0,b.$eg)(i.configPath);return o.endsWith($.$Wh)&&(o=o.substr(0,o.length-$.$Wh.length-1)),{title:(0,f.localize)(5,null,o),description:this.L(i.configPath)}}L(i){return i.scheme==="file"?(0,I.$eA)(i.fsPath):i.toString()}async M(){if(!l.$j)return;P.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let A=0;A<i.workspaces.length&&o<t.z;A++){const D=this.t(i.workspaces[A]);if(D.scheme===h.Schemas.file){const v=(0,b.$8f)(D);await p.Promises.exists(v)&&(n.push(v),o++)}}const k=[];for(let A=0;A<i.files.length&&o<t.C;A++){const D=this.t(i.files[A]);if(D.scheme===h.Schemas.file){const v=(0,b.$8f)(D);if(t.F.includes((0,b.$eg)(D))||n.includes(v))continue;await p.Promises.exists(v)&&(k.push(v),o++)}}k.reverse().forEach(A=>P.app.addRecentDocument(A)),n.reverse().forEach(A=>P.app.addRecentDocument(A))}};e.$_5b=u,e.$_5b=u=t=ke([_(0,d.$4i),_(1,E.$C5b),_(2,m.$_4b),_(3,c.$j5b)],u)}),define(te[302],ie([0,1,15,8,22,46,4,7,180,18,28,20,5,229,67,24,34,25,48,80,30,83]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$a6b=void 0;const u="menu";let r=class{static{t=this}static{this.a="lastKnownMenubarData"}constructor(o,k,A,D,v,C,L,T,z,se,ee){this.n=o,this.o=k,this.p=A,this.q=D,this.r=v,this.s=C,this.t=L,this.u=T,this.v=z,this.w=se,this.x=ee,this.m=Object.create(null),this.g=new O.$Rg(()=>this.E(),0),this.h=new O.$Rg(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(I.$j||(0,$.$TD)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(t.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(C,L,T)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.newWindow"]=(C,L,T)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.files.openFileFolder"]=(C,L,T)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(T),telemetryExtraData:{from:u}}),this.m["workbench.action.files.openFolder"]=(C,L,T)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(T),telemetryExtraData:{from:u}}),this.m["workbench.action.openWorkspace"]=(C,L,T)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(T),telemetryExtraData:{from:u}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.youTubeUrl;o&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(o,"openYouTubeUrl"));const k=this.x.requestFeatureUrl;k&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(k,"openUserVoiceUrl"));const A=this.x.reportIssueUrl;A&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(A,"openReportIssues"));const D=this.x.licenseUrl;D&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(I.$v){const C=D.indexOf("?")>0?"&":"?";this.Z(`${D}${C}lang=${I.$v}`,"openLicenseUrl")}else this.Z(D,"openLicenseUrl")});const v=this.x.privacyStatementUrl;v&&D&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(v,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!I.$j)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,k){this.k=o.menus,this.l=o.keybindings,this.t.setItem(t.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){I.$j&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){I.$j&&(this.f=!P.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=P.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){P.Menu.setApplicationMenu(I.$j?new P.Menu:null);return}const k=new P.Menu;let A;if(I.$j){const v=new P.Menu;A=new P.MenuItem({label:this.x.nameShort,submenu:v}),this.I(v),k.append(A)}if(I.$j&&!this.c){this.c=!0;const v=new P.Menu;v.append(new P.MenuItem({label:this.ab(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(v)}if(this.K("File")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(1,null)),submenu:v});this.M(v,"File"),k.append(C)}if(this.K("Edit")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(2,null)),submenu:v});this.M(v,"Edit"),k.append(C)}if(this.K("Selection")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(3,null)),submenu:v});this.M(v,"Selection"),k.append(C)}if(this.K("View")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(4,null)),submenu:v});this.M(v,"View"),k.append(C)}if(this.K("Go")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(5,null)),submenu:v});this.M(v,"Go"),k.append(C)}if(this.K("Run")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(6,null)),submenu:v});this.M(v,"Run"),k.append(C)}if(this.K("Terminal")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(7,null)),submenu:v});this.M(v,"Terminal"),k.append(C)}let D;if(this.K("Window")){const v=new P.Menu;D=new P.MenuItem({label:this.ab(h.localize(8,null)),submenu:v,role:"window"}),this.S(v)}if(D&&k.append(D),this.K("Help")){const v=new P.Menu,C=new P.MenuItem({label:this.ab(h.localize(9,null)),submenu:v,role:"help"});this.M(v,"Help"),k.append(C)}k.items&&k.items.length>0?P.Menu.setApplicationMenu(k):P.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const k=this.U(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),A=this.T();let D;if(this.K("Preferences")){const ae=new P.Menu;this.M(ae,"Preferences"),D=new P.MenuItem({label:this.ab(h.localize(11,null)),submenu:ae})}const v=new P.Menu,C=new P.MenuItem({label:h.localize(12,null),role:"services",submenu:v}),L=new P.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),T=new P.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new P.MenuItem({label:h.localize(15,null),role:"unhide"}),se=new P.MenuItem(this.Y("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(ae,ne,oe)=>{const G=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&await this.J(oe)&&this.w.quit(void 0)}})),ee=[k];ee.push(...A),D&&ee.push(i(),D),ee.push(i(),C,i(),L,T,z,i(),se),ee.forEach(ae=>o.append(ae))}async J(o){if(this.p.getWindowCount()===0)return!0;const k=this.o.getValue("window.confirmBeforeClose");if(k==="always"||k==="keyboardOnly"&&this.Q(o)){const{response:A}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return A===0}return!0}K(o){if(!I.$j&&(0,$.$TD)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(I.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(I.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,k){k.forEach(A=>{if((0,f.$85b)(A))o.append(i());else if((0,f.$75b)(A)){const D=new P.Menu,v=new P.MenuItem({label:this.ab(A.label),submenu:D});this.L(D,A.submenu.items),o.append(v)}else(0,f.$95b)(A)?o.append(this.O(A)):(0,f.$05b)(A)&&(A.id==="workbench.action.showAboutDialog"&&this.N(o),I.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[A.id]?o.append(new P.MenuItem(this.Y(A.id,{label:this.ab(A.label),click:this.m[A.id]}))):o.append(this.U(A.label,A.id,!1,A.checked)):o.append(this.U(A.label,A.id,A.enabled!==!1,!!A.checked)):o.append(this.U(A.label,A.id,A.enabled!==!1,!!A.checked)))})}M(o,k){this.k&&this.k[k]&&this.L(o,this.k[k].items)}N(o){const k=this.T();k.length&&(k.forEach(A=>o.append(A)),o.append(i()))}O(o){const k=S.URI.revive(o.uri),A=o.id,D=A==="openRecentFile"?{fileUri:k}:A==="openRecentWorkspace"?{workspaceUri:k}:{folderUri:k};return new P.MenuItem(this.Y(A,{label:o.label,click:async(v,C,L)=>{const T=this.P(L);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[D],forceNewWindow:T,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([k])}},!1))}P(o){return!!(o&&(!I.$j&&(o.ctrlKey||o.shiftKey)||I.$j&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,k,A){const D={label:this.ab(o),role:A,enabled:!0};return new P.MenuItem(this.X(k,D))}S(o){const k=new P.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),A=new P.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),D=new P.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),v=this.U(h.localize(23,null),"workbench.action.switchWindow"),C=[];this.C&&(C.push(i()),C.push(this.U(h.localize(24,null),"workbench.action.newWindowTab")),C.push(this.R(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.R(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.R(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.R(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[k,A,i(),v,...C,i(),D].forEach(L=>o.append(L))}T(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.ab(h.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.ab(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.ab(h.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.ab(h.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(o,k,A,D){const v=this.ab(o),C=typeof k=="function"?k:(ee,ae,ne)=>{const oe=ee?ee.userSettingsLabel:null;let G=k;Array.isArray(k)&&(G=this.P(ne)?k[1]:k[0]),oe&&ne.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:oe}):this.W({type:"commandId",commandId:G})},L=typeof A=="boolean"?A:this.p.getWindowCount()>0,T=typeof D=="boolean"?D:!1,z={label:v,click:C,enabled:L};T&&(z.type="checkbox",z.checked=T);let se;return typeof k=="string"?se=k:Array.isArray(k)&&(se=k[0]),I.$j&&(se==="editor.action.clipboardCutAction"?z.role="cut":se==="editor.action.clipboardCopyAction"?z.role="copy":se==="editor.action.clipboardPasteAction"&&(z.role="paste"),se==="undo"?z.click=this.V(C,{inDevTools:ee=>ee.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?z.click=this.V(C,{inDevTools:ee=>ee.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(z.click=this.V(C,{inDevTools:ee=>ee.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.X(se,z))}V(o,k){return(A,D,v)=>{const C=P.BrowserWindow.getFocusedWindow();if(!C)return k.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return k.inDevTools(C.webContents.devToolsWebContents);o(A,D||C,v)}}W(o){let k=P.BrowserWindow.getFocusedWindow();if(!k){const D=this.p.getLastActiveWindow();D?.isMinimized()&&(k=D.win)}const A=k?this.p.getWindowById(k.id):void 0;if(A){if(this.v.trace("menubar#runActionInRenderer",o),I.$j&&!this.q.isBuilt&&!A.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const D={id:o.commandId,from:"menu"};A.sendWhenReady("vscode:runAction",s.CancellationToken.None,D)}else{const D={userSettingsLabel:o.userSettingsLabel};A.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,D)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,k){const A=typeof o=="string"?this.l[o]:void 0;if(A?.label){if(A.isNative!==!1)k.accelerator=A.label,k.userSettingsLabel=A.userSettingsLabel;else if(typeof k.label=="string"){const D=k.label.indexOf("[");D>=0?k.label=`${k.label.substr(0,D)} [${A.label}]`:k.label=`${k.label} [${A.label}]`}}else k.accelerator=void 0;return k}Y(o,k,A=!k.accelerator){A&&(k=this.X(o,k));const D=k.click;return k.click=(v,C,L)=>{this.$(o),D?.(v,C,L)},k}Z(o,k){this.w.openExternal(void 0,o),this.$(k)}$(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:u})}ab(o){return(0,M.$jA)(o,!this.B)}};e.$a6b=r,e.$a6b=r=t=ke([_(0,a.$MT),_(1,l.$7h),_(2,E.$l5b),_(3,b.$04b),_(4,c.$8k),_(5,g.$$5b),_(6,d.$aN),_(7,w.$_4b),_(8,p.$4i),_(9,y.$X5b),_(10,m.$jj)],r);function i(){return new P.MenuItem({type:"separator"})}}),define(te[303],ie([0,1,6,20,5,302]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.$b6b=void 0,e.$b6b=(0,P.$Ah)("menubarMainService");let I=class{constructor(h,l,b){this.b=h,this.c=l,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$a6b)}async updateMenubar(h,l){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(l,h)}};e.$c6b=I,e.$c6b=I=ke([_(0,P.$zh),_(1,O.$_4b),_(2,s.$4i)],I)}),define(te[304],ie([0,1,15,21,131,27,23,22,3,32,49,46,2,13,9,65,4,35,19,12,7,190,64,18,61,28,16,6,20,5,77,78,60,34,80,301,130,297,29,98,83,54,79,39,53,66]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g,t,u,r,i,n,o,k,A,D,v,C,L,T,z,se,ee,ae,ne,oe,G,J,B,U,N){"use strict";var H;Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=void 0;function Q(Y){return(0,ae.$Ph)(Y?.workspace)}function x(Y){return(0,ae.$Kh)(Y?.workspace)}let ce=class extends p.$jc{static{H=this}static{this.a=[]}constructor(R,j,F,W,q,V,re,$e,de,ue,be,me,Se,Ie,je,ve,we,X){super(),this.m=R,this.n=j,this.r=F,this.s=W,this.t=q,this.u=V,this.w=re,this.z=$e,this.C=de,this.D=ue,this.F=be,this.G=me,this.H=Se,this.I=Ie,this.J=je,this.L=ve,this.M=we,this.N=X,this.b=this.B(new h.$ed),this.onDidOpenWindow=this.b.event,this.c=this.B(new h.$ed),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new h.$ed),this.onDidDestroyWindow=this.f.event,this.g=this.B(new h.$ed),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new h.$ed),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ee.$C6b(this,this.t,this.C,this.r,this.F)),this.O()}O(){this.B(this.H.onDidEnterWorkspace(R=>this.c.fire(R.window))),this.B(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const j=new p.$ic;if(j.add(h.Event.any(R.onDidClose,R.onDidDestroy)(()=>j.dispose())),R.config.extensionDevelopmentPath)for(const F of R.config.extensionDevelopmentPath)j.add(this.M.addValidFileRoot(F));R.config.extensionTestsPath&&j.add(this.M.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,j){const F=this.w.args,W=j?.remoteAuthority||void 0,q=!0,V=j?.forceReuseWindow,re=!V;return this.open({...R,cli:F,forceEmpty:q,forceNewWindow:re,forceReuseWindow:V,remoteAuthority:W})}openExistingWindow(R,j){R.focus(),this.P(j,[R])}async open(R){this.r.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const j=[],F=[],W=[],q=[],V=[];let re,$e=0;const de=await this.X(R);this.r.trace("windowsManager#open pathsToOpen",de);for(const Ie of de)x(Ie)?R.addMode?j.push(Ie):F.push(Ie):Q(Ie)?W.push(Ie):Ie.fileUri?(re||(re={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ie.remoteAuthority}),re.filesToOpenOrCreate.push(Ie)):Ie.backupPath?V.push({backupFolder:(0,y.$_d)(Ie.backupPath),remoteAuthority:Ie.remoteAuthority}):$e++;R.diffMode&&re&&re.filesToOpenOrCreate.length>=2&&(re.filesToDiff=re.filesToOpenOrCreate.slice(0,2),re.filesToOpenOrCreate=[]),R.mergeMode&&re&&re.filesToOpenOrCreate.length===4&&(re.filesToMerge=re.filesToOpenOrCreate.slice(0,4),re.filesToOpenOrCreate=[],re.filesToDiff=[]),re&&R.waitMarkerFileURI&&(re.filesToWait={paths:(0,I.$Eb)([...re.filesToDiff,re.filesToMerge[3],...re.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(q.push(...this.H.getUntitledWorkspaces()),W.push(...q),V.push(...this.D.getEmptyWindowBackups())):V.length=0;const{windows:ue,filesOpenedInWindow:be}=await this.Q(R,W,F,V,$e,re,j);if(this.r.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${W.length}, foldersToOpen: ${F.length}, emptyToRestore: ${V.length}, emptyToOpen: ${$e})`),ue.length>1)if(be)be.focus();else{const Ie=this.j.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let je=!0,ve=!0;if(Ie){const we=ue.filter(X=>this.j.state.lastActiveWindow&&X.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),je=!1,ve=!1)}if(je)for(let we=ue.length-1;we>=0;we--){const X=ue[we];if(!(X.openedWorkspace&&q.some(le=>X.openedWorkspace&&le.workspace.id===X.openedWorkspace.id)||X.backupPath&&V.some(le=>X.backupPath&&le.backupFolder===(0,y.$_d)(X.backupPath)))){X.focus(),ve=!1;break}}ve&&ue[ue.length-1].focus()}const me=re&&re.filesToDiff.length>0,Se=re&&re.filesToMerge.length>0;if(!ue.some(Ie=>Ie.isExtensionDevelopmentHost)&&!me&&!Se&&!R.noRecentEntry){const Ie=[];for(const je of de)Q(je)&&!je.transient?Ie.push({label:je.label,workspace:je.workspace,remoteAuthority:je.remoteAuthority}):x(je)?Ie.push({label:je.label,folderUri:je.workspace.uri,remoteAuthority:je.remoteAuthority}):je.fileUri&&Ie.push({label:je.label,fileUri:je.fileUri,remoteAuthority:je.remoteAuthority});this.G.addRecentlyOpened(Ie)}return this.P(R,ue),ue}P(R,j){const F=R.waitMarkerFileURI;R.context===0&&F&&j.length===1&&j[0]&&(async()=>{await j[0].whenClosedOrLoaded;try{await this.L.del(F)}catch{}})()}async Q(R,j,F,W,q,V,re){const $e=[];let de;function ue(we,X){$e.push(we),X&&(de=we,V=void 0)}let{openFolderInNewWindow:be,openFilesInNewWindow:me}=this.ib(R);if(!R.initialStartup&&re.length>0){const we=re[0].remoteAuthority,X=this.nb(we);X&&ue(this.S(X,re.map(le=>le.workspace.uri)))}const Se=F.length+j.length+W.length;if(V&&Se===0){const we=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],X=this.getWindows().filter(fe=>V&&(0,a.$mg)(fe.remoteAuthority,V.remoteAuthority));let le;we?.fileUri&&!me&&((R.context===4||R.context===0||R.context===1)&&(le=await(0,se.$z5b)(X,we.fileUri,async fe=>fe.configPath.scheme===f.Schemas.file?this.H.resolveLocalWorkspace(fe.configPath):void 0)),le||(le=this.ob(X))),le?(0,ae.$Ph)(le.openedWorkspace)?j.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):(0,ae.$Kh)(le.openedWorkspace)?F.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):ue(this.R(R,le,V),!0):ue(await this.jb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const Ie=(0,I.$Jb)(j,we=>we.workspace.id);if(Ie.length>0){const we=(0,I.$Eb)(Ie.map(X=>(0,se.$A5b)(this.getWindows(),X.workspace.configPath)));if(we.length>0){const X=we[0],le=(0,a.$mg)(V?.remoteAuthority,X.remoteAuthority)?V:void 0;ue(this.R(R,X,le),!!le),be=!0}for(const X of Ie){if(we.some(Ee=>Ee.openedWorkspace&&Ee.openedWorkspace.id===X.workspace.id))continue;const le=X.remoteAuthority,fe=(0,a.$mg)(V?.remoteAuthority,le)?V:void 0;ue(await this.W(R,X,be,fe),!!fe),be=!0}}const je=(0,I.$Jb)(F,we=>a.$$f.getComparisonKey(we.workspace.uri));if(je.length>0){const we=(0,I.$Eb)(je.map(X=>(0,se.$A5b)(this.getWindows(),X.workspace.uri)));if(we.length>0){const X=we[0],le=(0,a.$mg)(V?.remoteAuthority,X.remoteAuthority)?V:void 0;ue(this.R(R,X,le),!!le),be=!0}for(const X of je){if(we.some(Ee=>(0,ae.$Kh)(Ee.openedWorkspace)&&a.$$f.isEqual(Ee.openedWorkspace.uri,X.workspace.uri)))continue;const le=X.remoteAuthority,fe=(0,a.$mg)(V?.remoteAuthority,le)?V:void 0;ue(await this.W(R,X,be,fe),!!fe),be=!0}}const ve=(0,I.$Jb)(W,we=>we.backupFolder);if(ve.length>0)for(const we of ve){const X=we.remoteAuthority,le=(0,a.$mg)(V?.remoteAuthority,X)?V:void 0;ue(await this.U(R,!0,X,le,we),!!le),be=!0}if($e.length===0||V){V&&!q&&q++;const we=V?V.remoteAuthority:R.remoteAuthority;for(let X=0;X<q;X++)ue(await this.U(R,be,we,V),!!V),be=!0}return{windows:(0,I.$Jb)($e),filesOpenedInWindow:de}}R(R,j,F){this.r.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),j.focus();const W={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToMerge:F?.filesToMerge,filesToWait:F?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return j.sendWhenReady("vscode:openFiles",S.CancellationToken.None,W),j}S(R,j){this.r.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:j}),R.focus();const F={foldersToAdd:j};return R.sendWhenReady("vscode:addFolders",S.CancellationToken.None,F),R}U(R,j,F,W,q){this.r.trace("windowsManager#doOpenEmpty",{restore:!!q,remoteAuthority:F,filesToOpen:W,forceNewWindow:j});let V;return!j&&typeof R.contextWindowId=="number"&&(V=this.getWindowById(R.contextWindowId)),this.jb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:F,forceNewWindow:j,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:W,windowToUse:V,emptyWindowBackupInfo:q,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}W(R,j,F,W,q){return this.r.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:j,filesToOpen:W}),!F&&!q&&typeof R.contextWindowId=="number"&&(q=this.getWindowById(R.contextWindowId)),this.jb({workspace:j.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:j.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:W,windowToUse:q,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async X(R){let j,F=!1,W=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(j=await this.Y(R),F=!0):R.forceEmpty?j=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(j=await this.Z(R.cli),j.length===0&&j.push(Object.create(null)),F=!0):(j=await this.ab(),j.length===0&&j.push(Object.create(null)),W=!0),!R.addMode&&F){const q=j.filter(V=>x(V));if(q.length>1){const V=q[0].remoteAuthority;if(q.every(re=>(0,a.$mg)(re.remoteAuthority,V))){const re=await this.H.createUntitledWorkspace(q.map($e=>({uri:$e.workspace.uri})));j.push({workspace:re,remoteAuthority:V}),j=j.filter($e=>!x($e))}}}if(R.initialStartup&&!W&&this.F.getValue("window")?.restoreWindows==="preserve"){const q=await this.ab();j.unshift(...q.filter(V=>Q(V)||x(V)||V.backupPath))}return j}async Y(R){const j={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},F=await Promise.all((0,I.$Eb)(R.urisToOpen||[]).map(async W=>{const q=await this.cb(W,j);if(q)return q.label=W.label,q;const V=this.eb(W);this.J.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:V.scheme===f.Schemas.file?(0,g.localize)(1,null):(0,g.localize)(2,null),detail:V.scheme===f.Schemas.file?(0,g.localize)(3,null,(0,w.$dA)(V,{os:d.OS,tildify:this.w})):(0,g.localize)(4,null,V.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,I.$Eb)(F)}async Z(R){const j=[],F={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},W=R["folder-uri"];if(W){const re=await Promise.all(W.map($e=>{const de=this.$($e);if(de)return this.cb({folderUri:de},F)}));j.push(...(0,I.$Eb)(re))}const q=R["file-uri"];if(q){const re=await Promise.all(q.map($e=>{const de=this.$($e);if(de)return this.cb((0,ae.$6h)($e)?{workspaceUri:de}:{fileUri:de},F)}));j.push(...(0,I.$Eb)(re))}const V=await Promise.all(R._.map(re=>F.remoteAuthority?this.hb(re,F):this.fb(re,F)));return j.push(...(0,I.$Eb)(V)),j}$(R){try{const j=E.URI.parse(R);if(!j.scheme){this.r.error(`Invalid URI input string, scheme missing: ${R}`);return}return j.path?j:j.with({path:"/"})}catch(j){this.r.error(`Invalid URI input string: ${R}, ${j.message}`)}}async ab(){const R=this.bb();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const j=[];R!=="one"&&j.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&j.push(this.j.state.lastActiveWindow);const F=await Promise.all(j.map(async W=>{if(W.workspace){const q=await this.cb({workspaceUri:W.workspace.configPath},{remoteAuthority:W.remoteAuthority,rejectTransientWorkspaces:!0});if(Q(q))return q}else if(W.folderUri){const q=await this.cb({folderUri:W.folderUri},{remoteAuthority:W.remoteAuthority});if(x(q))return q}else if(R!=="folders"&&W.backupPath)return{backupPath:W.backupPath,remoteAuthority:W.remoteAuthority}}));return(0,I.$Eb)(F)}}}bb(){let R;return this.C.wasRestarted?R="all":(R=this.F.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async cb(R,j=Object.create(null)){const F=this.eb(R);return F.scheme===f.Schemas.file?((0,T.$RD)(R)&&(j={...j,forceOpenWorkspaceAsFile:!0}),this.fb(F.fsPath,j)):this.db(R,j)}db(R,j){let F=this.eb(R);const W=(0,C.$Nk)(F)||j.remoteAuthority;if(F=(0,a.$og)((0,a.$ig)(F)),(0,T.$RD)(R)){if(j.gotoLineMode){const{path:q,line:V,column:re}=(0,l.$Of)(F.path);return{fileUri:F.with({path:q}),options:{selection:V?{startLineNumber:V,startColumn:re||1}:void 0},remoteAuthority:W}}return{fileUri:F,remoteAuthority:W}}else if((0,T.$PD)(R))return{workspace:(0,ne.$s5b)(F),remoteAuthority:W};return{workspace:(0,ne.$t5b)(F),remoteAuthority:W}}eb(R){return(0,T.$PD)(R)?R.workspaceUri:(0,T.$QD)(R)?R.folderUri:R.fileUri}async fb(R,j,F){let W,q;j.gotoLineMode&&({path:R,line:W,column:q}=(0,l.$Of)(R)),R=(0,l.$Jf)((0,y.$6d)(R),(0,c.cwd)());try{const V=await O.Promises.stat(R);if(V.isFile()){if(!j.forceOpenWorkspaceAsFile){const re=await this.H.resolveLocalWorkspace(E.URI.file(R));if(re)return re.transient&&j.rejectTransientWorkspaces?void 0:{workspace:{id:re.id,configPath:re.configPath},type:n.FileType.File,exists:!0,remoteAuthority:re.remoteAuthority,transient:re.transient}}return{fileUri:E.URI.file(R),type:n.FileType.File,exists:!0,options:{selection:W?{startLineNumber:W,startColumn:q||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,ne.$t5b)(E.URI.file(R),V),type:n.FileType.Directory,exists:!0};if(!d.$i&&R==="/dev/null")return{fileUri:E.URI.file(R),type:n.FileType.File,exists:!0}}}catch(V){if(V.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!F)return this.gb(R,j);const re=E.URI.file(R);if(this.G.removeRecentlyOpened([re]),j.ignoreFileNotFound)return{fileUri:re,type:n.FileType.File,exists:!1}}}async gb(R,j){const F=E.URI.file(R),{response:W,checkboxChecked:q}=await this.J.showMessageBox({type:"warning",buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null),(0,g.localize)(7,null)],message:(0,g.localize)(8,null,F.authority),detail:(0,g.localize)(9,null,(0,w.$dA)(F,{os:d.OS,tildify:this.w})),checkboxLabel:(0,g.localize)(10,null,F.authority),cancelId:1});if(W===0)return(0,s.addUNCHostToAllowlist)(F.authority),q&&this.B(h.Event.once(this.onDidOpenWindow)(V=>{V.sendWhenReady("vscode:configureAllowedUNCHost",S.CancellationToken.None,F.authority)})),this.fb(R,j,!0);if(W===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.gb(R,j)}hb(R,j){const F=R.charCodeAt(0),W=j.remoteAuthority;let q,V;j.gotoLineMode&&({path:R,line:q,column:V}=(0,l.$Of)(R)),F!==47&&((0,l.$If)(F)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,l.$Bf)(R)),R=`/${R}`);const re=E.URI.from({scheme:f.Schemas.vscodeRemote,authority:W,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,ae.$6h)(R))return j.forceOpenWorkspaceAsFile?{fileUri:re,options:{selection:q?{startLineNumber:q,startColumn:V||1}:void 0},remoteAuthority:j.remoteAuthority}:{workspace:(0,ne.$s5b)(re),remoteAuthority:W};if(j.gotoLineMode||y.$5d.basename(R).indexOf(".")!==-1)return{fileUri:re,options:{selection:q?{startLineNumber:q,startColumn:V||1}:void 0},remoteAuthority:W}}return{workspace:(0,ne.$t5b)(re),remoteAuthority:W}}ib(R){const j=this.F.getValue("window"),F=j?.openFoldersInNewWindow||"default",W=j?.openFilesInNewWindow||"off";let q=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(F==="on"||F==="off")&&(q=F==="on");let V=!1;return R.forceNewWindow||R.forceReuseWindow?V=!!R.forceNewWindow&&!R.forceReuseWindow:(d.$j?R.context===1&&(V=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!R.cli.extensionDevelopmentPath&&(W==="on"||W==="off")&&(V=W==="on")),{openFolderInNewWindow:!!q,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(R,j){const F=(0,se.$B5b)(this.getWindows(),R);if(F)return this.C.reload(F,j.cli),F.focus(),[F];let W=j.cli["folder-uri"]||[],q=j.cli["file-uri"]||[],V=j.cli._;if(!V.length&&!W.length&&!q.length&&!j.cli.extensionTestsPath){const de=this.j.state.lastPluginDevelopmentHostWindow,ue=de?.workspace??de?.folderUri;ue&&(E.URI.isUri(ue)?ue.scheme===f.Schemas.file?V=[ue.fsPath]:W=[ue.toString()]:ue.configPath.scheme===f.Schemas.file?V=[(0,a.$8f)(ue.configPath)]:q=[ue.configPath.toString()])}let re=j.remoteAuthority;for(const de of R)if(de.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=E.URI.parse(de),be=(0,C.$Nk)(ue);be&&(re?(0,a.$mg)(be,re)||this.r.error("more than one extension development path authority"):re=be)}V=V.filter(de=>{const ue=E.URI.file(de);return(0,se.$A5b)(this.getWindows(),ue)?!1:(0,a.$mg)((0,C.$Nk)(ue),re)}),W=W.filter(de=>{const ue=this.$(de);return ue&&(0,se.$A5b)(this.getWindows(),ue)?!1:ue?(0,a.$mg)((0,C.$Nk)(ue),re):!1}),q=q.filter(de=>{const ue=this.$(de);return ue&&(0,se.$A5b)(this.getWindows(),ue)?!1:ue?(0,a.$mg)((0,C.$Nk)(ue),re):!1}),j.cli._=V,j.cli["folder-uri"]=W,j.cli["file-uri"]=q;const $e={context:j.context,cli:j.cli,forceNewWindow:!0,forceEmpty:!V.length&&!W.length&&!q.length,userEnv:j.userEnv,noRecentEntry:!0,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:re,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile};return this.open($e)}async jb(R){const j=this.F.getValue("window"),F=this.getLastActiveWindow(),W=F?.profile??this.z.defaultProfile;let q;!R.forceNewWindow&&!R.forceNewTabbedWindow&&(q=R.windowToUse||F,q&&q.focus());const V={...this.w.args,...R.cli,machineId:this.m,windowId:-1,mainPid:process.pid,appRoot:this.w.appRoot,execPath:process.execPath,codeCachePath:this.w.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,y.$8d)(this.w.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.z.profilesHome,all:this.z.profiles,profile:W},homeDir:this.w.userHome.with({scheme:f.Schemas.file}).fsPath,tmpDir:this.w.tmpDir.with({scheme:f.Schemas.file}).fsPath,userDataDir:this.w.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.n,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.s.getLogLevel(),loggers:{window:[],global:this.s.getRegisteredLoggers()},logsPath:this.w.logsHome.with({scheme:f.Schemas.file}).fsPath,product:D.default,isInitialStartup:R.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof j?.zoomLevel=="number"?j.zoomLevel:void 0,autoDetectHighContrast:j?.autoDetectHighContrast??!0,autoDetectColorScheme:j?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.N.getColorScheme(),policiesData:this.u.serialize(),continueOn:this.w.continueOn};if(q){const re=q.config;!V.extensionDevelopmentPath&&re?.extensionDevelopmentPath&&(V.extensionDevelopmentPath=re.extensionDevelopmentPath,V.extensionDevelopmentKind=re.extensionDevelopmentKind,V["enable-proposed-api"]=re["enable-proposed-api"],V.verbose=re.verbose,V["inspect-extensions"]=re["inspect-extensions"],V["inspect-brk-extensions"]=re["inspect-brk-extensions"],V.debugId=re.debugId,V.extensionEnvironment=re.extensionEnvironment,V["extensions-dir"]=re["extensions-dir"],V["disable-extensions"]=re["disable-extensions"]),V.loggers={global:V.loggers.global,window:re?.loggers.window??V.loggers.window}}else{const re=this.j.getNewWindowState(V);(0,m.mark)("code/willCreateCodeWindow");const $e=q=this.I.createInstance(z.$B6b,{state:re,extensionDevelopmentPath:V.extensionDevelopmentPath,isExtensionTestHost:!!V.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow($e),H.a.push($e),this.b.fire($e),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,b.$bb)($e.onDidSignalReady)(()=>this.c.fire($e)),(0,b.$bb)($e.onDidClose)(()=>this.mb($e)),(0,b.$bb)($e.onDidDestroy)(()=>this.f.fire($e)),$e.onDidTriggerSystemContextMenu(({x:ue,y:be})=>this.h.fire({window:$e,x:ue,y:be}));const de=(0,$.$tf)($e.win?.webContents);de.removeAllListeners("devtools-reload-page"),de.on("devtools-reload-page",()=>this.C.reload($e)),this.C.registerWindow($e)}return V.windowId=q.id,q.isReady?this.C.unload(q,4).then(async re=>{re||await this.kb(q,V,R,W)}):await this.kb(q,V,R,W),q}async kb(R,j,F,W){if(j.extensionDevelopmentPath||((0,ae.$Ph)(j.workspace)?j.backupPath=this.D.registerWorkspaceBackup({workspace:j.workspace,remoteAuthority:j.remoteAuthority}):(0,ae.$Kh)(j.workspace)?j.backupPath=this.D.registerFolderBackup({folderUri:j.workspace.uri,remoteAuthority:j.remoteAuthority}):j.backupPath=this.D.registerEmptyWindowBackup({backupFolder:F.emptyWindowBackupInfo?.backupFolder??(0,ne.$u5b)().id,remoteAuthority:j.remoteAuthority})),this.z.isEnabled()){const q=j.workspace??(0,ae.$Oh)(j.backupPath,!1),V=this.lb(F,q,W),re=V instanceof Promise?await V:V;j.profiles.profile=re,j.extensionDevelopmentPath||await this.z.setProfileForWorkspace(q,re)}R.load(j)}lb(R,j,F){return R.forceProfile?this.z.profiles.find(W=>W.name===R.forceProfile)??this.z.createNamedProfile(R.forceProfile):R.forceTempProfile?this.z.createTransientProfile():this.z.getProfileForWorkspace(j)??F}mb(R){const j=H.a.indexOf(R);H.a.splice(j,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=P.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.ob(this.getWindows())}nb(R){return this.ob(this.getWindows().filter(j=>(0,a.$mg)(j.remoteAuthority,R)))}ob(R){const j=Math.max.apply(Math,R.map(F=>F.lastFocusTime));return R.find(F=>F.lastFocusTime===j)}sendToFocused(R,...j){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,S.CancellationToken.None,...j)}sendToAll(R,j,F){for(const W of this.getWindows())F&&F.indexOf(W.id)>=0||W.sendWhenReady(R,S.CancellationToken.None,j)}getWindows(){return H.a}getWindowCount(){return H.a.length}getWindowById(R){const j=this.getWindows().filter(F=>F.id===R);return(0,I.$Lb)(j)}getWindowByWebContents(R){const j=P.BrowserWindow.fromWebContents(R);if(j)return this.getWindowById(j.id)}};e.$F6b=ce,e.$F6b=ce=H=ke([_(2,A.$4i),_(3,N.$d6b),_(4,L.$aN),_(5,B.$9m),_(6,i.$04b),_(7,U.$f5b),_(8,k.$_4b),_(9,t.$q5b),_(10,u.$7h),_(11,oe.$$5b),_(12,G.$C5b),_(13,o.$zh),_(14,r.$x5b),_(15,n.$5j),_(16,v.$Z5b),_(17,J.$T5b)],ce)}),define(te[305],ie([0,1,64,30,83,54]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H6b=void 0;let I=class{constructor(h,l,b,w){this.a=h,this.b=l,this.c=b,this.d=w,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,l){const b=this.b.getWindowById(h);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),l)}createUntitledWorkspace(h,l,b){return this.a.createUntitledWorkspace(l,b)}deleteUntitledWorkspace(h,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(h,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(h,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$H6b=I,e.$H6b=I=ke([_(0,M.$C5b),_(1,O.$l5b),_(2,s.$$5b),_(3,P.$q5b)],I)}),define(te[306],ie([0,1,15,131,38,27,17,50,14,32,49,44,46,2,13,9,4,12,7,31,147,42,158,110,288,161,64,284,18,199,90,132,61,115,218,28,63,94,208,233,209,293,117,210,211,16,222,93,75,6,92,217,298,285,273,20,5,303,67,24,60,294,95,34,276,82,122,25,250,252,52,48,264,290,299,291,300,127,266,267,268,271,274,30,304,275,29,97,83,305,54,39,231,53,243,51,81,129,278,292,281,8,254,277,226,66,91,296,270,23,125,295,262,238,84]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g,t,u,r,i,n,o,k,A,D,v,C,L,T,z,se,ee,ae,ne,oe,G,J,B,U,N,H,Q,x,ce,Y,R,j,F,W,q,V,re,$e,de,ue,be,me,Se,Ie,je,ve,we,X,le,fe,Ee,Re,Fe,Oe,ze,We,Z,he,ge,ye,Ce,Ue,Le,Te,Be,qe,He,xe,Qe,tt,nt,$t,rt,mt,wt,bt,pt,yt,vt,kt,ot,Et,St,Pt,At,It,at,Dt,ht,ct,Ct,Rt,lt,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=void 0;let ut=class extends f.$jc{constructor(Ae,Pe,pe,Me,De,Ne,Je,Ze,Xe,Ge,Ve,Ke){super(),this.c=Ae,this.f=Pe,this.g=pe,this.h=Me,this.j=De,this.m=Ne,this.n=Je,this.s=Ze,this.t=Xe,this.u=Ge,this.w=Ve,this.y=Ke,this.z(),this.C()}z(){const Ae=Ge=>Ge?.startsWith(`${y.Schemas.vscodeWebview}://`),Pe=new Set(this.w.quality==="stable"?[]:["media"]),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Ge,Ve,Ke,Ye)=>Ae(Ye.requestingUrl)?Ke(pe.has(Ve)):Ye.isMainFrame&&Ye.securityOrigin==="vscode-file://vscode-app/"?Ke(Pe.has(Ve)):Ke(!1)),P.session.defaultSession.setPermissionCheckHandler((Ge,Ve,Ke,Ye)=>Ae(Ye.requestingUrl)?pe.has(Ve):Ye.isMainFrame&&Ye.securityOrigin==="vscode-file://vscode-app/"?Pe.has(Ve):!1);const Me=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),De=Ge=>{for(let Ve=Ge;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Ne=Ge=>Ge.resourceType==="xhr"||De(Ge.frame),Je=Ge=>{const Ve=Ge.frame;if(!Ve||!this.a)return!1;const Ke=P.BrowserWindow.getAllWindows();for(const Ye of Ke)if(Ve.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Ze=(Ge,Ve)=>{if(Ge.path!=="/index.html")return!0;const Ke=Ve.frame;if(!Ke||!this.a)return!1;for(const Ye of this.a.getWindows())if(Ye.win&&Ke.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Ge,Ve)=>{const Ke=a.URI.parse(Ge.url);return Ke.scheme===y.Schemas.vscodeWebview&&!Ze(Ke,Ge)?(this.h.error("Blocked vscode-webview request",Ge.url),Ve({cancel:!0})):Ke.scheme===y.Schemas.vscodeFileResource&&!Je(Ge)?(this.h.error("Blocked vscode-file request",Ge.url),Ve({cancel:!0})):Ke.path.endsWith(".svg")&&!Me.has(Ke.scheme)?Ve({cancel:!Ne(Ge)}):Ve({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Ge,Ve)=>{const Ke=Ge.responseHeaders,Ye=Ke["content-type"]||Ke["Content-Type"];if(Ye&&Array.isArray(Ye)){const it=a.URI.parse(Ge.url);if(it.path.endsWith(".svg")&&Me.has(it.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ke});if(!it.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ye.some(_e=>_e.toLowerCase().includes("image/svg")))return Ve({cancel:!Ne(Ge)})}return Ve({cancel:!1})});const Xe=P.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.m.codeCachePath&&Xe.setCodeCachePath((0,m.$8d)(this.m.codeCachePath,"chrome")),d.$i&&(this.s.getValue("security.restrictUNCAccess")===!1?(0,O.disableUNCAccessRestrictions)():(0,O.addUNCHostToAllowlist)(this.s.getValue("security.allowedUNCHosts")))}C(){(0,h.setUnexpectedErrorHandler)(pe=>this.F(pe)),process.on("uncaughtException",pe=>{(0,h.$X)(pe)||(0,h.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,h.$Y)(pe)),this.n.onWillShutdown(()=>this.dispose()),(0,E.$NS)(),P.app.on("accessibility-support-changed",(pe,Me)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Me)}),P.app.on("activate",async(pe,Me)=>{this.h.trace("app#activate"),Me||await this.a?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(pe,Me)=>{Me.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Me.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let Ae=[],Pe;P.app.on("open-file",(pe,Me)=>{this.h.trace("app#open-file: ",Me),pe.preventDefault(),Ae.push((0,qe.$6h)(Me)?{workspaceUri:a.URI.file(Me)}:{fileUri:a.URI.file(Me)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.a?.open({context:1,cli:this.m.args,urisToOpen:Ae,gotoLineMode:!1,preferNewWindow:!0}),Ae=[],Pe=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),s.$MS.handle("vscode:fetchShellEnv",pe=>{const Me=this.a?.getWindowByWebContents(pe.sender);let De,Ne;return Me?.config?(De=Me.config,Ne={...process.env,...Me.config.userEnv}):(De=this.m.args,Ne=process.env),this.U(De,Ne,!1)}),s.$MS.handle("vscode:writeNlsFile",(pe,Me,De)=>{const Ne=this.D([Me]);if(!Ne||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.u.writeFile(Ne,I.$Ed.fromString(De))}),s.$MS.handle("vscode:readNlsFile",async(pe,...Me)=>{const De=this.D(Me);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.u.readFile(De)).value.toString()}),s.$MS.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),s.$MS.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),s.$MS.on("vscode:reloadWindow",pe=>pe.sender.reload())}D(Ae){let Pe;for(const pe of Ae)typeof pe=="string"&&(typeof Pe!="string"?Pe=pe:Pe=(0,m.$8d)(Pe,pe));if(!(typeof Pe!="string"||!(0,m.$7d)(Pe)||!(0,l.$Hf)(Pe,this.m.cachedLanguagesPath,!d.$k)))return a.URI.file(Pe)}F(Ae){if(Ae){const Pe={message:`[uncaught exception in main]: ${Ae.message}`,stack:Ae.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.h.error(`[uncaught exception in main]: ${Ae}`),Ae.stack&&this.h.error(Ae.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.m.appRoot}`),this.h.debug("args:",this.m.args);const Ae=this.w.win32AppUserModelId;d.$i&&Ae&&P.app.setAppUserModelId(Ae);try{d.$j&&this.s.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Xe){this.h.error(Xe)}const Pe=new t.$TS;this.n.onWillShutdown(Xe=>{Xe.reason===2&&Pe.dispose()}),this.h.trace("Resolving machine identifier...");const pe=await(0,Et.$O6b)(this.t,this.h);this.h.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Me,sharedProcessClient:De}=this.N(pe),Ne=await this.O(pe,Me);this.B(Ne.createInstance(r.$m5b)),this.B(Ne.createInstance(vt.$L6b)),Ne.invokeFunction(Xe=>this.P(Xe,Pe,De));const Je=Ne.invokeFunction(Xe=>this.G(Xe,Pe));this.H(Pe),this.n.phase=2,await Ne.invokeFunction(Xe=>this.Q(Xe,Je)),this.n.phase=3,this.R(),this.B(new ot.$Rg(()=>{this.B((0,ot.$Vg)(()=>this.n.phase=4,2500))},2500)).schedule()}G(Ae,Pe){const pe=this.a=Ae.get(Le.$l5b),Me=Ae.get(Z.$AT),De=this.b=Ae.get($e.$X5b),Ne=this;Me.registerHandler({async handleURL(Ke,Ye){return Ne.M(pe,Me,Ke,Ye)}});const Je=this.B(new Be.$G6b({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Ze=new g.$ih(Ke=>Je.getActiveClientId().then(Ye=>Ke===Ye)),Xe=new he.$w6b(Ze,this.h),Ge=Pe.getChannel("urlHandler",Xe);Me.registerHandler(new he.$v6b(Ge));const Ve=this.I();return this.B(new ye.$x6b(Ve?.urls,Me,pe,this.m,this.w,this.h)),Ve}H(Ae){const Pe=()=>({statusCode:404,data:"Not found"}),pe=new Ot.$T(()=>Ae.getChannel(lt.$V6b,new lt.$W6b));P.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(Me,De)=>{const Ne=a.URI.parse(Me.url);if(!Ne.authority.startsWith("window:"))return De(Pe());pe.value.call(lt.$U6b,[Ne]).then(Je=>De({...Je,data:Buffer.from(Je.body,"base64")}),Je=>{this.h.warn("error dispatching remote resource call",Je),De({statusCode:500,data:String(Je)})})})}I(){const Ae=this.m.args["open-url"]?this.m.args._urls||[]:[];Ae.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ae);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),Ae.length+Pe.length===0)return;const pe=[];return{urls:[...Ae,...Pe].map(De=>{try{return{uri:a.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.J(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const Ne=this.L(De.uri);return Ne?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),Ne),pe.push(Ne),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:pe}}J(Ae){if(Ae.authority===y.Schemas.file&&d.$i){const{options:Pe,buttonIndeces:pe}=(0,It.$rA)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,p.$dA)(Ae,{os:d.OS,tildify:this.m}),this.w.nameShort),detail:(0,i.localize)(3,null)},this.w);if(pe[P.dialog.showMessageBoxSync(Pe)]===1)return!0}return!1}L(Ae){if(Ae.path){if(Ae.authority===y.Schemas.file){const Pe=a.URI.file(Ae.fsPath);return(0,qe.$6h)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ae.authority===y.Schemas.vscodeRemote){const Pe=Ae.path.indexOf(m.$5d.sep,1);if(Pe!==-1){const pe=Ae.path.substring(1,Pe),Me=Ae.path.substring(Pe);let De=Ae.query;const Ne=new URLSearchParams(Ae.query);Ne.get("windowId")==="_blank"&&(Ne.delete("windowId"),De=Ne.toString());const Je=a.URI.from({scheme:y.Schemas.vscodeRemote,authority:pe,path:Me,query:De,fragment:Ae.fragment});return(0,qe.$6h)(Me)?{workspaceUri:Je}:/:[\d]+$/.test(Me)?{fileUri:Je}:{folderUri:Je}}}}}async M(Ae,Pe,pe,Me){if(this.h.trace("app#handleProtocolUrl():",pe.toString(!0),Me),pe.scheme===this.w.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:a.URI.parse(pe.query).path,query:""})),this.J(pe))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let De=!1;const Ne=new URLSearchParams(pe.query);Ne.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Ne.delete("windowId"),pe=pe.with({query:Ne.toString()}),De=!0):d.$j&&Ae.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),De=!0);const Je=Ne.get("continueOn");Je!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Ne.delete("continueOn"),pe=pe.with({query:Ne.toString()}),this.m.continueOn=Je??void 0);const Ze=this.L(pe);return Ze?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Ze,pe.toString(!0)),(0,ht.$Lb)(await Ae.open({context:5,cli:{...this.m.args},urisToOpen:[Ze],forceNewWindow:De,gotoLineMode:!0}))?.focus(),!0):De?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,ht.$Lb)(await Ae.open({context:5,cli:{...this.m.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.$Nk)(pe)}))?.ready(),Pe.open(pe,Me)):(this.h.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Me),!1)}N(Ae){const Pe=this.B(this.g.createInstance(be.$i6b,Ae)),pe=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await Pe.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new u.$US(De,"main")})();return{sharedProcessReady:(async()=>(await Pe.whenReady(),pe))(),sharedProcessClient:pe}}async O(Ae,Pe){const pe=new Y.$yh;switch(process.platform){case"win32":pe.set(Ee.$MT,new x.$xh(We.$t6b));break;case"linux":d.$l?pe.set(Ee.$MT,new x.$xh(ze.$s6b,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Ee.$MT,new x.$xh(Oe.$r6b));break;case"darwin":pe.set(Ee.$MT,new x.$xh(Fe.$q6b));break}pe.set(Le.$l5b,new x.$xh(Te.$F6b,[Ae,this.f],!1));const Me=new C.$y5b(this.h,this.w);pe.set(C.$x5b,Me),pe.set(W.$55b,new x.$xh(W.$65b,void 0,!1)),pe.set(v.$H5b,new x.$xh(v.$I5b,void 0,!1)),pe.set(D.$fm,g.ProxyChannel.toService((0,g.$gh)(Pe.then(Xe=>Xe.getChannel("diagnostics"))))),pe.set(R.$itb,new x.$xh(j.$15b,[this.f])),pe.set(L.$uT,new x.$xh(T.$J5b)),pe.set(F.$25b,new x.$xh(F.$35b)),pe.set($e.$X5b,new x.$xh($e.$Y5b,void 0,!1)),pe.set(Ce.$y6b,new x.$xh(Ue.$A6b)),pe.set(re.$b6b,new x.$xh(re.$c6b)),pe.set(ae.$Ykb,new x.$xh(ne.$K5b)),pe.set(oe.$L5b,new x.$xh(G.$N5b)),pe.set(je.$h5b,new x.$xh(je.$i5b)),pe.set(je.$j5b,new x.$xh(je.$k5b));const De=new Ct.$T6b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.s.getValue("terminal.integrated.persistentSessionScrollback")??100},this.s,this.m,this.n,this.h),Ne=new Rt.$kr(De,this.s,this.h,this.j);pe.set(ct.$Xq,Ne),d.$i?pe.set(J.$7Wb,new x.$xh(B.$O5b)):d.$j?pe.set(J.$7Wb,new x.$xh(B.$P5b)):d.$k&&pe.set(J.$7Wb,new x.$xh(B.$Q5b));const Je=new o.$v5b(this.m,this.s,this.h,this.t);pe.set(n.$q5b,Je);const Ze=new tt.$D5b(this.m,this.h,this.y,Je,Me);if(pe.set(tt.$C5b,Ze),pe.set(He.$0T,new x.$xh(Qe.$H6b,void 0,!1)),pe.set(xe.$$5b,new x.$xh(xe.$_5b,void 0,!1)),pe.set(Z.$AT,new x.$xh(ge.$CT,void 0,!1)),(0,fe.$go)(this.w,this.m)){const Xe=(0,fe.$lo)(this.w,this.s),Ge=(0,g.$gh)(Pe.then(_e=>_e.getChannel("telemetryAppender"))),Ve=new X.$l6b(Ge),Ke=(0,ve.$9n)((0,M.release)(),(0,M.hostname)(),process.arch,this.w.commit,this.w.version,Ae,Xe),Ye=(0,fe.$mo)(this.m),it={appenders:[Ve],commonProperties:Ke,piiPaths:Ye,sendErrorTelemetry:!0};pe.set(we.$8k,new x.$xh(le.$Pq,[it],!1))}else pe.set(we.$8k,fe.$ao);return pe.set(bt.$jp,new x.$xh(St.$hN,void 0,!0)),pe.set(pt.$np,new x.$xh(yt.$K6b,void 0,!0)),pe.set(at.$R6b,new x.$xh(at.$S6b,void 0,!0)),await ot.Promises.settled([Je.initialize(),Ze.initialize()]),this.g.createChild(pe)}P(Ae,Pe,pe){const Me=this.B(new f.$ic),De=g.ProxyChannel.fromService(Ae.get(W.$55b),Me,{disableMarshalling:!0});this.c.registerChannel("launch",De);const Ne=g.ProxyChannel.fromService(Ae.get(v.$H5b),Me,{disableMarshalling:!0});this.c.registerChannel("diagnostics",Ne);const Je=new $t.$I6b(Ae.get(nt.$9m));Pe.registerChannel("policy",Je),pe.then(et=>et.registerChannel("policy",Je));const Ze=this.u.getProvider(y.Schemas.file);(0,c.$sf)(Ze instanceof Q.$2p);const Xe=new H.$R5b(Ze,this.h,this.m);Pe.registerChannel(U.$3M,Xe),pe.then(et=>et.registerChannel(U.$3M,Xe));const Ge=g.ProxyChannel.fromService(Ae.get(rt.$f5b),Me);Pe.registerChannel("userDataProfiles",Ge),pe.then(et=>et.registerChannel("userDataProfiles",Ge));const Ve=new mt.$Kq(Ae.get(wt.$Ho));pe.then(et=>et.registerChannel("request",Ve));const Ke=new Re.$m6b(Ae.get(Ee.$MT));Pe.registerChannel("update",Ke);const Ye=g.ProxyChannel.fromService(Ae.get(R.$itb),Me);Pe.registerChannel("issue",Ye);const it=g.ProxyChannel.fromService(Ae.get(L.$uT),Me);Pe.registerChannel("encryption",it);const _e=g.ProxyChannel.fromService(Ae.get(me.$Vk),Me);Pe.registerChannel("sign",_e);const st=g.ProxyChannel.fromService(Ae.get(F.$25b),Me);Pe.registerChannel("keyboardLayout",st),this.b=Ae.get($e.$X5b);const ft=g.ProxyChannel.fromService(this.b,Me);Pe.registerChannel("nativeHost",ft),pe.then(et=>et.registerChannel("nativeHost",ft));const Mt=g.ProxyChannel.fromService(Ae.get(He.$0T),Me);Pe.registerChannel("workspaces",Mt);const Lt=g.ProxyChannel.fromService(Ae.get(re.$b6b),Me);Pe.registerChannel("menubar",Lt);const jt=g.ProxyChannel.fromService(Ae.get(Z.$AT),Me);Pe.registerChannel("url",jt);const Ut=g.ProxyChannel.fromService(Ae.get(ae.$Ykb),Me);Pe.registerChannel("extensionUrlTrust",Ut);const Ft=g.ProxyChannel.fromService(Ae.get(Ce.$y6b),Me);Pe.registerChannel("webview",Ft);const dt=this.B(new Ie.$j6b(this.h,Ae.get(je.$h5b)));Pe.registerChannel("storage",dt),pe.then(et=>et.registerChannel("storage",dt));const Tt=this.B(new kt.$M6b(Ae.get(je.$h5b),Ae.get(rt.$f5b),this.h));pe.then(et=>et.registerChannel("profileStorageListener",Tt));const Nt=g.ProxyChannel.fromService(Ae.get(ct.$Xq),Me);Pe.registerChannel(ct.TerminalIpcChannels.LocalPty,Nt);const Wt=g.ProxyChannel.fromService(Ae.get(J.$7Wb),Me);Pe.registerChannel("externalTerminal",Wt);const gt=new Pt.$P6b(Ae.get(At.$d6b));Pe.registerChannel("logger",gt),pe.then(et=>et.registerChannel("logger",gt));const zt=new A.$w5b(Ae.get(Le.$l5b));Pe.registerChannel("extensionhostdebugservice",zt);const Bt=g.ProxyChannel.fromService(Ae.get(oe.$L5b),Me);Pe.registerChannel(oe.$M5b,Bt);const qt=g.ProxyChannel.fromService(Ae.get(at.$R6b),Me);Pe.registerChannel(Dt.$Q6b,qt)}async Q(Ae,Pe){const pe=this.a=Ae.get(Le.$l5b),Me=(0,se.$Fl)(process.env)?0:4,De=this.m.args;if(Pe){if(Pe.openables.length>0)return pe.open({context:Me,cli:De,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const _e of Pe.urls){const st=new URLSearchParams(_e.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),_e.originalUrl=_e.uri.toString(!0),_e.uri=_e.uri.with({query:st.toString()}),pe.open({context:Me,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,Je=De._.length,Ze=!!De["folder-uri"],Xe=!!De["file-uri"],Ge=De["skip-add-to-recently-opened"]===!0,Ve=De.wait&&De.waitMarkerFilePath?a.URI.file(De.waitMarkerFilePath):void 0,Ke=De.remote||void 0,Ye=De.profile,it=De["profile-temp"];if(!Je&&!Ze&&!Xe){if(De["new-window"]||Ye||it)return pe.open({context:Me,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ye,forceTempProfile:it});if(Ne.length)return pe.open({context:1,cli:De,urisToOpen:Ne.map(_e=>(0,qe.$6h)(_e)?{workspaceUri:a.URI.file(_e)}:{fileUri:a.URI.file(_e)}),noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0})}return pe.open({context:Me,cli:De,forceNewWindow:De["new-window"]||!Je&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ge,waitMarkerFileURI:Ve,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ye,forceTempProfile:it})}R(){this.S(),P.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Ae,Pe)=>{Pe({url:Ae.url.replace(/^vscode-remote-resource:/,"http:"),method:Ae.method})}),this.U(this.m.args,process.env,!0),this.W(),d.$j&&P.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async S(){const Ae=this.w.win32MutexName;if(d.$i&&Ae)try{const Pe=await new Promise((Me,De)=>{K(["@vscode/windows-mutex"],Me,De)}),pe=new Pe.Mutex(Ae);(0,b.$bb)(this.n.onWillShutdown)(()=>pe.release())}catch(Pe){this.h.error(Pe)}}async U(Ae,Pe,pe){try{return await(0,ee.$Ll)(this.s,this.h,Ae,Pe)}catch(Me){const De=(0,S.$li)(Me);pe?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async W(){try{const Pe=(await this.u.readFile(this.m.argvResource)).value.toString(),pe=JSON.parse((0,w.$Sm)(Pe)),De=(0,fe.$io)(this.s)>=1;if(pe["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$3f)()}"`,"}"],Je=Pe.substring(0,Pe.length-2).concat(`,
`,Ne.join(`
`));await this.u.writeFile(this.m.argvResource,I.$Ed.fromString(Je))}else{const Ne=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);Ne!==Pe&&await this.u.writeFile(this.m.argvResource,I.$Ed.fromString(Ne))}}catch(Ae){this.h.error(Ae)}}};e.$X6b=ut,e.$X6b=ut=ke([_(2,ce.$zh),_(3,V.$4i),_(4,V.$5i),_(5,z.$04b),_(6,q.$_4b),_(7,k.$7h),_(8,Se.$aN),_(9,N.$5j),_(10,de.$jj),_(11,rt.$f5b)],ut)}),define(te[312],ie([0,1,15,45,7,23,8,50,14,32,49,46,13,9,65,4,35,26,21,42,99,306,10,18,237,249,28,63,201,16,220,93,75,216,92,20,223,5,77,24,78,279,126,289,51,287,95,248,34,52,79,53,39,232,230,2,40,265,66,225,91,121,269,263]),function(K,e,P,O,s,M,I,S,h,l,b,w,p,f,y,m,d,c,a,$,E,g,t,u,r,i,n,o,k,A,D,v,C,L,T,z,se,ee,ae,ne,oe,G,J,B,U,N,H,Q,x,ce,Y,R,j,F,W,q,V,re,$e,de,ue,be,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(ve){console.error(ve.message),P.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[ve,we,X,le,fe,Ee,Re,Fe]=this.b();try{try{await this.d(X,Fe,le,fe,Re)}catch(Oe){throw this.f(X,Re,Oe),Oe}await ve.invokeFunction(async Oe=>{const ze=Oe.get(ee.$4i),We=Oe.get(z.$_4b),Z=Oe.get(A.$5j),he=Oe.get(ee.$5i),ge=await this.e(ze,X,We,ve,Re,!0);return a.Promises.writeFile(X.mainLockfile,String(process.pid)).catch(ye=>{ze.warn(`app#startup(): Error writing main lockfile: ${ye.stack}`)}),Ee.logger=he.createLogger("main",{name:(0,t.localize)(0,null)}),(0,b.$bb)(We.onWillShutdown)(ye=>{Z.dispose(),le.dispose(),ye.join("instanceLockfile",a.Promises.unlink(X.mainLockfile).catch(()=>{}))}),ve.createInstance(g.$X6b,ge,we).startup()})}catch(Oe){ve.invokeFunction(this.i,Oe)}}b(){const ve=new T.$yh,we=new q.$ic;process.once("exit",()=>we.dispose());const X={_serviceBrand:void 0,...ae.default};ve.set(ne.$jj,X);const le=new n.$$4b(this.j(),X),fe=this.c(le);ve.set(n.$04b,le);const Ee=new $e.$e6b((0,ee.$fj)(le),le.logsHome);ve.set($e.$d6b,Ee);const Re=new se.$S2b(Ee.getLogLevel()),Fe=we.add(new de.$iN(Re,[new ee.$$i(Ee.getLogLevel())]));ve.set(ee.$4i,Fe);const Oe=new D.$Cp(Fe);ve.set(A.$5j,Oe);const ze=new v.$2p(Fe);Oe.registerProvider(p.Schemas.file,ze);const We=new re.$or(Oe);ve.set(V.$Bk,We);const Z=new be.$dN(1,le,Fe,Oe);ve.set(x.$_M,Z),ve.set(x.$aN,Z);const he=new R.$g5b(Z,We,le,Oe,Fe);ve.set(R.$f5b,he),Oe.registerProvider(p.Schemas.vscodeUserData,new me.$96b(p.Schemas.file,ze,p.Schemas.vscodeUserData,he,We,Fe));const ge=m.$i&&X.win32RegValueName?we.add(new F.$76b(Fe,X.win32RegValueName)):le.policyFile?we.add(new W.$86b(le.policyFile,Oe,Fe)):new j.$$m;ve.set(j.$9m,ge);const ye=new r.$yn(he.defaultProfile.settingsResource,Oe,ge,Fe);return ve.set(u.$7h,ye),ve.set(z.$_4b,new C.$xh(z.$a5b,void 0,!1)),ve.set(U.$Ho,new C.$xh(N.$56b,void 0,!0)),ve.set(Y.$T5b,new C.$xh(Y.$U5b)),ve.set(H.$Vk,new C.$xh(Q.$66b,void 0,!1)),ve.set(J.$Vz,new C.$xh(B.$36b)),ve.set(oe.$Z5b,new G.$Z6b(le,he,Fe)),[new L.$5p(ve,!0),fe,le,ye,Z,Re,X,he]}c(ve){const we={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(X=>{const le=process.env[X];typeof le=="string"&&(we[X]=le)}),Object.assign(process.env,we),we}async d(ve,we,X,le,fe){await I.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsHome.with({scheme:p.Schemas.file}).fsPath,we.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,ve.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,ve.localHistoryHome.with({scheme:p.Schemas.file}).fsPath,ve.backupHome].map(Ee=>Ee?a.Promises.mkdir(Ee,{recursive:!0}):void 0)),le.init(),X.initialize()]),we.init()}async e(ve,we,X,le,fe,Ee){let Re;try{(0,y.mark)("code/willStartMainServer"),Re=await(0,E.$vh)(we.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,b.$bb)(X.onWillShutdown)(()=>Re.dispose())}catch(Fe){if(Fe.code!=="EADDRINUSE")throw this.f(we,fe,Fe),Fe;let Oe;try{Oe=await(0,E.$wh)(we.mainIPCHandle,"main")}catch(he){if(!Ee||m.$i||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,t.localize)(1,null,fe.nameShort),(0,t.localize)(2,null),fe),he;try{(0,O.unlinkSync)(we.mainIPCHandle)}catch(ge){throw ve.warn("Could not delete obsolete instance handle",ge),ge}return this.e(ve,we,X,le,fe,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${fe.nameShort} is running.`;throw ve.error(he),Oe.dispose(),new Error(he)}let ze;!we.args.wait&&!we.args.status&&(ze=setTimeout(()=>{this.g((0,t.localize)(3,null,fe.nameShort),(0,t.localize)(4,null),fe)},1e4));const We=$.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Z=$.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return le.invokeFunction(async()=>{const he=new i.$vr(ce.$ao,fe),ge=await Z.getMainDiagnostics(),ye=await Z.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ce=await he.getDiagnostics(ge,ye);throw console.log(Ce),new h.$$});throw m.$i&&await this.h(We,ve),ve.trace("Sending env to running instance..."),await We.start(we.args,process.env),Oe.dispose(),ze&&clearTimeout(ze),new h.$$("Sent env to running instance. Terminating...")}if(we.args.status)throw console.log((0,t.localize)(5,null,fe.nameShort)),new h.$$("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}f(ve,we,X){if(X.code==="EACCES"||X.code==="EPERM"){const le=(0,M.$Eb)([ve.userDataPath,ve.extensionsPath,E.$rh]).map(fe=>(0,w.$dA)(s.URI.file(fe),{os:m.OS,tildify:ve}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$li)(X),le.join(`
`)),we)}}g(ve,we,X){P.dialog.showMessageBoxSync((0,ue.$rA)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ve,detail:we},X).options)}async h(ve,we){if(m.$i){const X=await ve.getMainProcessId();we.trace("Sending some foreground love to the running instance:",X);try{(await new Promise((le,fe)=>{K(["windows-foreground-love"],le,fe)})).allowSetForegroundWindow(X)}catch(le){we.error(le)}}}i(ve,we){const X=ve.get(ee.$4i),le=ve.get(z.$_4b);let fe=0;we&&(we.isExpected?we.message&&X.trace(we.message):(fe=1,we.stack?X.error(we.stack):X.error(`Startup error: ${we.toString()}`))),le.kill(fe)}j(){const ve=this.k((0,o.$Cl)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const we=(0,k.$Y6b)(ve.verbose);we&&((0,o.$El)(process.argv,"--waitMarkerFilePath",we),ve.waitMarkerFilePath=we)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const we=this.l(ve._,ve.goto);ve._=we}return ve}l(ve,we){const X=(0,d.cwd)(),le=ve.map(Re=>{let Fe=String(Re),Oe;we&&(Oe=(0,l.$Of)(Fe),Fe=Oe.path),Fe&&(Fe=this.m(X,Fe));const ze=(0,l.$Jf)(Fe,X),We=(0,f.$_d)(ze);return We&&!(0,l.$Ff)(We)?null:we&&Oe?(Oe.path=ze,this.n(Oe)):ze}),fe=m.$i||m.$j,Ee=(0,M.$Jb)(le,Re=>Re&&fe?Re.toLowerCase():Re||"");return(0,M.$Eb)(Ee)}m(ve,we){return m.$i&&(we=(0,c.$ue)(we,'"')),we=(0,c.$se)((0,c.$se)(we," "),"	"),m.$i&&(we=(0,f.$9d)(ve,we),we=(0,c.$ue)(we,".")),we}n(ve){const we=[ve.path];return typeof ve.line=="number"&&we.push(String(ve.line)),typeof ve.column=="number"&&we.push(String(ve.column)),we.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bccfade64adb249f57c8fcf03cba41609f76ce5c/core/vs/code/electron-main/main.js.map
