/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/types","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/nls","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],oe=function(te){for(var e=[],O=0,N=te.length;O<N;O++)e[O]=re[te[O]];return e};define(re[124],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class O{static get(){const A=new Map,L=new Map,j=new Map,R=new Map;function k(h,g){h.has(g.detail)||h.set(g.detail,-g.timestamp)}function $(h,g){const y=h.get(g.detail);y&&(y>=0||h.set(g.detail,y+g.timestamp))}let C=[];typeof te=="function"&&typeof te.getStats=="function"&&(C=te.getStats().slice(0).sort((h,g)=>h.timestamp-g.timestamp));for(const h of C)switch(h.type){case 10:k(A,h);break;case 11:case 12:$(A,h);break;case 21:k(L,h);break;case 22:$(L,h);break;case 33:k(j,h);break;case 34:$(j,h);break;case 31:k(R,h);break;case 32:$(R,h);break}let E=0;j.forEach(h=>E+=h);function d(h){const g=[];return h.forEach((y,f)=>g.push([f,y])),g}return{amdLoad:d(A),amdInvoke:d(L),nodeRequire:d(j),nodeEval:d(R),nodeRequireTotal:E}}static toMarkdownTable(A,L){let j="";const R=[];return A.forEach((k,$)=>{R[$]=k.length}),L.forEach(k=>{k.forEach(($,C)=>{typeof $>"u"&&($=k[C]="-");const E=$.toString().length;R[C]=Math.max(E,R[C])})}),A.forEach((k,$)=>{j+=`| ${k+" ".repeat(R[$]-k.toString().length)} `}),j+=`|
`,A.forEach((k,$)=>{j+=`| ${"-".repeat(R[$])} `}),j+=`|
`,L.forEach(k=>{k.forEach(($,C)=>{typeof $<"u"&&(j+=`| ${$+" ".repeat(R[C]-$.toString().length)} `)}),j+=`|
`}),j}}e.$S=O}),define(re[125],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function O(y,f,o){const l=N(y,f);if(l!==-1)return y[l]}e.$db=O;function N(y,f,o=y.length-1){for(let l=o;l>=0;l--){const w=y[l];if(f(w))return l}return-1}e.$eb=N;function A(y,f){const o=L(y,f);return o===-1?void 0:y[o]}e.$fb=A;function L(y,f,o=0,l=y.length){let w=o,m=l;for(;w<m;){const I=Math.floor((w+m)/2);f(y[I])?w=I+1:m=I}return w-1}e.$gb=L;function j(y,f){const o=R(y,f);return o===y.length?void 0:y[o]}e.$hb=j;function R(y,f,o=0,l=y.length){let w=o,m=l;for(;w<m;){const I=Math.floor((w+m)/2);f(y[I])?m=I:w=I+1}return w}e.$ib=R;function k(y,f,o=0,l=y.length){const w=R(y,f,o,l);return w===y.length?-1:w}e.$jb=k;class ${static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if($.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!f(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const o=L(this.e,f,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$kb=$;function C(y,f){if(y.length===0)return;let o=y[0];for(let l=1;l<y.length;l++){const w=y[l];f(w,o)>0&&(o=w)}return o}e.$lb=C;function E(y,f){if(y.length===0)return;let o=y[0];for(let l=1;l<y.length;l++){const w=y[l];f(w,o)>=0&&(o=w)}return o}e.$mb=E;function d(y,f){return C(y,(o,l)=>-f(o,l))}e.$nb=d;function h(y,f){if(y.length===0)return-1;let o=0;for(let l=1;l<y.length;l++){const w=y[l];f(w,y[o])>0&&(o=l)}return o}e.$ob=h;function g(y,f){for(const o of y){const l=f(o);if(l!==void 0)return l}}e.$pb=g}),define(re[126],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function O(j,R){const k=Object.create(null);for(const $ of j){const C=R($);let E=k[C];E||(E=k[C]=[]),E.push($)}return k}e.$I=O;function N(j,R){const k=[],$=[];for(const C of j)R.has(C)||k.push(C);for(const C of R)j.has(C)||$.push(C);return{removed:k,added:$}}e.$J=N;function A(j,R){const k=[],$=[];for(const[C,E]of j)R.has(C)||k.push(E);for(const[C,E]of R)j.has(C)||$.push(E);return{removed:k,added:$}}e.$K=A;class L{constructor(){this.a=new Map}add(R,k){let $=this.a.get(R);$||($=new Set,this.a.set(R,$)),$.add(k)}delete(R,k){const $=this.a.get(R);$&&($.delete(k),$.size===0&&this.a.delete(R))}forEach(R,k){const $=this.a.get(R);$&&$.forEach(k)}get(R){const k=this.a.get(R);return k||new Set}}e.$L=L}),define(re[83],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.$6g=e.$5g=void 0;function O(j){return(R,k,$)=>{let C=null,E=null;if(typeof $.value=="function"?(C="value",E=$.value):typeof $.get=="function"&&(C="get",E=$.get),!E)throw new Error("not supported");$[C]=j(E,k)}}function N(j,R,k){let $=null,C=null;if(typeof k.value=="function"?($="value",C=k.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&($="get",C=k.get),!C)throw new Error("not supported");const E=`$memoize$${R}`;k[$]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,d)}),this[E]}}e.$5g=N;function A(j,R,k){return O(($,C)=>{const E=`$debounce$${C}`,d=`$debounce$result$${C}`;return function(...h){this[d]||(this[d]=k?k():void 0),clearTimeout(this[E]),R&&(this[d]=R(this[d],...h),h=[this[d]]),this[E]=setTimeout(()=>{$.apply(this,h),this[d]=k?k():void 0},j)}})}e.$6g=A;function L(j,R,k){return O(($,C)=>{const E=`$throttle$timer$${C}`,d=`$throttle$result$${C}`,h=`$throttle$lastRun$${C}`,g=`$throttle$pending$${C}`;return function(...y){if(this[d]||(this[d]=k?k():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...y)),this[g])return;const f=this[h]+j;f<=Date.now()?(this[h]=Date.now(),$.apply(this,[this[d]]),this[d]=k?k():void 0):(this[g]=!0,this[E]=setTimeout(()=>{this[g]=!1,this[h]=Date.now(),$.apply(this,[this[d]]),this[d]=k?k():void 0},f-Date.now()))}})}e.$7g=L}),define(re[8],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class O{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?w.isErrorNoTelemetry(i)?new w(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(c=>{c(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=O,e.$V=new O;function N(I){e.$V.setUnexpectedErrorHandler(I)}e.setUnexpectedErrorHandler=N;function A(I){if(!I||typeof I!="object")return!1;const i=I;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$X=A;function L(I){$(I)||e.$V.onUnexpectedError(I)}e.$Y=L;function j(I){$(I)||e.$V.onUnexpectedExternalError(I)}e.$Z=j;function R(I){if(I instanceof Error){const{name:i,message:c}=I,n=I.stacktrace||I.stack;return{$isError:!0,name:i,message:c,stack:n,noTelemetry:w.isErrorNoTelemetry(I)}}return I}e.$1=R;const k="Canceled";function $(I){return I instanceof C?!0:I instanceof Error&&I.name===k&&I.message===k}e.$2=$;class C extends Error{constructor(){super(k),this.name=this.message}}e.$3=C;function E(){const I=new Error(k);return I.name=I.message,I}e.$4=E;function d(I){return I?new Error(`Illegal argument: ${I}`):new Error("Illegal argument")}e.$5=d;function h(I){return I?new Error(`Illegal state: ${I}`):new Error("Illegal state")}e.$6=h;class g extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=g;function y(I){return I?I.message?I.message:I.stack?I.stack.split(`
`)[0]:String(I):"Error"}e.$8=y;class f extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$9=f;class o extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$0=o;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=l;class w extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof w)return i;const c=new w;return c.message=i.message,c.stack=i.stack,c}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$_=w;class m extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$ab=m}),define(re[18],oe([0,1,8,125]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.$4b=e.CompareResult=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.top=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function A(M,T=0){return M[M.length-(1+T)]}e.$qb=A;function L(M){if(M.length===0)throw new Error("Invalid tail call");return[M.slice(0,M.length-1),M[M.length-1]]}e.$rb=L;function j(M,T,K=(_,ae)=>_===ae){if(M===T)return!0;if(!M||!T||M.length!==T.length)return!1;for(let _=0,ae=M.length;_<ae;_++)if(!K(M[_],T[_]))return!1;return!0}e.$sb=j;function R(M,T){const K=M.length-1;T<K&&(M[T]=M[K]),M.pop()}e.$tb=R;function k(M,T,K){return $(M.length,_=>K(M[_],T))}e.$ub=k;function $(M,T){let K=0,_=M-1;for(;K<=_;){const ae=(K+_)/2|0,he=T(ae);if(he<0)K=ae+1;else if(he>0)_=ae-1;else return ae}return-(K+1)}e.$vb=$;function C(M,T,K){if(M=M|0,M>=T.length)throw new TypeError("invalid index");const _=T[Math.floor(T.length*Math.random())],ae=[],he=[],fe=[];for(const le of T){const $e=K(le,_);$e<0?ae.push(le):$e>0?he.push(le):fe.push(le)}return M<ae.length?C(M,ae,K):M<ae.length+fe.length?fe[0]:C(M-(ae.length+fe.length),he,K)}e.$wb=C;function E(M,T){const K=[];let _;for(const ae of M.slice(0).sort(T))!_||T(_[0],ae)!==0?(_=[ae],K.push(_)):_.push(ae);return K}e.$xb=E;function*d(M,T){let K,_;for(const ae of M)_!==void 0&&T(_,ae)?K.push(ae):(K&&(yield K),K=[ae]),_=ae;K&&(yield K)}e.$yb=d;function h(M,T){for(let K=0;K<=M.length;K++)T(K===0?void 0:M[K-1],K===M.length?void 0:M[K])}e.$zb=h;function g(M,T,K){const _=[];function ae(le,$e,de){if($e===0&&de.length===0)return;const we=_[_.length-1];we&&we.start+we.deleteCount===le?(we.deleteCount+=$e,we.toInsert.push(...de)):_.push({start:le,deleteCount:$e,toInsert:de})}let he=0,fe=0;for(;;){if(he===M.length){ae(he,0,T.slice(fe));break}if(fe===T.length){ae(he,M.length-he,[]);break}const le=M[he],$e=T[fe],de=K(le,$e);de===0?(he+=1,fe+=1):de<0?(ae(he,1,[]),he+=1):de>0&&(ae(he,0,[$e]),fe+=1)}return _}e.$Ab=g;function y(M,T,K){const _=g(M,T,K),ae=[],he=[];for(const fe of _)ae.push(...M.slice(fe.start,fe.start+fe.deleteCount)),he.push(...fe.toInsert);return{removed:ae,added:he}}e.$Bb=y;function f(M,T,K){if(K===0)return[];const _=M.slice(0,K).sort(T);return l(M,T,_,K,M.length),_}e.top=f;function o(M,T,K,_,ae){return K===0?Promise.resolve([]):new Promise((he,fe)=>{(async()=>{const le=M.length,$e=M.slice(0,K).sort(T);for(let de=K,we=Math.min(K+_,le);de<le;de=we,we=Math.min(we+_,le)){if(de>K&&await new Promise(Ee=>setTimeout(Ee)),ae&&ae.isCancellationRequested)throw new O.$3;l(M,T,$e,de,we)}return $e})().then(he,fe)})}e.$Db=o;function l(M,T,K,_,ae){for(const he=K.length;_<ae;_++){const fe=M[_];if(T(fe,K[he-1])<0){K.pop();const le=(0,N.$ib)(K,$e=>T(fe,$e)<0);K.splice(le,0,fe)}}}function w(M){return M.filter(T=>!!T)}e.$Eb=w;function m(M){let T=0;for(let K=0;K<M.length;K++)M[K]&&(M[T]=M[K],T+=1);M.length=T}e.$Fb=m;function I(M,T,K){M.splice(K,0,M.splice(T,1)[0])}e.$Gb=I;function i(M){return!Array.isArray(M)||M.length===0}e.$Hb=i;function c(M){return Array.isArray(M)&&M.length>0}e.$Ib=c;function n(M,T=K=>K){const K=new Set;return M.filter(_=>{const ae=T(_);return K.has(ae)?!1:(K.add(ae),!0)})}e.$Jb=n;function s(M){const T=new Set;return K=>{const _=M(K);return T.has(_)?!1:(T.add(_),!0)}}e.$Kb=s;function t(M,T){return M.length>0?M[0]:T}e.$Lb=t;function r(M,T){return M.length>0?M[M.length-1]:T}e.$Mb=r;function a(M,T,K=(_,ae)=>_===ae){let _=0;for(let ae=0,he=Math.min(M.length,T.length);ae<he&&K(M[ae],T[ae]);ae++)_++;return _}e.$Nb=a;function v(M){return[].concat(...M)}e.$Ob=v;function b(M,T){let K=typeof T=="number"?M:0;typeof T=="number"?K=M:(K=0,T=M);const _=[];if(K<=T)for(let ae=K;ae<T;ae++)_.push(ae);else for(let ae=K;ae>T;ae--)_.push(ae);return _}e.$Pb=b;function u(M,T,K){return M.reduce((_,ae)=>(_[T(ae)]=K?K(ae):ae,_),Object.create(null))}e.$Qb=u;function p(M,T){return M.push(T),()=>D(M,T)}e.$Rb=p;function D(M,T){const K=M.indexOf(T);if(K>-1)return M.splice(K,1),T}e.$Sb=D;function F(M,T,K){const _=M.slice(0,T),ae=M.slice(T);return _.concat(K,ae)}e.$Tb=F;function z(M,T){let K;if(typeof T=="number"){let _=T;K=()=>{const ae=Math.sin(_++)*179426549;return ae-Math.floor(ae)}}else K=Math.random;for(let _=M.length-1;_>0;_-=1){const ae=Math.floor(K()*(_+1)),he=M[_];M[_]=M[ae],M[ae]=he}}e.$Ub=z;function U(M,T){const K=M.indexOf(T);K>-1&&(M.splice(K,1),M.unshift(T))}e.$Vb=U;function B(M,T){const K=M.indexOf(T);K>-1&&(M.splice(K,1),M.push(T))}e.$Wb=B;function x(M,T){for(const K of T)M.push(K)}e.$Xb=x;function J(M,T){return Array.isArray(M)?M.map(T):T(M)}e.$Yb=J;function Q(M){return Array.isArray(M)?M:[M]}e.$Zb=Q;function W(M){return M[Math.floor(Math.random()*M.length)]}e.$1b=W;function Z(M,T,K){const _=H(M,T),ae=M.length,he=K.length;M.length=ae+he;for(let fe=ae-1;fe>=_;fe--)M[fe+he]=M[fe];for(let fe=0;fe<he;fe++)M[fe+_]=K[fe]}e.$2b=Z;function G(M,T,K,_){const ae=H(M,T);let he=M.splice(ae,K);return he===void 0&&(he=[]),Z(M,ae,_),he}e.$3b=G;function H(M,T){return T<0?Math.max(T+M.length,0):Math.min(T,M.length)}var V;(function(M){function T(he){return he<0}M.isLessThan=T;function K(he){return he<=0}M.isLessThanOrEqual=K;function _(he){return he>0}M.isGreaterThan=_;function ae(he){return he===0}M.isNeitherLessOrGreaterThan=ae,M.greaterThan=1,M.lessThan=-1,M.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function ee(M,T){return(K,_)=>T(M(K),M(_))}e.$4b=ee;function ne(...M){return(T,K)=>{for(const _ of M){const ae=_(T,K);if(!V.isNeitherLessOrGreaterThan(ae))return ae}return V.neitherLessOrGreaterThan}}e.$5b=ne;const se=(M,T)=>M-T;e.$6b=se;const Y=(M,T)=>(0,e.$6b)(M?1:0,T?1:0);e.$7b=Y;function q(M){return(T,K)=>-M(T,K)}e.$8b=q;class S{constructor(T){this.g=T,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(T){let K=this.c;for(;K<this.g.length&&T(this.g[K]);)K++;const _=K===this.c?null:this.g.slice(this.c,K);return this.c=K,_}takeFromEndWhile(T){let K=this.d;for(;K>=0&&T(this.g[K]);)K--;const _=K===this.d?null:this.g.slice(K+1,this.d+1);return this.d=K,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const T=this.g[this.c];return this.c++,T}removeLast(){const T=this.g[this.d];return this.d--,T}takeCount(T){const K=this.g.slice(this.c,this.c+T);return this.c+=T,K}}e.$9b=S;class P{static{this.empty=new P(T=>{})}constructor(T){this.iterate=T}forEach(T){this.iterate(K=>(T(K),!0))}toArray(){const T=[];return this.iterate(K=>(T.push(K),!0)),T}filter(T){return new P(K=>this.iterate(_=>T(_)?K(_):!0))}map(T){return new P(K=>this.iterate(_=>K(T(_))))}some(T){let K=!1;return this.iterate(_=>(K=T(_),!K)),K}findFirst(T){let K;return this.iterate(_=>T(_)?(K=_,!1):!0),K}findLast(T){let K;return this.iterate(_=>(T(_)&&(K=_),!0)),K}findLastMaxBy(T){let K,_=!0;return this.iterate(ae=>((_||V.isGreaterThan(T(ae,K)))&&(_=!1,K=ae),!0)),K}}e.$0b=P}),define(re[127],oe([0,1,8]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xc=e.$wc=e.$vc=e.$uc=e.ok=void 0;function N(k,$){if(!k)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}e.ok=N;function A(k,$="Unreachable"){throw new Error($)}e.$uc=A;function L(k){if(!k)throw new O.$ab("Assertion Failed")}e.$vc=L;function j(k){if(!k()){debugger;k(),(0,O.$Y)(new O.$ab("Assertion Failed"))}}e.$wc=j;function R(k,$){let C=0;for(;C<k.length-1;){const E=k[C],d=k[C+1];if(!$(E,d))return!1;C++}return!0}e.$xc=R}),define(re[84],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function O(N){const A=this;let L=!1,j;return function(){return L||(L=!0,j=N.apply(A,arguments)),j}}e.$bb=O}),define(re[59],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var O;(function(N){function A(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}N.is=A;const L=Object.freeze([]);function j(){return L}N.empty=j;function*R(m){yield m}N.single=R;function k(m){return A(m)?m:R(m)}N.wrap=k;function $(m){return m||L}N.from=$;function C(m){return!m||m[Symbol.iterator]().next().done===!0}N.isEmpty=C;function E(m){return m[Symbol.iterator]().next().value}N.first=E;function d(m,I){for(const i of m)if(I(i))return!0;return!1}N.some=d;function h(m,I){for(const i of m)if(I(i))return i}N.find=h;function*g(m,I){for(const i of m)I(i)&&(yield i)}N.filter=g;function*y(m,I){let i=0;for(const c of m)yield I(c,i++)}N.map=y;function*f(...m){for(const I of m)for(const i of I)yield i}N.concat=f;function o(m,I,i){let c=i;for(const n of m)c=I(c,n);return c}N.reduce=o;function*l(m,I,i=m.length){for(I<0&&(I+=m.length),i<0?i+=m.length:i>m.length&&(i=m.length);I<i;I++)yield m[I]}N.slice=l;function w(m,I=Number.POSITIVE_INFINITY){const i=[];if(I===0)return[i,m];const c=m[Symbol.iterator]();for(let n=0;n<I;n++){const s=c.next();if(s.done)return[i,N.empty()];i.push(s.value)}return[i,{[Symbol.iterator](){return c}}]}N.consume=w})(O||(e.Iterable=O={}))}),define(re[34],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var A;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function j(i,c=!1){let n=0;const s=i.length;let t="",r=0,a=16,v=0;function b(B){let x=0,J=0;for(;x<B;){const Q=i.charCodeAt(n);if(Q>=48&&Q<=57)J=J*16+Q-48;else if(Q>=65&&Q<=70)J=J*16+Q-65+10;else if(Q>=97&&Q<=102)J=J*16+Q-97+10;else break;n++,x++}return x<B&&(J=-1),J}function u(B){n=B,t="",r=0,a=16,v=0}function p(){const B=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&$(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&$(i.charCodeAt(n)))for(n++;n<i.length&&$(i.charCodeAt(n));)n++;else return v=3,i.substring(B,n);let x=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&$(i.charCodeAt(n))){for(n++;n<i.length&&$(i.charCodeAt(n));)n++;x=n}else v=3;return i.substring(B,x)}function D(){let B="",x=n;for(;;){if(n>=s){B+=i.substring(x,n),v=2;break}const J=i.charCodeAt(n);if(J===34){B+=i.substring(x,n),n++;break}if(J===92){if(B+=i.substring(x,n),n++,n>=s){v=2;break}switch(i.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const W=b(4);W>=0?B+=String.fromCharCode(W):v=4;break}default:v=5}x=n;continue}if(J>=0&&J<=31)if(k(J)){B+=i.substring(x,n),v=2;break}else v=6;n++}return B}function F(){if(t="",v=0,r=n,n>=s)return r=s,a=17;let B=i.charCodeAt(n);if(R(B)){do n++,t+=String.fromCharCode(B),B=i.charCodeAt(n);while(R(B));return a=15}if(k(B))return n++,t+=String.fromCharCode(B),B===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(B){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=D(),a=10;case 47:{const x=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!k(i.charCodeAt(n));)n++;return t=i.substring(x,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const J=s-1;let Q=!1;for(;n<J;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Q=!0;break}n++}return Q||(n++,v=1),t=i.substring(x,n),a=13}return t+=String.fromCharCode(B),n++,a=16}case 45:if(t+=String.fromCharCode(B),n++,n===s||!$(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=p(),a=11;default:for(;n<s&&z(B);)n++,B=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(B),n++,a=16}}function z(B){if(R(B)||k(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=F();while(B>=12&&B<=15);return B}return{setPosition:u,getPosition:()=>n,scan:c?U:F,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>v}}e.$Im=j;function R(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function k(i){return i===10||i===13||i===8232||i===8233}function $(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function E(i,c){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(b,u,p,D){r.value=b,r.offset=u,r.length=p,r.type=D,r.colonOffset=void 0,t=r}try{w(i,{onObjectBegin:(b,u)=>{if(c<=b)throw s;t=void 0,a=c>b,n.push("")},onObjectProperty:(b,u,p)=>{if(c<u||(v(b,u,p,"property"),n[n.length-1]=b,c<=u+p))throw s},onObjectEnd:(b,u)=>{if(c<=b)throw s;t=void 0,n.pop()},onArrayBegin:(b,u)=>{if(c<=b)throw s;t=void 0,n.push(0)},onArrayEnd:(b,u)=>{if(c<=b)throw s;t=void 0,n.pop()},onLiteralValue:(b,u,p)=>{if(c<u||(v(b,u,p,I(b)),c<=u+p))throw s},onSeparator:(b,u,p)=>{if(c<=u)throw s;if(b===":"&&t&&t.type==="property")t.colonOffset=u,a=!1,t=void 0;else if(b===","){const D=n[n.length-1];typeof D=="number"?n[n.length-1]=D+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(b){if(b!==s)throw b}return{path:n,previousNode:t,isAtPropertyKey:a,matches:b=>{let u=0;for(let p=0;u<b.length&&p<n.length;p++)if(b[u]===n[p]||b[u]==="*")u++;else if(b[u]!=="**")return!1;return u===b.length}}}e.$Jm=E;function d(i,c=[],n=L.DEFAULT){let s=null,t=[];const r=[];function a(b){Array.isArray(t)?t.push(b):s!==null&&(t[s]=b)}return w(i,{onObjectBegin:()=>{const b={};a(b),r.push(t),t=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const b=[];a(b),r.push(t),t=b,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(b,u,p)=>{c.push({error:b,offset:u,length:p})}},n),t[0]}e.$Km=d;function h(i,c=[],n=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(b){s.type==="property"&&(s.length=b-s.offset,s=s.parent)}function r(b){return s.children.push(b),b}w(i,{onObjectBegin:b=>{s=r({type:"object",offset:b,length:-1,parent:s,children:[]})},onObjectProperty:(b,u,p)=>{s=r({type:"property",offset:u,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:b,offset:u,length:p,parent:s})},onObjectEnd:(b,u)=>{s.length=b+u-s.offset,s=s.parent,t(b+u)},onArrayBegin:(b,u)=>{s=r({type:"array",offset:b,length:-1,parent:s,children:[]})},onArrayEnd:(b,u)=>{s.length=b+u-s.offset,s=s.parent,t(b+u)},onLiteralValue:(b,u,p)=>{r({type:I(b),offset:u,length:p,parent:s,value:b}),t(u+p)},onSeparator:(b,u,p)=>{s.type==="property"&&(b===":"?s.colonOffset=u:b===","&&t(u))},onError:(b,u,p)=>{c.push({error:b,offset:u,length:p})}},n);const v=s.children[0];return v&&delete v.parent,v}e.$Lm=h;function g(i,c){if(!i)return;let n=i;for(const s of c)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$Mm=g;function y(i){if(!i.parent||!i.parent.children)return[];const c=y(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;c.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&c.push(n)}return c}e.$Nm=y;function f(i){switch(i.type){case"array":return i.children.map(f);case"object":{const c=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(c[n.children[0].value]=f(s))}return c}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$Om=f;function o(i,c,n=!1){return c>=i.offset&&c<i.offset+i.length||n&&c===i.offset+i.length}e.$Pm=o;function l(i,c,n=!1){if(o(i,c,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=c;t++){const r=l(s[t],c,n);if(r)return r}return i}}e.$Qm=l;function w(i,c,n=L.DEFAULT){const s=j(i,!1);function t(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ne){return ne?se=>ne(se,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(c.onObjectBegin),v=r(c.onObjectProperty),b=t(c.onObjectEnd),u=t(c.onArrayBegin),p=t(c.onArrayEnd),D=r(c.onLiteralValue),F=r(c.onSeparator),z=t(c.onComment),U=r(c.onError),B=n&&n.disallowComments,x=n&&n.allowTrailingComma;function J(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:B||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(ne){case 12:case 13:B?Q(10):z();break;case 16:Q(1);break;case 15:case 14:break;default:return ne}}}function Q(ne,se=[],Y=[]){if(U(ne),se.length+Y.length>0){let q=s.getToken();for(;q!==17;){if(se.indexOf(q)!==-1){J();break}else if(Y.indexOf(q)!==-1)break;q=J()}}}function W(ne){const se=s.getTokenValue();return ne?D(se):v(se),J(),!0}function Z(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(Q(2),ne=0)}catch{Q(2)}D(ne);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return J(),!0}function G(){return s.getToken()!==10?(Q(3,[],[2,5]),!1):(W(!1),s.getToken()===6?(F(":"),J(),ee()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function H(){a(),J();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||Q(4,[],[]),F(","),J(),s.getToken()===2&&x)break}else ne&&Q(6,[],[]);G()||Q(4,[],[2,5]),ne=!0}return b(),s.getToken()!==2?Q(7,[2],[]):J(),!0}function V(){u(),J();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||Q(4,[],[]),F(","),J(),s.getToken()===4&&x)break}else ne&&Q(6,[],[]);ee()||Q(4,[],[4,5]),ne=!0}return p(),s.getToken()!==4?Q(8,[4],[]):J(),!0}function ee(){switch(s.getToken()){case 3:return V();case 1:return H();case 10:return W(!0);default:return Z()}}return J(),s.getToken()===17?n.allowEmptyContent?!0:(Q(4,[],[]),!1):ee()?(s.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.$Rm=w;function m(i,c){const n=j(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),c!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,c)),r=n.getPosition();break}while(t!==17);return s.join("")}e.$Sm=m;function I(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$Tm=I}),define(re[41],oe([0,1,34]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tS=e.$sS=e.$rS=e.$qS=void 0;function N($,C,E){let d,h,g,y,f;if(C){for(y=C.offset,f=y+C.length,g=y;g>0&&!k($,g-1);)g--;let a=f;for(;a<$.length&&!k($,a);)a++;h=$.substring(g,a),d=j(h,E)}else h=$,d=0,g=0,y=0,f=$.length;const o=R(E,$);let l=!1,w=0,m;E.insertSpaces?m=L(" ",E.tabSize||4):m="	";const I=(0,O.$Im)(h,!1);let i=!1;function c(){return o+L(m,d+w)}function n(){let a=I.scan();for(l=!1;a===15||a===14;)l=l||a===14,a=I.scan();return i=a===16||I.getTokenError()!==0,a}const s=[];function t(a,v,b){!i&&v<f&&b>y&&$.substring(v,b)!==a&&s.push({offset:v,length:b-v,content:a})}let r=n();if(r!==17){const a=I.getTokenOffset()+g,v=L(m,d);t(v,g,a)}for(;r!==17;){let a=I.getTokenOffset()+I.getTokenLength()+g,v=n(),b="";for(;!l&&(v===12||v===13);){const p=I.getTokenOffset()+g;t(" ",a,p),a=I.getTokenOffset()+I.getTokenLength()+g,b=v===12?c():"",v=n()}if(v===2)r!==1&&(w--,b=c());else if(v===4)r!==3&&(w--,b=c());else{switch(r){case 3:case 1:w++,b=c();break;case 5:case 12:b=c();break;case 13:l?b=c():b=" ";break;case 6:b=" ";break;case 10:if(v===6){b="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?b=" ":v!==5&&v!==17&&(i=!0);break;case 16:i=!0;break}l&&(v===12||v===13)&&(b=c())}const u=I.getTokenOffset()+g;t(b,a,u),r=v}return s}e.$qS=N;function A($,C){const E=JSON.stringify($,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?E.replace(/\r\n|\r|\n/g,C.eol):E}e.$rS=A;function L($,C){let E="";for(let d=0;d<C;d++)E+=$;return E}function j($,C){let E=0,d=0;const h=C.tabSize||4;for(;E<$.length;){const g=$.charAt(E);if(g===" ")d++;else if(g==="	")d+=h;else break;E++}return Math.floor(d/h)}function R($,C){for(let E=0;E<C.length;E++){const d=C.charAt(E);if(d==="\r")return E+1<C.length&&C.charAt(E+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return $&&$.eol||`
`}e.$sS=R;function k($,C){return`\r
`.indexOf($.charAt(C))!==-1}e.$tS=k}),define(re[85],oe([0,1,34,41]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yS=e.$xS=e.$wS=e.$vS=e.$uS=void 0;function A($,C,E){return L($,C,void 0,E)}e.$uS=A;function L($,C,E,d,h){const g=C.slice(),y=[],f=(0,O.$Lm)($,y);let o,l;for(;g.length>0&&(l=g.pop(),o=(0,O.$Mm)(f,g),o===void 0&&E!==void 0);)typeof l=="string"?E={[l]:E}:E=[E];if(o)if(o.type==="object"&&typeof l=="string"&&Array.isArray(o.children)){const w=(0,O.$Mm)(o,[l]);if(w!==void 0)if(E===void 0){if(!w.parent)throw new Error("Malformed AST");const m=o.children.indexOf(w.parent);let I,i=w.parent.offset+w.parent.length;if(m>0){const c=o.children[m-1];I=c.offset+c.length}else I=o.offset+1,o.children.length>1&&(i=o.children[1].offset);return j($,{offset:I,length:i-I,content:""},d)}else return j($,{offset:w.offset,length:w.length,content:JSON.stringify(E)},d);else{if(E===void 0)return[];const m=`${JSON.stringify(l)}: ${JSON.stringify(E)}`,I=h?h(o.children.map(c=>c.children[0].value)):o.children.length;let i;if(I>0){const c=o.children[I-1];i={offset:c.offset+c.length,length:0,content:","+m}}else o.children.length===0?i={offset:o.offset+1,length:0,content:m}:i={offset:o.offset+1,length:0,content:m+","};return j($,i,d)}}else if(o.type==="array"&&typeof l=="number"&&Array.isArray(o.children))if(E!==void 0){const w=`${JSON.stringify(E)}`;let m;if(o.children.length===0||l===0)m={offset:o.offset+1,length:0,content:o.children.length===0?w:w+","};else{const I=l===-1||l>o.children.length?o.children.length:l,i=o.children[I-1];m={offset:i.offset+i.length,length:0,content:","+w}}return j($,m,d)}else{const w=l,m=o.children[w];let I;if(o.children.length===1)I={offset:o.offset+1,length:o.length-2,content:""};else if(o.children.length-1===w){const i=o.children[w-1],c=i.offset+i.length,n=o.offset+o.length;I={offset:c,length:n-2-c,content:""}}else I={offset:m.offset,length:o.children[w+1].offset-m.offset,content:""};return j($,I,d)}else throw new Error(`Can not add ${typeof l!="number"?"index":"property"} to parent of type ${o.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return j($,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(E)},d)}}e.$vS=L;function j($,C,E){let d=R($,C),h=C.offset,g=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;h>0&&!(0,N.$tS)(d,h-1);)h--;for(;g<d.length&&!(0,N.$tS)(d,g);)g++}const y=(0,N.$qS)(d,{offset:h,length:g-h},E);for(let o=y.length-1;o>=0;o--){const l=y[o];d=R(d,l),h=Math.min(h,l.offset),g=Math.max(g,l.offset+l.length),g+=l.content.length-l.length}const f=$.length-(d.length-g)-h;return[{offset:h,length:f,content:d.substring(h,g)}]}e.$wS=j;function R($,C){return $.substring(0,C.offset)+C.content+$.substring(C.offset+C.length)}e.$xS=R;function k($,C){const E=C.slice(0).sort((h,g)=>{const y=h.offset-g.offset;return y===0?h.length-g.length:y});let d=$.length;for(let h=E.length-1;h>=0;h--){const g=E[h];if(g.offset+g.length<=d)$=R($,g);else throw new Error("Overlapping edit");d=g.offset}return $}e.$yS=k}),define(re[86],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class O{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=O}),define(re[2],oe([0,1,18,126,84,59]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=void 0;const j=!1;let R=null;class k{constructor(){this.b=new Map}static{this.a=0}c(u){let p=this.b.get(u);return p||(p={parent:null,source:null,isSingleton:!1,value:u,idx:k.a++},this.b.set(u,p)),p}trackDisposable(u){const p=this.c(u);p.source||(p.source=new Error().stack)}setParent(u,p){const D=this.c(u);D.parent=p}markAsDisposed(u){this.b.delete(u)}markAsSingleton(u){this.c(u).isSingleton=!0}f(u,p){const D=p.get(u);if(D)return D;const F=u.parent?this.f(this.c(u.parent),p):u;return p.set(u,F),F}getTrackedDisposables(){const u=new Map;return[...this.b.entries()].filter(([,D])=>D.source!==null&&!this.f(D,u).isSingleton).map(([D])=>D).flat()}computeLeakingDisposables(u=10,p){let D;if(p)D=p;else{const x=new Map,J=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,x).isSingleton);if(J.length===0)return;const Q=new Set(J.map(W=>W.value));if(D=J.filter(W=>!(W.parent&&Q.has(W.parent))),D.length===0)throw new Error("There are cyclic diposable chains!")}if(!D)return;function F(x){function J(W,Z){for(;W.length>0&&Z.some(G=>typeof G=="string"?G===W[0]:W[0].match(G));)W.shift()}const Q=x.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return J(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const z=new N.$L;for(const x of D){const J=F(x);for(let Q=0;Q<=J.length;Q++)z.add(J.slice(0,Q).join(`
`),x)}D.sort((0,O.$4b)(x=>x.idx,O.$6b));let U="",B=0;for(const x of D.slice(0,u)){B++;const J=F(x),Q=[];for(let W=0;W<J.length;W++){let Z=J[W];Z=`(shared with ${z.get(J.slice(0,W+1).join(`
`)).size}/${D.length} leaks) at ${Z}`;const H=z.get(J.slice(0,W).join(`
`)),V=(0,N.$I)([...H].map(ee=>F(ee)[W]),ee=>ee);delete V[J[W]];for(const[ee,ne]of Object.entries(V))Q.unshift(`    - stacktraces of ${ne.length} other leaks continue with ${ee}`);Q.unshift(Z)}U+=`


==================== Leaking disposable ${B}/${D.length}: ${x.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return D.length>u&&(U+=`


... and ${D.length-u} more leaking disposables

`),{leaks:D,details:U}}}e.$$b=k;function $(b){R=b}if(e.$_b=$,j){const b="__is_disposable_tracked__";$(new class{trackDisposable(u){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[b]||console.log(p)},3e3)}setParent(u,p){if(u&&u!==I.None)try{u[b]=!0}catch{}}markAsDisposed(u){if(u&&u!==I.None)try{u[b]=!0}catch{}}markAsSingleton(u){}})}function C(b){return R?.trackDisposable(b),b}e.$ac=C;function E(b){R?.markAsDisposed(b)}e.$bc=E;function d(b,u){R?.setParent(b,u)}function h(b,u){if(R)for(const p of b)R.setParent(p,u)}function g(b){return R?.markAsSingleton(b),b}e.$cc=g;function y(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.$dc=y;function f(b){if(L.Iterable.is(b)){const u=[];for(const p of b)if(p)try{p.dispose()}catch(D){u.push(D)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.$ec=f;function o(b){for(const u of b)y(u)&&u.dispose();return[]}e.$fc=o;function l(...b){const u=w(()=>f(b));return h(b,u),u}e.$gc=l;function w(b){const u=C({dispose:(0,A.$bb)(()=>{E(u),b()})});return u}e.$hc=w;class m{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(E(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return d(u,this),this.g?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}}e.$ic=m;class I{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new m,C(this),d(this.q,this)}dispose(){E(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}e.$jc=I;class i{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&d(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&d(u,null),u}}e.$kc=i;class c{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$lc=c;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(u){let p=u;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,E(this))},this}}e.$mc=n;class s{constructor(){this.a=new Map}acquire(u,...p){let D=this.a.get(u);D||(D={counter:0,object:this.b(u,...p)},this.a.set(u,D));const{object:F}=D,z=(0,A.$bb)(()=>{--D.counter===0&&(this.c(u,D.object),this.a.delete(u))});return D.counter++,{object:F,dispose:z}}}e.$nc=s;class t{constructor(u){this.a=u}async acquire(u,...p){const D=this.a.acquire(u,...p);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(F){throw D.dispose(),F}}}e.$oc=t;class r{constructor(u){this.object=u}dispose(){}}e.$pc=r;function a(b){const u=new m;try{b(u)}finally{u.dispose()}}e.$qc=a;class v{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get size(){return this.a.size}get(u){return this.a.get(u)}set(u,p,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(u)?.dispose(),this.a.set(u,p)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$rc=v}),define(re[87],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=void 0;class O{static{this.Undefined=new O(void 0)}constructor(L){this.element=L,this.next=O.Undefined,this.prev=O.Undefined}}class N{constructor(){this.a=O.Undefined,this.b=O.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===O.Undefined}clear(){let L=this.a;for(;L!==O.Undefined;){const j=L.next;L.prev=O.Undefined,L.next=O.Undefined,L=j}this.a=O.Undefined,this.b=O.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,j){const R=new O(L);if(this.a===O.Undefined)this.a=R,this.b=R;else if(j){const $=this.b;this.b=R,R.prev=$,$.next=R}else{const $=this.a;this.a=R,R.next=$,$.prev=R}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(R))}}shift(){if(this.a!==O.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==O.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==O.Undefined&&L.next!==O.Undefined){const j=L.prev;j.next=L.next,L.next.prev=j}else L.prev===O.Undefined&&L.next===O.Undefined?(this.a=O.Undefined,this.b=O.Undefined):L.next===O.Undefined?(this.b=this.b.prev,this.b.next=O.Undefined):L.prev===O.Undefined&&(this.a=this.a.next,this.a.prev=O.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==O.Undefined;)yield L.element,L=L.next}}e.$sc=N}),define(re[35],oe([0,1]),function(te,e){"use strict";var O,N,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.Touch=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;function L(f,o,l){let w=f.get(o);return w===void 0&&(w=l,f.set(o,w)),w}e.$vi=L;function j(f){const o=[];return f.forEach((l,w)=>{o.push(`${w} => ${l}`)}),`Map(${f.size}) {${o.join(", ")}}`}e.$wi=j;function R(f){const o=[];return f.forEach(l=>{o.push(l)}),`Set(${f.size}) {${o.join(", ")}}`}e.$xi=R;class k{constructor(o,l){this.uri=o,this.value=l}}class ${static{this.a=o=>o.toString()}constructor(o,l){this[O]="ResourceMap",o instanceof $?(this.b=new Map(o.b),this.c=l??$.a):(this.b=new Map,this.c=o??$.a)}set(o,l){return this.b.set(this.c(o),new k(o,l)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,l){typeof l<"u"&&(o=o.bind(l));for(const[w,m]of this.b)o(m.value,m.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$yi=$;class C{constructor(o,l){this[N]="ResourceSet",!o||typeof o=="function"?this.a=new $(o):(this.a=new $(l),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,l){this.a.forEach((w,m)=>o.call(l,m,m,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zi=C;var E;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class d{constructor(){this[A]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,l=0){const w=this.a.get(o);if(w)return l!==0&&this.j(w,l),w.value}set(o,l,w=0){let m=this.a.get(o);if(m)m.value=l,w!==0&&this.j(m,w);else{switch(m={key:o,value:l,next:void 0,previous:void 0},w){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(o,m),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const l=this.a.get(o);if(l)return this.a.delete(o),this.i(l),this.d--,l.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,l){const w=this.e;let m=this.b;for(;m;){if(l?o.bind(l)(m.value,m.key,this):o(m.value,m.key,this),this.e!==w)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const o=this,l=this.e;let w=this.b;const m={[Symbol.iterator](){return m},next(){if(o.e!==l)throw new Error("LinkedMap got modified during iteration.");if(w){const I={value:w.key,done:!1};return w=w.next,I}else return{value:void 0,done:!0}}};return m}values(){const o=this,l=this.e;let w=this.b;const m={[Symbol.iterator](){return m},next(){if(o.e!==l)throw new Error("LinkedMap got modified during iteration.");if(w){const I={value:w.value,done:!1};return w=w.next,I}else return{value:void 0,done:!0}}};return m}entries(){const o=this,l=this.e;let w=this.b;const m={[Symbol.iterator](){return m},next(){if(o.e!==l)throw new Error("LinkedMap got modified during iteration.");if(w){const I={value:[w.key,w.value],done:!1};return w=w.next,I}else return{value:void 0,done:!0}}};return m}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let l=this.b,w=this.size;for(;l&&w>o;)this.a.delete(l.key),l=l.next,w--;this.b=l,this.d=w,l&&(l.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const l=o.next,w=o.previous;if(!l||!w)throw new Error("Invalid list");l.previous=w,w.next=l}o.next=void 0,o.previous=void 0,this.e++}j(o,l){if(!this.b||!this.c)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(o===this.b)return;const w=o.next,m=o.previous;o===this.c?(m.next=void 0,this.c=m):(w.previous=m,m.next=w),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(l===2){if(o===this.c)return;const w=o.next,m=o.previous;o===this.b?(w.previous=void 0,this.b=w):(w.previous=m,m.next=w),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((l,w)=>{o.push([w,l])}),o}fromJSON(o){this.clear();for(const[l,w]of o)this.set(l,w)}}e.$Ai=d;class h extends d{constructor(o,l=1){super(),this.k=o,this.l=Math.min(Math.max(0,l),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,l=2){return super.get(o,l)}peek(o){return super.get(o,0)}set(o,l){return super.set(o,l,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bi=h;class g{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let l=this.a.get(o)||0;return l===0?!1:(l--,l===0?this.a.delete(o):this.a.set(o,l),!0)}has(o){return this.a.has(o)}}e.$Ci=g;class y{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[l,w]of o)this.set(l,w)}clear(){this.a.clear(),this.b.clear()}set(o,l){this.a.set(o,l),this.b.set(l,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const l=this.a.get(o);return l===void 0?!1:(this.a.delete(o),this.b.delete(l),!0)}forEach(o,l){this.a.forEach((w,m)=>{o.call(l,w,m,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Di=y}),define(re[88],oe([0,1,35]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=e.$gl=void 0;const N=new O.$Bi(1e4);function A($){return k($,"NFC",N)}e.$gl=A;const L=new O.$Bi(1e4);function j($){return k($,"NFD",L)}e.$hl=j;const R=/[^\u0000-\u0080]/;function k($,C,E){if(!$)return $;const d=E.get($);if(d)return d;let h;return R.test($)?h=$.normalize(C):h=$,E.set($,h),h}e.$il=function(){const $=/[\u0300-\u036f]/g;return function(C){return j(C).replace($,"")}}()}),function(){function te(A){const L=[];typeof A=="number"&&L.push("code/timeOrigin",A);function j(k){L.push(k,Date.now())}function R(){const k=[];for(let $=0;$<L.length;$+=2)k.push({name:L[$],startTime:L[$+1]});return k}return{mark:j,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const j of performance.getEntriesByType("mark"))L.push({name:j.name,startTime:Math.round(A+j.startTime)});return L}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function O(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=O(N))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var N in O)(typeof exports=="object"?exports:te)[N]=O[N]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function O(N){if(e[N])return e[N].exports;var A=e[N]={i:N,l:!1,exports:{}};return te[N].call(A.exports,A,A.exports,O),A.l=!0,A.exports}return O.m=te,O.c=e,O.d=function(N,A,L){O.o(N,A)||Object.defineProperty(N,A,{enumerable:!0,get:L})},O.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},O.t=function(N,A){if(1&A&&(N=O(N)),8&A||4&A&&typeof N=="object"&&N&&N.__esModule)return N;var L=Object.create(null);if(O.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:N}),2&A&&typeof N!="string")for(var j in N)O.d(L,j,function(R){return N[R]}.bind(null,j));return L},O.n=function(N){var A=N&&N.__esModule?function(){return N.default}:function(){return N};return O.d(A,"a",A),A},O.o=function(N,A){return Object.prototype.hasOwnProperty.call(N,A)},O.p="",O(O.s=0)}([function(te,e,O){(function(N){var A;e=te.exports=Y,A=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ce=Array.prototype.slice.call(arguments,0);ce.unshift("SEMVER"),console.log.apply(console,ce)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],k=e.src=[],$=0,C=$++;k[C]="0|[1-9]\\d*";var E=$++;k[E]="[0-9]+";var d=$++;k[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=$++;k[h]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var g=$++;k[g]="("+k[E]+")\\.("+k[E]+")\\.("+k[E]+")";var y=$++;k[y]="(?:"+k[C]+"|"+k[d]+")";var f=$++;k[f]="(?:"+k[E]+"|"+k[d]+")";var o=$++;k[o]="(?:-("+k[y]+"(?:\\."+k[y]+")*))";var l=$++;k[l]="(?:-?("+k[f]+"(?:\\."+k[f]+")*))";var w=$++;k[w]="[0-9A-Za-z-]+";var m=$++;k[m]="(?:\\+("+k[w]+"(?:\\."+k[w]+")*))";var I=$++,i="v?"+k[h]+k[o]+"?"+k[m]+"?";k[I]="^"+i+"$";var c="[v=\\s]*"+k[g]+k[l]+"?"+k[m]+"?",n=$++;k[n]="^"+c+"$";var s=$++;k[s]="((?:<|>)?=?)";var t=$++;k[t]=k[E]+"|x|X|\\*";var r=$++;k[r]=k[C]+"|x|X|\\*";var a=$++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[o]+")?"+k[m]+"?)?)?";var v=$++;k[v]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[l]+")?"+k[m]+"?)?)?";var b=$++;k[b]="^"+k[s]+"\\s*"+k[a]+"$";var u=$++;k[u]="^"+k[s]+"\\s*"+k[v]+"$";var p=$++;k[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=$++;k[D]="(?:~>?)";var F=$++;k[F]="(\\s*)"+k[D]+"\\s+",R[F]=new RegExp(k[F],"g");var z=$++;k[z]="^"+k[D]+k[a]+"$";var U=$++;k[U]="^"+k[D]+k[v]+"$";var B=$++;k[B]="(?:\\^)";var x=$++;k[x]="(\\s*)"+k[B]+"\\s+",R[x]=new RegExp(k[x],"g");var J=$++;k[J]="^"+k[B]+k[a]+"$";var Q=$++;k[Q]="^"+k[B]+k[v]+"$";var W=$++;k[W]="^"+k[s]+"\\s*("+c+")$|^$";var Z=$++;k[Z]="^"+k[s]+"\\s*("+i+")$|^$";var G=$++;k[G]="(\\s*)"+k[s]+"\\s*("+c+"|"+k[a]+")",R[G]=new RegExp(k[G],"g");var H=$++;k[H]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var V=$++;k[V]="^\\s*("+k[v]+")\\s+-\\s+("+k[v]+")\\s*$";var ee=$++;k[ee]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)A(ne,k[ne]),R[ne]||(R[ne]=new RegExp(k[ne]));function se(ce,ge){if(ce instanceof Y)return ce;if(typeof ce!="string"||ce.length>L||!(ge?R[n]:R[I]).test(ce))return null;try{return new Y(ce,ge)}catch{return null}}function Y(ce,ge){if(ce instanceof Y){if(ce.loose===ge)return ce;ce=ce.version}else if(typeof ce!="string")throw new TypeError("Invalid Version: "+ce);if(ce.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Y))return new Y(ce,ge);A("SemVer",ce,ge),this.loose=ge;var be=ce.trim().match(ge?R[n]:R[I]);if(!be)throw new TypeError("Invalid Version: "+ce);if(this.raw=ce,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(ke){if(/^[0-9]+$/.test(ke)){var Pe=+ke;if(Pe>=0&&Pe<j)return Pe}return ke}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=se,e.valid=function(ce,ge){var be=se(ce,ge);return be?be.version:null},e.clean=function(ce,ge){var be=se(ce.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(ce){return A("SemVer.compare",this.version,this.loose,ce),ce instanceof Y||(ce=new Y(ce,this.loose)),this.compareMain(ce)||this.comparePre(ce)},Y.prototype.compareMain=function(ce){return ce instanceof Y||(ce=new Y(ce,this.loose)),S(this.major,ce.major)||S(this.minor,ce.minor)||S(this.patch,ce.patch)},Y.prototype.comparePre=function(ce){if(ce instanceof Y||(ce=new Y(ce,this.loose)),this.prerelease.length&&!ce.prerelease.length)return-1;if(!this.prerelease.length&&ce.prerelease.length)return 1;if(!this.prerelease.length&&!ce.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],ke=ce.prerelease[ge];if(A("prerelease compare",ge,be,ke),be===void 0&&ke===void 0)return 0;if(ke===void 0)return 1;if(be===void 0)return-1;if(be!==ke)return S(be,ke)}while(++ge)},Y.prototype.inc=function(ce,ge){switch(ce){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ce)}return this.format(),this.raw=this.version,this},e.inc=function(ce,ge,be,ke){typeof be=="string"&&(ke=be,be=void 0);try{return new Y(ce,be).inc(ge,ke).version}catch{return null}},e.diff=function(ce,ge){if(K(ce,ge))return null;var be=se(ce),ke=se(ge);if(be.prerelease.length||ke.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==ke[Pe])return Pe},e.compareIdentifiers=S;var q=/^[0-9]+$/;function S(ce,ge){var be=q.test(ce),ke=q.test(ge);return be&&ke&&(ce=+ce,ge=+ge),be&&!ke?-1:ke&&!be?1:ce<ge?-1:ce>ge?1:0}function P(ce,ge,be){return new Y(ce,be).compare(new Y(ge,be))}function M(ce,ge,be){return P(ce,ge,be)>0}function T(ce,ge,be){return P(ce,ge,be)<0}function K(ce,ge,be){return P(ce,ge,be)===0}function _(ce,ge,be){return P(ce,ge,be)!==0}function ae(ce,ge,be){return P(ce,ge,be)>=0}function he(ce,ge,be){return P(ce,ge,be)<=0}function fe(ce,ge,be,ke){var Pe;switch(ge){case"===":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce===be;break;case"!==":typeof ce=="object"&&(ce=ce.version),typeof be=="object"&&(be=be.version),Pe=ce!==be;break;case"":case"=":case"==":Pe=K(ce,be,ke);break;case"!=":Pe=_(ce,be,ke);break;case">":Pe=M(ce,be,ke);break;case">=":Pe=ae(ce,be,ke);break;case"<":Pe=T(ce,be,ke);break;case"<=":Pe=he(ce,be,ke);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function le(ce,ge){if(ce instanceof le){if(ce.loose===ge)return ce;ce=ce.value}if(!(this instanceof le))return new le(ce,ge);A("comparator",ce,ge),this.loose=ge,this.parse(ce),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(ce,ge){return S(ge,ce)},e.major=function(ce,ge){return new Y(ce,ge).major},e.minor=function(ce,ge){return new Y(ce,ge).minor},e.patch=function(ce,ge){return new Y(ce,ge).patch},e.compare=P,e.compareLoose=function(ce,ge){return P(ce,ge,!0)},e.rcompare=function(ce,ge,be){return P(ge,ce,be)},e.sort=function(ce,ge){return ce.sort(function(be,ke){return e.compare(be,ke,ge)})},e.rsort=function(ce,ge){return ce.sort(function(be,ke){return e.rcompare(be,ke,ge)})},e.gt=M,e.lt=T,e.eq=K,e.neq=_,e.gte=ae,e.lte=he,e.cmp=fe,e.Comparator=le;var $e={};function de(ce,ge){if(ce instanceof de)return ce.loose===ge?ce:new de(ce.raw,ge);if(ce instanceof le)return new de(ce.value,ge);if(!(this instanceof de))return new de(ce,ge);if(this.loose=ge,this.raw=ce,this.set=ce.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ce);this.format()}function we(ce){return!ce||ce.toLowerCase()==="x"||ce==="*"}function Ee(ce,ge,be,ke,Pe,ze,je,Ue,Fe,ie,ue,me,pe){return((ge=we(be)?"":we(ke)?">="+be+".0.0":we(Pe)?">="+be+"."+ke+".0":">="+ge)+" "+(Ue=we(Fe)?"":we(ie)?"<"+(+Fe+1)+".0.0":we(ue)?"<"+Fe+"."+(+ie+1)+".0":me?"<="+Fe+"."+ie+"."+ue+"-"+me:"<="+Ue)).trim()}function Oe(ce,ge){for(var be=0;be<ce.length;be++)if(!ce[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<ce.length;be++)if(A(ce[be].semver),ce[be].semver!==$e&&ce[be].semver.prerelease.length>0){var ke=ce[be].semver;if(ke.major===ge.major&&ke.minor===ge.minor&&ke.patch===ge.patch)return!0}return!1}return!0}function Le(ce,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(ce)}function Te(ce,ge,be,ke){var Pe,ze,je,Ue,Fe;switch(ce=new Y(ce,ke),ge=new de(ge,ke),be){case">":Pe=M,ze=he,je=T,Ue=">",Fe=">=";break;case"<":Pe=T,ze=ae,je=M,Ue="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le(ce,ge,ke))return!1;for(var ie=0;ie<ge.set.length;++ie){var ue=ge.set[ie],me=null,pe=null;if(ue.forEach(function(Se){Se.semver===$e&&(Se=new le(">=0.0.0")),me=me||Se,pe=pe||Se,Pe(Se.semver,me.semver,ke)?me=Se:je(Se.semver,pe.semver,ke)&&(pe=Se)}),me.operator===Ue||me.operator===Fe||(!pe.operator||pe.operator===Ue)&&ze(ce,pe.semver)||pe.operator===Fe&&je(ce,pe.semver))return!1}return!0}le.prototype.parse=function(ce){var ge=this.loose?R[W]:R[Z],be=ce.match(ge);if(!be)throw new TypeError("Invalid comparator: "+ce);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Y(be[2],this.loose):this.semver=$e},le.prototype.toString=function(){return this.value},le.prototype.test=function(ce){return A("Comparator.test",ce,this.loose),this.semver===$e||(typeof ce=="string"&&(ce=new Y(ce,this.loose)),fe(ce,this.operator,this.semver,this.loose))},le.prototype.intersects=function(ce,ge){if(!(ce instanceof le))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(ce.value,ge),Le(this.value,be,ge);if(ce.operator==="")return be=new de(this.value,ge),Le(ce.semver,be,ge);var ke=!(this.operator!==">="&&this.operator!==">"||ce.operator!==">="&&ce.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ce.operator!=="<="&&ce.operator!=="<"),ze=this.semver.version===ce.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ce.operator!==">="&&ce.operator!=="<="),Ue=fe(this.semver,"<",ce.semver,ge)&&(this.operator===">="||this.operator===">")&&(ce.operator==="<="||ce.operator==="<"),Fe=fe(this.semver,">",ce.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ce.operator===">="||ce.operator===">");return ke||Pe||ze&&je||Ue||Fe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ce){return ce.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ce){var ge=this.loose;ce=ce.trim(),A("range",ce,ge);var be=ge?R[V]:R[H];ce=ce.replace(be,Ee),A("hyphen replace",ce),ce=ce.replace(R[G],"$1$2$3"),A("comparator trim",ce,R[G]),ce=(ce=(ce=ce.replace(R[F],"$1~")).replace(R[x],"$1^")).split(/\s+/).join(" ");var ke=ge?R[W]:R[Z],Pe=ce.split(" ").map(function(ze){return function(je,Ue){return A("comp",je),je=function(Fe,ie){return Fe.trim().split(/\s+/).map(function(ue){return function(me,pe){A("caret",me,pe);var Se=pe?R[Q]:R[J];return me.replace(Se,function(Re,Ce,Ie,De,Ae){var Ne;return A("caret",me,Re,Ce,Ie,De,Ae),we(Ce)?Ne="":we(Ie)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(De)?Ne=Ce==="0"?">="+Ce+"."+Ie+".0 <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+".0 <"+(+Ce+1)+".0.0":Ae?(A("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ne=Ce==="0"?Ie==="0"?">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+Ie+"."+(+De+1):">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+"."+De+Ae+" <"+(+Ce+1)+".0.0"):(A("no pr"),Ne=Ce==="0"?Ie==="0"?">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+Ie+"."+(+De+1):">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+"."+De+" <"+(+Ce+1)+".0.0"),A("caret return",Ne),Ne})}(ue,ie)}).join(" ")}(je,Ue),A("caret",je),je=function(Fe,ie){return Fe.trim().split(/\s+/).map(function(ue){return function(me,pe){var Se=pe?R[U]:R[z];return me.replace(Se,function(Re,Ce,Ie,De,Ae){var Ne;return A("tilde",me,Re,Ce,Ie,De,Ae),we(Ce)?Ne="":we(Ie)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(De)?Ne=">="+Ce+"."+Ie+".0 <"+Ce+"."+(+Ie+1)+".0":Ae?(A("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ne=">="+Ce+"."+Ie+"."+De+Ae+" <"+Ce+"."+(+Ie+1)+".0"):Ne=">="+Ce+"."+Ie+"."+De+" <"+Ce+"."+(+Ie+1)+".0",A("tilde return",Ne),Ne})}(ue,ie)}).join(" ")}(je,Ue),A("tildes",je),je=function(Fe,ie){return A("replaceXRanges",Fe,ie),Fe.split(/\s+/).map(function(ue){return function(me,pe){me=me.trim();var Se=pe?R[u]:R[b];return me.replace(Se,function(Re,Ce,Ie,De,Ae,Ne){A("xRange",me,Re,Ce,Ie,De,Ae,Ne);var qe=we(Ie),Be=qe||we(De),Ve=Be||we(Ae);return Ce==="="&&Ve&&(Ce=""),qe?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ve?(Be&&(De=0),Ve&&(Ae=0),Ce===">"?(Ce=">=",Be?(Ie=+Ie+1,De=0,Ae=0):Ve&&(De=+De+1,Ae=0)):Ce==="<="&&(Ce="<",Be?Ie=+Ie+1:De=+De+1),Re=Ce+Ie+"."+De+"."+Ae):Be?Re=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Ve&&(Re=">="+Ie+"."+De+".0 <"+Ie+"."+(+De+1)+".0"),A("xRange return",Re),Re})}(ue,ie)}).join(" ")}(je,Ue),A("xrange",je),je=function(Fe,ie){return A("replaceStars",Fe,ie),Fe.trim().replace(R[ee],"")}(je,Ue),A("stars",je),je}(ze,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(ze){return!!ze.match(ke)})),Pe=Pe.map(function(ze){return new le(ze,ge)})},de.prototype.intersects=function(ce,ge){if(!(ce instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(ke){return ce.set.some(function(Pe){return Pe.every(function(ze){return ke.intersects(ze,ge)})})})})},e.toComparators=function(ce,ge){return new de(ce,ge).set.map(function(be){return be.map(function(ke){return ke.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ce){if(!ce)return!1;typeof ce=="string"&&(ce=new Y(ce,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Oe(this.set[ge],ce))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function(ce,ge,be){var ke=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return ce.forEach(function(je){ze.test(je)&&(ke&&Pe.compare(je)!==-1||(Pe=new Y(ke=je,be)))}),ke},e.minSatisfying=function(ce,ge,be){var ke=null,Pe=null;try{var ze=new de(ge,be)}catch{return null}return ce.forEach(function(je){ze.test(je)&&(ke&&Pe.compare(je)!==1||(Pe=new Y(ke=je,be)))}),ke},e.validRange=function(ce,ge){try{return new de(ce,ge).range||"*"}catch{return null}},e.ltr=function(ce,ge,be){return Te(ce,ge,"<",be)},e.gtr=function(ce,ge,be){return Te(ce,ge,">",be)},e.outside=Te,e.prerelease=function(ce,ge){var be=se(ce,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(ce,ge,be){return ce=new de(ce,be),ge=new de(ge,be),ce.intersects(ge)},e.coerce=function(ce){if(ce instanceof Y)return ce;if(typeof ce!="string")return null;var ge=ce.match(R[p]);return ge==null?null:se((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,O(1))},function(te,e){var O,N,A=te.exports={};function L(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function R(f){if(O===setTimeout)return setTimeout(f,0);if((O===L||!O)&&setTimeout)return O=setTimeout,setTimeout(f,0);try{return O(f,0)}catch{try{return O.call(null,f,0)}catch{return O.call(this,f,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:L}catch{O=L}try{N=typeof clearTimeout=="function"?clearTimeout:j}catch{N=j}})();var k,$=[],C=!1,E=-1;function d(){C&&k&&(C=!1,k.length?$=k.concat($):E=-1,$.length&&h())}function h(){if(!C){var f=R(d);C=!0;for(var o=$.length;o;){for(k=$,$=[];++E<o;)k&&k[E].run();E=-1,o=$.length}k=null,C=!1,function(l){if(N===clearTimeout)return clearTimeout(l);if((N===j||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(l);try{N(l)}catch{try{return N.call(null,l)}catch{return N.call(this,l)}}}(f)}}function g(f,o){this.fun=f,this.array=o}function y(){}A.nextTick=function(f){var o=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)o[l-1]=arguments[l];$.push(new g(f,o)),$.length!==1||C||R(h)},g.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=y,A.addListener=y,A.once=y,A.off=y,A.removeListener=y,A.removeAllListeners=y,A.emit=y,A.prependListener=y,A.prependOnceListener=y,A.listeners=function(f){return[]},A.binding=function(f){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(f){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(re[128],oe([0,1]),function(te,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class N{constructor(R,k,$){this.level=R,this.key=k,this.value=$,this.forward=[]}}const A=void 0;class L{constructor(R,k=2**16){this.comparator=R,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new N(this.c,A,A)}get size(){return this.f}clear(){this.e=new N(this.c,A,A)}has(R){return!!L.g(this,R,this.comparator)}get(R){return L.g(this,R,this.comparator)?.value}set(R,k){return L.h(this,R,k,this.comparator)&&(this.f+=1),this}delete(R){const k=L.k(this,R,this.comparator);return k&&(this.f-=1),k}forEach(R,k){let $=this.e.forward[0];for(;$;)R.call(k,$.value,$.key,this),$=$.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",k=this.e.forward[0];for(;k;)R+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return R}static g(R,k,$){let C=R.e;for(let E=R.d-1;E>=0;E--)for(;C.forward[E]&&$(C.forward[E].key,k)<0;)C=C.forward[E];if(C=C.forward[0],C&&$(C.key,k)===0)return C}static h(R,k,$,C){const E=[];let d=R.e;for(let h=R.d-1;h>=0;h--){for(;d.forward[h]&&C(d.forward[h].key,k)<0;)d=d.forward[h];E[h]=d}if(d=d.forward[0],d&&C(d.key,k)===0)return d.value=$,!1;{const h=L.j(R);if(h>R.d){for(let g=R.d;g<h;g++)E[g]=R.e;R.d=h}d=new N(h,k,$);for(let g=0;g<h;g++)d.forward[g]=E[g].forward[g],E[g].forward[g]=d;return!0}}static j(R,k=.5){let $=1;for(;Math.random()<k&&$<R.c;)$+=1;return $}static k(R,k,$){const C=[];let E=R.e;for(let d=R.d-1;d>=0;d--){for(;E.forward[d]&&$(E.forward[d].key,k)<0;)E=E.forward[d];C[d]=E}if(E=E.forward[0],!E||$(E.key,k)!==0)return!1;for(let d=0;d<R.d&&C[d].forward[d]===E;d++)C[d].forward[d]=E.forward[d];for(;R.d>0&&R.e.forward[R.d-1]===A;)R.d-=1;return!0}}e.$nr=L}),define(re[60],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0;const O=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(L){return new N(L)}constructor(L){this.c=O&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ad=N}),define(re[3],oe([0,1,8,84,2,87,60]),function(te,e,O,N,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.$cd=e.Event=void 0;const R=!1,k=!1;var $;(function(b){b.None=()=>A.$jc.None;function u(fe){if(k){const{onDidAddListener:le}=fe,$e=g.create();let de=0;fe.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),le?.()}}}function p(fe,le){return Z(fe,()=>{},0,void 0,!0,void 0,le)}b.defer=p;function D(fe){return(le,$e=null,de)=>{let we=!1,Ee;return Ee=fe(Oe=>{if(!we)return Ee?Ee.dispose():we=!0,le.call($e,Oe)},null,de),we&&Ee.dispose(),Ee}}b.once=D;function F(fe,le,$e){return Q((de,we=null,Ee)=>fe(Oe=>de.call(we,le(Oe)),null,Ee),$e)}b.map=F;function z(fe,le,$e){return Q((de,we=null,Ee)=>fe(Oe=>{le(Oe),de.call(we,Oe)},null,Ee),$e)}b.forEach=z;function U(fe,le,$e){return Q((de,we=null,Ee)=>fe(Oe=>le(Oe)&&de.call(we,Oe),null,Ee),$e)}b.filter=U;function B(fe){return fe}b.signal=B;function x(...fe){return(le,$e=null,de)=>{const we=(0,A.$gc)(...fe.map(Ee=>Ee(Oe=>le.call($e,Oe))));return W(we,de)}}b.any=x;function J(fe,le,$e,de){let we=$e;return F(fe,Ee=>(we=le(we,Ee),we),de)}b.reduce=J;function Q(fe,le){let $e;const de={onWillAddFirstListener(){$e=fe(we.fire,we)},onDidRemoveLastListener(){$e?.dispose()}};le||u(de);const we=new w(de);return le?.add(we),we.event}function W(fe,le){return le instanceof Array?le.push(fe):le&&le.add(fe),fe}function Z(fe,le,$e=100,de=!1,we=!1,Ee,Oe){let Le,Te,ce,ge=0,be;const ke={leakWarningThreshold:Ee,onWillAddFirstListener(){Le=fe(ze=>{ge++,Te=le(Te,ze),de&&!ce&&(Pe.fire(Te),Te=void 0),be=()=>{const je=Te;Te=void 0,ce=void 0,(!de||ge>1)&&Pe.fire(je),ge=0},typeof $e=="number"?(clearTimeout(ce),ce=setTimeout(be,$e)):ce===void 0&&(ce=0,queueMicrotask(be))})},onWillRemoveListener(){we&&ge>0&&be?.()},onDidRemoveLastListener(){be=void 0,Le.dispose()}};Oe||u(ke);const Pe=new w(ke);return Oe?.add(Pe),Pe.event}b.debounce=Z;function G(fe,le=0,$e){return b.debounce(fe,(de,we)=>de?(de.push(we),de):[we],le,void 0,!0,void 0,$e)}b.accumulate=G;function H(fe,le=(de,we)=>de===we,$e){let de=!0,we;return U(fe,Ee=>{const Oe=de||!le(Ee,we);return de=!1,we=Ee,Oe},$e)}b.latch=H;function V(fe,le,$e){return[b.filter(fe,le,$e),b.filter(fe,de=>!le(de),$e)]}b.split=V;function ee(fe,le=!1,$e=[],de){let we=$e.slice(),Ee=fe(Te=>{we?we.push(Te):Le.fire(Te)});de&&de.add(Ee);const Oe=()=>{we?.forEach(Te=>Le.fire(Te)),we=null},Le=new w({onWillAddFirstListener(){Ee||(Ee=fe(Te=>Le.fire(Te)),de&&de.add(Ee))},onDidAddFirstListener(){we&&(le?setTimeout(Oe):Oe())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Le),Le.event}b.buffer=ee;function ne(fe,le){return(de,we,Ee)=>{const Oe=le(new Y);return fe(function(Le){const Te=Oe.evaluate(Le);Te!==se&&de.call(we,Te)},void 0,Ee)}}b.chain=ne;const se=Symbol("HaltChainable");class Y{constructor(){this.f=[]}map(le){return this.f.push(le),this}forEach(le){return this.f.push($e=>(le($e),$e)),this}filter(le){return this.f.push($e=>le($e)?$e:se),this}reduce(le,$e){let de=$e;return this.f.push(we=>(de=le(de,we),de)),this}latch(le=($e,de)=>$e===de){let $e=!0,de;return this.f.push(we=>{const Ee=$e||!le(we,de);return $e=!1,de=we,Ee?we:se}),this}evaluate(le){for(const $e of this.f)if(le=$e(le),le===se)break;return le}}function q(fe,le,$e=de=>de){const de=(...Le)=>Oe.fire($e(...Le)),we=()=>fe.on(le,de),Ee=()=>fe.removeListener(le,de),Oe=new w({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Oe.event}b.fromNodeEventEmitter=q;function S(fe,le,$e=de=>de){const de=(...Le)=>Oe.fire($e(...Le)),we=()=>fe.addEventListener(le,de),Ee=()=>fe.removeEventListener(le,de),Oe=new w({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Oe.event}b.fromDOMEventEmitter=S;function P(fe){return new Promise(le=>D(fe)(le))}b.toPromise=P;function M(fe){const le=new w;return fe.then($e=>{le.fire($e)},()=>{le.fire(void 0)}).finally(()=>{le.dispose()}),le.event}b.fromPromise=M;function T(fe,le){return le(void 0),fe($e=>le($e))}b.runAndSubscribe=T;function K(fe,le){let $e=null;function de(Ee){$e?.dispose(),$e=new A.$ic,le(Ee,$e)}de(void 0);const we=fe(Ee=>de(Ee));return(0,A.$hc)(()=>{we.dispose(),$e?.dispose()})}b.runAndSubscribeWithStore=K;class _{constructor(le,$e){this._observable=le,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{le.addObserver(this)},onDidRemoveLastListener:()=>{le.removeObserver(this)}};$e||u(de),this.emitter=new w(de),$e&&$e.add(this.emitter)}beginUpdate(le){this.f++}handlePossibleChange(le){}handleChange(le,$e){this.g=!0}endUpdate(le){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ae(fe,le){return new _(fe,le).emitter.event}b.fromObservable=ae;function he(fe){return le=>{let $e=0,de=!1;const we={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(fe.reportChanges(),de&&(de=!1,le()))},handlePossibleChange(){},handleChange(){de=!0}};return fe.addObserver(we),fe.reportChanges(),{dispose(){fe.removeObserver(we)}}}}b.fromObservableLight=he})($||(e.Event=$={}));class C{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${C.f++}`,C.all.add(this)}start(u){this.g=new j.$ad,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$cd=C;let E=-1;function d(b){const u=E;return E=b,{dispose(){E=u}}}e.$dd=d;class h{constructor(u,p=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=p,this.g=0}dispose(){this.f?.clear()}check(u,p){const D=this.threshold;if(D<=0||p<D)return;this.f||(this.f=new Map);const F=this.f.get(u.value)||0;if(this.f.set(u.value,F+1),this.g-=1,this.g<=0){this.g=D*.5;let z,U=0;for(const[B,x]of this.f)(!z||U<x)&&(z=B,U=x);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${U}):`),console.warn(z)}return()=>{const z=this.f.get(u.value)||0;this.f.set(u.value,z-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class f{constructor(u){this.value=u,this.id=y++}}const o=2,l=(b,u)=>{if(b instanceof f)u(b);else for(let p=0;p<b.length;p++){const D=b[p];D&&u(D)}};class w{constructor(u){this.w=0,this.f=u,this.g=E>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const u=this.t;queueMicrotask(()=>{l(u,p=>p.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,p,D)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.$jc.None;if(this.m)return A.$jc.None;p&&(u=u.bind(p));const F=new f(u);let z,U;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=g.create(),z=this.g.check(F.stack,this.w+1)),R&&(F.stack=U??g.create()),this.t?this.t instanceof f?(this.u??=new I,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const B=(0,A.$hc)(()=>{z?.(),this.x(F)});return D instanceof A.$ic?D.add(B):Array.isArray(D)&&D.push(B),B},this.q}x(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const p=this.t,D=p.indexOf(u);if(D===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,p[D]=void 0;const F=this.u.current===this;if(this.w*o<=p.length){let z=0;for(let U=0;U<p.length;U++)p[U]?p[z++]=p[U]:F&&(this.u.end--,z<this.u.i&&this.u.i--);p.length=z}}y(u,p){if(!u)return;const D=this.f?.onListenerError||O.$Y;if(!D){u.value(p);return}try{u.value(p)}catch(F){D(F)}}z(u){const p=u.current.t;for(;u.i<u.end;)this.y(p[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,u);else{const p=this.u;p.enqueue(this,u,this.t.length),this.z(p)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ed=w;const m=()=>new I;e.$fd=m;class I{constructor(){this.i=-1,this.end=0}enqueue(u,p,D){this.i=0,this.end=D,this.current=u,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends w{async fireAsync(u,p,D){if(this.t)for(this.h||(this.h=new L.$sc),l(this.t,F=>this.h.push([F.value,u]));this.h.size>0&&!p.isCancellationRequested;){const[F,z]=this.h.shift(),U=[],B={...z,token:p,waitUntil:x=>{if(Object.isFrozen(U))throw new Error("waitUntil can NOT be called asynchronous");D&&(x=D(x,F)),U.push(x)}};try{F(B)}catch(x){(0,O.$Y)(x);continue}Object.freeze(U),await Promise.allSettled(U).then(x=>{for(const J of x)J.status==="rejected"&&(0,O.$Y)(J.reason)})}}}e.$gd=i;class c extends w{get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new L.$sc,this.A=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.A(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.w&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$hd=c;class n extends c{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$id=n;class s extends w{constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$jd=s;class t{constructor(){this.g=!1,this.h=[],this.f=new w({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const p={event:u,listener:null};this.h.push(p),this.g&&this.m(p);const D=()=>{this.g&&this.o(p);const F=this.h.indexOf(p);this.h.splice(F,1)};return(0,A.$hc)((0,N.$bb)(D))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event(p=>this.f.fire(p))}o(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.f.dispose()}}e.$kd=t;class r{constructor(u,p,D,F){this.f=new A.$ic;const z=this.f.add(new t),U=this.f.add(new A.$rc);function B(x){U.set(x,z.add(F(x)))}for(const x of u)B(x);this.f.add(p(x=>{B(x)})),this.f.add(D(x=>{U.deleteAndDispose(x)})),this.event=z.event}dispose(){this.f.dispose()}}e.$ld=r;class a{constructor(){this.f=[]}wrapEvent(u){return(p,D,F)=>u(z=>{const U=this.f[this.f.length-1];U?U.push(()=>p.call(D,z)):p.call(D,z)},void 0,F)}bufferEvents(u){const p=[];this.f.push(p);const D=u();return this.f.pop(),p.forEach(F=>F()),D}}e.$md=a;class v{constructor(){this.f=!1,this.g=$.None,this.h=A.$jc.None,this.j=new w({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$nd=v}),define(re[26],oe([0,1,3]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.CancellationToken=void 0;const N=Object.freeze(function(R,k){const $=setTimeout(R.bind(k),0);return{dispose(){clearTimeout($)}}});var A;(function(R){function k($){return $===R.None||$===R.Cancelled||$ instanceof L?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}R.isCancellationToken=k,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:O.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(A||(e.CancellationToken=A={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new O.$ed),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=A.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=A.None}}e.$od=j}),define(re[129],oe([0,1,26]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=void 0;class N{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new O.$od,k=this.b(R.token);return this.a={promise:k,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$ge=N;class A{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const k=JSON.stringify(R);return this.b!==k&&(this.b=k,this.a=this.c(R)),this.a}}e.$he=A;class L{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const k=this.b(R);return this.a.set(R,k),k}}e.$ie=L}),define(re[42],oe([0,1,8,2]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=void 0;function A(m){const I=m;return I?typeof I.read=="function":!1}e.$pd=A;function L(m){const I=m;return I?[I.on,I.pause,I.resume,I.destroy].every(i=>typeof i=="function"):!1}e.$qd=L;function j(m){const I=m;return I?L(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.$rd=j;function R(m,I){return new k(m,I)}e.$sd=R;class k{constructor(I,i){this.e=I,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(i=>i(I))}h(I){this.c.error.length===0?(0,O.$Y)(I):this.c.error.slice(0).forEach(i=>i(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,i){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(I,i){if(this.a.destroyed)return;let c;switch(I){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const n=c.indexOf(i);n>=0&&c.splice(n,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(m,I){const i=[];let c;for(;(c=m.read())!==null;)i.push(c);return I(i)}e.$td=$;function C(m,I,i){const c=[];let n;for(;(n=m.read())!==null&&c.length<i;)c.push(n);return n===null&&c.length>0?I(c):{read:()=>{if(c.length>0)return c.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return m.read()}}}e.$ud=C;function E(m,I){return new Promise((i,c)=>{const n=[];d(m,{onData:s=>{I&&n.push(s)},onError:s=>{I?c(s):i(void 0)},onEnd:()=>{i(I?I(n):void 0)}})})}e.$vd=E;function d(m,I,i){m.on("error",c=>{i?.isCancellationRequested||I.onError(c)}),m.on("end",()=>{i?.isCancellationRequested||I.onEnd()}),m.on("data",c=>{i?.isCancellationRequested||I.onData(c)})}e.$wd=d;function h(m,I){return new Promise((i,c)=>{const n=new N.$ic,s=[],t=v=>{if(s.push(v),s.length>I)return n.dispose(),m.pause(),i({stream:m,buffer:s,ended:!1})},r=v=>(n.dispose(),c(v)),a=()=>(n.dispose(),i({stream:m,buffer:s,ended:!0}));n.add((0,N.$hc)(()=>m.removeListener("error",r))),m.on("error",r),n.add((0,N.$hc)(()=>m.removeListener("end",a))),m.on("end",a),n.add((0,N.$hc)(()=>m.removeListener("data",t))),m.on("data",t)})}e.$xd=h;function g(m,I){const i=R(I);return i.end(m),i}e.$yd=g;function y(){const m=R(()=>{throw new Error("not supported")});return m.end(),m}e.$zd=y;function f(m){let I=!1;return{read:()=>I?null:(I=!0,m)}}e.$Ad=f;function o(m,I,i){const c=R(i);return d(m,{onData:n=>c.write(I.data(n)),onError:n=>c.error(I.error?I.error(n):n),onEnd:()=>c.end()}),c}e.$Bd=o;function l(m,I,i){let c=!1;return{read:()=>{const n=I.read();return c?n:(c=!0,n!==null?i([m,n]):m)}}}e.$Cd=l;function w(m,I,i){let c=!1;const n=R(i);return d(I,{onData:s=>c?n.write(s):(c=!0,n.write(i([m,s]))),onError:s=>n.error(s),onEnd:()=>{c||(c=!0,n.write(m)),n.end()}}),n}e.$Dd=w}),define(re[14],oe([0,1,86,42]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=void 0;const A=typeof Buffer<"u",L=new O.$T(()=>new Uint8Array(256));let j,R;class k{static alloc(p){return A?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return A&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,D){return!(D?.dontUseNodeBuffer||!1)&&A?new k(Buffer.from(p)):(j||(j=new TextEncoder),new k(j.encode(p)))}static fromByteArray(p){const D=k.alloc(p.length);for(let F=0,z=p.length;F<z;F++)D.buffer[F]=p[F];return D}static concat(p,D){if(typeof D>"u"){D=0;for(let U=0,B=p.length;U<B;U++)D+=p[U].byteLength}const F=k.alloc(D);let z=0;for(let U=0,B=p.length;U<B;U++){const x=p[U];F.set(x,z),z+=x.byteLength}return F}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=k.alloc(this.byteLength);return p.set(this),p}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(p,D){return new k(this.buffer.subarray(p,D))}set(p,D){if(p instanceof k)this.buffer.set(p.buffer,D);else if(p instanceof Uint8Array)this.buffer.set(p,D);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),D);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return d(this.buffer,p)}writeUInt32BE(p,D){h(this.buffer,p,D)}readUInt32LE(p){return g(this.buffer,p)}writeUInt32LE(p,D){y(this.buffer,p,D)}readUInt8(p){return f(this.buffer,p)}writeUInt8(p,D){o(this.buffer,p,D)}indexOf(p,D=0){return $(this.buffer,p instanceof k?p.buffer:p,D)}}e.$Ed=k;function $(u,p,D=0){const F=p.byteLength,z=u.byteLength;if(F===0)return 0;if(F===1)return u.indexOf(p[0]);if(F>z-D)return-1;const U=L.value;U.fill(p.length);for(let Q=0;Q<p.length;Q++)U[p[Q]]=p.length-Q-1;let B=D+p.length-1,x=B,J=-1;for(;B<z;)if(u[B]===p[x]){if(x===0){J=B;break}B--,x--}else B+=Math.max(p.length-x,U[u[B]]),x=p.length-1;return J}e.$Fd=$;function C(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0}e.$Gd=C;function E(u,p,D){u[D+0]=p&255,p=p>>>8,u[D+1]=p&255}e.$Hd=E;function d(u,p){return u[p]*2**24+u[p+1]*2**16+u[p+2]*2**8+u[p+3]}e.$Id=d;function h(u,p,D){u[D+3]=p,p=p>>>8,u[D+2]=p,p=p>>>8,u[D+1]=p,p=p>>>8,u[D]=p}e.$Jd=h;function g(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0|u[p+2]<<16>>>0|u[p+3]<<24>>>0}e.$Kd=g;function y(u,p,D){u[D+0]=p&255,p=p>>>8,u[D+1]=p&255,p=p>>>8,u[D+2]=p&255,p=p>>>8,u[D+3]=p&255}e.$Ld=y;function f(u,p){return u[p]}e.$Md=f;function o(u,p,D){u[D]=p}e.$Nd=o;function l(u){return N.$td(u,p=>k.concat(p))}e.$Od=l;function w(u){return N.$Ad(u)}e.$Pd=w;function m(u){return N.$vd(u,p=>k.concat(p))}e.$Qd=m;async function I(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await m(u.stream)])}e.$Rd=I;function i(u){return N.$yd(u,p=>k.concat(p))}e.$Sd=i;function c(u){return N.$Bd(u,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.$Td=c;function n(u){return N.$sd(p=>k.concat(p),u)}e.$Ud=n;function s(u,p){return N.$Cd(u,p,D=>k.concat(D))}e.$Vd=s;function t(u,p){return N.$Dd(u,p,D=>k.concat(D))}e.$Wd=t;function r(u){let p=0,D=0,F=0;const z=new Uint8Array(Math.floor(u.length/4*3)),U=x=>{switch(D){case 3:z[F++]=p|x,D=0;break;case 2:z[F++]=p|x>>>2,p=x<<6,D=3;break;case 1:z[F++]=p|x>>>4,p=x<<4,D=2;break;default:p=x<<2,D=1}};for(let x=0;x<u.length;x++){const J=u.charCodeAt(x);if(J>=65&&J<=90)U(J-65);else if(J>=97&&J<=122)U(J-97+26);else if(J>=48&&J<=57)U(J-48+52);else if(J===43||J===45)U(62);else if(J===47||J===95)U(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${u[x]}`)}}const B=F;for(;D>0;)U(0);return k.wrap(z).slice(0,B)}e.$Xd=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:u},p=!0,D=!1){const F=D?v:a;let z="";const U=u.byteLength%3;let B=0;for(;B<u.byteLength-U;B+=3){const x=u[B+0],J=u[B+1],Q=u[B+2];z+=F[x>>>2],z+=F[(x<<4|J>>>4)&63],z+=F[(J<<2|Q>>>6)&63],z+=F[Q&63]}if(U===1){const x=u[B+0];z+=F[x>>>2],z+=F[x<<4&63],p&&(z+="==")}else if(U===2){const x=u[B+0],J=u[B+1];z+=F[x>>>2],z+=F[(x<<4|J>>>4)&63],z+=F[J<<2&63],p&&(z+="=")}return z}e.$Yd=b}),define(re[27],oe([0,1,129,86]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hf=e.$gf=e.$ff=e.$ef=e.GraphemeBreakType=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=void 0;function A(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$le=A;const L=/{(\d+)}/g;function j(ie,...ue){return ue.length===0?ie:ie.replace(L,function(me,pe){const Se=parseInt(pe,10);return isNaN(Se)||Se<0||Se>=ue.length?me:ue[Se]})}e.$me=j;const R=/{([^}]+)}/g;function k(ie,ue){return ie.replace(R,(me,pe)=>ue[pe]??me)}e.$ne=k;function $(ie){return ie.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}e.$oe=$;function C(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$pe=C;function E(ie,ue){let me=0;const pe=ue.charCodeAt(0);for(let Se=ie.length-1;Se>=0;Se--)ie.charCodeAt(Se)===pe&&me++;return me}e.$qe=E;function d(ie,ue,me="\u2026"){return ie.length<=ue?ie:`${ie.substr(0,ue)}${me}`}e.$re=d;function h(ie,ue=" "){const me=g(ie,ue);return y(me,ue)}e.$se=h;function g(ie,ue){if(!ie||!ue)return ie;const me=ue.length;if(me===0||ie.length===0)return ie;let pe=0;for(;ie.indexOf(ue,pe)===pe;)pe=pe+me;return ie.substring(pe)}e.$te=g;function y(ie,ue){if(!ie||!ue)return ie;const me=ue.length,pe=ie.length;if(me===0||pe===0)return ie;let Se=pe,Re=-1;for(;Re=ie.lastIndexOf(ue,Se-1),!(Re===-1||Re+me!==Se);){if(Re===0)return"";Se=Re}return ie.substring(0,Se)}e.$ue=y;function f(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$ve=f;function o(ie){return ie.replace(/\*/g,"")}e.$we=o;function l(ie,ue,me={}){if(!ie)throw new Error("Cannot create regex from empty string");ue||(ie=C(ie)),me.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(ie,pe)}e.$xe=l;function w(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$ye=w;function m(ie){return ie.split(/\r\n|\r|\n/)}e.$ze=m;function I(ie){for(let ue=0,me=ie.length;ue<me;ue++){const pe=ie.charCodeAt(ue);if(pe!==32&&pe!==9)return ue}return-1}e.$Ae=I;function i(ie,ue=0,me=ie.length){for(let pe=ue;pe<me;pe++){const Se=ie.charCodeAt(pe);if(Se!==32&&Se!==9)return ie.substring(ue,pe)}return ie.substring(ue,me)}e.$Be=i;function c(ie,ue=ie.length-1){for(let me=ue;me>=0;me--){const pe=ie.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Ce=c;function n(ie,ue,me){const pe=[];let Se=0;for(const Re of ie.matchAll(ue)){if(pe.push(ie.slice(Se,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Se=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,ie,Re.groups))}return pe.push(ie.slice(Se)),Promise.all(pe).then(Re=>Re.join(""))}e.$De=n;function s(ie,ue){return ie<ue?-1:ie>ue?1:0}e.$Ee=s;function t(ie,ue,me=0,pe=ie.length,Se=0,Re=ue.length){for(;me<pe&&Se<Re;me++,Se++){const De=ie.charCodeAt(me),Ae=ue.charCodeAt(Se);if(De<Ae)return-1;if(De>Ae)return 1}const Ce=pe-me,Ie=Re-Se;return Ce<Ie?-1:Ce>Ie?1:0}e.$Fe=t;function r(ie,ue){return a(ie,ue,0,ie.length,0,ue.length)}e.$Ge=r;function a(ie,ue,me=0,pe=ie.length,Se=0,Re=ue.length){for(;me<pe&&Se<Re;me++,Se++){let De=ie.charCodeAt(me),Ae=ue.charCodeAt(Se);if(De===Ae)continue;if(De>=128||Ae>=128)return t(ie.toLowerCase(),ue.toLowerCase(),me,pe,Se,Re);b(De)&&(De-=32),b(Ae)&&(Ae-=32);const Ne=De-Ae;if(Ne!==0)return Ne}const Ce=pe-me,Ie=Re-Se;return Ce<Ie?-1:Ce>Ie?1:0}e.$He=a;function v(ie){return ie>=48&&ie<=57}e.$Ie=v;function b(ie){return ie>=97&&ie<=122}e.$Je=b;function u(ie){return ie>=65&&ie<=90}e.$Ke=u;function p(ie,ue){return ie.length===ue.length&&a(ie,ue)===0}e.$Le=p;function D(ie,ue){const me=ue.length;return ue.length>ie.length?!1:a(ie,ue,0,me)===0}e.$Me=D;function F(ie,ue){const me=Math.min(ie.length,ue.length);let pe;for(pe=0;pe<me;pe++)if(ie.charCodeAt(pe)!==ue.charCodeAt(pe))return pe;return me}e.$Ne=F;function z(ie,ue){const me=Math.min(ie.length,ue.length);let pe;const Se=ie.length-1,Re=ue.length-1;for(pe=0;pe<me;pe++)if(ie.charCodeAt(Se-pe)!==ue.charCodeAt(Re-pe))return pe;return me}e.$Oe=z;function U(ie){return 55296<=ie&&ie<=56319}e.$Pe=U;function B(ie){return 56320<=ie&&ie<=57343}e.$Qe=B;function x(ie,ue){return(ie-55296<<10)+(ue-56320)+65536}e.$Re=x;function J(ie,ue,me){const pe=ie.charCodeAt(me);if(U(pe)&&me+1<ue){const Se=ie.charCodeAt(me+1);if(B(Se))return x(pe,Se)}return pe}e.$Se=J;function Q(ie,ue){const me=ie.charCodeAt(ue-1);if(B(me)&&ue>1){const pe=ie.charCodeAt(ue-2);if(U(pe))return x(pe,me)}return me}class W{get offset(){return this.e}constructor(ue,me=0){this.c=ue,this.d=ue.length,this.e=me}setOffset(ue){this.e=ue}prevCodePoint(){const ue=Q(this.c,this.e);return this.e-=ue>=65536?2:1,ue}nextCodePoint(){const ue=J(this.c,this.d,this.e);return this.e+=ue>=65536?2:1,ue}eol(){return this.e>=this.d}}e.$Te=W;class Z{get offset(){return this.c.offset}constructor(ue,me=0){this.c=new W(ue,me)}nextGraphemeLength(){const ue=ge.getInstance(),me=this.c,pe=me.offset;let Se=ue.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=ue.getGraphemeBreakType(me.nextCodePoint());if(Te(Se,Ce)){me.setOffset(Re);break}Se=Ce}return me.offset-pe}prevGraphemeLength(){const ue=ge.getInstance(),me=this.c,pe=me.offset;let Se=ue.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=ue.getGraphemeBreakType(me.prevCodePoint());if(Te(Ce,Se)){me.setOffset(Re);break}Se=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$Ue=Z;function G(ie,ue){return new Z(ie,ue).nextGraphemeLength()}e.$Ve=G;function H(ie,ue){return new Z(ie,ue).prevGraphemeLength()}e.$We=H;function V(ie,ue){ue>0&&B(ie.charCodeAt(ue))&&ue--;const me=ue+G(ie,ue);return[me-H(ie,me),me]}e.$Xe=V;function ee(ie){const ue=new Z(ie);let me=0;for(;!ue.eol();)me++,ue.nextGraphemeLength();return me}e.$Ye=ee;let ne;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Y(ie){return ne||(ne=se()),ne.test(ie)}e.$Ze=Y;const q=/^[\t\n\r\x20-\x7E]*$/;function S(ie){return q.test(ie)}e.$1e=S,e.$2e=/[\u2028\u2029]/;function P(ie){return e.$2e.test(ie)}e.$3e=P;function M(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$4e=M;function T(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$5e=T;function K(ie,ue){if(ie.length<ue)return ie;const me=/\b/g;let pe=0;for(;me.test(ie)&&!(ie.length-me.lastIndex<ue);)pe=me.lastIndex,me.lastIndex+=1;return ie.substring(pe).replace(/^\s/,"")}e.$6e=K;const _=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ae=/\x1b\].*?\x07/g;function he(ie){return ie&&(ie=ie.replace(_,"").replace(ae,"")),ie}e.$7e=he,e.$8e=String.fromCharCode(65279);function fe(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$9e=fe;function le(ie){return fe(ie)?ie.substr(1):ie}e.$0e=le;function $e(ie,ue){if(!ie||!ue||ie.length<ue.length)return!1;const me=ue.length,pe=ie.toLowerCase();let Se=0,Re=-1;for(;Se<me;){const Ce=pe.indexOf(ue[Se],Re+1);if(Ce<0)return!1;Re=Ce,Se++}return!0}e.$$e=$e;function de(ie,ue=!1){return ie?(ue&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$_e=de;function we(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$af=we;function Ee(ie,ue=1){if(ue===0)return"";let me=-1;do me=ie.indexOf(`
`,me+1),ue--;while(ue>0&&me>=0);return me===-1?ie:(ie[me-1]==="\r"&&me--,ie.substr(0,me))}e.$bf=Ee;function Oe(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$cf=Oe;function Le(ie){return ge.getInstance().getGraphemeBreakType(ie)}e.$df=Le;function Te(ie,ue){return ie===0?ue!==5&&ue!==7:ie===2&&ue===3?!1:ie===4||ie===2||ie===3||ue===4||ue===2||ue===3?!0:!(ie===8&&(ue===8||ue===9||ue===11||ue===12)||(ie===11||ie===9)&&(ue===9||ue===10)||(ie===12||ie===10)&&ue===10||ue===5||ue===13||ue===7||ie===1||ie===13&&ue===14||ie===6&&ue===6)}var ce;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ce||(e.GraphemeBreakType=ce={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType(ue){if(ue<32)return ue===10?3:ue===13?2:4;if(ue<127)return 0;const me=this.d,pe=me.length/3;let Se=1;for(;Se<=pe;)if(ue<me[3*Se])Se=2*Se;else if(ue>me[3*Se+1])Se=2*Se+1;else return me[3*Se+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ke(ie,ue){if(ie===0)return 0;const me=Pe(ie,ue);if(me!==void 0)return me;const pe=new W(ue,ie);return pe.prevCodePoint(),pe.offset}e.$ef=ke;function Pe(ie,ue){const me=new W(ue,ie);let pe=me.prevCodePoint();for(;ze(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!T(pe))return;let Se=me.offset;return Se>0&&me.prevCodePoint()===8205&&(Se=me.offset),Se}function ze(ie){return 127995<=ie&&ie<=127999}var je;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$ff="\xA0";class Ue{static{this.c=new N.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new O.$he(ue=>{function me(Ne){const qe=new Map;for(let Be=0;Be<Ne.length;Be+=2)qe.set(Ne[Be],Ne[Be+1]);return qe}function pe(Ne,qe){const Be=new Map(Ne);for(const[Ve,xe]of qe)Be.set(Ve,xe);return Be}function Se(Ne,qe){if(!Ne)return qe;const Be=new Map;for(const[Ve,xe]of Ne)qe.has(Ve)&&Be.set(Ve,xe);return Be}const Re=this.c.value;let Ce=ue.filter(Ne=>!Ne.startsWith("_")&&Ne in Re);Ce.length===0&&(Ce=["_default"]);let Ie;for(const Ne of Ce){const qe=me(Re[Ne]);Ie=Se(Ie,qe)}const De=me(Re._common),Ae=pe(De,Ie);return new Ue(Ae)})}static getInstance(ue){return Ue.d.get(Array.from(ue))}static{this.e=new N.$T(()=>Object.keys(Ue.c.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$gf=Ue;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(ue){return Fe.e().has(ue)}static get codePoints(){return Fe.e()}}e.$hf=Fe}),define(re[51],oe([0,1,27]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=void 0;function N(o){return A(o,0)}e.$oi=N;function A(o,l){switch(typeof o){case"object":return o===null?L(349,l):Array.isArray(o)?k(o,l):$(o,l);case"string":return R(o,l);case"boolean":return j(o,l);case"number":return L(o,l);case"undefined":return L(937,l);default:return L(617,l)}}e.$pi=A;function L(o,l){return(l<<5)-l+o|0}e.$qi=L;function j(o,l){return L(o?433:863,l)}function R(o,l){l=L(149417,l);for(let w=0,m=o.length;w<m;w++)l=L(o.charCodeAt(w),l);return l}e.$ri=R;function k(o,l){return l=L(104579,l),o.reduce((w,m)=>A(m,w),l)}function $(o,l){return l=L(181387,l),Object.keys(o).sort().reduce((w,m)=>(w=R(m,w),A(o[m],w)),l)}class C{constructor(){this.g=0}get value(){return this.g}hash(l){return this.g=A(l,this.g),this.g}}e.$si=C;var E;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(o,l,w=32){const m=w-l,I=~((1<<m)-1);return(o<<l|(I&o)>>>m)>>>0}function h(o,l=0,w=o.byteLength,m=0){for(let I=0;I<w;I++)o[l+I]=m}function g(o,l,w="0"){for(;o.length<l;)o=w+o;return o}function y(o,l=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(w=>w.toString(16).padStart(2,"0")).join(""):g((o>>>0).toString(16),l/4)}e.$ti=y;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(l){const w=l.length;if(w===0)return;const m=this.p;let I=this.r,i=this.u,c,n;for(i!==0?(c=i,n=-1,i=0):(c=l.charCodeAt(0),n=0);;){let s=c;if(O.$Pe(c))if(n+1<w){const t=l.charCodeAt(n+1);O.$Qe(t)?(n++,s=O.$Re(c,t)):s=65533}else{i=c;break}else O.$Qe(c)&&(s=65533);if(I=this.w(m,I,s),n++,n<w)c=l.charCodeAt(n);else break}this.r=I,this.u=i}w(l,w,m){return m<128?l[w++]=m:m<2048?(l[w++]=192|(m&1984)>>>6,l[w++]=128|(m&63)>>>0):m<65536?(l[w++]=224|(m&61440)>>>12,l[w++]=128|(m&4032)>>>6,l[w++]=128|(m&63)>>>0):(l[w++]=240|(m&1835008)>>>18,l[w++]=128|(m&258048)>>>12,l[w++]=128|(m&4032)>>>6,l[w++]=128|(m&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,l[0]=l[64+0],l[1]=l[64+1],l[2]=l[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const l=8*this.t;this.q.setUint32(56,Math.floor(l/4294967296),!1),this.q.setUint32(60,l%4294967296,!1),this.y()}y(){const l=f.g,w=this.q;for(let a=0;a<64;a+=4)l.setUint32(a,w.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)l.setUint32(a,d(l.getUint32(a-12,!1)^l.getUint32(a-32,!1)^l.getUint32(a-56,!1)^l.getUint32(a-64,!1),1),!1);let m=this.h,I=this.l,i=this.m,c=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=I&i|~I&c,t=1518500249):a<40?(s=I^i^c,t=1859775393):a<60?(s=I&i|I&c|i&c,t=2400959708):(s=I^i^c,t=3395469782),r=d(m,5)+s+n+t+l.getUint32(a*4,!1)&4294967295,n=c,c=i,i=d(I,30),I=m,m=r;this.h=this.h+m&4294967295,this.l=this.l+I&4294967295,this.m=this.m+i&4294967295,this.n=this.n+c&4294967295,this.o=this.o+n&4294967295}}e.$ui=f}),define(re[89],oe([0,1,27]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(N||(N={})),function(A){const L="error",j="warning",R="warn",k="info",$="ignore";function C(d){return d?O.$Le(L,d)?A.Error:O.$Le(j,d)||O.$Le(R,d)?A.Warning:O.$Le(k,d)?A.Info:A.Ignore:A.Ignore}A.fromValue=C;function E(d){switch(d){case A.Error:return L;case A.Warning:return j;case A.Info:return k;default:return $}}A.toString=E}(N||(N={})),e.default=N}),define(re[130],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$bd=Symbol("MicrotaskDelay")}),define(re[47],oe([0,1,18,27]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class A{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const g=h.charCodeAt(0),y=this.b.charCodeAt(this.c);return g-y}value(){return this.b[this.c]}}e.$Ch=A;class L{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,N.$Fe)(h,this.b,0,h.length,this.c,this.d):(0,N.$He)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Dh=L;class j{constructor(h=!0,g=!0){this.f=h,this.g=g}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let g=h.length-1;g>=0;g--,this.c--){const y=this.b.charCodeAt(g);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,N.$Fe)(h,this.b,0,h.length,this.d,this.e):(0,N.$He)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Eh=j;var R;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(R||(R={}));class k{constructor(h,g){this.f=h,this.g=g,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,N.$Ge)(h,this.c.scheme);if(this.d[this.e]===2)return(0,N.$Ge)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,N.$Ee)(h,this.c.query);if(this.d[this.e]===5)return(0,N.$Ee)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fh=k;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(C||(C={}));class E{static forUris(h=()=>!1,g=()=>!1){return new E(new k(h,g))}static forPaths(h=!1){return new E(new j(void 0,!h))}static forStrings(){return new E(new A)}static forConfigKeys(){return new E(new L)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,g){if(g){const y=g.slice(0);(0,O.$Ub)(y);for(const f of y)this.set(f,h)}else{const y=h.slice(0);(0,O.$Ub)(y);for(const f of y)this.set(f[0],f[1])}}set(h,g){const y=this.b.reset(h);let f;this.c||(this.c=new $,this.c.segment=y.value());const o=[];for(f=this.c;;){const w=y.cmp(f.segment);if(w>0)f.left||(f.left=new $,f.left.segment=y.value()),o.push([-1,f]),f=f.left;else if(w<0)f.right||(f.right=new $,f.right.segment=y.value()),o.push([1,f]),f=f.right;else if(y.hasNext())y.next(),f.mid||(f.mid=new $,f.mid.segment=y.value()),o.push([0,f]),f=f.mid;else break}const l=f.value;f.value=g,f.key=h;for(let w=o.length-1;w>=0;w--){const m=o[w][1];m.updateHeight();const I=m.balanceFactor();if(I<-1||I>1){const i=o[w][0],c=o[w+1][0];if(i===1&&c===1)o[w][1]=m.rotateLeft();else if(i===-1&&c===-1)o[w][1]=m.rotateRight();else if(i===1&&c===-1)m.right=o[w+1][1]=o[w+1][1].rotateRight(),o[w][1]=m.rotateLeft();else if(i===-1&&c===1)m.left=o[w+1][1]=o[w+1][1].rotateLeft(),o[w][1]=m.rotateRight();else throw new Error;if(w>0)switch(o[w-1][0]){case-1:o[w-1][1].left=o[w][1];break;case 1:o[w-1][1].right=o[w][1];break;case 0:o[w-1][1].mid=o[w][1];break}else this.c=o[0][1]}}return l}get(h){return this.d(h)?.value}d(h){const g=this.b.reset(h);let y=this.c;for(;y;){const f=g.cmp(y.segment);if(f>0)y=y.left;else if(f<0)y=y.right;else if(g.hasNext())g.next(),y=y.mid;else break}return y}has(h){const g=this.d(h);return!(g?.value===void 0&&g?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,g){const y=this.b.reset(h),f=[];let o=this.c;for(;o;){const l=y.cmp(o.segment);if(l>0)f.push([-1,o]),o=o.left;else if(l<0)f.push([1,o]),o=o.right;else if(y.hasNext())y.next(),f.push([0,o]),o=o.mid;else break}if(o){if(g?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const l=this.f(o.right);if(l.key){const{key:w,value:m,segment:I}=l;this.e(l.key,!1),o.key=w,o.value=m,o.segment=I}}else{const l=o.left??o.right;if(f.length>0){const[w,m]=f[f.length-1];switch(w){case-1:m.left=l;break;case 0:m.mid=l;break;case 1:m.right=l;break}}else this.c=l}for(let l=f.length-1;l>=0;l--){const w=f[l][1];w.updateHeight();const m=w.balanceFactor();if(m>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),f[l][1]=w.rotateLeft()):m<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),f[l][1]=w.rotateRight()),l>0)switch(f[l-1][0]){case-1:f[l-1][1].left=f[l][1];break;case 1:f[l-1][1].right=f[l][1];break;case 0:f[l-1][1].mid=f[l][1];break}else this.c=f[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const g=this.b.reset(h);let y=this.c,f;for(;y;){const o=g.cmp(y.segment);if(o>0)y=y.left;else if(o<0)y=y.right;else if(g.hasNext())g.next(),f=y.value||f,y=y.mid;else break}return y&&y.value||f}findSuperstr(h){return this.g(h,!1)}g(h,g){const y=this.b.reset(h);let f=this.c;for(;f;){const o=y.cmp(f.segment);if(o>0)f=f.left;else if(o<0)f=f.right;else if(y.hasNext())y.next(),f=f.mid;else return f.mid?this.h(f.mid):g?f.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[g,y]of this)h(y,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const g=[];return this.j(h,g),g[Symbol.iterator]()}j(h,g){h&&(h.left&&this.j(h.left,g),h.value&&g.push([h.key,h.value]),h.mid&&this.j(h.mid,g),h.right&&this.j(h.right,g))}_isBalanced(){const h=g=>{if(!g)return!0;const y=g.balanceFactor();return y<-1||y>1?!1:h(g.left)&&h(g.right)};return h(this.c)}}e.$Gh=E}),define(re[9],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=void 0;function O(I){return typeof I=="string"}e.$if=O;function N(I){return Array.isArray(I)&&I.every(i=>O(i))}e.$jf=N;function A(I){return typeof I=="object"&&I!==null&&!Array.isArray(I)&&!(I instanceof RegExp)&&!(I instanceof Date)}e.$kf=A;function L(I){const i=Object.getPrototypeOf(Uint8Array);return typeof I=="object"&&I instanceof i}e.$lf=L;function j(I){return typeof I=="number"&&!isNaN(I)}e.$mf=j;function R(I){return!!I&&typeof I[Symbol.iterator]=="function"}e.$nf=R;function k(I){return I===!0||I===!1}e.$of=k;function $(I){return typeof I>"u"}e.$pf=$;function C(I){return!E(I)}e.$qf=C;function E(I){return $(I)||I===null}e.$rf=E;function d(I,i){if(!I)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$sf=d;function h(I){if(E(I))throw new Error("Assertion Failed: argument is undefined or null");return I}e.$tf=h;function g(...I){const i=[];for(let c=0;c<I.length;c++){const n=I[c];if(E(n))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);i.push(n)}return i}e.$uf=g;const y=Object.prototype.hasOwnProperty;function f(I){if(!A(I))return!1;for(const i in I)if(y.call(I,i))return!1;return!0}e.$vf=f;function o(I){return typeof I=="function"}e.$wf=o;function l(...I){return I.length>0&&I.every(o)}e.$xf=l;function w(I,i){const c=Math.min(I.length,i.length);for(let n=0;n<c;n++)m(I[n],i[n])}e.$yf=w;function m(I,i){if(O(i)){if(typeof I!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(o(i)){try{if(I instanceof i)return}catch{}if(!E(I)&&I.constructor===i||i.length===1&&i.call(void 0,I)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$zf=m}),define(re[30],oe([0,1,9]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=void 0;function N(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const l=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([w,m])=>{l[w]=m&&typeof m=="object"?N(m):m}),l}e.$Um=N;function A(o){if(!o||typeof o!="object")return o;const l=[o];for(;l.length>0;){const w=l.shift();Object.freeze(w);for(const m in w)if(L.call(w,m)){const I=w[m];typeof I=="object"&&!Object.isFrozen(I)&&!(0,O.$lf)(I)&&l.push(I)}}return o}e.$Vm=A;const L=Object.prototype.hasOwnProperty;function j(o,l){return R(o,l,new Set)}e.$Wm=j;function R(o,l,w){if((0,O.$rf)(o))return o;const m=l(o);if(typeof m<"u")return m;if(Array.isArray(o)){const I=[];for(const i of o)I.push(R(i,l,w));return I}if((0,O.$kf)(o)){if(w.has(o))throw new Error("Cannot clone recursive data-structure");w.add(o);const I={};for(const i in o)L.call(o,i)&&(I[i]=R(o[i],l,w));return w.delete(o),I}return o}function k(o,l,w=!0){return(0,O.$kf)(o)?((0,O.$kf)(l)&&Object.keys(l).forEach(m=>{m in o?w&&((0,O.$kf)(o[m])&&(0,O.$kf)(l[m])?k(o[m],l[m],w):o[m]=l[m]):o[m]=l[m]}),o):l}e.$Xm=k;function $(o,l){if(o===l)return!0;if(o==null||l===null||l===void 0||typeof o!=typeof l||typeof o!="object"||Array.isArray(o)!==Array.isArray(l))return!1;let w,m;if(Array.isArray(o)){if(o.length!==l.length)return!1;for(w=0;w<o.length;w++)if(!$(o[w],l[w]))return!1}else{const I=[];for(m in o)I.push(m);I.sort();const i=[];for(m in l)i.push(m);if(i.sort(),!$(I,i))return!1;for(w=0;w<I.length;w++)if(!$(o[I[w]],l[I[w]]))return!1}return!0}e.$Ym=$;function C(o){const l=new Set;return JSON.stringify(o,(w,m)=>{if((0,O.$kf)(m)||Array.isArray(m)){if(l.has(m))return"[Circular]";l.add(m)}return m})}e.$Zm=C;function E(o,l){const w=Object.create(null);return!o||!l||Object.keys(l).forEach(I=>{const i=o[I],c=l[I];$(i,c)||(w[I]=c)}),w}e.$1m=E;function d(o,l){const w=l.toLowerCase(),m=Object.keys(o).find(I=>I.toLowerCase()===w);return m?o[m]:o[l]}e.$2m=d;function h(o,l){const w=Object.create(null);for(const[m,I]of Object.entries(o))l(m,I)&&(w[m]=I);return w}e.$3m=h;function g(o){let l=[];for(;Object.prototype!==o;)l=l.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return l}e.$4m=g;function y(o){const l=[];for(const w of g(o))typeof o[w]=="function"&&l.push(w);return l}e.$5m=y;function f(o,l){const w=I=>function(){const i=Array.prototype.slice.call(arguments,0);return l(I,i)},m={};for(const I of o)m[I]=w(I);return m}e.$6m=f}),define(re[32],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(A){return O.test(A)}e.$2f=N,e.$3f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(R){for(let k=0;k<R.length;k++)R[k]=Math.floor(Math.random()*256);return R};const L=new Uint8Array(16),j=[];for(let R=0;R<256;R++)j.push(R.toString(16).padStart(2,"0"));return function(){A(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let k=0,$="";return $+=j[L[k++]],$+=j[L[k++]],$+=j[L[k++]],$+=j[L[k++]],$+="-",$+=j[L[k++]],$+=j[L[k++]],$+="-",$+=j[L[k++]],$+=j[L[k++]],$+="-",$+=j[L[k++]],$+=j[L[k++]],$+="-",$+=j[L[k++]],$+=j[L[k++]],$+=j[L[k++]],$+=j[L[k++]],$+=j[L[k++]],$+=j[L[k++]],$}}()}),define(re[131],oe([0,1,36]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(j){const R=j.replace(/\-/g,":").toLowerCase();return!N.has(R)}function L(){const j=(0,O.networkInterfaces)();for(const R in j){const k=j[R];if(k){for(const{mac:$}of k)if(A($))return $}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Fm=L}),define(re[132],oe([0,1,36,47,32,131]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=void 0,e.$Gm=new class{c($){return this.a||(this.a=N.$Gh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,C=0;const E=(0,O.networkInterfaces)();for(const d in E){const h=E[d];if(h)for(const{mac:g,internal:y}of h)y||(C+=1,this.c(g.toUpperCase())&&($+=1))}this.b=C>0?$/C:0}return this.b}};let j;async function R($){return j||(j=(async()=>await k($)||A.$3f())()),j}e.$Hm=R;async function k($){try{const C=await new Promise((d,h)=>{te(["crypto"],d,h)}),E=(0,L.$Fm)();return C.createHash("sha256").update(E,"utf8").digest("hex")}catch(C){$(C);return}}}),define(re[133],oe([0,1,268,14]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IS=void 0;class A extends O.Transform{constructor(j){if(super(),typeof j=="number")this.b=j,this.c=1;else{const R=Buffer.isBuffer(j)?j:Buffer.from(j);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(j,R,k){this.a?this.a=Buffer.concat([this.a,j]):this.a=j;let $=0;for(;$<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,$):(0,N.$Fd)(this.a,this.b,$);if(C===-1)break;this.push(this.a.slice($,C+this.c)),$=C+this.c}this.a=$===this.a.length?void 0:this.a.slice($),k()}_flush(j){this.a&&this.push(this.a),j()}}e.$IS=A}),define(re[134],oe([0,1,61]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=void 0;function N(R,k,$,C=1){let E=!1;return new Promise(d=>{const h=setTimeout(()=>{if(!E)return E=!0,d(0)},$);A(R,k,C,g=>{if(!E)return E=!0,clearTimeout(h),d(g)})})}e.$5f=N;function A(R,k,$,C){if(k===0)return C(0);const E=new O.Socket;E.once("connect",()=>(j(E),A(R+$,k-1,$,C))),E.once("data",()=>{}),E.once("error",d=>(j(E),d.code!=="ECONNREFUSED"?A(R+$,k-1,$,C):C(R))),E.connect(R,"127.0.0.1")}e.$6f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(R,k,$,C="127.0.0.1"){let E=!1,d,h=1;const g=O.createServer({pauseOnConnect:!0});function y(f,o){E||(E=!0,g.removeAllListeners(),g.close(),d&&clearTimeout(d),o(f))}return new Promise(f=>{d=setTimeout(()=>{y(0,f)},$),g.on("listening",()=>{y(R,f)}),g.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&h<k?(R++,h++,g.listen(R,C)):y(0,f)}),g.on("close",()=>{y(0,f)}),g.listen(R,C)})}e.$7f=L;function j(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(k){console.error(k)}}}),define(re[135],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YS=void 0;function O(N){return!!N.parentPort}e.$YS=O}),define(re[136],oe([13,10]),function(te,e){return te.create("vs/base/common/date",e)}),define(re[62],oe([0,1,136]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=void 0;const N=60,A=N*60,L=A*24,j=L*7,R=L*30,k=L*365;function $(E,d,h,g){typeof E!="number"&&(E=E.getTime());const y=Math.round((new Date().getTime()-E)/1e3);if(y<-30)return(0,O.localize)(0,null,$(new Date().getTime()+y*1e3,!1));if(!g&&y<30)return(0,O.localize)(1,null);let f;return y<N?(f=y,d?f===1?h?(0,O.localize)(2,null,f):(0,O.localize)(3,null,f):h?(0,O.localize)(4,null,f):(0,O.localize)(5,null,f):f===1?h?(0,O.localize)(6,null,f):(0,O.localize)(7,null,f):h?(0,O.localize)(8,null,f):(0,O.localize)(9,null,f)):y<A?(f=Math.floor(y/N),d?f===1?h?(0,O.localize)(10,null,f):(0,O.localize)(11,null,f):h?(0,O.localize)(12,null,f):(0,O.localize)(13,null,f):f===1?h?(0,O.localize)(14,null,f):(0,O.localize)(15,null,f):h?(0,O.localize)(16,null,f):(0,O.localize)(17,null,f)):y<L?(f=Math.floor(y/A),d?f===1?h?(0,O.localize)(18,null,f):(0,O.localize)(19,null,f):h?(0,O.localize)(20,null,f):(0,O.localize)(21,null,f):f===1?h?(0,O.localize)(22,null,f):(0,O.localize)(23,null,f):h?(0,O.localize)(24,null,f):(0,O.localize)(25,null,f)):y<j?(f=Math.floor(y/L),d?f===1?(0,O.localize)(26,null,f):(0,O.localize)(27,null,f):f===1?(0,O.localize)(28,null,f):(0,O.localize)(29,null,f)):y<R?(f=Math.floor(y/j),d?f===1?h?(0,O.localize)(30,null,f):(0,O.localize)(31,null,f):h?(0,O.localize)(32,null,f):(0,O.localize)(33,null,f):f===1?h?(0,O.localize)(34,null,f):(0,O.localize)(35,null,f):h?(0,O.localize)(36,null,f):(0,O.localize)(37,null,f)):y<k?(f=Math.floor(y/R),d?f===1?h?(0,O.localize)(38,null,f):(0,O.localize)(39,null,f):h?(0,O.localize)(40,null,f):(0,O.localize)(41,null,f):f===1?h?(0,O.localize)(42,null,f):(0,O.localize)(43,null,f):h?(0,O.localize)(44,null,f):(0,O.localize)(45,null,f)):(f=Math.floor(y/k),d?f===1?h?(0,O.localize)(46,null,f):(0,O.localize)(47,null,f):h?(0,O.localize)(48,null,f):(0,O.localize)(49,null,f):f===1?h?(0,O.localize)(50,null,f):(0,O.localize)(51,null,f):h?(0,O.localize)(52,null,f):(0,O.localize)(53,null,f))}e.$5l=$;function C(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$6l=C}),define(re[137],oe([13,10]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(re[38],oe([0,1,18,9,137]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=void 0;function L(E,d){return d&&(E.stack||E.stacktrace)?A.localize(0,null,R(E),j(E.stack)||j(E.stacktrace)):R(E)}function j(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?A.localize(1,null,E.message):E.message||A.localize(2,null)}function k(E=null,d=!1){if(!E)return A.localize(3,null);if(Array.isArray(E)){const h=O.$Eb(E),g=k(h[0],d);return h.length>1?A.localize(4,null,g,h.length):g}if(N.$if(E))return E;if(E.detail){const h=E.detail;if(h.error)return L(h.error,d);if(h.exception)return L(h.exception,d)}return E.stack?L(E,d):E.message?E.message:A.localize(5,null)}e.$li=k;function $(E){const d=E;return d instanceof Error&&Array.isArray(d.actions)}e.$mi=$;function C(E,d){let h;return typeof E=="string"?h=new Error(E):h=E,h.actions=d,h}e.$ni=C}),define(re[138],oe([13,10]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(re[139],oe([0,1,138]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;function N(A){switch(A){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.$lp=N}),define(re[140],oe([13,10]),function(te,e){return te.create("vs/base/common/platform",e)}),define(re[6],oe([0,1,140]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let N=!1,A=!1,L=!1,j=!1,R=!1,k=!1,$=!1,C=!1,E=!1,d=!1,h,g=e.$f,y=e.$f,f,o;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let l;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?l=e.$g.vscode.process:typeof process<"u"&&(l=process);const w=typeof l?.versions?.electron=="string",m=w&&l?.type==="renderer";if(typeof navigator=="object"&&!m)o=navigator.userAgent,N=o.indexOf("Windows")>=0,A=o.indexOf("Macintosh")>=0,C=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=o.indexOf("Linux")>=0,d=o?.indexOf("Mobi")>=0,k=!0,h=O.getConfiguredDefaultLocale(O.localize(0,null))||e.$f,g=h,y=navigator.language;else if(typeof l=="object"){N=l.platform==="win32",A=l.platform==="darwin",L=l.platform==="linux",j=L&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,$=w,E=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$f,g=e.$f;const v=l.env.VSCODE_NLS_CONFIG;if(v)try{const b=JSON.parse(v),u=b.availableLanguages["*"];h=b.locale,y=b.osLocale,g=u||e.$f,f=b._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var I;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(I||(e.Platform=I={}));function i(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=i;let c=0;A?c=1:N?c=3:L&&(c=2),e.$i=N,e.$j=A,e.$k=L,e.$l=j,e.$m=R,e.$n=$,e.$o=k,e.$p=k&&typeof e.$g.importScripts=="function",e.$q=C,e.$r=d,e.$s=E,e.$t=c,e.$u=o,e.$v=g;var n;(function(v){function b(){return e.$v}v.value=b;function u(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}v.isDefaultVariant=u;function p(){return e.$v==="en"}v.isDefault=p})(n||(e.Language=n={})),e.$w=h,e.$x=y,e.$y=f,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const v=[];e.$g.addEventListener("message",u=>{if(u.data&&u.data.vscodeScheduleAsyncWork)for(let p=0,D=v.length;p<D;p++){const F=v[p];if(F.id===u.data.vscodeScheduleAsyncWork){v.splice(p,1),F.callback();return}}});let b=0;return u=>{const p=++b;v.push({id:p,callback:u}),e.$g.postMessage({vscodeScheduleAsyncWork:p},"*")}}return v=>setTimeout(v)})();var s;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=A||C?2:N?1:3;let t=!0,r=!1;function a(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,t=new Uint16Array(v.buffer)[0]===(2<<8)+1}return t}e.$C=a,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(re[37],oe([0,1,6]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.$2d=e.env=e.cwd=void 0;let N;if(typeof O.$g.vscode<"u"&&typeof O.$g.vscode.process<"u"){const A=O.$g.vscode.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return O.$i?"win32":O.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$2d=N.platform,e.$3d=N.arch}),define(re[16],oe([0,1,37]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.sep=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;const N=65,A=97,L=90,j=122,R=46,k=47,$=92,C=58,E=63;class d extends Error{constructor(c,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=c.indexOf(".")!==-1?"property":"argument";let a=`The "${c}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(i,c){if(i===null||typeof i!="object")throw new d(c,"Object",i)}function g(i,c){if(typeof i!="string")throw new d(c,"string",i)}const y=O.$2d==="win32";function f(i){return i===k||i===$}function o(i){return i===k}function l(i){return i>=N&&i<=L||i>=A&&i<=j}function w(i,c,n,s){let t="",r=0,a=-1,v=0,b=0;for(let u=0;u<=i.length;++u){if(u<i.length)b=i.charCodeAt(u);else{if(s(b))break;b=k}if(s(b)){if(!(a===u-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const p=t.lastIndexOf(n);p===-1?(t="",r=0):(t=t.slice(0,p),r=t.length-1-t.lastIndexOf(n)),a=u,v=0;continue}else if(t.length!==0){t="",r=0,a=u,v=0;continue}}c&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,u)}`:t=i.slice(a+1,u),r=u-a-1;a=u,v=0}else b===R&&v!==-1?++v:v=-1}return t}function m(i,c){h(c,"pathObject");const n=c.dir||c.root,s=c.base||`${c.name||""}${c.ext||""}`;return n?n===c.root?`${n}${s}`:`${n}${i}${s}`:s}e.$4d={resolve(...i){let c="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],g(r,"path"),r.length===0)continue}else c.length===0?r=O.cwd():(r=O.env[`=${c}`]||O.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==c.toLowerCase()&&r.charCodeAt(2)===$)&&(r=`${c}\\`));const a=r.length;let v=0,b="",u=!1;const p=r.charCodeAt(0);if(a===1)f(p)&&(v=1,u=!0);else if(f(p))if(u=!0,f(r.charCodeAt(1))){let D=2,F=D;for(;D<a&&!f(r.charCodeAt(D));)D++;if(D<a&&D!==F){const z=r.slice(F,D);for(F=D;D<a&&f(r.charCodeAt(D));)D++;if(D<a&&D!==F){for(F=D;D<a&&!f(r.charCodeAt(D));)D++;(D===a||D!==F)&&(b=`\\\\${z}\\${r.slice(F,D)}`,v=D)}}}else v=1;else l(p)&&r.charCodeAt(1)===C&&(b=r.slice(0,2),v=2,a>2&&f(r.charCodeAt(2))&&(u=!0,v=3));if(b.length>0)if(c.length>0){if(b.toLowerCase()!==c.toLowerCase())continue}else c=b;if(s){if(c.length>0)break}else if(n=`${r.slice(v)}\\${n}`,s=u,u&&c.length>0)break}return n=w(n,!s,"\\",f),s?`${c}\\${n}`:`${c}${n}`||"."},normalize(i){g(i,"path");const c=i.length;if(c===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(c===1)return o(r)?"\\":i;if(f(r))if(t=!0,f(i.charCodeAt(1))){let v=2,b=v;for(;v<c&&!f(i.charCodeAt(v));)v++;if(v<c&&v!==b){const u=i.slice(b,v);for(b=v;v<c&&f(i.charCodeAt(v));)v++;if(v<c&&v!==b){for(b=v;v<c&&!f(i.charCodeAt(v));)v++;if(v===c)return`\\\\${u}\\${i.slice(b)}\\`;v!==b&&(s=`\\\\${u}\\${i.slice(b,v)}`,n=v)}}}else n=1;else l(r)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),n=2,c>2&&f(i.charCodeAt(2))&&(t=!0,n=3));let a=n<c?w(i.slice(n),!t,"\\",f):"";return a.length===0&&!t&&(a="."),a.length>0&&f(i.charCodeAt(c-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){g(i,"path");const c=i.length;if(c===0)return!1;const n=i.charCodeAt(0);return f(n)||c>2&&l(n)&&i.charCodeAt(1)===C&&f(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let c,n;for(let r=0;r<i.length;++r){const a=i[r];g(a,"path"),a.length>0&&(c===void 0?c=n=a:c+=`\\${a}`)}if(c===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&f(n.charCodeAt(0))){++t;const r=n.length;r>1&&f(n.charCodeAt(1))&&(++t,r>2&&(f(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<c.length&&f(c.charCodeAt(t));)t++;t>=2&&(c=`\\${c.slice(t)}`)}return e.$4d.normalize(c)},relative(i,c){if(g(i,"from"),g(c,"to"),i===c)return"";const n=e.$4d.resolve(i),s=e.$4d.resolve(c);if(n===s||(i=n.toLowerCase(),c=s.toLowerCase(),i===c))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===$;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===$;)r--;const a=r-t;let v=0;for(;v<c.length&&c.charCodeAt(v)===$;)v++;let b=c.length;for(;b-1>v&&c.charCodeAt(b-1)===$;)b--;const u=b-v,p=a<u?a:u;let D=-1,F=0;for(;F<p;F++){const U=i.charCodeAt(t+F);if(U!==c.charCodeAt(v+F))break;U===$&&(D=F)}if(F!==p){if(D===-1)return s}else{if(u>p){if(c.charCodeAt(v+F)===$)return s.slice(v+F+1);if(F===2)return s.slice(v+F)}a>p&&(i.charCodeAt(t+F)===$?D=F:F===2&&(D=3)),D===-1&&(D=0)}let z="";for(F=t+D+1;F<=r;++F)(F===r||i.charCodeAt(F)===$)&&(z+=z.length===0?"..":"\\..");return v+=D,z.length>0?`${z}${s.slice(v,b)}`:(s.charCodeAt(v)===$&&++v,s.slice(v,b))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const c=e.$4d.resolve(i);if(c.length<=2)return i;if(c.charCodeAt(0)===$){if(c.charCodeAt(1)===$){const n=c.charCodeAt(2);if(n!==E&&n!==R)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(l(c.charCodeAt(0))&&c.charCodeAt(1)===C&&c.charCodeAt(2)===$)return`\\\\?\\${c}`;return i},dirname(i){g(i,"path");const c=i.length;if(c===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(c===1)return f(t)?i:".";if(f(t)){if(n=s=1,f(i.charCodeAt(1))){let v=2,b=v;for(;v<c&&!f(i.charCodeAt(v));)v++;if(v<c&&v!==b){for(b=v;v<c&&f(i.charCodeAt(v));)v++;if(v<c&&v!==b){for(b=v;v<c&&!f(i.charCodeAt(v));)v++;if(v===c)return i;v!==b&&(n=s=v+1)}}}}else l(t)&&i.charCodeAt(1)===C&&(n=c>2&&f(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let v=c-1;v>=s;--v)if(f(i.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,c){c!==void 0&&g(c,"ext"),g(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&l(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(n=2),c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let a=c.length-1,v=-1;for(r=i.length-1;r>=n;--r){const b=i.charCodeAt(r);if(f(b)){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(b===c.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(f(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){g(i,"path");let c=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&l(i.charCodeAt(0))&&(c=s=2);for(let v=i.length-1;v>=c;--v){const b=i.charCodeAt(v);if(f(b)){if(!r){s=v+1;break}continue}t===-1&&(r=!1,t=v+1),b===R?n===-1?n=v:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:m.bind(null,"\\"),parse(i){g(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return f(t)?(c.root=c.dir=i,c):(c.base=c.name=i,c);if(f(t)){if(s=1,f(i.charCodeAt(1))){let D=2,F=D;for(;D<n&&!f(i.charCodeAt(D));)D++;if(D<n&&D!==F){for(F=D;D<n&&f(i.charCodeAt(D));)D++;if(D<n&&D!==F){for(F=D;D<n&&!f(i.charCodeAt(D));)D++;D===n?s=D:D!==F&&(s=D+1)}}}}else if(l(t)&&i.charCodeAt(1)===C){if(n<=2)return c.root=c.dir=i,c;if(s=2,f(i.charCodeAt(2))){if(n===3)return c.root=c.dir=i,c;s=3}}s>0&&(c.root=i.slice(0,s));let r=-1,a=s,v=-1,b=!0,u=i.length-1,p=0;for(;u>=s;--u){if(t=i.charCodeAt(u),f(t)){if(!b){a=u+1;break}continue}v===-1&&(b=!1,v=u+1),t===R?r===-1?r=u:p!==1&&(p=1):r!==-1&&(p=-1)}return v!==-1&&(r===-1||p===0||p===1&&r===v-1&&r===a+1?c.base=c.name=i.slice(a,v):(c.name=i.slice(a,r),c.base=i.slice(a,v),c.ext=i.slice(r,v))),a>0&&a!==s?c.dir=i.slice(0,a-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(y){const i=/\\/g;return()=>{const c=O.cwd().replace(i,"/");return c.slice(c.indexOf("/"))}}return()=>O.cwd()})();e.$5d={resolve(...i){let c="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:I();g(t,"path"),t.length!==0&&(c=`${t}/${c}`,n=t.charCodeAt(0)===k)}return c=w(c,!n,"/",o),n?`/${c}`:c.length>0?c:"."},normalize(i){if(g(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===k,n=i.charCodeAt(i.length-1)===k;return i=w(i,!c,"/",o),i.length===0?c?"/":n?"./":".":(n&&(i+="/"),c?`/${i}`:i)},isAbsolute(i){return g(i,"path"),i.length>0&&i.charCodeAt(0)===k},join(...i){if(i.length===0)return".";let c;for(let n=0;n<i.length;++n){const s=i[n];g(s,"path"),s.length>0&&(c===void 0?c=s:c+=`/${s}`)}return c===void 0?".":e.$5d.normalize(c)},relative(i,c){if(g(i,"from"),g(c,"to"),i===c||(i=e.$5d.resolve(i),c=e.$5d.resolve(c),i===c))return"";const n=1,s=i.length,t=s-n,r=1,a=c.length-r,v=t<a?t:a;let b=-1,u=0;for(;u<v;u++){const D=i.charCodeAt(n+u);if(D!==c.charCodeAt(r+u))break;D===k&&(b=u)}if(u===v)if(a>v){if(c.charCodeAt(r+u)===k)return c.slice(r+u+1);if(u===0)return c.slice(r+u)}else t>v&&(i.charCodeAt(n+u)===k?b=u:u===0&&(b=0));let p="";for(u=n+b+1;u<=s;++u)(u===s||i.charCodeAt(u)===k)&&(p+=p.length===0?"..":"/..");return`${p}${c.slice(r+b)}`},toNamespacedPath(i){return i},dirname(i){if(g(i,"path"),i.length===0)return".";const c=i.charCodeAt(0)===k;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===k){if(!s){n=t;break}}else s=!1;return n===-1?c?"/":".":c&&n===1?"//":i.slice(0,n)},basename(i,c){c!==void 0&&g(c,"ext"),g(i,"path");let n=0,s=-1,t=!0,r;if(c!==void 0&&c.length>0&&c.length<=i.length){if(c===i)return"";let a=c.length-1,v=-1;for(r=i.length-1;r>=0;--r){const b=i.charCodeAt(r);if(b===k){if(!t){n=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(b===c.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=v))}return n===s?s=v:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===k){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){g(i,"path");let c=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const v=i.charCodeAt(a);if(v===k){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),v===R?c===-1?c=a:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||s===-1||r===0||r===1&&c===s-1&&c===n+1?"":i.slice(c,s)},format:m.bind(null,"/"),parse(i){g(i,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return c;const n=i.charCodeAt(0)===k;let s;n?(c.root="/",s=1):s=0;let t=-1,r=0,a=-1,v=!0,b=i.length-1,u=0;for(;b>=s;--b){const p=i.charCodeAt(b);if(p===k){if(!v){r=b+1;break}continue}a===-1&&(v=!1,a=b+1),p===R?t===-1?t=b:u!==1&&(u=1):t!==-1&&(u=-1)}if(a!==-1){const p=r===0&&n?1:r;t===-1||u===0||u===1&&t===a-1&&t===r+1?c.base=c.name=i.slice(p,a):(c.name=i.slice(p,t),c.base=i.slice(p,a),c.ext=i.slice(t,a))}return r>0?c.dir=i.slice(0,r-1):n&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$5d.win32=e.$4d.win32=e.$4d,e.$5d.posix=e.$4d.posix=e.$5d,e.$6d=y?e.$4d.normalize:e.$5d.normalize,e.$7d=y?e.$4d.isAbsolute:e.$5d.isAbsolute,e.$8d=y?e.$4d.join:e.$5d.join,e.$9d=y?e.$4d.resolve:e.$5d.resolve,e.$0d=y?e.$4d.relative:e.$5d.relative,e.$$d=y?e.$4d.dirname:e.$5d.dirname,e.$_d=y?e.$4d.basename:e.$5d.basename,e.$ae=y?e.$4d.extname:e.$5d.extname,e.$be=y?e.$4d.format:e.$5d.format,e.$ce=y?e.$4d.parse:e.$5d.parse,e.$de=y?e.$4d.toNamespacedPath:e.$5d.toNamespacedPath,e.sep=y?e.$4d.sep:e.$5d.sep,e.$fe=y?e.$4d.delimiter:e.$5d.delimiter}),define(re[48],oe([0,1,16,6,27,9]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=void 0;function j(r){return r===47||r===92}e.$Af=j;function R(r){return r.replace(/[\\/]/g,O.$5d.sep)}e.$Bf=R;function k(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Cf=k;function $(r,a=O.$5d.sep){if(!r)return"";const v=r.length,b=r.charCodeAt(0);if(j(b)){if(j(r.charCodeAt(1))&&!j(r.charCodeAt(2))){let p=3;const D=p;for(;p<v&&!j(r.charCodeAt(p));p++);if(D!==p&&!j(r.charCodeAt(p+1))){for(p+=1;p<v;p++)if(j(r.charCodeAt(p)))return r.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(o(b)&&r.charCodeAt(1)===58)return j(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<v;u++)if(j(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$Df=$;function C(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const b=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(b===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$Ef=C;const E=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(r,a=N.$i){const v=a?E:d;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$Ff=g;function y(r,a,v){const b=r===a;return!v||b?b:!r||!a?!1:(0,A.$Le)(r,a)}e.$Gf=y;function f(r,a,v,b=O.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,A.$Me)(r,a))return!1;if(a.length===r.length)return!0;let p=a.length;return a.charAt(a.length-1)===b&&p--,r.charAt(p)===b}return a.charAt(a.length-1)!==b&&(a+=b),r.indexOf(a)===0}e.$Hf=f;function o(r){return r>=65&&r<=90||r>=97&&r<=122}e.$If=o;function l(r,a){return N.$i&&r.endsWith(":")&&(r+=O.sep),(0,O.$7d)(r)||(r=(0,O.$8d)(a,r)),r=(0,O.$6d)(r),N.$i?(r=(0,A.$ue)(r,O.sep),r.endsWith(":")&&(r+=O.sep)):(r=(0,A.$ue)(r,O.sep),r||(r=O.sep)),r}e.$Jf=l;function w(r){const a=(0,O.$6d)(r);return N.$i?r.length>3?!1:m(a)&&(r.length===2||a.charCodeAt(2)===92):a===O.$5d.sep}e.$Kf=w;function m(r,a=N.$i){return a?o(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$Lf=m;function I(r,a=N.$i){return m(r,a)?r[0]:void 0}e.$Mf=I;function i(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$Nf=i;function c(r){const a=r.split(":");let v,b,u;for(const p of a){const D=Number(p);(0,L.$mf)(D)?b===void 0?b=D:u===void 0&&(u=D):v=v?[v,p].join(":"):p}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:b!==void 0?b:void 0,column:u!==void 0?u:b!==void 0?1:void 0}}e.$Of=c;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let b="";for(let p=0;p<v;p++){let D;p===0&&N.$i&&!a&&(v===3||v===4)?D=s:D=n,b+=D.charAt(Math.floor(Math.random()*D.length))}let u;return a?u=`${a}-${b}`:u=b,r?(0,O.$8d)(r,u):u}e.$Pf=t}),define(re[141],oe([0,1,16]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=e.$Hr=e.$Gr=void 0,e.$Gr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(C){const E=(0,O.$ae)(C),d=N[E.toLowerCase()];return d!==void 0?d:j(C)}e.$Hr=L;function j(C){const E=(0,O.$ae)(C);return A[E.toLowerCase()]}e.$Ir=j;function R(C){for(const E in A)if(A[E]===C)return E}e.$Jr=R;const k=/^(.+)\/(.+?)(;.+)?$/;function $(C,E){const d=k.exec(C);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:E?void 0:C}e.$Kr=$}),define(re[90],oe([0,1,6]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.TerminateResponseCode=e.Source=void 0;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var A;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function L(R,...k){const $=k.reduce((d,h)=>(d[h]=!0,d),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(d=>!$[d]).forEach(d=>{for(let h=0;h<C.length;h++)if(d.search(C[h])!==-1){delete R[d];break}})}e.$rl=L;function j(R){R&&(delete R.DEBUG,O.$j&&delete R.DYLD_LIBRARY_PATH,O.$k&&delete R.LD_PRELOAD)}e.$sl=j}),define(re[11],oe([0,1,16,6]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,L=/^\//,j=/^\/\//;function R(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(s,t){return!s&&!t?"file":s}function $(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const C="",E="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(t){return t instanceof h?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,b,u=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=k(t,u),this.authority=r||C,this.path=$(this.scheme,a||C),this.query=v||C,this.fragment=b||C,R(this,u))}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:b,fragment:u}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),v===void 0?v=this.path:v===null&&(v=C),b===void 0?b=this.query:b===null&&(b=C),u===void 0?u=this.fragment:u===null&&(u=C),r===this.scheme&&a===this.authority&&v===this.path&&b===this.query&&u===this.fragment?this:new f(r,a,v,b,u)}static parse(t,r=!1){const a=d.exec(t);return a?new f(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new f(C,C,C,C,C)}static file(t){let r=C;if(N.$i&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const a=t.indexOf(E,2);a===-1?(r=t.substring(2),t=E):(r=t.substring(2,a),t=t.substring(a)||E)}return new f("file",r,t,C,C)}static from(t,r){return new f(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&t.scheme==="file"?a=h.file(O.$4d.join(m(t,!0),...r)).path:a=O.$5d.join(t.path,...r),t.with({path:a})}toString(t=!1){return I(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof h)return t;{const r=new f(t);return r._formatted=t.external??null,r._fsPath=t._sep===y?t.fsPath??null:null,r}}else return t}}e.URI=h;function g(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$Rf=g;const y=N.$i?1:void 0;class f extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=y),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function l(s,t,r){let a,v=-1;for(let b=0;b<s.length;b++){const u=s.charCodeAt(b);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47||r&&u===91||r&&u===93||r&&u===58)v!==-1&&(a+=encodeURIComponent(s.substring(v,b)),v=-1),a!==void 0&&(a+=s.charAt(b));else{a===void 0&&(a=s.substr(0,b));const p=o[u];p!==void 0?(v!==-1&&(a+=encodeURIComponent(s.substring(v,b)),v=-1),a+=p):v===-1&&(v=b)}}return v!==-1&&(a+=encodeURIComponent(s.substring(v))),a!==void 0?a:s}function w(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=o[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function m(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,N.$i&&(r=r.replace(/\//g,"\\")),r}e.$Sf=m;function I(s,t){const r=t?w:l;let a="",{scheme:v,authority:b,path:u,query:p,fragment:D}=s;if(v&&(a+=v,a+=":"),(b||v==="file")&&(a+=E,a+=E),b){let F=b.indexOf("@");if(F!==-1){const z=b.substr(0,F);b=b.substr(F+1),F=z.lastIndexOf(":"),F===-1?a+=r(z,!1,!1):(a+=r(z.substr(0,F),!1,!1),a+=":",a+=r(z.substr(F+1),!1,!0)),a+="@"}b=b.toLowerCase(),F=b.lastIndexOf(":"),F===-1?a+=r(b,!1,!0):(a+=r(b.substr(0,F),!1,!0),a+=b.substr(F))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const F=u.charCodeAt(1);F>=65&&F<=90&&(u=`/${String.fromCharCode(F+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const F=u.charCodeAt(0);F>=65&&F<=90&&(u=`${String.fromCharCode(F+32)}:${u.substr(2)}`)}a+=r(u,!0,!1)}return p&&(a+="?",a+=r(p,!1,!1)),D&&(a+="#",a+=t?D:l(D,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(c)?s.replace(c,t=>i(t)):s}}),define(re[142],oe([0,1,11]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Op=e.$Np=e.$Mp=void 0;function N($){const C=$;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$Mp=N;function A($){const C=[];let E;try{const d=JSON.parse($.arguments),h=d[d.length-1];h&&h.__$stack&&(d.pop(),E=h.__$stack),C.push(...d)}catch{C.push("Unable to log remote console arguments",$.arguments)}return{args:C,stack:E}}e.$Np=A;function L($){if(typeof $!="string")return L(A($).stack);const C=$;if(C){const E=j(C),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:O.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$Op=L;function j($){if(!$)return $;const C=$.indexOf(`
`);return C===-1?$:$.substring(0,C)}function R($,C){const{args:E,stack:d}=A($),h=typeof E[0]=="string"&&E.length===1;let g=j(d);g&&(g=`(${g.trim()})`);let y=[];if(typeof E[0]=="string"?g&&h?y=[`%c[${C}] %c${E[0]} %c${g}`,k("blue"),k(""),k("grey")]:y=[`%c[${C}] %c${E[0]}`,k("blue"),k(""),...E.slice(1)]:y=[`%c[${C}]%`,k("blue"),...E],g&&!h&&y.push(g),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,y)}e.log=R;function k($){return`color: ${$}`}}),define(re[63],oe([0,1,14,11]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=e.$9g=e.$8g=void 0;function A(k){return JSON.stringify(k,j)}e.$8g=A;function L(k){let $=JSON.parse(k);return $=R($),$}e.$9g=L;function j(k,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function R(k,$=0){if(!k||$>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return N.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof O.$Ed||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=R(k[C],$+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=R(k[C],$+1))}return k}e.$0g=R}),define(re[23],oe([0,1,8,6,11]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.Schemas=void 0;var L;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Tf="vscode-tkn",e.$Uf="tkn";class j{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${L.vscodeRemoteResource}`}set(C,E,d){this.a[C]=E,this.b[C]=d}setConnectionToken(C,E){this.c[C]=E}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(f){return O.$Y(f),C}const E=C.authority;let d=this.a[E];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const h=this.b[E],g=this.c[E];let y=`path=${encodeURIComponent(C.path)}`;return typeof g=="string"&&(y+=`&${e.$Uf}=${encodeURIComponent(g)}`),A.URI.from({scheme:N.$o?this.d:L.vscodeRemoteResource,authority:`${d}:${h}`,path:this.f,query:y})}}e.$Vf=new j,e.$Wf="vs/../../extensions",e.$Xf="vs/../../node_modules",e.$Yf="vs/../../node_modules.asar",e.$Zf="vs/../../node_modules.asar.unpacked";class R{static{this.a="vscode-app"}asBrowserUri(C){const E=this.b(C,te);return this.uriToBrowserUri(E)}uriToBrowserUri(C){return C.scheme===L.vscodeRemote?e.$Vf.rewrite(C):C.scheme===L.file&&(N.$m||N.$p&&N.$g.origin===`${L.vscodeFileResource}://${R.a}`)?C.with({scheme:L.vscodeFileResource,authority:C.authority||R.a,query:null,fragment:null}):C}asFileUri(C){const E=this.b(C,te);return this.uriToFileUri(E)}uriToFileUri(C){return C.scheme===L.vscodeFileResource?C.with({scheme:L.file,authority:C.authority!==R.a?C.authority:null,query:null,fragment:null}):C}b(C,E){return A.URI.isUri(C)?C:A.URI.parse(E.toUrl(C))}}e.$1f=new R;var k;(function($){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(C.get("3"));const E="vscode-coi";function d(g){let y;typeof g=="string"?y=new URL(g).searchParams:g instanceof URL?y=g.searchParams:A.URI.isUri(g)&&(y=new URL(g.toString(!0)).searchParams);const f=y?.get(E);if(f)return C.get(f)}$.getHeadersFromQuery=d;function h(g,y,f){if(!globalThis.crossOriginIsolated)return;const o=y&&f?"3":f?"2":"1";g instanceof URLSearchParams?g.set(E,o):g[E]=o}$.addSearchParam=h})(k||(e.COI=k={}))}),define(re[143],oe([0,1,124,23,6,11]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=void 0;class j{constructor(d,h,g){this.id=d,this.dependencies=h,this.callback=g}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,h,g)=>{typeof d!="string"&&(g=h,h=d,d=null),(typeof h!="object"||!Array.isArray(h))&&(g=h,h=null),this.c.push(new j(d,h,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const h=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!h)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(d){return new Promise((h,g)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const f=()=>{y.removeEventListener("load",o),y.removeEventListener("error",l)},o=w=>{f(),h(this.c.pop())},l=w=>{f(),g(w)};y.addEventListener("load",o),y.addEventListener("error",l),this.f&&(d=this.f.createScriptURL(d)),y.setAttribute("src",d),document.getElementsByTagName("head")[0].appendChild(y)})}i(d){return new Promise((h,g)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),h(this.c.pop())}catch(y){g(y)}})}async j(d){try{const h=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,f=L.URI.parse(d).fsPath,o=h.readFileSync(f).toString(),l=y.wrap(o.replace(/^#!.*/,""));return new g.Script(l).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const k=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function C(E,d,h){if(O.$R){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[E]&&(E=$[E]);const g=`${E}/${d}`;if(k.has(g))return k.get(g);let y;if(/^\w[\w\d+.-]*:\/\//.test(g))y=g;else{const w=`${h&&!A.$o?N.$Yf:N.$Xf}/${g}`;y=N.$1f.asBrowserUri(w).toString(!0)}const f=R.INSTANCE.load(y);return k.set(g,f),f}else return await new Promise((g,y)=>{te([E],g,y)})}e.$_C=C}),define(re[21],oe([0,1,48,23,16,6,27,11]),function(te,e,O,N,A,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.DataUri=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=void 0;function k(h){return(0,R.$Sf)(h,!0)}e.$8f=k;class ${constructor(g){this.a=g}compare(g,y,f=!1){return g===y?0:(0,j.$Ee)(this.getComparisonKey(g,f),this.getComparisonKey(y,f))}isEqual(g,y,f=!1){return g===y?!0:!g||!y?!1:this.getComparisonKey(g,f)===this.getComparisonKey(y,f)}getComparisonKey(g,y=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,y,f=!1){if(g.scheme===y.scheme){if(g.scheme===N.Schemas.file)return O.$Hf(k(g),k(y),this.a(g))&&g.query===y.query&&(f||g.fragment===y.fragment);if((0,e.$mg)(g.authority,y.authority))return O.$Hf(g.path,y.path,this.a(g),"/")&&g.query===y.query&&(f||g.fragment===y.fragment)}return!1}joinPath(g,...y){return R.URI.joinPath(g,...y)}basenameOrAuthority(g){return(0,e.$eg)(g)||g.authority}basename(g){return A.$5d.basename(g.path)}extname(g){return A.$5d.extname(g.path)}dirname(g){if(g.path.length===0)return g;let y;return g.scheme===N.Schemas.file?y=R.URI.file(A.$$d(k(g))).path:(y=A.$5d.dirname(g.path),g.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),y="/")),g.with({path:y})}normalizePath(g){if(!g.path.length)return g;let y;return g.scheme===N.Schemas.file?y=R.URI.file(A.$6d(k(g))).path:y=A.$5d.normalize(g.path),g.with({path:y})}relativePath(g,y){if(g.scheme!==y.scheme||!(0,e.$mg)(g.authority,y.authority))return;if(g.scheme===N.Schemas.file){const l=A.$0d(k(g),k(y));return L.$i?O.$Bf(l):l}let f=g.path||"/";const o=y.path||"/";if(this.a(g)){let l=0;for(const w=Math.min(f.length,o.length);l<w&&!(f.charCodeAt(l)!==o.charCodeAt(l)&&f.charAt(l).toLowerCase()!==o.charAt(l).toLowerCase());l++);f=o.substr(0,l)+f.substr(l)}return A.$5d.relative(f,o)}resolvePath(g,y){if(g.scheme===N.Schemas.file){const f=R.URI.file(A.$9d(k(g),y));return g.with({authority:f.authority,path:f.path})}return y=O.$Cf(y),g.with({path:A.$5d.resolve(g.path,y)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,y){return g===y||g!==void 0&&y!==void 0&&(0,j.$Le)(g,y)}hasTrailingPathSeparator(g,y=A.sep){if(g.scheme===N.Schemas.file){const f=k(g);return f.length>O.$Df(f).length&&f[f.length-1]===y}else{const f=g.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,y=A.sep){return(0,e.$ng)(g,y)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,y=A.sep){let f=!1;if(g.scheme===N.Schemas.file){const o=k(g);f=o!==void 0&&o.length===O.$Df(o).length&&o[o.length-1]===y}else{y="/";const o=g.path;f=o.length===1&&o.charCodeAt(o.length-1)===47}return!f&&!(0,e.$ng)(g,y)?g.with({path:g.path+"/"}):g}}e.$9f=$,e.$0f=new $(()=>!1),e.$$f=new $(h=>h.scheme===N.Schemas.file?!L.$k:!0),e.$_f=new $(h=>!0),e.$ag=e.$0f.isEqual.bind(e.$0f),e.$bg=e.$0f.isEqualOrParent.bind(e.$0f),e.$cg=e.$0f.getComparisonKey.bind(e.$0f),e.$dg=e.$0f.basenameOrAuthority.bind(e.$0f),e.$eg=e.$0f.basename.bind(e.$0f),e.$fg=e.$0f.extname.bind(e.$0f),e.$gg=e.$0f.dirname.bind(e.$0f),e.$hg=e.$0f.joinPath.bind(e.$0f),e.$ig=e.$0f.normalizePath.bind(e.$0f),e.$jg=e.$0f.relativePath.bind(e.$0f),e.$kg=e.$0f.resolvePath.bind(e.$0f),e.$lg=e.$0f.isAbsolutePath.bind(e.$0f),e.$mg=e.$0f.isEqualAuthority.bind(e.$0f),e.$ng=e.$0f.hasTrailingPathSeparator.bind(e.$0f),e.$og=e.$0f.removeTrailingPathSeparator.bind(e.$0f),e.$pg=e.$0f.addTrailingPathSeparator.bind(e.$0f);function C(h,g){const y=[];for(let f=0;f<h.length;f++){const o=g(h[f]);h.some((l,w)=>w===f?!1:(0,e.$bg)(o,g(l)))||y.push(h[f])}return y}e.$qg=C;var E;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function g(y){const f=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(w=>{const[m,I]=w.split(":");m&&I&&f.set(m,I)});const l=y.path.substring(0,y.path.indexOf(";"));return l&&f.set(h.META_DATA_MIME,l),f}h.parseMetaData=g})(E||(e.DataUri=E={}));function d(h,g,y){if(g){let f=h.path;return f&&f[0]!==A.$5d.sep&&(f=A.$5d.sep+f),h.with({scheme:y,authority:g,path:f})}return h.with({scheme:y})}e.$rg=d}),define(re[5],oe([0,1,26,8,3,2,21,6,130]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.$3g=e.$2g=e.Promises=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function $(S){return!!S&&typeof S.then=="function"}e.$sg=$;function C(S){const P=new O.$od,M=S(P.token),T=new Promise((K,_)=>{const ae=P.token.onCancellationRequested(()=>{ae.dispose(),P.dispose(),_(new N.$3)});Promise.resolve(M).then(he=>{ae.dispose(),P.dispose(),K(he)},he=>{ae.dispose(),P.dispose(),_(he)})});return new class{cancel(){P.cancel()}then(K,_){return T.then(K,_)}catch(K){return this.then(void 0,K)}finally(K){return T.finally(K)}}}e.$tg=C;function E(S,P,M){return new Promise((T,K)=>{const _=P.onCancellationRequested(()=>{_.dispose(),T(M)});S.then(T,K).finally(()=>_.dispose())})}e.$ug=E;function d(S,P){return new Promise((M,T)=>{const K=P.onCancellationRequested(()=>{K.dispose(),T(new N.$3)});S.then(M,T).finally(()=>K.dispose())})}e.$vg=d;async function h(S){let P=-1;const M=S.map((T,K)=>T.then(_=>(P=K,_)));try{return await Promise.race(M)}finally{S.forEach((T,K)=>{K!==P&&T.cancel()})}}e.$wg=h;function g(S,P,M){let T;const K=setTimeout(()=>{T?.(void 0),M?.()},P);return Promise.race([S.finally(()=>clearTimeout(K)),new Promise(_=>T=_)])}e.$xg=g;function y(S){return new Promise((P,M)=>{const T=S();$(T)?T.then(P,M):P(T)})}e.$yg=y;class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(P){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=P,!this.b){const M=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(M,M).then(T)})}return new Promise((M,T)=>{this.b.then(M,T)})}return this.a=P(),new Promise((M,T)=>{this.a.then(K=>{this.a=null,M(K)},K=>{this.a=null,T(K)})})}dispose(){this.f=!0}}e.$zg=f;class o{constructor(){this.a=Promise.resolve(null)}queue(P){return this.a=this.a.then(()=>P(),()=>P())}}e.$Ag=o;class l{constructor(){this.a=new Map}queue(P,M){const K=(this.a.get(P)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(P)===K&&this.a.delete(P)});return this.a.set(P,K),K}}e.$Bg=l;const w=(S,P)=>{let M=!0;const T=setTimeout(()=>{M=!1,P()},S);return{isTriggered:()=>M,dispose:()=>{clearTimeout(T),M=!1}}},m=S=>{let P=!0;return queueMicrotask(()=>{P&&(P=!1,S())}),{isTriggered:()=>P,dispose:()=>{P=!1}}};class I{constructor(P){this.defaultDelay=P,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(P,M=this.defaultDelay){this.g=P,this.h(),this.b||(this.b=new Promise((K,_)=>{this.d=K,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const K=this.g;return this.g=null,K()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=M===k.$bd?m(T):w(M,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Cg=I;class i{constructor(P){this.a=new I(P),this.b=new f}trigger(P,M){return this.a.trigger(()=>this.b.queue(P),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dg=i;class c{constructor(){this.a=!1,this.b=new Promise((P,M)=>{this.d=P})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eg=c;class n extends c{constructor(P){super(),this.f=setTimeout(()=>this.open(),P)}open(){clearTimeout(this.f),super.open()}}e.$Fg=n;function s(S,P){return P?new Promise((M,T)=>{const K=setTimeout(()=>{_.dispose(),M()},S),_=P.onCancellationRequested(()=>{clearTimeout(K),_.dispose(),T(new N.$3)})}):C(M=>s(S,M))}e.$Gg=s;function t(S,P=0){const M=setTimeout(S,P);return(0,L.$hc)(()=>clearTimeout(M))}e.$Hg=t;function r(S){const P=[];let M=0;const T=S.length;function K(){return M<T?S[M++]():null}function _(ae){ae!=null&&P.push(ae);const he=K();return he?he.then(_):Promise.resolve(P)}return Promise.resolve(null).then(_)}e.$Ig=r;function a(S,P=T=>!!T,M=null){let T=0;const K=S.length,_=()=>{if(T>=K)return Promise.resolve(M);const ae=S[T++];return Promise.resolve(ae()).then(fe=>P(fe)?Promise.resolve(fe):_())};return _()}e.$Jg=a;function v(S,P=T=>!!T,M=null){if(S.length===0)return Promise.resolve(M);let T=S.length;const K=()=>{T=-1;for(const _ of S)_.cancel?.()};return new Promise((_,ae)=>{for(const he of S)he.then(fe=>{--T>=0&&P(fe)?(K(),_(fe)):T===0&&_(M)}).catch(fe=>{--T>=0&&(K(),ae(fe))})})}e.$Kg=v;class b{constructor(P){this.a=0,this.d=P,this.f=[],this.b=0,this.g=new A.$ed}get onDrained(){return this.g.event}get size(){return this.a}queue(P){return this.a++,new Promise((M,T)=>{this.f.push({factory:P,c:M,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const P=this.f.shift();this.b++;const M=P.factory();M.then(P.c,P.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Lg=b;class u extends b{constructor(){super(1)}}e.$Mg=u;class p{constructor(){this.a=new Z,this.b=0}queue(P){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,P())):this.a.run(this.b++,P())}}e.$Ng=p;class D{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const P=new V;return this.b.add(P),P.p}g(){for(const[,P]of this.a)if(P.size>0)return!1;return!0}queueFor(P,M=j.$0f){const T=M.getComparisonKey(P);let K=this.a.get(T);if(!K){K=new u;const _=this.f++,ae=A.Event.once(K.onDrained)(()=>{K?.dispose(),this.a.delete(T),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$rc),this.d.set(_,ae),this.a.set(T,K)}return K}h(){this.g()&&this.j()}j(){for(const P of this.b)P.complete();this.b.clear()}dispose(){for(const[,P]of this.a)P.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Og=D;class F{constructor(P,M){this.a=-1,typeof P=="function"&&typeof M=="number"&&this.setIfNotSet(P,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(P,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,P()},M)}setIfNotSet(P,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,P()},M))}}e.$Pg=F;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(P,M){this.cancel(),this.a=setInterval(()=>{P()},M)}}e.$Qg=z;class U{constructor(P,M){this.b=-1,this.a=P,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(P=this.d){this.cancel(),this.b=setTimeout(this.f,P)}get delay(){return this.d}set delay(P){this.d=P}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rg=U;class B{constructor(P,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=P,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(P=this.b){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(P/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sg=B;class x extends U{constructor(P,M){super(P,M),this.j=[]}work(P){this.j.push(P),this.isScheduled()||this.schedule()}h(){const P=this.j;this.j=[],this.a?.(P)}dispose(){this.j=[],super.dispose()}}e.$Tg=x;class J extends L.$jc{constructor(P,M){super(),this.g=P,this.h=M,this.a=[],this.b=this.B(new L.$kc),this.f=!1}get pending(){return this.a.length}work(P){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+P.length>this.g.maxBufferedWork)return!1}else if(this.pending+P.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of P)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ug=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Vg=S=>{(0,R.$A)(()=>{if(P)return;const M=Date.now()+15;S(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let P=!1;return{dispose(){P||(P=!0)}}}:e.$Vg=(S,P)=>{const M=requestIdleCallback(S,typeof P=="number"?{timeout:P}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(M))}}}}();class Q{constructor(P){this.d=!1,this.a=()=>{try{this.f=P()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.$Vg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Wg=Q;async function W(S,P,M){let T;for(let K=0;K<M;K++)try{return await S()}catch(_){T=_,await s(P)}throw T}e.$Xg=W;class Z{isRunning(P){return typeof P=="number"?this.a?.taskId===P:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(P,M,T){return this.a={taskId:P,cancel:()=>T?.(),promise:M},M.then(()=>this.d(P),()=>this.d(P)),M}d(P){this.a&&P===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const P=this.b;this.b=void 0,P.run().then(P.promiseResolve,P.promiseReject)}}queue(P){if(this.b)this.b.run=P;else{let M,T;const K=new Promise((_,ae)=>{M=_,T=ae});this.b={run:P,promise:K,promiseResolve:M,promiseReject:T}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yg=Z;class G{constructor(P,M=()=>Date.now()){this.d=P,this.f=M,this.a=0,this.b=0}increment(){const P=this.f();return P-this.a>this.d&&(this.a=P,this.b=0),this.b++,this.b}}e.$Zg=G;var H;(function(S){S[S.Resolved=0]="Resolved",S[S.Rejected=1]="Rejected"})(H||(H={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((P,M)=>{this.a=P,this.b=M})}complete(P){return new Promise(M=>{this.a(P),this.d={outcome:0,value:P},M()})}error(P){return new Promise(M=>{this.b(P),this.d={outcome:1,value:P},M()})}cancel(){return this.error(new N.$3)}}e.$1g=V;var ee;(function(S){async function P(T){let K;const _=await Promise.all(T.map(ae=>ae.then(he=>he,he=>{K||(K=he)})));if(typeof K<"u")throw K;return _}S.settled=P;function M(T){return new Promise(async(K,_)=>{try{await T(K,_)}catch(ae){_(ae)}})}S.withAsyncBody=M})(ee||(e.Promises=ee={}));var ne;(function(S){S[S.Initial=0]="Initial",S[S.DoneOK=1]="DoneOK",S[S.DoneError=2]="DoneError"})(ne||(ne={}));class se{static fromArray(P){return new se(M=>{M.emitMany(P)})}static fromPromise(P){return new se(async M=>{M.emitMany(await P)})}static fromPromises(P){return new se(async M=>{await Promise.all(P.map(async T=>M.emitOne(await T)))})}static merge(P){return new se(async M=>{await Promise.all(P.map(async T=>{for await(const K of T)M.emitOne(K)}))})}static{this.EMPTY=se.fromArray([])}constructor(P){this.a=0,this.b=[],this.d=null,this.f=new A.$ed,queueMicrotask(async()=>{const M={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(P(M)),this.j()}catch(T){this.k(T)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let P=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(P<this.b.length)return{done:!1,value:this.b[P++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(P,M){return new se(async T=>{for await(const K of P)T.emitOne(M(K))})}map(P){return se.map(this,P)}static filter(P,M){return new se(async T=>{for await(const K of P)M(K)&&T.emitOne(K)})}filter(P){return se.filter(this,P)}static coalesce(P){return se.filter(P,M=>!!M)}coalesce(){return se.coalesce(this)}static async toPromise(P){const M=[];for await(const T of P)M.push(T);return M}toPromise(){return se.toPromise(this)}g(P){this.a===0&&(this.b.push(P),this.f.fire())}h(P){this.a===0&&(this.b=this.b.concat(P),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(P){this.a===0&&(this.a=2,this.d=P,this.f.fire())}}e.$2g=se;class Y extends se{constructor(P,M){super(M),this.l=P}cancel(){this.l.cancel()}}e.$3g=Y;function q(S){const P=new O.$od,M=S(P.token);return new Y(P,async T=>{const K=P.token.onCancellationRequested(()=>{K.dispose(),P.dispose(),T.reject(new N.$3)});try{for await(const _ of M){if(P.token.isCancellationRequested)return;T.emitOne(_)}K.dispose(),P.dispose()}catch(_){K.dispose(),P.dispose(),T.reject(_)}})}e.$4g=q}),define(re[91],oe([0,1,18,5,48,35,16,6,27]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0;function $(){return Object.create(null)}e.$lj=$,e.$mj="**",e.$nj="/";const C="[/\\\\]",E="[^/\\\\]",d=/\//g;function h(Z,G){switch(Z){case 0:return"";case 1:return`${E}*?`;default:return`(?:${C}|${E}+${C}${G?`|${C}${E}+`:""})*?`}}function g(Z,G){if(!Z)return[];const H=[];let V=!1,ee=!1,ne="";for(const se of Z){switch(se){case G:if(!V&&!ee){H.push(ne),ne="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ne+=se}return ne&&H.push(ne),H}e.$oj=g;function y(Z){if(!Z)return"";let G="";const H=g(Z,e.$nj);if(H.every(V=>V===e.$mj))G=".*";else{let V=!1;H.forEach((ee,ne)=>{if(ee===e.$mj){if(V)return;G+=h(2,ne===H.length-1)}else{let se=!1,Y="",q=!1,S="";for(const P of ee){if(P!=="}"&&se){Y+=P;continue}if(q&&(P!=="]"||!S)){let M;P==="-"?M=P:(P==="^"||P==="!")&&!S?M="^":P===e.$nj?M="":M=(0,k.$pe)(P),S+=M;continue}switch(P){case"{":se=!0;continue;case"[":q=!0;continue;case"}":{const T=`(?:${g(Y,",").map(K=>y(K)).join("|")})`;G+=T,se=!1,Y="";break}case"]":{G+="["+S+"]",q=!1,S="";break}case"?":G+=E;continue;case"*":G+=h(1);continue;default:G+=(0,k.$pe)(P)}}ne<H.length-1&&(H[ne+1]!==e.$mj||ne+2<H.length)&&(G+=C)}V=ee===e.$mj})}return G}const f=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Bi(1e4),c=function(){return!1},n=function(){return null};function s(Z,G){if(!Z)return n;let H;typeof Z!="string"?H=Z.pattern:H=Z,H=H.trim();const V=`${H}_${!!G.trimForExclusions}`;let ee=i.get(V);if(ee)return t(ee,Z);let ne;return f.test(H)?ee=a(H.substr(4),H):(ne=o.exec(r(H,G)))?ee=v(ne[1],H):(G.trimForExclusions?w:l).test(H)?ee=b(H,G):(ne=m.exec(r(H,G)))?ee=u(ne[1].substr(1),H,!0):(ne=I.exec(r(H,G)))?ee=u(ne[1],H,!1):ee=p(H),i.set(V,ee),t(ee,Z)}function t(Z,G){if(typeof G=="string")return Z;const H=function(V,ee){return(0,A.$Hf)(V,G.base,!R.$k)?Z((0,k.$te)(V.substr(G.base.length),j.sep),ee):null};return H.allBasenames=Z.allBasenames,H.allPaths=Z.allPaths,H.basenames=Z.basenames,H.patterns=Z.patterns,H}function r(Z,G){return G.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function a(Z,G){return function(H,V){return typeof H=="string"&&H.endsWith(Z)?G:null}}function v(Z,G){const H=`/${Z}`,V=`\\${Z}`,ee=function(se,Y){return typeof se!="string"?null:Y?Y===Z?G:null:se===Z||se.endsWith(H)||se.endsWith(V)?G:null},ne=[Z];return ee.basenames=ne,ee.patterns=[G],ee.allBasenames=ne,ee}function b(Z,G){const H=Q(Z.slice(1,-1).split(",").map(Y=>s(Y,G)).filter(Y=>Y!==n),Z),V=H.length;if(!V)return n;if(V===1)return H[0];const ee=function(Y,q){for(let S=0,P=H.length;S<P;S++)if(H[S](Y,q))return Z;return null},ne=H.find(Y=>!!Y.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const se=H.reduce((Y,q)=>q.allPaths?Y.concat(q.allPaths):Y,[]);return se.length&&(ee.allPaths=se),ee}function u(Z,G,H){const V=j.sep===j.$5d.sep,ee=V?Z:Z.replace(d,j.sep),ne=j.sep+ee,se=j.$5d.sep+Z;let Y;return H?Y=function(q,S){return typeof q=="string"&&(q===ee||q.endsWith(ne)||!V&&(q===Z||q.endsWith(se)))?G:null}:Y=function(q,S){return typeof q=="string"&&(q===ee||!V&&q===Z)?G:null},Y.allPaths=[(H?"*/":"./")+Z],Y}function p(Z){try{const G=new RegExp(`^${y(Z)}$`);return function(H){return G.lastIndex=0,typeof H=="string"&&G.test(H)?Z:null}}catch{return n}}function D(Z,G,H){return!Z||typeof G!="string"?!1:F(Z)(G,void 0,H)}e.$pj=D;function F(Z,G={}){if(!Z)return c;if(typeof Z=="string"||z(Z)){const H=s(Z,G);if(H===n)return c;const V=function(ee,ne){return!!H(ee,ne)};return H.allBasenames&&(V.allBasenames=H.allBasenames),H.allPaths&&(V.allPaths=H.allPaths),V}return x(Z,G)}e.$qj=F;function z(Z){const G=Z;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}e.$rj=z;function U(Z){return Z.allBasenames||[]}e.$sj=U;function B(Z){return Z.allPaths||[]}e.$tj=B;function x(Z,G){const H=Q(Object.getOwnPropertyNames(Z).map(Y=>J(Y,Z[Y],G)).filter(Y=>Y!==n)),V=H.length;if(!V)return n;if(!H.some(Y=>!!Y.requiresSiblings)){if(V===1)return H[0];const Y=function(P,M){let T;for(let K=0,_=H.length;K<_;K++){const ae=H[K](P,M);if(typeof ae=="string")return ae;(0,N.$sg)(ae)&&(T||(T=[]),T.push(ae))}return T?(async()=>{for(const K of T){const _=await K;if(typeof _=="string")return _}return null})():null},q=H.find(P=>!!P.allBasenames);q&&(Y.allBasenames=q.allBasenames);const S=H.reduce((P,M)=>M.allPaths?P.concat(M.allPaths):P,[]);return S.length&&(Y.allPaths=S),Y}const ee=function(Y,q,S){let P,M;for(let T=0,K=H.length;T<K;T++){const _=H[T];_.requiresSiblings&&S&&(q||(q=(0,j.$_d)(Y)),P||(P=q.substr(0,q.length-(0,j.$ae)(Y).length)));const ae=_(Y,q,P,S);if(typeof ae=="string")return ae;(0,N.$sg)(ae)&&(M||(M=[]),M.push(ae))}return M?(async()=>{for(const T of M){const K=await T;if(typeof K=="string")return K}return null})():null},ne=H.find(Y=>!!Y.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const se=H.reduce((Y,q)=>q.allPaths?Y.concat(q.allPaths):Y,[]);return se.length&&(ee.allPaths=se),ee}function J(Z,G,H){if(G===!1)return n;const V=s(Z,H);if(V===n)return n;if(typeof G=="boolean")return V;if(G){const ee=G.when;if(typeof ee=="string"){const ne=(se,Y,q,S)=>{if(!S||!V(se,Y))return null;const P=ee.replace("$(basename)",()=>q),M=S(P);return(0,N.$sg)(M)?M.then(T=>T?Z:null):M?Z:null};return ne.requiresSiblings=!0,ne}}return V}function Q(Z,G){const H=Z.filter(Y=>!!Y.basenames);if(H.length<2)return Z;const V=H.reduce((Y,q)=>{const S=q.basenames;return S?Y.concat(S):Y},[]);let ee;if(G){ee=[];for(let Y=0,q=V.length;Y<q;Y++)ee.push(G)}else ee=H.reduce((Y,q)=>{const S=q.patterns;return S?Y.concat(S):Y},[]);const ne=function(Y,q){if(typeof Y!="string")return null;if(!q){let P;for(P=Y.length;P>0;P--){const M=Y.charCodeAt(P-1);if(M===47||M===92)break}q=Y.substr(P)}const S=V.indexOf(q);return S!==-1?ee[S]:null};ne.basenames=V,ne.patterns=ee,ne.allBasenames=V;const se=Z.filter(Y=>!Y.basenames);return se.push(ne),se}function W(Z,G){return(0,O.$sb)(Z,G,(H,V)=>typeof H=="string"&&typeof V=="string"?H===V:typeof H!="string"&&typeof V!="string"?H.base===V.base&&H.pattern===V.pattern:!1)}e.$uj=W}),define(re[92],oe([0,1,14,11]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0;function A(E){return E.toJSON()}class L{constructor(d){this.a=d}transformIncoming(d){const h=this.a.transformIncoming(d);return h===d?d:A(N.URI.from(h))}transformOutgoing(d){const h=this.a.transformOutgoing(d);return h===d?d:A(N.URI.from(h))}transformOutgoingURI(d){const h=this.a.transformOutgoing(d);return h===d?d:N.URI.from(h)}transformOutgoingScheme(d){return this.a.transformOutgoingScheme(d)}}e.$Am=L,e.$Bm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function j(E,d,h){if(!E||h>200)return null;if(typeof E=="object"){if(E instanceof N.URI)return d.transformOutgoing(E);for(const g in E)if(Object.hasOwnProperty.call(E,g)){const y=j(E[g],d,h+1);y!==null&&(E[g]=y)}}return null}function R(E,d){const h=j(E,d,0);return h===null?E:h}e.$Cm=R;function k(E,d,h,g){if(!E||g>200)return null;if(typeof E=="object"){if(E.$mid===1)return h?N.URI.revive(d.transformIncoming(E)):d.transformIncoming(E);if(E instanceof O.$Ed)return null;for(const y in E)if(Object.hasOwnProperty.call(E,y)){const f=k(E[y],d,h,g+1);f!==null&&(E[y]=f)}}return null}function $(E,d){const h=k(E,d,!1,0);return h===null?E:h}e.$Dm=$;function C(E,d){const h=k(E,d,!0,0);return h===null?E:h}e.$Em=C}),define(re[31],oe([0,1,52,36,269,5,48,88,16,6,21,11]),function(te,e,O,N,A,L,j,R,k,$,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var d;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function h(J,Q=d.UNLINK,W){if((0,j.$Kf)(J))throw new Error("rimraf - will refuse to recursively delete root");return Q===d.UNLINK?y(J):g(J,W)}async function g(J,Q=(0,j.$Pf)((0,N.tmpdir)())){try{try{await O.promises.rename(J,Q)}catch(W){return W.code==="ENOENT"?void 0:y(J)}y(Q).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function y(J){return(0,A.promisify)(O.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function f(J){if((0,j.$Kf)(J))throw new Error("rimraf - will refuse to recursively delete root");O.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=f;async function o(J,Q){return m(await(Q?l(J):(0,A.promisify)(O.readdir)(J)))}async function l(J){try{return await(0,A.promisify)(O.readdir)(J,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const Q=[],W=await o(J);for(const Z of W){let G=!1,H=!1,V=!1;try{const ee=await e.Promises.lstat((0,k.$8d)(J,Z));G=ee.isFile(),H=ee.isDirectory(),V=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Q.push({name:Z,isFile:()=>G,isDirectory:()=>H,isSymbolicLink:()=>V})}return Q}function w(J){return m(O.readdirSync(J))}e.readdirSync=w;function m(J){return J.map(Q=>typeof Q=="string"?$.$j?(0,R.$gl)(Q):Q:(Q.name=$.$j?(0,R.$gl)(Q.name):Q.name,Q))}async function I(J){const Q=await o(J),W=[];for(const Z of Q)await c.existsDirectory((0,k.$8d)(J,Z))&&W.push(Z);return W}function i(J,Q=1e3){return new Promise(W=>{let Z=!1;const G=setInterval(()=>{Z||(Z=!0,O.access(J,H=>{Z=!1,H&&(clearInterval(G),W(void 0))}))},Q)})}e.whenDeleted=i;var c;(function(J){async function Q(G){let H;try{if(H=await e.Promises.lstat(G),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if($.$i&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw ee}throw V}}J.stat=Q;async function W(G){try{const{stat:H,symbolicLink:V}=await J.stat(G);return H.isFile()&&V?.dangling!==!0}catch{}return!1}J.existsFile=W;async function Z(G){try{const{stat:H,symbolicLink:V}=await J.stat(G);return H.isDirectory()&&V?.dangling!==!0}catch{}return!1}J.existsDirectory=Z})(c||(e.SymlinkSupport=c={}));const n=new L.$Og;function s(J,Q,W){return n.queueFor(E.URI.file(J),C.$$f).queue(()=>{const Z=b(W);return new Promise((G,H)=>a(J,Q,Z,V=>V?H(V):G()))})}let t=!0;function r(J){t=J}e.configureFlushOnWrite=r;function a(J,Q,W,Z){if(!t)return O.writeFile(J,Q,{mode:W.mode,flag:W.flag},Z);O.open(J,W.flag,W.mode,(G,H)=>{if(G)return Z(G);O.writeFile(H,Q,V=>{if(V)return O.close(H,()=>Z(V));O.fdatasync(H,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),r(!1)),O.close(H,ne=>Z(ne))))})})}function v(J,Q,W){const Z=b(W);if(!t)return O.writeFileSync(J,Q,{mode:Z.mode,flag:Z.flag});const G=O.openSync(J,Z.flag,Z.mode);try{O.writeFileSync(G,Q);try{O.fdatasyncSync(G)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),r(!1)}}finally{O.closeSync(G)}}e.writeFileSync=v;function b(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function u(J,Q,W=6e4){if(J!==Q)try{$.$i&&typeof W=="number"?await p(J,Q,Date.now(),W):await(0,A.promisify)(O.rename)(J,Q)}catch(Z){if(J.toLowerCase()!==Q.toLowerCase()&&Z.code==="EXDEV"||J.endsWith("."))await D(J,Q,{preserveSymlinks:!1}),await h(J,d.MOVE);else throw Z}}async function p(J,Q,W,Z,G=0){try{return await(0,A.promisify)(O.rename)(J,Q)}catch(H){if(H.code!=="EACCES"&&H.code!=="EPERM"&&H.code!=="EBUSY")throw H;if(Date.now()-W>=Z)throw console.error(`[node.js fs] rename failed after ${G} retries with error: ${H}`),H;if(G===0){let V=!1;try{const{stat:ee}=await c.stat(Q);ee.isFile()||(V=!0)}catch{}if(V)throw H}return await(0,L.$Gg)(Math.min(100,G*10)),p(J,Q,W,Z,G+1)}}async function D(J,Q,W){return z(J,Q,{root:{source:J,target:Q},options:W,handledSourcePaths:new Set})}const F=511;async function z(J,Q,W){if(W.handledSourcePaths.has(J))return;W.handledSourcePaths.add(J);const{stat:Z,symbolicLink:G}=await c.stat(J);if(G){if(W.options.preserveSymlinks)try{return await x(J,Q,W)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(G.dangling)return}return Z.isDirectory()?U(J,Q,Z.mode&F,W):B(J,Q,Z.mode&F)}async function U(J,Q,W,Z){await e.Promises.mkdir(Q,{recursive:!0,mode:W});const G=await o(J);for(const H of G)await z((0,k.$8d)(J,H),(0,k.$8d)(Q,H),Z)}async function B(J,Q,W){await e.Promises.copyFile(J,Q),await e.Promises.chmod(Q,W)}async function x(J,Q,W){let Z=await e.Promises.readlink(J);(0,j.$Hf)(Z,W.root.source,!$.$k)&&(Z=(0,k.$8d)(W.root.target,Z.substr(W.root.source.length+1))),await e.Promises.symlink(Z,Q)}e.Promises=new class{get access(){return(0,A.promisify)(O.access)}get stat(){return(0,A.promisify)(O.stat)}get lstat(){return(0,A.promisify)(O.lstat)}get utimes(){return(0,A.promisify)(O.utimes)}get read(){return(J,Q,W,Z,G)=>new Promise((H,V)=>{O.read(J,Q,W,Z,G,(ee,ne,se)=>ee?V(ee):H({bytesRead:ne,buffer:se}))})}get readFile(){return(0,A.promisify)(O.readFile)}get write(){return(J,Q,W,Z,G)=>new Promise((H,V)=>{O.write(J,Q,W,Z,G,(ee,ne,se)=>ee?V(ee):H({bytesWritten:ne,buffer:se}))})}get appendFile(){return(0,A.promisify)(O.appendFile)}get fdatasync(){return(0,A.promisify)(O.fdatasync)}get truncate(){return(0,A.promisify)(O.truncate)}get copyFile(){return(0,A.promisify)(O.copyFile)}get open(){return(0,A.promisify)(O.open)}get close(){return(0,A.promisify)(O.close)}get symlink(){return(0,A.promisify)(O.symlink)}get readlink(){return(0,A.promisify)(O.readlink)}get chmod(){return(0,A.promisify)(O.chmod)}get mkdir(){return(0,A.promisify)(O.mkdir)}get unlink(){return(0,A.promisify)(O.unlink)}get rmdir(){return(0,A.promisify)(O.rmdir)}get realpath(){return(0,A.promisify)(O.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return I}get writeFile(){return s}get rm(){return h}get rename(){return u}get copy(){return D}}}),define(re[144],oe([0,1,52,16,6,27,31]),function(te,e,O,N,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.$Tp=void 0;function R(d){if(A.$k)return d;const h=(0,N.$$d)(d);if(d===h)return d;const g=((0,N.$_d)(d)||d).toLowerCase();try{const f=(0,j.readdirSync)(h).filter(o=>o.toLowerCase()===g);if(f.length===1){const o=R(h);if(o)return(0,N.$8d)(o,f[0])}else if(f.length>1){const o=f.indexOf(g);if(o>=0){const l=R(h);if(l)return(0,N.$8d)(l,f[o])}}}catch{}return null}e.$Tp=R;async function k(d){if(A.$k)return d;const h=(0,N.$$d)(d);if(d===h)return d;const g=((0,N.$_d)(d)||d).toLowerCase();try{const f=(await j.Promises.readdir(h)).filter(o=>o.toLowerCase()===g);if(f.length===1){const o=await k(h);if(o)return(0,N.$8d)(o,f[0])}else if(f.length>1){const o=f.indexOf(g);if(o>=0){const l=await k(h);if(l)return(0,N.$8d)(l,f[o])}}}catch{}return null}e.$Up=k;async function $(d){try{return await j.Promises.realpath(d)}catch{const g=E(d);return await j.Promises.access(g,O.constants.R_OK),g}}e.$Vp=$;function C(d){try{return O.realpathSync(d)}catch{const g=E(d);return O.accessSync(g,O.constants.R_OK),g}}e.$Wp=C;function E(d){return(0,L.$ue)((0,N.$6d)(d),N.sep)}}),define(re[145],oe([0,1,16,6,37,90,9,31]),function(te,e,O,N,A,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$ul=e.$tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function k(E=A.env){return E.comspec||"cmd.exe"}e.$tl=k;function $(E){let d=[],h=!1;const g=function(y){if(h){d.push(y);return}(!E.send(y,o=>{if(o&&console.error(o),h=!1,d.length>0){const l=d.slice(0);d=[],l.forEach(w=>g(w))}})||N.$i)&&(h=!0)};return{send:g}}e.$ul=$;var C;(function(E){async function d(h,g,y){if(O.$7d(h))return h;if(g===void 0&&(g=A.cwd()),O.$$d(h)!=="."||(y===void 0&&j.$if(A.env.PATH)&&(y=A.env.PATH.split(O.$fe)),y===void 0||y.length===0))return O.$8d(g,h);async function o(l){if(await R.Promises.exists(l)){let w;try{w=await R.Promises.stat(l)}catch(m){m.message.startsWith("EACCES")&&(w=await R.Promises.lstat(l))}return w?!w.isDirectory():!1}return!1}for(const l of y){let w;if(O.$7d(l)?w=O.$8d(l,h):w=O.$8d(g,l,h),await o(w))return w;let m=w+".com";if(await o(m)||(m=w+".exe",await o(m)))return m}return O.$8d(g,h)}E.findExecutable=d})(C||(e.win32=C={}))}),define(re[146],oe([0,1,64,23]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;function A(j){return new Promise((R,k)=>{let $;const C=new Map;function E(h,g,y,f,o){const l=C.get(g);if(h===j||l){const w={name:d(y),cmd:y,pid:h,ppid:g,load:f,mem:o};C.set(h,w),h===j&&($=w),l&&(l.children||(l.children=[]),l.children.push(w),l.children.length>1&&(l.children=l.children.sort((m,I)=>m.pid-I.pid)))}}function d(h){const g=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,f=/--crashes-directory/i,o=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(f.exec(h))return"electron-crash-reporter";if(o.exec(h))return"winpty-agent";if(l.exec(h))return"conpty-agent";let m=w.exec(h);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?g.exec(h)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const I=/[a-zA-Z-]+\.js/g;let i="";do m=I.exec(h),m&&(i+=m+" ");while(m);return i&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${i})`:y.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,y)=>{te(["@vscode/windows-process-tree"],g,y)}).then(g=>{g.getProcessList(j,y=>{if(!y){k(new Error(`Root process ${j} not found`));return}g.getProcessCpuUsage(y,f=>{const o=new Map;f.forEach(l=>{const w=h(l.commandLine||"");o.set(l.pid,{name:d(w),cmd:w,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),$=o.get(j),$?(o.forEach(l=>{const w=o.get(l.ppid);w&&(w.children||(w.children=[]),w.children.push(l))}),o.forEach(l=>{l.children&&(l.children=l.children.sort((w,m)=>w.pid-m.pid))}),R($)):k(new Error(`Root process ${j} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let h=function(){let g=[$];const y=[];for(;g.length;){const o=g.shift();o&&(y.push(o.pid),o.children&&(g=g.concat(o.children)))}let f=JSON.stringify(N.$1f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+y.join(" "),(0,O.exec)(f,{},(o,l,w)=>{if(o||w)k(o||new Error(w.toString()));else{const m=l.toString().split(`
`);for(let I=0;I<y.length;I++){const i=C.get(y[I]);i.load=parseFloat(m[I])}if(!$){k(new Error(`Root process ${j} not found`));return}R($)}})};(0,O.exec)("which ps",{},(g,y,f)=>{if(g||f)if(process.platform!=="linux")k(g||new Error(f.toString()));else{const o=JSON.stringify(N.$1f.asFileUri("vs/base/node/ps.sh").fsPath);(0,O.exec)(o,{},(l,w,m)=>{l||m?k(l||new Error(m.toString())):(L(w,E),h())})}else{const o=y.toString().trim(),l="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,O.exec)(`${o} ${l}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,m,I)=>{w||I&&!I.includes("screen size is bogus")?k(w||new Error(I.toString())):(L(m,E),process.platform==="linux"?h():$?R($):k(new Error(`Root process ${j} not found`)))})}})}})}e.$rr=A;function L(j,R){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,$=j.toString().split(`
`);for(const C of $){const E=k.exec(C.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var ye=this&&this.__decorate||function(te,e,O,N){var A=arguments.length,L=A<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,O):N,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(te,e,O,N);else for(var R=te.length-1;R>=0;R--)(j=te[R])&&(L=(A<3?j(L):A>3?j(e,O,L):j(e,O))||L);return A>3&&L&&Object.defineProperty(e,O,L),L};define(re[43],oe([0,1,18,5,14,26,83,8,3,2,63,27,9]),function(te,e,O,N,A,L,j,R,k,$,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.ProxyChannel=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.RequestInitiator=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=void 0;var h;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(h||(h={}));function g(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(y||(y={}));function f(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(o||(o={}));function l(G){let H=0;for(let V=0;;V+=7){const ee=G.read(1);if(H|=(ee.buffer[0]&127)<<V,!(ee.buffer[0]&128))return H}}const w=n(0);function m(G,H){if(H===0){G.write(w);return}let V=0;for(let ne=H;ne!==0;ne=ne>>>7)V++;const ee=A.$Ed.alloc(V);for(let ne=0;H!==0;ne++)ee.buffer[ne]=H&127,H=H>>>7,H>0&&(ee.buffer[ne]|=128);G.write(ee)}class I{constructor(H){this.b=H,this.a=0}read(H){const V=this.b.slice(this.a,this.a+H);return this.a+=V.byteLength,V}}e.$$g=I;class i{constructor(){this.a=[]}get buffer(){return A.$Ed.concat(this.a)}write(H){this.a.push(H)}}e.$_g=i;var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object",G[G.Int=6]="Int"})(c||(c={}));function n(G){const H=A.$Ed.alloc(1);return H.writeUInt8(G,0),H}const s={Undefined:n(c.Undefined),String:n(c.String),Buffer:n(c.Buffer),VSBuffer:n(c.VSBuffer),Array:n(c.Array),Object:n(c.Object),Uint:n(c.Int)},t=typeof Buffer<"u";function r(G,H){if(typeof H>"u")G.write(s.Undefined);else if(typeof H=="string"){const V=A.$Ed.fromString(H);G.write(s.String),m(G,V.byteLength),G.write(V)}else if(t&&Buffer.isBuffer(H)){const V=A.$Ed.wrap(H);G.write(s.Buffer),m(G,V.byteLength),G.write(V)}else if(H instanceof A.$Ed)G.write(s.VSBuffer),m(G,H.byteLength),G.write(H);else if(Array.isArray(H)){G.write(s.Array),m(G,H.length);for(const V of H)r(G,V)}else if(typeof H=="number"&&(H|0)===H)G.write(s.Uint),m(G,H);else{const V=A.$Ed.fromString(JSON.stringify(H));G.write(s.Object),m(G,V.byteLength),G.write(V)}}e.$ah=r;function a(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(l(G)).toString();case c.Buffer:return G.read(l(G)).buffer;case c.VSBuffer:return G.read(l(G));case c.Array:{const V=l(G),ee=[];for(let ne=0;ne<V;ne++)ee.push(a(G));return ee}case c.Object:return JSON.parse(G.read(l(G)).toString());case c.Int:return l(G)}}e.$bh=a;class v{constructor(H,V,ee=null,ne=1e3){this.h=H,this.j=V,this.k=ee,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(H,V){this.b.set(H,V),setTimeout(()=>this.w(H),0)}m(H){switch(H.type){case 200:{const V=this.o([H.type]);this.k?.logOutgoing(V,0,1,f(H.type));return}case 201:case 202:case 204:case 203:{const V=this.o([H.type,H.id],H.data);this.k?.logOutgoing(V,H.id,1,f(H.type),H.data);return}}}o(H,V=void 0){const ee=new i;return r(ee,H),r(ee,V),this.p(ee.buffer)}p(H){try{return this.h.send(H),H.byteLength}catch{return 0}}q(H){const V=new I(H),ee=a(V),ne=a(V),se=ee[0];switch(se){case 100:return this.k?.logIncoming(H.byteLength,ee[1],1,`${g(se)}: ${ee[2]}.${ee[3]}`,ne),this.s({type:se,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 102:return this.k?.logIncoming(H.byteLength,ee[1],1,`${g(se)}: ${ee[2]}.${ee[3]}`,ne),this.t({type:se,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 101:return this.k?.logIncoming(H.byteLength,ee[1],1,`${g(se)}`),this.u({type:se,id:ee[1]});case 103:return this.k?.logIncoming(H.byteLength,ee[1],1,`${g(se)}`),this.u({type:se,id:ee[1]})}}s(H){const V=this.b.get(H.channelName);if(!V){this.v(H);return}const ee=new L.$od;let ne;try{ne=V.call(this.j,H.name,H.arg,ee.token)}catch(q){ne=Promise.reject(q)}const se=H.id;ne.then(q=>{this.m({id:se,data:q,type:201})},q=>{q instanceof Error?this.m({id:se,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:se,data:q,type:203})}).finally(()=>{Y.dispose(),this.d.delete(H.id)});const Y=(0,$.$hc)(()=>ee.cancel());this.d.set(H.id,Y)}t(H){const V=this.b.get(H.channelName);if(!V){this.v(H);return}const ee=H.id,se=V.listen(this.j,H.name,H.arg)(Y=>this.m({id:ee,data:Y,type:204}));this.d.set(H.id,se)}u(H){const V=this.d.get(H.id);V&&(V.dispose(),this.d.delete(H.id))}v(H){let V=this.g.get(H.channelName);V||(V=[],this.g.set(H.channelName,V));const ee=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:H,timeoutTimer:ee})}w(H){const V=this.g.get(H);if(V){for(const ee of V)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$ec)(this.d.values()),this.d.clear()}}e.$ch=v;var b;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class u{constructor(H,V=null){this.l=H,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$ed,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=V}getChannel(H){const V=this;return{call(ee,ne,se){return V.a?Promise.reject(new R.$3):V.m(H,ee,ne,se)},listen(ee,ne){return V.a?k.Event.None:V.o(H,ee,ne)}}}m(H,V,ee,ne=L.CancellationToken.None){const se=this.g++,q={id:se,type:100,channelName:H,name:V,arg:ee};if(ne.isCancellationRequested)return Promise.reject(new R.$3);let S;return new Promise((M,T)=>{if(ne.isCancellationRequested)return T(new R.$3);const K=()=>{const fe=le=>{switch(le.type){case 201:this.f.delete(se),M(le.data);break;case 202:{this.f.delete(se);const $e=new Error(le.data.message);$e.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,$e.name=le.data.name,T($e);break}case 203:this.f.delete(se),T(le.data);break}};this.f.set(se,fe),this.p(q)};let _=null;this.b===o.Idle?K():(_=(0,N.$tg)(fe=>this.u()),_.then(()=>{_=null,K()}));const ae=()=>{_?(_.cancel(),_=null):this.p({id:se,type:101}),T(new R.$3)},he=ne.onCancellationRequested(ae);S=(0,$.$gc)((0,$.$hc)(ae),he),this.d.add(S)}).finally(()=>{S.dispose(),this.d.delete(S)})}o(H,V,ee){const ne=this.g++,Y={id:ne,type:102,channelName:H,name:V,arg:ee};let q=null;const S=new k.$ed({onWillAddFirstListener:()=>{q=(0,N.$tg)(M=>this.u()),q.then(()=>{q=null,this.d.add(S),this.p(Y)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(S),this.p({id:ne,type:103}))}}),P=M=>S.fire(M.data);return this.f.set(ne,P),S.event}p(H){switch(H.type){case 100:case 102:{const V=this.q([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(V,H.id,0,`${g(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const V=this.q([H.type,H.id]);this.j?.logOutgoing(V,H.id,0,g(H.type));return}}}q(H,V=void 0){const ee=new i;return r(ee,H),r(ee,V),this.r(ee.buffer)}r(H){try{return this.l.send(H),H.byteLength}catch{return 0}}s(H){const V=new I(H),ee=a(V),ne=a(V),se=ee[0];switch(se){case 200:return this.j?.logIncoming(H.byteLength,0,0,f(se)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(H.byteLength,ee[1],0,f(se),ne),this.t({type:ee[0],id:ee[1],data:ne})}}t(H){if(H.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$ec)(this.d.values()),this.d.clear()}}e.$dh=u,ye([j.$5g],u.prototype,"onDidInitializePromise",null);class p{get connections(){const H=[];return this.f.forEach(V=>H.push(V)),H}constructor(H){this.a=new Map,this.f=new Set,this.g=new k.$ed,this.onDidAddConnection=this.g.event,this.h=new k.$ed,this.onDidRemoveConnection=this.h.event,this.j=new $.$ic,this.j.add(H(({protocol:V,onDidClientDisconnect:ee})=>{const ne=k.Event.once(V.onMessage);this.j.add(ne(se=>{const Y=new I(se),q=a(Y),S=new v(V,q),P=new u(V);this.a.forEach((T,K)=>S.registerChannel(K,T));const M={channelServer:S,channelClient:P,ctx:q};this.f.add(M),this.g.fire(M),this.j.add(ee(()=>{S.dispose(),P.dispose(),this.f.delete(M),this.h.fire(M)}))}))}))}getChannel(H,V){const ee=this;return{call(ne,se,Y){let q;if((0,d.$wf)(V)){const P=(0,O.$1b)(ee.connections.filter(V));q=P?Promise.resolve(P):k.Event.toPromise(k.Event.filter(ee.onDidAddConnection,V))}else q=V.routeCall(ee,ne,se);const S=q.then(P=>P.channelClient.getChannel(H));return F(S).call(ne,se,Y)},listen(ne,se){if((0,d.$wf)(V))return ee.k(H,V,ne,se);const Y=V.routeEvent(ee,ne,se).then(q=>q.channelClient.getChannel(H));return F(Y).listen(ne,se)}}}k(H,V,ee,ne){const se=this;let Y;const q=new k.$ed({onWillAddFirstListener:()=>{Y=new $.$ic;const S=new k.$kd,P=new Map,M=K=>{const ae=K.channelClient.getChannel(H).listen(ee,ne),he=S.add(ae);P.set(K,he)},T=K=>{const _=P.get(K);_&&(_.dispose(),P.delete(K))};se.connections.filter(V).forEach(M),k.Event.filter(se.onDidAddConnection,V)(M,void 0,Y),se.onDidRemoveConnection(T,void 0,Y),S.event(q.fire,q,Y),Y.add(S)},onDidRemoveLastListener:()=>{Y?.dispose(),Y=void 0}});return q.event}registerChannel(H,V){this.a.set(H,V);for(const ee of this.f)ee.channelServer.registerChannel(H,V)}dispose(){this.j.dispose();for(const H of this.f)H.channelClient.dispose(),H.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$eh=p;class D{constructor(H,V,ee=null){const ne=new i;r(ne,V),H.send(ne.buffer),this.a=new u(H,ee),this.d=new v(H,V,ee)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,V){this.d.registerChannel(H,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fh=D;function F(G){return{call(H,V,ee){return G.then(ne=>ne.call(H,V,ee))},listen(H,V){const ee=new k.$nd;return G.then(ne=>ee.input=ne.listen(H,V)),ee.event}}}e.$gh=F;function z(G){let H=!1;return{call(V,ee,ne){return H?G.call(V,ee,ne):(0,N.$Gg)(0).then(()=>H=!0).then(()=>G.call(V,ee,ne))},listen(V,ee){if(H)return G.listen(V,ee);const ne=new k.$nd;return(0,N.$Gg)(0).then(()=>H=!0).then(()=>ne.input=G.listen(V,ee)),ne.event}}}e.$hh=z;class U{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const V of H.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await k.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.$ih=U;var B;(function(G){function H(se,Y,q){const S=se,P=q&&q.disableMarshalling,M=new Map;for(const T in S)ee(T)&&M.set(T,k.Event.buffer(S[T],!0,void 0,Y));return new class{listen(T,K,_){const ae=M.get(K);if(ae)return ae;if(ne(K)){const he=S[K];if(typeof he=="function")return he.call(S,_)}throw new R.$_(`Event not found: ${K}`)}call(T,K,_){const ae=S[K];if(typeof ae=="function"){if(!P&&Array.isArray(_))for(let he=0;he<_.length;he++)_[he]=(0,C.$0g)(_[he]);return ae.apply(S,_)}throw new R.$_(`Method not found: ${K}`)}}}G.fromService=H;function V(se,Y){const q=Y&&Y.disableMarshalling;return new Proxy({},{get(S,P){if(typeof P=="string")return Y?.properties?.has(P)?Y.properties.get(P):ne(P)?function(M){return se.listen(P,M)}:ee(P)?se.listen(P):async function(...M){let T;Y&&!(0,d.$rf)(Y.context)?T=[Y.context,...M]:T=M;const K=await se.call(P,T);return q?K:(0,C.$0g)(K)};throw new R.$_(`Property not found: ${String(P)}`)}})}G.toService=V;function ee(se){return se[0]==="o"&&se[1]==="n"&&E.$Ke(se.charCodeAt(2))}function ne(se){return/^onDynamic/.test(se)&&E.$Ke(se.charCodeAt(9))}})(B||(e.ProxyChannel=B={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){const H=G.toString();if(H!=="[object Object]")return H}return G}function Q(G){return Array.isArray(G)?G.map(J):J(G)}function W(G,H,V,ee,ne,se,Y){Y=Q(Y);const q=x[ne],S=q[ee%q.length];let P=[`%c[${G}]%c[${String(H).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${S}`];/\($/.test(se)?(P=P.concat(Y),P.push(")")):P.push(Y),console.log.apply(console,P)}class Z{constructor(H,V){this.d=H,this.f=V,this.a=0,this.b=0}logOutgoing(H,V,ee,ne,se){this.b+=H,W(this.d,this.b,H,V,ee,ne,se)}logIncoming(H,V,ee,ne,se){this.a+=H,W(this.f,this.a,H,V,ee,ne,se)}}e.$jh=Z}),define(re[65],oe([0,1,14,3,2,43]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e.$lh=e.ProtocolConstants=e.$kh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var j;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(j||(e.SocketDiagnosticsEventType=j={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(b,u){if(!t.has(b)){const p=String(++r);t.set(b,p)}return t.get(b)}function v(b,u,p,D){if(!s.enableDiagnostics)return;const F=a(b,u);if(D instanceof O.$Ed||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const z=O.$Ed.alloc(D.byteLength);z.set(D),s.records.push({timestamp:Date.now(),id:F,label:u,type:p,buff:z})}else s.records.push({timestamp:Date.now(),id:F,label:u,type:p,data:D})}s.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var k;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let $=null;function C(){return $||($=O.$Ed.alloc(0)),$}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const u=this.a[0];return r&&(this.a.shift(),this.b-=t),u}if(this.a[0].byteLength>t){const u=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),u}const a=O.$Ed.alloc(t);let v=0,b=0;for(;t>0;){const u=this.a[b];if(u.byteLength>t){const p=u.slice(0,t);a.set(p,v),v+=t,r&&(this.a[b]=u.slice(t),this.b-=t),t-=t}else a.set(u,v),v+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):b++,t-=u.byteLength}return a}}e.$kh=E;var d;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(d||(d={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class y{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends A.$jc{constructor(t){super(),this.f=this.B(new N.$ed),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new y(a,v,b,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=O.$Ed.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=O.$Ed.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class l extends A.$jc{constructor(t){super(),this.f=new N.$ed,this.onMessage=this.f.event,this.g=new N.$ed,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new o(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new y(1,0,0,t))}}e.$lh=l;class w extends L.$fh{static fromSocket(t,r){return new w(new l(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$mh=w;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$ed({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$nh=m;class I{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new I(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class c{static{this.a=10}static{this.b=null}static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<c.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=c.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+c.a)*1e3;let a=0;for(let v=0;v<c.a;v++)t-this.c[v]<=r&&a++;return 1-a/c.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??c.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$ic,this.o=t.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new y(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new y(7,0,0,C());this.p.write(t)}sendResume(){const t=new y(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new A.$ic,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new y(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new y(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new y(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new y(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const b=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new y(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new y(9,0,this.h,C());this.p.write(t)}}e.$oh=n}),define(re[93],oe([0,1,64,5,14,26,142,8,3,2,30,145,90,43]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;class g extends h.$ch{constructor(o){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",l=>A.$Ed.wrap(Buffer.from(l,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Qp=g;class y{constructor(o,l){this.i=o,this.j=l,this.c=new Set,this.g=new Map,this.h=new k.$ed,this.onDidProcessExit=this.h.event;const w=l&&l.timeout?l.timeout:6e4;this.b=new N.$Cg(w),this.d=null,this.f=null}getChannel(o){const l=this;return{call(w,m,I){return l.k(o,w,m,I)},listen(w,m){return l.l(o,w,m)}}}k(o,l,w,m=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(R.$4());this.b.cancel();const I=this.n(o),i=(0,N.$tg)(s=>I.call(l,w,s)),c=m.onCancellationRequested(()=>i.cancel()),n=(0,$.$hc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{c.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(o,l,w){if(!this.b)return k.Event.None;this.b.cancel();let m;const I=new k.$ed({onWillAddFirstListener:()=>{m=this.n(o).listen(l,w)(I.fire,I),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return I.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,C.$Um)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,d.$sl)(l.env),this.d=(0,O.fork)(this.i,o,l);const w=new k.$ed;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,j.$Mp)(t)){(0,j.log)(t,`IPC Library: ${this.j.serverName}`);return}w.fire(A.$Ed.wrap(Buffer.from(t,"base64")))});const I=this.j.useQueue?(0,E.$ul)(this.d):this.d,i=t=>this.d&&this.d.connected&&I.send(t.buffer.toString("base64")),c=w.event,n={send:i,onMessage:c};this.f=new h.$dh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,$.$ec)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(o){let l=this.g.get(o);return l||(l=this.m.getChannel(o),this.g.set(o,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Rp=y}),define(re[147],oe([0,1,135,14,43,3,9,18]),function(te,e,O,N,A,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1S=e.$ZS=void 0;class k{constructor(d){this.a=d,this.onMessage=L.Event.fromNodeEventEmitter(this.a,"message",h=>N.$Ed.wrap(h.data)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}class $ extends A.$eh{static b(d){(0,j.$sf)((0,O.$YS)(process),"Electron Utility Process");const h=new L.$ed;return process.parentPort.on("message",g=>{if(d?.handledClientConnection(g))return;const y=(0,R.$Lb)(g.ports);y&&h.fire(y)}),L.Event.map(h.event,g=>({protocol:new k(g),onDidClientDisconnect:L.Event.fromNodeEventEmitter(g,"close")}))}constructor(d){super($.b(d))}}e.$ZS=$;function C(E,d,h){const g=y=>{y.data===d&&(E.removeListener("message",g),h())};E.on("message",g)}e.$1S=C}),define(re[66],oe([0,1,5,3,2,63,9]),function(te,e,O,N,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.StorageState=e.$Po=e.StorageHint=void 0;var R;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k(d){const h=d;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Po=k;var $;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})($||(e.StorageState=$={}));class C extends A.$jc{static{this.a=100}constructor(h,g=Object.create(null)){super(),this.r=h,this.s=g,this.b=this.B(new N.$hd),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new O.$Dg(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(h=>this.u(h)))}u(h){this.b.pause();try{h.changed?.forEach((g,y)=>this.w(y,g)),h.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(h,g){if(this.c===$.Closed)return;let y=!1;(0,j.$rf)(g)?y=this.f.delete(h):this.f.get(h)!==g&&(this.f.set(h,g),y=!0),y&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(h,g){const y=this.f.get(h);return(0,j.$rf)(y)?g:y}getBoolean(h,g){const y=this.get(h);return(0,j.$rf)(y)?g:y==="true"}getNumber(h,g){const y=this.get(h);return(0,j.$rf)(y)?g:parseInt(y,10)}getObject(h,g){const y=this.get(h);return(0,j.$rf)(y)?g:(0,L.$9g)(y)}async set(h,g,y=!1){if(this.c===$.Closed)return;if((0,j.$rf)(g))return this.delete(h,y);const f=(0,j.$kf)(g)||Array.isArray(g)?(0,L.$8g)(g):String(g);if(this.f.get(h)!==f)return this.f.set(h,f),this.j.set(h,f),this.h.delete(h),this.b.fire({key:h,external:y}),this.D()}async delete(h,g=!1){if(!(this.c===$.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:g}),this.D()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=$.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(h).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(h){if(this.z)return this.D(h)}async D(h){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),h)}async whenFlushed(){if(this.z)return new Promise(h=>this.n.push(h))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$Qo=C;class E{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((g,y)=>this.a.set(y,g)),h.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$Ro=E}),define(re[148],oe([13,10]),function(te,e){return te.create("vs/base/node/zip",e)}),define(re[149],oe([13,10]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[150],oe([13,10]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(re[151],oe([13,10]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(re[152],oe([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[153],oe([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[154],oe([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[155],oe([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[156],oe([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[157],oe([13,10]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[158],oe([13,10]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[159],oe([13,10]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(re[160],oe([13,10]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(re[161],oe([13,10]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(re[162],oe([13,10]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[163],oe([13,10]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[164],oe([13,10]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(re[165],oe([13,10]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(re[166],oe([13,10]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(re[167],oe([13,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(re[168],oe([13,10]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[169],oe([13,10]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[170],oe([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[171],oe([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[172],oe([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[173],oe([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[174],oe([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[175],oe([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(re[176],oe([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[177],oe([13,10]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(re[178],oe([13,10]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(re[179],oe([0,1,8,151]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.TokenType=void 0;var A;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(A||(e.TokenType=A={}));function L(...$){switch($.length){case 1:return(0,N.localize)(0,null,$[0]);case 2:return(0,N.localize)(1,null,$[0],$[1]);case 3:return(0,N.localize)(2,null,$[0],$[1],$[2]);default:return}}const j=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,O.$6)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const E=this.d,d=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:d};this.g.push({offset:E,lexeme:d,additionalInfo:C}),this.f.push(h)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const E=this.c.substring(this.d,this.e),d=k.b.get(E);d?this.k(d):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,E=!1,d=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const g=this.c.charCodeAt(C);if(E)E=!1;else if(g===47&&!d){C++;break}else g===91?d=!0:g===92?E=!0:g===93&&(d=!1);C++}for(;C<this.c.length&&k.a.has(this.c.charCodeAt(C));)C++;this.e=C;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ei=k}),define(re[180],oe([0,1,62,83,23,16,37,21,11]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=void 0,e.$7l=/^([^.]+\..+):(.+)$/;class ${get appRoot(){return(0,L.$$d)(A.$1f.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,L.$8d)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,R.$hg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$hg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,O.$6l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$8d)(this.userDataPath,"logs",h)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$hg)(k.URI.file((0,L.$8d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$hg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$hg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$hg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=j.env.VSCODE_PORTABLE;return h?k.URI.file((0,L.$8d)(h,"argv.json")):(0,R.$hg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,L.$8d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,L.$9d)(h):(0,L.$6d)((0,L.$8d)(A.$1f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?k.URI.file((0,L.$9d)(h)):k.URI.file((0,L.$8d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,L.$9d)(h);const g=j.env.VSCODE_EXTENSIONS;if(g)return g;const y=j.env.VSCODE_PORTABLE;return y?(0,L.$8d)(y,"extensions"):(0,R.$hg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(g=>/^[^:/?#]+?:\/\//.test(g)?k.URI.parse(g):k.URI.file((0,L.$6d)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?k.URI.parse(h):k.URI.file((0,L.$6d)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$7l.test(h))}get extensionLogLevel(){const h=[];for(const g of this.args.log||[]){const y=e.$7l.exec(g);y&&y[1]&&y[2]&&h.push([y[1],y[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.$hg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=j.env.VSCODE_PORTABLE;return h?k.URI.file((0,L.$8d)(h,"policy.json")):(0,R.$hg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,g,y){this.a=h,this.b=g,this.c=y,this.editSessionId=this.args.editSessionId}}e.$8l=$,ye([N.$5g],$.prototype,"appRoot",null),ye([N.$5g],$.prototype,"userHome",null),ye([N.$5g],$.prototype,"userDataPath",null),ye([N.$5g],$.prototype,"appSettingsHome",null),ye([N.$5g],$.prototype,"tmpDir",null),ye([N.$5g],$.prototype,"cacheHome",null),ye([N.$5g],$.prototype,"stateResource",null),ye([N.$5g],$.prototype,"userRoamingDataHome",null),ye([N.$5g],$.prototype,"userDataSyncHome",null),ye([N.$5g],$.prototype,"sync",null),ye([N.$5g],$.prototype,"machineSettingsResource",null),ye([N.$5g],$.prototype,"workspaceStorageHome",null),ye([N.$5g],$.prototype,"localHistoryHome",null),ye([N.$5g],$.prototype,"keyboardLayoutResource",null),ye([N.$5g],$.prototype,"argvResource",null),ye([N.$5g],$.prototype,"isExtensionDevelopment",null),ye([N.$5g],$.prototype,"untitledWorkspacesHome",null),ye([N.$5g],$.prototype,"builtinExtensionsPath",null),ye([N.$5g],$.prototype,"extensionsPath",null),ye([N.$5g],$.prototype,"extensionDevelopmentLocationURI",null),ye([N.$5g],$.prototype,"extensionDevelopmentKind",null),ye([N.$5g],$.prototype,"extensionTestsLocationURI",null),ye([N.$5g],$.prototype,"debugExtensionHost",null),ye([N.$5g],$.prototype,"logLevel",null),ye([N.$5g],$.prototype,"extensionLogLevel",null),ye([N.$5g],$.prototype,"serviceMachineIdResource",null),ye([N.$5g],$.prototype,"disableTelemetry",null),ye([N.$5g],$.prototype,"disableWorkspaceTrust",null),ye([N.$5g],$.prototype,"useInMemorySecretStorage",null),ye([N.$5g],$.prototype,"policyFile",null);function C(d,h){return E(d["inspect-extensions"],d["inspect-brk-extensions"],5870,h,d.debugId,d.extensionEnvironment)}e.$9l=C;function E(d,h,g,y,f,o){const w=Number(h||d)||(y?null:g),m=w?!!h:!1;let I;if(o)try{I=JSON.parse(o)}catch{}return{port:w,break:m,debugId:f,env:I}}e.$0l=E}),function(){"use strict";function te(e,O,N){function A(j,R){const k=L(j,R),$=[k];return e.isAbsolute(k)||$.unshift(N),e.resolve(...$)}function L(j,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let $=process.env.VSCODE_APPDATA;if($)return e.join($,R);const C=j["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if($=process.env.APPDATA,!$){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");$=e.join(E,"AppData","Roaming")}break;case"darwin":$=e.join(O.homedir(),"Library","Application Support");break;case"linux":$=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join($,R)}return{getUserDataPath:A}}if(typeof define=="function")define(re[181],oe([270,36,37]),function(e,O,N){return te(e,O,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=te(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[182],oe([0,1,36,180,181]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=void 0;class L extends N.$8l{constructor($,C){super($,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,A.getUserDataPath)($,C.nameShort)},C)}}e.$$l=L;function j(k,$){return(0,N.$0l)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,$,k.extensionEnvironment)}e.$_l=j;function R(k,$){return(0,N.$0l)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,$,k.extensionEnvironment)}e.$am=R}),define(re[183],oe([0,1,9,154]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function A(j,R,k,$){try{L(j,R,k,$)}catch(C){j.error(C?.message??C)}return R}e.$mp=A;function L(j,R,k,$){const C=(E,d,h)=>{const g=E[d];if((0,O.$if)(g)){const y=g,f=y.length;if(f>1&&y[0]==="%"&&y[f-1]==="%"){const o=y.substr(1,f-2);let l=k[o];l===void 0&&$&&(l=$[o]);const w=typeof l=="string"?l:l?.message,m=$?.[o],I=typeof m=="string"?m:m?.message;if(!w){I||j.warn(`[${R.name}]: ${(0,N.localize)(0,null,o)}`);return}if(h&&(d==="title"||d==="category")&&I&&I!==w){const i={value:w,original:I};E[d]=i}else E[d]=w}}else if((0,O.$kf)(g))for(const y in g)g.hasOwnProperty(y)&&(y==="commands"?C(g,y,!0):C(g,y,h));else if(Array.isArray(g))for(let y=0;y<g.length;y++)C(g,y,h)};for(const E in R)R.hasOwnProperty(E)&&C(R,E)}}),define(re[184],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47b=e.$37b=void 0;class O{constructor(L){this.a=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L){return this.a.call("promptImportantExtensionsInstallNotification",[L])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$37b=O;class N{constructor(L){this.a=L}listen(L,j){throw new Error(`Event not found: ${j}`)}call(L,j,R){switch(j){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${j}`)}}e.$47b=N}),define(re[67],oe([0,1,21,89,158,53]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(o){return o=o.trim(),o==="*"||j.test(o)}e.$Ao=k;function $(o){if(!k(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=o.match(j);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.$Bo=$;function C(o){if(!o)return null;const l=o.majorBase,w=o.majorMustEqual,m=o.minorBase;let I=o.minorMustEqual;const i=o.patchBase;let c=o.patchMustEqual;o.hasCaret&&(l===0||(I=!1),c=!1);let n=0;if(o.preRelease){const s=R.exec(o.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:l,majorMustEqual:w,minorBase:m,minorMustEqual:I,patchBase:i,patchMustEqual:c,isMinimum:o.hasGreaterEquals,notBefore:n}}e.$Co=C;function E(o,l,w){let m;typeof o=="string"?m=C($(o)):m=o;let I;l instanceof Date?I=l.getTime():typeof l=="string"&&(I=new Date(l).getTime());let i;if(typeof w=="string"?i=C($(w)):i=w,!m||!i)return!1;const c=m.majorBase,n=m.minorBase,s=m.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const v=i.notBefore;let b=i.majorMustEqual,u=i.minorMustEqual,p=i.patchMustEqual;return i.isMinimum?c>t?!0:c<t?!1:n>r?!0:n<r||I&&I<v?!1:s>=a:(c===1&&t===0&&(!b||!u||!p)&&(t=1,r=0,a=0,b=!0,u=!1,p=!1),c<t?!1:c>t?!b:n<r?!1:n>r?!u:s<a?!1:s>a?!p:!(I&&I<v))}e.$Do=E;function d(o,l,w,m,I){const i=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return i.push([N.default.Error,A.localize(0,null)]),i;if(typeof m.name!="string")return i.push([N.default.Error,A.localize(1,null,"name")]),i;if(typeof m.version!="string")return i.push([N.default.Error,A.localize(2,null,"version")]),i;if(!m.engines)return i.push([N.default.Error,A.localize(3,null,"engines")]),i;if(typeof m.engines.vscode!="string")return i.push([N.default.Error,A.localize(4,null,"engines.vscode")]),i;if(typeof m.extensionDependencies<"u"&&!f(m.extensionDependencies))return i.push([N.default.Error,A.localize(5,null,"extensionDependencies")]),i;if(typeof m.activationEvents<"u"){if(!f(m.activationEvents))return i.push([N.default.Error,A.localize(6,null,"activationEvents")]),i;if(typeof m.main>"u"&&typeof m.browser>"u")return i.push([N.default.Error,A.localize(7,null,"activationEvents","main","browser")]),i}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&i.push([N.default.Warning,A.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return i.push([N.default.Error,A.localize(9,null,"main")]),i;{const s=(0,O.$hg)(w,m.main);(0,O.$bg)(s,w)||i.push([N.default.Warning,A.localize(10,null,s.path,w.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return i.push([N.default.Error,A.localize(11,null,"browser")]),i;{const s=(0,O.$hg)(w,m.browser);(0,O.$bg)(s,w)||i.push([N.default.Warning,A.localize(12,null,s.path,w.path)])}}if(!L.valid(m.version))return i.push([N.default.Error,A.localize(13,null)]),i;const c=[];if(!h(o,l,m,I,c))for(const s of c)i.push([N.default.Error,s]);return i}e.$Eo=d;function h(o,l,w,m,I){return m||typeof w.main>"u"&&typeof w.browser>"u"?!0:y(o,l,w.engines.vscode,I)}e.$Fo=h;function g(o,l,w){return o==="*"||y(l,w,o)}e.$Go=g;function y(o,l,w,m=[]){const I=C($(w));if(!I)return m.push(A.localize(14,null,w)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return m.push(A.localize(15,null,w)),!1}else if(!I.majorMustEqual)return m.push(A.localize(16,null,w)),!1;return E(o,l,I)?!0:(m.push(A.localize(17,null,o,w)),!1)}function f(o){if(!Array.isArray(o))return!1;for(let l=0,w=o.length;l<w;l++)if(typeof o[l]!="string")return!1;return!0}}),define(re[44],oe([0,1,14,32]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=void 0;async function A(L,j,R){let k=R&&R.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const C=(await j.readFile(L.serviceMachineIdResource)).value.toString();k=(0,N.$2f)(C)?C:null}catch{k=null}if(!k){k=(0,N.$3f)();try{await j.writeFile(L.serviceMachineIdResource,O.$Ed.fromString(k))}catch{}}return R?.store("storage.serviceMachineId",k,-1,1),k}e.$1o=A}),define(re[68],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class O{constructor(A,L=[],j=!1){this.ctor=A,this.staticArguments=L,this.supportsDelayedInstantiation=j}}e.$xh=O}),define(re[185],oe([0,1,68]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.InstantiationType=void 0;const N=[];var A;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function L(R,k,$){k instanceof O.$xh||(k=new O.$xh(k,[],!!$)),N.push([R,k])}e.$lr=L;function j(){return N}e.$mr=j}),define(re[186],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;class O{constructor(L,j){this.key=L,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$3p=O;class N{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const j of this.a.values())j.outgoing.size===0&&L.push(j);return L}insertEdge(L,j){const R=this.lookupOrInsertNode(L),k=this.lookupOrInsertNode(j);R.outgoing.set(k.key,k),k.incoming.set(R.key,R)}removeNode(L){const j=this.b(L);this.a.delete(j);for(const R of this.a.values())R.outgoing.delete(j),R.incoming.delete(j)}lookupOrInsertNode(L){const j=this.b(L);let R=this.a.get(j);return R||(R=new O(j,L),this.a.set(j,R)),R}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[j,R]of this.a)L.push(`${j}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,j]of this.a){const R=new Set([L]),k=this.c(j,R);if(k)return k}}c(L,j){for(const[R,k]of L.outgoing){if(j.has(R))return[...j,R].join(" -> ");j.add(R);const $=this.c(k,j);if($)return $;j.delete(R)}}}e.$4p=N}),define(re[4],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e._util=void 0;var O;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function R(k){return k[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=R})(O||(e._util=O={})),e.$zh=A("instantiationService");function N(j,R,k){R[O.DI_TARGET]===R?R[O.DI_DEPENDENCIES].push({id:j,index:k}):(R[O.DI_DEPENDENCIES]=[{id:j,index:k}],R[O.DI_TARGET]=R)}function A(j){if(O.serviceIds.has(j))return O.serviceIds.get(j);const R=function(k,$,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,k,C)};return R.toString=()=>j,O.serviceIds.set(j,R),R}e.$Ah=A;function L(j){return j}e.$Bh=L}),define(re[187],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0,e.$z7b=(0,O.$Ah)("checksumService")}),define(re[19],oe([0,1,9,11,4]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.ConfigurationTarget=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,A.$Ah)("configurationService");function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof N.URI)}e.$8h=L;function j(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof N.URI)}e.$9h=j;var R;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function k(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$0h=k;function $(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$$h=$;function C(o,l){const w=Object.create(null);for(const m in o)E(w,m,o[m],l);return w}e.$_h=C;function E(o,l,w,m){const I=l.split("."),i=I.pop();let c=o;for(let n=0;n<I.length;n++){const s=I[n];let t=c[s];switch(typeof t){case"undefined":t=c[s]=Object.create(null);break;case"object":break;default:m(`Ignoring ${l} as ${I.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}c=t}if(typeof c=="object"&&c!==null)try{c[i]=w}catch{m(`Ignoring ${l} as ${I.join(".")} is ${JSON.stringify(c)}`)}else m(`Ignoring ${l} as ${I.join(".")} is ${JSON.stringify(c)}`)}e.$ai=E;function d(o,l){const w=l.split(".");h(o,w)}e.$bi=d;function h(o,l){const w=l.shift();if(l.length===0){delete o[w];return}if(Object.keys(o).indexOf(w)!==-1){const m=o[w];typeof m=="object"&&!Array.isArray(m)&&(h(m,l),Object.keys(m).length===0&&delete o[w])}}function g(o,l,w){function m(c,n){let s=c;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const I=l.split("."),i=m(o,I);return typeof i>"u"?w:i}e.$ci=g;function y(o,l,w){Object.keys(l).forEach(m=>{m!=="__proto__"&&(m in o?O.$kf(o[m])&&O.$kf(l[m])?y(o[m],l[m],w):w&&(o[m]=l[m]):o[m]=l[m])})}e.$di=y;function f(o){return o.replace(/[\[\]]/g,"")}e.$ei=f}),define(re[94],oe([0,1,6,27,179,4,150,8]),function(te,e,O,N,A,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.ContextKeyExprType=e.$Fi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",O.$j),k.set("isLinux",O.$k),k.set("isWindows",O.$i),k.set("isWeb",O.$o),k.set("isMacNative",O.$j&&!O.$o),k.set("isEdge",O.$G),k.set("isFirefox",O.$E),k.set("isChrome",O.$D),k.set("isSafari",O.$F);function $(q,S){if(k.get(q)!==void 0)throw(0,R.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(q,S)}e.$Fi=$;const C=Object.prototype.hasOwnProperty;var E;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const d={regexParsingWithErrorRecovery:!0},h=(0,j.localize)(0,null),g=(0,j.localize)(1,null),y=(0,j.localize)(2,null),f=(0,j.localize)(3,null),o=(0,j.localize)(4,null),l=(0,j.localize)(5,null),w=(0,j.localize)(6,null),m=(0,j.localize)(7,null);class I{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(S=d){this.k=S,this.d=new A.$Ei,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(S){if(S===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(S).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const M=this.D(),T=M.type===17?l:void 0;throw this.h.push({message:o,offset:M.offset,lexeme:A.$Ei.getLexeme(M),additionalInfo:T}),I.c}return P}catch(P){if(P!==I.c)throw P;return}}l(){return this.m()}m(){const S=[this.o()];for(;this.y(16);){const P=this.o();S.push(P)}return S.length===1?S[0]:i.or(...S)}o(){const S=[this.s()];for(;this.y(15);){const P=this.s();S.push(P)}return S.length===1?S[0]:i.and(...S)}s(){if(this.y(2)){const S=this.D();switch(S.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,f),P?.negate()}case 17:return this.z(),D.create(S.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",S)}}return this.t()}t(){const S=this.D();switch(S.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const P=this.l();return this.A(1,f),P}case 17:{const P=S.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const K=T.lexeme,_=K.lastIndexOf("/"),ae=_===K.length-1?void 0:this.w(K.substring(_+1));let he;try{he=new RegExp(K.substring(1,_),ae)}catch{throw this.B("REGEX",T)}return J.create(P,he)}switch(T.type){case 10:case 19:{const K=[T.lexeme];this.z();let _=this.D(),ae=0;for(let de=0;de<T.lexeme.length;de++)T.lexeme.charCodeAt(de)===40?ae++:T.lexeme.charCodeAt(de)===41&&ae--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ae++;break;case 1:ae--;break;case 10:case 18:for(let de=0;de<_.lexeme.length;de++)_.lexeme.charCodeAt(de)===40?ae++:T.lexeme.charCodeAt(de)===41&&ae--}if(ae<0)break;K.push(A.$Ei.getLexeme(_)),this.z(),_=this.D()}const he=K.join(""),fe=he.lastIndexOf("/"),le=fe===he.length-1?void 0:this.w(he.substring(fe+1));let $e;try{$e=new RegExp(he.substring(1,fe),le)}catch{throw this.B("REGEX",T)}return i.regex(P,$e)}case 18:{const K=T.lexeme;this.z();let _=null;if(!(0,N.$le)(K)){const ae=K.indexOf("/"),he=K.lastIndexOf("/");if(ae!==he&&ae>=0){const fe=K.slice(ae+1,he),le=K[he+1]==="i"?"i":"";try{_=new RegExp(fe,le)}catch{throw this.B("REGEX",T)}}}if(_===null)throw this.B("REGEX",T);return J.create(P,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const T=this.u();return i.notIn(P,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return i.equals(P,T);switch(T){case"true":return i.has(P);case"false":return i.not(P);default:return i.equals(P,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return i.notEquals(P,T);switch(T){case"true":return i.not(P);case"false":return i.has(P);default:return i.notEquals(P,T)}}case 5:return this.z(),B.create(P,this.u());case 6:return this.z(),x.create(P,this.u());case 7:return this.z(),z.create(P,this.u());case 8:return this.z(),U.create(P,this.u());case 13:return this.z(),i.in(P,this.u());default:return i.has(P)}}case 20:throw this.h.push({message:w,offset:S.offset,lexeme:"",additionalInfo:m}),I.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const S=this.D();switch(S.type){case 17:case 18:return this.z(),S.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(S){return S.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(S){return this.C(S)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(S,P){if(this.C(S))return this.z();throw this.B(P,this.D())}B(S,P,M){const T=(0,j.localize)(8,null,S,A.$Ei.getLexeme(P)),K=P.offset,_=A.$Ei.getLexeme(P);return this.h.push({message:T,offset:K,lexeme:_,additionalInfo:M}),I.c}C(S){return this.D().type===S}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Gi=I;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(S){return a.create(S)}static equals(S,P){return v.create(S,P)}static notEquals(S,P){return p.create(S,P)}static regex(S,P){return J.create(S,P)}static in(S,P){return b.create(S,P)}static notIn(S,P){return u.create(S,P)}static not(S){return D.create(S)}static and(...S){return Z.create(S,null,!0)}static or(...S){return G.create(S,null,!0)}static greater(S,P){return z.create(S,P)}static greaterEquals(S,P){return U.create(S,P)}static smaller(S,P){return B.create(S,P)}static smallerEquals(S,P){return x.create(S,P)}static{this.c=new I({regexParsingWithErrorRecovery:!1})}static deserialize(S){return S==null?void 0:this.c.parse(S)}}e.$Hi=i;function c(q){const S=new I({regexParsingWithErrorRecovery:!1});return q.map(P=>(S.parse(P),S.lexingErrors.length>0?S.lexingErrors.map(M=>({errorMessage:M.additionalInfo?(0,j.localize)(9,null,M.additionalInfo):(0,j.localize)(10,null),offset:M.offset,length:M.lexeme.length})):S.parsingErrors.length>0?S.parsingErrors.map(M=>({errorMessage:M.additionalInfo?`${M.message}. ${M.additionalInfo}`:M.message,offset:M.offset,length:M.lexeme.length})):[]))}e.$Ii=c;function n(q,S){const P=q?q.substituteConstants():void 0,M=S?S.substituteConstants():void 0;return!P&&!M?!0:!P||!M?!1:P.equals(M)}e.$Ji=n;function s(q,S){return q.cmp(S)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return r.INSTANCE}}e.$Ki=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return t.INSTANCE}}e.$Li=r;class a{static create(S,P=null){const M=k.get(S);return typeof M=="boolean"?M?r.INSTANCE:t.INSTANCE:new a(S,P)}constructor(S,P){this.key=S,this.c=P,this.type=2}cmp(S){return S.type!==this.type?this.type-S.type:V(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=k.get(this.key);return typeof S=="boolean"?S?r.INSTANCE:t.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$Mi=a;class v{static create(S,P,M=null){if(typeof P=="boolean")return P?a.create(S,M):D.create(S,M);const T=k.get(S);return typeof T=="boolean"?P===(T?"true":"false")?r.INSTANCE:t.INSTANCE:new v(S,P,M)}constructor(S,P,M){this.c=S,this.d=P,this.f=M,this.type=4}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){const S=k.get(this.c);if(typeof S=="boolean"){const P=S?"true":"false";return this.d===P?r.INSTANCE:t.INSTANCE}return this}evaluate(S){return S.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(S){return S.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$Ni=v;class b{static create(S,P){return new b(S,P)}constructor(S,P){this.d=S,this.f=P,this.type=10,this.c=null}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.d,this.f,S.d,S.f)}equals(S){return S.type===this.type?this.d===S.d&&this.f===S.f:!1}substituteConstants(){return this}evaluate(S){const P=S.getValue(this.f),M=S.getValue(this.d);return Array.isArray(P)?P.includes(M):typeof M=="string"&&typeof P=="object"&&P!==null?C.call(P,M):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(S){return S.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$Oi=b;class u{static create(S,P){return new u(S,P)}constructor(S,P){this.d=S,this.f=P,this.type=11,this.c=b.create(S,P)}cmp(S){return S.type!==this.type?this.type-S.type:this.c.cmp(S.c)}equals(S){return S.type===this.type?this.c.equals(S.c):!1}substituteConstants(){return this}evaluate(S){return!this.c.evaluate(S)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(S){return S.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Pi=u;class p{static create(S,P,M=null){if(typeof P=="boolean")return P?D.create(S,M):a.create(S,M);const T=k.get(S);return typeof T=="boolean"?P===(T?"true":"false")?t.INSTANCE:r.INSTANCE:new p(S,P,M)}constructor(S,P,M){this.c=S,this.d=P,this.f=M,this.type=5}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){const S=k.get(this.c);if(typeof S=="boolean"){const P=S?"true":"false";return this.d===P?t.INSTANCE:r.INSTANCE}return this}evaluate(S){return S.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(S){return S.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Qi=p;class D{static create(S,P=null){const M=k.get(S);return typeof M=="boolean"?M?t.INSTANCE:r.INSTANCE:new D(S,P)}constructor(S,P){this.c=S,this.d=P,this.type=3}cmp(S){return S.type!==this.type?this.type-S.type:V(this.c,S.c)}equals(S){return S.type===this.type?this.c===S.c:!1}substituteConstants(){const S=k.get(this.c);return typeof S=="boolean"?S?t.INSTANCE:r.INSTANCE:this}evaluate(S){return!S.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(S){return S.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Ri=D;function F(q,S){if(typeof q=="string"){const P=parseFloat(q);isNaN(P)||(q=P)}return typeof q=="string"||typeof q=="number"?S(q):t.INSTANCE}class z{static create(S,P,M=null){return F(P,T=>new z(S,T,M))}constructor(S,P,M){this.c=S,this.d=P,this.f=M,this.type=12}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(S){return S.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Si=z;class U{static create(S,P,M=null){return F(P,T=>new U(S,T,M))}constructor(S,P,M){this.c=S,this.d=P,this.f=M,this.type=13}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(S){return S.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ti=U;class B{static create(S,P,M=null){return F(P,T=>new B(S,T,M))}constructor(S,P,M){this.c=S,this.d=P,this.f=M,this.type=14}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(S){return S.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Ui=B;class x{static create(S,P,M=null){return F(P,T=>new x(S,T,M))}constructor(S,P,M){this.c=S,this.d=P,this.f=M,this.type=15}cmp(S){return S.type!==this.type?this.type-S.type:ee(this.c,this.d,S.c,S.d)}equals(S){return S.type===this.type?this.c===S.c&&this.d===S.d:!1}substituteConstants(){return this}evaluate(S){return typeof this.d=="string"?!1:parseFloat(S.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(S){return S.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Vi=x;class J{static create(S,P){return new J(S,P)}constructor(S,P){this.d=S,this.f=P,this.type=7,this.c=null}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.d<S.d)return-1;if(this.d>S.d)return 1;const P=this.f?this.f.source:"",M=S.f?S.f.source:"";return P<M?-1:P>M?1:0}equals(S){if(S.type===this.type){const P=this.f?this.f.source:"",M=S.f?S.f.source:"";return this.d===S.d&&P===M}return!1}substituteConstants(){return this}evaluate(S){const P=S.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const S=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${S}`}keys(){return[this.d]}map(S){return S.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.$Wi=J;class Q{static create(S){return new Q(S)}constructor(S){this.c=S,this.type=8}cmp(S){return S.type!==this.type?this.type-S.type:this.c.cmp(S.c)}equals(S){return S.type===this.type?this.c.equals(S.c):!1}substituteConstants(){return this}evaluate(S){return!this.c.evaluate(S)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(S){return new Q(this.c.map(S))}negate(){return this.c}}e.$Xi=Q;function W(q){let S=null;for(let P=0,M=q.length;P<M;P++){const T=q[P].substituteConstants();if(q[P]!==T&&S===null){S=[];for(let K=0;K<P;K++)S[K]=q[K]}S!==null&&(S[P]=T)}return S===null?q:S}class Z{static create(S,P,M){return Z.d(S,P,M)}constructor(S,P){this.expr=S,this.c=P,this.type=6}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let P=0,M=this.expr.length;P<M;P++){const T=s(this.expr[P],S.expr[P]);if(T!==0)return T}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let P=0,M=this.expr.length;P<M;P++)if(!this.expr[P].equals(S.expr[P]))return!1;return!0}return!1}substituteConstants(){const S=W(this.expr);return S===this.expr?this:Z.create(S,this.c,!1)}evaluate(S){for(let P=0,M=this.expr.length;P<M;P++)if(!this.expr[P].evaluate(S))return!1;return!0}static d(S,P,M){const T=[];let K=!1;for(const _ of S)if(_){if(_.type===1){K=!0;continue}if(_.type===0)return t.INSTANCE;if(_.type===6){T.push(..._.expr);continue}T.push(_)}if(T.length===0&&K)return r.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(s);for(let _=1;_<T.length;_++)T[_-1].equals(T[_])&&(T.splice(_,1),_--);if(T.length===1)return T[0];for(;T.length>1;){const _=T[T.length-1];if(_.type!==9)break;T.pop();const ae=T.pop(),he=T.length===0,fe=G.create(_.expr.map(le=>Z.create([le,ae],null,M)),null,he);fe&&(T.push(fe),T.sort(s))}if(T.length===1)return T[0];if(M){for(let _=0;_<T.length;_++)for(let ae=_+1;ae<T.length;ae++)if(T[_].negate().equals(T[ae]))return t.INSTANCE;if(T.length===1)return T[0]}return new Z(T,P)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(const P of this.expr)S.push(...P.keys());return S}map(S){return new Z(this.expr.map(P=>P.map(S)),null)}negate(){if(!this.c){const S=[];for(const P of this.expr)S.push(P.negate());this.c=G.create(S,this,!0)}return this.c}}e.$Yi=Z;class G{static create(S,P,M){return G.d(S,P,M)}constructor(S,P){this.expr=S,this.c=P,this.type=9}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let P=0,M=this.expr.length;P<M;P++){const T=s(this.expr[P],S.expr[P]);if(T!==0)return T}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let P=0,M=this.expr.length;P<M;P++)if(!this.expr[P].equals(S.expr[P]))return!1;return!0}return!1}substituteConstants(){const S=W(this.expr);return S===this.expr?this:G.create(S,this.c,!1)}evaluate(S){for(let P=0,M=this.expr.length;P<M;P++)if(this.expr[P].evaluate(S))return!0;return!1}static d(S,P,M){let T=[],K=!1;if(S){for(let _=0,ae=S.length;_<ae;_++){const he=S[_];if(he){if(he.type===0){K=!0;continue}if(he.type===1)return r.INSTANCE;if(he.type===9){T=T.concat(he.expr);continue}T.push(he)}}if(T.length===0&&K)return t.INSTANCE;T.sort(s)}if(T.length!==0){if(T.length===1)return T[0];for(let _=1;_<T.length;_++)T[_-1].equals(T[_])&&(T.splice(_,1),_--);if(T.length===1)return T[0];if(M){for(let _=0;_<T.length;_++)for(let ae=_+1;ae<T.length;ae++)if(T[_].negate().equals(T[ae]))return r.INSTANCE;if(T.length===1)return T[0]}return new G(T,P)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(const P of this.expr)S.push(...P.keys());return S}map(S){return new G(this.expr.map(P=>P.map(S)),null)}negate(){if(!this.c){const S=[];for(const P of this.expr)S.push(P.negate());for(;S.length>1;){const P=S.shift(),M=S.shift(),T=[];for(const K of Y(P))for(const _ of Y(M))T.push(Z.create([K,_],null,!1));S.unshift(G.create(T,null,!1))}this.c=G.create(S,this,!0)}return this.c}}e.$Zi=G;class H extends a{static{this.d=[]}static all(){return H.d.values()}constructor(S,P,M){super(S,null),this.f=P,typeof M=="object"?H.d.push({...M,key:S}):M!==!0&&H.d.push({key:S,description:M,type:P!=null?typeof P:void 0})}bindTo(S){return S.createKey(this.key,this.f)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return v.create(this.key,S)}notEqualsTo(S){return p.create(this.key,S)}}e.$1i=H,e.$2i=(0,L.$Ah)("contextKeyService");function V(q,S){return q<S?-1:q>S?1:0}function ee(q,S,P,M){return q<P?-1:q>P?1:S<M?-1:S>M?1:0}function ne(q,S){if(q.type===0||S.type===1)return!0;if(q.type===9)return S.type===9?se(q.expr,S.expr):!1;if(S.type===9){for(const P of S.expr)if(ne(q,P))return!0;return!1}if(q.type===6){if(S.type===6)return se(S.expr,q.expr);for(const P of q.expr)if(ne(P,S))return!0;return!1}return q.equals(S)}e.$3i=ne;function se(q,S){let P=0,M=0;for(;P<q.length&&M<S.length;){const T=q[P].cmp(S[M]);if(T<0)return!1;T===0&&P++,M++}return P===q.length}function Y(q){return q.type===9?q.expr:[q]}}),define(re[95],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hm=e.$gm=e.$fm=e.ID=void 0,e.ID="diagnosticsService",e.$fm=(0,O.$Ah)(e.ID);function N(L){return!!L.hostName&&!!L.errorMessage}e.$gm=N;class A{async getPerformanceInfo(j,R){return{}}async getSystemInfo(j,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(j,R){return""}async getWorkspaceFileExtensions(j){return{extensions:[]}}async reportWorkspaceStats(j){}}e.$hm=A}),define(re[96],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=void 0,e.$Cn=(0,O.$Ah)("downloadService")}),define(re[15],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=void 0,e.$Hh=(0,O.$Ah)("environmentService"),e.$Ih=(0,O.$Bh)(e.$Hh)}),define(re[29],oe([0,1,153,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Yn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0,e.$Ln="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Mn=new RegExp(e.$Ln),e.$Nn="__web_extension",e.$On="skipWalkthrough",e.$Pn="extensionsSync",e.$Qn="dependecyOrPackExtensionInstall";function A(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Rn=A;function L(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Sn=L;function j(l,w){switch(l){case 3:return w==="x64"?"win32-x64":w==="ia32"?"win32-ia32":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Tn=j;function R(l,w){return w==="web"&&!l.includes("web")}e.$Un=R;function k(l,w,m){return R(w,m)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===m?!0:$(m).includes(l)}e.$Vn=k;function $(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Wn=$;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$Xn=C;var E;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var d;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var h;(function(l){l.Install="install",l.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var g;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$Yn=(0,N.$Ah)("extensionGalleryService");var y;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var f;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class o extends Error{constructor(w,m){super(w),this.code=m,this.name=m}}e.$Zn=o,e.$1n=(0,N.$Ah)("extensionManagementService"),e.$2n="extensionsIdentifiers/disabled",e.$3n="extensionsIdentifiers/enabled",e.$4n=(0,N.$Ah)("IGlobalExtensionEnablementService"),e.$5n=(0,N.$Ah)("IExtensionTipsService"),e.$6n=(0,O.localize)(0,null),e.$7n={value:e.$6n,original:"Extensions"},e.$8n={value:(0,O.localize)(1,null),original:"Preferences"}}),define(re[188],oe([0,1,3,2,30,11,92,29]),function(te,e,O,N,A,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=void 0;function k(f,o){return f?L.URI.revive(o?o.transformIncoming(f):f):void 0}function $(f,o){return o?o.transformOutgoingURI(f):f}function C(f,o){o=o||j.$Bm;const l=f.manifest;return{...(0,j.$Em)({...f,manifest:void 0},o),manifest:l}}function E(f,o){return f?.profileLocation?(0,j.$Em)(f,o??j.$Bm):f}function d(f,o){return o?(0,A.$Wm)(f,l=>l instanceof L.URI?o.transformOutgoingURI(l):void 0):f}class h{constructor(o,l){this.a=o,this.b=l,this.onInstallExtension=O.Event.buffer(o.onInstallExtension,!0),this.onDidInstallExtensions=O.Event.buffer(o.onDidInstallExtensions,!0),this.onUninstallExtension=O.Event.buffer(o.onUninstallExtension,!0),this.onDidUninstallExtension=O.Event.buffer(o.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=O.Event.buffer(o.onDidUpdateExtensionMetadata,!0)}listen(o,l){const w=this.b(o);switch(l){case"onInstallExtension":return O.Event.map(this.onInstallExtension,m=>({...m,profileLocation:m.profileLocation?$(m.profileLocation,w):m.profileLocation}));case"onDidInstallExtensions":return O.Event.map(this.onDidInstallExtensions,m=>m.map(I=>({...I,local:I.local?d(I.local,w):I.local,profileLocation:I.profileLocation?$(I.profileLocation,w):I.profileLocation})));case"onUninstallExtension":return O.Event.map(this.onUninstallExtension,m=>({...m,profileLocation:m.profileLocation?$(m.profileLocation,w):m.profileLocation}));case"onDidUninstallExtension":return O.Event.map(this.onDidUninstallExtension,m=>({...m,profileLocation:m.profileLocation?$(m.profileLocation,w):m.profileLocation}));case"onDidUpdateExtensionMetadata":return O.Event.map(this.onDidUpdateExtensionMetadata,m=>d(m,w))}throw new Error("Invalid listen")}async call(o,l,w){const m=this.b(o);switch(l){case"zip":{const I=C(w[0],m),i=await this.a.zip(I);return $(i,m)}case"unzip":return this.a.unzip(k(w[0],m));case"install":return this.a.install(k(w[0],m),E(w[1],m));case"installFromLocation":return this.a.installFromLocation(k(w[0],m),k(w[1],m));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(w[0],k(w[1],m),k(w[2],m));case"getManifest":return this.a.getManifest(k(w[0],m));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(w[0]);case"installFromGallery":return this.a.installFromGallery(w[0],E(w[1],m));case"installGalleryExtensions":{const I=w[0];return this.a.installGalleryExtensions(I.map(({extension:i,options:c})=>({extension:i,options:E(c,m)??{}})))}case"uninstall":return this.a.uninstall(C(w[0],m),E(w[1],m));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(w[0],m));case"getInstalled":return(await this.a.getInstalled(w[0],k(w[1],m))).map(i=>d(i,m));case"toggleAppliationScope":{const I=await this.a.toggleAppliationScope(C(w[0],m),k(w[1],m));return d(I,m)}case"copyExtensions":return this.a.copyExtensions(k(w[0],m),k(w[1],m));case"updateMetadata":{const I=await this.a.updateMetadata(C(w[0],m),w[1],k(w[2],m));return d(I,m)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(w[0],w[1],w[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$9o=h;class g extends N.$jc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(o){super(),this.m=o,this.c=this.B(new O.$ed),this.f=this.B(new O.$ed),this.g=this.B(new O.$ed),this.h=this.B(new O.$ed),this.j=this.B(new O.$ed),this.B(this.m.listen("onInstallExtension")(l=>this.n(this.c,{...l,source:this.r(l.source)?L.URI.revive(l.source):l.source,profileLocation:L.URI.revive(l.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(l=>this.n(this.f,l.map(w=>({...w,local:w.local?C(w.local,null):w.local,source:this.r(w.source)?L.URI.revive(w.source):w.source,profileLocation:L.URI.revive(w.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(l=>this.n(this.g,{...l,profileLocation:L.URI.revive(l.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(l=>this.n(this.h,{...l,profileLocation:L.URI.revive(l.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(l=>this.j.fire(C(l,null))))}n(o,l){o.fire(l)}r(o){return o?typeof o.path=="string"&&typeof o.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(o){const l=await this.getTargetPlatform();return o.allTargetPlatforms.some(w=>(0,R.$Vn)(w,o.allTargetPlatforms,l))}zip(o){return Promise.resolve(this.m.call("zip",[o]).then(l=>L.URI.revive(l)))}unzip(o){return Promise.resolve(this.m.call("unzip",[o]))}install(o,l){return Promise.resolve(this.m.call("install",[o,l])).then(w=>C(w,null))}installFromLocation(o,l){return Promise.resolve(this.m.call("installFromLocation",[o,l])).then(w=>C(w,null))}async installExtensionsFromProfile(o,l,w){return(await this.m.call("installExtensionsFromProfile",[o,l,w])).map(I=>C(I,null))}getManifest(o){return Promise.resolve(this.m.call("getManifest",[o]))}installFromGallery(o,l){return Promise.resolve(this.m.call("installFromGallery",[o,l])).then(w=>C(w,null))}async installGalleryExtensions(o){return(await this.m.call("installGalleryExtensions",[o])).map(w=>({...w,local:w.local?C(w.local,null):w.local,source:this.r(w.source)?L.URI.revive(w.source):w.source,profileLocation:L.URI.revive(w.profileLocation)}))}uninstall(o,l){return Promise.resolve(this.m.call("uninstall",[o,l]))}reinstallFromGallery(o){return Promise.resolve(this.m.call("reinstallFromGallery",[o])).then(l=>C(l,null))}getInstalled(o=null,l){return Promise.resolve(this.m.call("getInstalled",[o,l])).then(w=>w.map(m=>C(m,null)))}updateMetadata(o,l,w){return Promise.resolve(this.m.call("updateMetadata",[o,l,w])).then(m=>C(m,null))}toggleAppliationScope(o,l){return this.m.call("toggleAppliationScope",[o,l]).then(w=>C(w,null))}copyExtensions(o,l){return this.m.call("copyExtensions",[o,l])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(o,l,w){const m=await this.m.call("download",[o,l,w]);return L.URI.revive(m)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$0o=g;class y{constructor(o){this.a=o}listen(o,l){throw new Error("Invalid listen")}call(o,l,w){switch(l){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$$o=y}),define(re[97],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=void 0,e.$6o=(0,O.$Ah)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((L,j)=>te(["node-vsce-sign"],async R=>L(R),j))),this.a}async verify(L,j,R){let k;try{k=await this.b()}catch{return!1}return k.verify(L,j,R)}}e.$7o=N}),define(re[98],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CUb=e.RecommendationsNotificationResult=e.$BUb=e.RecommendationSource=void 0;var N;(function(j){j[j.FILE=1]="FILE",j[j.WORKSPACE=2]="WORKSPACE",j[j.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function A(j){switch(j){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$BUb=A;var L;(function(j){j.Ignored="ignored",j.Cancelled="cancelled",j.TooMany="toomany",j.IncompatibleWindow="incompatibleWindow",j.Accepted="reacted"})(L||(e.RecommendationsNotificationResult=L={})),e.$CUb=(0,O.$Ah)("IExtensionRecommendationNotificationService")}),define(re[12],oe([0,1,47,16,27,9,11,160,4,6,23]),function(te,e,O,N,A,L,j,R,k,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileKind=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileOperationResult=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileChangeType=e.$jk=e.FileOperation=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileSystemProviderErrorCode=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$6j=e.$5j=void 0,e.$5j=(0,k.$Ah)("fileService");function E(V){return V.create===!0}e.$6j=E;var d;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var h;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var g;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function y(V){return!!(V.capabilities&2)}e.$7j=y;function f(V){return!!(V.capabilities&8)}e.$8j=f;function o(V){return!!(V.capabilities&131072)}e.$9j=o;function l(V){return!!(V.capabilities&4)}e.$0j=l;function w(V){return!!(V.capabilities&16)}e.$$j=w;function m(V){return y(V)?!!(V.capabilities&16384):!1}e.$_j=m;function I(V){return y(V)?!!(V.capabilities&32768):!1}e.$ak=I;function i(V){return!!(V.capabilities&65536)}e.$bk=i;function c(V){return!!(V.capabilities&2048)}e.$ck=c;var n;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(ee,ne){const se=new s(ee.toString(),ne);return a(se,ne),se}constructor(ee,ne){super(ee),this.code=ne}}e.$dk=s;function t(V,ee){return s.create(V,ee)}e.$ek=t;function r(V){return V||t((0,R.localize)(0,null),n.Unknown)}e.$fk=r;function a(V,ee){return V.name=ee?`${ee} (FileSystemError)`:"FileSystemError",V}e.$gk=a;function v(V){if(!V)return n.Unknown;if(V instanceof s)return V.code;const ee=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!ee)return n.Unknown;switch(ee[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$hk=v;function b(V){if(V instanceof U)return V.fileOperationResult;switch(v(V)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$ik=b;var u;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(u||(e.FileOperation=u={}));class p{constructor(ee,ne,se){this.resource=ee,this.operation=ne,this.target=se}isOperation(ee){return this.operation===ee}}e.$jk=p;var D;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(D||(e.FileChangeType=D={}));class F{constructor(ee,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const Y of ee){const q=se.get(Y.type);switch(q?q.push([Y.resource,Y]):se.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,q]of se)switch(Y){case 1:this.a=O.$Gh.forUris(()=>ne),this.a.fill(q);break;case 0:this.b=O.$Gh.forUris(()=>ne),this.b.fill(q);break;case 2:this.c=O.$Gh.forUris(()=>ne),this.c.fill(q);break}}contains(ee,...ne){return this.d(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.d(ee,{includeChildren:!0},...ne)}d(ee,ne,...se){if(!ee)return!1;const Y=se.length>0;return!!((!Y||se.includes(1))&&(this.a?.get(ee)||ne.includeChildren&&this.a?.findSuperstr(ee))||(!Y||se.includes(0))&&(this.b?.get(ee)||ne.includeChildren&&this.b?.findSuperstr(ee))||(!Y||se.includes(2))&&(this.c?.findSubstr(ee)||ne.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$kk=F;function z(V,ee,ne){return!V||!ee||V===ee||ee.length>V.length?!1:(ee.charAt(ee.length-1)!==N.sep&&(ee+=N.sep),ne?(0,A.$Me)(V,ee):V.indexOf(ee)===0)}e.$lk=z;class U extends Error{constructor(ee,ne,se){super(ee),this.fileOperationResult=ne,this.options=se}}e.$mk=U;class B extends U{constructor(ee,ne,se,Y){super(ee,ne,Y),this.fileOperationResult=ne,this.size=se}}e.$nk=B;class x extends U{constructor(ee,ne,se){super(ee,2,se),this.stat=ne}}e.$ok=x;var J;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$rk="files.associations",e.$sk="files.exclude",e.$tk="files.readonlyInclude",e.$uk="files.readonlyExclude",e.$vk="files.readonlyFromPermissions";var Q;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$wk="";function W(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$xk=W;async function Z(V,ee){if(!ee.hasProvider(j.URI.from({scheme:V.scheme})))return new Promise(ne=>{const se=ee.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===V.scheme&&Y.added&&(se.dispose(),ne())})})}e.$yk=Z;class G{static{this.KB=1024}static{this.MB=G.KB*G.KB}static{this.GB=G.MB*G.KB}static{this.TB=G.GB*G.KB}static formatSize(ee){return(0,L.$mf)(ee)||(ee=0),ee<G.KB?(0,R.localize)(1,null,ee.toFixed(0)):ee<G.MB?(0,R.localize)(2,null,(ee/G.KB).toFixed(2)):ee<G.GB?(0,R.localize)(3,null,(ee/G.MB).toFixed(2)):ee<G.TB?(0,R.localize)(4,null,(ee/G.GB).toFixed(2)):(0,R.localize)(5,null,(ee/G.TB).toFixed(2))}}e.$zk=G;function H(V){const ee=typeof V=="string"||V?.scheme===C.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===C.Schemas.file?1024*G.MB:ee?10*G.MB:$.$o?50*G.MB:1024*G.MB}e.$Ak=H});var X=this&&this.__param||function(te,e){return function(O,N){e(O,N,te)}};define(re[189],oe([0,1,69,42,12]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A7b=void 0;let L=class{constructor(R){this.a=R}async checksum(R){const k=(await this.a.readFileStream(R)).value;return new Promise(($,C)=>{const E=(0,O.createHash)("md5");(0,N.$wd)(k,{onData:d=>E.update(d.buffer),onError:d=>C(d),onEnd:()=>$(E.digest("base64").replace(/=+$/,""))})})}};e.$A7b=L,e.$A7b=L=ye([X(0,A.$5j)],L)}),define(re[190],oe([0,1,14,38,8,3,2,42,11,32,12]),function(te,e,O,N,A,L,j,R,k,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=void 0,e.$3M="localFilesystem";class E extends j.$jc{constructor(h,g){super(),this.a=h,this.b=g,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$ed),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$ed),this.onDidWatchError=this.g.event,this.h=(0,$.$3f)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,g){const{buffer:y}=await this.a.call("readFile",[h,g]);return y}readFileStream(h,g,y){const f=(0,R.$sd)(l=>O.$Ed.concat(l.map(w=>O.$Ed.wrap(w))).buffer),o=new j.$ic;return o.add(this.a.listen("readFileStream",[h,g])(l=>{if(l instanceof O.$Ed)f.write(l.buffer);else{if(l==="end")f.end();else{let w;if(l instanceof Error)w=l;else{const m=l;w=(0,C.$ek)(m.message??(0,N.$li)(m),m.code??C.FileSystemProviderErrorCode.Unknown)}f.error(w),f.end()}o.dispose()}})),o.add(y.onCancellationRequested(()=>{f.error((0,A.$4)()),f.end(),o.dispose()})),f}writeFile(h,g,y){return this.a.call("writeFile",[h,O.$Ed.wrap(g),y])}open(h,g){return this.a.call("open",[h,g])}close(h){return this.a.call("close",[h])}async read(h,g,y,f,o){const[l,w]=await this.a.call("read",[h,g,o]);return y.set(l.buffer.slice(0,w),f),w}write(h,g,y,f,o){return this.a.call("write",[h,g,O.$Ed.wrap(y),f,o])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,g){return this.a.call("delete",[h,g])}rename(h,g,y){return this.a.call("rename",[h,g,y])}copy(h,g,y){return this.a.call("copy",[h,g,y])}cloneFile(h,g){return this.a.call("cloneFile",[h,g])}j(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const g=h;this.f.fire(g.map(y=>({resource:k.URI.revive(y.resource),type:y.type})))}else{const g=h;this.g.fire(g)}}))}watch(h,g){const y=(0,$.$3f)();return this.a.call("watch",[this.h,y,h,g]),(0,j.$hc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$4M=E}),define(re[99],oe([0,1,14,8,161,12]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;async function j(C,E,d,h,g,y){let f;try{await R(C,E,d,h,g,y)}catch(o){f=o}finally{f&&g.errorTransformer&&(f=g.errorTransformer(f)),typeof f<"u"&&d.error(f),d.end()}}e.$Bp=j;async function R(C,E,d,h,g,y){k(y);const f=await C.open(E,{create:!1});try{k(y);let o=0,l=0,w=g&&typeof g.length=="number"?g.length:void 0,m=O.$Ed.alloc(Math.min(g.bufferSize,typeof w=="number"?w:g.bufferSize)),I=g&&typeof g.position=="number"?g.position:0,i=0;do l=await C.read(f,I,m.buffer,i,m.byteLength-i),I+=l,i+=l,o+=l,typeof w=="number"&&(w-=l),i===m.byteLength&&(await d.write(h(m)),m=O.$Ed.alloc(Math.min(g.bufferSize,typeof w=="number"?w:g.bufferSize)),i=0);while(l>0&&(typeof w!="number"||w>0)&&k(y)&&$(o,g));if(i>0){let c=i;typeof w=="number"&&(c=Math.min(i,w)),d.write(h(m.slice(0,c)))}}catch(o){throw(0,L.$fk)(o)}finally{await C.close(f)}}function k(C){if(C.isCancellationRequested)throw(0,N.$4)();return!0}function $(C,E){if(typeof E?.limits?.size=="number"&&C>E.limits.size)throw(0,L.$ek)((0,A.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[54],oe([0,1,91,2,16,6,11,12]),function(te,e,O,N,A,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=void 0;function k(o){return o.recursive===!0}e.$Dp=k;class $ extends N.$jc{static{this.a=5}constructor(l,w,m,I){super(),this.h=l,this.j=w,this.m=m,this.n=I,this.c=this.B(new N.$kc),this.f=void 0,this.g=0}s(){const l=new N.$ic;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(w=>this.h(w))),l.add(this.b.onDidLogMessage(w=>this.j(w))),l.add(this.b.onDidError(w=>this.t(w)))}t(l){this.n.restartOnError?this.g<$.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Ep=$;class C extends ${constructor(l,w,m){super(l,w,m,{type:"node.js",restartOnError:!1})}}e.$Fp=C;class E extends ${constructor(l,w,m){super(l,w,m,{type:"universal",restartOnError:!0})}}e.$Gp=E;function d(o){return o.map(l=>({type:l.type,resource:j.URI.file(l.path)}))}e.$Hp=d;function h(o){const l=new f;for(const w of o)l.processEvent(w);return l.coalesce()}e.$Ip=h;function g(o,l){return typeof l=="string"&&!l.startsWith(O.$mj)&&!(0,A.$7d)(l)?{base:o,pattern:l}:l}e.$Jp=g;function y(o,l){const w=[];for(const m of l)w.push((0,O.$qj)(g(o,m)));return w}e.$Kp=y;class f{constructor(){this.a=new Set,this.b=new Map}c(l){return L.$k?l.path:l.path.toLowerCase()}processEvent(l){const w=this.b.get(this.c(l));let m=!1;if(w){const I=w.type,i=l.type;w.path!==l.path&&(l.type===2||l.type===1)?m=!0:I===1&&i===2?(this.b.delete(this.c(l)),this.a.delete(w)):I===2&&i===1?w.type=0:I===1&&i===0||(w.type=i)}else m=!0;m&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],w=[];return Array.from(this.a).filter(m=>m.type!==2?(l.push(m),!1):!0).sort((m,I)=>m.path.length-I.path.length).filter(m=>w.some(I=>(0,R.$lk)(m.path,I,!L.$k))?!1:(w.push(m.path),!0)).concat(l)}}}),define(re[191],oe([0,1,52,5,26,48,2,88,16,6,144,31,54]),function(te,e,O,N,A,L,j,R,k,$,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0;class h extends j.$jc{static{this.a=100}static{this.b=75}constructor(f,o,l,w){super(),this.m=f,this.n=o,this.r=l,this.s=w,this.c=this.B(new N.$Ug({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},m=>this.n(m))),this.f=this.B(new N.$Tg(m=>this.z(m),h.b)),this.g=(0,d.$Kp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,d.$Kp)(this.m.path,this.m.includes):void 0,this.j=new A.$od,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const o=await E.Promises.stat(f);this.B(await this.w(f,o.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let o=f.path;try{o=await E.Promises.realpath(f.path),f.path===o&&(o=await(0,C.$Up)(f.path)??f.path),f.path!==o&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${o})`)}catch{}return o}async w(f,o){if($.$j&&(0,L.$Hf)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),j.$jc.None;const l=new A.$od(this.j.token),w=new j.$ic;try{const m=(0,k.$_d)(f),I=(0,O.watch)(f);w.add((0,j.$hc)(()=>{I.removeAllListeners(),I.close()})),this.G(`Started watching: '${f}'`);const i=new Set;if(o)try{for(const n of await E.Promises.readdir(f))i.add(n)}catch(n){this.D(n)}const c=new Map;w.add((0,j.$hc)(()=>{for(const[,n]of c)n.dispose();c.clear()})),I.on("error",(n,s)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),I.on("change",(n,s)=>{if(l.token.isCancellationRequested)return;this.G(`[raw] ["${n}"] ${s}`);let t="";if(s&&(t=s.toString(),$.$j&&(t=(0,R.$gl)(t))),!(!t||n!=="change"&&n!=="rename"))if(o)if(n==="rename"){c.get(t)?.dispose();const r=setTimeout(async()=>{if(c.delete(t),t===m&&!await E.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.C((0,k.$8d)(f,t));if(l.token.isCancellationRequested)return;let v;a?i.has(t)?v=0:(v=1,i.add(t)):(i.delete(t),v=2),this.y({path:(0,k.$8d)(this.m.path,t),type:v})},h.a);c.set(t,(0,j.$hc)(()=>clearTimeout(r)))}else{let r;i.has(t)?r=0:(r=1,i.add(t)),this.y({path:(0,k.$8d)(this.m.path,t),type:r})}else if(n==="rename"||t!==m){const r=setTimeout(async()=>{const a=await E.Promises.exists(f);l.token.isCancellationRequested||(a?(this.y({path:this.m.path,type:0},!0),w.add(await this.w(f,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);w.clear(),w.add((0,j.$hc)(()=>clearTimeout(r)))}else this.y({path:this.m.path,type:0},!0)})}catch(m){await E.Promises.exists(f)&&!l.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${m.toString()})`)}return(0,j.$hc)(()=>{l.dispose(!0),w.dispose()})}y(f,o=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),!o&&this.g.some(l=>l(f.path))?this.s&&this.G(` >> ignored (excluded) ${f.path}`):!o&&this.h&&this.h.length>0&&!this.h.some(l=>l(f.path))?this.s&&this.G(` >> ignored (not included) ${f.path}`):this.f.work(f))}z(f){const o=(0,d.$Ip)(f);if(o.length>0){if(this.s)for(const w of o)this.G(`>> normalized ${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`);this.c.work(o)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if($.$k)return E.Promises.exists(f);try{const o=(0,k.$_d)(f);return(await E.Promises.readdir((0,k.$$d)(f))).some(w=>w===o)}catch(o){return this.G(o),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Xp=h;async function g(y,f,o,l,w=512){const m=await E.Promises.open(y,"r"),I=Buffer.allocUnsafe(w),i=new A.$od(l);let c,n=!1;const s={path:y,excludes:[],recursive:!1},t=new h(s,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:v}=await E.Promises.read(m,I,0,w,null);if(!v||i.token.isCancellationRequested)break;f(I.slice(0,v))}}catch(v){c=new Error(v),i.dispose(!0)}finally{n=!1}}})()});return await t.ready,o(),new Promise((r,a)=>{i.token.onCancellationRequested(async()=>{t.dispose();try{await E.Promises.close(m)}catch(v){c=new Error(v)}c?a(c):r()})})}e.$Yp=g}),define(re[192],oe([0,1,3,91,2,6,191]),function(te,e,O,N,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;class R extends A.$jc{constructor(){super(...arguments),this.a=this.B(new O.$ed),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$ed),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch($){const C=this.j($),E=C.filter(h=>{const g=this.c.get(h.path);return g?!(0,N.$uj)(g.request.excludes,h.excludes)||!(0,N.$uj)(g.request.includes,h.includes):!0}),d=Array.from(this.c.values()).filter(({request:h})=>!C.find(g=>g.path===h.path&&(0,N.$uj)(g.excludes,h.excludes)&&(0,N.$uj)(g.includes,h.includes))).map(({request:h})=>h.path);E.length&&this.m(`Request to start watching: ${E.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const h of d)this.h(h);for(const h of E)this.g(h)}g($){const C=new j.$Xp($,d=>this.a.fire(d),d=>this.b.fire(d),this.f),E={request:$,instance:C};this.c.set($.path,E)}async stop(){for(const[$]of this.c)this.h($);this.c.clear()}h($){const C=this.c.get($);C&&(this.c.delete($),C.instance.dispose())}j($){const C=new Map;for(const E of $){const d=L.$k?E.path:E.path.toLowerCase();C.set(d,E)}return Array.from(C.values())}async setVerboseLogging($){this.f=$;for(const[,C]of this.c)C.instance.setVerboseLogging($)}m($){this.f&&this.b.fire({type:"trace",message:this.n($)})}n($,C){return C?`[File Watcher (node.js)] ${$} (path: ${C.request.path})`:`[File Watcher (node.js)] ${$}`}}e.$Zp=R}),define(re[193],oe([0,1,54,192]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class A extends O.$Fp{constructor(j,R,k){super(j,R,k),this.s()}r(j){return j.add(new N.$Zp)}}e.$1p=A}),define(re[194],oe([0,1,23,43,93,54]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class j extends L.$Gp{constructor(k,$,C){super(k,$,C),this.s()}r(k){const $=k.add(new A.$Rp(O.$1f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add($.onDidProcessExit(({code:C,signal:E})=>this.t(`terminated by itself with code ${C}, signal: ${E}`))),N.ProxyChannel.toService((0,N.$hh)($.getChannel("watcher")))}}e.$Sp=j}),define(re[70],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class O{constructor(...A){this.a=new Map;for(const[L,j]of A)this.set(L,j)}set(A,L){const j=this.a.get(A);return this.a.set(A,L),j}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$yh=O}),define(re[195],oe([0,1,5,8,2,68,186,4,70,87]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;const C=!1;class E extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class d{constructor(f=new k.$yh,o=!1,l,w=C){this.f=f,this.g=o,this.h=l,this.i=w,this.o=new Set,this.f.set(R.$zh,this),this._globalGraph=w?l?._globalGraph??new j.$4p(m=>m):void 0}createChild(f){return new d(f,this.g,this,this.i)}invokeFunction(f,...o){const l=g.traceInvocation(this.i,f);let w=!1;try{return f({get:I=>{if(w)throw(0,N.$6)("service accessor is only valid during the invocation of its target method");const i=this.m(I,l);if(!i)throw new Error(`[invokeFunction] unknown service '${I}'`);return i}},...o)}finally{w=!0,l.stop()}}createInstance(f,...o){let l,w;return f instanceof L.$xh?(l=g.traceCreation(this.i,f.ctor),w=this.j(f.ctor,f.staticArguments.concat(o),l)):(l=g.traceCreation(this.i,f),w=this.j(f,o,l)),l.stop(),w}j(f,o=[],l){const w=R._util.getServiceDependencies(f).sort((i,c)=>i.index-c.index),m=[];for(const i of w){const c=this.m(i.id,l);c||this.u(`[createInstance] ${f.name} depends on UNKNOWN service ${i.id}.`,!1),m.push(c)}const I=w.length>0?w[0].index:o.length;if(o.length!==I){console.trace(`[createInstance] First service dependency of ${f.name} at position ${I+1} conflicts with ${o.length} static arguments`);const i=I-o.length;i>0?o=o.concat(new Array(i)):o=o.slice(0,I)}return Reflect.construct(f,o.concat(m))}k(f,o){if(this.f.get(f)instanceof L.$xh)this.f.set(f,o);else if(this.h)this.h.k(f,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(f){const o=this.f.get(f);return!o&&this.h?this.h.l(f):o}m(f,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const l=this.l(f);return l instanceof L.$xh?this.q(f,l,o.branch(f,!0)):(o.branch(f,!1),l)}q(f,o,l){if(this.o.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.o.add(f);try{return this.r(f,o,l)}finally{this.o.delete(f)}}r(f,o,l){const w=new j.$4p(i=>i.id.toString());let m=0;const I=[{id:f,desc:o,_trace:l}];for(;I.length;){const i=I.pop();if(w.lookupOrInsertNode(i),m++>1e3)throw new E(w);for(const c of R._util.getServiceDependencies(i.desc.ctor)){const n=this.l(c.id);if(n||this.u(`[createInstance] ${f} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(c.id)),n instanceof L.$xh){const s={id:c.id,desc:n,_trace:i._trace.branch(c.id,!0)};w.insertEdge(i,s),I.push(s)}}}for(;;){const i=w.roots();if(i.length===0){if(!w.isEmpty())throw new E(w);break}for(const{data:c}of i){if(this.l(c.id)instanceof L.$xh){const s=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,s)}w.removeNode(c)}}return this.l(f)}s(f,o,l=[],w,m){if(this.f.get(f)instanceof L.$xh)return this.t(f,o,l,w,m);if(this.h)return this.h.s(f,o,l,w,m);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(f,o,l=[],w,m){if(w){const I=new d(void 0,this.g,this,this.i);I.c=String(f);const i=new Map,c=new O.$Wg(()=>{const n=I.j(o,l,m);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)r.apply(n,a)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!c.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new $.$sc,i.set(s,a)),(b,u,p)=>{const D=a.push([b,u,p]);return(0,A.$hc)(D)}}if(s in n)return n[s];const t=c.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return c.value[s]=t,!0},getPrototypeOf(n){return o.prototype}})}else return this.j(o,l,m)}u(f,o){if(o&&console.warn(f),this.g)throw new Error(f)}}e.$5p=d;var h;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(h||(h={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,o){return f?new g(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(f,o){return f?new g(1,o.name):g.c}static{this.f=0}constructor(f,o){this.type=f,this.name=o,this.g=Date.now(),this.h=[]}branch(f,o){const l=new g(3,f.toString());return this.h.push([f,o,l]),l}stop(){const f=Date.now()-this.g;g.f+=f;let o=!1;function l(m,I){const i=[],c=new Array(m+1).join("	");for(const[n,s,t]of I.h)if(s&&t){o=!0,i.push(`${c}CREATES -> ${n}`);const r=l(m+1,t);r&&i.push(r)}else i.push(`${c}uses -> ${n}`);return i.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(f>2||o)&&g.all.add(w.join(`
`))}}e.$6p=g}),define(re[71],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$6b=e.$06b=void 0,e.$06b=(0,O.$Ah)("mainProcessService");class N{constructor(L,j){this.a=L,this.b=j}getChannel(L){return this.a.getChannel(L,this.b)}registerChannel(L,j){this.a.registerChannel(L,j)}}e.$$6b=N}),define(re[72],oe([0,1,26,2,6,163,29,4]),function(te,e,O,N,A,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=e.$Hq=e.$Gq=void 0;function k(C){return C.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$Gq=k,e.$Hq=(0,R.$Ah)("languagePackService");let $=class extends N.$jc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new O.$od;setTimeout(()=>E.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const g=d.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(f=>f.startsWith("lp-"))).map(y=>{const f=y.properties.localizedLanguages?.[0],o=k(y);return{...this.f(o,f,y),extensionId:y.identifier.id,galleryExtension:y}});return g.push(this.f("en","English")),g}f(E,d,h){const g=d??E;let y;if(g!==E&&(y=`(${E})`),E.toLowerCase()===A.$v.toLowerCase()&&(y??="",y+=(0,L.localize)(0,null)),h?.installCount){y??="";const f=h.installCount;let o;f>1e6?o=`${Math.floor(f/1e5)/10}M`:f>1e3?o=`${Math.floor(f/1e3)}K`:o=String(f),y+=` $(cloud-download) ${o}`}return{id:E,label:g,description:y}}};e.$Iq=$,e.$Iq=$=ye([X(0,j.$Yn)],$)}),define(re[196],oe([0,1,2,72]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0;let A=class extends O.$jc{constructor(j){super(),this.a=j,this.b()}b(){this.a.update()}};e.$w7b=A,e.$w7b=A=ye([X(0,N.$Hq)],A)}),define(re[7],oe([0,1,38,3,51,2,35,6,21,9,11,94,4]),function(te,e,O,N,A,L,j,R,k,$,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.log=e.$7i=e.LogLevel=e.$6i=e.$5i=e.$4i=void 0,e.$4i=(0,d.$Ah)("logService"),e.$5i=(0,d.$Ah)("loggerService");function h(){return new Date().toISOString()}function g(b){return(0,$.$mf)(b)}e.$6i=g;var y;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$7i=y.Info;function f(b,u,p){switch(u){case y.Trace:b.trace(p);break;case y.Debug:b.debug(p);break;case y.Info:b.info(p);break;case y.Warning:b.warn(p);break;case y.Error:b.error(p);break;case y.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=f;function o(b,u=!1){let p="";for(let D=0;D<b.length;D++){let F=b[D];if(F instanceof Error&&(F=(0,O.$li)(F,u)),typeof F=="object")try{F=JSON.stringify(F)}catch{}p+=(D>0?" ":"")+F}return p}class l extends L.$jc{constructor(){super(...arguments),this.b=e.$7i,this.c=this.B(new N.$ed),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==y.Off&&this.b<=u}}e.$9i=l;class w extends l{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...p){this.f(y.Trace)&&this.g(y.Trace,o([u,...p],!0))}debug(u,...p){this.f(y.Debug)&&this.g(y.Debug,o([u,...p]))}info(u,...p){this.f(y.Info)&&this.g(y.Info,o([u,...p]))}warn(u,...p){this.f(y.Warning)&&this.g(y.Warning,o([u,...p]))}error(u,...p){if(this.f(y.Error))if(u instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=u.stack,this.g(y.Error,o(D))}else this.g(y.Error,o([u,...p]))}flush(){}}e.$0i=w;class m extends l{constructor(u=e.$7i){super(),this.setLevel(u),this.g=!R.$i}trace(u,...p){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...p):console.log(`[main ${h()}]`,u,...p))}debug(u,...p){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...p):console.log(`[main ${h()}]`,u,...p))}info(u,...p){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,u,...p):console.log(`[main ${h()}]`,u,...p))}warn(u,...p){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,u,...p):console.warn(`[main ${h()}]`,u,...p))}error(u,...p){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,u,...p):console.error(`[main ${h()}]`,u,...p))}dispose(){}flush(){}}e.$$i=m;class I extends l{constructor(u=e.$7i,p=!0){super(),this.g=p,this.setLevel(u)}trace(u,...p){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...p):console.log(u,...p))}debug(u,...p){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...p):console.log(u,...p))}info(u,...p){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...p):console.log(u,...p))}warn(u,...p){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...p):console.log(u,...p))}error(u,...p){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...p):console.error(u,...p))}dispose(){}flush(){}}e.$_i=I;class i extends l{constructor(u,p=e.$7i){super(),this.g=u,this.setLevel(p)}trace(u,...p){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(u),...p])}debug(u,...p){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(u),...p])}info(u,...p){this.f(y.Info)&&this.g.log(y.Info,[this.h(u),...p])}warn(u,...p){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(u),...p])}error(u,...p){this.f(y.Error)&&this.g.log(y.Error,[this.h(u),...p])}h(u){return typeof u=="string"?u:(0,O.$li)(u,this.f(y.Trace))}dispose(){}flush(){}}e.$aj=i;class c extends l{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const p of this.g)p.setLevel(u);super.setLevel(u)}trace(u,...p){for(const D of this.g)D.trace(u,...p)}debug(u,...p){for(const D of this.g)D.debug(u,...p)}info(u,...p){for(const D of this.g)D.info(u,...p)}warn(u,...p){for(const D of this.g)D.warn(u,...p)}error(u,...p){for(const D of this.g)D.error(u,...p)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.$bj=c;class n extends L.$jc{constructor(u,p,D){if(super(),this.h=u,this.j=p,this.b=new j.$yi,this.c=this.B(new N.$ed),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$ed),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$ed),this.onDidChangeVisibility=this.g.event,D)for(const F of D)this.b.set(F.resource,{logger:void 0,info:F})}m(u){return(0,$.$if)(u)?[...this.b.values()].find(p=>p.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,p){const D=this.n(u),F=(0,$.$if)(u)?u:p?.id??(0,A.$oi)(D.toString()).toString(16);let z=this.b.get(D)?.logger;const U=p?.logLevel==="always"?y.Trace:p?.logLevel;z||(z=this.s(D,U??this.getLogLevel(D)??this.h,{...p,id:F}));const B={logger:z,info:{resource:D,id:F,logLevel:U,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(B.info),this.b.set(D,B),z}n(u){return(0,$.$if)(u)?(0,k.$hg)(this.j,`${u}.log`):u}setLogLevel(u,p){if(C.URI.isUri(u)){const D=u,F=p,z=this.b.get(D);z&&F!==z.info.logLevel&&(z.info.logLevel=F===this.h?void 0:F,z.logger?.setLevel(F),this.b.set(z.info.resource,z),this.f.fire([D,F]))}else{this.h=u;for(const[D,F]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,p){const D=this.m(u);D&&p!==!D.info.hidden&&(D.info.hidden=!p,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,p]))}getLogLevel(u){let p;return u&&(p=this.b.get(u)?.info.logLevel),p??this.h}registerLogger(u){const p=this.b.get(u.resource);p?p.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const p=this.b.get(u);p&&(p.logger&&p.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$cj=n;class s{constructor(){this.onDidChangeLogLevel=new N.$ed().event}setLevel(u){}getLevel(){return y.Info}trace(u,...p){}debug(u,...p){}info(u,...p){}warn(u,...p){}error(u,...p){}critical(u,...p){}dispose(){}flush(){}}e.$dj=s;class t extends s{}e.$ej=t;function r(b){if(b.verbose)return y.Trace;if(typeof b.logLevel=="string"){const u=v(b.logLevel.toLowerCase());if(u!==void 0)return u}return e.$7i}e.$fj=r;function a(b){switch(b){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$gj=a;function v(b){switch(b){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$hj=v,e.$ij=new E.$1i("logLevel",a(y.Info))}),define(re[197],oe([0,1,5,8,2,23,16,21,31,15,7]),function(te,e,O,N,A,L,j,R,k,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x7b=void 0;let E=class extends A.$jc{constructor(h,g){super(),this.a=h,this.b=g,this.B(new O.$Rg(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const h=(0,R.$eg)(this.a.logsHome),g=(0,R.$gg)(this.a.logsHome.with({scheme:L.Schemas.file})).fsPath,o=(await k.Promises.readdir(g)).filter(w=>/^\d{8}T\d{6}$/.test(w)).sort().filter(w=>w!==h),l=o.slice(0,Math.max(0,o.length-9));l.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${l.join(", ")}'`),await Promise.all(l.map(w=>k.Promises.rm((0,j.$8d)(g,w)))))}catch(h){(0,N.$Y)(h)}}};e.$x7b=E,e.$x7b=E=ye([X(0,$.$Hh),X(1,C.$4i)],E)}),define(re[198],oe([0,1,18,5,8,3,2,16,54,7]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class C extends j.$jc{constructor(d,h){super(),this.a=d,this.b=h,this.c=this.B(new L.$ed),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$ed),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Dg(0)),this.w=[],this.y=this.B(new N.$Dg(0))}watch(d,h){return h.recursive||this.b?.watcher?.forceUniversal?this.n(d,h):this.z(d,h)}n(d,h){const g={path:this.H(d),excludes:h.excludes,includes:h.includes,recursive:h.recursive},y=(0,O.$Rb)(this.j,g);return this.r(),(0,j.$hc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,A.$Y)(d))}s(){this.h||(this.h=this.B(this.t(h=>this.c.fire((0,k.$Hp)(h)),h=>this.G(h),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const h of this.j)(0,k.$Dp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const h of this.j)(0,k.$Dp)(h)&&d.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,h){const g={path:this.H(d),excludes:h.excludes,includes:h.includes,recursive:!1},y=(0,O.$Rb)(this.w,g);return this.C(),(0,j.$hc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,A.$Y)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,k.$Hp)(d)),d=>this.G(d),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,R.$6d)(d.fsPath)}}e.$Lp=C}),define(re[199],oe([0,1,18,5,14,26,3,51,59,2,47,23,100,21,42,159,12,99,7,8]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;let m=class extends $.$jc{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new j.$ed),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$ed),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$ed),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$ed),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$ed),this.onDidFilesChange=this.X.event,this.Y=this.B(new j.$ed),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new N.$Og)}registerProvider(i,c){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${i}`);const n=new $.$ic;return this.h.set(i,c),this.c.fire({added:!0,scheme:i,provider:c}),n.add(c.onDidChangeFile(s=>this.X.fire(new f.$kk(s,!this.S(c))))),typeof c.onDidWatchError=="function"&&n.add(c.onDidWatchError(s=>this.Y.fire(new Error(s)))),n.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:i}))),(0,$.$hc)(()=>{this.c.fire({added:!1,scheme:i,provider:c}),this.h.delete(i),(0,$.$ec)(n)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const c=[];this.f.fire({scheme:i,join(n){c.push(n)}}),!this.h.has(i)&&await N.Promises.settled(c)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,c){const n=this.h.get(i.scheme);return!!(n&&n.capabilities&c)}listCapabilities(){return k.Iterable.map(this.h,([i,c])=>({scheme:i,capabilities:c.capabilities}))}async j(i){if(!(0,h.$lg)(i))throw new f.$mk((0,y.localize)(0,null,this.rb(i)),8);await this.activateProvider(i.scheme);const c=this.h.get(i.scheme);if(!c){const n=new w.$_;throw n.message=(0,y.localize)(1,null,i.toString()),n}return c}async m(i){const c=await this.j(i);if((0,f.$0j)(c)||(0,f.$7j)(c)||(0,f.$$j)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const c=await this.j(i);if((0,f.$0j)(c)||(0,f.$7j)(c))return c;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,c){try{return await this.s(i,c)}catch(n){throw(0,f.$hk)(n)===f.FileSystemProviderErrorCode.FileNotFound?new f.$mk((0,y.localize)(2,null,this.rb(i)),1):(0,f.$fk)(n)}}async s(i,c){const n=await this.j(i),s=this.S(n),t=c?.resolveTo,r=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,v=await n.stat(i);let b;return this.t(n,i,v,void 0,!!a,(u,p)=>(b||(b=C.$Gh.forUris(()=>!s),b.set(i,!0),t&&b.fill(!0,t)),b.get(u.resource)||b.findSuperstr(u.resource.with({query:null,fragment:null}))?!0:u.isDirectory&&r?p===1:!1))}async t(i,c,n,s,t,r){const{providerExtUri:a}=this.R(i),v={resource:c,name:a.basename(c),isFile:(n.type&f.FileType.File)!==0,isDirectory:(n.type&f.FileType.Directory)!==0,isSymbolicLink:(n.type&f.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&f.FilePermission.Readonly)||!!(i.capabilities&2048),locked:!!((n.permissions??0)&f.FilePermission.Locked),etag:(0,f.$xk)({mtime:n.mtime,size:n.size}),children:void 0};if(v.isDirectory&&r(v,s)){try{const b=await i.readdir(c),u=await N.Promises.settled(b.map(async([p,D])=>{try{const F=a.joinPath(c,p),z=t?await i.stat(F):{type:D};return await this.t(i,F,z,b.length,t,r)}catch(F){return this.b.trace(F),null}}));v.children=(0,O.$Eb)(u)}catch(b){this.b.trace(b),v.children=[]}return v}return v}async resolveAll(i){return N.Promises.settled(i.map(async c=>{try{return{stat:await this.s(c.resource,c.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(i){const c=await this.j(i),n=await c.stat(i);return this.t(c,i,n,void 0,!0,()=>!1)}async exists(i){const c=await this.j(i);try{return!!await c.stat(i)}catch{return!1}}async canCreateFile(i,c){try{await this.u(i,c)}catch(n){return n}return!0}async u(i,c){if(!c?.overwrite&&await this.exists(i))throw new f.$mk((0,y.localize)(3,null,this.rb(i)),3,c)}async createFile(i,c=A.$Ed.fromString(""),n){await this.u(i,n);const s=await this.writeFile(i,c);return this.r.fire(new f.$jk(i,0,s)),s}async writeFile(i,c,n){const s=this.pb(await this.n(i),i),{providerExtUri:t}=this.R(s);try{await this.w(s,i,n)||await this.U(s,t.dirname(i));let a;if((0,f.$7j)(s)&&!(c instanceof A.$Ed))if((0,g.$qd)(c)){const v=await(0,g.$xd)(c,3);v.ended?a=A.$Ed.concat(v.buffer):a=v}else a=(0,g.$ud)(c,v=>A.$Ed.concat(v),3);else a=c;if(!(0,f.$0j)(s)||(0,f.$7j)(s)&&a instanceof A.$Ed)await this.gb(s,i,n,a);else{const v=a instanceof A.$Ed?(0,A.$Pd)(a):a;n?.atomic!==!1&&n?.atomic?.postfix?await this.bb(s,i,(0,h.$hg)((0,h.$gg)(i),`${(0,h.$eg)(i)}${n.atomic.postfix}`),n,v):await this.cb(s,i,n,v)}this.r.fire(new f.$jk(i,4))}catch(r){throw new f.$mk((0,y.localize)(4,null,this.rb(i),(0,f.$fk)(r).toString()),(0,f.$ik)(r),n)}return this.resolve(i,{resolveMetadata:!0})}async w(i,c,n){const s=!!n?.unlock;if(s&&!(i.capabilities&8192))throw new Error((0,y.localize)(5,null,this.rb(c)));if(!!n?.atomic){if(!(i.capabilities&32768))throw new Error((0,y.localize)(6,null,this.rb(c)));if(s)throw new Error((0,y.localize)(7,null,this.rb(c)))}let r;try{r=await i.stat(c)}catch{return}if(r.type&f.FileType.Directory)throw new f.$mk((0,y.localize)(8,null,this.rb(c)),0,n);if(this.qb(c,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==f.$wk&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,f.$xk)({mtime:n.mtime,size:r.size}))throw new f.$mk((0,y.localize)(9,null),3,n);return r}async readFile(i,c,n){const s=await this.m(i);return c?.atomic?this.z(s,i,c,n):this.C(s,i,c,n)}async z(i,c,n,s){return new Promise((t,r)=>{this.ab.queueFor(c,this.R(i).providerExtUri).queue(async()=>{try{const a=await this.C(i,c,n,s);t(a)}catch(a){r(a)}})})}async C(i,c,n,s){const t=await this.D(i,c,{...n,preferUnbuffered:!0},s);return{...t,value:await(0,A.$Qd)(t.value)}}async readFileStream(i,c,n){const s=await this.m(i);return this.D(s,i,c,n)}async D(i,c,n,s){const t=new L.$od(s),r=this.J(c,n).then(v=>v,v=>{throw t.dispose(!0),v});let a;try{return typeof n?.etag=="string"&&n.etag!==f.$wk&&await r,n?.atomic&&(0,f.$_j)(i)||!((0,f.$0j)(i)||(0,f.$$j)(i))||(0,f.$7j)(i)&&n?.preferUnbuffered?a=this.I(i,c,n):(0,f.$$j)(i)?a=this.G(i,c,t.token,n):a=this.H(i,c,t.token,n),a.on("end",()=>t.dispose()),a.on("error",()=>t.dispose()),{...await r,value:a}}catch(v){throw a&&await(0,g.$vd)(a),this.F(v,c,n)}}F(i,c,n){const s=(0,y.localize)(10,null,this.rb(c),(0,f.$fk)(i).toString());return i instanceof f.$ok?new f.$ok(s,i.stat,n):i instanceof f.$nk?new f.$nk(s,i.fileOperationResult,i.size,i.options):new f.$mk(s,(0,f.$ik)(i),n)}G(i,c,n,s=Object.create(null)){const t=i.readFileStream(c,s,n);return(0,g.$Bd)(t,{data:r=>r instanceof A.$Ed?r:A.$Ed.wrap(r),error:r=>this.F(r,c,s)},r=>A.$Ed.concat(r))}H(i,c,n,s=Object.create(null)){const t=(0,A.$Ud)();return(0,o.$Bp)(i,c,t,r=>r,{...s,bufferSize:this.a,errorTransformer:r=>this.F(r,c,s)},n),t}I(i,c,n){const s=(0,g.$sd)(t=>A.$Ed.concat(t));return(async()=>{try{let t;n?.atomic&&(0,f.$_j)(i)?t=await i.readFile(c,{atomic:!0}):t=await i.readFile(c),typeof n?.position=="number"&&(t=t.slice(n.position)),typeof n?.length=="number"&&(t=t.slice(0,n.length)),this.L(c,t.byteLength,n),s.end(A.$Ed.wrap(t))}catch(t){s.error(t),s.end()}})(),s}async J(i,c){const n=await this.resolve(i,{resolveMetadata:!0});if(n.isDirectory)throw new f.$mk((0,y.localize)(11,null,this.rb(i)),0,c);if(typeof c?.etag=="string"&&c.etag!==f.$wk&&c.etag===n.etag)throw new f.$ok((0,y.localize)(12,null),n,c);return this.L(i,n.size,c),n}L(i,c,n){if(typeof n?.limits?.size=="number"&&c>n.limits.size)throw new f.$nk((0,y.localize)(13,null,this.rb(i)),7,c,n)}async canMove(i,c,n){return this.M(i,c,"move",n)}async canCopy(i,c,n){return this.M(i,c,"copy",n)}async M(i,c,n,s){if(i.toString()!==c.toString())try{const t=n==="move"?this.pb(await this.n(i),i):await this.m(i),r=this.pb(await this.n(c),c);await this.Q(t,i,r,c,n,s)}catch(t){return t}return!0}async move(i,c,n){const s=this.pb(await this.n(i),i),t=this.pb(await this.n(c),c),r=await this.N(s,i,t,c,"move",!!n),a=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new f.$jk(i,r==="move"?2:3,a)),a}async copy(i,c,n){const s=await this.m(i),t=this.pb(await this.n(c),c),r=await this.N(s,i,t,c,"copy",!!n),a=await this.resolve(c,{resolveMetadata:!0});return this.r.fire(new f.$jk(i,r==="copy"?3:2,a)),a}async N(i,c,n,s,t,r){if(c.toString()===s.toString())return t;const{exists:a,isSameResourceWithDifferentPathCase:v}=await this.Q(i,c,n,s,t,r);if(a&&!v&&r&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),t==="copy"){if(i===n&&(0,f.$8j)(i))await i.copy(c,s,{overwrite:r});else{const b=await this.resolve(c);b.isDirectory?await this.P(i,b,n,s):await this.O(i,c,n,s)}return t}else return i===n?(await i.rename(c,s,{overwrite:r}),t):(await this.N(i,c,n,s,"copy",r),await this.del(c,{recursive:!0}),"copy")}async O(i,c,n,s){if((0,f.$0j)(i)&&(0,f.$0j)(n))return this.ib(i,c,n,s);if((0,f.$0j)(i)&&(0,f.$7j)(n))return this.ob(i,c,n,s);if((0,f.$7j)(i)&&(0,f.$0j)(n))return this.mb(i,c,n,s);if((0,f.$7j)(i)&&(0,f.$7j)(n))return this.kb(i,c,n,s)}async P(i,c,n,s){await n.mkdir(s),Array.isArray(c.children)&&await N.Promises.settled(c.children.map(async t=>{const r=this.R(n).providerExtUri.joinPath(s,t.name);return t.isDirectory?this.P(i,await this.resolve(t.resource),n,r):this.O(i,t.resource,n,r)}))}async Q(i,c,n,s,t,r){let a=!1;if(i===n){const{providerExtUri:b,isPathCaseSensitive:u}=this.R(i);if(u||(a=b.isEqual(c,s)),a&&t==="copy")throw new Error((0,y.localize)(14,null,this.rb(c),this.rb(s)));if(!a&&b.isEqualOrParent(s,c))throw new Error((0,y.localize)(15,null,this.rb(c),this.rb(s)))}const v=await this.exists(s);if(v&&!a){if(!r)throw new f.$mk((0,y.localize)(16,null,this.rb(c),this.rb(s)),4);if(i===n){const{providerExtUri:b}=this.R(i);if(b.isEqualOrParent(c,s))throw new Error((0,y.localize)(17,null,this.rb(c),this.rb(s)))}}return{exists:v,isSameResourceWithDifferentPathCase:a}}R(i){const c=this.S(i);return{providerExtUri:c?h.$0f:h.$_f,isPathCaseSensitive:c}}S(i){return!!(i.capabilities&1024)}async createFolder(i){const c=this.pb(await this.j(i),i);await this.U(c,i);const n=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new f.$jk(i,0,n)),n}async U(i,c){const n=[],{providerExtUri:s}=this.R(i);for(;!s.isEqual(c,s.dirname(c));)try{if(!((await i.stat(c)).type&f.FileType.Directory))throw new Error((0,y.localize)(18,null,this.rb(c)));break}catch(t){if((0,f.$hk)(t)!==f.FileSystemProviderErrorCode.FileNotFound)throw t;n.push(s.basename(c)),c=s.dirname(c)}for(let t=n.length-1;t>=0;t--){c=s.joinPath(c,n[t]);try{await i.mkdir(c)}catch(r){if((0,f.$hk)(r)!==f.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(i,c){try{await this.W(i,c)}catch(n){return n}return!0}async W(i,c){const n=this.pb(await this.j(i),i),s=!!c?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,y.localize)(19,null,this.rb(i)));const t=c?.atomic;if(t&&!(n.capabilities&65536))throw new Error((0,y.localize)(20,null,this.rb(i)));if(s&&t)throw new Error((0,y.localize)(21,null,this.rb(i)));let r;try{r=await n.stat(i)}catch{}if(r)this.qb(i,r);else throw new f.$mk((0,y.localize)(22,null,this.rb(i)),1);if(!!!c?.recursive){const v=await this.resolve(i);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,y.localize)(23,null,this.rb(i)))}return n}async del(i,c){const n=await this.W(i,c),s=!!c?.useTrash,t=!!c?.recursive,r=c?.atomic??!1;await n.delete(i,{recursive:t,useTrash:s,atomic:r}),this.r.fire(new f.$jk(i,1))}async cloneFile(i,c){const n=await this.j(i),s=this.pb(await this.n(c),c);if(n===s&&this.R(n).providerExtUri.isEqual(i,c))return;if(n===s&&(0,f.$9j)(n))return n.cloneFile(i,c);await this.U(s,this.R(s).providerExtUri.dirname(c));const t=this.ab.queueFor(i,this.R(n).providerExtUri);return n===s&&(0,f.$8j)(n)?t.queue(()=>n.copy(i,c,{overwrite:!0})):t.queue(()=>this.O(n,i,s,c))}watch(i,c={recursive:!1,excludes:[]}){const n=new $.$ic;let s=!1,t=()=>{s=!0};return n.add((0,$.$hc)(()=>t())),(async()=>{try{const r=await this.$(i,c);s?(0,$.$ec)(r):t=()=>(0,$.$ec)(r)}catch(r){this.b.error(r)}})(),n}async $(i,c){const n=await this.j(i),s=(0,R.$oi)([this.R(n).providerExtUri.getComparisonKey(i),c]);let t=this.Z.get(s);return t||(t={count:0,disposable:n.watch(i,c)},this.Z.set(s,t)),t.count+=1,(0,$.$hc)(()=>{t&&(t.count--,t.count===0&&((0,$.$ec)(t.disposable),this.Z.delete(s)))})}dispose(){super.dispose();for(const[,i]of this.Z)(0,$.$ec)(i.disposable);this.Z.clear()}async bb(i,c,n,s,t){await this.cb(i,n,s,t);try{await i.rename(n,c,{overwrite:!0})}catch(r){try{await i.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async cb(i,c,n,s){return this.ab.queueFor(c,this.R(i).providerExtUri).queue(async()=>{const t=await i.open(c,{create:!0,unlock:n?.unlock??!1});try{(0,g.$qd)(s)||(0,g.$rd)(s)?await this.db(i,t,s):await this.eb(i,t,s)}catch(r){throw(0,f.$fk)(r)}finally{await i.close(t)}})}async db(i,c,n){let s=0,t;if((0,g.$rd)(n)){if(n.buffer.length>0){const r=A.$Ed.concat(n.buffer);await this.fb(i,c,r,r.byteLength,s,0),s+=r.byteLength}if(n.ended)return;t=n.stream}else t=n;return new Promise((r,a)=>{(0,g.$wd)(t,{onData:async v=>{t.pause();try{await this.fb(i,c,v,v.byteLength,s,0)}catch(b){return a(b)}s+=v.byteLength,setTimeout(()=>t.resume())},onError:v=>a(v),onEnd:()=>r()})})}async eb(i,c,n){let s=0,t;for(;(t=n.read())!==null;)await this.fb(i,c,t,t.byteLength,s,0),s+=t.byteLength}async fb(i,c,n,s,t,r){let a=0;for(;a<s;){const v=await i.write(c,t+a,n.buffer,r+a,s-a);a+=v}}async gb(i,c,n,s){return this.ab.queueFor(c,this.R(i).providerExtUri).queue(()=>this.hb(i,c,n,s))}async hb(i,c,n,s){let t;s instanceof A.$Ed?t=s:(0,g.$qd)(s)?t=await(0,A.$Qd)(s):(0,g.$rd)(s)?t=await(0,A.$Rd)(s):t=(0,A.$Od)(s),await i.writeFile(c,t.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async ib(i,c,n,s){return this.ab.queueFor(s,this.R(n).providerExtUri).queue(()=>this.jb(i,c,n,s))}async jb(i,c,n,s){let t,r;try{t=await i.open(c,{create:!1}),r=await n.open(s,{create:!0,unlock:!1});const a=A.$Ed.alloc(this.a);let v=0,b=0,u=0;do u=await i.read(t,v,a.buffer,b,a.byteLength-b),await this.fb(n,r,a,u,v,b),v+=u,b+=u,b===a.byteLength&&(b=0);while(u>0)}catch(a){throw(0,f.$fk)(a)}finally{await N.Promises.settled([typeof t=="number"?i.close(t):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async kb(i,c,n,s){return this.ab.queueFor(s,this.R(n).providerExtUri).queue(()=>this.lb(i,c,n,s))}async lb(i,c,n,s){return n.writeFile(s,await i.readFile(c),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(i,c,n,s){return this.ab.queueFor(s,this.R(n).providerExtUri).queue(()=>this.nb(i,c,n,s))}async nb(i,c,n,s){const t=await n.open(s,{create:!0,unlock:!1});try{const r=await i.readFile(c);await this.fb(n,t,A.$Ed.wrap(r),r.byteLength,0,0)}catch(r){throw(0,f.$fk)(r)}finally{await n.close(t)}}async ob(i,c,n,s){const t=await(0,A.$Qd)(this.H(i,c,L.CancellationToken.None));await this.gb(n,s,void 0,t)}pb(i,c){if(i.capabilities&2048)throw new f.$mk((0,y.localize)(24,null,this.rb(c)),6);return i}qb(i,c){if((c.permissions??0)&f.FilePermission.Readonly)throw new f.$mk((0,y.localize)(25,null,this.rb(i)),6)}rb(i){return i.scheme===E.Schemas.file?i.fsPath:i.toString(!0)}};e.$Cp=m,e.$Cp=m=ye([X(0,l.$4i)],m)}),define(re[200],oe([0,1,52,271,5,35,14,3,48,2,16,6,21,42,31,162,12,99,198,38,194,193]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0,(()=>{try{(0,N.gracefulify)(O)}catch(c){console.error(`Error enabling graceful-fs: ${(0,w.$li)(c)}`)}})();class i extends l.$Lp{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.N=new L.$yi(t=>d.$$f.getComparisonKey(t)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await g.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:f.FilePermission.Locked}}catch(s){throw this.eb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await g.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,d.$hg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.eb(s)}}M(n,s){let t;return s?.dangling?t=f.FileType.Unknown:n.isFile()?t=f.FileType.File:n.isDirectory()?t=f.FileType.Directory:t=f.FileType.Unknown,s&&(t|=f.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new A.$Eg;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,$.$hc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await g.Promises.readFile(r)}catch(r){throw this.eb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,h.$sd)(a=>j.$Ed.concat(a.map(v=>j.$Ed.wrap(v))).buffer);return(0,o.$Bp)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix?this.Q(n,(0,d.$hg)((0,d.$gg)(n),`${(0,d.$eg)(n)}${t.atomic.postfix}`),s,t):this.R(n,s,t)}async Q(n,s,t,r){await this.R(s,t,r);try{await this.rename(s,n,{overwrite:!0})}catch(a){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async R(n,s,t){let r;try{const a=this.H(n);if(!t.create||!t.overwrite){if(await g.Promises.exists(a)){if(!t.overwrite)throw(0,f.$ek)((0,y.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,f.$ek)((0,y.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(n,{create:!0,unlock:t.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(a){throw await this.fb(n,a)}finally{typeof r=="number"&&await this.close(r)}}static{this.X=!0}static configureFlushOnWrite(n){i.X=n}async open(n,s){const t=this.H(n);let r;(0,f.$6j)(s)&&(r=await this.O(n));let a;try{if((0,f.$6j)(s)&&s.unlock)try{const{stat:b}=await g.SymlinkSupport.stat(t);b.mode&128||await g.Promises.chmod(t,b.mode|128)}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}let v;if((0,f.$6j)(s)){if(E.$i)try{await g.Promises.truncate(t,0),v="r+"}catch(b){b.code!=="ENOENT"&&this.a.trace(b)}v||(v="w")}else v="r";a=await g.Promises.open(t,v)}catch(v){throw r?.dispose(),(0,f.$6j)(s)?await this.fb(n,v):this.eb(v)}if(this.S.set(a,0),(0,f.$6j)(s)&&this.W.set(a,n),r){const v=this.U.get(a);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${t})`),this.U.set(a,r),v&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${t})`),v.dispose())}return a}async close(n){const s=this.U.get(n);try{if(this.S.delete(n),this.W.delete(n)&&i.X)try{await g.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await g.Promises.close(n)}catch(t){throw this.eb(t)}finally{s&&(this.U.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.U.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const v=this.Y(n,s);let b=null;try{b=(await g.Promises.read(n,t,r,a,v)).bytesRead}catch(u){throw this.eb(u)}finally{this.Z(n,v,b)}return b}Y(n,s){return s===this.S.get(n)?null:s}Z(n,s,t){const r=this.S.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.S.set(n,r+t):this.S.delete(n)))}async write(n,s,t,r,a){return(0,A.$Xg)(()=>this.$(n,s,t,r,a),100,3)}async $(n,s,t,r,a){const v=this.Y(n,s);let b=null;try{b=(await g.Promises.write(n,t,r,a,v)).bytesWritten}catch(u){throw await this.fb(this.W.get(n),u)}finally{this.Z(n,v,b)}return b}async mkdir(n){try{await g.Promises.mkdir(this.H(n))}catch(s){throw this.eb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,C.$8d)((0,C.$$d)(t),`${(0,C.$_d)(t)}${s.atomic.postfix}`)),await g.Promises.rm(t,g.RimRafMode.MOVE,r)}else try{await g.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:b}=await g.SymlinkSupport.stat(t);a=v.isDirectory()&&!b}catch{}if(a)await g.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.eb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.ab(n,s,"move",t.overwrite),await g.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(2,null,(0,C.$_d)(r),(0,C.$_d)((0,C.$$d)(a)),v.toString()))),this.eb(v)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.ab(n,s,"copy",t.overwrite),await g.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(3,null,(0,C.$_d)(r),(0,C.$_d)((0,C.$$d)(a)),v.toString()))),this.eb(v)}}async ab(n,s,t,r){const a=this.H(n),v=this.H(s);let b=!1;if(!!(this.capabilities&1024)||(b=(0,k.$Gf)(a,v,!0)),b){if(t==="copy")throw(0,f.$ek)((0,y.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const p=await this.L(n);if(!p)throw(0,f.$ek)((0,y.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const D=await this.L(s);if(D){if(!r)throw(0,f.$ek)((0,y.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);p.type&f.FileType.File&&D.type&f.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.bb(n,s,!1)}async bb(n,s,t){const r=this.H(n),a=this.H(s),v=!!(this.capabilities&1024);if((0,k.$Gf)(r,a,!v))return;const b=new $.$ic;try{const[u,p]=await Promise.all([this.O(n),this.O(s)]);b.add(u),b.add(p),t&&await g.Promises.mkdir((0,C.$$d)(a),{recursive:!0}),await g.Promises.copyFile(r,a)}catch(u){if(u.code==="ENOENT"&&!t)return this.bb(n,s,!0);throw this.eb(u)}finally{b.dispose()}}t(n,s,t){return new m.$Sp(r=>n(r),r=>s(r),t)}F(n,s,t){return new I.$1p(r=>n(r),r=>s(r),t)}eb(n){if(n instanceof f.$dk)return n;let s=n,t;switch(n.code){case"ENOENT":t=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=f.FileSystemProviderErrorCode.Unknown;break;default:t=f.FileSystemProviderErrorCode.Unknown}return(0,f.$ek)(s,t)}async fb(n,s){let t=this.eb(s);if(n&&t.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await g.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,f.$ek)(s,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$2p=i}),define(re[101],oe([0,1,3,2,4,7]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$17b=e.$Z7b=void 0,e.$Z7b=(0,A.$Ah)("sharedProcessLifecycleService");let j=class extends N.$jc{constructor(k){super(),this.b=k,this.a=this.B(new O.$ed),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$17b=j,e.$17b=j=ye([X(0,L.$4i)],j)}),define(re[201],oe([0,1,11,3,7,2]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=void 0;class j extends A.$cj{constructor(E,d,h,g,y){super(d,h,g),this.r=E,this.t=y,this.B(y.listen("onDidChangeLogLevel",E)(f=>{(0,A.$6i)(f)?super.setLogLevel(f):super.setLogLevel(O.URI.revive(f[0]),f[1])})),this.B(y.listen("onDidChangeVisibility",E)(([f,o])=>super.setVisibility(O.URI.revive(f),o))),this.B(y.listen("onDidChangeLoggers",E)(({added:f,removed:o})=>{for(const l of f)super.registerLogger({...l,resource:O.URI.revive(l.resource)});for(const l of o)super.deregisterLogger(l.resource)}))}createConsoleMainLogger(){return new A.$aj({log:(E,d)=>{this.t.call("consoleLog",[E,d])}})}registerLogger(E){super.registerLogger(E),this.t.call("registerLogger",[E,this.r])}deregisterLogger(E){super.deregisterLogger(E),this.t.call("deregisterLogger",[E,this.r])}setLogLevel(E,d){super.setLogLevel(E,d),this.t.call("setLogLevel",[E,d])}setVisibility(E,d){super.setVisibility(E,d),this.t.call("setVisibility",[this.n(E),d])}s(E,d,h){return new R(this.t,E,d,h,this.r)}static setLogLevel(E,d,h){return E.call("setLogLevel",[d,h])}}e.$Zq=j;class R extends A.$0i{constructor(E,d,h,g,y){super(g?.logLevel==="always"),this.r=E,this.s=d,this.m=!1,this.n=[],this.setLevel(h),this.r.call("createLogger",[d,g,y]).then(()=>{this.u(this.n),this.m=!0})}g(E,d){const h=[[E,d]];this.m?this.u(h):this.n.push(...h)}u(E){this.r.call("log",[this.s,E])}}class k{constructor(E,d){this.a=E,this.b=d}listen(E,d){const h=this.b(E);switch(d){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(y=>this.c(y,h)),removed:[...g.removed].map(y=>this.c(y,h))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,g=>[h.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,g=>(0,A.$6i)(g)?g:[h.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${d}`)}async call(E,d,h){const g=this.b(E);switch(d){case"setLogLevel":return(0,A.$6i)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(O.URI.revive(g.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,g)))}throw new Error(`Call not found: ${d}`)}c(E,d){return{...E,resource:d.transformOutgoingURI(E.resource)}}}e.$1q=k;class $ extends L.$jc{constructor(E,d){super(),d.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(h=>d.call("setLogLevel",[h]))),d.call("getRegisteredLoggers").then(h=>{for(const g of h)E.registerLogger({...g,resource:O.URI.revive(g.resource)})}),this.B(d.listen("onDidChangeVisibility")(([h,g])=>E.setVisibility(O.URI.revive(h),g))),this.B(d.listen("onDidChangeLoggers")(({added:h,removed:g})=>{for(const y of h)E.registerLogger({...y,resource:O.URI.revive(y.resource)});for(const y of g)E.deregisterLogger(y.resource)}))}}e.$2q=$}),define(re[202],oe([0,1,2,7]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;class A extends O.$jc{constructor(j,R=[]){super(),this.a=new N.$bj([j,...R]),this.B(j.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...R){this.a.trace(j,...R)}debug(j,...R){this.a.debug(j,...R)}info(j,...R){this.a.info(j,...R)}warn(j,...R){this.a.warn(j,...R)}error(j,...R){this.a.error(j,...R)}flush(){this.a.flush()}}e.$iN=A}),define(re[55],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S5b=void 0,e.$S5b=(0,O.$Ah)("nativeHostService")}),define(re[56],oe([0,1,3,59,2,4]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=void 0,e.$9m=(0,L.$Ah)("policy");class j extends A.$jc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$ed),this.onDidChange=this.h.event}async updatePolicyDefinitions($){const C=Object.keys(this.f).length;return this.f={...$,...this.f},C!==Object.keys(this.f).length&&await this.j($),N.Iterable.reduce(this.g.entries(),(E,[d,h])=>({...E,[d]:h}),{})}getPolicyValue($){return this.g.get($)}serialize(){return N.Iterable.reduce(Object.entries(this.f),($,[C,E])=>({...$,[C]:{definition:E,value:this.g.get(C)}}),{})}}e.$0m=j;class R{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$$m=R}),define(re[203],oe([0,1,3,2,56]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J6b=e.$I6b=void 0;class L{constructor(k){this.b=k,this.a=new N.$ic}listen(k,$){switch($){case"onDidChange":return O.Event.map(this.b.onDidChange,C=>C.reduce((E,d)=>({...E,[d]:this.b.getPolicyValue(d)??null}),{}),this.a)}throw new Error(`Event not found: ${$}`)}call(k,$,C){switch($){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${$}`)}dispose(){this.a.dispose()}}e.$I6b=L;class j extends A.$0m{constructor(k,$){super(),this.a=$;for(const C in k){const{definition:E,value:d}=k[C];this.f[C]=E,d!==void 0&&this.g.set(C,d)}this.a.listen("onDidChange")(C=>{for(const E in C){const d=C[E];d===null?this.g.delete(E):this.g.set(E,d)}this.h.fire(Object.keys(C))})}async j(k){const $=await this.a.call("updatePolicyDefinitions",k);for(const C in $)this.g.set(C,$[C])}}e.$J6b=j}),define(re[102],oe([0,1,6,37]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof O.$g.vscode<"u"&&typeof O.$g.vscode.context<"u"){const L=O.$g.vscode.context.configuration();if(L)A=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(A=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),!A.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(A,{version:L.version})}}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(re[24],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=void 0,e.$jj=(0,O.$Ah)("productService"),e.$kj="vscode://schemas/vscode-product"}),define(re[204],oe([0,1,5,8,2,16,31,7,24]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u7b=void 0;let $=class extends A.$jc{constructor(E,d,h){super(),this.b=d,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new O.$Rg(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),h=(0,L.$$d)(E),g=(0,L.$_d)(E),y=await j.Promises.readdir(h);await Promise.all(y.map(async f=>{if(f===g)return;const o=(0,L.$8d)(h,f),l=await j.Promises.stat(o);if(l.isDirectory()&&d-l.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${f}.`),j.Promises.rm(o)}))}catch(d){(0,N.$Y)(d)}}};e.$u7b=$,e.$u7b=$=ye([X(1,k.$jj),X(2,R.$4i)],$)}),define(re[205],oe([0,1,5,8,2,16,31,15,7,24]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=void 0;let C=class extends A.$jc{constructor(d,h,g){super(),this.b=d,this.c=h,this.f=g,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new O.$Rg(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),h=JSON.parse(await j.Promises.readFile((0,L.$8d)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const l of Object.keys(h)){const w=h[l];d[`${w.hash}.${l}`]=!0}const g=(0,L.$8d)(this.b.userDataPath,"clp");if(!await j.Promises.exists(g))return;const f=await j.Promises.readdir(g);for(const l of f){if(d[l]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${l}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${l}`),await j.Promises.rm((0,L.$8d)(g,l))}const o=Date.now();for(const l of Object.keys(d)){const w=(0,L.$8d)(g,l),m=await j.Promises.readdir(w);for(const I of m){if(I==="tcf.json")continue;const i=(0,L.$8d)(w,I),c=await j.Promises.stat(i);c.isDirectory()&&o-c.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.$8d)(l,I)}`),await j.Promises.rm(i))}}}catch(d){(0,N.$Y)(d)}}};e.$v7b=C,e.$v7b=C=ye([X(0,R.$Ih),X(1,k.$4i),X(2,$.$jj)],C)}),define(re[206],oe([0,1,16,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$BF=void 0,e.$BF=(0,N.$Ah)("IV8InspectProfilingService");var A;(function(L){function j(k){return!!(k.samples&&k.timeDeltas)}L.isValidProfile=j;function R(k,$="noAbsolutePaths"){for(const C of k.nodes)C.callFrame&&C.callFrame.url&&((0,O.$7d)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,O.$8d)($,(0,O.$_d)(C.callFrame.url)));return k}L.rewriteAbsolutePaths=R})(A||(e.Utils=A={}))}),define(re[207],oe([0,1,32]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P7b=void 0;class N{constructor(){this.a=new Map}async startProfiling(L){const R=await(await new Promise(($,C)=>{te(["v8-inspect-profiler"],$,C)})).startProfiling({port:L.port,checkForPaused:!0}),k=(0,O.$3f)();return this.a.set(k,R),k}async stopProfiling(L){const j=this.a.get(L);if(!j)throw new Error(`UNKNOWN session '${L}'`);const R=await j.stop();return this.a.delete(L),R.profile}}e.$P7b=N}),define(re[40],oe([0,1,127,9]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;class A{constructor(){this.a=new Map}add(j,R){O.ok(N.$if(j)),O.ok(N.$kf(R)),O.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,R)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$7m=new A}),define(re[103],oe([0,1,3,40]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$8m={JSONContribution:"base.contributions.json"};function A(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this.b=new O.$ed,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,$){this.a[A(k)]=$,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const j=new L;N.$7m.add(e.$8m.JSONContribution,j)}),define(re[49],oe([0,1,18,3,9,149,19,103,40]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ConfigurationScope=e.$_m=e.EditPresentationTypes=void 0;var $;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$_m={Configuration:"base.contributions.configuration"};var C;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn="vscode://schemas/settings/resourceLanguage",e.$hn="vscode://schemas/settings/configurationDefaults";const E=k.$7m.as(R.$8m.JSONContribution);class d{constructor(){this.h=new Set,this.i=new N.$ed,this.onDidSchemaChange=this.i.event,this.j=new N.$ed,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$gn,this.g),this.v()}registerConfiguration(i,c=!0){this.registerConfigurations([i],c)}registerConfigurations(i,c=!0){const n=new Set;this.n(i,c,n),E.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const c=new Set;this.o(i,c),E.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:i,remove:c}){const n=new Set;this.o(c,n),this.n(i,!1,n),E.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const c=new Set;this.k(i,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(i,c){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(c.add(r),e.$jn.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const D of Object.keys(s[r]))v.set(D,t);const b={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:b,valuesSources:v});const u=(0,j.$ei)(r),p={type:"object",default:b,description:L.localize(1,null,u),$ref:e.$gn,defaultDefaultValue:b,source:A.$if(t)?void 0:t,defaultValueSource:t};n.push(...y(r)),this.d[r]=p,this.b.properties[r]=p}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const c=new Set;this.l(i,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(i,c){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=A.$if(s)?s:s?.id,v=A.$if(r?.source)?r?.source:r?.source?.id;if(a===v)if(c.add(t),this.a.delete(t),e.$jn.test(t))delete this.d[t],delete this.b.properties[t];else{const b=this.d[t];b&&(this.w(t,b),this.r(t,b))}}this.u()}deltaConfiguration(i){let c=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),c=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),c=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const c of i)this.h.add(c);this.u()}n(i,c,n){i.forEach(s=>{this.p(s,c,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,c){const n=s=>{if(s.properties)for(const t in s.properties){c.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,c=!0,n,s,t=3,r){t=A.$rf(i.scope)?t:i.scope;const a=i.properties;if(a)for(const b in a){const u=a[b];if(c&&w(b,u)){delete a[b];continue}if(u.source=n,u.defaultDefaultValue=a[b].default,this.w(b,u),e.$jn.test(b)?u.scope=void 0:(u.scope=A.$rf(u.scope)?t:u.scope,u.restricted=A.$rf(u.restricted)?!!s?.includes(b):u.restricted),a[b].hasOwnProperty("included")&&!a[b].included){this.f[b]=a[b],delete a[b];continue}else this.d[b]=a[b],a[b].policy?.name&&this.e.set(a[b].policy.name,b);!a[b].deprecationMessage&&a[b].markdownDeprecationMessage&&(a[b].deprecationMessage=a[b].markdownDeprecationMessage),r.add(b)}const v=i.allOf;if(v)for(const b of v)this.p(b,c,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const c=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(c)};c(i)}r(i,c){switch(e.$an.properties[i]=c,c.scope){case 1:e.$bn.properties[i]=c;break;case 2:e.$cn.properties[i]=c;break;case 6:e.$dn.properties[i]=c;break;case 3:e.$en.properties[i]=c;break;case 4:e.$fn.properties[i]=c;break;case 5:e.$fn.properties[i]=c,this.g.properties[i]=c;break}}s(i,c){switch(delete e.$an.properties[i],c.scope){case 1:delete e.$bn.properties[i];break;case 2:delete e.$cn.properties[i];break;case 6:delete e.$dn.properties[i];break;case 3:delete e.$en.properties[i];break;case 4:case 5:delete e.$fn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const c=`[${i}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$gn};this.w(c,n),e.$an.properties[c]=n,e.$bn.properties[c]=n,e.$cn.properties[c]=n,e.$dn.properties[c]=n,e.$en.properties[c]=n,e.$fn.properties[c]=n}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$gn};e.$an.patternProperties[e.$in]=i,e.$bn.patternProperties[e.$in]=i,e.$cn.patternProperties[e.$in]=i,e.$dn.patternProperties[e.$in]=i,e.$en.patternProperties[e.$in]=i,e.$fn.patternProperties[e.$in]=i,this.i.fire()}w(i,c){const n=this.a.get(i);let s=n?.value,t=n?.source;A.$pf(s)&&(s=c.defaultDefaultValue,t=void 0),A.$pf(s)&&(s=o(c.type)),c.default=s,c.defaultValueSource=t}}const h="\\[([^\\]]+)\\]",g=new RegExp(h,"g");e.$in=`^(${h})+$`,e.$jn=new RegExp(e.$in);function y(I){const i=[];if(e.$jn.test(I)){let c=g.exec(I);for(;c?.length;){const n=c[1].trim();n&&i.push(n),c=g.exec(I)}}return(0,O.$Jb)(i)}e.$kn=y;function f(I){return I.reduce((i,c)=>`${i}[${c}]`,"")}e.$ln=f;function o(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$mn=o;const l=new d;k.$7m.add(e.$_m.Configuration,l);function w(I,i){return I.trim()?e.$jn.test(I)?L.localize(7,null,I):l.getConfigurationProperties()[I]!==void 0?L.localize(8,null,I):i.policy?.name&&l.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,I,i.policy?.name,l.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$nn=w;function m(){const I=[],i=l.getConfigurationProperties();for(const c of Object.keys(i))I.push([c,i[c].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.$on=m}),define(re[73],oe([0,1,18,3,34,2,35,30,9,11,19,49,40]),function(te,e,O,N,A,L,j,R,k,$,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function h(c){return Object.isFrozen(c)?c:R.$Vm(c)}class g{constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof g)return s;const t=new y("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$ci)(this.contents,n):this.contents}inspect(n,s){const t=this.rawConfiguration.getValue(n),r=s?this.rawConfiguration.getOverrideValue(n,s):void 0,a=s?this.rawConfiguration.override(s).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,C.$ci)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return O.$Jb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return O.$Jb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=R.$Um(this.contents),t=R.$Um(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of n)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(s,v.contents);for(const b of v.overrides){const[u]=t.filter(p=>O.$sb(p.identifiers,b.identifiers));u?(this.h(u.contents,b.contents),u.keys.push(...b.keys),u.keys=O.$Jb(u.keys)):t.push(R.$Um(b))}for(const b of v.keys)r.indexOf(b)===-1&&r.push(b)}return new g(s,r,t,a.every(v=>v instanceof g)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of O.$Jb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const v=s[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$Um(a),this.h(a,v)):a=v),t[r]=a}return new g(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&k.$kf(n[t])&&k.$kf(s[t])){this.h(n[t],s[t]);continue}n[t]=R.$Um(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$Um(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$bi)(this.contents,n),E.$jn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>O.$sb(t.identifiers,(0,E.$kn)(n))),1))}j(n,s,t){(0,C.$ai)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),E.$jn.test(n)&&this.overrides.push({identifiers:(0,E.$kn)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$_h)(this.contents[n],r=>console.error(r))})}}e.$pn=g;class y{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!k.$rf(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:b}=this.h(n,s);this.b=new g(t,r,a,b?[n]:void 0),this.c=v||[]}g(n){let s={},t=null,r=[];const a=[],v=[];function b(p){Array.isArray(r)?r.push(p):t!==null&&(r[t]=p)}const u={onObjectBegin:()=>{const p={};b(p),a.push(r),r=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const p=[];b(p),a.push(r),r=p,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:b,onError:(p,D,F)=>{v.push({error:p,offset:D,length:F})}};if(n)try{A.$Rm(n,u),s=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return s}h(n,s){const t=d.$7m.as(E.$_m.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,C.$_h)(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),v=Object.keys(n),b=this.j(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:a,keys:v,overrides:b,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const v={},b=[];for(const u in n)if(E.$jn.test(u)&&t){const p=this.i(n[u],s,!1,r);v[u]=p.raw,a=a||p.hasExcludedProperties,b.push(...p.restricted)}else{const p=s[u],D=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&b.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(D===void 0||r.scopes===void 0||r.scopes.includes(D))&&!(r.skipRestricted&&p?.restricted))?v[u]=n[u]:a=!0}return{raw:v,restricted:b,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(E.$jn.test(r)){const a={};for(const v in n[r])a[v]=n[r][v];t.push({identifiers:(0,E.$kn)(r),keys:Object.keys(a),contents:(0,C.$_h)(a,s)})}return t}}e.$qn=y;class f extends L.$jc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new N.$ed),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$rn=f;class o{constructor(n,s,t,r,a,v,b,u,p,D,F,z,U){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=b,this.h=u,this.i=p,this.j=D,this.k=F,this.l=z,this.m=U}get value(){return h(this.c)}n(n,s,t){const r=n.inspect(s,t);return{get value(){return h(r.value)},get override(){return h(r.override)},get merged(){return h(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class l{constructor(n,s,t,r,a=new g,v=new g,b=new j.$yi,u=new g,p=new j.$yi){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=v,this.j=b,this.l=u,this.m=p,this.a=null,this.b=new j.$yi,this.n=null}getValue(n,s,t){return this.q(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new g,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.q(n,s,t),a=this.u(s.resource,t),v=s.resource?this.m.get(s.resource)||this.l:this.l,b=new Set;for(const u of r.overrides)for(const p of u.identifiers)r.getOverrideValue(n,p)!==void 0&&b.add(p);return new o(n,s,r.getValue(n),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(n){const s=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:v}=I(this.c,n);s=[...r,...a,...v]}for(const r of s)for(const a of(0,E.$kn)(r)){const v=this.c.getKeysForOverrideIdentifier(a),b=n.getKeysForOverrideIdentifier(a),u=[...b.filter(p=>v.indexOf(p)===-1),...v.filter(p=>b.indexOf(p)===-1),...v.filter(p=>!R.$Ym(this.c.override(a).getValue(p),n.override(a).getValue(p)))];t.push([a,u])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=I(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=I(this.applicationConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateApplicationConfiguration(n),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=I(this.localUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateLocalUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=I(this.remoteUserConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateRemoteUserConfiguration(n),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=I(this.workspaceConfiguration,n),v=[...s,...t,...r];return v.length&&this.updateWorkspaceConfiguration(n),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.p.get(n),{added:r,updated:a,removed:v,overrides:b}=I(t,s),u=[...r,...a,...v];return(u.length||!t)&&this.updateFolderConfiguration(n,s),{keys:u,overrides:b}}compareAndDeleteFolderConfiguration(n){const s=this.p.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:v}=I(s,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,s,t){let r=this.r(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},s){let t=this.s();if(s&&n){const r=s.getFolder(n);r&&(t=this.t(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let s=this.b.get(n);if(!s){const t=this.s(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}u(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}w(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.x(n.defaults),t=this.x(n.policy),r=this.x(n.application),a=this.x(n.user),v=this.x(n.workspace),b=n.folders.reduce((u,p)=>(u.set($.URI.revive(p[0]),this.x(p[1])),u),new j.$yi);return new l(s,t,r,a,new g,v,b,new g,new j.$yi)}static x(n){return new g(n.contents,n.keys,n.overrides)}}e.$sn=l;function w(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const n=new Set,s=new Map;for(const r of c)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,v])=>{const b=(0,j.$vi)(s,a,new Set);v.forEach(u=>b.add(u))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$tn=w;class m{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(s){const b=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,u=this.g.getValue(n,s,this.h);return!R.$Ym(b,u)}return!0}}e.$un=m;function I(c,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,c?.rawConfiguration),a=[],v=c?.getAllOverrideIdentifiers()||[],b=n?.getAllOverrideIdentifiers()||[];if(n){const u=b.filter(p=>!v.includes(p));for(const p of u)a.push([p,n.getKeysForOverrideIdentifier(p)])}if(c){const u=v.filter(p=>!b.includes(p));for(const p of u)a.push([p,c.getKeysForOverrideIdentifier(p)])}if(n&&c){for(const u of v)if(b.includes(u)){const p=i({contents:c.getOverrideValue(void 0,u)||{},keys:c.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});a.push([u,[...p.added,...p.removed,...p.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(c,n){const s=c?n?c.keys.filter(a=>n.keys.indexOf(a)===-1):[...c.keys]:[],t=n?c?n.keys.filter(a=>c.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(c&&n){for(const a of n.keys)if(c.keys.indexOf(a)!==-1){const v=(0,C.$ci)(n.contents,a),b=(0,C.$ci)(c.contents,a);R.$Ym(v,b)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(re[208],oe([0,1,18,3,2,30,9,73,49,7,56,40]),function(te,e,O,N,A,L,j,R,k,$,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$wn=e.$vn=void 0;class d extends A.$jc{constructor(){super(...arguments),this.a=this.B(new N.$ed),this.onDidChangeConfiguration=this.a.event,this.b=new R.$pn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$7m.as(k.$_m.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:o})=>this.c(Array.from(f),o))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(f,o){this.h(f,E.$7m.as(k.$_m.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:f})}f(){return{}}g(){this.b=new R.$pn;const f=E.$7m.as(k.$_m.Configuration).getConfigurationProperties();this.h(Object.keys(f),f)}h(f,o){const l=this.f();for(const w of f){const m=l[w],I=o[w];m!==void 0?this.b.addValue(w,m):I?this.b.addValue(w,I.default):this.b.removeValue(w)}}}e.$vn=d;class h{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new R.$pn}async initialize(){return this.configurationModel}}e.$wn=h;let g=class extends A.$jc{get configurationModel(){return this.b}constructor(f,o,l){super(),this.c=f,this.f=o,this.g=l,this.a=this.B(new N.$ed),this.onDidChangeConfiguration=this.a.event,this.b=new R.$pn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.j(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.m(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const o={},l=[],w=E.$7m.as(k.$_m.Configuration).getConfigurationProperties();for(const m of f){const I=w[m];if(!I){l.push(m);continue}if(I.policy){if(I.type!=="string"&&I.type!=="number"){this.g.warn(`Policy ${I.policy.name} has unsupported type ${I.type}`);continue}l.push(m),o[I.policy.name]={type:I.type}}}return(0,j.$vf)(o)||await this.f.updatePolicyDefinitions(o),l}j(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const o=E.$7m.as(k.$_m.Configuration).getPolicyConfigurations(),l=(0,O.$Eb)(f.map(w=>o.get(w)));this.m(l,!0)}m(f,o){this.g.trace("PolicyConfiguration#update",f);const l=E.$7m.as(k.$_m.Configuration).getConfigurationProperties(),w=[],m=this.b.isEmpty();for(const I of f){const i=l[I]?.policy?.name;if(i){const c=this.f.getPolicyValue(i);(m?c!==void 0:!(0,L.$Ym)(this.b.getValue(I),c))&&w.push([I,c])}else this.b.getValue(I)!==void 0&&w.push([I,void 0])}if(w.length){this.g.trace("PolicyConfiguration#changed",w);const I=this.b;this.b=new R.$pn;for(const i of I.keys)this.b.setValue(i,I.getValue(i));for(const[i,c]of w)c===void 0?this.b.removeValue(i):this.b.setValue(i,c);o&&this.a.fire(this.b)}}};e.$xn=g,e.$xn=g=ye([X(1,C.$9m),X(2,$.$4i)],g)}),define(re[209],oe([0,1,5,3,2,21,19,73,208,56]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=void 0;class C extends A.$jc{constructor(d,h,g,y){super(),this.j=d,this.h=this.B(new N.$ed),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$vn),this.c=g instanceof $.$$m?new k.$wn:this.B(new k.$xn(this.b,g,y)),this.f=this.B(new R.$rn(this.j,{},L.$$f,h)),this.a=new R.$sn(this.b.configurationModel,this.c.configurationModel,new R.$pn,new R.$pn),this.g=this.B(new O.$Rg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:f,properties:o})=>this.n(f,o))),this.B(this.c.onDidChangeConfiguration(f=>this.r(f))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,h,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$sn(d,h,new R.$pn,g)}getConfigurationData(){return this.a.toData()}getValue(d,h){const g=typeof d=="string"?d:void 0,y=(0,j.$8h)(d)?d:(0,j.$8h)(h)?h:{};return this.a.getValue(g,y,void 0)}updateValue(d,h,g,y){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.m(d)}m(d){const h=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(d);this.s(g,h,2)}n(d,h){const g=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(d,h);this.s(y,g,7)}r(d){const h=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(d);this.s(g,h,7)}s(d,h,g){const y=new R.$un(d,{data:h},this.a);y.source=g,y.sourceConfig=this.t(g),this.h.fire(y)}t(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$yn=C}),define(re[210],oe([0,1,14,3,2,65]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$skb=e.$rkb=e.$qkb=e.$pkb=void 0;const j=($,C,E)=>{const d=new Uint8Array(16);for(let y=0;y<16;y++)d[y]=Math.round(Math.random()*256);const h=(0,O.$Yd)(O.$Ed.wrap(d));return[`GET ws://localhost${$}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${h}`].join(`\r
`)+`\r
\r
`};e.$pkb=j,e.$qkb=O.$Ed.fromString(`\r
\r
`);async function R($,C,E,d,h){$.write(O.$Ed.fromString((0,e.$pkb)(C,E,d)));const g=new A.$ic;try{return await new Promise((y,f)=>{let o;g.add($.onData(l=>{o?o=O.$Ed.concat([o,l],o.byteLength+l.byteLength):o=l;const w=o.indexOf(e.$qkb);if(w===-1)return;y($),$.pauseData();const m=o.slice(w+e.$qkb.byteLength);m.byteLength&&h.onData.fire(m)})),g.add($.onClose(l=>f(l??new Error("socket closed")))),g.add($.onEnd(()=>f(new Error("socket ended"))))})}catch(y){throw $.dispose(),y}finally{g.dispose()}}e.$rkb=R;class k extends A.$jc{constructor(C,E){super(),this.g=C,this.a=this.B(new N.$hd),this.onData=(...d)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...d)),this.b=this.B(new N.$ed),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(d=>this.a.fire(d))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,E){L.SocketDiagnostics.traceSocketEvent(this,this.g,C,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$skb=k}),define(re[211],oe([0,1,8,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.RemoteAuthorityResolverErrorCode=e.$Kk=e.$Jk=e.RemoteConnectionType=e.$Ik=void 0,e.$Ik=(0,N.$Ah)("remoteAuthorityResolverService");var A;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class L{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$Jk=L;class j{constructor(E,d){this.host=E,this.port=d,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Kk=j;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class k extends O.$_{static isNotAvailable(E){return E instanceof k&&E._code===R.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof k&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof k&&E._code===R.NoResolverFound}static isInvalidAuthority(E){return E instanceof k&&E._code===R.InvalidAuthority}static isHandled(E){return E instanceof k&&E.isHandled}constructor(E,d=R.Unknown,h){super(E),this._message=E,this._code=d,this._detail=h,this.isHandled=d===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Lk=k;function $(C){const E=C.indexOf("+");return E===-1?C:C.substring(0,E)}e.$Mk=$}),define(re[74],oe([0,1,23]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=void 0;function N($){return $.scheme===O.Schemas.vscodeRemote?$.authority:void 0}e.$Nk=N;function A($){if(!$)return;const C=$.indexOf("+");return C<0?$:$.substr(0,C)}e.$Ok=A;function L($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Pk=L;function j($){const{host:C,port:E}=k($);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:E}}e.$Qk=j;function R($,C){let{host:E,port:d}=k($);return typeof d>"u"&&(d=C),{host:E,port:d}}e.$Rk=R;function k($){const C=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const E=$.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const d=$.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:$,port:void 0}}}),define(re[45],oe([0,1,27,4,74]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.TargetPlatform=e.ExtensionType=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=void 0,e.$Ol="extensions.user.cache",e.$Pl="extensions.builtin.cache",e.$Ql="undefined_publisher",e.$Rl=["ui","workspace","web"];function L(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Sl=L,e.$Tl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(j||(e.ExtensionType=j={}));var R;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class k{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,o){if(typeof f>"u"||f===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof f=="string"||typeof o=="string"){const l=typeof f=="string"?f:f.value,w=typeof o=="string"?o:o.value;return O.$Le(l,w)}return f._lower===o._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$Ul=k;class ${get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const o of f)this.add(o)}add(f){this.c.add(k.toKey(f))}delete(f){return this.c.delete(k.toKey(f))}has(f){return this.c.has(k.toKey(f))}}e.$Vl=$;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(k.toKey(f))}get(f){return this.c.get(k.toKey(f))}has(f){return this.c.has(k.toKey(f))}set(f,o){this.c.set(k.toKey(f),o)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Wl=C;function E(y){return d(y)}e.$Xl=E;function d(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$Yl=d;function h(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$Zl=h;function g(y,f){if(f){const o=`onResolveRemoteAuthority:${(0,A.$Ok)(f)}`;return!!y.activationEvents?.includes(o)}return!1}e.$1l=g,e.$2l=(0,N.$Ah)("IBuiltinExtensionsScannerService")}),define(re[212],oe([0,1,2,45,12]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;class L extends O.$jc{constructor(R,k,$,C,E){super(),this.a=R,this.b=k,this.c=$,this.f=E,this.B(C.onDidInstallExtensions(d=>this.g(d))),this.B(C.onDidUninstallExtension(d=>this.h(d)))}g(R){for(const k of R)k.local&&this.invalidate(k.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,R)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$Ol))}catch(k){(0,A.$ik)(k)!==1&&this.f.error(k)}}}e.$vp=L}),define(re[213],oe([0,1,5,14,26,8,3,2,100,60,32,65,211,74]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.PersistentConnectionEventType=e.$Yk=e.$Xk=e.$Wk=e.ConnectionType=void 0;const g=30*1e3;var y;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function f(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(q){const S=new A.$od;return setTimeout(()=>S.cancel(),q),S.token}function l(q,S){if(q.isCancellationRequested||S.isCancellationRequested)return A.CancellationToken.Cancelled;const P=new A.$od;return q.onCancellationRequested(()=>P.cancel()),S.onCancellationRequested(()=>P.cancel()),P.token}class w{get didTimeout(){return this.c==="timedout"}constructor(S){this.c="pending",this.d=new R.$ic,this.promise=new Promise((P,M)=>{this.f=P,this.g=M}),S.isCancellationRequested?this.h():this.d.add(S.onCancellationRequested(()=>this.h()))}registerDisposable(S){this.c==="pending"?this.d.add(S):S.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const S=new Error("Time limit reached");return S.code="ETIMEDOUT",S.syscall="connect",S}resolve(S){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(S))}reject(S){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(S))}}function m(q,S){const P=new w(S);return P.registerDisposable(q.onControlMessage(M=>{const T=JSON.parse(M.toString()),K=H(T);K?P.reject(K):P.resolve(T)})),P.promise}function I(q,S,P,M,T,K,_,ae){const he=new w(ae),fe=$.$ad.create(!1);return q.info(`Creating a socket (${_})...`),k.mark(`code/willCreateSocket/${K}`),S.connect(P,M,T,_).then(le=>{he.didTimeout?(k.mark(`code/didCreateSocketError/${K}`),q.info(`Creating a socket (${_}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(k.mark(`code/didCreateSocketOK/${K}`),q.info(`Creating a socket (${_}) was successful after ${fe.elapsed()} ms.`),he.resolve(le))},le=>{k.mark(`code/didCreateSocketError/${K}`),q.info(`Creating a socket (${_}) returned an error after ${fe.elapsed()} ms.`),q.error(le),he.reject(le)}),he.promise}function i(q,S){const P=new w(S);return q.then(M=>{P.didTimeout||P.resolve(M)},M=>{P.didTimeout||P.reject(M)}),P.promise}async function c(q,S,P,M){const T=se(q,S);q.logService.trace(`${T} 1/6. invoking socketFactory.connect().`);let K;try{K=await I(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,h.$Pk)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,f(S),`renderer-${f(S)}-${q.reconnectionToken}`,M)}catch(le){throw q.logService.error(`${T} socketFactory.connect() failed or timed out. Error:`),q.logService.error(le),le}q.logService.trace(`${T} 2/6. socketFactory.connect() was successful.`);let _,ae;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(K,null),_=q.reconnectionProtocol,ae=!1):(_=new E.$oh({socket:K}),ae=!0),q.logService.trace(`${T} 3/6. sending AuthRequest control message.`);const he=await i(q.signService.createNewMessage((0,C.$3f)()),M),fe={type:"auth",auth:q.connectionToken||"00000000000000000000",data:he.data};_.sendControl(N.$Ed.fromString(JSON.stringify(fe)));try{const le=await m(_,l(M,o(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(q.logService.trace(`${T} 4/6. received SignRequest control message.`),!await i(q.signService.validate(he,le.signedData),M)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await i(q.signService.sign(le.data),M),we={type:"connectionType",commit:q.commit,signedData:de,desiredConnectionType:S};return P&&(we.args=P),q.logService.trace(`${T} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(N.$Ed.fromString(JSON.stringify(we))),{protocol:_,ownsProtocol:ae}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(q.logService.error(`${T} the handshake timed out. Error:`),q.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${T} received error control message when negotiating connection. Error:`),q.logService.error(le)),ae&&G(_),le}}async function n(q,S,P,M){const T=Date.now(),K=se(q,S),{protocol:_,ownsProtocol:ae}=await c(q,S,P,M),he=new w(M);return he.registerDisposable(_.onControlMessage(fe=>{const le=JSON.parse(fe.toString()),$e=H(le);$e?(q.logService.error(`${K} received error control message when negotiating connection. Error:`),q.logService.error($e),ae&&G(_),he.reject($e)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${Y(T)}!`),he.resolve({protocol:_,firstMessage:le}))})),he.promise}async function s(q,S){const{protocol:P}=await n(q,1,void 0,S);return{protocol:P}}async function t(q,S,P){const{protocol:M,firstMessage:T}=await n(q,2,S,P),K=T&&T.debugPort;return{protocol:M,debugPort:K}}async function r(q,S,P){const M=Date.now(),T=se(q,3),{protocol:K}=await c(q,3,S,P);return q.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${Y(M)}!`),K}async function a(q,S,P){const{connectTo:M,connectionToken:T}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:M,connectionToken:T,reconnectionToken:S,reconnectionProtocol:P,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function v(q,S,P){return u(q,async M=>{const{protocol:T}=await s(M,A.CancellationToken.None);return new W(q,S,P,M.reconnectionToken,T)})}e.$Wk=v;async function b(q,S){return u(q,async P=>{const{protocol:M,debugPort:T}=await t(P,S,A.CancellationToken.None);return new Z(q,S,P.reconnectionToken,M,T)})}e.$Xk=b;async function u(q,S){for(let M=1;;M++)try{const T=(0,C.$3f)(),K=await a(q,T,null);return await S(K)}catch(T){if(M<5)q.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(T);else throw q.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(T),Q.triggerPermanentFailure(0,0,d.$Lk.isHandled(T)),T}}async function p(q,S,P){const M=await a(q,(0,C.$3f)(),null);return await r(M,{host:S,port:P},A.CancellationToken.None)}e.$Yk=p;function D(q){return(0,O.$tg)(S=>new Promise((P,M)=>{const T=setTimeout(P,q*1e3);S.onCancellationRequested(()=>{clearTimeout(T),P()})}))}var F;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class z{constructor(S,P){this.reconnectionToken=S,this.millisSinceLastIncomingData=P,this.type=0}}e.$Zk=z;class U{constructor(S,P,M,T){this.reconnectionToken=S,this.millisSinceLastIncomingData=P,this.durationSeconds=M,this.c=T,this.type=1}skipWait(){this.c.cancel()}}e.$1k=U;class B{constructor(S,P,M){this.reconnectionToken=S,this.millisSinceLastIncomingData=P,this.attempt=M,this.type=2}}e.$2k=B;class x{constructor(S,P,M){this.reconnectionToken=S,this.millisSinceLastIncomingData=P,this.attempt=M,this.type=4}}e.$3k=x;class J{constructor(S,P,M,T){this.reconnectionToken=S,this.millisSinceLastIncomingData=P,this.attempt=M,this.handled=T,this.type=3}}e.$4k=J;class Q extends R.$jc{static triggerPermanentFailure(S,P,M){this._permanentFailure=!0,this.f=S,this.g=P,this.h=M,this.j.forEach(T=>T.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(S=>S.y())}static debugPauseSocketWriting(){this.j.forEach(S=>S.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Q._permanentFailure}constructor(S,P,M,T,K){super(),this.t=S,this.u=P,this.reconnectionToken=M,this.protocol=T,this.w=K,this.m=this.B(new j.$ed),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new x(this.reconnectionToken,0,0)),this.B(T.onSocketClose(_=>{const ae=ne(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ae} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ae} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ae} received socket close event.`),this.y()})),this.B(T.onSocketTimeout(_=>{const ae=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ae} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),Q.j.push(this),this.B((0,R.$hc)(()=>{const _=Q.j.indexOf(this);_>=0&&Q.j.splice(_,1)})),this.n&&this.D(Q.f,Q.g,Q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const S=ne(this.t,this.reconnectionToken,!0);this.u.logService.info(`${S} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const P=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const T=M<P.length?P[M]:P[P.length-1];try{if(T>0){const _=D(T);this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T,_)),this.u.logService.info(`${S} waiting for ${T} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${S} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this.u.logService.info(`${S} resolving connection...`);const K=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${S} connecting to ${K.connectTo}...`),await this.G(K,o(g)),this.u.logService.info(`${S} reconnected!`),this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${S} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this.u.logService.error(`${S} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(d.$Lk.isTemporarilyNotAvailable(K)){this.u.logService.info(`${S} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.u.logService.info(`${S} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if((0,L.$2)(K)){this.u.logService.info(`${S} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(K);continue}if(K instanceof d.$Lk){this.u.logService.error(`${S} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,d.$Lk.isHandled(K));break}this.u.logService.error(`${S} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(K),this.C(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this.n&&!this.s)}C(S,P,M){this.w?Q.triggerPermanentFailure(S,P,M):this.D(S,P,M)}D(S,P,M){this.m.fire(new J(this.reconnectionToken,S,P,M)),G(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$5k=Q;class W extends Q{constructor(S,P,M,T,K){super(1,S,T,K,!0),this.client=this.B(new E.$mh(K,{remoteAuthority:P,clientId:M},S.ipcLogger))}async G(S,P){await s(S,P)}}e.$6k=W;class Z extends Q{constructor(S,P,M,T,K){super(2,S,M,T,!1),this.H=P,this.debugPort=K}async G(S,P){await t(S,this.H,P)}}e.$7k=Z;function G(q){try{q.acceptDisconnect();const S=q.getSocket();q.dispose(),S.dispose()}catch(S){(0,L.$Y)(S)}}function H(q){if(q&&q.type==="error"){const S=new Error(`Connection error: ${q.reason}`);return S.code="VSCODE_CONNECTION_ERROR",S}return null}function V(q,S){for(;q.length<S;)q+=" ";return q}function ee(q,S){return`[remote-connection][${V(f(q),13)}][${S.substr(0,5)}\u2026]`}function ne(q,S,P){return`${ee(q,S)}[${P?"reconnect":"initial"}]`}function se(q,S){return`${ne(S,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function Y(q){return`${Date.now()-q} ms`}}),define(re[104],oe([0,1,2,4]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=void 0,e.$Sk=(0,N.$Ah)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(j,R){return this.a[j]??=[],this.a[j].push(R),(0,O.$hc)(()=>{const k=this.a[j]?.indexOf(R);typeof k=="number"&&k>=0&&this.a[j]?.splice(k,1)})}b(j){return(this.a[j.type]||[]).find(k=>k.supports(j))}connect(j,R,k,$){const C=this.b(j);if(!C)throw new Error(`No socket factory found for ${j}`);return C.connect(j,R,k,$)}}e.$Tk=A}),define(re[214],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N7b=e.$M7b=void 0,e.$M7b=(0,O.$Ah)("sharedProcessTunnelService"),e.$N7b="sharedProcessTunnel"}),define(re[105],oe([0,1,4,164]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X7b=e.$W7b=e.$V7b=e.$U7b=e.$T7b=e.TunnelStates=e.$S7b=e.$R7b=void 0,e.$R7b=(0,O.$Ah)("IRemoteTunnelService"),e.$S7b={active:!1};var A;(function(L){L.disconnected=j=>({type:"disconnected",onTokenFailed:j}),L.connected=(j,R)=>({type:"connected",info:j,serviceInstallFailed:R}),L.connecting=j=>({type:"connecting",progress:j}),L.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$T7b="remote.tunnels.access",e.$U7b=e.$T7b+".hostNameOverride",e.$V7b=e.$T7b+".preventSleep",e.$W7b="remoteTunnelService",e.$X7b=(0,N.localize)(0,null)}),define(re[57],oe([0,1,14,8,2,166,49,4,7,40]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=void 0,e.$Ho=(0,R.$Ah)("requestService");class C{constructor(I){this.b=I}toJSON(){if(!this.a){const I=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?I[i]="*****":I[i]=this.b[i];this.a=I}return this.a}}class E extends A.$jc{constructor(I){super(),this.b=0,this.a=I.createLogger("network",{name:(0,L.localize)(0,null),when:k.$ij.isEqualTo((0,k.$gj)(k.LogLevel.Trace)).serialize()})}async c(I,i,c){const n=`${I} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new C(i.headers??{}));try{const s=await c();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,N.$8)(s)),s}}}e.$Io=E;function d(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.$Jo=d;function h(m){return m.res.statusCode===204}e.$Ko=h;async function g(m){return h(m)?null:(await(0,O.$Qd)(m.stream)).toString()}e.$Lo=g;async function y(m){if(!d(m))throw new Error("Server returned "+m.res.statusCode);return g(m)}e.$Mo=y;async function f(m){if(!d(m))throw new Error("Server returned "+m.res.statusCode);if(h(m))return null;const i=(await(0,O.$Qd)(m.stream)).toString();try{return JSON.parse(i)}catch(c){throw c.message+=`:
`+i,c}}e.$No=f;function o(m){w(m)}e.$Oo=o;let l;function w(m){const I=$.$7m.as(j.$_m.Configuration),i=l;l={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0}}},I.updateConfigurations({add:[l],remove:i?[i]:[]})}w(1)}),define(re[215],oe([0,1,26,23,12,57]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=void 0;let j=class{constructor(k,$){this.a=k,this.b=$}async download(k,$,C=O.CancellationToken.None){if(k.scheme===N.Schemas.file||k.scheme===N.Schemas.vscodeRemote){await this.b.copy(k,$);return}const E={type:"GET",url:k.toString(!0)},d=await this.a.request(E,C);if(d.res.statusCode===200)await this.b.writeFile($,d.stream);else{const h=await(0,L.$Mo)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${h}`)}}};e.$xN=j,e.$xN=j=ye([X(0,L.$Ho),X(1,A.$5j)],j)}),define(re[216],oe([0,1,14,26]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=void 0;class A{constructor(R){this.a=R}listen(R,k){throw new Error("Invalid listen")}call(R,k,$,C=N.CancellationToken.None){switch(k){case"request":return this.a.request($[0],C).then(async({res:E,stream:d})=>{const h=await(0,O.$Qd)(d);return[{statusCode:E.statusCode,headers:E.headers},h]});case"resolveProxy":return this.a.resolveProxy($[0])}throw new Error("Invalid call")}}e.$Kq=A;class L{constructor(R){this.a=R}async request(R,k){const[$,C]=await this.a.call("request",[R],k);return{res:$,stream:(0,O.$Sd)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$Lq=L}),define(re[217],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=e.$g6b=e.$f6b=void 0,e.$f6b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$g6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$h6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[218],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h2b=void 0;class O{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const L=await this.c();if(L){const j=String(O.a++);return this.b.set(j,L),{id:j,data:L.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,L){if(!A.id)return!0;const j=this.b.get(A.id);if(!j)return!1;this.b.delete(A.id);try{return j.validate(L)==="ok"}catch{return!1}finally{j.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$h2b=O}),define(re[106],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=void 0,e.$Uk="signService",e.$Vk=(0,O.$Ah)(e.$Uk)}),define(re[219],oe([0,1,218]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=void 0;class N extends O.$h2b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(j=>new j.signer().sign(L))}h(){return new Promise((L,j)=>te(["vsda"],L,j))}}e.$66b=N}),define(re[75],oe([0,1,3,2]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6zb=e.$5zb=e.$4zb=e.$3zb=void 0;class A extends N.$jc{constructor(E,d,h){super(),this.a=E,this.b=d,this.c=h}async getItems(){const E={profile:this.b,workspace:this.c},d=await this.a.call("getItems",E);return new Map(d)}updateItems(E){const d={profile:this.b,workspace:this.c};return E.insert&&(d.insert=Array.from(E.insert.entries())),E.delete&&(d.delete=Array.from(E.delete.values())),this.a.call("updateItems",d)}optimize(){const E={profile:this.b,workspace:this.c};return this.a.call("optimize",E)}}class L extends A{constructor(E,d){super(E,d,void 0),this.f=this.B(new O.$ed),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class j extends L{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$3zb=j;class R extends L{constructor(E,d){super(E,d)}async close(){this.dispose()}}e.$4zb=R;class k extends A{constructor(E,d){super(E,void 0,d),this.onDidChangeItemsExternal=O.Event.None}async close(){this.dispose()}}e.$5zb=k;class ${constructor(E){this.a=E}isUsed(E){const d={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",d)}}e.$6zb=$}),define(re[107],oe([0,1,6,37,32]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=void 0;function L(k){if(O.$t===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function j(k,$,C,E,d,h,g,y){const f=Object.create(null);f["common.machineId"]=h,f.sessionID=(0,A.$3f)()+Date.now(),f.commitHash=E,f.version=d,f["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,O.$h)(O.$t),f["common.nodePlatform"]=N.$2d,f["common.nodeArch"]=C,f["common.product"]=y||"desktop",g&&(f["common.msftInternal"]=g);let o=0;const l=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),O.$l&&(f["common.snap"]="true");const w=L($);return w&&(f["common.platformDetail"]=w),f}e.$9n=j;function R(k){const $=N.env.USERDNSDOMAIN;if(!$)return!1;const C=$.toLowerCase();return k.some(E=>C===E)}e.$0n=R}),define(re[22],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0,e.$8k=(0,O.$Ah)("telemetryService"),e.$9k=(0,O.$Ah)("customEndpointTelemetryService"),e.$0k="telemetry.currentSessionDate",e.$$k="telemetry.firstSessionDate",e.$_k="telemetry.lastSessionDate",e.$al="telemetry.machineId",e.$bl="telemetry",e.$cl="telemetry.telemetryLevel",e.$dl="telemetry.enableCrashReporter",e.$el="telemetry.enableTelemetry";var N;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var A;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(re[220],oe([0,1,36,5,34,23,16,6,11,132,31,146,95,12,24,22]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=void 0;const f=new Map;async function o(i,c){const n=`${i}::${c.join(":")}`,s=f.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function b(p,D,F,z){const U=D.substring(p.length+1);return N.Promises.withAsyncBody(async B=>{let x;try{x=await C.Promises.readdir(D,{withFileTypes:!0})}catch{B();return}if(z.count>=v){z.count+=x.length,z.maxReached=!0,B();return}let J=x.length;if(J===0){B();return}let Q=x;z.count+x.length>v&&(z.maxReached=!0,J=v-z.count,Q=x.slice(0,J)),z.count+=x.length;for(const W of Q)if(W.isDirectory()){if(F.includes(W.name)||await b(p,(0,j.$8d)(D,W.name),F,z),--J===0){B();return}}else{const Z=W.name.lastIndexOf(".");if(Z>=0){const G=W.name.substring(Z+1);G&&r.set(G,(r.get(G)??0)+1)}for(const G of t)G.relativePathPattern?.test(U)!==!1&&G.filePattern.test(W.name)&&a.set(G.tag,(a.get(G.tag)??0)+1);if(--J===0){B();return}}})}const u=N.Promises.withAsyncBody(async p=>{const D={count:0,maxReached:!1};await b(i,i,c,D);const F=await m(i);p({configFiles:l(a),fileTypes:l(r),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:F})});return f.set(n,u),u}e.$sr=o;function l(i){return Array.from(i.entries(),([c,n])=>({name:c,count:n})).sort((c,n)=>n.count-c.count)}function w(){const i={os:`${O.type()} ${O.arch()} ${O.release()}`,memory:`${(O.totalmem()/h.$zk.GB).toFixed(2)}GB (${(O.freemem()/h.$zk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$Gm.value()*100)}%`},c=O.cpus();return c&&c.length>0&&(i.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),i}e.$tr=w;async function m(i){try{const c=new Map,n=(0,j.$8d)(i,".vscode","launch.json"),s=await C.Promises.readFile(n),t=[],r=(0,A.$Km)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,A.$Tm)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(c.has(v)?c.set(v,c.get(v)+1):c.set(v,1))}return l(c)}catch{return[]}}e.$ur=m;let I=class{constructor(c,n){this.c=c,this.d=n}f(c){const n=[];return n.push(`OS Version:       ${c.os}`),n.push(`CPUs:             ${c.cpus}`),n.push(`Memory (System):  ${c.memory}`),n.push(`VM:               ${c.vmHint}`),n.join(`
`)}g(c){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${O.type()} ${O.arch()} ${O.release()}`);const s=O.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(O.totalmem()/h.$zk.GB).toFixed(2)}GB (${(O.freemem()/h.$zk.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${O.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round($.$Gm.value()*100)}%`),n.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${c.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(c,n){return Promise.all([(0,E.$rr)(c.mainPID),this.k(c)]).then(async s=>{let[t,r]=s,a=this.m(c,t);return n.forEach(v=>{if((0,d.$gm)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(c,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const b of Object.keys(v.workspaceMetadata)){const u=v.workspaceMetadata[b];let p=`${u.fileCount} files`;u.maxFilesReached&&(p=`more than ${p}`),r+=`|    Folder (${b}): ${p}`,r+=this.h(u)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(c,n){const{memory:s,vmHint:t,os:r,cpus:a}=w(),v={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(v.load=`${O.loadavg().map(b=>Math.round(b)).join(", ")}`),R.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(c,n){const s=[];return(0,E.$rr)(c.mainPID).then(async t=>(s.push(""),s.push(this.g(c)),s.push(""),s.push(this.m(c,t)),c.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(c))),n.forEach(r=>{if((0,d.$gm)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(c,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let b=`${v.fileCount} files`;v.maxFilesReached&&(b=`more than ${b}`),s.push(`Folder (${a}): ${b}`),s.push(this.h(v))}}),s.push(""),s.push(""),s.join(`
`)))}h(c){const n=[];let t=0;const r=(u,p)=>{const D=` ${u}(${p})`;t+D.length>60?(n.push(a),a="|                 ",t=a.length):t+=D.length,a+=D};let a="|      File types:";const v=10,b=c.fileTypes.length>v?v:c.fileTypes.length;for(let u=0;u<b;u++){const p=c.fileTypes[u];r(p.name,p.count)}if(n.push(a),c.configFiles.length>=0&&(a="|      Conf files:",t=0,c.configFiles.forEach(u=>{r(u.name,u.count)}),n.push(a)),c.launchConfigFiles.length>0){let u="|      Launch Configs:";c.launchConfigFiles.forEach(p=>{const D=p.count>1?` ${p.name}(${p.count})`:` ${p.name}`;u+=D}),n.push(u)}return n.join(`
`)}j(c){const n=Math.max(...Object.keys(c).map(s=>s.length));return Object.keys(c).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${c[s]}`).join(`
                  `)}k(c){const n=[],s=[];return c.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=k.URI.revive(r);if(a.scheme===L.Schemas.file){const v=a.fsPath;s.push(o(v,["node_modules",".git"]).then(b=>{let u=`${b.fileCount} files`;b.maxFilesReached&&(u=`more than ${u}`),n.push(`|    Folder (${(0,j.$_d)(v)}): ${u}`),n.push(this.h(b))}).catch(b=>{n.push(`|      Error: Unable to collect workspace stats for folder ${v} (${b.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(c,n){const s=new Map;c.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),c.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(c.mainPID,s,t,n,0),t.join(`
`)}n(c,n,s,t,r){const a=r===0;let v;a?v=t.pid===c?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?v=n.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const b=process.platform==="win32"?t.mem:O.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(b/h.$zk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(u=>this.n(c,n,s,u,r+1))}async getWorkspaceFileExtensions(c){const n=new Set;for(const{uri:s}of c.folders){const t=k.URI.revive(s);if(t.scheme!==L.Schemas.file)continue;const r=t.fsPath;try{(await o(r,["node_modules",".git"])).fileTypes.forEach(v=>n.add(v.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(c){for(const{uri:n}of c.folders){const s=k.URI.revive(n);if(s.scheme!==L.Schemas.file)continue;const t=s.fsPath;try{const r=await o(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$vr=I,e.$vr=I=ye([X(0,y.$8k),X(1,g.$jj)],I)}),define(re[108],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=e.$k6b=void 0;class O{constructor(L){this.b=L}listen(L,j){throw new Error(`Event not found: ${j}`)}call(L,j,{eventName:R,data:k}){return this.b.forEach($=>$.log(R,k)),Promise.resolve(null)}}e.$k6b=O;class N{constructor(L){this.b=L}log(L,j){return this.b.call("log",{eventName:L,data:j}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$l6b=N}),define(re[46],oe([0,1,30,9,3,19,74,107,22]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0;class ${constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$$n=$;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$_n=C,e.$ao=new C;class E{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.$bo=E,e.$co="telemetry",e.$do="extensionTelemetryLog",e.$eo={log:()=>null,flush:()=>Promise.resolve(null)};function d(s,t){return A.Event.debounce(t.onDidChangeConfiguration,(a,v)=>{const b=a?new Set([...a.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:b}},1e3,!0)(a=>{a.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,L.$0h)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$fo=d;function h(s,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!s.enableTelemetry||t.extensionTestsLocationURI)}e.$go=h;function g(s,t){return!(t.isBuilt||t.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$ho=g;function y(s){const t=s.getValue(k.$cl),r=s.getValue(k.$dl);if(s.getValue(k.$el)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$io=y;function f(s){const t={},r={},a={};w(s,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const b=a[v];typeof b=="number"?r[v]=b:typeof b=="boolean"?r[v]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${b.length}`),t[v]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(t[v]=b)}return{properties:t,measurements:r}}e.$jo=f;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(s){if(!s)return"none";const t=(0,j.$Ok)(s);return o.has(t)?t:"other"}e.$ko=l;function w(s,t,r=0,a){if(s)for(const v of Object.getOwnPropertyNames(s)){const b=s[v],u=a?a+v:v;Array.isArray(b)?t[u]=(0,O.$Zm)(b):b instanceof Date?t[u]=b.toISOString():(0,N.$kf)(b)?r<2?w(b,t,r+1,u+"."):t[u]=(0,O.$Zm)(b):t[u]=b}}function m(s,t){const r=s.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,R.$0n)(r)||a}e.$lo=m;function I(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$mo=I;function i(s,t){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const a=[];for(const p of t)for(;;){const D=p.exec(s);if(!D)break;a.push([D.index,p.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const p=b.exec(s);if(!p)break;const D=a.some(([F,z])=>p.index<z&&F<b.lastIndex);!v.test(p[0])&&!D&&(r+=s.substring(u,p.index)+"<REDACTED: user-file-path>",u=b.lastIndex)}return u<s.length&&(r+=s.substr(u)),r}function c(s){if(!s)return s;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function n(s,t){return(0,O.$Wm)(s,r=>{if(r instanceof $||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=i(a,t);for(const v of t)a=a.replace(v,"");return a=c(a),a}})}e.$no=n}),define(re[33],oe([0,1,27,29,45,6,11,8,37,46]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,O.$Ge)(n.id,s.id)===0}e.$oo=C;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new d(s.identifier,t,r)}static parse(s){const t=E.exec(s);return t&&t[1]&&t[2]?new d({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof d?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$po=d;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(n){const s=h.exec(n);return s&&s[1]?[f(s[1]),s[2]]:[f(n),void 0]}e.$qo=g;function y(n,s){return`${n}.${s}`}e.$ro=y;function f(n){return n.toLowerCase()}e.$so=f;function o(n,s){return f(y(n??A.$Ql,s))}e.$to=o;function l(n,s){const t=[],r=a=>{for(const v of t)if(v.some(b=>C(s(b),s(a))))return v;return null};for(const a of n){const v=r(a);v?v.push(a):t.push([a])}return t}e.$uo=l;function w(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$vo=w;function m(n){return{id:new $.$$n(n.identifier.id),name:new $.$$n(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$wo=m,e.$xo=new A.$Ul("pprice.better-merge");function I(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!C(v.identifier,{id:a}))){const v=n.filter(b=>C(b.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$yo=I;async function i(n,s){if(!L.$k)return!1;let t;try{t=(await n.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$8)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(n,s){const t=await i(n,s),r=(0,N.$Tn)(t?"alpine":L.$t,k.$3d);return s.debug("ComputeTargetPlatform:",r),r}e.$zo=c}),define(re[221],oe([0,1,18,2,21,11,12,24,5,3,16,6,37,33]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n4b=e.$m4b=void 0;let g=class extends N.$jc{constructor(w,m){super(),this.b=w,this.c=m,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,I])=>this.a.set(I.configPath,I))}getConfigBasedTips(w){return this.f(w)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(w){const m=[];for(const[I,i]of this.a)if(!(i.configScheme&&i.configScheme!==w.scheme))try{const c=(await this.b.readFile((0,A.$hg)(w,I))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(c))&&m.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return m}};e.$m4b=g,e.$m4b=g=ye([X(0,j.$5j),X(1,R.$jj)],g);const y="extensionTips/promptedExecutableTips",f="extensionTips/lastPromptedMediumImpExeTime";class o extends g{constructor(w,m,I,i,c,n,s,t){super(s,t),this.r=w,this.s=m,this.t=I,this.u=i,this.w=c,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],b=[],u=[];Object.entries(a.recommendations).forEach(([p,D])=>{D.important?a.important?v.push({extensionId:p,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):b.push({extensionId:p,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):u.push({extensionId:p,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),b.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:b}),u.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:u})}),this.B((0,k.$Hg)(async()=>{await this.C(),this.F(),this.G()},3e3))}async getImportantExecutableBasedTips(){const w=await this.O(this.g),m=await this.O(this.h);return[...w,...m]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const w=await this.O(this.g),m=await this.O(this.h),I=await this.u.getInstalled();this.m=this.D(w,I),this.n=this.D(m,I)}D(w,m){const I=new Map;w.forEach(t=>I.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:c}=this.N([...I.keys()],m);for(const t of i){const r=I.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of c){const r=I.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of c){const r=I.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[w,m]=[...this.m.entries()][0];this.H(m).then(I=>{switch(I){case"reacted":this.M(m[0].exeName,m);break;case"ignored":this.m.delete(w);break;case"incompatibleWindow":{const i=$.Event.once($.Event.latch($.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B((0,k.$Hg)(()=>{i.dispose(),this.F()},36e5));break}}})}G(){if(this.n.size===0)return;const w=this.I(),m=Date.now()-w,I=7*24*60*60*1e3;if(m<I){const n=this.B((0,k.$Hg)(()=>{n.dispose(),this.G()},I-m));return}const[i,c]=[...this.n.entries()][0];this.H(c).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(c[0].exeName,c);const s=this.B((0,k.$Hg)(()=>{s.dispose(),this.G()},I));break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=$.Event.once($.Event.latch($.Event.any(this.s.onDidOpenWindow,this.s.onDidFocusWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B((0,k.$Hg)(()=>{s.dispose(),this.G()},36e5));break}}})}async H(w){const m=await this.u.getInstalled(1),I=w.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(c=>m.every(n=>!(0,h.$oo)(n.identifier,{id:c})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:I,source:3,name:w[0].exeFriendlyName,searchValue:`@exe:"${w[0].exeName}"`})}I(){let w=this.w.getNumber(f,-1);return w||(w=Date.now(),this.J(w)),w}J(w){this.w.store(f,w,-1,1)}L(){return JSON.parse(this.w.get(y,-1,"{}"))}M(w,m){const I=this.L();I[w]=m.map(({extensionId:i})=>i.toLowerCase()),this.w.store(y,JSON.stringify(I),-1,0)}N(w,m){const I=[],i=[],c=m.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return w.forEach(n=>{c.has(n.toLowerCase())?I.push(n):i.push(n)}),{installed:I,uninstalled:i}}async O(w){const m=[],I=new Map;for(const i of w.keys()){const c=w.get(i);if(!c||!(0,O.$Ib)(c.recommendations))continue;const n=[];E.$i?c.windowsPath&&n.push(c.windowsPath.replace("%USERPROFILE%",()=>d.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>d.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>d.env.ProgramFiles).replace("%APPDATA%",()=>d.env.APPDATA).replace("%WINDIR%",()=>d.env.WINDIR)):(n.push((0,C.$8d)("/usr/local/bin",i)),n.push((0,C.$8d)("/usr/bin",i)),n.push((0,C.$8d)(this.r.fsPath,i)));for(const s of n){let t=I.get(s);if(t===void 0&&(t=await this.b.exists(L.URI.file(s)),I.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:b}of c.recommendations)m.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:i,exeFriendlyName:c.exeFriendlyName,windowsPath:c.windowsPath,whenNotInstalled:b})}}return m}}e.$n4b=o}),define(re[222],oe([0,1,26,33]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SUb=void 0;async function A(L,j,R,k,$){try{const C=await L.getExtensionsControlManifest();if(!C.deprecated)return;const E=await L.getInstalled(1);for(const[d,h]of Object.entries(C.deprecated)){if(!h?.extension)continue;const{id:g,autoMigrate:y,preRelease:f}=h.extension;if(!y)continue;const o=E.find(w=>(0,N.$oo)(w.identifier,{id:d}));if(!o)continue;const l=(await j.getExtensions([{id:g,preRelease:f}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0];if(!l){$.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${g}' extension is not found`);continue}try{$.info(`Migrating '${o.identifier.id}' extension to '${g}' extension...`);const w=!k.getDisabledExtensions().some(I=>(0,N.$oo)(I,o.identifier));await L.uninstall(o),$.info(`Uninstalled the unsupported extension '${o.identifier.id}'`);let m=E.find(I=>(0,N.$oo)(I.identifier,{id:g}));(!m||!m.isPreReleaseVersion&&w)&&(m=await L.installFromGallery(l,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4}),$.info(`Installed the pre-release extension '${m.identifier.id}'`),w||(await k.disableExtension(m.identifier),$.info(`Disabled the pre-release extension '${m.identifier.id}' because the unsupported extension '${o.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,N.$ro)(o.manifest.publisher,o.manifest.name),(0,N.$ro)(m.manifest.publisher,m.manifest.name)),$.info("Added pre-release extension to the storage migration list"))),$.info(`Migrated '${o.identifier.id}' extension to '${g}' extension.`)}catch(w){$.error(w)}}}catch(C){$.error(C)}}e.$SUb=A}),define(re[223],oe([0,1,3,2,35,33,45]),function(te,e,O,N,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;class R extends N.$jc{constructor($,C,E,d,h,g,y){super(),this.f=$,this.g=C,this.h=E,this.j=d,this.m=h,this.n=g,this.r=y,this.a=this.B(new O.$ed),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$rc),this.s().then(null,f=>y.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(C=>(this.c.set(C.id,(0,N.$gc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w($){for(const C of $.extensions)this.I(this.L(C.identifier,C.version),$.profileLocation)}async y($){for(const C of $.extensions){const E=this.L(C.identifier,C.version);$.error?this.J(E,$.profileLocation):this.I(E,$.profileLocation)}}async z($){for(const C of $.extensions)this.J(this.L(C.identifier,C.version),$.profileLocation)}async C($){const C=[],E=[];for(const d of $.extensions){const h=this.L(d.identifier,d.version);$.error?this.I(h,$.profileLocation):(this.J(h,$.profileLocation),this.b.has(h)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),E.push(this.f.scanInstalledExtensionAtLocation(d.location).then(g=>{g?C.push(g):this.r.info("Extension not found at the location",d.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(E),C.length&&await this.H(C)}catch(d){this.r.error(d)}}D($){for(const C of this.h.profiles)$.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F($){const C=[],E=[],d=await this.j.scanProfileExtensions($),h=new Set,g=new Set;for(const[y,f]of this.b)f.has($)&&g.add(y);for(const y of d){const f=this.L(y.identifier,y.version);h.add(f),g.has(f)||(C.push(y.identifier),this.I(f,$))}for(const y of g)if(!h.has(y)){const f=this.M(y);f&&(E.push(f.identifier),this.J(y,$))}(C.length||E.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:$}:void 0,removed:E.length?{extensions:E,profileLocation:$}:void 0})}async G($){const C=await this.j.scanProfileExtensions($);for(const E of C)this.I(this.L(E.identifier,E.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,C){let E=this.b.get($);E||this.b.set($,E=new A.$zi(d=>this.m.extUri.getComparisonKey(d))),E.add(C)}J($,C){const E=this.b.get($);E&&E.delete(C),E?.size||this.b.delete($)}L($,C){return`${j.$Ul.toKey($.id)}@${C}`}M($){const[C,E]=(0,L.$qo)($);return E?{identifier:{id:C},version:E}:void 0}}e.$wp=R}),define(re[224],oe([0,1,44,46]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;async function A(L,j,R,k,$,C,E){const d={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${j.nameShort})`};if((0,N.$go)(j,R)&&(0,N.$io)(k)===3){const h=await(0,O.$1o)(R,$,C);d["X-Market-User-Id"]=h,d["VSCode-SessionId"]=E.machineId||h}return d}e.$2o=A}),define(re[225],oe([0,1,69,18,5,2,23,16,31,15,29,33,7,72,11]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;let y=class extends h.$Iq{constructor(w,m,I,i){super(I),this.h=w,this.j=i,this.g=this.B(new f(m,i)),this.h.registerParticipant({postInstall:async c=>this.m(c),postUninstall:async c=>this.n(c)})}async getBuiltInExtensionTranslationsUri(w,m){const i=(await this.g.getLanguagePacks())[m];if(!i){this.j.warn(`No language pack found for ${m}`);return}const c=i.translations[w];return c?g.URI.file(c):void 0}async getInstalledLanguages(){const w=await this.g.getLanguagePacks(),m=Object.keys(w).map(I=>{const i=w[I];return{...this.f(I,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((I,i)=>I.label.localeCompare(i.label)),m}async m(w){w&&w.manifest&&w.manifest.contributes&&w.manifest.contributes.localizations&&w.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",w.identifier.id),await this.update())}async n(w){const m=await this.g.getLanguagePacks();Object.keys(m).some(I=>m[I]&&m[I].extensions.some(i=>(0,E.$oo)(i.extensionIdentifier,w.identifier)))&&(this.j.info("Removing language packs from the extension",w.identifier.id),await this.update())}async update(){const[w,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),I=await this.g.update(m);return!(0,N.$sb)(Object.keys(w),Object.keys(I))}};e.$Jq=y,e.$Jq=y=ye([X(0,C.$1n),X(1,$.$Ih),X(2,C.$Yn),X(3,d.$4i)],y);let f=class extends L.$jc{constructor(w,m){super(),this.j=m,this.c={},this.f=(0,R.$8d)(w.userDataPath,"languagepacks.json"),this.g=new A.$Mg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(w){return this.s(m=>{Object.keys(m).forEach(I=>delete m[I]),this.m(m,...w)}).then(()=>this.c)}m(w,...m){for(const I of m)I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&this.n(w,I);Object.keys(w).forEach(I=>this.r(w[I]))}n(w,m){const I=m.identifier,i=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const c of i)if(m.location.scheme===j.Schemas.file&&o(c)){let n=w[c.languageId];n||(n={hash:"",extensions:[],translations:{},label:c.localizedLanguageName??c.languageName},w[c.languageId]=n);const s=n.extensions.filter(t=>(0,E.$oo)(t.extensionIdentifier,I))[0];s?s.version=m.manifest.version:n.extensions.push({extensionIdentifier:I,version:m.manifest.version});for(const t of c.translations)n.translations[t.id]=(0,R.$8d)(m.location.fsPath,t.path)}}r(w){if(w){const m=(0,O.createHash)("md5");for(const I of w.extensions)m.update(I.extensionIdentifier.uuid||I.extensionIdentifier.id).update(I.version);w.hash=m.digest("hex")}}s(w=()=>null){return this.g.queue(()=>{let m=null;return k.Promises.readFile(this.f,"utf8").then(void 0,I=>I.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(I)).then(I=>{try{return JSON.parse(I)}catch{return{}}}).then(I=>(m=w(I),I)).then(I=>{for(const c of Object.keys(I))I[c]||delete I[c];this.c=I,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),k.Promises.writeFile(this.f,i)}).then(()=>m,I=>this.j.error(I))})}};f=ye([X(0,$.$Ih),X(1,d.$4i)],f);function o(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const w of l.translations)if(typeof w.id!="string"||typeof w.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(re[226],oe([0,1,143,8,30,46]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(C,E,d){const h=await(0,O.$_C)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,O.$_C)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new h.AppInsightsCore,f=new g.PostChannel,o={instrumentationKey:C,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(d){o.extensionConfig={};const l={alwaysUseXhrOverride:!0,httpXHROverride:d};o.extensionConfig[f.identifier]=l}return y.initialize(o,[]),y.addTelemetryInitializer(l=>{E&&(l.ext=l.ext??{},l.ext.utc=l.ext.utc??{},l.ext.utc.flags=8462029)}),y}class ${constructor(E,d,h,g,y){this.e=E,this.f=d,this.g=h,this.h=y,this.c=j,this.d=R,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(d=>{E(d)},d=>{(0,N.$Y)(d),console.error(d)})}}log(E,d){if(!this.a)return;d=(0,A.$Xm)(d,this.g),d=(0,L.$jo)(d);const h=this.f+"/"+E;try{this.i(g=>{g.pluginVersionString=d?.properties.version??"Unknown",g.track({name:h,baseData:{name:h,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$8M=$}),define(re[109],oe([0,1,2,167,15,7,24,46]),function(te,e,O,N,A,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N3b=void 0;let k=class extends O.$jc{constructor(C,E,d,h,g=""){super(),this.b=g;const y=E.getLogger(R.$co);if(y)this.a=this.B(y);else{const o=(0,R.$ho)(h,d)?" (Not Sent)":"",l=()=>(0,R.$go)(h,d)&&C.getLevel()===L.LogLevel.Trace;this.a=this.B(E.createLogger(R.$co,{name:(0,N.localize)(0,null,o),hidden:!l()})),this.B(C.onDidChangeLogLevel(()=>E.setVisibility(R.$co,l()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,E){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$jo)(E))}};e.$N3b=k,e.$N3b=k=ye([X(0,L.$4i),X(1,L.$5i),X(2,A.$Hh),X(3,j.$jj)],k)}),define(re[110],oe([0,1,2,30,6,27,168,19,49,102,24,40,22,46]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(o,l,w){this.k=l,this.l=w,this.d={},this.i=new O.$ic,this.j=[],this.b=o.appenders,this.c=o.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=o.piiPaths||[],this.g=3,this.h=!!o.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,L.$pe)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$pe)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(d.$cl)||m.affectsConfiguration(d.$el)||m.affectsConfiguration(d.$dl))&&this.m()}))}setExperimentProperty(o,l){this.d[o]=l}m(){let o=(0,h.$io)(this.k);const l=this.l.enabledTelemetryLevels;if(l){this.h=this.sendErrorTelemetry?l.error:!1;const w=l.usage?3:l.error?2:0;o=Math.min(o,w)}this.g=o}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(o,l,w){this.g<l||(w=(0,N.$Xm)(w,this.d),w=(0,h.$no)(w,this.j),w=(0,N.$Xm)(w,this.c),this.b.forEach(m=>m.log(o,w)))}publicLog(o,l){this.n(o,3,l)}publicLog2(o,l){this.publicLog(o,l)}publicLogError(o,l){this.h&&this.n(o,2,l)}publicLogError2(o,l){this.publicLogError(o,l)}};e.$Pq=g,e.$Pq=g=ye([X(1,R.$7h),X(2,C.$jj)],g);function y(){const f=(0,j.localize)(0,null,$.default.nameLong),o=$.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",$.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),l=A.$o?"":(0,j.localize)(3,null),w=(0,j.localize)(4,null),m=(0,j.localize)(5,null),I=(0,j.localize)(6,null),i=(0,j.localize)(7,null),c=`
|       | ${w} | ${m} | ${I} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,j.localize)(8,null);return`
${f} ${o} ${l}

&nbsp;

${i}
${c}

&nbsp;

${n}
`}E.$7m.as(k.$_m.Configuration).registerConfiguration({id:d.$bl,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[d.$cl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$7m.as(k.$_m.Configuration).registerConfiguration({id:d.$bl,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[d.$el]:{type:"boolean",markdownDescription:$.default.privacyStatementUrl?(0,j.localize)(16,null,$.default.nameLong,$.default.privacyStatementUrl):(0,j.localize)(15,null,$.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${d.$cl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[227],oe([0,1,14,26,272,226]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;async function j(C,E){const d=await E.request(C,N.CancellationToken.None),h=(await(0,O.$Qd)(d.stream)).toString(),g=d.res.statusCode??200;return{headers:d.res.headers,statusCode:g,responseData:h}}async function R(C){const E={method:C.type,headers:C.headers};return new Promise((h,g)=>{const y=A.request(C.url??"",E,f=>{f.on("data",function(o){h({headers:f.headers,statusCode:f.statusCode??200,responseData:o.toString()})}),f.on("error",function(o){g(o)})});y.write(C.data,f=>{f&&g(f)}),y.end()})}async function k(C,E,d){const h=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),g={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:h};try{const y=C?await j(g,C):await R(g);d(y.statusCode,y.headers,y.responseData)}catch{d(0,{})}}class $ extends L.$8M{constructor(E,d,h,g,y){const f={sendPOST:(o,l)=>{k(E,o,l)}};super(d,h,g,y,f)}}e.$9M=$}),define(re[228],oe([0,1,23,93,19,15,7,24,22,108,109,110]),function(te,e,O,N,A,L,j,R,k,$,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=void 0;let d=class{constructor(g,y,f,o,l,w){this.b=g,this.c=y,this.d=f,this.e=o,this.f=l,this.g=w,this.a=new Map}h(g){if(!this.a.has(g.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.c.machineId,y["common.vscodesessionid"]=this.c.sessionId;const f=[g.id,JSON.stringify(y),g.aiKey],l=new N.$Rp(O.$1f.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:f,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),w=[new $.$l6b(l),new C.$N3b(this.d,this.e,this.f,this.g,`[${g.id}] `)];this.a.set(g.id,new E.$Pq({appenders:w,sendErrorTelemetry:g.sendErrorTelemetry},this.b,this.g))}return this.a.get(g.id)}publicLog(g,y,f){this.h(g).publicLog(y,f)}publicLogError(g,y,f){this.h(g).publicLogError(y,f)}};e.$B7b=d,e.$B7b=d=ye([X(0,A.$7h),X(1,k.$8k),X(2,j.$4i),X(3,j.$5i),X(4,L.$Hh),X(5,R.$jj)],d)}),define(re[76],oe([0,1,3,19,4,7]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.ProvidedOnAutoForward=e.$Xz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Wz=e.$Vz=void 0,e.$Vz=(0,A.$Ah)("tunnelService"),e.$Wz=(0,A.$Ah)("sharedTunnelsService");var j;(function(f){f.Http="http",f.Https="https"})(j||(e.TunnelProtocol=j={}));var R;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(R||(e.TunnelPrivacyId=R={}));function k(f){return!!f.forwardPort}e.$Xz=k;var $;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function C(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(o)return{address:o[1],port:+o[2]}}e.$Yz=C,e.$Zz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(f){return e.$Zz.indexOf(f)>=0}e.$1z=E,e.$2z=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(f){return e.$2z.indexOf(f)>=0}e.$3z=d;function h(f,o,l,w){if(l===1)return!1;if(l===2&&d(o)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(w);if(m?.length===4&&parseInt(m[1])>=18)return!1}return f<1024}e.$4z=h;class g{constructor(o,l,w){this.remoteAddress=o,this.localAddress=l,this.b=w,this.a=new O.$ed,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$5z=g;let y=class{constructor(o,l){this.j=o,this.k=l,this.a=new O.$ed,this.onTunnelOpened=this.a.event,this.b=new O.$ed,this.onTunnelClosed=this.b.event,this.c=new O.$ed,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],l=Array.from(this.e.values());for(const w of l){const m=Array.from(w.values());for(const I of m){const i=await I.value;i&&typeof i!="string"&&o.push(i)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:l}of o.values())await l.then(w=>typeof w!="string"?w?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,l,w,m,I){this.p(o,l,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:l,localAddress:w,privacy:m,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,l){(d(o)||E(o))&&(o=e.$Zz[0]);const w=this.r(o,l);if(w)return++w.refcount,w.value}openTunnel(o,l,w,m,I,i=!1,c,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${w} on local port ${I}.`);const s=this.f??o;if(!s)return;if(l||(l="localhost"),m||(m=this.l),this.f&&this.i.has(w)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(s,l,w,m,I,i,c,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(l,w),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(l,w);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==l||r.tunnelRemotePort!==w)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),c&&r.privacy!==c&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const l=this.e.get(o.tunnelRemoteHost);if(l){const w=l.get(o.tunnelRemotePort);w&&(w.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,w))}}}}async o(o,l,w){if(w.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${l}.`);const m=w.value.then(async I=>{I&&typeof I!="string"&&(await I.dispose(!0),this.b.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(l),m}}async closeTunnel(o,l){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${l} `);const w=this.e.get(o);if(w&&w.has(l)){const m=w.get(l);m.refcount=0,await this.o(o,l,m)}}p(o,l,w){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(l,{refcount:1,value:w})}async q(o,l){const w=this.e.get(o);if(w){const m=w.get(l),I=m?await m.value:void 0;(!I||typeof I=="string")&&w.delete(l),w.size===0&&this.e.delete(o)}}r(o,l){const w=[o];E(o)?(w.push(...e.$Zz),w.push(...e.$2z)):d(o)&&w.push(...e.$2z);const m=w.map(I=>this.e.get(I));for(const I of m){const i=I?.get(l);if(i)return i}}canTunnel(o){return!!C(o)}t(o,l,w,m,I,i,c){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${w} on local port ${m}.`);const n=w;this.i.add(n);const s=m===void 0?w:m,t={elevationRequired:I?this.isPortPrivileged(s):!1},r={remoteAddress:{host:l,port:w},localAddressPort:m,privacy:i,public:i?i!==R.Private:void 0,protocol:c},a=o.forwardPort(r,t);return a?(this.p(l,w,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),a}};e.$6z=y,e.$6z=y=ye([X(0,L.$4i),X(1,N.$7h)],y)}),define(re[229],oe([0,1,7,76,2,8,5]),function(te,e,O,N,A,L,j){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$O7b=void 0;class k extends A.$jc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new j.$1g),this.b.p)}setAddress(E){this.a=E,this.b&&(this.b.complete(E),this.b=null)}setTunnel(E){this.B(E)}}let $=class extends A.$jc{static{R=this}static{this.a=0}constructor(E,d){super(),this.f=E,this.g=d,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(E,d,h,g,y,f,o){const l=new k,w=await Promise.resolve(this.f.openTunnel(E,l,h,g,y,f,o));if(!w||typeof w=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${h}:${g} (remote).`),l.dispose(),new Error("Could not create tunnel");if(this.c.has(d))throw this.c.delete(d),l.dispose(),await w.dispose(),(0,L.$4)();return l.setTunnel(w),this.b.set(d,l),this.g.info(`[SharedProcessTunnelService] Created tunnel ${d}: ${w.localAddress} (local) to ${h}:${g} (remote).`),{tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress}}async setAddress(E,d){const h=this.b.get(E);h&&h.setAddress(d)}async destroyTunnel(E){const d=this.b.get(E);if(d){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this.b.delete(E),await d.dispose();return}this.c.add(E)}};e.$O7b=$,e.$O7b=$=R=ye([X(0,N.$Wz),X(1,O.$4i)],$)}),define(re[28],oe([0,1,4]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=void 0,e.$Bk=(0,O.$Ah)("IUriIdentityService")}),define(re[230],oe([0,1,28,185,12,21,128,3,2]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class ${static{this._clock=0}constructor(d){this.uri=d,this.time=$._clock++}touch(){return this.time=$._clock++,this}}let C=class{constructor(d){this.g=d,this.c=new k.$ic,this.f=2**16;const h=new Map,g=y=>{let f=h.get(y.scheme);return f===void 0&&(f=d.hasProvider(y)&&!this.g.hasCapability(y,1024),h.set(y.scheme,f)),f};this.c.add(R.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(y=>{h.delete(y.scheme)})),this.extUri=new L.$9f(g),this.d=new j.$nr((y,f)=>this.extUri.compare(y,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,L.$ig)(d));const h=this.d.get(d);return h?h.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new $(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((g,y)=>g[1].time<y[1].time?1:g[1].time>y[1].time?-1:0);$._clock=0,this.d.clear();const h=this.f*.5;for(let g=0;g<h;g++)this.d.set(d[g][0],d[g][1].touch())}};e.$or=C,e.$or=C=ye([X(0,A.$5j)],C),(0,N.$lr)(O.$Bk,C,1)}),define(re[231],oe([0,1,3,2,12,42,47,14,9,35]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=void 0;class C extends N.$jc{get capabilities(){return this.g.capabilities&-5}constructor(d,h,g,y,f,o){super(),this.f=d,this.g=h,this.h=g,this.j=y,this.m=o,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$ed),this.onDidChangeFile=this.a.event,this.b=j.$Gh.forUris(()=>!(this.capabilities&1024)),this.c=new $.$zi(l=>f.extUri.getComparisonKey(this.s(l))),this.n(),this.B(y.onDidChangeProfiles(()=>this.n())),this.B(this.g.onDidChangeFile(l=>this.r(l)))}n(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}watch(d,h){this.b.set(d,d);const g=this.g.watch(this.s(d),h);return(0,N.$hc)(()=>{this.b.delete(d),g.dispose()})}stat(d){return this.g.stat(this.s(d))}mkdir(d){return this.g.mkdir(this.s(d))}rename(d,h,g){return this.g.rename(this.s(d),this.s(h),g)}readFile(d){return this.g.readFile(this.s(d),{atomic:!0})}readFileStream(d,h,g){const y=(0,L.$sd)(f=>R.$Ed.concat(f.map(o=>R.$Ed.wrap(o))).buffer);return(async()=>{try{const f=await this.readFile(d);y.end(f)}catch(f){y.error(f),y.end()}})(),y}readdir(d){return this.g.readdir(this.s(d))}writeFile(d,h,g){return this.c.has(d)&&!(0,k.$kf)(g.atomic)&&(0,A.$ak)(this.g)&&(g={...g,atomic:{postfix:".vsctmp"}}),this.g.writeFile(this.s(d),h,g)}delete(d,h){return this.g.delete(this.s(d),h)}copy(d,h,g){if((0,A.$8j)(this.g))return this.g.copy(this.s(d),this.s(h),g);throw new Error("copy not supported")}r(d){const h=[];for(const g of d){if(g.resource.scheme!==this.f)continue;const y=this.t(g.resource);this.b.findSubstr(y)&&h.push({resource:y,type:g.type})}h.length&&(this.m.debug("User data changed"),this.a.fire(h))}s(d){return d.with({scheme:this.f})}t(d){return d.with({scheme:this.h})}}e.$96b=C}),define(re[77],oe([0,1,85]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jzb=e.$Izb=e.edit=void 0;function N(j,R,k,$){const C=(0,O.$vS)(j,R,k,$)[0];return C&&(j=j.substring(0,C.offset)+C.content+j.substring(C.offset+C.length)),j}e.edit=N;function A(j,R,k){let $=k;for(;$>=0;){if(j.charAt($)===R.charAt(R.length-1)&&R.length===1)return $+1;if($--,R.length===2&&$>=0&&j.charAt($)===R.charAt(0))return $+2}return 0}e.$Izb=A;function L(j,R,k){let $=k;for(;$>=0;)if(j.charAt($)===R.charAt(R.length-1)&&R.length===1||($++,R.length===2&&$>=0&&j.charAt($)===R.charAt(1)))return $;return j.length-1}e.$Jzb=L}),define(re[232],oe([0,1,30,53,9]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v2b=void 0;function L(h,g,y,f,o,l){const w=[],m=[],I=[];if(!g){const B=h.filter(({identifier:x})=>o.every(J=>J.toLowerCase()!==x.id.toLowerCase()));return{local:{added:w,removed:m,updated:I},remote:B.length>0?{added:B,updated:[],removed:[],all:B}:null}}h=h.map(E),g=g.map(E),y=y?y.map(E):null;const i=new Map,c=B=>{B.uuid&&i.set(B.id.toLowerCase(),B.uuid)};h.forEach(({identifier:B})=>c(B)),g.forEach(({identifier:B})=>c(B)),y?.forEach(({identifier:B})=>c(B));const n=B=>{const x=B.identifier.uuid||i.get(B.identifier.id.toLowerCase());return x?`uuid:${x}`:`id:${B.identifier.id.toLowerCase()}`},s=(B,x)=>(B.set(n(x),x),B),t=h.reduce(s,new Map),r=g.reduce(s,new Map),a=g.reduce((B,x)=>s(B,(0,O.$Um)(x)),new Map),v=y?y.reduce(s,new Map):null,b=f.reduce(s,new Map),u=o.reduce((B,x)=>{const J=i.get(x.toLowerCase());return B.add(J?`uuid:${J}`:`id:${x.toLowerCase()}`)},new Set),p=l?l.reduce((B,{id:x,uuid:J})=>(J=J??i.get(x.toLowerCase()),B.add(J?`uuid:${J}`:`id:${x.toLowerCase()}`)),new Set):null,D=j(t,r,u,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const B=j(v,t,u,!1),x=j(v,r,u,!0),J=(Q,W,Z,G)=>{let H,V,ee;return W.installed?(H=G.pinned,ee=G.preRelease,H&&(V=G.version)):(H=Z.pinned,ee=Z.preRelease,H&&(V=Z.version)),H===void 0&&(H=W.pinned,H&&(V=W.version)),ee===void 0&&(ee=W.preRelease),{...G,installed:W.installed||Z.installed,pinned:H,preRelease:ee,version:V??(Z.version&&(!W.installed||N.gt(Z.version,W.version))?Z.version:W.version),state:k(W,Z,v?.get(Q))}};for(const Q of x.removed.values()){const W=t.get(Q);if(!W)continue;const Z=(0,A.$tf)(v?.get(Q)),G=p&&!p.has(Q)&&Z.installed;W.installed&&G?m.push(W.identifier):a.set(Q,W)}for(const Q of x.added.values()){const W=(0,A.$tf)(r.get(Q)),Z=t.get(Q);if(Z){if(D.updated.has(Q)){const G=J(Q,Z,W,W);R(Z,W,!1,!1)||I.push(d(G,Q)),a.set(Q,G)}}else W.installed&&w.push(d(W,Q))}for(const Q of x.updated.values()){const W=(0,A.$tf)(r.get(Q)),Z=(0,A.$tf)(v?.get(Q)),G=t.get(Q);if(G)if(p&&!p.has(Q)&&Z.installed&&G.installed&&!W.installed)m.push(G.identifier);else{const V=J(Q,G,W,W);I.push(d(V,Q)),a.set(Q,V)}else W.installed&&w.push(d(W,Q))}for(const Q of B.added.values())x.added.has(Q)||a.set(Q,(0,A.$tf)(t.get(Q)));for(const Q of B.updated.values()){if(x.removed.has(Q)||x.updated.has(Q))continue;const W=(0,A.$tf)(t.get(Q)),Z=(0,A.$tf)(r.get(Q));a.set(Q,J(Q,W,Z,W))}for(const Q of B.removed.values())x.updated.has(Q)||x.removed.has(Q)||b.has(Q)||(0,A.$tf)(r.get(Q)).installed&&p&&(p.has(Q)||!(0,A.$tf)(v?.get(Q)).installed||a.delete(Q))}const F=[],z=j(r,a,new Set,!0),U=z.added.size>0||z.updated.size>0||z.removed.size>0;return U&&a.forEach((B,x)=>F.push(d(B,x))),{local:{added:w,removed:m,updated:I},remote:U?{added:[...z.added].map(B=>a.get(B)),updated:[...z.updated].map(B=>a.get(B)),removed:[...z.removed].map(B=>r.get(B)),all:F}:null}}e.$v2b=L;function j(h,g,y,f){const o=h?[...h.keys()].filter(i=>!y.has(i)):[],l=[...g.keys()].filter(i=>!y.has(i)),w=l.filter(i=>!o.includes(i)).reduce((i,c)=>(i.add(c),i),new Set),m=o.filter(i=>!l.includes(i)).reduce((i,c)=>(i.add(c),i),new Set),I=new Set;for(const i of o){if(m.has(i))continue;const c=h.get(i),n=g.get(i);(!n||!R(c,n,f,!0))&&I.add(i)}return{added:w,removed:m,updated:I}}function R(h,g,y,f){return!(h.disabled!==g.disabled||!!h.isApplicationScoped!=!!g.isApplicationScoped||f&&h.installed!==g.installed||h.installed&&g.installed&&(h.preRelease!==g.preRelease||h.pinned!==g.pinned||g.pinned&&h.version!==g.version)||!C(h.state,g.state)||y&&h.version!==g.version)}function k(h,g,y){const f=h.state,o=g.state,l=y?.state;if(!g.version||f&&N.gt(h.version,g.version))return f;if(o&&N.gt(g.version,h.version)||!f)return o;if(!o)return f;const w=(0,O.$Um)(f),m=l?$(l,o):{added:Object.keys(o).reduce((i,c)=>(i.add(c),i),new Set),removed:new Set,updated:new Set},I=l?$(l,f):{added:Object.keys(f).reduce((i,c)=>(i.add(c),i),new Set),removed:new Set,updated:new Set};for(const i of[...m.added.values(),...m.updated.values()])w[i]=o[i];for(const i of m.removed.values())I.updated.has(i)||delete w[i];return w}function $(h,g){const y=Object.keys(h),f=Object.keys(g),o=f.filter(m=>!y.includes(m)).reduce((m,I)=>(m.add(I),m),new Set),l=y.filter(m=>!f.includes(m)).reduce((m,I)=>(m.add(I),m),new Set),w=new Set;for(const m of y){if(l.has(m))continue;const I=h[m],i=g[m];(0,O.$Ym)(I,i)||w.add(m)}return{added:o,removed:l,updated:w}}function C(h={},g={}){const{added:y,removed:f,updated:o}=$(h,g);return y.size===0&&f.size===0&&o.size===0}function E(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function d(h,g){const y={...h,identifier:{id:h.identifier.id,uuid:g.startsWith("uuid:")?g.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete y.disabled,h.installed||delete y.installed,h.state||delete y.state,h.isApplicationScoped||delete y.isApplicationScoped,y}}),define(re[111],oe([0,1,18,19,4]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GBb=e.$FBb=void 0,e.$FBb=(0,A.$Ah)("IIgnoredExtensionsManagementService");let L=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,k){let $=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return $=$.filter(C=>C!==R&&C!==`-${R}`),k&&$.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",$.length?$:void 0,2)}updateSynchronizedExtensions(R,k){let $=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return $=$.filter(C=>C!==R&&C!==`-${R}`),k&&$.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",$.length?$:void 0,2)}getIgnoredExtensions(R){const k=R.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),$=this.b().map(d=>d.toLowerCase()),C=[],E=[];if(Array.isArray($))for(const d of $)d.startsWith("-")?E.push(d.substring(1)):C.push(d);return(0,O.$Jb)([...k,...C].filter(d=>!E.includes(d)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$GBb=L,e.$GBb=L=ye([X(0,N.$7h)],L)}),define(re[233],oe([0,1,18,34,30,94,77]),function(te,e,O,N,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B2b=void 0;function R(m){return(0,N.$Km)(m)||[]}async function k(m,I,i,c,n){const s=R(m),t=R(I),r=i?R(i):null,a=[...s,...t,...r||[]].map(J=>J.key),v=await n.resolveUserBindings(a),b=C(s,t,r,v);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:m,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:I,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:m,hasChanges:!0,hasConflicts:!1};const u=d(s),p=d(t),D=r?d(r):null,F=g(u,p,v),z=D?g(D,u,v):{added:[...u.keys()].reduce((J,Q)=>(J.add(Q),J),new Set),removed:new Set,updated:new Set},U=D?g(D,p,v):{added:[...p.keys()].reduce((J,Q)=>(J.add(Q),J),new Set),removed:new Set,updated:new Set},B=$(F,z,U);let x=m;for(const J of B.removed.values())B.conflicts.has(J)||(x=l(x,J,c));for(const J of B.added.values()){if(B.conflicts.has(J))continue;const Q=p.get(J);if(Q.some(W=>W.command!==`-${J}`&&b.conflicts.has(v[W.key]))){B.conflicts.add(J);continue}x=o(x,Q,c)}for(const J of B.updated.values()){if(B.conflicts.has(J))continue;const Q=p.get(J);if(Q.some(W=>W.command!==`-${J}`&&b.conflicts.has(v[W.key]))){B.conflicts.add(J);continue}x=w(x,J,Q,c)}return{mergeContent:x,hasChanges:!0,hasConflicts:B.conflicts.size>0}}e.$B2b=k;function $(m,I,i){const c=new Set,n=new Set,s=new Set,t=new Set;for(const r of I.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(I.updated.has(r)?t.add(r):n.add(r));for(const r of I.added.values())t.has(r)||i.added.has(r)&&m.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(I.added.has(r)?m.updated.has(r)&&t.add(r):c.add(r));for(const r of I.updated.values())t.has(r)||i.updated.has(r)&&m.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(I.updated.has(r)?m.updated.has(r)&&t.add(r):s.add(r));return{added:c,removed:n,updated:s,conflicts:t}}function C(m,I,i,c){const n=new Set,s=E(m,c),t=E(I,c),r=i?E(i,c):null,a=h(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const v=r?h(r,s):{added:[...s.keys()].reduce((z,U)=>(z.add(U),z),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const b=r?h(r,t):{added:[...t.keys()].reduce((z,U)=>(z.add(U),z),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:u,removed:p,updated:D,conflicts:F}=$(a,v,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:p,updated:D,conflicts:F}}function E(m,I){const i=new Map;for(const c of m){const n=I[c.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(c)}return i}function d(m){const I=new Map;for(const i of m){const c=i.command[0]==="-"?i.command.substring(1):i.command;let n=I.get(c);n||(n=[],I.set(c,n)),n.push(i)}return I}function h(m,I){const i=[...m.keys()],c=[...I.keys()],n=c.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!c.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=m.get(r).map(b=>({...b,key:r})),v=I.get(r).map(b=>({...b,key:r}));(0,O.$sb)(a,v,(b,u)=>f(b,u))||t.add(r)}return{added:n,removed:s,updated:t}}function g(m,I,i){const c=[...m.keys()],n=[...I.keys()],s=n.filter(a=>!c.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=c.filter(a=>!n.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of c){if(t.has(a))continue;const v=m.get(a).map(u=>({...u,key:i[u.key]})),b=I.get(a).map(u=>({...u,key:i[u.key]}));y(v,b)||r.add(a)}return{added:s,removed:t,updated:r}}function y(m,I){return!(!(0,O.$sb)(m.filter(({command:i})=>i[0]!=="-"),I.filter(({command:i})=>i[0]!=="-"),(i,c)=>f(i,c))||!(0,O.$sb)(m.filter(({command:i})=>i[0]==="-"),I.filter(({command:i})=>i[0]==="-"),(i,c)=>f(i,c)))}function f(m,I){if(m.command!==I.command||m.key!==I.key)return!1;const i=L.$Hi.deserialize(m.when),c=L.$Hi.deserialize(I.when);return!(i&&!c||!i&&c||i&&c&&!i.equals(c)||!A.$Ym(m.args,I.args))}function o(m,I,i){for(const c of I)m=j.edit(m,[-1],c,i);return m}function l(m,I,i){const c=R(m);for(let n=c.length-1;n>=0;n--)(c[n].command===I||c[n].command===`-${I}`)&&(m=j.edit(m,[n],void 0,i));return m}function w(m,I,i,c){const n=R(m),s=n.findIndex(t=>t.command===I||t.command===`-${I}`);for(let t=n.length-1;t>=0;t--)(n[t].command===I||n[t].command===`-${I}`)&&(m=j.edit(m,[t],void 0,c));for(let t=i.length-1;t>=0;t--)m=j.edit(m,[s],i[t],c);return m}}),define(re[234],oe([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J2b=e.$I2b=void 0;function O(L,j,R){const k={},$={},C=new Set;if(!j)return{local:{added:k,updated:$,removed:[...C.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=N(L,j);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:k,updated:$,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=N(R,L),h=N(R,j),g={},y={},f=new Set,o=new Set;for(const l of d.removed.values())h.updated.has(l)?k[l]=j[l]:f.add(l);for(const l of h.removed.values())o.has(l)||(d.updated.has(l)?o.add(l):C.add(l));for(const l of d.updated.values())o.has(l)||(h.updated.has(l)?E.updated.has(l)&&o.add(l):y[l]=L[l]);for(const l of h.updated.values())o.has(l)||(d.updated.has(l)?E.updated.has(l)&&o.add(l):L[l]!==void 0&&($[l]=j[l]));for(const l of d.added.values())o.has(l)||(h.added.has(l)?E.updated.has(l)&&o.add(l):g[l]=L[l]);for(const l of h.added.values())o.has(l)||(d.added.has(l)?E.updated.has(l)&&o.add(l):k[l]=j[l]);return{local:{added:k,removed:[...C.values()],updated:$},remote:{added:g,removed:[...f.values()],updated:y},conflicts:[...o.values()]}}e.$I2b=O;function N(L,j){const R=L?Object.keys(L):[],k=j?Object.keys(j):[],$=k.filter(d=>!R.includes(d)).reduce((d,h)=>(d.add(h),d),new Set),C=R.filter(d=>!k.includes(d)).reduce((d,h)=>(d.add(h),d),new Set),E=new Set;for(const d of R){if(C.has(d))continue;const h=L[d],g=j[d];h!==g&&E.add(d)}return{added:$,removed:C,updated:E}}function A(L,j){const{added:R,removed:k,updated:$}=N(L,j);return R.size===0&&k.size===0&&$.size===0}e.$J2b=A}),define(re[235],oe([0,1,30]),function(te,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q4b=void 0;function N(L,j,R,k){const $={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!j){const d=L.filter(({id:h})=>!k.includes(h));return d.length?C.added=d:C=null,{local:$,remote:C}}const E=A(L,j,k);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const d=A(R,L,k),h=A(R,j,k);for(const g of h.removed){const y=L.find(f=>f.id===g);y&&$.removed.push(y)}for(const g of h.added){const y=j.find(f=>f.id===g);d.added.includes(g)?E.updated.includes(g)&&$.updated.push(y):$.added.push(y)}for(const g of h.updated)$.updated.push(j.find(y=>y.id===g));for(const g of d.added)h.added.includes(g)||C.added.push(L.find(y=>y.id===g));for(const g of d.updated)h.removed.includes(g)||h.updated.includes(g)||C.updated.push(L.find(y=>y.id===g));for(const g of d.removed){const y=j.find(f=>f.id===g);y&&C.removed.push(y)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:$,remote:C}}e.$q4b=N;function A(L,j,R){L=L?L.filter(({id:h})=>!R.includes(h)):[],j=j.filter(({id:h})=>!R.includes(h));const k=L.map(({id:h})=>h),$=j.map(({id:h})=>h),C=$.filter(h=>!k.includes(h)),E=k.filter(h=>!$.includes(h)),d=[];for(const{id:h,name:g,shortName:y,useDefaultFlags:f}of L){if(E.includes(h))continue;const o=j.find(l=>l.id===h);(!o||o.name!==g||o.shortName!==y||!(0,O.$Ym)(o.useDefaultFlags,f))&&d.push(h)}return{added:C,removed:E,updated:d}}}),define(re[25],oe([0,1,18,9,174,49,29,4,103,40]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngb=e.$Mgb=e.$Lgb=e.$Kgb=e.$Jgb=e.$Igb=e.$Hgb=e.$Ggb=e.$Fgb=e.$Egb=e.$Dgb=e.MergeState=e.Change=e.SyncStatus=e.$Cgb=e.$Bgb=e.$Agb=e.UserDataSyncErrorCode=e.$zgb=e.$ygb=e.$xgb=e.$wgb=e.$vgb=e.$ugb=e.$tgb=e.$sgb=e.$rgb=e.SyncResource=e.$qgb=e.$pgb=e.$ogb=e.$ngb=e.$mgb=e.$lgb=void 0;function C(){const t=$.$7m.as(L.$_m.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$lgb=C;function E(){const t=$.$7m.as(L.$_m.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(b=>!!t[b].ignoreSync),a=Object.keys(t).filter(b=>t[b].scope===2||t[b].scope===6),v=C();return(0,O.$Jb)([...r,...a,...v])}e.$mgb=E,e.$ngb="settingsSync",e.$ogb="settingsSync.keybindingsPerPlatform";function d(){const t="vscode://schemas/ignoredSettings",r=$.$7m.as(L.$_m.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.$ogb]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:j.$Ln,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=$.$7m.as(k.$8m.JSONContribution),v=()=>{const b=C(),u=E(),p=Object.keys(L.$an.properties).filter(z=>!u.includes(z)),D=u.filter(z=>!b.includes(z)),F={items:{type:"string",enum:[...p,...D.map(z=>`-${z}`)]}};a.registerSchema(t,F)};return r.onDidUpdateConfiguration(()=>v())}e.$pgb=d;function h(t){return t&&(0,N.$kf)(t)&&(0,N.$if)(t.id)&&Array.isArray(t.scopes)}e.$qgb=h;var g;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})(g||(e.SyncResource=g={})),e.$rgb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(t,...r){return t?[t,...r]:r}e.$sgb=y;function f(t,r,a,v){return v.joinPath(a.userDataSyncHome,...y(t,r,`lastSync${r}.json`))}e.$tgb=f,e.$ugb=(0,R.$Ah)("IUserDataSyncStoreManagementService"),e.$vgb=(0,R.$Ah)("IUserDataSyncStoreService"),e.$wgb=(0,R.$Ah)("IUserDataSyncLocalStoreService"),e.$xgb="x-operation-id",e.$ygb="X-Execution-Id";function o(t){const r={};return r[e.$ygb]=t,r}e.$zgb=o;var l;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(l||(e.UserDataSyncErrorCode=l={}));class w extends Error{constructor(r,a,v,b){super(r),this.code=a,this.resource=v,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Agb=w;class m extends w{constructor(r,a,v,b,u){super(r,v,void 0,u),this.url=a,this.serverCode=b}}e.$Bgb=m;class I extends w{constructor(r,a){super(r,a)}}e.$Cgb=I,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const b=v[2]==="unknown"?void 0:v[2],u=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],b,u)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(w||(e.$Agb=w={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var c;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(c||(e.Change=c={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Dgb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$Egb=s,e.$Fgb=(0,R.$Ah)("IUserDataSyncEnablementService"),e.$Ggb=(0,R.$Ah)("IUserDataSyncService"),e.$Hgb=(0,R.$Ah)("IUserDataSyncResourceProviderService"),e.$Igb=(0,R.$Ah)("IUserDataAutoSyncService"),e.$Jgb=(0,R.$Ah)("IUserDataSyncUtilService"),e.$Kgb=(0,R.$Ah)("IUserDataSyncLogService"),e.$Lgb="userDataSync",e.$Mgb="vscode-userdata-sync",e.$Ngb="preview"}),define(re[236],oe([0,1,30,25]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Ab=void 0;function A(j,R,k,$,C){if(!R)return{remote:{added:Object.keys(j),removed:[],updated:[],all:Object.keys(j).length>0?j:null},local:{added:{},removed:[],updated:{}}};const E=L(j,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const d=k?L(k,R):{added:Object.keys(R).reduce((l,w)=>(l.add(w),l),new Set),removed:new Set,updated:new Set},h=k?L(k,j):{added:Object.keys(j).reduce((l,w)=>(l.add(w),l),new Set),removed:new Set,updated:new Set},g={added:{},removed:[],updated:{}},y=O.$Um(R),f=!k;for(const l of h.added.values())l!==N.$Dgb&&f&&d.added.has(l)||(y[l]=j[l]);for(const l of h.updated.values())y[l]=j[l];for(const l of h.removed.values())$.unregistered.includes(l)||delete y[l];for(const l of d.added.values()){const w=R[l];if($.machine.includes(l)){C.info(`GlobalState: Skipped adding ${l} in local storage because it is declared as machine scoped.`);continue}if(k&&h.added.has(l))continue;const m=j[l];m&&m.value===w.value||l===N.$Dgb&&f&&h.added.has(l)||(m?g.updated[l]=w:g.added[l]=w)}for(const l of d.updated.values()){const w=R[l];if($.machine.includes(l)){C.info(`GlobalState: Skipped updating ${l} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(l)||h.removed.has(l))continue;const m=j[l];m&&m.value===w.value||(g.updated[l]=w)}for(const l of d.removed.values()){if($.machine.includes(l)){C.trace(`GlobalState: Skipped removing ${l} in local storage because it is declared as machine scoped.`);continue}h.updated.has(l)||h.removed.has(l)||g.removed.push(l)}const o=L(R,y);return{local:g,remote:{added:[...o.added],updated:[...o.updated],removed:[...o.removed],all:o.added.size===0&&o.removed.size===0&&o.updated.size===0?null:y}}}e.$2Ab=A;function L(j,R){const k=Object.keys(j),$=Object.keys(R),C=$.filter(h=>!k.includes(h)).reduce((h,g)=>(h.add(g),h),new Set),E=k.filter(h=>!$.includes(h)).reduce((h,g)=>(h.add(g),h),new Set),d=new Set;for(const h of k){if(E.has(h))continue;const g=j[h],y=R[h];O.$Ym(g,y)||d.add(h)}return{added:C,removed:E,updated:d}}}),define(re[237],oe([0,1,18,34,85,41,30,77,25]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pzb=e.$Ozb=e.$Nzb=e.$Mzb=e.$Lzb=e.$Kzb=void 0;function $(a,v,b){let u=[];b?u=E(b):u=C(v);const p=[],D=[...(0,k.$lgb)()];if(Array.isArray(u))for(const F of u)F.startsWith("-")?D.push(F.substring(1)):p.push(F);return(0,O.$Jb)([...a,...p].filter(F=>!D.includes(F)))}e.$Kzb=$;function C(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const v=(0,N.$Km)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function d(a,v){const b=(0,N.$Km)(a)||{};let u="{}";for(const p of Object.keys(b)){const D=(0,A.$vS)(u,[p],b[p],v);u=(0,A.$yS)(u,D)}return u}e.$Lzb=d;function h(a,v,b,u){if(b.length){const p=r(v),D=(0,N.$Km)(v)||{},F=(0,N.$Km)(a);if(!F)return a;const z=[];for(const U of b){const B=D[U],x=F[U];B===void 0?a=R.edit(a,[U],void 0,u):x!==void 0?a=R.edit(a,[U],B,u):z.push(i(U,p))}z.sort((U,B)=>U.startOffset-B.startOffset),z.forEach(U=>a=l(U.setting.key,v,a,u))}return a}e.$Mzb=h;function g(a,v,b,u,p,D){const F=h(a,v,u,D),z=b!==F,U=b!==v;if(!z&&!U)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!U)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(U&&!z)return{conflictsSettings:[],localContent:h(v,a,u,D),remoteContent:null,hasConflicts:!1};if(b===null&&f(a)){const P=y(a,v,u)?null:h(v,a,u,D);return{conflictsSettings:[],localContent:P,remoteContent:null,hasConflicts:!1}}let B=a,x=v;const J=(0,N.$Km)(a),Q=(0,N.$Km)(v),W=b?(0,N.$Km)(b):null,Z=u.reduce((P,M)=>(P.add(M),P),new Set),G=o(J,Q,Z),H=o(W,J,Z),V=o(W,Q,Z),ee=new Map,ne=new Set,se=P=>{ne.add(P);const M=p.filter(({key:T})=>T===P)[0];M?(B=R.edit(B,[P],M.value,D),x=R.edit(x,[P],M.value,D)):ee.set(P,{key:P,localValue:J[P],remoteValue:Q[P]})};for(const P of H.removed.values())V.updated.has(P)?se(P):x=R.edit(x,[P],void 0,D);for(const P of V.removed.values())ne.has(P)||(H.updated.has(P)?se(P):B=R.edit(B,[P],void 0,D));for(const P of H.updated.values())ne.has(P)||(V.updated.has(P)?G.updated.has(P)&&se(P):x=R.edit(x,[P],J[P],D));for(const P of V.updated.values())ne.has(P)||(H.updated.has(P)?G.updated.has(P)&&se(P):B=R.edit(B,[P],Q[P],D));for(const P of H.added.values())ne.has(P)||(V.added.has(P)?G.updated.has(P)&&se(P):x=l(P,B,x,D));for(const P of V.added.values())ne.has(P)||(H.added.has(P)?G.updated.has(P)&&se(P):B=l(P,x,B,D));const Y=ee.size>0||!y(B,x,u),q=Y||!y(B,a,[]),S=Y||!y(x,v,[]);return{localContent:q?B:null,remoteContent:S?x:null,conflictsSettings:[...ee.values()],hasConflicts:Y}}e.$Nzb=g;function y(a,v,b){if(a===v)return!0;const u=(0,N.$Km)(a),p=(0,N.$Km)(v),D=b.reduce((U,B)=>(U.add(B),U),new Set),F=r(a).filter(U=>!(U.setting&&D.has(U.setting.key))),z=r(v).filter(U=>!(U.setting&&D.has(U.setting.key)));if(F.length!==z.length)return!1;for(let U=0;U<F.length;U++){const B=F[U],x=z[U];if(B.setting&&x.setting){if(B.setting.key!==x.setting.key||!j.$Ym(u[B.setting.key],p[B.setting.key]))return!1}else if(!B.setting&&!x.setting){if(B.value!==x.value)return!1}else return!1}return!0}function f(a){return a?r(a).length===0:!0}e.$Ozb=f;function o(a,v,b){const u=a?Object.keys(a).filter(U=>!b.has(U)):[],p=Object.keys(v).filter(U=>!b.has(U)),D=p.filter(U=>!u.includes(U)).reduce((U,B)=>(U.add(B),U),new Set),F=u.filter(U=>!p.includes(U)).reduce((U,B)=>(U.add(B),U),new Set),z=new Set;if(a)for(const U of u){if(F.has(U))continue;const B=a[U],x=v[U];j.$Ym(B,x)||z.add(U)}return{added:D,removed:F,updated:z}}function l(a,v,b,u){const p=(0,N.$Km)(v),D=r(v),F=r(b),z=w(a,D,F);return m(b,a,p[a],z,F,u)}e.$Pzb=l;function w(a,v,b){const u=v.findIndex(D=>D.setting?.key===a),p=v[u-1];if(p){if(p.setting){const F=i(p.setting.key,b);if(F)return{index:b.indexOf(F),insertAfter:!0}}else{const F=c(u,v);if(F){const z=i(F.setting.key,b);if(z){const U=n(b.indexOf(z),b),B=s(v,F,v[u]);if(U){const x=s(b,z,U),J=t(B,x);return J?{index:b.indexOf(J),insertAfter:!0}:{index:b.indexOf(U),insertAfter:!1}}else{const x=s(b,z,b[b.length-1]),J=t(B,x);return J?{index:b.indexOf(J),insertAfter:!0}:{index:b.length-1,insertAfter:!0}}}}}const D=v[u+1];if(D)if(D.setting){const F=i(D.setting.key,b);if(F)return{index:b.indexOf(F),insertAfter:!1}}else{const F=n(u,v);if(F){const z=i(F.setting.key,b);if(z){const U=c(b.indexOf(z),b),B=s(v,v[u],F);if(U){const x=s(b,U,z),J=t(B.reverse(),x.reverse());return J?{index:b.indexOf(J),insertAfter:!1}:{index:b.indexOf(U),insertAfter:!0}}else{const x=s(b,b[0],z),J=t(B.reverse(),x.reverse());return J?{index:b.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:b.length-1,insertAfter:!0}}function m(a,v,b,u,p,D){let F;return u.index===-1?F=(0,A.$vS)(a,[v],b,D):F=I(a,v,b,u,p,D).map(z=>(0,A.$wS)(a,z,D)[0]),(0,A.$yS)(a,F)}function I(a,v,b,u,p,D){const F=`${JSON.stringify(v)}: ${JSON.stringify(b)}`,z=(0,L.$sS)(D,a),U=p[u.index];if(u.insertAfter){const B=[];if(U.setting)B.push({offset:U.endOffset,length:0,content:","+F});else{const x=n(u.index,p),J=c(u.index,p),Q=J?.setting?.commaOffset;J&&Q===void 0&&B.push({offset:J.endOffset,length:0,content:","});const W=Q!==void 0&&Q>U.endOffset;B.push({offset:W?Q+1:U.endOffset,length:0,content:x?z+F+",":z+F})}return B}else{if(U.setting)return[{offset:U.startOffset,length:0,content:F+","}];const B=(p[u.index-1]&&!p[u.index-1].setting?z:"")+F+(n(u.index,p)?",":"")+z;return[{offset:U.startOffset,length:0,content:B}]}}function i(a,v){return v.filter(b=>b.setting?.key===a)[0]}function c(a,v){for(let b=a-1;b>=0;b--)if(v[b].setting)return v[b]}function n(a,v){for(let b=a+1;b<v.length;b++)if(v[b].setting)return v[b]}function s(a,v,b){const u=a.indexOf(v),p=a.indexOf(b);return a.filter((D,F)=>u<F&&F<p)}function t(a,v){if(a.length&&v.length){let b=0;for(;b<v.length&&b<a.length;b++)if(a[b].value!==v[b].value)return v[b-1];return v[b-1]}}function r(a){const v=[];let b=-1,u,p;const D={onObjectBegin:F=>{b++},onObjectProperty:(F,z,U)=>{b===0&&(u=z,p=F)},onObjectEnd:(F,z)=>{b--,b===0&&v.push({startOffset:u,endOffset:F+z,value:a.substring(u,F+z),setting:{key:p,commaOffset:void 0}})},onArrayBegin:(F,z)=>{b++},onArrayEnd:(F,z)=>{b--,b===0&&v.push({startOffset:u,endOffset:F+z,value:a.substring(u,F+z),setting:{key:p,commaOffset:void 0}})},onLiteralValue:(F,z,U)=>{b===0&&v.push({startOffset:u,endOffset:z+U,value:a.substring(u,z+U),setting:{key:p,commaOffset:void 0}})},onSeparator:(F,z,U)=>{if(b===0&&F===","){let B=v.length-1;for(;B>=0&&!v[B].setting;B--);const x=v[B];x&&v.splice(B,1,{startOffset:x.startOffset,endOffset:x.endOffset,value:x.value,setting:{key:x.setting.key,commaOffset:z}})}},onComment:(F,z)=>{b===0&&v.push({startOffset:F,endOffset:F+z,value:a.substring(F,F+z)})}};return(0,N.$Rm)(a,D),v}}),define(re[78],oe([0,1,3,2,4,25]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vzb=e.$uzb=void 0,e.$uzb=(0,A.$Ah)("IUserDataSyncAccountService");let j=class extends N.$jc{get account(){return this.a}constructor(k,$){super(),this.g=k,this.h=$,this.b=this.B(new O.$ed),this.onDidChangeAccount=this.b.event,this.c=this.B(new O.$ed),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$vzb=j,e.$vzb=j=ye([X(0,L.$vgb),X(1,L.$Kgb)],j)}),define(re[238],oe([0,1,2,11]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I7b=e.$H7b=e.$G7b=e.$F7b=e.$E7b=e.$D7b=e.$C7b=void 0;class A{constructor(d){this.a=d}listen(d,h){switch(h){case"onError":return this.a.onError}throw new Error(`Event not found: ${h}`)}call(d,h,g){switch(h){case"triggerSync":return this.a.triggerSync(g[0],g[1],g[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(g[0])}throw new Error("Invalid call")}}e.$C7b=A;class L{constructor(d){this.a=d}listen(d,h){throw new Error(`Event not found: ${h}`)}call(d,h,g){switch(h){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(g[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(g[0]))}throw new Error("Invalid call")}}e.$D7b=L;class j{constructor(d){this.a=d}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.a.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.a.call("resolveFormattingOptions",[d])}}e.$E7b=j;class R{constructor(d){this.a=d}listen(d,h){switch(h){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${h}`)}async call(d,h,g){switch(h){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(g[0],g[1]);case"setEnablements":return this.a.setEnablements(g)}throw new Error("Invalid call")}}e.$F7b=R;class k{constructor(d){this.a=d}listen(d,h){switch(h){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${h}`)}call(d,h,g){switch(h){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(g)}throw new Error("Invalid call")}}e.$G7b=k;class ${constructor(d){this.a=d}listen(d,h){switch(h){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${h}`)}call(d,h,g){switch(h){case"switch":return this.a.switch(g[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$H7b=$;class C extends O.$jc{constructor(d){super(),this.a=d,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.a.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.a.call("getPreviousUserDataSyncStore");return this.b(d)}b(d){return{url:N.URI.revive(d.url),type:d.type,defaultUrl:N.URI.revive(d.defaultUrl),insidersUrl:N.URI.revive(d.insidersUrl),stableUrl:N.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.$I7b=C}),define(re[239],oe([0,1,21,175,15,7,25]),function(te,e,O,N,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HBb=void 0;let R=class extends L.$9i{constructor($,C){super(),this.g=this.B($.createLogger((0,O.$hg)(C.logsHome,`${j.$Lgb}.log`),{id:j.$Lgb,name:(0,N.localize)(0,null)}))}trace($,...C){this.g.trace($,...C)}debug($,...C){this.g.debug($,...C)}info($,...C){this.g.info($,...C)}warn($,...C){this.g.warn($,...C)}error($,...C){this.g.error($,...C)}flush(){this.g.flush()}};e.$HBb=R,e.$HBb=R=ye([X(0,L.$5i),X(1,A.$Hh)],R)}),define(re[112],oe([0,1,7,4,24]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$07b=e.$97b=void 0,e.$97b=(0,N.$Ah)("voiceRecognitionService");let L=class{constructor(R,k){this.a=R,this.b=k}async transcribe(R,k){this.a.info(`[voice] transcribe(${R.length}): Begin`);const $=process.env.VSCODE_VOICE_MODULE_PATH;if(!$||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${R.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const C=Date.now();this.a.info(`[voice] transcribe(${R.length}): Getting module from ${$}`);try{const E=te.__$__nodeRequire($),d=new AbortController;k.onCancellationRequested(()=>d.abort());const h=await E.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:R},{language:"en",suppressNonSpeechTokens:!0,signal:d.signal});return this.a.info(`[voice] transcribe(${R.length}): End (text: "${h}", took: ${Date.now()-C}ms)`),h}catch(E){throw this.a.error(`[voice] transcribe(${R.length}): Failed (error: "${E}", took: ${Date.now()-C}ms)`),E}}};e.$07b=L,e.$07b=L=ye([X(0,O.$4i),X(1,A.$jj)],L)}),define(re[240],oe([0,1,2,112,7,26,5]),function(te,e,O,N,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$7b=void 0;let R=class extends O.$jc{constructor(C,E,d){super(),this.a=C,this.b=E,this.c=d,this.f()}f(){this.B(this.a(C=>{this.B(new k(C,this.b,this.c))}))}};e.$$7b=R,e.$$7b=R=ye([X(1,N.$97b),X(2,A.$4i)],R);class k extends O.$jc{static{this.a=30*16e3*16*1/8}constructor(C,E,d){super(),this.f=C,this.g=E,this.h=d,this.b=new j.$Ng,this.c=void 0,this.j()}j(){this.h.info("[voice] transcriber: new connection");const C=new L.$od;this.B((0,O.$hc)(()=>C.dispose(!0)));const E=d=>this.m(d,C.token);this.f.on("message",E),this.B((0,O.$hc)(()=>this.f.off("message",E))),this.f.start(),this.B((0,O.$hc)(()=>this.f.close())),this.f.on("close",()=>{this.h.info("[voice] transcriber: closed connection"),C.dispose(!0)})}async m(C,E){if(!Array.isArray(C.data))return;const d=[];for(const g of C.data)g instanceof Float32Array&&d.push(g);const h=this.r(this.c?[this.c,...d]:d);if(h.length>k.a){this.h.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.c=h,this.b.queue(()=>this.n(E))}async n(C){if(C.isCancellationRequested)return;const E=this.c?.slice(0);if(!E)return;const d=await this.g.transcribe(E,C);C.isCancellationRequested||this.f.postMessage(d)}r(C){const E=new Float32Array(C.reduce((h,g)=>h+g.length,0));let d=0;for(const h of C)E.set(h,d),d+=h.length;return E}}}),define(re[241],oe([0,1,5,3,2]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=void 0;class L extends A.$jc{constructor({onDidOpenWindow:R,onDidFocusWindow:k,getActiveWindowId:$}){super(),this.a=this.B(new A.$ic),N.Event.latch(N.Event.any(R,k))(this.f,this,this.a),this.b=(0,O.$tg)(()=>$()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$G6b=L}),define(re[113],oe([0,1,178,16,47,21,11,4,23]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.WorkbenchState=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0,e.$Jh=(0,R.$Ah)("contextService");function $(s){const t=s;return typeof t?.id=="string"&&j.URI.isUri(t.uri)}e.$Kh=$;function C(s){return typeof s?.id=="string"&&!$(s)&&!d(s)}e.$Lh=C,e.$Mh={id:"ext-dev"},e.$Nh={id:"empty-window"};function E(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$_d)(s)}:t?e.$Mh:e.$Nh;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Oh=E;function d(s){const t=s;return typeof t?.id=="string"&&j.URI.isUri(t.configPath)}e.$Ph=d;function h(s){const t=s;if(t?.uri)return{id:t.id,uri:j.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:j.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$Qh=h;var g;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function y(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$Rh=y;function f(s){const t=s;return!!(t&&typeof t=="object"&&j.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$Sh=f;class o{constructor(t,r,a,v,b){this.h=t,this.j=a,this.k=v,this.l=b,this.c=A.$Gh.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=A.$Gh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Th=o;class l{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.$hg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Uh=l;function w(s){return new l({uri:s,index:0,name:(0,L.$dg)(s)},{uri:s.toString()})}e.$Vh=w,e.$Wh="code-workspace",e.$Xh=`.${e.$Wh}`,e.$Yh=[{name:(0,O.localize)(0,null),extensions:[e.$Wh]}],e.$Zh="workspace.json";function m(s,t){return L.$$f.isEqualOrParent(s,t.untitledWorkspacesHome)}e.$1h=m;function I(s){let t;return j.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===k.Schemas.tmp}e.$2h=I,e.$3h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$3h}e.$4h=i;function c(s,t){return!m(s,t)&&!I(s)}e.$5h=c;function n(s){return(typeof s=="string"?(0,N.$ae)(s):(0,L.$fg)(s))===e.$Xh}e.$6h=n}),define(re[17],oe([0,1,51,3,2,21,11,169,15,12,4,7,113,35,28,5,32,27,9]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.ProfileResourceType=void 0;var w;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(w||(e.ProfileResourceType=w={}));function m(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&j.URI.isUri(t.location)&&j.URI.isUri(t.globalStorageHome)&&j.URI.isUri(t.settingsResource)&&j.URI.isUri(t.keybindingsResource)&&j.URI.isUri(t.tasksResource)&&j.URI.isUri(t.snippetsHome)&&j.URI.isUri(t.extensionsResource))}e.$Ck=m,e.$Dk=(0,C.$Ah)("IUserDataProfilesService");function I(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:j.URI.revive(s.location).with({scheme:t}),globalStorageHome:j.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:j.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:j.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:j.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:j.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:j.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:j.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$Ek=I;function i(s,t,r,a,v,b){return{id:s,name:t,location:r,isDefault:!1,shortName:v?.shortName,globalStorageHome:b&&v?.useDefaultFlags?.globalState?b.globalStorageHome:(0,L.$hg)(r,"globalStorage"),settingsResource:b&&v?.useDefaultFlags?.settings?b.settingsResource:(0,L.$hg)(r,"settings.json"),keybindingsResource:b&&v?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,L.$hg)(r,"keybindings.json"),tasksResource:b&&v?.useDefaultFlags?.tasks?b.tasksResource:(0,L.$hg)(r,"tasks.json"),snippetsHome:b&&v?.useDefaultFlags?.snippets?b.snippetsHome:(0,L.$hg)(r,"snippets"),extensionsResource:b&&v?.useDefaultFlags?.extensions?b.extensionsResource:(0,L.$hg)(r,"extensions.json"),cacheHome:(0,L.$hg)(a,s),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$Fk=i;let c=class extends A.$jc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new N.$ed),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$ed),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$ed),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$ed),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new h.$yi,emptyWindows:new Map},this.profilesHome=(0,L.$hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,l.$if)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}r.push(i((0,L.$eg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,useDefaultFlags:b.useDefaultFlags},t))}}catch(b){this.y.error(b)}const a=new h.$yi,v=new Map;if(r.length)try{const b=this.Q();if(b.workspaces)for(const[u,p]of Object.entries(b.workspaces)){const D=j.URI.parse(u),F=r.find(z=>z.id===p);F&&a.set(D,F)}if(b.emptyWindows)for(const[u,p]of Object.entries(b.emptyWindows)){const D=r.find(F=>F.id===p);D&&v.set(u,D)}}catch(b){this.y.error(b)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=i("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,o.$pe)(r)}\\s(\\d+)`);let v=0;for(const u of this.profiles){const p=a.exec(u.name),D=p?parseInt(p[1]):0;v=D>v?D:v}const b=`${r} ${v+1}`;return this.createProfile((0,O.$oi)((0,f.$3f)()).toString(16),b,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,O.$oi)((0,f.$3f)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,b),b}async F(t,r,a){if(!(0,l.$if)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const b=this.profiles.find(D=>D.name===r||D.id===t);if(b)return b;const u=i(t,r,(0,L.$hg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(u.location);const p=[];return this.j.fire({profile:u,join(D){p.push(D)}}),await y.Promises.settled(p),this.I([u],[],[]),u}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,$.$ik)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return j.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,d.$Kh)(t)?t.uri:(0,d.$Ph)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],b=[];this.s.profiles=[];for(let u of v)u.isDefault||r.some(p=>u.id===p.id)||(u=a.find(p=>u.id===p.id)??u,u.isTransient?this.s.profiles.push(u):b.push({location:u.location,name:u.name,shortName:u.shortName,useDefaultFlags:u.useDefaultFlags}));this.P(b),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),b=a?this.s:this.C;j.URI.isUri(v)?(b.workspaces.delete(v),r&&b.workspaces.set(v,r)):(b.emptyWindows.delete(v),r&&b.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[b,u]of Object.entries(t.workspaces)){const p=j.URI.parse(u);r[b]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}const v={};if(t.emptyWindows)for(const[b,u]of Object.entries(t.emptyWindows)){const p=j.URI.parse(u);v[b]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Gk=c,e.$Gk=c=ye([X(0,k.$Hh),X(1,$.$5j),X(2,g.$Bk),X(3,E.$4i)],c);class n extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Hk=n}),define(re[242],oe([0,1,5,2,17]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q7b=void 0;let L=class extends N.$jc{constructor(R){super(),this.B(new O.$Rg(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$Q7b=L,e.$Q7b=L=ye([X(0,A.$Dk)],L)}),define(re[243],oe([0,1,18,5,26,8,3,2,6,9,11,152,29,33,45,7,24,22,28,17]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=e.$gp=e.$fp=e.$ep=void 0;let m=class extends R.$jc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,b,u){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=b,this.H=u,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new j.$ed),this.s=this.B(new j.$ed),this.t=this.B(new j.$ed),this.u=this.B(new j.$ed),this.w=this.B(new j.$ed),this.y=[],this.B((0,R.$hc)(()=>{this.j.forEach(({task:p})=>p.cancel()),this.m.forEach(p=>p.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,d.$Vn)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:b})=>(0,h.$oo)(b,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:i(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new d.$Zn(E.localize(0,null),d.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:b})=>{try{const u=await this.O(v,!!b?.installGivenVersion,!!b?.installPreReleaseVersion);a.push({...u,options:b})}catch(u){r.push({identifier:v.identifier,operation:2,source:v,error:u})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&c(this.C,"extensionGallery:install",{extensionData:(0,h.$wo)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,g.$Xl)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const b=(await this.getInstalled(1,v.extensionsResource)).find(u=>(0,h.$oo)(u.identifier,t.identifier));b?this.w.fire(b):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const v=await this.J(a);r.push(...v)}catch(v){r.push({identifier:{id:(0,h.$to)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:a}){const v=a.isApplicationScoped||a.isBuiltin||(0,g.$Xl)(t),b={...a,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:v,profileLocation:v?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},u=B=>`${h.$po.create(B).toString()}${b.profileLocation?`-${b.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const B=this.j.get(u(r));if(B)return this.F.info("Extensions is already requested to install",r.identifier.id),await B.task.waitUntilTaskIsFinished(),[]}const p=[],D=[],F=[],z=this.Z(t,r,b);C.URI.isUri(r)||this.j.set(u(r),{task:z,waitingTasks:[]}),this.n.fire({identifier:z.identifier,source:r,profileLocation:b.profileLocation}),this.F.info("Installing extension:",z.identifier.id),p.push({task:z,manifest:t});let U=!1;try{if(b.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",z.identifier.id);else try{const x=await this.N(z.identifier,t,!!b.installOnlyNewlyAddedFromExtensionPack,!!b.installPreReleaseVersion,b.profileLocation),J=await this.getInstalled(void 0,b.profileLocation),Q={...b,donotIncludePackAndDependencies:!0,context:{...b.context,[d.$Qn]:!0}};for(const{gallery:W,manifest:Z}of(0,O.$Jb)(x,({gallery:G})=>G.identifier.id)){U=U||!!Z.extensionDependencies?.some(V=>(0,h.$oo)({id:V},z.identifier));const G=u(W),H=this.j.get(G);if(H){if(this.L(z,H.task)){const V=H.task.identifier;this.F.info("Waiting for already requested installing extension",V.id,z.identifier.id),H.waitingTasks.push(z),D.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ne=>(0,h.$oo)(ne.identifier,V)))).then(ee=>{if(this.F.info("Finished waiting for already requested installing extension",V.id,z.identifier.id),!ee.find(se=>(0,h.$oo)(se.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!J.some(({identifier:V})=>(0,h.$oo)(V,W.identifier))){const V=this.Z(Z,W,Q);this.j.set(G,{task:V,waitingTasks:[z]}),this.n.fire({identifier:V.identifier,source:W,profileLocation:b.profileLocation}),this.F.info("Installing extension:",V.identifier.id,z.identifier.id),p.push({task:V,manifest:Z})}}}catch(x){if(C.URI.isUri(z.source))(0,O.$Ib)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",z.identifier.id,x.message),(0,O.$Ib)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",z.identifier.id,x.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",z.identifier.id),x}const B=p.reduce((x,{task:J,manifest:Q})=>(x.set(J.identifier.id.toLowerCase(),{task:J,manifest:Q}),x),new Map);for(;B.size;){let x;const J=[...B.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(W=>B.has(W.toLowerCase())));J.length?x=B.size===1?J:J.filter(({task:Q})=>!(Q===z&&!U)):(this.F.info("Found extensions with circular dependencies",J.map(({task:Q})=>Q.identifier.id)),x=[...B.values()]),await this.M(x.map(async({task:Q})=>{const W=new Date().getTime();try{const Z=await Q.run();if(await this.M(this.y.map(G=>G.postInstall(Z,Q.source,b,A.CancellationToken.None))),!C.URI.isUri(Q.source)){const G=Q.operation===3,H=G?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(c(this.C,G?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$wo)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-W,durationSinceUpdate:H}),k.$o&&Q.operation!==3)try{await this.z.reportStatistic(Z.manifest.publisher,Z.manifest.name,Z.manifest.version,"install")}catch{}}F.push({local:Z,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,applicationScoped:Z.isApplicationScoped})}catch(Z){throw C.URI.isUri(Q.source)||c(this.C,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$wo)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-W,error:Z}),this.F.error("Error while installing the extension:",Q.identifier.id),Z}finally{B.delete(Q.identifier.id.toLowerCase())}}))}return D.length&&await this.M(D),F.forEach(({identifier:x})=>this.F.info("Extension installed successfully:",x.id)),F}catch(B){if(p.forEach(({task:x})=>x.cancel()),F.length)try{const x=await Promise.allSettled(F.map(({local:J})=>this.$(J,{versionOnly:!0,profileLocation:b.profileLocation}).run()));for(let J=0;J<x.length;J++){const Q=x[J],{identifier:W}=F[J];Q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",W.id):this.F.warn("Rollback: Error while uninstalling extension",W.id,(0,L.$8)(Q.reason))}}catch(x){this.F.warn("Error while rolling back extensions",(0,L.$8)(x),F.map(({identifier:J})=>J.id))}return p.map(({task:x})=>({identifier:x.identifier,operation:2,source:x.source,context:b.context,profileLocation:b.profileLocation,error:B}))}finally{for(const{task:B}of p)B.source&&!C.URI.isUri(B.source)&&this.j.delete(u(B.source))}}L(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(b=>this.L(b,r)))||a===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],a=[],v=await Promise.allSettled(t);for(const b of v)b.status==="fulfilled"?r.push(b.value):a.push(b.reason);if(a.length)throw I(a);return r}async N(t,r,a,v,b){if(!this.z.isEnabled())return[];const u=await this.getInstalled(void 0,b),p=[],D=[],F=async(z,U)=>{p.push(z);const B=U.extensionDependencies||[],x=[...B];if(U.extensionPack){const J=a?u.find(Q=>(0,h.$oo)(Q.identifier,z)):void 0;for(const Q of U.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(W=>(0,h.$oo)({id:W},{id:Q}))||x.every(W=>!(0,h.$oo)({id:W},{id:Q}))&&x.push(Q)}if(x.length){const J=x.filter(Q=>p.every(W=>!(0,h.$oo)(W,{id:Q})));if(J.length){const Q=await this.z.getExtensions(J.map(W=>({id:W,preRelease:v})),A.CancellationToken.None);for(const W of Q){if(p.find(H=>(0,h.$oo)(H,W.identifier)))continue;const Z=B.some(H=>(0,h.$oo)({id:H},W.identifier));let G;try{G=await this.O(W,!1,v)}catch(H){if(Z)throw H;this.F.info("Skipping the packed extension as it cannot be installed",W.identifier.id,(0,L.$8)(H));continue}D.push({gallery:G.extension,manifest:G.manifest}),await F(G.extension.identifier,G.manifest)}}}};return await F(t,r),D}async O(t,r,a){let v;const b=await this.getExtensionsControlManifest();if(b.malicious.some(D=>(0,h.$oo)(t.identifier,D)))throw new d.$Zn(E.localize(1,null,t.identifier.id),d.ExtensionManagementErrorCode.Malicious);const u=b.deprecated[t.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!v)throw new d.$Zn(E.localize(2,null,t.identifier.id,u.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const D=await this.getTargetPlatform();throw new d.$Zn(E.localize(3,null,t.identifier.id,this.G.nameLong,(0,d.$Rn)(D)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,a),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],A.CancellationToken.None))[0]?new d.$Zn(E.localize(4,null,t.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$Zn(E.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const p=await this.z.getManifest(v,A.CancellationToken.None);if(p===null)throw new d.$Zn(`Missing manifest for extension ${v.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(p.version!==v.version)throw new d.$Zn(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:p}}async P(t,r,a){const v=await this.getTargetPlatform();let b=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(b=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},A.CancellationToken.None))[0]||null),!b&&await this.z.isExtensionCompatible(t,a,v)&&(b=t),b||(r?b=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},A.CancellationToken.None))[0]||null:b=await this.z.getCompatibleExtension(t,a,v)),b}async Q(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=z=>`${z.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,b=this.m.get(v(t.identifier));if(b)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),b.waitUntilTaskIsFinished();const u=z=>{const U=this.$(z,a);return this.m.set(v(U.extension.identifier),U),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${z.identifier.id}@${z.manifest.version}`),this.t.fire({identifier:z.identifier,profileLocation:a.profileLocation,applicationScoped:z.isApplicationScoped}),U},p=(z,U)=>{U?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${z.identifier.id}@${z.manifest.version}`,U.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${z.identifier.id}@${z.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${z.identifier.id}@${z.manifest.version}`),c(this.C,"extensionGallery:uninstall",{extensionData:(0,h.$vo)(z),error:U}),this.u.fire({identifier:z.identifier,error:U?.code,profileLocation:a.profileLocation,applicationScoped:z.isApplicationScoped})},D=[],F=[];try{D.push(u(t));const z=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const U=this.U(t,z);for(const B of U)this.m.has(v(B.identifier))?this.F.info("Extensions is already requested to uninstall",B.identifier.id):D.push(u(B))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(D.map(U=>U.extension),z,t),await this.M(D.map(async U=>{try{if(await U.run(),await this.M(this.y.map(B=>B.postUninstall(U.extension,a,A.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,"uninstall")}catch{}p(U.extension)}catch(B){const x=B instanceof d.$Zn?B:new d.$Zn((0,L.$8)(B),d.ExtensionManagementErrorCode.Internal);throw p(U.extension,x),x}finally{F.push(U)}}))}catch(z){const U=z instanceof d.$Zn?z:new d.$Zn((0,L.$8)(z),d.ExtensionManagementErrorCode.Internal);for(const B of D){try{B.cancel()}catch{}F.includes(B)||p(B.extension,U)}throw U}finally{for(const z of D)this.m.delete(v(z.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",z.extension.identifier.id)}}R(t,r,a){for(const v of t){const b=this.W(v,r);if(b.length){const u=b.filter(p=>!t.some(D=>(0,h.$oo)(D.identifier,p.identifier)));if(u.length)throw new Error(this.S(v,u,a))}}}S(t,r,a){return a===t?r.length===1?E.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const b=r.filter(p=>!p.isBuiltin&&v.some(D=>(0,h.$oo)({id:D},p.identifier))),u=[];for(const p of b)u.push(...this.U(p,r,a));return[...b,...u]}return[]}W(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,h.$oo)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$ep=m,e.$ep=m=ye([X(0,d.$Yn),X(1,o.$8k),X(2,l.$Bk),X(3,y.$4i),X(4,f.$jj),X(5,w.$Dk)],m);function I(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$fp=I;function i(s){if(s instanceof d.$Zn)return s;const t=new d.$Zn(s.message,d.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.$gp=i;function c(s,t,{extensionData:r,verificationStatus:a,duration:v,error:b,durationSinceUpdate:u}){let p,D;(0,$.$qf)(a)&&(a===!0?a="Verified":(a===!1||(p=d.ExtensionManagementErrorCode.Signature,D=a),a="Unverified")),b&&(b instanceof d.$Zn?(p=b.code,b.code===d.ExtensionManagementErrorCode.Signature&&(D=b.message)):p=d.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!b,duration:v,errorcode:p,errorcodeDetail:D,durationSinceUpdate:u})}class n{constructor(){this.d=new N.$Eg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$tg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$tg)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new L.$3)})})),this.d.open()),this.g.cancel()}}e.$hp=n}),define(re[50],oe([0,1,5,14,2,3,35,11,29,33,12,4,7,17,28,9,8,22]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.ExtensionsProfileScanningErrorCode=void 0;var l;(function(c){c.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",c.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(l||(e.ExtensionsProfileScanningErrorCode=l={}));class w extends Error{constructor(n,s){super(n),this.code=s}}e.$ip=w,e.$jp=(0,E.$Ah)("IExtensionsProfileScannerService");let m=class extends A.$jc{constructor(n,s,t,r,a,v){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new L.$ed),this.onAddExtensions=this.b.event,this.c=this.B(new L.$ed),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$ed),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$ed),this.onDidRemoveExtensions=this.g.event,this.h=new j.$yi}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s){const t=[],r=[];try{return await this.u(s,a=>{const v=[];for(const b of a)n.some(([u])=>(0,$.$oo)(u.identifier,b.identifier)&&u.manifest.version!==b.version)?t.push(b):v.push(b);for(const[b,u]of n){const p=v.findIndex(F=>(0,$.$oo)(F.identifier,b.identifier)&&F.version===b.manifest.version),D={identifier:b.identifier,version:b.manifest.version,location:b.location,metadata:u};p===-1?(r.push(D),v.push(D)):v.splice(p,1,D)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),t.length&&this.f.fire({extensions:t,profileLocation:s}),v}),r.length&&this.c.fire({extensions:r,profileLocation:s}),t.length&&this.g.fire({extensions:t,profileLocation:s}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:s}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const v of r){const b=n.find(([u])=>(0,$.$oo)(u.identifier,v.identifier)&&u.manifest.version===v.version);b&&(v.metadata={...v.metadata,...b[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const v of r)(0,$.$oo)(v.identifier,n.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(n);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$ik)(v)!==1)throw v;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new w((0,f.$8)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let v=!1;for(const b of a){I(b)||this.w(n);let u;if((0,y.$if)(b.relativeLocation)&&b.relativeLocation)u=this.z(b.relativeLocation);else if((0,y.$if)(b.location))u=this.z(b.location),v=!0,b.relativeLocation=b.location,b.location=u.toJSON();else{u=R.URI.revive(b.location);const p=this.y(u);p&&(v=!0,b.relativeLocation=p)}r.push({identifier:b.identifier,location:u,version:b.version,metadata:b.metadata})}v&&await this.m.writeFile(n,N.$Ed.fromString(JSON.stringify(a)))}if(s){r=s(r);const v=r.map(b=>({identifier:b.identifier,version:b.version,location:b.location.toJSON(),relativeLocation:this.y(b.location),metadata:b.metadata}));await this.m.writeFile(n,N.$Ed.fromString(JSON.stringify(v)))}return r})}w(n){const s=new w(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$ik)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>I(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$Ed.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$ik)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$ik)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,C.$ik)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new O.$Mg,this.h.set(n,s)),s}};e.$kp=m,e.$kp=m=ye([X(1,C.$5j),X(2,h.$Dk),X(3,g.$Bk),X(4,o.$8k),X(5,d.$4i)],m);function I(c){return(0,y.$kf)(c)&&(0,k.$Xn)(c.identifier)&&(i(c.location)||(0,y.$if)(c.location)&&c.location)&&((0,y.$pf)(c.relativeLocation)||(0,y.$if)(c.relativeLocation))&&c.version&&(0,y.$if)(c.version)}function i(c){return c?(0,y.$if)(c.path)&&(0,y.$if)(c.scheme):!1}}),define(re[79],oe([0,1,18,5,30,14,8,34,139,2,23,16,6,21,53,89,9,11,155,15,33,45,67,12,4,7,24,3,63,50,17,28,183]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m,I,i,c,n,s,t,r,a,v,b,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.Translations=void 0;var D;(function(Q){function W(Z,G){if(Z===G)return!0;const H=Object.keys(Z),V=new Set;for(const ee of Object.keys(G))V.add(ee);if(H.length!==V.size)return!1;for(const ee of H){if(Z[ee]!==G[ee])return!1;V.delete(ee)}return V.size===0}Q.equals=W})(D||(e.Translations=D={})),e.$np=(0,n.$Ah)("IExtensionsScannerService");let F=class extends $.$jc{constructor(W,Z,G,H,V,ee,ne,se,Y,q,S,P){super(),this.systemExtensionsLocation=W,this.userExtensionsLocation=Z,this.r=G,this.s=H,this.t=V,this.u=ee,this.w=ne,this.y=se,this.z=Y,this.C=q,this.D=S,this.F=P,this.g=this.B(new r.$ed),this.onDidChangeCache=this.g.event,this.h=(0,h.$hg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(B,this.s,this.h)),this.m=this.B(this.F.createInstance(B,this.s,this.h)),this.n=this.B(this.F.createInstance(U,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$zo)(this.w,this.y)),this.G}async scanAllExtensions(W,Z,G){const[H,V]=await Promise.all([this.scanSystemExtensions(W),this.scanUserExtensions(Z)]),ee=G?await this.scanExtensionsUnderDevelopment(W,[...H,...V]):[];return this.L(H,V,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(W){const Z=[];Z.push(this.M(!!W.useCache,W.language)),Z.push(this.N(W.language,!!W.checkControlFile));const[G,H]=await Promise.all(Z);return this.J([...G,...H],0,W,!1)}async scanUserExtensions(W){const Z=W.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const G=this.D.extUri.isEqual(W.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,H=await this.P(Z,!!W.profileLocation,1,!W.includeUninstalled,W.language,!0,G),V=W.useCache&&!H.devMode&&H.excludeObsolete?this.m:this.n;let ee;try{ee=await V.scanExtensions(H)}catch(ne){if(ne instanceof v.$ip&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ee=await V.scanExtensions(H);else throw ne}return ee=await this.J(ee,1,W,!0),this.y.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(W,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const G=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(H=>H.scheme===C.Schemas.file).map(async H=>{const V=await this.P(H,!1,1,!0,W.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(V)).map(ne=>(ne.type=Z.find(se=>(0,m.$oo)(se.identifier,ne.identifier))?.type??ne.type,this.n.validate(ne,V)))}))).flat();return this.J(G,"development",W,!0)}return[]}async scanExistingExtension(W,Z,G){const H=await this.P(W,!1,Z,!0,G.language,!0,void 0),V=await this.n.scanExtension(H);return!V||!G.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(W,Z,G){const H=await this.P(W,!1,Z,!0,G.language,!0,void 0),V=await this.n.scanOneOrMultipleExtensions(H);return this.J(V,Z,G,!0)}async scanMetadata(W){const Z=(0,h.$hg)(W,"package.json"),G=(await this.w.readFile(Z)).value.toString();return JSON.parse(G).__metadata}async updateMetadata(W,Z){const G=(0,h.$hg)(W,"package.json"),H=(await this.w.readFile(G)).value.toString(),V=JSON.parse(H);Z.isMachineScoped=Z.isMachineScoped||void 0,Z.isBuiltin=Z.isBuiltin||void 0,V.__metadata={...V.__metadata,...Z},await this.w.writeFile((0,h.$hg)(W,"package.json"),L.$Ed.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(W){if(W instanceof v.$ip&&W.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw W}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const W=await this.scanUserExtensions({includeInvalid:!0});if(W.length)await this.u.addExtensionsToProfile(W.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$Ed.fromString(JSON.stringify([])))}catch(Z){(0,c.$ik)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$8)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(W){this.y.error(W)}finally{this.H=void 0}})()),this.H}async J(W,Z,G,H){return G.includeAllVersions||(W=this.L(Z===0?W:void 0,Z===1?W:void 0,Z==="development"?W:void 0,await this.getTargetPlatform(),H)),G.includeInvalid||(W=W.filter(V=>V.isValid)),W.sort((V,ee)=>{const ne=E.$_d(V.location.fsPath),se=E.$_d(ee.location.fsPath);return ne<se?-1:ne>se?1:0})}L(W,Z,G,H,V){const ee=(se,Y,q)=>{if(se.isValid&&!Y.isValid)return!1;if(se.isValid===Y.isValid){if(V&&g.gt(se.manifest.version,Y.manifest.version))return this.y.debug(`Skipping extension ${Y.location.path} with lower version ${Y.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(g.eq(se.manifest.version,Y.manifest.version)){if(se.type===0)return this.y.debug(`Skipping extension ${Y.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===H)return this.y.debug(`Skipping extension ${Y.location.path} from different target platform ${Y.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${se.location.path} with ${Y.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${Y.location.path}.`),!0},ne=new I.$Wl;return W?.forEach(se=>{const Y=ne.get(se.identifier.id);(!Y||ee(Y,se,!1))&&ne.set(se.identifier.id,se)}),Z?.forEach(se=>{const Y=ne.get(se.identifier.id);if(!Y&&W&&se.type===0){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!Y||ee(Y,se,!1))&&ne.set(se.identifier.id,se)}),G?.forEach(se=>{const Y=ne.get(se.identifier.id);(!Y||ee(Y,se,!0))&&ne.set(se.identifier.id,se),ne.set(se.identifier.id,se)}),[...ne.values()]}async M(W,Z){this.y.trace("Started scanning system extensions");const G=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0),V=await(W&&!G.devMode?this.j:this.n).scanExtensions(G);return this.y.trace("Scanned system extensions:",V.length),V}async N(W,Z){const G=this.z.isBuilt?[]:this.C.builtInExtensions;if(!G?.length)return[];this.y.trace("Started scanning dev system extensions");const H=Z?await this.O():{},V=[],ee=o.URI.file(E.$6d(E.$8d(C.$1f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of G){const Y=H[se.name]||"marketplace";switch(Y){case"disabled":break;case"marketplace":V.push((0,h.$hg)(ee,se.name));break;default:V.push(o.URI.file(Y));break}}const ne=await Promise.all(V.map(async se=>this.n.scanExtension(await this.P(se,!1,0,!0,W,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ne.length),(0,O.$Eb)(ne)}async O(){try{const W=await this.w.readFile(this.r);return JSON.parse(W.value.toString())}catch{return{}}}async P(W,Z,G,H,V,ee,ne){const se=await this.f(V??d.$v),Y=await this.Q(W),q=Z&&!this.D.extUri.isEqual(W,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,S=q?await this.Q(q):void 0;return new z(W,Y,q,S,Z,ne,G,H,ee,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,V,se)}async Q(W){try{const Z=await this.w.stat(W);if(typeof Z.mtime=="number")return Z.mtime}catch{}}};e.$op=F,e.$op=F=ye([X(4,b.$Dk),X(5,v.$jp),X(6,c.$5j),X(7,s.$4i),X(8,w.$Hh),X(9,t.$jj),X(10,u.$Bk),X(11,n.$zh)],F);class z{constructor(W,Z,G,H,V,ee,ne,se,Y,q,S,P,M,T,K){this.location=W,this.mtime=Z,this.applicationExtensionslocation=G,this.applicationExtensionslocationMtime=H,this.profile=V,this.profileScanOptions=ee,this.type=ne,this.excludeObsolete=se,this.validate=Y,this.productVersion=q,this.productDate=S,this.productCommit=P,this.devMode=M,this.language=T,this.translations=K}static createNlsConfiguration(W){return{language:W.language,pseudo:W.language==="pseudo",devMode:W.devMode,translations:W.translations}}static equals(W,Z){return(0,h.$ag)(W.location,Z.location)&&W.mtime===Z.mtime&&(0,h.$ag)(W.applicationExtensionslocation,Z.applicationExtensionslocation)&&W.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&W.profile===Z.profile&&A.$Ym(W.profileScanOptions,Z.profileScanOptions)&&W.type===Z.type&&W.excludeObsolete===Z.excludeObsolete&&W.validate===Z.validate&&W.productVersion===Z.productVersion&&W.productDate===Z.productDate&&W.productCommit===Z.productCommit&&W.devMode===Z.devMode&&W.language===Z.language&&D.equals(W.translations,Z.translations)}}e.$pp=z;let U=class extends $.$jc{constructor(W,Z,G,H,V){super(),this.f=W,this.g=Z,this.h=G,this.j=H,this.m=V}async scanExtensions(W){const Z=W.profile?await this.r(W):await this.n(W);let G={};if(W.excludeObsolete&&W.type===1)try{const H=(await this.j.readFile(this.f)).value.toString();G=JSON.parse(H)}catch{}return(0,f.$vf)(G)?Z:Z.filter(H=>!G[m.$po.create(H).toString()])}async n(W){const Z=await this.j.resolve(W.location);if(!Z.children?.length)return[];const G=await Promise.all(Z.children.map(async H=>{if(!H.isDirectory||W.type===1&&(0,h.$eg)(H.resource).indexOf(".")===0)return null;const V=new z(H.resource,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(V)}));return(0,O.$Eb)(G).sort((H,V)=>H.location.path<V.location.path?-1:1)}async r(W){let Z=await this.s(W.location,()=>!0,W);if(W.applicationExtensionslocation&&!this.h.extUri.isEqual(W.location,W.applicationExtensionslocation)){Z=Z.filter(H=>!H.metadata?.isApplicationScoped);const G=await this.s(W.applicationExtensionslocation,H=>!!H.metadata?.isBuiltin||!!H.metadata?.isApplicationScoped,W);Z.push(...G)}return Z}async s(W,Z,G){const H=await this.g.scanProfileExtensions(W,G.profileScanOptions);if(!H.length)return[];const V=await Promise.all(H.map(async ee=>{if(Z(ee)){const ne=new z(ee.location,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ne,ee.metadata)}return null}));return(0,O.$Eb)(V)}async scanOneOrMultipleExtensions(W){try{if(await this.j.exists((0,h.$hg)(W.location,"package.json"))){const Z=await this.scanExtension(W);return Z?[Z]:[]}else return await this.scanExtensions(W)}catch(Z){return this.m.error(`Error scanning extensions at ${W.location.path}:`,(0,j.$8)(Z)),[]}}async scanExtension(W,Z){try{let G=await this.scanExtensionManifest(W.location);if(G){G.publisher||(G.publisher=I.$Ql),Z=Z??G.__metadata,delete G.__metadata;const H=(0,m.$to)(G.publisher,G.name),V=Z?.id?{id:H,uuid:Z.id}:{id:H},ee=Z?.isSystem?0:W.type,ne=ee===0||!!Z?.isBuiltin;G=await this.t(W.location,G,z.createNlsConfiguration(W));const se={type:ee,identifier:V,manifest:G,location:W.location,isBuiltin:ne,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return W.validate?this.validate(se,W):se}}catch(G){W.type!==0&&this.m.error(G)}return null}validate(W,Z){let G=!0;const H=(0,i.$Eo)(Z.productVersion,Z.productDate,Z.location,W.manifest,W.isBuiltin);for(const[V,ee]of H)V===y.default.Error&&(G=!1,this.m.error(this.z(Z.location,ee)));return W.isValid=G,W.validations=H,W}async scanExtensionManifest(W){const Z=(0,h.$hg)(W,"package.json");let G;try{G=(await this.j.readFile(Z)).value.toString()}catch(V){return(0,c.$ik)(V)!==1&&this.m.error(this.z(W,(0,l.localize)(0,null,Z.path,V.message))),null}let H;try{H=JSON.parse(G)}catch{const ee=[];(0,R.$Km)(G,ee);for(const ne of ee)this.m.error(this.z(W,(0,l.localize)(1,null,Z.path,ne.offset,ne.length,(0,k.$lp)(ne.error))));return null}return(0,R.$Tm)(H)!=="object"?(this.m.error(this.z(W,(0,l.localize)(2,null,Z.path))),null):H}async t(W,Z,G){const H=await this.u(W,Z,G);if(H)try{const V=[],ee=await this.w(H.default,V);if(V.length>0)return V.forEach(se=>{this.m.error(this.z(W,(0,l.localize)(3,null,H.default?.path,(0,k.$lp)(se.error))))}),Z;if((0,R.$Tm)(H)!=="object")return this.m.error(this.z(W,(0,l.localize)(4,null,H.default?.path))),Z;const ne=H.values||Object.create(null);return(0,p.$mp)(this.m,Z,ne,ee)}catch{}return Z}async u(W,Z,G){const H=(0,h.$hg)(W,"package.nls.json"),V=(Y,q)=>{q.forEach(S=>{this.m.error(this.z(W,(0,l.localize)(5,null,Y?.path,(0,k.$lp)(S.error))))})},ee=Y=>{this.m.error(this.z(W,(0,l.localize)(6,null,Y?.path)))},ne=`${Z.publisher}.${Z.name}`,se=G.translations[ne];if(se)try{const Y=o.URI.file(se),q=(await this.j.readFile(Y)).value.toString(),S=[],P=(0,R.$Km)(q,S);return S.length>0?(V(Y,S),{values:void 0,default:H}):(0,R.$Tm)(P)!=="object"?(ee(Y),{values:void 0,default:H}):{values:P.contents?P.contents.package:void 0,default:H}}catch{return{values:void 0,default:H}}else{if(!await this.j.exists(H))return;let q;try{q=await this.y(W,G)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const S=(await this.j.readFile(q.localized)).value.toString(),P=[],M=(0,R.$Km)(S,P);return P.length>0?(V(q.localized,P),{values:void 0,default:q.original}):(0,R.$Tm)(M)!=="object"?(ee(q.localized),{values:void 0,default:q.original}):{values:M,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(W,Z){if(W)try{const G=(await this.j.readFile(W)).value.toString();return(0,R.$Km)(G,Z)}catch{}}y(W,Z){return new Promise((G,H)=>{const V=ee=>{const ne=(0,h.$hg)(W,`package.nls.${ee}.json`);this.j.exists(ne).then(se=>{se&&G({localized:ne,original:(0,h.$hg)(W,"package.nls.json")});const Y=ee.lastIndexOf("-");Y===-1?G({localized:(0,h.$hg)(W,"package.nls.json"),original:null}):(ee=ee.substring(0,Y),V(ee))})};if(Z.devMode||Z.pseudo||!Z.language)return G({localized:(0,h.$hg)(W,"package.nls.json"),original:null});V(Z.language)})}z(W,Z){return`[${W.path}]: ${Z}`}};U=ye([X(1,v.$jp),X(2,u.$Bk),X(3,c.$5j),X(4,s.$4i)],U);let B=class extends U{constructor(W,Z,G,H,V,ee,ne){super(Z,H,V,ee,ne),this.G=W,this.H=G,this.D=this.B(new N.$Dg(3e3)),this.F=this.B(new r.$ed),this.onDidChangeCache=this.F.event}async scanExtensions(W){const Z=this.M(W),G=await this.I(Z);if(this.C=W,G&&G.input&&z.equals(G.input,this.C))return this.m.debug("Using cached extensions scan result",W.location.toString()),this.D.trigger(()=>this.L()),G.result.map(V=>(V.location=o.URI.revive(V.location),V));const H=await super.scanExtensions(W);return await this.J(Z,{input:W,result:H}),H}async I(W){try{const Z=await this.j.readFile(W),G=JSON.parse(Z.value.toString());return{result:G.result,input:(0,a.$0g)(G.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",W.path,(0,j.$8)(Z))}return null}async J(W,Z){try{await this.j.writeFile(W,L.$Ed.fromString(JSON.stringify(Z)))}catch(G){this.m.debug("Error while writing the extension cache file:",W.path,(0,j.$8)(G))}}async L(){if(!this.C)return;const W=this.M(this.C),Z=await this.I(W);if(!Z)return;const G=Z.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$Ym(H,G))try{this.m.info("Invalidating Cache",G,H),await this.j.del(W),this.F.fire()}catch(V){this.m.error(V)}}M(W){const Z=this.N(W);return this.h.extUri.joinPath(Z.cacheHome,W.type===0?I.$Pl:I.$Ol)}N(W){return W.type===0?this.H.defaultProfile:W.profile?this.h.extUri.isEqual(W.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(W.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};B=ye([X(2,b.$Dk),X(3,v.$jp),X(4,u.$Bk),X(5,c.$5j),X(6,s.$4i)],B);function x(Q,W){const Z=(0,m.$ro)(Q.manifest.publisher,Q.manifest.name);return{id:Z,identifier:new I.$Ul(Z),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:W,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.$qp=x;class J extends F{constructor(W,Z,G,H,V,ee,ne,se,Y,q,S,P){super(W,Z,(0,h.$hg)(G,".vscode-oss-dev","extensions","control.json"),H,V,ee,ne,se,Y,q,S,P),this.R=(async()=>{if(d.$y)try{const M=await this.w.readFile(o.URI.file(d.$y));return JSON.parse(M.value.toString())}catch{}return Object.create(null)})()}f(W){return this.R}}e.$rp=J}),define(re[244],oe([0,1,64,5,38,3,2,23,16,31,7,17]),function(te,e,O,N,A,L,j,R,k,$,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;let d=class extends j.$jc{constructor(g,y){super(),this.b=g,this.f=y,this.a=new N.$Lg(5)}async postUninstall(g){const y=this.g(g,"uninstall");y&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(f){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(f)}}));try{await $.Promises.rm(this.m(g))}catch(f){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(f)}}g(g,y){const f=`vscode:${y}`;if(g.location.scheme===R.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[f]=="string"){const o=g.manifest.scripts[f].split(" ");return o.length<2||o[0]!=="node"||!o[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${f} should be a node script`),null):{script:(0,k.$8d)(g.location.fsPath,o[1]),args:o.slice(2)||[]}}return null}h(g,y,f,o,l){return new Promise((w,m)=>{const I=this.j(g,y,f,l);let i;const c=n=>{i&&(clearTimeout(i),i=null),n?m(n):w(void 0)};I.on("error",n=>{c((0,A.$li)(n)||"Unknown")}),I.on("exit",(n,s)=>{c(n?`post-${y} process exited with code ${n}`:void 0)}),o&&(i=setTimeout(()=>{i=null,I.kill(),m("timed out")},5e3))})}j(g,y,f,o){const l={silent:!0,execArgv:void 0},w=(0,O.fork)(g,[`--type=extension-post-${y}`,...f],l);w.stdout.setEncoding("utf8"),w.stderr.setEncoding("utf8");const m=L.Event.fromNodeEventEmitter(w.stdout,"data"),I=L.Event.fromNodeEventEmitter(w.stderr,"data");m(n=>this.f.info(o.identifier.id,o.manifest.version,`post-${y}`,n)),I(n=>this.f.error(o.identifier.id,o.manifest.version,`post-${y}`,n));const i=L.Event.any(L.Event.map(m,n=>({data:`%c${n}`,format:[""]})),L.Event.map(I,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(o.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),w}m(g){return(0,k.$8d)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$tp=d,e.$tp=d=ye([X(0,E.$Dk),X(1,C.$4i)],d)}),define(re[245],oe([0,1,7,17,28,22,50,12,15,11]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;let C=class extends j.$kp{constructor(d,h,g,y,f,o){super($.URI.file(d.extensionsPath),h,g,y,f,o)}};e.$hN=C,e.$hN=C=ye([X(0,k.$Ih),X(1,R.$5j),X(2,N.$Dk),X(3,A.$Bk),X(4,L.$8k),X(5,O.$4i)],C)}),define(re[246],oe([0,1,11,15,50,79,12,4,7,24,28,17]),function(te,e,O,N,A,L,j,R,k,$,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=void 0;let d=class extends L.$rp{constructor(g,y,f,o,l,w,m,I){super(O.URI.file(l.builtinExtensionsPath),O.URI.file(l.extensionsPath),l.userHome,g.defaultProfile,g,y,f,o,l,w,m,I)}};e.$K6b=d,e.$K6b=d=ye([X(0,E.$Dk),X(1,A.$jp),X(2,j.$5j),X(3,k.$4i),X(4,N.$Ih),X(5,$.$jj),X(6,C.$Bk),X(7,R.$zh)],d)}),define(re[20],oe([0,1,5,3,2,100,9,66,4,17]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Uo=e.$To=e.$So=void 0,e.$So="__$__isNewStorageMarker",e.$To="__$__targetStorageMarker",e.$Uo=(0,k.$Ah)("storageService");var C;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var E;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var d;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function h(l){const w=l.get(e.$To);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}e.$Vo=h;class g extends A.$jc{static{this.a=60*1e3}constructor(w={flushInterval:g.a}){super(),this.m=w,this.b=this.B(new N.$hd),this.c=this.B(new N.$hd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$ed),this.onWillSaveState=this.f.event,this.h=this.B(new O.$Rg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$kc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(w,m,I){return N.Event.filter(this.b.event,i=>i.scope===w&&(m===void 0||i.key===m),I)}n(){this.j.value=(0,O.$Vg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$ec)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(w,m){const{key:I,external:i}=m;if(I===e.$To){switch(w){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:I,target:this.J(w)[I],external:i})}w(w){this.f.fire({reason:w})}get(w,m,I){return this.P(m)?.get(w,I)}getBoolean(w,m,I){return this.P(m)?.getBoolean(w,I)}getNumber(w,m,I){return this.P(m)?.getNumber(w,I)}getObject(w,m,I){return this.P(m)?.getObject(w,I)}storeAll(w,m){this.y(()=>{for(const I of w)this.store(I.key,I.value,I.scope,I.target,m)})}store(w,m,I,i,c=!1){if((0,j.$rf)(m)){this.remove(w,I,c);return}this.y(()=>{this.z(w,I,i),this.P(I)?.set(w,m,c)})}remove(w,m,I=!1){this.y(()=>{this.z(w,m,void 0),this.P(m)?.delete(w,I)})}y(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,m){const I=[],i=this.J(w);for(const c of Object.keys(i))i[c]===m&&I.push(c);return I}z(w,m,I,i=!1){const c=this.J(m);typeof I=="number"?c[w]!==I&&(c[w]=I,this.P(m)?.set(e.$To,JSON.stringify(c),i)):typeof c[w]=="number"&&(delete c[w],this.P(m)?.set(e.$To,JSON.stringify(c),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(w){switch(w){case-1:return this.I;case 0:return this.G;default:return this.D}}L(w){const m=this.P(w);return m?h(m):Object.create(null)}isNew(w){return this.getBoolean(e.$So,w)===!0}async flush(w=C.NONE){this.f.fire({reason:w});const m=this.P(-1),I=this.P(0),i=this.P(1);switch(w){case C.NONE:await O.Promises.settled([m?.whenFlushed()??Promise.resolve(),I?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await O.Promises.settled([m?.flush(0)??Promise.resolve(),I?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,I=this.P(1)?.items??new Map;return o(w,m,I,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(w){return await this.flush(),this.P(w)?.optimize()}async switch(w,m){return this.w(C.NONE),(0,$.$Ck)(w)?this.R(w,m):this.S(w,m)}M(w,m){return!(w.id===m.id||y(m)&&y(w))}N(w,m,I){this.y(()=>{const i=new Set;for(const[c,n]of w)i.add(c),m.get(c)!==n&&this.u(I,{key:c,external:!0});for(const[c]of m.items)i.has(c)||this.u(I,{key:c,external:!0})})}}e.$Wo=g;function y(l){return l.isDefault||!!l.useDefaultFlags?.globalState}e.$Xo=y;class f extends g{constructor(){super(),this.U=this.B(new R.$Qo(new R.$Ro,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$Qo(new R.$Ro,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$Qo(new R.$Ro,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(w=>this.u(1,w))),this.B(this.W.onDidChangeStorage(w=>this.u(0,w))),this.B(this.U.onDidChangeStorage(w=>this.u(-1,w)))}P(w){switch(w){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(w){return!1}}e.$Yo=f;async function o(l,w,m,I,i,c){const n=D=>{try{return JSON.parse(D)}catch{return D}},s=new Map,t=new Map;l.forEach((D,F)=>{s.set(F,D),t.set(F,n(D))});const r=new Map,a=new Map;w.forEach((D,F)=>{r.set(F,D),a.set(F,n(D))});const v=new Map,b=new Map;m.forEach((D,F)=>{v.set(F,D),b.set(F,n(D))}),console.group(I!==i?`Storage: Application (path: ${I})`:`Storage: Application & Profile (path: ${I}, default profile)`);const u=[];if(s.forEach((D,F)=>{u.push({key:F,value:D})}),console.table(u),console.groupEnd(),console.log(t),I!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const D=[];r.forEach((F,z)=>{D.push({key:z,value:F})}),console.table(D),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${c})`);const p=[];v.forEach((D,F)=>{p.push({key:F,value:D})}),console.table(p),console.groupEnd(),console.log(b)}e.$Zo=o}),define(re[114],oe([0,1,3,2,9,29,33,20]),function(te,e,O,N,A,L,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tzb=e.$szb=void 0;let k=class extends N.$jc{constructor(E,d){super(),this.a=new O.$ed,this.onDidChangeEnablement=this.a.event,this.b=this.B(new $(E)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(d.onDidInstallExtensions(h=>h.forEach(({local:g,operation:y})=>{g&&y===4&&this.f(g.identifier)})))}async enableExtension(E,d){return this.f(E)?(this.a.fire({extensions:[E],source:d}),!0):!1}async disableExtension(E,d){return this.c(E)?(this.a.fire({extensions:[E],source:d}),!0):!1}getDisabledExtensions(){return this.h(L.$2n)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const d=this.getDisabledExtensions();return d.every(h=>!(0,j.$oo)(h,E))?(d.push(E),this.g(d),!0):!1}f(E){const d=this.getDisabledExtensions();for(let h=0;h<d.length;h++){const g=d[h];if((0,j.$oo)(g,E))return d.splice(h,1),this.g(d),!0}return!1}g(E){this.j(L.$2n,E)}h(E){return this.b.get(E,0)}j(E,d){this.b.set(E,d,0)}};e.$szb=k,e.$szb=k=ye([X(0,R.$Uo),X(1,L.$1n)],k);class $ extends N.$jc{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new O.$ed),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(0,void 0,this.B(new N.$ic))(d=>this.f(d)))}get(E,d){let h;return d===0?((0,A.$rf)(this.a[E])&&(this.a[E]=this.g(E,d)),h=this.a[E]):h=this.g(E,d),JSON.parse(h)}set(E,d,h){const g=JSON.stringify(d.map(({id:f,uuid:o})=>({id:f,uuid:o})));this.g(E,h)!==g&&(h===0&&(d.length?this.a[E]=g:delete this.a[E]),this.h(E,d.length?g:void 0,h))}f(E){if(!(0,A.$rf)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const h=this.get(E.key,E.scope);delete this.a[E.key];const g=this.get(E.key,E.scope),y=h.filter(o=>!g.some(l=>(0,j.$oo)(o,l))),f=g.filter(o=>!h.some(l=>(0,j.$oo)(l,o)));(y.length||f.length)&&this.b.fire([...y,...f])}}g(E,d){return this.c.get(E,d,"[]")}h(E,d,h){d?this.c.store(E,d,h,1):this.c.remove(E,h)}}e.$tzb=$}),define(re[247],oe([0,1,18,26,8,6,37,9,11,19,15,29,33,67,12,7,24,57,224,20,22,60]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=void 0;const i=L.$o?"web":(0,E.$Tn)(L.$t,j.$3d),c="X-Market-Search-Activity-Id";var n;(function(S){S[S.None=0]="None",S[S.IncludeVersions=1]="IncludeVersions",S[S.IncludeFiles=2]="IncludeFiles",S[S.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",S[S.IncludeSharedAccounts=8]="IncludeSharedAccounts",S[S.IncludeVersionProperties=16]="IncludeVersionProperties",S[S.ExcludeNonValidated=32]="ExcludeNonValidated",S[S.IncludeInstallationTargets=64]="IncludeInstallationTargets",S[S.IncludeAssetUri=128]="IncludeAssetUri",S[S.IncludeStatistics=256]="IncludeStatistics",S[S.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",S[S.Unpublished=4096]="Unpublished",S[S.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...S){return String(S.reduce((P,M)=>P|M,0))}var t;(function(S){S[S.Tag=1]="Tag",S[S.ExtensionId=4]="ExtensionId",S[S.Category=5]="Category",S[S.ExtensionName=7]="ExtensionName",S[S.Target=8]="Target",S[S.Featured=9]="Featured",S[S.SearchText=10]="SearchText",S[S.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},b={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(P=b){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,M=this.d.pageSize){return new u({...this.d,pageNumber:P,pageSize:M})}withFilter(P,...M){const T=[...this.d.criteria,...M.length?M.map(K=>({filterType:P,value:K})):[{filterType:P}]];return new u({...this.d,criteria:T})}withSortBy(P){return new u({...this.d,sortBy:P})}withSortOrder(P){return new u({...this.d,sortOrder:P})}withFlags(...P){return new u({...this.d,flags:P.reduce((M,T)=>M|T,0)})}withAssetTypes(...P){return new u({...this.d,assetTypes:P})}withSource(P){return new u({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:M,pageSize:T,sortBy:K,sortOrder:_,flags:ae,assetTypes:he}=this.d;return{filters:[{criteria:P,pageNumber:M,pageSize:T,sortBy:K,sortOrder:_}],assetTypes:he,flags:ae}}get searchText(){const P=this.d.criteria.filter(M=>M.filterType===t.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function p(S,P){const M=(S||[]).filter(T=>T.statisticName===P)[0];return M?M.value:0}function D(S){const P="Microsoft.VisualStudio.Code.Translation.";return S.files.filter(T=>T.assetType.indexOf(P)===0).reduce((T,K)=>{const _=U(S,K.assetType);return _&&T.push([K.assetType.substring(P.length),_]),T},[])}function F(S){if(S.properties){const P=S.properties.filter(K=>K.key===r.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),T=P.filter(K=>M.test(K.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return U(S,r.Repository)}function z(S){return{uri:`${S.fallbackAssetUri}/${r.VSIX}?redirect=true${S.targetPlatform?`&targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${r.VSIX}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}}function U(S,P){return S.files.filter(T=>T.assetType===P)[0]?{uri:`${S.assetUri}/${P}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`,fallbackUri:`${S.fallbackAssetUri}/${P}${S.targetPlatform?`?targetPlatform=${S.targetPlatform}`:""}`}:null}function B(S,P){const M=S.properties?S.properties.filter(K=>K.key===P):[],T=M.length>0&&M[0].value;return T?T.split(",").map(K=>(0,d.$so)(K)):[]}function x(S){const P=S.properties?S.properties.filter(M=>M.key===a.Engine):[];return P.length>0&&P[0].value||""}function J(S){const P=S.properties?S.properties.filter(M=>M.key===a.PreRelease):[];return P.length>0&&P[0].value==="true"}function Q(S){const P=S.properties?S.properties.filter(T=>T.key===a.LocalizedLanguages):[],M=P.length>0&&P[0].value||"";return M?M.split(","):[]}function W(S){return S.properties?.find(P=>P.key===a.SponsorLink)?.value}function Z(S){return S.indexOf("preview")!==-1}function G(S){return S.targetPlatform?(0,E.$Sn)(S.targetPlatform):"undefined"}function H(S){const P=(0,O.$Jb)(S.versions.map(G)),M=!!S.tags?.includes(E.$Nn),T=P.indexOf("web");return M?T===-1&&P.push("web"):T!==-1&&P.splice(T,1),P}function V(S,P){const M=(0,E.$Wn)(P);for(let T=0;T<S.length;T++){const K=S[T];if(K.version===S[T-1]?.version){let _=T;const ae=G(K);if(ae===P)for(;_>0&&S[_-1].version===K.version;)_--;else if(M.includes(ae))for(;_>0&&S[_-1].version===K.version&&G(S[_-1])!==P;)_--;_!==T&&(S.splice(T,1),S.splice(_,0,K))}}return S}e.$3o=V;function ee(S,P,M){S.telemetryData={index:P,querySource:M,queryActivityId:S.queryContext?.[c]}}function ne(S,P,M,T){const K=S.versions[0],_={manifest:U(P,r.Manifest),readme:U(P,r.Details),changelog:U(P,r.Changelog),license:U(P,r.License),repository:F(P),download:z(P),icon:U(P,r.Icon),signature:U(P,r.Signature),coreTranslations:D(P)};return{identifier:{id:(0,d.$to)(S.publisher.publisherName,S.extensionName),uuid:S.extensionId},name:S.extensionName,version:P.version,displayName:S.displayName,publisherId:S.publisher.publisherId,publisher:S.publisher.publisherName,publisherDisplayName:S.publisher.displayName,publisherDomain:S.publisher.domain?{link:S.publisher.domain,verified:!!S.publisher.isDomainVerified}:void 0,publisherSponsorLink:W(K),description:S.shortDescription||"",installCount:p(S.statistics,"install"),rating:p(S.statistics,"averagerating"),ratingCount:p(S.statistics,"ratingcount"),categories:S.categories||[],tags:S.tags||[],releaseDate:Date.parse(S.releaseDate),lastUpdated:Date.parse(S.lastUpdated),allTargetPlatforms:M,assets:_,properties:{dependencies:B(P,a.Dependency),extensionPack:B(P,a.ExtensionPack),engine:x(P),localizedLanguages:Q(P),targetPlatform:G(P),isPreReleaseVersion:J(P)},hasPreReleaseVersion:J(K),hasReleaseVersion:!0,preview:Z(S.flags),isSigned:!!_.signature,queryContext:T}}let se=class{constructor(P,M,T,K,_,ae,he,fe){this.k=M,this.l=T,this.n=K,this.o=_,this.q=ae,this.u=he,this.w=fe;const le=he.extensionsGallery,$e=le?.servicePPEUrl&&fe.getValue("_extensionsGallery.enablePPE");this.d=$e?le.servicePPEUrl:le?.serviceUrl,this.g=$e?void 0:le?.searchUrl,this.h=le?.controlUrl,this.j=(0,l.$2o)(he.version,he,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,M,T){const K=N.CancellationToken.isCancellationToken(M)?{}:M,_=N.CancellationToken.isCancellationToken(M)?M:T,ae=[],he=[],fe=[],le=[];let $e=!0;for(const Ee of P){Ee.uuid?he.push(Ee.uuid):ae.push(Ee.id);const Oe=!!(Ee.version||Ee.preRelease);fe.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Oe}),Ee.version&&le.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),$e=$e&&!!Ee.hasPreRelease&&!Oe}if(!he.length&&!ae.length)return[];let de=new u().withPage(1,P.length);he.length&&(de=de.withFilter(t.ExtensionId,...he)),ae.length&&(de=de.withFilter(t.ExtensionName,...ae)),(K.queryAllVersions||$e)&&(de=de.withFlags(de.flags,n.IncludeVersions)),K.source&&(de=de.withSource(K.source));const{extensions:we}=await this.z(de,{targetPlatform:K.targetPlatform??i,includePreRelease:fe,versions:le,compatible:!!K.compatible},_);return K.source&&we.forEach((Ee,Oe)=>ee(Ee,Oe,K.source)),we}async getCompatibleExtension(P,M,T){if((0,E.$Un)(P.allTargetPlatforms,T))return null;if(await this.isExtensionCompatible(P,M,T))return P;const K=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,P.identifier.uuid),{extensions:_}=await this.z(K,{targetPlatform:T,compatible:!0,includePreRelease:M},N.CancellationToken.None);return _[0]||null}async isExtensionCompatible(P,M,T){if(!(0,E.$Vn)(P.properties.targetPlatform,P.allTargetPlatforms,T)||!M&&P.properties.isPreReleaseVersion)return!1;let K=P.properties.engine;if(!K){const _=await this.getManifest(P,N.CancellationToken.None);if(!_)throw new Error("Manifest was not found");K=_.engines.vscode}return(0,h.$Go)(K,this.u.version,this.u.date)}async y(P,M,T,K,_){if(!(0,E.$Vn)(G(P),K,_)||M!=="any"&&J(P)!==(M==="prerelease"))return!1;if(T)try{const ae=await this.E(P);if(!(0,h.$Go)(ae,this.u.version,this.u.date))return!1}catch(ae){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,A.$8)(ae)),!1}return!0}async query(P,M){let T=P.text||"";const K=P.pageSize??50;let _=new u().withPage(1,K);T?(T=T.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(_=_.withFilter(t.Category,we||de),"")),T=T.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,de,we)=>(_=_.withFilter(t.Tag,we||de),"")),T=T.replace(/\bfeatured(\s+|\b|$)/g,()=>(_=_.withFilter(t.Featured),"")),T=T.trim(),T&&(T=T.length<200?T:T.substring(0,200),_=_.withFilter(t.SearchText,T)),_=_.withSortBy(0)):P.ids?_=_.withFilter(t.ExtensionId,...P.ids):P.names?_=_.withFilter(t.ExtensionName,...P.names):_=_.withSortBy(4),typeof P.sortBy=="number"&&(_=_.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(_=_.withSortOrder(P.sortOrder)),P.source&&(_=_.withSource(P.source));const ae=async($e,de)=>{const{extensions:we,total:Ee}=await this.z($e,{targetPlatform:i,compatible:!1,includePreRelease:!!P.includePreRelease},de);return we.forEach((Oe,Le)=>ee(Oe,($e.pageNumber-1)*$e.pageSize+Le,P.source)),{extensions:we,total:Ee}},{extensions:he,total:fe}=await ae(_,M),le=async($e,de)=>{if(de.isCancellationRequested)throw new A.$3;const{extensions:we}=await ae(_.withPage($e+1),de);return we};return{firstPage:he,total:fe,pageSize:_.pageSize,getPage:le}}async z(P,M,T){const K=P.flags;P.flags&n.IncludeLatestVersionOnly&&P.flags&n.IncludeVersions&&(P=P.withFlags(P.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(P.flags&n.IncludeLatestVersionOnly)&&!(P.flags&n.IncludeVersions)&&(P=P.withFlags(P.flags,n.IncludeLatestVersionOnly)),M.versions?.length&&(P=P.withFlags(P.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),P=P.withFlags(P.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:_,total:ae,context:he}=await this.B(P,T);if(!(P.flags&n.IncludeLatestVersionOnly)){const de=[];for(const we of _){const Ee=await this.A(we,M,he);Ee&&de.push(Ee)}return{extensions:de,total:ae}}const le=[],$e=new Map;for(let de=0;de<_.length;de++){const we=_[de],Ee={id:(0,d.$to)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Oe=(0,R.$of)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(Te=>(0,d.$oo)(Te,Ee))?.includePreRelease;if(M.compatible&&(0,E.$Un)(H(we),M.targetPlatform))continue;const Le=await this.A(we,M,he);!Le||Le.properties.isPreReleaseVersion&&(!Oe||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==M.targetPlatform&&Le.hasPreReleaseVersion?$e.set(we.extensionId,de):le.push([de,Le])}if($e.size){const de=new I.$ad,we=new u().withFlags(K&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(t.ExtensionId,...$e.keys()),{extensions:Ee}=await this.z(we,M,T);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:$e.size});for(const Oe of Ee){const Le=$e.get(Oe.identifier.uuid);le.push([Le,Oe])}}return{extensions:le.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:ae}}async A(P,M,T){const K={id:(0,d.$to)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},_=M.versions?.find(le=>(0,d.$oo)(le,K))?.version,ae=(0,R.$of)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(le=>(0,d.$oo)(le,K))?.includePreRelease,he=H(P),fe=V(P.versions,M.targetPlatform);if(M.compatible&&(0,E.$Un)(he,M.targetPlatform))return null;for(let le=0;le<fe.length;le++){const $e=fe[le];if(!(_&&$e.version!==_)){if(await this.y($e,ae?"any":"release",M.compatible,he,M.targetPlatform))return ne(P,$e,he,T);if(_&&$e.version===_)return null}}return _||M.compatible?null:ne(P,P.versions[0],he)}async B(P,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const T=await this.j,K=JSON.stringify(P.raw),_={...T,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(K.length)},ae=new I.$ad;let he,fe,le=0;try{if(he=await this.k.request({type:"POST",url:this.g&&P.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:K,headers:_},M),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:le};const $e=await(0,o.$No)(he);if($e){const de=$e.results[0],we=de.extensions,Ee=de.resultMetadata&&de.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return le=Ee&&Ee.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:le,context:{[c]:he.res.headers.activityid}}}return{galleryExtensions:[],total:le}}catch($e){throw fe=$e,$e}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(K.length),duration:ae.elapsed(),success:!!he&&(0,o.$Jo)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:fe?(0,A.$2)(fe)?"canceled":(0,A.$8)(fe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(le)})}}async reportStatistic(P,M,T,K){if(!this.isEnabled())return;const _=L.$o?this.x(`/itemName/${P}.${M}/version/${T}/statType/${K==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${M}/${T}/stats?statType=${K}`),ae=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",fe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:_,headers:fe},N.CancellationToken.None)}catch{}}async download(P,M,T){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const K=(0,d.$wo)(P),_=new Date().getTime(),ae=de=>this.o.publicLog("galleryService:downloadVSIX",{...K,duration:de}),he=T===2?"install":T===3?"update":"",fe=he?{uri:`${P.assets.download.uri}${k.URI.parse(P.assets.download.uri).query?"&":"?"}${he}=true`,fallbackUri:`${P.assets.download.fallbackUri}${k.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${he}=true`}:P.assets.download,le=P.queryContext?.[c]?{[c]:P.queryContext[c]}:void 0,$e=await this.D(fe,le?{headers:le}:void 0);await this.q.writeFile(M,$e.stream),ae(new Date().getTime()-_)}async downloadSignatureArchive(P,M){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const T=await this.D(P.assets.signature);await this.q.writeFile(M,T.stream)}async getReadme(P,M){if(P.assets.readme){const T=await this.D(P.assets.readme,{},M);return await(0,o.$Mo)(T)||""}return""}async getManifest(P,M){if(P.assets.manifest){const T=await this.D(P.assets.manifest,{},M),K=await(0,o.$Mo)(T);return K?JSON.parse(K):null}return null}async C(P,M){const T=U(P,r.Manifest);if(!T)throw new Error("Manifest was not found");const K={"Accept-Encoding":"gzip"},_=await this.D(T,{headers:K});return await(0,o.$No)(_)}async getCoreTranslation(P,M){const T=P.assets.coreTranslations.filter(K=>K[0]===M.toUpperCase())[0];if(T){const K=await this.D(T[1]),_=await(0,o.$Mo)(K);return _?JSON.parse(_):null}return null}async getChangelog(P,M){if(P.assets.changelog){const T=await this.D(P.assets.changelog,{},M);return await(0,o.$Mo)(T)||""}return""}async getAllCompatibleVersions(P,M,T){let K=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?K=K.withFilter(t.ExtensionId,P.identifier.uuid):K=K.withFilter(t.ExtensionName,P.identifier.id);const{galleryExtensions:_}=await this.B(K,N.CancellationToken.None);if(!_.length)return[];const ae=H(_[0]);if((0,E.$Un)(ae,T))return[];const he=[];await Promise.all(_[0].versions.map(async $e=>{try{await this.y($e,M?"any":"release",!0,ae,T)&&he.push($e)}catch{}}));const fe=[],le=new Set;for(const $e of V(he,T))le.has($e.version)||(le.add($e.version),fe.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:J($e)}));return fe}async D(P,M={},T=N.CancellationToken.None){const K=await this.j,_={type:"GET"},ae={...K,...M.headers||{}};M={...M,..._,headers:ae};const he=P.uri,fe=P.fallbackUri,le={...M,url:he};try{const $e=await this.k.request(le,T);if($e.res.statusCode===200)return $e;const de=await(0,o.$Mo)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${de}`)}catch($e){if((0,A.$2)($e))throw $e;const de=(0,A.$8)($e);this.o.publicLog2("galleryService:cdnFallback",{url:he,message:de});const we={...M,url:fe};return this.k.request(we,T)}}async E(P){let M=x(P);if(!M){const T=await this.C(P,N.CancellationToken.None);if(!T)throw new Error("Manifest was not found");M=T.engines.vscode}return M}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const P=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,o.$No)(P),T=[],K={},_=[];if(M){for(const ae of M.malicious)T.push({id:ae});if(M.migrateToPreRelease)for(const[ae,he]of Object.entries(M.migrateToPreRelease))(!he.engine||(0,h.$Go)(he.engine,this.u.version,this.u.date))&&(K[ae.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ae,he]of Object.entries(M.deprecated))he&&(K[ae.toLowerCase()]=(0,R.$of)(he)?{}:he);if(M.search)for(const ae of M.search)_.push(ae)}return{malicious:T,deprecated:K,search:_}}};se=ye([X(1,o.$Ho),X(2,y.$4i),X(3,C.$Hh),X(4,m.$8k),X(5,g.$5j),X(6,f.$jj),X(7,$.$7h)],se);let Y=class extends se{constructor(P,M,T,K,_,ae,he,fe){super(P,M,T,K,_,ae,he,fe)}};e.$4o=Y,e.$4o=Y=ye([X(0,w.$Uo),X(1,o.$Ho),X(2,y.$4i),X(3,C.$Hh),X(4,m.$8k),X(5,g.$5j),X(6,f.$jj),X(7,$.$7h)],Y);let q=class extends se{constructor(P,M,T,K,_,ae,he){super(void 0,P,M,T,K,_,ae,he)}};e.$5o=q,e.$5o=q=ye([X(0,o.$Ho),X(1,y.$4i),X(2,C.$Hh),X(3,m.$8k),X(4,g.$5j),X(5,f.$jj),X(6,$.$7h)],q)}),define(re[80],oe([0,1,4,3,2,20,33,24,18,7,9]),function(te,e,O,N,A,L,j,R,k,$,C){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tz=e.$Sz=void 0,e.$Sz=(0,O.$Ah)("IExtensionStorageService");const d=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let h=class extends A.$jc{static{E=this}static{this.a=512*1024}static b(y){return`extensionKeys/${(0,j.$so)(y.id)}@${y.version}`}static c(y){const f=d.exec(y);if(f&&f[1])return{id:f[1],version:f[2]}}static async removeOutdatedExtensionVersions(y,f){const o=await y.getInstalled(),l=[];for(const[w,m]of E.f(f)){const I=o.find(i=>(0,j.$oo)(i.identifier,{id:w}))?.manifest.version;for(const i of m)I!==i&&l.push(E.b({id:w,version:i}))}for(const w of l)f.remove(w,0)}static f(y){const f=new Map,o=y.keys(0,1);for(const l of o){const w=E.c(l);if(w){let m=f.get(w.id.toLowerCase());m||f.set(w.id.toLowerCase(),m=[]),m.push(w.version)}}return f}constructor(y,f,o){super(),this.j=y,this.m=f,this.n=o,this.g=this.B(new N.$ed),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=E.f(y),this.B(this.j.onDidChangeValue(0,void 0,this.B(new A.$ic))(l=>this.r(l)))}r(y){if(this.h.has(y.key.toLowerCase())){this.g.fire();return}const f=E.c(y.key);if(f){if(this.j.get(y.key,0)===void 0)this.h.delete(f.id.toLowerCase());else{let o=this.h.get(f.id.toLowerCase());o||this.h.set(f.id.toLowerCase(),o=[]),o.push(f.version),this.g.fire()}return}}s(y){if((0,C.$if)(y))return y;const f=y.manifest?y.manifest.publisher:y.publisher,o=y.manifest?y.manifest.name:y.name;return(0,j.$ro)(f,o)}getExtensionState(y,f){const o=this.s(y),l=this.getExtensionStateRaw(y,f);if(l)try{return JSON.parse(l)}catch(w){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${o}, global: ${f}): ${w}`)}}getExtensionStateRaw(y,f){const o=this.s(y),l=this.j.get(o,f?0:1);return l&&l?.length>E.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${o}, global: ${f}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState(y,f,o){const l=this.s(y);f===void 0?this.j.remove(l,o?0:1):this.j.store(l,JSON.stringify(f),o?0:1,1)}setKeysForSync(y,f){this.j.store(E.b(y),JSON.stringify(f),0,1)}getKeysForSync(y){const f=this.m.extensionSyncedKeys?.[y.id.toLowerCase()],o=this.j.get(E.b(y),0),l=o?JSON.parse(o):void 0;return l&&f?(0,k.$Jb)([...l,...f]):l||f}addToMigrationList(y,f){if(y!==f){const o=this.t.filter(l=>!l.includes(y)&&!l.includes(f));o.push([y,f]),this.t=o}}getSourceExtensionToMigrate(y){const f=this.t.find(([,o])=>y===o);return f?f[0]:void 0}get t(){const y=this.j.get("extensionStorage.migrationList",-1,"[]");try{const f=JSON.parse(y);if(Array.isArray(f))return f}catch{}return[]}set t(y){y.length?this.j.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$Tz=h,e.$Tz=h=E=ye([X(0,L.$Uo),X(1,R.$jj),X(2,$.$4i)],h)}),define(re[248],oe([0,1,29,12,24,15,98,55,20,22,221]),function(te,e,O,N,A,L,j,R,k,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67b=void 0;let E=class extends C.$n4b{constructor(h,g,y,f,o,l,w,m){super(h.userHome,o,g,y,f,l,w,m)}};e.$67b=E,e.$67b=E=ye([X(0,L.$Ih),X(1,$.$8k),X(2,O.$1n),X(3,k.$Uo),X(4,R.$S5b),X(5,j.$CUb),X(6,N.$5j),X(7,A.$jj)],E)}),define(re[249],oe([0,1,105,3,22,15,2,7,16,64,24,6,5,101,19,165,36,20,9,133,21]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$27b=void 0;const I=[O.$U7b,O.$V7b],i="remoteTunnelSession",c="remoteTunnelIsService";let n=class extends j.$jc{constructor(a,v,b,u,p,D,F){super(),this.y=a,this.z=v,this.C=b,this.D=D,this.F=F,this.f=new N.$ed,this.onDidTokenFailed=this.f.event,this.g=new N.$ed,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$ed,this.onDidChangeMode=this.h.event,this.n=O.$S7b,this.w=!1,this.I=(z,U)=>{U?this.j.error(z):this.j.info(z)},this.j=this.B(u.createLogger((0,m.$hg)(b.logsHome,`${O.$W7b}.log`),{id:O.$W7b,name:O.$X7b})),this.t=new d.$Cg(100),this.B(this.j.onDidChangeLogLevel(z=>this.j.info("Log level changed to "+(0,R.$gj)(z)))),this.B(p.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(D.onDidChangeConfiguration(z=>{I.some(U=>z.affectsConfiguration(U))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=O.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;E.$j?a=this.C.appRoot:a=(0,k.$$d)((0,k.$$d)(this.C.appRoot)),this.u=(0,k.$8d)(a,"bin",`${this.z.tunnelApplicationName}${E.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),!this.n.active)return;const a=this.n.asService;this.H(O.$S7b);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}try{await this.O("stop",["kill"])}catch(v){this.j.error(v)}this.G(O.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const b=(U,B)=>{B?this.j.error(U):a+=U,!this.C.isBuilt&&U.startsWith("   Compiling")&&this.G(O.TunnelStates.connecting((0,y.localize)(0,null)))},u=this.O("status",["status"],b);this.r=u;try{if(await u,this.r!==u)return;const U=JSON.parse(a.trim().split(`
`).find(B=>B.startsWith("{")));if(v=U.service_installed,this.j.info(U.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!U.tunnel&&!this.n.active){this.G(O.TunnelStates.disconnected());return}}catch(U){this.j.error(U),this.G(O.TunnelStates.disconnected());return}finally{this.r===u&&(this.r=void 0)}const p=this.n.active?this.n.session:void 0;if(p&&p.token){const U=p.token;this.G(O.TunnelStates.connecting((0,y.localize)(1,null,p.accountLabel,p.providerId)));const B=(J,Q)=>{J=J.replaceAll(U,"*".repeat(4)),b(J,Q)},x=this.O("login",["user","login","--provider",p.providerId,"--access-token",U,"--log",(0,R.$gj)(this.j.getLevel())],B);this.r=x;try{if(await x,this.r!==x)return}catch(J){this.j.error(J),this.r=void 0,this.f.fire(p),this.G(O.TunnelStates.disconnected(p));return}}const D=this.Q();D?this.G(O.TunnelStates.connecting((0,y.localize)(2,null,D))):this.G(O.TunnelStates.connecting((0,y.localize)(3,null)));const F=["--accept-server-license-terms","--log",(0,R.$gj)(this.j.getLevel())];D?F.push("--name",D):F.push("--random-name");let z=!1;return this.n.active&&this.n.asService&&!v&&(z=await this.M(F)===!1),this.N(p,F,z)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(b){this.j.error(b),v=1}if(v!==0){const b=(0,y.localize)(4,null);return this.j.warn(b),this.G(O.TunnelStates.connecting(b)),!1}return!0}async N(a,v,b){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let u=!1;const p=this.O("tunnel",v,(D,F)=>{F?this.j.error(D):this.j.info(D),D.includes("Connected to an existing tunnel process")&&(u=!0);const z=D.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(z){const U={link:z[1],domain:z[2],tunnelName:z[4],isAttached:u};this.G(O.TunnelStates.connected(U,b))}else D.match(/error refreshing token/)&&(p.cancel(),this.f.fire(a),this.G(O.TunnelStates.disconnected(a)))});this.r=p,p.finally(()=>{p===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=O.$S7b,this.G(O.TunnelStates.disconnected()))})}O(a,v,b=this.I){return(0,d.$tg)(u=>new Promise((p,D)=>{u.isCancellationRequested&&p(-1);let F;const z=["ignore","pipe","pipe"];if(u.onCancellationRequested(()=>{F&&(this.j.info(`${a} terminating(${F.pid})`),F.kill())}),!this.C.isBuilt)b(`Building tunnel CLI from sources and run
`,!1),b(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),F=(0,$.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,k.$8d)(this.C.appRoot,"cli"),stdio:z});else{b(`Running tunnel CLI
`,!1);const U=this.J();b(`${a} Spawning: ${U} tunnel ${v.join(" ")}
`,!1),F=(0,$.spawn)(U,["tunnel",...v],{cwd:(0,f.homedir)(),stdio:z})}F.stdout.pipe(new w.$IS(`
`)).on("data",U=>{if(F){const B=U.toString();b(B,!1)}}),F.stderr.pipe(new w.$IS(`
`)).on("data",U=>{if(F){const B=U.toString();b(B,!0)}}),F.on("exit",U=>{F&&(b(`${a} exit(${F.pid}): + ${U} `,!1),F=void 0,p(U||0))}),F.on("error",U=>{F&&(b(`${a} error(${F.pid}): + ${U} `,!0),F=void 0,D())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(O.$V7b)}Q(){let a=this.D.getValue(O.$U7b)||(0,f.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),v=this.F.getBoolean(c,-1,!1);if(a){const b=JSON.parse(a);if(b&&(0,l.$if)(b.accountLabel)&&(0,l.$if)(b.sessionId)&&(0,l.$if)(b.providerId))return{active:!0,session:b,asService:v};this.j.error("Problems restoring session from storage, invalid format",b)}}catch(a){this.j.error("Problems restoring session from storage",a)}return O.$S7b}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(v),-1,1),this.F.store(c,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(c,-1)}};e.$27b=n,e.$27b=n=ye([X(0,A.$8k),X(1,C.$jj),X(2,L.$Ih),X(3,R.$5i),X(4,h.$Z7b),X(5,g.$7h),X(6,o.$Uo)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(re[250],oe([0,1,5,2,23,21,66,20,75,17]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$77b=void 0;class C extends R.$Wo{constructor(d,h,g,y){super(),this.bb=d,this.cb=h,this.db=g,this.eb=y,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$ic),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$ic),this.ab=this.hb(this.bb)}fb(){const d=this.B(new k.$3zb(this.db.getChannel("storage"))),h=this.B(new j.$Qo(d));return this.B(h.onDidChangeStorage(g=>this.u(-1,g))),h}gb(d){this.X.clear(),this.W=d;let h;if((0,R.$Xo)(d))h=this.U;else{const g=this.X.add(new k.$4zb(this.db.getChannel("storage"),d));h=this.X.add(new j.$Qo(g))}return this.X.add(h.onDidChangeStorage(g=>this.u(0,g))),h}hb(d){this.$.clear(),this.Z=d?.id;let h;if(d){const g=this.$.add(new k.$5zb(this.db.getChannel("storage"),d));h=this.$.add(new j.$Qo(g)),this.$.add(h.onDidChangeStorage(y=>this.u(1,y)))}return h}async O(){await O.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(d){switch(d){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(d){switch(d){case-1:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,L.$hg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await O.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(d){if(!this.M(this.W,d))return;const h=this.Y,g=h.items;h!==this.U&&await h.close(),this.Y=this.gb(d),await this.Y.init(),this.N(g,this.Y,0)}async S(d,h){const g=this.ab,y=g?.items??new Map;await g?.close(),this.ab=this.hb(d),await this.ab.init(),this.N(y,this.ab,1)}hasScope(d){return(0,$.$Ck)(d)?this.W.id===d.id:this.Z===d.id}}e.$77b=C}),define(re[251],oe([0,1,3,2,17,92]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pN=e.$oN=void 0;class j{constructor($,C){this.a=$,this.b=C}listen($,C){const E=this.b($);switch(C){case"onDidChangeProfiles":return O.Event.map(this.a.onDidChangeProfiles,d=>({all:d.all.map(h=>(0,L.$Cm)({...h},E)),added:d.added.map(h=>(0,L.$Cm)({...h},E)),removed:d.removed.map(h=>(0,L.$Cm)({...h},E)),updated:d.updated.map(h=>(0,L.$Cm)({...h},E))}))}throw new Error(`Invalid listen ${C}`)}async call($,C,E){const d=this.b($);switch(C){case"createProfile":{const h=await this.a.createProfile(E[0],E[1],E[2]);return(0,L.$Cm)({...h},d)}case"updateProfile":{let h=(0,A.$Ek)((0,L.$Dm)(E[0],d),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,E[1]),(0,L.$Cm)({...h},d)}case"removeProfile":{const h=(0,A.$Ek)((0,L.$Dm)(E[0],d),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${C}`)}}e.$oN=j;class R extends N.$jc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor($,C,E){super(),this.profilesHome=C,this.f=E,this.a=[],this.b=this.B(new O.$ed),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=$.map(d=>(0,A.$Ek)(d,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(d=>{const h=d.added.map(f=>(0,A.$Ek)(f,this.profilesHome.scheme)),g=d.removed.map(f=>(0,A.$Ek)(f,this.profilesHome.scheme)),y=d.updated.map(f=>(0,A.$Ek)(f,this.profilesHome.scheme));this.a=d.all.map(f=>(0,A.$Ek)(f,this.profilesHome.scheme)),this.b.fire({added:h,removed:g,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement($){this.c=$}isEnabled(){return this.c}async createNamedProfile($,C,E){const d=await this.f.call("createNamedProfile",[$,C,E]);return(0,A.$Ek)(d,this.profilesHome.scheme)}async createProfile($,C,E,d){const h=await this.f.call("createProfile",[$,C,E,d]);return(0,A.$Ek)(h,this.profilesHome.scheme)}async createTransientProfile($){const C=await this.f.call("createTransientProfile",[$]);return(0,A.$Ek)(C,this.profilesHome.scheme)}async setProfileForWorkspace($,C){await this.f.call("setProfileForWorkspace",[$,C])}removeProfile($){return this.f.call("removeProfile",[$])}async updateProfile($,C){const E=await this.f.call("updateProfile",[$,C]);return(0,A.$Ek)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$pN=R}),define(re[58],oe([0,1,2,66,4,20,3,75,17]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9zb=e.$8zb=e.$7zb=void 0,e.$7zb=(0,A.$Ah)("IUserDataProfileStorageService");let $=class extends O.$jc{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async g=>this.b(g))}async updateStorageData(h,g,y){return this.withProfileScopedStorageService(h,async f=>this.c(f,g,y))}async withProfileScopedStorageService(h,g){if(this.a.hasScope(h))return g(this.a);const y=await this.g(h),f=new E(y);try{await f.initialize();const o=await g(f);return await f.flush(),o}finally{f.dispose(),await this.f(y)}}b(h){const g=new Map,y=f=>{for(const o of h.keys(0,f))g.set(o,{value:h.get(o,0),target:f})};return y(0),y(1),g}c(h,g,y){h.storeAll(Array.from(g.entries()).map(([f,o])=>({key:f,value:o,scope:0,target:y})),!0)}async f(h){try{await h.close()}finally{(0,O.$dc)(h)&&h.dispose()}}};e.$8zb=$,e.$8zb=$=ye([X(0,L.$Uo)],$);class C extends ${constructor(h,g,y,f){super(y),this.j=h;const o=h.getChannel("profileStorageListener"),l=this.B(new O.$kc);this.h=this.B(new j.$ed({onWillAddFirstListener:()=>{l.value=o.listen("onDidChange")(w=>{f.trace("profile storage changes",w),this.h.fire({targetChanges:w.targetChanges.map(m=>(0,k.$Ek)(m,g.profilesHome.scheme)),valueChanges:w.valueChanges.map(m=>({...m,profile:(0,k.$Ek)(m.profile,g.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>l.value=void 0})),this.onDidChange=this.h.event}async g(h){const g=this.j.getChannel("storage");return(0,L.$Xo)(h)?new R.$3zb(g):new R.$4zb(g,h)}}e.$9zb=C;class E extends L.$Wo{constructor(h){super({flushInterval:100}),this.s=this.B(new N.$Qo(h))}O(){return this.s.init()}P(h){return h===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(re[252],oe([0,1,20,7,17,71,58]),function(te,e,O,N,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=void 0;let R=class extends j.$9zb{constructor($,C,E,d){super($,C,E,d)}};e.$L7b=R,e.$L7b=R=ye([X(0,L.$06b),X(1,A.$Dk),X(2,O.$Uo),X(3,N.$4i)],R)}),define(re[39],oe([0,1,18,5,14,26,3,34,2,27,9,170,19,15,12,7,44,20,22,28,25,17]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Ab=e.$ZAb=e.$YAb=e.$XAb=e.$WAb=e.$VAb=e.$UAb=void 0;function i(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||c(v.syncData)))}e.$UAb=i;function c(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$VAb=c;function n(v,b){return`${(0,$.$af)(v)}${b.isDefault?"":` (${b.name})`}`}e.$WAb=n;let s=class extends k.$jc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(b,u,p,D,F,z,U,B,x,J,Q,W){super(),this.syncResource=b,this.collection=u,this.G=p,this.H=D,this.I=F,this.J=z,this.L=U,this.M=B,this.N=x,this.O=J,this.P=Q,this.c=null,this.m="idle",this.n=this.B(new j.$ed),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new j.$ed),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$Dg(50)),this.w=this.B(new j.$ed),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(b.syncResource,b.profile),this.h=W.extUri,this.f=this.h.joinPath(D.userDataSyncHome,...(0,m.$sgb)(b.profile.isDefault?void 0:b.profile.id,b.syncResource)),this.g=this.h.joinPath(this.f,m.$Ngb),this.y=(0,m.$tgb)(b.profile.isDefault?void 0:b.profile.id,b.syncResource,D,this.h),this.j=(0,f.$1o)(D,p,F)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const b=await this.c;this.c=null;const u=await this.Y(b.remoteUserData,b.lastSyncUserData,!0,this.ob());this.S(u)}else{this.O.trace(`${this.D}: Checking for local changes...`);const b=await this.getLastSyncUserData();(b?await this.ub(b):!0)&&this.w.fire()}}S(b){this.m!==b&&(this.m=b,this.n.fire(b))}async sync(b,u={}){await this.U(b,!0,this.ob(),u)}async preview(b,u,p={}){return this.U(b,!1,u,p)}async apply(b,u={}){try{this.F={...u};const p=await this.ab(b);return this.S(p),this.c}finally{this.F={}}}async U(b,u,p,D){try{if(this.F={...D},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let F="idle";try{const z=await this.getLastSyncUserData(),U=await this.X(b,z);return F=await this.Y(U,z,u,p),F==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):F==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(F)}}finally{this.F={}}}async replace(b){const u=this.kb(b);if(!u)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const p=await this.getLastSyncUserData(),D=await this.X(null,p),F=await this.W(D),z=await this.qb({ref:D.ref,syncData:u},p,F,this.ob(),L.CancellationToken.None),U=[];for(const B of z){const x=await this.sb(B,B.remoteResource,void 0,L.CancellationToken.None),{remoteChange:J}=await this.sb(B,B.previewResource,B.remoteContent,L.CancellationToken.None);U.push([B,{...x,remoteChange:J!==0?J:2}])}await this.tb(D,p,U,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(b){const u=await this.j;return!!b.syncData?.machineId&&b.syncData.machineId===u}async X(b,u){if(u){const p=b?b[this.resource]:void 0;if(u.ref===p||p===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async Y(b,u,p,D){if(b.syncData&&b.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new m.$Agb((0,E.localize)(0,null,this.resource,this.pb,b.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(b,u,p,D)}catch(F){if(F instanceof m.$Agb)switch(F.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(b,u,p,D);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),b=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.Y(b,u,p,D)}throw F}}async Z(b,u,p,D){try{const F=await this.W(b),z=!F&&u===null&&this.gb()!==void 0,U=p&&!z;this.c||(this.c=(0,N.$tg)(x=>this.eb(b,u,F,U,D,x)));let B=await this.c;if(p&&z){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const x of B.resourcePreviews)B=await this.accept(x.remoteResource)||B}return this.cb(B.resourcePreviews),B.resourcePreviews.some(({mergeState:x})=>x==="conflict")?"hasConflicts":p?await this.ab(!1):"syncing"}catch(F){throw this.c=null,F}}async merge(b){return await this.$(b,async u=>{const p=await this.rb(u,L.CancellationToken.None);await this.G.writeFile(u.previewResource,A.$Ed.fromString(p?.content||""));const D=p&&!p.hasConflicts?await this.sb(u,u.previewResource,void 0,L.CancellationToken.None):void 0;return u.acceptResult=D,u.mergeState=p.hasConflicts?"conflict":D?"accepted":"preview",u.localChange=D?D.localChange:p.localChange,u.remoteChange=D?D.remoteChange:p.remoteChange,u}),this.c}async accept(b,u){return await this.$(b,async p=>{const D=await this.sb(p,b,u,L.CancellationToken.None);return p.acceptResult=D,p.mergeState="accepted",p.localChange=D.localChange,p.remoteChange=D.remoteChange,p}),this.c}async discard(b){return await this.$(b,async u=>{const p=await this.rb(u,L.CancellationToken.None);return await this.G.writeFile(u.previewResource,A.$Ed.fromString(p.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=p.localChange,u.remoteChange=p.remoteChange,u}),this.c}async $(b,u){if(!this.c)return;let p=await this.c;const D=p.resourcePreviews.findIndex(({localResource:F,remoteResource:z,previewResource:U})=>this.h.isEqual(F,b)||this.h.isEqual(z,b)||this.h.isEqual(U,b));D!==-1&&(this.c=(0,N.$tg)(async F=>{const z=[...p.resourcePreviews];return z[D]=await u(z[D]),{...p,resourcePreviews:z}}),p=await this.c,this.cb(p.resourcePreviews),p.resourcePreviews.some(({mergeState:F})=>F==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(b){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.tb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(p=>[p,p.acceptResult]),b),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(b){const u=b.filter(({mergeState:p})=>p==="conflict");(0,O.$sb)(this.s,u,(p,D)=>this.h.isEqual(p.previewResource,D.previewResource))||(this.s=u,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const b=await this.getLastSyncUserData();return!!b&&b.syncData!==null}async db(b){const u=this.c?await this.c:null;if(u)for(const p of u.resourcePreviews){if(this.h.isEqual(p.acceptedResource,b))return p.acceptResult?p.acceptResult.content:null;if(this.h.isEqual(p.remoteResource,b))return p.remoteContent;if(this.h.isEqual(p.localResource,b))return p.localContent;if(this.h.isEqual(p.baseResource,b))return p.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(b){(0,g.$ik)(b)!==1&&this.O.error(b)}}async eb(b,u,p,D,F,z){const U=await this.qb(b,u,p,F,z),B=[];for(const x of U){const J=x.previewResource.with({scheme:m.$Mgb,authority:"accepted"});if(x.localChange===0&&x.remoteChange===0)B.push({...x,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=D?await this.rb(x,z):void 0;if(z.isCancellationRequested)break;await this.G.writeFile(x.previewResource,A.$Ed.fromString(Q?.content||""));const W=Q&&!Q.hasConflicts?await this.sb(x,x.previewResource,void 0,z):void 0;B.push({...x,acceptResult:W,mergeState:Q?.hasConflicts?"conflict":W?"accepted":"preview",localChange:W?W.localChange:Q?Q.localChange:x.localChange,remoteChange:W?W.remoteChange:Q?Q.remoteChange:x.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:b,lastSyncUserData:u,resourcePreviews:B,isLastSyncFromCurrentMachine:p}}async getLastSyncUserData(){let b=this.gb();if(b||(b=await this.jb()),!b)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const u=JSON.parse(b),p=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!u.version&&!!p&&u.version!==p,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;let D,F=1;for(;D===void 0&&F++<6;)try{const z=await this.hb();z&&(z.ref===u.ref?D=z.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(z){if(z instanceof g.$mk&&z.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(z instanceof m.$Agb)throw z;this.O.error(z,F)}}if(D===void 0)try{const z=await this.J.resolveResourceContent(this.resource,u.ref,this.collection,this.F);D=z===null?null:this.kb(z),await this.ib({ref:u.ref,syncData:D})}catch(z){if(z instanceof m.$Agb&&z.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw z}return D===void 0?null:{...u,syncData:D}}async fb(b,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p=this.M.getResourceSyncStateVersion(this.resource),D={ref:b.ref,version:p,...u};this.I.store(this.z,JSON.stringify(D),-1,1),await this.ib(b)}gb(){return this.I.get(this.z,-1)}async hb(){const b=(await this.G.readFile(this.y)).value.toString();try{const u=b?JSON.parse(b):void 0;if(i(u))return u}catch(u){this.O.error(u)}}async ib(b){await this.G.writeFile(this.y,A.$Ed.fromString(JSON.stringify(b)))}async jb(){try{const b=await this.G.readFile(this.y),u=JSON.parse(b.value.toString());await this.G.del(this.y),u.ref&&u.content!==void 0?(this.I.store(this.z,JSON.stringify({...u,content:void 0}),-1,1),await this.ib({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,u)}catch(b){b instanceof g.$mk&&b.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(b)}return this.I.get(this.z,-1)}async getRemoteUserData(b){const{ref:u,content:p}=await this.lb(b);let D=null;return p!==null&&(D=this.kb(p)),{ref:u,syncData:D}}kb(b){try{const u=JSON.parse(b);if(c(u))return u}catch(u){this.O.error(u)}throw new m.$Agb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(b){const u=b?{ref:b.ref,content:b.syncData?JSON.stringify(b.syncData):null}:null;return this.J.readResource(this.resource,u,this.collection,this.F)}async mb(b,u){const p=await this.j,D={version:this.pb,machineId:p,content:b};try{return u=await this.J.writeResource(this.resource,JSON.stringify(D),u,this.collection,this.F),{ref:u,syncData:D}}catch(F){throw F instanceof m.$Agb&&F.code==="TooLarge"&&(F=new m.$Agb(F.message,F.code,this.resource)),F}}async nb(b){const u={version:this.pb,content:b};return this.L.writeResource(this.resource,JSON.stringify(u),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(m.$ngb)}};e.$XAb=s,e.$XAb=s=ye([X(2,g.$5j),X(3,h.$Hh),X(4,o.$Uo),X(5,m.$vgb),X(6,m.$wgb),X(7,m.$Fgb),X(8,l.$8k),X(9,m.$Kgb),X(10,d.$7h),X(11,w.$Bk)],s);let t=class extends s{constructor(b,u,p,D,F,z,U,B,x,J,Q,W,Z){super(u,p,D,F,z,U,B,x,J,Q,W,Z),this.r=b,this.B(this.G.watch(this.h.dirname(b))),this.B(this.G.onDidFilesChange(G=>this.yb(G)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(b,u,p){try{u?await this.G.writeFile(this.r,A.$Ed.fromString(b),p?void 0:u):await this.G.createFile(this.r,A.$Ed.fromString(b),{overwrite:p})}catch(D){throw D instanceof g.$mk&&D.fileOperationResult===1||D instanceof g.$mk&&D.fileOperationResult===3?new m.$Agb(D.message,"LocalPreconditionFailed"):D}}async xb(){try{await this.G.del(this.r)}catch(b){if(!(b instanceof g.$mk&&b.fileOperationResult===1))throw b}}yb(b){b.contains(this.r)&&this.Q()}};e.$YAb=t,e.$YAb=t=ye([X(3,g.$5j),X(4,h.$Hh),X(5,o.$Uo),X(6,m.$vgb),X(7,m.$wgb),X(8,m.$Fgb),X(9,l.$8k),X(10,m.$Kgb),X(11,d.$7h),X(12,w.$Bk)],t);let r=class extends t{constructor(b,u,p,D,F,z,U,B,x,J,Q,W,Z,G){super(b,u,p,D,F,z,U,B,x,J,Q,Z,G),this.zb=W,this.Bb=void 0}Ab(b,u){const p=[],D=(0,R.$Km)(b,p,{allowEmptyContent:!0,allowTrailingComma:!0});return p.length>0||!(0,C.$pf)(D)&&u!==Array.isArray(D)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$ZAb=r,e.$ZAb=r=ye([X(3,g.$5j),X(4,h.$Hh),X(5,o.$Uo),X(6,m.$vgb),X(7,m.$wgb),X(8,m.$Fgb),X(9,l.$8k),X(10,m.$Kgb),X(11,m.$Jgb),X(12,d.$7h),X(13,w.$Bk)],r);let a=class{constructor(b,u,p,D,F,z,U){this.resource=b,this.g=u,this.h=p,this.j=D,this.k=F,this.l=z,this.d=U.extUri,this.f=(0,m.$tgb)(void 0,this.resource,p,this.d)}async initialize({ref:b,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const p=this.m(u);if(p)try{await this.o({ref:b,syncData:p})}catch(D){this.j.error(D)}}m(b){try{const u=JSON.parse(b);if(c(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(b,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p={ref:b.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(p),-1,1),await this.k.writeFile(this.f,A.$Ed.fromString(JSON.stringify(b)))}};e.$1Ab=a,e.$1Ab=a=ye([X(1,I.$Dk),X(2,h.$Hh),X(3,y.$4i),X(4,g.$5j),X(5,o.$Uo),X(6,w.$Bk)],a)}),define(re[115],oe([0,1,5,26,8,3,41,2,27,19,15,114,29,33,80,45,12,4,70,7,20,22,28,17,39,232,111,25,58]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m,I,i,c,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A2b=e.$z2b=e.$y2b=e.$x2b=e.$w2b=void 0;async function v(z,U){const B=JSON.parse(z.content);if(z.version===1||z.version===2){const x=(await U.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of B)z.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),z.version===2&&x.every(Q=>!(0,h.$oo)(Q.identifier,J.identifier))&&(J.installed=!0)}return B}function b(z){return JSON.parse(z.content)}e.$w2b=b;function u(z,U){return z.sort((B,x)=>!B.identifier.uuid&&x.identifier.uuid?-1:B.identifier.uuid&&!x.identifier.uuid?1:(0,k.$Ee)(B.identifier.id,x.identifier.id)),U?(0,j.$rS)(z,{}):JSON.stringify(z)}e.$x2b=u;let p=class extends n.$XAb{constructor(U,B,x,J,Q,W,Z,G,H,V,ee,ne,se,Y,q,S,P){super({syncResource:"extensions",profile:U},B,J,x,Q,W,Z,ne,se,V,ee,q),this.Cb=G,this.Db=H,this.Eb=P,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$Mgb,authority:"base"}),this.yb=this.wb.with({scheme:r.$Mgb,authority:"local"}),this.zb=this.wb.with({scheme:r.$Mgb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$Mgb,authority:"accepted"}),this.Bb=this.Eb.createInstance(D),this.B(L.Event.any(L.Event.filter(this.Cb.onDidInstallExtensions,M=>M.some(({local:T})=>!!T)),L.Event.filter(this.Cb.onDidUninstallExtension,M=>!M.error),L.Event.filter(S.onDidChange,M=>M.valueChanges.some(({profile:T,changes:K})=>this.syncResource.profile.id===T.id&&K.some(_=>_.key===d.$2n))),Y.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(U,B){const x=U.syncData?await v(U.syncData,this.Cb):null,J=B?.skippedExtensions??[],Q=B?.builtinExtensions??null,W=B?.syncData?await v(B.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:G}=await this.Bb.getLocalExtensions(this.syncResource.profile);x?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:H,remote:V}=(0,s.$v2b)(Z,x,W,J,G,Q),ee={local:H,remote:V,content:this.Hb(Z,H.added,H.updated,H.removed),localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:V!==null?2:0},ne=this.Ob(Z,!1);return[{skippedExtensions:J,builtinExtensions:Q,baseResource:this.xb,baseContent:W?this.Ob(W,!1):ne,localResource:this.yb,localContent:ne,localExtensions:Z,remoteResource:this.zb,remoteExtensions:x,remoteContent:x?this.Ob(x,!1):null,previewResource:this.wb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.Ab}]}async ub(U){const B=U.syncData?await v(U.syncData,this.Cb):null,{localExtensions:x,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,s.$v2b)(x,B,B,U.skippedExtensions||[],J,U.builtinExtensions||[]);return Q!==null}Hb(U,B,x,J){const Q=[...B,...x],W=new Set,Z=G=>{W.add(G.id.toLowerCase()),G.uuid&&W.add(G.uuid)};Q.forEach(({identifier:G})=>Z(G)),J.forEach(Z);for(const G of U)W.has(G.identifier.id.toLowerCase())||G.identifier.uuid&&W.has(G.identifier.uuid)||Q.push(G);return this.Ob(Q,!1)}async rb(U,B){return{...U.previewResult,hasConflicts:!1}}async sb(U,B,x,J){if(this.h.isEqual(B,this.yb))return this.Kb(U);if(this.h.isEqual(B,this.zb))return this.Lb(U);if(this.h.isEqual(B,this.wb))return U.previewResult;throw new Error(`Invalid Resource: ${B.toString()}`)}async Kb(U){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),x=this.Db.getIgnoredExtensions(B),J=(0,s.$v2b)(U.localExtensions,null,null,U.skippedExtensions,x,U.builtinExtensions),{local:Q,remote:W}=J;return{content:U.localContent,local:Q,remote:W,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:W!==null?2:0}}async Lb(U){const B=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),x=this.Db.getIgnoredExtensions(B),J=U.remoteContent?JSON.parse(U.remoteContent):null;if(J!==null){const Q=(0,s.$v2b)(U.localExtensions,J,U.localExtensions,[],x,U.builtinExtensions),{local:W,remote:Z}=Q;return{content:U.remoteContent,local:W,remote:Z,localChange:W.added.length>0||W.removed.length>0||W.updated.length>0?2:0,remoteChange:Z!==null?2:0}}else return{content:U.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(U,B,x,J){let{skippedExtensions:Q,builtinExtensions:W,localExtensions:Z}=x[0][0];const{local:G,remote:H,localChange:V,remoteChange:ee}=x[0][1];if(V===0&&ee===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),V!==0&&(await this.nb(JSON.stringify(Z)),Q=await this.Bb.updateLocalExtensions(G.added,G.removed,G.updated,Q,this.syncResource.profile)),H){this.O.trace(`${this.D}: Updating remote extensions...`);const ne=JSON.stringify(H.all);U=await this.mb(ne,J?null:U.ref),this.O.info(`${this.D}: Updated remote extensions.${H.added.length?` Added: ${JSON.stringify(H.added.map(se=>se.identifier.id))}.`:""}${H.updated.length?` Updated: ${JSON.stringify(H.updated.map(se=>se.identifier.id))}.`:""}${H.removed.length?` Removed: ${JSON.stringify(H.removed.map(se=>se.identifier.id))}.`:""}`)}B?.ref!==U.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),W=this.Nb(Z,W),await this.fb(U,{skippedExtensions:Q,builtinExtensions:W}),this.O.info(`${this.D}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ne=>ne.identifier.id))}.`:""}`))}Nb(U,B){const x=new Set,J=[];for(const Q of U)x.add(Q.identifier.id.toLowerCase()),Q.installed||J.push(Q.identifier);if(B)for(const Q of B)x.has(Q.id.toLowerCase())||J.push(Q);return J}async resolveContent(U){if(this.h.isEqual(this.zb,U)||this.h.isEqual(this.xb,U)||this.h.isEqual(this.yb,U)||this.h.isEqual(this.Ab,U)){const B=await this.db(U);return B&&this.Ob(JSON.parse(B),!0)}return null}Ob(U,B){return u(U,B)}async hasLocalData(){try{const{localExtensions:U}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(U.some(B=>B.installed||B.disabled))return!0}catch{}return!1}};e.$y2b=p,e.$y2b=p=ye([X(2,C.$Hh),X(3,f.$5j),X(4,m.$Uo),X(5,r.$vgb),X(6,r.$wgb),X(7,d.$1n),X(8,t.$FBb),X(9,r.$Kgb),X(10,$.$7h),X(11,r.$Fgb),X(12,I.$8k),X(13,g.$Sz),X(14,i.$Bk),X(15,a.$7zb),X(16,o.$zh)],p);let D=class{constructor(U,B,x,J,Q,W){this.a=U,this.b=B,this.c=x,this.d=J,this.f=Q,this.g=W}async getLocalExtensions(U){const B=await this.a.getInstalled(void 0,U.extensionsResource),x=this.d.getIgnoredExtensions(B);return{localExtensions:await this.j(U,async(Q,W)=>{const Z=Q.getDisabledExtensions();return B.map(G=>{const{identifier:H,isBuiltin:V,manifest:ee,preRelease:ne,pinned:se,isApplicationScoped:Y}=G,q={identifier:H,preRelease:ne,version:ee.version,pinned:!!se};Y&&!(0,y.$Xl)(ee)&&(q.isApplicationScoped=Y),Z.some(S=>(0,h.$oo)(S,H))&&(q.disabled=!0),V||(q.installed=!0);try{const S=W.getKeysForSync({id:H.id,version:ee.version});if(S){const P=W.getExtensionState(G,!0)||{};q.state=Object.keys(P).reduce((M,T)=>(S.includes(T)&&(M[T]=P[T]),M),{})}}catch(S){this.g.info(`${(0,n.$WAb)("extensions",U)}: Error while parsing extension state`,(0,A.$8)(S))}return q})}),ignoredExtensions:x}}async updateLocalExtensions(U,B,x,J,Q){const W=(0,n.$WAb)("extensions",Q),Z=[],G=new Map,H=[],V=[],ee=await this.a.getInstalled(void 0,Q.extensionsResource);if((U.length||x.length)&&await this.j(Q,async(Y,q)=>{await O.Promises.settled([...U,...x].map(async S=>{const P=ee.find(K=>(0,h.$oo)(K.identifier,S.identifier));if(P&&P.isBuiltin){S.state&&P.manifest.version===S.version&&this.h(S.state,P,P.manifest.version,q),Y.getDisabledExtensions().some(_=>(0,h.$oo)(_,S.identifier))!==!!S.disabled&&(S.disabled?(this.g.trace(`${W}: Disabling extension...`,S.identifier.id),await Y.disableExtension(S.identifier),this.g.info(`${W}: Disabled extension`,S.identifier.id)):(this.g.trace(`${W}: Enabling extension...`,S.identifier.id),await Y.enableExtension(S.identifier),this.g.info(`${W}: Enabled extension`,S.identifier.id))),H.push(S.identifier);return}const M=S.pinned?S.version:void 0,T=(await this.c.getExtensions([{...S.identifier,version:M,preRelease:M?void 0:S.preRelease}],N.CancellationToken.None))[0];if(S.state&&(P?P.manifest.version===S.version:T)&&this.h(S.state,P||T,P?.manifest.version,q),T)try{Y.getDisabledExtensions().some(_=>(0,h.$oo)(_,S.identifier))!==!!S.disabled&&(S.disabled?(this.g.trace(`${W}: Disabling extension...`,S.identifier.id,T.version),await Y.disableExtension(T.identifier),this.g.info(`${W}: Disabled extension`,S.identifier.id,T.version)):(this.g.trace(`${W}: Enabling extension...`,S.identifier.id,T.version),await Y.enableExtension(T.identifier),this.g.info(`${W}: Enabled extension`,S.identifier.id,T.version))),(!P||P.preRelease!==S.preRelease||P.pinned!==S.pinned||M&&P.manifest.version!==M)&&(await this.a.canInstall(T)?(Z.push({extension:T,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:S.pinned&&!!S.version,installPreReleaseVersion:S.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:S.isApplicationScoped,context:{[d.$On]:!0,[d.$Pn]:!0}}}),G.set(T.identifier.id.toLowerCase(),S)):(this.g.info(`${W}: Skipped synchronizing extension because it cannot be installed.`,T.displayName||T.identifier.id),V.push(S)))}catch(K){V.push(S),this.g.error(K),this.g.info(`${W}: Skipped synchronizing extension`,T.displayName||T.identifier.id)}else V.push(S),this.g.info(`${W}: Skipped synchronizing extension because the extension is not found.`,S.identifier.id)}))}),B.length){const Y=ee.filter(({identifier:q,isBuiltin:S})=>!S&&B.some(P=>(0,h.$oo)(q,P)));await O.Promises.settled(Y.map(async q=>{this.g.trace(`${W}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${W}: Uninstalled local extension.`,q.identifier.id),H.push(q.identifier)}))}const ne=await this.a.installGalleryExtensions(Z);for(const{identifier:Y,local:q,error:S,source:P}of ne){const M=P;if(q)this.g.info(`${W}: Installed extension.`,Y.id,M.version),H.push(Y);else{const T=G.get(Y.id.toLowerCase());T&&(V.push(T),this.g.info(`${W}: Skipped synchronizing extension`,M.displayName||M.identifier.id)),S instanceof d.$Zn&&[d.ExtensionManagementErrorCode.Incompatible,d.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(S.code)?this.g.info(`${W}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):S&&this.g.error(S)}}const se=[];for(const Y of J)H.some(q=>(0,h.$oo)(q,Y.identifier))||se.push(Y);for(const Y of V)se.some(q=>(0,h.$oo)(q.identifier,Y.identifier))||se.push(Y);return se}h(U,B,x,J){const Q=J.getExtensionState(B,!0)||{},W=x?J.getKeysForSync({id:B.identifier.id,version:x}):void 0;W?W.forEach(Z=>{Q[Z]=U[Z]}):Object.keys(U).forEach(Z=>Q[Z]=U[Z]),J.setExtensionState(B,Q,!0)}async j(U,B){return this.b.withProfileScopedStorageService(U,async x=>{const J=new R.$ic,Q=this.f.createChild(new l.$yh([m.$Uo,x])),W=J.add(Q.createInstance(E.$szb)),Z=J.add(Q.createInstance(g.$Tz));try{return await B(W,Z)}finally{J.dispose()}})}};e.$z2b=D,e.$z2b=D=ye([X(0,d.$1n),X(1,a.$7zb),X(2,d.$Yn),X(3,t.$FBb),X(4,o.$zh),X(5,r.$Kgb)],D);let F=class extends n.$1Ab{constructor(U,B,x,J,Q,W,Z,G){super("extensions",J,Q,W,x,Z,G),this.p=U,this.q=B}async t(U){return U.syncData?await v(U.syncData,this.p):null}u(U,B){const x=[],J=[],Q=[];for(const W of U){if(this.q.hasToNeverSyncExtension(W.identifier.id))continue;const Z=B.find(G=>(0,h.$oo)(G.identifier,W.identifier));Z?(x.push(Z),W.disabled&&Q.push(W.identifier)):W.installed&&(J.push({...W.identifier,preRelease:!!W.preRelease}),W.disabled&&Q.push(W.identifier))}return{installedExtensions:x,newExtensions:J,disabledExtensions:Q,remoteExtensions:U}}};e.$A2b=F,e.$A2b=F=ye([X(0,d.$1n),X(1,t.$FBb),X(2,f.$5j),X(3,c.$Dk),X(4,C.$Hh),X(5,w.$4i),X(6,m.$Uo),X(7,i.$Bk)],F)}),define(re[116],oe([0,1,14,8,3,34,41,6,32,19,15,12,7,44,20,22,28,39,77,236,25,17,58,4]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m,I,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Ab=e.$6Ab=e.$5Ab=e.$4Ab=e.$3Ab=void 0;const n="globalState.argv.",s=["locale"];function t(p,D){const F=p.storage?Object.keys(p.storage).sort():[],z={};return F.forEach(U=>z[U]=p.storage[U]),p.storage=z,D?(0,j.$rS)(p,{}):JSON.stringify(p)}e.$3Ab=t;const r=1;let a=class extends o.$XAb{constructor(D,F,z,U,B,x,J,Q,W,Z,G,H,V,ee){super({syncResource:"globalState",profile:D},F,U,Q,H,B,x,W,Z,J,G,V),this.Bb=z,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:m.$Mgb,authority:"base"}),this.xb=this.vb.with({scheme:m.$Mgb,authority:"local"}),this.yb=this.vb.with({scheme:m.$Mgb,authority:"remote"}),this.zb=this.vb.with({scheme:m.$Mgb,authority:"accepted"}),this.Ab=ee.createInstance(v),this.B(U.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(U.onDidFilesChange,ne=>ne.contains(this.H.argvResource)),A.Event.filter(z.onDidChange,ne=>!!(ne.targetChanges.some(se=>this.syncResource.profile.id===se.id)||ne.valueChanges.some(({profile:se,changes:Y})=>this.syncResource.profile.id===se.id&&Y.some(q=>q.target===0)))))(()=>this.Q()))}async qb(D,F,z){const U=D.syncData?JSON.parse(D.syncData.content):null;F=F===null&&z?D:F;const B=F&&F.syncData?JSON.parse(F.syncData.content):null,x=await this.Ab.getLocalGlobalState(this.syncResource.profile);U?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Jb(B),{local:Q,remote:W}=(0,w.$2Ab)(x.storage,U?U.storage:null,B?B.storage:null,J,this.O),Z={content:null,local:Q,remote:W,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:W.all!==null?2:0},G=t(x,!1);return[{baseResource:this.wb,baseContent:B?t(B,!1):G,localResource:this.xb,localContent:G,localUserData:x,remoteResource:this.yb,remoteContent:U?t(U,!1):null,previewResource:this.vb,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.zb,storageKeys:J}]}async ub(D){const F=D.syncData?JSON.parse(D.syncData.content):null;if(F===null)return!0;const z=await this.Ab.getLocalGlobalState(this.syncResource.profile),U=await this.Jb(F),{remote:B}=(0,w.$2Ab)(z.storage,F.storage,F.storage,U,this.O);return B.all!==null}async rb(D,F){return{...D.previewResult,hasConflicts:!1}}async sb(D,F,z,U){if(this.h.isEqual(F,this.xb))return this.Gb(D);if(this.h.isEqual(F,this.yb))return this.Hb(D);if(this.h.isEqual(F,this.vb))return D.previewResult;throw new Error(`Invalid Resource: ${F.toString()}`)}async Gb(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async Hb(D){if(D.remoteContent!==null){const F=JSON.parse(D.remoteContent),{local:z,remote:U}=(0,w.$2Ab)(D.localUserData.storage,F.storage,null,D.storageKeys,this.O);return{content:D.remoteContent,local:z,remote:U,localChange:Object.keys(z.added).length>0||Object.keys(z.updated).length>0||z.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(D,F,z,U){const{localUserData:B}=z[0][0],{local:x,remote:J,localChange:Q,remoteChange:W}=z[0][1];if(Q===0&&W===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Q!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(B)),await this.Ab.writeLocalGlobalState(x,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),W!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Z=JSON.stringify({storage:J.all});D=await this.mb(Z,U?null:D.ref),this.O.info(`${this.D}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}F?.ref!==D.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(D),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(D){if(this.h.isEqual(this.yb,D)||this.h.isEqual(this.wb,D)||this.h.isEqual(this.xb,D)||this.h.isEqual(this.zb,D)){const F=await this.db(D);return F&&t(JSON.parse(F),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(D){const F=await this.Bb.readStorageData(this.syncResource.profile),z=[],U=[];for(const[J,Q]of F)Q.target===0?z.push(J):Q.target===1&&U.push(J);const B=[...z,...U],x=D?.storage?Object.keys(D.storage).filter(J=>!J.startsWith(n)&&!B.includes(J)&&F.get(J)!==void 0):[];if(!R.$o){const J=[...m.$rgb.map(Q=>(0,m.$Egb)(Q)),m.$Dgb];x.push(...J),U.push(...J)}return{user:z,machine:U,unregistered:x}}};e.$4Ab=a,e.$4Ab=a=ye([X(2,i.$7zb),X(3,E.$5j),X(4,m.$vgb),X(5,m.$wgb),X(6,m.$Kgb),X(7,C.$Hh),X(8,m.$Fgb),X(9,y.$8k),X(10,$.$7h),X(11,g.$Uo),X(12,f.$Bk),X(13,c.$zh)],a);let v=class{constructor(D,F,z,U){this.a=D,this.b=F,this.c=z,this.d=U}async getLocalGlobalState(D){const F={};if(D.isDefault){const U=await this.f(),B=(0,L.$Km)(U);for(const x of s)B[x]!==void 0&&(F[`${n}${x}`]={version:1,value:B[x]})}const z=await this.c.readStorageData(D);for(const[U,B]of z)B.value&&B.target===0&&(F[U]={version:1,value:B.value});return{storage:F}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const D=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),D.value.toString()}catch(D){this.d.debug((0,N.$8)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:F,updated:z},U){const B=(0,o.$WAb)("globalState",U),x={},J=new Map,Q=await this.c.readStorageData(U),W=(Z,G)=>{for(const H of Z){if(H.startsWith(n)){x[H.substring(n.length)]=G?G[H].value:void 0;continue}if(G){const V=G[H];V.value!==Q.get(H)?.value&&J.set(H,V.value)}else Q.get(H)!==void 0&&J.set(H,void 0)}};if(W(Object.keys(D),D),W(Object.keys(z),z),W(F),Object.keys(x).length){this.d.trace(`${B}: Updating locale...`);const Z=await this.f();let G=Z;for(const H of Object.keys(x))G=(0,l.edit)(G,[H],x[H],{});Z!==G&&(this.d.trace(`${B}: Updating locale...`),await this.a.writeFile(this.b.argvResource,O.$Ed.fromString(G)),this.d.info(`${B}: Updated locale.`)),this.d.info(`${B}: Updated locale`)}J.size&&(this.d.trace(`${B}: Updating global state...`),await this.c.updateStorageData(U,J,0),this.d.info(`${B}: Updated global state`,[...J.keys()]))}};e.$5Ab=v,e.$5Ab=v=ye([X(0,E.$5j),X(1,C.$Hh),X(2,i.$7zb),X(3,m.$Kgb)],v);let b=class extends o.$1Ab{constructor(D,F,z,U,B,x){super("globalState",z,U,B,F,D,x)}async o(D){const F=D.syncData?JSON.parse(D.syncData.content):null;if(!F){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const z={},U={};for(const B of Object.keys(F.storage))B.startsWith(n)?z[B.substring(n.length)]=F.storage[B].value:this.l.get(B,0)===void 0&&(U[B]=F.storage[B].value);if(Object.keys(z).length){let B="{}";try{B=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const x of Object.keys(z))B=(0,l.edit)(B,[x],z[x],{});await this.k.writeFile(this.h.argvResource,O.$Ed.fromString(B))}if(Object.keys(U).length){const B=[];for(const x of Object.keys(U))B.push({key:x,value:U[x],scope:0,target:0});this.l.storeAll(B,!0)}}};e.$6Ab=b,e.$6Ab=b=ye([X(0,g.$Uo),X(1,E.$5j),X(2,I.$Dk),X(3,C.$Hh),X(4,m.$Kgb),X(5,f.$Bk)],b);let u=class{constructor(D,F,z,U,B){this.a=D,this.b=F,this.c=z,this.d=U,this.f=B}getSyncStoreType(D){return this.h(D)?.storage[m.$Dgb]?.value}async sync(D){const F=(0,m.$zgb)((0,k.$3f)());try{return await this.g(D,F)}catch(z){if(z instanceof m.$Agb)switch(z.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(D,F)}throw z}}async g(D,F){const z=await this.a.readResource("globalState",null,void 0,F),U=this.h(z)||{storage:{}};U.storage[m.$Dgb]={value:D,version:r};const B=await(0,h.$1o)(this.c,this.d,this.b),x={version:r,machineId:B,content:t(U,!1)};await this.a.writeResource("globalState",JSON.stringify(x),z.ref,void 0,F)}h({content:D}){if(!D)return null;const F=JSON.parse(D);if((0,o.$VAb)(F))return F?JSON.parse(F.content):null;throw new Error("Invalid remote data")}};e.$7Ab=u,e.$7Ab=u=ye([X(1,g.$Uo),X(2,C.$Hh),X(3,E.$5j),X(4,d.$4i)],u)}),define(re[117],oe([0,1,18,14,3,34,6,9,171,19,15,12,20,22,28,17,39,233,25]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E2b=e.$D2b=e.$C2b=void 0;function w(i,c,n){try{const s=JSON.parse(i);if(!c)return(0,R.$pf)(s.all)?null:s.all;switch(j.OS){case 2:return(0,R.$pf)(s.mac)?null:s.mac;case 3:return(0,R.$pf)(s.linux)?null:s.linux;case 1:return(0,R.$pf)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.$C2b=w;let m=class extends f.$ZAb{constructor(c,n,s,t,r,a,v,b,u,p,D,F,z){super(c.keybindingsResource,{syncResource:"keybindings",profile:c},n,b,u,p,s,t,v,F,r,D,a,z),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:l.$Mgb,authority:"base"}),this.Gb=this.Eb.with({scheme:l.$Mgb,authority:"local"}),this.Hb=this.Eb.with({scheme:l.$Mgb,authority:"remote"}),this.Ib=this.Eb.with({scheme:l.$Mgb,authority:"accepted"}),this.B(A.Event.filter(a.onDidChangeConfiguration,U=>U.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(c,n,s,t){const r=c.syncData?w(c.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?c:n;const a=n?this.Ob(n):null,v=await this.vb(),b=await this.Cb();let u=null,p=!1,D=!1,F=!1;if(r){let B=v?v.value.toString():"[]";if(B=B||"[]",this.Ab(B,!0))throw new l.$Agb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==B||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const x=await(0,o.$B2b)(B,r,a,b,this.zb);x.hasChanges&&(u=x.mergeContent,F=x.hasConflicts,p=F||x.mergeContent!==B,D=F||x.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=v.value.toString(),D=!0);const z={content:F?a:u,localChange:p?v?2:1:0,remoteChange:D?2:0,hasConflicts:F},U=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:U,localChange:z.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:z.remoteChange,previewResource:this.Eb,previewResult:z,acceptedResource:this.Ib}]}async ub(c){const n=this.Ob(c);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,o.$B2b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(c,n){return c.previewResult}async sb(c,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(c,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:v,remoteChange:b}=s[0][1];if(v===0&&b===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new l.$Agb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),b!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const u=this.Pb(a||"[]",c.syncData?.content);c=await this.mb(u,t?null:c.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==c.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(c,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.vb();if(c){const n=(0,L.$Km)(c.value.toString());if((0,O.$Ib)(n))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async resolveContent(c){return this.h.isEqual(this.Hb,c)||this.h.isEqual(this.Fb,c)||this.h.isEqual(this.Gb,c)||this.h.isEqual(this.Ib,c)?this.db(c):null}Ob(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.Qb()?null:w(c.syncData.content,this.Qb(),this.O)}Pb(c,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=c,j.OS){case 2:s.mac=c;break;case 3:s.linux=c;break;case 1:s.windows=c;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(l.$ogb)}};e.$D2b=m,e.$D2b=m=ye([X(2,l.$vgb),X(3,l.$wgb),X(4,l.$Kgb),X(5,$.$7h),X(6,l.$Fgb),X(7,E.$5j),X(8,C.$Hh),X(9,d.$Uo),X(10,l.$Jgb),X(11,h.$8k),X(12,g.$Bk)],m);let I=class extends f.$1Ab{constructor(c,n,s,t,r,a){super("keybindings",n,s,t,c,r,a)}async o(c){const n=c.syncData?this.p(c.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Ed.fromString(n)),await this.n(c)}async i(){try{const c=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,L.$Km)(c.value.toString());return!(0,O.$Ib)(n)}catch(c){return c.fileOperationResult===1}}p(c){try{return w(c,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$E2b=I,e.$E2b=I=ye([X(0,E.$5j),X(1,y.$Dk),X(2,C.$Hh),X(3,l.$Kgb),X(4,d.$Uo),X(5,g.$Bk)],I)}),define(re[118],oe([0,1,14,3,172,19,73,15,29,12,20,22,28,17,39,237,25]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H2b=e.$G2b=e.$F2b=void 0;function o(I){return I&&I.settings&&typeof I.settings=="string"&&Object.keys(I).length===1}function l(I){const i=JSON.parse(I);return o(i)?i:{settings:I}}e.$F2b=l;let w=class extends g.$ZAb{constructor(i,c,n,s,t,r,a,v,b,u,p,D,F,z){super(i.settingsResource,{syncResource:"settings",profile:i},c,n,s,t,r,a,p,D,v,b,u,z),this.Eb=F,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:f.$Mgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:f.$Mgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:f.$Mgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:f.$Mgb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const c=await this.getLastSyncUserData(),n=await this.X(i,c),s=this.Lb(n),t=new j.$qn(f.$ngb);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(f.$ngb)||{}}async qb(i,c,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);c=c===null&&n?i:c;const a=c?this.Lb(c):null,v=await this.Pb();let b=null,u=!1,p=!1,D=!1;if(r){let B=s?s.value.toString().trim():"{}";B=B||"{}",this.Qb(B),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const x=(0,y.$Nzb)(B,r.settings,a?a.settings:null,v,[],t);b=x.localContent||x.remoteContent,u=x.localContent!==null,p=x.remoteContent!==null,D=x.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),b=s.value.toString().trim()||"{}",this.Qb(b),p=!0);const F=s?s.value.toString():null,z=a?.settings??null,U={content:D?z:b,localChange:u?2:0,remoteChange:p?2:0,hasConflicts:D};return[{fileContent:s,baseResource:this.baseResource,baseContent:z,localResource:this.localResource,localContent:F,localChange:U.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:U.remoteChange,previewResource:this.previewResource,previewResult:U,acceptedResource:this.acceptedResource}]}async ub(i){const c=this.Lb(i);if(c===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,y.$Nzb)(s||"{}",c.settings,c.settings,t,[],r).remoteContent!==null}async rb(i,c){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,y.$Mzb)(i.previewResult.content,"{}",s,n):null}}async sb(i,c,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(c,this.localResource))return{content:i.fileContent?(0,y.$Mzb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(c,this.remoteResource))return{content:i.remoteContent!==null?(0,y.$Mzb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(c,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,y.$Mzb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(i,c,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:v}=n[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const b=await this.Cb(),u=this.Lb(i),p=await this.Pb(r);r=(0,y.$Mzb)(r,u?u.settings:"{}",p,b),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}c?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,y.$Ozb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let c=await super.db(i);if(c){const n=await this.Cb(),s=await this.Pb();c=(0,y.$Mzb)(c,"{}",s,n)}return c}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return l(i)}catch(c){this.O.error(c)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const c=await this.Ob;return(0,y.$Kzb)(c,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new f.$Agb((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$G2b=w,e.$G2b=w=ye([X(2,$.$5j),X(3,R.$Hh),X(4,C.$Uo),X(5,f.$vgb),X(6,f.$wgb),X(7,f.$Kgb),X(8,f.$Jgb),X(9,L.$7h),X(10,f.$Fgb),X(11,E.$8k),X(12,k.$1n),X(13,d.$Bk)],w);let m=class extends g.$1Ab{constructor(i,c,n,s,t,r){super("settings",c,n,s,i,t,r)}async o(i){const c=i.syncData?this.p(i.syncData.content):null;if(!c){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,O.$Ed.fromString(c.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,y.$Ozb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return l(i)}catch(c){this.j.error(c)}return null}};e.$H2b=m,e.$H2b=m=ye([X(0,$.$5j),X(1,h.$Dk),X(2,R.$Hh),X(3,f.$Kgb),X(4,C.$Uo),X(5,d.$Bk)],m)}),define(re[119],oe([0,1,14,3,30,19,15,12,20,22,28,17,39,234,25]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M2b=e.$L2b=e.$K2b=void 0;function y(l){return JSON.parse(l.content)}e.$K2b=y;let f=class extends d.$XAb{constructor(w,m,I,i,c,n,s,t,r,a,v,b){super({syncResource:"snippets",profile:w},m,i,I,c,n,s,a,v,t,r,b),this.pb=1,this.vb=w.snippetsHome,this.B(this.G.watch(I.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,u=>u.affects(this.vb))(()=>this.Q()))}async qb(w,m,I){const i=await this.Hb(),c=this.Gb(i),n=w.syncData?this.Fb(w.syncData):null;m=m===null&&I?w:m;const s=m&&m.syncData?this.Fb(m.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,h.$I2b)(c,n,s);return this.Bb(t,i,n||{},s||{})}async ub(w){const m=w.syncData?this.Fb(w.syncData):null;if(m===null)return!0;const I=await this.Hb(),i=this.Gb(I),c=(0,h.$I2b)(i,m,m);return Object.keys(c.remote.added).length>0||Object.keys(c.remote.updated).length>0||c.remote.removed.length>0||c.conflicts.length>0}async rb(w,m){return w.previewResult}async sb(w,m,I,i){if(this.h.isEqualOrParent(m,this.g.with({scheme:g.$Mgb,authority:"local"})))return{content:w.fileContent?w.fileContent.value.toString():null,localChange:0,remoteChange:w.fileContent?w.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(m,this.g.with({scheme:g.$Mgb,authority:"remote"})))return{content:w.remoteContent,localChange:w.remoteContent!==null?w.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(m,this.g))return I===void 0?{content:w.previewResult.content,localChange:w.previewResult.localChange,remoteChange:w.previewResult.remoteChange}:{content:I,localChange:I===null?w.fileContent!==null?3:0:2,remoteChange:I===null?w.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${m.toString()}`)}async tb(w,m,I,i){const c=I.map(([n,s])=>({...n,acceptResult:s}));c.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),c.some(({localChange:n})=>n!==0)&&(await this.Cb(c),await this.Db(c,i)),c.some(({remoteChange:n})=>n!==0)&&(w=await this.Eb(c,w,i)),m?.ref!==w.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(w),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of c)try{await this.G.del(n)}catch{}}Bb(w,m,I,i){const c=new Map;for(const n of Object.keys(w.local.added)){const s={content:w.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:I[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"accepted"})})}for(const n of Object.keys(w.local.updated)){const s={content:w.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=m[n]?m[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:I[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"accepted"})})}for(const n of w.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=m[n]?m[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"accepted"})})}for(const n of Object.keys(w.remote.added)){const s={content:w.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=m[n]?m[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"accepted"})})}for(const n of Object.keys(w.remote.updated)){const s={content:w.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=m[n]?m[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"local"}),fileContent:m[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:I[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"accepted"})})}for(const n of w.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:I[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"accepted"})})}for(const n of w.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:m[n]?2:1,remoteChange:I[n]?2:1},t=m[n]?m[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:I[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"accepted"})})}for(const n of Object.keys(m))if(!c.has(n)){const s={content:m[n]?m[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=m[n]?m[n].value.toString():null;c.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"local"}),fileContent:m[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"remote"}),remoteContent:I[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:g.$Mgb,authority:"accepted"})})}return[...c.values()]}async resolveContent(w){return this.h.isEqualOrParent(w,this.g.with({scheme:g.$Mgb,authority:"remote"}))||this.h.isEqualOrParent(w,this.g.with({scheme:g.$Mgb,authority:"local"}))||this.h.isEqualOrParent(w,this.g.with({scheme:g.$Mgb,authority:"base"}))||this.h.isEqualOrParent(w,this.g.with({scheme:g.$Mgb,authority:"accepted"}))?this.db(w):null}async hasLocalData(){try{const w=await this.Hb();if(Object.keys(w).length)return!0}catch{}return!1}async Cb(w){const m={};for(const I of w)I.fileContent&&(m[this.h.basename(I.localResource)]=I.fileContent);await this.nb(JSON.stringify(this.Gb(m)))}async Db(w,m){for(const{fileContent:I,acceptResult:i,localResource:c,remoteResource:n,localChange:s}of w)if(s!==0){const t=n?this.h.basename(n):this.h.basename(c),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,O.$Ed.fromString(i.content),{overwrite:m}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,O.$Ed.fromString(i.content),m?void 0:I),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(w,m,I){const i=m.syncData?this.Fb(m.syncData):{},c=(0,A.$Um)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of w)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete c[a]:c[a]=n.content}return(0,h.$J2b)(i,c)||(this.O.trace(`${this.D}: Updating remote snippets...`),m=await this.mb(JSON.stringify(c),I?null:m.ref),this.O.info(`${this.D}: Updated remote snippets`)),m}Fb(w){return y(w)}Gb(w){const m={};for(const I of Object.keys(w))m[I]=w[I].value.toString();return m}async Hb(){const w={};let m;try{m=await this.G.resolve(this.vb)}catch(I){if(I instanceof R.$mk&&I.fileOperationResult===1)return w;throw I}for(const I of m.children||[]){const i=I.resource,c=this.h.extname(i);if(c===".json"||c===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);w[n]=s}}return w}};e.$L2b=f,e.$L2b=f=ye([X(2,j.$Hh),X(3,R.$5j),X(4,k.$Uo),X(5,g.$vgb),X(6,g.$wgb),X(7,g.$Kgb),X(8,L.$7h),X(9,g.$Fgb),X(10,$.$8k),X(11,C.$Bk)],f);let o=class extends d.$1Ab{constructor(w,m,I,i,c,n){super("snippets",m,I,i,w,c,n)}async o(w){const m=w.syncData?JSON.parse(w.syncData.content):null;if(!m){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(m)){const c=m[i];if(c){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,O.$Ed.fromString(c)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(w)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(w){return w.fileOperationResult===1}}};e.$M2b=o,e.$M2b=o=ye([X(0,R.$5j),X(1,E.$Dk),X(2,j.$Hh),X(3,g.$Kgb),X(4,k.$Uo),X(5,C.$Bk)],o)}),define(re[120],oe([0,1,14,19,15,12,20,22,28,17,39,25]),function(te,e,O,N,A,L,j,R,k,$,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P2b=e.$O2b=e.$N2b=void 0;function d(f,o){try{return JSON.parse(f).tasks??null}catch(l){return o.error(l),null}}e.$N2b=d;let h=class extends C.$YAb{constructor(o,l,w,m,I,i,c,n,s,t,r,a){super(o.tasksResource,{syncResource:"tasks",profile:o},l,n,s,t,w,m,c,r,I,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:E.$Mgb,authority:"base"}),this.Cb=this.Ab.with({scheme:E.$Mgb,authority:"local"}),this.Db=this.Ab.with({scheme:E.$Mgb,authority:"remote"}),this.Eb=this.Ab.with({scheme:E.$Mgb,authority:"accepted"})}async qb(o,l,w,m){const I=o.syncData?d(o.syncData.content,this.O):null;l=l===null&&w?o:l;const i=l?.syncData?d(l.syncData.content,this.O):null,c=await this.vb();let n=null,s=!1,t=!1,r=!1;if(o.syncData){const b=c?c.value.toString():null;if(!i||i!==b||i!==I){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const u=y(b,I,i);n=u.content,r=u.hasConflicts,s=u.hasLocalChanged,t=u.hasRemoteChanged}}else c&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=c.value.toString(),t=!0);const a={content:r?i:n,localChange:s?c?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=c?c.value.toString():null;return[{fileContent:c,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:I,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(o){const l=o?.syncData?d(o.syncData.content,this.O):null;if(l===null)return!0;const w=await this.vb(),m=w?w.value.toString():null,I=y(m,l,l);return I.hasLocalChanged||I.hasRemoteChanged}async rb(o,l){return o.previewResult}async sb(o,l,w,m){if(this.h.isEqual(l,this.Cb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(l,this.Db))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(l,this.Ab))return w===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:w,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${l.toString()}`)}async tb(o,l,w,m){const{fileContent:I}=w[0][0],{content:i,localChange:c,remoteChange:n}=w[0][1];if(c===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),c!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),I&&await this.nb(JSON.stringify(this.Kb(I.value.toString()))),i?await this.wb(i,I,m):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));o=await this.mb(s,m?null:o.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}l?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(o),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(o){return this.h.isEqual(this.Db,o)||this.h.isEqual(this.Bb,o)||this.h.isEqual(this.Cb,o)||this.h.isEqual(this.Eb,o)?this.db(o):null}Kb(o){return o?{tasks:o}:{}}};e.$O2b=h,e.$O2b=h=ye([X(2,E.$vgb),X(3,E.$wgb),X(4,E.$Kgb),X(5,N.$7h),X(6,E.$Fgb),X(7,L.$5j),X(8,A.$Hh),X(9,j.$Uo),X(10,R.$8k),X(11,k.$Bk)],h);let g=class extends C.$1Ab{constructor(o,l,w,m,I,i){super("tasks",l,w,m,o,I,i),this.c=this.g.defaultProfile.tasksResource}async o(o){const l=o.syncData?d(o.syncData.content,this.j):null;if(!l){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,O.$Ed.fromString(l)),await this.n(o)}async p(){return this.k.exists(this.c)}};e.$P2b=g,e.$P2b=g=ye([X(0,L.$5j),X(1,$.$Dk),X(2,A.$Hh),X(3,E.$Kgb),X(4,j.$Uo),X(5,k.$Bk)],g);function y(f,o,l){if(f===null&&o===null&&l===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(f===o)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const w=l!==f,m=l!==o;return!w&&!m?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:w&&!m?{content:f,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:m&&!w?{content:o,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:f,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[121],oe([0,1,41,19,15,12,20,22,28,17,39,235,25]),function(te,e,O,N,A,L,j,R,k,$,C,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t4b=e.$s4b=e.$r4b=void 0;let h=class extends C.$XAb{constructor(o,l,w,m,I,i,c,n,s,t,r,a,v){super({syncResource:"profiles",profile:o},l,m,I,i,c,n,r,a,s,t,v),this.vb=w,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:d.$Mgb,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.$Mgb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.$Mgb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.$Mgb,authority:"accepted"}),this.B(w.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const o=await this.getLastSyncUserData();return o?.syncData?y(o.syncData):null}async getRemoteSyncedProfiles(o){const l=await this.getLastSyncUserData(),w=await this.X(o,l);return w?.syncData?y(w.syncData):null}async qb(o,l,w){if(!this.vb.isEnabled())throw new d.$Agb("Cannot sync profiles because they are disabled","LocalError");const m=o.syncData?y(o.syncData):null,I=l?.syncData?y(l.syncData):null,i=this.Db(),{local:c,remote:n}=(0,E.$q4b)(i,m,I,[]),s={local:c,remote:n,content:I?this.Eb(I):null,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:n!==null?2:0},t=g(i,!1);return[{baseResource:this.baseResource,baseContent:I?this.Eb(I):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:m?this.Eb(m):null,remoteProfiles:m,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(o){const l=o?.syncData?y(o.syncData):null,w=this.Db(),{remote:m}=(0,E.$q4b)(w,l,l,[]);return!!m?.added.length||!!m?.removed.length||!!m?.updated.length}async rb(o,l){return{...o.previewResult,hasConflicts:!1}}async sb(o,l,w,m){if(this.h.isEqual(l,this.localResource))return this.Ab(o);if(this.h.isEqual(l,this.remoteResource))return this.Bb(o);if(this.h.isEqual(l,this.previewResource))return o.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async Ab(o){const l=this.Db(),w=(0,E.$q4b)(l,null,null,[]),{local:m,remote:I}=w;return{content:o.localContent,local:m,remote:I,localChange:m.added.length>0||m.removed.length>0||m.updated.length>0?2:0,remoteChange:I!==null?2:0}}async Bb(o){const l=o.remoteContent?JSON.parse(o.remoteContent):null,w=[],m=[];for(const I of this.Db()){const i=l?.find(c=>c.id===I.id);i&&(w.push({id:I.id,name:I.name,collection:i.collection}),m.push(I))}if(l!==null){const I=(0,E.$q4b)(m,l,w,[]),{local:i,remote:c}=I;return{content:o.remoteContent,local:i,remote:c,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:c!==null?2:0}}else return{content:o.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(o,l,w,m){const{local:I,remote:i,localChange:c,remoteChange:n}=w[0][1];c===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=w[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new d.$Agb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(c!==0){await this.nb(g(this.Db(),!1));const t=[];for(const r of I.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of I.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of I.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),s.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:v})=>a.id===v),1);for(const a of i?.updated||[]){const v=s.find(({id:b})=>a.id===b);v&&s.splice(s.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}try{o=await this.updateRemoteProfiles(s,m?null:o.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}l?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(o),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(o,l){return this.mb(this.Eb(o),l)}async hasLocalData(){return this.Db().length>0}async resolveContent(o){if(this.h.isEqual(this.remoteResource,o)||this.h.isEqual(this.baseResource,o)||this.h.isEqual(this.localResource,o)||this.h.isEqual(this.acceptedResource,o)){const l=await this.db(o);return l&&(0,O.$rS)(JSON.parse(l),{})}return null}Db(){return this.vb.profiles.filter(o=>!o.isDefault&&!o.isTransient)}Eb(o){return JSON.stringify([...o].sort((l,w)=>l.name.localeCompare(w.name)))}};e.$r4b=h,e.$r4b=h=ye([X(2,$.$Dk),X(3,L.$5j),X(4,A.$Hh),X(5,j.$Uo),X(6,d.$vgb),X(7,d.$wgb),X(8,d.$Kgb),X(9,N.$7h),X(10,d.$Fgb),X(11,R.$8k),X(12,k.$Bk)],h);function g(f,o){const l=[...f].sort((w,m)=>w.name.localeCompare(m.name)).map(w=>({id:w.id,name:w.name}));return o?(0,O.$rS)(l,{}):JSON.stringify(l)}e.$s4b=g;function y(f){return JSON.parse(f.content)}e.$t4b=y}),define(re[253],oe([0,1,3,2,6,15,20,22,25]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e4b=void 0;const $="sync.enable";let C=class extends N.$jc{constructor(d,h,g,y){super(),this.c=d,this.f=h,this.g=g,this.h=y,this.a=new O.$ed,this.onDidChangeEnablement=this.a.event,this.b=new O.$ed,this.onDidChangeResourceEnablement=this.b.event,this.B(d.onDidChangeValue(-1,void 0,this.B(new N.$ic))(f=>this.m(f)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean($,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||(this.f.publicLog2($,{enabled:d}),this.c.store($,d,-1,1))}isResourceEnabled(d){return this.c.getBoolean((0,k.$Egb)(d),-1,!0)}setResourceEnablement(d,h){if(this.isResourceEnabled(d)!==h){const g=(0,k.$Egb)(d);this.j(g,h)}}getResourceSyncStateVersion(d){}j(d,h){this.c.store(d,h,-1,A.$o?0:1)}m(d){if($===d.key){this.a.fire(this.isEnabled());return}const h=k.$rgb.filter(g=>(0,k.$Egb)(g)===d.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$e4b=C,e.$e4b=C=ye([X(0,j.$Uo),X(1,R.$8k),X(2,L.$Hh),X(3,k.$ugb)],C)}),define(re[254],oe([0,1,5,14,62,2,21,19,15,12,17,25]),function(te,e,O,N,A,L,j,R,k,$,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p4b=void 0;let d=class extends L.$jc{constructor(g,y,f,o,l){super(),this.a=g,this.b=y,this.c=f,this.f=o,this.g=l,this.h()}async h(){for(const y of this.g.profiles)for(const f of E.$rgb)try{await this.m(this.j(f,y.isDefault?void 0:y.id))}catch(o){this.f.error(o)}let g;try{g=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,$.$ik)(y)!==1&&this.f.error(y);return}if(g.children){for(const y of g.children)if(y.isDirectory&&!this.g.profiles.some(f=>f.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(f){this.f.error(f)}}}async getAllResourceRefs(g,y,f){const o=this.j(g,y,f);try{const l=await this.b.resolve(o);if(l.children)return l.children.filter(m=>m.isFile&&!m.name.startsWith("lastSync")).sort().reverse().map(m=>({ref:m.name,created:this.n(m)}))}catch(l){if((0,$.$ik)(l)!==1)throw l}return[]}async resolveResourceContent(g,y,f,o){const l=this.j(g,f,o),w=(0,j.$hg)(l,y);try{return(await this.b.readFile(w)).value.toString()}catch(m){return this.f.error(m),null}}async writeResource(g,y,f,o,l){const w=this.j(g,o,l),m=(0,j.$hg)(w,`${(0,A.$6l)(f).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(m,N.$Ed.fromString(y))}catch(I){this.f.error(I)}}j(g,y,f=this.a.userDataSyncHome){return(0,j.$hg)(f,...y?[y,g]:[g])}async m(g){try{try{if(!await this.b.exists(g))return}catch{return}const y=await this.b.resolve(g);if(y.children){const f=y.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort(),o=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let l=f.filter(m=>Date.now()-this.n(m)>o);const w=f.length-l.length;w<10&&(l=l.slice(10-w)),await O.Promises.settled(l.map(async m=>{this.f.info("Deleting from backup",m.resource.path),await this.b.del(m.resource)}))}}catch(y){this.f.error(y)}}n(g){return new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};e.$p4b=d,e.$p4b=d=ye([X(0,k.$Hh),X(1,$.$5j),X(2,R.$7h),X(3,E.$Kgb),X(4,C.$Dk)],d)}),define(re[81],oe([0,1,3,2,6,27,176,15,12,4,24,44,20,25]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$kgb=e.$jgb=e.$igb=void 0,e.$igb=(0,$.$Ah)("IUserDataSyncMachinesService");const y="sync.currentMachineName",f="Safari",o="Chrome",l="Edge",w="Firefox",m="Android";function I(n){switch(n){case f:case o:case l:case w:case m:case(0,A.$h)(0):return!0}return!1}e.$jgb=I;function i(){return A.$F?f:A.$D?o:A.$G?l:A.$E?w:A.$H?m:(0,A.$h)(A.$o?0:A.$t)}let c=class extends N.$jc{static{g=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,v,b){super(),this.h=r,this.j=a,this.m=v,this.n=b,this.c=this.B(new O.$ed),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$1o)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),v=a.machines.find(({id:b})=>b===s);if(v){v.name=t,await this.t(a);const b=await this.f;s===b&&this.h.store(y,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const v=t.machines.find(b=>b.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(y,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,L.$pe)(r)}\\s#(\\d+)`);let v=0;for(const b of s){const u=a.exec(b.name),p=u?parseInt(u[1]):0;v=p>v?p:v}return`${r} #${v+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==g.a)throw new Error((0,j.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource(g.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[g.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource(g.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:g.a,machines:[]}}};e.$kgb=c,e.$kgb=c=g=ye([X(0,R.$Hh),X(1,k.$5j),X(2,d.$Uo),X(3,h.$vgb),X(4,h.$Kgb),X(5,C.$jj)],c)}),define(re[255],oe([0,1,5,62,38,8,3,2,6,21,11,173,24,20,22,25,78,81]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v4b=void 0;const l="sync.disableMachineEventually",w="sync.sessionId",m="sync.storeUrl",I="sync.productQuality";let i=class extends R.$jc{get n(){const s=this.H.get(m,-1);return s?C.URI.parse(s):void 0}set n(s){s?this.H.store(m,s.toString(),-1,1):this.H.remove(m,-1)}get s(){return this.H.get(I,-1)}set s(s){s?this.H.store(I,s,-1,1):this.H.remove(I,-1)}constructor(s,t,r,a,v,b,u,p,D,F){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=b,this.D=u,this.F=p,this.G=D,this.H=F,this.a=this.B(new R.$kc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new j.$ed),this.onError=this.h.event,this.S=[],this.f=this.B(new O.$Dg(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,$.$ag)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(u.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(z=>this.triggerSync([z],!1,!1))),this.B(j.Event.filter(this.y.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new c(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$6l)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(w,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=y.$Agb.toUserDataSyncError(s);t instanceof y.$Cgb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(l,!0,-1,1),await(0,O.$Gg)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(l,-1,!1)}R(){this.H.remove(l,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$v4b=i,e.$v4b=i=ye([X(0,d.$jj),X(1,y.$ugb),X(2,y.$vgb),X(3,y.$Fgb),X(4,y.$Ggb),X(5,y.$Kgb),X(6,f.$uzb),X(7,g.$8k),X(8,o.$igb),X(9,h.$Uo)],i);class c extends R.$jc{static{this.a="Interval"}constructor(s,t,r,a,v,b,u,p,D){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=v,this.w=b,this.y=u,this.z=p,this.C=D,this.b=this.B(new R.$kc),this.c=this.B(new j.$ed),this.onDidStartSync=this.c.event,this.f=this.B(new j.$ed),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$hc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(c.a,!1)}D(){this.b.value=(0,O.$Hg)(()=>this.sync(c.a,!1),this.n)}sync(s,t){const r=(0,O.$tg)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,L.$2)(v))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,$.$ag)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,$.$ag)(t.defaultUrl,s.defaultUrl)||!(0,$.$ag)(t.insidersUrl,s.insidersUrl)||!(0,$.$ag)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,y.$Agb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(b){this.y.error(b),a=b}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new y.$Cgb((0,E.localize)(0,null),"DefaultServiceChanged"):new y.$Cgb((0,E.localize)(1,null),"ServiceChanged"):new y.$Cgb((0,E.localize)(2,null),"TurnedOff");const r=this.C.get(w,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new y.$Cgb((0,E.localize)(3,null),"DefaultServiceChanged"):new y.$Cgb((0,E.localize)(4,null),"ServiceChanged"):new y.$Cgb((0,E.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(u=>u.isCurrent);if(v?.disabled)throw new y.$Cgb((0,E.localize)(6,null),"TurnedOff");const b=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-b}),this.g===null)try{this.g=await this.s.manifest(null)}catch(u){throw new y.$Cgb((0,A.$li)(u),u instanceof y.$Agb?u.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(w,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(re[256],oe([0,1,11,177,15,12,44,20,28,25,17,39,119,118,117,19,120,115,116,4,121,41,27]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m,I,i){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$74b=void 0;let n=class{static{c=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,b,u,p,D,F,z){this.e=t,this.f=r,this.g=a,this.h=b,this.i=u,this.j=p,this.k=D,this.l=F,this.n=z,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,m.$t4b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,m.$t4b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(b=>({...b,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:b})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:b,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:b,ref:u})=>({created:b,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:u,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,j.$1o)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===c.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,b){if(t){const{content:u}=await this.M(r,v,a);return u}return this.f.resolveResourceContent(r,v,a,b)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,c.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,h.$F2b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,c.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,g.$C2b)(t.content,!!this.l.getValue($.$ogb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,c.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,f.$N2b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const b=(0,d.$K2b)(v),u=[];for(const p of Object.keys(b)){const D=this.d.joinPath(t,p),F=r?this.d.joinPath(r.snippetsHome,p):this.d.joinPath(t,c.a);u.push({resource:D,comparableResource:F})}return u}}return[]}z(t,r){return(0,d.$K2b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,c.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,o.$x2b)((0,o.$w2b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(o.$z2b).getLocalExtensions(t);return(0,o.$x2b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,c.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,l.$3Ab)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(l.$5Ab).getLocalGlobalState(t);return(0,l.$3Ab)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,I.$rS)(JSON.parse(t.content),{})}return null}async I(t){return(0,m.$s4b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?c.b:c.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$se)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),a.push(t.profile),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(O.URI.from({scheme:$.$Mgb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==$.$Mgb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===c.b;let v,b;const u=[];let p,D,F,z,U;for(;r.length;){const B=r.shift();B.startsWith("scheme:")?v=B.substring(7):B.startsWith("authority:")?b=B.substring(10):B.startsWith("syncResource:")?p=B.substring(13):B.startsWith("profile:")?D=B.substring(8):B.startsWith("collection:")?F=B.substring(11):B.startsWith("ref:")?z=B.substring(4):p?U=B:u.push(B)}return{remote:a,syncResource:p,profile:D,collection:F,ref:z,node:U,location:v&&b!==void 0?this.d.joinPath(O.URI.from({scheme:v,authority:b,query:t.query,fragment:t.fragment,path:"/"}),...u):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,E.$VAb)(a))return a}catch(a){this.g.error(a)}throw new $.$Agb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$74b=n,e.$74b=n=c=ye([X(0,$.$vgb),X(1,$.$wgb),X(2,$.$Kgb),X(3,k.$Bk),X(4,A.$Hh),X(5,R.$Uo),X(6,L.$5j),X(7,C.$Dk),X(8,y.$7h),X(9,w.$zh)],n)}),define(re[257],oe([0,1,18,5,26,38,3,2,21,9,32,19,29,12,4,20,22,17,115,116,117,118,119,120,121,25]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m,I,i,c,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u4b=void 0;const t="sync.lastSyncTime";let r=class extends R.$jc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(p,D,F,z,U,B,x,J,Q,W,Z){super(),this.C=p,this.D=D,this.F=F,this.G=z,this.H=U,this.I=B,this.J=x,this.L=J,this.M=Q,this.N=W,this.O=Z,this.f="uninitialized",this.g=this.B(new j.$ed),this.onDidChangeStatus=this.g.event,this.h=this.B(new j.$ed),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new j.$ed),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new j.$ed),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new j.$ed),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new j.$ed),this.onDidResetLocal=this.w.event,this.y=this.B(new j.$ed),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=F.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$hc)(()=>this.bb()))}async createSyncTask(p,D){this.cb(),this.H.info("Sync started.");const F=new Date().getTime(),z=(0,C.$3f)();try{const J=(0,s.$zgb)(z);D&&(J["Cache-Control"]="no-cache"),p=await this.D.manifest(p,J)}catch(J){const Q=s.$Agb.toUserDataSyncError(J);throw b(Q,z,this.F,this.I),Q}const U=!1,B=this;let x;return{manifest:p,async run(){if(U)throw new Error("Can run a task only once");x=(0,N.$tg)(J=>B.P(p,!1,z,J)),await x.finally(()=>x=void 0),B.H.info(`Sync done. Took ${new Date().getTime()-F}ms`),B.$()},stop(){return x?.cancel(),B.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$Agb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const p=new Date().getTime(),D=(0,C.$3f)(),F=(0,s.$zgb)(D);let z;try{z=await this.D.manifest(null,F)}catch(x){const J=s.$Agb.toUserDataSyncError(x);throw b(J,D,this.F,this.I),J}await this.resetLocal();const U=this,B=new A.$od;return{id:D,async merge(){return U.P(z,!0,D,B.token)},async apply(){try{try{await U.R(z,D,B.token)}catch(x){if(s.$Agb.toUserDataSyncError(x).code==="MethodNotFound")U.H.info("Client is making invalid requests. Cleaning up data..."),await U.cleanUpRemoteData(),U.H.info("Applying manual sync again..."),await U.R(z,D,B.token);else throw x}}catch(x){throw U.H.error(x),x}U.H.info(`Sync done. Took ${new Date().getTime()-p}ms`),U.$()},async stop(){B.cancel(),await U.U(),await U.resetLocal()}}}async P(p,D,F,z){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const U=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(U,p,D,F,z));const B=U.enabled.find(x=>x.resource==="profiles");if(B){const x=await B.getLastSyncedProfiles()||[];if(z.isCancellationRequested)return;await this.Q(x,p,D,F,z)}}finally{this.r.fire(this.n)}}async Q(p,D,F,z,U){for(const B of p){if(U.isCancellationRequested)return;const x=this.M.profiles.find(Q=>Q.id===B.id);if(!x){this.H.error(`Profile with id:${B.id} and name: ${B.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",B.name);const J=this.getOrCreateActiveProfileSynchronizer(x,B);this.n.push(...await this.S(J,D,F,z,U))}for(const[B,x]of this.z.entries())this.M.profiles.some(J=>J.id===x[0].profile.id)||(x[1].dispose(),this.z.delete(B))}async R(p,D,F){const z=this.ab();for(const Q of z){if(F.isCancellationRequested)return;await Q.apply(D,F)}const U=z.find(Q=>Q.profile.isDefault);if(!U)return;const B=U.enabled.find(Q=>Q.resource==="profiles");if(!B)return;const J=(await B.getRemoteSyncedProfiles(p?.latest??null)||[]).filter(Q=>z.every(W=>W.profile.id!==Q.id));J.length&&await this.Q(J,p,!1,D,F)}async S(p,D,F,z,U){return(await p.sync(D,F,z,U)).map(([x,J])=>({profile:p.profile,syncResource:x,error:J}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(p=>p.stop()))}async resolveContent(p){const D=await this.N.resolveContent(p);if(D)return D;for(const F of this.ab())for(const z of F.enabled){const U=await z.resolveContent(p);if(U)return U}return null}async replace(p){this.cb();const D=this.N.resolveUserDataSyncResource(p);if(!D)return;const F=await this.resolveContent(p.uri);F&&await this.W(D.profile,async z=>{if(D.syncResource===z.resource)return await z.replace(F),!0})}async accept(p,D,F,z){this.cb(),await this.W(p.profile,async U=>{if(p.syncResource===U.resource)return await U.accept(D,F),z&&await U.apply((0,$.$of)(z)?!1:z.force,(0,s.$zgb)((0,C.$3f)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async D=>{if(D.resource!=="globalState"&&await D.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async D=>{if(await D.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(p){this.H.error(p)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[p]of this.z.values())try{await p.resetLocal()}catch(D){this.H.error(D)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const p=await this.N.getRemoteSyncedProfiles(),D=p.map(B=>B.collection),F=await this.D.getAllCollections(),z=F.filter(B=>!D.includes(B));z.length&&(this.H.info(`Deleting ${z.length} redundant collections on server`),await Promise.allSettled(z.map(B=>this.D.deleteCollection(B))),this.H.info("Deleted redundant collections on server"));const U=p.filter(B=>F.includes(B.collection));if(U.length!==p.length){const B=this.G.createInstance(n.$r4b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await B.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await B.updateRemoteProfiles(U,null),this.H.info("Updated remote profiles on server")}finally{B.dispose()}}}async saveRemoteActivityData(p){this.cb();const D=await this.D.getActivityData();await this.C.writeFile(p,D)}async extractActivityData(p,D){const F=(await this.C.readFile(p)).value.toString(),z=JSON.parse(F);if(z.resources)for(const U in z.resources)for(const B of z.resources[U])await this.O.writeResource(U,B.content,new Date(B.created*1e3),void 0,D);if(z.collections)for(const U in z.collections)for(const B in z.collections[U].resources)for(const x of z.collections[U].resources?.[B]??[])await this.O.writeResource(B,x.content,new Date(x.created*1e3),U,D)}async W(p,D){const F=new R.$ic;try{const z=this.z.get(p.id);if(z){const Q=await this.X(z[0],D,F);return(0,$.$pf)(Q)?null:Q}if(p.isDefault){const Q=F.add(this.G.createInstance(a,p,void 0)),W=await this.X(Q,D,F);return(0,$.$pf)(W)?null:W}if(this.M.isEnabled())return null;const U=F.add(this.G.createInstance(n.$r4b,p,void 0)),B=await this.D.manifest(null),J=(await U.getRemoteSyncedProfiles(B?.latest??null)||[]).find(Q=>Q.id===p.id);if(J){const Q=F.add(this.G.createInstance(a,p,J.collection)),W=await this.X(Q,D,F);return(0,$.$pf)(W)?null:W}return null}finally{F.dispose()}}async X(p,D,F){const z=[...p.enabled,...p.disabled.reduce((U,B)=>(B!=="workspaceState"&&U.push(F.add(p.createSynchronizer(B))),U),[])];for(const U of z){const B=await D(U);if(!(0,$.$pf)(B))return B}}Y(p){const D=this.f;this.f!==p&&(this.f=p,this.g.fire(p),D==="hasConflicts"&&this.$())}Z(){const p=this.ab().map(D=>D.conflicts).flat();(0,O.$sb)(this.j,p,(D,F)=>D.profile.id===F.profile.id&&D.syncResource===F.syncResource&&(0,O.$sb)(D.conflicts,F.conflicts,(z,U)=>(0,k.$ag)(z.previewResource,U.previewResource)))||(this.j=p,this.m.fire(p))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(p,D){let F=this.z.get(p.id);if(F&&F[0].collection!==D?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),F[1].dispose(),F=void 0,this.z.delete(p.id)),!F){const z=new R.$ic,U=z.add(this.G.createInstance(a,p,D?.collection));z.add(U.onDidChangeStatus(B=>this.Y(B))),z.add(U.onDidChangeConflicts(B=>this.Z())),z.add(U.onDidChangeLocal(B=>this.h.fire(B))),this.z.set(p.id,F=[U,z])}return F[0]}ab(){const p=[];for(const[D]of this.z.values())p.push(D);return p}bb(){this.z.forEach(([,p])=>p.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$u4b=r,e.$u4b=r=ye([X(0,h.$5j),X(1,s.$vgb),X(2,s.$ugb),X(3,g.$zh),X(4,s.$Kgb),X(5,f.$8k),X(6,y.$Uo),X(7,s.$Fgb),X(8,o.$Dk),X(9,s.$Hgb),X(10,s.$wgb)],r);let a=class extends R.$jc{get enabled(){return this.f.sort((p,D)=>p[1]-D[1]).map(([p])=>p)}get disabled(){return s.$rgb.filter(p=>!this.r.isResourceEnabled(p))}get status(){return this.g}get conflicts(){return this.m}constructor(p,D,F,z,U,B,x,J,Q,W){super(),this.profile=p,this.collection=D,this.r=F,this.t=z,this.u=U,this.w=B,this.y=x,this.z=J,this.C=Q,this.D=W,this.f=[],this.g="idle",this.h=this.B(new j.$ed),this.onDidChangeStatus=this.h.event,this.j=this.B(new j.$ed),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new j.$ed),this.onDidChangeConflicts=this.n.event,this.B(F.onDidChangeResourceEnablement(([Z,G])=>this.F(Z,G))),this.B((0,R.$hc)(()=>this.f.splice(0,this.f.length).forEach(([,,Z])=>Z.dispose())));for(const Z of s.$rgb)F.isResourceEnabled(Z)&&this.G(Z)}F(p,D){D?this.G(p):this.H(p)}G(p){if(this.f.some(([U])=>U.resource===p))return;if(p==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(p==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||p==="workspaceState")return;if(p!=="profiles"&&this.profile.useDefaultFlags?.[p]){this.z.debug(`Skipping syncing ${p} in ${this.profile.name} because it is already synced by default profile`);return}const D=new R.$ic,F=D.add(this.createSynchronizer(p));D.add(F.onDidChangeStatus(()=>this.L())),D.add(F.onDidChangeConflicts(()=>this.M())),D.add(F.onDidChangeLocal(()=>this.j.fire(p)));const z=this.N(p);this.f.push([F,z,D])}H(p){const D=this.f.findIndex(([F])=>F.resource===p);if(D!==-1){const[[F,,z]]=this.f.splice(D,1);z.dispose(),this.L(),Promise.allSettled([F.stop(),F.resetLocal()]).then(null,U=>this.z.error(U))}}createSynchronizer(p){switch(p){case"settings":return this.t.createInstance(I.$G2b,this.profile,this.collection);case"keybindings":return this.t.createInstance(m.$D2b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$L2b,this.profile,this.collection);case"tasks":return this.t.createInstance(c.$O2b,this.profile,this.collection);case"globalState":return this.t.createInstance(w.$4Ab,this.profile,this.collection);case"extensions":return this.t.createInstance(l.$y2b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$r4b,this.profile,this.collection)}}async sync(p,D,F,z){if(z.isCancellationRequested)return[];const U=this.enabled;if(!U.length)return[];try{const B=[],x=(0,s.$zgb)(F),J=(this.collection?p?.collections?.[this.collection]?.latest:p?.latest)??null,Q=D?await this.I(J):{};for(const W of U){if(z.isCancellationRequested)return[];if(!this.r.isResourceEnabled(W.resource))return[];try{if(D){const Z=await W.preview(J,Q,x);if(Z)for(const G of Z.resourcePreviews)(G.localChange!==0||G.remoteChange!==0)&&G.mergeState==="preview"&&await W.merge(G.previewResource)}else await W.sync(J,x)}catch(Z){const G=s.$Agb.toUserDataSyncError(Z);if(b(G,F,this.w,this.y),v(Z))throw G;this.z.error(Z),this.z.error(`${W.resource}: ${(0,L.$li)(Z)}`),B.push([W.resource,G])}}return B}finally{this.L()}}async apply(p,D){const F=(0,s.$zgb)(p);for(const z of this.enabled){if(D.isCancellationRequested)return;try{await z.apply(!1,F)}catch(U){const B=s.$Agb.toUserDataSyncError(U);if(b(B,p,this.w,this.y),v(U))throw B;this.z.error(U),this.z.error(`${z.resource}: ${(0,L.$li)(U)}`)}}}async stop(){for(const p of this.enabled)try{p.status!=="idle"&&await p.stop()}catch(D){this.z.error(D)}}async resetLocal(){for(const p of this.enabled)try{await p.resetLocal()}catch(D){this.z.error(`${p.resource}: ${(0,L.$li)(D)}`),this.z.error(D)}}async I(p){if(!this.profile.isDefault)return{};const D=this.D.getValue(s.$ngb),F=this.enabled.find(z=>z instanceof I.$G2b);if(F){const z=await F.getRemoteUserDataSyncConfiguration(p);return{...D,...z}}return D}J(p){this.g!==p&&(this.g=p,this.h.fire(p))}L(){return this.M(),this.enabled.some(p=>p.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(p=>p.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const p=this.enabled.filter(D=>D.status==="hasConflicts").filter(D=>D.conflicts.conflicts.length>0).map(D=>D.conflicts);(0,O.$sb)(this.m,p,(D,F)=>D.syncResource===F.syncResource&&(0,O.$sb)(D.conflicts,F.conflicts,(z,U)=>(0,k.$ag)(z.previewResource,U.previewResource)))||(this.m=p,this.n.fire(p))}N(p){switch(p){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([X(2,s.$Fgb),X(3,g.$zh),X(4,d.$Yn),X(5,s.$ugb),X(6,f.$8k),X(7,s.$Kgb),X(8,o.$Dk),X(9,E.$7h)],a);function v(u){if(u instanceof s.$Agb)switch(u.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function b(u,p,D,F){F.publicLog2("sync/error",{code:u.code,serverCode:u instanceof s.$Bgb?String(u.serverCode):void 0,url:u instanceof s.$Bgb?u.url:void 0,resource:u.resource,executionId:p,service:D.userDataSyncStore.url.toString()})}}),define(re[258],oe([0,1,3,2,11,17,25]),function(te,e,O,N,A,L,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K7b=e.$J7b=void 0;function R(d,h){return{...d,profile:(0,L.$Ek)(d.profile,h.profilesHome.scheme)}}function k(d){return{created:d.created,uri:A.URI.revive(d.uri)}}class ${constructor(h,g,y){this.c=h,this.d=g,this.f=y,this.a=new Map,this.b=new O.$ed}listen(h,g){switch(g){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${g}`)}async call(h,g,y){try{return await this.g(h,g,y)}catch(f){throw this.f.error(f),f}}async g(h,g,y){switch(g){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),A.URI.revive(y[1]),y[2],y[3]);case"replace":return this.c.replace(k(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(y[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(y[0]),A.URI.revive(y[1]));case"createManualSyncTask":return this.i()}if(g.startsWith("manualSync/")){const f=g.substring(11),o=y[0],l=this.h(o);switch(y=y.slice(1),f){case"merge":return l.merge();case"apply":return l.apply().then(()=>this.a.delete(this.j(l.id)));case"stop":return l.stop().finally(()=>this.a.delete(this.j(l.id)))}}throw new Error("Invalid call")}h(h){const g=this.a.get(this.j(h));if(!g)throw new Error(`Manual sync taks not found: ${h}`);return g}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$J7b=$;let C=class extends N.$jc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,g){super(),this.n=g,this.b="uninitialized",this.c=this.B(new O.$ed),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new O.$ed),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new O.$ed),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new O.$ed),this.onSyncErrors=this.m.event,this.a={call(y,f,o){return h.call(y,f,o).then(null,l=>{throw j.$Agb.toUserDataSyncError(l)})},listen(y,f){return h.listen(y,f)}},this.a.call("_getInitialData").then(([y,f,o])=>{this.s(y),this.t(f),o&&this.u(o),this.B(this.a.listen("onDidChangeStatus")(l=>this.s(l))),this.B(this.a.listen("onDidChangeLastSyncTime")(l=>this.u(l)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.t(y))),this.B(this.a.listen("onSyncErrors")(y=>this.m.fire(y.map(f=>({...f,error:j.$Agb.toUserDataSyncError(f.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),g=this;return new E(h,{async call(f,o,l){return g.a.call(`manualSync/${f}`,[h,...Array.isArray(o)?o:[o]],l)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,g,y,f){return this.a.call("accept",[h,g,y,f])}resolveContent(h){return this.a.call("resolveContent",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}saveRemoteActivityData(h){return this.a.call("getRemoteActivityData",[h])}extractActivityData(h,g){return this.a.call("extractActivityData",[h,g])}async s(h){this.b=h,this.c.fire(h)}async t(h){this.f=h.map(g=>({syncResource:g.syncResource,profile:(0,L.$Ek)(g.profile,this.n.profilesHome.scheme),conflicts:g.conflicts.map(y=>({...y,baseResource:A.URI.revive(y.baseResource),localResource:A.URI.revive(y.localResource),remoteResource:A.URI.revive(y.remoteResource),previewResource:A.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}u(h){this.h!==h&&(this.h=h,this.j.fire(h))}};e.$K7b=C,e.$K7b=C=ye([X(1,L.$Dk)],C);class E extends N.$jc{constructor(h,g){super(),this.id=h,this.a=g}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(re[259],oe([0,1,5,26,8,3,2,141,6,21,9,11,32,19,15,12,24,57,44,20,25]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TAb=e.$SAb=e.$RAb=e.$QAb=e.$PAb=void 0;const I="configurationSync.store",i="sync.previous.store",c="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends j.$jc{get userDataSyncStore(){return this.b}get c(){return this.h.get(m.$Dgb,-1)}set c(F){this.h.store(m.$Dgb,F,-1,k.$o?0:1)}constructor(F,z,U){super(),this.f=F,this.g=z,this.h=U,this.a=this.B(new L.$ed),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const B=this.B(new j.$ic);this.B(L.Event.filter(U.onDidChangeValue(-1,m.$Dgb,B),()=>this.c!==this.userDataSyncStore?.type,B)(()=>this.j()))}j(){this.b=this.m(this.f[I]),this.a.fire()}m(F){if(F&&(F=k.$o&&F.web?{...F,...F.web}:F,(0,C.$if)(F.url)&&(0,C.$kf)(F.authenticationProviders)&&Object.keys(F.authenticationProviders).every(z=>Array.isArray(F.authenticationProviders[z].scopes)))){const z=F,U=!!z.canSwitch,B=z.url===z.insidersUrl?"insiders":"stable",x=(U?this.c:void 0)||B,J=x==="insiders"?z.insidersUrl:x==="stable"?z.stableUrl:z.url;return{url:E.URI.parse(J),type:x,defaultType:B,defaultUrl:E.URI.parse(z.url),stableUrl:E.URI.parse(z.stableUrl),insidersUrl:E.URI.parse(z.insidersUrl),canSwitch:U,authenticationProviders:Object.keys(z.authenticationProviders).reduce((Q,W)=>(Q.push({id:W,scopes:z.authenticationProviders[W].scopes}),Q),[])}}}};e.$PAb=a,e.$PAb=a=ye([X(0,f.$jj),X(1,h.$7h),X(2,w.$Uo)],a);let v=class extends a{constructor(F,z,U){super(F,z,U);const B=this.h.get(i,-1);B&&(this.n=JSON.parse(B));const x=this.f[I];x?this.h.store(i,JSON.stringify(x),-1,1):this.h.remove(i,-1)}async switch(F){F!==this.c&&(this.c=F,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$QAb=v,e.$QAb=v=ye([X(0,f.$jj),X(1,h.$7h),X(2,w.$Uo)],v);let b=class extends j.$jc{get donotMakeRequestsUntil(){return this.j}constructor(F,z,U,B,x,J,Q){super(),this.n=U,this.r=B,this.s=Q,this.g=this.B(new L.$ed),this.onTokenFailed=this.g.event,this.h=this.B(new L.$ed),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new L.$ed),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(F),this.c=(0,l.$1o)(x,J,Q).then(W=>{const Z={"X-Client-Name":`${z.applicationName}${k.$o?"-web":""}`,"X-Client-Version":z.version};return z.commit&&(Z["X-Client-Commit"]=z.commit),Z}),this.f=new p(t,r,this.n,this.r),this.u(),this.B((0,j.$hc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(F,z){this.b={token:F,type:z}}t(F){this.a=F?(0,$.$hg)(F,"v1"):void 0}u(){const F=this.s.getNumber(c,-1);F&&Date.now()<F&&this.y(new Date(F))}y(F){this.j?.getTime()!==F?.getTime()&&(this.j=F,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(c,this.j.getTime(),-1,1),this.w=(0,O.$tg)(z=>(0,O.$Gg)(this.j.getTime()-Date.now(),z).then(()=>this.y(void 0))),this.w.then(null,z=>null)):this.s.remove(c,-1),this.m.fire())}async getAllCollections(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,$.$hg)(this.a,"collection").toString();F={...F},F["Content-Type"]="application/json";const U=await this.D(z,{type:"GET",headers:F},[],N.CancellationToken.None);return(await(0,o.$No)(U))?.map(({id:B})=>B)||[]}async createCollection(F={}){if(!this.a)throw new Error("No settings sync store url configured.");const z=(0,$.$hg)(this.a,"collection").toString();F={...F},F["Content-Type"]=R.$Gr.text;const U=await this.D(z,{type:"POST",headers:F},[],N.CancellationToken.None),B=await(0,o.$Mo)(U);if(!B)throw new m.$Bgb("Server did not return the collection id",z,"NoCollection",U.res.statusCode,U.res.headers[m.$xgb]);return B}async deleteCollection(F,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=F?(0,$.$hg)(this.a,"collection",F).toString():(0,$.$hg)(this.a,"collection").toString();z={...z},await this.D(U,{type:"DELETE",headers:z},[],N.CancellationToken.None)}async getAllResourceRefs(F,z){if(!this.a)throw new Error("No settings sync store url configured.");const U=this.z(this.a,z,F),B={},x=await this.D(U.toString(),{type:"GET",headers:B},[],N.CancellationToken.None);return(await(0,o.$No)(x)||[]).map(({url:Q,created:W})=>({ref:(0,$.$jg)(U,U.with({path:Q})),created:W*1e3}))}async resolveResourceContent(F,z,U,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const x=(0,$.$hg)(this.z(this.a,U,F),z).toString();B={...B},B["Cache-Control"]="no-cache";const J=await this.D(x,{type:"GET",headers:B},[],N.CancellationToken.None);return await(0,o.$Mo)(J)}async deleteResource(F,z,U){if(!this.a)throw new Error("No settings sync store url configured.");const B=z!==null?(0,$.$hg)(this.z(this.a,U,F),z).toString():this.z(this.a,U,F).toString(),x={};await this.D(B,{type:"DELETE",headers:x},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,$.$hg)(this.a,"resource").toString(),z={"Content-Type":R.$Gr.text};await this.D(F,{type:"DELETE",headers:z},[],N.CancellationToken.None)}async readResource(F,z,U,B={}){if(!this.a)throw new Error("No settings sync store url configured.");const x=(0,$.$hg)(this.z(this.a,U,F),"latest").toString();B={...B},B["Cache-Control"]="no-cache",z&&(B["If-None-Match"]=z.ref);const J=await this.D(x,{type:"GET",headers:B},[304],N.CancellationToken.None);let Q=null;if(J.res.statusCode===304&&(Q=z),Q===null){const W=J.res.headers.etag;if(!W)throw new m.$Bgb("Server did not return the ref",x,"NoRef",J.res.statusCode,J.res.headers[m.$xgb]);const Z=await(0,o.$Mo)(J);if(!Z&&J.res.statusCode===304)throw new m.$Bgb("Empty response",x,"EmptyResponse",J.res.statusCode,J.res.headers[m.$xgb]);Q={ref:W,content:Z}}return Q}async writeResource(F,z,U,B,x={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.z(this.a,B,F).toString();x={...x},x["Content-Type"]=R.$Gr.text,U&&(x["If-Match"]=U);const Q=await this.D(J,{type:"POST",data:z,headers:x},[],N.CancellationToken.None),W=Q.res.headers.etag;if(!W)throw new m.$Bgb("Server did not return the ref",J,"NoRef",Q.res.statusCode,Q.res.headers[m.$xgb]);return W}async manifest(F,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,$.$hg)(this.a,"manifest").toString();z={...z},z["Content-Type"]="application/json",F&&(z["If-None-Match"]=F.ref);const B=await this.D(U,{type:"GET",headers:z},[304],N.CancellationToken.None);let x=null;if(B.res.statusCode===304&&(x=F),!x){const Q=B.res.headers.etag;if(!Q)throw new m.$Bgb("Server did not return the ref",U,"NoRef",B.res.statusCode,B.res.headers[m.$xgb]);const W=await(0,o.$Mo)(B);if(!W&&B.res.statusCode===304)throw new m.$Bgb("Empty response",U,"EmptyResponse",B.res.statusCode,B.res.headers[m.$xgb]);W&&(x={...JSON.parse(W),ref:Q})}const J=this.s.get(n,-1);return J&&x&&J!==x.session&&this.C(),x===null&&J&&this.C(),x&&this.s.store(n,x.session,-1,1),x}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,$.$hg)(this.a,"download").toString(),z={},U=await this.D(F,{type:"GET",headers:z},[],N.CancellationToken.None);if(!(0,o.$Jo)(U))throw new m.$Bgb("Server returned "+U.res.statusCode,F,"EmptyResponse",U.res.statusCode,U.res.headers[m.$xgb]);if((0,o.$Ko)(U))throw new m.$Bgb("Empty response",F,"EmptyResponse",U.res.statusCode,U.res.headers[m.$xgb]);return U.stream}z(F,z,U){return z?(0,$.$hg)(F,"collection",z,"resource",U):(0,$.$hg)(F,"resource",U)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(F,z,U,B){if(!this.b)throw new m.$Bgb("No Auth Token Available",F,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new m.$Bgb(`${z.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const x=await this.c;z.headers={...z.headers||{},...x,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(z.headers),this.r.trace("Sending request to server",{url:F,type:z.type,headers:{...z.headers,authorization:void 0}});let J;try{J=await this.f.request(F,z,B)}catch(H){if(!(H instanceof m.$Bgb)){let V="RequestFailed";const ee=(0,A.$8)(H).toLowerCase();ee.includes("xhr timeout")?V="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?V="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?V="RequestPathNotEscaped":ee.includes("headers must be an object")?V="RequestHeadersNotObject":(0,A.$2)(H)&&(V="RequestCanceled"),H=new m.$Bgb(`Connection refused for the request '${F}'.`,F,V,void 0,void 0)}throw this.r.info("Request failed",F),H}const Q=J.res.headers[m.$xgb],W={url:F,status:J.res.statusCode,"execution-id":z.headers[m.$ygb],"operation-id":Q},Z=(0,o.$Jo)(J)||J.res.statusCode&&U.includes(J.res.statusCode);let G="";if(Z?this.r.trace("Request succeeded",W):(G=await(0,o.$Lo)(J)||"",this.r.info("Request failed",W,G)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new m.$Bgb(`${z.type} request '${F}' failed because of Unauthorized (401).`,F,"Unauthorized",J.res.statusCode,Q);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new m.$Bgb(`${z.type} request '${F}' failed because the access is forbidden (403).`,F,"Forbidden",J.res.statusCode,Q)}if(this.h.fire(),J.res.statusCode===404)throw new m.$Bgb(`${z.type} request '${F}' failed because the requested resource is not found (404).`,F,"NotFound",J.res.statusCode,Q);if(J.res.statusCode===405)throw new m.$Bgb(`${z.type} request '${F}' failed because the requested endpoint is not found (405). ${G}`,F,"MethodNotFound",J.res.statusCode,Q);if(J.res.statusCode===409)throw new m.$Bgb(`${z.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,"Conflict",J.res.statusCode,Q);if(J.res.statusCode===410)throw new m.$Bgb(`${z.type} request '${F}' failed because the requested resource is not longer available (410).`,F,"Gone",J.res.statusCode,Q);if(J.res.statusCode===412)throw new m.$Bgb(`${z.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,"PreconditionFailed",J.res.statusCode,Q);if(J.res.statusCode===413)throw new m.$Bgb(`${z.type} request '${F}' failed because of too large payload (413).`,F,"TooLarge",J.res.statusCode,Q);if(J.res.statusCode===426)throw new m.$Bgb(`${z.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,"UpgradeRequired",J.res.statusCode,Q);if(J.res.statusCode===429){const H=J.res.headers["retry-after"];throw H?(this.y(new Date(Date.now()+parseInt(H)*1e3)),new m.$Bgb(`${z.type} request '${F}' failed because of too many requests (429).`,F,"TooManyRequestsAndRetryAfter",J.res.statusCode,Q)):new m.$Bgb(`${z.type} request '${F}' failed because of too many requests (429).`,F,"RemoteTooManyRequests",J.res.statusCode,Q)}if(!Z)throw new m.$Bgb("Server returned "+J.res.statusCode,F,"Unknown",J.res.statusCode,Q);return J}F(F){let z=this.s.get(s,-1);z===void 0&&(z=(0,d.$3f)(),this.s.store(s,z,-1,1)),F["X-Machine-Session-Id"]=z;const U=this.s.get(n,-1);U!==void 0&&(F["X-User-Session-Id"]=U)}};e.$RAb=b,e.$RAb=b=ye([X(1,f.$jj),X(2,o.$Ho),X(3,m.$Kgb),X(4,g.$Hh),X(5,y.$5j),X(6,w.$Uo)],b);let u=class extends b{constructor(F,z,U,B,x,J,Q){super(F.userDataSyncStore?.url,z,U,B,x,J,Q),this.B(F.onDidChangeUserDataSyncStore(()=>this.t(F.userDataSyncStore?.url)))}};e.$SAb=u,e.$SAb=u=ye([X(0,m.$ugb),X(1,f.$jj),X(2,o.$Ho),X(3,m.$Kgb),X(4,g.$Hh),X(5,y.$5j),X(6,w.$Uo)],u);class p{constructor(F,z,U,B){this.c=F,this.d=z,this.f=U,this.g=B,this.a=[],this.b=void 0}request(F,z,U){if(this.h()&&this.i(),z.url=F,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new m.$Bgb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,F,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(F),this.f.request(z,U)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$TAb=p}),define(re[260],oe([0,1,3,55,24,20,22,255,25,78,81]),function(te,e,O,N,A,L,j,R,k,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=void 0;let E=class extends R.$v4b{constructor(h,g,y,f,o,l,w,m,I,i,c){super(h,g,y,f,o,w,m,I,i,c),this.B(O.Event.debounce(O.Event.any(O.Event.map(l.onDidFocusWindow,()=>"windowFocus"),O.Event.map(l.onDidOpenWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$57b=E,e.$57b=E=ye([X(0,A.$jj),X(1,k.$ugb),X(2,k.$vgb),X(3,k.$Fgb),X(4,k.$Ggb),X(5,N.$S5b),X(6,k.$Kgb),X(7,$.$uzb),X(8,j.$8k),X(9,C.$igb),X(10,L.$Uo)],E)}),define(re[261],oe([0,1,69,23,6,21]),function(te,e,O,N,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u5b=e.$t5b=e.$s5b=e.$r5b=void 0,e.$r5b=128/4;function j($){function C(){let E=$.scheme===N.Schemas.file?(0,L.$8f)($):$.toString();return A.$k||(E=E.toLowerCase()),(0,O.createHash)("md5").update(E).digest("hex")}return{id:C(),configPath:$}}e.$s5b=j;function R($,C){function E(){if($.scheme!==N.Schemas.file)return(0,O.createHash)("md5").update($.toString()).digest("hex");if(!C)return;let h;return A.$k?h=C.ino:A.$j?h=C.birthtime.getTime():A.$i&&(typeof C.birthtimeMs=="number"?h=Math.floor(C.birthtimeMs):h=C.birthtime.getTime()),(0,O.createHash)("md5").update($.fsPath).update(h?String(h):"").digest("hex")}const d=E();if(typeof d=="string")return{id:d,uri:$}}e.$t5b=R;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$u5b=k}),define(re[262],oe([0,1,5,8,2,16,31,15,7,75,113,261,55,71,23]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=void 0;let y=class extends A.$jc{constructor(o,l,w,m){super(),this.a=o,this.b=l,this.c=w,this.f=m,this.B(new O.$Rg(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const o=this.a.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,l=await j.Promises.readdir(o),w=new $.$6zb(this.f.getChannel("storage"));await Promise.all(l.map(async m=>{const I=(0,L.$8d)(o,m);m.length===E.$r5b||m===C.$Mh.id||(await this.c.getWindows()).some(n=>n.workspace?.id===m)||await w.isUsed(I)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${m} as it seems to be an unused empty workspace.`),await j.Promises.rm(I))}))}catch(o){(0,N.$Y)(o)}}};e.$y7b=y,e.$y7b=y=ye([X(0,R.$Ih),X(1,k.$4i),X(2,d.$S5b),X(3,h.$06b)],y)}),define(re[82],oe([0,1,52,5,16,9,31,148,273,274]),function(te,e,O,N,A,L,j,R,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.zip=e.$ap=e.$_o=void 0,e.$_o="end of central directory record signature not found";const C=new RegExp(e.$_o);class E extends Error{constructor(c,n){let s=n.message;switch(c){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=c,this.cause=n}}e.$ap=E;function d(i){const c=i.externalFileAttributes>>16||33188;return[448,56,7].map(n=>c&n).reduce((n,s)=>n+s,c&61440)}function h(i){if(i instanceof E)return i;let c;return C.test(i.message)&&(c="CorruptZip"),new E(c,i)}function g(i,c,n,s,t,r){const a=A.$$d(c),v=A.$8d(s,a);if(!v.startsWith(s))return Promise.reject(new Error(R.localize(0,null,c)));const b=A.$8d(s,c);let u;return r.onCancellationRequested(()=>{u?.destroy()}),Promise.resolve(j.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((p,D)=>{if(!r.isCancellationRequested)try{u=(0,O.createWriteStream)(b,{mode:n}),u.once("close",()=>p()),u.once("error",D),i.once("error",D),i.pipe(u)}catch(F){D(F)}}))}function y(i,c,n,s){let t=(0,N.$tg)(()=>Promise.resolve()),r=0;const a=s.onCancellationRequested(()=>{t.cancel(),i.close()});return new Promise((v,b)=>{const u=new N.$Ag,p=D=>{D.isCancellationRequested||(r++,i.readEntry())};i.once("error",b),i.once("close",()=>t.then(()=>{s.isCancellationRequested||i.entryCount===r?v():b(new E("Incomplete",new Error(R.localize(1,null,r,i.entryCount))))},b)),i.readEntry(),i.on("entry",D=>{if(s.isCancellationRequested)return;if(!n.sourcePathRegex.test(D.fileName)){p(s);return}const F=D.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(F)){const B=A.$8d(c,F);t=(0,N.$tg)(x=>j.Promises.mkdir(B,{recursive:!0}).then(()=>p(x)).then(void 0,b));return}const z=o(i,D),U=d(D);t=(0,N.$tg)(B=>u.queue(()=>z.then(x=>g(x,F,U,c,n,B).then(()=>p(B)))).then(null,b))})}).finally(()=>a.dispose())}function f(i,c=!1){return new Promise((n,s)=>{(0,k.open)(i,c?{lazyEntries:!0}:void 0,(t,r)=>{t?s(h(t)):n((0,L.$tf)(r))})})}function o(i,c){return new Promise((n,s)=>{i.openReadStream(c,(t,r)=>{t?s(h(t)):n((0,L.$tf)(r))})})}function l(i,c){return new Promise((n,s)=>{const t=new $.ZipFile;c.forEach(a=>{a.contents?t.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&t.addFile(a.localPath,a.path)}),t.end();const r=(0,O.createWriteStream)(i);t.outputStream.pipe(r),t.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(i))})}e.zip=l;function w(i,c,n={},s){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=f(i,!0);return n.overwrite&&(r=r.then(a=>j.Promises.rm(c).then(()=>a))),r.then(a=>y(a,c,{sourcePathRegex:t},s))}e.$cp=w;function m(i,c){return f(i).then(n=>new Promise((s,t)=>{n.on("entry",r=>{r.fileName===c&&o(n,r).then(a=>s(a),a=>t(a))}),n.once("close",()=>t(new Error(R.localize(2,null,c))))}))}function I(i,c){return m(i,c).then(n=>new Promise((s,t)=>{const r=[];n.once("error",t),n.on("data",a=>r.push(a)),n.on("end",()=>s(Buffer.concat(r)))}))}e.$dp=I}),define(re[263],oe([0,1,5,8,2,23,21,53,9,32,31,82,19,15,29,33,97,12,7]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=void 0;let m=class extends A.$jc{static{w=this}static{this.c=".sigzip"}constructor(i,c,n,s,t,r){super(),this.h=c,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,c,n){await this.g;const s=(0,j.$hg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,c))}catch(r){throw new g.$Zn(r.message,g.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===l.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${v.output}`),t===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$Zn(E.$_o,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return!1;const c=this.m.getValue("extensions.verifySignature");return(0,k.$of)(c)?c:!0}async u(i){await this.g;const c=(0,j.$hg)(this.extensionsDownloadDir,`${this.z(i)}${w.c}`);return await this.w(i,c,n=>this.j.downloadSignatureArchive(i,n)),c}async w(i,c,n){if(await this.h.exists(c))return;if(c.scheme!==L.Schemas.file){await n(c);return}const s=(0,j.$hg)(this.extensionsDownloadDir,`.${(0,$.$3f)()}`);await this.h.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,c.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,c.path);else throw this.r.info(`Rename failed because of ${(0,N.$8)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const c=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(w.c))s.push(a.resource);else{const v=y.$po.parse(a.name);v&&n.push([v,a])}const t=(0,y.$uo)(n,([a])=>a),r=[];for(const a of t)a.sort((v,b)=>R.rcompare(v[0].version,b[0].version)),c.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),c.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),c.push(...s),await O.Promises.settled(c.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?y.$po.create(i).toString().toLowerCase():(0,$.$3f)()}};e.$sp=m,e.$sp=m=w=ye([X(0,h.$Ih),X(1,o.$5j),X(2,g.$Yn),X(3,d.$7h),X(4,f.$6o),X(5,l.$4i)],m)}),define(re[264],oe([0,1,82,157]),function(te,e,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;function A(L){return(0,O.$dp)(L,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$up=A}),define(re[122],oe([0,1,5,14,26,38,8,3,51,2,35,23,16,21,53,9,11,32,31,82,156,96,15,243,29,33,50,79,263,244,264,212,223,67,12,4,7,24,22,28,17]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m,I,i,c,n,s,t,r,a,v,b,u,p,D,F,z,U,B,x,J,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.$xp=void 0,e.$xp=(0,z.$Bh)(n.$1n);const W=".vsctmp";let Z=class extends c.$ep{constructor(Y,q,S,P,M,T,K,_,ae,he,fe,le){super(Y,q,fe,S,he,le),this.fb=M,this.gb=T,this.hb=K,this.ib=ae,this.eb=new Map,this.rb=new C.$zi;const $e=this.B(_.createInstance(v.$tp));this.bb=this.B(_.createInstance(G,we=>$e.postUninstall(we))),this.cb=this.B(new u.$vp(le,ae,fe,this,this.F)),this.db=this.B(_.createInstance(a.$sp));const de=this.B(new p.$wp(this,this.fb,le,T,fe,ae,S));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$zo)(this.ib,this.F)),this.jb}async zip(Y){this.F.trace("ExtensionManagementService#zip",Y.identifier.id);const q=await this.pb(Y),S=await(0,w.zip)((0,h.$hg)(this.db.extensionsDownloadDir,(0,o.$3f)()).fsPath,q);return f.URI.file(S)}async unzip(Y){return this.F.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const{location:q,cleanup:S}=await this.lb(Y),P=d.$9d(q.fsPath);try{return await(0,b.$up)(P)}finally{await S()}}getInstalled(Y,q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(Y??null,q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Y){return this.bb.scanUserExtensionAtLocation(Y)}async install(Y,q={}){this.F.trace("ExtensionManagementService#install",Y.toString());const{location:S,cleanup:P}=await this.lb(Y);try{const M=await(0,b.$up)(d.$9d(S.fsPath)),T=(0,s.$to)(M.publisher,M.name);if(M.engines&&M.engines.vscode&&!(0,D.$Go)(M.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,T,this.G.version));const _=(await this.I([{manifest:M,extension:S,options:q}])).find(({identifier:ae})=>(0,s.$oo)(ae,{id:T}));if(_?.local)return _.local;throw _?.error?_.error:(0,c.$gp)(new Error(`Unknown error while installing extension ${T}`))}finally{await P()}}async installFromLocation(Y,q){this.F.trace("ExtensionManagementService#installFromLocation",Y.toString());const S=await this.bb.scanUserExtensionAtLocation(Y);if(!S)throw new Error(`Cannot find a valid extension from the location ${Y.toString()}`);return await this.ub([[S,void 0]],q),this.F.info("Successfully installed extension",S.identifier.id,q.toString()),S}async installExtensionsFromProfile(Y,q,S){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",Y,q.toString(),S.toString());const P=(await this.bb.scanExtensions(1,q)).filter(M=>Y.some(T=>(0,s.$oo)(T,M.identifier)));if(P.length){const M=await Promise.all(P.map(T=>this.bb.scanMetadata(T,q)));await this.ub(P.map((T,K)=>[T,M[K]]),S),this.F.info("Successfully installed extensions",P.map(T=>T.identifier.id),S.toString())}return P}async updateMetadata(Y,q,S=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",Y.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,q.pinned=q.pinned||void 0,Y=await this.bb.updateMetadata(Y,q,S),this.cb.invalidate(S),this.w.fire(Y),Y}async reinstallFromGallery(Y){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",Y.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const q=await this.getTargetPlatform(),[S]=await this.z.getExtensions([{...Y.identifier,preRelease:Y.preRelease}],{targetPlatform:q,compatible:!0},A.CancellationToken.None);if(!S)throw new Error(m.localize(2,null));await this.bb.setUninstalled(Y);try{await this.bb.removeUninstalledExtension(Y)}catch(P){throw new Error(m.localize(3,null,(0,L.$li)(P)))}return this.installFromGallery(S)}ab(Y,q,S,P){return this.bb.copyExtension(Y,q,S,P)}copyExtensions(Y,q){return this.bb.copyExtensions(Y,q)}markAsUninstalled(...Y){return this.bb.setUninstalled(...Y)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(Y){this.F.error(Y)}}async download(Y,q,S){const{location:P}=await this.db.download(Y,q,!S);return P}async lb(Y){if(Y.scheme===E.Schemas.file)return{location:Y,async cleanup(){}};this.F.trace("Downloading extension from",Y.toString());const q=(0,h.$hg)(this.db.extensionsDownloadDir,(0,o.$3f)());return await this.hb.download(Y,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(P){this.F.error(P)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(Y,q,S){if(f.URI.isUri(q))return new ee(Y,q,S,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const P=s.$po.create(q).toString();let M=this.eb.get(P);return M||(this.eb.set(P,M=new V(Y,q,S,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),M.waitUntilTaskIsFinished().finally(()=>this.eb.delete(P))),M}$(Y,q){return new ne(Y,q.profileLocation,this.gb)}async pb(Y){const q=async P=>{let M=await l.Promises.readdir(P);M=M.map(_=>d.$8d(P,_));const T=await Promise.all(M.map(_=>l.Promises.stat(_)));let K=Promise.resolve([]);return T.forEach((_,ae)=>{const he=M[ae];_.isFile()&&(K=K.then(fe=>[...fe,he])),_.isDirectory()&&(K=K.then(fe=>q(he).then(le=>[...fe,...le])))}),K};return(await q(Y.location.fsPath)).map(P=>({path:`extension/${d.$0d(Y.location.fsPath,P)}`,localPath:P}))}async qb({added:Y,removed:q}){if(q)for(const S of q.extensions)this.F.info("Extensions removed from another source",S.id,q.profileLocation.toString()),this.u.fire({identifier:S,profileLocation:q.profileLocation});if(Y){const P=(await this.bb.scanExtensions(1,Y.profileLocation)).filter(M=>Y.extensions.some(T=>(0,s.$oo)(T,M.identifier)));this.s.fire(P.map(M=>(this.F.info("Extensions added from another source",M.identifier.id,Y.profileLocation.toString()),{identifier:M.identifier,local:M,profileLocation:Y.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(q=>this.rb.add(q)));const Y=await this.ib.resolve(this.fb.userExtensionsLocation);for(const q of Y.children??[])q.isDirectory&&this.rb.add(q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.tb(q)))}async tb(Y){if(!Y.affects(this.fb.userExtensionsLocation,1))return;const q=[];for(const S of Y.rawAdded){if(this.rb.has(S)||!this.D.extUri.isEqual(this.D.extUri.dirname(S),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(S,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(S).startsWith(".")||!(await this.ib.stat(S)).isDirectory)continue;const P=await this.bb.scanUserExtensionAtLocation(S);P&&P.installedTimestamp===void 0&&(this.rb.add(S),q.push(P))}q.length&&(await this.ub(q.map(S=>[S,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(S=>S.identifier.id)))}async ub(Y,q){const S=Y.map(P=>P[0]);await this.vb(S),await this.gb.addExtensionsToProfile(Y,q),this.s.fire(S.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:q})))}async vb(Y){const q=await this.bb.getUninstalledExtensions();for(const S of Y){const P=s.$po.create(S);q[P.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",P.id),await this.bb.setInstalled(P),this.F.info("Removed the extension from uninstalled list:",P.id))}}};e.$yp=Z,e.$yp=Z=ye([X(0,n.$Yn),X(1,x.$8k),X(2,U.$4i),X(3,i.$Ih),X(4,r.$np),X(5,t.$jp),X(6,I.$Cn),X(7,z.$zh),X(8,F.$5j),X(9,B.$jj),X(10,J.$Bk),X(11,Q.$Dk)],Z);let G=class extends $.$jc{constructor(Y,q,S,P,M,T){super(),this.j=Y,this.m=q,this.n=S,this.s=P,this.t=M,this.u=T,this.h=this.B(new R.$ed),this.onExtract=this.h.event,this.c=(0,h.$hg)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$Mg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(Y,q){const S={includeInvalid:!0,profileLocation:q};let P=[];return Y===null||Y===0?P.push(...await this.n.scanAllExtensions({includeInvalid:!0},S,!1)):Y===1&&P.push(...await this.n.scanUserExtensions(S)),P=Y!==null?P.filter(M=>M.type===Y):P,Promise.all(P.map(M=>this.F(M)))}async scanAllUserExtensions(Y){const q=await this.n.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return Promise.all(q.map(S=>this.F(S)))}async scanUserExtensionAtLocation(Y){try{const q=await this.n.scanExistingExtension(Y,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(Y,q,S,P,M){const T=Y.toString(),K=f.URI.file(d.$8d(this.n.userExtensionsLocation.fsPath,`.${(0,o.$3f)()}`)),_=f.URI.file(d.$8d(this.n.userExtensionsLocation.fsPath,T));let ae=await this.m.exists(_);if(ae&&P){try{await this.y(Y.id,_,"removeExisting")}catch{throw new n.$Zn(m.localize(4,null,_.fsPath,Y.id),n.ExtensionManagementErrorCode.Delete)}ae=!1}if(!ae)try{try{this.u.trace(`Started extracting the extension from ${q} to ${_.fsPath}`),await(0,w.$cp)(q,K.fsPath,{sourcePath:"extension",overwrite:!0},M),this.u.info(`Extracted extension to ${_}:`,Y.id)}catch(he){let fe=n.ExtensionManagementErrorCode.Extract;throw he instanceof w.$ap&&(he.type==="CorruptZip"?fe=n.ExtensionManagementErrorCode.CorruptZip:he.type==="Incomplete"&&(fe=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$Zn(he.message,fe)}await this.n.updateMetadata(K,S);try{this.u.trace(`Started renaming the extension from ${K.fsPath} to ${_.fsPath}`),await this.C(K.fsPath,_.fsPath),this.u.info("Renamed to",_.fsPath)}catch(he){if(he.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);else throw this.u.info(`Rename failed because of ${(0,j.$8)(he)}. Deleted from extracted location`,K),he}this.h.fire(_)}catch(he){try{await this.m.del(K,{recursive:!0})}catch{}throw he}return this.D(_,1)}async scanMetadata(Y,q){return q?(await this.w(Y,q))?.metadata:this.n.scanMetadata(Y.location)}async w(Y,q){return(await this.s.scanProfileExtensions(q)).find(P=>(0,s.$oo)(P.identifier,Y.identifier))}async updateMetadata(Y,q,S){return S?await this.s.updateMetadata([[Y,q]],S):await this.n.updateMetadata(Y.location,q),this.D(Y.location,Y.type,S)}getUninstalledExtensions(){return this.z()}async setUninstalled(...Y){const q=Y.map(S=>s.$po.create(S));await this.z(S=>q.forEach(P=>{S[P.toString()]=!0,this.u.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(Y){await this.z(q=>delete q[Y.toString()])}async removeExtension(Y,q){if(this.t.extUri.isEqualOrParent(Y.location,this.n.userExtensionsLocation))return this.y(Y.identifier.id,Y.location,q)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.z(q=>delete q[s.$po.create(Y).toString()])}async copyExtension(Y,q,S,P){const M=await this.w(Y,q),T=await this.w(Y,S);return P={...M?.metadata,...P},T?await this.s.updateMetadata([[Y,{...T.metadata,...P}]],S):await this.s.addExtensionsToProfile([[Y,P]],S),this.D(Y.location,Y.type,S)}async copyExtensions(Y,q){const S=await this.scanExtensions(1,Y),P=await Promise.all(S.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,Y)]));await this.s.addExtensionsToProfile(P,q)}async y(Y,q,S){this.u.trace(`Deleting ${S} extension from disk`,Y,q.fsPath);const P=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,k.$oi)((0,o.$3f)()).toString(16)}${W}`);await this.C(q.fsPath,P.fsPath),await this.m.del(P,{recursive:!0}),this.u.info(`Deleted ${S} extension from disk`,Y,q.fsPath)}async z(Y){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,F.$ik)(P)!==1)throw P}let S={};if(q)try{S=JSON.parse(q)}catch{}return Y&&(Y(S),Object.keys(S).length?await this.m.writeFile(this.c,N.$Ed.fromString(JSON.stringify(S))):await this.m.del(this.c)),S})}async C(Y,q){try{await l.Promises.rename(Y,q,2*60*1e3)}catch(S){throw new n.$Zn(S.message||m.localize(5,null,Y,q),S.code||n.ExtensionManagementErrorCode.Rename)}}async D(Y,q,S){if(S){const M=(await this.n.scanUserExtensions({profileLocation:S})).find(T=>this.t.extUri.isEqual(T.location,Y));if(M)return this.F(M)}else{const P=await this.n.scanExistingExtension(Y,q,{includeInvalid:!0});if(P)return this.F(P)}throw new Error(m.localize(6,null,Y.path))}async F(Y){const q=await this.m.resolve(Y.location);let S,P;return q.children&&(S=q.children.find(({name:M})=>/^readme(\.txt|\.md|)$/i.test(M))?.resource,P=q.children.find(({name:M})=>/^changelog(\.txt|\.md|)$/i.test(M))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:S,changelogUrl:P,publisherDisplayName:Y.metadata?.publisherDisplayName||null,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated,pinned:!!Y.metadata?.pinned}}async G(){const Y=await this.getUninstalledExtensions();if(Object.keys(Y).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(Y));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),S=new Set;for(const M of q)Y[s.$po.create(M).toString()]||S.add(M.identifier.id.toLowerCase());try{const M=(0,s.$uo)(q,T=>T.identifier);await O.Promises.settled(M.map(async T=>{const K=T.sort((_,ae)=>g.rcompare(_.manifest.version,ae.manifest.version))[0];S.has(K.identifier.id.toLowerCase())||await this.j(await this.F(K))}))}catch(M){this.u.error(M)}const P=q.filter(M=>M.metadata&&Y[s.$po.create(M).toString()]);await Promise.allSettled(P.map(M=>this.removeUninstalledExtension(M)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let Y;try{Y=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,F.$ik)(q)!==1&&this.u.error(q);return}if(Y?.children)try{await Promise.allSettled(Y.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(W))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(S){(0,F.$ik)(S)!==1&&this.u.error(S)}}}))}catch{}}};e.$zp=G,e.$zp=G=ye([X(1,F.$5j),X(2,r.$np),X(3,t.$jp),X(4,J.$Bk),X(5,U.$4i)],G);class H extends c.$hp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$pf)(this.options.operation)?this.l:this.options.operation}constructor(Y,q,S,P,M,T,K,_,ae){super(),this.identifier=Y,this.source=q,this.options=S,this.m=P,this.n=M,this.o=T,this.p=K,this.q=_,this.s=ae,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Y){const[q,S]=await this.x(Y);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,S]],this.j),q}async u({zipPath:Y,key:q,metadata:S},P,M){let T=await this.v(q);return T||(this.s.trace("Extracting extension...",q.id),T=await this.m.extractUserExtension(q,Y,S,P,M),this.s.info("Extracting extension completed.",q.id)),T}async v(Y){return await this.w(Y)?(this.s.trace("Removing the extension from uninstalled list:",Y.id),await this.m.setInstalled(Y),this.s.info("Removed the extension from uninstalled list:",Y.id),(await this.m.scanAllUserExtensions(!0)).find(P=>s.$po.create(P).equals(Y))):void 0}async w(Y){return!!(await this.m.getUninstalledExtensions())[Y.toString()]}}class V extends H{constructor(Y,q,S,P,M,T,K,_,ae,he){super(q.identifier,q,S,M,T,K,_,ae,he),this.y=q,this.z=P}async x(Y){const S=(await this.m.scanExtensions(null,this.options.profileLocation)).find(K=>(0,s.$oo)(K.identifier,this.y.identifier));S&&(this.l=3);const P={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||S?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||S?.isMachineScoped,isBuiltin:this.options.isBuiltin||S?.isBuiltin,isSystem:S?.type===0?!0:void 0,updated:!!S,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$of)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:S?.preRelease)};if(S?.manifest.version===this.y.version)return[await this.m.updateMetadata(S,P),P];const{location:M,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.B(M.fsPath),[await this.u({zipPath:M.fsPath,key:s.$po.create(this.y),metadata:P},!1,Y),P]}catch(K){try{await this.z.delete(M)}catch(_){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,j.$8)(_))}throw K}}async B(Y){try{await(0,b.$up)(Y)}catch(q){throw new n.$Zn((0,c.$fp)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$Ap=V;class ee extends H{constructor(Y,q,S,P,M,T,K,_,ae,he){super({id:(0,s.$to)(Y.publisher,Y.name)},q,S,M,T,K,_,ae,he),this.y=Y,this.z=q,this.A=P}async h(Y){const q=await super.h(Y);return this.D(q,Y),q}async x(Y){const q=new s.$po(this.identifier,this.y.version),P=(await this.m.scanExtensions(1,this.options.profileLocation)).find(K=>(0,s.$oo)(this.identifier,K.identifier)),M={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(P)if(this.l=3,q.equals(new s.$po(P.identifier,P.manifest.version)))try{await this.m.removeExtension(P,"existing")}catch{throw new Error(m.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(P.manifest.version,this.y.version)&&await this.m.setUninstalled(P);else{const K=await this.v(q);if(K)try{await this.m.removeExtension(K,"existing")}catch{throw new Error(m.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$9d(this.z.fsPath),key:q,metadata:M},!0,Y),M]}async D(Y,q){try{let[S]=await this.A.getExtensions([{id:Y.identifier.id,version:Y.manifest.version}],q);if(S||([S]=await this.A.getExtensions([{id:Y.identifier.id}],q)),S){const P={id:S.identifier.uuid,publisherDisplayName:S.publisherDisplayName,publisherId:S.publisherId,isPreReleaseVersion:S.properties.isPreReleaseVersion,preRelease:S.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Y,P,this.options.profileLocation)}}catch{}}}class ne extends c.$hp{constructor(Y,q,S){super(),this.extension=Y,this.j=q,this.k=S}async h(Y){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[265],oe([0,1,2,29,80,222,122,7,20]),function(te,e,O,N,A,L,j,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;let $=class extends O.$jc{constructor(E,d,h,g,y,f){super(),E.cleanUp(),(0,L.$SUb)(E,d,h,g,f),A.$Tz.removeOutdatedExtensionVersions(E,y)}};e.$Y7b=$,e.$Y7b=$=ye([X(0,j.$xp),X(1,N.$Yn),X(2,A.$Sz),X(3,N.$4n),X(4,k.$Uo),X(5,R.$4i)],$)}),define(re[123],oe([0,1,69,61,36,275,14,8,3,2,16,6,32,43,65]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0;class y{traceSocketEvent(u,p){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,p)}constructor(u,p=""){this.f=!0,this.debugLabel=p,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,R.$Y)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const p=D=>{this.traceSocketEvent("read",D),u(j.$Ed.wrap(D))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(u){const p=D=>{u({type:0,hadError:D,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(u){const p=()=>{u()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,R.$Y)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,R.$Y)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$ph=y;var f;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var o;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(o||(o={}));class l extends $.$jc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,p){this.socket.traceSocketEvent(u,p)}constructor(u,p,D,F){super(),this.f=this.B(new k.$ed),this.g=this.B(new k.$ed),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:D?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new w(this,p,D,F,this.f,(z,U)=>this.m(z,U))),this.B(this.a.onError(z=>{console.error(z),(0,R.$Y)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new g.$kh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let p=0;for(;p<u.byteLength;)this.a.writeMessage(u.slice(p,Math.min(p+262144,u.byteLength))),p+=262144}m(u,p){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let D=2;u.byteLength<126?D+=0:u.byteLength<2**16?D+=2:D+=8;const F=j.$Ed.alloc(D);if(p?F.writeUInt8(194,0):F.writeUInt8(130,0),u.byteLength<126)F.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){F.writeUInt8(126,1);let z=1;F.writeUInt8(u.byteLength>>>8&255,++z),F.writeUInt8(u.byteLength>>>0&255,++z)}else{F.writeUInt8(127,1);let z=1;F.writeUInt8(0,++z),F.writeUInt8(0,++z),F.writeUInt8(0,++z),F.writeUInt8(0,++z),F.writeUInt8(u.byteLength>>>24&255,++z),F.writeUInt8(u.byteLength>>>16&255,++z),F.writeUInt8(u.byteLength>>>8&255,++z),F.writeUInt8(u.byteLength>>>0&255,++z)}this.socket.write(j.$Ed.concat([F,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),D=p.readUInt8(0),F=(D&128)>>>7,z=(D&64)>>>6,U=p.readUInt8(1),B=(U&128)>>>7,x=U&127;this.j.state=2,this.j.readLen=2+(B?4:0)+(x===126?2:0)+(x===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),D=p.readUInt8(1),F=(D&128)>>>7;let z=D&127,U=1;z===126?z=p.readUInt8(++U)*2**8+p.readUInt8(++U):z===127&&(z=p.readUInt8(++U)*0+p.readUInt8(++U)*0+p.readUInt8(++U)*0+p.readUInt8(++U)*0+p.readUInt8(++U)*2**24+p.readUInt8(++U)*2**16+p.readUInt8(++U)*2**8+p.readUInt8(++U));let B=0;F&&(B=p.readUInt8(++U)*2**24+p.readUInt8(++U)*2**16+p.readUInt8(++U)*2**8+p.readUInt8(++U)),this.j.state=3,this.j.readLen=z,this.j.mask=B,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),i(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(p,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$qh=l;class w extends $.$jc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:j.$Ed.alloc(0)}constructor(u,p,D,F,z,U){super(),this.n=u,this.r=z,this.s=U,this.a=this.B(new k.$ed),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$ed),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$ed),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,p?(this.b=this.B(new m(this.n,F,D,{windowBits:15})),this.f=this.B(new I(this.n,{windowBits:15})),this.B(this.b.onError(B=>this.a.fire(B))),this.B(this.f.onError(B=>this.a.fire(B)))):(this.b=null,this.f=null)}writeMessage(u){this.g.push(u),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const u=this.g.shift();if(this.f){const p=await this.w(this.f,u);this.s(p,!0)}else this.s(u,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,p){return new Promise((D,F)=>{u.write(p),u.flush(z=>D(z))})}acceptFrame(u,p,D){this.h.push({data:u,isCompressed:p,isLastFrameOfMessage:D}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const p=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire(p)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,p,D){return new Promise((F,z)=>{u.write(p),D&&u.write(j.$Ed.fromByteArray([0,0,255,255])),u.flush(U=>F(U))})}}class m extends $.$jc{get recordedInflateBytes(){return this.j?j.$Ed.concat(this.f):j.$Ed.alloc(0)}constructor(u,p,D,F){super(),this.h=u,this.j=p,this.a=this.B(new k.$ed),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(F),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(j.$Ed.wrap(z))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=j.$Ed.concat(this.g);this.g.length=0,u(p)})}}class I extends $.$jc{constructor(u,p){super(),this.g=u,this.a=this.B(new k.$ed),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(j.$Ed.wrap(D))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=j.$Ed.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),u(p)})}}function i(b,u){if(u===0)return;const p=b.byteLength>>>2;for(let x=0;x<p;x++){const J=b.readUInt32BE(x*4);b.writeUInt32BE(J^u,x*4)}const D=p*4,F=b.byteLength-D,z=u>>>24&255,U=u>>>16&255,B=u>>>8&255;F>=1&&b.writeUInt8(b.readUInt8(D)^z,D),F>=2&&b.writeUInt8(b.readUInt8(D+1)^U,D+1),F>=3&&b.writeUInt8(b.readUInt8(D+2)^B,D+2)}e.$rh=process.env.XDG_RUNTIME_DIR;const c={[2]:107,[1]:103};function n(){const b=(0,d.$3f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const u=process.platform!=="darwin"&&e.$rh?e.$rh:(0,A.tmpdir)(),p=(0,C.$8d)(u,`vscode-ipc-${b}.sock`);return t(p),p}e.$sh=n;function s(b,u,p){const D=(0,O.createHash)("md5").update(b).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${p}-${u}-sock`;const F=p.substr(0,4),z=u.substr(0,6),U=D.substr(0,8);let B;return process.platform!=="darwin"&&e.$rh&&!process.env.VSCODE_PORTABLE?B=(0,C.$8d)(e.$rh,`vscode-${U}-${F}-${z}.sock`):B=(0,C.$8d)(b,`${F}-${z}.sock`),t(B),B}e.$th=s;function t(b){const u=c[E.$t];typeof u=="number"&&b.length>=u&&console.warn(`WARNING: IPC handle "${b}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends h.$eh{static b(u){const p=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(p,D=>({protocol:new g.$lh(new y(D,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(D,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$uh=r;function a(b){return new Promise((u,p)=>{const D=(0,N.createServer)();D.on("error",p),D.listen(b,()=>{D.removeListener("error",p),u(new r(D))})})}e.$vh=a;function v(b,u){return new Promise((p,D)=>{const F=(0,N.createConnection)(b,()=>{F.removeListener("error",D),p(g.$mh.fromSocket(new y(F,`ipc-client${u}`),u))});F.once("error",D)})}e.$wh=v}),define(re[266],oe([0,1,61,123,210]),function(te,e,O,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=void 0,e.$87b=new class{supports(L){return!0}connect({host:L,port:j},R,k,$){return new Promise((C,E)=>{const d=O.createConnection({host:L,port:j},()=>{d.removeListener("error",E),d.write((0,A.$pkb)(R,k,$));const h=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(d.off("data",h),C(new N.$ph(d,$)))};d.on("data",h)});d.setNoDelay(!0),d.once("error",E)})}}}),define(re[267],oe([0,1,61,36,134,123,5,2,6,19,7,24,213,104,106,76,14]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=e.$36b=e.$26b=e.$16b=void 0;async function o(i,c,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new l(i,c,n,s,t).waitForReady(),!(t&&A.$6f[t]||!A.$6f[r.tunnelLocalPort]));a--);return r}class l extends R.$jc{constructor(c,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=c,this.b=O.createServer(),this.c=new j.$Eg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const c=this.n??this.tunnelRemotePort,n=(0,y.$3z)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,A.$7f)(c,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(c){c.pause();const n=(0,y.$1z)(this.tunnelRemoteHost)||(0,y.$3z)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,d.$Yk)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&c.write(r.buffer),c.on("end",()=>{c.localAddress&&this.j.delete(c.localAddress),t.end()}),c.on("close",()=>t.end()),c.on("error",()=>{c.localAddress&&this.j.delete(c.localAddress),t instanceof L.$ph?t.socket.destroy():t.end()}),t instanceof L.$ph?this.t(c,t):this.s(c,t),c.localAddress&&this.j.set(c.localAddress,()=>{c.end(),t.end()})}s(c,n){n.onClose(()=>c.destroy()),n.onEnd(()=>c.end()),n.onData(s=>c.write(s.buffer)),c.on("data",s=>n.write(f.$Ed.wrap(s))),c.resume()}t(c,n){const s=n.socket;s.on("end",()=>c.end()),s.on("close",()=>c.end()),s.on("error",()=>{c.destroy()}),s.pipe(c),c.pipe(s)}}e.$16b=l;let w=class extends y.$6z{constructor(c,n,s,t,r){super(n,r),this.u=c,this.v=s,this.w=t}isPortPrivileged(c){return(0,y.$4z)(c,this.l,k.OS,N.release())}s(c,n,s,t,r,a,v,b){const u=this.r(n,s);if(u)return++u.refcount,u.value;if((0,y.$Xz)(c))return this.t(c,n,s,r,a,v,b);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const p={commit:this.w.commit,quality:this.w.quality,addressProvider:c,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},D=o(p,t,n,s,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(n,s,D),D}}};e.$26b=w,e.$26b=w=ye([X(0,h.$Sk),X(1,C.$4i),X(2,g.$Vk),X(3,E.$jj),X(4,$.$7h)],w);let m=class extends w{constructor(c,n,s,t,r){super(c,n,s,t,r)}};e.$36b=m,e.$36b=m=ye([X(0,h.$Sk),X(1,C.$4i),X(2,g.$Vk),X(3,E.$jj),X(4,$.$7h)],m);let I=class extends R.$jc{constructor(c,n,s,t,r){super(),this.b=c,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(c,n,s,t,r,a,v,b,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(c)){const p=new m(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(c,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(n,s,t,r,a,v,b,u)}};e.$46b=I,e.$46b=I=ye([X(0,h.$Sk),X(1,C.$4i),X(2,E.$jj),X(3,g.$Vk),X(4,$.$7h)],I)}),define(re[276],oe([0,1,36,38,8,2,23,11,18,3,43,147,204,205,196,197,262,187,189,19,209,95,220,96,215,15,114,247,29,97,188,122,98,12,199,200,68,4,195,70,72,225,7,201,102,24,57,20,107,22,108,109,110,46,228,80,111,25,78,254,238,239,81,253,257,258,259,58,252,241,106,219,76,267,214,229,28,230,6,231,190,207,206,79,246,17,50,203,56,251,227,242,105,256,265,10,202,101,249,245,216,184,55,260,248,71,250,104,266,182,112,240,217]),function(te,e,O,N,A,L,j,R,k,$,C,E,d,h,g,y,f,o,l,w,m,I,i,c,n,s,t,r,a,v,b,u,p,D,F,z,U,B,x,J,Q,W,Z,G,H,V,ee,ne,se,Y,q,S,P,M,T,K,_,ae,he,fe,le,$e,de,we,Ee,Oe,Le,Te,ce,ge,be,ke,Pe,ze,je,Ue,Fe,ie,ue,me,pe,Se,Re,Ce,Ie,De,Ae,Ne,qe,Be,Ve,xe,ut,vt,Et,St,kt,ft,Ct,Pt,Rt,It,Ot,jt,Dt,dt,At,gt,Lt,Nt,$t,Mt,tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends L.$jc{constructor(ve){super(),this.f=ve,this.a=this.B(new E.$ZS(this)),this.b=void 0,this.c=this.B(new $.$ed),this.g()}g(){let ve=!1;const Me=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Me),(0,E.$1S)(process.parentPort,tt.$f6b.exit,Me)}async init(){const ve=await this.h();(0,ae.$pgb)(),ve.invokeFunction(Me=>{const Ke=Me.get(Z.$4i);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Me),this.m(Ke)}),this.B((0,L.$gc)(ve.createInstance(d.$u7b,this.f.codeCachePath),ve.createInstance(h.$v7b),ve.createInstance(f.$y7b),ve.createInstance(y.$x7b),ve.createInstance(g.$w7b),ve.createInstance(Et.$Y7b),ve.createInstance(xe.$Q7b),ve.createInstance(Mt.$$7b,this.c.event)))}async h(){const ve=new J.$yh,Me={_serviceBrand:void 0,...H.default};ve.set(V.$jj,Me);const Ke=new C.$ih(He=>He==="main"),We=new dt.$$6b(this.a,Ke);ve.set(dt.$06b,We);const nt=this.f.policiesData?new Ne.$J6b(this.f.policiesData,We.getChannel("policy")):new qe.$$m;ve.set(qe.$9m,nt);const Ge=new Nt.$$l(this.f.args,Me);ve.set(s.$Ih,Ge);const Ze=new G.$Zq(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),We.getChannel("logger"));ve.set(Z.$5i,Ze);const st=this.B(Ze.createLogger("sharedprocess",{name:(0,St.localize)(0,null)})),ct=this.B(new Z.$_i(st.getLevel())),Je=this.B(new kt.$iN(st,[ct]));ve.set(Z.$4i,Je),this.b=this.B(new ft.$17b(Je)),ve.set(ft.$Z7b,this.b);const Ye=this.B(new F.$Cp(Je));ve.set(D.$5j,Ye);const lt=this.B(new z.$2p(Je));Ye.registerProvider(j.Schemas.file,lt);const rt=new ie.$or(Ye);ve.set(Fe.$Bk,rt);const Xe=this.B(new Be.$pN(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));ve.set(De.$Dk,Xe);const ht=this.B(new me.$96b(j.Schemas.file,this.B(new pe.$4M(We.getChannel(pe.$3M),{pathCaseSensitive:ue.$k})),j.Schemas.vscodeUserData,Xe,rt,Je));Ye.registerProvider(j.Schemas.vscodeUserData,ht);const Qe=this.B(new m.$yn(Xe.defaultProfile.settingsResource,Ye,nt,Je));ve.set(w.$7h,Qe);const _e=new At.$77b(void 0,{defaultProfile:Xe.defaultProfile,currentProfile:Xe.defaultProfile},We,Ge);ve.set(ne.$Uo,_e),this.B((0,L.$hc)(()=>_e.flush())),await Promise.all([Qe.initialize(),_e.initialize()]);const bt=new Rt.$Lq(We.getChannel("request"));ve.set(ee.$Ho,bt),ve.set(o.$z7b,new U.$xh(l.$A7b,void 0,!1)),ve.set(Re.$BF,new U.$xh(Se.$P7b,void 0,!1));const wt=C.ProxyChannel.toService(We.getChannel("nativeHost"));ve.set(Ot.$S5b,wt),ve.set(c.$Cn,new U.$xh(n.$xN,void 0,!0));const Tt=this.B(new ge.$G6b(wt)),zt=new C.$ih(He=>Tt.getActiveClientId().then(at=>He===at));ve.set(p.$CUb,new It.$37b(this.a.getChannel("extensionRecommendationNotification",zt)));let ot;const et=[],yt=(0,M.$lo)(Me,Qe);if((0,M.$go)(Me,Ge)){const He=new S.$N3b(Je,Ze,Ge,Me);if(et.push(He),Me.aiConfig?.ariaKey){const at=new Ve.$9M(bt,yt,"monacoworkbench",null,Me.aiConfig.ariaKey);this.B((0,L.$hc)(()=>at.flush())),et.push(at)}ot=new P.$Pq({appenders:et,commonProperties:(0,se.$9n)((0,O.release)(),(0,O.hostname)(),process.arch,Me.commit,Me.version,this.f.machineId,yt),sendErrorTelemetry:!0,piiPaths:(0,M.$mo)(Ge)},Qe,Me)}else{ot=M.$ao;const He=M.$eo;et.push(He)}this.a.registerChannel("telemetryAppender",new q.$k6b(et)),ve.set(Y.$8k,ot);const Ut=new T.$B7b(Qe,ot,Je,Ze,Ge,Me);ve.set(Y.$9k,Ut),ve.set(Ae.$jp,new U.$xh(Pt.$hN,void 0,!0)),ve.set(Ce.$np,new U.$xh(Ie.$K6b,void 0,!0)),ve.set(v.$6o,new U.$xh(v.$7o,void 0,!0)),ve.set(u.$xp,new U.$xh(u.$yp,void 0,!0)),ve.set(a.$Yn,new U.$xh(r.$4o,void 0,!0)),ve.set(a.$5n,new U.$xh(Dt.$67b,void 0,!1)),ve.set(Q.$Hq,new U.$xh(W.$Jq,void 0,!1)),ve.set(I.$fm,new U.$xh(i.$vr,void 0,!1)),ve.set(he.$uzb,new U.$xh(he.$vzb,void 0,!0)),ve.set(ae.$Kgb,new U.$xh($e.$HBb,void 0,!0)),ve.set(ae.$Jgb,new le.$E7b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ve.set(a.$4n,new U.$xh(t.$szb,void 0,!1)),ve.set(_.$FBb,new U.$xh(_.$GBb,void 0,!0)),ve.set(K.$Sz,new U.$xh(K.$Tz)),ve.set(ae.$ugb,new U.$xh(Le.$QAb,void 0,!0)),ve.set(ae.$vgb,new U.$xh(Le.$SAb,void 0,!0)),ve.set(de.$igb,new U.$xh(de.$kgb,void 0,!0)),ve.set(ae.$wgb,new U.$xh(fe.$p4b,void 0,!1)),ve.set(ae.$Fgb,new U.$xh(we.$e4b,void 0,!0)),ve.set(ae.$Ggb,new U.$xh(Ee.$u4b,void 0,!1)),ve.set(Te.$7zb,new U.$xh(ce.$L7b,void 0,!0)),ve.set(ae.$Hgb,new U.$xh(vt.$74b,void 0,!0)),ve.set(be.$Vk,new U.$xh(ke.$66b,void 0,!1));const pt=new gt.$Tk;return ve.set(gt.$Sk,pt),pt.register(0,Lt.$87b),ve.set(Pe.$Wz,new U.$xh(ze.$46b)),ve.set(je.$M7b,new U.$xh(Ue.$O7b)),ve.set(ut.$R7b,new U.$xh(Ct.$27b)),ve.set($t.$97b,new U.$xh($t.$07b)),new x.$5p(ve)}j(ve){const Me=this.B(new L.$ic),Ke=new b.$9o(ve.get(a.$1n),()=>null);this.a.registerChannel("extensions",Ke);const We=C.ProxyChannel.fromService(ve.get(Q.$Hq),Me);this.a.registerChannel("languagePacks",We);const nt=C.ProxyChannel.fromService(ve.get(I.$fm),Me);this.a.registerChannel("diagnostics",nt);const Ge=new b.$$o(ve.get(a.$5n));this.a.registerChannel("extensionTipsService",Ge);const Ze=C.ProxyChannel.fromService(ve.get(o.$z7b),Me);this.a.registerChannel("checksum",Ze);const st=C.ProxyChannel.fromService(ve.get(Re.$BF),Me);this.a.registerChannel("v8InspectProfiling",st);const ct=new le.$F7b(ve.get(de.$igb));this.a.registerChannel("userDataSyncMachines",ct);const Je=C.ProxyChannel.fromService(ve.get(Y.$9k),Me);this.a.registerChannel("customEndpointTelemetry",Je);const Ye=new le.$G7b(ve.get(he.$uzb));this.a.registerChannel("userDataSyncAccount",Ye);const lt=new le.$H7b(ve.get(ae.$ugb));this.a.registerChannel("userDataSyncStoreManagement",lt);const rt=new Oe.$J7b(ve.get(ae.$Ggb),ve.get(De.$Dk),ve.get(Z.$4i));this.a.registerChannel("userDataSync",rt);const Xe=this.B(ve.get(B.$zh).createInstance(jt.$57b)),ht=new le.$C7b(Xe);this.a.registerChannel("userDataAutoSync",ht),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(ve.get(ae.$Hgb),Me));const Qe=C.ProxyChannel.fromService(ve.get(je.$M7b),Me);this.a.registerChannel(je.$N7b,Qe);const _e=C.ProxyChannel.fromService(ve.get(ut.$R7b),Me);this.a.registerChannel("remoteTunnel",_e)}m(ve){process.on("uncaughtException",Me=>(0,A.$Y)(Me)),process.on("unhandledRejection",Me=>(0,A.$Y)(Me)),(0,A.setUnexpectedErrorHandler)(Me=>{const Ke=(0,N.$li)(Me,!0);Ke&&ve.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}handledClientConnection(ve){if(ve.data!==tt.$h6b.response)return!1;const Me=(0,k.$Lb)(ve.ports);return Me?(this.c.fire(Me),!0):!1}}async function mt(it){const ve=new Ft(it);process.parentPort.postMessage(tt.$f6b.ipcReady),await ve.init(),process.parentPort.postMessage(tt.$f6b.initDone)}e.main=mt,process.parentPort.once("message",it=>{mt(it.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bccfade64adb249f57c8fcf03cba41609f76ce5c/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
