/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(be){for(var e=[],w=0,F=be.length;w<F;w++)e[w]=Ae[be[w]];return e};define(Ae[64],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7g=e.$6g=e.$5g=void 0;function w(A){return(l,S,d)=>{let P=null,D=null;if(typeof d.value=="function"?(P="value",D=d.value):typeof d.get=="function"&&(P="get",D=d.get),!D)throw new Error("not supported");d[P]=A(D,S)}}function F(A,l,S){let d=null,P=null;if(typeof S.value=="function"?(d="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(d="get",P=S.get),!P)throw new Error("not supported");const D=`$memoize$${l}`;S[d]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[D]}}e.$5g=F;function C(A,l,S){return w((d,P)=>{const D=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...b){this[u]||(this[u]=S?S():void 0),clearTimeout(this[D]),l&&(this[u]=l(this[u],...b),b=[this[u]]),this[D]=setTimeout(()=>{d.apply(this,b),this[u]=S?S():void 0},A)}})}e.$6g=C;function L(A,l,S){return w((d,P)=>{const D=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,b=`$throttle$lastRun$${P}`,p=`$throttle$pending$${P}`;return function(...f){if(this[u]||(this[u]=S?S():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),l&&(this[u]=l(this[u],...f)),this[p])return;const i=this[b]+A;i<=Date.now()?(this[b]=Date.now(),d.apply(this,[this[u]]),this[u]=S?S():void 0):(this[p]=!0,this[D]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),d.apply(this,[this[u]]),this[u]=S?S():void 0},i-Date.now()))}})}e.$7g=L}),define(Ae[88],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=void 0;class w{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$3L=w,e.$4L=new w("id#")}),define(Ae[116],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var F;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var C;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var L;(function(s){s.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(s,a=!1){let n=0;const o=s.length;let y="",m=0,I=16,k=0;function r(B){let O=0,N=0;for(;O<B;){const ee=s.charCodeAt(n);if(ee>=48&&ee<=57)N=N*16+ee-48;else if(ee>=65&&ee<=70)N=N*16+ee-65+10;else if(ee>=97&&ee<=102)N=N*16+ee-97+10;else break;n++,O++}return O<B&&(N=-1),N}function h(B){n=B,y="",m=0,I=16,k=0}function v(){const B=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&d(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&d(s.charCodeAt(n)))for(n++;n<s.length&&d(s.charCodeAt(n));)n++;else return k=3,s.substring(B,n);let O=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&d(s.charCodeAt(n))){for(n++;n<s.length&&d(s.charCodeAt(n));)n++;O=n}else k=3;return s.substring(B,O)}function R(){let B="",O=n;for(;;){if(n>=o){B+=s.substring(O,n),k=2;break}const N=s.charCodeAt(n);if(N===34){B+=s.substring(O,n),n++;break}if(N===92){if(B+=s.substring(O,n),n++,n>=o){k=2;break}switch(s.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const Y=r(4);Y>=0?B+=String.fromCharCode(Y):k=4;break}default:k=5}O=n;continue}if(N>=0&&N<=31)if(S(N)){B+=s.substring(O,n),k=2;break}else k=6;n++}return B}function W(){if(y="",k=0,m=n,n>=o)return m=o,I=17;let B=s.charCodeAt(n);if(l(B)){do n++,y+=String.fromCharCode(B),B=s.charCodeAt(n);while(l(B));return I=15}if(S(B))return n++,y+=String.fromCharCode(B),B===13&&s.charCodeAt(n)===10&&(n++,y+=`
`),I=14;switch(B){case 123:return n++,I=1;case 125:return n++,I=2;case 91:return n++,I=3;case 93:return n++,I=4;case 58:return n++,I=6;case 44:return n++,I=5;case 34:return n++,y=R(),I=10;case 47:{const O=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<o&&!S(s.charCodeAt(n));)n++;return y=s.substring(O,n),I=12}if(s.charCodeAt(n+1)===42){n+=2;const N=o-1;let ee=!1;for(;n<N;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,ee=!0;break}n++}return ee||(n++,k=1),y=s.substring(O,n),I=13}return y+=String.fromCharCode(B),n++,I=16}case 45:if(y+=String.fromCharCode(B),n++,n===o||!d(s.charCodeAt(n)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return y+=v(),I=11;default:for(;n<o&&V(B);)n++,B=s.charCodeAt(n);if(m!==n){switch(y=s.substring(m,n),y){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return y+=String.fromCharCode(B),n++,I=16}}function V(B){if(l(B)||S(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let B;do B=W();while(B>=12&&B<=15);return B}return{setPosition:h,getPosition:()=>n,scan:a?U:W,getToken:()=>I,getTokenValue:()=>y,getTokenOffset:()=>m,getTokenLength:()=>n-m,getTokenError:()=>k}}e.$Im=A;function l(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function S(s){return s===10||s===13||s===8232||s===8233}function d(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function D(s,a){const n=[],o=new Object;let y;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function k(r,h,v,R){m.value=r,m.offset=h,m.length=v,m.type=R,m.colonOffset=void 0,y=m}try{g(s,{onObjectBegin:(r,h)=>{if(a<=r)throw o;y=void 0,I=a>r,n.push("")},onObjectProperty:(r,h,v)=>{if(a<h||(k(r,h,v,"property"),n[n.length-1]=r,a<=h+v))throw o},onObjectEnd:(r,h)=>{if(a<=r)throw o;y=void 0,n.pop()},onArrayBegin:(r,h)=>{if(a<=r)throw o;y=void 0,n.push(0)},onArrayEnd:(r,h)=>{if(a<=r)throw o;y=void 0,n.pop()},onLiteralValue:(r,h,v)=>{if(a<h||(k(r,h,v,$(r)),a<=h+v))throw o},onSeparator:(r,h,v)=>{if(a<=h)throw o;if(r===":"&&y&&y.type==="property")y.colonOffset=h,I=!1,y=void 0;else if(r===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(I=!0,n[n.length-1]=""),y=void 0}}})}catch(r){if(r!==o)throw r}return{path:n,previousNode:y,isAtPropertyKey:I,matches:r=>{let h=0;for(let v=0;h<r.length&&v<n.length;v++)if(r[h]===n[v]||r[h]==="*")h++;else if(r[h]!=="**")return!1;return h===r.length}}}e.$Jm=D;function u(s,a=[],n=L.DEFAULT){let o=null,y=[];const m=[];function I(r){Array.isArray(y)?y.push(r):o!==null&&(y[o]=r)}return g(s,{onObjectBegin:()=>{const r={};I(r),m.push(y),y=r,o=null},onObjectProperty:r=>{o=r},onObjectEnd:()=>{y=m.pop()},onArrayBegin:()=>{const r=[];I(r),m.push(y),y=r,o=null},onArrayEnd:()=>{y=m.pop()},onLiteralValue:I,onError:(r,h,v)=>{a.push({error:r,offset:h,length:v})}},n),y[0]}e.$Km=u;function b(s,a=[],n=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function y(r){o.type==="property"&&(o.length=r-o.offset,o=o.parent)}function m(r){return o.children.push(r),r}g(s,{onObjectBegin:r=>{o=m({type:"object",offset:r,length:-1,parent:o,children:[]})},onObjectProperty:(r,h,v)=>{o=m({type:"property",offset:h,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:r,offset:h,length:v,parent:o})},onObjectEnd:(r,h)=>{o.length=r+h-o.offset,o=o.parent,y(r+h)},onArrayBegin:(r,h)=>{o=m({type:"array",offset:r,length:-1,parent:o,children:[]})},onArrayEnd:(r,h)=>{o.length=r+h-o.offset,o=o.parent,y(r+h)},onLiteralValue:(r,h,v)=>{m({type:$(r),offset:h,length:v,parent:o,value:r}),y(h+v)},onSeparator:(r,h,v)=>{o.type==="property"&&(r===":"?o.colonOffset=h:r===","&&y(h))},onError:(r,h,v)=>{a.push({error:r,offset:h,length:v})}},n);const k=o.children[0];return k&&delete k.parent,k}e.$Lm=b;function p(s,a){if(!s)return;let n=s;for(const o of a)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let y=!1;for(const m of n.children)if(Array.isArray(m.children)&&m.children[0].value===o){n=m.children[1],y=!0;break}if(!y)return}else{const y=o;if(n.type!=="array"||y<0||!Array.isArray(n.children)||y>=n.children.length)return;n=n.children[y]}return n}e.$Mm=p;function f(s){if(!s.parent||!s.parent.children)return[];const a=f(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;a.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&a.push(n)}return a}e.$Nm=f;function i(s){switch(s.type){case"array":return s.children.map(i);case"object":{const a=Object.create(null);for(const n of s.children){const o=n.children[1];o&&(a[n.children[0].value]=i(o))}return a}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$Om=i;function t(s,a,n=!1){return a>=s.offset&&a<s.offset+s.length||n&&a===s.offset+s.length}e.$Pm=t;function c(s,a,n=!1){if(t(s,a,n)){const o=s.children;if(Array.isArray(o))for(let y=0;y<o.length&&o[y].offset<=a;y++){const m=c(o[y],a,n);if(m)return m}return s}}e.$Qm=c;function g(s,a,n=L.DEFAULT){const o=A(s,!1);function y(ye){return ye?()=>ye(o.getTokenOffset(),o.getTokenLength()):()=>!0}function m(ye){return ye?ce=>ye(ce,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=y(a.onObjectBegin),k=m(a.onObjectProperty),r=y(a.onObjectEnd),h=y(a.onArrayBegin),v=y(a.onArrayEnd),R=m(a.onLiteralValue),W=m(a.onSeparator),V=y(a.onComment),U=m(a.onError),B=n&&n.disallowComments,O=n&&n.allowTrailingComma;function N(){for(;;){const ye=o.scan();switch(o.getTokenError()){case 4:ee(14);break;case 5:ee(15);break;case 3:ee(13);break;case 1:B||ee(11);break;case 2:ee(12);break;case 6:ee(16);break}switch(ye){case 12:case 13:B?ee(10):V();break;case 16:ee(1);break;case 15:case 14:break;default:return ye}}}function ee(ye,ce=[],$e=[]){if(U(ye),ce.length+$e.length>0){let ie=o.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){N();break}else if($e.indexOf(ie)!==-1)break;ie=N()}}}function Y(ye){const ce=o.getTokenValue();return ye?R(ce):k(ce),N(),!0}function Ee(){switch(o.getToken()){case 11:{let ye=0;try{ye=JSON.parse(o.getTokenValue()),typeof ye!="number"&&(ee(2),ye=0)}catch{ee(2)}R(ye);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return N(),!0}function ke(){return o.getToken()!==10?(ee(3,[],[2,5]),!1):(Y(!1),o.getToken()===6?(W(":"),N(),ue()||ee(4,[],[2,5])):ee(5,[],[2,5]),!0)}function Pe(){I(),N();let ye=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ye||ee(4,[],[]),W(","),N(),o.getToken()===2&&O)break}else ye&&ee(6,[],[]);ke()||ee(4,[],[2,5]),ye=!0}return r(),o.getToken()!==2?ee(7,[2],[]):N(),!0}function Z(){h(),N();let ye=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ye||ee(4,[],[]),W(","),N(),o.getToken()===4&&O)break}else ye&&ee(6,[],[]);ue()||ee(4,[],[4,5]),ye=!0}return v(),o.getToken()!==4?ee(8,[4],[]):N(),!0}function ue(){switch(o.getToken()){case 3:return Z();case 1:return Pe();case 10:return Y(!0);default:return Ee()}}return N(),o.getToken()===17?n.allowEmptyContent?!0:(ee(4,[],[]),!1):ue()?(o.getToken()!==17&&ee(9,[],[]),!0):(ee(4,[],[]),!1)}e.$Rm=g;function E(s,a){const n=A(s),o=[];let y,m=0,I;do switch(I=n.getPosition(),y=n.scan(),y){case 12:case 13:case 17:m!==I&&o.push(s.substring(m,I)),a!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,a)),m=n.getPosition();break}while(y!==17);return o.join("")}e.$Sm=E;function $(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$Tm=$}),define(Ae[28],Re([1,0]),function(be,e){"use strict";var w,F,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.Touch=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;function L(i,t,c){let g=i.get(t);return g===void 0&&(g=c,i.set(t,g)),g}e.$vi=L;function A(i){const t=[];return i.forEach((c,g)=>{t.push(`${g} => ${c}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.$wi=A;function l(i){const t=[];return i.forEach(c=>{t.push(c)}),`Set(${i.size}) {${t.join(", ")}}`}e.$xi=l;class S{constructor(t,c){this.uri=t,this.value=c}}class d{static{this.a=t=>t.toString()}constructor(t,c){this[w]="ResourceMap",t instanceof d?(this.b=new Map(t.b),this.c=c??d.a):(this.b=new Map,this.c=t??d.a)}set(t,c){return this.b.set(this.c(t),new S(t,c)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[g,E]of this.b)t(E.value,E.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.$yi=d;class P{constructor(t,c){this[F]="ResourceSet",!t||typeof t=="function"?this.a=new d(t):(this.a=new d(c),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,c){this.a.forEach((g,E)=>t.call(c,E,E,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zi=P;var D;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(D||(e.Touch=D={}));class u{constructor(){this[C]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,c=0){const g=this.a.get(t);if(g)return c!==0&&this.j(g,c),g.value}set(t,c,g=0){let E=this.a.get(t);if(E)E.value=c,g!==0&&this.j(E,g);else{switch(E={key:t,value:c,next:void 0,previous:void 0},g){case 0:this.h(E);break;case 1:this.g(E);break;case 2:this.h(E);break;default:this.h(E);break}this.a.set(t,E),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this.a.get(t);if(c)return this.a.delete(t),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,c){const g=this.e;let E=this.b;for(;E;){if(c?t.bind(c)(E.value,E.key,this):t(E.value,E.key,this),this.e!==g)throw new Error("LinkedMap got modified during iteration.");E=E.next}}keys(){const t=this,c=this.e;let g=this.b;const E={[Symbol.iterator](){return E},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:g.key,done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return E}values(){const t=this,c=this.e;let g=this.b;const E={[Symbol.iterator](){return E},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:g.value,done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return E}entries(){const t=this,c=this.e;let g=this.b;const E={[Symbol.iterator](){return E},next(){if(t.e!==c)throw new Error("LinkedMap got modified during iteration.");if(g){const $={value:[g.key,g.value],done:!1};return g=g.next,$}else return{value:void 0,done:!0}}};return E}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.b,g=this.size;for(;c&&g>t;)this.a.delete(c.key),c=c.next,g--;this.b=c,this.d=g,c&&(c.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const c=t.next,g=t.previous;if(!c||!g)throw new Error("Invalid list");c.previous=g,g.next=c}t.next=void 0,t.previous=void 0,this.e++}j(t,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this.b)return;const g=t.next,E=t.previous;t===this.c?(E.next=void 0,this.c=E):(g.previous=E,E.next=g),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(c===2){if(t===this.c)return;const g=t.next,E=t.previous;t===this.b?(g.previous=void 0,this.b=g):(g.previous=E,E.next=g),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((c,g)=>{t.push([g,c])}),t}fromJSON(t){this.clear();for(const[c,g]of t)this.set(c,g)}}e.$Ai=u;class b extends u{constructor(t,c=1){super(),this.k=t,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bi=b;class p{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let c=this.a.get(t)||0;return c===0?!1:(c--,c===0?this.a.delete(t):this.a.set(t,c),!0)}has(t){return this.a.has(t)}}e.$Ci=p;class f{constructor(t){if(this.a=new Map,this.b=new Map,t)for(const[c,g]of t)this.set(c,g)}clear(){this.a.clear(),this.b.clear()}set(t,c){this.a.set(t,c),this.b.set(c,t)}get(t){return this.a.get(t)}getKey(t){return this.b.get(t)}delete(t){const c=this.a.get(t);return c===void 0?!1:(this.a.delete(t),this.b.delete(c),!0)}forEach(t,c){this.a.forEach((g,E)=>{t.call(c,g,E,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Di=f}),function(be,e){typeof define=="function"&&define.amd?define(Ae[117],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(be=typeof globalThis<"u"?globalThis:be||self,e(be.marked={}))}(this,function(be){"use strict";function e(ve,me){for(var De=0;De<me.length;De++){var ne=me[De];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(ve,ne.key,ne)}}function w(ve,me,De){return me&&e(ve.prototype,me),De&&e(ve,De),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function F(ve,me){if(ve){if(typeof ve=="string")return C(ve,me);var De=Object.prototype.toString.call(ve).slice(8,-1);if(De==="Object"&&ve.constructor&&(De=ve.constructor.name),De==="Map"||De==="Set")return Array.from(ve);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C(ve,me)}}function C(ve,me){(me==null||me>ve.length)&&(me=ve.length);for(var De=0,ne=new Array(me);De<me;De++)ne[De]=ve[De];return ne}function L(ve,me){var De=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(De)return(De=De.call(ve)).next.bind(De);if(Array.isArray(ve)||(De=F(ve))||me&&ve&&typeof ve.length=="number"){De&&(ve=De);var ne=0;return function(){return ne>=ve.length?{done:!0}:{done:!1,value:ve[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}be.defaults=A();function l(ve){be.defaults=ve}var S=/[&<>"']/,d=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(me){return u[me]};function p(ve,me){if(me){if(S.test(ve))return ve.replace(d,b)}else if(P.test(ve))return ve.replace(D,b);return ve}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function i(ve){return ve.replace(f,function(me,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var t=/(^|[^\[])\^/g;function c(ve,me){ve=typeof ve=="string"?ve:ve.source,me=me||"";var De={replace:function(he,se){return se=se.source||se,se=se.replace(t,"$1"),ve=ve.replace(he,se),De},getRegex:function(){return new RegExp(ve,me)}};return De}var g=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function $(ve,me,De){if(ve){var ne;try{ne=decodeURIComponent(i(De)).replace(g,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}me&&!E.test(De)&&(De=y(me,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var s={},a=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function y(ve,me){s[" "+ve]||(a.test(ve)?s[" "+ve]=ve+"/":s[" "+ve]=r(ve,"/",!0)),ve=s[" "+ve];var De=ve.indexOf(":")===-1;return me.substring(0,2)==="//"?De?me:ve.replace(n,"$1")+me:me.charAt(0)==="/"?De?me:ve.replace(o,"$1")+me:ve+me}var m={exec:function(){}};function I(ve){for(var me=1,De,ne;me<arguments.length;me++){De=arguments[me];for(ne in De)Object.prototype.hasOwnProperty.call(De,ne)&&(ve[ne]=De[ne])}return ve}function k(ve,me){var De=ve.replace(/\|/g,function(se,oe,fe){for(var Ie=!1,M=oe;--M>=0&&fe[M]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ne=De.split(/ \|/),he=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>me)ne.splice(me);else for(;ne.length<me;)ne.push("");for(;he<ne.length;he++)ne[he]=ne[he].trim().replace(/\\\|/g,"|");return ne}function r(ve,me,De){var ne=ve.length;if(ne===0)return"";for(var he=0;he<ne;){var se=ve.charAt(ne-he-1);if(se===me&&!De)he++;else if(se!==me&&De)he++;else break}return ve.slice(0,ne-he)}function h(ve,me){if(ve.indexOf(me[1])===-1)return-1;for(var De=ve.length,ne=0,he=0;he<De;he++)if(ve[he]==="\\")he++;else if(ve[he]===me[0])ne++;else if(ve[he]===me[1]&&(ne--,ne<0))return he;return-1}function v(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ve,me){if(me<1)return"";for(var De="";me>1;)me&1&&(De+=ve),me>>=1,ve+=ve;return De+ve}function W(ve,me,De,ne){var he=me.href,se=me.title?p(me.title):null,oe=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){ne.state.inLink=!0;var fe={type:"link",raw:De,href:he,title:se,text:oe,tokens:ne.inlineTokens(oe)};return ne.state.inLink=!1,fe}return{type:"image",raw:De,href:he,title:se,text:p(oe)}}function V(ve,me){var De=ve.match(/^(\s+)(?:```)/);if(De===null)return me;var ne=De[1];return me.split(`
`).map(function(he){var se=he.match(/^\s+/);if(se===null)return he;var oe=se[0];return oe.length>=ne.length?he.slice(ne.length):he}).join(`
`)}var U=function(){function ve(De){this.options=De||be.defaults}var me=ve.prototype;return me.space=function(ne){var he=this.rules.block.newline.exec(ne);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},me.code=function(ne){var he=this.rules.block.code.exec(ne);if(he){var se=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?se:r(se,`
`)}}},me.fences=function(ne){var he=this.rules.block.fences.exec(ne);if(he){var se=he[0],oe=V(se,he[3]||"");return{type:"code",raw:se,lang:he[2]?he[2].trim():he[2],text:oe}}},me.heading=function(ne){var he=this.rules.block.heading.exec(ne);if(he){var se=he[2].trim();if(/#$/.test(se)){var oe=r(se,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(se=oe.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:se,tokens:this.lexer.inline(se)}}},me.hr=function(ne){var he=this.rules.block.hr.exec(ne);if(he)return{type:"hr",raw:he[0]}},me.blockquote=function(ne){var he=this.rules.block.blockquote.exec(ne);if(he){var se=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},me.list=function(ne){var he=this.rules.block.list.exec(ne);if(he){var se,oe,fe,Ie,M,K,G,X,J,x,ae,Le,je=he[1].trim(),Xe=je.length>1,He={type:"list",raw:"",ordered:Xe,start:Xe?+je.slice(0,-1):"",loose:!1,items:[]};je=Xe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Xe?je:"[*+-]");for(var et=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(Le=!1,!(!(he=et.exec(ne))||this.rules.block.hr.test(ne)));){if(se=he[0],ne=ne.substring(se.length),X=he[2].split(`
`,1)[0],J=ne.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=X.trimLeft()):(Ie=he[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=X.slice(Ie),Ie+=he[1].length),K=!1,!X&&/^ *$/.test(J)&&(se+=J+`
`,ne=ne.substring(J.length+1),Le=!0),!Le)for(var Ze=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");ne&&(x=ne.split(`
`,1)[0],X=x,this.options.pedantic&&(X=X.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(X)||tt.test(X)||Ze.test(X)||_e.test(ne)));){if(X.search(/[^ ]/)>=Ie||!X.trim())ae+=`
`+X.slice(Ie);else if(!K)ae+=`
`+X;else break;!K&&!X.trim()&&(K=!0),se+=x+`
`,ne=ne.substring(x.length+1)}He.loose||(G?He.loose=!0:/\n *\n *$/.test(se)&&(G=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(fe=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:se,task:!!oe,checked:fe,loose:!1,text:ae}),He.raw+=se}He.items[He.items.length-1].raw=se.trimRight(),He.items[He.items.length-1].text=ae.trimRight(),He.raw=He.raw.trimRight();var ze=He.items.length;for(M=0;M<ze;M++){this.lexer.state.top=!1,He.items[M].tokens=this.lexer.blockTokens(He.items[M].text,[]);var st=He.items[M].tokens.filter(function(Q){return Q.type==="space"}),_=st.every(function(Q){for(var pe=Q.raw.split(""),Ue=0,Ne=L(pe),Qe;!(Qe=Ne()).done;){var nt=Qe.value;if(nt===`
`&&(Ue+=1),Ue>1)return!0}return!1});!He.loose&&st.length&&_&&(He.loose=!0,He.items[M].loose=!0)}return He}},me.html=function(ne){var he=this.rules.block.html.exec(ne);if(he){var se={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(he[0]):p(he[0]);se.type="paragraph",se.text=oe,se.tokens=this.lexer.inline(oe)}return se}},me.def=function(ne){var he=this.rules.block.def.exec(ne);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var se=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:he[0],href:he[2],title:he[3]}}},me.table=function(ne){var he=this.rules.block.table.exec(ne);if(he){var se={type:"table",header:k(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=he[0];var oe=se.align.length,fe,Ie,M,K;for(fe=0;fe<oe;fe++)/^ *-+: *$/.test(se.align[fe])?se.align[fe]="right":/^ *:-+: *$/.test(se.align[fe])?se.align[fe]="center":/^ *:-+ *$/.test(se.align[fe])?se.align[fe]="left":se.align[fe]=null;for(oe=se.rows.length,fe=0;fe<oe;fe++)se.rows[fe]=k(se.rows[fe],se.header.length).map(function(G){return{text:G}});for(oe=se.header.length,Ie=0;Ie<oe;Ie++)se.header[Ie].tokens=this.lexer.inline(se.header[Ie].text);for(oe=se.rows.length,Ie=0;Ie<oe;Ie++)for(K=se.rows[Ie],M=0;M<K.length;M++)K[M].tokens=this.lexer.inline(K[M].text);return se}}},me.lheading=function(ne){var he=this.rules.block.lheading.exec(ne);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},me.paragraph=function(ne){var he=this.rules.block.paragraph.exec(ne);if(he){var se=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:se,tokens:this.lexer.inline(se)}}},me.text=function(ne){var he=this.rules.block.text.exec(ne);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},me.escape=function(ne){var he=this.rules.inline.escape.exec(ne);if(he)return{type:"escape",raw:he[0],text:p(he[1])}},me.tag=function(ne){var he=this.rules.inline.tag.exec(ne);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):p(he[0]):he[0]}},me.link=function(ne){var he=this.rules.inline.link.exec(ne);if(he){var se=he[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var oe=r(se.slice(0,-1),"\\");if((se.length-oe.length)%2===0)return}else{var fe=h(he[2],"()");if(fe>-1){var Ie=he[0].indexOf("!")===0?5:4,M=Ie+he[1].length+fe;he[2]=he[2].substring(0,fe),he[0]=he[0].substring(0,M).trim(),he[3]=""}}var K=he[2],G="";if(this.options.pedantic){var X=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);X&&(K=X[1],G=X[3])}else G=he[3]?he[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(se)?K=K.slice(1):K=K.slice(1,-1)),W(he,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},me.reflink=function(ne,he){var se;if((se=this.rules.inline.reflink.exec(ne))||(se=this.rules.inline.nolink.exec(ne))){var oe=(se[2]||se[1]).replace(/\s+/g," ");if(oe=he[oe.toLowerCase()],!oe||!oe.href){var fe=se[0].charAt(0);return{type:"text",raw:fe,text:fe}}return W(se,oe,se[0],this.lexer)}},me.emStrong=function(ne,he,se){se===void 0&&(se="");var oe=this.rules.inline.emStrong.lDelim.exec(ne);if(oe&&!(oe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=oe[1]||oe[2]||"";if(!fe||fe&&(se===""||this.rules.inline.punctuation.exec(se))){var Ie=oe[0].length-1,M,K,G=Ie,X=0,J=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(J.lastIndex=0,he=he.slice(-1*ne.length+Ie);(oe=J.exec(he))!=null;)if(M=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!M){if(K=M.length,oe[3]||oe[4]){G+=K;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+K)%3)){X+=K;continue}if(G-=K,!(G>0)){if(K=Math.min(K,K+G+X),Math.min(Ie,K)%2){var x=ne.slice(1,Ie+oe.index+K);return{type:"em",raw:ne.slice(0,Ie+oe.index+K+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ae=ne.slice(2,Ie+oe.index+K-1);return{type:"strong",raw:ne.slice(0,Ie+oe.index+K+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},me.codespan=function(ne){var he=this.rules.inline.code.exec(ne);if(he){var se=he[2].replace(/\n/g," "),oe=/[^ ]/.test(se),fe=/^ /.test(se)&&/ $/.test(se);return oe&&fe&&(se=se.substring(1,se.length-1)),se=p(se,!0),{type:"codespan",raw:he[0],text:se}}},me.br=function(ne){var he=this.rules.inline.br.exec(ne);if(he)return{type:"br",raw:he[0]}},me.del=function(ne){var he=this.rules.inline.del.exec(ne);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},me.autolink=function(ne,he){var se=this.rules.inline.autolink.exec(ne);if(se){var oe,fe;return se[2]==="@"?(oe=p(this.options.mangle?he(se[1]):se[1]),fe="mailto:"+oe):(oe=p(se[1]),fe=oe),{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},me.url=function(ne,he){var se;if(se=this.rules.inline.url.exec(ne)){var oe,fe;if(se[2]==="@")oe=p(this.options.mangle?he(se[0]):se[0]),fe="mailto:"+oe;else{var Ie;do Ie=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Ie!==se[0]);oe=p(se[0]),se[1]==="www."?fe="http://"+oe:fe=oe}return{type:"link",raw:se[0],text:oe,href:fe,tokens:[{type:"text",raw:oe,text:oe}]}}},me.inlineText=function(ne,he){var se=this.rules.inline.text.exec(ne);if(se){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):p(se[0]):se[0]:oe=p(this.options.smartypants?he(se[0]):se[0]),{type:"text",raw:se[0],text:oe}}},ve}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=c(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=c(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=c(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=c(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=c(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=c(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=I({},B),B.gfm=I({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=c(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=c(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=I({},B.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:c(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=c(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=c(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=c(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=c(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=c(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=c(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=c(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=c(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=c(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=c(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=c(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=I({},O),O.pedantic=I({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=I({},O.normal,{escape:c(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=c(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=I({},O.gfm,{br:c(O.br).replace("{2,}","*").getRegex(),text:c(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(ve){var me="",De,ne,he=ve.length;for(De=0;De<he;De++)ne=ve.charCodeAt(De),Math.random()>.5&&(ne="x"+ne.toString(16)),me+="&#"+ne+";";return me}var Y=function(){function ve(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||be.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:B.normal,inline:O.normal};this.options.pedantic?(ne.block=B.pedantic,ne.inline=O.pedantic):this.options.gfm&&(ne.block=B.gfm,this.options.breaks?ne.inline=O.breaks:ne.inline=O.gfm),this.tokenizer.rules=ne}ve.lex=function(ne,he){var se=new ve(he);return se.lex(ne)},ve.lexInline=function(ne,he){var se=new ve(he);return se.inlineTokens(ne)};var me=ve.prototype;return me.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},me.blockTokens=function(ne,he){var se=this;he===void 0&&(he=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(G,X,J){return X+"    ".repeat(J.length)});for(var oe,fe,Ie,M;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(oe=G.call({lexer:se},ne,he))?(ne=ne.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.space(ne)){ne=ne.substring(oe.raw.length),oe.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(oe);continue}if(oe=this.tokenizer.code(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(oe=this.tokenizer.fences(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.heading(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.hr(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.blockquote(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.list(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.html(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.def(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.lheading(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,X=ne.slice(1),J=void 0;se.options.extensions.startBlock.forEach(function(x){J=x.call({lexer:this},X),typeof J=="number"&&J>=0&&(G=Math.min(G,J))}),G<1/0&&G>=0&&(Ie=ne.substring(0,G+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){fe=he[he.length-1],M&&fe.type==="paragraph"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe),M=Ie.length!==ne.length,ne=ne.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+oe.raw,fe.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):he.push(oe);continue}if(ne){var K="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,he},me.inline=function(ne,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:ne,tokens:he}),he},me.inlineTokens=function(ne,he){var se=this;he===void 0&&(he=[]);var oe,fe,Ie,M=ne,K,G,X;if(this.tokens.links){var J=Object.keys(this.tokens.links);if(J.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(M))!=null;)J.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(M=M.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+M.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(M))!=null;)M=M.slice(0,K.index)+"["+R("a",K[0].length-2)+"]"+M.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(M))!=null;)M=M.slice(0,K.index)+"++"+M.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(G||(X=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:se},ne,he))?(ne=ne.substring(oe.raw.length),he.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.tag(ne)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.link(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(oe.raw.length),fe=he[he.length-1],fe&&oe.type==="text"&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(oe=this.tokenizer.emStrong(ne,M,X)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.codespan(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.br(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.del(ne)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(oe=this.tokenizer.autolink(ne,ee)){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(ne,ee))){ne=ne.substring(oe.raw.length),he.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Le=ne.slice(1),je=void 0;se.options.extensions.startInline.forEach(function(Xe){je=Xe.call({lexer:this},Le),typeof je=="number"&&je>=0&&(ae=Math.min(ae,je))}),ae<1/0&&ae>=0&&(Ie=ne.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,N)){ne=ne.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(X=oe.raw.slice(-1)),G=!0,fe=he[he.length-1],fe&&fe.type==="text"?(fe.raw+=oe.raw,fe.text+=oe.text):he.push(oe);continue}if(ne){var x="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return he},w(ve,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),ve}(),Ee=function(){function ve(De){this.options=De||be.defaults}var me=ve.prototype;return me.code=function(ne,he,se){var oe=(he||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(ne,oe);fe!=null&&fe!==ne&&(se=!0,ne=fe)}return ne=ne.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+p(oe,!0)+'">'+(se?ne:p(ne,!0))+`</code></pre>
`:"<pre><code>"+(se?ne:p(ne,!0))+`</code></pre>
`},me.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},me.html=function(ne){return ne},me.heading=function(ne,he,se,oe){if(this.options.headerIds){var fe=this.options.headerPrefix+oe.slug(se);return"<h"+he+' id="'+fe+'">'+ne+"</h"+he+`>
`}return"<h"+he+">"+ne+"</h"+he+`>
`},me.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},me.list=function(ne,he,se){var oe=he?"ol":"ul",fe=he&&se!==1?' start="'+se+'"':"";return"<"+oe+fe+`>
`+ne+"</"+oe+`>
`},me.listitem=function(ne){return"<li>"+ne+`</li>
`},me.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},me.paragraph=function(ne){return"<p>"+ne+`</p>
`},me.table=function(ne,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+he+`</table>
`},me.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},me.tablecell=function(ne,he){var se=he.header?"th":"td",oe=he.align?"<"+se+' align="'+he.align+'">':"<"+se+">";return oe+ne+("</"+se+`>
`)},me.strong=function(ne){return"<strong>"+ne+"</strong>"},me.em=function(ne){return"<em>"+ne+"</em>"},me.codespan=function(ne){return"<code>"+ne+"</code>"},me.br=function(){return this.options.xhtml?"<br/>":"<br>"},me.del=function(ne){return"<del>"+ne+"</del>"},me.link=function(ne,he,se){if(ne=$(this.options.sanitize,this.options.baseUrl,ne),ne===null)return se;var oe='<a href="'+p(ne)+'"';return he&&(oe+=' title="'+he+'"'),oe+=">"+se+"</a>",oe},me.image=function(ne,he,se){if(ne=$(this.options.sanitize,this.options.baseUrl,ne),ne===null)return se;var oe='<img src="'+ne+'" alt="'+se+'"';return he&&(oe+=' title="'+he+'"'),oe+=this.options.xhtml?"/>":">",oe},me.text=function(ne){return ne},ve}(),ke=function(){function ve(){}var me=ve.prototype;return me.strong=function(ne){return ne},me.em=function(ne){return ne},me.codespan=function(ne){return ne},me.del=function(ne){return ne},me.html=function(ne){return ne},me.text=function(ne){return ne},me.link=function(ne,he,se){return""+se},me.image=function(ne,he,se){return""+se},me.br=function(){return""},ve}(),Pe=function(){function ve(){this.seen={}}var me=ve.prototype;return me.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},me.getNextSafeSlug=function(ne,he){var se=ne,oe=0;if(this.seen.hasOwnProperty(se)){oe=this.seen[ne];do oe++,se=ne+"-"+oe;while(this.seen.hasOwnProperty(se))}return he||(this.seen[ne]=oe,this.seen[se]=0),se},me.slug=function(ne,he){he===void 0&&(he={});var se=this.serialize(ne);return this.getNextSafeSlug(se,he.dryrun)},ve}(),Z=function(){function ve(De){this.options=De||be.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ke,this.slugger=new Pe}ve.parse=function(ne,he){var se=new ve(he);return se.parse(ne)},ve.parseInline=function(ne,he){var se=new ve(he);return se.parseInline(ne)};var me=ve.prototype;return me.parse=function(ne,he){he===void 0&&(he=!0);var se="",oe,fe,Ie,M,K,G,X,J,x,ae,Le,je,Xe,He,et,Ze,_e,it,tt,ze=ne.length;for(oe=0;oe<ze;oe++){if(ae=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){se+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,i(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(J="",X="",M=ae.header.length,fe=0;fe<M;fe++)X+=this.renderer.tablecell(this.parseInline(ae.header[fe].tokens),{header:!0,align:ae.align[fe]});for(J+=this.renderer.tablerow(X),x="",M=ae.rows.length,fe=0;fe<M;fe++){for(G=ae.rows[fe],X="",K=G.length,Ie=0;Ie<K;Ie++)X+=this.renderer.tablecell(this.parseInline(G[Ie].tokens),{header:!1,align:ae.align[Ie]});x+=this.renderer.tablerow(X)}se+=this.renderer.table(J,x);continue}case"blockquote":{x=this.parse(ae.tokens),se+=this.renderer.blockquote(x);continue}case"list":{for(Le=ae.ordered,je=ae.start,Xe=ae.loose,M=ae.items.length,x="",fe=0;fe<M;fe++)et=ae.items[fe],Ze=et.checked,_e=et.task,He="",et.task&&(it=this.renderer.checkbox(Ze),Xe?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=it+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=it+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(et.tokens,Xe),x+=this.renderer.listitem(He,_e,Ze);se+=this.renderer.list(x,Le,je);continue}case"html":{se+=this.renderer.html(ae.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(x=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<ze&&ne[oe+1].type==="text";)ae=ne[++oe],x+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);se+=he?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return se},me.parseInline=function(ne,he){he=he||this.renderer;var se="",oe,fe,Ie,M=ne.length;for(oe=0;oe<M;oe++){if(fe=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Ie=this.options.extensions.renderers[fe.type].call({parser:this},fe),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){se+=Ie||"";continue}switch(fe.type){case"escape":{se+=he.text(fe.text);break}case"html":{se+=he.html(fe.text);break}case"link":{se+=he.link(fe.href,fe.title,this.parseInline(fe.tokens,he));break}case"image":{se+=he.image(fe.href,fe.title,fe.text);break}case"strong":{se+=he.strong(this.parseInline(fe.tokens,he));break}case"em":{se+=he.em(this.parseInline(fe.tokens,he));break}case"codespan":{se+=he.codespan(fe.text);break}case"br":{se+=he.br();break}case"del":{se+=he.del(this.parseInline(fe.tokens,he));break}case"text":{se+=he.text(fe.text);break}default:{var K='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return se},ve}();function ue(ve,me,De){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof me=="function"&&(De=me,me=null),me=I({},ue.defaults,me||{}),v(me),De){var ne=me.highlight,he;try{he=Y.lex(ve,me)}catch(M){return De(M)}var se=function(K){var G;if(!K)try{me.walkTokens&&ue.walkTokens(he,me.walkTokens),G=Z.parse(he,me)}catch(X){K=X}return me.highlight=ne,K?De(K):De(null,G)};if(!ne||ne.length<3||(delete me.highlight,!he.length))return se();var oe=0;ue.walkTokens(he,function(M){M.type==="code"&&(oe++,setTimeout(function(){ne(M.text,M.lang,function(K,G){if(K)return se(K);G!=null&&G!==M.text&&(M.text=G,M.escaped=!0),oe--,oe===0&&se()})},0))}),oe===0&&se();return}function fe(M){if(M.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+p(M.message+"",!0)+"</pre>";throw M}try{var Ie=Y.lex(ve,me);if(me.walkTokens){if(me.async)return Promise.all(ue.walkTokens(Ie,me.walkTokens)).then(function(){return Z.parse(Ie,me)}).catch(fe);ue.walkTokens(Ie,me.walkTokens)}return Z.parse(Ie,me)}catch(M){fe(M)}}ue.options=ue.setOptions=function(ve){return I(ue.defaults,ve),l(ue.defaults),ue},ue.getDefaults=A,ue.defaults=be.defaults,ue.use=function(){for(var ve=arguments.length,me=new Array(ve),De=0;De<ve;De++)me[De]=arguments[De];var ne=I.apply(void 0,[{}].concat(me)),he=ue.defaults.extensions||{renderers:{},childTokens:{}},se;me.forEach(function(oe){if(oe.extensions&&(se=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var M=he.renderers?he.renderers[Ie.name]:null;M?he.renderers[Ie.name]=function(){for(var K=arguments.length,G=new Array(K),X=0;X<K;X++)G[X]=arguments[X];var J=Ie.renderer.apply(this,G);return J===!1&&(J=M.apply(this,G)),J}:he.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Ie.level]?he[Ie.level].unshift(Ie.tokenizer):he[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?he.startBlock?he.startBlock.push(Ie.start):he.startBlock=[Ie.start]:Ie.level==="inline"&&(he.startInline?he.startInline.push(Ie.start):he.startInline=[Ie.start]))}Ie.childTokens&&(he.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=ue.defaults.renderer||new Ee,M=function(X){var J=Ie[X];Ie[X]=function(){for(var x=arguments.length,ae=new Array(x),Le=0;Le<x;Le++)ae[Le]=arguments[Le];var je=oe.renderer[X].apply(Ie,ae);return je===!1&&(je=J.apply(Ie,ae)),je}};for(var K in oe.renderer)M(K);ne.renderer=Ie}(),oe.tokenizer&&function(){var Ie=ue.defaults.tokenizer||new U,M=function(X){var J=Ie[X];Ie[X]=function(){for(var x=arguments.length,ae=new Array(x),Le=0;Le<x;Le++)ae[Le]=arguments[Le];var je=oe.tokenizer[X].apply(Ie,ae);return je===!1&&(je=J.apply(Ie,ae)),je}};for(var K in oe.tokenizer)M(K);ne.tokenizer=Ie}(),oe.walkTokens){var fe=ue.defaults.walkTokens;ne.walkTokens=function(Ie){var M=[];return M.push(oe.walkTokens.call(this,Ie)),fe&&(M=M.concat(fe.call(this,Ie))),M}}se&&(ne.extensions=he),ue.setOptions(ne)})},ue.walkTokens=function(ve,me){for(var De=[],ne=function(){var fe=se.value;switch(De=De.concat(me.call(ue,fe)),fe.type){case"table":{for(var Ie=L(fe.header),M;!(M=Ie()).done;){var K=M.value;De=De.concat(ue.walkTokens(K.tokens,me))}for(var G=L(fe.rows),X;!(X=G()).done;)for(var J=X.value,x=L(J),ae;!(ae=x()).done;){var Le=ae.value;De=De.concat(ue.walkTokens(Le.tokens,me))}break}case"list":{De=De.concat(ue.walkTokens(fe.items,me));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[fe.type]?ue.defaults.extensions.childTokens[fe.type].forEach(function(je){De=De.concat(ue.walkTokens(fe[je],me))}):fe.tokens&&(De=De.concat(ue.walkTokens(fe.tokens,me)))}},he=L(ve),se;!(se=he()).done;)ne();return De},ue.parseInline=function(ve,me){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");me=I({},ue.defaults,me||{}),v(me);try{var De=Y.lexInline(ve,me);return me.walkTokens&&ue.walkTokens(De,me.walkTokens),Z.parseInline(De,me)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+p(ne.message+"",!0)+"</pre>";throw ne}},ue.Parser=Z,ue.parser=Z.parse,ue.Renderer=Ee,ue.TextRenderer=ke,ue.Lexer=Y,ue.lexer=Y.lex,ue.Tokenizer=U,ue.Slugger=Pe,ue.parse=ue;var ye=ue.options,ce=ue.setOptions,$e=ue.use,ie=ue.walkTokens,z=ue.parseInline,q=ue,le=Z.parse,we=Y.lex;be.Lexer=Y,be.Parser=Z,be.Renderer=Ee,be.Slugger=Pe,be.TextRenderer=ke,be.Tokenizer=U,be.getDefaults=A,be.lexer=we,be.marked=ue,be.options=ye,be.parse=q,be.parseInline=z,be.parser=le,be.setOptions=ce,be.use=$e,be.walkTokens=ie,Object.defineProperty(be,"__esModule",{value:!0})}),define(Ae[118],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Il=e.rot=e.$Gl=void 0;function w(l,S,d){return Math.min(Math.max(l,S),d)}e.$Gl=w;function F(l,S){return(S+l%S)%S}e.rot=F;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Il=C;class L{constructor(){this.a=1,this.b=0}update(S){return this.b=this.b+(S-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Jl=L;class A{constructor(S){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(S),this.c.fill(0,0,S)}update(S){const d=this.c[this.d];return this.c[this.d]=S,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=S,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Kl=A}),function(){function be(C){const L=[];typeof C=="number"&&L.push("code/timeOrigin",C);function A(S){L.push(S,Date.now())}function l(){const S=[];for(let d=0;d<L.length;d+=2)S.push({name:L[d],startTime:L[d+1]});return S}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?be():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(C+A.startTime)});return L}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return be(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),be()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=w(F))}(),function(be,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var F in w)(typeof exports=="object"?exports:be)[F]=w[F]}}(typeof self<"u"?self:this,function(){return function(be){var e={};function w(F){if(e[F])return e[F].exports;var C=e[F]={i:F,l:!1,exports:{}};return be[F].call(C.exports,C,C.exports,w),C.l=!0,C.exports}return w.m=be,w.c=e,w.d=function(F,C,L){w.o(F,C)||Object.defineProperty(F,C,{enumerable:!0,get:L})},w.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},w.t=function(F,C){if(1&C&&(F=w(F)),8&C||4&C&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(w.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&C&&typeof F!="string")for(var A in F)w.d(L,A,function(l){return F[l]}.bind(null,A));return L},w.n=function(F){var C=F&&F.__esModule?function(){return F.default}:function(){return F};return w.d(C,"a",C),C},w.o=function(F,C){return Object.prototype.hasOwnProperty.call(F,C)},w.p="",w(w.s=0)}([function(be,e,w){(function(F){var C;e=be.exports=$e,C=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],S=e.src=[],d=0,P=d++;S[P]="0|[1-9]\\d*";var D=d++;S[D]="[0-9]+";var u=d++;S[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=d++;S[b]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var p=d++;S[p]="("+S[D]+")\\.("+S[D]+")\\.("+S[D]+")";var f=d++;S[f]="(?:"+S[P]+"|"+S[u]+")";var i=d++;S[i]="(?:"+S[D]+"|"+S[u]+")";var t=d++;S[t]="(?:-("+S[f]+"(?:\\."+S[f]+")*))";var c=d++;S[c]="(?:-?("+S[i]+"(?:\\."+S[i]+")*))";var g=d++;S[g]="[0-9A-Za-z-]+";var E=d++;S[E]="(?:\\+("+S[g]+"(?:\\."+S[g]+")*))";var $=d++,s="v?"+S[b]+S[t]+"?"+S[E]+"?";S[$]="^"+s+"$";var a="[v=\\s]*"+S[p]+S[c]+"?"+S[E]+"?",n=d++;S[n]="^"+a+"$";var o=d++;S[o]="((?:<|>)?=?)";var y=d++;S[y]=S[D]+"|x|X|\\*";var m=d++;S[m]=S[P]+"|x|X|\\*";var I=d++;S[I]="[v=\\s]*("+S[m]+")(?:\\.("+S[m]+")(?:\\.("+S[m]+")(?:"+S[t]+")?"+S[E]+"?)?)?";var k=d++;S[k]="[v=\\s]*("+S[y]+")(?:\\.("+S[y]+")(?:\\.("+S[y]+")(?:"+S[c]+")?"+S[E]+"?)?)?";var r=d++;S[r]="^"+S[o]+"\\s*"+S[I]+"$";var h=d++;S[h]="^"+S[o]+"\\s*"+S[k]+"$";var v=d++;S[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=d++;S[R]="(?:~>?)";var W=d++;S[W]="(\\s*)"+S[R]+"\\s+",l[W]=new RegExp(S[W],"g");var V=d++;S[V]="^"+S[R]+S[I]+"$";var U=d++;S[U]="^"+S[R]+S[k]+"$";var B=d++;S[B]="(?:\\^)";var O=d++;S[O]="(\\s*)"+S[B]+"\\s+",l[O]=new RegExp(S[O],"g");var N=d++;S[N]="^"+S[B]+S[I]+"$";var ee=d++;S[ee]="^"+S[B]+S[k]+"$";var Y=d++;S[Y]="^"+S[o]+"\\s*("+a+")$|^$";var Ee=d++;S[Ee]="^"+S[o]+"\\s*("+s+")$|^$";var ke=d++;S[ke]="(\\s*)"+S[o]+"\\s*("+a+"|"+S[I]+")",l[ke]=new RegExp(S[ke],"g");var Pe=d++;S[Pe]="^\\s*("+S[I]+")\\s+-\\s+("+S[I]+")\\s*$";var Z=d++;S[Z]="^\\s*("+S[k]+")\\s+-\\s+("+S[k]+")\\s*$";var ue=d++;S[ue]="(<|>)?=?\\s*\\*";for(var ye=0;ye<35;ye++)C(ye,S[ye]),l[ye]||(l[ye]=new RegExp(S[ye]));function ce(J,x){if(J instanceof $e)return J;if(typeof J!="string"||J.length>L||!(x?l[n]:l[$]).test(J))return null;try{return new $e(J,x)}catch{return null}}function $e(J,x){if(J instanceof $e){if(J.loose===x)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof $e))return new $e(J,x);C("SemVer",J,x),this.loose=x;var ae=J.trim().match(x?l[n]:l[$]);if(!ae)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var je=+Le;if(je>=0&&je<A)return je}return Le}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=ce,e.valid=function(J,x){var ae=ce(J,x);return ae?ae.version:null},e.clean=function(J,x){var ae=ce(J.trim().replace(/^[=v]+/,""),x);return ae?ae.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(J){return C("SemVer.compare",this.version,this.loose,J),J instanceof $e||(J=new $e(J,this.loose)),this.compareMain(J)||this.comparePre(J)},$e.prototype.compareMain=function(J){return J instanceof $e||(J=new $e(J,this.loose)),z(this.major,J.major)||z(this.minor,J.minor)||z(this.patch,J.patch)},$e.prototype.comparePre=function(J){if(J instanceof $e||(J=new $e(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var x=0;do{var ae=this.prerelease[x],Le=J.prerelease[x];if(C("prerelease compare",x,ae,Le),ae===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(ae===void 0)return-1;if(ae!==Le)return z(ae,Le)}while(++x)},$e.prototype.inc=function(J,x){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,x,ae,Le){typeof ae=="string"&&(Le=ae,ae=void 0);try{return new $e(J,ae).inc(x,Le).version}catch{return null}},e.diff=function(J,x){if(ve(J,x))return null;var ae=ce(J),Le=ce(x);if(ae.prerelease.length||Le.prerelease.length){for(var je in ae)if((je==="major"||je==="minor"||je==="patch")&&ae[je]!==Le[je])return"pre"+je;return"prerelease"}for(var je in ae)if((je==="major"||je==="minor"||je==="patch")&&ae[je]!==Le[je])return je},e.compareIdentifiers=z;var ie=/^[0-9]+$/;function z(J,x){var ae=ie.test(J),Le=ie.test(x);return ae&&Le&&(J=+J,x=+x),ae&&!Le?-1:Le&&!ae?1:J<x?-1:J>x?1:0}function q(J,x,ae){return new $e(J,ae).compare(new $e(x,ae))}function le(J,x,ae){return q(J,x,ae)>0}function we(J,x,ae){return q(J,x,ae)<0}function ve(J,x,ae){return q(J,x,ae)===0}function me(J,x,ae){return q(J,x,ae)!==0}function De(J,x,ae){return q(J,x,ae)>=0}function ne(J,x,ae){return q(J,x,ae)<=0}function he(J,x,ae,Le){var je;switch(x){case"===":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),je=J===ae;break;case"!==":typeof J=="object"&&(J=J.version),typeof ae=="object"&&(ae=ae.version),je=J!==ae;break;case"":case"=":case"==":je=ve(J,ae,Le);break;case"!=":je=me(J,ae,Le);break;case">":je=le(J,ae,Le);break;case">=":je=De(J,ae,Le);break;case"<":je=we(J,ae,Le);break;case"<=":je=ne(J,ae,Le);break;default:throw new TypeError("Invalid operator: "+x)}return je}function se(J,x){if(J instanceof se){if(J.loose===x)return J;J=J.value}if(!(this instanceof se))return new se(J,x);C("comparator",J,x),this.loose=x,this.parse(J),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(J,x){return z(x,J)},e.major=function(J,x){return new $e(J,x).major},e.minor=function(J,x){return new $e(J,x).minor},e.patch=function(J,x){return new $e(J,x).patch},e.compare=q,e.compareLoose=function(J,x){return q(J,x,!0)},e.rcompare=function(J,x,ae){return q(x,J,ae)},e.sort=function(J,x){return J.sort(function(ae,Le){return e.compare(ae,Le,x)})},e.rsort=function(J,x){return J.sort(function(ae,Le){return e.rcompare(ae,Le,x)})},e.gt=le,e.lt=we,e.eq=ve,e.neq=me,e.gte=De,e.lte=ne,e.cmp=he,e.Comparator=se;var oe={};function fe(J,x){if(J instanceof fe)return J.loose===x?J:new fe(J.raw,x);if(J instanceof se)return new fe(J.value,x);if(!(this instanceof fe))return new fe(J,x);if(this.loose=x,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ie(J){return!J||J.toLowerCase()==="x"||J==="*"}function M(J,x,ae,Le,je,Xe,He,et,Ze,_e,it,tt,ze){return((x=Ie(ae)?"":Ie(Le)?">="+ae+".0.0":Ie(je)?">="+ae+"."+Le+".0":">="+x)+" "+(et=Ie(Ze)?"":Ie(_e)?"<"+(+Ze+1)+".0.0":Ie(it)?"<"+Ze+"."+(+_e+1)+".0":tt?"<="+Ze+"."+_e+"."+it+"-"+tt:"<="+et)).trim()}function K(J,x){for(var ae=0;ae<J.length;ae++)if(!J[ae].test(x))return!1;if(x.prerelease.length){for(ae=0;ae<J.length;ae++)if(C(J[ae].semver),J[ae].semver!==oe&&J[ae].semver.prerelease.length>0){var Le=J[ae].semver;if(Le.major===x.major&&Le.minor===x.minor&&Le.patch===x.patch)return!0}return!1}return!0}function G(J,x,ae){try{x=new fe(x,ae)}catch{return!1}return x.test(J)}function X(J,x,ae,Le){var je,Xe,He,et,Ze;switch(J=new $e(J,Le),x=new fe(x,Le),ae){case">":je=le,Xe=ne,He=we,et=">",Ze=">=";break;case"<":je=we,Xe=De,He=le,et="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(J,x,Le))return!1;for(var _e=0;_e<x.set.length;++_e){var it=x.set[_e],tt=null,ze=null;if(it.forEach(function(st){st.semver===oe&&(st=new se(">=0.0.0")),tt=tt||st,ze=ze||st,je(st.semver,tt.semver,Le)?tt=st:He(st.semver,ze.semver,Le)&&(ze=st)}),tt.operator===et||tt.operator===Ze||(!ze.operator||ze.operator===et)&&Xe(J,ze.semver)||ze.operator===Ze&&He(J,ze.semver))return!1}return!0}se.prototype.parse=function(J){var x=this.loose?l[Y]:l[Ee],ae=J.match(x);if(!ae)throw new TypeError("Invalid comparator: "+J);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new $e(ae[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(J){return C("Comparator.test",J,this.loose),this.semver===oe||(typeof J=="string"&&(J=new $e(J,this.loose)),he(J,this.operator,this.semver,this.loose))},se.prototype.intersects=function(J,x){if(!(J instanceof se))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new fe(J.value,x),G(this.value,ae,x);if(J.operator==="")return ae=new fe(this.value,x),G(J.semver,ae,x);var Le=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Xe=this.semver.version===J.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),et=he(this.semver,"<",J.semver,x)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ze=he(this.semver,">",J.semver,x)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return Le||je||Xe&&He||et||Ze},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(J){var x=this.loose;J=J.trim(),C("range",J,x);var ae=x?l[Z]:l[Pe];J=J.replace(ae,M),C("hyphen replace",J),J=J.replace(l[ke],"$1$2$3"),C("comparator trim",J,l[ke]),J=(J=(J=J.replace(l[W],"$1~")).replace(l[O],"$1^")).split(/\s+/).join(" ");var Le=x?l[Y]:l[Ee],je=J.split(" ").map(function(Xe){return function(He,et){return C("comp",He),He=function(Ze,_e){return Ze.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?l[ee]:l[N];return tt.replace(st,function(_,Q,pe,Ue,Ne){var Qe;return C("caret",tt,_,Q,pe,Ue,Ne),Ie(Q)?Qe="":Ie(pe)?Qe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Ue)?Qe=Q==="0"?">="+Q+"."+pe+".0 <"+Q+"."+(+pe+1)+".0":">="+Q+"."+pe+".0 <"+(+Q+1)+".0.0":Ne?(C("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Qe=Q==="0"?pe==="0"?">="+Q+"."+pe+"."+Ue+Ne+" <"+Q+"."+pe+"."+(+Ue+1):">="+Q+"."+pe+"."+Ue+Ne+" <"+Q+"."+(+pe+1)+".0":">="+Q+"."+pe+"."+Ue+Ne+" <"+(+Q+1)+".0.0"):(C("no pr"),Qe=Q==="0"?pe==="0"?">="+Q+"."+pe+"."+Ue+" <"+Q+"."+pe+"."+(+Ue+1):">="+Q+"."+pe+"."+Ue+" <"+Q+"."+(+pe+1)+".0":">="+Q+"."+pe+"."+Ue+" <"+(+Q+1)+".0.0"),C("caret return",Qe),Qe})}(it,_e)}).join(" ")}(He,et),C("caret",He),He=function(Ze,_e){return Ze.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?l[U]:l[V];return tt.replace(st,function(_,Q,pe,Ue,Ne){var Qe;return C("tilde",tt,_,Q,pe,Ue,Ne),Ie(Q)?Qe="":Ie(pe)?Qe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Ue)?Qe=">="+Q+"."+pe+".0 <"+Q+"."+(+pe+1)+".0":Ne?(C("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),Qe=">="+Q+"."+pe+"."+Ue+Ne+" <"+Q+"."+(+pe+1)+".0"):Qe=">="+Q+"."+pe+"."+Ue+" <"+Q+"."+(+pe+1)+".0",C("tilde return",Qe),Qe})}(it,_e)}).join(" ")}(He,et),C("tildes",He),He=function(Ze,_e){return C("replaceXRanges",Ze,_e),Ze.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?l[h]:l[r];return tt.replace(st,function(_,Q,pe,Ue,Ne,Qe){C("xRange",tt,_,Q,pe,Ue,Ne,Qe);var nt=Ie(pe),gt=nt||Ie(Ue),vt=gt||Ie(Ne);return Q==="="&&vt&&(Q=""),nt?_=Q===">"||Q==="<"?"<0.0.0":"*":Q&&vt?(gt&&(Ue=0),vt&&(Ne=0),Q===">"?(Q=">=",gt?(pe=+pe+1,Ue=0,Ne=0):vt&&(Ue=+Ue+1,Ne=0)):Q==="<="&&(Q="<",gt?pe=+pe+1:Ue=+Ue+1),_=Q+pe+"."+Ue+"."+Ne):gt?_=">="+pe+".0.0 <"+(+pe+1)+".0.0":vt&&(_=">="+pe+"."+Ue+".0 <"+pe+"."+(+Ue+1)+".0"),C("xRange return",_),_})}(it,_e)}).join(" ")}(He,et),C("xrange",He),He=function(Ze,_e){return C("replaceStars",Ze,_e),Ze.trim().replace(l[ue],"")}(He,et),C("stars",He),He}(Xe,x)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Xe){return!!Xe.match(Le)})),je=je.map(function(Xe){return new se(Xe,x)})},fe.prototype.intersects=function(J,x){if(!(J instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Le){return J.set.some(function(je){return je.every(function(Xe){return Le.intersects(Xe,x)})})})})},e.toComparators=function(J,x){return new fe(J,x).set.map(function(ae){return ae.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new $e(J,this.loose));for(var x=0;x<this.set.length;x++)if(K(this.set[x],J))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(J,x,ae){var Le=null,je=null;try{var Xe=new fe(x,ae)}catch{return null}return J.forEach(function(He){Xe.test(He)&&(Le&&je.compare(He)!==-1||(je=new $e(Le=He,ae)))}),Le},e.minSatisfying=function(J,x,ae){var Le=null,je=null;try{var Xe=new fe(x,ae)}catch{return null}return J.forEach(function(He){Xe.test(He)&&(Le&&je.compare(He)!==1||(je=new $e(Le=He,ae)))}),Le},e.validRange=function(J,x){try{return new fe(J,x).range||"*"}catch{return null}},e.ltr=function(J,x,ae){return X(J,x,"<",ae)},e.gtr=function(J,x,ae){return X(J,x,">",ae)},e.outside=X,e.prerelease=function(J,x){var ae=ce(J,x);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(J,x,ae){return J=new fe(J,ae),x=new fe(x,ae),J.intersects(x)},e.coerce=function(J){if(J instanceof $e)return J;if(typeof J!="string")return null;var x=J.match(l[v]);return x==null?null:ce((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,w(1))},function(be,e){var w,F,C=be.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(i){if(w===setTimeout)return setTimeout(i,0);if((w===L||!w)&&setTimeout)return w=setTimeout,setTimeout(i,0);try{return w(i,0)}catch{try{return w.call(null,i,0)}catch{return w.call(this,i,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:L}catch{w=L}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var S,d=[],P=!1,D=-1;function u(){P&&S&&(P=!1,S.length?d=S.concat(d):D=-1,d.length&&b())}function b(){if(!P){var i=l(u);P=!0;for(var t=d.length;t;){for(S=d,d=[];++D<t;)S&&S[D].run();D=-1,t=d.length}S=null,P=!1,function(c){if(F===clearTimeout)return clearTimeout(c);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(c);try{F(c)}catch{try{return F.call(null,c)}catch{return F.call(this,c)}}}(i)}}function p(i,t){this.fun=i,this.array=t}function f(){}C.nextTick=function(i){var t=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)t[c-1]=arguments[c];d.push(new p(i,t)),d.length!==1||P||l(b)},p.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=f,C.addListener=f,C.once=f,C.off=f,C.removeListener=f,C.removeAllListeners=f,C.emit=f,C.prependListener=f,C.prependOnceListener=f,C.listeners=function(i){return[]},C.binding=function(i){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(i){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Ae[119],Re([1,0,9,6]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=void 0;function C(E){const $=E;return $?typeof $.read=="function":!1}e.$pd=C;function L(E){const $=E;return $?[$.on,$.pause,$.resume,$.destroy].every(s=>typeof s=="function"):!1}e.$qd=L;function A(E){const $=E;return $?L($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}e.$rd=A;function l(E,$){return new S(E,$)}e.$sd=l;class S{constructor($,s){this.e=$,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(s=>s($))}h($){this.c.error.length===0?(0,w.$Y)($):this.c.error.slice(0).forEach(s=>s($))}i(){this.c.end.slice(0).forEach($=>$())}on($,s){if(!this.a.destroyed)switch($){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener($,s){if(this.a.destroyed)return;let a;switch($){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(s);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(E,$){const s=[];let a;for(;(a=E.read())!==null;)s.push(a);return $(s)}e.$td=d;function P(E,$,s){const a=[];let n;for(;(n=E.read())!==null&&a.length<s;)a.push(n);return n===null&&a.length>0?$(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return E.read()}}}e.$ud=P;function D(E,$){return new Promise((s,a)=>{const n=[];u(E,{onData:o=>{$&&n.push(o)},onError:o=>{$?a(o):s(void 0)},onEnd:()=>{s($?$(n):void 0)}})})}e.$vd=D;function u(E,$,s){E.on("error",a=>{s?.isCancellationRequested||$.onError(a)}),E.on("end",()=>{s?.isCancellationRequested||$.onEnd()}),E.on("data",a=>{s?.isCancellationRequested||$.onData(a)})}e.$wd=u;function b(E,$){return new Promise((s,a)=>{const n=new F.$ic,o=[],y=k=>{if(o.push(k),o.length>$)return n.dispose(),E.pause(),s({stream:E,buffer:o,ended:!1})},m=k=>(n.dispose(),a(k)),I=()=>(n.dispose(),s({stream:E,buffer:o,ended:!0}));n.add((0,F.$hc)(()=>E.removeListener("error",m))),E.on("error",m),n.add((0,F.$hc)(()=>E.removeListener("end",I))),E.on("end",I),n.add((0,F.$hc)(()=>E.removeListener("data",y))),E.on("data",y)})}e.$xd=b;function p(E,$){const s=l($);return s.end(E),s}e.$yd=p;function f(){const E=l(()=>{throw new Error("not supported")});return E.end(),E}e.$zd=f;function i(E){let $=!1;return{read:()=>$?null:($=!0,E)}}e.$Ad=i;function t(E,$,s){const a=l(s);return u(E,{onData:n=>a.write($.data(n)),onError:n=>a.error($.error?$.error(n):n),onEnd:()=>a.end()}),a}e.$Bd=t;function c(E,$,s){let a=!1;return{read:()=>{const n=$.read();return a?n:(a=!0,n!==null?s([E,n]):E)}}}e.$Cd=c;function g(E,$,s){let a=!1;const n=l(s);return u($,{onData:o=>a?n.write(o):(a=!0,n.write(s([E,o]))),onError:o=>n.error(o),onEnd:()=>{a||(a=!0,n.write(E)),n.end()}}),n}e.$Dd=g}),define(Ae[25],Re([1,0,65,119]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=void 0;const C=typeof Buffer<"u",L=new w.$T(()=>new Uint8Array(256));let A,l;class S{static alloc(v){return C?new S(Buffer.allocUnsafe(v)):new S(new Uint8Array(v))}static wrap(v){return C&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new S(v)}static fromString(v,R){return!(R?.dontUseNodeBuffer||!1)&&C?new S(Buffer.from(v)):(A||(A=new TextEncoder),new S(A.encode(v)))}static fromByteArray(v){const R=S.alloc(v.length);for(let W=0,V=v.length;W<V;W++)R.buffer[W]=v[W];return R}static concat(v,R){if(typeof R>"u"){R=0;for(let U=0,B=v.length;U<B;U++)R+=v[U].byteLength}const W=S.alloc(R);let V=0;for(let U=0,B=v.length;U<B;U++){const O=v[U];W.set(O,V),V+=O.byteLength}return W}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=S.alloc(this.byteLength);return v.set(this),v}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(v,R){return new S(this.buffer.subarray(v,R))}set(v,R){if(v instanceof S)this.buffer.set(v.buffer,R);else if(v instanceof Uint8Array)this.buffer.set(v,R);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),R);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return u(this.buffer,v)}writeUInt32BE(v,R){b(this.buffer,v,R)}readUInt32LE(v){return p(this.buffer,v)}writeUInt32LE(v,R){f(this.buffer,v,R)}readUInt8(v){return i(this.buffer,v)}writeUInt8(v,R){t(this.buffer,v,R)}indexOf(v,R=0){return d(this.buffer,v instanceof S?v.buffer:v,R)}}e.$Ed=S;function d(h,v,R=0){const W=v.byteLength,V=h.byteLength;if(W===0)return 0;if(W===1)return h.indexOf(v[0]);if(W>V-R)return-1;const U=L.value;U.fill(v.length);for(let ee=0;ee<v.length;ee++)U[v[ee]]=v.length-ee-1;let B=R+v.length-1,O=B,N=-1;for(;B<V;)if(h[B]===v[O]){if(O===0){N=B;break}B--,O--}else B+=Math.max(v.length-O,U[h[B]]),O=v.length-1;return N}e.$Fd=d;function P(h,v){return h[v+0]<<0>>>0|h[v+1]<<8>>>0}e.$Gd=P;function D(h,v,R){h[R+0]=v&255,v=v>>>8,h[R+1]=v&255}e.$Hd=D;function u(h,v){return h[v]*2**24+h[v+1]*2**16+h[v+2]*2**8+h[v+3]}e.$Id=u;function b(h,v,R){h[R+3]=v,v=v>>>8,h[R+2]=v,v=v>>>8,h[R+1]=v,v=v>>>8,h[R]=v}e.$Jd=b;function p(h,v){return h[v+0]<<0>>>0|h[v+1]<<8>>>0|h[v+2]<<16>>>0|h[v+3]<<24>>>0}e.$Kd=p;function f(h,v,R){h[R+0]=v&255,v=v>>>8,h[R+1]=v&255,v=v>>>8,h[R+2]=v&255,v=v>>>8,h[R+3]=v&255}e.$Ld=f;function i(h,v){return h[v]}e.$Md=i;function t(h,v,R){h[R]=v}e.$Nd=t;function c(h){return F.$td(h,v=>S.concat(v))}e.$Od=c;function g(h){return F.$Ad(h)}e.$Pd=g;function E(h){return F.$vd(h,v=>S.concat(v))}e.$Qd=E;async function $(h){return h.ended?S.concat(h.buffer):S.concat([...h.buffer,await E(h.stream)])}e.$Rd=$;function s(h){return F.$yd(h,v=>S.concat(v))}e.$Sd=s;function a(h){return F.$Bd(h,{data:v=>typeof v=="string"?S.fromString(v):S.wrap(v)},v=>S.concat(v))}e.$Td=a;function n(h){return F.$sd(v=>S.concat(v),h)}e.$Ud=n;function o(h,v){return F.$Cd(h,v,R=>S.concat(R))}e.$Vd=o;function y(h,v){return F.$Dd(h,v,R=>S.concat(R))}e.$Wd=y;function m(h){let v=0,R=0,W=0;const V=new Uint8Array(Math.floor(h.length/4*3)),U=O=>{switch(R){case 3:V[W++]=v|O,R=0;break;case 2:V[W++]=v|O>>>2,v=O<<6,R=3;break;case 1:V[W++]=v|O>>>4,v=O<<4,R=2;break;default:v=O<<2,R=1}};for(let O=0;O<h.length;O++){const N=h.charCodeAt(O);if(N>=65&&N<=90)U(N-65);else if(N>=97&&N<=122)U(N-97+26);else if(N>=48&&N<=57)U(N-48+52);else if(N===43||N===45)U(62);else if(N===47||N===95)U(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${h[O]}`)}}const B=W;for(;R>0;)U(0);return S.wrap(V).slice(0,B)}e.$Xd=m;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function r({buffer:h},v=!0,R=!1){const W=R?k:I;let V="";const U=h.byteLength%3;let B=0;for(;B<h.byteLength-U;B+=3){const O=h[B+0],N=h[B+1],ee=h[B+2];V+=W[O>>>2],V+=W[(O<<4|N>>>4)&63],V+=W[(N<<2|ee>>>6)&63],V+=W[ee&63]}if(U===1){const O=h[B+0];V+=W[O>>>2],V+=W[O<<4&63],v&&(V+="==")}else if(U===2){const O=h[B+0],N=h[B+1];V+=W[O>>>2],V+=W[(O<<4|N>>>4)&63],V+=W[N<<2&63],v&&(V+="=")}return V}e.$Yd=r}),define(Ae[120],Re([1,0,28,15]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.FuzzyScore=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.or=void 0;function C(...se){return function(oe,fe){for(let Ie=0,M=se.length;Ie<M;Ie++){const K=se[Ie](oe,fe);if(K)return K}return null}}e.or=C,e.$wj=L.bind(void 0,!1),e.$xj=L.bind(void 0,!0);function L(se,oe,fe){if(!fe||fe.length<oe.length)return null;let Ie;return se?Ie=F.$Me(fe,oe):Ie=fe.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(se,oe){const fe=oe.toLowerCase().indexOf(se.toLowerCase());return fe===-1?null:[{start:fe,end:fe+se.length}]}e.$yj=A;function l(se,oe){return S(se.toLowerCase(),oe.toLowerCase(),0,0)}e.$zj=l;function S(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]===oe[Ie]){let M=null;return(M=S(se,oe,fe+1,Ie+1))?t({start:Ie,end:Ie+1},M):null}return S(se,oe,fe,Ie+1)}function d(se){return 97<=se&&se<=122}function P(se){return 65<=se&&se<=90}e.$Aj=P;function D(se){return 48<=se&&se<=57}function u(se){return se===32||se===9||se===10||se===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(se=>b.add(se.charCodeAt(0)));function p(se){return u(se)||b.has(se)}function f(se,oe){return se===oe||p(se)&&p(oe)}function i(se){return d(se)||P(se)||D(se)}function t(se,oe){return oe.length===0?oe=[se]:se.end===oe[0].start?oe[0].start=se.start:oe.unshift(se),oe}function c(se,oe){for(let fe=oe;fe<se.length;fe++){const Ie=se.charCodeAt(fe);if(P(Ie)||D(Ie)||fe>0&&!i(se.charCodeAt(fe-1)))return fe}return se.length}function g(se,oe,fe,Ie){if(fe===se.length)return[];if(Ie===oe.length)return null;if(se[fe]!==oe[Ie].toLowerCase())return null;{let M=null,K=Ie+1;for(M=g(se,oe,fe+1,Ie+1);!M&&(K=c(oe,K))<oe.length;)M=g(se,oe,fe+1,K),K++;return M===null?null:t({start:Ie,end:Ie+1},M)}}function E(se){let oe=0,fe=0,Ie=0,M=0,K=0;for(let ae=0;ae<se.length;ae++)K=se.charCodeAt(ae),P(K)&&oe++,d(K)&&fe++,i(K)&&Ie++,D(K)&&M++;const G=oe/se.length,X=fe/se.length,J=Ie/se.length,x=M/se.length;return{upperPercent:G,lowerPercent:X,alphaPercent:J,numericPercent:x}}function $(se){const{upperPercent:oe,lowerPercent:fe}=se;return fe===0&&oe>.6}function s(se){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ie,numericPercent:M}=se;return fe>.2&&oe<.8&&Ie>.6&&M<.2}function a(se){let oe=0,fe=0,Ie=0,M=0;for(let K=0;K<se.length;K++)Ie=se.charCodeAt(K),P(Ie)&&oe++,d(Ie)&&fe++,u(Ie)&&M++;return(oe===0||fe===0)&&M===0?se.length<=30:oe<=5}function n(se,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!a(se)||oe.length>60)return null;const fe=E(oe);if(!s(fe)){if(!$(fe))return null;oe=oe.toLowerCase()}let Ie=null,M=0;for(se=se.toLowerCase();M<oe.length&&(Ie=g(se,oe,0,M))===null;)M=c(oe,M+1);return Ie}e.$Bj=n;function o(se,oe,fe=!1){if(!oe||oe.length===0)return null;let Ie=null,M=0;for(se=se.toLowerCase(),oe=oe.toLowerCase();M<oe.length&&(Ie=y(se,oe,0,M,fe))===null;)M=m(oe,M+1);return Ie}e.$Cj=o;function y(se,oe,fe,Ie,M){if(fe===se.length)return[];if(Ie===oe.length)return null;if(f(se.charCodeAt(fe),oe.charCodeAt(Ie))){let K=null,G=Ie+1;if(K=y(se,oe,fe+1,Ie+1,M),!M)for(;!K&&(G=m(oe,G))<oe.length;)K=y(se,oe,fe+1,G,M),G++;return K?se.charCodeAt(fe)!==oe.charCodeAt(Ie)?K:t({start:Ie,end:Ie+1},K):null}else return null}function m(se,oe){for(let fe=oe;fe<se.length;fe++)if(p(se.charCodeAt(fe))||fe>0&&p(se.charCodeAt(fe-1)))return fe;return se.length}const I=C(e.$xj,n,A),k=C(e.$xj,n,l),r=new w.$Bi(1e4);function h(se,oe,fe=!1){if(typeof se!="string"||typeof oe!="string")return null;let Ie=r.get(se);Ie||(Ie=new RegExp(F.$ve(se),"i"),r.set(se,Ie));const M=Ie.exec(oe);return M?[{start:M.index,end:M.index+M[0].length}]:fe?k(se,oe):I(se,oe)}e.$Dj=h;function v(se,oe){const fe=le(se,se.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?W(fe):null}e.$Ej=v;function R(se,oe,fe,Ie,M,K){const G=Math.min(13,se.length);for(;fe<G;fe++){const X=le(se,oe,fe,Ie,M,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return X}return[0,K]}e.$Fj=R;function W(se){if(typeof se>"u")return[];const oe=[],fe=se[1];for(let Ie=se.length-1;Ie>1;Ie--){const M=se[Ie]+fe,K=oe[oe.length-1];K&&K.end===M?K.end=M+1:oe.push({start:M,end:M+1})}return oe}e.$Gj=W;const V=128;function U(){const se=[],oe=[];for(let fe=0;fe<=V;fe++)oe[fe]=0;for(let fe=0;fe<=V;fe++)se.push(oe.slice(0));return se}function B(se){const oe=[];for(let fe=0;fe<=se;fe++)oe[fe]=0;return oe}const O=B(2*V),N=B(2*V),ee=U(),Y=U(),Ee=U(),ke=!1;function Pe(se,oe,fe,Ie,M){function K(X,J,x=" "){for(;X.length<J;)X=x+X;return X}let G=` |   |${Ie.split("").map(X=>K(X,3)).join("|")}
`;for(let X=0;X<=fe;X++)X===0?G+=" |":G+=`${oe[X-1]}|`,G+=se[X].slice(0,M+1).map(J=>K(J.toString(),3)).join("|")+`
`;return G}function Z(se,oe,fe,Ie){se=se.substr(oe),fe=fe.substr(Ie),console.log(Pe(Y,se,se.length,fe,fe.length)),console.log(Pe(Ee,se,se.length,fe,fe.length)),console.log(Pe(ee,se,se.length,fe,fe.length))}function ue(se,oe){if(oe<0||oe>=se.length)return!1;const fe=se.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$5e(fe)}}function ye(se,oe){if(oe<0||oe>=se.length)return!1;switch(se.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function ce(se,oe,fe){return oe[se]!==fe[se]}function $e(se,oe,fe,Ie,M,K,G=!1){for(;oe<fe&&M<K;)se[oe]===Ie[M]&&(G&&(O[oe]=M),oe+=1),M+=1;return oe===fe}e.$Hj=$e;var ie;(function(se){se[se.Diag=1]="Diag",se[se.Left=2]="Left",se[se.LeftLeft=3]="LeftLeft"})(ie||(ie={}));var z;(function(se){se.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}se.isDefault=oe})(z||(e.FuzzyScore=z={}));class q{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,fe){this.firstMatchCanBeWeak=oe,this.boostFullMatch=fe}}e.$Ij=q;function le(se,oe,fe,Ie,M,K,G=q.default){const X=se.length>V?V:se.length,J=Ie.length>V?V:Ie.length;if(fe>=X||K>=J||X-fe>J-K||!$e(oe,fe,X,M,K,J,!0))return;we(X,J,fe,K,oe,M);let x=1,ae=1,Le=fe,je=K;const Xe=[!1];for(x=1,Le=fe;Le<X;x++,Le++){const it=O[Le],tt=N[Le],ze=Le+1<X?N[Le+1]:J;for(ae=it-K+1,je=it;je<ze;ae++,je++){let st=Number.MIN_SAFE_INTEGER,_=!1;je<=tt&&(st=ve(se,oe,Le,fe,Ie,M,je,J,K,ee[x-1][ae-1]===0,Xe));let Q=0;st!==Number.MAX_SAFE_INTEGER&&(_=!0,Q=st+Y[x-1][ae-1]);const pe=je>it,Ue=pe?Y[x][ae-1]+(ee[x][ae-1]>0?-5:0):0,Ne=je>it+1&&ee[x][ae-1]>0,Qe=Ne?Y[x][ae-2]+(ee[x][ae-2]>0?-5:0):0;if(Ne&&(!pe||Qe>=Ue)&&(!_||Qe>=Q))Y[x][ae]=Qe,Ee[x][ae]=3,ee[x][ae]=0;else if(pe&&(!_||Ue>=Q))Y[x][ae]=Ue,Ee[x][ae]=2,ee[x][ae]=0;else if(_)Y[x][ae]=Q,Ee[x][ae]=1,ee[x][ae]=ee[x-1][ae-1]+1;else throw new Error("not possible")}}if(ke&&Z(se,fe,Ie,K),!Xe[0]&&!G.firstMatchCanBeWeak)return;x--,ae--;const He=[Y[x][ae],K];let et=0,Ze=0;for(;x>=1;){let it=ae;do{const tt=Ee[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);et>1&&oe[fe+x-1]===M[K+ae-1]&&!ce(it+K-1,Ie,M)&&et+1>ee[x][it]&&(it=ae),it===ae?et++:et=1,Ze||(Ze=it),x--,ae=it-1,He.push(ae)}J===X&&G.boostFullMatch&&(He[0]+=2);const _e=Ze-X;return He[0]-=_e,He}e.$Jj=le;function we(se,oe,fe,Ie,M,K){let G=se-1,X=oe-1;for(;G>=fe&&X>=Ie;)M[G]===K[X]&&(N[G]=X,G--),X--}function ve(se,oe,fe,Ie,M,K,G,X,J,x,ae){if(oe[fe]!==K[G])return Number.MIN_SAFE_INTEGER;let Le=1,je=!1;return G===fe-Ie?Le=se[fe]===M[G]?7:5:ce(G,M,K)&&(G===0||!ce(G-1,M,K))?(Le=se[fe]===M[G]?7:5,je=!0):ue(K,G)&&(G===0||!ue(K,G-1))?Le=5:(ue(K,G-1)||ye(K,G-1))&&(Le=5,je=!0),Le>1&&fe===Ie&&(ae[0]=!0),je||(je=ce(G,M,K)||ue(K,G-1)||ye(K,G-1)),fe===Ie?G>J&&(Le-=je?3:5):x?Le+=je?2:0:Le+=je?0:1,G+1===X&&(Le-=je?3:5),Le}function me(se,oe,fe,Ie,M,K,G){return ne(se,oe,fe,Ie,M,K,!0,G)}e.$Kj=me;function De(se,oe,fe,Ie,M,K,G){return ne(se,oe,fe,Ie,M,K,!1,G)}e.$Lj=De;function ne(se,oe,fe,Ie,M,K,G,X){let J=le(se,oe,fe,Ie,M,K,X);if(J&&!G)return J;if(se.length>=3){const x=Math.min(7,se.length-1);for(let ae=fe+1;ae<x;ae++){const Le=he(se,ae);if(Le){const je=le(Le,Le.toLowerCase(),fe,Ie,M,K,X);je&&(je[0]-=3,(!J||je[0]>J[0])&&(J=je))}}}return J}function he(se,oe){if(oe+1>=se.length)return;const fe=se[oe],Ie=se[oe+1];if(fe!==Ie)return se.slice(0,oe)+Ie+fe+se.slice(oe+2)}}),define(Ae[29],Re([1,0,15]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(F||(F={})),function(C){const L="error",A="warning",l="warn",S="info",d="ignore";function P(u){return u?w.$Le(L,u)?C.Error:w.$Le(A,u)||w.$Le(l,u)?C.Warning:w.$Le(S,u)?C.Info:C.Ignore:C.Ignore}C.fromValue=P;function D(u){switch(u){case C.Error:return L;case C.Warning:return A;case C.Info:return S;default:return d}}C.toString=D}(F||(F={})),e.default=F}),define(Ae[121],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$bd=Symbol("MicrotaskDelay")}),define(Ae[48],Re([1,0,18,15]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=void 0;class C{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const p=b.charCodeAt(0),f=this.b.charCodeAt(this.c);return p-f}value(){return this.b[this.c]}}e.$Ch=C;class L{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,F.$Fe)(b,this.b,0,b.length,this.c,this.d):(0,F.$He)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Dh=L;class A{constructor(b=!0,p=!0){this.f=b,this.g=p}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let p=b.length-1;p>=0;p--,this.c--){const f=this.b.charCodeAt(p);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,F.$Fe)(b,this.b,0,b.length,this.d,this.e):(0,F.$He)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Eh=A;var l;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(l||(l={}));class S{constructor(b,p){this.f=b,this.g=p,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,F.$Ge)(b,this.c.scheme);if(this.d[this.e]===2)return(0,F.$Ge)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,F.$Ee)(b,this.c.query);if(this.d[this.e]===5)return(0,F.$Ee)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Fh=S;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(P||(P={}));class D{static forUris(b=()=>!1,p=()=>!1){return new D(new S(b,p))}static forPaths(b=!1){return new D(new A(void 0,!b))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new L)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,p){if(p){const f=p.slice(0);(0,w.$Ub)(f);for(const i of f)this.set(i,b)}else{const f=b.slice(0);(0,w.$Ub)(f);for(const i of f)this.set(i[0],i[1])}}set(b,p){const f=this.b.reset(b);let i;this.c||(this.c=new d,this.c.segment=f.value());const t=[];for(i=this.c;;){const g=f.cmp(i.segment);if(g>0)i.left||(i.left=new d,i.left.segment=f.value()),t.push([-1,i]),i=i.left;else if(g<0)i.right||(i.right=new d,i.right.segment=f.value()),t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),i.mid||(i.mid=new d,i.mid.segment=f.value()),t.push([0,i]),i=i.mid;else break}const c=i.value;i.value=p,i.key=b;for(let g=t.length-1;g>=0;g--){const E=t[g][1];E.updateHeight();const $=E.balanceFactor();if($<-1||$>1){const s=t[g][0],a=t[g+1][0];if(s===1&&a===1)t[g][1]=E.rotateLeft();else if(s===-1&&a===-1)t[g][1]=E.rotateRight();else if(s===1&&a===-1)E.right=t[g+1][1]=t[g+1][1].rotateRight(),t[g][1]=E.rotateLeft();else if(s===-1&&a===1)E.left=t[g+1][1]=t[g+1][1].rotateLeft(),t[g][1]=E.rotateRight();else throw new Error;if(g>0)switch(t[g-1][0]){case-1:t[g-1][1].left=t[g][1];break;case 1:t[g-1][1].right=t[g][1];break;case 0:t[g-1][1].mid=t[g][1];break}else this.c=t[0][1]}}return c}get(b){return this.d(b)?.value}d(b){const p=this.b.reset(b);let f=this.c;for(;f;){const i=p.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if(p.hasNext())p.next(),f=f.mid;else break}return f}has(b){const p=this.d(b);return!(p?.value===void 0&&p?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,p){const f=this.b.reset(b),i=[];let t=this.c;for(;t;){const c=f.cmp(t.segment);if(c>0)i.push([-1,t]),t=t.left;else if(c<0)i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),i.push([0,t]),t=t.mid;else break}if(t){if(p?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const c=this.f(t.right);if(c.key){const{key:g,value:E,segment:$}=c;this.e(c.key,!1),t.key=g,t.value=E,t.segment=$}}else{const c=t.left??t.right;if(i.length>0){const[g,E]=i[i.length-1];switch(g){case-1:E.left=c;break;case 0:E.mid=c;break;case 1:E.right=c;break}}else this.c=c}for(let c=i.length-1;c>=0;c--){const g=i[c][1];g.updateHeight();const E=g.balanceFactor();if(E>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),i[c][1]=g.rotateLeft()):E<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),i[c][1]=g.rotateRight()),c>0)switch(i[c-1][0]){case-1:i[c-1][1].left=i[c][1];break;case 1:i[c-1][1].right=i[c][1];break;case 0:i[c-1][1].mid=i[c][1];break}else this.c=i[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const p=this.b.reset(b);let f=this.c,i;for(;f;){const t=p.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(p.hasNext())p.next(),i=f.value||i,f=f.mid;else break}return f&&f.value||i}findSuperstr(b){return this.g(b,!1)}g(b,p){const f=this.b.reset(b);let i=this.c;for(;i;){const t=f.cmp(i.segment);if(t>0)i=i.left;else if(t<0)i=i.right;else if(f.hasNext())f.next(),i=i.mid;else return i.mid?this.h(i.mid):p?i.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[p,f]of this)b(f,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const p=[];return this.j(b,p),p[Symbol.iterator]()}j(b,p){b&&(b.left&&this.j(b.left,p),b.value&&p.push([b.key,b.value]),b.mid&&this.j(b.mid,p),b.right&&this.j(b.right,p))}_isBalanced(){const b=p=>{if(!p)return!0;const f=p.balanceFactor();return f<-1||f>1?!1:b(p.left)&&b(p.right)};return b(this.c)}}e.$Gh=D}),define(Ae[40],Re([1,0,89]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Pj=e.ThemeColor=void 0;var F;(function(A){function l(S){return S&&typeof S=="object"&&typeof S.id=="string"}A.isThemeColor=l})(F||(e.ThemeColor=F={}));function C(A){return{id:A}}e.$Pj=C;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function S(c){const g=l.exec(c.id);if(!g)return S(w.$Oj.error);const[,E,$]=g,s=["codicon","codicon-"+E];return $&&s.push("codicon-modifier-"+$.substring(1)),s}A.asClassNameArray=S;function d(c){return S(c).join(" ")}A.asClassName=d;function P(c){return"."+S(c).join(".")}A.asCSSSelector=P;function D(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||F.isThemeColor(c.color))}A.isThemeIcon=D;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(c){const g=u.exec(c);if(!g)return;const[,E]=g;return{id:E}}A.fromString=b;function p(c){return{id:c}}A.fromId=p;function f(c,g){let E=c.id;const $=E.lastIndexOf("~");return $!==-1&&(E=E.substring(0,$)),g&&(E=`${E}~${g}`),{id:E}}A.modify=f;function i(c){const g=c.id.lastIndexOf("~");if(g!==-1)return c.id.substring(g+1)}A.getModifier=i;function t(c,g){return c.id===g.id&&c.color?.id===g.color?.id}A.isEqual=t})(L||(e.ThemeIcon=L={}))}),define(Ae[122],Re([1,0,120,15,40]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=void 0;const L="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function S(t){return t.replace(l,(c,g)=>g?c:`\\${c}`)}e.$Qj=S;const d=new RegExp(`\\\\${A.source}`,"g");function P(t){return t.replace(d,c=>`\\${c}`)}e.$Rj=P;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(t){return t.indexOf(L)===-1?t:t.replace(D,(c,g,E,$)=>E?c:g||$||"")}e.$Sj=u;function b(t){return t?t.replace(/\$\((.*?)\)/g,(c,g)=>` ${g} `).trim():""}e.$Tj=b;const p=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(t){p.lastIndex=0;let c="";const g=[];let E=0;for(;;){const $=p.lastIndex,s=p.exec(t),a=t.substring($,s?.index);if(a.length>0){c+=a;for(let n=0;n<a.length;n++)g.push(E)}if(!s)break;E+=s[0].length}return{text:c,iconOffsets:g}}e.$Uj=f;function i(t,c,g=!1){const{text:E,iconOffsets:$}=c;if(!$||$.length===0)return(0,w.$Dj)(t,E,g);const s=(0,F.$te)(E," "),a=E.length-s.length,n=(0,w.$Dj)(t,s,g);if(n)for(const o of n){const y=$[o.start+a]+a;o.start+=y,o.end+=y}return n}e.$Vj=i}),define(Ae[36],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3f=e.$2f=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(C){return w.test(C)}e.$2f=F,e.$3f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let S=0;S<l.length;S++)l[S]=Math.floor(Math.random()*256);return l};const L=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,d="";return d+=A[L[S++]],d+=A[L[S++]],d+=A[L[S++]],d+=A[L[S++]],d+="-",d+=A[L[S++]],d+=A[L[S++]],d+="-",d+=A[L[S++]],d+=A[L[S++]],d+="-",d+=A[L[S++]],d+=A[L[S++]],d+="-",d+=A[L[S++]],d+=A[L[S++]],d+=A[L[S++]],d+=A[L[S++]],d+=A[L[S++]],d+=A[L[S++]],d}}()}),define(Ae[123],Re([1,0,18,66,36]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=e.$Rs=e.$Qs=e.$Ps=e.$Os=void 0;function L(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$Os=L;function A(D,u,b){const p={id:(0,C.$3f)(),name:D,uri:u,data:b};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$Ps=A;class l{constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return F.Iterable.some(this,([p,f])=>f.asFile())&&b.push("files"),P(S(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const p=this.a.get(u);p?p.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const p of b)yield[u,p]}b(u){return S(u)}}e.$Qs=l;function S(D){return D.toLowerCase()}function d(D,u){return P(S(D),u.map(S))}e.$Rs=d;function P(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const b=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[p,f,i]=b;return i==="*"?u.some(t=>t.startsWith(f+"/")):!1}e.$Ss=Object.freeze({create:D=>(0,w.$Jb)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Ss.split(D).filter(u=>!u.startsWith("#"))})}),define(Ae[124],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0,e.$Tr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[125],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=e.IndentAction=void 0;var w;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class F{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let S=0,d=l.notIn.length;S<d;S++)switch(l.notIn[S]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,S){if(l.getTokenCount()===0)return!0;const d=l.findTokenIndexAtOffset(S-2),P=l.getStandardTokenType(d);return this.isOK(P)}g(l,S){for(let d=l;d<=S;d++){const P=String.fromCharCode(d);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ft=F;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of l)L(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),L(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),L(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),L(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&L(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.$gt=C;function L(A,l,S){A.has(l)?A.get(l).push(S):A.set(l,[S])}}),define(Ae[126],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d7=e.$c7=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$c7=w;class F{constructor(L){this.identifier=L}}e.$d7=F}),define(Ae[127],Re([10,11]),function(be,e){return be.create("vs/base/common/actions",e)}),define(Ae[128],Re([1,0,5,6,127]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=void 0;class L extends F.$jc{constructor(u,b="",p="",f=!0,i){super(),this.h=this.B(new w.$ed),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=p,this.w=f,this.C=i}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$fi=L;class A extends F.$jc{constructor(){super(...arguments),this.f=this.B(new w.$ed),this.onWillRun=this.f.event,this.m=this.B(new w.$ed),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let p;try{await this.u(u,b)}catch(f){p=f}this.m.fire({action:u,error:p})}async u(u,b){await u.run(b)}}e.$gi=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const p of u)p.length&&(b.length?b=[...b,new l,...p]:b=p);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$hi=l;class S{get actions(){return this.a}constructor(u,b,p,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=f,this.a=p}async run(){}}e.$ii=S;class d extends L{static{this.ID="vs.actions.empty"}constructor(){super(d.ID,C.localize(0,null),void 0,!1)}}e.$ji=d;function P(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...u)=>D.run(),tooltip:D.label}}e.$ki=P}),define(Ae[129],Re([10,11]),function(be,e){return be.create("vs/base/common/date",e)}),define(Ae[130],Re([1,0,129]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=void 0;const F=60,C=F*60,L=C*24,A=L*7,l=L*30,S=L*365;function d(D,u,b,p){typeof D!="number"&&(D=D.getTime());const f=Math.round((new Date().getTime()-D)/1e3);if(f<-30)return(0,w.localize)(0,null,d(new Date().getTime()+f*1e3,!1));if(!p&&f<30)return(0,w.localize)(1,null);let i;return f<F?(i=f,u?i===1?b?(0,w.localize)(2,null,i):(0,w.localize)(3,null,i):b?(0,w.localize)(4,null,i):(0,w.localize)(5,null,i):i===1?b?(0,w.localize)(6,null,i):(0,w.localize)(7,null,i):b?(0,w.localize)(8,null,i):(0,w.localize)(9,null,i)):f<C?(i=Math.floor(f/F),u?i===1?b?(0,w.localize)(10,null,i):(0,w.localize)(11,null,i):b?(0,w.localize)(12,null,i):(0,w.localize)(13,null,i):i===1?b?(0,w.localize)(14,null,i):(0,w.localize)(15,null,i):b?(0,w.localize)(16,null,i):(0,w.localize)(17,null,i)):f<L?(i=Math.floor(f/C),u?i===1?b?(0,w.localize)(18,null,i):(0,w.localize)(19,null,i):b?(0,w.localize)(20,null,i):(0,w.localize)(21,null,i):i===1?b?(0,w.localize)(22,null,i):(0,w.localize)(23,null,i):b?(0,w.localize)(24,null,i):(0,w.localize)(25,null,i)):f<A?(i=Math.floor(f/L),u?i===1?(0,w.localize)(26,null,i):(0,w.localize)(27,null,i):i===1?(0,w.localize)(28,null,i):(0,w.localize)(29,null,i)):f<l?(i=Math.floor(f/A),u?i===1?b?(0,w.localize)(30,null,i):(0,w.localize)(31,null,i):b?(0,w.localize)(32,null,i):(0,w.localize)(33,null,i):i===1?b?(0,w.localize)(34,null,i):(0,w.localize)(35,null,i):b?(0,w.localize)(36,null,i):(0,w.localize)(37,null,i)):f<S?(i=Math.floor(f/l),u?i===1?b?(0,w.localize)(38,null,i):(0,w.localize)(39,null,i):b?(0,w.localize)(40,null,i):(0,w.localize)(41,null,i):i===1?b?(0,w.localize)(42,null,i):(0,w.localize)(43,null,i):b?(0,w.localize)(44,null,i):(0,w.localize)(45,null,i)):(i=Math.floor(f/S),u?i===1?b?(0,w.localize)(46,null,i):(0,w.localize)(47,null,i):b?(0,w.localize)(48,null,i):(0,w.localize)(49,null,i):i===1?b?(0,w.localize)(50,null,i):(0,w.localize)(51,null,i):b?(0,w.localize)(52,null,i):(0,w.localize)(53,null,i))}e.$5l=d;function P(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$6l=P}),define(Ae[131],Re([10,11]),function(be,e){return be.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,16,131]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.$mi=e.$li=void 0;function L(D,u){return u&&(D.stack||D.stacktrace)?C.localize(0,null,l(D),A(D.stack)||A(D.stacktrace)):l(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function l(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function S(D=null,u=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const b=w.$Eb(D),p=S(b[0],u);return b.length>1?C.localize(4,null,p,b.length):p}if(F.$if(D))return D;if(D.detail){const b=D.detail;if(b.error)return L(b.error,u);if(b.exception)return L(b.exception,u)}return D.stack?L(D,u):D.message?D.message:C.localize(5,null)}e.$li=S;function d(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}e.$mi=d;function P(D,u){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=u,b}e.$ni=P}),define(Ae[132],Re([1,0,65,19]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=void 0;const C=new w.$T(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),L=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(k,r,h=!1){const v=k||"",R=r||"",W=C.value.collator.compare(v,R);return C.value.collatorIsNumeric&&W===0&&v!==R?v<R?-1:1:W}e.$9p=l;function S(k,r){const h=L.value.collator;return k=k||"",r=r||"",E(h,k,r)}e.$0p=S;function d(k,r){const h=L.value.collator;return k=k||"",r=r||"",n(k,r)||E(h,k,r)}e.$$p=d;function P(k,r){const h=L.value.collator;return k=k||"",r=r||"",a(k,r)||E(h,k,r)}e.$_p=P;function D(k,r){return k=k||"",r=r||"",k===r?0:k<r?-1:1}e.$aq=D;function u(k,r){const[h,v]=c(k),[R,W]=c(r);let V=C.value.collator.compare(v,W);if(V===0){if(C.value.collatorIsNumeric&&v!==W)return v<W?-1:1;if(V=C.value.collator.compare(h,R),C.value.collatorIsNumeric&&V===0&&h!==R)return h<R?-1:1}return V}e.$bq=u;function b(k,r){k=k||"",r=r||"";const h=g(k),v=g(r),R=L.value.collator,W=A.value.collator;return E(W,h,v)||E(R,k,r)}e.$cq=b;function p(k,r){k=k||"",r=r||"";const h=g(k),v=g(r),R=L.value.collator,W=A.value.collator;return E(W,h,v)||n(k,r)||E(R,k,r)}e.$dq=p;function f(k,r){k=k||"",r=r||"";const h=g(k),v=g(r),R=L.value.collator,W=A.value.collator;return E(W,h,v)||a(k,r)||E(R,k,r)}e.$eq=f;function i(k,r){k=k||"",r=r||"";const h=g(k).toLowerCase(),v=g(r).toLowerCase();return h!==v?h<v?-1:1:k!==r?k<r?-1:1:0}e.$fq=i;const t=/^(.*?)(\.([^.]*))?$/;function c(k,r=!1){const h=k?t.exec(k):[];let v=[h&&h[1]||"",h&&h[3]||""];return r&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function g(k){const r=k?t.exec(k):[];return r&&r[1]&&r[1].charAt(0)!=="."&&r[3]||""}function E(k,r,h){const v=k.compare(r,h);return v!==0?v:r.length!==h.length?r.length<h.length?-1:1:0}function $(k){const r=k.charAt(0);return r.toLocaleUpperCase()!==r}function s(k){const r=k.charAt(0);return r.toLocaleLowerCase()!==r}function a(k,r){return $(k)&&s(r)?-1:s(k)&&$(r)?1:0}function n(k,r){return s(k)&&$(r)?-1:$(k)&&s(r)?1:0}function o(k,r,h=!1){return h||(k=k&&k.toLowerCase(),r=r&&r.toLowerCase()),k===r?0:k<r?-1:1}function y(k,r,h=!1){const v=k.split(F.sep),R=r.split(F.sep),W=v.length-1,V=R.length-1;let U,B;for(let O=0;;O++){if(U=W===O,B=V===O,U&&B)return l(v[O],R[O],h);if(U)return-1;if(B)return 1;const N=o(v[O],R[O],h);if(N!==0)return N}}e.$gq=y;function m(k,r,h){const v=k.toLowerCase(),R=r.toLowerCase(),W=I(k,r,h);if(W)return W;const V=v.endsWith(h),U=R.endsWith(h);if(V!==U)return V?-1:1;const B=l(v,R);return B!==0?B:v.localeCompare(R)}e.$hq=m;function I(k,r,h){const v=k.toLowerCase(),R=r.toLowerCase(),W=v.startsWith(h),V=R.startsWith(h);if(W!==V)return W?-1:1;if(W&&V){if(v.length<R.length)return-1;if(v.length>R.length)return 1}return 0}e.$iq=I}),define(Ae[42],Re([1,0,19,22,15,16]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=void 0;function A(m){return m===47||m===92}e.$Af=A;function l(m){return m.replace(/[\\/]/g,w.$5d.sep)}e.$Bf=l;function S(m){return m.indexOf("/")===-1&&(m=l(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Cf=S;function d(m,I=w.$5d.sep){if(!m)return"";const k=m.length,r=m.charCodeAt(0);if(A(r)){if(A(m.charCodeAt(1))&&!A(m.charCodeAt(2))){let v=3;const R=v;for(;v<k&&!A(m.charCodeAt(v));v++);if(R!==v&&!A(m.charCodeAt(v+1))){for(v+=1;v<k;v++)if(A(m.charCodeAt(v)))return m.slice(0,v+1).replace(/[\\/]/g,I)}}return I}else if(t(r)&&m.charCodeAt(1)===58)return A(m.charCodeAt(2))?m.slice(0,2)+I:m.slice(0,2);let h=m.indexOf("://");if(h!==-1){for(h+=3;h<k;h++)if(A(m.charCodeAt(h)))return m.slice(0,h+1)}return""}e.$Df=d;function P(m){if(!F.$i||!m||m.length<5)return!1;let I=m.charCodeAt(0);if(I!==92||(I=m.charCodeAt(1),I!==92))return!1;let k=2;const r=k;for(;k<m.length&&(I=m.charCodeAt(k),I!==92);k++);return!(r===k||(I=m.charCodeAt(k+1),isNaN(I)||I===92))}e.$Ef=P;const D=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(m,I=F.$i){const k=I?D:u;return!(!m||m.length===0||/^\s+$/.test(m)||(k.lastIndex=0,k.test(m))||I&&b.test(m)||m==="."||m===".."||I&&m[m.length-1]==="."||I&&m.length!==m.trim().length||m.length>255)}e.$Ff=p;function f(m,I,k){const r=m===I;return!k||r?r:!m||!I?!1:(0,C.$Le)(m,I)}e.$Gf=f;function i(m,I,k,r=w.sep){if(m===I)return!0;if(!m||!I||I.length>m.length)return!1;if(k){if(!(0,C.$Me)(m,I))return!1;if(I.length===m.length)return!0;let v=I.length;return I.charAt(I.length-1)===r&&v--,m.charAt(v)===r}return I.charAt(I.length-1)!==r&&(I+=r),m.indexOf(I)===0}e.$Hf=i;function t(m){return m>=65&&m<=90||m>=97&&m<=122}e.$If=t;function c(m,I){return F.$i&&m.endsWith(":")&&(m+=w.sep),(0,w.$7d)(m)||(m=(0,w.$8d)(I,m)),m=(0,w.$6d)(m),F.$i?(m=(0,C.$ue)(m,w.sep),m.endsWith(":")&&(m+=w.sep)):(m=(0,C.$ue)(m,w.sep),m||(m=w.sep)),m}e.$Jf=c;function g(m){const I=(0,w.$6d)(m);return F.$i?m.length>3?!1:E(I)&&(m.length===2||I.charCodeAt(2)===92):I===w.$5d.sep}e.$Kf=g;function E(m,I=F.$i){return I?t(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$Lf=E;function $(m,I=F.$i){return E(m,I)?m[0]:void 0}e.$Mf=$;function s(m,I,k){return I.length>m.length?-1:m===I?0:(k&&(m=m.toLowerCase(),I=I.toLowerCase()),m.indexOf(I))}e.$Nf=s;function a(m){const I=m.split(":");let k,r,h;for(const v of I){const R=Number(v);(0,L.$mf)(R)?r===void 0?r=R:h===void 0&&(h=R):k=k?[k,v].join(":"):v}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:r!==void 0?r:void 0,column:h!==void 0?h:r!==void 0?1:void 0}}e.$Of=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function y(m,I,k=8){let r="";for(let v=0;v<k;v++){let R;v===0&&F.$i&&!I&&(k===3||k===4)?R=o:R=n,r+=R.charAt(Math.floor(Math.random()*R.length))}let h;return I?h=`${I}-${r}`:h=r,m?(0,w.$8d)(m,h):h}e.$Pf=y}),define(Ae[67],Re([1,0,19]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=e.$Hr=e.$Gr=void 0,e.$Gr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(P){const D=(0,w.$ae)(P),u=F[D.toLowerCase()];return u!==void 0?u:A(P)}e.$Hr=L;function A(P){const D=(0,w.$ae)(P);return C[D.toLowerCase()]}e.$Ir=A;function l(P){for(const D in C)if(C[D]===P)return D}e.$Jr=l;const S=/^(.+)\/(.+?)(;.+)?$/;function d(P,D){const u=S.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:P}e.$Kr=d}),define(Ae[68],Re([1,0,25,2]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0g=e.$9g=e.$8g=void 0;function C(S){return JSON.stringify(S,A)}e.$8g=C;function L(S){let d=JSON.parse(S);return d=l(d),d}e.$9g=L;function A(S,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function l(S,d=0){if(!S||d>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return F.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof w.$Ed||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let P=0;P<S.length;++P)S[P]=l(S[P],d+1);else for(const P in S)Object.hasOwnProperty.call(S,P)&&(S[P]=l(S[P],d+1))}return S}e.$0g=l}),define(Ae[12],Re([1,0,9,22,2]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.Schemas=void 0;var L;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Tf="vscode-tkn",e.$Uf="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${L.vscodeRemoteResource}`}set(P,D,u){this.a[P]=D,this.b[P]=u}setConnectionToken(P,D){this.c[P]=D}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(i){return w.$Y(i),P}const D=P.authority;let u=this.a[D];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const b=this.b[D],p=this.c[D];let f=`path=${encodeURIComponent(P.path)}`;return typeof p=="string"&&(f+=`&${e.$Uf}=${encodeURIComponent(p)}`),C.URI.from({scheme:F.$o?this.d:L.vscodeRemoteResource,authority:`${u}:${b}`,path:this.f,query:f})}}e.$Vf=new A,e.$Wf="vs/../../extensions",e.$Xf="vs/../../node_modules",e.$Yf="vs/../../node_modules.asar",e.$Zf="vs/../../node_modules.asar.unpacked";class l{static{this.a="vscode-app"}asBrowserUri(P){const D=this.b(P,be);return this.uriToBrowserUri(D)}uriToBrowserUri(P){return P.scheme===L.vscodeRemote?e.$Vf.rewrite(P):P.scheme===L.file&&(F.$m||F.$p&&F.$g.origin===`${L.vscodeFileResource}://${l.a}`)?P.with({scheme:L.vscodeFileResource,authority:P.authority||l.a,query:null,fragment:null}):P}asFileUri(P){const D=this.b(P,be);return this.uriToFileUri(D)}uriToFileUri(P){return P.scheme===L.vscodeFileResource?P.with({scheme:L.file,authority:P.authority!==l.a?P.authority:null,query:null,fragment:null}):P}b(P,D){return C.URI.isUri(P)?P:C.URI.parse(D.toUrl(P))}}e.$1f=new l;var S;(function(d){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(P.get("3"));const D="vscode-coi";function u(p){let f;typeof p=="string"?f=new URL(p).searchParams:p instanceof URL?f=p.searchParams:C.URI.isUri(p)&&(f=new URL(p.toString(!0)).searchParams);const i=f?.get(D);if(i)return P.get(i)}d.getHeadersFromQuery=u;function b(p,f,i){if(!globalThis.crossOriginIsolated)return;const t=f&&i?"3":i?"2":"1";p instanceof URLSearchParams?p.set(D,t):p[D]=t}d.addSearchParam=b})(S||(e.COI=S={}))}),define(Ae[23],Re([1,0,42,12,19,22,15,2]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.DataUri=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=void 0;function S(b){return(0,l.$Sf)(b,!0)}e.$8f=S;class d{constructor(p){this.a=p}compare(p,f,i=!1){return p===f?0:(0,A.$Ee)(this.getComparisonKey(p,i),this.getComparisonKey(f,i))}isEqual(p,f,i=!1){return p===f?!0:!p||!f?!1:this.getComparisonKey(p,i)===this.getComparisonKey(f,i)}getComparisonKey(p,f=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,f,i=!1){if(p.scheme===f.scheme){if(p.scheme===F.Schemas.file)return w.$Hf(S(p),S(f),this.a(p))&&p.query===f.query&&(i||p.fragment===f.fragment);if((0,e.$mg)(p.authority,f.authority))return w.$Hf(p.path,f.path,this.a(p),"/")&&p.query===f.query&&(i||p.fragment===f.fragment)}return!1}joinPath(p,...f){return l.URI.joinPath(p,...f)}basenameOrAuthority(p){return(0,e.$eg)(p)||p.authority}basename(p){return C.$5d.basename(p.path)}extname(p){return C.$5d.extname(p.path)}dirname(p){if(p.path.length===0)return p;let f;return p.scheme===F.Schemas.file?f=l.URI.file(C.$$d(S(p))).path:(f=C.$5d.dirname(p.path),p.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),f="/")),p.with({path:f})}normalizePath(p){if(!p.path.length)return p;let f;return p.scheme===F.Schemas.file?f=l.URI.file(C.$6d(S(p))).path:f=C.$5d.normalize(p.path),p.with({path:f})}relativePath(p,f){if(p.scheme!==f.scheme||!(0,e.$mg)(p.authority,f.authority))return;if(p.scheme===F.Schemas.file){const c=C.$0d(S(p),S(f));return L.$i?w.$Bf(c):c}let i=p.path||"/";const t=f.path||"/";if(this.a(p)){let c=0;for(const g=Math.min(i.length,t.length);c<g&&!(i.charCodeAt(c)!==t.charCodeAt(c)&&i.charAt(c).toLowerCase()!==t.charAt(c).toLowerCase());c++);i=t.substr(0,c)+i.substr(c)}return C.$5d.relative(i,t)}resolvePath(p,f){if(p.scheme===F.Schemas.file){const i=l.URI.file(C.$9d(S(p),f));return p.with({authority:i.authority,path:i.path})}return f=w.$Cf(f),p.with({path:C.$5d.resolve(p.path,f)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,f){return p===f||p!==void 0&&f!==void 0&&(0,A.$Le)(p,f)}hasTrailingPathSeparator(p,f=C.sep){if(p.scheme===F.Schemas.file){const i=S(p);return i.length>w.$Df(i).length&&i[i.length-1]===f}else{const i=p.path;return i.length>1&&i.charCodeAt(i.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,f=C.sep){return(0,e.$ng)(p,f)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,f=C.sep){let i=!1;if(p.scheme===F.Schemas.file){const t=S(p);i=t!==void 0&&t.length===w.$Df(t).length&&t[t.length-1]===f}else{f="/";const t=p.path;i=t.length===1&&t.charCodeAt(t.length-1)===47}return!i&&!(0,e.$ng)(p,f)?p.with({path:p.path+"/"}):p}}e.$9f=d,e.$0f=new d(()=>!1),e.$$f=new d(b=>b.scheme===F.Schemas.file?!L.$k:!0),e.$_f=new d(b=>!0),e.$ag=e.$0f.isEqual.bind(e.$0f),e.$bg=e.$0f.isEqualOrParent.bind(e.$0f),e.$cg=e.$0f.getComparisonKey.bind(e.$0f),e.$dg=e.$0f.basenameOrAuthority.bind(e.$0f),e.$eg=e.$0f.basename.bind(e.$0f),e.$fg=e.$0f.extname.bind(e.$0f),e.$gg=e.$0f.dirname.bind(e.$0f),e.$hg=e.$0f.joinPath.bind(e.$0f),e.$ig=e.$0f.normalizePath.bind(e.$0f),e.$jg=e.$0f.relativePath.bind(e.$0f),e.$kg=e.$0f.resolvePath.bind(e.$0f),e.$lg=e.$0f.isAbsolutePath.bind(e.$0f),e.$mg=e.$0f.isEqualAuthority.bind(e.$0f),e.$ng=e.$0f.hasTrailingPathSeparator.bind(e.$0f),e.$og=e.$0f.removeTrailingPathSeparator.bind(e.$0f),e.$pg=e.$0f.addTrailingPathSeparator.bind(e.$0f);function P(b,p){const f=[];for(let i=0;i<b.length;i++){const t=p(b[i]);b.some((c,g)=>g===i?!1:(0,e.$bg)(t,p(c)))||f.push(b[i])}return f}e.$qg=P;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(f){const i=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(g=>{const[E,$]=g.split(":");E&&$&&i.set(E,$)});const c=f.path.substring(0,f.path.indexOf(";"));return c&&i.set(b.META_DATA_MIME,c),i}b.parseMetaData=p})(D||(e.DataUri=D={}));function u(b,p,f){if(p){let i=b.path;return i&&i[0]!==C.$5d.sep&&(i=C.$5d.sep+i),b.with({scheme:f,authority:p,path:i})}return b.with({scheme:f})}e.$rg=u}),define(Ae[13],Re([1,0,21,9,5,6,23,22,121]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.$3g=e.$2g=e.Promises=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=void 0;function d(z){return!!z&&typeof z.then=="function"}e.$sg=d;function P(z){const q=new w.$od,le=z(q.token),we=new Promise((ve,me)=>{const De=q.token.onCancellationRequested(()=>{De.dispose(),q.dispose(),me(new F.$3)});Promise.resolve(le).then(ne=>{De.dispose(),q.dispose(),ve(ne)},ne=>{De.dispose(),q.dispose(),me(ne)})});return new class{cancel(){q.cancel()}then(ve,me){return we.then(ve,me)}catch(ve){return this.then(void 0,ve)}finally(ve){return we.finally(ve)}}}e.$tg=P;function D(z,q,le){return new Promise((we,ve)=>{const me=q.onCancellationRequested(()=>{me.dispose(),we(le)});z.then(we,ve).finally(()=>me.dispose())})}e.$ug=D;function u(z,q){return new Promise((le,we)=>{const ve=q.onCancellationRequested(()=>{ve.dispose(),we(new F.$3)});z.then(le,we).finally(()=>ve.dispose())})}e.$vg=u;async function b(z){let q=-1;const le=z.map((we,ve)=>we.then(me=>(q=ve,me)));try{return await Promise.race(le)}finally{z.forEach((we,ve)=>{ve!==q&&we.cancel()})}}e.$wg=b;function p(z,q,le){let we;const ve=setTimeout(()=>{we?.(void 0),le?.()},q);return Promise.race([z.finally(()=>clearTimeout(ve)),new Promise(me=>we=me)])}e.$xg=p;function f(z){return new Promise((q,le)=>{const we=z();d(we)?we.then(q,le):q(we)})}e.$yg=f;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=q,!this.b){const le=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(le,le).then(we)})}return new Promise((le,we)=>{this.b.then(le,we)})}return this.a=q(),new Promise((le,we)=>{this.a.then(ve=>{this.a=null,le(ve)},ve=>{this.a=null,we(ve)})})}dispose(){this.f=!0}}e.$zg=i;class t{constructor(){this.a=Promise.resolve(null)}queue(q){return this.a=this.a.then(()=>q(),()=>q())}}e.$Ag=t;class c{constructor(){this.a=new Map}queue(q,le){const ve=(this.a.get(q)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(q)===ve&&this.a.delete(q)});return this.a.set(q,ve),ve}}e.$Bg=c;const g=(z,q)=>{let le=!0;const we=setTimeout(()=>{le=!1,q()},z);return{isTriggered:()=>le,dispose:()=>{clearTimeout(we),le=!1}}},E=z=>{let q=!0;return queueMicrotask(()=>{q&&(q=!1,z())}),{isTriggered:()=>q,dispose:()=>{q=!1}}};class ${constructor(q){this.defaultDelay=q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(q,le=this.defaultDelay){this.g=q,this.h(),this.b||(this.b=new Promise((ve,me)=>{this.d=ve,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=le===S.$bd?E(we):g(le,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Cg=$;class s{constructor(q){this.a=new $(q),this.b=new i}trigger(q,le){return this.a.trigger(()=>this.b.queue(q),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dg=s;class a{constructor(){this.a=!1,this.b=new Promise((q,le)=>{this.d=q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eg=a;class n extends a{constructor(q){super(),this.f=setTimeout(()=>this.open(),q)}open(){clearTimeout(this.f),super.open()}}e.$Fg=n;function o(z,q){return q?new Promise((le,we)=>{const ve=setTimeout(()=>{me.dispose(),le()},z),me=q.onCancellationRequested(()=>{clearTimeout(ve),me.dispose(),we(new F.$3)})}):P(le=>o(z,le))}e.$Gg=o;function y(z,q=0){const le=setTimeout(z,q);return(0,L.$hc)(()=>clearTimeout(le))}e.$Hg=y;function m(z){const q=[];let le=0;const we=z.length;function ve(){return le<we?z[le++]():null}function me(De){De!=null&&q.push(De);const ne=ve();return ne?ne.then(me):Promise.resolve(q)}return Promise.resolve(null).then(me)}e.$Ig=m;function I(z,q=we=>!!we,le=null){let we=0;const ve=z.length,me=()=>{if(we>=ve)return Promise.resolve(le);const De=z[we++];return Promise.resolve(De()).then(he=>q(he)?Promise.resolve(he):me())};return me()}e.$Jg=I;function k(z,q=we=>!!we,le=null){if(z.length===0)return Promise.resolve(le);let we=z.length;const ve=()=>{we=-1;for(const me of z)me.cancel?.()};return new Promise((me,De)=>{for(const ne of z)ne.then(he=>{--we>=0&&q(he)?(ve(),me(he)):we===0&&me(le)}).catch(he=>{--we>=0&&(ve(),De(he))})})}e.$Kg=k;class r{constructor(q){this.a=0,this.d=q,this.f=[],this.b=0,this.g=new C.$ed}get onDrained(){return this.g.event}get size(){return this.a}queue(q){return this.a++,new Promise((le,we)=>{this.f.push({factory:q,c:le,e:we}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const q=this.f.shift();this.b++;const le=q.factory();le.then(q.c,q.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Lg=r;class h extends r{constructor(){super(1)}}e.$Mg=h;class v{constructor(){this.a=new Ee,this.b=0}queue(q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,q())):this.a.run(this.b++,q())}}e.$Ng=v;class R{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const q=new Z;return this.b.add(q),q.p}g(){for(const[,q]of this.a)if(q.size>0)return!1;return!0}queueFor(q,le=A.$0f){const we=le.getComparisonKey(q);let ve=this.a.get(we);if(!ve){ve=new h;const me=this.f++,De=C.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(we),this.h(),this.d?.deleteAndDispose(me),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$rc),this.d.set(me,De),this.a.set(we,ve)}return ve}h(){this.g()&&this.j()}j(){for(const q of this.b)q.complete();this.b.clear()}dispose(){for(const[,q]of this.a)q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Og=R;class W{constructor(q,le){this.a=-1,typeof q=="function"&&typeof le=="number"&&this.setIfNotSet(q,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(q,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,q()},le)}setIfNotSet(q,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,q()},le))}}e.$Pg=W;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(q,le){this.cancel(),this.a=setInterval(()=>{q()},le)}}e.$Qg=V;class U{constructor(q,le){this.b=-1,this.a=q,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(q=this.d){this.cancel(),this.b=setTimeout(this.f,q)}get delay(){return this.d}set delay(q){this.d=q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rg=U;class B{constructor(q,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=q,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(q=this.b){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sg=B;class O extends U{constructor(q,le){super(q,le),this.j=[]}work(q){this.j.push(q),this.isScheduled()||this.schedule()}h(){const q=this.j;this.j=[],this.a?.(q)}dispose(){this.j=[],super.dispose()}}e.$Tg=O;class N extends L.$jc{constructor(q,le){super(),this.g=q,this.h=le,this.a=[],this.b=this.B(new L.$kc),this.f=!1}get pending(){return this.a.length}work(q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+q.length>this.g.maxBufferedWork)return!1}else if(this.pending+q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of q)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ug=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Vg=z=>{(0,l.$A)(()=>{if(q)return;const le=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$Vg=(z,q)=>{const le=requestIdleCallback(z,typeof q=="number"?{timeout:q}:void 0);let we=!1;return{dispose(){we||(we=!0,cancelIdleCallback(le))}}}}();class ee{constructor(q){this.d=!1,this.a=()=>{try{this.f=q()}catch(le){this.g=le}finally{this.d=!0}},this.b=(0,e.$Vg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Wg=ee;async function Y(z,q,le){let we;for(let ve=0;ve<le;ve++)try{return await z()}catch(me){we=me,await o(q)}throw we}e.$Xg=Y;class Ee{isRunning(q){return typeof q=="number"?this.a?.taskId===q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(q,le,we){return this.a={taskId:q,cancel:()=>we?.(),promise:le},le.then(()=>this.d(q),()=>this.d(q)),le}d(q){this.a&&q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const q=this.b;this.b=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}queue(q){if(this.b)this.b.run=q;else{let le,we;const ve=new Promise((me,De)=>{le=me,we=De});this.b={run:q,promise:ve,promiseResolve:le,promiseReject:we}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Yg=Ee;class ke{constructor(q,le=()=>Date.now()){this.d=q,this.f=le,this.a=0,this.b=0}increment(){const q=this.f();return q-this.a>this.d&&(this.a=q,this.b=0),this.b++,this.b}}e.$Zg=ke;var Pe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Pe||(Pe={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((q,le)=>{this.a=q,this.b=le})}complete(q){return new Promise(le=>{this.a(q),this.d={outcome:0,value:q},le()})}error(q){return new Promise(le=>{this.b(q),this.d={outcome:1,value:q},le()})}cancel(){return this.error(new F.$3)}}e.$1g=Z;var ue;(function(z){async function q(we){let ve;const me=await Promise.all(we.map(De=>De.then(ne=>ne,ne=>{ve||(ve=ne)})));if(typeof ve<"u")throw ve;return me}z.settled=q;function le(we){return new Promise(async(ve,me)=>{try{await we(ve,me)}catch(De){me(De)}})}z.withAsyncBody=le})(ue||(e.Promises=ue={}));var ye;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(ye||(ye={}));class ce{static fromArray(q){return new ce(le=>{le.emitMany(q)})}static fromPromise(q){return new ce(async le=>{le.emitMany(await q)})}static fromPromises(q){return new ce(async le=>{await Promise.all(q.map(async we=>le.emitOne(await we)))})}static merge(q){return new ce(async le=>{await Promise.all(q.map(async we=>{for await(const ve of we)le.emitOne(ve)}))})}static{this.EMPTY=ce.fromArray([])}constructor(q){this.a=0,this.b=[],this.d=null,this.f=new C.$ed,queueMicrotask(async()=>{const le={emitOne:we=>this.g(we),emitMany:we=>this.h(we),reject:we=>this.k(we)};try{await Promise.resolve(q(le)),this.j()}catch(we){this.k(we)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(q<this.b.length)return{done:!1,value:this.b[q++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(q,le){return new ce(async we=>{for await(const ve of q)we.emitOne(le(ve))})}map(q){return ce.map(this,q)}static filter(q,le){return new ce(async we=>{for await(const ve of q)le(ve)&&we.emitOne(ve)})}filter(q){return ce.filter(this,q)}static coalesce(q){return ce.filter(q,le=>!!le)}coalesce(){return ce.coalesce(this)}static async toPromise(q){const le=[];for await(const we of q)le.push(we);return le}toPromise(){return ce.toPromise(this)}g(q){this.a===0&&(this.b.push(q),this.f.fire())}h(q){this.a===0&&(this.b=this.b.concat(q),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(q){this.a===0&&(this.a=2,this.d=q,this.f.fire())}}e.$2g=ce;class $e extends ce{constructor(q,le){super(le),this.l=q}cancel(){this.l.cancel()}}e.$3g=$e;function ie(z){const q=new w.$od,le=z(q.token);return new $e(q,async we=>{const ve=q.token.onCancellationRequested(()=>{ve.dispose(),q.dispose(),we.reject(new F.$3)});try{for await(const me of le){if(q.token.isCancellationRequested)return;we.emitOne(me)}ve.dispose(),q.dispose()}catch(me){ve.dispose(),q.dispose(),we.reject(me)}})}e.$4g=ie}),define(Ae[37],Re([1,0,18,13,42,28,19,22,15]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=void 0;function d(){return Object.create(null)}e.$lj=d,e.$mj="**",e.$nj="/";const P="[/\\\\]",D="[^/\\\\]",u=/\//g;function b(Ee,ke){switch(Ee){case 0:return"";case 1:return`${D}*?`;default:return`(?:${P}|${D}+${P}${ke?`|${P}${D}+`:""})*?`}}function p(Ee,ke){if(!Ee)return[];const Pe=[];let Z=!1,ue=!1,ye="";for(const ce of Ee){switch(ce){case ke:if(!Z&&!ue){Pe.push(ye),ye="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ye+=ce}return ye&&Pe.push(ye),Pe}e.$oj=p;function f(Ee){if(!Ee)return"";let ke="";const Pe=p(Ee,e.$nj);if(Pe.every(Z=>Z===e.$mj))ke=".*";else{let Z=!1;Pe.forEach((ue,ye)=>{if(ue===e.$mj){if(Z)return;ke+=b(2,ye===Pe.length-1)}else{let ce=!1,$e="",ie=!1,z="";for(const q of ue){if(q!=="}"&&ce){$e+=q;continue}if(ie&&(q!=="]"||!z)){let le;q==="-"?le=q:(q==="^"||q==="!")&&!z?le="^":q===e.$nj?le="":le=(0,S.$pe)(q),z+=le;continue}switch(q){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const we=`(?:${p($e,",").map(ve=>f(ve)).join("|")})`;ke+=we,ce=!1,$e="";break}case"]":{ke+="["+z+"]",ie=!1,z="";break}case"?":ke+=D;continue;case"*":ke+=b(1);continue;default:ke+=(0,S.$pe)(q)}}ye<Pe.length-1&&(Pe[ye+1]!==e.$mj||ye+2<Pe.length)&&(ke+=P)}Z=ue===e.$mj})}return ke}const i=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,$=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new L.$Bi(1e4),a=function(){return!1},n=function(){return null};function o(Ee,ke){if(!Ee)return n;let Pe;typeof Ee!="string"?Pe=Ee.pattern:Pe=Ee,Pe=Pe.trim();const Z=`${Pe}_${!!ke.trimForExclusions}`;let ue=s.get(Z);if(ue)return y(ue,Ee);let ye;return i.test(Pe)?ue=I(Pe.substr(4),Pe):(ye=t.exec(m(Pe,ke)))?ue=k(ye[1],Pe):(ke.trimForExclusions?g:c).test(Pe)?ue=r(Pe,ke):(ye=E.exec(m(Pe,ke)))?ue=h(ye[1].substr(1),Pe,!0):(ye=$.exec(m(Pe,ke)))?ue=h(ye[1],Pe,!1):ue=v(Pe),s.set(Z,ue),y(ue,Ee)}function y(Ee,ke){if(typeof ke=="string")return Ee;const Pe=function(Z,ue){return(0,C.$Hf)(Z,ke.base,!l.$k)?Ee((0,S.$te)(Z.substr(ke.base.length),A.sep),ue):null};return Pe.allBasenames=Ee.allBasenames,Pe.allPaths=Ee.allPaths,Pe.basenames=Ee.basenames,Pe.patterns=Ee.patterns,Pe}function m(Ee,ke){return ke.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,ke){return function(Pe,Z){return typeof Pe=="string"&&Pe.endsWith(Ee)?ke:null}}function k(Ee,ke){const Pe=`/${Ee}`,Z=`\\${Ee}`,ue=function(ce,$e){return typeof ce!="string"?null:$e?$e===Ee?ke:null:ce===Ee||ce.endsWith(Pe)||ce.endsWith(Z)?ke:null},ye=[Ee];return ue.basenames=ye,ue.patterns=[ke],ue.allBasenames=ye,ue}function r(Ee,ke){const Pe=ee(Ee.slice(1,-1).split(",").map($e=>o($e,ke)).filter($e=>$e!==n),Ee),Z=Pe.length;if(!Z)return n;if(Z===1)return Pe[0];const ue=function($e,ie){for(let z=0,q=Pe.length;z<q;z++)if(Pe[z]($e,ie))return Ee;return null},ye=Pe.find($e=>!!$e.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(ue.allPaths=ce),ue}function h(Ee,ke,Pe){const Z=A.sep===A.$5d.sep,ue=Z?Ee:Ee.replace(u,A.sep),ye=A.sep+ue,ce=A.$5d.sep+Ee;let $e;return Pe?$e=function(ie,z){return typeof ie=="string"&&(ie===ue||ie.endsWith(ye)||!Z&&(ie===Ee||ie.endsWith(ce)))?ke:null}:$e=function(ie,z){return typeof ie=="string"&&(ie===ue||!Z&&ie===Ee)?ke:null},$e.allPaths=[(Pe?"*/":"./")+Ee],$e}function v(Ee){try{const ke=new RegExp(`^${f(Ee)}$`);return function(Pe){return ke.lastIndex=0,typeof Pe=="string"&&ke.test(Pe)?Ee:null}}catch{return n}}function R(Ee,ke,Pe){return!Ee||typeof ke!="string"?!1:W(Ee)(ke,void 0,Pe)}e.$pj=R;function W(Ee,ke={}){if(!Ee)return a;if(typeof Ee=="string"||V(Ee)){const Pe=o(Ee,ke);if(Pe===n)return a;const Z=function(ue,ye){return!!Pe(ue,ye)};return Pe.allBasenames&&(Z.allBasenames=Pe.allBasenames),Pe.allPaths&&(Z.allPaths=Pe.allPaths),Z}return O(Ee,ke)}e.$qj=W;function V(Ee){const ke=Ee;return ke?typeof ke.base=="string"&&typeof ke.pattern=="string":!1}e.$rj=V;function U(Ee){return Ee.allBasenames||[]}e.$sj=U;function B(Ee){return Ee.allPaths||[]}e.$tj=B;function O(Ee,ke){const Pe=ee(Object.getOwnPropertyNames(Ee).map($e=>N($e,Ee[$e],ke)).filter($e=>$e!==n)),Z=Pe.length;if(!Z)return n;if(!Pe.some($e=>!!$e.requiresSiblings)){if(Z===1)return Pe[0];const $e=function(q,le){let we;for(let ve=0,me=Pe.length;ve<me;ve++){const De=Pe[ve](q,le);if(typeof De=="string")return De;(0,F.$sg)(De)&&(we||(we=[]),we.push(De))}return we?(async()=>{for(const ve of we){const me=await ve;if(typeof me=="string")return me}return null})():null},ie=Pe.find(q=>!!q.allBasenames);ie&&($e.allBasenames=ie.allBasenames);const z=Pe.reduce((q,le)=>le.allPaths?q.concat(le.allPaths):q,[]);return z.length&&($e.allPaths=z),$e}const ue=function($e,ie,z){let q,le;for(let we=0,ve=Pe.length;we<ve;we++){const me=Pe[we];me.requiresSiblings&&z&&(ie||(ie=(0,A.$_d)($e)),q||(q=ie.substr(0,ie.length-(0,A.$ae)($e).length)));const De=me($e,ie,q,z);if(typeof De=="string")return De;(0,F.$sg)(De)&&(le||(le=[]),le.push(De))}return le?(async()=>{for(const we of le){const ve=await we;if(typeof ve=="string")return ve}return null})():null},ye=Pe.find($e=>!!$e.allBasenames);ye&&(ue.allBasenames=ye.allBasenames);const ce=Pe.reduce(($e,ie)=>ie.allPaths?$e.concat(ie.allPaths):$e,[]);return ce.length&&(ue.allPaths=ce),ue}function N(Ee,ke,Pe){if(ke===!1)return n;const Z=o(Ee,Pe);if(Z===n)return n;if(typeof ke=="boolean")return Z;if(ke){const ue=ke.when;if(typeof ue=="string"){const ye=(ce,$e,ie,z)=>{if(!z||!Z(ce,$e))return null;const q=ue.replace("$(basename)",()=>ie),le=z(q);return(0,F.$sg)(le)?le.then(we=>we?Ee:null):le?Ee:null};return ye.requiresSiblings=!0,ye}}return Z}function ee(Ee,ke){const Pe=Ee.filter($e=>!!$e.basenames);if(Pe.length<2)return Ee;const Z=Pe.reduce(($e,ie)=>{const z=ie.basenames;return z?$e.concat(z):$e},[]);let ue;if(ke){ue=[];for(let $e=0,ie=Z.length;$e<ie;$e++)ue.push(ke)}else ue=Pe.reduce(($e,ie)=>{const z=ie.patterns;return z?$e.concat(z):$e},[]);const ye=function($e,ie){if(typeof $e!="string")return null;if(!ie){let q;for(q=$e.length;q>0;q--){const le=$e.charCodeAt(q-1);if(le===47||le===92)break}ie=$e.substr(q)}const z=Z.indexOf(ie);return z!==-1?ue[z]:null};ye.basenames=Z,ye.patterns=ue,ye.allBasenames=Z;const ce=Ee.filter($e=>!$e.basenames);return ce.push(ye),ce}function Y(Ee,ke){return(0,w.$sb)(Ee,ke,(Pe,Z)=>typeof Pe=="string"&&typeof Z=="string"?Pe===Z:typeof Pe!="string"&&typeof Z!="string"?Pe.base===Z.base&&Pe.pattern===Z.pattern:!1)}e.$uj=Y}),define(Ae[49],Re([1,0,9,122,23,15,2]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class S{constructor(t="",c=!1){if(this.value=t,typeof this.value!="string")throw(0,w.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(t,c=0){return this.value+=u(this.supportThemeIcons?(0,F.$Qj)(t):t).replace(/([ \t]+)/g,(g,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,c){return this.value+="\n```",this.value+=t,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(t,c,g){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(t),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(t,c){const g=new RegExp((0,L.$pe)(c),"g");return t.replace(g,(E,$)=>t.charAt($-1)!=="\\"?`\\${E}`:E)}}e.$Wj=S;function d(i){return P(i)?!i.value:Array.isArray(i)?i.every(d):!0}e.$Xj=d;function P(i){return i instanceof S?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||typeof i.isTrusted=="object"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.$Yj=P;function D(i,t){return i===t?!0:!i||!t?!1:i.value===t.value&&i.isTrusted===t.isTrusted&&i.supportThemeIcons===t.supportThemeIcons&&i.supportHtml===t.supportHtml&&(i.baseUri===t.baseUri||!!i.baseUri&&!!t.baseUri&&(0,C.$ag)(A.URI.from(i.baseUri),A.URI.from(t.baseUri)))}e.$Zj=D;function u(i){return i.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$1j=u;function b(i){return i.replace(/"/g,"&quot;")}e.$2j=b;function p(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$3j=p;function f(i){const t=[],c=i.split("|").map(E=>E.trim());i=c[0];const g=c[1];if(g){const E=/height=(\d+)/.exec(g),$=/width=(\d+)/.exec(g),s=E?E[1]:"",a=$?$[1]:"",n=isFinite(parseInt(a)),o=isFinite(parseInt(s));n&&t.push(`width="${a}"`),o&&t.push(`height="${s}"`)}return{href:i,dimensions:t}}e.$4j=f}),define(Ae[90],Re([1,0,18,42,19,22,23,15]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mA=e.$lA=e.$kA=e.$jA=e.$iA=e.$hA=e.$gA=e.$fA=e.$eA=e.$dA=void 0;function S(o,y){const{os:m,tildify:I,relative:k}=y;if(k){const v=d(o,k,m);if(typeof v=="string")return v}let r=o.fsPath;if(m===1&&!L.$i?r=r.replace(/\//g,"\\"):m!==1&&L.$i&&(r=r.replace(/\\/g,"/")),m!==1&&I?.userHome){const v=I.userHome.fsPath;let R;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$5d.sep)?R=I.userHome.with({path:o.path}).fsPath:R=o.fsPath,r=u(R,v,m)}return(m===1?C.$4d:C.$5d).normalize(P(r,m===1))}e.$dA=S;function d(o,y,m){const I=m===1?C.$4d:C.$5d,k=m===3?A.$0f:A.$_f,r=y.getWorkspace(),h=(0,w.$Lb)(r.folders);if(!h)return;o.scheme!==h.uri.scheme&&o.path.startsWith(C.$5d.sep)&&(o=h.uri.with({path:o.path}));const v=y.getWorkspaceFolder(o);if(!v)return;let R;if(k.isEqual(v.uri,o)?R="":R=k.relativePath(v.uri,o)??"",R&&(R=I.normalize(R)),r.folders.length>1&&!y.noPrefix){const W=v.name?v.name:k.basenameOrAuthority(v.uri);R=R?`${W} \u2022 ${R}`:W}return R}function P(o,y=L.$i){return(0,F.$Lf)(o,y)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$eA=P;let D=Object.create(null);function u(o,y,m=L.OS){if(m===1||!o||!y)return o;let I=D.original===y?D.normalized:void 0;I||(I=y,L.$i&&(I=(0,F.$Bf)(I)),I=`${(0,l.$ue)(I,C.$5d.sep)}${C.$5d.sep}`,D={original:y,normalized:I});let k=o;return L.$i&&(k=(0,F.$Bf)(k)),(m===3?k.startsWith(I):(0,l.$Me)(k,I))?`~/${k.substr(I.length)}`:o}e.$fA=u;function b(o,y){return o.replace(/^~($|\/|\\)/,`${y}$1`)}e.$gA=b;const p="\u2026",f="\\\\",i="~";function t(o,y=C.sep){const m=new Array(o.length);let I=!1;for(let k=0;k<o.length;k++){const r=o[k];if(r===""){m[k]=`.${y}`;continue}if(!r){m[k]=r;continue}I=!0;let h="",v=r;v.indexOf(f)===0?(h=v.substr(0,v.indexOf(f)+f.length),v=v.substr(v.indexOf(f)+f.length)):v.indexOf(y)===0?(h=v.substr(0,v.indexOf(y)+y.length),v=v.substr(v.indexOf(y)+y.length)):v.indexOf(i)===0&&(h=v.substr(0,v.indexOf(i)+i.length),v=v.substr(v.indexOf(i)+i.length));const R=v.split(y);for(let W=1;I&&W<=R.length;W++)for(let V=R.length-W;I&&V>=0;V--){I=!1;let U=R.slice(V,V+W).join(y);for(let B=0;!I&&B<o.length;B++)if(B!==k&&o[B]&&o[B].indexOf(U)>-1){const O=V+W===R.length,N=V>0&&o[B].indexOf(y)>-1?y+U:U,ee=o[B].endsWith(N);I=!O||ee}if(!I){let B="";(R[0].endsWith(":")||h!=="")&&(V===1&&(V=0,W++,U=R[0]+y+U),V>0&&(B=R[0]+y),B=h+B),V>0&&(B=B+p+y),B=B+U,V+W<R.length&&(B=B+y+p),m[k]=B}}I&&(m[k]=r)}return m}e.$hA=t;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function g(o,y=Object.create(null)){const m=[];let I=!1,k="";for(const r of o)if(r==="$"||I&&r==="{")k&&m.push({value:k,type:c.TEXT}),k="",I=!0;else if(r==="}"&&I){const h=y[k];if(typeof h=="string")h.length&&m.push({value:h,type:c.VARIABLE});else if(h){const v=m[m.length-1];(!v||v.type!==c.SEPARATOR)&&m.push({value:h.label,type:c.SEPARATOR})}k="",I=!1}else k+=r;return k&&!I&&m.push({value:k,type:c.TEXT}),m.filter((r,h)=>{if(r.type===c.SEPARATOR){const v=m[h-1],R=m[h+1];return[v,R].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(r=>r.value).join("")}e.$iA=g;function E(o,y){return L.$j||y?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):o.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$jA=E;function $(o,y){return L.$j||y?o.replace(/\(&&\w\)|&&/g,""):L.$i?o.replace(/&&|&/g,m=>m==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$kA=$;function s(o){return o.replace(/&/g,"&&")}e.$lA=s;function a(o){if(o.endsWith("]")){const y=o.lastIndexOf(" [",o.length-2);if(y!==-1){const m=n(o.substring(0,y));return{name:m.name,parentPath:m.parentPath+o.substring(y)}}}return n(o)}e.$mA=a;function n(o){const y=o.indexOf("/")!==-1?C.$5d:C.$4d,m=y.basename(o),I=y.dirname(o);return m.length?{name:m,parentPath:I}:{name:I,parentPath:""}}}),define(Ae[133],Re([1,0,25,2]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=void 0;function C(D){return D.toJSON()}class L{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:C(F.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:C(F.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:F.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Am=L,e.$Bm=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,u,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof F.URI)return u.transformOutgoing(D);for(const p in D)if(Object.hasOwnProperty.call(D,p)){const f=A(D[p],u,b+1);f!==null&&(D[p]=f)}}return null}function l(D,u){const b=A(D,u,0);return b===null?D:b}e.$Cm=l;function S(D,u,b,p){if(!D||p>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?F.URI.revive(u.transformIncoming(D)):u.transformIncoming(D);if(D instanceof w.$Ed)return null;for(const f in D)if(Object.hasOwnProperty.call(D,f)){const i=S(D[f],u,b,p+1);i!==null&&(D[f]=i)}}return null}function d(D,u){const b=S(D,u,!1,0);return b===null?D:b}e.$Dm=d;function P(D,u){const b=S(D,u,!0,0);return b===null?D:b}e.$Em=P}),define(Ae[134],Re([1,0,37,19]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bF=void 0;function C(L,A,l,S,d,P){if(Array.isArray(L)){let D=0;for(const u of L){const b=C(u,A,l,S,d,P);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof L=="string")return S?L==="*"?5:L===l?10:0:0;if(L){const{language:D,pattern:u,scheme:b,hasAccessToAllModels:p,notebookType:f}=L;if(!S&&!p)return 0;f&&d&&(A=d);let i=0;if(b)if(b===A.scheme)i=10;else if(b==="*")i=5;else return 0;if(D)if(D===l)i=10;else if(D==="*")i=Math.max(i,5);else return 0;if(f)if(f===P)i=10;else if(f==="*"&&P!==void 0)i=Math.max(i,5);else return 0;if(u){let t;if(typeof u=="string"?t=u:t={...u,base:(0,F.$6d)(u.base)},t===A.fsPath||(0,w.$pj)(t,A.fsPath))i=10;else return 0}return i}else return 0}}e.$bF=C}),define(Ae[91],Re([1,0,25,22]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n0=e.$m0=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function L(D){for(let u=0,b=D.length;u<b;u+=4){const p=D[u+0],f=D[u+1],i=D[u+2],t=D[u+3];D[u+0]=t,D[u+1]=i,D[u+2]=f,D[u+3]=p}}function A(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return F.$C()||L(u),w.$Ed.wrap(u)}function l(D){const u=D.buffer;if(F.$C()||L(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function S(D){const u=new Uint32Array(d(D));let b=0;if(u[b++]=D.id,D.type==="full")u[b++]=1,u[b++]=D.data.length,u.set(D.data,b),b+=D.data.length;else{u[b++]=2,u[b++]=D.deltas.length;for(const p of D.deltas)u[b++]=p.start,u[b++]=p.deleteCount,p.data?(u[b++]=p.data.length,u.set(p.data,b),b+=p.data.length):u[b++]=0}return A(u)}e.$m0=S;function d(D){let u=0;if(u+=1+1,D.type==="full")u+=1+D.data.length;else{u+=1,u+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(u+=b.data.length)}return u}function P(D){const u=l(D);let b=0;const p=u[b++];if(u[b++]===1){const c=u[b++],g=u.subarray(b,b+c);return b+=c,{id:p,type:"full",data:g}}const i=u[b++],t=[];for(let c=0;c<i;c++){const g=u[b++],E=u[b++],$=u[b++];let s;$>0&&(s=u.subarray(b,b+$),b+=$),t[c]={start:g,deleteCount:E,data:s}}return{id:p,type:"delta",deltas:t}}e.$n0=P}),define(Ae[135],Re([10,11]),function(be,e){return be.create("vs/editor/common/config/editorOptions",e)}),define(Ae[136],Re([1,0,18,24,22,124,137,135]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(S||(e.EditorAutoIndentStrategy=S={})),e.MINIMAP_GUTTER_WIDTH=8;class d{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=d;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class D{constructor(Q,pe,Ue,Ne){this.id=Q,this.name=pe,this.defaultValue=Ue,this.schema=Ne}applyUpdate(Q,pe){return b(Q,pe)}compute(Q,pe,Ue){return Ue}}class u{constructor(Q,pe){this.newValue=Q,this.didChange=pe}}e.ApplyUpdateResult=u;function b(_,Q){if(typeof _!="object"||typeof Q!="object"||!_||!Q)return new u(Q,_!==Q);if(Array.isArray(_)||Array.isArray(Q)){const Ue=Array.isArray(_)&&Array.isArray(Q)&&w.$sb(_,Q);return new u(Q,!Ue)}let pe=!1;for(const Ue in Q)if(Q.hasOwnProperty(Ue)){const Ne=b(_[Ue],Q[Ue]);Ne.didChange&&(_[Ue]=Ne.newValue,pe=!0)}return new u(_,pe)}class p{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,pe){return b(Q,pe)}validate(Q){return this.defaultValue}}class f{constructor(Q,pe,Ue,Ne){this.id=Q,this.name=pe,this.defaultValue=Ue,this.schema=Ne}applyUpdate(Q,pe){return b(Q,pe)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,pe,Ue){return Ue}}function i(_,Q){return typeof _>"u"?Q:_==="false"?!1:!!_}e.boolean=i;class t extends f{constructor(Q,pe,Ue,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Ue),super(Q,pe,Ue,Ne)}validate(Q){return i(Q,this.defaultValue)}}function c(_,Q,pe,Ue){if(typeof _>"u")return Q;let Ne=parseInt(_,10);return isNaN(Ne)?Q:(Ne=Math.max(pe,Ne),Ne=Math.min(Ue,Ne),Ne|0)}e.clampedInt=c;class g extends f{static clampedInt(Q,pe,Ue,Ne){return c(Q,pe,Ue,Ne)}constructor(Q,pe,Ue,Ne,Qe,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Ue,nt.minimum=Ne,nt.maximum=Qe),super(Q,pe,Ue,nt),this.minimum=Ne,this.maximum=Qe}validate(Q){return g.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function E(_,Q,pe,Ue){if(typeof _>"u")return Q;const Ne=$.float(_,Q);return $.clamp(Ne,pe,Ue)}e.clampedFloat=E;class $ extends f{static clamp(Q,pe,Ue){return Q<pe?pe:Q>Ue?Ue:Q}static float(Q,pe){if(typeof Q=="number")return Q;if(typeof Q>"u")return pe;const Ue=parseFloat(Q);return isNaN(Ue)?pe:Ue}constructor(Q,pe,Ue,Ne,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=Ue),super(Q,pe,Ue,Qe),this.validationFn=Ne}validate(Q){return this.validationFn($.float(Q,this.defaultValue))}}class s extends f{static string(Q,pe){return typeof Q!="string"?pe:Q}constructor(Q,pe,Ue,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Ue),super(Q,pe,Ue,Ne)}validate(Q){return s.string(Q,this.defaultValue)}}function a(_,Q,pe,Ue){return typeof _!="string"?Q:Ue&&_ in Ue?Ue[_]:pe.indexOf(_)===-1?Q:_}e.stringSet=a;class n extends f{constructor(Q,pe,Ue,Ne,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=Ne,Qe.default=Ue),super(Q,pe,Ue,Qe),this.c=Ne}validate(Q){return a(Q,this.defaultValue,this.c)}}class o extends D{constructor(Q,pe,Ue,Ne,Qe,nt,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=Qe,gt.default=Ne),super(Q,pe,Ue,gt),this.c=Qe,this.d=nt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function y(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,pe,Ue){return Ue===0?Q.accessibilitySupport:Ue}}class I extends D{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertSpace:i(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function r(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(h||(e.TextEditorCursorStyle=h={}));function v(_){switch(_){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=v;function R(_){switch(_){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class W extends p{constructor(){super(140)}compute(Q,pe,Ue){const Ne=["monaco-editor"];return pe.get(39)&&Ne.push(pe.get(39)),Q.extraEditorClassName&&Ne.push(Q.extraEditorClassName),pe.get(73)==="default"?Ne.push("mouse-default"):pe.get(73)==="copy"&&Ne.push("mouse-copy"),pe.get(110)&&Ne.push("showUnused"),pe.get(138)&&Ne.push("showDeprecated"),Ne.join(" ")}}class V extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Q,pe,Ue){return Ue&&Q.emptySelectionClipboard}}class U extends D{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:l.localize(16,null),included:C.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:l.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{cursorMoveOnType:i(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":a(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":a(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(pe.loop,this.defaultValue.loop)}}}class B extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?B.OFF:Q==="true"?B.ON:Q:Q?B.ON:B.OFF}}e.EditorFontLigatures=B;class O extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?O.OFF:Q==="true"?O.TRANSLATE:Q:Q?O.TRANSLATE:O.OFF}compute(Q,pe,Ue){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends p{constructor(){super(50)}compute(Q,pe,Ue){return Q.fontInfo}}class ee extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Q){const pe=$.float(Q,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:$.clamp(pe,6,100)}compute(Q,pe,Ue){return Q.fontInfo.fontSize}}class Y extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(g.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class Ee extends D{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ue,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ue,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ue,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ue,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ue,description:l.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{multiple:a(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??a(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??a(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??a(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??a(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??a(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:s.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:s.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:s.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:s.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:s.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ke extends D{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:l.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:i(pe.enabled,this.defaultValue.enabled),delay:g.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:i(pe.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(pe.above,this.defaultValue.above)}}}var Pe;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class Z extends p{constructor(){super(143)}compute(Q,pe,Ue){return Z.computeLayout(pe,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const pe=Q.height/Q.lineHeight,Ue=Math.floor(Q.paddingTop/Q.lineHeight);let Ne=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(Ne=Math.max(Ne,pe-1));const Qe=(Ue+Q.viewLineCount+Ne)/(Q.pixelRatio*Q.height),nt=Math.floor(Q.viewLineCount/Qe);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Ue,extraLinesBeyondLastLine:Ne,desiredRatio:Qe,minimapLineCount:nt}}static c(Q,pe){const Ue=Q.outerWidth,Ne=Q.outerHeight,Qe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const nt=pe.stableMinimapLayoutInput,gt=nt&&Q.outerHeight===nt.outerHeight&&Q.lineHeight===nt.lineHeight&&Q.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===nt.pixelRatio&&Q.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Q.paddingTop===nt.paddingTop&&Q.paddingBottom===nt.paddingBottom&&Q.minimap.enabled===nt.minimap.enabled&&Q.minimap.side===nt.minimap.side&&Q.minimap.size===nt.minimap.size&&Q.minimap.showSlider===nt.minimap.showSlider&&Q.minimap.renderCharacters===nt.minimap.renderCharacters&&Q.minimap.maxColumn===nt.minimap.maxColumn&&Q.minimap.scale===nt.minimap.scale&&Q.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Q.isViewportWrapping===nt.isViewportWrapping,vt=Q.lineHeight,Mt=Q.typicalHalfwidthCharacterWidth,Qt=Q.scrollBeyondLastLine,Vt=Q.minimap.renderCharacters;let wt=Qe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Tt=Q.minimap.maxColumn,Ot=Q.minimap.size,Jt=Q.minimap.side,Pt=Q.verticalScrollbarWidth,At=Q.viewLineCount,Nt=Q.remainingWidth,Ut=Q.isViewportWrapping,qt=Vt?2:3;let Bt=Math.floor(Qe*Ne);const at=Bt/Qe;let ut=!1,Ht=!1,Ct=qt*wt,kt=wt/Qe,ht=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Fe,extraLinesBeforeFirstLine:ge,extraLinesBeyondLastLine:H,desiredRatio:Me,minimapLineCount:Be}=Z.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Qt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:Ne,lineHeight:vt,pixelRatio:Qe});if(At/Be>1)ut=!0,Ht=!0,wt=1,Ct=1,kt=wt/Qe;else{let We=!1,xe=wt+1;if(Ot==="fit"){const pt=Math.ceil((ge+At+H)*Ct);Ut&&gt&&Nt<=pe.stableFitRemainingWidth?(We=!0,xe=pe.stableFitMaxMinimapScale):We=pt>Bt}if(Ot==="fill"||We){ut=!0;const pt=wt;Ct=Math.min(vt*Qe,Math.max(1,Math.floor(1/Me))),Ut&&gt&&Nt<=pe.stableFitRemainingWidth&&(xe=pe.stableFitMaxMinimapScale),wt=Math.min(xe,Math.max(1,Math.floor(Ct/qt))),wt>pt&&(ht=Math.min(2,wt/pt)),kt=wt/Qe/ht,Bt=Math.ceil(Math.max(Fe,ge+At+H)*Ct),Ut?(pe.stableMinimapLayoutInput=Q,pe.stableFitRemainingWidth=Nt,pe.stableFitMaxMinimapScale=wt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const St=Math.floor(Tt*kt),Lt=Math.min(St,Math.max(0,Math.floor((Nt-Pt-2)*kt/(Mt+kt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(Qe*Lt);const qe=Et/Qe;Et=Math.floor(Et*ht);const zt=Vt?1:2,Ce=Jt==="left"?0:Ue-Lt-Pt;return{renderMinimap:zt,minimapLeft:Ce,minimapWidth:Lt,minimapHeightIsEditorHeight:ut,minimapIsSampling:Ht,minimapScale:wt,minimapLineHeight:Ct,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:at}}static computeLayout(Q,pe){const Ue=pe.outerWidth|0,Ne=pe.outerHeight|0,Qe=pe.lineHeight|0,nt=pe.lineNumbersDigitCount|0,gt=pe.typicalHalfwidthCharacterWidth,vt=pe.maxDigitWidth,Mt=pe.pixelRatio,Qt=pe.viewLineCount,Vt=Q.get(135),wt=Vt==="inherit"?Q.get(134):Vt,Tt=wt==="inherit"?Q.get(130):wt,Ot=Q.get(133),Jt=pe.isDominatedByLongLines,Pt=Q.get(57),At=Q.get(67).renderType!==0,Nt=Q.get(68),Ut=Q.get(104),qt=Q.get(83),Bt=Q.get(72),at=Q.get(102),ut=at.verticalScrollbarSize,Ht=at.verticalHasArrows,Ct=at.arrowSize,kt=at.horizontalScrollbarSize,ht=Q.get(43),St=Q.get(109)!=="never";let Lt=Q.get(65);ht&&St&&(Lt+=16);let Et=0;if(At){const dt=Math.max(nt,Nt);Et=Math.round(dt*vt)}let qe=0;Pt&&(qe=Qe*pe.glyphMarginDecorationLaneCount);let zt=0,Ce=zt+qe,Fe=Ce+Et,ge=Fe+Lt;const H=Ue-qe-Et-Lt;let Me=!1,Be=!1,Ge=-1;wt==="inherit"&&Jt?(Me=!0,Be=!0):Tt==="on"||Tt==="bounded"?Be=!0:Tt==="wordWrapColumn"&&(Ge=Ot);const We=Z.c({outerWidth:Ue,outerHeight:Ne,lineHeight:Qe,typicalHalfwidthCharacterWidth:gt,pixelRatio:Mt,scrollBeyondLastLine:Ut,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Bt,verticalScrollbarWidth:ut,viewLineCount:Qt,remainingWidth:H,isViewportWrapping:Be},pe.memory||new P);We.renderMinimap!==0&&We.minimapLeft===0&&(zt+=We.minimapWidth,Ce+=We.minimapWidth,Fe+=We.minimapWidth,ge+=We.minimapWidth);const xe=H-We.minimapWidth,pt=Math.max(1,Math.floor((xe-ut-2)/gt)),bt=Ht?Ct:0;return Be&&(Ge=Math.max(1,pt),Tt==="bounded"&&(Ge=Math.min(Ge,Ot))),{width:Ue,height:Ne,glyphMarginLeft:zt,glyphMarginWidth:qe,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ce,lineNumbersWidth:Et,decorationsLeft:Fe,decorationsWidth:Lt,contentLeft:ge,contentWidth:xe,minimap:We,viewportColumn:pt,isWordWrapMinified:Me,isViewportWrapping:Be,wrappingColumn:Ge,verticalScrollbarWidth:ut,horizontalScrollbarHeight:kt,overviewRuler:{top:bt,width:ut,height:Ne-2*bt,right:0}}}}e.EditorLayoutInfoComputer=Z;class ue extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Q){return a(Q,"simple",["simple","advanced"])}compute(Q,pe,Ue){return pe.get(2)===2?"advanced":Ue}}class ye extends D{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:l.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:i(Q.enabled,this.defaultValue.enabled)}}}class ce extends D{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:l.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:i(pe.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends D{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:l.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:a(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:s.string(pe.fontFamily,this.defaultValue.fontFamily),padding:i(pe.padding,this.defaultValue.padding)}}}class ie extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):g.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,pe,Ue){return Ue<0?g.clampedInt(-Ue*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class z extends ${constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>$.clamp(Q,0,150),{markdownDescription:l.localize(63,null)})}compute(Q,pe,Ue){return Q.fontInfo.lineHeight}}class q extends D{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:Q.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:l.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:i(pe.enabled,this.defaultValue.enabled),autohide:i(pe.autohide,this.defaultValue.autohide),size:a(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(pe.side,this.defaultValue.side,["right","left"]),showSlider:a(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(pe.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(pe.scale,1,1,3),maxColumn:g.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(_){return _==="ctrlCmd"?C.$j?"metaKey":"ctrlKey":"altKey"}class we extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{top:g.clampedInt(pe.top,0,0,1e3),bottom:g.clampedInt(pe.bottom,0,0,1e3)}}}class ve extends D{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:l.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:i(pe.enabled,this.defaultValue.enabled),cycle:i(pe.cycle,this.defaultValue.cycle)}}}class me extends p{constructor(){super(141)}compute(Q,pe,Ue){return Q.pixelRatio}}class De extends D{constructor(){const Q={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Q.strings,description:l.localize(82,null)},comments:{anyOf:pe,default:Q.comments,description:l.localize(83,null)},other:{anyOf:pe,default:Q.other,description:l.localize(84,null)}},default:Q,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Mt=Q?"on":"off";return{comments:Mt,strings:Mt,other:Mt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:pe,comments:Ue,strings:Ne}=Q,Qe=["on","inline","off"];let nt,gt,vt;return typeof pe=="boolean"?nt=pe?"on":"off":nt=a(pe,this.defaultValue.other,Qe),typeof Ue=="boolean"?gt=Ue?"on":"off":gt=a(Ue,this.defaultValue.comments,Qe),typeof Ne=="boolean"?vt=Ne?"on":"off":vt=a(Ne,this.defaultValue.strings,Qe),{other:nt,comments:gt,strings:vt}}}var ne;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class he extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(Q){let pe=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(pe=4,Ue=Q):Q==="interval"?pe=3:Q==="relative"?pe=2:Q==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ue}}}function se(_){const Q=_.get(97);return Q==="editable"?_.get(90):Q!=="on"}e.filterValidationDecorations=se;class oe extends D{constructor(){const Q=[],pe={type:"number",description:l.localize(91,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:Q,description:l.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const pe=[];for(const Ue of Q)if(typeof Ue=="number")pe.push({column:g.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Ne=Ue;pe.push({column:g.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return pe.sort((Ue,Ne)=>Ue.column-Ne.column),pe}return this.defaultValue}}class fe extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ie(_,Q){if(typeof _!="string")return Q;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class M extends D{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:l.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q,Ue=g.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=g.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(pe.vertical,this.defaultValue.vertical),horizontal:Ie(pe.horizontal,this.defaultValue.horizontal),useShadows:i(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:g.clampedInt(pe.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:g.clampedInt(pe.verticalSliderSize,Ne,0,1e3),scrollByPage:i(pe.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends D{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:l.localize(111,null)}})}applyUpdate(Q,pe){let Ue=!1;pe.allowedCharacters&&Q&&(F.$Ym(Q.allowedCharacters,pe.allowedCharacters)||(Q={...Q,allowedCharacters:pe.allowedCharacters},Ue=!0)),pe.allowedLocales&&Q&&(F.$Ym(Q.allowedLocales,pe.allowedLocales)||(Q={...Q,allowedLocales:pe.allowedLocales},Ue=!0));const Ne=super.applyUpdate(Q,pe);return Ue?new u(Ne.newValue,!0):Ne}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{nonBasicASCII:x(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,pe){if(typeof Q!="object"||!Q)return pe;const Ue={};for(const[Ne,Qe]of Object.entries(Q))Qe===!0&&(Ue[Ne]=!0);return Ue}}class G extends D{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:l.localize(116,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:i(pe.enabled,this.defaultValue.enabled),mode:a(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:i(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class X extends D{constructor(){const Q={enabled:L.$Tr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Tr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:i(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends D{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:Q.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:Q.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:Q.highlightActiveIndentation,description:l.localize(132,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{bracketPairs:x(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(_,Q,pe){const Ue=pe.indexOf(_);return Ue===-1?Q:pe[Ue]}class ae extends D{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:Q.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Q.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{insertMode:a(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(pe.showIcons,this.defaultValue.showIcons),showStatusBar:i(pe.showStatusBar,this.defaultValue.showStatusBar),preview:i(pe.preview,this.defaultValue.preview),previewMode:a(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(pe.showMethods,this.defaultValue.showMethods),showFunctions:i(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:i(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(pe.showFields,this.defaultValue.showFields),showVariables:i(pe.showVariables,this.defaultValue.showVariables),showClasses:i(pe.showClasses,this.defaultValue.showClasses),showStructs:i(pe.showStructs,this.defaultValue.showStructs),showInterfaces:i(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:i(pe.showModules,this.defaultValue.showModules),showProperties:i(pe.showProperties,this.defaultValue.showProperties),showEvents:i(pe.showEvents,this.defaultValue.showEvents),showOperators:i(pe.showOperators,this.defaultValue.showOperators),showUnits:i(pe.showUnits,this.defaultValue.showUnits),showValues:i(pe.showValues,this.defaultValue.showValues),showConstants:i(pe.showConstants,this.defaultValue.showConstants),showEnums:i(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:i(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(pe.showKeywords,this.defaultValue.showKeywords),showWords:i(pe.showWords,this.defaultValue.showWords),showColors:i(pe.showColors,this.defaultValue.showColors),showFiles:i(pe.showFiles,this.defaultValue.showFiles),showReferences:i(pe.showReferences,this.defaultValue.showReferences),showFolders:i(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:i(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(pe.showSnippets,this.defaultValue.showSnippets),showUsers:i(pe.showUsers,this.defaultValue.showUsers),showIssues:i(pe.showIssues,this.defaultValue.showIssues)}}}class Le extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Xe extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,pe,Ue){return pe.get(2)===2?0:Ue}}class He extends p{constructor(){super(144)}compute(Q,pe,Ue){const Ne=pe.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class et extends D{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:i(pe.enabled,this.defaultValue.enabled),showDropSelector:a(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ze extends D{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const pe=Q;return{enabled:i(pe.enabled,this.defaultValue.enabled),showPasteSelector:a(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$j?it:C.$k?tt:_e,fontWeight:"normal",fontSize:C.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(_){return e.editorOptionsRegistry[_.id]=_,_}var st;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.occurrencesHighlight=80]="occurrencesHighlight",_[_.overviewRulerBorder=81]="overviewRulerBorder",_[_.overviewRulerLanes=82]="overviewRulerLanes",_[_.padding=83]="padding",_[_.pasteAs=84]="pasteAs",_[_.parameterHints=85]="parameterHints",_[_.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",_[_.quickSuggestions=88]="quickSuggestions",_[_.quickSuggestionsDelay=89]="quickSuggestionsDelay",_[_.readOnly=90]="readOnly",_[_.readOnlyMessage=91]="readOnlyMessage",_[_.renameOnType=92]="renameOnType",_[_.renderControlCharacters=93]="renderControlCharacters",_[_.renderFinalNewline=94]="renderFinalNewline",_[_.renderLineHighlight=95]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=97]="renderValidationDecorations",_[_.renderWhitespace=98]="renderWhitespace",_[_.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",_[_.roundedSelection=100]="roundedSelection",_[_.rulers=101]="rulers",_[_.scrollbar=102]="scrollbar",_[_.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=104]="scrollBeyondLastLine",_[_.scrollPredominantAxis=105]="scrollPredominantAxis",_[_.selectionClipboard=106]="selectionClipboard",_[_.selectionHighlight=107]="selectionHighlight",_[_.selectOnLineNumbers=108]="selectOnLineNumbers",_[_.showFoldingControls=109]="showFoldingControls",_[_.showUnused=110]="showUnused",_[_.snippetSuggestions=111]="snippetSuggestions",_[_.smartSelect=112]="smartSelect",_[_.smoothScrolling=113]="smoothScrolling",_[_.stickyScroll=114]="stickyScroll",_[_.stickyTabStops=115]="stickyTabStops",_[_.stopRenderingLineAfter=116]="stopRenderingLineAfter",_[_.suggest=117]="suggest",_[_.suggestFontSize=118]="suggestFontSize",_[_.suggestLineHeight=119]="suggestLineHeight",_[_.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",_[_.suggestSelection=121]="suggestSelection",_[_.tabCompletion=122]="tabCompletion",_[_.tabIndex=123]="tabIndex",_[_.unicodeHighlighting=124]="unicodeHighlighting",_[_.unusualLineTerminators=125]="unusualLineTerminators",_[_.useShadowDOM=126]="useShadowDOM",_[_.useTabStops=127]="useTabStops",_[_.wordBreak=128]="wordBreak",_[_.wordSeparators=129]="wordSeparators",_[_.wordWrap=130]="wordWrap",_[_.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=133]="wordWrapColumn",_[_.wordWrapOverride1=134]="wordWrapOverride1",_[_.wordWrapOverride2=135]="wordWrapOverride2",_[_.wrappingIndent=136]="wrappingIndent",_[_.wrappingStrategy=137]="wrappingStrategy",_[_.showDeprecated=138]="showDeprecated",_[_.inlayHints=139]="inlayHints",_[_.editorClassName=140]="editorClassName",_[_.pixelRatio=141]="pixelRatio",_[_.tabFocusMode=142]="tabFocusMode",_[_.layoutInfo=143]="layoutInfo",_[_.wrappingInfo=144]="wrappingInfo",_[_.defaultColorDecorators=145]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:ze(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:ze(new m),accessibilityPageSize:ze(new g(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new s(4,"ariaLabel",l.localize(200,null))),ariaRequired:ze(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:ze(new n(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:ze(new n(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:ze(new n(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:ze(new n(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:ze(new t(13,"automaticLayout",!1)),autoSurround:ze(new n(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:ze(new X),bracketPairGuides:ze(new J),stickyTabStops:ze(new t(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:ze(new t(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:ze(new s(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:ze(new g(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:ze(new t(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:ze(new n(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:ze(new g(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:ze(new t(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:ze(new I),contextmenu:ze(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new t(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:ze(new n(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],R,{description:l.localize(242,null)})),cursorSurroundingLines:ze(new g(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:ze(new n(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:ze(new g(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:ze(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new t(34,"domReadOnly",!1)),dragAndDrop:ze(new t(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:ze(new V),dropIntoEditor:ze(new et),stickyScroll:ze(new ce),experimentalWhitespaceRendering:ze(new n(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:ze(new s(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new $(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:l.localize(253,null)})),find:ze(new U),fixedOverflowWidgets:ze(new t(42,"fixedOverflowWidgets",!1)),folding:ze(new t(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:ze(new n(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:ze(new t(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:ze(new t(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:ze(new g(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:ze(new s(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new B),fontSize:ze(new ee),fontWeight:ze(new Y),fontVariations:ze(new O),formatOnPaste:ze(new t(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:ze(new t(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:ze(new t(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:ze(new Ee),hideCursorInOverviewRuler:ze(new t(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:ze(new ke),inDiffEditor:ze(new t(61,"inDiffEditor",!1)),letterSpacing:ze(new $(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>$.clamp(_,-5,20),{description:l.localize(267,null)})),lightbulb:ze(new ye),lineDecorationsWidth:ze(new ie),lineHeight:ze(new z),lineNumbers:ze(new he),lineNumbersMinChars:ze(new g(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new t(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:ze(new t(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:ze(new n(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:ze(new q),mouseStyle:ze(new n(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new $(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:ze(new t(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:ze(new t(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:ze(new n(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:ze(new g(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:ze(new t(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:ze(new t(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:ze(new g(82,"overviewRulerLanes",3,0,3)),padding:ze(new we),pasteAs:ze(new Ze),parameterHints:ze(new ve),peekWidgetDefaultFocus:ze(new n(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:ze(new t(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:ze(new De),quickSuggestionsDelay:ze(new g(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:ze(new t(90,"readOnly",!1)),readOnlyMessage:ze(new fe),renameOnType:ze(new t(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:ze(new t(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:ze(new n(94,"renderFinalNewline",C.$k?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:ze(new n(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:ze(new n(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new n(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:ze(new g(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new t(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new M),scrollBeyondLastColumn:ze(new g(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:ze(new t(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:ze(new t(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:ze(new t(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$k})),selectionHighlight:ze(new t(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:ze(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new n(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:ze(new t(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:ze(new t(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:ze(new $e),snippetSuggestions:ze(new n(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:ze(new Le),smoothScrolling:ze(new t(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:ze(new g(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ae),inlineSuggest:ze(new G),inlineCompletionsAccessibilityVerbose:ze(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:ze(new g(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new g(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new t(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:ze(new n(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:ze(new n(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:ze(new g(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new K),unusualLineTerminators:ze(new n(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:ze(new t(126,"useShadowDOM",!0)),useTabStops:ze(new t(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:ze(new n(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:ze(new s(129,"wordSeparators",A.$Ur,{description:l.localize(337,null)})),wordWrap:ze(new n(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new s(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new s(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new g(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:ze(new n(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new n(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new t(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:ze(new me),tabFocusMode:ze(new t(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:ze(new Z),wrappingInfo:ze(new He),wrappingIndent:ze(new Xe),wrappingStrategy:ze(new ue)}}),define(Ae[138],Re([10,11]),function(be,e){return be.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[139],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[140],Re([10,11]),function(be,e){return be.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[141],Re([10,11]),function(be,e){return be.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[142],Re([10,11]),function(be,e){return be.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[143],Re([10,11]),function(be,e){return be.create("vs/platform/files/common/files",e)}),define(Ae[144],Re([10,11]),function(be,e){return be.create("vs/platform/markers/common/markers",e)}),define(Ae[145],Re([10,11]),function(be,e){return be.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[146],Re([10,11]),function(be,e){return be.create("vs/platform/workspace/common/workspace",e)}),define(Ae[147],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[148],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[149],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[150],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[151],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[152],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[153],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[154],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[155],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[156],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[157],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[158],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[159],Re([10,11]),function(be,e){return be.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[160],Re([10,11]),function(be,e){return be.create("vs/workbench/common/editor",e)}),define(Ae[161],Re([10,11]),function(be,e){return be.create("vs/workbench/common/views",e)}),define(Ae[162],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[163],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[164],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[165],Re([10,11]),function(be,e){return be.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[166],Re([10,11]),function(be,e){return be.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[167],Re([10,11]),function(be,e){return be.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[168],Re([10,11]),function(be,e){return be.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[169],Re([1,0,9,140]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.TokenType=void 0;var C;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(C||(e.TokenType=C={}));function L(...d){switch(d.length){case 1:return(0,F.localize)(0,null,d[0]);case 2:return(0,F.localize)(1,null,d[0],d[1]);case 3:return(0,F.localize)(2,null,d[0],d[1],d[2]);default:return}}const A=(0,F.localize)(3,null),l=(0,F.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,w.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const D=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:D,lexeme:u,additionalInfo:P}),this.f.push(b)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const D=this.c.substring(this.d,this.e),u=S.b.get(D);u?this.k(u):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,D=!1,u=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(l);return}const p=this.c.charCodeAt(P);if(D)D=!1;else if(p===47&&!u){P++;break}else p===91?u=!0:p===92?D=!0:p===93&&(u=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ei=S}),define(Ae[170],Re([1,0,23,29,142,276]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function S(t){return t=t.trim(),t==="*"||A.test(t)}e.$Ao=S;function d(t){if(!S(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=t.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$Bo=d;function P(t){if(!t)return null;const c=t.majorBase,g=t.majorMustEqual,E=t.minorBase;let $=t.minorMustEqual;const s=t.patchBase;let a=t.patchMustEqual;t.hasCaret&&(c===0||($=!1),a=!1);let n=0;if(t.preRelease){const o=l.exec(t.preRelease);if(o){const[,y,m,I]=o;n=Date.UTC(Number(y),Number(m)-1,Number(I))}}return{majorBase:c,majorMustEqual:g,minorBase:E,minorMustEqual:$,patchBase:s,patchMustEqual:a,isMinimum:t.hasGreaterEquals,notBefore:n}}e.$Co=P;function D(t,c,g){let E;typeof t=="string"?E=P(d(t)):E=t;let $;c instanceof Date?$=c.getTime():typeof c=="string"&&($=new Date(c).getTime());let s;if(typeof g=="string"?s=P(d(g)):s=g,!E||!s)return!1;const a=E.majorBase,n=E.minorBase,o=E.patchBase;let y=s.majorBase,m=s.minorBase,I=s.patchBase;const k=s.notBefore;let r=s.majorMustEqual,h=s.minorMustEqual,v=s.patchMustEqual;return s.isMinimum?a>y?!0:a<y?!1:n>m?!0:n<m||$&&$<k?!1:o>=I:(a===1&&y===0&&(!r||!h||!v)&&(y=1,m=0,I=0,r=!0,h=!1,v=!1),a<y?!1:a>y?!r:n<m?!1:n>m?!h:o<I?!1:o>I?!v:!($&&$<k))}e.$Do=D;function u(t,c,g,E,$){const s=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return s.push([F.default.Error,C.localize(0,null)]),s;if(typeof E.name!="string")return s.push([F.default.Error,C.localize(1,null,"name")]),s;if(typeof E.version!="string")return s.push([F.default.Error,C.localize(2,null,"version")]),s;if(!E.engines)return s.push([F.default.Error,C.localize(3,null,"engines")]),s;if(typeof E.engines.vscode!="string")return s.push([F.default.Error,C.localize(4,null,"engines.vscode")]),s;if(typeof E.extensionDependencies<"u"&&!i(E.extensionDependencies))return s.push([F.default.Error,C.localize(5,null,"extensionDependencies")]),s;if(typeof E.activationEvents<"u"){if(!i(E.activationEvents))return s.push([F.default.Error,C.localize(6,null,"activationEvents")]),s;if(typeof E.main>"u"&&typeof E.browser>"u")return s.push([F.default.Error,C.localize(7,null,"activationEvents","main","browser")]),s}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&s.push([F.default.Warning,C.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return s.push([F.default.Error,C.localize(9,null,"main")]),s;{const o=(0,w.$hg)(g,E.main);(0,w.$bg)(o,g)||s.push([F.default.Warning,C.localize(10,null,o.path,g.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return s.push([F.default.Error,C.localize(11,null,"browser")]),s;{const o=(0,w.$hg)(g,E.browser);(0,w.$bg)(o,g)||s.push([F.default.Warning,C.localize(12,null,o.path,g.path)])}}if(!L.valid(E.version))return s.push([F.default.Error,C.localize(13,null)]),s;const a=[];if(!b(t,c,E,$,a))for(const o of a)s.push([F.default.Error,o]);return s}e.$Eo=u;function b(t,c,g,E,$){return E||typeof g.main>"u"&&typeof g.browser>"u"?!0:f(t,c,g.engines.vscode,$)}e.$Fo=b;function p(t,c,g){return t==="*"||f(c,g,t)}e.$Go=p;function f(t,c,g,E=[]){const $=P(d(g));if(!$)return E.push(C.localize(14,null,g)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return E.push(C.localize(15,null,g)),!1}else if(!$.majorMustEqual)return E.push(C.localize(16,null,g)),!1;return D(t,c,$)?!0:(E.push(C.localize(17,null,t,g)),!1)}function i(t){if(!Array.isArray(t))return!1;for(let c=0,g=t.length;c<g;c++)if(typeof t[c]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=void 0;class w{constructor(C,L=[],A=!1){this.ctor=C,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$xh=w}),define(Ae[70],Re([1,0,69]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.InstantiationType=void 0;const F=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function L(l,S,d){S instanceof w.$xh||(S=new w.$xh(S,[],!!d)),F.push([l,S])}e.$lr=L;function A(){return F}e.$mr=A}),define(Ae[171],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=void 0;class w{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$3p=w;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const l=this.lookupOrInsertNode(L),S=this.lookupOrInsertNode(A);l.outgoing.set(S.key,S),S.incoming.set(l.key,l)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let l=this.a.get(A);return l||(l=new w(A,L),this.a.set(A,l)),l}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,l]of this.a)L.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const l=new Set([L]),S=this.c(A,l);if(S)return S}}c(L,A){for(const[l,S]of L.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const d=this.c(S,A);if(d)return d;A.delete(l)}}}e.$4p=F}),define(Ae[4],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=e._util=void 0;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(S){return S[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(w||(e._util=w={})),e.$zh=C("instantiationService");function F(A,l,S){l[w.DI_TARGET]===l?l[w.DI_DEPENDENCIES].push({id:A,index:S}):(l[w.DI_DEPENDENCIES]=[{id:A,index:S}],l[w.DI_TARGET]=l)}function C(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const l=function(S,d,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(l,S,P)};return l.toString=()=>A,w.serviceIds.set(A,l),l}e.$Ah=C;function L(A){return A}e.$Bh=L}),define(Ae[43],Re([1,0,16,2,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.ConfigurationTarget=e.$9h=e.$8h=e.$7h=void 0,e.$7h=(0,C.$Ah)("configurationService");function L(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof F.URI)}e.$8h=L;function A(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof F.URI)}e.$9h=A;var l;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function S(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$0h=S;function d(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$$h=d;function P(t,c){const g=Object.create(null);for(const E in t)D(g,E,t[E],c);return g}e.$_h=P;function D(t,c,g,E){const $=c.split("."),s=$.pop();let a=t;for(let n=0;n<$.length;n++){const o=$[n];let y=a[o];switch(typeof y){case"undefined":y=a[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${c} as ${$.slice(0,n+1).join(".")} is ${JSON.stringify(y)}`);return}a=y}if(typeof a=="object"&&a!==null)try{a[s]=g}catch{E(`Ignoring ${c} as ${$.join(".")} is ${JSON.stringify(a)}`)}else E(`Ignoring ${c} as ${$.join(".")} is ${JSON.stringify(a)}`)}e.$ai=D;function u(t,c){const g=c.split(".");b(t,g)}e.$bi=u;function b(t,c){const g=c.shift();if(c.length===0){delete t[g];return}if(Object.keys(t).indexOf(g)!==-1){const E=t[g];typeof E=="object"&&!Array.isArray(E)&&(b(E,c),Object.keys(E).length===0&&delete t[g])}}function p(t,c,g){function E(a,n){let o=a;for(const y of n){if(typeof o!="object"||o===null)return;o=o[y]}return o}const $=c.split("."),s=E(t,$);return typeof s>"u"?g:s}e.$ci=p;function f(t,c,g){Object.keys(c).forEach(E=>{E!=="__proto__"&&(E in t?w.$kf(t[E])&&w.$kf(c[E])?f(t[E],c[E],g):g&&(t[E]=c[E]):t[E]=c[E])})}e.$di=f;function i(t){return t.replace(/[\[\]]/g,"")}e.$ei=i}),define(Ae[32],Re([1,0,22,15,169,4,139,9]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.ContextKeyExprType=e.$Fi=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",w.$j),S.set("isLinux",w.$k),S.set("isWindows",w.$i),S.set("isWeb",w.$o),S.set("isMacNative",w.$j&&!w.$o),S.set("isEdge",w.$G),S.set("isFirefox",w.$E),S.set("isChrome",w.$D),S.set("isSafari",w.$F);function d(ie,z){if(S.get(ie)!==void 0)throw(0,l.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(ie,z)}e.$Fi=d;const P=Object.prototype.hasOwnProperty;var D;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const u={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),p=(0,A.localize)(1,null),f=(0,A.localize)(2,null),i=(0,A.localize)(3,null),t=(0,A.localize)(4,null),c=(0,A.localize)(5,null),g=(0,A.localize)(6,null),E=(0,A.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=u){this.k=z,this.d=new C.$Ei,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const q=this.l();if(!this.E()){const le=this.D(),we=le.type===17?c:void 0;throw this.h.push({message:t,offset:le.offset,lexeme:C.$Ei.getLexeme(le),additionalInfo:we}),$.c}return q}catch(q){if(q!==$.c)throw q;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const q=this.o();z.push(q)}return z.length===1?z[0]:s.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const q=this.s();z.push(q)}return z.length===1?z[0]:s.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),y.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const q=this.l();return this.A(1,i),q?.negate()}case 17:return this.z(),R.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const q=this.l();return this.A(1,i),q}case 17:{const q=z.lexeme;if(this.z(),this.y(9)){const we=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),we.type!==10)throw this.B("REGEX",we);const ve=we.lexeme,me=ve.lastIndexOf("/"),De=me===ve.length-1?void 0:this.w(ve.substring(me+1));let ne;try{ne=new RegExp(ve.substring(1,me),De)}catch{throw this.B("REGEX",we)}return N.create(q,ne)}switch(we.type){case 10:case 19:{const ve=[we.lexeme];this.z();let me=this.D(),De=0;for(let fe=0;fe<we.lexeme.length;fe++)we.lexeme.charCodeAt(fe)===40?De++:we.lexeme.charCodeAt(fe)===41&&De--;for(;!this.E()&&me.type!==15&&me.type!==16;){switch(me.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let fe=0;fe<me.lexeme.length;fe++)me.lexeme.charCodeAt(fe)===40?De++:we.lexeme.charCodeAt(fe)===41&&De--}if(De<0)break;ve.push(C.$Ei.getLexeme(me)),this.z(),me=this.D()}const ne=ve.join(""),he=ne.lastIndexOf("/"),se=he===ne.length-1?void 0:this.w(ne.substring(he+1));let oe;try{oe=new RegExp(ne.substring(1,he),se)}catch{throw this.B("REGEX",we)}return s.regex(q,oe)}case 18:{const ve=we.lexeme;this.z();let me=null;if(!(0,F.$le)(ve)){const De=ve.indexOf("/"),ne=ve.lastIndexOf("/");if(De!==ne&&De>=0){const he=ve.slice(De+1,ne),se=ve[ne+1]==="i"?"i":"";try{me=new RegExp(he,se)}catch{throw this.B("REGEX",we)}}}if(me===null)throw this.B("REGEX",we);return N.create(q,me)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const we=this.u();return s.notIn(q,we)}switch(this.D().type){case 3:{this.z();const we=this.u();if(this.x().type===18)return s.equals(q,we);switch(we){case"true":return s.has(q);case"false":return s.not(q);default:return s.equals(q,we)}}case 4:{this.z();const we=this.u();if(this.x().type===18)return s.notEquals(q,we);switch(we){case"true":return s.not(q);case"false":return s.has(q);default:return s.notEquals(q,we)}}case 5:return this.z(),B.create(q,this.u());case 6:return this.z(),O.create(q,this.u());case 7:return this.z(),V.create(q,this.u());case 8:return this.z(),U.create(q,this.u());case 13:return this.z(),s.in(q,this.u());default:return s.has(q)}}case 20:throw this.h.push({message:g,offset:z.offset,lexeme:"",additionalInfo:E}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,q){if(this.C(z))return this.z();throw this.B(q,this.D())}B(z,q,le){const we=(0,A.localize)(8,null,z,C.$Ei.getLexeme(q)),ve=q.offset,me=C.$Ei.getLexeme(q);return this.h.push({message:we,offset:ve,lexeme:me,additionalInfo:le}),$.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Gi=$;class s{static false(){return y.INSTANCE}static true(){return m.INSTANCE}static has(z){return I.create(z)}static equals(z,q){return k.create(z,q)}static notEquals(z,q){return v.create(z,q)}static regex(z,q){return N.create(z,q)}static in(z,q){return r.create(z,q)}static notIn(z,q){return h.create(z,q)}static not(z){return R.create(z)}static and(...z){return Ee.create(z,null,!0)}static or(...z){return ke.create(z,null,!0)}static greater(z,q){return V.create(z,q)}static greaterEquals(z,q){return U.create(z,q)}static smaller(z,q){return B.create(z,q)}static smallerEquals(z,q){return O.create(z,q)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Hi=s;function a(ie){const z=new $({regexParsingWithErrorRecovery:!1});return ie.map(q=>(z.parse(q),z.lexingErrors.length>0?z.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,A.localize)(9,null,le.additionalInfo):(0,A.localize)(10,null),offset:le.offset,length:le.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}e.$Ii=a;function n(ie,z){const q=ie?ie.substituteConstants():void 0,le=z?z.substituteConstants():void 0;return!q&&!le?!0:!q||!le?!1:q.equals(le)}e.$Ji=n;function o(ie,z){return ie.cmp(z)}class y{static{this.INSTANCE=new y}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return m.INSTANCE}}e.$Ki=y;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return y.INSTANCE}}e.$Li=m;class I{static create(z,q=null){const le=S.get(z);return typeof le=="boolean"?le?m.INSTANCE:y.INSTANCE:new I(z,q)}constructor(z,q){this.key=z,this.c=q,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:Z(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=S.get(this.key);return typeof z=="boolean"?z?m.INSTANCE:y.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$Mi=I;class k{static create(z,q,le=null){if(typeof q=="boolean")return q?I.create(z,le):R.create(z,le);const we=S.get(z);return typeof we=="boolean"?q===(we?"true":"false")?m.INSTANCE:y.INSTANCE:new k(z,q,le)}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=S.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?m.INSTANCE:y.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ni=k;class r{static create(z,q){return new r(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.f),le=z.getValue(this.d);return Array.isArray(q)?q.includes(le):typeof le=="string"&&typeof q=="object"&&q!==null?P.call(q,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=h.create(this.d,this.f)),this.c}}e.$Oi=r;class h{static create(z,q){return new h(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=11,this.c=r.create(z,q)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Pi=h;class v{static create(z,q,le=null){if(typeof q=="boolean")return q?R.create(z,le):I.create(z,le);const we=S.get(z);return typeof we=="boolean"?q===(we?"true":"false")?y.INSTANCE:m.INSTANCE:new v(z,q,le)}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=S.get(this.c);if(typeof z=="boolean"){const q=z?"true":"false";return this.d===q?y.INSTANCE:m.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Qi=v;class R{static create(z,q=null){const le=S.get(z);return typeof le=="boolean"?le?y.INSTANCE:m.INSTANCE:new R(z,q)}constructor(z,q){this.c=z,this.d=q,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:Z(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=S.get(this.c);return typeof z=="boolean"?z?y.INSTANCE:m.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Ri=R;function W(ie,z){if(typeof ie=="string"){const q=parseFloat(ie);isNaN(q)||(ie=q)}return typeof ie=="string"||typeof ie=="number"?z(ie):y.INSTANCE}class V{static create(z,q,le=null){return W(q,we=>new V(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Si=V;class U{static create(z,q,le=null){return W(q,we=>new U(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ti=U;class B{static create(z,q,le=null){return W(q,we=>new B(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Ui=B;class O{static create(z,q,le=null){return W(q,we=>new O(z,we,le))}constructor(z,q,le){this.c=z,this.d=q,this.f=le,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:ue(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Vi=O;class N{static create(z,q){return new N(z,q)}constructor(z,q){this.d=z,this.f=q,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const q=this.f?this.f.source:"",le=z.f?z.f.source:"";return q<le?-1:q>le?1:0}equals(z){if(z.type===this.type){const q=this.f?this.f.source:"",le=z.f?z.f.source:"";return this.d===z.d&&q===le}return!1}substituteConstants(){return this}evaluate(z){const q=z.getValue(this.d);return this.f?this.f.test(q):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Wi=N;class ee{static create(z){return new ee(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new ee(this.c.map(z))}negate(){return this.c}}e.$Xi=ee;function Y(ie){let z=null;for(let q=0,le=ie.length;q<le;q++){const we=ie[q].substituteConstants();if(ie[q]!==we&&z===null){z=[];for(let ve=0;ve<q;ve++)z[ve]=ie[ve]}z!==null&&(z[q]=we)}return z===null?ie:z}class Ee{static create(z,q,le){return Ee.d(z,q,le)}constructor(z,q){this.expr=z,this.c=q,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,le=this.expr.length;q<le;q++){const we=o(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:Ee.create(z,this.c,!1)}evaluate(z){for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].evaluate(z))return!1;return!0}static d(z,q,le){const we=[];let ve=!1;for(const me of z)if(me){if(me.type===1){ve=!0;continue}if(me.type===0)return y.INSTANCE;if(me.type===6){we.push(...me.expr);continue}we.push(me)}if(we.length===0&&ve)return m.INSTANCE;if(we.length!==0){if(we.length===1)return we[0];we.sort(o);for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];for(;we.length>1;){const me=we[we.length-1];if(me.type!==9)break;we.pop();const De=we.pop(),ne=we.length===0,he=ke.create(me.expr.map(se=>Ee.create([se,De],null,le)),null,ne);he&&(we.push(he),we.sort(o))}if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let De=me+1;De<we.length;De++)if(we[me].negate().equals(we[De]))return y.INSTANCE;if(we.length===1)return we[0]}return new Ee(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new Ee(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());this.c=ke.create(z,this,!0)}return this.c}}e.$Yi=Ee;class ke{static create(z,q,le){return ke.d(z,q,le)}constructor(z,q){this.expr=z,this.c=q,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let q=0,le=this.expr.length;q<le;q++){const we=o(this.expr[q],z.expr[q]);if(we!==0)return we}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let q=0,le=this.expr.length;q<le;q++)if(!this.expr[q].equals(z.expr[q]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:ke.create(z,this.c,!1)}evaluate(z){for(let q=0,le=this.expr.length;q<le;q++)if(this.expr[q].evaluate(z))return!0;return!1}static d(z,q,le){let we=[],ve=!1;if(z){for(let me=0,De=z.length;me<De;me++){const ne=z[me];if(ne){if(ne.type===0){ve=!0;continue}if(ne.type===1)return m.INSTANCE;if(ne.type===9){we=we.concat(ne.expr);continue}we.push(ne)}}if(we.length===0&&ve)return y.INSTANCE;we.sort(o)}if(we.length!==0){if(we.length===1)return we[0];for(let me=1;me<we.length;me++)we[me-1].equals(we[me])&&(we.splice(me,1),me--);if(we.length===1)return we[0];if(le){for(let me=0;me<we.length;me++)for(let De=me+1;De<we.length;De++)if(we[me].negate().equals(we[De]))return m.INSTANCE;if(we.length===1)return we[0]}return new ke(we,q)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const q of this.expr)z.push(...q.keys());return z}map(z){return new ke(this.expr.map(q=>q.map(z)),null)}negate(){if(!this.c){const z=[];for(const q of this.expr)z.push(q.negate());for(;z.length>1;){const q=z.shift(),le=z.shift(),we=[];for(const ve of $e(q))for(const me of $e(le))we.push(Ee.create([ve,me],null,!1));z.unshift(ke.create(we,null,!1))}this.c=ke.create(z,this,!0)}return this.c}}e.$Zi=ke;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,q,le){super(z,null),this.f=q,typeof le=="object"?Pe.d.push({...le,key:z}):le!==!0&&Pe.d.push({key:z,description:le,type:q!=null?typeof q:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return k.create(this.key,z)}notEqualsTo(z){return v.create(this.key,z)}}e.$1i=Pe,e.$2i=(0,L.$Ah)("contextKeyService");function Z(ie,z){return ie<z?-1:ie>z?1:0}function ue(ie,z,q,le){return ie<q?-1:ie>q?1:z<le?-1:z>le?1:0}function ye(ie,z){if(ie.type===0||z.type===1)return!0;if(ie.type===9)return z.type===9?ce(ie.expr,z.expr):!1;if(z.type===9){for(const q of z.expr)if(ye(ie,q))return!0;return!1}if(ie.type===6){if(z.type===6)return ce(z.expr,ie.expr);for(const q of ie.expr)if(ye(q,z))return!0;return!1}return ie.equals(z)}e.$3i=ye;function ce(ie,z){let q=0,le=0;for(;q<ie.length&&le<z.length;){const we=ie[q].cmp(z[le]);if(we<0)return!1;we===0&&q++,le++}return q===ie.length}function $e(ie){return ie.type===9?ie.expr:[ie]}}),define(Ae[172],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.$Hh=void 0,e.$Hh=(0,w.$Ah)("environmentService"),e.$Ih=(0,w.$Bh)(e.$Hh)}),define(Ae[92],Re([1,0,141,4]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Yn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0,e.$Ln="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Mn=new RegExp(e.$Ln),e.$Nn="__web_extension",e.$On="skipWalkthrough",e.$Pn="extensionsSync",e.$Qn="dependecyOrPackExtensionInstall";function C(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Rn=C;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Sn=L;function A(c,g){switch(c){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Tn=A;function l(c,g){return g==="web"&&!c.includes("web")}e.$Un=l;function S(c,g,E){return l(g,E)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===E?!0:d(E).includes(c)}e.$Vn=S;function d(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Wn=d;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$Xn=P;var D;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var u;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(u||(e.SortOrder=u={}));var b;(function(c){c.Install="install",c.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var p;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$Yn=(0,F.$Ah)("extensionGalleryService");var f;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));var i;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(i||(e.ExtensionSignaturetErrorCode=i={}));class t extends Error{constructor(g,E){super(g),this.code=E,this.name=E}}e.$Zn=t,e.$1n=(0,F.$Ah)("extensionManagementService"),e.$2n="extensionsIdentifiers/disabled",e.$3n="extensionsIdentifiers/enabled",e.$4n=(0,F.$Ah)("IGlobalExtensionEnablementService"),e.$5n=(0,F.$Ah)("IExtensionTipsService"),e.$6n=(0,w.localize)(0,null),e.$7n={value:e.$6n,original:"Extensions"},e.$8n={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,48,19,15,16,2,143,4,22,12]),function(be,e,w,F,C,L,A,l,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.FileKind=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileOperationResult=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileChangeType=e.$jk=e.FileOperation=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileSystemProviderErrorCode=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$6j=e.$5j=void 0,e.$5j=(0,S.$Ah)("fileService");function D(Z){return Z.create===!0}e.$6j=D;var u;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.File=1]="File",Z[Z.Directory=2]="Directory",Z[Z.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var b;(function(Z){Z[Z.Readonly=1]="Readonly",Z[Z.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var p;(function(Z){Z[Z.None=0]="None",Z[Z.FileReadWrite=2]="FileReadWrite",Z[Z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Z[Z.FileReadStream=16]="FileReadStream",Z[Z.FileFolderCopy=8]="FileFolderCopy",Z[Z.PathCaseSensitive=1024]="PathCaseSensitive",Z[Z.Readonly=2048]="Readonly",Z[Z.Trash=4096]="Trash",Z[Z.FileWriteUnlock=8192]="FileWriteUnlock",Z[Z.FileAtomicRead=16384]="FileAtomicRead",Z[Z.FileAtomicWrite=32768]="FileAtomicWrite",Z[Z.FileAtomicDelete=65536]="FileAtomicDelete",Z[Z.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function f(Z){return!!(Z.capabilities&2)}e.$7j=f;function i(Z){return!!(Z.capabilities&8)}e.$8j=i;function t(Z){return!!(Z.capabilities&131072)}e.$9j=t;function c(Z){return!!(Z.capabilities&4)}e.$0j=c;function g(Z){return!!(Z.capabilities&16)}e.$$j=g;function E(Z){return f(Z)?!!(Z.capabilities&16384):!1}e.$_j=E;function $(Z){return f(Z)?!!(Z.capabilities&32768):!1}e.$ak=$;function s(Z){return!!(Z.capabilities&65536)}e.$bk=s;function a(Z){return!!(Z.capabilities&2048)}e.$ck=a;var n;(function(Z){Z.FileExists="EntryExists",Z.FileNotFound="EntryNotFound",Z.FileNotADirectory="EntryNotADirectory",Z.FileIsADirectory="EntryIsADirectory",Z.FileExceedsStorageQuota="EntryExceedsStorageQuota",Z.FileTooLarge="EntryTooLarge",Z.FileWriteLocked="EntryWriteLocked",Z.NoPermissions="NoPermissions",Z.Unavailable="Unavailable",Z.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class o extends Error{static create(ue,ye){const ce=new o(ue.toString(),ye);return I(ce,ye),ce}constructor(ue,ye){super(ue),this.code=ye}}e.$dk=o;function y(Z,ue){return o.create(Z,ue)}e.$ek=y;function m(Z){return Z||y((0,l.localize)(0,null),n.Unknown)}e.$fk=m;function I(Z,ue){return Z.name=ue?`${ue} (FileSystemError)`:"FileSystemError",Z}e.$gk=I;function k(Z){if(!Z)return n.Unknown;if(Z instanceof o)return Z.code;const ue=/^(.+) \(FileSystemError\)$/.exec(Z.name);if(!ue)return n.Unknown;switch(ue[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$hk=k;function r(Z){if(Z instanceof U)return Z.fileOperationResult;switch(k(Z)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$ik=r;var h;(function(Z){Z[Z.CREATE=0]="CREATE",Z[Z.DELETE=1]="DELETE",Z[Z.MOVE=2]="MOVE",Z[Z.COPY=3]="COPY",Z[Z.WRITE=4]="WRITE"})(h||(e.FileOperation=h={}));class v{constructor(ue,ye,ce){this.resource=ue,this.operation=ye,this.target=ce}isOperation(ue){return this.operation===ue}}e.$jk=v;var R;(function(Z){Z[Z.UPDATED=0]="UPDATED",Z[Z.ADDED=1]="ADDED",Z[Z.DELETED=2]="DELETED"})(R||(e.FileChangeType=R={}));class W{constructor(ue,ye){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const $e of ue){const ie=ce.get($e.type);switch(ie?ie.push([$e.resource,$e]):ce.set($e.type,[[$e.resource,$e]]),$e.type){case 1:this.rawAdded.push($e.resource);break;case 0:this.rawUpdated.push($e.resource);break;case 2:this.rawDeleted.push($e.resource);break}}for(const[$e,ie]of ce)switch($e){case 1:this.a=w.$Gh.forUris(()=>ye),this.a.fill(ie);break;case 0:this.b=w.$Gh.forUris(()=>ye),this.b.fill(ie);break;case 2:this.c=w.$Gh.forUris(()=>ye),this.c.fill(ie);break}}contains(ue,...ye){return this.d(ue,{includeChildren:!1},...ye)}affects(ue,...ye){return this.d(ue,{includeChildren:!0},...ye)}d(ue,ye,...ce){if(!ue)return!1;const $e=ce.length>0;return!!((!$e||ce.includes(1))&&(this.a?.get(ue)||ye.includeChildren&&this.a?.findSuperstr(ue))||(!$e||ce.includes(0))&&(this.b?.get(ue)||ye.includeChildren&&this.b?.findSuperstr(ue))||(!$e||ce.includes(2))&&(this.c?.findSubstr(ue)||ye.includeChildren&&this.c?.findSuperstr(ue)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$kk=W;function V(Z,ue,ye){return!Z||!ue||Z===ue||ue.length>Z.length?!1:(ue.charAt(ue.length-1)!==F.sep&&(ue+=F.sep),ye?(0,C.$Me)(Z,ue):Z.indexOf(ue)===0)}e.$lk=V;class U extends Error{constructor(ue,ye,ce){super(ue),this.fileOperationResult=ye,this.options=ce}}e.$mk=U;class B extends U{constructor(ue,ye,ce,$e){super(ue,ye,$e),this.fileOperationResult=ye,this.size=ce}}e.$nk=B;class O extends U{constructor(ue,ye,ce){super(ue,2,ce),this.stat=ye}}e.$ok=O;var N;(function(Z){Z[Z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Z[Z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Z[Z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Z[Z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Z[Z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Z[Z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Z[Z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Z[Z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Z[Z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Z[Z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Z[Z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.$pk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$qk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$rk="files.associations",e.$sk="files.exclude",e.$tk="files.readonlyInclude",e.$uk="files.readonlyExclude",e.$vk="files.readonlyFromPermissions";var ee;(function(Z){Z[Z.FILE=0]="FILE",Z[Z.FOLDER=1]="FOLDER",Z[Z.ROOT_FOLDER=2]="ROOT_FOLDER"})(ee||(e.FileKind=ee={})),e.$wk="";function Y(Z){if(!(typeof Z.size!="number"||typeof Z.mtime!="number"))return Z.mtime.toString(29)+Z.size.toString(31)}e.$xk=Y;async function Ee(Z,ue){if(!ue.hasProvider(A.URI.from({scheme:Z.scheme})))return new Promise(ye=>{const ce=ue.onDidChangeFileSystemProviderRegistrations($e=>{$e.scheme===Z.scheme&&$e.added&&(ce.dispose(),ye())})})}e.$yk=Ee;class ke{static{this.KB=1024}static{this.MB=ke.KB*ke.KB}static{this.GB=ke.MB*ke.KB}static{this.TB=ke.GB*ke.KB}static formatSize(ue){return(0,L.$mf)(ue)||(ue=0),ue<ke.KB?(0,l.localize)(1,null,ue.toFixed(0)):ue<ke.MB?(0,l.localize)(2,null,(ue/ke.KB).toFixed(2)):ue<ke.GB?(0,l.localize)(3,null,(ue/ke.MB).toFixed(2)):ue<ke.TB?(0,l.localize)(4,null,(ue/ke.GB).toFixed(2)):(0,l.localize)(5,null,(ue/ke.TB).toFixed(2))}}e.$zk=ke;function Pe(Z){const ue=typeof Z=="string"||Z?.scheme===P.Schemas.vscodeRemote;return typeof Z!="string"&&Z?.scheme===P.Schemas.file?1024*ke.MB:ue?10*ke.MB:d.$o?50*ke.MB:1024*ke.MB}e.$Ak=Pe}),define(Ae[71],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class w{constructor(...C){this.a=new Map;for(const[L,A]of C)this.set(L,A)}set(C,L){const A=this.a.get(C);return this.a.set(C,L),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$yh=w}),define(Ae[173],Re([1,0,13,9,6,69,171,4,71,174]),function(be,e,w,F,C,L,A,l,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;const P=!1;class D extends Error{constructor(i){super("cyclic dependency between services"),this.message=i.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${i.toString()}`}}class u{constructor(i=new S.$yh,t=!1,c,g=P){this.f=i,this.g=t,this.h=c,this.i=g,this.o=new Set,this.f.set(l.$zh,this),this._globalGraph=g?c?._globalGraph??new A.$4p(E=>E):void 0}createChild(i){return new u(i,this.g,this,this.i)}invokeFunction(i,...t){const c=p.traceInvocation(this.i,i);let g=!1;try{return i({get:$=>{if(g)throw(0,F.$6)("service accessor is only valid during the invocation of its target method");const s=this.m($,c);if(!s)throw new Error(`[invokeFunction] unknown service '${$}'`);return s}},...t)}finally{g=!0,c.stop()}}createInstance(i,...t){let c,g;return i instanceof L.$xh?(c=p.traceCreation(this.i,i.ctor),g=this.j(i.ctor,i.staticArguments.concat(t),c)):(c=p.traceCreation(this.i,i),g=this.j(i,t,c)),c.stop(),g}j(i,t=[],c){const g=l._util.getServiceDependencies(i).sort((s,a)=>s.index-a.index),E=[];for(const s of g){const a=this.m(s.id,c);a||this.u(`[createInstance] ${i.name} depends on UNKNOWN service ${s.id}.`,!1),E.push(a)}const $=g.length>0?g[0].index:t.length;if(t.length!==$){console.trace(`[createInstance] First service dependency of ${i.name} at position ${$+1} conflicts with ${t.length} static arguments`);const s=$-t.length;s>0?t=t.concat(new Array(s)):t=t.slice(0,$)}return Reflect.construct(i,t.concat(E))}k(i,t){if(this.f.get(i)instanceof L.$xh)this.f.set(i,t);else if(this.h)this.h.k(i,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(i){const t=this.f.get(i);return!t&&this.h?this.h.l(i):t}m(i,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(i));const c=this.l(i);return c instanceof L.$xh?this.q(i,c,t.branch(i,!0)):(t.branch(i,!1),c)}q(i,t,c){if(this.o.has(i))throw new Error(`illegal state - RECURSIVELY instantiating service '${i}'`);this.o.add(i);try{return this.r(i,t,c)}finally{this.o.delete(i)}}r(i,t,c){const g=new A.$4p(s=>s.id.toString());let E=0;const $=[{id:i,desc:t,_trace:c}];for(;$.length;){const s=$.pop();if(g.lookupOrInsertNode(s),E++>1e3)throw new D(g);for(const a of l._util.getServiceDependencies(s.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${i} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(a.id)),n instanceof L.$xh){const o={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};g.insertEdge(s,o),$.push(o)}}}for(;;){const s=g.roots();if(s.length===0){if(!g.isEmpty())throw new D(g);break}for(const{data:a}of s){if(this.l(a.id)instanceof L.$xh){const o=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,o)}g.removeNode(a)}}return this.l(i)}s(i,t,c=[],g,E){if(this.f.get(i)instanceof L.$xh)return this.t(i,t,c,g,E);if(this.h)return this.h.s(i,t,c,g,E);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(i,t,c=[],g,E){if(g){const $=new u(void 0,this.g,this,this.i);$.c=String(i);const s=new Map,a=new w.$Wg(()=>{const n=$.j(t,c,E);for(const[o,y]of s){const m=n[o];if(typeof m=="function")for(const I of y)m.apply(n,I)}return s.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!a.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=s.get(o);return I||(I=new d.$sc,s.set(o,I)),(r,h,v)=>{const R=I.push([r,h,v]);return(0,C.$hc)(R)}}if(o in n)return n[o];const y=a.value;let m=y[o];return typeof m!="function"||(m=m.bind(y),n[o]=m),m},set(n,o,y){return a.value[o]=y,!0},getPrototypeOf(n){return t.prototype}})}else return this.j(t,c,E)}u(i,t){if(t&&console.warn(i),this.g)throw new Error(i)}}e.$5p=u;var b;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(b||(b={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(i,t){return i?new p(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(i,t){return i?new p(1,t.name):p.c}static{this.f=0}constructor(i,t){this.type=i,this.name=t,this.g=Date.now(),this.h=[]}branch(i,t){const c=new p(3,i.toString());return this.h.push([i,t,c]),c}stop(){const i=Date.now()-this.g;p.f+=i;let t=!1;function c(E,$){const s=[],a=new Array(E+1).join("	");for(const[n,o,y]of $.h)if(o&&y){t=!0,s.push(`${a}CREATES -> ${n}`);const m=c(E+1,y);m&&s.push(m)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${i.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(i>2||t)&&p.all.add(g.join(`
`))}}e.$6p=p}),define(Ae[14],Re([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(be,e,w,F,C,L,A,l,S,d,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.log=e.$7i=e.LogLevel=e.$6i=e.$5i=e.$4i=void 0,e.$4i=(0,u.$Ah)("logService"),e.$5i=(0,u.$Ah)("loggerService");function b(){return new Date().toISOString()}function p(r){return(0,d.$mf)(r)}e.$6i=p;var f;(function(r){r[r.Off=0]="Off",r[r.Trace=1]="Trace",r[r.Debug=2]="Debug",r[r.Info=3]="Info",r[r.Warning=4]="Warning",r[r.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$7i=f.Info;function i(r,h,v){switch(h){case f.Trace:r.trace(v);break;case f.Debug:r.debug(v);break;case f.Info:r.info(v);break;case f.Warning:r.warn(v);break;case f.Error:r.error(v);break;case f.Off:break;default:throw new Error(`Invalid log level ${h}`)}}e.log=i;function t(r,h=!1){let v="";for(let R=0;R<r.length;R++){let W=r[R];if(W instanceof Error&&(W=(0,w.$li)(W,h)),typeof W=="object")try{W=JSON.stringify(W)}catch{}v+=(R>0?" ":"")+W}return v}class c extends L.$jc{constructor(){super(...arguments),this.b=e.$7i,this.c=this.B(new F.$ed),this.onDidChangeLogLevel=this.c.event}setLevel(h){this.b!==h&&(this.b=h,this.c.fire(this.b))}getLevel(){return this.b}f(h){return this.b!==f.Off&&this.b<=h}}e.$9i=c;class g extends c{constructor(h){super(),this.h=h}f(h){return this.h||super.f(h)}trace(h,...v){this.f(f.Trace)&&this.g(f.Trace,t([h,...v],!0))}debug(h,...v){this.f(f.Debug)&&this.g(f.Debug,t([h,...v]))}info(h,...v){this.f(f.Info)&&this.g(f.Info,t([h,...v]))}warn(h,...v){this.f(f.Warning)&&this.g(f.Warning,t([h,...v]))}error(h,...v){if(this.f(f.Error))if(h instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=h.stack,this.g(f.Error,t(R))}else this.g(f.Error,t([h,...v]))}flush(){}}e.$0i=g;class E extends c{constructor(h=e.$7i){super(),this.setLevel(h),this.g=!l.$i}trace(h,...v){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,h,...v):console.log(`[main ${b()}]`,h,...v))}debug(h,...v){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,h,...v):console.log(`[main ${b()}]`,h,...v))}info(h,...v){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,h,...v):console.log(`[main ${b()}]`,h,...v))}warn(h,...v){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,h,...v):console.warn(`[main ${b()}]`,h,...v))}error(h,...v){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,h,...v):console.error(`[main ${b()}]`,h,...v))}dispose(){}flush(){}}e.$$i=E;class $ extends c{constructor(h=e.$7i,v=!0){super(),this.g=v,this.setLevel(h)}trace(h,...v){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",h,...v):console.log(h,...v))}debug(h,...v){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",h,...v):console.log(h,...v))}info(h,...v){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",h,...v):console.log(h,...v))}warn(h,...v){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",h,...v):console.log(h,...v))}error(h,...v){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",h,...v):console.error(h,...v))}dispose(){}flush(){}}e.$_i=$;class s extends c{constructor(h,v=e.$7i){super(),this.g=h,this.setLevel(v)}trace(h,...v){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(h),...v])}debug(h,...v){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(h),...v])}info(h,...v){this.f(f.Info)&&this.g.log(f.Info,[this.h(h),...v])}warn(h,...v){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(h),...v])}error(h,...v){this.f(f.Error)&&this.g.log(f.Error,[this.h(h),...v])}h(h){return typeof h=="string"?h:(0,w.$li)(h,this.f(f.Trace))}dispose(){}flush(){}}e.$aj=s;class a extends c{constructor(h){super(),this.g=h,h.length&&this.setLevel(h[0].getLevel())}setLevel(h){for(const v of this.g)v.setLevel(h);super.setLevel(h)}trace(h,...v){for(const R of this.g)R.trace(h,...v)}debug(h,...v){for(const R of this.g)R.debug(h,...v)}info(h,...v){for(const R of this.g)R.info(h,...v)}warn(h,...v){for(const R of this.g)R.warn(h,...v)}error(h,...v){for(const R of this.g)R.error(h,...v)}flush(){for(const h of this.g)h.flush()}dispose(){for(const h of this.g)h.dispose()}}e.$bj=a;class n extends L.$jc{constructor(h,v,R){if(super(),this.h=h,this.j=v,this.b=new A.$yi,this.c=this.B(new F.$ed),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$ed),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$ed),this.onDidChangeVisibility=this.g.event,R)for(const W of R)this.b.set(W.resource,{logger:void 0,info:W})}m(h){return(0,d.$if)(h)?[...this.b.values()].find(v=>v.info.id===h):this.b.get(h)}getLogger(h){return this.m(h)?.logger}createLogger(h,v){const R=this.n(h),W=(0,d.$if)(h)?h:v?.id??(0,C.$oi)(R.toString()).toString(16);let V=this.b.get(R)?.logger;const U=v?.logLevel==="always"?f.Trace:v?.logLevel;V||(V=this.s(R,U??this.getLogLevel(R)??this.h,{...v,id:W}));const B={logger:V,info:{resource:R,id:W,logLevel:U,name:v?.name,hidden:v?.hidden,extensionId:v?.extensionId,when:v?.when}};return this.registerLogger(B.info),this.b.set(R,B),V}n(h){return(0,d.$if)(h)?(0,S.$hg)(this.j,`${h}.log`):h}setLogLevel(h,v){if(P.URI.isUri(h)){const R=h,W=v,V=this.b.get(R);V&&W!==V.info.logLevel&&(V.info.logLevel=W===this.h?void 0:W,V.logger?.setLevel(W),this.b.set(V.info.resource,V),this.f.fire([R,W]))}else{this.h=h;for(const[R,W]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(h,v){const R=this.m(h);R&&v!==!R.info.hidden&&(R.info.hidden=!v,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,v]))}getLogLevel(h){let v;return h&&(v=this.b.get(h)?.info.logLevel),v??this.h}registerLogger(h){const v=this.b.get(h.resource);v?v.info.hidden!==h.hidden&&this.setVisibility(h.resource,!h.hidden):(this.b.set(h.resource,{info:h,logger:void 0}),this.c.fire({added:[h],removed:[]}))}deregisterLogger(h){const v=this.b.get(h);v&&(v.logger&&v.logger.dispose(),this.b.delete(h),this.c.fire({added:[],removed:[v.info]}))}*getRegisteredLoggers(){for(const h of this.b.values())yield h.info}getRegisteredLogger(h){return this.b.get(h)?.info}dispose(){this.b.forEach(h=>h.logger?.dispose()),this.b.clear(),super.dispose()}}e.$cj=n;class o{constructor(){this.onDidChangeLogLevel=new F.$ed().event}setLevel(h){}getLevel(){return f.Info}trace(h,...v){}debug(h,...v){}info(h,...v){}warn(h,...v){}error(h,...v){}critical(h,...v){}dispose(){}flush(){}}e.$dj=o;class y extends o{}e.$ej=y;function m(r){if(r.verbose)return f.Trace;if(typeof r.logLevel=="string"){const h=k(r.logLevel.toLowerCase());if(h!==void 0)return h}return e.$7i}e.$fj=m;function I(r){switch(r){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$gj=I;function k(r){switch(r){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$hj=k,e.$ij=new D.$1i("logLevel",I(f.Info))}),define(Ae[175],Re([1,0,6,14]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;class C extends w.$jc{constructor(A,l=[]){super(),this.a=new F.$bj([A,...l]),this.B(A.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$iN=C}),define(Ae[94],Re([1,0,29,144,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(S){function d(p,f){return f-p}S.compare=d;const P=Object.create(null);P[S.Error]=(0,F.localize)(0,null),P[S.Warning]=(0,F.localize)(1,null),P[S.Info]=(0,F.localize)(2,null);function D(p){return P[p]||""}S.toString=D;function u(p){switch(p){case w.default.Error:return S.Error;case w.default.Warning:return S.Warning;case w.default.Info:return S.Info;case w.default.Ignore:return S.Hint}}S.fromSeverity=u;function b(p){switch(p){case S.Error:return w.default.Error;case S.Warning:return w.default.Warning;case S.Info:return w.default.Info;case S.Hint:return w.default.Ignore}}S.toSeverity=b}(A||(e.MarkerSeverity=A={}));var l;(function(S){const d="";function P(u){return D(u,!0)}S.makeKey=P;function D(u,b){const p=[d];return u.source?p.push(u.source.replace("\xA6","\\\xA6")):p.push(d),u.code?typeof u.code=="string"?p.push(u.code.replace("\xA6","\\\xA6")):p.push(u.code.value.replace("\xA6","\\\xA6")):p.push(d),u.severity!==void 0&&u.severity!==null?p.push(A.toString(u.severity)):p.push(d),u.message&&b?p.push(u.message.replace("\xA6","\\\xA6")):p.push(d),u.startLineNumber!==void 0&&u.startLineNumber!==null?p.push(u.startLineNumber.toString()):p.push(d),u.startColumn!==void 0&&u.startColumn!==null?p.push(u.startColumn.toString()):p.push(d),u.endLineNumber!==void 0&&u.endLineNumber!==null?p.push(u.endLineNumber.toString()):p.push(d),u.endColumn!==void 0&&u.endColumn!==null?p.push(u.endColumn.toString()):p.push(d),p.push(d),p.join("\xA6")}S.makeKeyOptionalMessage=D})(l||(e.IMarkerData=l={})),e.$2s=(0,C.$Ah)("markerService")}),define(Ae[176],Re([1,0,5,29,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zu=e.$Yu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Xu=e.Severity=void 0,e.Severity=F.default,e.$Xu=(0,C.$Ah)("notificationService");var L;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class S{constructor(){this.progress=new d,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$Yu=S;class d{infinite(){}done(){}total(D){}worked(D){}}e.$Zu=d}),define(Ae[95],Re([1,0,15,2,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JT=e.$IT=e.$HT=e.$GT=e.$FT=void 0,e.$FT=(0,C.$Ah)("openerService");function L(d,P){return F.URI.isUri(d)?(0,w.$Le)(d.scheme,P):(0,w.$Me)(d,P+":")}e.$GT=L;function A(d,...P){return P.some(D=>L(d,D))}e.$HT=A;function l(d,P){return d.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$IT=l;function S(d){let P;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(d.fragment);return D&&(P={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},d=d.with({fragment:""})),{selection:P,uri:d}}e.$JT=S}),define(Ae[177],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=void 0,e.$jj=(0,w.$Ah)("productService"),e.$kj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(be,e,w,F){var C=arguments.length,L=C<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,w):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(be,e,w,F);else for(var l=be.length-1;l>=0;l--)(A=be[l])&&(L=(C<3?A(L):C>3?A(e,w,L):A(e,w))||L);return C>3&&L&&Object.defineProperty(e,w,L),L},Ve=this&&this.__param||function(be,e){return function(w,F){e(w,F,be)}};define(Ae[72],Re([1,0,13,21,6,4]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6u=e.$5u=e.$4u=e.$3u=e.$2u=e.ProgressLocation=e.$1u=void 0,e.$1u=(0,L.$Ah)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$2u=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(D,u){this.c=D,this.report=u?.async?this.e.bind(this):this.d.bind(this)}d(D){this.a=D,this.c(this.a)}e(D){Promise.resolve(this.b).finally(()=>{this.a=D;const u=this.c(this.a);this.b=Promise.resolve(u).finally(()=>this.b=void 0)})}}e.$3u=l;let S=class extends C.$jc{constructor(D,u){super(),this.a=new w.$1g,u.withProgress(D,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,C.$hc)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};e.$4u=S,e.$4u=S=Ke([Ve(1,e.$1u)],S);class d extends C.$jc{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new C.$ic)}start(D){this.stop();const u=++this.a,b=new F.$od;return this.f=setTimeout(()=>{u===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,C.$hc)(()=>clearTimeout(this.f))),this.b.add((0,C.$hc)(()=>b.cancel())),this.b.add((0,C.$hc)(()=>this.c?this.c.done():void 0)),{id:u,token:b.token,stop:()=>this.h(u),isCurrent:()=>this.a===u}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.$5u=d,e.$6u=(0,L.$Ah)("editorProgressService")}),define(Ae[30],Re([1,0,50,16]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;class C{constructor(){this.a=new Map}add(A,l){w.ok(F.$if(A)),w.ok(F.$kf(l)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$7m=new C}),define(Ae[73],Re([1,0,5,30]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$8m={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class L{constructor(){this.b=new w.$ed,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,d){this.a[C(S)]=d,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;F.$7m.add(e.$8m.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,16,138,43,73,30]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ConfigurationScope=e.$_m=e.EditPresentationTypes=void 0;var d;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$_m={Configuration:"base.contributions.configuration"};var P;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$an={properties:{},patternProperties:{}},e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn="vscode://schemas/settings/resourceLanguage",e.$hn="vscode://schemas/settings/configurationDefaults";const D=S.$7m.as(l.$8m.JSONContribution);class u{constructor(){this.h=new Set,this.i=new F.$ed,this.onDidSchemaChange=this.i.event,this.j=new F.$ed,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$gn,this.g),this.v()}registerConfiguration(s,a=!0){this.registerConfigurations([s],a)}registerConfigurations(s,a=!0){const n=new Set;this.n(s,a,n),D.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(s){const a=new Set;this.o(s,a),D.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:s,remove:a}){const n=new Set;this.o(a,n),this.n(s,!1,n),D.registerSchema(e.$gn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(s){const a=new Set;this.k(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(s,a){const n=[];for(const{overrides:o,source:y}of s)for(const m in o)if(a.add(m),e.$jn.test(m)){const I=this.a.get(m),k=I?.valuesSources??new Map;if(y)for(const R of Object.keys(o[m]))k.set(R,y);const r={...I?.value||{},...o[m]};this.a.set(m,{source:y,value:r,valuesSources:k});const h=(0,A.$ei)(m),v={type:"object",default:r,description:L.localize(1,null,h),$ref:e.$gn,defaultDefaultValue:r,source:C.$if(y)?void 0:y,defaultValueSource:y};n.push(...f(m)),this.d[m]=v,this.b.properties[m]=v}else{this.a.set(m,{value:o[m],source:y});const I=this.d[m];I&&(this.w(m,I),this.r(m,I))}this.m(n)}deregisterDefaultConfigurations(s){const a=new Set;this.l(s,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(s,a){for(const{overrides:n,source:o}of s)for(const y in n){const m=this.a.get(y),I=C.$if(o)?o:o?.id,k=C.$if(m?.source)?m?.source:m?.source?.id;if(I===k)if(a.add(y),this.a.delete(y),e.$jn.test(y))delete this.d[y],delete this.b.properties[y];else{const r=this.d[y];r&&(this.w(y,r),this.r(y,r))}}this.u()}deltaConfiguration(s){let a=!1;const n=new Set;s.removedDefaults&&(this.l(s.removedDefaults,n),a=!0),s.addedDefaults&&(this.k(s.addedDefaults,n),a=!0),s.removedConfigurations&&this.o(s.removedConfigurations,n),s.addedConfigurations&&this.n(s.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const a of s)this.h.add(a);this.u()}n(s,a,n){s.forEach(o=>{this.p(o,a,o.extensionInfo,o.restrictedProperties,void 0,n),this.c.push(o),this.q(o)})}o(s,a){const n=o=>{if(o.properties)for(const y in o.properties){a.add(y);const m=this.d[y];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[y],this.s(y,o.properties[y])}o.allOf?.forEach(y=>n(y))};for(const o of s){n(o);const y=this.c.indexOf(o);y!==-1&&this.c.splice(y,1)}}p(s,a=!0,n,o,y=3,m){y=C.$rf(s.scope)?y:s.scope;const I=s.properties;if(I)for(const r in I){const h=I[r];if(a&&g(r,h)){delete I[r];continue}if(h.source=n,h.defaultDefaultValue=I[r].default,this.w(r,h),e.$jn.test(r)?h.scope=void 0:(h.scope=C.$rf(h.scope)?y:h.scope,h.restricted=C.$rf(h.restricted)?!!o?.includes(r):h.restricted),I[r].hasOwnProperty("included")&&!I[r].included){this.f[r]=I[r],delete I[r];continue}else this.d[r]=I[r],I[r].policy?.name&&this.e.set(I[r].policy.name,r);!I[r].deprecationMessage&&I[r].markdownDeprecationMessage&&(I[r].deprecationMessage=I[r].markdownDeprecationMessage),m.add(r)}const k=s.allOf;if(k)for(const r of k)this.p(r,a,n,o,y,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const a=n=>{const o=n.properties;if(o)for(const m in o)this.r(m,o[m]);n.allOf?.forEach(a)};a(s)}r(s,a){switch(e.$an.properties[s]=a,a.scope){case 1:e.$bn.properties[s]=a;break;case 2:e.$cn.properties[s]=a;break;case 6:e.$dn.properties[s]=a;break;case 3:e.$en.properties[s]=a;break;case 4:e.$fn.properties[s]=a;break;case 5:e.$fn.properties[s]=a,this.g.properties[s]=a;break}}s(s,a){switch(delete e.$an.properties[s],a.scope){case 1:delete e.$bn.properties[s];break;case 2:delete e.$cn.properties[s];break;case 6:delete e.$dn.properties[s];break;case 3:delete e.$en.properties[s];break;case 4:case 5:delete e.$fn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const a=`[${s}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$gn};this.w(a,n),e.$an.properties[a]=n,e.$bn.properties[a]=n,e.$cn.properties[a]=n,e.$dn.properties[a]=n,e.$en.properties[a]=n,e.$fn.properties[a]=n}}v(){const s={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$gn};e.$an.patternProperties[e.$in]=s,e.$bn.patternProperties[e.$in]=s,e.$cn.patternProperties[e.$in]=s,e.$dn.patternProperties[e.$in]=s,e.$en.patternProperties[e.$in]=s,e.$fn.patternProperties[e.$in]=s,this.i.fire()}w(s,a){const n=this.a.get(s);let o=n?.value,y=n?.source;C.$pf(o)&&(o=a.defaultDefaultValue,y=void 0),C.$pf(o)&&(o=t(a.type)),a.default=o,a.defaultValueSource=y}}const b="\\[([^\\]]+)\\]",p=new RegExp(b,"g");e.$in=`^(${b})+$`,e.$jn=new RegExp(e.$in);function f($){const s=[];if(e.$jn.test($)){let a=p.exec($);for(;a?.length;){const n=a[1].trim();n&&s.push(n),a=p.exec($)}}return(0,w.$Jb)(s)}e.$kn=f;function i($){return $.reduce((s,a)=>`${s}[${a}]`,"")}e.$ln=i;function t($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$mn=t;const c=new u;S.$7m.add(e.$_m.Configuration,c);function g($,s){return $.trim()?e.$jn.test($)?L.localize(7,null,$):c.getConfigurationProperties()[$]!==void 0?L.localize(8,null,$):s.policy?.name&&c.getPolicyConfigurations().get(s.policy?.name)!==void 0?L.localize(9,null,$,s.policy?.name,c.getPolicyConfigurations().get(s.policy?.name)):null:L.localize(6,null)}e.$nn=g;function E(){const $=[],s=c.getConfigurationProperties();for(const a of Object.keys(s))$.push([a,s[a].scope]);return $.push(["launch",4]),$.push(["task",4]),$}e.$on=E}),define(Ae[178],Re([1,0,18,5,116,6,28,24,16,2,43,96,30]),function(be,e,w,F,C,L,A,l,S,d,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=void 0;function b(a){return Object.isFrozen(a)?a:l.$Vm(a)}class p{constructor(n={},o=[],y=[],m){this.b=n,this.c=o,this.d=y,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(o=>{if(o instanceof p)return o;const y=new f("");return y.parseRaw(o),y.configurationModel});this.f=n.reduce((o,y)=>y===o?y:o.merge(y),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$ci)(this.contents,n):this.contents}inspect(n,o){const y=this.rawConfiguration.getValue(n),m=o?this.rawConfiguration.getOverrideValue(n,o):void 0,I=o?this.rawConfiguration.override(o).getValue(n):y;return{value:y,override:m,merged:I}}getOverrideValue(n,o){const y=this.i(o);return y?n?(0,P.$ci)(y,n):y:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const y of this.overrides)y.identifiers.includes(n)&&o.push(...y.keys);return w.$Jb(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return w.$Jb(n)}override(n){let o=this.a.get(n);return o||(o=this.g(n),this.a.set(n,o)),o}merge(...n){const o=l.$Um(this.contents),y=l.$Um(this.overrides),m=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const k of n)if(I.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(o,k.contents);for(const r of k.overrides){const[h]=y.filter(v=>w.$sb(v.identifiers,r.identifiers));h?(this.h(h.contents,r.contents),h.keys.push(...r.keys),h.keys=w.$Jb(h.keys)):y.push(l.$Um(r))}for(const r of k.keys)m.indexOf(r)===-1&&m.push(r)}return new p(o,m,y,I.every(k=>k instanceof p)?void 0:I)}g(n){const o=this.i(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const y={};for(const m of w.$Jb([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[m];const k=o[m];k&&(typeof I=="object"&&typeof k=="object"?(I=l.$Um(I),this.h(I,k)):I=k),y[m]=I}return new p(y,this.keys,this.overrides)}h(n,o){for(const y of Object.keys(o)){if(y in n&&S.$kf(n[y])&&S.$kf(o[y])){this.h(n[y],o[y]);continue}n[y]=l.$Um(o[y])}}i(n){let o=null,y=null;const m=I=>{I&&(y?this.h(y,I):y=l.$Um(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===n?o=I.contents:I.identifiers.includes(n)&&m(I.contents);return m(o),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,o){this.j(n,o,!0)}setValue(n,o){this.j(n,o,!1)}removeValue(n){const o=this.keys.indexOf(n);o!==-1&&(this.keys.splice(o,1),(0,P.$bi)(this.contents,n),D.$jn.test(n)&&this.overrides.splice(this.overrides.findIndex(y=>w.$sb(y.identifiers,(0,D.$kn)(n))),1))}j(n,o,y){(0,P.$ai)(this.contents,n,o,m=>console.error(m)),y=y||this.keys.indexOf(n)===-1,y&&this.keys.push(n),D.$jn.test(n)&&this.overrides.push({identifiers:(0,D.$kn)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$_h)(this.contents[n],m=>console.error(m))})}}e.$pn=p;class f{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,o){if(!S.$rf(n)){const y=this.g(n);this.parseRaw(y,o)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,o){this.a=n;const{contents:y,keys:m,overrides:I,restricted:k,hasExcludedProperties:r}=this.h(n,o);this.b=new p(y,m,I,r?[n]:void 0),this.c=k||[]}g(n){let o={},y=null,m=[];const I=[],k=[];function r(v){Array.isArray(m)?m.push(v):y!==null&&(m[y]=v)}const h={onObjectBegin:()=>{const v={};r(v),I.push(m),m=v,y=null},onObjectProperty:v=>{y=v},onObjectEnd:()=>{m=I.pop()},onArrayBegin:()=>{const v=[];r(v),I.push(m),m=v,y=null},onArrayEnd:()=>{m=I.pop()},onLiteralValue:r,onError:(v,R,W)=>{k.push({error:v,offset:R,length:W})}};if(n)try{C.$Rm(n,h),o=m[0]||{}}catch(v){console.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return o}h(n,o){const y=u.$7m.as(D.$_m.Configuration).getConfigurationProperties(),m=this.i(n,y,!0,o);n=m.raw;const I=(0,P.$_h)(n,h=>console.error(`Conflict in settings file ${this.f}: ${h}`)),k=Object.keys(n),r=this.j(n,h=>console.error(`Conflict in settings file ${this.f}: ${h}`));return{contents:I,keys:k,overrides:r,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(n,o,y,m){let I=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:I};const k={},r=[];for(const h in n)if(D.$jn.test(h)&&y){const v=this.i(n[h],o,!1,m);k[h]=v.raw,I=I||v.hasExcludedProperties,r.push(...v.restricted)}else{const v=o[h],R=v?typeof v.scope<"u"?v.scope:3:void 0;v?.restricted&&r.push(h),!m.exclude?.includes(h)&&(m.include?.includes(h)||(R===void 0||m.scopes===void 0||m.scopes.includes(R))&&!(m.skipRestricted&&v?.restricted))?k[h]=n[h]:I=!0}return{raw:k,restricted:r,hasExcludedProperties:I}}j(n,o){const y=[];for(const m of Object.keys(n))if(D.$jn.test(m)){const I={};for(const k in n[m])I[k]=n[m][k];y.push({identifiers:(0,D.$kn)(m),keys:Object.keys(I),contents:(0,P.$_h)(I,o)})}return y}}e.$qn=f;class i extends L.$jc{constructor(n,o,y,m){super(),this.c=n,this.f=o,this.g=m,this.b=this.B(new F.$ed),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&y.isEqual(I.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$rn=i;class t{constructor(n,o,y,m,I,k,r,h,v,R,W,V,U){this.a=n,this.b=o,this.c=y,this.overrideIdentifiers=m,this.d=I,this.f=k,this.g=r,this.h=h,this.i=v,this.j=R,this.k=W,this.l=V,this.m=U}get value(){return b(this.c)}n(n,o,y){const m=n.inspect(o,y);return{get value(){return b(m.value)},get override(){return b(m.override)},get merged(){return b(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(n,o,y,m,I=new p,k=new p,r=new A.$yi,h=new p,v=new A.$yi){this.c=n,this.d=o,this.f=y,this.g=m,this.h=I,this.i=k,this.j=r,this.l=h,this.m=v,this.a=null,this.b=new A.$yi,this.n=null}getValue(n,o,y){return this.q(n,o,y).getValue(n)}updateValue(n,o,y={}){let m;y.resource?(m=this.m.get(y.resource),m||(m=new p,this.m.set(y.resource,m))):m=this.l,o===void 0?m.removeValue(n):m.setValue(n,o),y.resource||(this.a=null)}inspect(n,o,y){const m=this.q(n,o,y),I=this.u(o.resource,y),k=o.resource?this.m.get(o.resource)||this.l:this.l,r=new Set;for(const h of m.overrides)for(const v of h.identifiers)m.getOverrideValue(n,v)!==void 0&&r.add(v);return new t(n,o,m.getValue(n),r.size?[...r]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.i:void 0,I||void 0,k)}keys(n){const o=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,o){this.j.set(n,o),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const y=[];if(!o){const{added:m,updated:I,removed:k}=$(this.c,n);o=[...m,...I,...k]}for(const m of o)for(const I of(0,D.$kn)(m)){const k=this.c.getKeysForOverrideIdentifier(I),r=n.getKeysForOverrideIdentifier(I),h=[...r.filter(v=>k.indexOf(v)===-1),...k.filter(v=>r.indexOf(v)===-1),...k.filter(v=>!l.$Ym(this.c.override(I).getValue(v),n.override(I).getValue(v)))];y.push([I,h])}return this.updateDefaultConfiguration(n),{keys:o,overrides:y}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:y,removed:m}=$(this.d,n),I=[...o,...y,...m];return I.length&&this.updatePolicyConfiguration(n),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:y,removed:m,overrides:I}=$(this.applicationConfiguration,n),k=[...o,...y,...m];return k.length&&this.updateApplicationConfiguration(n),{keys:k,overrides:I}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:y,removed:m,overrides:I}=$(this.localUserConfiguration,n),k=[...o,...y,...m];return k.length&&this.updateLocalUserConfiguration(n),{keys:k,overrides:I}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:y,removed:m,overrides:I}=$(this.remoteUserConfiguration,n),k=[...o,...y,...m];return k.length&&this.updateRemoteUserConfiguration(n),{keys:k,overrides:I}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:y,removed:m,overrides:I}=$(this.workspaceConfiguration,n),k=[...o,...y,...m];return k.length&&this.updateWorkspaceConfiguration(n),{keys:k,overrides:I}}compareAndUpdateFolderConfiguration(n,o){const y=this.p.get(n),{added:m,updated:I,removed:k,overrides:r}=$(y,o),h=[...m,...I,...k];return(h.length||!y)&&this.updateFolderConfiguration(n,o),{keys:h,overrides:r}}compareAndDeleteFolderConfiguration(n){const o=this.p.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:y,updated:m,removed:I,overrides:k}=$(o,void 0);return{keys:[...y,...m,...I],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,o,y){let m=this.r(o,y);return o.overrideIdentifier&&(m=m.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(m=m.merge(this.d)),m}r({resource:n},o){let y=this.s();if(o&&n){const m=o.getFolder(n);m&&(y=this.t(m.uri)||y);const I=this.m.get(n);I&&(y=y.merge(I))}return y}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let o=this.b.get(n);if(!o){const y=this.s(),m=this.j.get(n);m?(o=y.merge(m),this.b.set(n,o)):o=y}return o}u(n,o){if(o&&n){const y=o.getFolder(n);if(y)return this.j.get(y.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,o)=>{const{contents:y,overrides:m,keys:I}=this.j.get(o);return n.push([o,{contents:y,overrides:m,keys:I}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(o=>n.add(o)),this.userConfiguration.keys.forEach(o=>n.add(o)),this.i.keys.forEach(o=>n.add(o)),this.j.forEach(o=>o.keys.forEach(y=>n.add(y))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(y=>n.add(y))),[...n.values()]}w(n){const o=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(y=>o.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(y=>o.add(y)),this.i.getKeysForOverrideIdentifier(n).forEach(y=>o.add(y)),this.j.forEach(y=>y.getKeysForOverrideIdentifier(n).forEach(m=>o.add(m))),[...o.values()]}static parse(n){const o=this.x(n.defaults),y=this.x(n.policy),m=this.x(n.application),I=this.x(n.user),k=this.x(n.workspace),r=n.folders.reduce((h,v)=>(h.set(d.URI.revive(v[0]),this.x(v[1])),h),new A.$yi);return new c(o,y,m,I,new p,k,r,new p,new A.$yi)}static x(n){return new p(n.contents,n.keys,n.overrides)}}e.$sn=c;function g(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,o=new Map;for(const m of a)m.keys.forEach(I=>n.add(I)),m.overrides.forEach(([I,k])=>{const r=(0,A.$vi)(o,I,new Set);k.forEach(h=>r.add(h))});const y=[];return o.forEach((m,I)=>y.push([I,[...m.values()]])),{keys:[...n.values()],overrides:y}}e.$tn=g;class E{constructor(n,o,y,m){this.change=n,this.f=o,this.g=y,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of n.keys)this.affectedKeys.add(I);for(const[,I]of n.overrides)for(const k of I)this.affectedKeys.add(k);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(n,o){const y=this.a+n,m=this.d.indexOf(y);if(m<0)return!1;const I=m+y.length;if(I>=this.d.length)return!1;const k=this.d.charCodeAt(I);if(k!==this.b&&k!==this.c)return!1;if(o){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.f?.workspace):void 0,h=this.g.getValue(n,o,this.h);return!l.$Ym(r,h)}return!0}}e.$un=E;function $(a,n){const{added:o,removed:y,updated:m}=s(n?.rawConfiguration,a?.rawConfiguration),I=[],k=a?.getAllOverrideIdentifiers()||[],r=n?.getAllOverrideIdentifiers()||[];if(n){const h=r.filter(v=>!k.includes(v));for(const v of h)I.push([v,n.getKeysForOverrideIdentifier(v)])}if(a){const h=k.filter(v=>!r.includes(v));for(const v of h)I.push([v,a.getKeysForOverrideIdentifier(v)])}if(n&&a){for(const h of k)if(r.includes(h)){const v=s({contents:a.getOverrideValue(void 0,h)||{},keys:a.getKeysForOverrideIdentifier(h)},{contents:n.getOverrideValue(void 0,h)||{},keys:n.getKeysForOverrideIdentifier(h)});I.push([h,[...v.added,...v.removed,...v.updated]])}}return{added:o,removed:y,updated:m,overrides:I}}function s(a,n){const o=a?n?a.keys.filter(I=>n.keys.indexOf(I)===-1):[...a.keys]:[],y=n?a?n.keys.filter(I=>a.keys.indexOf(I)===-1):[...n.keys]:[],m=[];if(a&&n){for(const I of n.keys)if(a.keys.indexOf(I)!==-1){const k=(0,P.$ci)(n.contents,I),r=(0,P.$ci)(a.contents,I);l.$Ym(k,r)||m.push(I)}}return{added:o,removed:y,updated:m}}}),define(Ae[97],Re([1,0,9,4]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=e.$Lk=e.RemoteAuthorityResolverErrorCode=e.$Kk=e.$Jk=e.RemoteConnectionType=e.$Ik=void 0,e.$Ik=(0,F.$Ah)("remoteAuthorityResolverService");var C;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class L{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Jk=L;class A{constructor(D,u){this.host=D,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Kk=A;var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class S extends w.$_{static isNotAvailable(D){return D instanceof S&&D._code===l.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof S&&D._code===l.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof S&&D._code===l.NoResolverFound}static isInvalidAuthority(D){return D instanceof S&&D._code===l.InvalidAuthority}static isHandled(D){return D instanceof S&&D.isHandled}constructor(D,u=l.Unknown,b){super(D),this._message=D,this._code=u,this._detail=b,this.isHandled=u===l.NotAvailable&&b===!0,Object.setPrototypeOf(this,S.prototype)}}e.$Lk=S;function d(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.$Mk=d}),define(Ae[51],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=void 0;function F(d){return d.scheme===w.Schemas.vscodeRemote?d.authority:void 0}e.$Nk=F;function C(d){if(!d)return;const P=d.indexOf("+");return P<0?d:d.substr(0,P)}e.$Ok=C;function L(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$Pk=L;function A(d){const{host:P,port:D}=S(d);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:D}}e.$Qk=A;function l(d,P){let{host:D,port:u}=S(d);return typeof u>"u"&&(u=P),{host:D,port:u}}e.$Rk=l;function S(d){const P=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const D=d.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const u=d.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:d,port:void 0}}}),define(Ae[20],Re([1,0,15,4,51]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.TargetPlatform=e.ExtensionType=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=void 0,e.$Ol="extensions.user.cache",e.$Pl="extensions.builtin.cache",e.$Ql="undefined_publisher",e.$Rl=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$Sl=L,e.$Tl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class S{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,t){if(typeof i>"u"||i===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof i=="string"||typeof t=="string"){const c=typeof i=="string"?i:i.value,g=typeof t=="string"?t:t.value;return w.$Le(c,g)}return i._lower===t._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.$Ul=S;class d{get size(){return this.c.size}constructor(i){if(this.c=new Set,i)for(const t of i)this.add(t)}add(i){this.c.add(S.toKey(i))}delete(i){return this.c.delete(S.toKey(i))}has(i){return this.c.has(S.toKey(i))}}e.$Vl=d;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(i){this.c.delete(S.toKey(i))}get(i){return this.c.get(S.toKey(i))}has(i){return this.c.has(S.toKey(i))}set(i,t){this.c.set(S.toKey(i),t)}values(){return this.c.values()}forEach(i){this.c.forEach(i)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Wl=P;function D(f){return u(f)}e.$Xl=D;function u(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$Yl=u;function b(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$Zl=b;function p(f,i){if(i){const t=`onResolveRemoteAuthority:${(0,C.$Ok)(i)}`;return!!f.activationEvents?.includes(t)}return!1}e.$1l=p,e.$2l=(0,F.$Ah)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,9,20]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AF=e.$zF=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const S of A){const d=this.readActivationEvents(S);d.length>0&&(l[F.$Ul.toKey(S.identifier)]=d)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const S in A.contributes){const d=this.a.get(S);if(!d)continue;const P=A.contributes[S],D=Array.isArray(P)?P:[P];try{d(D,l)}catch(u){(0,w.$Y)(u)}}return l}}e.$zF=C,e.$AF=new C}),define(Ae[179],Re([1,0,22,74,36]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=void 0;function L(S){if(w.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function A(S,d,P,D,u,b,p,f){const i=Object.create(null);i["common.machineId"]=b,i.sessionID=(0,C.$3f)()+Date.now(),i.commitHash=D,i.version=u,i["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,w.$h)(w.$t),i["common.nodePlatform"]=F.$2d,i["common.nodeArch"]=P,i["common.product"]=f||"desktop",p&&(i["common.msftInternal"]=p);let t=0;const c=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>t++,enumerable:!0}}),w.$l&&(i["common.snap"]="true");const g=L(d);return g&&(i["common.platformDetail"]=g),i}e.$9n=A;function l(S){const d=F.env.USERDNSDOMAIN;if(!d)return!1;const P=d.toLowerCase();return S.some(D=>P===D)}e.$0n=l}),define(Ae[180],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=void 0,e.$8k=(0,w.$Ah)("telemetryService"),e.$9k=(0,w.$Ah)("customEndpointTelemetryService"),e.$0k="telemetry.currentSessionDate",e.$$k="telemetry.firstSessionDate",e.$_k="telemetry.lastSessionDate",e.$al="telemetry.machineId",e.$bl="telemetry",e.$cl="telemetry.telemetryLevel",e.$dl="telemetry.enableCrashReporter",e.$el="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var C;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Ae[52],Re([1,0,24,16,5,43,51,179,180]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=void 0;class d{constructor(y){this.value=y,this.isTrustedTelemetryValue=!0}}e.$$n=d;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$_n=P,e.$ao=new P;class D{async publicLog(y,m,I){}async publicLogError(y,m,I){}}e.$bo=D,e.$co="telemetry",e.$do="extensionTelemetryLog",e.$eo={log:()=>null,flush:()=>Promise.resolve(null)};function u(o,y){return C.Event.debounce(y.onDidChangeConfiguration,(I,k)=>{const r=I?new Set([...I.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:r}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,L.$0h)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$fo=u;function b(o,y){return!y.isBuilt&&!y.disableTelemetry?!0:!(y.disableTelemetry||!o.enableTelemetry||y.extensionTestsLocationURI)}e.$go=b;function p(o,y){return!(y.isBuilt||y.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$ho=p;function f(o){const y=o.getValue(S.$cl),m=o.getValue(S.$dl);if(o.getValue(S.$el)===!1||m===!1)return 0;switch(y??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$io=f;function i(o){const y={},m={},I={};g(o,I);for(let k in I){k=k.length>150?k.substr(k.length-149):k;const r=I[k];typeof r=="number"?m[k]=r:typeof r=="boolean"?m[k]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${r.length}`),y[k]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(y[k]=r)}return{properties:y,measurements:m}}e.$jo=i;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(o){if(!o)return"none";const y=(0,A.$Ok)(o);return t.has(y)?y:"other"}e.$ko=c;function g(o,y,m=0,I){if(o)for(const k of Object.getOwnPropertyNames(o)){const r=o[k],h=I?I+k:k;Array.isArray(r)?y[h]=(0,w.$Zm)(r):r instanceof Date?y[h]=r.toISOString():(0,F.$kf)(r)?m<2?g(r,y,m+1,h+"."):y[h]=(0,w.$Zm)(r):y[h]=r}}function E(o,y){const m=o.msftInternalDomains||[],I=y.getValue("telemetry.internalTesting");return(0,l.$0n)(m)||I}e.$lo=E;function $(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$mo=$;function s(o,y){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let m=o;const I=[];for(const v of y)for(;;){const R=v.exec(o);if(!R)break;I.push([R.index,v.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(m="";;){const v=r.exec(o);if(!v)break;const R=I.some(([W,V])=>v.index<V&&W<r.lastIndex);!k.test(v[0])&&!R&&(m+=o.substring(h,v.index)+"<REDACTED: user-file-path>",h=r.lastIndex)}return h<o.length&&(m+=o.substr(h)),m}function a(o){if(!o)return o;const y=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of y)if(m.regex.test(o))return`<REDACTED: ${m.label}>`;return o}function n(o,y){return(0,w.$Wm)(o,m=>{if(m instanceof d||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let I=m.replaceAll("%20"," ");I=s(I,y);for(const k of y)I=I.replace(k,"");return I=a(I),I}})}e.$no=n}),define(Ae[181],Re([1,0,15,92,20,22,2,9,74,52]),function(be,e,w,F,C,L,A,l,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;function P(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,w.$Ge)(n.id,o.id)===0}e.$oo=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(o){const y=o.manifest?o.manifest.version:o.version,m=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new u(o.identifier,y,m)}static parse(o){const y=D.exec(o);return y&&y[1]&&y[2]?new u({id:y[1]},y[2],y[4]||void 0):null}constructor(o,y,m="undefined"){this.version=y,this.targetPlatform=m,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof u?P(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$po=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(n){const o=b.exec(n);return o&&o[1]?[i(o[1]),o[2]]:[i(n),void 0]}e.$qo=p;function f(n,o){return`${n}.${o}`}e.$ro=f;function i(n){return n.toLowerCase()}e.$so=i;function t(n,o){return i(f(n??C.$Ql,o))}e.$to=t;function c(n,o){const y=[],m=I=>{for(const k of y)if(k.some(r=>P(o(r),o(I))))return k;return null};for(const I of n){const k=m(I);k?k.push(I):y.push([I])}return y}e.$uo=c;function g(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$vo=g;function E(n){return{id:new d.$$n(n.identifier.id),name:new d.$$n(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$wo=E,e.$xo=new C.$Ul("pprice.better-merge");function $(n,o){const y=[],m=o.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const I=m.shift();if(I&&y.every(k=>!P(k.identifier,{id:I}))){const k=n.filter(r=>P(r.identifier,{id:I}));k.length===1&&(y.push(k[0]),m.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return y}e.$yo=$;async function s(n,o){if(!L.$k)return!1;let y;try{y=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{y=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,l.$8)(I))}}return!!y&&(y.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,o){const y=await s(n,o),m=(0,F.$Tn)(y?"alpine":L.$t,S.$3d);return o.debug("ComputeTargetPlatform:",m),m}e.$zo=a}),define(Ae[182],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.$cr=e.$br=e.$ar=e.$_q=void 0;function w(S){return[...S.entries()]}e.$_q=w;function F(S){return S?[...S.entries()]:[]}e.$ar=F;function C(S){return new Map(S)}e.$br=C;function L(S){return new Map(S??[])}e.$cr=L;function A(S){return Array.from(S.entries()).map(d=>[d[0],w(d[1].map),F(d[1].descriptionMap)])}e.$dr=A;function l(S){return new Map(S.map(d=>[d[0],{map:C(d[1]),descriptionMap:L(d[2])}]))}e.$er=l}),define(Ae[183],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,L,A=5){const l=L(S=>{const d=typeof S=="string"?S:S.data;let P=this.a.get(C);if(P){P.data.push(d);return}const D=setTimeout(()=>this.flushBuffer(C),A);P={data:[d],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),l.dispose()}},this.a.set(C,P)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const L=this.a.get(C);L&&(this.a.delete(C),this.b(C,L.data.join("")))}}e.$Ikb=w}),define(Ae[184],Re([1,0,13,89,40,5,16,2,145,73,30]),function(be,e,w,F,C,L,A,l,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.IconFontDefinition=e.IconContribution=e.$7u=void 0,e.$7u={IconContribution:"base.contributions.icons"};var D;(function(E){function $(s,a){let n=s.defaults;for(;C.ThemeIcon.isThemeIcon(n);){const o=p.getIcon(n.id);if(!o)return;n=o.defaults}return n}E.getDefinition=$})(D||(e.IconContribution=D={}));var u;(function(E){function $(a){return{weight:a.weight,style:a.style,src:a.src.map(n=>({format:n.format,location:n.location.toString()}))}}E.toJSONObject=$;function s(a){const n=o=>(0,A.$if)(o)?o:void 0;if(a&&Array.isArray(a.src)&&a.src.every(o=>(0,A.$if)(o.format)&&(0,A.$if)(o.location)))return{weight:n(a.weight),style:n(a.style),src:a.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}E.fromJSONObject=s})(u||(e.IconFontDefinition=u={}));class b{constructor(){this.a=new L.$ed,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,S.localize)(0,null)},fontCharacter:{type:"string",description:(0,S.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon($,s,a,n){const o=this.b[$];if(o){if(a&&!o.description){o.description=a,this.d.properties[$].markdownDescription=`${a} $(${$})`;const I=this.e.enum.indexOf($);I!==-1&&(this.e.enumDescriptions[I]=a),this.a.fire()}return o}const y={id:$,description:a,defaults:s,deprecationMessage:n};this.b[$]=y;const m={$ref:"#/definitions/icons"};return n&&(m.deprecationMessage=n),a&&(m.markdownDescription=`${a}: $(${$})`),this.d.properties[$]=m,this.e.enum.push($),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:$}}deregisterIcon($){delete this.b[$],delete this.d.properties[$];const s=this.e.enum.indexOf($);s!==-1&&(this.e.enum.splice(s,1),this.e.enumDescriptions.splice(s,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map($=>this.b[$])}getIcon($){return this.b[$]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont($,s){const a=this.f[$];return a||(this.f[$]=s,this.a.fire(),s)}deregisterIconFont($){delete this.f[$]}getIconFont($){return this.f[$]}toString(){const $=(o,y)=>o.id.localeCompare(y.id),s=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(o=>this.b[o]);for(const o of n.filter(y=>!!y.description).sort($))a.push(`|<i class="${s(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const o of n.filter(y=>!C.ThemeIcon.isThemeIcon(y.defaults)).sort($))a.push(`|<i class="${s(o)}"></i>|${o.id}|`);return a.join(`
`)}}const p=new b;P.$7m.add(e.$7u.IconContribution,p);function f(E,$,s,a){return p.registerIcon(E,$,s,a)}e.$8u=f;function i(){return p}e.$9u=i;function t(){const E=(0,F.$Mj)();for(const $ in E){const s="\\"+E[$].toString(16);p.registerIcon($,{fontCharacter:s})}}t(),e.$0u="vscode://schemas/icons";const c=P.$7m.as(d.$8m.JSONContribution);c.registerSchema(e.$0u,p.getIconSchema());const g=new w.$Rg(()=>c.notifySchemaChanged(e.$0u),200);p.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.$$u=f("widget-close",F.$Oj.close,(0,S.localize)(2,null)),e.$_u=f("goto-previous-location",F.$Oj.arrowUp,(0,S.localize)(3,null)),e.$av=f("goto-next-location",F.$Oj.arrowDown,(0,S.localize)(4,null)),e.$bv=C.ThemeIcon.modify(F.$Oj.sync,"spin"),e.$cv=C.ThemeIcon.modify(F.$Oj.loading,"spin")}),define(Ae[185],Re([1,0,5,43,4,14]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.ProvidedOnAutoForward=e.$Xz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Wz=e.$Vz=void 0,e.$Vz=(0,C.$Ah)("tunnelService"),e.$Wz=(0,C.$Ah)("sharedTunnelsService");var A;(function(i){i.Http="http",i.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(l||(e.TunnelPrivacyId=l={}));function S(i){return!!i.forwardPort}e.$Xz=S;var d;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function P(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(t)return{address:t[1],port:+t[2]}}e.$Yz=P,e.$Zz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(i){return e.$Zz.indexOf(i)>=0}e.$1z=D,e.$2z=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(i){return e.$2z.indexOf(i)>=0}e.$3z=u;function b(i,t,c,g){if(c===1)return!1;if(c===2&&u(t)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(E?.length===4&&parseInt(E[1])>=18)return!1}return i<1024}e.$4z=b;class p{constructor(t,c,g){this.remoteAddress=t,this.localAddress=c,this.b=g,this.a=new w.$ed,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$5z=p;let f=class{constructor(t,c){this.j=t,this.k=c,this.a=new w.$ed,this.onTunnelOpened=this.a.event,this.b=new w.$ed,this.onTunnelClosed=this.b.event,this.c=new w.$ed,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const t=this.k.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.h=t.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const t=[],c=Array.from(this.e.values());for(const g of c){const E=Array.from(g.values());for(const $ of E){const s=await $.value;s&&typeof s!="string"&&t.push(s)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:c}of t.values())await c.then(g=>typeof g!="string"?g?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,c,g,E,$){this.p(t,c,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:c,localAddress:g,privacy:E,protocol:$,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,c){(u(t)||D(t))&&(t=e.$Zz[0]);const g=this.r(t,c);if(g)return++g.refcount,g.value}openTunnel(t,c,g,E,$,s=!1,a,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${g} on local port ${$}.`);const o=this.f??t;if(!o)return;if(c||(c="localhost"),E||(E=this.l),this.f&&this.i.has(g)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const y=this.s(o,c,g,E,$,s,a,n);return y?y.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,g),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,g);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(m);return(m.tunnelRemoteHost!==c||m.tunnelRemotePort!==g)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&m.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),y)}n(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const c=this.e.get(t.tunnelRemoteHost);if(c){const g=c.get(t.tunnelRemotePort);g&&(g.refcount--,await this.o(t.tunnelRemoteHost,t.tunnelRemotePort,g))}}}}async o(t,c,g){if(g.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${c}.`);const E=g.value.then(async $=>{$&&typeof $!="string"&&(await $.dispose(!0),this.b.fire({host:$.tunnelRemoteHost,port:$.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(c),E}}async closeTunnel(t,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${c} `);const g=this.e.get(t);if(g&&g.has(c)){const E=g.get(c);E.refcount=0,await this.o(t,c,E)}}p(t,c,g){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(c,{refcount:1,value:g})}async q(t,c){const g=this.e.get(t);if(g){const E=g.get(c),$=E?await E.value:void 0;(!$||typeof $=="string")&&g.delete(c),g.size===0&&this.e.delete(t)}}r(t,c){const g=[t];D(t)?(g.push(...e.$Zz),g.push(...e.$2z)):u(t)&&g.push(...e.$2z);const E=g.map($=>this.e.get($));for(const $ of E){const s=$?.get(c);if(s)return s}}canTunnel(t){return!!P(t)}t(t,c,g,E,$,s,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${g} on local port ${E}.`);const n=g;this.i.add(n);const o=E===void 0?g:E,y={elevationRequired:$?this.isPortPrivileged(o):!1},m={remoteAddress:{host:c,port:g},localAddressPort:E,privacy:s,public:s?s!==l.Private:void 0,protocol:a},I=t.forwardPort(m,y);return I?(this.p(c,g,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),I}};e.$6z=f,e.$6z=f=Ke([Ve(0,L.$4i),Ve(1,F.$7h)],f)}),define(Ae[186],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$7z=void 0,e.$7z=(0,w.$Ah)("editSessionIdentityService");var F;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Ae[187],Re([1,0,12]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=void 0;function F(S){return S.scheme!==w.Schemas.file&&S.scheme!==w.Schemas.vscodeRemote}e.$mJ=F;function C(S){if(S.folders.length)return S.folders.every(d=>F(d.uri))?S.folders[0].uri:void 0;if(S.configuration&&F(S.configuration))return S.configuration}e.$nJ=C;function L(S){return C(S)?.scheme}e.$oJ=L;function A(S){return C(S)?.authority}e.$pJ=A;function l(S){return C(S)!==void 0}e.$qJ=l}),define(Ae[53],Re([1,0,146,19,48,23,2,4,12]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.WorkbenchState=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=void 0,e.$Jh=(0,l.$Ah)("contextService");function d(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.uri)}e.$Kh=d;function P(o){return typeof o?.id=="string"&&!d(o)&&!u(o)}e.$Lh=P,e.$Mh={id:"ext-dev"},e.$Nh={id:"empty-window"};function D(o,y){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,F.$_d)(o)}:y?e.$Mh:e.$Nh;const m=o;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$Oh=D;function u(o){const y=o;return typeof y?.id=="string"&&A.URI.isUri(y.configPath)}e.$Ph=u;function b(o){const y=o;if(y?.uri)return{id:y.id,uri:A.URI.revive(y.uri)};const m=o;if(m?.configPath)return{id:m.id,configPath:A.URI.revive(m.configPath)};if(o?.id)return{id:o.id}}e.$Qh=b;var p;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function f(o){const y=o;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.$Rh=f;function i(o){const y=o;return!!(y&&typeof y=="object"&&A.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.$Sh=i;class t{constructor(y,m,I,k,r){this.h=y,this.j=I,this.k=k,this.l=r,this.c=C.$Gh.forUris(this.l,()=>!0),this.folders=m}update(y){this.h=y.id,this.k=y.configuration,this.j=y.transient,this.l=y.l,this.folders=y.folders}get folders(){return this.g}set folders(y){this.g=y,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(y){this.k=y}getFolder(y){return y&&this.c.findSubstr(y)||null}n(){this.c=C.$Gh.forUris(this.l,()=>!0);for(const y of this.folders)this.c.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Th=t;class c{constructor(y,m){this.raw=m,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,L.$hg)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Uh=c;function g(o){return new c({uri:o,index:0,name:(0,L.$dg)(o)},{uri:o.toString()})}e.$Vh=g,e.$Wh="code-workspace",e.$Xh=`.${e.$Wh}`,e.$Yh=[{name:(0,w.localize)(0,null),extensions:[e.$Wh]}],e.$Zh="workspace.json";function E(o,y){return L.$$f.isEqualOrParent(o,y.untitledWorkspacesHome)}e.$1h=E;function $(o){let y;return A.URI.isUri(o)?y=o:y=o.configuration,y?.scheme===S.Schemas.tmp}e.$2h=$,e.$3h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(o){return o.id===e.$3h}e.$4h=s;function a(o,y){return!E(o,y)&&!$(o)}e.$5h=a;function n(o){return(typeof o=="string"?(0,F.$ae)(o):(0,L.$fg)(o))===e.$Xh}e.$6h=n}),define(Ae[54],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oac=void 0;class w{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const L=this.c++;return this.b.set(L,C),this.e(),L}get(C,L){return this.b.has(C)?this.b.get(C)[L]:void 0}delete(C){this.b.delete(C),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Oac=w}),define(Ae[39],Re([1,0,12,23,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=e.$Qac=void 0;class L{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new F.$9f(l=>{const S=this.b.get(l.scheme);return!(S===void 0||S&1024)})}$acceptProviderInfos(l,S){S===null?this.b.delete(l.scheme):this.b.set(l.scheme,S)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$Qac=L,e.$Rac=(0,C.$Ah)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bM=void 0,e.$bM=(0,w.$Ah)("IExtHostInitDataService")}),define(Ae[188],Re([1,0,151,14,175,27]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;let A=class extends C.$iN{constructor(S,d,P){const D=P.remote.isRemote?"remoteexthost":S?"workerexthost":"exthost",u=P.remote.isRemote?(0,w.localize)(0,null):S?(0,w.localize)(1,null):(0,w.localize)(2,null);super(d.createLogger(D,{name:u}))}};e.$Xcc=A,e.$Xcc=A=Ke([Ve(1,F.$5i),Ve(2,L.$bM)],A)}),define(Ae[189],Re([1,0,13]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=e.$hbc=void 0;class F{constructor(A,l,S){this.h=new Map,this.a=A,this.b=l,this.c=S,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(d=>(this.f=d,this)),this.g=this.c.onDidChangeStorage(d=>{d.shared===this.b&&d.key===this.a&&(this.f=d.value)}),this.i=new w.$Rg(()=>{const d=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of d.values())P.complete()}catch(P){for(const D of d.values())D.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let S=this.f[A];return typeof S>"u"&&(S=l),S}update(A,l){this.f[A]=l;const S=this.h.get(A);if(S!==void 0)return S.p;const d=new w.$1g;return this.h.set(A,d),this.i.isScheduled()||this.i.schedule(),d.p}dispose(){this.g.dispose()}}e.$hbc=F;class C extends F{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$ibc=C}),define(Ae[190],Re([1,0,5,2]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcc=void 0;class C{constructor(A){this.c=A,this.a=new w.$ed,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$ed,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,S,d){const D=this.c.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(l.value,S,d);this.b.fire(D)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(F.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(F.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$Gcc=C}),define(Ae[17],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YL=e.$XL=void 0,e.$XL=(0,w.$Ah)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$YL=F}),define(Ae[191],Re([1,0,20,5]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=void 0;class C{#e;constructor(A,l){this.b=new F.$ed,this.onDidChange=this.b.event,this.a=w.$Ul.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(S=>{S.extensionId===this.a&&this.b.fire({key:S.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$tbc=C}),define(Ae[55],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=e.$2ac=void 0,e.$2ac=(0,w.$Ah)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$3ac=F}),define(Ae[192],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bb=e.$1bb=void 0;class F{constructor(){this.buffers=[]}add(S){let d=this.buffers.indexOf(S);return d<0&&(d=this.buffers.length,this.buffers.push(S)),d}}function C(l,S){if(S.serializeBuffersForPostMessage){const d=new F,D=JSON.stringify(l,(b,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:d.add(p)};if(ArrayBuffer.isView(p)){const f=L(p);if(f)return{$$vscode_array_buffer_reference$$:!0,index:d.add(p.buffer),view:{type:f,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),u=d.buffers.map(b=>{const p=new Uint8Array(b);return w.$Ed.wrap(p)});return{message:D,buffers:u}}else return{message:JSON.stringify(l),buffers:[]}}e.$1bb=C;function L(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,S){const d=S.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),P=S.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:f}=p,i=d[f];if(p.view)switch(p.view.type){case 1:return new Int8Array(i,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(i,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(i,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(i,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(i,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(i,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(i,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(i,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(i,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(i,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(i,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return i}return b}:void 0;return{message:JSON.parse(l,P),arrayBuffers:d}}e.$2bb=A}),define(Ae[99],Re([1,0,160,16,2,6,4,30,38,12,41,128,29]),function(be,e,w,F,C,L,A,l,S,d,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6E=e.$5E=e.$4E=e.EditorsOrder=e.$3E=e.CloseDirection=e.$2E=e.$1E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.EditorInputCapabilities=e.$RE=e.SaveReason=e.Verbosity=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$JE=e.$IE=e.$HE=e.$GE=e.$FE=void 0,e.$FE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$GE={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$HE="workbench.editor.sidebysideEditor",e.$IE="workbench.editors.textDiffEditor",e.$JE="workbench.editors.binaryResourceDiffEditor";var b;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var p;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function f(ce){const $e=ce;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$KE=f;function i(ce,$e,ie){for(const z of ie.visibleEditorPanes)if(z.group.id===$e&&ce.matches(z.input))return z.getViewState()}e.$LE=i;function t(ce){if(m(ce))return!1;const $e=ce;return C.URI.isUri($e?.resource)}e.$ME=t;function c(ce){if(m(ce))return!1;const $e=ce;return $e?.original!==void 0&&$e.modified!==void 0}e.$NE=c;function g(ce){if(m(ce)||c(ce))return!1;const $e=ce;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$OE=g;function E(ce){if(m(ce))return!1;const $e=ce;return $e?$e.resource===void 0||$e.resource.scheme===d.Schemas.untitled||$e.forceUntitled===!0:!1}e.$PE=E;function $(ce){if(m(ce))return!1;const $e=ce;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$QE=$;var s;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var a;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class n{constructor(){this.a=new Map}registerSource($e,ie){let z=this.a.get($e);return z||(z={source:$e,label:ie},this.a.set($e,z)),z.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$RE=new n;var o;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class y extends L.$jc{}e.$SE=y;function m(ce){return ce instanceof y}e.$TE=m;function I(ce){const $e=ce;return C.URI.isUri($e?.preferredResource)}function k(ce){const $e=ce;return m($e?.primary)&&m($e?.secondary)}e.$UE=k;function r(ce){const $e=ce;return m($e?.modified)&&m($e?.original)}e.$VE=r;function h(ce,$e,ie,z,q){return ye(z,[(0,D.$ki)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const le={...ie,limits:{size:Number.MAX_VALUE}};ce.openEditor($e,le)}}),(0,D.$ki)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$WE=h;function v(ce){return m(ce?.editor)}e.$XE=v;function R(ce){const $e=ce;return v(ce)&&$e?.group!==void 0}e.$YE=R;function W(ce){const $e=ce;return typeof $e?.groupId=="number"&&m($e.editor)}e.$ZE=W;var V;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var U;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LOCKED=2]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=3]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=4]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=5]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=7]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=9]="EDITOR_PIN",ce[ce.EDITOR_STICKY=10]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=11]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var B;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class O{getOriginalUri($e,ie){if(!$e)return;if($($e))return e.$2E.getOriginalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:le}=this.a($e);if(q&&le){if(ie?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===B.ANY)return this.getOriginalUri(q,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===B.PRIMARY?q:le}}if(c($e)||g($e)||$($e))return;const z=I($e)?$e.preferredResource:$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}a($e){return k($e)||g($e)?{primary:$e.primary,secondary:$e.secondary}:r($e)||c($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,ie){if(!$e)return;if($($e))return e.$2E.getCanonicalUri($e.result,ie);if(ie?.supportSideBySide){const{primary:q,secondary:le}=this.a($e);if(q&&le){if(ie?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===B.ANY)return this.getCanonicalUri(q,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:ie.filterByScheme});$e=ie.supportSideBySide===B.PRIMARY?q:le}}if(c($e)||g($e)||$($e))return;const z=$e.resource;return!z||!ie||!ie.filterByScheme?z:this.b(z,ie.filterByScheme)}b($e,ie){if(Array.isArray(ie)){if(ie.some(z=>$e.scheme===z))return $e}else if(ie===$e.scheme)return $e}}var N;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function ee(ce,$e,ie,z){if(!ce.isSticky($e))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return ie===N.MOUSE||ie===N.KEYBOARD;case"mouse":return ie===N.MOUSE;case"keyboard":return ie===N.KEYBOARD}return!1}e.$1E=ee,e.$2E=new O;var Y;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start($e){const ie=this.a=$e.get(A.$zh);for(const[z,q]of this.c)this.e(z,q,ie);this.c.clear()}e($e,ie,z){const q=z.createInstance(ie);this.d.set($e,q)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,F.$tf)(this.b)}registerEditorSerializer($e,ie){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,ie,this.a):this.c.set($e,ie),(0,L.$hc)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}l.$7m.add(e.$FE.EditorFactory,new Ee);async function ke(ce,$e,ie){return!ce||!ce.length?[]:await Promise.all(ce.map(async z=>{const q=C.URI.revive(z.fileUri);if(!q){ie.info("Cannot resolve the path because it is not valid.",z);return}if(!await $e.canHandleResource(q)){ie.info("Cannot resolve the path because it cannot be handled",z);return}let we=z.exists,ve=z.type;if(typeof we!="boolean"||typeof ve!="number")try{ve=(await $e.stat(q)).isDirectory?S.FileType.Directory:S.FileType.Unknown,we=!0}catch(De){ie.error(De),we=!1}if(!we&&z.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",z);return}if(ve===S.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",z);return}const me={...z.options,pinned:!0};return we?{resource:q,options:me}:{resource:q,options:me,forceUntitled:!0}}))}e.$3E=ke;var Pe;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function Z(ce){const $e=ce;if(!$e)return!1;const ie=$e;if(ie.modified)return Z(ie.modified);const z=$e;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$4E=Z;function ue(ce){return(0,P.$mi)(ce)}e.$5E=ue;function ye(ce,$e,ie){const z=(0,P.$ni)(ce,$e);return z.forceMessage=ie?.forceMessage,z.forceSeverity=ie?.forceSeverity,z.allowDialog=ie?.allowDialog,z}e.$6E=ye}),define(Ae[193],Re([1,0,5,161,4,6,28,30,18,100,24,89,184]),function(be,e,w,F,C,L,A,l,S,d,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$$E=e.$0E=e.ViewContentGroups=e.$9E=e.$8E=e.ViewContainerLocation=e.Extensions=e.$7E=void 0,e.$7E=(0,u.$8u)("default-view-icon",D.$Oj.window,(0,F.localize)(0,null));var b;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var p;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$8E=[0,1,2];function f(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$9E=f;class i extends L.$jc{constructor(){super(...arguments),this.c=this.B(new w.$ed),this.onDidRegister=this.c.event,this.f=this.B(new w.$ed),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,S.$Ob)([...this.g.values()])}registerViewContainer(o,y,m){const I=this.get(o.id);if(I)return I;const k=o;return k.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,A.$vi)(this.g,y,[]).push(k),m?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:y}),k}deregisterViewContainer(o){for(const y of this.g.keys()){const m=this.g.get(y),I=m?.indexOf(o);if(I!==-1){m?.splice(I,1),m.length===0&&this.g.delete(y),this.f.fire({viewContainer:o,viewContainerLocation:y});return}}}get(o){return this.all.filter(y=>y.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(y=>this.getViewContainers(y).filter(m=>m?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(y=>this.getViewContainerLocation(y)===o)}}l.$7m.add(b.ViewContainersRegistry,new i);var t;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(t||(e.ViewContentGroups=t={}));function c(n,o){const y=n.group??t.More,m=o.group??t.More;return y!==m?y.localeCompare(m):(n.order??5)-(o.order??5)}class g extends L.$jc{constructor(){super(...arguments),this.c=this.B(new w.$ed),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$ed),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$ed),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$ed),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new d.$L}registerViews(o,y){this.registerViews2([{views:o,viewContainer:y}])}registerViews2(o){o.forEach(({views:y,viewContainer:m})=>this.r(y,m)),this.c.fire(o)}deregisterViews(o,y){const m=this.s(o,y);m.length&&this.f.fire({views:m,viewContainer:y})}moveViews(o,y){for(const m of this.m.keys())if(m!==y){const I=this.s(o,m);I.length&&(this.r(I,y),this.g.fire({views:I,from:m,to:y}))}}getViews(o){return this.m.get(o)||[]}getView(o){for(const y of this.j){const m=(this.m.get(y)||[]).filter(I=>I.id===o)[0];if(m)return m}return null}getViewContainer(o){for(const y of this.j)if((this.m.get(y)||[]).filter(I=>I.id===o)[0])return y;return null}registerViewWelcomeContent(o,y){return this.n.add(o,y),this.h.fire(o),(0,L.$hc)(()=>{this.n.delete(o,y),this.h.fire(o)})}registerViewWelcomeContent2(o,y){const m=new Map;for(const[I,k]of y)this.n.add(o,k),m.set(I,(0,L.$hc)(()=>{this.n.delete(o,k),this.h.fire(o)}));return this.h.fire(o),m}getViewWelcomeContent(o){const y=[];return this.n.forEach(o,m=>y.push(m)),y.sort(c)}r(o,y){let m=this.m.get(y);m||(m=[],this.m.set(y,m),this.j.push(y));for(const I of o){if(this.getView(I.id)!==null)throw new Error((0,F.localize)(1,null,I.id));m.push(I)}}s(o,y){const m=this.m.get(y);if(!m)return[];const I=[],k=[];for(const r of m)o.includes(r)?I.push(r):k.push(r);return I.length&&(k.length?this.m.set(y,k):(this.m.delete(y),this.j.splice(this.j.indexOf(y),1))),I}}l.$7m.add(b.ViewsRegistry,new g),e.$0E=(0,C.$Ah)("viewsService"),e.$$E=(0,C.$Ah)("viewDescriptorService");var E;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(E||(e.ViewVisibilityState=E={}));var $;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})($||(e.TreeItemCollapsibleState=$={}));class s{constructor(o,y){this.c=!1,this.d=!1,(0,P.$Xm)(this,o),this.d=!!y,this.resolve=async m=>{if(y&&!this.c){const I=await y(m);I&&(this.tooltip=this.tooltip??I.tooltip,this.command=this.command??I.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$_E=s;class a extends Error{constructor(o){super((0,F.localize)(2,null,o)),this.name="NoTreeViewError"}static is(o){return o.name==="NoTreeViewError"}}e.$aF=a}),define(Ae[194],Re([1,0,5,13,162]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new w.$ed,this.n=new w.$ed,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,S,d,P){const D={command:l};if(S&&Object.keys(S).length>0&&(D.arguments=S),this.s("request",D),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const p={type:"response",seq:0,request_seq:D.seq,success:!1,command:l,message:(0,C.localize)(0,null,P,l)};b(p)}},P)}return d&&this.f.set(D.seq,d),D.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,S){return l.type!=="event"||S.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,F.$Gg)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const S=l,d=this.f.get(S.request_seq);d&&(this.f.delete(S.request_seq),d(S));break}}}}s(l,S){S.type=l,S.seq=this.d++,this.sendMessage(S)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((S,d)=>l.set(d,S)),await(0,F.$Gg)(500),l.forEach((S,d)=>{S({type:"response",seq:0,request_seq:d,success:!1,command:"canceled",message:"canceled"}),this.f.delete(d)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$ucb=L}),define(Ae[195],Re([1,0,163,32,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$mH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$lH=e.MemoryRangeType=e.$kH=e.State=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=void 0,e.$iG="workbench.view.debug",e.$jG="workbench.debug.variablesView",e.$kG="workbench.debug.watchExpressionsView",e.$lG="workbench.debug.callStackView",e.$mG="workbench.debug.loadedScriptsView",e.$nG="workbench.debug.breakPointsView",e.$oG="workbench.debug.disassemblyView",e.$pG="workbench.panel.repl",e.$qG="workbench.panel.repl.view",e.$rG=new F.$1i("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$sG=new F.$1i("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$tG=new F.$1i("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$uG="debugUx",e.$vG=new F.$1i(e.$uG,"default",{type:"string",description:w.localize(3,null)}),e.$wG=new F.$1i("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$xG=new F.$1i("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$yG=new F.$1i("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$zG=new F.$1i("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$AG=new F.$1i("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$BG=new F.$1i("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$CG=new F.$1i("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$DG=new F.$1i("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$EG=new F.$1i("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$FG=new F.$1i("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$GG=new F.$1i("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$HG=new F.$1i("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$IG=new F.$1i("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$JG=new F.$1i("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$KG=new F.$1i("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$LG=new F.$1i("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$MG=new F.$1i("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$NG=new F.$1i("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$OG=new F.$1i("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$PG=new F.$1i("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$QG=new F.$1i("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$RG=new F.$1i("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$SG=new F.$1i("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$TG=new F.$1i("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$UG=new F.$1i("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$VG=new F.$1i("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$WG=new F.$1i("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$XG=new F.$1i("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$YG=new F.$1i("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$ZG=new F.$1i("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$1G=new F.$1i("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$2G=new F.$1i("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$3G=new F.$1i("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$4G=new F.$1i("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$5G=new F.$1i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$6G=new F.$1i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$7G=new F.$1i("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$8G=new F.$1i("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$9G=new F.$1i("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$0G=new F.$1i("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$$G=new F.$1i("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$_G=new F.$1i("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$aH=new F.$1i("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$bH=new F.$1i("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$cH=new F.$1i("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$dH=new F.$1i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$eH=new F.$1i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const L=u=>w.localize(51,null,u);e.$fH=L,e.$gH="editor.contrib.debug",e.$hH="editor.contrib.breakpoint",e.$iH="debug",e.$jH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var A;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(A||(e.State=A={}));function l(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$kH=l;var S;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(S||(e.MemoryRangeType=S={})),e.$lH="vscode-debug-memory";var d;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var P;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$mH=(0,C.$Ah)("debugService");var D;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Ae[196],Re([1,0,15,2,19,24,12,44,21,18]),function(be,e,w,F,C,L,A,l,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=void 0;const P=/{([^}]+)}/g;function D(k,r,h){return k.replace(P,function(v,R){return r&&R.length>0&&R[0]!=="_"?v:h&&h.hasOwnProperty(R)?h[R]:v})}e.$hF=D;function u(k){const r={};for(const h of Object.keys(k))h.startsWith("!")||(r[h]=k[h]);return r}e.$iF=u;function b(k){return k.configuration.request==="attach"&&!p(k)&&(!k.parentSession||b(k.parentSession))}e.$jF=b;function p(k){let r=k.configuration.type;if(r)return r==="vslsShare"&&(r=k.configuration.adapterProxy.configuration.type),(0,w.$Le)(r,"extensionhost")||(0,w.$Le)(r,"pwa-extensionhost")?k:k.parentSession?p(k.parentSession):void 0}e.$kF=p;function f(k){return k.type&&(k.label||k.program||k.runtime)}e.$lF=f;function i(k,r,h){let v,R=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=W.exec(k);){const U=V.index+1,B=U+V[0].length;if(U<=r&&B>=h){v=V[0],R=U;break}}if(v){const U=/\w+/g;let B=null;for(;(B=U.exec(v))&&!(B.index+1+R+B[0].length>=h););B&&(v=v.substring(0,U.lastIndex))}return v?{start:R,end:R+v.length-1}:{start:0,end:0}}e.$mF=i;async function t(k,r,h,v){if(k.evaluatableExpressionProvider.has(r)){const R=k.evaluatableExpressionProvider.ordered(r),W=(0,d.$Eb)(await Promise.all(R.map(async V=>{try{return await V.provideEvaluatableExpression(r,h,v??S.CancellationToken.None)}catch{return}})));if(W.length>0){let V=W[0].expression;const U=W[0].range;return V||(V=r.getLineContent(h.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:V}}}else{const R=r.getLineContent(h.lineNumber),{start:W,end:V}=i(R,h.column,h.column),U=R.substring(W-1,V);return{matchingExpression:U,range:new l.$js(h.lineNumber,W,h.lineNumber,W+U.length)}}return null}e.$nF=t;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(k){return!!(k&&k.match(c))}e.$oF=g;function E(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(g(k.path))return F.URI.parse(k.path);if((0,C.$7d)(k.path))return F.URI.file(k.path)}return k.path}function $(k){if(typeof k.path=="object"){const r=F.URI.revive(k.path);if(r)return r.scheme===A.Schemas.file?r.fsPath:r.toString()}return k.path}function s(k,r){const h=r?E:$,v=(0,L.$Um)(k);return n(v,(R,W)=>{R&&W&&(W.path=h(W))}),v}e.$pF=s;function a(k,r){const h=r?E:$,v=(0,L.$Um)(k);return n(v,(R,W)=>{!R&&W&&(W.path=h(W))}),v}e.$qF=a;function n(k,r){switch(k.type){case"event":{const h=k;switch(h.event){case"output":r(!1,h.body.source);break;case"loadedSource":r(!1,h.body.source);break;case"breakpoint":r(!1,h.body.breakpoint.source);break;default:break}break}case"request":{const h=k;switch(h.command){case"setBreakpoints":r(!0,h.arguments.source);break;case"breakpointLocations":r(!0,h.arguments.source);break;case"source":r(!0,h.arguments.source);break;case"gotoTargets":r(!0,h.arguments.source);break;case"launchVSCode":h.arguments.args.forEach(v=>r(!1,v));break;default:break}break}case"response":{const h=k;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(v=>r(!1,v.source));break;case"loadedSources":h.body.sources.forEach(v=>r(!1,v));break;case"scopes":h.body.scopes.forEach(v=>r(!1,v.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(v=>r(!1,v.source));break;case"setBreakpoints":h.body.breakpoints.forEach(v=>r(!1,v.source));break;case"disassemble":h.body?.instructions.forEach(R=>r(!1,R.location));break;default:break}break}}}function o(k){return k.filter(r=>!r.presentation?.hidden).sort((r,h)=>r.presentation?h.presentation?r.presentation.group?h.presentation.group?r.presentation.group!==h.presentation.group?r.presentation.group.localeCompare(h.presentation.group):y(r.presentation.order,h.presentation.order):-1:h.presentation.group?1:y(r.presentation.order,h.presentation.order):-1:h.presentation?1:0)}e.$rF=o;function y(k,r){return typeof k!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:k-r}async function m(k,r){const h=k.getValue("debug.saveBeforeStart",{overrideIdentifier:r.activeTextEditorLanguageId});if(h!=="none"&&(await r.saveAll(),h==="allEditorsInActiveGroup")){const v=r.activeEditorPane;v&&v.input.resource?.scheme===A.Schemas.untitled&&await r.save({editor:v.input,groupId:v.group.id})}await k.reloadConfiguration()}e.$sF=m;const I=(k,r)=>!k||!r?k===r:k.name===r.name&&k.path===r.path&&k.sourceReference===r.sourceReference;e.$tF=I}),define(Ae[75],Re([1,0,25,37,66,67,12,19,22,32]),function(be,e,w,F,C,L,A,l,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5H=e.$4H=e.$3H=e.$2H=e.CellStatusbarAlignment=e.$1H=e.$ZH=e.$YH=e.NotebookEditorPriority=e.$XH=e.$WH=e.$VH=e.$UH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$TH=e.$SH=e.$RH=e.$QH=e.CellKind=e.$PH=e.$OH=e.$NH=void 0,e.$NH="workbench.editor.notebook",e.$OH="workbench.editor.notebookTextDiffEditor",e.$PH="workbench.editor.interactive";var P;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(P||(e.CellKind=P={})),e.$QH=["application/json","application/javascript","text/html","image/svg+xml",L.$Gr.latex,L.$Gr.markdown,"image/png","image/jpeg",L.$Gr.text],e.$RH=[L.$Gr.latex,L.$Gr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Gr.text],e.$SH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$TH="_notAvailable";var D;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var u;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var b;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var p;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var f;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var i;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(i||(e.NotebookCellsChangeType=i={}));var t;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var c;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var g;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const ee=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${ee.join("")}]+`),Ee=7;function ke($e,ie){const z=ie.toString(Ee),le=`${z.length<ee.length?ee[z.length-1]:"z"}${z}s${(0,w.$Yd)(w.$Ed.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:N.scheme,fragment:le})}N.generate=ke;function Pe($e){if($e.scheme!==N.scheme)return;const ie=$e.fragment.indexOf("s");if(ie<0)return;const z=parseInt($e.fragment.substring(0,ie).replace(Y,""),Ee),q=(0,w.$Xd)($e.fragment.substring(ie+1)).toString();if(!isNaN(z))return{handle:z,notebook:$e.with({scheme:q,fragment:null})}}N.parse=Pe;function Z($e,ie){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ie??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}N.generateCellOutputUri=Z;function ue($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ie=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!ie)return;const z=ie[1]&&ie[1]!==""?ie[1]:void 0,q=ie[2];return{outputId:z,notebook:$e.with({scheme:q||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=ue;function ye($e,ie,z){return N.generate($e,ie).with({scheme:z})}N.generateCellPropertyUri=ye;function ce($e,ie){if($e.scheme===ie)return N.parse($e.with({scheme:N.scheme}))}N.parseCellPropertyUri=ce})(g||(e.CellUri=g={}));const E=N=>S.$i?N.replace(/\//g,"\\"):N;class ${constructor(ee=[],Y=e.$QH){this.e=Y,this.d=[...new Set(ee)].map(Ee=>({pattern:Ee,matches:F.$qj(E(Ee))}))}sort(ee){const Y=new Map(C.Iterable.map(ee,ke=>[ke,E(ke)]));let Ee=[];for(const{matches:ke}of this.d)for(const[Pe,Z]of Y)if(ke(Z)){Ee.push(Pe),Y.delete(Pe);break}return Y.size&&(Ee=Ee.concat([...Y.keys()].sort((ke,Pe)=>this.e.indexOf(ke)-this.e.indexOf(Pe)))),Ee}prioritize(ee,Y){const Ee=this.f(ee);if(Ee===-1){this.d.unshift({pattern:ee,matches:F.$qj(E(ee))});return}const ke=new Set(Y.map(Z=>this.f(Z,Ee)));ke.delete(-1);const Pe=Array.from(ke).sort();this.d.splice(Ee+1,0,...Pe.map(Z=>this.d[Z]));for(let Z=Pe.length-1;Z>=0;Z--)this.d.splice(Pe[Z],1)}toArray(){return this.d.map(ee=>ee.pattern)}f(ee,Y=this.d.length){const Ee=E(ee);for(let ke=0;ke<Y;ke++)if(this.d[ke].matches(Ee))return ke;return-1}}e.$UH=$;function s(N,ee,Y,Ee=(ke,Pe)=>ke===Pe){const ke=[];function Pe(ye,ce,$e){if(ce===0&&$e.length===0)return;const ie=ke[ke.length-1];ie&&ie.start+ie.deleteCount===ye?(ie.deleteCount+=ce,ie.toInsert.push(...$e)):ke.push({start:ye,deleteCount:ce,toInsert:$e})}let Z=0,ue=0;for(;;){if(Z===N.length){Pe(Z,0,ee.slice(ue));break}if(ue===ee.length){Pe(Z,N.length-Z,[]);break}const ye=N[Z],ce=ee[ue];if(Ee(ye,ce)){Z+=1,ue+=1;continue}Y(ce)?(Pe(Z,1,[]),Z+=1):(Pe(Z,0,[ce]),ue+=1)}return ke}e.$VH=s,e.$WH=new d.$1i("notebookEditorCursorAtBoundary","none"),e.$XH=new d.$1i("notebookEditorCursorAtLineBoundary","none");var a;(function(N){N.default="default",N.option="option"})(a||(e.NotebookEditorPriority=a={}));function n(N){const ee=N;return!!((typeof ee.include=="string"||F.$rj(ee.include))&&(typeof ee.exclude=="string"||F.$rj(ee.exclude)))}e.$YH=n;function o(N,ee,Y){if(Array.isArray(N.viewType)&&N.viewType.indexOf(ee)>=0||N.viewType===ee)return!0;if(N.filenamePattern){const Ee=n(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,ke=n(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(F.$pj(Ee,(0,l.$_d)(Y.fsPath).toLowerCase()))return!(ke&&F.$pj(ke,(0,l.$_d)(Y.fsPath).toLowerCase()))}return!1}e.$ZH=o,e.$1H={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols"};var y;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class m{static{this.d="notebook/"}static create(ee){return`${m.d}${ee}`}static parse(ee){if(ee.startsWith(m.d))return ee.substring(m.d.length)}}e.$2H=m;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$3H=I;const k=new TextDecoder;function r(N){const ee=[];let Y=!1;for(const Z of N)(ee.length===0||Y)&&(ee.push(Z),Y=!0);let Ee=R(ee);const ke=w.$Ed.concat(ee.map(Z=>w.$Ed.wrap(Z))),Pe=O(ke);return Ee=Ee||Pe.byteLength!==ke.byteLength,{data:Pe,didCompression:Ee}}e.$4H=r,e.$5H=`${String.fromCharCode(27)}[A`;const h=e.$5H.split("").map(N=>N.charCodeAt(0)),v=10;function R(N){let ee=!1;return N.forEach((Y,Ee)=>{if(Ee===0||Y.length<e.$5H.length)return;const ke=N[Ee-1],Pe=Y.subarray(0,e.$5H.length);if(Pe[0]===h[0]&&Pe[1]===h[1]&&Pe[2]===h[2]){const Z=ke.lastIndexOf(v);if(Z===-1)return;ee=!0,N[Ee-1]=ke.subarray(0,Z),N[Ee]=Y.subarray(e.$5H.length)}}),ee}function W(N){let ee=N;do N=ee,ee=N.replace(/[^\n]\x08/gm,"");while(ee.length<N.length);return N}function V(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const ee=N.match(/^(.*)\r+/m)[1];let Y=N.match(/\r+(.*)$/m)[1];Y=Y+ee.slice(Y.length,ee.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return N}const U="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(N){return!N.buffer.includes(U)&&!N.buffer.includes(B)?N:w.$Ed.fromString(V(W(k.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,9,49,28,67,15,16,2,36,20,38,97,75]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p){"use strict";var f,i,t,c,g,E,$,s,a,n,o,y,m,I,k,r,h,v;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$ML=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.TestRunProfileKind=e.TestResultState=e.$tL=e.$sL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$rL=e.$qL=e.$pL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$oL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.ColorThemeKind=e.$iL=e.$hL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$gL=e.DebugConsoleMode=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$aL=e.$_K=e.FileChangeType=e.$$K=e.$0K=e.$9K=e.$8K=e.InlineCompletionTriggerKind=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.ConfigurationTarget=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$KK=e.ViewBadge=e.ProgressLocation=e.$JK=e.$IK=e.TaskScope=e.ShellQuoting=e.$HK=e.$GK=e.$FK=e.TaskPanelKind=e.TaskRevealKind=e.$EK=e.TerminalLocation=e.$DK=e.$CK=e.$BK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$AK=e.$zK=e.$yK=e.$xK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$wK=e.StatusBarAlignment=e.ViewColumn=e.$vK=e.$uK=e.$tK=e.$sK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$rK=e.$qK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.LanguageStatusSeverity=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.CodeActionTriggerKind=e.$dK=e.$cK=e.SymbolTag=e.SymbolKind=e.$bK=e.DocumentHighlightKind=e.$aK=e.$_J=e.$$J=e.$0J=e.DiagnosticSeverity=e.DiagnosticTag=e.$9J=e.$8J=e.FileEditType=e.$7J=e.$6J=e.$5J=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function R(j){return Object.assign(j,{apply:function(...re){if(re.length===0)return Reflect.construct(j,[]);{const Se=re.length===1?[]:re[1];return Reflect.construct(j,Se,re[0].constructor)}},call:function(...re){if(re.length===0)return Reflect.construct(j,[]);{const[Se,...Je]=re;return Reflect.construct(j,Je,Se.constructor)}}})}var W;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var V;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let U=f=class{static from(...T){let re=T;return new f(function(){if(re){for(const Se of re)Se&&typeof Se.dispose=="function"&&Se.dispose();re=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$XJ=U,e.$XJ=U=f=Ke([R],U);let B=i=class{static Min(...T){if(T.length===0)throw new TypeError;let re=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isBefore(re)&&(re=Je)}return re}static Max(...T){if(T.length===0)throw new TypeError;let re=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isAfter(re)&&(re=Je)}return re}static isPosition(T){if(!T)return!1;if(T instanceof i)return!0;const{line:re,character:Se}=T;return typeof re=="number"&&typeof Se=="number"}static of(T){if(T instanceof i)return T;if(this.isPosition(T))return new i(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,re){if(T<0)throw(0,F.$5)("line must be non-negative");if(re<0)throw(0,F.$5)("character must be non-negative");this.c=T,this.e=re}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,re=0){if(T===null||re===null)throw(0,F.$5)();let Se;return typeof T>"u"?Se=0:typeof T=="number"?Se=T:(Se=typeof T.lineDelta=="number"?T.lineDelta:0,re=typeof T.characterDelta=="number"?T.characterDelta:0),Se===0&&re===0?this:new i(this.line+Se,this.character+re)}with(T,re=this.character){if(T===null||re===null)throw(0,F.$5)();let Se;return typeof T>"u"?Se=this.line:typeof T=="number"?Se=T:(Se=typeof T.line=="number"?T.line:this.line,re=typeof T.character=="number"?T.character:this.character),Se===this.line&&re===this.character?this:new i(Se,re)}toJSON(){return{line:this.line,character:this.character}}};e.$YJ=B,e.$YJ=B=i=Ke([R],B);let O=t=class{static isRange(T){return T instanceof t?!0:T?B.isPosition(T.start)&&B.isPosition(T.end):!1}static of(T){if(T instanceof t)return T;if(this.isRange(T))return new t(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,re,Se,Je){let Ye,ot;if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"?(Ye=new B(T,re),ot=new B(Se,Je)):B.isPosition(T)&&B.isPosition(re)&&(Ye=B.of(T),ot=B.of(re)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(T){return t.isRange(T)?this.contains(T.start)&&this.contains(T.end):B.isPosition(T)?!(B.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const re=B.Max(T.start,this.c),Se=B.Min(T.end,this.e);if(!re.isAfter(Se))return new t(re,Se)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const re=B.Min(T.start,this.c),Se=B.Max(T.end,this.end);return new t(re,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,re=this.end){if(T===null||re===null)throw(0,F.$5)();let Se;return T?B.isPosition(T)?Se=T:(Se=T.start||this.start,re=T.end||this.end):Se=this.start,Se.isEqual(this.c)&&re.isEqual(this.end)?this:new t(Se,re)}toJSON(){return[this.start,this.end]}};e.$ZJ=O,e.$ZJ=O=t=Ke([R],O);let N=c=class extends O{static isSelection(T){return T instanceof c?!0:T?O.isRange(T)&&B.isPosition(T.anchor)&&B.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,re,Se,Je){let Ye,ot;if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"?(Ye=new B(T,re),ot=new B(Se,Je)):B.isPosition(T)&&B.isPosition(re)&&(Ye=B.of(T),ot=B.of(re)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$1J=N,e.$1J=N=c=Ke([R],N);const ee=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,F.$5)("connectionToken")};class Y{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,re,Se){if(typeof T!="string"||T.length===0)throw(0,F.$5)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,F.$5)("port");typeof Se<"u"&&ee(Se),this.host=T,this.port=Math.round(re),this.connectionToken=Se}}e.$2J=Y;class Ee{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,re){this.makeConnection=T,this.connectionToken=re,typeof re<"u"&&ee(re)}}e.$3J=Ee;class ke extends Error{static NotAvailable(T,re){return new ke(T,b.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(T){return new ke(T,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,re=b.RemoteAuthorityResolverErrorCode.Unknown,Se){super(T),this._message=T,this._code=re,this._detail=Se,Object.setPrototypeOf(this,ke.prototype)}}e.$4J=ke;var Pe;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var Z;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let ue=g=class{static isTextEdit(T){return T instanceof g?!0:T?O.isRange(T)&&typeof T.newText=="string":!1}static replace(T,re){return new g(T,re)}static insert(T,re){return g.replace(new O(T,T),re)}static delete(T){return g.replace(T,"")}static setEndOfLine(T){const re=new g(new O(new B(0,0),new B(0,0)),"");return re.newEol=T,re}get range(){return this.c}set range(T){if(T&&!O.isRange(T))throw(0,F.$5)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,F.$5)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,F.$5)("newEol");this.f=T}constructor(T,re){this.c=T,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$5J=ue,e.$5J=ue=g=Ke([R],ue);let ye=E=class{static isNotebookCellEdit(T){return T instanceof E?!0:T?Zt.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,re){return new E(T,re)}static insertCells(T,re){return new E(new Zt(T,T),re)}static deleteCells(T){return new E(T,[])}static updateCellMetadata(T,re){const Se=new E(new Zt(T,T),[]);return Se.newCellMetadata=re,Se}static updateNotebookMetadata(T){const re=new E(new Zt(0,0),[]);return re.newNotebookMetadata=T,re}constructor(T,re){this.range=T,this.newCells=re}};e.$6J=ye,e.$6J=ye=E=Ke([R],ye);class ce{static isSnippetTextEdit(T){return T instanceof ce?!0:T?O.isRange(T.range)&&z.isSnippetString(T.snippet):!1}static replace(T,re){return new ce(T,re)}static insert(T,re){return ce.replace(new O(T,T),re)}constructor(T,re){this.range=T,this.snippet=re}}e.$7J=ce;var $e;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,re,Se,Je){this.c.push({_type:1,from:T,to:re,options:Se,metadata:Je})}createFile(T,re,Se){this.c.push({_type:1,from:void 0,to:T,options:re,metadata:Se})}deleteFile(T,re,Se){this.c.push({_type:1,from:T,to:void 0,options:re,metadata:Se})}e(T,re,Se){this.c.push({_type:3,metadata:Se,uri:T,edit:{editType:5,metadata:re},notebookMetadata:re})}f(T,re,Se,Je){const Ye=re.start,ot=re.end;(Ye!==ot||Se.length>0)&&this.c.push({_type:5,uri:T,index:Ye,count:ot-Ye,cells:Se,metadata:Je})}g(T,re,Se,Je){this.c.push({_type:3,metadata:Je,uri:T,edit:{editType:3,index:re,metadata:Se}})}replace(T,re,Se,Je){this.c.push({_type:2,uri:T,edit:new ue(re,Se),metadata:Je})}insert(T,re,Se,Je){this.replace(T,new O(re,re),Se,Je)}delete(T,re,Se){this.replace(T,re,"",Se)}has(T){return this.c.some(re=>re._type===2&&re.uri.toString()===T.toString())}set(T,re){if(re)for(const Se of re){if(!Se)continue;let Je,Ye;Array.isArray(Se)?(Je=Se[0],Ye=Se[1]):Je=Se,ye.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(T,Je.range.start,Je.newCellMetadata,Ye):Je.newNotebookMetadata?this.e(T,Je.newNotebookMetadata,Ye):this.f(T,Je.range,Je.newCells,Ye):ce.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:T,range:Je.range,edit:Je.snippet,metadata:Ye}):this.c.push({_type:2,uri:T,edit:Je,metadata:Ye})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===T.toString()&&(this.c[Se]=void 0);break}}(0,w.$Fb)(this.c)}}get(T){const re=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===T.toString()&&re.push(Se.edit);return re}entries(){const T=new L.$yi;for(const re of this.c)if(re._type===2){let Se=T.get(re.uri);Se||(Se=[re.uri,[]],T.set(re.uri,Se)),Se[1].push(re.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$8J=ie,e.$8J=ie=Ke([R],ie);let z=$=class{static isSnippetString(T){return T instanceof $?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=$.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,re=this.e++){if(typeof T=="function"){const Se=new $;Se.e=this.e,T(Se),this.e=Se.e,T=Se.value}else T=$.c(T);return this.value+="${",this.value+=re,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,re=this.e++){const Se=T.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(T,re){if(typeof re=="function"){const Se=new $;Se.e=this.e,re(Se),this.e=Se.e,re=Se.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$9J=z,e.$9J=z=$=Ke([R],z);var q;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(q||(e.DiagnosticTag=q={}));var le;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let we=s=class{static isLocation(T){return T instanceof s?!0:T?O.isRange(T.range)&&d.URI.isUri(T.uri):!1}constructor(T,re){if(this.uri=T,re)if(O.isRange(re))this.range=O.of(re);else if(B.isPosition(re))this.range=new O(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$0J=we,e.$0J=we=s=Ke([R],we);let ve=class{static is(T){return T?typeof T.message=="string"&&T.location&&O.isRange(T.location.range)&&d.URI.isUri(T.location.uri):!1}constructor(T,re){this.location=T,this.message=re}static isEqual(T,re){return T===re?!0:!T||!re?!1:T.message===re.message&&T.location.range.isEqual(re.location.range)&&T.location.uri.toString()===re.location.uri.toString()}};e.$$J=ve,e.$$J=ve=Ke([R],ve);let me=class{constructor(T,re,Se=le.Error){if(!O.isRange(T))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=T,this.message=re,this.severity=Se}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,re){return T===re?!0:!T||!re?!1:T.message===re.message&&T.severity===re.severity&&T.code===re.code&&T.severity===re.severity&&T.source===re.source&&T.range.isEqual(re.range)&&(0,w.$sb)(T.tags,re.tags)&&(0,w.$sb)(T.relatedInformation,re.relatedInformation,ve.isEqual)}};e.$_J=me,e.$_J=me=Ke([R],me);let De=class{constructor(T,re){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=re}};e.$aK=De,e.$aK=De=Ke([R],De);var ne;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let he=class{constructor(T,re=ne.Text){this.range=T,this.kind=re}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$bK=he,e.$bK=he=Ke([R],he);var se;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(se||(e.SymbolKind=se={}));var oe;(function(j){j[j.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let fe=a=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,re,Se,Je,Ye){this.name=T,this.kind=re,this.containerName=Ye,typeof Se=="string"&&(this.containerName=Se),Je instanceof we?this.location=Je:Se instanceof O&&(this.location=new we(Je,Se)),a.validate(this)}toJSON(){return{name:this.name,kind:se[this.kind],location:this.location,containerName:this.containerName}}};e.$cK=fe,e.$cK=fe=a=Ke([R],fe);let Ie=n=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(n.validate)}constructor(T,re,Se,Je,Ye){this.name=T,this.detail=re,this.kind=Se,this.range=Je,this.selectionRange=Ye,this.children=[],n.validate(this)}};e.$dK=Ie,e.$dK=Ie=n=Ke([R],Ie);var M;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(M||(e.CodeActionTriggerKind=M={}));let K=class{constructor(T,re){this.title=T,this.kind=re}};e.$eK=K,e.$eK=K=Ke([R],K);let G=class{static{o=this}static{this.c="."}constructor(T){this.value=T}append(T){return new o(this.value?this.value+o.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+o.c)}};e.$fK=G,e.$fK=G=o=Ke([R],G);class X extends G{constructor(T){super(T),this.value=T}}e.$gK=X,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let J=class{constructor(T,re){if(this.range=T,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$hK=J,e.$hK=J=Ke([R],J);class x{constructor(T,re,Se,Je,Ye,ot){this.kind=T,this.name=re,this.detail=Se,this.uri=Je,this.range=Ye,this.selectionRange=ot}}e.$iK=x;class ae{constructor(T,re){this.fromRanges=re,this.from=T}}e.$jK=ae;class Le{constructor(T,re){this.fromRanges=re,this.to=T}}e.$kK=Le;var je;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(je||(e.LanguageStatusSeverity=je={}));let Xe=class{constructor(T,re){this.range=T,this.command=re}get isResolved(){return!!this.command}};e.$lK=Xe,e.$lK=Xe=Ke([R],Xe);let He=y=class{#e;static isMarkdownString(T){return T instanceof y?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,re=!1){this.#e=new C.$Wj(T,{supportThemeIcons:re})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,re){return this.#e.appendCodeblock(re??"",T),this}};e.$mK=He,e.$mK=He=y=Ke([R],He);let et=class{constructor(T,re){this.label=T,this.documentation=re}};e.$nK=et,e.$nK=et=Ke([R],et);let Ze=class{constructor(T,re){this.label=T,this.documentation=re,this.parameters=[]}};e.$oK=Ze,e.$oK=Ze=Ke([R],Ze);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$pK=_e,e.$pK=_e=Ke([R],_e);var it;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var tt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let ze=class{constructor(T){this.value=T}};e.$qK=ze,e.$qK=ze=Ke([R],ze);let st=class{constructor(T,re,Se){this.position=T,this.label=re,this.kind=Se}};e.$rK=st,e.$rK=st=Ke([R],st);var _;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(_||(e.CompletionTriggerKind=_={}));var Q;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Q||(e.CompletionItemKind=Q={}));var pe;(function(j){j[j.Deprecated=1]="Deprecated"})(pe||(e.CompletionItemTag=pe={}));let Ue=class{constructor(T,re){this.label=T,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Q[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$sK=Ue,e.$sK=Ue=Ke([R],Ue);let Ne=class{constructor(T=[],re=!1){this.items=T,this.isIncomplete=re}};e.$tK=Ne,e.$tK=Ne=Ke([R],Ne);let Qe=class{constructor(T,re,Se){this.insertText=T,this.range=re,this.command=Se}};e.$uK=Qe,e.$uK=Qe=Ke([R],Qe);let nt=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$vK=nt,e.$vK=nt=Ke([R],nt);var gt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(gt||(e.ViewColumn=gt={}));var vt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Mt(j,T){return`${D.$Ul.toKey(j)}.${T}`}e.$wK=Mt;var Qt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var Vt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var wt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(wt||(e.TextEditorRevealType=wt={}));var Tt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Ot;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Ot||(e.TextDocumentChangeReason=Ot={}));var Jt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(j){function T(re){switch(re){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=T}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));let Pt=class{constructor(T,re){if(re&&!d.URI.isUri(re))throw(0,F.$5)("target");if(!O.isRange(T)||T.isEmpty)throw(0,F.$5)("range");this.range=T,this.target=re}};e.$xK=Pt,e.$xK=Pt=Ke([R],Pt);let At=class{constructor(T,re,Se,Je){this.red=T,this.green=re,this.blue=Se,this.alpha=Je}};e.$yK=At,e.$yK=At=Ke([R],At);let Nt=class{constructor(T,re){if(re&&!(re instanceof At))throw(0,F.$5)("color");if(!O.isRange(T)||T.isEmpty)throw(0,F.$5)("range");this.range=T,this.color=re}};e.$zK=Nt,e.$zK=Nt=Ke([R],Nt);let Ut=class{constructor(T){if(!T||typeof T!="string")throw(0,F.$5)("label");this.label=T}};e.$AK=Ut,e.$AK=Ut=Ke([R],Ut);var qt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Bt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var at;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(T,re,Se){if(this.startIndex=T,this.length=re,this.tooltip=Se,typeof T!="number"||T<0)throw(0,F.$5)("startIndex");if(typeof re!="number"||re<1)throw(0,F.$5)("length");if(Se!==void 0&&typeof Se!="string")throw(0,F.$5)("tooltip")}}e.$BK=ut;class Ht{constructor(T){this.uri=T}}e.$CK=Ht;class Ct{constructor(T){this.terminalCommand=T}}e.$DK=Ct;var kt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ht{constructor(T){if(this.options=T,typeof T!="object")throw(0,F.$5)("options")}}e.$EK=ht;var St;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(St||(e.TaskRevealKind=St={}));var Lt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Lt||(e.TaskPanelKind=Lt={}));let Et=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(T){switch(T){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(T,re){if(this.label=re,typeof T!="string"||typeof re!="string")throw(0,F.$5)("name");this.c=T}get id(){return this.c}};e.$FK=Et,e.$FK=Et=m=Ke([R],Et);function qe(j){let T="";for(let re=0;re<j.length;re++)T+=j[re].replace(/,/g,",,")+",";return T}let zt=class{constructor(T,re,Se){if(typeof T!="string")throw(0,F.$5)("process");this.e=[],this.c=T,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=Se):this.f=re)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,F.$5)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const re of this.e)T.push(re);return qe(T)}};e.$GK=zt,e.$GK=zt=Ke([R],zt);let Ce=class{constructor(T,re,Se){if(this.f=[],Array.isArray(re)){if(!T)throw(0,F.$5)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,F.$5)("command");this.e=T,this.f=re,this.g=Se}else{if(typeof T!="string")throw(0,F.$5)("commandLine");this.c=T,this.g=re}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,F.$5)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,F.$5)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)T.push(typeof re=="string"?re:re.value);return qe(T)}};e.$HK=Ce,e.$HK=Ce=Ke([R],Ce);var Fe;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Fe||(e.ShellQuoting=Fe={}));var ge;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ge||(e.TaskScope=ge={}));class H{constructor(T){this.c=T}computeId(){return"customExecution"+(0,P.$3f)()}set callback(T){this.c=T}get callback(){return this.c}}e.$IK=H;let Me=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,re,Se,Je,Ye,ot){this.j=!1,this.k=this.definition=T;let lt;typeof re=="string"?(this.m=this.name=re,this.t=this.source=Se,this.execution=Je,lt=Ye,this.j=!0):re===ge.Global||re===ge.Workspace?(this.target=re,this.m=this.name=Se,this.t=this.source=Je,this.execution=Ye,lt=ot):(this.target=re,this.m=this.name=Se,this.t=this.source=Je,this.execution=Ye,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(T){this.h=T}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof zt?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof Ce?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof H?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,P.$3f)()}}get definition(){return this.k}set definition(T){if(T==null)throw(0,F.$5)("Kind can't be undefined or null");this.y(),this.k=T}get scope(){return this.l}set target(T){this.y(),this.l=T}get name(){return this.m}set name(T){if(typeof T!="string")throw(0,F.$5)("name");this.y(),this.m=T}get execution(){return this.n}set execution(T){T===null&&(T=void 0),this.y(),this.n=T;const re=this.k.type;(I.g===re||I.e===re||I.f===re||I.c===re)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(T){if(Array.isArray(T))this.y(),this.o=T,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.y(),this.r=T}get source(){return this.t}set source(T){if(typeof T!="string"||T.length===0)throw(0,F.$5)("source must be a string of length > 0");this.y(),this.t=T}get group(){return this.u}set group(T){T===null&&(T=void 0),this.y(),this.u=T}get detail(){return this.x}set detail(T){T===null&&(T=void 0),this.x=T}get presentationOptions(){return this.v}set presentationOptions(T){T==null&&(T=Object.create(null)),this.y(),this.v=T}get runOptions(){return this.w}set runOptions(T){T==null&&(T=Object.create(null)),this.y(),this.w=T}};e.$JK=Me,e.$JK=Me=I=Ke([R],Me);var Be;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Be||(e.ProgressLocation=Be={}));var Ge;(function(j){function T(re){const Se=re;return(0,S.$mf)(Se.value)?Se.tooltip&&!(0,S.$if)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=T})(Ge||(e.ViewBadge=Ge={}));let We=k=class{static isTreeItem(T,re){const Se=T;if(Se.checkboxState!==void 0){const Je=(0,S.$mf)(Se.checkboxState)?Se.checkboxState:(0,S.$kf)(Se.checkboxState)&&(0,S.$mf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,Ye=!(0,S.$mf)(Se.checkboxState)&&(0,S.$kf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==pt.Checked&&Je!==pt.Unchecked||Ye!==void 0&&!(0,S.$if)(Ye))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(T instanceof k)return!0;if(Se.label!==void 0&&!(0,S.$if)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,S.$if)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,S.$if)(Se.iconPath)&&!d.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,S.$if)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,S.$if)(Je.light)&&!d.URI.isUri(Je.light)&&!(0,S.$if)(Je.dark)&&!d.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,S.$if)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!d.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,S.$if)(Se.tooltip)&&!(Se.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<xe.None&&Se.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,S.$if)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(T,re=xe.None){this.collapsibleState=re,d.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$KK=We,e.$KK=We=k=Ke([R],We);var xe;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var pt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(pt||(e.TreeItemCheckboxState=pt={}));let bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$LK=bt,e.$LK=bt=Ke([R],bt);class dt extends bt{}e.$MK=dt;class ft extends dt{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$NK=ft;class mt{constructor(T,re,Se,Je){this.name=T,this.uri=re,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$OK=mt;let gi=class{#e=new Map;constructor(T){for(const[re,Se]of T??[]){const Je=this.#e.get(this.#t(re));Je?Je.push(Se):this.#e.set(this.#t(re),[Se])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,re){this.#e.set(this.#t(T),[re])}forEach(T,re){for(const[Se,Je]of this.#e)for(const Ye of Je)T.call(re,Ye,Se,this)}*[Symbol.iterator](){for(const[T,re]of this.#e)for(const Se of re)yield[T,Se]}#t(T){return T.toLowerCase()}};e.$PK=gi,e.$PK=gi=Ke([R],gi);let Kt=class{constructor(T){this.insertText=T}};e.$QK=Kt,e.$QK=Kt=Ke([R],Kt);let Ei=class{constructor(T,re){this.label=re,this.insertText=T}};e.$RK=Ei,e.$RK=Ei=Ke([R],Ei);let Wt=class{constructor(T,re){this.id=T,this.color=re}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$SK=Wt,e.$SK=Wt=Ke([R],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let mi=class{constructor(T){this.id=T}};e.$TK=mi,e.$TK=mi=Ke([R],mi);var It;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(It||(e.ConfigurationTarget=It={}));let ki=class{get base(){return this.c}set base(T){this.c=T,this.e=d.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,re){if(typeof T!="string"&&(!T||!d.URI.isUri(T)&&!d.URI.isUri(T.uri)))throw(0,F.$5)("base");if(typeof re!="string")throw(0,F.$5)("pattern");typeof T=="string"?this.baseUri=d.URI.file(T):d.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$UK=ki,e.$UK=ki=Ke([R],ki);const Vi=new WeakMap;function Dt(j,T){Vi.set(j,T)}e.$VK=Dt;let ti=class{constructor(T,re,Se,Je){this.enabled=typeof T=="boolean"?T:!0,typeof re=="string"&&(this.condition=re),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$3f)()),this.c}};e.$WK=ti,e.$WK=ti=Ke([R],ti);let $i=class extends ti{constructor(T,re,Se,Je,Ye){if(super(re,Se,Je,Ye),T===null)throw(0,F.$5)("location");this.location=T}};e.$XK=$i,e.$XK=$i=Ke([R],$i);let si=class extends ti{constructor(T,re,Se,Je,Ye){super(re,Se,Je,Ye),this.functionName=T}};e.$YK=si,e.$YK=si=Ke([R],si);let Di=class extends ti{constructor(T,re,Se,Je,Ye,ot,lt){if(super(Je,Ye,ot,lt),!re)throw(0,F.$5)("dataId");this.label=T,this.dataId=re,this.canPersist=Se}};e.$ZK=Di,e.$ZK=Di=Ke([R],Di);let Si=class{constructor(T,re,Se){this.command=T,this.args=re||[],this.options=Se}};e.$1K=Si,e.$1K=Si=Ke([R],Si);let Rt=class{constructor(T,re){this.port=T,this.host=re}};e.$2K=Rt,e.$2K=Rt=Ke([R],Rt);let pi=class{constructor(T){this.path=T}};e.$3K=pi,e.$3K=pi=Ke([R],pi);let Ii=class{constructor(T){this.implementation=T}};e.$4K=Ii,e.$4K=Ii=Ke([R],Ii);let oi=class{constructor(T,re,Se){this.session=T,this.threadId=re,this.frameId=Se}};e.$5K=oi,e.$5K=oi=Ke([R],oi);let ai=class{constructor(T,re){this.session=T,this.threadId=re}};e.$6K=ai,e.$6K=ai=Ke([R],ai);let ct=class{constructor(T,re){this.range=T,this.expression=re}};e.$7K=ct,e.$7K=ct=Ke([R],ct);var qi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Yt=class{constructor(T,re){this.range=T,this.text=re}};e.$8K=Yt,e.$8K=Yt=Ke([R],Yt);let ii=class{constructor(T,re,Se=!0){this.range=T,this.variableName=re,this.caseSensitiveLookup=Se}};e.$9K=ii,e.$9K=ii=Ke([R],ii);let bi=class{constructor(T,re){this.range=T,this.expression=re}};e.$0K=bi,e.$0K=bi=Ke([R],bi);let Ci=class{constructor(T,re){this.frameId=T,this.stoppedLocation=re}};e.$$K=Ci,e.$$K=Ci=Ke([R],Ci);var Ki;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=r=class extends Error{static FileExists(T){return new r(T,u.FileSystemProviderErrorCode.FileExists,r.FileExists)}static FileNotFound(T){return new r(T,u.FileSystemProviderErrorCode.FileNotFound,r.FileNotFound)}static FileNotADirectory(T){return new r(T,u.FileSystemProviderErrorCode.FileNotADirectory,r.FileNotADirectory)}static FileIsADirectory(T){return new r(T,u.FileSystemProviderErrorCode.FileIsADirectory,r.FileIsADirectory)}static NoPermissions(T){return new r(T,u.FileSystemProviderErrorCode.NoPermissions,r.NoPermissions)}static Unavailable(T){return new r(T,u.FileSystemProviderErrorCode.Unavailable,r.Unavailable)}constructor(T,re=u.FileSystemProviderErrorCode.Unknown,Se){super(d.URI.isUri(T)?T.toString(!0):T),this.code=Se?.name??"Unknown",(0,u.$gk)(this,re),Object.setPrototypeOf(this,r.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$_K=Pi,e.$_K=Pi=r=Ke([R],Pi);let vi=class{constructor(T,re,Se){this.start=T,this.end=re,this.kind=Se}};e.$aL=vi,e.$aL=vi=Ke([R],vi);var Ji;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ai;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Hi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Hi||(e.CommentState=Hi={}));var wi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(T,re=[]){this.tokenTypes=T,this.tokenModifiers=re}}e.$bL=Ri;function cn(j){return typeof j>"u"||(0,S.$jf)(j)}class Fi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,T){this.l=!0;for(let re=0,Se=T.tokenTypes.length;re<Se;re++)this.j.set(T.tokenTypes[re],re);for(let re=0,Se=T.tokenModifiers.length;re<Se;re++)this.k.set(T.tokenModifiers[re],re)}}push(T,re,Se,Je,Ye){if(typeof T=="number"&&typeof re=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(T,re,Se,Je,Ye);if(O.isRange(T)&&typeof re=="string"&&cn(Se))return this.m(T,re,Se);throw(0,F.$5)()}m(T,re,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const Je=T.start.line,Ye=T.start.character,ot=T.end.character-T.start.character,lt=this.j.get(re);let jt=0;if(Se)for(const Xt of Se){if(!this.k.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Xt);jt|=1<<xt>>>0}this.n(Je,Ye,ot,lt,jt)}n(T,re,Se,Je,Ye){if(this.f&&(T<this.c||T===this.c&&re<this.e)){this.f=!1;const jt=this.g.length/5|0;let Xt=0,xt=0;for(let ei=0;ei<jt;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Xt,Bi+=xt):ri+=Xt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Xt=ri,xt=Bi}}let ot=T,lt=re;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=Se,this.g[this.h++]=Je,this.g[this.h++]=Ye,this.c=T,this.e=re}static o(T){const re=[],Se=T.length/5|0;for(let lt=0;lt<Se;lt++)re[lt]=lt;re.sort((lt,jt)=>{const Xt=T[5*lt],xt=T[5*jt];if(Xt===xt){const ei=T[5*lt+1],ri=T[5*jt+1];return ei-ri}return Xt-xt});const Je=new Uint32Array(T.length);let Ye=0,ot=0;for(let lt=0;lt<Se;lt++){const jt=5*re[lt],Xt=T[jt+0],xt=T[jt+1],ei=T[jt+2],ri=T[jt+3],Bi=T[jt+4],wn=Xt-Ye,Fn=wn===0?xt-ot:xt,Wi=5*lt;Je[Wi+0]=wn,Je[Wi+1]=Fn,Je[Wi+2]=ei,Je[Wi+3]=ri,Je[Wi+4]=Bi,Ye=Xt,ot=xt}return Je}build(T){return this.f?new ni(new Uint32Array(this.g),T):new ni(Fi.o(this.g),T)}}e.$cL=Fi;class ni{constructor(T,re){this.resultId=re,this.data=T}}e.$dL=ni;class un{constructor(T,re,Se){this.start=T,this.deleteCount=re,this.data=Se}}e.$eL=un;class ln{constructor(T,re){this.resultId=re,this.edits=T}}e.$fL=ln;var Gi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.$gL=fi,e.$gL=fi=Ke([R],fi);var Xi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Qi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Qi||(e.InputBoxValidationSeverity=Qi={}));var ui;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Yi{static validate(T){if(typeof T.badge=="string"){let re=(0,l.$Ve)(T.badge,0);if(re<T.badge.length&&(re+=(0,l.$Ve)(T.badge,re)),T.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!Wt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,re,Se){this.badge=T,this.tooltip=re,this.color=Se}}e.$hL=Yi;let Mi=class{constructor(T){this.kind=T}};e.$iL=Mi,e.$iL=Mi=Ke([R],Mi);var Zi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Zi||(e.ColorThemeKind=Zi={}));class Zt{static isNotebookRange(T){return T instanceof Zt?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,re){if(T<0)throw(0,F.$5)("start must be positive");if(re<0)throw(0,F.$5)("end must be positive");T<=re?(this.c=T,this.e=re):(this.c=re,this.e=T)}with(T){let re=this.c,Se=this.e;return T.start!==void 0&&(re=T.start),T.end!==void 0&&(Se=T.end),re===this.c&&Se===this.e?this:new Zt(re,Se)}}e.$jL=Zt;class yi{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(re=>yi.isNotebookCellData(re))}static isNotebookCellData(T){return!0}constructor(T,re,Se,Je,Ye,ot,lt){this.kind=T,this.value=re,this.languageId=Se,this.mime=Je,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=lt,yi.validate(this)}}e.$kL=yi;class hn{constructor(T){this.cells=T}}e.$lL=hn;class Gt{static isNotebookCellOutputItem(T){return T instanceof Gt?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const re={name:T.name,message:T.message,stack:T.stack};return Gt.json(re,"application/vnd.code.notebook.error")}static stdout(T){return Gt.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return Gt.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,re="application/octet-stream"){return new Gt(T,re)}static#e=new TextEncoder;static text(T,re=A.$Gr.text){const Se=Gt.#e.encode(String(T));return new Gt(Se,re)}static json(T,re="text/x-json"){const Se=JSON.stringify(T,void 0,"	");return Gt.text(Se,re)}constructor(T,re){this.data=T,this.mime=re;const Se=(0,A.$Kr)(re,!0);if(!Se)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$mL=Gt;class li{static isNotebookCellOutput(T){return T instanceof li?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,re=!1){const Se=new Set,Je=new Set;for(let Ye=0;Ye<T.length;Ye++){const ot=T[Ye],lt=(0,A.$Kr)(ot.mime);if(!Se.has(lt)||(0,p.$3H)(lt)){Se.add(lt);continue}Je.add(Ye),re&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Je.size===0?T:T.filter((Ye,ot)=>!Je.has(ot))}constructor(T,re,Se){this.items=li.ensureUniqueMimeTypes(T,!0),typeof re=="string"?(this.id=re,this.metadata=Se):(this.id=(0,P.$3f)(),this.metadata=re??Se)}}e.$nL=li;var Ti;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Oe;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Oe||(e.NotebookCellExecutionState=Oe={}));var _t;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Li;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Li||(e.NotebookEditorRevealType=Li={}));class $t{constructor(T,re){this.text=T,this.alignment=re}}e.$oL=$t;var _i;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(_i||(e.NotebookControllerAffinity=_i={}));var xi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class en{constructor(T,re=[]){this.uri=T,this.provides=(0,w.$Zb)(re)}}e.$pL=en;class dn{constructor(T){this.label=T}}e.$qL=dn;let hi=class{constructor(T,re){this.label=T,this.timestamp=re}};e.$rL=hi,e.$rL=hi=Ke([R],hi);var tn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(T,re){this.ranges=T,this.wordPattern=re}}e.$sL=sn;class fn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$tL=fn;var on;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(T=void 0,re=void 0,Se=void 0,Je=!1){this.include=T,this.exclude=re,this.profile=Se,this.continuous=Je}};e.$uL=Oi,e.$uL=Oi=Ke([R],Oi);let Ni=h=class{static diff(T,re,Se){const Je=new h(T);return Je.expectedOutput=re,Je.actualOutput=Se,Je}constructor(T){this.message=T}};e.$vL=Ni,e.$vL=Ni=h=Ke([R],Ni);let zi=class{constructor(T){this.id=T}};e.$wL=zi,e.$wL=zi=Ke([R],zi);let di=class{constructor(T,re){this.covered=T,this.total=re}};e.$xL=di,e.$xL=di=Ke([R],di);let ji=v=class{static fromDetails(T,re){const Se=new di(0,0),Je=new di(0,0),Ye=new di(0,0);for(const lt of re)if("branches"in lt){Se.total+=1,Se.covered+=lt.executionCount>0?1:0;for(const jt of lt.branches)Je.total+=1,Je.covered+=jt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const ot=new v(T,Se,Je.total>0?Je:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=re,ot}constructor(T,re,Se,Je){this.uri=T,this.statementCoverage=re,this.branchCoverage=Se,this.functionCoverage=Je}};e.$yL=ji,e.$yL=ji=v=Ke([R],ji);let Ui=class{constructor(T,re,Se=[]){this.executionCount=T,this.location=re,this.branches=Se}};e.$zL=Ui,e.$zL=Ui=Ke([R],Ui);let te=class{constructor(T,re){this.executionCount=T,this.location=re}};e.$AL=te,e.$AL=te=Ke([R],te);let de=class{constructor(T,re){this.executionCount=T,this.location=re}};e.$BL=de,e.$BL=de=Ke([R],de);var Te;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Te||(e.ExternalUriOpenerPriority=Te={}));var rt;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(rt||(e.WorkspaceTrustState=rt={}));var yt;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(yt||(e.PortAutoForwardAction=yt={}));class Ft{constructor(T,re,Se,Je,Ye,ot){this.kind=T,this.name=re,this.detail=Se,this.uri=Je,this.range=Ye,this.selectionRange=ot}}e.$CL=Ft;class yn{constructor(T){this.uri=T}}e.$DL=yn;class En{constructor(T,re){this.original=T,this.modified=re}}e.$EL=En;class kn{constructor(T,re,Se,Je){this.base=T,this.input1=re,this.input2=Se,this.result=Je}}e.$FL=kn;class Dn{constructor(T,re){this.uri=T,this.viewType=re}}e.$GL=Dn;class Sn{constructor(T){this.viewType=T}}e.$HL=Sn;class In{constructor(T,re){this.uri=T,this.notebookType=re}}e.$IL=In;class Cn{constructor(T,re,Se){this.original=T,this.modified=re,this.notebookType=Se}}e.$JL=Cn;class Pn{constructor(){}}e.$KL=Pn;class An{constructor(T,re){this.uri=T,this.inputBoxUri=re}}e.$LL=An;var gn;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var bn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Rn{constructor(T,re){this.role=T,this.content=re}}e.$ML=Rn;var vn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(vn||(e.RelatedInformationType=vn={}))}),define(Ae[101],Re([1,0,50,12,15,277,137,7,18]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=e.$ZL=void 0;const d=new Map;function P(p,f){f?d.set(p,f):d.delete(p)}e.$ZL=P;function D(p){return d.get(p)}class u extends L.$Lu{constructor(f,i,t,c,g,E,$,s){super(i,t,c,g),this.c=f,this.m=E,this.q=$,this.notebook=s,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,S.$sb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===F.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(i){return i?f.s(i):f.getText()},get eol(){return f.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(i){return f.t(i)},offsetAt(i){return f.u(i)},positionAt(i){return f.v(i)},validateRange(i){return f.w(i)},validatePosition(i){return f.x(i)},getWordRangeAtPosition(i,t){return f.y(i,t)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,w.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,w.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const i=this.w(f);if(i.isEmpty)return"";if(i.isSingleLine)return this.f[i.start.line].substring(i.start.character,i.end.character);const t=this.g,c=i.start.line,g=i.end.line,E=[];E.push(this.f[c].substring(i.start.character));for(let $=c+1;$<g;$++)E.push(this.f[$]);return E.push(this.f[g].substring(0,i.end.character)),E.join(t)}t(f){let i;if(f instanceof l.$YJ?i=f.line:typeof f=="number"&&(i=f),typeof i!="number"||i<0||i>=this.f.length||Math.floor(i)!==i)throw new Error("Illegal value for `line`");return new b(i,this.f[i],i===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const i=this.j.getIndexOf(f),t=this.f[i.index].length;return new l.$YJ(i.index,Math.min(i.remainder,t))}w(f){if(!(f instanceof l.$ZJ))throw new Error("Invalid argument");const i=this.x(f.start),t=this.x(f.end);return i===f.start&&t===f.end?f:new l.$ZJ(i.line,i.character,t.line,t.character)}x(f){if(!(f instanceof l.$YJ))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:i,character:t}=f,c=!1;if(i<0)i=0,t=0,c=!0;else if(i>=this.f.length)i=this.f.length-1,t=this.f[i].length,c=!0;else{const g=this.f[i].length;t<0?(t=0,c=!0):t>g&&(t=g,c=!0)}return c?new l.$YJ(i,t):f}y(f,i){const t=this.x(f);if(!i)i=D(this.m);else if((0,C.$ye)(i))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${i.source}' because it matches the empty string.`);const c=(0,A.$Yr)(t.character+1,(0,A.$Wr)(i),this.f[t.line],0);if(c)return new l.$ZJ(t.line,c.startColumn-1,t.line,c.endColumn-1)}}e.$1L=u;class b{constructor(f,i,t){this.a=f,this.b=i,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$ZJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$ZJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$2L=b}),define(Ae[197],Re([1,0,7,17,5]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;let L=class{constructor(l){this.a=new w.$iL(w.ColorThemeKind.Dark),this.b=new C.$ed}get activeColorTheme(){return this.a}$onColorThemeChange(l){let S;switch(l){case"light":S=w.ColorThemeKind.Light;break;case"hcDark":S=w.ColorThemeKind.HighContrast;break;case"hcLight":S=w.ColorThemeKind.HighContrastLight;break;default:S=w.ColorThemeKind.Dark}this.a=new w.$iL(S),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$pcc=L,e.$pcc=L=Ke([Ve(0,F.$XL)],L)}),define(Ae[198],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7H=e.CellExecutionUpdateType=void 0;var F;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$7H=(0,w.$Ah)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$II=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(L){L.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class C{static fromExtHostTestItem(A,l,S=A.parent){if(A._isRoot)return new C([l]);const d=[A.id];for(let P=S;P&&P.id!==l;P=P.parent)d.push(P.id);return d.push(l),new C(d.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$II=C}),define(Ae[56],Re([1,0,2,44,45]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$OI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$NI=e.$MI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$LI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$KI=e.$JI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$JI=[2,4,8,16,32,64];const S=k=>"runId"in k;e.$KI=S;var d;(function(k){k.serialize=r=>({range:r.range.toJSON(),uri:r.uri.toJSON()}),k.deserialize=r=>({range:F.$js.lift(r.range),uri:w.URI.revive(r.uri)})})(d||(e.IRichLocation=d={}));var P;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(P||(e.TestMessageType=P={}));var D;(function(k){k.serialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,contextValue:r.contextValue,location:r.location&&d.serialize(r.location)}),k.deserialize=r=>({message:r.message,type:0,expected:r.expected,actual:r.actual,contextValue:r.contextValue,location:r.location&&d.deserialize(r.location)})})(D||(e.ITestErrorMessage=D={}));const u=(k,r)=>`${r?"s":"e"}${k}`;e.$LI=u;var b;(function(k){k.serialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&d.serialize(r.location)}),k.deserialize=r=>({message:r.message,type:1,offset:r.offset,length:r.length,location:r.location&&d.deserialize(r.location)})})(b||(e.ITestOutputMessage=b={}));var p;(function(k){k.serialize=r=>r.type===0?D.serialize(r):b.serialize(r),k.deserialize=r=>r.type===0?D.deserialize(r):b.deserialize(r)})(p||(e.ITestMessage=p={}));var f;(function(k){k.serializeWithoutMessages=r=>({state:r.state,duration:r.duration,messages:[]}),k.serialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map(p.serialize)}),k.deserialize=r=>({state:r.state,duration:r.duration,messages:r.messages.map(p.deserialize)})})(f||(e.ITestTaskState=f={}));const i="\0",t=(k,r)=>k+i+r;e.$MI=t;const c=k=>{const r=k.indexOf(i);return{ctrlId:k.slice(0,r),tagId:k.slice(r+1)}};e.$NI=c;var g;(function(k){k.serialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?.toJSON(),range:r.range?.toJSON()||null,description:r.description,error:r.error,sortText:r.sortText}),k.deserialize=r=>({extId:r.extId,label:r.label,tags:r.tags,busy:r.busy,children:void 0,uri:r.uri?w.URI.revive(r.uri):void 0,range:r.range?F.$js.lift(r.range):null,description:r.description,error:r.error,sortText:r.sortText})})(g||(e.ITestItem=g={}));var E;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var $;(function(k){k.serialize=r=>({expand:r.expand,item:g.serialize(r.item)}),k.deserialize=r=>({controllerId:C.$II.root(r.item.extId),expand:r.expand,item:g.deserialize(r.item)})})($||(e.InternalTestItem=$={}));var s;(function(k){k.serialize=r=>{let h;return r.item&&(h={},r.item.label!==void 0&&(h.label=r.item.label),r.item.tags!==void 0&&(h.tags=r.item.tags),r.item.busy!==void 0&&(h.busy=r.item.busy),r.item.uri!==void 0&&(h.uri=r.item.uri?.toJSON()),r.item.range!==void 0&&(h.range=r.item.range?.toJSON()),r.item.description!==void 0&&(h.description=r.item.description),r.item.error!==void 0&&(h.error=r.item.error),r.item.sortText!==void 0&&(h.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:h}},k.deserialize=r=>{let h;return r.item&&(h={},r.item.label!==void 0&&(h.label=r.item.label),r.item.tags!==void 0&&(h.tags=r.item.tags),r.item.busy!==void 0&&(h.busy=r.item.busy),r.item.range!==void 0&&(h.range=r.item.range?F.$js.lift(r.item.range):null),r.item.description!==void 0&&(h.description=r.item.description),r.item.error!==void 0&&(h.error=r.item.error),r.item.sortText!==void 0&&(h.sortText=r.item.sortText)),{extId:r.extId,expand:r.expand,item:h}}})(s||(e.ITestItemUpdate=s={}));const a=(k,r)=>{r.expand!==void 0&&(k.expand=r.expand),r.item!==void 0&&(k.item=k.item?Object.assign(k.item,r.item):r.item)};e.$OI=a;var n;(function(k){k.serializeWithoutMessages=r=>({...$.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(f.serializeWithoutMessages)}),k.serialize=r=>({...$.serialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(f.serialize)}),k.deserialize=r=>({...$.deserialize(r),ownComputedState:r.ownComputedState,computedState:r.computedState,tasks:r.tasks.map(f.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var o;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(o||(e.DetailType=o={}));var y;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(y||(e.TestDiffOpType=y={}));var m;(function(k){k.deserialize=r=>r.op===0?{op:r.op,item:$.deserialize(r.item)}:r.op===1?{op:r.op,item:s.deserialize(r.item)}:r.op===2?{op:r.op,uri:w.URI.revive(r.uri),docv:r.docv}:r,k.serialize=r=>r.op===0?{op:r.op,item:$.serialize(r.item)}:r.op===1?{op:r.op,item:s.serialize(r.item)}:r})(m||(e.TestsDiffOp=m={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(r){const h=this.p();for(const v of r)switch(v.op){case 0:this.k($.deserialize(v.item),h);break;case 1:this.l(s.deserialize(v.item),h);break;case 3:this.m(v.itemId,h);break;case 5:this.o(v.itemId);break;case 4:this.updatePendingRoots(v.amount);break;case 6:this.d.set(v.tag.id,v.tag);break;case 7:this.d.delete(v.id);break}h.complete?.()}k(r,h){const v=C.$II.parentId(r.item.extId)?.toString();let R;if(!v)R=this.q(r),this.g.add(R),this.f.set(r.item.extId,R);else if(this.f.has(v)){const W=this.f.get(v);W.children.add(r.item.extId),R=this.q(r,W),this.f.set(r.item.extId,R)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(r)}`);return}return h.add?.(R),r.expand===2&&this.h++,R}l(r,h){const v=this.f.get(r.extId);if(v)return r.expand!==void 0&&(v.expand===2&&this.h--,r.expand===2&&this.h++),(0,e.$OI)(v,r),h.update?.(v),v}m(r,h){const v=this.f.get(r);if(!v)return;const R=C.$II.parentId(v.item.extId)?.toString();R?this.f.get(R).children.delete(v.item.extId):this.g.delete(v);const W=[[r]];for(;W.length;)for(const V of W.pop()){const U=this.f.get(V);U&&(W.push(U.children),this.f.delete(V),h.remove?.(U,U!==v),U.expand===2&&this.h--)}}o(r){}updatePendingRoots(r){this.j+=r}p(){return{}}}e.$PI=I}),define(Ae[76],Re([1,0,13,5,6,50,56,45]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.TestItemEventOp=void 0;var S;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(S||(e.TestItemEventOp=S={}));const d=(c,g)=>c===g,D=Object.entries({range:(c,g)=>c===g?!0:!c||!g?!1:c.equalsRange(g),busy:d,label:d,description:d,error:d,sortText:d,tags:(c,g)=>!(c.length!==g.length||c.some(E=>!g.includes(E)))}),u=(c,g)=>{let E;for(const[$,s]of D)s(c[$],g[$])||(E?E[$]=g[$]:E={[$]:g[$]});return E};class b extends C.$jc{get root(){return this.s.root}constructor(g){super(),this.s=g,this.f=this.B(new w.$Rg(()=>this.flushDiff(),200)),this.g=this.B(new F.$ed),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(g){this.h=g;for(const E of this.tree.values())this.I(E)}get resolveHandler(){return this.h}collectDiff(){const g=this.m;return this.m=[],g}pushDiff(g){switch(g.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===g.uri){E.docv=g.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===g.item.extId){(0,A.$OI)(E.item,g.item);return}if(E.op===0&&E.item.item.extId===g.item.extId){(0,A.$OI)(E.item,g.item);return}}break}}this.m.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,E){const $=this.tree.get(g);if($){if(($.expandLevels===void 0||E>$.expandLevels)&&($.expandLevels=E),$.expand===1){const s=this.L($);return s.isOpen()?this.J($,E-1):s.wait().then(()=>this.J($,E-1))}else if($.expand===3)return $.resolveBarrier?.isOpen()===!1?$.resolveBarrier.wait().then(()=>this.J($,E-1)):this.J($,E-1)}}dispose(){for(const g of this.tree.values())this.s.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(g,E){switch(E.op){case 3:this.N(l.$II.joinToString(g.fullId,E.id));break;case 0:this.y(E.item,g);break;case 5:for(const $ of E.ops)this.u(g,$);break;case 1:this.z(E.new,E.old,g.fullId.toString());break;case 2:this.I(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:E.update}});break;case 6:this.w(g.actual.uri);break;default:(0,L.$uc)(E)}}w(g){g&&this.pushDiff({op:2,uri:g,docv:this.s.getDocumentVersion(g)})}y(g,E){const $=l.$II.fromExtHostTestItem(g,this.root.id,E?.actual),s=this.s.getApiFor(g);s.parent&&s.parent!==E?.actual&&this.s.getChildren(s.parent).delete(g.id);let a=this.tree.get($.toString());if(!a){a={fullId:$,actual:g,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},g.tags.forEach(this.C,this),this.tree.set(a.fullId.toString(),a),this.F(g,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:a.expand,item:this.s.toITestItem(g)}}),this.H(g,a,E);return}if(a.actual===g){this.G(g,a,E);return}if(a.actual.uri?.toString()!==g.uri?.toString())return this.N($.toString()),this.y(g,E);const n=this.s.getChildren(a.actual),o=a.actual,y=u(this.s.toITestItem(o),this.s.toITestItem(g));this.s.getApiFor(o).listener=void 0,a.actual=g,a.expand=0,y&&(y.hasOwnProperty("tags")&&(this.z(g.tags,o.tags,$.toString()),delete y.tags),this.u(a,{op:4,update:y})),this.H(g,a,E);for(const[m,I]of n)this.s.getChildren(g).get(I.id)||this.N(l.$II.joinToString($,I.id));this.w(a.actual.uri)}z(g,E,$){const s=new Set(E.map(a=>a.id));for(const a of g)s.delete(a.id)||this.C(a);this.pushDiff({op:1,item:{extId:$,item:{tags:g.map(a=>(0,A.$MI)(this.s.controllerId,a.id))}}}),s.forEach(this.D,this)}C(g){const E=this.j.get(g.id);E?E.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$MI)(this.s.controllerId,g.id)}}))}D(g){const E=this.j.get(g);E&&!--E.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,A.$MI)(this.s.controllerId,g)}))}F(g,E){this.s.getApiFor(g).parent=E&&E.actual!==this.root?E.actual:void 0}G(g,E,$){this.F(g,$);const s=this.s.getApiFor(g);s.parent=$?.actual,s.listener=a=>this.u(E,a),this.I(E)}H(g,E,$){this.G(g,E,$);for(const[s,a]of this.s.getChildren(g))this.y(a,E)}I(g){let E;this.h?g.resolveBarrier?E=g.resolveBarrier.isOpen()?3:2:E=g.actual.canResolveChildren?1:0:E=0,E!==g.expand&&(g.expand=E,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:E}}),E===1&&g.expandLevels!==void 0&&this.L(g))}J(g,E){if(E<0)return;const $=[];for(const[s,a]of this.s.getChildren(g.actual)){const n=this.expand(l.$II.joinToString(g.fullId,a.id),E);(0,w.$sg)(n)&&$.push(n)}if($.length)return Promise.all($).then(()=>{})}L(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const a=new w.$Eg;return a.open(),a}g.expand=2,this.M(g);const E=g.resolveBarrier=new w.$Eg,$=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,a)};let s;try{s=this.h(g.actual===this.root?void 0:g.actual)}catch(a){$(a)}return(0,w.$sg)(s)?s.catch($).then(()=>{E.open(),this.I(g)}):(E.open(),this.I(g)),g.resolveBarrier}M(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}N(g){const E=this.tree.get(g);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const $=[E];for(;$.length;){const s=$.pop();if(s){this.s.getApiFor(s.actual).listener=void 0;for(const a of s.actual.tags)this.D(a.id);this.tree.delete(s.fullId.toString());for(const[a,n]of this.s.getChildren(s.actual))$.push(this.tree.get(l.$II.joinToString(s.fullId,n.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.$NL=b;class p extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.$OL=p;class f extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$PL=f;class i extends Error{constructor(g,E,$){super(`TestItem with ID "${g}" is from controller "${E}" and cannot be added as a child of an item from controller "${$}".`)}}e.$QL=i;const t=(c,g,E)=>{let $=new Map;return{get size(){return $.size},forEach(s,a){for(const n of $.values())s.call(a,n,this)},[Symbol.iterator](){return $.entries()},replace(s){const a=new Map,n=new Set($.keys()),o={op:5,ops:[]};for(const y of s){if(!(y instanceof E))throw new f(y.id);const m=g(y).controllerId;if(m!==c.controllerId)throw new i(y.id,m,c.controllerId);if(a.has(y.id))throw new p(y.id);a.set(y.id,y),n.delete(y.id),o.ops.push({op:0,item:y})}for(const y of n.keys())o.ops.push({op:3,id:y});c.listener?.(o),$=a},add(s){if(!(s instanceof E))throw new f(s.id);$.set(s.id,s),c.listener?.({op:0,item:s})},delete(s){$.delete(s)&&c.listener?.({op:3,id:s})},get(s){return $.get(s)},toJSON(){return Array.from($.values())}}};e.$RL=t}),define(Ae[102],Re([1,0,76]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=void 0;const F=new WeakMap,C=(A,l)=>{const S={controllerId:l};return F.set(A,S),S};e.$SL=C;const L=A=>{const l=F.get(A);if(!l)throw new w.$PL(A?.id||"<unknown>");return l};e.$TL=L}),define(Ae[77],Re([1,0,12,2]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rob=e.$Qob=e.$Pob=e.$Oob=e.$Nob=void 0,e.$Nob="vscode-cdn.net",e.$Oob=`vscode-resource.${e.$Nob}`,e.$Pob=`'self' https://*.${e.$Nob}`;function C(l,S){return l.scheme===w.Schemas.http||l.scheme===w.Schemas.https?l:(S&&S.authority&&S.isRemote&&l.scheme===w.Schemas.file&&(l=F.URI.from({scheme:w.Schemas.vscodeRemote,authority:S.authority,path:l.path})),F.URI.from({scheme:w.Schemas.https,authority:`${l.scheme}+${L(l.authority)}.${e.$Oob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$Qob=C;function L(l){return l.replace(/./g,S=>{const d=S.charCodeAt(0);return d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57?S:"-"+d.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(S,d)=>String.fromCharCode(parseInt(d,16)))}e.$Rob=A}),define(Ae[199],Re([1,0,5,6,77]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=void 0;class L{constructor(l,S,d){this.d=l,this.e=S,this.f=d,this.a=0,this.b=new F.$ic,this.c=new Map,this.b.add(S.onDidChangeVisibleTextEditors(()=>{const P=S.getVisibleTextEditors();for(const D of this.c.values())P.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,S,d,P,D){let u;for(const g of this.e.getVisibleTextEditors(!0))if(g.value===l){u=g;break}if(!u)throw new Error("not a visible editor");const b=this,p=this.a++,f=new w.$ed,i=new w.$ed,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(g){return(0,C.$Qob)(g,b.f)}get cspSource(){return C.$Pob}set options(g){this.b=g,b.d.$setOptions(p,g)}get options(){return this.b}set html(g){this.a=g,b.d.$setHtml(p,g)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(g){return b.d.$postMessage(p,g)}},c=new class{constructor(){this.editor=l,this.line=S,this.height=d,this.webview=t,this.onDidDispose=i.event}dispose(){b.c.has(p)&&(b.c.delete(p),b.d.$disposeEditorInset(p),i.fire(),i.dispose(),f.dispose())}};return this.d.$createEditorInset(p,u.id,u.value.document.uri,S+1,d,P||{},D.identifier,D.extensionLocation),this.c.set(p,{editor:l,inset:c,onDidReceiveMessage:f}),c}$onDidDispose(l){const S=this.c.get(l);S&&S.inset.dispose()}$onDidReceiveMessage(l,S){this.c.get(l)?.onDidReceiveMessage.fire(S)}}e.$Zbc=L}),define(Ae[200],Re([1,0,4]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.VariableKind=e.$JM=void 0,e.$JM=(0,w.$Ah)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$KM=C}),define(Ae[201],Re([1,0,19,74,16,24,22,90,166,200,15]),function(be,e,w,F,C,L,A,l,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,p,f,i){this.h=new Map,this.a=b,this.b=p,this.g=f,i&&(this.c=i.then(t=>this.i(t)))}i(b){if(A.$i){const p=Object.create(null);return Object.keys(b).forEach(f=>{p[f.toLowerCase()]=b[f]}),p}return b}resolveWithEnvironment(b,p,f){return this.l({env:this.i(b),userHome:void 0},p?p.uri:void 0,f)}async resolveAsync(b,p){const f={env:await this.c,userHome:await this.g};return this.l(f,b?b.uri:void 0,p)}async j(b,p,f,i){const t=L.$Um(p);A.$i&&t.windows?Object.keys(t.windows).forEach(g=>t[g]=t.windows[g]):A.$j&&t.osx?Object.keys(t.osx).forEach(g=>t[g]=t.osx[g]):A.$k&&t.linux&&Object.keys(t.linux).forEach(g=>t[g]=t.linux[g]),delete t.windows,delete t.osx,delete t.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,b?b.uri:void 0,t,f,i)}async resolveAnyAsync(b,p,f){return this.j(b,p,f)}async resolveAnyMap(b,p,f){const i=new Map;return{newConfig:await this.j(b,p,f,i),resolvedVariables:i}}resolveWithInteractionReplace(b,p,f,i){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,p,f,i){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,p){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,p)}async l(b,p,f,i,t){if(C.$if(f))return this.m(b,p,f,i,t);if(Array.isArray(f))return Promise.all(f.map(c=>this.l(b,p,c,i,t)));if(C.$kf(f)){const c=Object.create(null),g=await Promise.all(Object.keys(f).map(async E=>[await this.m(b,p,E,i,t),await this.l(b,p,f[E],i,t)]));for(const[E,$]of g)c[E]=$;return c}return f}m(b,p,f,i,t){return(0,P.$De)(f,D.VARIABLE_REGEXP,async(c,g)=>{if(g.includes(D.VARIABLE_LHS))return c;let E=await this.o(b,c,g,p,i);return t?.set(g,E),E!==c&&C.$if(E)&&E.match(D.VARIABLE_REGEXP)&&(E=await this.m(b,p,E,i,t)),E})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,p,f,i,t){let c;const g=f.split(":");g.length>1&&(f=g[0],c=g[1]);const E=a=>{const n=this.a.getFilePath();if(n)return(0,l.$eA)(n);throw new d.$KM(a,(0,S.localize)(0,null,p))},$=a=>{const n=E(a);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$eA)(o)}throw new d.$KM(a,(0,S.localize)(1,null,p,w.$_d(n)))},s=a=>{if(c){const n=this.a.getFolderUri(c);if(n)return n;throw new d.$KM(a,(0,S.localize)(2,null,p,c))}if(i)return i;throw this.a.getWorkspaceFolderCount()>1?new d.$KM(a,(0,S.localize)(3,null,p)):new d.$KM(a,(0,S.localize)(4,null,p))};switch(f){case"env":if(c){if(b.env){const a=b.env[A.$i?c.toLowerCase():c];if(C.$if(a))return a}return""}throw new d.$KM(d.VariableKind.Env,(0,S.localize)(5,null,p));case"config":if(c){const a=this.a.getConfigurationValue(i,c);if(C.$rf(a))throw new d.$KM(d.VariableKind.Config,(0,S.localize)(6,null,p,c));if(C.$kf(a))throw new d.$KM(d.VariableKind.Config,(0,S.localize)(7,null,p,c));return a}throw new d.$KM(d.VariableKind.Config,(0,S.localize)(8,null,p));case"command":return this.p(d.VariableKind.Command,p,c,t,"command");case"input":return this.p(d.VariableKind.Input,p,c,t,"input");case"extensionInstallFolder":if(c){const a=await this.a.getExtension(c);if(!a)throw new d.$KM(d.VariableKind.ExtensionInstallFolder,(0,S.localize)(9,null,p,c));return this.n(a.extensionLocation)}throw new d.$KM(d.VariableKind.ExtensionInstallFolder,(0,S.localize)(10,null,p));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,l.$eA)(this.n(s(d.VariableKind.WorkspaceFolder)));case"cwd":return i||c?(0,l.$eA)(this.n(s(d.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$eA)(w.$_d(this.n(s(d.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new d.$KM(d.VariableKind.UserHome,(0,S.localize)(11,null,p))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new d.$KM(d.VariableKind.LineNumber,(0,S.localize)(12,null,p))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new d.$KM(d.VariableKind.SelectedText,(0,S.localize)(13,null,p))}case"file":return E(d.VariableKind.File);case"fileWorkspaceFolder":return $(d.VariableKind.FileWorkspaceFolder);case"relativeFile":return i||c?w.$0d(this.n(s(d.VariableKind.RelativeFile)),E(d.VariableKind.RelativeFile)):E(d.VariableKind.RelativeFile);case"relativeFileDirname":{const a=w.$$d(E(d.VariableKind.RelativeFileDirname));if(i||c){const n=w.$0d(this.n(s(d.VariableKind.RelativeFileDirname)),a);return n.length===0?".":n}return a}case"fileDirname":return w.$$d(E(d.VariableKind.FileDirname));case"fileExtname":return w.$ae(E(d.VariableKind.FileExtname));case"fileBasename":return w.$_d(E(d.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=w.$_d(E(d.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-w.$ae(a).length)}case"fileDirnameBasename":return w.$_d(w.$$d(E(d.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||p}case"execInstallFolder":{const a=this.a.getAppRoot();return a||p}case"pathSeparator":return w.sep;default:try{const a=c?`${f}:${c}`:f;return this.p(d.VariableKind.Unknown,p,a,t,void 0)}catch{return p}}}}p(b,p,f,i,t){if(f&&i){const c=t===void 0?i[f]:i[t+":"+f];if(typeof c=="string")return c;throw new d.$KM(b,(0,S.localize)(14,null,p))}return p}}e.$YM=D}),define(Ae[103],Re([1,0,4,99]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7C=e.$6C=e.OpenEditorContext=e.GroupsOrder=e.$5C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$4C=void 0,e.$4C=(0,w.$Ah)("editorGroupsService");var C;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var L;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var S;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(S||(e.MergeGroupMode=S={}));function d(p){const f=p;return(0,F.$TE)(f?.editor)&&(0,F.$TE)(f?.replacement)}e.$5C=d;var P;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var D;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u(p){const f=p;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$6C=u;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$7C=b}),define(Ae[202],Re([1,0,4,103]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$C=e.$0C=e.$9C=e.$8C=void 0,e.$8C=(0,w.$Ah)("editorService"),e.$9C=-1,e.$0C=-2;function C(L){const A=L;return typeof L=="number"||(0,F.$6C)(A)}e.$$C=C}),define(Ae[8],Re([1,0,18,25,123,203,49,28,117,68,67,24,16,2,44,78,94,102,99,75,45,56,202,7]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E,$,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$WL=e.$VL=e.MarkdownString=e.$UL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ce){function Fe(H){const{selectionStartLineNumber:Me,selectionStartColumn:Be,positionLineNumber:Ge,positionColumn:We}=H,xe=new a.$YJ(Me-1,Be-1),pt=new a.$YJ(Ge-1,We-1);return new a.$1J(xe,pt)}Ce.to=Fe;function ge(H){const{anchor:Me,active:Be}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ce.from=ge})(n||(e.Selection=n={}));var o;(function(Ce){function Fe(H){if(!H)return;const{start:Me,end:Be}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ce.from=Fe;function ge(H){if(!H)return;const{startLineNumber:Me,startColumn:Be,endLineNumber:Ge,endColumn:We}=H;return new a.$ZJ(Me-1,Be-1,Ge-1,We-1)}Ce.to=ge})(o||(e.Range=o={}));var y;(function(Ce){function Fe(ge){switch(ge){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ce.to=Fe})(y||(e.TokenType=y={}));var m;(function(Ce){function Fe(H){return new a.$YJ(H.lineNumber-1,H.column-1)}Ce.to=Fe;function ge(H){return{lineNumber:H.line+1,column:H.character+1}}Ce.from=ge})(m||(e.Position=m={}));var I;(function(Ce){function Fe(Me,Be,Ge){return(0,w.$Eb)((0,w.$Zb)(Me).map(We=>ge(We,Be,Ge)))}Ce.from=Fe;function ge(Me,Be,Ge){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Ge?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,Be),pattern:st.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Ge?.isBuiltin}}function H(Me,Be){return Be&&typeof Me=="string"?Be.transformOutgoingScheme(Me):Me}})(I||(e.DocumentSelector=I={}));var k;(function(Ce){function Fe(H){switch(H){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ce.from=Fe;function ge(H){switch(H){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ce.to=ge})(k||(e.DiagnosticTag=k={}));var r;(function(Ce){function Fe(H){let Me;return H.code&&((0,u.$if)(H.code)||(0,u.$mf)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...o.from(H.range),message:H.message,source:H.source,code:Me,severity:v.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(h.from),tags:Array.isArray(H.tags)?(0,w.$Eb)(H.tags.map(k.from)):void 0}}Ce.from=Fe;function ge(H){const Me=new a.$_J(o.to(H),H.message,v.to(H.severity));return Me.source=H.source,Me.code=(0,u.$if)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(h.to),Me.tags=H.tags&&(0,w.$Eb)(H.tags.map(k.to)),Me}Ce.to=ge})(r||(e.Diagnostic=r={}));var h;(function(Ce){function Fe(H){return{...o.from(H.location.range),message:H.message,resource:H.location.uri}}Ce.from=Fe;function ge(H){return new a.$$J(new a.$0J(H.resource,o.to(H)),H.message)}Ce.to=ge})(h||(e.DiagnosticRelatedInformation=h={}));var v;(function(Ce){function Fe(H){switch(H){case a.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Ce.from=Fe;function ge(H){switch(H){case i.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ce.to=ge})(v||(e.DiagnosticSeverity=v={}));var R;(function(Ce){function Fe(H){return typeof H=="number"&&H>=a.ViewColumn.One?H-1:H===a.ViewColumn.Beside?s.$0C:s.$9C}Ce.from=Fe;function ge(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=ge})(R||(e.ViewColumn=R={}));function W(Ce){return typeof Ce.range<"u"}function V(Ce){return Ce.length===0?!0:!!W(Ce[0])}e.$UL=V;var U;(function(Ce){function Fe(We){return We.map(Ce.from)}Ce.fromMany=Fe;function ge(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function H(We){let xe;if(ge(We)){const{language:ft,value:mt}=We;xe={value:"```"+ft+`
`+mt+"\n```\n"}}else a.$mK.isMarkdownString(We)?xe={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?xe={value:We}:xe={value:""};const pt=Object.create(null);xe.uris=pt;const bt=ft=>{try{let mt=b.URI.parse(ft,!0);mt=mt.with({query:Me(mt.query,pt)}),pt[ft]=mt}catch{}return""},dt=new S.marked.Renderer;return dt.link=bt,dt.image=ft=>typeof ft=="string"?bt(A.$4j(ft).href):"",(0,S.marked)(xe.value,{renderer:dt}),xe}Ce.from=H;function Me(We,xe){if(!We)return We;let pt;try{pt=(0,d.$9g)(We)}catch{}if(!pt)return We;let bt=!1;return pt=(0,D.$Wm)(pt,dt=>{if(b.URI.isUri(dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[ft]=dt,bt=!0,ft}else return}),bt?JSON.stringify(pt):We}function Be(We){const xe=new a.$mK(We.value,We.supportThemeIcons);return xe.isTrusted=We.isTrusted,xe.supportHtml=We.supportHtml,xe.baseUri=We.baseUri?b.URI.from(We.baseUri):void 0,xe}Ce.to=Be;function Ge(We){if(We)return typeof We=="string"?We:Ce.from(We)}Ce.fromStrict=Ge})(U||(e.MarkdownString=U={}));function B(Ce){return V(Ce)?Ce.map(Fe=>({range:o.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?U.fromMany(Fe.hoverMessage):Fe.hoverMessage?U.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Ce.map(Fe=>({range:o.from(Fe)}))}e.$VL=B;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.$WL=O;var N;(function(Ce){function Fe(ge){return typeof ge>"u"?ge:{contentText:ge.contentText,contentIconPath:ge.contentIconPath?O(ge.contentIconPath):void 0,border:ge.border,borderColor:ge.borderColor,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,color:ge.color,backgroundColor:ge.backgroundColor,margin:ge.margin,width:ge.width,height:ge.height}}Ce.from=Fe})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var ee;(function(Ce){function Fe(ge){return typeof ge>"u"?ge:{backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?N.from(ge.before):void 0,after:ge.after?N.from(ge.after):void 0}}Ce.from=Fe})(ee||(e.ThemableDecorationRenderOptions=ee={}));var Y;(function(Ce){function Fe(ge){if(typeof ge>"u")return ge;switch(ge){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Fe})(Y||(e.DecorationRangeBehavior=Y={}));var Ee;(function(Ce){function Fe(ge){return{isWholeLine:ge.isWholeLine,rangeBehavior:ge.rangeBehavior?Y.from(ge.rangeBehavior):void 0,overviewRulerLane:ge.overviewRulerLane,light:ge.light?ee.from(ge.light):void 0,dark:ge.dark?ee.from(ge.dark):void 0,backgroundColor:ge.backgroundColor,outline:ge.outline,outlineColor:ge.outlineColor,outlineStyle:ge.outlineStyle,outlineWidth:ge.outlineWidth,border:ge.border,borderColor:ge.borderColor,borderRadius:ge.borderRadius,borderSpacing:ge.borderSpacing,borderStyle:ge.borderStyle,borderWidth:ge.borderWidth,fontStyle:ge.fontStyle,fontWeight:ge.fontWeight,textDecoration:ge.textDecoration,cursor:ge.cursor,color:ge.color,opacity:ge.opacity,letterSpacing:ge.letterSpacing,gutterIconPath:ge.gutterIconPath?O(ge.gutterIconPath):void 0,gutterIconSize:ge.gutterIconSize,overviewRulerColor:ge.overviewRulerColor,before:ge.before?N.from(ge.before):void 0,after:ge.after?N.from(ge.after):void 0}}Ce.from=Fe})(Ee||(e.DecorationRenderOptions=Ee={}));var ke;(function(Ce){function Fe(H){return{text:H.newText,eol:H.newEol&&Ze.from(H.newEol),range:o.from(H.range)}}Ce.from=Fe;function ge(H){const Me=new a.$5J(o.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:Ze.to(H.eol),Me}Ce.to=ge})(ke||(e.TextEdit=ke={}));var Pe;(function(Ce){function Fe(H,Me){const Be={edits:[]};if(H instanceof a.$8J){const Ge=new l.$zi;for(const We of H._allEntries())We._type===1&&b.URI.isUri(We.to)&&We.from===void 0&&Ge.add(We.to);for(const We of H._allEntries())if(We._type===1){let xe;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?xe={type:"base64",value:(0,F.$Yd)(F.$Ed.wrap(We.options.contents))}:xe={type:"dataTransferItem",id:We.options.contents._itemId}),Be.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:xe},metadata:We.metadata})}else We._type===2?Be.edits.push({resource:We.uri,textEdit:ke.from(We.edit),versionId:Ge.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Be.edits.push({resource:We.uri,textEdit:{range:o.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:Ge.has(We.uri)?void 0:Me?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Be.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Be.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Me?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(gt.from)}})}return Be}Ce.from=Fe;function ge(H){const Me=new a.$8J,Be=new l.$yi;for(const Ge of H.edits)if(Ge.textEdit){const We=Ge,xe=b.URI.revive(We.resource),pt=o.to(We.textEdit.range),bt=We.textEdit.text,dt=We.textEdit.insertAsSnippet;let ft;dt?ft=a.$7J.replace(pt,new a.$9J(bt)):ft=a.$5J.replace(pt,bt);const mt=Be.get(xe);mt?mt.push(ft):Be.set(xe,[ft])}else Me.renameFile(b.URI.revive(Ge.oldResource),b.URI.revive(Ge.newResource),Ge.options);for(const[Ge,We]of Be)Me.set(Ge,We);return Me}Ce.to=ge})(Pe||(e.WorkspaceEdit=Pe={}));var Z;(function(Ce){const Fe=Object.create(null);Fe[a.SymbolKind.File]=0,Fe[a.SymbolKind.Module]=1,Fe[a.SymbolKind.Namespace]=2,Fe[a.SymbolKind.Package]=3,Fe[a.SymbolKind.Class]=4,Fe[a.SymbolKind.Method]=5,Fe[a.SymbolKind.Property]=6,Fe[a.SymbolKind.Field]=7,Fe[a.SymbolKind.Constructor]=8,Fe[a.SymbolKind.Enum]=9,Fe[a.SymbolKind.Interface]=10,Fe[a.SymbolKind.Function]=11,Fe[a.SymbolKind.Variable]=12,Fe[a.SymbolKind.Constant]=13,Fe[a.SymbolKind.String]=14,Fe[a.SymbolKind.Number]=15,Fe[a.SymbolKind.Boolean]=16,Fe[a.SymbolKind.Array]=17,Fe[a.SymbolKind.Object]=18,Fe[a.SymbolKind.Key]=19,Fe[a.SymbolKind.Null]=20,Fe[a.SymbolKind.EnumMember]=21,Fe[a.SymbolKind.Struct]=22,Fe[a.SymbolKind.Event]=23,Fe[a.SymbolKind.Operator]=24,Fe[a.SymbolKind.TypeParameter]=25;function ge(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Ce.from=ge;function H(Me){for(const Be in Fe)if(Fe[Be]===Me)return Number(Be);return a.SymbolKind.Property}Ce.to=H})(Z||(e.SymbolKind=Z={}));var ue;(function(Ce){function Fe(H){switch(H){case a.SymbolTag.Deprecated:return 1}}Ce.from=Fe;function ge(H){switch(H){case 1:return a.SymbolTag.Deprecated}}Ce.to=ge})(ue||(e.SymbolTag=ue={}));var ye;(function(Ce){function Fe(H){return{name:H.name,kind:Z.from(H.kind),tags:H.tags&&H.tags.map(ue.from),containerName:H.containerName,location:q.from(H.location)}}Ce.from=Fe;function ge(H){const Me=new a.$cK(H.name,Z.to(H.kind),H.containerName,q.to(H.location));return Me.tags=H.tags&&H.tags.map(ue.to),Me}Ce.to=ge})(ye||(e.WorkspaceSymbol=ye={}));var ce;(function(Ce){function Fe(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:o.from(H.range),selectionRange:o.from(H.selectionRange),kind:Z.from(H.kind),tags:H.tags?.map(ue.from)??[]};return H.children&&(Me.children=H.children.map(Fe)),Me}Ce.from=Fe;function ge(H){const Me=new a.$dK(H.name,H.detail,Z.to(H.kind),o.to(H.range),o.to(H.selectionRange));return(0,w.$Ib)(H.tags)&&(Me.tags=H.tags.map(ue.to)),H.children&&(Me.children=H.children.map(ge)),Me}Ce.to=ge})(ce||(e.DocumentSymbol=ce={}));var $e;(function(Ce){function Fe(H){const Me=new a.$iK(Z.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function ge(H,Me,Be){if(Me=Me??H._sessionId,Be=Be??H._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,name:H.name,detail:H.detail,kind:Z.from(H.kind),uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ce.from=ge})($e||(e.CallHierarchyItem=$e={}));var ie;(function(Ce){function Fe(ge){return new a.$jK($e.to(ge.from),ge.fromRanges.map(H=>o.to(H)))}Ce.to=Fe})(ie||(e.CallHierarchyIncomingCall=ie={}));var z;(function(Ce){function Fe(ge){return new a.$kK($e.to(ge.to),ge.fromRanges.map(H=>o.to(H)))}Ce.to=Fe})(z||(e.CallHierarchyOutgoingCall=z={}));var q;(function(Ce){function Fe(H){return{range:H.range&&o.from(H.range),uri:H.uri}}Ce.from=Fe;function ge(H){return new a.$0J(b.URI.revive(H.uri),o.to(H.range))}Ce.to=ge})(q||(e.location=q={}));var le;(function(Ce){function Fe(H){const Me=H,Be=H;return{originSelectionRange:Me.originSelectionRange?o.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Be.uri,range:o.from(Me.targetRange?Me.targetRange:Be.range),targetSelectionRange:Me.targetSelectionRange?o.from(Me.targetSelectionRange):void 0}}Ce.from=Fe;function ge(H){return{targetUri:b.URI.revive(H.uri),targetRange:o.to(H.range),targetSelectionRange:H.targetSelectionRange?o.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?o.to(H.originSelectionRange):void 0}}Ce.to=ge})(le||(e.DefinitionLink=le={}));var we;(function(Ce){function Fe(H){return{range:o.from(H.range),contents:U.fromMany(H.contents)}}Ce.from=Fe;function ge(H){return new a.$aK(H.contents.map(U.to),o.to(H.range))}Ce.to=ge})(we||(e.Hover=we={}));var ve;(function(Ce){function Fe(H){return{range:o.from(H.range),expression:H.expression}}Ce.from=Fe;function ge(H){return new a.$7K(o.to(H.range),H.expression)}Ce.to=ge})(ve||(e.EvaluatableExpression=ve={}));var me;(function(Ce){function Fe(H){if(H instanceof a.$8K)return{type:"text",range:o.from(H.range),text:H.text};if(H instanceof a.$9K)return{type:"variable",range:o.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof a.$0K)return{type:"expression",range:o.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Fe;function ge(H){switch(H.type){case"text":return{range:o.to(H.range),text:H.text};case"variable":return{range:o.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:o.to(H.range),expression:H.expression}}}Ce.to=ge})(me||(e.InlineValue=me={}));var De;(function(Ce){function Fe(H){return{frameId:H.frameId,stoppedLocation:o.from(H.stoppedLocation)}}Ce.from=Fe;function ge(H){return new a.$$K(H.frameId,o.to(H.stoppedLocation))}Ce.to=ge})(De||(e.InlineValueContext=De={}));var ne;(function(Ce){function Fe(H){return{range:o.from(H.range),kind:H.kind}}Ce.from=Fe;function ge(H){return new a.$bK(o.to(H.range),H.kind)}Ce.to=ge})(ne||(e.DocumentHighlight=ne={}));var he;(function(Ce){function Fe(ge){switch(ge){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ce.to=Fe})(he||(e.CompletionTriggerKind=he={}));var se;(function(Ce){function Fe(ge){return{triggerKind:he.to(ge.triggerKind),triggerCharacter:ge.triggerCharacter}}Ce.to=Fe})(se||(e.CompletionContext=se={}));var oe;(function(Ce){function Fe(H){switch(H){case a.CompletionItemTag.Deprecated:return 1}}Ce.from=Fe;function ge(H){switch(H){case 1:return a.CompletionItemTag.Deprecated}}Ce.to=ge})(oe||(e.CompletionItemTag=oe={}));var fe;(function(Ce){const Fe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ge(Be){return Fe.get(Be)??9}Ce.from=ge;const H=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Me(Be){return H.get(Be)??a.CompletionItemKind.Property}Ce.to=Me})(fe||(e.CompletionItemKind=fe={}));var Ie;(function(Ce){function Fe(ge,H){const Me=new a.$sK(ge.label);return Me.insertText=ge.insertText,Me.kind=fe.to(ge.kind),Me.tags=ge.tags?.map(oe.to),Me.detail=ge.detail,Me.documentation=A.$Yj(ge.documentation)?U.to(ge.documentation):ge.documentation,Me.sortText=ge.sortText,Me.filterText=ge.filterText,Me.preselect=ge.preselect,Me.commitCharacters=ge.commitCharacters,p.$js.isIRange(ge.range)?Me.range=o.to(ge.range):typeof ge.range=="object"&&(Me.range={inserting:o.to(ge.range.insert),replacing:o.to(ge.range.replace)}),Me.keepWhitespace=typeof ge.insertTextRules>"u"?!1:!!(ge.insertTextRules&1),typeof ge.insertTextRules<"u"&&ge.insertTextRules&4?Me.insertText=new a.$9J(ge.insertText):(Me.insertText=ge.insertText,Me.textEdit=Me.range instanceof a.$ZJ?new a.$5J(Me.range,Me.insertText):void 0),ge.additionalTextEdits&&ge.additionalTextEdits.length>0&&(Me.additionalTextEdits=ge.additionalTextEdits.map(Be=>ke.to(Be))),Me.command=H&&ge.command?H.fromInternal(ge.command):void 0,Me}Ce.to=Fe})(Ie||(e.CompletionItem=Ie={}));var M;(function(Ce){function Fe(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:U.fromStrict(H.documentation)}}Ce.from=Fe;function ge(H){return{label:H.label,documentation:A.$Yj(H.documentation)?U.to(H.documentation):H.documentation}}Ce.to=ge})(M||(e.ParameterInformation=M={}));var K;(function(Ce){function Fe(H){return{label:H.label,documentation:U.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(M.from):[],activeParameter:H.activeParameter}}Ce.from=Fe;function ge(H){return{label:H.label,documentation:A.$Yj(H.documentation)?U.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(M.to):[],activeParameter:H.activeParameter}}Ce.to=ge})(K||(e.SignatureInformation=K={}));var G;(function(Ce){function Fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.from):[]}}Ce.from=Fe;function ge(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(K.to):[]}}Ce.to=ge})(G||(e.SignatureHelp=G={}));var X;(function(Ce){function Fe(ge,H){const Me=new a.$rK(m.to(H.position),typeof H.label=="string"?H.label:H.label.map(J.to.bind(void 0,ge)),H.kind&&x.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(ke.to),Me.tooltip=A.$Yj(H.tooltip)?U.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}Ce.to=Fe})(X||(e.InlayHint=X={}));var J;(function(Ce){function Fe(ge,H){const Me=new a.$qK(H.label);return Me.tooltip=A.$Yj(H.tooltip)?U.to(H.tooltip):H.tooltip,f.Command.is(H.command)&&(Me.command=ge.fromInternal(H.command)),H.location&&(Me.location=q.to(H.location)),Me}Ce.to=Fe})(J||(e.InlayHintLabelPart=J={}));var x;(function(Ce){function Fe(H){return H}Ce.from=Fe;function ge(H){return H}Ce.to=ge})(x||(e.InlayHintKind=x={}));var ae;(function(Ce){function Fe(H){return{range:o.from(H.range),url:H.target,tooltip:H.tooltip}}Ce.from=Fe;function ge(H){let Me;if(H.url)try{Me=typeof H.url=="string"?b.URI.parse(H.url,!0):b.URI.revive(H.url)}catch{}return new a.$xK(o.to(H.range),Me)}Ce.to=ge})(ae||(e.DocumentLink=ae={}));var Le;(function(Ce){function Fe(H){const Me=new a.$AK(H.label);return H.textEdit&&(Me.textEdit=ke.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(Be=>ke.to(Be))),Me}Ce.to=Fe;function ge(H){return{label:H.label,textEdit:H.textEdit?ke.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>ke.from(Me)):void 0}}Ce.from=ge})(Le||(e.ColorPresentation=Le={}));var je;(function(Ce){function Fe(H){return new a.$yK(H[0],H[1],H[2],H[3])}Ce.to=Fe;function ge(H){return[H.red,H.green,H.blue,H.alpha]}Ce.from=ge})(je||(e.Color=je={}));var Xe;(function(Ce){function Fe(H){return{range:o.from(H.range)}}Ce.from=Fe;function ge(H){return new a.$hK(o.to(H.range))}Ce.to=ge})(Xe||(e.SelectionRange=Xe={}));var He;(function(Ce){function Fe(ge){switch(ge){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ce.to=Fe})(He||(e.TextDocumentSaveReason=He={}));var et;(function(Ce){function Fe(H){switch(H){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Fe;function ge(H){switch(H){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ce.to=ge})(et||(e.TextEditorLineNumbersStyle=et={}));var Ze;(function(Ce){function Fe(H){if(H===a.EndOfLine.CRLF)return 1;if(H===a.EndOfLine.LF)return 0}Ce.from=Fe;function ge(H){if(H===1)return a.EndOfLine.CRLF;if(H===0)return a.EndOfLine.LF}Ce.to=ge})(Ze||(e.EndOfLine=Ze={}));var _e;(function(Ce){function Fe(ge){if(typeof ge=="object")return ge.viewId;switch(ge){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Fe})(_e||(e.ProgressLocation=_e={}));var it;(function(Ce){function Fe(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=tt.from(H.kind)),Me}Ce.from=Fe;function ge(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=tt.to(H.kind)),Me}Ce.to=ge})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Fe(H){if(H)switch(H){case a.FoldingRangeKind.Comment:return f.$$s.Comment;case a.FoldingRangeKind.Imports:return f.$$s.Imports;case a.FoldingRangeKind.Region:return f.$$s.Region}}Ce.from=Fe;function ge(H){if(H)switch(H.value){case f.$$s.Comment.value:return a.FoldingRangeKind.Comment;case f.$$s.Imports.value:return a.FoldingRangeKind.Imports;case f.$$s.Region.value:return a.FoldingRangeKind.Region}}Ce.to=ge})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Fe(ge){if(ge)return{pinned:typeof ge.preview=="boolean"?!ge.preview:void 0,inactive:ge.background,preserveFocus:ge.preserveFocus,selection:typeof ge.selection=="object"?o.from(ge.selection):void 0,override:typeof ge.override=="boolean"?c.$GE.id:void 0}}Ce.from=Fe})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Fe(Be){return Be instanceof a.$UK?Be.toJSON():typeof Be=="string"?Be:ge(Be)||H(Be)?new a.$UK(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ce.from=Fe;function ge(Be){const Ge=Be;return Ge?b.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function H(Be){const Ge=Be;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Me(Be){return typeof Be=="string"?Be:new a.$UK(b.URI.revive(Be.baseUri),Be.pattern)}Ce.to=Me})(st||(e.GlobPattern=st={}));var _;(function(Ce){function Fe(ge){if(ge){if(Array.isArray(ge))return ge.map(Fe);if(typeof ge=="string")return ge;{const H=ge;return{language:H.language,scheme:H.scheme,pattern:st.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ce.from=Fe})(_||(e.LanguageSelector=_={}));var Q;(function(Ce){function Fe(H){return!!H&&typeof H=="object"&&"selections"in H&&Array.isArray(H.selections)&&H.selections.every(Me=>Me instanceof a.$1J)&&"related"in H&&Array.isArray(H.related)&&H.related.every(Me=>Me&&typeof Me=="object"&&b.URI.isUri(Me.uri)&&Me.range instanceof a.$ZJ)}Ce.is=Fe;function ge(H){return{selections:H.selections.map(Me=>n.from(Me)),related:H.related.map(Me=>({uri:b.URI.from(Me.uri),range:o.from(Me.range)}))}}Ce.from=ge})(Q||(e.MappedEditsContext=Q={}));var pe;(function(Ce){function Fe(H){return{start:H.start,end:H.end}}Ce.from=Fe;function ge(H){return new a.$jL(H.start,H.end)}Ce.to=ge})(pe||(e.NotebookRange=pe={}));var Ue;(function(Ce){function Fe(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ce.to=Fe;function ge(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ce.from=ge})(Ue||(e.NotebookCellExecutionSummary=Ue={}));var Ne;(function(Ce){function Fe(ge){if(ge===g.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(ge===g.NotebookCellExecutionState.Pending)return;if(ge===g.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ge}`)}Ce.to=Fe})(Ne||(e.NotebookCellExecutionState=Ne={}));var Qe;(function(Ce){function Fe(H){switch(H){case a.NotebookCellKind.Markup:return g.CellKind.Markup;case a.NotebookCellKind.Code:default:return g.CellKind.Code}}Ce.from=Fe;function ge(H){switch(H){case g.CellKind.Markup:return a.NotebookCellKind.Markup;case g.CellKind.Code:default:return a.NotebookCellKind.Code}}Ce.to=ge})(Qe||(e.NotebookCellKind=Qe={}));var nt;(function(Ce){function Fe(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const Be of H.cells)a.$kL.validate(Be),Me.cells.push(gt.from(Be));return Me}Ce.from=Fe;function ge(H){const Me=new a.$lL(H.cells.map(gt.to));return(0,u.$vf)(H.metadata)||(Me.metadata=H.metadata),Me}Ce.to=ge})(nt||(e.NotebookData=nt={}));var gt;(function(Ce){function Fe(H){return{cellKind:Qe.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:Ue.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Mt.from):[]}}Ce.from=Fe;function ge(H){return new a.$kL(Qe.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Mt.to):void 0,H.metadata,H.internalMetadata?Ue.to(H.internalMetadata):void 0)}Ce.to=ge})(gt||(e.NotebookCellData=gt={}));var vt;(function(Ce){function Fe(H){return{mime:H.mime,valueBytes:F.$Ed.wrap(H.data)}}Ce.from=Fe;function ge(H){return new a.$mL(H.valueBytes.buffer,H.mime)}Ce.to=ge})(vt||(e.NotebookCellOutputItem=vt={}));var Mt;(function(Ce){function Fe(H){return{outputId:H.id,items:H.items.map(vt.from),metadata:H.metadata}}Ce.from=Fe;function ge(H){const Me=H.items.map(vt.to);return new a.$nL(Me,H.outputId,H.metadata)}Ce.to=ge})(Mt||(e.NotebookCellOutput=Mt={}));var Qt;(function(Ce){function Fe(Me){return H(Me)?{include:st.from(Me.include)??void 0,exclude:st.from(Me.exclude)??void 0}:st.from(Me)??void 0}Ce.from=Fe;function ge(Me){return H(Me)?{include:st.to(Me.include),exclude:st.to(Me.exclude)}:st.to(Me)}Ce.to=ge;function H(Me){const Be=Me;return Be?!(0,u.$rf)(Be.include)&&!(0,u.$rf)(Be.exclude):!1}})(Qt||(e.NotebookExclusiveDocumentPattern=Qt={}));var Vt;(function(Ce){function Fe(ge,H,Me){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{alignment:ge.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Be,Me),text:ge.text,tooltip:ge.tooltip,accessibilityInformation:ge.accessibilityInformation,priority:ge.priority}}Ce.from=Fe})(Vt||(e.NotebookStatusBarItem=Vt={}));var wt;(function(Ce){function Fe(ge,H,Me){const Be=typeof ge.command=="string"?{title:"",command:ge.command}:ge.command;return{command:H.toInternal(Be,Me),label:ge.label,description:ge.description,detail:ge.detail,documentation:ge.documentation}}Ce.from=Fe})(wt||(e.NotebookKernelSourceAction=wt={}));var Tt;(function(Ce){function Fe(ge){return{transientOutputs:ge?.transientOutputs??!1,transientCellMetadata:ge?.transientCellMetadata??{},transientDocumentMetadata:ge?.transientDocumentMetadata??{},cellContentMetadata:ge?.cellContentMetadata??{}}}Ce.from=Fe})(Tt||(e.NotebookDocumentContentOptions=Tt={}));var Ot;(function(Ce){function Fe(H){return{uri:H.uri,provides:H.provides}}Ce.from=Fe;function ge(H){return new a.$pL(b.URI.revive(H.uri),H.provides)}Ce.to=ge})(Ot||(e.NotebookRendererScript=Ot={}));var Jt;(function(Ce){function Fe(H){return{message:U.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:o.from(H.location.range),uri:H.location.uri}}}Ce.from=Fe;function ge(H){const Me=new a.$vL(typeof H.message=="string"?H.message:U.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?q.to(H.location):void 0,Me}Ce.to=ge})(Jt||(e.TestMessage=Jt={}));var Pt;(function(Ce){Ce.namespace=$.$MI,Ce.denamespace=$.$NI})(Pt||(e.TestTag=Pt={}));var At;(function(Ce){function Fe(H){const Me=(0,t.$TL)(H).controllerId;return{extId:E.$II.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:b.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Be=>Pt.namespace(Me,Be.id)),range:p.$js.lift(o.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&U.fromStrict(H.error)||null}}Ce.from=Fe;function ge(H){return{parent:void 0,error:void 0,id:E.$II.fromString(H.extId).localId,label:H.label,uri:b.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:Be}=Pt.denamespace(Me);return new a.$wL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ce.toPlain=ge})(At||(e.TestItem=At={})),function(Ce){function Fe(H){return{id:H.id}}Ce.from=Fe;function ge(H){return new a.$wL(H.id)}Ce.to=ge}(Pt||(e.TestTag=Pt={}));var Nt;(function(Ce){const Fe=(H,Me)=>{const Be=[];for(const[We,xe]of Me)E.$II.compare(xe.item.extId,We)===2&&(Me.delete(We),Be.push(xe));const Ge={...At.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(xe=>xe.type===0).map(Jt.to)})),children:Be.map(We=>Fe(We,Me))};for(const We of Ge.children)We.parent=Ge;return Ge};function ge(H){const Me=[],Be=new Map;for(const Ge of H.items){Be.set(Ge.item.extId,Ge);const We=E.$II.root(Ge.item.extId);H.request.targets.some(xe=>xe.controllerId===We&&xe.testIds.includes(Ge.item.extId))&&Me.push(Ge)}return{completedAt:H.completedAt,results:Me.map(Ge=>Fe(Ge,Be))}}Ce.to=ge})(Nt||(e.TestResults=Nt={}));var Ut;(function(Ce){function Fe(Be){return{covered:Be.covered,total:Be.covered}}function ge(Be){return"line"in Be?m.from(Be):o.from(Be)}function H(Be){return"branches"in Be?{count:Be.executionCount,location:ge(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&ge(Ge.location)})):void 0}:{type:0,count:Be.executionCount,location:ge(Be.location)}}Ce.fromDetailed=H;function Me(Be){return{uri:Be.uri,statement:Fe(Be.statementCoverage),branch:Be.branchCoverage&&Fe(Be.branchCoverage),function:Be.functionCoverage&&Fe(Be.functionCoverage),details:Be.detailedCoverage?.map(H)}}Ce.fromFile=Me})(Ut||(e.TestCoverage=Ut={}));var qt;(function(Ce){function Fe(ge){switch(ge){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ce.to=Fe})(qt||(e.CodeActionTriggerKind=qt={}));var Bt;(function(Ce){function Fe(H){const Me=new a.$CL(Z.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),o.to(H.range),o.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}Ce.to=Fe;function ge(H,Me,Be){if(Me=Me??H._sessionId,Be=Be??H._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,kind:Z.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:o.from(H.range),selectionRange:o.from(H.selectionRange),tags:H.tags?.map(ue.from)}}Ce.from=ge})(Bt||(e.TypeHierarchyItem=Bt={}));var at;(function(Ce){function Fe(ge){if(ge)return{value:ge.value,tooltip:ge.tooltip}}Ce.from=Fe})(at||(e.ViewBadge=at={}));var ut;(function(Ce){function Fe(Be,Ge,We){const xe=Ge.fileData;return xe?new a.$NK(new a.$OK(xe.name,b.URI.revive(xe.uri),xe.id,(0,L.$bb)(()=>We(xe.id)))):Be===P.$Gr.uriList&&Ge.uriListData?new a.$MK(Me(Ge.uriListData)):new a.$MK(Ge.asString)}Ce.to=Fe;async function ge(Be,Ge){const We=await Ge.asString();if(Be===P.$Gr.uriList)return{asString:We,fileData:void 0,uriListData:H(We)};const xe=Ge.asFile();return{asString:We,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}Ce.from=ge;function H(Be){return C.$Ss.split(Be).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return b.URI.parse(Ge)}catch{}return Ge})}function Me(Be){return C.$Ss.create(Be.map(Ge=>typeof Ge=="string"?Ge:b.URI.revive(Ge)))}})(ut||(e.DataTransferItem=ut={}));var Ht;(function(Ce){function Fe(H,Me){const Be=H.items.map(([Ge,We])=>[Ge,ut.to(Ge,We,Me)]);return new a.$PK(Be)}Ce.toDataTransfer=Fe;async function ge(H){const Me={items:[]},Be=[];for(const[Ge,We]of H)Be.push((async()=>{Me.items.push([Ge,await ut.from(Ge,We)])})());return await Promise.all(Be),Me}Ce.from=ge})(Ht||(e.DataTransfer=Ht={}));var Ct;(function(Ce){function Fe(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.to=Fe;function ge(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ce.from=ge})(Ct||(e.ChatReplyFollowup=Ct={}));var kt;(function(Ce){function Fe(ge){return typeof ge=="string"?{title:ge,message:ge,kind:"reply"}:"commandId"in ge?{kind:"command",title:ge.title??"",commandId:ge.commandId??"",when:ge.when??"",args:ge.args}:Ct.from(ge)}Ce.from=Fe})(kt||(e.ChatFollowup=kt={}));var ht;(function(Ce){function Fe(H){const Me=new a.$ML(St.to(H.role),H.content);return Me.name=H.name,Me}Ce.to=Fe;function ge(H){return{role:St.from(H.role),content:H.content,name:H.name}}Ce.from=ge})(ht||(e.ChatMessage=ht={}));var St;(function(Ce){function Fe(H){switch(H){case 0:return a.ChatMessageRole.System;case 1:return a.ChatMessageRole.User;case 2:return a.ChatMessageRole.Assistant;case 3:return a.ChatMessageRole.Function}}Ce.to=Fe;function ge(H){switch(H){case a.ChatMessageRole.System:return 0;case a.ChatMessageRole.Assistant:return 2;case a.ChatMessageRole.Function:return 3;case a.ChatMessageRole.User:default:return 1}}Ce.from=ge})(St||(e.ChatMessageRole=St={}));var Lt;(function(Ce){function Fe(H){return{level:Et.to(H.level),value:H.value,description:H.description}}Ce.to=Fe;function ge(H){return{level:Et.from(H.level),value:H.value,description:H.description}}Ce.from=ge})(Lt||(e.ChatVariable=Lt={}));var Et;(function(Ce){function Fe(H){switch(H){case"short":return a.ChatVariableLevel.Short;case"medium":return a.ChatVariableLevel.Medium;case"full":default:return a.ChatVariableLevel.Full}}Ce.to=Fe;function ge(H){switch(H){case a.ChatVariableLevel.Short:return"short";case a.ChatVariableLevel.Medium:return"medium";case a.ChatVariableLevel.Full:default:return"full"}}Ce.from=ge})(Et||(e.ChatVariableLevel=Et={}));var qe;(function(Ce){function Fe(ge){switch(ge){case 1:return a.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return a.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return a.InteractiveEditorResponseFeedbackKind.Undone;case 3:return a.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Fe})(qe||(e.InteractiveEditorResponseFeedbackKind=qe={}));var zt;(function(Ce){function Fe(ge,H,Me){return"terminalCommand"in ge?{terminalCommand:ge.terminalCommand}:"uri"in ge?{uri:ge.uri}:H.toInternal(ge,Me)}Ce.from=Fe})(zt||(e.TerminalQuickFix=zt={}))}),define(Ae[204],Re([1,0,2,9,7,8,174]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;class l{constructor(d,P,D,u={timeout:1500,errors:3}){this.c=d,this.d=P,this.f=D,this.g=u,this.a=new A.$sc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(d){return(P,D,u)=>{const p={dispose:this.a.push([P,D,d])};return Array.isArray(u)&&u.push(p),p}}async $participateInSave(d,P){const D=w.URI.revive(d);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),p=[];try{for(const f of[...this.a]){if(u)break;const i=this.d.getDocument(D),t=await this.h(f,{document:i,reason:L.TextDocumentSaveReason.to(P)});p.push(t)}}finally{clearTimeout(b)}return p}h([d,P,D],u){const b=this.b.get(d);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,d,P,u).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const f=this.b.get(d);this.b.set(d,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(d,P,D,u){const b=[],p=Date.now(),{document:f,reason:i}=u,{version:t}=f,c=Object.freeze({document:f,reason:i,waitUntil(g){if(Object.isFrozen(b))throw(0,F.$6)("waitUntil can not be called async");b.push(Promise.resolve(g))}});try{P.apply(D,[c])}catch(g){return Promise.reject(g)}return Object.freeze(b),new Promise((g,E)=>{const $=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(b).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout($),g(s)}).catch(s=>{clearTimeout($),E(s)})}).then(g=>{const E={edits:[]};for(const $ of g)if(Array.isArray($)&&$.every(s=>s instanceof C.$5J))for(const{newText:s,newEol:a,range:n}of $)E.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:n&&L.Range.from(n),text:s,eol:a&&L.EndOfLine.from(a)}});if(E.edits.length!==0)return t===f.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.$$ac=l}),define(Ae[205],Re([1,0,12,2,8,7,75]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=void 0;class l{constructor(D,u,b,p){this.start=D,this.deletedCount=u,this.deletedItems=b,this.items=p}asApiEvent(){return{range:new L.$jL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class S{static asModelAddData(D,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,u,b){this.notebook=D,this.h=u,this.j=b,this.handle=b.handle,this.uri=F.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(C.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return D.g},set mime(p){D.g=p},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,u,b){const p=b.map(C.NotebookCellOutputItem.to),f=this.a.find(i=>i.id===D);if(f&&(u||(f.items.length=0),f.items.push(...p),f.items.length>1&&f.items.every(i=>A.$3H(i.mime)))){const i=new Map,t=[];f.items.forEach(c=>{let g;i.has(c.mime)?g=i.get(c.mime):(g=[],i.set(c.mime,g),t.push(c.mime)),g.push(c.data)}),f.items.length=0,t.forEach(c=>{const g=A.$4H(i.get(c));f.items.push({mime:c,data:g.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$lcc=S;class d{static{this.a=0}constructor(D,u,b,p,f){this.k=D,this.l=u,this.m=b,this.uri=p,this.handle=d.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,u={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===w.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(f=>f.apiCell)},save(){return D.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,u,b){this.g=D.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const p={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},f=[];for(const t of D.rawEvents)t.kind===A.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,p.contentChanges):t.kind===A.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,p.contentChanges):t.kind===A.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),f.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===A.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),f.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),f.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===A.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),f.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),f.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const i=new Map;for(let t=0;t<f.length;t++){const c=f[t],g=i.get(c.cell);if(g===void 0){const E=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});i.set(c.cell,E-1)}else p.cellChanges[g]={...p.cellChanges[g],...c}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let u=D.start|0,b=D.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),D.with({start:u,end:b})}p(D){D=this.o(D);const u=[];for(let b=D.start;b<D.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,u,b){if(this.j)return;const p=[],f=[],i=[];if(D.reverse().forEach(t=>{const g=t[2].map(s=>{const a=new S(this,this.l,s);return u||f.push(S.asModelAddData(this.apiNotebook,s)),a}),E=new l(t[0],t[1],[],g),$=this.b.splice(t[0],t[1],...g);for(const s of $)i.push(s.uri),E.deletedItems.push(s.apiCell);p.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:i}),b)for(const t of p)b.push(t.asApiEvent())}s(D,u,b,p){const f=this.b.splice(D,u);this.b.splice(b,0,...f);const i=[new l(D,u,f.map(t=>t.apiCell),[]),new l(b,0,[],f)];for(const t of i)p.push(t.asApiEvent())}t(D,u){this.b[D].setOutputs(u)}u(D,u,b,p){this.b[D].setOutputItems(u,b,p)}v(D,u){const b=this.b[D];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(D,u){const b=this.b[D];b.apiCell.mime=u}x(D,u){this.b[D].setMetadata(u)}y(D,u){this.b[D].setInternalMetadata(u)}getCellFromApiCell(D){return this.b.find(u=>u.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(u=>u.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$mcc=d}),define(Ae[206],Re([1,0,5,2,8,7]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class A{constructor(S,d,P,D={timeout:1500,errors:3}){this.b=S,this.c=d,this.d=P,this.f=D,this.a=new w.$gd}dispose(){}getOnWillSaveNotebookDocumentEvent(S){return(d,P,D)=>{const u=function(p){d.call(P,p)};return u.extension=S,this.a.event(u,void 0,D)}}async $participateInSave(S,d,P){const D=F.URI.revive(S),u=this.c.getNotebookDocument(D);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:C.TextDocumentSaveReason.to(d)},P,async(f,i)=>{const t=Date.now(),c=await await Promise.resolve(f);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",i.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof L.$8J?b.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",i.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(b.length===0)return!0;const p={edits:[]};for(const f of b){const{edits:i}=C.WorkspaceEdit.from(f);p.edits=p.edits.concat(i)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$Mcc=A}),define(Ae[104],Re([1,0,9,8,7]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,S,d,P,D,u){this.id=l,this.f=S,this.notebookData=d,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=P,this.c=u}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(S){this.selections=[S]},get selections(){return l.a},set selections(S){if(!Array.isArray(S)||!S.every(C.$jL.isNotebookRange))throw(0,w.$5)("selections");l.a=S,l.g(S)},get visibleRanges(){return l.b},revealRange(S,d){l.f.$tryRevealRange(l.id,F.NotebookRange.from(S),d??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(F.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$ncc=L}),define(Ae[207],Re([1,0,9,5,14,8]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;let A=class{constructor(S,d){this.c=S,this.d=d,this.a=new F.$ed({onListenerError:w.$Z}),this.b=new F.$ed({onListenerError:w.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(S,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",S,d);const P=this.d.getEditorById(S);d.visibleRanges&&P._acceptVisibleRanges(d.visibleRanges.ranges.map(L.NotebookRange.to)),d.selections&&P._acceptSelections(d.selections.selections.map(L.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(S){for(const d in S)this.d.getEditorById(d)._acceptViewColumn(L.ViewColumn.to(S[d]))}};e.$Fcc=A,e.$Fcc=A=Ke([Ve(0,C.$4i)],A)}),define(Ae[208],Re([1,0,8,72,153,21,64,9]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class S{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,b,p){const f=this.b++,{title:i,location:t,cancellable:c}=b,g={label:(0,C.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(f,{location:w.ProgressLocation.from(t),title:i,source:g,cancellable:c},u.isUnderDevelopment?void 0:u.identifier.value).catch(l.$Z),this.d(f,p,!!c)}d(u,b,p){let f;p&&(f=new L.$od,this.c.set(u,f));const i=c=>{this.a.$progressEnd(c),this.c.delete(c),f?.dispose()};let t;try{t=b(new P(this.a,u),p&&f?f.token:L.CancellationToken.None)}catch(c){throw i(u),c}return t.then(c=>i(u),c=>i(u)),t}$acceptProgressCanceled(u){const b=this.c.get(u);b&&(b.cancel(),this.c.delete(u))}}e.$Jbc=S;function d(D,u){return D.message=u.message,typeof u.increment=="number"&&(typeof D.increment=="number"?D.increment+=u.increment:D.increment=u.increment),D}class P extends F.$3u{constructor(u,b){super(p=>this.throttledReport(p)),this.f=u,this.g=b}throttledReport(u){this.f.$progressReport(this.g,u)}}Ke([(0,A.$7g)(100,(D,u)=>d(D,u),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ae[105],Re([1,0,44,102,45,76,56,8,2]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aM=e.$_L=e.$$L=e.$0L=void 0;const d=(g,E,$,s)=>{let a=E;return{enumerable:!0,configurable:!1,get(){return a},set(n){if(!$(a,n)){const o=a;a=n,g.listener?.(s(n,o))}}}},P=(g,E)=>g===E,D={range:(g,E)=>g===E?!0:!g||!E?!1:g.isEqual(E),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(g,E)=>!(g.length!==E.length||g.some($=>!E.find(s=>$.id===s.id)))},u=g=>E=>({op:4,update:g(E)}),b=(g,E)=>({range:(()=>{let $;const s=u(a=>({range:w.$js.lift(l.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return $},set(a){g.listener?.({op:6}),D.range($,a)||($=a,g.listener?.(s(a)))}}})(),label:d(g,E,D.label,u($=>({label:$}))),description:d(g,void 0,D.description,u($=>({description:$}))),sortText:d(g,void 0,D.sortText,u($=>({sortText:$}))),canResolveChildren:d(g,!1,D.canResolveChildren,$=>({op:2,state:$})),busy:d(g,!1,D.busy,u($=>({busy:$}))),error:d(g,void 0,D.error,u($=>({error:l.MarkdownString.fromStrict($)||null}))),tags:d(g,[],D.tags,($,s)=>({op:1,new:$.map(l.TestTag.from),old:s.map(l.TestTag.from)}))}),p=g=>{const E=C.$II.fromString(g.extId),$=new i(E.controllerId,E.localId,g.label,S.URI.revive(g.uri)||void 0);return $.range=l.Range.to(g.range||void 0),$.description=g.description||void 0,$.sortText=g.sortText||void 0,$.tags=g.tags.map(s=>l.TestTag.to({id:(0,A.$NI)(s).tagId})),$},f=g=>{let E;for(const $ of g.tests){const s=p($.item);(0,F.$TL)(s).parent=E,E=s}return E};e.$0L=f;class i{constructor(E,$,s,a){if($.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify($)} symbol`);const n=(0,F.$SL)(this,E);Object.defineProperties(this,{id:{value:$,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof t?void 0:n.parent}},children:{value:(0,L.$RL)(n,F.$TL,i),enumerable:!0,writable:!1},...b(n,s)})}}e.$$L=i;class t extends i{constructor(E,$){super(E,E,$,void 0),this._isRoot=!0}}e.$_L=t;class c extends L.$NL{constructor(E,$,s){super({controllerId:E,getDocumentVersion:a=>a&&s.getDocument(a)?.version,getApiFor:F.$TL,getChildren:a=>a.children,root:new t(E,$),toITestItem:l.TestItem.from})}}e.$aM=c}),define(Ae[106],Re([1,0,50,9,88,8,7]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$6L=e.$5L=void 0;class l{static{this.c=new C.$3L("TextEditorDecorationType")}constructor(u,b,p){const f=l.c.nextId();u.$registerTextEditorDecorationType(b.identifier,f,L.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:f,dispose(){u.$removeTextEditorDecorationType(f)}})}}e.$5L=l;class S{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let p=null;if(u instanceof A.$YJ)p=new A.$ZJ(u,u);else if(u instanceof A.$ZJ)p=u;else throw new Error("Unrecognized location");this.l(p,b,!1)}insert(u,b){this.k(),this.l(new A.$ZJ(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof A.$ZJ)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,p){const f=this.c.validateRange(u);this.g.push({range:f,text:b,forceMoveMarkers:p})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,F.$5)("endOfLine");this.h=u}}class d{constructor(u,b,p,f){this.c=u,this.d=b,this._accept(p),this.e=f;const i=this;this.value={get tabSize(){return i.f},set tabSize(t){i.m(t)},get indentSize(){return i.g},set indentSize(t){i.o(t)},get insertSpaces(){return i.h},set insertSpaces(t){i.q(t)},get cursorStyle(){return i.j},set cursorStyle(t){i.s(t)},get lineNumbers(){return i.k},set lineNumbers(t){i.t(t)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}m(u){const b=this.l(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}o(u){const b=this.n(u);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const b=this.p(u);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let p=!1;if(typeof u.tabSize<"u"){const f=this.l(u.tabSize);f==="auto"?(p=!0,b.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,p=!0,b.tabSize=f)}if(typeof u.indentSize<"u"){const f=this.n(u.indentSize);f==="tabSize"?(p=!0,b.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,p=!0,b.indentSize=f)}if(typeof u.insertSpaces<"u"){const f=this.p(u.insertSpaces);f==="auto"?(p=!0,b.insertSpaces=f):this.h!==f&&(this.h=f,p=!0,b.insertSpaces=f)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,p=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,p=!0,b.lineNumbers=L.TextEditorLineNumbersStyle.from(u.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(u,b){b.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(p)})}}e.$6L=d;class P{constructor(u,b,p,f,i,t,c,g){this.id=u,this.j=b,this.k=p,this.g=!1,this.h=new Set,this.c=i,this.d=new d(this.j,this.id,t,p),this.e=c,this.f=g;const E=this;this.value=Object.freeze({get document(){return f.value},set document($){throw new F.$7("document")},get selection(){return E.c&&E.c[0]},set selection($){if(!($ instanceof A.$1J))throw(0,F.$5)("selection");E.c=[$],E.l()},get selections(){return E.c},set selections($){if(!Array.isArray($)||$.some(s=>!(s instanceof A.$1J)))throw(0,F.$5)("selections");E.c=$,E.l()},get visibleRanges(){return E.e},set visibleRanges($){throw new F.$7("visibleRanges")},get options(){return E.d.value},set options($){E.g||E.d.assign($)},get viewColumn(){return E.f},set viewColumn($){throw new F.$7("viewColumn")},edit($,s={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new S(f.value,s);return $(a),E.m(a)},insertSnippet($,s,a={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!s||Array.isArray(s)&&s.length===0)n=E.c.map(o=>L.Range.from(o));else if(s instanceof A.$YJ){const{lineNumber:o,column:y}=L.Position.from(s);n=[{startLineNumber:o,startColumn:y,endLineNumber:o,endColumn:y}]}else if(s instanceof A.$ZJ)n=[L.Range.from(s)];else{n=[];for(const o of s)if(o instanceof A.$ZJ)n.push(L.Range.from(o));else{const{lineNumber:y,column:m}=L.Position.from(o);n.push({startLineNumber:y,startColumn:m,endLineNumber:y,endColumn:m})}}return b.$tryInsertSnippet(u,f.value.version,$.value,n,a)},setDecorations($,s){const a=s.length===0;a&&!E.h.has($.key)||(a?E.h.delete($.key):E.h.add($.key),E.n(()=>{if(L.$UL(s))return b.$trySetDecorations(u,$.key,L.$VL(s));{const n=new Array(4*s.length);for(let o=0,y=s.length;o<y;o++){const m=s[o];n[4*o]=m.start.line+1,n[4*o+1]=m.start.character+1,n[4*o+2]=m.end.line+1,n[4*o+3]=m.end.character+1}return b.$trySetDecorationsFast(u,$.key,n)}}))},revealRange($,s){E.n(()=>b.$tryRevealRange(u,L.Range.from($),s||A.TextEditorRevealType.Default))},show($){b.$tryShowEditor(u,L.ViewColumn.from($))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,w.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,w.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,w.ok)(!this.g),this.f=u}_acceptSelections(u){(0,w.ok)(!this.g),this.c=u}async l(){const u=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(i=>i.range);p.sort((i,t)=>i.end.line===t.end.line?i.end.character===t.end.character?i.start.line===t.start.line?i.start.character-t.start.character:i.start.line-t.start.line:i.end.character-t.end.character:i.end.line-t.end.line);for(let i=0,t=p.length-1;i<t;i++){const c=p[i].end;if(p[i+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=b.edits.map(i=>({range:L.Range.from(i.range),text:i.text,forceMoveMarkers:i.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,f,{setEndOfLine:typeof b.setEndOfLine=="number"?L.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$7L=P}),define(Ae[209],Re([1,0,4,172]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=void 0,e.$aJ=(0,w.$Bh)(F.$Hh)}),define(Ae[107],Re([1,0,20,5,19,6]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m3b=e.$l3b=e.$k3b=e.$j3b=e.$i3b=e.$h3b=void 0;class A{constructor(t,c){this.versionId=t,this.removedDueToLooping=c}}e.$h3b=A;class l{static isHostExtension(t,c,g){if(c.getExtensionDescription(t))return!1;const E=g.getExtensionDescription(t);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(t,c){this.j=t,this.c=new F.$ed,this.onDidChange=this.c.event,this.d=0,this.e=c,this.k()}k(){this.e.sort(p),this.f=new w.$Wl,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const c=this.j.readActivationEvents(t);if(Array.isArray(c))for(let g of c)g==="onUri"&&(g=`onUri:${w.$Ul.toKey(t.identifier)}`),this.h.has(g)||this.h.set(g,[]),this.h.get(g).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,c){this.e=f(this.e,c),this.e=this.e.concat(t);const g=l.l(this.e);return this.e=f(this.e,g.map(E=>E.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,g)}static l(t){const c=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,n){this.addNode(a),this.addNode(n),this.c.has(a)?this.c.get(a).push(n):this.c.set(a,[n])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,n){const o=c.getArcs(a);for(let y=0;y<o.length;y++)if(!n.has(o[y]))return!1;return!0}getNodes(){return this.e}},g=new w.$Wl;for(const a of t)if(g.set(a.identifier,a),a.extensionDependencies)for(const n of a.extensionDependencies)c.addArc(w.$Ul.toKey(a.identifier),w.$Ul.toKey(n));const E=new Set;c.getNodes().filter(a=>c.getArcs(a).length===0).forEach(a=>E.add(a));const $=c.getNodes().filter(a=>!E.has(a));let s;do{s=!1;for(let a=0;a<$.length;a++){const n=$[a];c.hasOnlyGoodArcs(n,E)&&($.splice(a,1),a--,E.add(n),s=!0)}}while(s);return $.map(a=>g.get(a))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const c=this.h.get(t);return c?c.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new S(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const c=this.f.get(t);return c||void 0}getExtensionDescriptionByUUID(t){for(const c of this.g)if(c.uuid===t)return c}getExtensionDescriptionByIdOrUUID(t,c){return this.getExtensionDescription(t)??(c?this.getExtensionDescriptionByUUID(c):void 0)}}e.$i3b=l;class S{constructor(t,c){this.versionId=t,this.extensions=c}}e.$j3b=S,e.$k3b={readActivationEvents:i=>i.activationEvents};class d{constructor(t){this.d=new u,this.c=new l(t,[])}async acquireLock(t){const c=await this.d.acquire(t);return new P(this,c)}deltaExtensions(t,c,g){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(c,g)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,c){return this.c.getExtensionDescriptionByIdOrUUID(t,c)}}e.$l3b=d;class P extends L.$jc{constructor(t,c){super(),this.f=t,this.c=!1,this.B(c)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$m3b=P;class D{constructor(t){this.name=t,this.promise=new Promise((c,g)=>{this.c=c})}resolve(t){this.c(t)}}class u{constructor(){this.c=[],this.d=!1}async acquire(t){const c=new D(t);return this.c.push(c),this.e(),c.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let c=!0;const g=setTimeout(()=>{c&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),E=()=>{c&&(clearTimeout(g),c=!1,this.d=!1,this.e())};t.resolve((0,L.$hc)(E))}}var b;(function(i){i[i.Builtin=0]="Builtin",i[i.User=1]="User",i[i.Dev=2]="Dev"})(b||(b={}));function p(i,t){const c=i.isBuiltin?0:i.isUnderDevelopment?2:1,g=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(c!==g)return c-g;const E=C.$5d.basename(i.extensionLocation.path),$=C.$5d.basename(t.extensionLocation.path);return E<$?-1:E>$?1:0}function f(i,t){const c=new w.$Vl(t);return i.filter(g=>!c.has(g.identifier))}}),define(Ae[79],Re([1,0,25]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$4l=e.$3l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(F||(e.UIKind=F={}));var C;(function(d){d[d.VersionMismatch=55]="VersionMismatch",d[d.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var L;(function(d){d[d.Initialized=0]="Initialized",d[d.Ready=1]="Ready",d[d.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(d){const P=w.$Ed.alloc(1);switch(d){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$3l=A;function l(d,P){if(d.byteLength!==1)return!1;switch(d.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$4l=l;var S;(function(d){d.Start="START_NATIVE_LOG",d.End="END_NATIVE_LOG"})(S||(e.NativeLogMarkers=S={}))}),define(Ae[57],Re([1,0,4,5,14,27,79,51,52,24,2,6,155]),function(be,e,w,F,C,L,A,l,S,d,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=e.$eM=e.$dM=e.$cM=void 0;let b=class extends D.$jc{constructor(t,c){super(),this.s=t,this.t=c,this.a=this.B(new F.$ed),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$ed),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=c.createLogger(this.m,{id:S.$do,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(g=>{(0,C.$6i)(g)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,c,g){const E=this.getTelemetryDetails(),$=new p(c,g,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),s=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...s,$]),$.apiTelemetryLogger}$initializeTelemetryLevel(t,c,g){this.f=t,this.g=c,this.c=g??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const c=Object.create(null);switch(c["common.extname"]=`${t.publisher}.${t.name}`,c["common.extversion"]=t.version,c["common.vscodemachineid"]=this.s.telemetryInfo.machineId,c["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,c["common.vscodeversion"]=this.s.version,c["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),c["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,l.$Ok)((0,S.$ko)(this.s.remote.authority)),c}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const c=this.getTelemetryDetails();this.r.forEach((g,E)=>{const $=g.filter(s=>!s.isDisposed);$.length===0?this.r.delete(E):this.r.set(E,$)}),this.r.forEach(g=>{for(const E of g)E.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,c){const E=this.r.get(t.value)?.filter(s=>!s.isDisposed);if(!E)return this.r.delete(t.value),!1;let $=!1;for(const s of E)s.ignoreUnhandledExtHostErrors||(s.logError(c),$=!0);return $}};e.$cM=b,e.$cM=b=Ke([Ve(0,L.$bM),Ve(1,C.$5i)],b);class p{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,c,g,E,$,s,a){this.g=g,this.h=E,this.i=$,this.j=s,this.a=new F.$ed,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(t,c){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let c="properties"in t?t.properties??{}:t;return c=(0,S.$no)(c,[]),this.c&&(c=(0,d.$Xm)(c,this.c)),this.b||(c=(0,d.$Xm)(c,this.j)),"properties"in t?t.properties=c:t=c,t}k(t,c){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(t,c),this.h.trace(t,c))}logUsage(t,c){this.d.isUsageEnabled&&this.k(t,c)}logError(t,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,c);else{const g={name:t.name,message:t.message,stack:t.stack,cause:t.cause},E=(0,S.$no)(g,[]),$=new Error(E.message,{cause:E.cause});$.stack=E.stack,$.name=E.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData($,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const t=this,c={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$dM=p;function f(i){const t=Date.now()-new Date(i).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$eM=f,e.$fM=(0,w.$Ah)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,181,98,20,4]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UF=e.$TF=e.$SF=e.ActivationKind=e.$RF=e.$QF=e.$PF=e.$OF=e.$NF=e.ExtensionHostStartup=e.$MF=e.$LF=e.$KF=e.$JF=void 0,e.$JF=Object.freeze({identifier:new A.$Ul("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$KF="extensions.webWorker",e.$LF=(0,l.$Ah)("extensionService");class S{constructor($){this.dependency=$}}e.$MF=S;var d;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(d||(e.ExtensionHostStartup=d={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor($,s,a){this.c=$,this.d=s.slice(0),this.e=a.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$AF.createActivationEventsMap(this.d)}}set($,s,a){if(this.c>$)throw new Error(`ExtensionHostExtensions: invalid versionId ${$} (current: ${this.c})`);const n=[],o=[],y=[],m=[],I=D(this.d),k=D(s),r=(V,U)=>V.extensionLocation.toString()===U.extensionLocation.toString()||V.isBuiltin===U.isBuiltin||V.isUserBuiltin===U.isUserBuiltin||V.isUnderDevelopment===U.isUnderDevelopment;for(const V of this.d){const U=k.get(V.identifier);if(!U){n.push(V.identifier),I.delete(V.identifier);continue}if(!r(V,U)){n.push(V.identifier),I.delete(V.identifier);continue}}for(const V of s){const U=I.get(V.identifier);if(!U){o.push(V);continue}if(!r(U,V)){n.push(U.identifier),I.delete(U.identifier);continue}}const h=new A.$Vl(this.e),v=new A.$Vl(a);for(const V of this.e)v.has(V)||y.push(V);for(const V of a)h.has(V)||m.push(V);const R=L.$AF.createActivationEventsMap(o),W={versionId:$,toRemove:n,toAdd:o,addActivationEvents:R,myToRemove:y,myToAdd:m};return this.delta(W),W}delta($){if(this.c>=$.versionId)return null;const{toRemove:s,toAdd:a,myToRemove:n,myToAdd:o}=$,y=new A.$Vl(s),m=new A.$Vl(n);for(let I=0;I<this.d.length;I++)y.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)m.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of a)this.d.push(I);for(const I of o)this.e.push(I);return $}containsExtension($){for(const s of this.e)if(A.$Ul.equals(s,$))return!0;return!1}}e.$NF=P;function D(E){const $=new A.$Wl;for(const s of E)$.set(s.identifier,s);return $}function u(E,$){return E.enabledApiProposals?E.enabledApiProposals.includes($):!1}e.$OF=u;function b(E,$){if(!u(E,$))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${$}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${$}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.$PF=b;class p{constructor($,s,a,n){this.codeLoadingTime=$,this.activateCallTime=s,this.activateResolvedTime=a,this.activationReason=n}}e.$QF=p;class f{constructor($,s){this.description=$,this.value=s}}e.$RF=f;var i;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(i||(e.ActivationKind=i={}));function t(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,C.$to)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.$SF=t;function c(E,$){return{identifier:new A.$Ul((0,C.$ro)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!$,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.$TF=c;class g{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent($){return Promise.resolve(void 0)}activationEventIsDone($){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions($){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts($,s){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment($){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$UF=g}),define(Ae[210],Re([1,0,9,107,20,26,14,13]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=e.$dbc=e.$cbc=e.$bbc=e.$abc=e.$_ac=void 0;class S{static{this.NONE=new S(!1,-1,-1,-1)}constructor(t,c,g,E){this.startup=t,this.codeLoadingTime=c,this.activateCallTime=g,this.activateResolvedTime=E}}e.$_ac=S;class d{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,c){return t===-1||c===-1?-1:c-t}build(){return new S(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$abc=d;class P{constructor(t,c,g,E,$,s){this.activationFailed=t,this.activationFailedError=c,this.activationTimes=g,this.module=E,this.exports=$,this.subscriptions=s}}e.$bbc=P;class D extends P{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$cbc=D;class u extends P{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$dbc=u;class b extends P{constructor(t){super(!0,t,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(t,c,g,E){this.g=E,this.a=t,this.b=c,this.c=g,this.d=new C.$Wl,this.f=Object.create(null)}dispose(){for(const[t,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const t=[];for(const[c,g]of this.d)t.push(g.wait());await Promise.all(t)}isActivated(t){const c=this.d.get(t);return!!(c&&c.value)}getActivatedExtension(t){const c=this.d.get(t);if(!c||!c.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return c.value}async activateByEvent(t,c){if(this.f[t])return;const g=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(g.map(E=>({id:E.identifier,reason:{startup:c,extensionId:E.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,c){const g=this.a.getExtensionDescription(t);if(!g)throw new Error(`Extension '${t}' is not known`);return this.h([{id:g.identifier,reason:c}])}async h(t){const c=t.filter(g=>!this.isActivated(g.id)).map(g=>this.j(g));await Promise.all(c.map(g=>g.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const c=this.a.getExtensionDescription(t.id);if(!c){const $=new Error(`Cannot activate unknown extension '${t.id.value}'`),s=this.k(t,null,[],new b($));return this.c.onExtensionActivationError(t.id,$,new L.$MF(t.id.value)),s}const g=[],E=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const $ of E){if(this.m($))continue;const s=this.d.get($);if(s){g.push(s);continue}if(this.l($)){g.push(this.j({id:this.b.getExtensionDescription($).identifier,reason:t.reason}));continue}const a=this.a.getExtensionDescription($);if(a){if(!a.main&&!a.browser)continue;g.push(this.j({id:a.identifier,reason:t.reason}));continue}const n=c.displayName||c.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${$}'`),y=this.k(t,c.displayName,[],new b(o));return this.c.onExtensionActivationError(c.identifier,o,new L.$MF($)),y}return this.k(t,c.displayName,g,null)}k(t,c,g,E){const $=new f(t.id,c,t.reason,g,E,this.c,this.g);return this.d.set(t.id,$),$}l(t){return F.$i3b.isHostExtension(t,this.a,this.b)}m(t){const c=this.b.getExtensionDescription(t);return c?!c.main&&!c.browser:!1}};e.$ebc=p,e.$ebc=p=Ke([Ve(3,A.$4i)],p);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,c,g,E,$,s,a){this.c=t,this.d=c,this.f=g,this.g=E,this.h=$,this.j=s,this.k=a,this.a=new l.$Eg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const c=this.g[t];if(c.value&&!c.value.activationFailed){this.g.splice(t,1),t--;continue}if(c.value&&c.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);g.detail=c.value.activationFailedError,this.h=new b(g),this.j.onExtensionActivationError(this.c,g,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const c=new Error;if(t&&t.name&&(c.name=t.name),t&&t.message?c.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(c.stack=t.stack),this.h=new b(c),this.b&&w.$2(t))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};f=Ke([Ve(6,A.$4i)],f)}),define(Ae[211],Re([1,0,157,23,2,5,6,193,13,7,16,18,8,49,21,126,26]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=void 0;function t(E,$){if((0,P.$if)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let s;return Array.isArray(E.highlights)&&(s=E.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),s=s.length?s:void 0),{label:E.label,highlights:s}}}class c extends A.$jc{constructor($,s,a){super(),this.f=$,this.g=s,this.h=a,this.a=new Map,this.b=new f.$c7;function n(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}s.registerArgumentProcessor({processArgument:o=>n(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(y=>n(y)?this.r(y):y):o})}registerTreeDataProvider($,s,a){const n=this.createTreeView($,{treeDataProvider:s},a);return{dispose:()=>n.dispose()}}createTreeView($,s,a){if(!s||!s.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=s.dragAndDropController?.dropMimeTypes??[],o=s.dragAndDropController?.dragMimeTypes??[],y=!!s.dragAndDropController?.handleDrag,m=!!s.dragAndDropController?.handleDrop,I=this.m($,s,a),k={showCollapseAll:!!s.showCollapseAll,canSelectMany:!!s.canSelectMany,dropMimeTypes:n,dragMimeTypes:o,hasHandleDrag:y,hasHandleDrop:m,manuallyManageCheckboxes:!!s.manageCheckboxStateManually},r=this.f.$registerTreeViewDataProvider($,k),h={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,i.$PF)(a,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,i.$PF)(a,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(v){(0,b.$Yj)(v)&&(0,i.$PF)(a,"treeViewMarkdownMessage"),I.message=v},get title(){return I.title},set title(v){I.title=v},get description(){return I.description},set description(v){I.description=v},get badge(){return I.badge},set badge(v){v!==void 0&&d.ViewBadge.isViewBadge(v)?I.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(I.badge=void 0)},reveal:(v,R)=>I.reveal(v,R),dispose:async()=>{await r,this.a.delete($),I.dispose()}};return this.B(h),h}$getChildren($,s){const a=this.a.get($);return a?a.getChildren(s):Promise.reject(new l.$aF($))}async $handleDrop($,s,a,n,o,y,m,I){const k=this.a.get($);if(!k)return Promise.reject(new l.$aF($));const r=u.DataTransfer.toDataTransfer(a,async h=>(await this.f.$resolveDropFileData($,s,h)).buffer);return m===$&&I&&await this.j(r,k,I,o,y),k.onDrop(r,n,o)}async j($,s,a,n,o){const y=this.b.removeDragOperationTransfer(o);if(y)(await y)?.forEach((m,I)=>{m&&$.set(I,m)});else if(o&&s.handleDrag){const m=s.handleDrag(a,$,n);this.b.addDragOperationTransfer(o,m),await m}return $}async $handleDrag($,s,a,n){const o=this.a.get($);if(!o)return Promise.reject(new l.$aF($));const y=await this.j(new d.$PK,o,s,n,a);if(!(!y||n.isCancellationRequested))return u.DataTransfer.from(y)}async $hasResolve($){const s=this.a.get($);if(!s)throw new l.$aF($);return s.hasResolve}$resolve($,s,a){const n=this.a.get($);if(!n)throw new l.$aF($);return n.resolveTreeItem(s,a)}$setExpanded($,s,a){const n=this.a.get($);if(!n)throw new l.$aF($);n.setExpanded(s,a)}$setSelectionAndFocus($,s,a){const n=this.a.get($);if(!n)throw new l.$aF($);n.setSelectionAndFocus(s,a)}$setVisible($,s){const a=this.a.get($);if(!a){if(!s)return;throw new l.$aF($)}a.setVisible(s)}$changeCheckboxState($,s){const a=this.a.get($);if(!a)throw new l.$aF($);a.setCheckboxState(s)}m($,s,a){const n=this.B(new g($,s,this.f,this.g.converter,this.h,a));return this.a.set($,n),n}r($){const s=this.a.get($.$treeViewId);return s&&"$treeItemHandle"in $?s.getExtensionElement($.$treeItemHandle):s&&"$focusedTreeItem"in $&&$.$focusedTreeItem?s.focusedElement:null}}e.$Qbc=c;class g extends A.$jc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map($=>this.getExtensionElement($)).filter($=>!(0,P.$rf)($))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor($,s,a,n,o,y){if(super(),this.I=$,this.J=a,this.L=n,this.M=o,this.N=y,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$ed),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$ed),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$ed),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$ed),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$ed),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$ed),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$ed),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$od,y.contributes&&y.contributes.views)for(const r in y.contributes.views)for(const h of y.contributes.views[r])h.id===$&&(this.P=h.name);this.f=s.treeDataProvider,this.g=s.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(r=>this.F.fire({message:!1,element:r})));let m,I;const k=L.Event.debounce(this.F.event,(r,h)=>(r||(r={message:!1,elements:[]}),h.element!==!1&&(m||(m=new Promise(v=>I=v),this.G=this.G.then(()=>m)),Array.isArray(h.element)?r.elements.push(...h.element):r.elements.push(h.element)),h.message&&(r.message=!0),r),200,!0);this.B(k(({message:r,elements:h})=>{h.length&&(this.H=this.H.then(()=>{const v=I;return m=null,this.$(h).then(()=>v())})),r&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren($){const s=$?this.getExtensionElement($):void 0;if($&&!s)return this.M.error(`No tree item with id '${$}' found.`),Promise.resolve([]);let a=this.X($);return a||(a=await this.Y(s)),a?a.map(n=>n.item):void 0}getExtensionElement($){return this.j.get($)}reveal($,s){s=s||{select:!0,focus:!1};const a=(0,P.$rf)(s.select)?!0:s.select,n=(0,P.$rf)(s.focus)?!1:s.focus,o=(0,P.$rf)(s.expand)?!1:s.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):$?this.G.then(()=>this.S($)).then(y=>this.W($,y[y.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:y.map(I=>I.item)},{select:a,focus:n,expand:o})),y=>this.M.error(y)):this.J.$reveal(this.I,void 0,{select:a,focus:n,expand:o})}get message(){return this.O}set message($){this.O=$,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title($){this.P=$,this.J.$setTitle(this.I,$,this.Q)}get description(){return this.Q}set description($){this.Q=$,this.J.$setTitle(this.I,this.P,$)}get badge(){return this.R}set badge($){this.R?.value===$?.value&&this.R?.tooltip===$?.tooltip||(this.R=u.ViewBadge.from($),this.J.$setBadge(this.I,$))}setExpanded($,s){const a=this.getExtensionElement($);a&&(s?this.u.fire(Object.freeze({element:a})):this.w.fire(Object.freeze({element:a})))}setSelectionAndFocus($,s){const a=!(0,D.$sb)(this.s,$);this.s=$;const n=this.t!==s;this.t=s,a&&this.y.fire(Object.freeze({selection:this.selectedElements})),n&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible($){$!==this.r&&(this.r=$,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState($){const s=(await Promise.all($.map(async a=>{const n=this.getExtensionElement(a.treeItemHandle);return n?{extensionItem:n,treeItem:await this.f.getTreeItem(n),newState:a.newState?d.TreeItemCheckboxState.Checked:d.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);s.forEach(a=>{a.treeItem.checkboxState=a.newState?d.TreeItemCheckboxState.Checked:d.TreeItemCheckboxState.Unchecked}),this.D.fire({items:s.map(a=>[a.extensionItem,a.newState])})}async handleDrag($,s,a){const n=[];for(const o of $){const y=this.getExtensionElement(o);y&&n.push(y)}if(!(!this.g?.handleDrag||n.length===0))return await this.g.handleDrag(n,s,a),s}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop($,s,a){const n=s?this.getExtensionElement(s):void 0;if(!(!n&&s||!this.g?.handleDrop))return(0,S.$yg)(()=>this.g?.handleDrop?this.g.handleDrop(n,$,a):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem($,s){if(!this.f.resolveTreeItem)return;const a=this.j.get($);if(a){const n=this.m.get(a);if(n){const o=await this.f.resolveTreeItem(n.extensionItem,a,s)??n.extensionItem;return this.hb(o),n.item.tooltip=this.eb(o.tooltip),n.item.command=this.fb(n.disposableStore,o.command),n.item}}}S($){return this.U($).then(s=>s?this.S(s).then(a=>this.W(s,a[a.length-1]).then(n=>(a.push(n),a))):Promise.resolve([]))}U($){const s=this.m.get($);return s?Promise.resolve(s.parent?this.j.get(s.parent.item.handle):void 0):(0,S.$yg)(()=>this.f.getParent($))}W($,s){const a=this.m.get($);return a?Promise.resolve(a):(0,S.$yg)(()=>this.f.getTreeItem($)).then(n=>this.kb($,n,s,!0)).then(n=>this.getChildren(s?s.item.handle:void 0).then(()=>{const o=this.getExtensionElement(n);if(o){const y=this.m.get(o);if(y)return Promise.resolve(y)}throw new Error(`Cannot resolve tree item for element ${n} from extension ${this.N.identifier.value}`)}))}X($){if($){let s;if(typeof $=="string"){const a=this.getExtensionElement($);s=a?this.m.get(a):void 0}else s=$;return s&&s.children||void 0}return this.h}async Y($){this.rb($);const s=new p.$od(this.Z.token);try{const a=$?this.m.get($):void 0,n=await this.f.getChildren($);if(s.token.isCancellationRequested)return;const o=await Promise.all((0,D.$Eb)(n||[]).map(async y=>{const m=await this.f.getTreeItem(y);return m&&!s.token.isCancellationRequested?this.db(y,m,a):null}));return s.token.isCancellationRequested?void 0:(0,D.$Eb)(o)}finally{s.dispose()}}$($){if($.some(a=>!a))return this.Z.dispose(!0),this.Z=new p.$od,this.tb(),this.J.$refresh(this.I);{const a=this.ab($);if(a.length)return this.bb(a)}return Promise.resolve(void 0)}ab($){const s=new Set,a=$.map(o=>this.m.get(o));for(const o of a)if(o&&!s.has(o.item.handle)){let y=o;for(;y&&y.parent&&a.findIndex(m=>y&&y.parent&&m&&m.item.handle===y.parent.item.handle)===-1;){const m=this.j.get(y.parent.item.handle);y=m?this.m.get(m):void 0}y&&!y.parent&&s.add(o.item.handle)}const n=[];return s.forEach(o=>{const y=this.j.get(o);if(y){const m=this.m.get(y);m&&(!m.parent||!s.has(m.parent.item.handle))&&n.push(o)}}),n}bb($){const s={};return Promise.all($.map(a=>this.cb(a).then(n=>{n&&(s[a]=n.item)}))).then(()=>Object.keys(s).length?this.J.$refresh(this.I,s):void 0)}cb($){const s=this.getExtensionElement($);if(s){const a=this.m.get(s);if(a)return this.rb(s),(0,S.$yg)(()=>this.f.getTreeItem(s)).then(n=>{if(n){const o=this.ib(s,n,a.parent);return this.pb(s,o,a,a.parent),a.dispose(),o}return null})}return Promise.resolve(null)}db($,s,a){const n=this.ib($,s,a);if(s.id&&this.j.has(n.item.handle))throw new Error((0,w.localize)(0,null,s.id));return this.ob($,n),this.qb(n,a),n}eb($){return d.$mK.isMarkdownString($)?u.MarkdownString.from($):$}fb($,s){return s?{...this.L.toInternal(s,$),originalId:s.command}:void 0}gb($){if($.checkboxState===void 0)return;let s,a,n;return typeof $.checkboxState=="number"?s=$.checkboxState:(s=$.checkboxState.state,a=$.checkboxState.tooltip,n=$.checkboxState.accessibilityInformation),{isChecked:s===d.TreeItemCheckboxState.Checked,tooltip:a,accessibilityInformation:n}}hb($){if(!d.$KK.isTreeItem($,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib($,s,a){this.hb(s);const n=this.B(new A.$ic),o=this.kb($,s,a),y=this.lb(s);return{item:{handle:o,parentHandle:a?a.item.handle:void 0,label:t(s.label,this.N),description:s.description,resourceUri:s.resourceUri,tooltip:this.eb(s.tooltip),command:this.fb(n,s.command),contextValue:s.contextValue,icon:y,iconDark:this.mb(s)||y,themeIcon:this.jb(s),collapsibleState:(0,P.$rf)(s.collapsibleState)?d.TreeItemCollapsibleState.None:s.collapsibleState,accessibilityInformation:s.accessibilityInformation,checkbox:this.gb(s)},extensionItem:s,parent:a,children:void 0,disposableStore:n,dispose(){n.dispose()}}}jb($){return $.iconPath instanceof d.$SK?$.iconPath:void 0}kb($,{id:s,label:a,resourceUri:n},o,y){if(s)return`${g.b}/${s}`;const m=t(a,this.N),I=o?o.item.handle:g.a;let k=m?m.label:n?(0,F.$eg)(n):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const r=this.m.has($)?this.m.get($).item.handle:void 0,h=this.X(o)||[];let v,R=0;do{if(v=`${I}/${R}:${k}`,y||!this.j.has(v)||r===v)break;R++}while(R<=h.length);return v}lb($){if($.iconPath&&!($.iconPath instanceof d.$SK))return typeof $.iconPath=="string"||C.URI.isUri($.iconPath)?this.nb($.iconPath):this.nb($.iconPath.light)}mb($){if($.iconPath&&!($.iconPath instanceof d.$SK)&&$.iconPath.dark)return this.nb($.iconPath.dark)}nb($){return C.URI.isUri($)?$:C.URI.file($)}ob($,s){this.j.set(s.item.handle,$),this.m.set($,s)}pb($,s,a,n){this.j.delete(s.item.handle),this.m.delete($),s.item.handle!==a.item.handle&&this.j.delete(a.item.handle),this.ob($,s);const o=this.X(n)||[],y=o.filter(m=>m.item.handle===a.item.handle)[0];y&&o.splice(o.indexOf(y),1,s)}qb($,s){s?(s.children||(s.children=[]),s.children.push($)):(this.h||(this.h=[]),this.h.push($))}rb($){if($){const s=this.m.get($);if(s){if(s.children)for(const a of s.children){const n=this.j.get(a.item.handle);n&&this.sb(n)}s.children=void 0}}else this.tb()}sb($){const s=this.m.get($);if(s){if(s.children)for(const a of s.children){const n=this.j.get(a.item.handle);n&&this.sb(n)}this.m.delete($),this.j.delete(s.item.handle),s.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach($=>$.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[212],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[213],Re([1,0,167,9,29,92,73,30,20,212,177,98]),function(be,e,w,F,C,L,A,l,S,d,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=void 0;const u=l.$7m.as(A.$8m.JSONContribution);class b{constructor($,s,a){this.a=$,this.b=s,this.c=a}d($,s){this.a({type:$,message:s,extensionId:this.b.identifier,extensionPointId:this.c})}error($){this.d(C.default.Error,$)}warn($){this.d(C.default.Warning,$)}info($){this.d(C.default.Info,$)}}e.$VF=b;class p{static a($){const s=new S.$Vl;for(let a=0,n=$.length;a<n;a++)s.add($[a].description.identifier);return s}static compute($,s){if(!$||!$.length)return new p(s,[]);if(!s||!s.length)return new p([],$);const a=this.a($),n=this.a(s),o=s.filter(m=>!a.has(m.description.identifier)),y=$.filter(m=>!n.has(m.description.identifier));return new p(o,y)}constructor($,s){this.added=$,this.removed=s}}e.$WF=p;class f{constructor($,s){this.name=$,this.defaultExtensionKind=s,this.a=null,this.b=null,this.c=null}setHandler($){if(this.a!==null)throw new Error("Handler already set!");this.a=$,this.d()}acceptUsers($){this.c=p.compute(this.b,$),this.b=$,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch($){(0,F.$Y)($)}}}e.$XF=f;const i={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$YF={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:S.$Tl},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(d.allApiProposals),markdownEnumDescriptions:Object.values(d.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Ln}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Ln}},extensionKind:{description:w.localize(51,null),type:"array",items:i,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)},pricing:{type:"string",markdownDescription:w.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint($){if(this.a.has($.extensionPoint))throw new Error("Duplicate extension point: "+$.extensionPoint);const s=new f($.extensionPoint,$.defaultExtensionKind);return this.a.set($.extensionPoint,s),$.activationEventsGenerator&&D.$AF.register($.extensionPoint,$.activationEventsGenerator),e.$YF.properties.contributes.properties[$.extensionPoint]=$.jsonSchema,u.registerSchema(t,e.$YF),s}getExtensionPoints(){return Array.from(this.a.values())}}e.$ZF=c;const g={ExtensionsRegistry:"ExtensionsRegistry"};l.$7m.add(g.ExtensionsRegistry,new c),e.$1F=l.$7m.as(g.ExtensionsRegistry),u.registerSchema(t,e.$YF),u.registerSchema(P.$kj,{properties:{extensionEnabledApiProposals:{description:w.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(d.allApiProposals),markdownEnumDescriptions:Object.values(d.allApiProposals)}}]}}}})}),define(Ae[214],Re([1,0,164,16,24,213,32,5]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0F=void 0;const S={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var d;(function(u){function b(p,f,i){if(!p)return;const t=F.$if(p.type)?p.type:void 0;if(!t||t.length===0){i.error(w.localize(3,null));return}const c=[];if(Array.isArray(p.required))for(const g of p.required)F.$if(g)&&c.push(g);return{extensionId:f.value,taskType:t,required:c,properties:p.properties?C.$Um(p.properties):{},when:p.when?A.$Hi.deserialize(p.when):void 0}}u.from=b})(d||(d={}));const P=L.$1F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const p of u)p.type&&b.push(`onTaskType:${p.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:S}});class D{constructor(){this.d=new l.$ed,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,p)=>{P.setHandler((f,i)=>{this.c=void 0;try{for(const t of i.removed){const c=t.value;for(const g of c)this.a&&g.type&&this.a[g.type]&&delete this.a[g.type]}for(const t of i.added){const c=t.value;for(const g of c){const E=d.from(g,t.description.identifier,t.collector);E&&(this.a[E.taskType]=E)}}(i.removed.length>0||i.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const p of this.all()){const f={type:"object",additionalProperties:!1};p.required.length>0&&(f.required=p.required.slice(0)),p.properties!==void 0?f.properties=C.$Um(p.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[p.taskType]},b.push(f)}this.c={oneOf:b}}return this.c}}e.$0F=new D}),define(Ae[215],Re([1,0,165,16,23,24,32,214]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$hG=e.JsonSchemaVersion=e.ExecutionEngine=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$bG=e.ShellQuoting=e.$aG=e.$_F=e.$$F=void 0,e.$$F="settings",e.$_F=new A.$1i("taskRunning",!1,w.localize(0,null)),e.$aG={value:w.localize(1,null),original:"Tasks"};var S;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(S||(e.ShellQuoting=S={})),e.$bG="$customized",function(O){function N(ee){if(!ee)return O.Strong;switch(ee.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(S||(e.ShellQuoting=S={}));var d;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(d||(e.CommandOptions=d={}));var P;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(P||(e.RevealKind=P={})),function(O){function N(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(P||(e.RevealKind=P={}));var D;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(O){function N(ee){switch(ee.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(D||(e.RevealProblemKind=D={}));var u;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(u||(e.PanelKind=u={})),function(O){function N(ee){switch(ee.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(u||(e.PanelKind=u={}));var b;(function(O){O.defaults={echo:!0,reveal:P.Always,revealProblems:D.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var p;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(O){function N(Y){switch(Y.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function ee(Y){switch(Y){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=ee}(p||(e.RuntimeType=p={}));var f;(function(O){function N(ee){return F.$if(ee)?ee:ee.value}O.value=N})(f||(e.CommandString=f={}));var i;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(Y){return Y===O.Clean._id||Y===O.Build._id||Y===O.Rebuild._id||Y===O.Test._id}O.is=N;function ee(Y){if(Y!==void 0)return F.$if(Y)?N(Y)?{_id:Y,isDefault:!1}:void 0:Y}O.from=ee})(i||(e.TaskGroup=i={}));var t;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var c;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(ee){switch(ee){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(c||(e.TaskSourceKind=c={}));var g;(function(O){O.parallel="parallel",O.sequence="sequence"})(g||(e.DependsOrder=g={}));var E;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var $;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})($||(e.RunOptions=$={}));class s{constructor(N,ee,Y,Ee,ke,Pe){this._label="",this._id=N,ee&&(this._label=ee),Y&&(this.type=Y),this.runOptions=Ee,this.configurationProperties=ke,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,ee=!1){if(N===void 0)return!1;if(F.$if(N))return N===this._label||N===this.configurationProperties.identifier||ee&&N===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$cG=s;class a extends s{constructor(N,ee,Y,Ee,ke,Pe,Z,ue){super(N,Y,void 0,Z,ue,ee),this.command={},this._source=ee,this.hasDefinedMatchers=Pe,ke&&(this.command=ke)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let ee;switch(this.command?this.command.runtime:void 0){case p.Shell:ee="shell";break;case p.Process:ee="process";break;case p.CustomExecution:ee="customExecution";break;case void 0:ee="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ee,_key:this._id,id:this._id}}}static is(N){return N instanceof a}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$$F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ee+=this._source.kind);const Y={type:e.$bG,folder:N,id:ee};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new a(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$dG=a;class n extends s{constructor(N,ee,Y,Ee,ke,Pe,Z){super(N,Y,Ee,Pe,Z,ee),this._source=ee,this.configures=ke}static is(N){return N instanceof n}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$$F:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ee=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ee+=this._source.kind);const Y={type:e.$bG,folder:N,id:ee};return JSON.stringify(Y)}}e.$eG=n;class o extends s{constructor(N,ee,Y,Ee,ke,Pe,Z,ue,ye){super(N,Y,Ee,ue,ye,ee),this.defines=ke,this.hasDefinedMatchers=Z,this.command=Pe,this.icon=ye.icon,this.hide=ye.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$fG=o;class y extends s{constructor(N,ee,Y,Ee,ke,Pe){super(N,Y,Ee,ke,Pe,ee),this._source=ee}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new y(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$gG=y;var m;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(O){O._default=O.Terminal}(m||(e.ExecutionEngine=m={}));var I;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class k{constructor(N){this.c=new Map;for(let ee=0;ee<N.length;ee++)this.c.set(N[ee].uri.toString(),ee)}compare(N,ee){const Y=N.getWorkspaceFolder(),Ee=ee.getWorkspaceFolder();if(Y&&Ee){let ke=this.c.get(Y.uri.toString());ke=ke===void 0?0:ke+1;let Pe=this.c.get(Ee.uri.toString());return Pe=Pe===void 0?0:Pe+1,ke===Pe?N._label.localeCompare(ee._label):ke-Pe}else return!Y&&Ee?-1:Y&&!Ee?1:0}}e.$hG=k;var r;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(r||(e.TaskEventKind=r={}));var h;(function(O){O.SingleRun="singleRun",O.Background="background"})(h||(e.TaskRunType=h={}));var v;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var R;(function(O){function N(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function ee(ue,ye,ce){return{...N(ue),kind:"start",terminalId:ye,resolvedVariables:ce}}O.start=ee;function Y(ue,ye,ce){return{...N(ue),kind:"processStarted",terminalId:ye,processId:ce}}O.processStarted=Y;function Ee(ue,ye,ce){return{...N(ue),kind:"processEnded",terminalId:ye,exitCode:ce}}O.processEnded=Ee;function ke(ue,ye,ce){return{...N(ue),kind:"terminated",exitReason:ce,terminalId:ye}}O.terminated=ke;function Pe(ue,ye,ce){return{...N(ye),kind:ue,terminalId:ce}}O.general=Pe;function Z(){return{kind:"changed"}}O.changed=Z})(R||(e.TaskEvent=R={}));var W;(function(O){function N(Y){const Ee=Object.keys(Y).sort();let ke="";for(const Pe of Ee){let Z=Y[Pe];Z instanceof Object?Z=N(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),ke+=Pe+","+Z+","}return ke}function ee(Y){const ke={_key:N(Y),type:Y.taskType};return Object.assign(ke,Y),ke}O.create=ee})(W||(e.KeyedTaskIdentifier=W={}));var V;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var U;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var B;(function(O){function N(ee,Y){const Ee=l.$0F.get(ee.type);if(Ee===void 0){const ue=L.$Um(ee);return delete ue._key,W.create(ue)}const ke=Object.create(null);ke.type=Ee.taskType;const Pe=new Set;Ee.required.forEach(ue=>Pe.add(ue));const Z=Ee.properties;for(const ue of Object.keys(Z)){const ye=ee[ue];if(ye!=null)ke[ue]=ye;else if(Pe.has(ue)){const ce=Z[ue];if(ce.default!==void 0)ke[ue]=L.$Um(ce.default);else switch(ce.type){case"boolean":ke[ue]=!1;break;case"number":case"integer":ke[ue]=0;break;case"string":ke[ue]="";break;default:Y.error(w.localize(2,null,JSON.stringify(ee,void 0,0),ue));return}}}return W.create(ke)}O.createTaskIdentifier=N})(B||(e.TaskDefinition=B={}))}),define(Ae[216],Re([1,0,9]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o3b=e.$n3b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$Y)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$n3b=F;class C extends F{constructor(){super(),this.h=!0,this.i=new w.$3}}e.$o3b=C}),define(Ae[46],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cA=e.$bA=e.$aA=e.$_z=void 0;class w{static{this.count=0}constructor(S){this._proxyIdentifierBrand=void 0,this.sid=S,this.nid=++w.count}}e.$_z=w;const F=[];function C(l){const S=new w(l);return F[S.nid]=S,S}e.$aA=C;function L(l){return F[l].sid}e.$bA=L;class A{constructor(S){this.value=S}}e.$cA=A}),define(Ae[3],Re([1,0,46]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WJ=e.$VJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$UJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var C;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var L;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var S;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(S||(e.CellOutputKind=S={}));var d;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(d||(e.NotebookEditorRevealType=d={}));var P;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class D{static{this.a=0}static mixin(i){return i._id=D.a++,i}}e.$UJ=D;var u;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var p;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$VJ={MainThreadAuthentication:(0,w.$aA)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$aA)("MainThreadBulkEdits"),MainThreadChatProvider:(0,w.$aA)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,w.$aA)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,w.$aA)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$aA)("MainThreadClipboard"),MainThreadCommands:(0,w.$aA)("MainThreadCommands"),MainThreadComments:(0,w.$aA)("MainThreadComments"),MainThreadConfiguration:(0,w.$aA)("MainThreadConfiguration"),MainThreadConsole:(0,w.$aA)("MainThreadConsole"),MainThreadDebugService:(0,w.$aA)("MainThreadDebugService"),MainThreadDecorations:(0,w.$aA)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$aA)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$aA)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$aA)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$aA)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$aA)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$aA)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$aA)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$aA)("MainThreadErrors"),MainThreadTreeViews:(0,w.$aA)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$aA)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$aA)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$aA)("MainThreadLanguages"),MainThreadLogger:(0,w.$aA)("MainThreadLogger"),MainThreadMessageService:(0,w.$aA)("MainThreadMessageService"),MainThreadOutputService:(0,w.$aA)("MainThreadOutputService"),MainThreadProgress:(0,w.$aA)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$aA)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$aA)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$aA)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$aA)("MainThreadSecretState"),MainThreadStorage:(0,w.$aA)("MainThreadStorage"),MainThreadTelemetry:(0,w.$aA)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$aA)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$aA)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$aA)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$aA)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$aA)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$aA)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$aA)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$aA)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$aA)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$aA)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$aA)("MainThreadExtensionService"),MainThreadSCM:(0,w.$aA)("MainThreadSCM"),MainThreadSearch:(0,w.$aA)("MainThreadSearch"),MainThreadShare:(0,w.$aA)("MainThreadShare"),MainThreadTask:(0,w.$aA)("MainThreadTask"),MainThreadWindow:(0,w.$aA)("MainThreadWindow"),MainThreadLabelService:(0,w.$aA)("MainThreadLabelService"),MainThreadNotebook:(0,w.$aA)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$aA)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$aA)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$aA)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$aA)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$aA)("MainThreadInteractive"),MainThreadChat:(0,w.$aA)("MainThreadChat"),MainThreadInlineChat:(0,w.$aA)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$aA)("MainThreadTheming"),MainThreadTunnelService:(0,w.$aA)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$aA)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$aA)("MainThreadTimeline"),MainThreadTesting:(0,w.$aA)("MainThreadTesting"),MainThreadLocalization:(0,w.$aA)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$aA)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$aA)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,w.$aA)("MainThreadIssueReporter")},e.$WJ={ExtHostCommands:(0,w.$aA)("ExtHostCommands"),ExtHostConfiguration:(0,w.$aA)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$aA)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$aA)("ExtHostDebugService"),ExtHostDecorations:(0,w.$aA)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$aA)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$aA)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$aA)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$aA)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$aA)("ExtHostEditors"),ExtHostTreeViews:(0,w.$aA)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$aA)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$aA)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$aA)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$aA)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$aA)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$aA)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$aA)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$aA)("ExtHostStatusBar"),ExtHostShare:(0,w.$aA)("ExtHostShare"),ExtHostExtensionService:(0,w.$aA)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$aA)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$aA)("ExtHostTerminalService"),ExtHostSCM:(0,w.$aA)("ExtHostSCM"),ExtHostSearch:(0,w.$aA)("ExtHostSearch"),ExtHostTask:(0,w.$aA)("ExtHostTask"),ExtHostWorkspace:(0,w.$aA)("ExtHostWorkspace"),ExtHostWindow:(0,w.$aA)("ExtHostWindow"),ExtHostWebviews:(0,w.$aA)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$aA)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$aA)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$aA)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$aA)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$aA)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$aA)("ExtHostProgress"),ExtHostComments:(0,w.$aA)("ExtHostComments"),ExtHostSecretState:(0,w.$aA)("ExtHostSecretState"),ExtHostStorage:(0,w.$aA)("ExtHostStorage"),ExtHostUrls:(0,w.$aA)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$aA)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$aA)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$aA)("ExtHostOutputService"),ExtHosLabelService:(0,w.$aA)("ExtHostLabelService"),ExtHostNotebook:(0,w.$aA)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$aA)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$aA)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$aA)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$aA)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$aA)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$aA)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$aA)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$aA)("ExtHostChat"),ExtHostChatSlashCommands:(0,w.$aA)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,w.$aA)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$aA)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,w.$aA)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$aA)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$aA)("ExtHostTheming"),ExtHostTunnelService:(0,w.$aA)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$aA)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$aA)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$aA)("ExtHostTimeline"),ExtHostTesting:(0,w.$aA)("ExtHostTesting"),ExtHostTelemetry:(0,w.$aA)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$aA)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$aA)("ExtHostIssueReporter")}}),define(Ae[217],Re([1,0,3,7]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$VJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,S){if(this.a.size===0)throw new Error("No related information providers registered");const d=this.a.get(A);if(!d)throw new Error("related information provider not found");return await d.provideRelatedInformation(l,S)??[]}getRelatedInformation(A,l,S){return this.c.$getAiRelatedInformation(l,S)}registerRelatedInformationProvider(A,l,S){const d=this.b;return this.b++,this.a.set(d,S),this.c.$registerAiRelatedInformationProvider(d,l),new F.$XJ(()=>{this.c.$unregisterAiRelatedInformationProvider(d),this.a.delete(d)})}}e.$Scc=C}),define(Ae[80],Re([1,0,4,14,3,17]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=e.$Uac=void 0,e.$Uac=(0,w.$Ah)("IExtHostApiDeprecationService");let A=class{constructor(S,d){this.c=d,this.a=new Set,this.b=S.getProxy(C.$VJ.MainThreadTelemetry)}report(S,d,P){const D=this.d(S,d);this.a.has(D)||(this.a.add(D),d.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${S}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:d.identifier.value,apiId:S}))}d(S,d){return`${S}-${d.identifier.value}`}};e.$Vac=A,e.$Vac=A=Ke([Ve(0,L.$XL),Ve(1,F.$4i)],A),e.$Wac=Object.freeze(new class{report(l,S,d){}})}),define(Ae[218],Re([1,0,5,3,7,20]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;class A{constructor(d){this.b=new Map,this.c=[],this.d=new w.$ed,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=d.getProxy(F.$VJ.MainThreadAuthentication)}$setProviders(d){return this.c=d,Promise.resolve()}async getSession(d,P,D,u={}){const b=L.$Ul.toKey(d.identifier),p=[...D].sort().join(" ");return await this.f.getOrCreate(`${b} ${P} ${p}`,async()=>{await this.a.$ensureProvider(P);const f=d.displayName||d.name;return this.a.$getSession(P,D,b,f,u)})}async getSessions(d,P,D){const u=L.$Ul.toKey(d.identifier),b=[...D].sort().join(" ");return await this.g.getOrCreate(`${u} ${b}`,async()=>{await this.a.$ensureProvider(P);const p=d.displayName||d.name;return this.a.$getSessions(P,D,u,p)})}async removeSession(d,P){const D=this.b.get(d);return D?D.provider.removeSession(P):this.a.$removeSession(d,P)}registerAuthenticationProvider(d,P,D,u){if(this.b.get(d))throw new Error(`An authentication provider with id '${d}' is already registered.`);this.b.set(d,{label:P,provider:D,options:u??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===d)||this.c.push({id:d,label:P});const b=D.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(d,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(d,P,u?.supportsMultipleAccounts??!1),new C.$XJ(()=>{b.dispose(),this.b.delete(d);const p=this.c.findIndex(f=>f.id===d);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(d)})}$createSession(d,P,D){const u=this.b.get(d);if(u)return Promise.resolve(u.provider.createSession(P,D));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$removeSession(d,P){const D=this.b.get(d);if(D)return Promise.resolve(D.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$getSessions(d,P){const D=this.b.get(d);if(D)return Promise.resolve(D.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$onDidChangeAuthenticationSessions(d,P){return this.d.fire({provider:{id:d,label:P}}),Promise.resolve()}}e.$qcc=A;class l{constructor(){this.a=new Map}getOrCreate(d,P){const D=this.a.get(d);if(D)return D;const u=P().finally(()=>this.a.delete(d));return this.a.set(d,u),u}}}),define(Ae[219],Re([1,0,3,17,8]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;let L=class{constructor(l,S){this.a=l.getProxy(w.$VJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:d=>S.getDocument(d)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,S,d){const P=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,d?.isRefactoring??!1)}};e.$wcc=L,e.$wcc=L=Ke([Ve(0,F.$XL)],L)}),define(Ae[220],Re([1,0,13,5,66,6,58,147,3,8]),function(be,e,w,F,C,L,A,l,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class P{static{this.a=0}constructor(b,p){this.extension=b,this.provider=p,this.handle=P.a++}}class D{static{this.a=0}constructor(b,p){this.h=p,this.b=new Map,this.d=new Map,this.e=new F.$ed,this.onDidPerformUserAction=this.e.event,this.g=b.getProxy(S.$VJ.MainThreadChat)}registerChatProvider(b,p,f){const i=new P(b,f);return this.b.set(i.handle,i),this.g.$registerChatProvider(i.handle,p),(0,L.$hc)(()=>{this.g.$unregisterChatProvider(i.handle),this.b.delete(i.handle)})}transferChatSession(b,p){const f=C.Iterable.find(this.d.keys(),i=>this.d.get(i)===b)??0;typeof f=="number"&&this.g.$transferChatSession(f,p)}addChatRequest(b){this.g.$addRequest(b)}sendInteractiveRequestToProvider(b,p){this.g.$sendRequestToProvider(b,p)}async $prepareChat(b,p,f){const i=this.b.get(b);if(!i)return;const t=await i.provider.prepareSession(p,f);if(!t)return;const c=D.a++;return this.d.set(c,t),{id:c,requesterUsername:t.requester?.name,requesterAvatarIconUri:t.requester?.icon,responderUsername:t.responder?.name,responderAvatarIconUri:t.responder?.icon,inputPlaceholder:t.inputPlaceholder}}async $resolveRequest(b,p,f,i){const t=this.b.get(b);if(!t)return;const c=this.d.get(p);if(!c||!t.provider.resolveRequest)return;const g=await t.provider.resolveRequest(c,f,i);if(g)return{message:typeof g.message=="string"?g.message:d.ChatReplyFollowup.from(g.message)}}async $provideWelcomeMessage(b,p){const f=this.b.get(b);if(!f||!f.provider.provideWelcomeMessage)return;const i=await f.provider.provideWelcomeMessage(p);if(i)return i.map(t=>typeof t=="string"?t:t.map(c=>d.ChatReplyFollowup.from(c)))}async $provideFollowups(b,p,f){const i=this.b.get(b);if(!i)return;const t=this.d.get(p);return!t||!i.provider.provideFollowups?void 0:(await i.provider.provideFollowups(t,f))?.map(g=>d.ChatFollowup.from(g))}$removeRequest(b,p,f){const i=this.b.get(b);if(!i)return;const t=this.d.get(p);t&&i.provider.removeRequest&&i.provider.removeRequest(t,f)}async $provideReply(b,p,f,i){const t=this.b.get(b);if(!t)return;const c=this.d.get(p);if(!c)return;const g={session:c,message:typeof f.message=="string"?f.message:d.ChatReplyFollowup.to(f.message),variables:{}};if(f.variables)for(const o of Object.keys(f.variables))g.variables[o]=f.variables[o].map(d.ChatVariable.to);const E=A.$ad.create(!1);let $;const s={report:o=>{if(!i.isCancellationRequested)if(typeof $>"u"&&($=E.elapsed()),"responseId"in o)this.g.$acceptResponseProgress(b,p,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const y=Promise.all([this.g.$acceptResponseProgress(b,p,{placeholder:o.placeholder}),o.resolvedContent]);(0,w.$ug)(y,i).then(m=>{if(!m)return;const[I,k]=m;this.g.$acceptResponseProgress(b,p,k,I??void 0)})}else"content"in o?this.g.$acceptResponseProgress(b,p,{content:typeof o.content=="string"?o.content:d.MarkdownString.from(o.content)}):this.g.$acceptResponseProgress(b,p,o)}};let a;try{a=await t.provider.provideResponseWithProgress(g,s,i),a||(a={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){a={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(c.saveState&&this.d.has(p)){const o=c.saveState();this.g.$acceptChatState(p,o)}}catch(o){this.h.warn(o)}const n={firstProgress:$??0,totalElapsed:E.elapsed()};return{errorDetails:a.errorDetails,timings:n}}async $provideSlashCommands(b,p,f){const i=this.b.get(b);if(!i)return;const t=this.d.get(p);return!t||!i.provider.provideSlashCommands?void 0:(await i.provider.provideSlashCommands(t,f))?.map(g=>({...g,kind:d.CompletionItemKind.from(g.kind)}))}$releaseSession(b){this.d.delete(b)}async $onDidPerformUserAction(b){this.e.fire(b)}}e.$Kcc=D}),define(Ae[221],Re([1,0,6,3,8,72,20]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pcc=void 0;class l{static{this.a=1}constructor(d,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Wl,this.b=d.getProxy(F.$VJ.MainThreadChatProvider)}registerProvider(d,P,D,u){const b=l.a++;return this.c.set(b,{extension:d,provider:D}),this.b.$registerProvider(b,P,{extension:d,displayName:u.name??d.value}),(0,w.$hc)(()=>{this.b.$unregisterProvider(b),this.c.delete(b)})}async $provideChatResponse(d,P,D,u,b){const p=this.c.get(d);if(!p)return;const f=new L.$3u(async i=>{if(b.isCancellationRequested){this.d.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:i.index,part:i.part})},{async:!0});return p.provider.provideChatResponse(D.map(C.ChatMessage.to),u,f,b)}allowListExtensionWhile(d,P){this.f.set(d,P),P.finally(()=>this.f.delete(d))}async requestChatResponseProvider(d,P){if(!this.f.has(d))throw new Error("Extension is NOT allowed to make chat requests");const D=this;return{get isRevoked(){return!D.f.has(d)},async makeRequest(u,b,p,f){if(!D.f.has(d))throw new Error("Access to chat has been revoked");const i=Math.random()*1e6|0;D.e.set(i,p);try{await D.b.$fetchResponse(d,P,i,u.map(C.ChatMessage.from),b,f)}finally{D.e.delete(i)}}}}async $handleResponseFragment(d,P){this.e.get(d)?.report(P)}}e.$Pcc=l}),define(Ae[222],Re([1,0,6,3,7,8,72,13]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=void 0;class S{static{this.a=0}constructor(D,u,b){this.d=u,this.e=b,this.b=new Map,this.c=D.getProxy(F.$VJ.MainThreadChatSlashCommands)}registerCommand(D,u,b,p){const f=S.a++;return this.b.set(f,{extension:D,command:b}),this.c.$registerCommand(f,u,p.description),(0,w.$hc)(()=>{this.c.$unregisterCommand(f),this.b.delete(f)})}async $executeCommand(D,u,b,p,f){const i=this.b.get(D);if(!i){this.e.warn(`[CHAT](${D}) CANNOT execute command because the command is not registered`);return}let t=!1;function c(){if(t)throw new Error("Only valid while executing the command")}const g=new l.$1g;f.onCancellationRequested(()=>g.complete()),setTimeout(()=>g.complete(),3*1e3),this.d.allowListExtensionWhile(i.extension,g.p);const E=i.command({role:C.ChatMessageRole.User,content:b},{history:p.history.map(L.ChatMessage.to)},new A.$3u($=>{c(),this.c.$handleProgressChunk(u,{content:d($.message)?$.message:$.message.value})}),f);try{return await(0,l.$ug)(Promise.resolve(E).then($=>{if($&&"followUp"in $)return{followUp:$?.followUp?.map(a=>L.ChatFollowup.from(a))}}),f)}finally{t=!0,g.complete()}}}e.$Qcc=S;function d(P){return!!P&&typeof P=="object"&&"treeData"in P}}),define(Ae[223],Re([1,0,6,3,9,8]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;class A{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(F.$VJ.MainThreadChatVariables)}async $resolveVariable(S,d,P){const D=this.b.get(S);if(D)try{const u=await D.resolver.resolve(D.data.name,{message:d},P);if(u)return u.map(L.ChatVariable.from)}catch(u){(0,C.$Z)(u)}}registerVariableResolver(S,d,P,D){const u=A.a++;return this.b.set(u,{extension:S.identifier,data:{name:d,description:P},resolver:D}),this.c.$registerVariable(u,{name:d,description:P}),(0,w.$hc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$Rcc=A}),define(Ae[224],Re([1,0,3]),function(be,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=void 0;class F{constructor(L){const A=L.getProxy(w.$VJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$Zac=F}),define(Ae[31],Re([1,0,16,7,8,24,3,18,14,68,44,278,2,6,4,17,105,25,46,41,58,52,57]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E,$,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=void 0;let a=class{#e;#t;#i;constructor(k,r,h){this.b=new Map,this.c=new Map,this.#e=k.getProxy(A.$VJ.MainThreadCommands),this.d=r,this.#i=h,this.#t=k.getProxy(A.$VJ.MainThreadTelemetry),this.converter=new n(this,v=>{const R=this.c.get(v);return R?.result===y.Void?R:void 0},r),this.f=[{processArgument(v){return(0,d.$0g)(v)}},{processArgument(v){return(0,L.$Wm)(v,function(R){if(P.$js.isIRange(R))return C.Range.to(R);if(D.$is.isIPosition(R))return C.Position.to(R);if(P.$js.isIRange(R.range)&&u.URI.isUri(R.uri))return C.location.to(R);if(R instanceof t.$Ed)return R.buffer.buffer;if(!Array.isArray(R))return R})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const r=this.registerCommand(!1,k.id,async(...h)=>{const v=k.args.map((W,V)=>{if(!W.validate(h[V]))throw new Error(`Invalid argument '${W.name}' when running '${k.id}', received: ${h[V]}`);return W.convert(h[V])}),R=await this.executeCommand(k.internalId,...v);return k.result.convert(R,h,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new F.$XJ(()=>{r.dispose(),this.c.delete(k.id)})}registerCommand(k,r,h,v,R,W){if(this.d.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this.b.has(r))throw new Error(`command '${r}' already exists`);return this.b.set(r,{callback:h,thisArg:v,description:R,extension:W}),k&&this.#e.$registerCommand(r),new F.$XJ(()=>{this.b.delete(r)&&k&&this.#e.$unregisterCommand(r)})}executeCommand(k,...r){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,r,!0)}async g(k,r,h){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,r,!1);{let v=!1;const R=(0,L.$Wm)(r,function(W){if(W instanceof F.$YJ)return C.Position.from(W);if(W instanceof F.$ZJ)return C.Range.from(W);if(W instanceof F.$0J)return C.location.from(W);if(F.$jL.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return v=!0,t.$Ed.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return v=!0,t.$Ed.wrap(W);if(W instanceof t.$Ed)return v=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(k,v?new c.$cA(R):R,h);return(0,d.$0g)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(k,r,!1);throw W}}}async h(k,r,h){const v=this.b.get(k);if(!v)throw new Error("Unknown command");const{callback:R,thisArg:W,description:V}=v;if(V)for(let B=0;B<V.args.length;B++)try{(0,w.$zf)(r[B],V.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${V.args[B].name}' - ${V.args[B].description}`)}const U=E.$ad.create();try{return await R.apply(W,r)}catch(B){if(k===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...r);O&&(k=O.command)}if(this.d.error(B,k,v.extension?.identifier),!h)throw B;if(v.extension?.identifier){const O=this.#i.onExtensionError(v.extension.identifier,B);this.d.trace("forwarded error to extension?",O,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.$li)(B)),this.id=k,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,k,U.elapsed())}}j(k,r,h){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new $.$$n(r),duration:h})}$executeContributedCommand(k,...r){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const h=this.b.get(k);return h?(r=r.map(v=>this.f.reduce((R,W)=>W.processArgument(R,h.extension?.identifier),v)),this.h(k,r,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(r=>(k&&(r=r.filter(h=>h[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const k=Object.create(null);for(const[r,h]of this.b){const{description:v}=h;v&&(k[r]=v)}return Promise.resolve(k)}};e.$gM=a,e.$gM=a=Ke([Ve(0,f.$XL),Ve(1,S.$4i),Ve(2,s.$fM)],a),e.$hM=(0,p.$Ah)("IExtHostCommands");class n{constructor(k,r,h){this.d=k,this.f=r,this.g=h,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,r){if(!k)return;const h={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return h;const v=this.f(k.command);if(v)h.id=v.internalId,h.arguments=v.args.map((R,W)=>R.convert(k.arguments&&k.arguments[W]));else if((0,l.$Ib)(k.arguments)){const R=`${k.command}/${++this.c}`;this.b.set(R,k),r.add((0,b.$hc)(()=>{this.b.delete(R),this.g.trace("CommandsConverter#DISPOSE",R)})),h.$ident=R,h.id=this.delegatingCommandId,h.arguments=[R],this.g.trace("CommandsConverter#CREATE",k.command,R)}return h}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const r=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],r?r.command:"MISSING"),r?this.d.executeCommand(r.command,...r.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$iM=n;class o{static{this.Uri=new o("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new o("position","A position in a text document",k=>F.$YJ.isPosition(k),C.Position.from)}static{this.Range=new o("range","A range in a text document",k=>F.$ZJ.isRange(k),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",k=>F.$1J.isSelection(k),C.Selection.from)}static{this.Number=new o("number","",k=>typeof k=="number",k=>k)}static{this.String=new o("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=o.Arr(o.String)}static Arr(k){return new o(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,r=>Array.isArray(r)&&r.every(h=>k.validate(h)),r=>r.map(h=>k.convert(h)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",k=>k instanceof F.$iK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",k=>k instanceof F.$CL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",k=>k instanceof i.$$L,C.TestItem.from)}constructor(k,r,h,v){this.name=k,this.description=r,this.validate=h,this.convert=v}optional(){return new o(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,r){return new o(k??this.name,r??this.description,this.validate,this.convert)}}e.$jM=o;class y{static{this.Void=new y("no result",k=>k)}constructor(k,r){this.description=k,this.convert=r}}e.$kM=y;class m{constructor(k,r,h,v,R){this.id=k,this.internalId=r,this.description=h,this.args=v,this.result=R}}e.$lM=m}),define(Ae[225],Re([1,0,18,12,2,78,91,32,95,31,8,7]),function(be,e,w,F,C,L,A,l,S,d,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=void 0;const u=[new d.$lM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$jM.Uri,d.$jM.Position],new d.$kM("A promise that resolves to an array of DocumentHighlight-instances.",p(P.DocumentHighlight.to))),new d.$lM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$jM.Uri],new d.$kM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,t)=>{if((0,w.$Hb)(i))return;class c extends D.$cK{static to(E){const $=new c(E.name,P.SymbolKind.to(E.kind),E.containerName||"",new D.$0J(t[0],P.Range.to(E.range)));return $.detail=E.detail,$.range=$.location.range,$.selectionRange=P.Range.to(E.selectionRange),$.children=E.children?E.children.map(c.to):[],$}}return i.map(c.to)})),new d.$lM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$jM.Uri,new d.$jM("options","Formatting options",i=>!0,i=>i)],new d.$kM("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new d.$lM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$jM.Uri,d.$jM.Range,new d.$jM("options","Formatting options",i=>!0,i=>i)],new d.$kM("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new d.$lM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$jM.Uri,d.$jM.Position,new d.$jM("ch","Trigger character",i=>typeof i=="string",i=>i),new d.$jM("options","Formatting options",i=>!0,i=>i)],new d.$kM("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new d.$lM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$jM.Uri,d.$jM.Position],new d.$kM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$lM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$jM.Uri,d.$jM.Position],new d.$kM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$lM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$jM.Uri,d.$jM.Position],new d.$kM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$lM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$jM.Uri,d.$jM.Position],new d.$kM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$lM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$jM.Uri,d.$jM.Position],new d.$kM("A promise that resolves to an array of Location-instances.",p(P.location.to))),new d.$lM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$jM.Uri,d.$jM.Position],new d.$kM("A promise that resolves to an array of Hover-instances.",p(P.Hover.to))),new d.$lM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$jM.Uri,new d.$jM("position","A position in a text document",i=>Array.isArray(i)&&i.every(t=>D.$YJ.isPosition(t)),i=>i.map(P.Position.from))],new d.$kM("A promise that resolves to an array of ranges.",i=>i.map(t=>{let c;for(const g of t.reverse())c=new D.$hK(P.Range.to(g),c);return c}))),new d.$lM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$jM.String.with("query","Search string")],new d.$kM("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(P.WorkspaceSymbol.to))),new d.$lM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$jM.Uri,d.$jM.Position],new d.$kM("A promise that resolves to an array of CallHierarchyItem-instances",i=>i.map(P.CallHierarchyItem.to))),new d.$lM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$jM.CallHierarchyItem],new d.$kM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",i=>i.map(P.CallHierarchyIncomingCall.to))),new d.$lM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$jM.CallHierarchyItem],new d.$kM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",i=>i.map(P.CallHierarchyOutgoingCall.to))),new d.$lM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$jM.Uri,d.$jM.Position],new d.$kM("A promise that resolves to a range and placeholder text.",i=>{if(i)return{range:P.Range.to(i.range),placeholder:i.text}})),new d.$lM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$jM.Uri,d.$jM.Position,d.$jM.String.with("newName","The new symbol name")],new d.$kM("A promise that resolves to a WorkspaceEdit.",i=>{if(i){if(i.rejectReason)throw new Error(i.rejectReason);return P.WorkspaceEdit.to(i)}})),new d.$lM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$jM.Uri,d.$jM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$kM("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(P.DocumentLink.to))),new d.$lM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$jM.Uri],new d.$kM("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new D.$bL(i.tokenTypes,i.tokenModifiers)})),new d.$lM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$jM.Uri],new d.$kM("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const t=(0,A.$n0)(i);if(t.type==="full")return new D.$dL(t.data,void 0)})),new d.$lM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$jM.Uri,d.$jM.Range.optional()],new d.$kM("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new D.$bL(i.tokenTypes,i.tokenModifiers)})),new d.$lM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$jM.Uri,d.$jM.Range],new d.$kM("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const t=(0,A.$n0)(i);if(t.type==="full")return new D.$dL(t.data,void 0)})),new d.$lM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$jM.Uri,d.$jM.Position,d.$jM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$jM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$kM("A promise that resolves to a CompletionList-instance.",(i,t,c)=>{if(!i)return new D.$tK([]);const g=i.suggestions.map(E=>P.CompletionItem.to(E,c));return new D.$tK(g,i.incomplete)})),new d.$lM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$jM.Uri,d.$jM.Position,d.$jM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$kM("A promise that resolves to SignatureHelp.",i=>{if(i)return P.SignatureHelp.to(i)})),new d.$lM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$jM.Uri,d.$jM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$kM("A promise that resolves to an array of CodeLens-instances.",(i,t,c)=>p(g=>new D.$lK(P.Range.to(g.range),g.command&&c.fromInternal(g.command)))(i))),new d.$lM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$jM.Uri,new d.$jM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>D.$ZJ.isRange(i),i=>D.$1J.isSelection(i)?P.Selection.from(i):P.Range.from(i)),d.$jM.String.with("kind","Code action kind to return code actions for").optional(),d.$jM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$kM("A promise that resolves to an array of Command-instances.",(i,t,c)=>p(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(g.command)}else{const E=new D.$eK(g.title,g.kind?new D.$fK(g.kind):void 0);return g.edit&&(E.edit=P.WorkspaceEdit.to(g.edit)),g.command&&(E.command=c.fromInternal(g.command)),E.isPreferred=g.isPreferred,E}})(i))),new d.$lM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$jM.Uri],new d.$kM("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(t=>new D.$zK(P.Range.to(t.range),P.Color.to(t.color))):[])),new d.$lM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$jM("color","The color to show and insert",i=>i instanceof D.$yK,P.Color.from),new d.$jM("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:P.Range.from(i.range)}))],new d.$kM("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(P.ColorPresentation.to):[])),new d.$lM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$jM.Uri,d.$jM.Range],new d.$kM("A promise that resolves to an array of Inlay objects",(i,t,c)=>i.map(P.InlayHint.to.bind(void 0,c)))),new d.$lM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$jM.Uri],new d.$kM("A promise that resolves to an array of FoldingRange objects",(i,t)=>{if(i)return i.map(P.FoldingRange.to)})),new d.$lM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$kM("A promise that resolves to an array of NotebookContentProvider static info objects.",p(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(t=>P.NotebookExclusiveDocumentPattern.to(t))})))),new d.$lM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$jM.Uri,d.$jM.Range,new d.$jM("context","An InlineValueContext",i=>i&&typeof i.frameId=="number"&&i.stoppedLocation instanceof D.$ZJ,i=>P.InlineValueContext.from(i))],new d.$kM("A promise that resolves to an array of InlineValue objects",i=>i.map(P.InlineValue.to))),new d.$lM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$jM("uriOrString","Uri-instance or string (only http/https)",i=>C.URI.isUri(i)||typeof i=="string"&&(0,S.$HT)(i,F.Schemas.http,F.Schemas.https),i=>i),new d.$jM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[P.ViewColumn.from(i),void 0]:[P.ViewColumn.from(i.viewColumn),P.TextEditorOpenOptions.from(i)])).optional(),d.$jM.String.with("label","").optional()],d.$kM.Void),new d.$lM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$jM.Uri.with("resource","Resource to open"),d.$jM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new d.$jM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[P.ViewColumn.from(i),void 0]:[P.ViewColumn.from(i.viewColumn),P.TextEditorOpenOptions.from(i)])).optional()],d.$kM.Void),new d.$lM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$jM.Uri.with("left","Left-hand side resource of the diff editor"),d.$jM.Uri.with("right","Right-hand side resource of the diff editor"),d.$jM.String.with("title","Human readable title for the diff editor").optional(),new d.$jM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[P.ViewColumn.from(i.viewColumn),P.TextEditorOpenOptions.from(i)]).optional()],d.$kM.Void),new d.$lM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$jM.Uri,d.$jM.Position],new d.$kM("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(P.TypeHierarchyItem.to))),new d.$lM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$jM.TypeHierarchyItem],new d.$kM("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(P.TypeHierarchyItem.to))),new d.$lM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$jM.TypeHierarchyItem],new d.$kM("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(P.TypeHierarchyItem.to))),new d.$lM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$jM.TestItem],d.$kM.Void),new d.$lM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$jM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$kM.Void),new d.$lM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$jM.String.with("name","The context key name"),new d.$jM("value","The context key value",()=>!0,i=>i)],d.$kM.Void),new d.$lM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$jM.Uri,d.$jM.StringArray,new d.$jM("MappedEditsContext","Mapped Edits Context",i=>P.MappedEditsContext.is(i),i=>P.MappedEditsContext.from(i))],new d.$kM("A promise that resolves to a workspace edit or null",i=>i?P.WorkspaceEdit.to(i):null))];class b{static register(t){u.forEach(t.registerApiCommand,t),this.a(t)}static a(t){t.registerCommand(!1,"_validateWhenClauses",l.$Ii)}}e.$Yac=b;function p(i){return t=>{if(Array.isArray(t))return t.map(i)}}function f(i){if(!Array.isArray(i))return;const t=[];for(const c of i)L.$7s(c)?t.push(P.DefinitionLink.to(c)):t.push(P.location.to(c));return t}}),define(Ae[226],Re([1,0,13,64,5,6,2,78,20,8,7,3,26]),function(be,e,w,F,C,L,A,l,S,d,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0;function b(p,f,i){const t=p.getProxy(D.$VJ.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new S.$Wl,f.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const I=this.b.get(m.handle);return I?I.value:m}else if(m&&m.$mid===7){const I=this.b.get(m.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.commentThreadHandle);return k?k.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);return k?m.$mid===8?k.value:{thread:k.value,text:m.text}:m}else if(m&&m.$mid===10){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const r=m.commentUniqueId,h=k.getCommentByUniqueId(r);return h||m}else if(m&&m.$mid===11){const I=this.b.get(m.thread.commentControlHandle);if(!I)return m;const k=I.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const r=m.text,h=m.commentUniqueId,v=k.getCommentByUniqueId(h);return v?(typeof v.body=="string"?v.body=r:v.body=new P.$mK(r),v):m}return m}})}createCommentController(m,I,k){const r=c.a++,h=new E(m,r,I,k);this.b.set(h.handle,h);const v=this.c.get(m.identifier)||[];return v.push(h),this.c.set(m.identifier,v),h.value}$createCommentThreadTemplate(m,I,k){const r=this.b.get(m);r&&r.$createCommentThreadTemplate(I,k)}async $updateCommentThreadTemplate(m,I,k){const r=this.b.get(m);r&&r.$updateCommentThreadTemplate(I,k)}$deleteCommentThread(m,I){this.b.get(m)?.$deleteCommentThread(I)}$provideCommentingRanges(m,I,k){const r=this.b.get(m);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const h=i.getDocument(A.URI.revive(I));return(0,w.$yg)(async()=>{const v=await r.commentingRangeProvider.provideCommentingRanges(h,k);let R;return Array.isArray(v)?R={ranges:v,fileComments:!1}:v?R={ranges:v.ranges||[],fileComments:v.fileComments||!1}:R=v??void 0,R}).then(v=>{let R;return v&&(R={ranges:v.ranges.map(W=>d.Range.from(W)),fileComments:v.fileComments}),R})}$toggleReaction(m,I,k,r,h){const v=this.b.get(m);return!v||!v.reactionHandler?Promise.resolve(void 0):(0,w.$yg)(()=>{const R=v.getCommentThread(I);if(R){const W=R.getCommentByUniqueId(r.uniqueIdInThread);if(v!==void 0&&W&&v.reactionHandler)return v.reactionHandler(W,a(h))}return Promise.resolve(void 0)})}}class g{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,I,k,r,h,v,R,W){this.m=I,this.n=k,this.o=r,this.p=h,this.q=v,this.extensionDescription=R,this.r=W,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$ed,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$kc,this.l.value=new L.$ic,this.n===void 0&&(this.n=`${m}.${this.handle}`),t.$createCommentThread(I,this.handle,this.n,this.o,d.Range.from(this.p),R.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=v,this.i.push({dispose:()=>{t.$deleteCommentThread(I,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(U){V.range=U},get comments(){return V.comments},set comments(U){V.comments=U},get collapsibleState(){return V.collapsibleState},set collapsibleState(U){V.collapsibleState=U},get canReply(){return V.canReply},set canReply(U){V.canReply=U},get contextValue(){return V.contextValue},set contextValue(U){V.contextValue=U},get label(){return V.label},set label(U){V.label=U},get state(){return V.state},set state(U){V.state=U},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$ic);const m=k=>Object.prototype.hasOwnProperty.call(this.b,k),I={};m("range")&&(I.range=d.Range.from(this.p)),m("label")&&(I.label=this.label),m("contextValue")&&(I.contextValue=this.contextValue??null),m("comments")&&(I.comments=this.q.map(k=>$(this,k,this.k,this.extensionDescription))),m("collapsibleState")&&(I.collapseState=n(this.g)),m("canReply")&&(I.canReply=this.canReply),m("state")&&(I.state=o(this.h)),m("isTemplate")&&(I.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(m){for(const I of this.k){const k=I[0],r=I[1];if(m===r)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,F.$6g)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,I,k,r){this.f=m,this.g=I,this.h=k,this.i=r,this.a=new Map,t.$registerCommentController(this.handle,k,r,this.f.identifier.value);const h=this;this.value=Object.freeze({id:h.id,label:h.label,get options(){return h.options},set options(v){h.options=v},get commentingRangeProvider(){return h.commentingRangeProvider},set commentingRangeProvider(v){h.commentingRangeProvider=v},get reactionHandler(){return h.reactionHandler},set reactionHandler(v){h.reactionHandler=v},createCommentThread(v,R,W){return h.createCommentThread(v,R,W).value},dispose:()=>{h.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(m,I,k){I===void 0&&(0,u.$PF)(this.f,"fileComments");const r=new g(this.id,this.handle,void 0,m,I,k,this.f,!1);return this.a.set(r.handle,r),r}$createCommentThreadTemplate(m,I){const k=new g(this.id,this.handle,void 0,A.URI.revive(m),d.Range.to(I),[],this.f,!0);return k.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(m,I){const k=this.a.get(m);k&&(k.range=d.Range.to(I))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function $(y,m,I,k){let r=I.get(m);return r||(r=++y.commentHandle,I.set(m,r)),m.state!==void 0&&(0,u.$PF)(k,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:r,body:typeof m.body=="string"?m.body:d.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(h=>s(h)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function s(y){return{label:y.label,iconPath:y.iconPath?d.$WL(y.iconPath):void 0,count:y.count,hasReacted:y.authorHasReacted}}function a(y){return{label:y.label||"",count:y.count||0,iconPath:y.iconPath?A.URI.revive(y.iconPath):"",authorHasReacted:y.hasReacted||!1}}function n(y){if(y!==void 0)switch(y){case P.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(y){if(y!==void 0)switch(y){case P.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new c}e.$1ac=b}),define(Ae[227],Re([1,0,24,3,27,17]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;let A=class{constructor(P,D){this.a=P.getProxy(F.$VJ.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,D){const u=this,b=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,D,b,arguments)}})}e(P,D,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:S(b,this.b)}),this.c&&this.f(P,u,b)}};e.$Wcc=A,e.$Wcc=A=Ke([Ve(0,L.$XL),Ve(1,C.$bM)],A);const l=1e5;function S(d,P){const D=[];if(d.length)for(let u=0;u<d.length;u++){let b=d[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const p=b;p.stack?b=p.stack:b=p.toString()}D.push(b)}if(P){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,w.$Zm)(D);return u.length>l?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ae[108],Re([1,0,2,3,7,4,17,14,18,15,19,26]),function(be,e,w,F,C,L,A,l,S,d,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(f,i){this.h=i,this.f=new Map,this.g=f.getProxy(F.$VJ.MainThreadDecorations)}registerFileDecorationProvider(f,i){const t=u.c++;this.f.set(t,{provider:f,extensionDescription:i}),this.g.$registerDecorationProvider(t,i.identifier.value);const c=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(t,null);return}const E=(0,S.$Zb)(g);if(E.length<=u.d){this.g.$onDidChange(t,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",i.identifier.value,E.length);const $=E.map(n=>({uri:n,rank:(0,d.$qe)(n.path,"/")})),s=(0,S.$xb)($,(n,o)=>n.rank-o.rank||(0,d.$Ee)(n.uri.path,o.uri.path)),a=[];e:for(const n of s){let o;for(const y of n){const m=(0,P.$$d)(y.uri.path);if(o!==m&&(o=m,a.push(y.uri)>=u.d))break e}}this.g.$onDidChange(t,a)});return new C.$XJ(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(f,i,t){if(!this.f.has(f))return Object.create(null);const c=Object.create(null),{provider:g,extensionDescription:E}=this.f.get(f);return await Promise.all(i.map(async $=>{try{const{uri:s,id:a}=$,n=await Promise.resolve(g.provideFileDecoration(w.URI.revive(s),t));if(!n)return;try{C.$hL.validate(n),n.badge&&typeof n.badge!="string"&&(0,D.$PF)(E,"codiconDecoration"),c[a]=[n.propagate,n.tooltip,n.badge,n.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E.identifier.value}': ${o}`)}}catch(s){this.h.error(s)}})),c}};e.$2bc=b,e.$2bc=b=u=Ke([Ve(0,A.$XL),Ve(1,l.$4i)],b),e.$3bc=(0,L.$Ah)("IExtHostDecorations")}),define(Ae[228],Re([1,0,148,94,2,3,7,8,5,14,28,39]),function(be,e,w,F,C,L,A,l,S,d,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=e.$Sac=void 0;class b{#e;#t;#i;constructor(i,t,c,g,E,$,s,a){this.d=i,this.e=t,this.f=c,this.g=g,this.h=E,this.c=!1,this.f=Math.max(g,c),this.#i=new P.$yi(n=>$.getComparisonKey(n)),this.#e=s,this.#t=a}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(i,t){if(!i){this.clear();return}this.j();let c=[];if(C.URI.isUri(i)){if(!t){this.delete(i);return}this.#i.set(i,t.slice()),c=[i]}else if(Array.isArray(i)){c=[];let $;i=[...i].sort(b.k);for(const s of i){const[a,n]=s;if((!$||a.toString()!==$.toString())&&($&&this.#i.get($).length===0&&this.#i.delete($),$=a,c.push(a),this.#i.set(a,[])),n)this.#i.get(a)?.push(...n);else{const o=this.#i.get(a);o&&(o.length=0)}}}if(this.#t.fire(c),!this.#e)return;const g=[];let E=0;for(const $ of c){let s=[];const a=this.#i.get($);if(a)if(a.length>this.g){s=[];const n=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const y of a)if(y.severity===n[o]&&s.push({...l.Diagnostic.from(y),modelVersionId:this.h($)})===this.g)break e;s.push({severity:F.MarkerSeverity.Info,message:(0,w.localize)(0,null,a.length-this.g),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=a.map(n=>({...l.Diagnostic.from(n),modelVersionId:this.h($)}));if(g.push([$,s]),E+=s.length,E>this.f)break}this.#e.$changeMany(this.e,g)}delete(i){this.j(),this.#t.fire([i]),this.#i.delete(i),this.#e?.$changeMany(this.e,[[i,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(i,t){this.j();for(const[c,g]of this)i.call(t,c,g,this)}*[Symbol.iterator](){this.j();for(const i of this.#i.keys())yield[i,this.get(i)]}get(i){this.j();const t=this.#i.get(i);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(i){return this.j(),Array.isArray(this.#i.get(i))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(i,t){return i[0].toString()<t[0].toString()?-1:i[0].toString()>t[0].toString()?1:0}}e.$Sac=b;let p=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(i){const t=new P.$yi;for(const c of i)t.set(c,c);return{uris:Object.freeze(Array.from(t.values()))}}constructor(i,t,c,g){this.j=t,this.k=c,this.l=g,this.g=new Map,this.h=new S.$id({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=S.Event.map(this.h.event,u._mapper),this.f=i.getProxy(L.$VJ.MainThreadDiagnostics)}createDiagnosticCollection(i,t){const{g:c,f:g,h:E,j:$,k:s,l:a}=this,n=new class{$changeMany(m,I){g.$changeMany(m,I),$.trace("[DiagnosticCollection] change many (extension, owner, uris)",i.value,m,I.length===0?"CLEARING":I)}$clear(m){g.$clear(m),$.trace("[DiagnosticCollection] remove all (extension, owner)",i.value,m)}dispose(){g.dispose()}};let o;if(!t)t="_generated_diagnostic_collection_name_#"+u.c++,o=t;else if(!c.has(t))o=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do o=t+u.c++;while(c.has(o))}return new class extends b{constructor(){super(t,o,u.e,u.d,m=>a.getDocument(m)?.version,s.extUri,n,E),c.set(o,this)}dispose(){super.dispose(),c.delete(o)}}}getDiagnostics(i){if(i)return this.m(i);{const t=new Map,c=[];for(const g of this.g.values())g.forEach((E,$)=>{let s=t.get(E.toString());typeof s>"u"&&(s=c.length,t.set(E.toString(),s),c.push([E,[]])),c[s][1]=c[s][1].concat(...$)});return c}}m(i){let t=[];for(const c of this.g.values())c.has(i)&&(t=t.concat(c.get(i)));return t}$acceptMarkersChange(i){if(!this.n){const t="_generated_mirror",c=new b(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,g=>{},this.k.extUri,void 0,this.h);this.g.set(t,c),this.n=c}for(const[t,c]of i)this.n.set(C.URI.revive(t),c.map(l.Diagnostic.to))}};e.$Tac=p,e.$Tac=p=u=Ke([Ve(1,d.$4i),Ve(2,D.$Rac)],p)}),define(Ae[229],Re([1,0,2,3,26]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=void 0;class L{constructor(l){this.a=l.getProxy(F.$VJ.MainThreadDialogs)}showOpenDialog(l,S){return S?.allowUIResources&&(0,C.$PF)(l,"showLocal"),this.a.$showOpenDialog(S).then(d=>d?d.map(P=>w.URI.revive(P)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(S=>S?w.URI.revive(S):void 0)}}e.$9ac=L}),define(Ae[230],Re([1,0,9,2,7,3,12,21,15]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=void 0;class d{static{this.a=0}constructor(D,u,b){this.d=u,this.e=b,this.b=new Map,this.c=D.getProxy(L.$VJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=d.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,D);let p;return typeof u.onDidChange=="function"&&(p=u.onDidChange(f=>{if(f.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(b,f).then(i=>{if(!i&&typeof i!="string")return;const t=this.d.getDocument(f);if(!t)return;const c=(0,S.$ze)(i);if(!t.equalLines(c))return this.c.$onVirtualDocumentChange(f,i)},w.$Y)})),new C.$XJ(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(D,u){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(F.URI.revive(u),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$0ac=d}),define(Ae[231],Re([1,0,5,6,2,3,101,8,16,24,7,9]),function(be,e,w,F,C,L,A,l,S,d,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=void 0;class u{constructor(p,f){this.a=new w.$ed({onListenerError:D.$Z}),this.b=new w.$ed({onListenerError:D.$Z}),this.c=new w.$ed({onListenerError:D.$Z}),this.d=new w.$ed({onListenerError:D.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$ic,this.h=new Map,this.f=p.getProxy(L.$VJ.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(i=>{for(const t of i)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(i=>{for(const t of i)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const f=this.g.getDocument(p);if(f)return f}getDocument(p){const f=this.getDocumentData(p);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return f.document}ensureDocumentData(p){const f=this.g.getDocument(p);if(f)return Promise.resolve(f);let i=this.h.get(p.toString());return i||(i=this.f.$tryOpenDocument(p).then(t=>{this.h.delete(p.toString());const c=C.URI.revive(t);return(0,S.$tf)(this.g.getDocument(c))},t=>(this.h.delete(p.toString()),Promise.reject(t))),this.h.set(p.toString(),i)),i}createDocumentData(p){return this.f.$tryCreateDocument(p).then(f=>C.URI.revive(f))}$acceptModelLanguageChanged(p,f){const i=C.URI.revive(p),t=this.g.getDocument(i);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(f),this.a.fire(t.document)}$acceptModelSaved(p){const f=C.URI.revive(p),i=this.g.getDocument(f);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(i.document)}$acceptDirtyStateChanged(p,f){const i=C.URI.revive(p),t=this.g.getDocument(i);if(!t)throw new Error("unknown document");t._acceptIsDirty(f),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,f,i){const t=C.URI.revive(p),c=this.g.getDocument(t);if(!c)throw new Error("unknown document");c._acceptIsDirty(i),c.onEvents(f);let g;f.isUndoing?g=P.TextDocumentChangeReason.Undo:f.isRedoing&&(g=P.TextDocumentChangeReason.Redo),this.c.fire((0,d.$Vm)({document:c.document,contentChanges:f.changes.map(E=>({range:l.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:g}))}setWordDefinitionFor(p,f){(0,A.$ZL)(p,f)}}e.$Pac=u}),define(Ae[59],Re([1,0,50,5,6,2,4,3,101,17,106,8,14,28,12,66,65]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9L=e.$8L=void 0;class t{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(E,$){this.h=E,this.i=$,this.a=null,this.b=new Map,this.c=new b.$yi,this.d=new F.$ed,this.e=new F.$ed,this.f=new F.$ed,this.g=new F.$ed,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const $=[],s=[],a=[];if(E.removedDocuments)for(const n of E.removedDocuments){const o=L.URI.revive(n),y=this.c.get(o);y?.unref()&&(this.c.delete(o),$.push(y.value))}if(E.addedDocuments)for(const n of E.addedDocuments){const o=L.URI.revive(n.uri);let y=this.c.get(o);if(y&&o.scheme!==p.Schemas.vscodeNotebookCell&&o.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);y||(y=new t(new S.$1L(this.h.getProxy(l.$VJ.MainThreadDocuments),o,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(o,y),s.push(y.value)),y.ref()}if(E.removedEditors)for(const n of E.removedEditors){const o=this.b.get(n);this.b.delete(n),o&&a.push(o)}if(E.addedEditors)for(const n of E.addedEditors){const o=L.URI.revive(n.documentUri);w.ok(this.c.has(o),`document '${o}' does not exist`),w.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const y=this.c.get(o).value,m=new P.$7L(n.id,this.h.getProxy(l.$VJ.MainThreadTextEditors),this.i,new i.$T(()=>y.document),n.selections.map(D.Selection.to),n.options,n.visibleRanges.map(I=>D.Range.to(I)),typeof n.editorPosition=="number"?D.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,m)}E.newActiveEditor!==void 0&&(w.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,C.$ec)($),(0,C.$ec)(a),E.removedDocuments&&this.e.fire($),E.addedDocuments&&this.d.fire(s),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return f.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const $=this.b.get(this.a);return E?$:$?.value}allEditors(){return[...this.b.values()]}};e.$8L=c,e.$8L=c=Ke([Ve(0,d.$XL),Ve(1,u.$4i)],c),e.$9L=(0,A.$Ah)("IExtHostDocumentsAndEditors")}),define(Ae[60],Re([1,0,8,3,2,5,4,7,17,16,100]),function(be,e,w,F,C,L,A,l,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=void 0,e.$7bc=(0,A.$Ah)("IExtHostEditorTabs");class D{constructor(i,t,c){this.e=c,this.d=t,this.acceptDtoUpdate(i)}get apiObject(){if(!this.a){const i=this,t={get isActive(){return i.b.id===i.e()},get label(){return i.b.label},get input(){return i.c},get isDirty(){return i.b.isDirty},get isPinned(){return i.b.isPinned},get isPreview(){return i.b.isPreview},get group(){return i.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(i){this.b=i,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$DL(C.URI.revive(this.b.input.uri));case 2:return new l.$EL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$FL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$GL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$HL(this.b.input.viewType);case 4:return new l.$IL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$JL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$KL;case 9:return new l.$LL(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class u{constructor(i,t){this.c=[],this.d="",this.b=i,this.e=t;for(const c of i.tabs)c.isActive&&(this.d=c.id),this.c.push(new D(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const i=this,t={get isActive(){return i.b.groupId===i.e()},get viewColumn(){return w.ViewColumn.to(i.b.viewColumn)},get activeTab(){return i.c.find(c=>c.tabId===i.d)?.apiObject},get tabs(){return Object.freeze(i.c.map(c=>c.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(i){this.b=i}acceptTabOperation(i){if(i.kind===0){const c=new D(i.tabDto,this,()=>this.activeTabId());return this.c.splice(i.index,0,c),i.tabDto.isActive&&(this.d=c.tabId),c}else if(i.kind===1){const c=this.c.splice(i.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${i.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(i.kind===3){if(i.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(i.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${i.oldIndex} which does not exist`);return this.c.splice(i.index,0,c),c}const t=this.c.find(c=>c.tabId===i.tabDto.id);if(!t)throw new Error("INVALID tab");return i.tabDto.isActive?this.d=i.tabDto.id:this.d===i.tabDto.id&&!i.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(i.tabDto),t}activeTabId(){return this.d}}let b=class{constructor(i){this.b=new L.$ed,this.c=new L.$ed,this.e=[],this.a=i.getProxy(F.$VJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const i=this,t={onDidChangeTabGroups:i.c.event,onDidChangeTabs:i.b.event,get all(){return Object.freeze(i.e.map(c=>c.apiObject))},get activeTabGroup(){const c=i.d;return(0,d.$tf)(i.e.find(E=>E.groupId===c)?.apiObject)},close:async(c,g)=>{const E=Array.isArray(c)?c:[c];return E.length?p(E[0])?this.j(E,g):this.i(E,g):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(i){const t=new Set(this.e.map(n=>n.groupId)),c=new Set(i.map(n=>n.groupId)),g=(0,P.$J)(t,c),E=this.e.filter(n=>g.removed.includes(n.groupId)).map(n=>n.apiObject),$=[],s=[];this.e=i.map(n=>{const o=new u(n,()=>this.d);return g.added.includes(o.groupId)?$.push(o.apiObject):s.push(o.apiObject),o});const a=(0,d.$tf)(i.find(n=>n.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:$,closed:E,changed:s}))}$acceptTabGroupUpdate(i){const t=this.e.find(c=>c.groupId===i.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(i),i.isActive&&(this.d=i.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(i){const t=this.e.find(g=>g.groupId===i.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const c=t.acceptTabOperation(i);switch(i.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(i){for(const t of this.e)for(const c of t.tabs)if(c.apiObject===i)return c}h(i){return this.e.find(t=>t.apiObject===i)}async i(i,t){const c=[];for(const g of i){const E=this.g(g);if(!E)throw new Error("Tab close: Invalid tab not found!");c.push(E.tabId)}return this.a.$closeTab(c,t)}async j(i,t){const c=[];for(const g of i){const E=this.h(g);if(!E)throw new Error("Group close: Invalid group not found!");c.push(E.groupId)}return this.a.$closeGroup(c,t)}};e.$8bc=b,e.$8bc=b=Ke([Ve(0,S.$XL)],b);function p(f){return f.tabs!==void 0}}),define(Ae[232],Re([1,0,3,7]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$VJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,S){if(this.a.size===0)throw new Error("No embedding vector providers registered");const d=this.a.get(A);if(!d)throw new Error("Embedding vector provider not found");const P=await d.provideEmbeddingVector(l,S);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,l,S){const d=this.b;return this.b++,this.a.set(d,S),this.c.$registerAiEmbeddingVectorProvider(l,d),new F.$XJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider(d),this.a.delete(d)})}}e.$Tcc=C}),define(Ae[233],Re([1,0,2,3,6,7,8,279,15,25,26,49]),function(be,e,w,F,C,L,A,l,S,d,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dbc=void 0;class u{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const i=this.a.indexOf(f);i>=0&&(this.a.splice(i,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),i=[];let t,c,g=14,E=14;for(const $ of f){let s=t?(0,S.$Ne)(t,$):0;for(s===0?c=1:c=E;s<$.length;s++)s+1===$.length?(g=E,E=9):E+=1,i.push([c,$.toUpperCase().charCodeAt(s),E]),i.push([c,$.toLowerCase().charCodeAt(s),E]),c=E;t=$,E=g}i.push([9,58,10]),i.push([10,47,12]),this.b=new l.$qY(i)}}provideDocumentLinks(f){this.c();const i=[],t=l.$rY.computeLinks({getLineContent(c){return f.lineAt(c-1).text},getLineCount(){return f.lineCount}},this.b);for(const c of t){const g=A.DocumentLink.to(c);g.target&&i.push(g)}return i}}class b{constructor(f,i){this.i=i,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(F.$VJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,i,t,c={}){if(b.j(t),this.d.has(i))throw new Error(`a provider for the scheme '${i}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const g=this.h++;this.b.add(i),this.d.add(i),this.c.set(g,t);let E=2;c.isCaseSensitive&&(E+=1024),c.isReadonly&&(E+=2048),typeof t.copy=="function"&&(E+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,P.$PF)(f,"fsChunks"),E+=4);let $;c.isReadonly&&(0,D.$Yj)(c.isReadonly)&&((0,P.$PF)(f,"readonlyMessage"),$={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(g,i,E,$).catch(a=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${i}`),console.error(a)});const s=t.onDidChangeFile(a=>{const n=[];for(const o of a){const{uri:y,type:m}=o;if(y.scheme!==i)continue;let I;switch(m){case L.FileChangeType.Changed:I=0;break;case L.FileChangeType.Created:I=1;break;case L.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:y,type:I})}this.a.$onFileSystemChange(g,n)});return(0,C.$hc)(()=>{s.dispose(),this.b.delete(i),this.d.delete(i),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:i,ctime:t,mtime:c,size:g,permissions:E}=f;return{type:i,ctime:t,mtime:c,size:g,permissions:E}}$stat(f,i){return Promise.resolve(this.l(f).stat(w.URI.revive(i))).then(t=>b.k(t))}$readdir(f,i){return Promise.resolve(this.l(f).readDirectory(w.URI.revive(i)))}$readFile(f,i){return Promise.resolve(this.l(f).readFile(w.URI.revive(i))).then(t=>d.$Ed.wrap(t))}$writeFile(f,i,t,c){return Promise.resolve(this.l(f).writeFile(w.URI.revive(i),t.buffer,c))}$delete(f,i,t){return Promise.resolve(this.l(f).delete(w.URI.revive(i),t))}$rename(f,i,t,c){return Promise.resolve(this.l(f).rename(w.URI.revive(i),w.URI.revive(t),c))}$copy(f,i,t,c){const g=this.l(f);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(w.URI.revive(i),w.URI.revive(t),c))}$mkdir(f,i){return Promise.resolve(this.l(f).createDirectory(w.URI.revive(i)))}$watch(f,i,t,c){const g=this.l(f).watch(w.URI.revive(t),c);this.f.set(i,g)}$unwatch(f,i){const t=this.f.get(i);t&&(t.dispose(),this.f.delete(i))}$open(f,i,t){const c=this.l(f);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(w.URI.revive(i),t))}$close(f,i){const t=this.l(f);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(i))}$read(f,i,t,c){const g=this.l(f);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const E=d.$Ed.alloc(c);return Promise.resolve(g.read(i,t,E.buffer,0,c)).then($=>E.slice(0,$))}$write(f,i,t,c){const g=this.l(f);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(i,t,c.buffer,0,c.byteLength))}l(f){const i=this.c.get(f);if(!i){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return i}}e.$Dbc=b}),define(Ae[61],Re([1,0,3,38,7,25,4,17,39,6,13,23,12]),function(be,e,w,F,C,L,A,l,S,d,P,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=e.$jbc=void 0;let p=b=class{constructor(i,t){this.b=new Map,this.c=new P.$Og,this.a=i.getProxy(w.$VJ.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(g){try{let E;const $=c.b.get(g.scheme);return $?(await c.a.$ensureActivation(g.scheme),E=await $.impl.stat(g)):E=await c.a.$stat(g),{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===F.FilePermission.Readonly?1:void 0}}catch(E){b.e(E)}},async readDirectory(g){try{const E=c.b.get(g.scheme);return E?(await c.a.$ensureActivation(g.scheme),(await E.impl.readDirectory(g)).slice()):await c.a.$readdir(g)}catch(E){return b.e(E)}},async createDirectory(g){try{const E=c.b.get(g.scheme);return E&&!E.isReadonly?(await c.a.$ensureActivation(g.scheme),await c.d(E.impl,E.extUri,g)):await c.a.$mkdir(g)}catch(E){return b.e(E)}},async readFile(g){try{const E=c.b.get(g.scheme);return E?(await c.a.$ensureActivation(g.scheme),(await E.impl.readFile(g)).slice()):(await c.a.$readFile(g)).buffer}catch(E){return b.e(E)}},async writeFile(g,E){try{const $=c.b.get(g.scheme);return $&&!$.isReadonly?(await c.a.$ensureActivation(g.scheme),await c.d($.impl,$.extUri,$.extUri.dirname(g)),await c.c.queueFor(g).queue(()=>Promise.resolve($.impl.writeFile(g,E,{create:!0,overwrite:!0})))):await c.a.$writeFile(g,L.$Ed.wrap(E))}catch($){return b.e($)}},async delete(g,E){try{const $=c.b.get(g.scheme);return $&&!$.isReadonly?(await c.a.$ensureActivation(g.scheme),await $.impl.delete(g,{recursive:!1,...E})):await c.a.$delete(g,{recursive:!1,useTrash:!1,atomic:!1,...E})}catch($){return b.e($)}},async rename(g,E,$){try{return await c.a.$rename(g,E,{overwrite:!1,...$})}catch(s){return b.e(s)}},async copy(g,E,$){try{return await c.a.$copy(g,E,{overwrite:!1,...$})}catch(s){return b.e(s)}},isWritableFileSystem(g){const E=t.getCapabilities(g);if(typeof E=="number")return!(E&2048)}})}async d(i,t,c){const g=[];for(;!t.isEqual(c,t.dirname(c));)try{if(!((await i.stat(c)).type&F.FileType.Directory))throw C.$_K.FileExists(`Unable to create folder '${c.scheme===u.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(E){if(F.$hk(E)!==F.FileSystemProviderErrorCode.FileNotFound)throw E;g.push(t.basename(c)),c=t.dirname(c)}for(let E=g.length-1;E>=0;E--){c=t.joinPath(c,g[E]);try{await i.createDirectory(c)}catch($){if(F.$hk($)!==F.FileSystemProviderErrorCode.FileExists)throw $}}}static e(i){if(i instanceof C.$_K)throw i;if(i instanceof F.$dk)switch(i.code){case F.FileSystemProviderErrorCode.FileExists:throw C.$_K.FileExists(i.message);case F.FileSystemProviderErrorCode.FileNotFound:throw C.$_K.FileNotFound(i.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw C.$_K.FileNotADirectory(i.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw C.$_K.FileIsADirectory(i.message);case F.FileSystemProviderErrorCode.NoPermissions:throw C.$_K.NoPermissions(i.message);case F.FileSystemProviderErrorCode.Unavailable:throw C.$_K.Unavailable(i.message);default:throw new C.$_K(i.message,i.name)}if(!(i instanceof Error))throw new C.$_K(String(i));if(i.name==="ENOPRO"||i.message.includes("ENOPRO"))throw C.$_K.Unavailable(i.message);switch(i.name){case F.FileSystemProviderErrorCode.FileExists:throw C.$_K.FileExists(i.message);case F.FileSystemProviderErrorCode.FileNotFound:throw C.$_K.FileNotFound(i.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw C.$_K.FileNotADirectory(i.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw C.$_K.FileIsADirectory(i.message);case F.FileSystemProviderErrorCode.NoPermissions:throw C.$_K.NoPermissions(i.message);case F.FileSystemProviderErrorCode.Unavailable:throw C.$_K.Unavailable(i.message);default:throw new C.$_K(i.message,i.name)}}addFileSystemProvider(i,t,c){return this.b.set(i,{impl:t,extUri:c?.isCaseSensitive?D.$0f:D.$_f,isReadonly:!!c?.isReadonly}),(0,d.$hc)(()=>this.b.delete(i))}getFileSystemProviderExtUri(i){return this.b.get(i)?.extUri??D.$0f}};e.$jbc=p,e.$jbc=p=b=Ke([Ve(0,l.$XL),Ve(1,S.$Rac)],p),e.$kbc=(0,A.$Ah)("IExtHostConsumerFileSystem")}),define(Ae[234],Re([1,0,5,37,2,3,8,7]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=void 0;class S{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(D,u,b,p,f,i,t,c){this.a=new w.$ed,this.b=new w.$ed,this.c=new w.$ed;const g=this.h(D,b,f);this.g=0,i&&(this.g+=1),t&&(this.g+=2),c&&(this.g+=4);const E=(0,F.$qj)(f),$=typeof f=="string",s=p(a=>{if(!i)for(const n of a.created){const o=C.URI.revive(n);E(o.fsPath)&&(!$||u.getWorkspaceFolder(o))&&this.a.fire(o)}if(!t)for(const n of a.changed){const o=C.URI.revive(n);E(o.fsPath)&&(!$||u.getWorkspaceFolder(o))&&this.b.fire(o)}if(!c)for(const n of a.deleted){const o=C.URI.revive(n);E(o.fsPath)&&(!$||u.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=l.$XJ.from(g,this.a,this.b,this.c,s)}h(D,u,b){const p=l.$XJ.from();if(typeof b=="string")return p;const f=D.getProxy(L.$VJ.MainThreadFileSystem);let i=!1;(b.pattern.includes(F.$mj)||b.pattern.includes(F.$nj))&&(i=!0);const t=Math.random();return f.$watch(u.identifier.value,t,b.baseUri,{recursive:i,excludes:[]}),l.$XJ.from({dispose:()=>f.$unwatch(t)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class d{constructor(D,u,b){this.j=D,this.k=u,this.l=b,this.a=new w.$ed,this.b=new w.$ed,this.c=new w.$ed,this.d=new w.$ed,this.g=new w.$gd,this.h=new w.$gd,this.i=new w.$gd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,u,b,p,f,i){return new S(this.j,D,u,this.a.event,A.GlobPattern.from(b),p,f,i)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,u){switch(D){case 2:this.b.fire(Object.freeze({files:u.map(b=>({oldUri:C.URI.revive(b.source),newUri:C.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:u.map(b=>C.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:u.map(b=>C.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,u){return(b,p,f)=>{const i=function(c){b.call(p,c)};return i.extension=D,u.event(i,void 0,f)}}async $onWillRunFileOperation(D,u,b,p){switch(D){case 2:return await this.n(this.g,{files:u.map(f=>({oldUri:C.URI.revive(f.source),newUri:C.URI.revive(f.target)}))},b,p);case 1:return await this.n(this.i,{files:u.map(f=>C.URI.revive(f.target))},b,p);case 0:case 3:return await this.n(this.h,{files:u.map(f=>C.URI.revive(f.target))},b,p)}}async n(D,u,b,p){const f=new Set,i=[];if(await D.fireAsync(u,p,async(c,g)=>{const E=Date.now(),$=await Promise.resolve(c);$ instanceof l.$8J&&(i.push([g.extension,$]),f.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-E>b&&this.k.warn("SLOW file-participant",g.extension.identifier)}),p.isCancellationRequested||i.length===0)return;const t={edits:[]};for(const[,c]of i){const{edits:g}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:E=>this.l.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}});t.edits=t.edits.concat(g)}return{edit:t,extensionNames:Array.from(f)}}}e.$Ebc=d}),define(Ae[235],Re([1,0,6,2,3,8,7,31]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;class S{static{this.a=0}constructor(u,b){this.extension=u,this.provider=b,this.handle=S.a++}}class d{constructor(u){this.session=u,this.responses=[]}}class P{static{this.a=0}constructor(u,b,p,f){this.f=p,this.g=f,this.b=new Map,this.d=new Map,this.e=u.getProxy(C.$VJ.MainThreadInlineChat),b.registerApiCommand(new l.$lM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$jM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?L.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?L.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?L.Position.from(i.position):void 0}})],l.$kM.Void))}registerProvider(u,b,p){const f=new S(u,b);return this.b.set(f.handle,f),this.e.$registerInteractiveEditorProvider(f.handle,p.label,u.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function"),(0,w.$hc)(()=>{this.e.$unregisterInteractiveEditorProvider(f.handle),this.b.delete(f.handle)})}async $prepareSession(u,b,p,f){const i=this.b.get(u);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const t=this.f.getDocument(F.URI.revive(b)),c=L.Selection.to(p),g=await i.provider.prepareInteractiveEditorSession({document:t,selection:c},f);if(!g)return;if(g.wholeRange&&!g.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const E=P.a++;return this.d.set(E,new d(g)),{id:E,placeholder:g.placeholder,slashCommands:g.slashCommands?.map($=>({command:$.command,detail:$.detail,refer:$.refer,executeImmediately:$.executeImmediately})),wholeRange:L.Range.from(g.wholeRange),message:g.message}}async $provideResponse(u,b,p,f){const i=this.b.get(u);if(!i)return;const t=this.d.get(b.id);if(!t)return;const c={prompt:p.prompt,selection:L.Selection.to(p.selection),wholeRange:L.Range.to(p.wholeRange),attempt:p.attempt,live:p.live};let g=!1;const E={report:a=>{if(!p.live)throw new Error("Progress reporting is only supported for live sessions");g||f.isCancellationRequested||!a.message&&!a.edits||this.e.$handleProgressChunk(p.requestId,{message:a.message,edits:a.edits?.map(L.TextEdit.from)})}},$=i.provider.provideInteractiveEditorResponse(t.session,c,E,f);Promise.resolve($).finally(()=>g=!0);const s=await $;if(s){const a=t.responses.push(s)-1,n={wholeRange:L.Range.from(s.wholeRange),placeholder:s.placeholder};if(P.h(s))return{...n,id:a,type:"message",message:L.MarkdownString.from(s.contents)};const{edits:o}=s;if(o instanceof A.$8J)return{...n,id:a,type:"bulkEdit",edits:L.WorkspaceEdit.from(o)};if(Array.isArray(o))return{...n,id:a,type:"editorEdit",edits:o.map(L.TextEdit.from)}}}$handleFeedback(u,b,p,f){const i=this.b.get(u),t=this.d.get(b),c=t?.responses[p];if(i&&c){const g=L.InteractiveEditorResponseFeedbackKind.to(f);i.provider.handleInteractiveEditorResponseFeedback?.(t.session,c,g)}}$releaseSession(u,b){}static h(u){return typeof u=="object"&&typeof u.contents=="object"}}e.$Lcc=P}),define(Ae[236],Re([1,0,2,31]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=void 0;class C{constructor(A,l,S,d,P){this.a=l,this.b=S,this.c=d;const D=new F.$lM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$jM("showOptions","Show Options",u=>!0,u=>u),new F.$jM("resource","Interactive resource Uri",u=>!0,u=>u),new F.$jM("controllerId","Notebook controller Id",u=>!0,u=>u),new F.$jM("title","Interactive editor title",u=>!0,u=>u)],new F.$kM("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,l,S,d){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:S,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive(d))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Hcc=C}),define(Ae[237],Re([1,0,3,7]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(w.$VJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const S=this.a.get(A);if(!S)throw new Error("Issue request handler not found");const d=await S.handleIssueUrlRequest();if(!d)throw new Error("Issue request handler returned no result");return d}registerIssueUriRequestHandler(A,l){const S=A.identifier.value;return this.a.set(S,l),this.b.$registerIssueUriRequestHandler(S),new F.$XJ(()=>{this.b.$unregisterIssueUriRequestHandler(S),this.a.delete(S)})}}e.$Ncc=C}),define(Ae[238],Re([1,0,6,3]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(F.$VJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,w.$hc)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$1bc=C}),define(Ae[239],Re([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,54,58,9,13,26,150]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E,$,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=void 0;class n{constructor(M,K){this.d=M,this.e=K}async provideDocumentSymbols(M,K){const G=this.d.getDocument(M),X=await this.e.provideDocumentSymbols(G,K);if(!(0,P.$Hb)(X))return X[0]instanceof L.$dK?X.map(C.DocumentSymbol.from):n.f(X)}static f(M){M=M.slice(0).sort((X,J)=>{let x=X.location.range.start.compareTo(J.location.range.start);return x===0&&(x=J.location.range.end.compareTo(X.location.range.end)),x});const K=[],G=[];for(const X of M){const J={name:X.name||"!!MISSING: name!!",kind:C.SymbolKind.from(X.kind),tags:X.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:C.Range.from(X.location.range),selectionRange:C.Range.from(X.location.range),children:[]};for(;;){if(G.length===0){G.push(J),K.push(J);break}const x=G[G.length-1];if(d.$js.containsRange(x.range,J.range)&&!d.$js.equalsRange(x.range,J.range)){x.children?.push(J),G.push(J);break}G.pop()}}return K}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(M,K,G){this.g=M,this.h=K,this.j=G,this.e=new c.$Oac("CodeLens"),this.f=new Map}async provideCodeLenses(M,K){const G=this.g.getDocument(M),X=await this.j.provideCodeLenses(G,K);if(!X||K.isCancellationRequested)return;const J=this.e.add(X),x=new f.$ic;this.f.set(J,x);const ae={cacheId:J,lenses:[]};for(let Le=0;Le<X.length;Le++)ae.lenses.push({cacheId:[J,Le],range:C.Range.from(X[Le].range),command:this.h.toInternal(X[Le].command,x)});return ae}async resolveCodeLens(M,K){const G=M.cacheId&&this.e.get(...M.cacheId);if(!G)return;let X;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?X=G:X=await this.j.resolveCodeLens(G,K),X||(X=G),K.isCancellationRequested)return;const J=M.cacheId&&this.f.get(M.cacheId[0]);if(J)return M.command=this.h.toInternal(X.command??o.d,J),M}releaseCodeLenses(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}}function y(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class m{constructor(M,K){this.d=M,this.e=K}async provideDefinition(M,K,G){const X=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDefinition(X,J,G);return y(x)}}class I{constructor(M,K){this.d=M,this.e=K}async provideDeclaration(M,K,G){const X=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDeclaration(X,J,G);return y(x)}}class k{constructor(M,K){this.d=M,this.e=K}async provideImplementation(M,K,G){const X=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideImplementation(X,J,G);return y(x)}}class r{constructor(M,K){this.d=M,this.e=K}async provideTypeDefinition(M,K,G){const X=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideTypeDefinition(X,J,G);return y(x)}}class h{constructor(M,K){this.d=M,this.e=K}async provideHover(M,K,G){const X=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideHover(X,J,G);if(!(!x||(0,P.$Hb)(x.contents)))return x.range||(x.range=X.getWordRangeAtPosition(J)),x.range||(x.range=new L.$ZJ(J,J)),C.Hover.from(x)}}class v{constructor(M,K){this.d=M,this.e=K}async provideEvaluatableExpression(M,K,G){const X=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideEvaluatableExpression(X,J,G);if(x)return C.EvaluatableExpression.from(x)}}class R{constructor(M,K){this.d=M,this.e=K}async provideInlineValues(M,K,G,X){const J=this.d.getDocument(M),x=await this.e.provideInlineValues(J,C.Range.to(K),C.InlineValueContext.to(G),X);if(Array.isArray(x))return x.map(ae=>C.InlineValue.from(ae))}}class W{constructor(M,K){this.d=M,this.e=K}async provideDocumentHighlights(M,K,G){const X=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideDocumentHighlights(X,J,G);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class V{constructor(M,K){this.d=M,this.e=K}async provideLinkedEditingRanges(M,K,G){const X=this.d.getDocument(M),J=C.Position.to(K),x=await this.e.provideLinkedEditingRanges(X,J,G);if(x&&Array.isArray(x.ranges))return{ranges:(0,P.$Eb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class U{constructor(M,K){this.d=M,this.e=K}async provideReferences(M,K,G,X){const J=this.d.getDocument(M),x=C.Position.to(K),ae=await this.e.provideReferences(J,x,G,X);if(Array.isArray(ae))return ae.map(C.location.from)}}class B{static{this.d=1e3}constructor(M,K,G,X,J,x,ae){this.h=M,this.j=K,this.k=G,this.l=X,this.m=J,this.n=x,this.o=ae,this.e=new c.$Oac("CodeAction"),this.f=new Map,this.g=new L.$fK("notebook")}async provideCodeActions(M,K,G,X){const J=this.h.getDocument(M),x=u.$ls.isISelection(K)?C.Selection.to(K):C.Range.to(K),ae=[];for(const Ze of this.k.getDiagnostics(M))if(x.intersection(Ze.range)&&ae.push(Ze)>B.d)break;const Le={diagnostics:ae,only:G.only?new L.$fK(G.only):void 0,triggerKind:C.CodeActionTriggerKind.to(G.trigger)},je=await this.l.provideCodeActions(J,x,Le,X);if(!(0,P.$Ib)(je)||X.isCancellationRequested)return;const Xe=this.e.add(je),He=new f.$ic;this.f.set(Xe,He);const et=[];for(let Ze=0;Ze<je.length;Ze++){const _e=je[Ze];if(_e)if(B.p(_e))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:_e.title,command:this.j.toInternal(_e,He)});else{if(Le.triggerKind!==L.CodeActionTriggerKind.Invoke&&_e.kind&&this.g.contains(_e.kind))continue;Le.only&&(_e.kind?Le.only.contains(_e.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Xe,Ze],title:_e.title,command:_e.command&&this.j.toInternal(_e.command,He),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,disabled:_e.disabled?.reason})}}return{cacheId:Xe,actions:et}}async resolveCodeAction(M,K){const[G,X]=M,J=this.e.get(G,X);if(!J||B.p(J))return{};if(!this.l.resolveCodeAction)return{};const x=await this.l.resolveCodeAction(J,K)??J;let ae;x.edit&&(ae=C.WorkspaceEdit.from(x.edit,void 0));let Le;if(x.command){const je=this.f.get(G);je&&(Le=this.j.toInternal(x.command,je))}return{edit:ae,command:Le}}releaseCodeActions(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}static p(M){return typeof M.command=="string"&&typeof M.title=="string"}}class O{static toInternalProviderId(M,K){return M+"."+K}constructor(M,K,G,X,J){this.d=M,this.e=K,this.f=G,this.g=X,this.h=J}async prepareDocumentPaste(M,K,G,X){if(!this.f.prepareDocumentPaste)return;const J=this.e.getDocument(M),x=K.map(je=>C.Range.to(je)),ae=C.DataTransfer.toDataTransfer(G,()=>{throw new E.$9});if(await this.f.prepareDocumentPaste(J,x,ae,X),X.isCancellationRequested)return;const Le=Array.from(ae).filter(([,je])=>!(je instanceof L.$MK));return C.DataTransfer.from(Le)}async providePasteEdits(M,K,G,X,J){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(K),ae=G.map(Xe=>C.Range.to(Xe)),Le=C.DataTransfer.toDataTransfer(X,async Xe=>(await this.d.$resolvePasteFileData(this.g,M,Xe)).buffer),je=await this.f.provideDocumentPasteEdits(x,ae,Le,J);if(je)return{label:je.label??(0,a.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Xe=>"mimeType"in Xe?Xe:{providerId:O.toInternalProviderId(Xe.extensionId,Xe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?C.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class N{constructor(M,K){this.d=M,this.e=K}async provideDocumentFormattingEdits(M,K,G){const X=this.d.getDocument(M),J=await this.e.provideDocumentFormattingEdits(X,K,G);if(Array.isArray(J))return J.map(C.TextEdit.from)}}class ee{constructor(M,K){this.d=M,this.e=K}async provideDocumentRangeFormattingEdits(M,K,G,X){const J=this.d.getDocument(M),x=C.Range.to(K),ae=await this.e.provideDocumentRangeFormattingEdits(J,x,G,X);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(M,K,G,X){(0,D.$sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const J=this.d.getDocument(M),x=K.map(C.Range.to),ae=await this.e.provideDocumentRangesFormattingEdits(J,x,G,X);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class Y{constructor(M,K){this.d=M,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,K,G,X,J){const x=this.d.getDocument(M),ae=C.Position.to(K),Le=await this.e.provideOnTypeFormattingEdits(x,ae,G,X,J);if(Array.isArray(Le))return Le.map(C.TextEdit.from)}}class Ee{constructor(M,K){this.e=M,this.f=K,this.d=new c.$Oac("WorkspaceSymbols")}async provideWorkspaceSymbols(M,K){const G=await this.e.provideWorkspaceSymbols(M,K);if(!(0,P.$Ib)(G))return{symbols:[]};const X=this.d.add(G),J={cacheId:X,symbols:[]};for(let x=0;x<G.length;x++){const ae=G[x];if(!ae||!ae.name){this.f.warn("INVALID SymbolInformation",ae);continue}J.symbols.push({...C.WorkspaceSymbol.from(ae),cacheId:[X,x]})}return J}async resolveWorkspaceSymbol(M,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const G=this.d.get(...M.cacheId);if(G){const X=await this.e.resolveWorkspaceSymbol(G,K);return X&&(0,F.$Xm)(M,C.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(M){this.d.delete(M)}}class ke{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,K,G){this.d=M,this.e=K,this.f=G}async provideRenameEdits(M,K,G,X){const J=this.d.getDocument(M),x=C.Position.to(K);try{const ae=await this.e.provideRenameEdits(J,x,G,X);return ae?C.WorkspaceEdit.from(ae):void 0}catch(ae){const Le=ke.g(ae);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(M,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const X=this.d.getDocument(M),J=C.Position.to(K);try{const x=await this.e.prepareRename(X,J,G);let ae,Le;if(L.$ZJ.isRange(x)?(ae=x,Le=X.getText(x)):(0,D.$kf)(x)&&(ae=x.range,Le=x.placeholder),!ae||!Le)return;if(ae.start.line>J.line||ae.end.line<J.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ae),text:Le}}catch(x){const ae=ke.g(x);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(x)}}static g(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class Pe{constructor(M,K){this.resultId=M,this.tokens=K}}class Z{constructor(M,K){this.f=M,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(M,K,G){const X=this.f.getDocument(M),J=K!==0?this.d.get(K):null;let x=typeof J?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(X,J.resultId,G):await this.g.provideDocumentSemanticTokens(X,G);return J&&this.d.delete(K),x?(x=Z.h(x),this.o(Z.n(J,x),x)):null}async releaseDocumentSemanticColoring(M){this.d.delete(M)}static h(M){return Z.j(M)?Z.k(M)?M:new L.$dL(new Uint32Array(M.data),M.resultId):Z.l(M)?Z.m(M)?M:new L.$fL(M.edits.map(K=>new L.$eL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),M.resultId):M}static j(M){return M&&!!M.data}static k(M){return M.data instanceof Uint32Array}static l(M){return M&&Array.isArray(M.edits)}static m(M){for(const K of M.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(M,K){if(!Z.j(K)||!M||!M.tokens)return K;const G=M.tokens,X=G.length,J=K.data,x=J.length;let ae=0;const Le=Math.min(X,x);for(;ae<Le&&G[ae]===J[ae];)ae++;if(ae===X&&ae===x)return new L.$fL([],K.resultId);let je=0;const Xe=Le-ae;for(;je<Xe&&G[X-je-1]===J[x-je-1];)je++;return new L.$fL([{start:ae,deleteCount:X-ae-je,data:J.subarray(ae,x-je)}],K.resultId)}o(M,K){if(Z.j(M)){const G=this.e++;return this.d.set(G,new Pe(M.resultId,M.data)),(0,i.$m0)({id:G,type:"full",data:M.data})}if(Z.l(M)){const G=this.e++;return Z.j(K)?this.d.set(G,new Pe(K.resultId,K.data)):this.d.set(G,new Pe(M.resultId)),(0,i.$m0)({id:G,type:"delta",deltas:(M.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class ue{constructor(M,K){this.d=M,this.e=K}async provideDocumentRangeSemanticTokens(M,K,G){const X=this.d.getDocument(M),J=await this.e.provideDocumentRangeSemanticTokens(X,C.Range.to(K),G);return J?this.f(J):null}f(M){return(0,i.$m0)({id:0,type:"full",data:M.data})}}class ye{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,K,G,X,J){this.f=M,this.g=K,this.h=G,this.j=X,this.k=J,this.d=new c.$Oac("CompletionItem"),this.e=new Map}async provideCompletionItems(M,K,G,X){const J=this.f.getDocument(M),x=C.Position.to(K),ae=J.getWordRangeAtPosition(x)||new L.$ZJ(x,x),Le=ae.with({end:x}),je=new g.$ad,Xe=await this.h.provideCompletionItems(J,x,X,C.CompletionContext.to(G));if(!Xe||X.isCancellationRequested)return;const He=Array.isArray(Xe)?new L.$tK(Xe):Xe,et=ye.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Ze=new f.$ic;this.e.set(et,Ze);const _e=[],it={x:et,b:_e,a:{replace:C.Range.from(ae),insert:C.Range.from(Le)},c:He.isIncomplete||void 0,d:je.elapsed()};for(let tt=0;tt<He.items.length;tt++){const ze=He.items[tt],st=this.l(ze,[et,tt],Le,ae);_e.push(st)}return it}async resolveCompletionItem(M,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...M);if(!G)return;const X=this.l(G,M),J=await this.h.resolveCompletionItem(G,K);if(!J)return;const x=this.l(J,M);return(X.h!==x.h||X.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(X.n!==x.n||X.o!==x.o||!(0,F.$Ym)(X.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...X,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,K,G,X){const J=this.e.get(K[0]);if(!J)throw Error("DisposableStore is missing...");const x=this.g.toInternal(M.command,J),ae={x:K,a:M.label,b:M.kind!==void 0?C.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(C.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:C.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};M.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=M.textEdit.newText):typeof M.insertText=="string"?ae.h=M.insertText:M.insertText instanceof L.$9J&&(ae.h=M.insertText.value,ae.i|=4);let Le;return M.textEdit?Le=M.textEdit.range:M.range&&(Le=M.range),L.$ZJ.isRange(Le)?ae.j=C.Range.from(Le):Le&&(!G?.isEqual(Le.inserting)||!X?.isEqual(Le.replacing))&&(ae.j={insert:C.Range.from(Le.inserting),replace:C.Range.from(Le.replacing)}),ae}}class ce{async provideInlineCompletions(M,K,G,X){}disposeCompletions(M){}handleDidShowCompletionItem(M,K,G){}handlePartialAccept(M,K,G){}}class $e extends ce{constructor(M,K,G,X){super(),this.f=M,this.g=K,this.h=G,this.j=X,this.d=new ie,this.e=(0,s.$OF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$OF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,K,G,X){const J=this.g.getDocument(M),x=C.Position.to(K),ae=await this.h.provideInlineCompletionItems(J,x,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:C.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},X);if(!ae||X.isCancellationRequested)return;const Le=Array.isArray(ae)?ae:ae.items,je=this.e?Array.isArray(ae)?[]:ae.commands||[]:[],Xe=this.e&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:Le}),items:Le.map((Ze,_e)=>{let it;Ze.command&&(He||(He=new f.$ic),it=this.j.toInternal(Ze.command,He));const tt=Ze.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ze.filterText,range:Ze.range?C.Range.from(Ze.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Ze.completeBracketPairs:!1}}),commands:je.map(Ze=>(He||(He=new f.$ic),this.j.toInternal(Ze,He))),suppressSuggestions:!1,enableForwardStability:Xe}}disposeCompletions(M){this.d.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,K,G){const X=this.d.get(M)?.items[K];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X,G)}handlePartialAccept(M,K,G){const X=this.d.get(M)?.items[K];X&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(X,G)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(M){const K=this.e++;return this.d.set(K,M),K}disposeReferenceId(M){const K=this.d.get(M);return this.d.delete(M),K}get(M){return this.d.get(M)}}class z{constructor(M,K){this.e=M,this.f=K,this.d=new c.$Oac("SignatureHelp")}async provideSignatureHelp(M,K,G,X){const J=this.e.getDocument(M),x=C.Position.to(K),ae=this.g(G),Le=await this.f.provideSignatureHelp(J,x,X,ae);if(Le){const je=this.d.add([Le]);return{...C.SignatureHelp.from(Le),id:je}}}g(M){let K;if(M.activeSignatureHelp){const G=C.SignatureHelp.to(M.activeSignatureHelp),X=this.d.get(M.activeSignatureHelp.id,0);X?(K=X,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...M,activeSignatureHelp:K}}releaseSignatureHelp(M){this.d.delete(M)}}class q{constructor(M,K,G,X,J){this.f=M,this.g=K,this.h=G,this.j=X,this.k=J,this.d=new c.$Oac("InlayHints"),this.e=new Map}async provideInlayHints(M,K,G){const X=this.f.getDocument(M),J=C.Range.to(K),x=await this.h.provideInlayHints(X,J,G);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ae=this.d.add(x);this.e.set(ae,new f.$ic);const Le={hints:[],cacheId:ae};for(let je=0;je<x.length;je++)this.l(x[je],J)&&Le.hints.push(this.m(x[je],[ae,je]));return this.j.trace(`[InlayHints] ${Le.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Le}async resolveInlayHint(M,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...M);if(!G)return;const X=await this.h.resolveInlayHint(G,K);if(X&&this.l(X))return this.m(X,M)}releaseHints(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,K){return M.label.length===0||Array.isArray(M.label)&&M.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(K&&!K.contains(M.position))}m(M,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const X={label:"",cacheId:K,tooltip:C.MarkdownString.fromStrict(M.tooltip),position:C.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(C.TextEdit.from),kind:M.kind&&C.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?X.label=M.label:X.label=M.label.map(J=>{const x={label:J.value};return x.tooltip=C.MarkdownString.fromStrict(J.tooltip),L.$0J.isLocation(J.location)&&(x.location=C.location.from(J.location)),J.command&&(x.command=this.g.toInternal(J.command,G)),x}),X}}class le{constructor(M,K){this.e=M,this.f=K,this.d=new c.$Oac("DocumentLink")}async provideLinks(M,K){const G=this.e.getDocument(M),X=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(X)||X.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:X.filter(le.g).map(C.DocumentLink.from)};{const J=this.d.add(X),x={links:[],cacheId:J};for(let ae=0;ae<X.length;ae++){if(!le.g(X[ae]))continue;const Le=C.DocumentLink.from(X[ae]);Le.cacheId=[J,ae],x.links.push(Le)}return x}}}static g(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...M);if(!G)return;const X=await this.f.resolveDocumentLink(G,K);if(!(!X||!le.g(X)))return C.DocumentLink.from(X)}releaseLinks(M){this.d.delete(M)}}class we{constructor(M,K){this.d=M,this.e=K}async provideColors(M,K){const G=this.d.getDocument(M),X=await this.e.provideDocumentColors(G,K);return Array.isArray(X)?X.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(M,K,G){const X=this.d.getDocument(M),J=C.Range.to(K.range),x=C.Color.to(K.color),ae=await this.e.provideColorPresentations(x,{document:X,range:J},G);if(Array.isArray(ae))return ae.map(C.ColorPresentation.from)}}class ve{constructor(M,K){this.d=M,this.e=K}async provideFoldingRanges(M,K,G){const X=this.d.getDocument(M),J=await this.e.provideFoldingRanges(X,K,G);if(Array.isArray(J))return J.map(C.FoldingRange.from)}}class me{constructor(M,K,G){this.d=M,this.e=K,this.f=G}async provideSelectionRanges(M,K,G){const X=this.d.getDocument(M),J=K.map(C.Position.to),x=await this.e.provideSelectionRanges(X,J,G);if(!(0,P.$Ib)(x))return[];if(x.length!==J.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Le=0;Le<J.length;Le++){const je=[];ae.push(je);let Xe=J[Le],He=x[Le];for(;;){if(!He.range.contains(Xe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(C.SelectionRange.from(He)),!He.parent)break;Xe=He.range,He=He.parent}}return ae}}class De{constructor(M,K){this.f=M,this.g=K,this.d=new t.$3L(""),this.e=new Map}async prepareSession(M,K,G){const X=this.f.getDocument(M),J=C.Position.to(K),x=await this.g.prepareCallHierarchy(X,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Le=>this.h(ae,Le)):[this.h(ae,x)]}async provideCallsTo(M,K,G){const X=this.j(M,K);if(!X)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyIncomingCalls(X,G);if(J)return J.map(x=>({from:this.h(M,x.from),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}async provideCallsFrom(M,K,G){const X=this.j(M,K);if(!X)throw new Error("missing call hierarchy item");const J=await this.g.provideCallHierarchyOutgoingCalls(X,G);if(J)return J.map(x=>({to:this.h(M,x.to),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}releaseSession(M){this.e.delete(M)}h(M,K){const G=this.e.get(M),X=C.CallHierarchyItem.from(K,M,G.size.toString(36));return G.set(X._itemId,K),X}j(M,K){return this.e.get(M)?.get(K)}}class ne{constructor(M,K){this.f=M,this.g=K,this.d=new t.$3L(""),this.e=new Map}async prepareSession(M,K,G){const X=this.f.getDocument(M),J=C.Position.to(K),x=await this.g.prepareTypeHierarchy(X,J,G);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Le=>this.h(ae,Le)):[this.h(ae,x)]}async provideSupertypes(M,K,G){const X=this.j(M,K);if(!X)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySupertypes(X,G);if(J)return J.map(x=>this.h(M,x))}async provideSubtypes(M,K,G){const X=this.j(M,K);if(!X)throw new Error("missing type hierarchy item");const J=await this.g.provideTypeHierarchySubtypes(X,G);if(J)return J.map(x=>this.h(M,x))}releaseSession(M){this.e.delete(M)}h(M,K){const G=this.e.get(M),X=C.TypeHierarchyItem.from(K,M,G.size.toString(36));return G.set(X._itemId,K),X}j(M,K){return this.e.get(M)?.get(K)}}class he{static toInternalProviderId(M,K){return M+"."+K}constructor(M,K,G,X,J){this.d=M,this.e=K,this.f=G,this.g=X,this.h=J}async provideDocumentOnDropEdits(M,K,G,X,J){const x=this.e.getDocument(K),ae=C.Position.to(G),Le=C.DataTransfer.toDataTransfer(X,async Xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,M,Xe)).buffer),je=await this.f.provideDocumentDropEdits(x,ae,Le,J);if(je)return{label:je.label??(0,a.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Xe=>"mimeType"in Xe?Xe:{providerId:he.toInternalProviderId(Xe.extensionId,Xe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?C.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class se{constructor(M,K){this.d=M,this.e=K}async provideMappedEdits(M,K,G,X){const J=w.URI.revive(M),x=this.d.getDocument(J),ae={selections:G.selections.map(je=>C.Selection.to(je)),related:G.related.map(je=>({uri:w.URI.revive(je.uri),range:C.Range.to(je.range)}))},Le=await this.e.provideMappedEdits(x,K,ae,X);return Le?C.WorkspaceEdit.from(Le):null}}class oe{constructor(M,K){this.adapter=M,this.extension=K}}class fe{static{this.d=0}constructor(M,K,G,X,J,x,ae,Le){this.g=K,this.h=G,this.j=X,this.k=J,this.l=x,this.m=ae,this.n=Le,this.f=new Map,this.e=M.getProxy(l.$VJ.MainThreadLanguageFeatures)}o(M,K){return C.DocumentSelector.from(M,this.g,K)}p(M){return new L.$XJ(()=>{this.f.delete(M),this.e.$unregister(M)})}q(){return fe.d++}async t(M,K,G,X,J,x=!1){const ae=this.f.get(M);if(!ae||!(ae.adapter instanceof K))return X;const Le=Date.now();x||this.l.trace(`[${ae.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const je=G(ae.adapter,ae.extension);return Promise.resolve(je).catch(Xe=>{(0,E.$2)(Xe)||(this.l.error(`[${ae.extension.identifier.value}] provider FAILED`),this.l.error(Xe),this.n.onExtensionError(ae.extension.identifier,Xe))}).finally(()=>{x||this.l.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Le}ms`)}),b.CancellationToken.isCancellationToken(J)?(0,$.$vg)(je,J):je}u(M,K){const G=this.q();return this.f.set(G,new oe(M,K)),G}static w(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,K,G,X){const J=this.u(new n(this.h,G),M),x=X&&X.label||fe.w(M);return this.e.$registerDocumentSymbolProvider(J,this.o(K,M),x),this.p(J)}$provideDocumentSymbols(M,K,G){return this.t(M,n,X=>X.provideDocumentSymbols(w.URI.revive(K),G),void 0,G)}registerCodeLensProvider(M,K,G){const X=this.q(),J=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(X,new oe(new o(this.h,this.j.converter,G),M)),this.e.$registerCodeLensSupport(X,this.o(K,M),J);let x=this.p(X);if(J!==void 0){const ae=G.onDidChangeCodeLenses(Le=>this.e.$emitCodeLensEvent(J));x=L.$XJ.from(x,ae)}return x}$provideCodeLenses(M,K,G){return this.t(M,o,X=>X.provideCodeLenses(w.URI.revive(K),G),void 0,G)}$resolveCodeLens(M,K,G){return this.t(M,o,X=>X.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(M,K){this.t(M,o,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(M,K,G){const X=this.u(new m(this.h,G),M);return this.e.$registerDefinitionSupport(X,this.o(K,M)),this.p(X)}$provideDefinition(M,K,G,X){return this.t(M,m,J=>J.provideDefinition(w.URI.revive(K),G,X),[],X)}registerDeclarationProvider(M,K,G){const X=this.u(new I(this.h,G),M);return this.e.$registerDeclarationSupport(X,this.o(K,M)),this.p(X)}$provideDeclaration(M,K,G,X){return this.t(M,I,J=>J.provideDeclaration(w.URI.revive(K),G,X),[],X)}registerImplementationProvider(M,K,G){const X=this.u(new k(this.h,G),M);return this.e.$registerImplementationSupport(X,this.o(K,M)),this.p(X)}$provideImplementation(M,K,G,X){return this.t(M,k,J=>J.provideImplementation(w.URI.revive(K),G,X),[],X)}registerTypeDefinitionProvider(M,K,G){const X=this.u(new r(this.h,G),M);return this.e.$registerTypeDefinitionSupport(X,this.o(K,M)),this.p(X)}$provideTypeDefinition(M,K,G,X){return this.t(M,r,J=>J.provideTypeDefinition(w.URI.revive(K),G,X),[],X)}registerHoverProvider(M,K,G,X){const J=this.u(new h(this.h,G),M);return this.e.$registerHoverProvider(J,this.o(K,M)),this.p(J)}$provideHover(M,K,G,X){return this.t(M,h,J=>J.provideHover(w.URI.revive(K),G,X),void 0,X)}registerEvaluatableExpressionProvider(M,K,G,X){const J=this.u(new v(this.h,G),M);return this.e.$registerEvaluatableExpressionProvider(J,this.o(K,M)),this.p(J)}$provideEvaluatableExpression(M,K,G,X){return this.t(M,v,J=>J.provideEvaluatableExpression(w.URI.revive(K),G,X),void 0,X)}registerInlineValuesProvider(M,K,G,X){const J=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,x=this.u(new R(this.h,G),M);this.e.$registerInlineValuesProvider(x,this.o(K,M),J);let ae=this.p(x);if(J!==void 0){const Le=G.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(J));ae=L.$XJ.from(ae,Le)}return ae}$provideInlineValues(M,K,G,X,J){return this.t(M,R,x=>x.provideInlineValues(w.URI.revive(K),G,X,J),void 0,J)}registerDocumentHighlightProvider(M,K,G){const X=this.u(new W(this.h,G),M);return this.e.$registerDocumentHighlightProvider(X,this.o(K,M)),this.p(X)}$provideDocumentHighlights(M,K,G,X){return this.t(M,W,J=>J.provideDocumentHighlights(w.URI.revive(K),G,X),void 0,X)}registerLinkedEditingRangeProvider(M,K,G){const X=this.u(new V(this.h,G),M);return this.e.$registerLinkedEditingRangeProvider(X,this.o(K,M)),this.p(X)}$provideLinkedEditingRanges(M,K,G,X){return this.t(M,V,async J=>{const x=await J.provideLinkedEditingRanges(w.URI.revive(K),G,X);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?fe.y(x.wordPattern):void 0}},void 0,X)}registerReferenceProvider(M,K,G){const X=this.u(new U(this.h,G),M);return this.e.$registerReferenceSupport(X,this.o(K,M)),this.p(X)}$provideReferences(M,K,G,X,J){return this.t(M,U,x=>x.provideReferences(w.URI.revive(K),G,X,J),void 0,J)}registerCodeActionProvider(M,K,G,X){const J=new f.$ic,x=this.u(new B(this.h,this.j.converter,this.k,G,this.l,M,this.m),M);return this.e.$registerQuickFixSupport(x,this.o(K,M),{providedKinds:X?.providedCodeActionKinds?.map(ae=>ae.value),documentation:X?.documentation?.map(ae=>({kind:ae.kind.value,command:this.j.converter.toInternal(ae.command,J)}))},fe.w(M),!!G.resolveCodeAction),J.add(this.p(x)),J}$provideCodeActions(M,K,G,X,J){return this.t(M,B,x=>x.provideCodeActions(w.URI.revive(K),G,X,J),void 0,J)}$resolveCodeAction(M,K,G){return this.t(M,B,X=>X.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(M,K){this.t(M,B,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(M,K,G){const X=this.u(new N(this.h,G),M);return this.e.$registerDocumentFormattingSupport(X,this.o(K,M),M.identifier,M.displayName||M.name),this.p(X)}$provideDocumentFormattingEdits(M,K,G,X){return this.t(M,N,J=>J.provideDocumentFormattingEdits(w.URI.revive(K),G,X),void 0,X)}registerDocumentRangeFormattingEditProvider(M,K,G){const X=typeof G.provideDocumentRangesFormattingEdits=="function",J=this.u(new ee(this.h,G),M);return this.e.$registerRangeFormattingSupport(J,this.o(K,M),M.identifier,M.displayName||M.name,X),this.p(J)}$provideDocumentRangeFormattingEdits(M,K,G,X,J){return this.t(M,ee,x=>x.provideDocumentRangeFormattingEdits(w.URI.revive(K),G,X,J),void 0,J)}$provideDocumentRangesFormattingEdits(M,K,G,X,J){return this.t(M,ee,x=>x.provideDocumentRangesFormattingEdits(w.URI.revive(K),G,X,J),void 0,J)}registerOnTypeFormattingEditProvider(M,K,G,X){const J=this.u(new Y(this.h,G),M);return this.e.$registerOnTypeFormattingSupport(J,this.o(K,M),X,M.identifier),this.p(J)}$provideOnTypeFormattingEdits(M,K,G,X,J,x){return this.t(M,Y,ae=>ae.provideOnTypeFormattingEdits(w.URI.revive(K),G,X,J,x),void 0,x)}registerWorkspaceSymbolProvider(M,K){const G=this.u(new Ee(K,this.l),M);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(M,K,G){return this.t(M,Ee,X=>X.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(M,K,G){return this.t(M,Ee,X=>X.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(M,K){this.t(M,Ee,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(M,K,G){const X=this.u(new ke(this.h,G,this.l),M);return this.e.$registerRenameSupport(X,this.o(K,M),ke.supportsResolving(G)),this.p(X)}$provideRenameEdits(M,K,G,X,J){return this.t(M,ke,x=>x.provideRenameEdits(w.URI.revive(K),G,X,J),void 0,J)}$resolveRenameLocation(M,K,G,X){return this.t(M,ke,J=>J.resolveRenameLocation(w.URI.revive(K),G,X),void 0,X)}registerDocumentSemanticTokensProvider(M,K,G,X){const J=this.u(new Z(this.h,G),M),x=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(J,this.o(K,M),X,x);let ae=this.p(J);if(x){const Le=G.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(x));ae=L.$XJ.from(ae,Le)}return ae}$provideDocumentSemanticTokens(M,K,G,X){return this.t(M,Z,J=>J.provideDocumentSemanticTokens(w.URI.revive(K),G,X),null,X)}$releaseDocumentSemanticTokens(M,K){this.t(M,Z,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,K,G,X){const J=this.u(new ue(this.h,G),M);return this.e.$registerDocumentRangeSemanticTokensProvider(J,this.o(K,M),X),this.p(J)}$provideDocumentRangeSemanticTokens(M,K,G,X){return this.t(M,ue,J=>J.provideDocumentRangeSemanticTokens(w.URI.revive(K),G,X),null,X)}registerCompletionItemProvider(M,K,G,X){const J=this.u(new ye(this.h,this.j.converter,G,this.m,M),M);return this.e.$registerCompletionsProvider(J,this.o(K,M),X,ye.supportsResolving(G),M.identifier),this.p(J)}$provideCompletionItems(M,K,G,X,J){return this.t(M,ye,x=>x.provideCompletionItems(w.URI.revive(K),G,X,J),void 0,J)}$resolveCompletionItem(M,K,G){return this.t(M,ye,X=>X.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(M,K){this.t(M,ye,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(M,K,G,X){const J=new $e(M,this.h,G,this.j.converter),x=this.u(J,M);return this.e.$registerInlineCompletionsSupport(x,this.o(K,M),J.supportsHandleEvents,p.$Ul.toKey(M.identifier.value),X?.yieldTo?.map(ae=>p.$Ul.toKey(ae))||[]),this.p(x)}$provideInlineCompletions(M,K,G,X,J){return this.t(M,ce,x=>x.provideInlineCompletions(w.URI.revive(K),G,X,J),void 0,J)}$handleInlineCompletionDidShow(M,K,G,X){this.t(M,ce,async J=>{J.handleDidShowCompletionItem(K,G,X)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,K,G,X){this.t(M,ce,async J=>{J.handlePartialAccept(K,G,X)},void 0,void 0)}$freeInlineCompletionsList(M,K){this.t(M,ce,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(M,K,G,X){const J=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,x=this.u(new z(this.h,G),M);return this.e.$registerSignatureHelpProvider(x,this.o(K,M),J),this.p(x)}$provideSignatureHelp(M,K,G,X,J){return this.t(M,z,x=>x.provideSignatureHelp(w.URI.revive(K),G,X,J),void 0,J)}$releaseSignatureHelp(M,K){this.t(M,z,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(M,K,G){const X=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,J=this.u(new q(this.h,this.j.converter,G,this.l,M),M);this.e.$registerInlayHintsProvider(J,this.o(K,M),typeof G.resolveInlayHint=="function",X,fe.w(M));let x=this.p(J);if(X!==void 0){const ae=G.onDidChangeInlayHints(Le=>this.e.$emitInlayHintsEvent(X));x=L.$XJ.from(x,ae)}return x}$provideInlayHints(M,K,G,X){return this.t(M,q,J=>J.provideInlayHints(w.URI.revive(K),G,X),void 0,X)}$resolveInlayHint(M,K,G){return this.t(M,q,X=>X.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(M,K){this.t(M,q,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(M,K,G){const X=this.u(new le(this.h,G),M);return this.e.$registerDocumentLinkProvider(X,this.o(K,M),typeof G.resolveDocumentLink=="function"),this.p(X)}$provideDocumentLinks(M,K,G){return this.t(M,le,X=>X.provideLinks(w.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(M,K,G){return this.t(M,le,X=>X.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(M,K){this.t(M,le,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(M,K,G){const X=this.u(new we(this.h,G),M);return this.e.$registerDocumentColorProvider(X,this.o(K,M)),this.p(X)}$provideDocumentColors(M,K,G){return this.t(M,we,X=>X.provideColors(w.URI.revive(K),G),[],G)}$provideColorPresentations(M,K,G,X){return this.t(M,we,J=>J.provideColorPresentations(w.URI.revive(K),G,X),void 0,X)}registerFoldingRangeProvider(M,K,G){const X=this.q(),J=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(X,new oe(new ve(this.h,G),M)),this.e.$registerFoldingRangeProvider(X,this.o(K,M),M.identifier,J);let x=this.p(X);if(J!==void 0){const ae=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(J));x=L.$XJ.from(x,ae)}return x}$provideFoldingRanges(M,K,G,X){return this.t(M,ve,J=>J.provideFoldingRanges(w.URI.revive(K),G,X),void 0,X)}registerSelectionRangeProvider(M,K,G){const X=this.u(new me(this.h,G,this.l),M);return this.e.$registerSelectionRangeProvider(X,this.o(K,M)),this.p(X)}$provideSelectionRanges(M,K,G,X){return this.t(M,me,J=>J.provideSelectionRanges(w.URI.revive(K),G,X),[],X)}registerCallHierarchyProvider(M,K,G){const X=this.u(new De(this.h,G),M);return this.e.$registerCallHierarchyProvider(X,this.o(K,M)),this.p(X)}$prepareCallHierarchy(M,K,G,X){return this.t(M,De,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,X)),void 0,X)}$provideCallHierarchyIncomingCalls(M,K,G,X){return this.t(M,De,J=>J.provideCallsTo(K,G,X),void 0,X)}$provideCallHierarchyOutgoingCalls(M,K,G,X){return this.t(M,De,J=>J.provideCallsFrom(K,G,X),void 0,X)}$releaseCallHierarchy(M,K){this.t(M,De,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(M,K,G){const X=this.u(new ne(this.h,G),M);return this.e.$registerTypeHierarchyProvider(X,this.o(K,M)),this.p(X)}$prepareTypeHierarchy(M,K,G,X){return this.t(M,ne,J=>Promise.resolve(J.prepareSession(w.URI.revive(K),G,X)),void 0,X)}$provideTypeHierarchySupertypes(M,K,G,X){return this.t(M,ne,J=>J.provideSupertypes(K,G,X),void 0,X)}$provideTypeHierarchySubtypes(M,K,G,X){return this.t(M,ne,J=>J.provideSubtypes(K,G,X),void 0,X)}$releaseTypeHierarchy(M,K){this.t(M,ne,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(M,K,G,X){const J=this.q();this.f.set(J,new oe(new he(this.e,this.h,G,J,M),M));const x=(0,s.$OF)(M,"dropMetadata")&&X?he.toInternalProviderId(M.identifier.value,X.id):void 0;return this.e.$registerDocumentOnDropEditProvider(J,this.o(K,M),x,(0,s.$OF)(M,"dropMetadata")?X:void 0),this.p(J)}$provideDocumentOnDropEdits(M,K,G,X,J,x){return this.t(M,he,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(K,w.URI.revive(G),X,J,x)),void 0,void 0)}registerMappedEditsProvider(M,K,G){const X=this.u(new se(this.h,G),M);return this.e.$registerMappedEditsProvider(X,this.o(K,M)),this.p(X)}$provideMappedEdits(M,K,G,X,J){return this.t(M,se,x=>Promise.resolve(x.provideMappedEdits(K,G,X,J)),null,J)}registerDocumentPasteEditProvider(M,K,G,X){const J=this.q();this.f.set(J,new oe(new O(this.e,this.h,G,J,M),M));const x=O.toInternalProviderId(M.identifier.value,X.id);return this.e.$registerPasteEditProvider(J,this.o(K,M),x,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:X.copyMimeTypes,pasteMimeTypes:X.pasteMimeTypes}),this.p(J)}$prepareDocumentPaste(M,K,G,X,J){return this.t(M,O,x=>x.prepareDocumentPaste(w.URI.revive(K),G,X,J),void 0,J)}$providePasteEdits(M,K,G,X,J,x){return this.t(M,O,ae=>ae.providePasteEdits(K,w.URI.revive(G),X,J,x),void 0,x)}static y(M){return{pattern:M.source,flags:M.flags}}static z(M){return{decreaseIndentPattern:fe.y(M.decreaseIndentPattern),increaseIndentPattern:fe.y(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?fe.y(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?fe.y(M.unIndentedLinePattern):void 0}}static B(M){return{beforeText:fe.y(M.beforeText),afterText:M.afterText?fe.y(M.afterText):void 0,previousLineText:M.previousLineText?fe.y(M.previousLineText):void 0,action:M.action}}static C(M){return M.map(fe.B)}setLanguageConfiguration(M,K,G){const{wordPattern:X}=G;if(X&&(0,S.$ye)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this.h.setWordDefinitionFor(K,X):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",M,"Do not use."),G.autoClosingPairs&&(0,s.$PF)(M,"languageConfigurationAutoClosingPairs");const J=this.q(),x={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?fe.y(G.wordPattern):void 0,indentationRules:G.indentationRules?fe.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?fe.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs};return this.e.$setLanguageConfiguration(J,K,x),this.p(J)}$setWordDefinitions(M){for(const K of M)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Xac=fe}),define(Ae[240],Re([1,0,3,8,7,29,13,6]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=void 0;class S{constructor(P,D,u,b){this.c=D,this.d=u,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(w.$VJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,D){await this.a.$changeLanguage(P,D);const u=this.c.getDocumentData(P);if(!u)throw new Error(`document '${P.toString()}' NOT found`);return u.document}async tokenAtPosition(P,D){const u=P.version,b=F.Position.from(D),p=await this.a.$tokensAtPosition(P.uri,b),f={type:C.StandardTokenType.Other,range:P.getWordRangeAtPosition(D)??new C.$ZJ(D.line,D.character,D.line,D.character)};if(!p)return f;const i={range:F.Range.to(p.range),type:F.TokenType.to(p.type)};return!i.range.contains(D)||u!==P.version?f:i}createLanguageStatusItem(P,D,u){const b=this.f++,p=this.a,f=this.g,i=`${P.identifier.value}/${D}`;if(f.has(i))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);f.add(i);const t={selector:u,id:D,name:P.displayName??P.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const g=new l.$ic,E=()=>{if(c?.dispose(),!f.has(i)){console.warn(`LanguageStatusItem (${D}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Hg)(()=>{g.clear(),this.a.$setLanguageStatus(b,{id:i,name:t.name??P.displayName??P.name,source:P.displayName??P.name,selector:F.DocumentSelector.from(t.selector,this.e),label:t.text,detail:t.detail??"",severity:t.severity===C.LanguageStatusSeverity.Error?L.default.Error:t.severity===C.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:t.command&&this.d.toInternal(t.command,g),accessibilityInfo:t.accessibilityInformation,busy:t.busy})},0)},$={dispose(){g.dispose(),c?.dispose(),p.$removeLanguageStatus(b),f.delete(i)},get id(){return t.id},get name(){return t.name},set name(s){t.name=s,E()},get selector(){return t.selector},set selector(s){t.selector=s,E()},get text(){return t.text},set text(s){t.text=s,E()},get detail(){return t.detail},set detail(s){t.detail=s,E()},get severity(){return t.severity},set severity(s){t.severity=s,E()},get accessibilityInformation(){return t.accessibilityInformation},set accessibilityInformation(s){t.accessibilityInformation=s,E()},get command(){return t.command},set command(s){t.command=s,E()},get busy(){return t.busy},set busy(s){t.busy=s,E()}};return E(),$}}e.$Fbc=S}),define(Ae[81],Re([1,0,22,15,2,4,14,3,27,17]),function(be,e,w,F,C,L,A,l,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=e.$ubc=void 0;let P=class{constructor(u,b,p){this.f=p,this.d=new Map,this.a=b.getProxy(l.$VJ.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===w.$f}getMessage(u,b){const{message:p,args:f,comment:i}=b;if(this.c)return(0,F.$ne)(p,f??{});let t=p;i&&i.length>0&&(t+=`/${Array.isArray(i)?i.join(""):i}`);const c=this.d.get(u)?.contents[t];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,F.$ne)(c??p,f??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const p=await this.g(u);if(!p){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(p),i=JSON.parse(f);b=u.isBuiltin?i.contents?.bundle:i}catch(f){this.f.error(`Failed to load translations for ${u.identifier.value} from ${p}: ${f.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:p})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return C.URI.revive(b)}return u.l10n?C.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$ubc=P,e.$ubc=P=Ke([Ve(0,S.$bM),Ve(1,d.$XL),Ve(2,A.$4i)],P),e.$vbc=(0,L.$Ah)("IExtHostLocalizationService")}),define(Ae[241],Re([1,0,14,3,27,17,2,68]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;let S=class extends w.$cj{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,l.$0g)(b))),this.r=D.getProxy(F.$VJ.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(A.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this.r.$setVisibility(D,u)}s(D,u,b){return new d(this.r,D,u,b)}};e.$Vcc=S,e.$Vcc=S=Ke([Ve(0,L.$XL),Ve(1,C.$bM)],S);class d extends w.$0i{constructor(D,u,b,p){super(p?.logLevel==="always"),this.r=D,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,p).then(()=>{this.u(this.n),this.m=!0})}g(D,u){const b=[[D,u]];this.m?this.u(b):this.n.push(...b)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,25]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=e.$wbc=void 0,e.$wbc=(0,F.$Ah)("IExtHostManagedSockets");let l=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(w.$VJ.MainThreadManagedSockets)}setFactory(D,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new S(D,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this.b,b=await this.c.makeConnection(),p=new C.$ic;return this.d.set(u,new d(u,b,p)),p.add((0,C.$hc)(()=>this.d.delete(u))),p.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),p.dispose()})),p.add(b.onDidClose(f=>{this.a.$onDidManagedSocketClose(u,f?.stack??f?.message),p.dispose()})),p.add(b.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(u,A.$Ed.wrap(f)))),u}$remoteSocketWrite(D,u){this.d.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this.d.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$xbc=l,e.$xbc=l=Ke([Ve(0,L.$XL)],l);class S{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class d extends C.$jc{constructor(D,u,b){super(),this.socketId=D,this.actual=u,this.B(b)}}}),define(Ae[242],Re([1,0,3,14,26]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gbc=void 0;function L(l){return l&&l.title}let A=class{constructor(S,d){this.b=d,this.a=S.getProxy(w.$VJ.MainThreadMessageService)}showMessage(S,d,P,D,u){const b={source:{identifier:S.identifier,label:S.displayName||S.name}};let p;typeof D=="string"||L(D)?p=[D,...u]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,p=u),b.useCustom&&(0,C.$PF)(S,"resolvers");const f=[];for(let i=0;i<p.length;i++){const t=p[i];if(typeof t=="string")f.push({title:t,handle:i,isCloseAffordance:!1});else if(typeof t=="object"){const{title:c,isCloseAffordance:g}=t;f.push({title:c,isCloseAffordance:!!g,handle:i})}else this.b.warn("Invalid message item:",t)}return this.a.$showMessage(d,P,b,f).then(i=>{if(typeof i=="number")return p[i]})}};e.$Gbc=A,e.$Gbc=A=Ke([Ve(1,F.$4i)],A)}),define(Ae[243],Re([1,0,152,25,5,6,28,15,16,2,38,54,3,31,8,7,46,205,104,9,24,12]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,o,y,m,I){this.q=y,this.r=m,this.s=I,this.f=new Map,this.g=new A.$yi,this.h=new Map,this.j=new C.$ed({onListenerError:g.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$ed({onListenerError:g.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$ed({onListenerError:g.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$ed({onListenerError:g.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Oac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy(u.$VJ.MainThreadNotebook),this.c=n.getProxy(u.$VJ.MainThreadNotebookDocuments),this.d=n.getProxy(u.$VJ.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const r=k.notebookEditor?.notebookUri,h=k.cell.handle,R=this.g.get(r)?.getCell(h);if(R)return R.apiCell}if(k&&k.$mid===14){const r=k.uri,h=this.g.get(r);if(h)return h.apiNotebook}return k}}),s.A(o)}getEditorById(n){const o=this.h.get(n);if(!o)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(n){for(const[o,y]of this.h)if(y.apiEditor===n)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,o){const y=this.g.get(n);if(!y&&!o)throw new Error(`NO notebook document for '${n}'`);return y}static t(n,o){if(!o)return;const y=o.filenamePattern.map(m=>p.NotebookExclusiveDocumentPattern.from(m)).filter(m=>m!==void 0);if(o.filenamePattern&&!y){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:o.displayName,filenamePattern:y,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,o,y){const m=s.a++,I=typeof y.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(m,y),this.b.$registerNotebookCellStatusBarItemProvider(m,I,o);let k;return I!==void 0&&(k=y.onDidChangeCellStatusBarItems(r=>this.b.$emitCellStatusBarEvent(I))),new f.$XJ(()=>{this.f.delete(m),this.b.$unregisterNotebookCellStatusBarItemProvider(m,I),k?.dispose()})}async createNotebookDocument(n){const o=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&p.NotebookData.from(n.content)});return d.URI.revive(o)}async openNotebookDocument(n){const o=this.g.get(n);if(o)return o.apiNotebook;const y=await this.c.$tryOpenNotebook(n),m=this.g.get(d.URI.revive(y));return(0,S.$tf)(m?.apiNotebook)}async showNotebookDocument(n,o){d.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let y;typeof o=="object"?y={position:p.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(p.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:y={preserveFocus:!1};const m=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,y),I=m&&this.h.get(m)?.apiEditor;if(I)return I;throw m?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,o,y,m){const I=this.f.get(n),k=d.URI.revive(o),r=this.g.get(k);if(!r||!I)return;const h=r.getCellFromIndex(y);if(!h)return;const v=await I.provideCellStatusBarItems(h.apiCell,m);if(!v)return;const R=new L.$ic,W=this.p.add([R]),U=(Array.isArray(v)?v:[v]).map(B=>p.NotebookStatusBarItem.from(B,this.i,R));return{cacheId:W,items:U}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,o,y,m,I){if((0,l.$le)(o))throw new Error("viewType cannot be empty or just whitespace");const k=this.u++;return this.w.set(k,{viewType:o,serializer:y,options:m}),this.b.$registerNotebookSerializer(k,{id:n.identifier,location:n.extensionLocation},o,p.NotebookDocumentContentOptions.from(m),s.t(n,I)),(0,L.$hc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(n,o,y){const m=this.w.get(n);if(!m)throw new Error("NO serializer found");const I=await m.serializer.deserializeNotebook(o.buffer,y);return new i.$cA(p.NotebookData.from(I))}async $notebookToData(n,o,y){const m=this.w.get(n);if(!m)throw new Error("NO serializer found");const I=await m.serializer.serializeNotebook(p.NotebookData.to(o.value),y);return F.$Ed.wrap(I)}async $saveNotebook(n,o,y,m,I){const k=d.URI.revive(o),r=this.w.get(n);if(!r)throw new Error("NO serializer found");const h=this.g.get(k);if(!h)throw new Error("Document NOT found");if(h.versionId!==y)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new P.$mk((0,w.localize)(0,null,this.y(k)),6);await this.x(k,m);const v={metadata:(0,E.$3m)(h.apiNotebook.metadata,B=>!(r.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of h.apiNotebook.getCells()){const O=new f.$kL(B.kind,B.document.getText(),B.document.languageId,B.mime,r.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);O.metadata=(0,E.$3m)(B.metadata,N=>!(r.options?.transientCellMetadata??{})[N]),v.cells.push(O)}const R=await r.serializer.serializeNotebook(v,I);await this.s.value.writeFile(k,R);const W=this.s.getFileSystemProviderExtUri(k.scheme),V=await this.s.value.stat(k);return{name:W.basename(k),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$xk({mtime:V.mtime,size:V.size}),children:void 0}}async x(n,o){const y=await this.s.value.stat(n);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==P.$wk&&typeof y.mtime=="number"&&typeof y.size=="number"&&o.mtime<y.mtime&&o.etag!==P.$xk({mtime:o.mtime,size:y.size}))throw new P.$mk((0,w.localize)(1,null),3,o)}y(n){return n.scheme===$.Schemas.file?n.fsPath:n.toString()}z(n,o,y){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const m=new c.$ncc(o,this.d,n,y.visibleRanges.map(p.NotebookRange.to),y.selections.map(p.NotebookRange.to),typeof y.viewColumn=="number"?p.ViewColumn.to(y.viewColumn):void 0);this.h.set(o,m)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const y of n.value.removedDocuments){const m=d.URI.revive(y),I=this.g.get(m);I&&(I.dispose(),this.g.delete(m),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(I.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===m.toString()&&this.h.delete(k.id)}if(n.value.addedDocuments){const y=[];for(const m of n.value.addedDocuments){const I=d.URI.revive(m.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const k=new t.$mcc(this.c,this.q,this.r,I,m);y.push(...m.cells.map(r=>t.$lcc.asModelAddData(k.apiNotebook,r))),this.g.get(I)?.dispose(),this.g.set(I,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:y}),this.m.fire(k.apiNotebook)}}if(n.value.addedEditors)for(const y of n.value.addedEditors){if(this.h.has(y.id))return;const m=d.URI.revive(y.documentUri),I=this.g.get(m);I&&this.z(I,y.id,y)}const o=[];if(n.value.removedEditors)for(const y of n.value.removedEditors){const m=this.h.get(y);m&&(this.h.delete(y),this.k?.id===m.id&&(this.k=void 0),o.push(m))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(m=>this.h.get(m)).filter(m=>!!m);const y=new Set;this.l.forEach(m=>y.add(m.id));for(const m of this.h.values()){const I=y.has(m.id);m._acceptVisibility(I)}this.l=[...this.h.values()].map(m=>m).filter(m=>m.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const o=b.$jM.String.with("notebookType","A notebook type"),y=new b.$lM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new b.$jM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>F.$Ed.wrap(I))],new b.$kM("Notebook Data",I=>p.NotebookData.to(I.value))),m=new b.$lM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new b.$jM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new i.$cA(p.NotebookData.from(I)))],new b.$kM("Bytes",I=>I.buffer));n.registerApiCommand(y),n.registerApiCommand(m)}}e.$occ=s}),define(Ae[244],Re([1,0,18,13,21,5,6,28,2,20,14,54,3,31,8,7,77,198,26,46]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=void 0;let E=class{constructor(I,k,r,h,v){this.m=k,this.n=r,this.o=h,this.q=v,this.b=new l.$yi,this.c=new l.$yi,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new D.$Oac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$ed,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=I.getProxy(u.$VJ.MainThreadNotebookKernels);const R=new b.$lM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$jM("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],b.$kM.Void);this.o.registerApiCommand(R)}createNotebookController(I,k,r,h,v,R){for(const ye of this.j.values())if(ye.controller.id===k&&d.$Ul.equals(I.identifier,ye.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const W=this.k++,V=this;this.q.trace(`NotebookController[${W}], CREATED by ${I.identifier.value}, ${k}`);const U=()=>console.warn(`NO execute handler from notebook controller '${ee.id}' of extension: '${I.identifier}'`);let B=!1;const O=new L.$ed,N=new L.$ed,ee={id:y(I.identifier,k),notebookType:r,extensionId:I.identifier,extensionLocation:I.extensionLocation,label:h||I.identifier.value,preloads:R?R.map(p.NotebookRendererScript.from):[]};let Y=v??U,Ee;this.a.$addKernel(W,ee).catch(ye=>{console.log(ye),B=!0});let ke=0;const Pe=()=>{if(B)return;const ye=++ke;Promise.resolve().then(()=>{ye===ke&&this.a.$updateKernel(W,ee)})},Z=new l.$yi,ue={get id(){return k},get notebookType(){return ee.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return ee.label},set label(ye){ee.label=ye??I.displayName??I.name,Pe()},get detail(){return ee.detail??""},set detail(ye){ee.detail=ye,Pe()},get description(){return ee.description??""},set description(ye){ee.description=ye,Pe()},get supportedLanguages(){return ee.supportedLanguages},set supportedLanguages(ye){ee.supportedLanguages=ye,Pe()},get supportsExecutionOrder(){return ee.supportsExecutionOrder??!1},set supportsExecutionOrder(ye){ee.supportsExecutionOrder=ye,Pe()},get rendererScripts(){return ee.preloads?ee.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(ye){Y=ye??U},get interruptHandler(){return Ee},set interruptHandler(ye){Ee=ye,ee.supportsInterrupt=!!ye,Pe()},createNotebookCellExecution(ye){if(B)throw new Error("notebook controller is DISPOSED");if(!Z.has(ye.notebook.uri))throw V.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.notebook.uri.toString()}`);return V._createNotebookCellExecution(ye,y(I.identifier,this.id))},createNotebookExecution(ye){if((0,c.$PF)(I,"notebookExecution"),B)throw new Error("notebook controller is DISPOSED");if(!Z.has(ye.uri))throw V.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ye.uri.toString()}`);return V._createNotebookExecution(ye,y(I.identifier,this.id))},dispose:()=>{B||(this.q.trace(`NotebookController[${W}], DISPOSED`),B=!0,this.j.delete(W),O.dispose(),N.dispose(),this.a.$removeKernel(W))},updateNotebookAffinity(ye,ce){ce===f.NotebookControllerAffinity2.Hidden&&(0,c.$PF)(I,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(W,ye.uri,ce)},onDidReceiveMessage:N.event,postMessage(ye,ce){return(0,c.$PF)(I,"notebookMessaging"),V.a.$postMessage(W,ce&&V.n.getIdByEditor(ce),ye)},asWebviewUri(ye){return(0,c.$PF)(I,"notebookMessaging"),(0,i.$Qob)(ye,V.m.remote)}};return this.j.set(W,{extensionId:I.identifier,controller:ue,onDidReceiveMessage:N,onDidChangeSelection:O,associatedNotebooks:Z}),ue}getIdByController(I){for(const[k,r]of this.j)if(r.controller===I)return y(r.extensionId,I.id);return null}createNotebookControllerDetectionTask(I,k){const r=this.f++,h=this;this.q.trace(`NotebookControllerDetectionTask[${r}], CREATED by ${I.identifier.value}`),this.a.$addKernelDetectionTask(r,k);const v={dispose:()=>{this.e.delete(r),h.a.$removeKernelDetectionTask(r)}};return this.e.set(r,v),v}registerKernelSourceActionProvider(I,k,r){const h=this.h++,v=typeof r.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,R=this;this.g.set(h,r),this.q.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${I.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,k);let W;return v!==void 0&&(W=r.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this.g.delete(h),R.a.$removeKernelSourceActionProvider(h,h),W?.dispose()}}}async $provideKernelSourceActions(I,k){const r=this.g.get(I);if(r){const h=new A.$ic;return this.i.add([h]),(await r.provideNotebookKernelSourceActions(k)??[]).map(R=>p.NotebookKernelSourceAction.from(R,this.o.converter,h))}return[]}$acceptNotebookAssociation(I,k,r){const h=this.j.get(I);if(h){const v=this.n.getNotebookDocument(S.URI.revive(k));r?h.associatedNotebooks.set(v.uri,!0):h.associatedNotebooks.delete(v.uri),this.q.trace(`NotebookController[${I}] ASSOCIATE notebook`,v.uri.toString(),r),h.onDidChangeSelection.fire({selected:r,notebook:v.apiNotebook})}}async $executeCells(I,k,r){const h=this.j.get(I);if(!h)return;const v=this.n.getNotebookDocument(S.URI.revive(k)),R=[];for(const W of r){const V=v.getCell(W);V&&R.push(V.apiCell)}try{this.q.trace(`NotebookController[${I}] EXECUTE cells`,v.uri.toString(),R.length),await h.controller.executeHandler.call(h.controller,R,v.apiNotebook,h.controller)}catch(W){this.q.error(`NotebookController[${I}] execute cells FAILED`,W),console.error(W)}}async $cancelCells(I,k,r){const h=this.j.get(I);if(!h)return;const v=this.n.getNotebookDocument(S.URI.revive(k));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,v.apiNotebook);else for(const R of r){const W=v.getCell(R);W&&this.b.get(W.uri)?.cancel()}if(h.controller.interruptHandler){const R=this.c.get(v.uri);r.length&&Array.isArray(R)&&R.length&&R.forEach(W=>W.dispose())}}$acceptKernelMessageFromRenderer(I,k,r){const h=this.j.get(I);if(!h)return;const v=this.n.getEditorById(k);h.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:r}))}$cellExecutionChanged(I,k,r){const v=this.n.getNotebookDocument(S.URI.revive(I)).getCell(k);if(v){const R=r?p.NotebookCellExecutionState.to(r):f.NotebookCellExecutionState.Idle;R!==void 0&&this.l.fire({cell:v.apiCell,state:R})}}_createNotebookCellExecution(I,k){if(I.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.n.getNotebookDocument(I.notebook.uri).getCellFromApiCell(I);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const v=new s(k,h,this.a);this.b.set(h.uri,v);const R=v.onDidChangeState(()=>{v.state===$.Resolved&&(v.dispose(),R.dispose(),this.b.delete(h.uri))});return v.asApiObject()}_createNotebookExecution(I,k){const r=this.n.getNotebookDocument(I.uri),h=I.getCells().find(W=>{const V=r.getCellFromApiCell(W);return V&&this.b.has(V.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(r.uri))throw new Error(`duplicate notebook execution for ${r.uri}`);const v=new n(k,r,this.a),R=v.onDidChangeState(()=>{v.state===a.Resolved&&(v.dispose(),R.dispose(),this.c.delete(r.uri))});return this.c.set(r.uri,[v,R]),v.asApiObject()}};e.$Ccc=E,e.$Ccc=E=Ke([Ve(4,P.$4i)],E);var $;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})($||($={}));class s extends A.$jc{static{this.a=0}get state(){return this.f}constructor(I,k,r){super(),this.m=k,this.n=r,this.b=s.a++,this.c=new L.$ed,this.onDidChangeState=this.c.event,this.f=$.Init,this.g=this.B(new C.$od),this.h=new o(10,h=>this.s(h)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,I,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(I){await this.h.addItem(I)}async s(I){const k=Array.isArray(I)?I:[I];return this.n.$updateExecution(this.b,new g.$cA(k))}t(){if(this.f===$.Init)throw new Error("Must call start before modifying cell output");if(this.f===$.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(I){let k=this.m;if(I&&(k=this.m.notebook.getCellFromApiCell(I)),!k)throw new Error("INVALID cell");return k.handle}y(I){return I.map(k=>{const r=f.$nL.ensureUniqueMimeTypes(k.items,!0);return r===k.items?p.NotebookCellOutput.from(k):p.NotebookCellOutput.from({items:r,id:k.id,metadata:k.metadata})})}async z(I,k,r){const h=this.w(k),v=this.y((0,w.$Zb)(I));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:h,append:r,outputs:v})}async C(I,k,r){return I=f.$nL.ensureUniqueMimeTypes((0,w.$Zb)(I),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:I.map(p.NotebookCellOutputItem.from),outputId:k.id,append:r})}asApiObject(){const I=this;return Object.freeze({get token(){return I.g.token},get cell(){return I.m.apiCell},get executionOrder(){return I.j},set executionOrder(r){I.j=r,I.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:I.j}])},start(r){if(I.f===$.Resolved||I.f===$.Started)throw new Error("Cannot call start again");I.f=$.Started,I.c.fire(),I.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:r})},end(r,h){if(I.f===$.Resolved)throw new Error("Cannot call resolve twice");I.f=$.Resolved,I.c.fire(),I.h.flush(),I.n.$completeExecution(I.b,new g.$cA({runEndTime:h,lastRunSuccess:r}))},clearOutput(r){return I.t(),I.z([],r,!1)},appendOutput(r,h){return I.t(),I.z(r,h,!0)},replaceOutput(r,h){return I.t(),I.z(r,h,!1)},appendOutputItems(r,h){return I.t(),I.C(r,h,!0)},replaceOutputItems(r,h){return I.t(),I.C(r,h,!1)}})}}var a;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(a||(a={}));class n extends A.$jc{static{this.a=0}get state(){return this.f}constructor(I,k,r){super(),this.h=k,this.j=r,this.b=n.a++,this.c=new L.$ed,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new C.$od),this.j.$createNotebookExecution(this.b,I,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor(I,k){this.e=I,this.f=k,this.a=[],this.b=Date.now()}addItem(I){return this.a.push(I),this.c||(this.c=new F.$1g,this.b=Date.now(),(0,F.$Gg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const I=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>I.complete())}}function y(m,I){return`${m.value}/${I}`}e.$Dcc=y}),define(Ae[245],Re([1,0,5,3,104]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class L{constructor(l,S){this.c=S,this.a=new Map,this.b=l.getProxy(F.$VJ.MainThreadNotebookRenderers)}$postRendererMessage(l,S,d){const P=this.c.getEditorById(l);this.a.get(S)?.fire({editor:P.apiEditor,message:d})}createRendererMessaging(l,S){if(!l.contributes?.notebookRenderer?.some(P=>P.id===S))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${S})`);return{onDidReceiveMessage:(P,D,u)=>this.d(S).event(P,D,u),postMessage:(P,D)=>{C.$ncc.apiEditorsToExtHost.has(P)&&([P,D]=[D,P]);const u=D&&C.$ncc.apiEditorsToExtHost.get(D);return this.b.$postMessage(u?.id,S,P)}}}d(l){let S=this.a.get(l);return S||(S=new w.$ed({onDidRemoveLastListener:()=>{S?.dispose(),this.a.delete(l)}}),this.a.set(l,S),S)}}e.$Ecc=L}),define(Ae[246],Re([1,0,6,16,2,26,3]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=void 0;class l{constructor(d){this.b=new Map,this.a=d.getProxy(A.$VJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(d,P,D){if((0,L.$PF)(d,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,D),this.a.$registerProfileContentHandler(P,D.name,D.description,d.identifier.value),(0,w.$hc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(d,P,D,u){const b=this.b.get(d);if(!b)throw new Error(`Unknown handler with id: ${d}`);return b.saveProfile(P,D,u)}async $readProfile(d,P,D){const u=this.b.get(d);if(!u)throw new Error(`Unknown handler with id: ${d}`);return u.readProfile((0,F.$if)(P)?P:C.URI.revive(P),D)}}e.$Icc=l}),define(Ae[247],Re([1,0,2,3,13,8]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0;class A{static{this.a=0}constructor(S,d){this.d=d,this.c=new Map,this.b=S.getProxy(F.$VJ.MainThreadQuickDiff)}$provideOriginalResource(S,d,P){const D=w.URI.revive(d),u=this.c.get(S);return u?(0,C.$yg)(()=>u.provideOriginalResource(D,P)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(S,d,P,D){const u=A.a++;return this.c.set(u,d),this.b.$registerQuickDiffProvider(u,L.DocumentSelector.from(S,this.d),P,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$Jcc=A}),define(Ae[248],Re([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;function p(f,i,t){const c=f.getProxy(L.$VJ.MainThreadQuickOpen);class g{constructor(I,k){this.e=new Map,this.f=0,this.a=I,this.b=k}showQuickPick(I,k,r,h=w.CancellationToken.None){this.c=void 0;const v=Promise.resolve(k),R=++this.f,W=c.$show(R,{title:r?.title,placeHolder:r?.placeHolder,matchOnDescription:r?.matchOnDescription,matchOnDetail:r?.matchOnDetail,ignoreFocusLost:r?.ignoreFocusOut,canPickMany:r?.canPickMany},h),V={},U=W.then(()=>V);return Promise.race([U,v]).then(B=>{if(B===V)return;const O=(0,u.$OF)(I,"quickPickItemTooltip");return v.then(N=>{const ee=[];for(let Y=0;Y<N.length;Y++){const Ee=N[Y];if(typeof Ee=="string")ee.push({label:Ee,handle:Y});else if(Ee.kind===l.QuickPickItemKind.Separator)ee.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!O&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const ke=Ee.iconPath?n(Ee.iconPath):void 0;ee.push({label:Ee.label,iconPath:ke?.iconPath,iconClass:ke?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:O?b.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:Y})}}return r&&typeof r.onDidSelectItem=="function"&&(this.c=Y=>{r.onDidSelectItem(N[Y])}),c.$setItems(R,ee),W.then(Y=>{if(typeof Y=="number")return N[Y];if(Array.isArray(Y))return Y.map(Ee=>N[Ee])})})}).then(void 0,B=>{if(!(0,S.$2)(B))return c.$setError(R,B),Promise.reject(B)})}$onItemSelected(I){this.c?.(I)}showInput(I,k=w.CancellationToken.None){return this.d=I?.validateInput,c.$input(I,typeof this.d=="function",k).then(void 0,r=>{if(!(0,S.$2)(r))return Promise.reject(r)})}async $validateInput(I){if(!this.d)return;const k=await this.d(I);if(!k||typeof k=="string")return k;let r;switch(k.severity){case l.InputBoxValidationSeverity.Info:r=P.default.Info;break;case l.InputBoxValidationSeverity.Warning:r=P.default.Warning;break;case l.InputBoxValidationSeverity.Error:r=P.default.Error;break;default:r=k.message?P.default.Error:P.default.Ignore;break}return{content:k.message,severity:r}}async showWorkspaceFolderPick(I,k=w.CancellationToken.None){const r=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!r)return;const h=await this.a.getWorkspaceFolders2();if(h)return h.find(v=>v.uri.toString()===r.uri.toString())}createQuickPick(I){const k=new o(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(I){const k=new y(I,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(I,k){this.e.get(I)?._fireDidChangeValue(k)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,k){const r=this.e.get(I);r instanceof o&&r._fireDidChangeActive(k)}$onDidChangeSelection(I,k){const r=this.e.get(I);r instanceof o&&r._fireDidChangeSelection(k)}$onDidTriggerButton(I,k){this.e.get(I)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(I,k,r){const h=this.e.get(I);h instanceof o&&h._fireDidTriggerItemButton(k,r)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class E{static{this.a=1}constructor(I,k){this.x=I,this.y=k,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$ed,this.q=new F.$ed,this.r=new F.$ed,this.s=new F.$ed,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((k,r)=>{const h=k===l.$gL.Back?-1:r;this.o.set(h,k)}),this.z({buttons:I.map((k,r)=>({...n(k.iconPath),tooltip:k.tooltip,handle:k===l.$gL.Back?-1:r}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const k=this.o.get(I);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$ec)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(I){if(!this.v){for(const k of Object.keys(I)){const r=I[k];this.u[k]=r===void 0?null:r}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function $(m){if(m instanceof l.$SK)return{id:m.id};const I=a(m),k=s(m);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof k=="string"?A.URI.file(k):k}}function s(m){return typeof m=="object"&&"light"in m?m.light:m}function a(m){return typeof m=="object"&&"dark"in m?m.dark:m}function n(m){const I=$(m);let k,r;return"id"in I?r=D.ThemeIcon.asClassName(I):k=I,{iconPath:k,iconClass:r}}class o extends E{constructor(I,k){super(I.identifier,k),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$ed,this.L=[],this.M=new F.$ed,this.N=new F.$ed,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((h,v)=>{this.C.set(v,h),this.D.set(h,v)});const k=(0,u.$OF)(this.O,"quickPickItemTooltip"),r=[];for(let h=0;h<I.length;h++){const v=I[h];if(v.kind===l.QuickPickItemKind.Separator)r.push({type:"separator",label:v.label});else{v.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const R=v.iconPath?n(v.iconPath):void 0;r.push({handle:h,label:v.label,iconPath:R?.iconPath,iconClass:R?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:k?b.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((W,V)=>({...n(W.iconPath),tooltip:W.tooltip,handle:V}))})}}this.z({items:r})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(I){const k=(0,d.$Eb)(I.map(r=>this.C.get(r)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(I){const k=(0,d.$Eb)(I.map(r=>this.C.get(r)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(I,k){const r=this.C.get(I);if(!r||!r.buttons||!r.buttons.length)return;const h=r.buttons[k];h&&this.N.fire({button:h,item:r})}}class y extends E{constructor(I,k){super(I.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:P.default.Error}):this.z({validationMessage:I.message,severity:I.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new g(i,t)}e.$Kbc=p}),define(Ae[249],Re([1,0,2,5,64,6,13,3,18,132,14,20,40,8,26,12]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.$Lbc=void 0;function t(k){if(k)return typeof k.iconPath=="string"?w.URI.file(k.iconPath):w.URI.isUri(k.iconPath)||u.ThemeIcon.isThemeIcon(k.iconPath)?k.iconPath:void 0}function c(k,r){if(!k.iconPath&&!r.iconPath)return 0;if(k.iconPath){if(!r.iconPath)return 1}else return-1;const h=typeof k.iconPath=="string"?k.iconPath:w.URI.isUri(k.iconPath)?k.iconPath.fsPath:k.iconPath.id,v=typeof r.iconPath=="string"?r.iconPath:w.URI.isUri(r.iconPath)?r.iconPath.fsPath:r.iconPath.id;return(0,d.$gq)(h,v)}function g(k,r){let h=0;if(k.strikeThrough!==r.strikeThrough)return k.strikeThrough?1:-1;if(k.faded!==r.faded)return k.faded?1:-1;if(k.tooltip!==r.tooltip)return(k.tooltip||"").localeCompare(r.tooltip||"");if(h=c(k,r),h!==0)return h;if(k.light&&r.light)h=c(k.light,r.light);else{if(k.light)return 1;if(r.light)return-1}if(h!==0)return h;if(k.dark&&r.dark)h=c(k.dark,r.dark);else{if(k.dark)return 1;if(r.dark)return-1}return h}function E(k,r){if(k.command!==r.command)return k.command<r.command?-1:1;if(k.title!==r.title)return k.title<r.title?-1:1;if(k.tooltip!==r.tooltip){if(k.tooltip!==void 0&&r.tooltip!==void 0)return k.tooltip<r.tooltip?-1:1;if(k.tooltip!==void 0)return 1;if(r.tooltip!==void 0)return-1}if(k.arguments===r.arguments)return 0;if(k.arguments)if(r.arguments){if(k.arguments.length!==r.arguments.length)return k.arguments.length-r.arguments.length}else return 1;else return-1;for(let h=0;h<k.arguments.length;h++){const v=k.arguments[h],R=r.arguments[h];if(v!==R)return v<R?-1:1}return 0}function $(k,r){let h=(0,d.$gq)(k.resourceUri.fsPath,r.resourceUri.fsPath,!0);if(h!==0)return h;if(k.command&&r.command)h=E(k.command,r.command);else{if(k.command)return 1;if(r.command)return-1}if(h!==0)return h;if(k.decorations&&r.decorations)h=g(k.decorations,r.decorations);else{if(k.decorations)return 1;if(r.decorations)return-1}return h}function s(k,r){for(let h=0;h<k.length;h++)if(k[h]!==r[h])return!1;return!0}function a(k,r){return k.command===r.command&&k.title===r.title&&k.tooltip===r.tooltip&&(k.arguments&&r.arguments?s(k.arguments,r.arguments):k.arguments===r.arguments)}function n(k,r){return(0,S.$sb)(k,r,a)}class o{#e;#t;get value(){return this.d}set value(r){r=r??"",this.#e.$setInputBoxValue(this.l,r),this.n(r)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(r){this.#e.$setInputBoxPlaceholder(this.l,r),this.f=r}get validateInput(){return(0,p.$PF)(this.k,"scmValidation"),this.g}set validateInput(r){if((0,p.$PF)(this.k,"scmValidation"),r&&typeof r!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=r,this.#e.$setValidationProviderIsEnabled(this.l,!!r)}get enabled(){return this.h}set enabled(r){r=!!r,this.h!==r&&(this.h=r,this.#e.$setInputBoxEnablement(this.l,r))}get visible(){return this.j}set visible(r){r=!!r,this.j!==r&&(this.j=r,this.#e.$setInputBoxVisibility(this.l,r))}get document(){return(0,p.$PF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(r,h,v,R,W){this.k=r,this.l=R,this.m=W,this.d="",this.e=new F.$ed,this.f="",this.h=!0,this.j=!0,this.#t=h,this.#e=v}showValidationMessage(r,h){(0,p.$PF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,r,h)}$onInputBoxValueChange(r){this.n(r)}n(r){this.d=r,this.e.fire(r)}}e.$Lbc=o;class y{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(r){this.v=r,this.q.$updateGroupLabel(this.t,this.handle,r)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(r){this.p=r,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(r){this.f=[...r],this.k.fire()}constructor(r,h,v,R,W){this.q=r,this.s=h,this.t=v,this.u=R,this.v=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$ed,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$ed,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=y.d++}getResourceState(r){return this.g.get(r)}$executeResourceCommand(r,h){const v=this.h.get(r);return v?(0,A.$yg)(()=>this.s.executeCommand(v.command,...v.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const r=[...this.f].sort($),v=(0,S.$Ab)(this.o,r,$).map(V=>{const U=V.toInsert.map(B=>{const O=this.e++;this.g.set(O,B);const N=B.resourceUri;let ee;if(B.command)if(B.command.command==="vscode.open"||B.command.command==="vscode.diff"){const ie=new L.$ic;ee=this.s.converter.toInternal(B.command,ie),this.j.set(O,ie)}else this.h.set(O,B.command);const Y=t(B.decorations),Ee=B.decorations&&t(B.decorations.light)||Y,ke=B.decorations&&t(B.decorations.dark)||Y,Pe=[Ee,ke],Z=B.decorations&&B.decorations.tooltip||"",ue=B.decorations&&!!B.decorations.strikeThrough,ye=B.decorations&&!!B.decorations.faded,ce=B.contextValue||"";return{rawResource:[O,N,Pe,Z,ue,ye,ce,ee],handle:O}});return{start:V.start,deleteCount:V.deleteCount,toInsert:U}}),R=v.map(({start:V,deleteCount:U,toInsert:B})=>[V,U,B.map(O=>O.rawResource)]),W=v.reverse();for(const{start:V,deleteCount:U,toInsert:B}of W){const O=B.map(ee=>ee.handle),N=this.n.splice(V,U,...O);for(const ee of N)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=r,R}dispose(){this.l=!0,this.m.fire()}}class m{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(r){this.g!==r&&(this.g=r,this.#e.$updateSourceControl(this.t,{count:r}))}get quickDiffProvider(){return this.h}set quickDiffProvider(r){this.h=r;let h;(0,p.$OF)(this.u,"quickDiffProvider")&&(h=r?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!r,quickDiffLabel:h})}get commitTemplate(){return this.j}set commitTemplate(r){r!==this.j&&(this.j=r,this.#e.$updateSourceControl(this.t,{commitTemplate:r}))}get acceptInputCommand(){return this.l}set acceptInputCommand(r){this.k.value=new L.$ic,this.l=r;const h=this.v.converter.toInternal(r,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:h})}get actionButton(){return(0,p.$PF)(this.u,"scmActionButton"),this.n}set actionButton(r){(0,p.$PF)(this.u,"scmActionButton"),this.m.value=new L.$ic,this.n=r;const h=r!==void 0?{command:this.v.converter.toInternal(r.command,this.m.value),secondaryCommands:r.secondaryCommands?.map(v=>v.map(R=>this.v.converter.toInternal(R,this.m.value))),description:r.description,enabled:r.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:h??null})}get statusBarCommands(){return this.p}set statusBarCommands(r){if(this.p&&r&&n(this.p,r))return;this.o.value=new L.$ic,this.p=r;const h=(r||[]).map(v=>this.v.converter.toInternal(v,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:h})}get selected(){return this.q}constructor(r,h,v,R,W,V,U){this.u=r,this.v=R,this.w=W,this.x=V,this.y=U,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.$kc,this.l=void 0,this.m=new L.$kc,this.o=new L.$kc,this.p=void 0,this.q=!1,this.s=new F.$ed,this.onDidChangeSelection=this.s.event,this.t=m.d++,this.z=new Map,this.A=new Set,this.#e=v;const B=w.URI.from({scheme:f.Schemas.vscodeSourceControl,path:`${W}/scm${this.t}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new o(r,h,this.#e,this.t,B),this.#e.$registerSourceControl(this.t,W,V,U,B)}createResourceGroup(r,h){const v=new y(this.#e,this.v,this.t,r,h),R=F.Event.once(v.onDidDispose)(()=>this.z.delete(v));return this.z.set(v,R),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const r=[],h=[];for(const[v,R]of this.z){R.dispose();const W=v.onDidUpdateResourceStates(()=>{this.A.add(v),this.eventuallyUpdateResourceStates()});F.Event.once(v.onDidDispose)(()=>{this.A.delete(v),W.dispose(),this.e.delete(v.handle),this.#e.$unregisterGroup(this.t,v.handle)}),r.push([v.handle,v.id,v.label,v.features]);const V=v._takeResourceStateSnapshot();V.length>0&&h.push([v.handle,V]),this.e.set(v.handle,v)}this.#e.$registerGroups(this.t,r,h),this.z.clear()}eventuallyUpdateResourceStates(){const r=[];this.A.forEach(h=>{const v=h._takeResourceStateSnapshot();v.length!==0&&r.push([h.handle,v])}),r.length>0&&this.#e.$spliceResourceStates(this.t,r),this.A.clear()}getResourceGroup(r){return this.e.get(r)}setSelectionState(r){this.q=r,this.s.fire(r)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(r=>r.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,C.$6g)(100)],m.prototype,"eventuallyAddResourceGroups",null),Ke([(0,C.$6g)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let I=class{static{i=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(r,h,v,R){this.l=h,this.m=v,this.n=R,this.g=new Map,this.h=new D.$Wl,this.j=new F.$ed,this.e=r.getProxy(l.$VJ.MainThreadSCM),this.f=r.getProxy(l.$VJ.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const V=this.g.get(W.sourceControlHandle);if(!V)return W;const U=V.getResourceGroup(W.groupHandle);return U?U.getResourceState(W.handle):W}else if(W&&W.$mid===4){const V=this.g.get(W.sourceControlHandle);return V?V.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const V=this.g.get(W.handle);return V||W}return W}})}createSourceControl(r,h,v,R){this.n.trace("ExtHostSCM#createSourceControl",r.identifier.value,h,v,R),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:r.identifier.value});const W=i.d++,V=new m(r,this.m,this.e,this.l,h,v,R);this.g.set(W,V);const U=this.h.get(r.identifier)||[];return U.push(V),this.h.set(r.identifier,U),V}getLastInputBox(r){this.n.trace("ExtHostSCM#getLastInputBox",r.identifier.value);const h=this.h.get(r.identifier),v=h&&h[h.length-1];return v&&v.inputBox}$provideOriginalResource(r,h,v){const R=w.URI.revive(h);this.n.trace("ExtHostSCM#$provideOriginalResource",r,R.toString());const W=this.g.get(r);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$yg)(()=>W.quickDiffProvider.provideOriginalResource(R,v)).then(V=>V||null)}$onInputBoxValueChange(r,h){this.n.trace("ExtHostSCM#$onInputBoxValueChange",r);const v=this.g.get(r);return v&&v.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(r,h,v,R){this.n.trace("ExtHostSCM#$executeResourceCommand",r,h,v);const W=this.g.get(r);if(!W)return Promise.resolve(void 0);const V=W.getResourceGroup(h);return V?V.$executeResourceCommand(v,R):Promise.resolve(void 0)}$validateInput(r,h,v){this.n.trace("ExtHostSCM#$validateInput",r);const R=this.g.get(r);return!R||!R.inputBox.validateInput?Promise.resolve(void 0):(0,A.$yg)(()=>R.inputBox.validateInput(h,v)).then(W=>{if(!W)return Promise.resolve(void 0);const V=b.MarkdownString.fromStrict(W.message);return V?Promise.resolve([V,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(r){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",r),r!==void 0&&this.g.get(r)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=r,Promise.resolve(void 0)}};e.$Mbc=I,e.$Mbc=I=i=Ke([Ve(3,P.$4i)],I)}),define(Ae[83],Re([1,0,3,5,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=e.$rbc=void 0;class L{constructor(l){this.b=new F.$ed,this.onDidChangePassword=this.b.event,this.a=l.getProxy(w.$VJ.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,S){return this.a.$getPassword(l,S)}store(l,S,d){return this.a.$setPassword(l,S,d)}delete(l,S){return this.a.$deletePassword(l,S)}}e.$rbc=L,e.$sbc=(0,C.$Ah)("IExtHostSecretState")}),define(Ae[250],Re([1,0,3,8,2]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;class L{static{this.a=0}constructor(l,S){this.d=S,this.c=new Map,this.b=l.getProxy(w.$VJ.MainThreadShare)}async $provideShare(l,S,d){return await this.c.get(l)?.provideShare({selection:F.Range.to(S.selection),resourceUri:C.URI.revive(S.resourceUri)},d)??void 0}registerShareProvider(l,S){const d=L.a++;return this.c.set(d,S),this.b.$registerShareProvider(d,F.DocumentSelector.from(l,this.d),S.id,S.label,S.priority),{dispose:()=>{this.b.$unregisterShareProvider(d),this.c.delete(d)}}}}e.$Occ=L}),define(Ae[251],Re([1,0,7,3,154,6,8,16]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=void 0;class S{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$TK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$TK("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,p,f,i,t=w.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new L.$ic,this.#e=u,this.#t=b,i&&f){this.c=(0,w.$wK)(f.identifier,i);const g=p.get(this.c);g&&(t=g.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,c=g.priority,this.j=!0,this.name=g.name,this.text=g.text,this.tooltip=g.tooltip,this.command=g.command,this.accessibilityInformation=g.accessibilityInformation)}else this.c=String(S.a++);this.e=f,this.f=i,this.g=t,this.h=this.u(c)}u(u){if((0,l.$mf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!S.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new L.$ic,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,C.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=S.b.get(this.o.id));const f=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,f,this.r?.internal,p,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Nbc=S;class d{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new w.$XJ(()=>{const p=this.b.indexOf(b);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(u,b){this.e=new Map,this.a=u.getProxy(F.$VJ.MainThreadStatusBar),this.b=b,this.c=new d(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,p,f){return new S(this.a,this.b,this.e,u,b,p,f)}setStatusBarMessage(u,b){const p=this.c.setMessage(u);let f;return typeof b=="number"?f=setTimeout(()=>p.dispose(),b):typeof b<"u"&&b.then(()=>p.dispose(),()=>p.dispose()),new w.$XJ(()=>{p.dispose(),clearTimeout(f)})}}e.$Obc=P}),define(Ae[84],Re([1,0,3,5,4]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=e.$fbc=void 0;class L{constructor(l,S){this.c=S,this.b=new F.$ed,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(w.$VJ.MainThreadStorage)}registerExtensionStorageKeysToSync(l,S){this.a.$registerExtensionStorageKeysToSync(l,S)}async initializeExtensionStorage(l,S,d){const P=await this.a.$initializeExtensionStorage(l,S);let D;return P&&(D=this.d(l,S,P)),D||d}setValue(l,S,d){return this.a.$setValue(l,S,d)}$acceptValue(l,S,d){const P=this.d(l,S,d);P&&this.b.fire({shared:l,key:S,value:P})}d(l,S,d){try{return JSON.parse(d)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${S}, global: ${l}): ${P}`)}}}e.$fbc=L,e.$gbc=(0,C.$Ah)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,61,2]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=e.$lbc=void 0,e.$lbc=(0,w.$Ah)("IExtensionStoragePaths");let l=class{constructor(d,P,D){this.d=P,this.f=D,this.a=d.workspace??void 0,this.b=d.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(d){return A.URI.joinPath(this.b.workspaceStorageHome,d)}async h(){if(!this.a)return Promise.resolve(void 0);const d=this.a.id,P=await this.g(d);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(d){if(this.c)return A.URI.joinPath(this.c,d.identifier.value)}globalValue(d){return A.URI.joinPath(this.b.globalStorageHome,d.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$mbc=l,e.$mbc=l=Ke([Ve(0,F.$bM),Ve(1,C.$4i),Ve(2,L.$kbc)],l)}),define(Ae[62],Re([1,0,5,3,4,2,17,6,7,156,9,182,21,36,183,40,13,8,31]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=e.$pbc=e.$obc=e.$nbc=void 0,e.$nbc=(0,C.$Ah)("IExtHostTerminalService");class g{constructor(r,h,v,R){this.k=r,this._id=h,this.l=v,this.m=R,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const W=this;this.value={get name(){return W.m||""},get processId(){return W.b},get creationOptions(){return W.l},get exitStatus(){return W.h},get state(){return W.i},get selection(){return W.j},sendText(V,U=!0){W.o(),W.k.$sendText(W._id,V,U)},show(V){W.o(),W.k.$show(W._id,V)},hide(){W.o(),W.k.$hide(W._id)},dispose(){W.a||(W.a=!0,W.k.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(r,h){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:r.name,shellPath:r.shellPath??void 0,shellArgs:r.shellArgs??void 0,cwd:r.cwd??void 0,env:r.env??void 0,icon:y(r.iconPath)??void 0,color:f.ThemeColor.isThemeColor(r.color)?r.color.id:void 0,initialText:r.message??void 0,strictEnv:r.strictEnv??void 0,hideFromUser:r.hideFromUser??void 0,isFeatureTerminal:h?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:h?.useShellEnvironment??void 0,location:h?.location||this.n(r.location,h?.resolvedExtHostIdentifier),isTransient:r.isTransient??void 0})}async createExtensionTerminal(r,h,v,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:v,color:f.ThemeColor.isThemeColor(R)?R.id:void 0,location:this.n(r,h),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(r,h){return typeof r=="object"?"parentTerminal"in r&&r.parentTerminal&&h?{parentTerminal:h}:"viewColumn"in r?{viewColumn:t.ViewColumn.from(r.viewColumn),preserveFocus:r.preserveFocus}:void 0:r}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(r){this.m=r}setExitStatus(r,h){this.h=Object.freeze({code:r,reason:h})}setDimensions(r,h){return r===this.d&&h===this.g||r===0||h===0?!1:(this.d=r,this.g=h,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(r){this.j=r}_setProcessId(r){this.f?(this.f(r),this.f=void 0):this.b.then(h=>{h!==r&&(this.b=Promise.resolve(r))})}}e.$obc=g;class E{get onProcessReady(){return this.b.event}constructor(r){this.g=r,this.id=0,this.shouldPersist=!1,this.a=new w.$ed,this.onProcessData=this.a.event,this.b=new w.$ed,this.d=new w.$ed,this.onDidChangeProperty=this.d.event,this.f=new w.$ed,this.onProcessExit=this.f.event}refreshProperty(r){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${r}`)}updateProperty(r,h){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${r}, value: ${h}`)}async start(){}shutdown(){this.g.close()}input(r){this.g.handleInput?.(r)}resize(r,h){this.g.setDimensions?.({columns:r,rows:h})}clearBuffer(){}async processBinary(r){}acknowledgeDataEvent(r){}async setUnicodeVersion(r){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(r){this.g.onDidWrite(h=>this.a.fire(h)),this.g.onDidClose?.((h=void 0)=>{this.f.fire(h===void 0?void 0:h)}),this.g.onDidOverrideDimensions?.(h=>{h&&this.d.fire({type:"overrideDimensions",value:{cols:h.columns,rows:h.rows}})}),this.g.onDidChangeName?.(h=>{this.d.fire({type:"title",value:h})}),this.g.open(r||void 0),r&&this.g.setDimensions?.(r),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let $=1,s=class extends l.$jc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(r=>r.value)}constructor(r,h,v){super(),this.Q=h,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$kc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$ed,this.onDidCloseTerminal=this.H.event,this.I=new w.$ed,this.onDidOpenTerminal=this.I.event,this.J=new w.$ed,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$ed,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$ed,this.onDidChangeTerminalState=this.M.event,this.N=new w.$ed,this.onDidChangeShell=this.N.event,this.O=new w.$ed({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$ed({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=v.getProxy(F.$VJ.MainThreadTerminalService),this.y=new p.$Ikb(this.a.$sendProcessData),this.a.$registerProcessSupport(r),this.B({dispose:()=>{for(const[R,W]of this.g)W.shutdown(!0)}})}getDefaultShell(r){return(r?this.u:this.s)?.path||""}getDefaultShellArgs(r){return(r?this.u:this.s)?.args||[]}createExtensionTerminal(r,h){const v=new g(this.a,(0,b.$3f)(),r,r.name),R=new E(r.pty);return v.createExtensionTerminal(r.location,this.R(r,h).resolvedExtHostIdentifier,y(r.iconPath),m(r.color)).then(W=>{const V=this.S(W,R);this.h[W]=V}),this.f.push(v),v.value}R(r,h){if(h=h||{},r.location&&typeof r.location=="object"&&"parentTerminal"in r.location){const v=r.location.parentTerminal;if(v){const R=this.f.find(W=>W.value===v);R&&(h.resolvedExtHostIdentifier=R._id)}}else r.location&&typeof r.location!="object"?h.location=r.location:h.location&&typeof h.location=="object"&&"splitActiveTerminal"in h.location&&(h.location={splitActiveTerminal:!0});return h}attachPtyToTerminal(r,h){if(!this.W(r))throw new Error(`Cannot resolve terminal with id ${r} for virtual process`);const R=new E(h),W=this.S(r,R);this.h[r]=W}async $acceptActiveTerminalChanged(r){const h=this.b;if(r===null){this.b=void 0,h!==this.b&&this.J.fire(this.b);return}const v=this.W(r);v&&(this.b=v,h!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(r,h){const v=this.W(r);v&&this.O.fire({terminal:v.value,data:h})}async $acceptTerminalDimensions(r,h,v){const R=this.W(r);R&&R.setDimensions(h,v)&&this.L.fire({terminal:R.value,dimensions:R.value.dimensions})}async $acceptDidExecuteCommand(r,h){const v=this.W(r);v&&this.P.fire({terminal:v.value,...h})}async $acceptTerminalMaximumDimensions(r,h,v){this.g.get(r)?.resize(h,v)}async $acceptTerminalTitleChange(r,h){const v=this.W(r);v&&(v.name=h)}async $acceptTerminalClosed(r,h,v){const R=this.Y(this.f,r);if(R!==null){const W=this.f.splice(R,1)[0];W.setExitStatus(h,v),this.H.fire(W.value)}}$acceptTerminalOpened(r,h,v,R){if(h){const U=this.Y(this.f,h);if(U!==null){this.f[U]._id=r,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const W={name:R.name,shellPath:R.executable,shellArgs:R.args,cwd:typeof R.cwd=="string"?R.cwd:L.URI.revive(R.cwd),env:R.env,hideFromUser:R.hideFromUser},V=new g(this.a,r,W,v);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(r,h){this.W(r)?._setProcessId(h)}async $startExtensionTerminal(r,h){const v=this.W(r);if(!v)return{message:(0,d.localize)(0,null,r)};v.isOpen||await new Promise(W=>{const V=this.onDidOpenTerminal(async U=>{U===v.value&&(V.dispose(),W())})});const R=this.g.get(r);R?R.startSendingEvents(h):this.j[r]={initialDimensions:h}}S(r,h){const v=new l.$ic;v.add(h.onProcessReady(W=>this.a.$sendProcessReady(r,W.pid,W.cwd,W.windowsPty))),v.add(h.onDidChangeProperty(W=>this.a.$sendProcessProperty(r,W))),this.y.startBuffering(r,h.onProcessData),v.add(h.onProcessExit(W=>this.U(r,W))),this.g.set(r,h);const R=this.j[r];return R&&h instanceof E&&(h.startSendingEvents(R.initialDimensions),delete this.j[r]),v}$acceptProcessAckDataEvent(r,h){this.g.get(r)?.acknowledgeDataEvent(h)}$acceptProcessInput(r,h){this.g.get(r)?.input(h)}$acceptTerminalInteraction(r){const h=this.W(r);h?.setInteractedWith()&&this.M.fire(h.value)}$acceptTerminalSelection(r,h){this.W(r)?.setSelection(h)}$acceptProcessResize(r,h,v){try{this.g.get(r)?.resize(h,v)}catch(R){if(R.code!=="EPIPE"&&R.code!=="ERR_IPC_CHANNEL_CLOSED")throw R}}$acceptProcessShutdown(r,h){this.g.get(r)?.shutdown(h)}$acceptProcessRequestInitialCwd(r){this.g.get(r)?.getInitialCwd().then(h=>this.a.$sendProcessProperty(r,{type:"initialCwd",value:h}))}$acceptProcessRequestCwd(r){this.g.get(r)?.getCwd().then(h=>this.a.$sendProcessProperty(r,{type:"cwd",value:h}))}$acceptProcessRequestLatency(r){return Promise.resolve(r)}registerLinkProvider(r){return this.z.add(r),this.z.size===1&&this.a.$startLinkProvider(),new S.$XJ(()=>{this.z.delete(r),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(r,h,v){if(this.C.has(h))throw new Error(`Terminal profile provider "${h}" already registered`);return this.C.set(h,v),this.a.$registerProfileProvider(h,r.identifier.value),new S.$XJ(()=>{this.C.delete(h),this.a.$unregisterProfileProvider(h)})}registerTerminalQuickFixProvider(r,h,v){if(this.D.has(r))throw new Error(`Terminal quick fix provider "${r}" is already registered`);return this.D.set(r,v),this.a.$registerQuickFixProvider(r,h),new S.$XJ(()=>{this.D.delete(r),this.a.$unregisterQuickFixProvider(r)})}async $provideTerminalQuickFixes(r,h){const v=new u.$od().token;if(v.isCancellationRequested)return;const R=this.D.get(r);if(!R)return;const W=await R.provideTerminalQuickFixes(h,v);if(W===null||Array.isArray(W)&&W.length===0)return;const V=new l.$ic;if(this.w.value=V,!Array.isArray(W))return W?t.TerminalQuickFix.from(W,this.Q.converter,V):void 0;const U=[];for(const B of W){const O=t.TerminalQuickFix.from(B,this.Q.converter,V);O&&U.push(O)}return U}async $createContributedProfileTerminal(r,h){const v=new u.$od().token;let R=await this.C.get(r)?.provideTerminalProfile(v);if(!v.isCancellationRequested){if(R&&!("options"in R)&&(R={options:R}),!R||!("options"in R))throw new Error(`No terminal profile options provided for id "${r}"`);if("pty"in R.options){this.createExtensionTerminal(R.options,h);return}this.createTerminalFromOptions(R.options,h)}}async $provideLinks(r,h){const v=this.W(r);if(!v)return[];this.F.delete(r),this.G.get(r)?.dispose(!0);const W=new u.$od;this.G.set(r,W);const V=[],U={terminal:v.value,line:h},B=[];for(const ee of this.z)B.push(i.Promises.withAsyncBody(async Y=>{W.token.onCancellationRequested(()=>Y({provider:ee,links:[]}));const Ee=await ee.provideTerminalLinks(U,W.token)||[];W.token.isCancellationRequested||Y({provider:ee,links:Ee})}));const O=await Promise.all(B);if(W.token.isCancellationRequested)return[];const N=new Map;for(const ee of O)ee&&ee.links.length>0&&V.push(...ee.links.map(Y=>{const Ee={id:$++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return N.set(Ee.id,{provider:ee.provider,link:Y}),Ee}));return this.F.set(r,N),V}$activateLink(r,h){const v=this.F.get(r)?.get(h);v&&v.provider.handleTerminalLink(v.link)}U(r,h){this.y.stopBuffering(r),this.g.delete(r),delete this.j[r];const v=this.h[r];v&&(v.dispose(),delete this.h[r]),this.a.$sendProcessExit(r,h)}W(r){return this.X(this.f,r)}X(r,h){const v=this.Y(r,h);return v!==null?r[v]:null}Y(r,h){const v=r.findIndex(R=>R._id===h);return v===-1?null:v}getEnvironmentVariableCollection(r){let h=this.n.get(r.identifier.value);return h||(h=new a,this.$(r.identifier.value,h)),h.getScopedEnvironmentVariableCollection(void 0)}Z(r,h){const v=(0,D.$_q)(h.map),R=(0,D.$ar)(h.descriptionMap);this.a.$setEnvironmentVariableCollection(r,h.persistent,v.length===0?void 0:v,R)}$initEnvironmentVariableCollections(r){r.forEach(h=>{const v=h[0],R=new a(h[1]);this.$(v,R)})}$acceptDefaultProfile(r,h){const v=this.s;this.s=r,this.u=h,v?.path!==r.path&&this.N.fire(r.path)}$(r,h){this.n.set(r,h),h.onDidChangeCollection(()=>{this.Z(r,h)})}};e.$pbc=s,e.$pbc=s=Ke([Ve(1,c.$hM),Ve(2,A.$XL)],s);class a{get persistent(){return this.b}set persistent(r){this.b=r,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(r){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$ed,this.map=new Map(r)}getScopedEnvironmentVariableCollection(r){const h=this.h(r);let v=this.a.get(h);return v||(v=new n(this,r),this.a.set(h,v),v.onDidChangeCollection(()=>this.d.fire())),v}replace(r,h,v,R){this.f(r,{value:h,type:S.EnvironmentVariableMutatorType.Replace,options:v??{applyAtProcessCreation:!0},scope:R})}append(r,h,v,R){this.f(r,{value:h,type:S.EnvironmentVariableMutatorType.Append,options:v??{applyAtProcessCreation:!0},scope:R})}prepend(r,h,v,R){this.f(r,{value:h,type:S.EnvironmentVariableMutatorType.Prepend,options:v??{applyAtProcessCreation:!0},scope:R})}f(r,h){if(h.options&&h.options.applyAtProcessCreation===!1&&!h.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const v=this.g(r,h.scope),R=this.map.get(v),W=h.options?{applyAtProcessCreation:h.options.applyAtProcessCreation??!1,applyAtShellIntegration:h.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!R||R.value!==h.value||R.type!==h.type||R.options?.applyAtProcessCreation!==W.applyAtProcessCreation||R.options?.applyAtShellIntegration!==W.applyAtShellIntegration||R.scope?.workspaceFolder?.index!==h.scope?.workspaceFolder?.index){const V=this.g(r,h.scope),U={variable:r,...h,options:W};this.map.set(V,U),this.d.fire()}}get(r,h){const v=this.g(r,h),R=this.map.get(v);return R?I(R):void 0}g(r,h){const v=this.h(h);return v.length?`${r}:::${v}`:r}h(r){return this.i(r?.workspaceFolder)??""}i(r){return r?r.uri.toString():void 0}getVariableMap(r){const h=new Map;for(const[v,R]of this.map)this.h(R.scope)===this.h(r)&&h.set(R.variable,I(R));return h}delete(r,h){const v=this.g(r,h);this.map.delete(v),this.d.fire()}clear(r){if(r?.workspaceFolder){for(const[h,v]of this.map)v.scope?.workspaceFolder?.index===r.workspaceFolder.index&&this.map.delete(h);this.j(r)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(r,h){const v=this.h(h),R=this.descriptionMap.get(v);if(!R||R.description!==r){let W;typeof r=="string"?W=r:W=r?.value.split(`

`)[0];const V={description:W,scope:h};this.descriptionMap.set(v,V),this.d.fire()}}getDescription(r){const h=this.h(r);return this.descriptionMap.get(h)?.description}j(r){const h=this.h(r);this.descriptionMap.delete(h)}}class n{get persistent(){return this.b.persistent}set persistent(r){this.b.persistent=r}get onDidChangeCollection(){return this.a&&this.a.event}constructor(r,h){this.b=r,this.d=h,this.a=new w.$ed}getScoped(r){return this.b.getScopedEnvironmentVariableCollection(r)}replace(r,h,v){this.b.replace(r,h,v,this.d)}append(r,h,v){this.b.append(r,h,v,this.d)}prepend(r,h,v){this.b.prepend(r,h,v,this.d)}get(r){return this.b.get(r,this.d)}forEach(r,h){this.b.getVariableMap(this.d).forEach((v,R)=>r.call(h,R,v,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(r){this.b.delete(r,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(r){this.b.setDescription(r,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends s{constructor(r,h){super(!1,r,h)}createTerminal(r,h,v){throw new P.$0}createTerminalFromOptions(r,h){throw new P.$0}};e.$qbc=o,e.$qbc=o=Ke([Ve(0,c.$hM),Ve(1,A.$XL)],o);function y(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function m(k){return f.ThemeColor.isThemeColor(k)?k:void 0}function I(k){const r={...k};return delete r.scope,r.options=r.options??void 0,delete r.variable,r}}),define(Ae[252],Re([1,0,281,13,25,21,5,203,93,6,24,16,36,3,17,105,8,7,45,76,56,26]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=e.$ycc=e.$xcc=void 0;let s=class{constructor(U,B,O){this.k=O,this.d=new A.$ed,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=U.getProxy(b.$VJ.MainThreadTesting),this.j=new v(this.g),this.h=new y(this.g),B.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 15:{const ee=N,Y=ee.tests[ee.tests.length-1].item.extId;return this.f.get(c.$II.root(Y))?.collection.tree.get(Y)?.actual??(0,f.$0L)(N)}case 17:{const{extId:ee,message:Y}=N;return{test:this.f.get(c.$II.root(ee))?.collection.tree.get(ee)?.actual,message:i.TestMessage.to(Y)}}default:return N}}}),B.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await B.executeCommand("_testing.getExplorerSelection"),ee=Y=>{const Ee=this.f.get(c.$II.root(Y));if(Ee)return c.$II.isRoot(Y)?Ee.controller:Ee.collection.tree.get(Y)?.actual};return{include:N?.include.map(ee).filter(D.$qf)||[],exclude:N?.exclude.map(ee).filter(D.$qf)||[]}})}createTestController(U,B,O,N){if(this.f.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const ee=new d.$ic,Y=ee.add(new f.$aM(B,O,this.k));Y.root.label=O;const Ee=new Map,ke=this.g,Pe={items:Y.root.children,get label(){return O},set label(ue){O=ue,Y.root.label=ue,ke.$updateController(B,{label:O})},get refreshHandler(){return N},set refreshHandler(ue){N=ue,ke.$updateController(B,{canRefresh:!!ue})},get id(){return B},createRunProfile:(ue,ye,ce,$e,ie,z)=>{let q=(0,S.$oi)(ue);for(;Ee.has(q);)q++;return new R(this.g,Ee,B,q,ue,ye,ce,$e,ie,z)},createTestItem(ue,ye,ce){return new f.$$L(B,ue,ye,ce)},createTestRun:(ue,ye,ce=!0)=>this.h.createTestRun(U,B,Y,ue,ye,ce),invalidateTestResults:ue=>{if(ue===void 0)this.g.$markTestRetired(void 0);else{const ye=ue instanceof Array?ue:[ue];this.g.$markTestRetired(ye.map(ce=>c.$II.fromExtHostTestItem(ce,B).toString()))}},set resolveHandler(ue){Y.resolveHandler=ue},get resolveHandler(){return Y.resolveHandler},dispose:()=>{ee.dispose()}};ke.$registerTestController(B,O,!!N),ee.add((0,d.$hc)(()=>ke.$unregisterTestController(B)));const Z={controller:Pe,collection:Y,profiles:Ee,extension:U};return this.f.set(B,Z),ee.add((0,d.$hc)(()=>this.f.delete(B))),ee.add(Y.onDidGenerateDiff(ue=>ke.$publishDiff(B,ue.map(E.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(U,B=L.CancellationToken.None){const O=m(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ee=>c.$II.fromExtHostTestItem(ee,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:W[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(ee=>ee.id)},B)}$syncTests(){for(const{collection:U}of this.f.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,B,O){return(0,w.$pb)(this.h.trackers,ee=>ee.id===U?ee.getCoverage(B):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(U,B,O,N){return(0,w.$pb)(this.h.trackers,Y=>Y.id===U?Y.getCoverage(B):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(U,B){this.f.get(U)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(U,B){await this.f.get(U)?.controller.refreshHandler?.(B)}$publishTestResults(U){this.results=Object.freeze(U.map(B=>(0,P.$Vm)(i.TestResults.to(B))).concat(this.results).sort((B,O)=>O.completedAt-B.completedAt).slice(0,32)),this.d.fire()}async $expandTest(U,B){const O=this.f.get(c.$II.fromString(U).controllerId)?.collection;O&&(await O.expand(U,B<0?1/0:B),O.flushDiff())}$acceptDiff(U){this.j.applyDiff(U.map(E.TestsDiffOp.deserialize))}async $runControllerTests(U,B){return Promise.all(U.map(O=>this.l(O,!1,B)))}async $startContinuousRun(U,B){const O=new L.$od(B),N=await Promise.all(U.map(ee=>this.l(ee,!0,O.token)));return!B.isCancellationRequested&&!N.some(ee=>ee.error)&&await new Promise(ee=>B.onCancellationRequested(ee)),O.dispose(!0),N}async l(U,B,O){const N=this.f.get(U.controllerId);if(!N)return{};const{collection:ee,profiles:Y,extension:Ee}=N,ke=Y.get(U.profileId);if(!ke)return{};const Pe=U.testIds.map(ce=>ee.tree.get(ce)).filter(D.$qf),Z=U.excludeExtIds.map(ce=>N.collection.tree.get(ce)).filter(D.$qf).filter(ce=>Pe.some($e=>$e.fullId.compare(ce.fullId)===2));if(!Pe.length)return{};const ue=new t.$uL(Pe.some(ce=>ce.actual instanceof f.$_L)?void 0:Pe.map(ce=>ce.actual),Z.map(ce=>ce.actual),ke,B),ye=(0,E.$KI)(U)&&this.h.prepareForMainThreadTestRun(ue,I.fromInternal(U,N.collection),Ee,O);try{return await ke.runHandler(ue,O),{}}catch(ce){return{error:String(ce)}}finally{ye&&(ye.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(ye.onEnd),ye.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.h.cancelAllRuns():this.h.cancelRunById(U)}};e.$xcc=s,e.$xcc=s=Ke([Ve(0,p.$XL)],s);const a=1e4;var n;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(n||(n={}));class o extends d.$jc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(U,B,O,N){super(),this.s=U,this.u=B,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$ed),this.onEnd=this.m.event,this.j=this.B(new L.$od(N));const ee=this.B(new F.$Rg(()=>this.y(),a));this.B(this.j.token.onCancellationRequested(()=>ee.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(U){return this.g.get(U)?.coverage}createRun(U){const B=this.s.id,O=this.s.controllerId,N=(0,u.$3f)(),ee=new k(this.u,B,N),Y=Z=>(ue,...ye)=>{if(ke){console.warn(`Setting the state of test "${ue.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ue)&&(this.C(ue),Z(ue,...ye))},Ee=(Z,ue)=>{const ye=ue instanceof Array?ue.map(i.TestMessage.from):[i.TestMessage.from(ue)];if(ye.some(ce=>ce.contextValue!==void 0)&&(0,$.$PF)(this.w,"testMessageContextValue"),Z.uri&&Z.range){const ce={range:i.Range.from(Z.range),uri:Z.uri};for(const $e of ye)$e.location=$e.location||ce}this.u.$appendTestMessagesInRun(B,N,c.$II.fromExtHostTestItem(Z,O).toString(),ye)};let ke=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:U,get coverageProvider(){return ee.coverageProvider},set coverageProvider(Z){ee.coverageProvider=Z},enqueued:Y(Z=>{this.u.$updateTestStateInRun(B,N,c.$II.fromExtHostTestItem(Z,O).toString(),1)}),skipped:Y(Z=>{this.u.$updateTestStateInRun(B,N,c.$II.fromExtHostTestItem(Z,O).toString(),5)}),started:Y(Z=>{this.u.$updateTestStateInRun(B,N,c.$II.fromExtHostTestItem(Z,O).toString(),2)}),errored:Y((Z,ue,ye)=>{Ee(Z,ue),this.u.$updateTestStateInRun(B,N,c.$II.fromExtHostTestItem(Z,O).toString(),6,ye)}),failed:Y((Z,ue,ye)=>{Ee(Z,ue),this.u.$updateTestStateInRun(B,N,c.$II.fromExtHostTestItem(Z,O).toString(),4,ye)}),passed:Y((Z,ue)=>{this.u.$updateTestStateInRun(B,N,c.$II.fromExtHostTestItem(Z,this.s.controllerId).toString(),3,ue)}),appendOutput:(Z,ue,ye)=>{ke||(ye&&(this.s.isIncluded(ye)?this.C(ye):ye=void 0),this.u.$appendOutputToRun(B,N,C.$Ed.fromString(Z),ue&&i.location.from(ue),ye&&c.$II.fromExtHostTestItem(ye,O).toString()))},end:()=>{ke||(ke=!0,this.u.$finishedTestRunTask(B,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:ee}),this.u.$startedTestRunTask(B,{id:N,name:U,running:!0}),Pe}y(){for(const{run:U}of this.g.values())U.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(U){if(!(U instanceof f.$$L))throw new g.$PL(U.id);if(this.h.has(c.$II.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const B=[],O=this.s.colllection.root;for(;;){const N=i.TestItem.from(U);if(B.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),U===O))break;U=U.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,B)}dispose(){this.z(),super.dispose()}}class y{get trackers(){return this.d.values()}constructor(U){this.f=U,this.d=new Map}prepareForMainThreadTestRun(U,B,O,N){return this.g(U,B,O,N)}cancelRunById(U){for(const B of this.d.values())if(B.id===U){B.cancel();return}}cancelAllRuns(){for(const U of this.d.values())U.cancel()}createTestRun(U,B,O,N,ee,Y){const Ee=this.d.get(N);if(Ee)return Ee.createRun(ee);const ke=I.fromPublic(B,O,N,Y),Pe=m(N);this.f.$startedExtensionTestRun({controllerId:B,continuous:!!N.continuous,profile:Pe&&{group:W[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(ue=>c.$II.fromExtHostTestItem(ue,O.root.id).toString())??[],id:ke.id,include:N.include?.map(ue=>c.$II.fromExtHostTestItem(ue,O.root.id).toString())??[O.root.id],persist:Y});const Z=this.g(N,ke,U);return A.Event.once(Z.onEnd)(()=>{this.f.$finishedExtensionTestRun(ke.id),Z.dispose()}),Z.createRun(ee)}g(U,B,O,N){const ee=new o(B,this.f,O,N);return this.d.set(U,ee),A.Event.once(ee.onEnd)(()=>this.d.delete(U)),ee}}e.$ycc=y;const m=V=>{if(V.profile){if(!(V.profile instanceof R))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class I{static fromPublic(U,B,O,N){return new I(U,(0,u.$3f)(),O.include?.map(ee=>c.$II.fromExtHostTestItem(ee,U).toString())??[U],O.exclude?.map(ee=>c.$II.fromExtHostTestItem(ee,U).toString())??[],N,B)}static fromInternal(U,B){return new I(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,B)}constructor(U,B,O,N,ee,Y){this.controllerId=U,this.id=B,this.isPersisted=ee,this.colllection=Y,this.d=O.map(Ee=>Ee+"\0"),this.f=N.map(Ee=>Ee+"\0")}isIncluded(U){const B=c.$II.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(B===O||B.startsWith(O))return!1;for(const O of this.d)if(B===O||B.startsWith(O))return!0;return!1}}e.$zcc=I;class k{set coverageProvider(U){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.d=U,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(U,B,O){this.g=U,this.h=B,this.j=O}async provideFileCoverage(U){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(U))());try{return(await this.f)?.map(i.TestCoverage.fromFile)??[]}catch(B){throw this.f=void 0,B}}async resolveFileCoverage(U,B){const O=await this.f;let N=O?.[U];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[U]=await this.d.resolveFileCoverage?.(N,B)??N),N.detailedCoverage?.map(i.TestCoverage.fromDetailed)??[])}}class r{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.d.add(U)}update(U){Object.assign(U.revived,i.TestItem.toPlain(U.item)),this.d.has(U)||this.f.add(U)}remove(U){if(this.d.has(U)){this.d.delete(U);return}this.f.delete(U);const B=c.$II.parentId(U.item.extId);if(B&&this.h.has(B.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{d:U,f:B,g:O}=this;return{get added(){return[...U].map(N=>N.revived)},get updated(){return[...B].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class h extends E.$PI{constructor(){super(...arguments),this.s=new A.$ed,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}q(U,B){return{...U,revived:i.TestItem.toPlain(U.item),depth:B?B.depth+1:0,children:new Set}}p(){return new r(this.s)}}class v{constructor(U){this.f=U}checkout(){this.d||(this.d=this.g());const U=this.d;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(B=>B.revived)},dispose:(0,l.$bb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(U){return this.d?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.d?.tests.apply(U)}g(){const U=new h;return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}class R{#e;#t;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(U){U!==this.h&&(this.h=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.g}set isDefault(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?i.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.d}set configureHandler(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,B,O,N,ee,Y,Ee,ke=!1,Pe=void 0,Z=!1){this.controllerId=O,this.profileId=N,this.f=ee,this.kind=Y,this.runHandler=Ee,this.g=ke,this._tag=Pe,this.h=Z,this.#e=U,this.#t=B,B.set(N,this);const ue=W[Y];if(typeof ue!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?i.TestTag.namespace(this.controllerId,Pe.id):null,label:ee,group:ue,isDefault:ke,hasConfigurationHandler:!1,supportsContinuousRun:Z})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Acc=R;const W={[t.TestRunProfileKind.Coverage]:8,[t.TestRunProfileKind.Debug]:4,[t.TestRunProfileKind.Run]:2}}),define(Ae[253],Re([1,0,18,9,5,3,106,8,7]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=void 0;class d{constructor(D,u){this.i=u,this.a=new C.$ed({onListenerError:F.$Z}),this.b=new C.$ed({onListenerError:F.$Z}),this.c=new C.$ed({onListenerError:F.$Z}),this.d=new C.$ed({onListenerError:F.$Z}),this.f=new C.$ed({onListenerError:F.$Z}),this.g=new C.$ed({onListenerError:F.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(L.$VJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const u=this.i.allEditors();return D?u:u.map(b=>b.value)}async showTextDocument(D,u,b){let p;typeof u=="number"?p={position:l.ViewColumn.from(u),preserveFocus:b}:typeof u=="object"?p={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?l.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(D.uri,p),i=f&&this.i.getEditor(f);if(i)return i.value;throw f?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,u){return new A.$5L(this.h,D,u).value}$acceptEditorPropertiesChanged(D,u){const b=this.i.getEditor(D);if(!b)throw new Error("unknown text editor");if(u.options&&b._acceptOptions(u.options),u.selections){const p=u.selections.selections.map(l.Selection.to);b._acceptSelections(p)}if(u.visibleRanges){const p=w.$Eb(u.visibleRanges.map(l.Range.to));b._acceptVisibleRanges(p)}if(u.options&&this.b.fire({textEditor:b.value,options:{...u.options,lineNumbers:l.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const p=S.TextEditorSelectionChangeKind.fromValue(u.selections.source),f=u.selections.selections.map(l.Selection.to);this.a.fire({textEditor:b.value,selections:f,kind:p})}if(u.visibleRanges){const p=w.$Eb(u.visibleRanges.map(l.Range.to));this.c.fire({textEditor:b.value,visibleRanges:p})}}$acceptEditorPositionData(D){for(const u in D){const b=this.i.getEditor(u);if(!b)throw new Error("Unknown text editor");const p=l.ViewColumn.to(D[u]);b.value.viewColumn!==p&&(b._acceptViewColumn(p),this.d.fire({textEditor:b.value,viewColumn:p}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$Pbc=d}),define(Ae[254],Re([1,0,2,4,3,6,7,8,20,16]),function(be,e,w,F,C,L,A,l,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=e.$rcc=void 0,e.$rcc=(0,F.$Ah)("IExtHostTimeline");class P{constructor(b,p){this.b=new Map,this.c=new Map,this.a=b.getProxy(C.$VJ.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(f,i)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&S.$Ul.equals(i,this.b.get(f.source)?.extension)){const t=f.uri===void 0?void 0:w.URI.revive(f.uri);return this.c.get(f.source)?.get(D(t))?.get(f.handle)}else return;return f}})}async $getTimeline(b,p,f,i){return this.b.get(b)?.provider.provideTimeline(w.URI.revive(p),f,i)}registerTimelineProvider(b,p,f,i){const t=new L.$ic,c=this.d(p.id,i,t).bind(this);let g;p.onDidChange&&(g=p.onDidChange($=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...$,id:p.id}),this));const E=this.c;return this.f({...p,scheme:b,onDidChange:void 0,async provideTimeline($,s,a){s?.resetCache&&(t.clear(),E.get(p.id)?.clear());const n=await p.provideTimeline($,s,a);if(n==null)return;const o=c($,s);return{...n,source:p.id,items:n.items.map(o)}},dispose(){for(const $ of E.values())$.get(p.id)?.clear();g?.dispose(),t.dispose()}},f)}d(b,p,f){return(i,t)=>{let c;if(t?.cacheResults){let g=this.c.get(b);g===void 0&&(g=new Map,this.c.set(b,g));const E=D(i);c=g.get(E),c===void 0&&(c=new Map,g.set(E,c))}return g=>{const{iconPath:E,...$}=g,s=`${b}|${g.id??g.timestamp}`;c?.set(s,g);let a,n,o;g.iconPath&&(E instanceof A.$SK?o={id:E.id,color:E.color}:w.URI.isUri(E)?(a=E,n=E):{light:a,dark:n}=E);let y;return A.$mK.isMarkdownString($.tooltip)?y=l.MarkdownString.from($.tooltip):(0,d.$if)($.tooltip)?y=$.tooltip:A.$mK.isMarkdownString($.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=l.MarkdownString.from($.detail)):(0,d.$if)($.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=$.detail),{...$,id:$.id??void 0,handle:s,source:b,command:g.command?p.toInternal(g.command,f):void 0,icon:a,iconDark:n,themeIcon:o,tooltip:y,accessibilityInformation:g.accessibilityInformation}}}}f(b,p){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:p}),(0,L.$hc)(()=>{for(const i of this.c.values())i.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$scc=P;function D(u){return u?.toString()}}),define(Ae[86],Re([1,0,21,5,6,158,4,14,185,3,27,17,7]),function(be,e,w,F,C,L,A,l,S,d,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ksb=e.$jsb=e.TunnelDtoConverter=void 0;class b extends S.$5z{}var p;(function(i){function t(g){return{remoteAddress:g.remoteAddress,localAddress:g.localAddress,public:!!g.public,privacy:g.privacy??(g.public?S.TunnelPrivacyId.Public:S.TunnelPrivacyId.Private),protocol:g.protocol}}i.fromApiTunnel=t;function c(g){return{remoteAddress:{host:g.tunnelRemoteHost,port:g.tunnelRemotePort},localAddress:g.localAddress,public:g.privacy!==S.TunnelPrivacyId.ConstantPrivate&&g.privacy!==S.TunnelPrivacyId.ConstantPrivate,privacy:g.privacy,protocol:g.protocol}}i.fromServiceTunnel=c})(p||(e.TunnelDtoConverter=p={})),e.$jsb=(0,A.$Ah)("IExtHostTunnelService");let f=class extends C.$jc{constructor(t,c,g){super(),this.s=g,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$ed,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(d.$VJ.MainThreadTunnelService)}async openTunnel(t,c){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const g=await this.a.$openTunnel(c,t.displayName);if(g){const E=new b(g.remoteAddress,g.localAddress,()=>this.a.$closeTunnel(g.remoteAddress));return this.B(E),E}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,c){const g=this.u();return this.r.set(g,{selector:t,provider:c}),this.a.$registerPortsAttributesProvider(t,g),new u.$XJ(()=>{this.r.delete(g),this.a.$unregisterPortsAttributesProvider(g)})}async $providePortAttributes(t,c,g,E,$){const s=[];for(const n of t){const o=this.r.get(n);if(!o)return[];s.push(...await Promise.all(c.map(async y=>{let m;try{m=await o.provider.providePortAttributes({port:y,pid:g,commandLine:E},$)}catch{m=await o.provider.providePortAttributes(y,g,E,$)}return{providedAttributes:m,port:y}})))}const a=s.filter(n=>!!n.providedAttributes);return a.length>0?a.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(E,$)=>await t.provideTunnel(E,$,new w.$od().token)??void 0;const g=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(g),Promise.resolve((0,C.$hc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,c){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const g=t.tunnelFactory??(c?this.w(c):void 0);if(g){this.b=g;let E=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const $=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider($)}}else this.b=void 0;return(0,C.$hc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,c){if(this.g.has(t.host)){const g=this.g.get(t.host);g.has(t.port)&&(c&&g.get(t.port).disposeListener.dispose(),await g.get(t.port).tunnel.dispose(),g.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,c){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const g=this.b(t,c);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),g!==void 0){const E=await g;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),E===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const $=this.B(E.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(E.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:E,disposeListener:$}),p.fromApiTunnel(E)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(g){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),g instanceof Error)return g.message}}async $applyCandidateFilter(t){const c=await Promise.all(t.map(E=>this.f(E.host,E.port,E.detail??""))),g=t.filter((E,$)=>c[$]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(E=>E.port).join(", ")} to ${g.map(E=>E.port).join(", ")}`),g}};e.$ksb=f,e.$ksb=f=Ke([Ve(0,D.$XL),Ve(1,P.$bM),Ve(2,l.$4i)],f)}),define(Ae[255],Re([1,0,6,12,2,3]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;class A{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(S){this.c=new Map,this.b=S.getProxy(L.$VJ.MainThreadUriOpeners)}registerExternalUriOpener(S,d,P,D){if(this.c.has(d))throw new Error(`Opener with id '${d}' already registered`);const u=D.schemes.find(b=>!A.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(d,P),this.b.$registerUriOpener(d,D.schemes,S,D.label),(0,w.$hc)(()=>{this.c.delete(d),this.b.$unregisterUriOpener(d)})}async $canOpenUri(S,d,P){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener with id: ${S}`);const u=C.URI.revive(d);return D.canOpenExternalUri(u,P)}async $openUri(S,d,P){const D=this.c.get(S);if(!D)throw new Error(`Unknown opener id: '${S}'`);return D.openExternalUri(C.URI.revive(d.resolvedUri),{sourceUri:C.URI.revive(d.sourceUri)},P)}}e.$Bcc=A}),define(Ae[256],Re([1,0,3,2,6,9,20]),function(be,e,w,F,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;class l{static{this.a=0}constructor(d){this.c=new A.$Vl,this.d=new Map,this.b=d.getProxy(w.$VJ.MainThreadUrls)}registerUriHandler(d,P){const D=d.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=l.a++;return this.c.add(D),this.d.set(u,P),this.b.$registerUriHandler(u,D,d.displayName||d.name),(0,C.$hc)(()=>{this.c.delete(D),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(d,P){const D=this.d.get(d);if(!D)return Promise.resolve(void 0);try{D.handleUri(F.URI.revive(P))}catch(u){(0,L.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(d){return F.URI.revive(await this.b.$createAppUri(d))}}e.$Rbc=l}),define(Ae[63],Re([1,0,5,6,12,24,2,170,192,77,3]),function(be,e,w,F,C,L,A,l,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=e.$Vbc=e.$Ubc=e.$Tbc=e.$Sbc=void 0;class D{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(E,$,s,a,n,o,y){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$ed,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$ed,this._onDidDispose=this.#h.event,this.#e=E,this.#t=$,this.#r=s,this.#l=a,this.#u=n,this.#n=o,this.#c=u(o),this.#d=b(o),this.#i=y}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return this.#a=!0,(0,d.$Qob)(E,this.#l)}get cspSource(){const E=this.#n.extensionLocation;if(E.scheme===C.Schemas.https||E.scheme===C.Schemas.http){let $=E.toString();return $.endsWith("/")||($+="/"),$+" "+d.$Pob}return d.$Pob}get html(){return this.a(),this.#s}set html(E){this.a(),this.#s!==E&&(this.#s=E,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(E)))}get options(){return this.a(),this.#r}set options(E){this.a(),L.$Ym(this.#r,E)||this.#t.$setOptions(this.#e,i(this.#n,this.#u,E)),this.#r=E}async postMessage(E){if(this.#o)return!1;const $=(0,S.$1bb)(E,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,$.message,...$.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(E){if(!this.#d)return E;const $=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,s=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,n,o,y,m,I)=>{const k=A.URI.from({scheme:y||"file",path:decodeURIComponent(m)}),r=(0,d.$Qob)(k,{isRemote:$,authority:s}).toString();return`${n}${r}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(a,n,o,y,m,I)=>{const k=A.URI.from({scheme:y||"file",path:decodeURIComponent(m)}),r=(0,d.$Qob)(k,{isRemote:$,authority:s}).toString();return`${n}${r}${I}`})}}e.$Sbc=D;function u(g){try{const E=(0,l.$Co)((0,l.$Bo)(g.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.$Tbc=u;function b(g){try{const E=(0,l.$Co)((0,l.$Bo)(g.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class p extends F.$jc{constructor(E,$,s,a,n){super(),this.c=$,this.f=s,this.g=a,this.h=n,this.b=new Map,this.a=E.getProxy(P.$VJ.MainThreadWebviews)}dispose(){super.dispose();for(const E of this.b.values())E.dispose();this.b.clear()}$onMessage(E,$,s){const a=this.j(E);if(a){const{message:n}=(0,S.$2bb)($,s.value);a._onMessageEmitter.fire(n)}}$onMissingCsp(E,$){this.g.warn(`${$} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,$,s){const a=new D(E,this.a,t($),this.c,this.f,s,this.h);this.b.set(E,a);const n=a._onDidDispose(()=>{n.dispose(),this.deleteWebview(E)});return a}deleteWebview(E){this.b.delete(E)}j(E){return this.b.get(E)}}e.$Ubc=p;function f(g){return{id:g.identifier,location:g.extensionLocation}}e.$Vbc=f;function i(g,E,$){return{enableCommandUris:$.enableCommandUris,enableScripts:$.enableScripts,enableForms:$.enableForms,portMapping:$.portMapping,localResourceRoots:$.localResourceRoots||c(g,E)}}e.$Wbc=i;function t(g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots?.map(E=>A.URI.from(E))}}function c(g,E){return[...(E?.getWorkspaceFolders()||[]).map($=>$.uri),g.extensionLocation]}}),define(Ae[257],Re([1,0,21,93,6,12,23,2,8,63,54,3,7]),function(be,e,w,F,C,L,A,l,S,d,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=void 0;class b{constructor(a,n){this.document=a,this.b=n,this.a=1,this.c=new P.$Oac("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,n){await this.f(a).undo(),n||this.disposeBackup()}async redo(a,n){await this.f(a).redo(),n||this.disposeBackup()}disposeEdits(a){for(const n of a)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=$(this.document.uri)+this.a++;return(0,A.$hg)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const n=this.c.get(a,0);if(!n)throw new Error("No edit found");return n}}class p{constructor(){this.a=new Map}get(a,n){return this.a.get(this.b(a,n))}add(a,n,o){const y=this.b(a,n.uri);if(this.a.has(y))throw new Error(`Document already exists for viewType:${a} resource:${n.uri}`);const m=new b(n,o);return this.a.set(y,m),m}delete(a,n){const o=this.b(a,n.uri);this.a.delete(o)}b(a,n){return`${a}@@@${n}`}}var f;(function(s){s[s.Text=0]="Text",s[s.Custom=1]="Custom"})(f||(f={}));class i{constructor(){this.a=new Map}addTextProvider(a,n,o){return this.b(0,a,n,o)}addCustomProvider(a,n,o){return this.b(1,a,n,o)}get(a){return this.a.get(a)}b(a,n,o,y){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:a,extension:o,provider:y}),new u.$XJ(()=>this.a.delete(n))}}class t{constructor(a,n,o,y,m){this.d=n,this.f=o,this.g=y,this.h=m,this.b=new i,this.c=new p,this.a=a.getProxy(D.$VJ.MainThreadCustomEditors)}registerCustomEditorProvider(a,n,o,y){const m=new C.$ic;return g(o)?(m.add(this.b.addTextProvider(n,a,o)),this.a.$registerTextEditorProvider((0,d.$Vbc)(a),n,y.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,d.$Tbc)(a))):(m.add(this.b.addCustomProvider(n,a,o)),c(o)&&m.add(o.onDidChangeCustomDocument(I=>{const k=this.i(n,I.document.uri);if(E(I)){const r=k.addEdit(I);this.a.$onDidEdit(I.document.uri,n,r,I.label)}else this.a.$onContentChange(I.document.uri,n)})),this.a.$registerCustomEditorProvider((0,d.$Vbc)(a),n,y.webviewOptions||{},!!y.supportsMultipleEditorsPerDocument,(0,d.$Tbc)(a))),u.$XJ.from(m,new u.$XJ(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(a,n,o,y,m){const I=this.b.get(n);if(!I)throw new Error(`No provider found for '${n}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${n}'`);const k=l.URI.revive(a),r=await I.provider.openCustomDocument(k,{backupId:o,untitledDocumentData:y?.buffer},m);let h;return c(I.provider)&&this.f&&(h=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(n,r,h),{editable:c(I.provider)}}async $disposeCustomDocument(a,n){const o=this.b.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const y=l.URI.revive(a),{document:m}=this.i(n,y);this.c.delete(n,m),m.dispose()}async $resolveCustomEditor(a,n,o,y,m,I){const k=this.b.get(o);if(!k)throw new Error(`No provider found for '${o}'`);const r=S.ViewColumn.to(m),h=this.g.createNewWebview(n,y.contentOptions,k.extension),v=this.h.createNewWebviewPanel(n,o,y.title,r,y.options,h,y.active),R=l.URI.revive(a);switch(k.type){case 1:{const{document:W}=this.i(o,R);return k.provider.resolveCustomEditor(W,v,I)}case 0:{const W=this.d.getDocument(R);return k.provider.resolveCustomTextEditor(W,v,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,n,o){this.i(n,a).disposeEdits(o)}async $onMoveCustomEditor(a,n,o){const y=this.b.get(o);if(!y)throw new Error(`No provider found for '${o}'`);if(!y.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const m=this.h.getWebviewPanel(a);if(!m)throw new Error("No webview found");const I=l.URI.revive(n),k=this.d.getDocument(I);await y.provider.moveCustomTextEditor(k,m,w.CancellationToken.None)}async $undo(a,n,o,y){return this.i(n,a).undo(o,y)}async $redo(a,n,o,y){return this.i(n,a).redo(o,y)}async $revert(a,n,o){const y=this.i(n,a);await this.j(n).revertCustomDocument(y.document,o),y.disposeBackup()}async $onSave(a,n,o){const y=this.i(n,a);await this.j(n).saveCustomDocument(y.document,o),y.disposeBackup()}async $onSaveAs(a,n,o,y){const m=this.i(n,a);return this.j(n).saveCustomDocumentAs(m.document,l.URI.revive(o),y)}async $backup(a,n,o){const y=this.i(n,a),I=await this.j(n).backupCustomDocument(y.document,{destination:y.getNewBackupUri()},o);return y.updateBackup(I),I.id}i(a,n){const o=this.c.get(a,l.URI.revive(n));if(!o)throw new Error("No custom document found");return o}j(a){const o=this.b.get(a)?.provider;if(!o||!c(o))throw new Error("Custom document is not editable");return o}}e.$vcc=t;function c(s){return!!s.onDidChangeCustomDocument}function g(s){return typeof s.resolveCustomTextEditor=="function"}function E(s){return typeof s.undo=="function"&&typeof s.redo=="function"}function $(s){const a=s.scheme===L.Schemas.file||s.scheme===L.Schemas.untitled?s.fsPath:s.toString();return(0,F.$oi)(a)+""}}),define(Ae[258],Re([1,0,5,6,2,36,8,63,3,7]),function(be,e,w,F,C,L,A,l,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=void 0;class P extends F.$jc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(p,f,i,t){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$ed),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$ed),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=f,this.#l=i,this.#i=t.viewType,this.#u=t.panelOptions,this.#r=t.viewColumn,this.#n=t.title,this.#a=t.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(p){this.c(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#s}set iconPath(p){this.c(),this.#s!==p&&(this.#s=p,this.#t.$setIconPath(this.#e,C.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(p){this.#c||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#a=p.active,this.#o=p.visible,this.#r=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:A.ViewColumn.from(p),preserveFocus:!!f})}c(){if(this.#c)throw new Error("Webview is disposed")}}class D extends F.$jc{static c(){return(0,L.$3f)()}constructor(p,f,i){super(),this.j=f,this.m=i,this.g=new Map,this.h=new Map,this.f=p.getProxy(S.$VJ.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,f,i,t,c={}){const g=typeof t=="object"?t.viewColumn:t,E={viewColumn:A.ViewColumn.from(g),preserveFocus:typeof t=="object"&&!!t.preserveFocus},$=(0,l.$Tbc)(p),s=D.c();this.f.$createWebviewPanel((0,l.$Vbc)(p),s,f,{title:i,panelOptions:u(c),webviewOptions:(0,l.$Wbc)(p,this.m,c),serializeBuffersForPostMessage:$},E);const a=this.j.createNewWebview(s,c,p);return this.createNewWebviewPanel(s,f,i,g,c,a,!0)}$onDidChangeWebviewPanelViewStates(p){const f=Object.keys(p);f.sort((i,t)=>{const c=p[i],g=p[t];return c.active?1:g.active?-1:+c.visible-+g.visible});for(const i of f){const t=this.getWebviewPanel(i);if(!t)continue;const c=p[i];t._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,f,i){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:i,extension:p}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,l.$Tbc)(p)}),new d.$XJ(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(p,f,i,t){const c=this.h.get(f);if(!c)throw new Error(`No serializer found for '${f}'`);const{serializer:g,extension:E}=c,$=this.j.createNewWebview(p,i.webviewOptions,E),s=this.createNewWebviewPanel(p,f,i.title,t,i.panelOptions,$,i.active);await g.deserializeWebviewPanel(s,i.state)}createNewWebviewPanel(p,f,i,t,c,g,E){const $=new P(p,this.f,g,{viewType:f,title:i,viewColumn:t,panelOptions:c,active:E});return this.g.set(p,$),$}getWebviewPanel(p){return this.g.get(p)}}e.$ucc=D;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ae[259],Re([1,0,5,6,63,8,3,7]),function(be,e,w,F,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;class S extends F.$jc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(D,u,b,p,f,i){super(),this.#u=!1,this.#a=this.B(new w.$ed),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$ed),this.onDidDispose=this.#c.event,this.#i=b,this.#s=p,this.#e=D,this.#t=u,this.#l=f,this.#n=i}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#r}set description(D){this.a(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#u||(this.#n=D,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(D){this.a(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#u)throw new Error("Webview is disposed")}}class d{constructor(D,u){this.d=u,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$VJ.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,b,p){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:D}),this.a.$registerWebviewViewProvider((0,C.$Vbc)(D),u,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Tbc)(D)}),new l.$XJ(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,b,p,f){const i=this.b.get(u);if(!i)throw new Error(`No view provider found for '${u}'`);const{provider:t,extension:c}=i,g=this.d.createNewWebview(D,{},c),E=new S(D,this.a,u,b,g,!0);this.c.set(D,E),await t.resolveWebviewView(E,{state:p},f)}async $onDidChangeWebviewViewVisibility(D,u){this.e(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.e(D);this.c.delete(D),u.dispose(),this.d.deleteWebview(D)}e(D){const u=this.c.get(D);if(!u)throw new Error("No webview found");return u}}e.$tcc=d}),define(Ae[109],Re([1,0,5,3,2,12,15,4,17,26]),function(be,e,w,F,C,L,A,l,S,d){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=e.$Xbc=void 0;let D=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(b){const p=this.d;return{get focused(){return p.focused},get active(){return(0,d.$PF)(b,"windowActivity"),p.active}}}constructor(b){this.c=new w.$ed,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=b.getProxy(F.$VJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:f})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,p){p!==this.d[b]&&(this.d={...this.d,[b]:p},this.c.fire(this.d))}openUri(b,p){let f;if(typeof b=="string"){f=b;try{b=C.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$le)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,f,p)}async asExternalUri(b,p){if((0,A.$le)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(b,p);return C.URI.from(f)}};e.$Xbc=D,e.$Xbc=D=P=Ke([Ve(0,S.$XL)],D),e.$Ybc=(0,l.$Ah)("IExtHostWindow")}),define(Ae[260],Re([1,0,227,27,17]),function(be,e,w,F,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;let L=class extends w.$Wcc{constructor(l,S){super(l,S)}f(l,S,d){S.apply(console,d)}};e.$4ec=L,e.$4ec=L=Ke([Ve(0,C.$XL),Ve(1,F.$bM)],L)}),define(Ae[261],Re([1,0,13,25,21,9,5,6,133,216,46]),function(be,e,w,F,C,L,A,l,S,d,P){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$r3b=e.ResponsiveState=e.RequestInitiator=e.$q3b=e.$p3b=void 0;function u(v,R){try{return JSON.stringify(v,R)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class f{constructor(R,W){this.jsonString=R,this.referencedBuffers=W}}function i(v,R=null,W=!1){const V=[];return{jsonString:(W?u:JSON.stringify)(v,(B,O)=>{if(typeof O>"u")return p;if(typeof O=="object"){if(O instanceof F.$Ed){const N=V.push(O)-1;return{[b]:N}}if(R)return R(B,O)}return O}),referencedBuffers:V}}e.$p3b=i;function t(v,R,W){return JSON.parse(v,(V,U)=>{if(U){const B=U[b];if(typeof B=="number")return R[B];if(W&&U.$mid===1)return W.transformIncoming(U)}return U})}e.$q3b=t;function c(v,R){return JSON.stringify(v,R)}function g(v){return v?(R,W)=>W&&W.$mid===1?v.transformOutgoing(W):W:null}var E;(function(v){v[v.LocalSide=0]="LocalSide",v[v.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var $;(function(v){v[v.Responsive=0]="Responsive",v[v.Unresponsive=1]="Unresponsive"})($||(e.ResponsiveState=$={}));const s=()=>{},a=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class o extends l.$jc{static{D=a}static{this.a=3*1e3}constructor(R,W=null,V=null){super(),this[D]=!0,this.b=this.B(new A.$ed),this.onDidChangeResponsiveState=this.b.event,this.c=R,this.f=W,this.g=V,this.h=g(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,B=P.$_z.count;U<B;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new w.$Rg(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(R=>{const W=this.w[R];delete this.w[R],W.resolveErr(L.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(R){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(R){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(R){this.y!==R&&(this.y=R,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(R){return this.g?(0,S.$Dm)(R,this.g):R}getProxy(R){const{nid:W,sid:V}=R;return this.s[W]||(this.s[W]=this.J(W,V)),this.s[W]}J(R,W){const V={get:(U,B)=>(typeof B=="string"&&!U[B]&&B.charCodeAt(0)===36&&(U[B]=(...O)=>this.U(R,B,O)),B===n?W:U[B])};return new Proxy(Object.create(null),V)}set(R,W){return this.m[R.nid]=W,W}assertRegistered(R){for(let W=0,V=R.length;W<V;W++){const U=R[W];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(R){if(this.j)return;const W=R.byteLength,V=m.read(R,0),U=V.readUInt8(),B=V.readUInt32();switch(U){case 1:case 2:{let{rpcId:O,method:N,args:ee}=k.deserializeRequestJSONArgs(V);this.g&&(ee=(0,S.$Dm)(ee,this.g)),this.M(W,B,O,N,ee,U===2);break}case 3:case 4:{let{rpcId:O,method:N,args:ee}=k.deserializeRequestMixedArgs(V);this.g&&(ee=(0,S.$Dm)(ee,this.g)),this.M(W,B,O,N,ee,U===4);break}case 5:{this.f?.logIncoming(W,B,0,"ack"),this.G(B);break}case 6:{this.N(W,B);break}case 7:{this.O(W,B,void 0);break}case 9:{let O=k.deserializeReplyOKJSON(V);this.g&&(O=(0,S.$Dm)(O,this.g)),this.O(W,B,O);break}case 10:{const O=k.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(W,B,O);break}case 8:{const O=k.deserializeReplyOKVSBuffer(V);this.O(W,B,O);break}case 11:{let O=k.deserializeReplyErrError(V);this.g&&(O=(0,S.$Dm)(O,this.g)),this.P(W,B,O);break}case 12:{this.P(W,B,void 0);break}default:console.error("received unexpected message"),console.error(R)}}M(R,W,V,U,B,O){this.f?.logIncoming(R,W,1,`receiveRequest ${(0,P.$bA)(V)}.${U}(`,B);const N=String(W);let ee,Y;if(O){const ke=new C.$od;B.push(ke.token),ee=this.Q(V,U,B),Y=()=>ke.cancel()}else ee=this.Q(V,U,B),Y=s;this.u[N]=Y;const Ee=k.serializeAcknowledged(W);this.f?.logOutgoing(Ee.byteLength,W,1,"ack"),this.c.send(Ee),ee.then(ke=>{delete this.u[N];const Pe=k.serializeReplyOK(W,ke,this.h);this.f?.logOutgoing(Pe.byteLength,W,1,"reply:",ke),this.c.send(Pe)},ke=>{delete this.u[N];const Pe=k.serializeReplyErr(W,ke);this.f?.logOutgoing(Pe.byteLength,W,1,"replyErr:",ke),this.c.send(Pe)})}N(R,W){this.f?.logIncoming(R,W,1,"receiveCancel");const V=String(W);this.u[V]?.()}O(R,W,V){this.f?.logIncoming(R,W,0,"receiveReply:",V);const U=String(W);if(!this.w.hasOwnProperty(U))return;const B=this.w[U];delete this.w[U],B.resolveOk(V)}P(R,W,V){this.f?.logIncoming(R,W,0,"receiveReplyErr:",V);const U=String(W);if(!this.w.hasOwnProperty(U))return;const B=this.w[U];delete this.w[U];let O;V&&(V.$isError?(O=new Error,O.name=V.name,O.message=V.message,O.stack=V.stack):O=V),B.resolveErr(O)}Q(R,W,V){try{return Promise.resolve(this.S(R,W,V))}catch(U){return Promise.reject(U)}}S(R,W,V){const U=this.m[R];if(!U)throw new Error("Unknown actor "+(0,P.$bA)(R));const B=U[W];if(typeof B!="function")throw new Error("Unknown method "+W+" on actor "+(0,P.$bA)(R));return B.apply(U,V)}U(R,W,V){if(this.j)return new d.$o3b;let U=null;if(V.length>0&&C.CancellationToken.isCancellationToken(V[V.length-1])&&(U=V.pop()),U&&U.isCancellationRequested)return Promise.reject(L.$4());const B=k.serializeRequestArguments(V,this.h),O=++this.t,N=String(O),ee=new d.$n3b,Y=new l.$ic;U&&Y.add(U.onCancellationRequested(()=>{const ke=k.serializeCancel(O);this.f?.logOutgoing(ke.byteLength,O,0,"cancel"),this.c.send(k.serializeCancel(O))})),this.w[N]=new y(ee,Y),this.F(O);const Ee=k.serializeRequest(O,R,W,B,!!U);return this.f?.logOutgoing(Ee.byteLength,O,0,`request: ${(0,P.$bA)(R)}.${W}(`,V),this.c.send(Ee),ee}}e.$r3b=o;class y{constructor(R,W){this.a=R,this.b=W}resolveOk(R){this.a.resolveOk(R),this.b.dispose()}resolveErr(R){this.a.resolveErr(R),this.b.dispose()}}class m{static alloc(R,W,V){const U=new m(F.$Ed.alloc(V+1+4),0);return U.writeUInt8(R),U.writeUInt32(W),U}static read(R,W){return new m(R,W)}get buffer(){return this.a}constructor(R,W){this.a=R,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(R){this.a.writeUInt8(R,this.b),this.b+=1}readUInt8(){const R=this.a.readUInt8(this.b);return this.b+=1,R}writeUInt32(R){this.a.writeUInt32BE(R,this.b),this.b+=4}readUInt32(){const R=this.a.readUInt32BE(this.b);return this.b+=4,R}static sizeShortString(R){return 1+R.byteLength}writeShortString(R){this.a.writeUInt8(R.byteLength,this.b),this.b+=1,this.a.set(R,this.b),this.b+=R.byteLength}readShortString(){const R=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}static sizeLongString(R){return 4+R.byteLength}writeLongString(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readLongString(){const R=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+R).toString();return this.b+=R,V}writeBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}static sizeVSBuffer(R){return 4+R.byteLength}writeVSBuffer(R){this.a.writeUInt32BE(R.byteLength,this.b),this.b+=4,this.a.set(R,this.b),this.b+=R.byteLength}readVSBuffer(){const R=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+R);return this.b+=R,W}static sizeMixedArray(R){let W=0;W+=1;for(let V=0,U=R.length;V<U;V++){const B=R[V];switch(W+=1,B.type){case 1:W+=this.sizeLongString(B.value);break;case 2:W+=this.sizeVSBuffer(B.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(B.value);for(let O=0;O<B.buffers.length;++O)W+=this.sizeVSBuffer(B.buffers[O]);break;case 4:break}}return W}writeMixedArray(R){this.a.writeUInt8(R.length,this.b),this.b+=1;for(let W=0,V=R.length;W<V;W++){const U=R[W];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let B=0;B<U.buffers.length;++B)this.writeBuffer(U.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const R=this.a.readUInt8(this.b);this.b+=1;const W=new Array(R);for(let V=0;V<R;V++)switch(this.readUInt8()){case 1:W[V]=this.readLongString();break;case 2:W[V]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),O=this.readLongString(),N=[];for(let ee=0;ee<B;++ee)N.push(this.readVSBuffer());W[V]=new P.$cA(t(O,N,null));break}case 4:W[V]=void 0;break}return W}}var I;(function(v){v[v.Simple=0]="Simple",v[v.Mixed=1]="Mixed"})(I||(I={}));class k{static a(R){for(let W=0,V=R.length;W<V;W++)if(R[W]instanceof F.$Ed||R[W]instanceof P.$cA||typeof R[W]>"u")return!0;return!1}static serializeRequestArguments(R,W){if(this.a(R)){const V=[];for(let U=0,B=R.length;U<B;U++){const O=R[U];if(O instanceof F.$Ed)V[U]={type:2,value:O};else if(typeof O>"u")V[U]={type:4};else if(O instanceof P.$cA){const{jsonString:N,referencedBuffers:ee}=i(O.value,W);V[U]={type:3,value:F.$Ed.fromString(N),buffers:ee}}else V[U]={type:1,value:F.$Ed.fromString(c(O,W))}}return{type:1,args:V}}return{type:0,args:c(R,W)}}static serializeRequest(R,W,V,U,B){switch(U.type){case 0:return this.b(R,W,V,U.args,B);case 1:return this.c(R,W,V,U.args,B)}}static b(R,W,V,U,B){const O=F.$Ed.fromString(V),N=F.$Ed.fromString(U);let ee=0;ee+=m.sizeUInt8(),ee+=m.sizeShortString(O),ee+=m.sizeLongString(N);const Y=m.alloc(B?2:1,R,ee);return Y.writeUInt8(W),Y.writeShortString(O),Y.writeLongString(N),Y.buffer}static deserializeRequestJSONArgs(R){const W=R.readUInt8(),V=R.readShortString(),U=R.readLongString();return{rpcId:W,method:V,args:JSON.parse(U)}}static c(R,W,V,U,B){const O=F.$Ed.fromString(V);let N=0;N+=m.sizeUInt8(),N+=m.sizeShortString(O),N+=m.sizeMixedArray(U);const ee=m.alloc(B?4:3,R,N);return ee.writeUInt8(W),ee.writeShortString(O),ee.writeMixedArray(U),ee.buffer}static deserializeRequestMixedArgs(R){const W=R.readUInt8(),V=R.readShortString(),U=R.readMixedArray(),B=new Array(U.length);for(let O=0,N=U.length;O<N;O++){const ee=U[O];typeof ee=="string"?B[O]=JSON.parse(ee):B[O]=ee}return{rpcId:W,method:V,args:B}}static serializeAcknowledged(R){return m.alloc(5,R,0).buffer}static serializeCancel(R){return m.alloc(6,R,0).buffer}static serializeReplyOK(R,W,V){if(typeof W>"u")return this.d(R);if(W instanceof F.$Ed)return this.e(R,W);if(W instanceof P.$cA){const{jsonString:U,referencedBuffers:B}=i(W.value,V,!0);return this.g(R,U,B)}else return this.f(R,u(W,V))}static d(R){return m.alloc(7,R,0).buffer}static e(R,W){let V=0;V+=m.sizeVSBuffer(W);const U=m.alloc(8,R,V);return U.writeVSBuffer(W),U.buffer}static deserializeReplyOKVSBuffer(R){return R.readVSBuffer()}static f(R,W){const V=F.$Ed.fromString(W);let U=0;U+=m.sizeLongString(V);const B=m.alloc(9,R,U);return B.writeLongString(V),B.buffer}static g(R,W,V){const U=F.$Ed.fromString(W);let B=0;B+=m.sizeUInt32,B+=m.sizeLongString(U);for(const N of V)B+=m.sizeVSBuffer(N);const O=m.alloc(10,R,B);O.writeUInt32(V.length),O.writeLongString(U);for(const N of V)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(R){const W=R.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(R,W){const V=R.readUInt32(),U=R.readLongString(),B=[];for(let O=0;O<V;++O)B.push(R.readVSBuffer());return new P.$cA(t(U,B,W))}static serializeReplyErr(R,W){const V=W?u(L.$1(W),null):void 0;if(typeof V!="string")return this.h(R);const U=F.$Ed.fromString(V);let B=0;B+=m.sizeLongString(U);const O=m.alloc(11,R,B);return O.writeLongString(U),O.buffer}static deserializeReplyErrError(R){const W=R.readLongString();return JSON.parse(W)}static h(R){return m.alloc(12,R,0).buffer}}var r;(function(v){v[v.RequestJSONArgs=1]="RequestJSONArgs",v[v.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",v[v.RequestMixedArgs=3]="RequestMixedArgs",v[v.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",v[v.Acknowledged=5]="Acknowledged",v[v.Cancel=6]="Cancel",v[v.ReplyOKEmpty=7]="ReplyOKEmpty",v[v.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",v[v.ReplyOKJSON=9]="ReplyOKJSON",v[v.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",v[v.ReplyErrError=11]="ReplyErrError",v[v.ReplyErrEmpty=12]="ReplyErrEmpty"})(r||(r={}));var h;(function(v){v[v.String=1]="String",v[v.VSBuffer=2]="VSBuffer",v[v.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",v[v.Undefined=4]="Undefined"})(h||(h={}))}),define(Ae[262],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0;const w=function(L){const A=l=>{globalThis.removeEventListener("message",A);const S=l.data;Object.defineProperties(globalThis,{postMessage:{value(d,P){S.postMessage(d,P)}},onmessage:{get(){return S.onmessage},set(d){S.onmessage=d}}}),S.addEventListener("message",d=>{globalThis.dispatchEvent(new MessageEvent("message",{data:d.data,ports:d.ports?[...d.ports]:void 0}))}),S.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",A)}.toString();class F extends EventTarget{constructor(L,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${w})('${A}'))`,d=new Blob([S],{type:"application/javascript"}),P=URL.createObjectURL(d),D=new MessageChannel,u=P,b={type:"_newWorker",id:u,port:D.port2,url:P,options:l};L(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(p){D.port1.onmessage=p}},onmessageerror:{get(){return D.port1.onmessageerror},set(p){D.port1.onmessageerror=p}}}),D.port1.addEventListener("messageerror",p=>{const f=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(f)}),D.port1.addEventListener("message",p=>{const f=new MessageEvent("message",{data:p.data});this.dispatchEvent(f)}),D.port1.start()}}e.$6ec=F}),define(Ae[263],Re([1,0,5,30,32,4]),function(be,e,w,F,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_I=e.$$I=e.OutputChannelUpdateMode=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=void 0,e.$ZI="text/x-code-output",e.$1I="output",e.$2I="Log",e.$3I="text/x-code-log-output",e.$4I="log",e.$5I="log",e.$6I="workbench.panel.output",e.$7I=new C.$1i("inOutput",!1),e.$8I=new C.$1i("activeLogOutput",!1),e.$9I=new C.$1i("outputView.scrollLock",!1),e.$0I=(0,L.$Ah)("outputService");var A;(function(S){S[S.Append=1]="Append",S[S.Replace=2]="Replace",S[S.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$$I={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new w.$ed,this.onDidRegisterChannel=this.b.event,this.c=new w.$ed,this.onDidRemoveChannel=this.c.event}registerChannel(d){this.a.has(d.id)||(this.a.set(d.id,d),this.b.fire(d.id))}getChannels(){const d=[];return this.a.forEach(P=>d.push(P)),d}getChannel(d){return this.a.get(d)}removeChannel(d){this.a.delete(d),this.c.fire(d)}}F.$7m.add(e.$$I.OutputChannels,new l),e.$_I=new C.$1i("activeOutputChannel","")}),define(Ae[110],Re([1,0,3,4,17,20,14,263,61,27,39,130,25,16,38,5,6]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=e.$Hbc=void 0;class t extends A.$0i{get disposed(){return this.n}constructor($,s,a,n,o){super(),this.id=$,this.name=s,this.r=a,this.s=n,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(y=>this.setLevel(y)))}get logLevel(){return this.getLevel()}appendLine($){this.append($+`
`)}append($){this.info($)}clear(){const $=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,$)}replace($){const s=this.m;this.info($),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,s),this.visible&&this.r.flush()}show($,s){this.r.flush(),this.s.$reveal(this.id,!!(typeof $=="boolean"?$:s))}hide(){this.s.$close(this.id)}g($,s){this.m+=u.$Ed.fromString(s).byteLength,(0,A.log)(this.r,$,s),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class c extends t{appendLine($){this.append($)}}let g=class{constructor($,s,a,n,o,y){this.i=s,this.j=a,this.k=n,this.l=o,this.m=y,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=$.getProxy(w.$VJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(s.logsLocation,`output_logging_${(0,D.$6l)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel($){this.h=$;for(const[s,a]of this.g)a.visible=s===this.h}createOutputChannel($,s,a){if($=$.trim(),!$)throw new Error("illegal argument `name`. must not be falsy");const n=typeof s=="object"&&s.log,o=(0,b.$if)(s)?s:void 0;if((0,b.$if)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let y;const m=this.i.environment.extensionLogLevel?.find(([k])=>L.$Ul.equals(a.identifier,k))?.[1];m&&(y=(0,A.$hj)(m));const I=n?this.o($,y,a):this.n($,o,a);return I.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),n?this.r($,y??this.m.getLevel(),I):this.q($,I)}async n($,s,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,o=this.k.extUri.joinPath(n,`${this.f++}-${$.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),y=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register($,o,s,a.identifier.value);return new t(m,$,y,this.a,a)}async o($,s,a){const n=await this.p(a),o=$.replace(/[\\/:\*\?"<>\|]/g,""),y=this.k.extUri.joinPath(n,`${o}.log`),m=`${a.identifier.value}.${o}`,I=this.l.createLogger(y,{id:m,name:$,logLevel:s,extensionId:a.identifier.value});return new c(m,$,I,this.a,a)}p($){let s=this.d.get($.identifier.value);if(!s){const a=this.k.extUri.joinPath(this.i.logsLocation,$.identifier.value);this.d.set($.identifier.value,s=(async()=>{try{await this.j.value.createDirectory(a)}catch(n){if((0,p.$hk)(n)!==p.FileSystemProviderErrorCode.FileExists)throw n}return a})())}return s}q($,s){let a=!1;const n=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return $},append(o){n(),s.then(y=>y.append(o))},appendLine(o){n(),s.then(y=>y.appendLine(o))},clear(){n(),s.then(o=>o.clear())},replace(o){n(),s.then(y=>y.replace(o))},show(o,y){n(),s.then(m=>m.show(o,y))},hide(){n(),s.then(o=>o.hide())},dispose(){a=!0,s.then(o=>o.dispose())}}}r($,s,a){const n=new i.$ic,o=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},y=n.add(new f.$ed);function m(I){s=I,y.fire(I)}return a.then(I=>{n.add(I),I.logLevel!==s&&m(I.logLevel),n.add(I.onDidChangeLogLevel(k=>m(k)))}),{...this.q($,a),get logLevel(){return s},onDidChangeLogLevel:y.event,trace(I,...k){o(),a.then(r=>r.trace(I,...k))},debug(I,...k){o(),a.then(r=>r.debug(I,...k))},info(I,...k){o(),a.then(r=>r.info(I,...k))},warn(I,...k){o(),a.then(r=>r.warn(I,...k))},error(I,...k){o(),a.then(r=>r.error(I,...k))},dispose(){n.dispose()}}}};e.$Hbc=g,e.$Hbc=g=Ke([Ve(0,C.$XL),Ve(1,d.$bM),Ve(2,S.$kbc),Ve(3,P.$Rac),Ve(4,A.$5i),Ve(5,A.$4i)],g),e.$Ibc=(0,F.$Ah)("IExtHostOutputService")}),define(Ae[264],Re([1,0,4,13]),function(be,e,w,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=void 0,e.$im=(0,w.$Ah)("remoteAgentService"),e.$jm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let L=1/0;for(let l=0;l<this.maxSampleCount;l++){const S=await C.getRoundTripTime();if(S===void 0)return;L=Math.min(L,S/2),await(0,F.$Gg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((l,S)=>l+S,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((l,S)=>l+S,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[265],Re([1,0,42,12,19,22,23,2,4,187,53,209,264]),function(be,e,w,F,C,L,A,l,S,d,P,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=void 0,e.$rJ=(0,S.$Ah)("pathService");let p=b=class{constructor(i,t,c,g){this.d=i,this.e=t,this.f=c,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??i})()}hasValidBasename(i,t,c){return typeof t=="string"||typeof t>"u"?this.a.then(g=>this.h(i,g,t)):this.h(i,t,c)}h(i,t,c){return i.scheme===F.Schemas.file||i.scheme===F.Schemas.vscodeRemote?(0,w.$Ff)(c??(0,A.$eg)(i),t===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(i,t){if(i.remoteAuthority)return F.Schemas.vscodeRemote;const c=(0,d.$oJ)(t.getWorkspace());if(c)return c;const g=t.getWorkspace().folders[0];if(g)return g.uri.scheme;const E=t.getWorkspace().configuration;return E?E.scheme:F.Schemas.file}userHome(i){return i?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(i=>i===1?C.$4d:C.$5d)}async fileURI(i){let t="";if(await this.a===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const g=i.indexOf("/",2);g===-1?(t=i.substring(2),i="/"):(t=i.substring(2,g),i=i.substring(g)||"/")}return l.URI.from({scheme:F.Schemas.file,authority:t,path:i,query:"",fragment:""})}};e.$sJ=p,e.$sJ=p=b=Ke([Ve(1,u.$im),Ve(2,D.$aJ),Ve(3,P.$Jh)],p)}),define(Ae[111],Re([1,0]),function(be,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$bI=e.$aI=void 0;class w{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new w(0,0)}with(A){return new w(0,0)}}e.$aI=w;class F{constructor(A,l,S,d){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,l),this.end=new w(S,d)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.$bI=F;var C;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Ae[47],Re([1,0,18,37,24,42,15,4,19,9,111,13]),function(be,e,w,F,C,L,A,l,S,d,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.SearchErrorCode=e.$qI=e.$pI=e.SearchSortOrder=e.ViewMode=e.$oI=e.$nI=e.$mI=e.$lI=e.SearchCompletionExitCode=e.$kI=e.$jI=e.$iI=e.QueryType=e.SearchProviderType=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$cI="workbench.view.search",e.$dI="workbench.panel.search",e.$eI="workbench.view.search",e.$fI="search-result",e.$gI="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",p=(u.length+b.length+5)*2;e.$hI=(0,l.$Ah)("searchService");var f;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(f||(e.SearchProviderType=f={}));var i;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(i||(e.QueryType=i={}));function t(Z){return!!Z.preview}e.$iI=t;function c(Z){return!!Z.resource}e.$jI=c;function g(Z){return!!Z.message}e.$kI=g;var E;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class ${constructor(ue){this.resource=ue,this.results=[]}}e.$lI=$;class s{constructor(ue,ye,ce,$e){this.ranges=ye,this.webviewIndex=$e;const ie=Array.isArray(ye)?ye:[ye];if(ce&&ce.matchLines===1&&a(ie)){ue=(0,A.$bf)(ue,ce.matchLines);let z="",q=0,le=0;const we=Math.floor(ce.charsPerLine/5),ve=[];for(const me of ie){const De=Math.max(me.startColumn-we,0),ne=me.startColumn+ce.charsPerLine;if(De>le+we+p){const he=u+(De-le)+b;z+=he+ue.slice(De,ne),q+=De-(le+he.length)}else z+=ue.slice(le,ne);ve.push(new o(0,me.startColumn-q,me.endColumn-q)),le=ne}this.preview={text:z,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const z=Array.isArray(ye)?ye[0].startLineNumber:ye.startLineNumber;this.preview={text:ue,matches:(0,w.$Yb)(ye,q=>new n(q.startLineNumber-z,q.startColumn,q.endLineNumber-z,q.endColumn))}}}}e.$mI=s;function a(Z){const ue=Z[0].startLineNumber;for(const ye of Z)if(ye.startLineNumber!==ue||ye.endLineNumber!==ue)return!1;return!0}class n{constructor(ue,ye,ce,$e){this.startLineNumber=ue,this.startColumn=ye,this.endLineNumber=ce,this.endColumn=$e}}e.$nI=n;class o extends n{constructor(ue,ye,ce){super(ue,ye,ue,ce)}}e.$oI=o;var y;(function(Z){Z.List="list",Z.Tree="tree"})(y||(e.ViewMode=y={}));var m;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function I(Z,ue=!0){const ye=Z&&Z.files&&Z.files.exclude,ce=ue&&Z&&Z.search&&Z.search.exclude;if(!ye&&!ce)return;if(!ye||!ce)return ye||ce;let $e=Object.create(null);return $e=C.$Xm($e,C.$Um(ye)),$e=C.$Xm($e,C.$Um(ce),!0),$e}e.$pI=I;function k(Z,ue){return Z.excludePattern&&F.$pj(Z.excludePattern,ue)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&F.$pj(Z.includePattern,ue)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(ye=>{const ce=ye.folder.fsPath;if(L.$Hf(ue,ce)){const $e=S.$0d(ce,ue);return!ye.includePattern||!!F.$pj(ye.includePattern,$e)}else return!1}):!1:!0}e.$qI=k;var r;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(r||(e.SearchErrorCode=r={}));class h extends Error{constructor(ue,ye){super(ue),this.code=ye}}e.$rI=h;function v(Z){const ue=Z.message;if((0,d.$2)(Z))return new h(ue,r.canceled);try{const ye=JSON.parse(ue);return new h(ye.message,ye.code)}catch{return new h(ue,r.other)}}e.$sI=v;function R(Z){const ue={message:Z.message,code:Z.code};return new Error(JSON.stringify(ue))}e.$tI=R;function W(Z){return Z.type==="error"?!0:Z.type==="success"}e.$uI=W;function V(Z){return Z.type==="success"}e.$vI=V;function U(Z){return!!Z.path}e.$wI=U;function B(Z,ue){const ye=Z.searchPath?Z.searchPath:Z.relativePath;return(0,A.$$e)(ye,ue)}e.$xI=B;class O{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$yI=O;function N(Z,ue){const ye={...Z||{},...ue||{}};return Object.keys(ye).filter(ce=>{const $e=ye[ce];return typeof $e=="boolean"&&$e})}e.$zI=N;class ee{constructor(ue,ye){this.c=null,this.a={...ue.excludePattern||{},...ye.excludePattern||{}},this.b=F.$qj(this.a);let ce=ue.includePattern;ye.includePattern&&(ce?ce={...ce,...ye.includePattern}:ce=ye.includePattern),ce&&(this.c=F.$qj(ce))}matchesExcludesSync(ue,ye,ce){return!!(this.b&&this.b(ue,ye,ce))}includedInQuerySync(ue,ye,ce){return!(this.b&&this.b(ue,ye,ce)||this.c&&!this.c(ue,ye,ce))}includedInQuery(ue,ye,ce){const $e=this.b(ue,ye,ce),ie=()=>this.c?!!this.c(ue,ye,ce):!0;return(0,D.$sg)($e)?$e.then(z=>z?!1:ie()):ie()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$AI=ee;function Y(Z){for(const ue in Z)if(typeof Z[ue]!="boolean")return!0;return!1}function Ee(Z){if(!Z)return;let ue;return ye=>(ue||(ue=(Z()||Promise.resolve([])).then(ce=>ce?Pe(ce):{})),ue.then(ce=>!!ce[ye]))}e.$BI=Ee;function ke(Z){if(!Z)return;let ue;return ye=>{if(!ue){const ce=Z();ue=ce?Pe(ce):{}}return!!ue[ye]}}e.$CI=ke;function Pe(Z){const ue={};for(const ye of Z)ue[ye]=!0;return ue}}),define(Ae[33],Re([1,0,18,13,21,5,6,48,12,118,23,15,2,159,4,14,176,53,39,27,17,8,7,55,47,3]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E,$,s,a,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=void 0;function y(W,V,U){return new P.$9f(B=>r(B,U)).isEqual(W,V)}function m(W,V,U){return y(W.uri,V.uri,U)?0:(0,D.$Ee)(W.uri.toString(),V.uri.toString())}function I(W,V,U){return W.index!==V.index?W.index<V.index?-1:1:y(W.uri,V.uri,U)?(0,D.$Ee)(W.name,V.name):(0,D.$Ee)(W.uri.toString(),V.uri.toString())}function k(W,V,U,B){const O=W.slice(0).sort((ee,Y)=>U(ee,Y,B)),N=V.slice(0).sort((ee,Y)=>U(ee,Y,B));return(0,w.$Bb)(O,N,(ee,Y)=>U(ee,Y,B))}function r(W,V){const U=V.getCapabilities(W.scheme);return!(U&&U&1024)}class h extends t.$Th{static toExtHostWorkspace(V,U,B,O){if(!V)return{workspace:null,added:[],removed:[]};const{id:N,name:ee,folders:Y,configuration:Ee,transient:ke,isUntitled:Pe}=V,Z=[],ue=U;U?Y.forEach((ie,z)=>{const q=u.URI.revive(ie.uri),le=h.o(B||U,q,O);le?(le.name=ie.name,le.index=ie.index,Z.push(le)):Z.push({uri:q,name:ie.name,index:z})}):Z.push(...Y.map(({uri:ie,name:z,index:q})=>({uri:u.URI.revive(ie),name:z,index:q}))),Z.sort((ie,z)=>ie.index<z.index?-1:1);const ye=new h(N,ee,Z,!!ke,Ee?u.URI.revive(Ee):null,!!Pe,ie=>r(ie,O)),{added:ce,removed:$e}=k(ue?ue.workspaceFolders:[],ye.workspaceFolders,m,O);return{workspace:ye,added:ce,removed:$e}}static o(V,U,B){for(let O=0;O<V.folders.length;O++){const N=V.workspaceFolders[O];if(y(N.uri,U,B))return N}}constructor(V,U,B,O,N,ee,Y){super(V,B.map(Ee=>new t.$Uh(Ee)),O,N,Y),this.t=U,this.u=ee,this.q=[],this.s=l.$Gh.forUris(Y),B.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,U){return U&&this.s.get(V)&&(V=(0,P.$gg)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let v=class{constructor(V,U,B,O,N){this.c=new L.$ed,this.onDidChangeWorkspace=this.c.event,this.g=new L.$ed,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$gd,this.B=new Map,this.h=O,this.s=B,this.t=N,this.j=new d.$Il,this.k=new F.$Eg,this.o=V.getProxy(o.$VJ.MainThreadWorkspace),this.q=V.getProxy(o.$VJ.MainThreadMessageService);const ee=U.workspace;this.l=ee?new h(ee.id,ee.name,[],!!ee.transient,ee.configuration?u.URI.revive(ee.configuration):null,!!ee.isUntitled,Y=>r(Y,B)):void 0}$initializeWorkspace(V,U){this.v=U,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:S.Schemas.untitled,path:(0,P.$eg)((0,P.$gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,U,B,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{u.URI.isUri(Pe.uri)&&!N.some(Z=>y(Z.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,P.$dg)(Pe.uri)})}),this.n||[U,B].some(Pe=>typeof Pe!="number"||Pe<0)||B===0&&N.length===0)return!1;const ee=this.x?this.x.workspaceFolders:[];if(U+B>ee.length)return!1;const Y=ee.slice(0);Y.splice(U,B,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,P.$dg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Y.length;Pe++){const Z=Y[Pe];if(Y.some((ue,ye)=>ye!==Pe&&y(Z.uri,ue.uri,this.s)))return!1}Y.forEach((Pe,Z)=>Pe.index=Z);const{added:Ee,removed:ke}=k(ee,Y,I,this.s);if(Ee.length===0&&ke.length===0)return!1;if(this.o){const Pe=V.displayName||V.name;this.o.$updateWorkspaceFolders(Pe,U,B,N).then(void 0,Z=>{this.n=void 0;const ue={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(i.Severity.Error,(0,b.localize)(0,null,Pe,Z.toString()),ue,[])})}return this.y(Y),!0}getWorkspaceFolder(V,U){if(this.x)return this.x.getWorkspaceFolder(V,U)}async getWorkspaceFolder2(V,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,U)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,U){let B,O="";if(typeof V=="string"?(B=u.URI.file(V),O=V):typeof V<"u"&&(B=V,O=V.fsPath),!B)return O;const N=this.getWorkspaceFolder(B,!0);if(!N)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ee=(0,P.$jg)(N.uri,B);return U&&N.name&&(ee=`${N.name}/${ee}`),ee}y(V){this.x&&(this.n=h.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:U,added:B,removed:O}=h.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:B,removed:O}))}findFiles(V,U,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let ee;if(U===null?ee=!1:U&&(typeof U=="string"?ee=U:ee=U.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:Ee}=R($.GlobPattern.from(V));return this.o.$startFileSearch(Y??null,Ee??null,ee??null,B??null,N).then(ke=>Array.isArray(ke)?ke.map(Pe=>u.URI.revive(Pe)):[])}async findTextInFiles(V,U,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const ee=this.j.getNext(),Y=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:Ee,folder:ke}=R($.GlobPattern.from(U.include)),Pe=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,Z={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Y,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:Ee,excludePattern:Pe},ue=!1;if(this.u[ee]=ye=>{if(ue)return;const ce=u.URI.revive(ye.resource);ye.results.forEach($e=>{(0,n.$iI)($e)?B({uri:ce,preview:{text:$e.preview.text,matches:(0,w.$Yb)($e.preview.matches,ie=>new s.$ZJ(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,w.$Yb)($e.ranges,ie=>new s.$ZJ(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):B({uri:ce,text:$e.text,lineNumber:$e.lineNumber})})},N.isCancellationRequested)return{};try{const ye=await this.o.$startTextSearch(V,ke??null,Z,ee,N);return delete this.u[ee],ye||{}}catch(ye){throw delete this.u[ee],ye}}$handleTextSearchResult(V,U){this.u[U]?.(V)}async save(V){const U=await this.o.$save(V,{saveAs:!1});return u.URI.revive(U)}async saveAs(V){const U=await this.o.$save(V,{saveAs:!0});return u.URI.revive(U)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,U){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,U);const B=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,B),(0,A.$hc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(V,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const B=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const O=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(B,U);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(V,U,B,O){this.h.info("Getting edit session identifier for workspaceFolder",V);const N=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const ee=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!ee),!ee)return;const Y=await ee.provideEditSessionIdentityMatch?.(U,B,O);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(V){return(U,B,O)=>{const N=function(Y){U.call(B,Y)};return N.extension=V,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(V,U,B){const O=await this.resolveWorkspaceFolder(u.URI.revive(V));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},U,async(N,ee)=>{const Y=Date.now();await Promise.resolve(N),Date.now()-Y>B&&this.h.warn("SLOW edit session create-participant",ee.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(V,U){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,U);const B=this.t.transformOutgoingScheme(V),O=this.z++;return this.o.$registerCanonicalUriProvider(O,B),(0,A.$hc)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(V,U,B){const O=this.B.get(V.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(u.URI.revive(V),U,B);if(N)return N}async $provideCanonicalUri(V,U,B){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:U},B)}};e.$4ac=v,e.$4ac=v=Ke([Ve(0,E.$XL),Ve(1,g.$bM),Ve(2,c.$Rac),Ve(3,f.$4i),Ve(4,a.$2ac)],v),e.$5ac=(0,p.$Ah)("IExtHostWorkspace");function R(W){let V,U;return W&&(typeof W=="string"?V=W:(V=W.pattern,U=u.URI.revive(W.baseUri))),{includePattern:V,folder:U}}}),define(Ae[34],Re([1,0,24,5,33,3,7,178,96,16,13,4,17,14,2]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=e.$7ac=e.$6ac=void 0;function f(a,n){if(n){const o=n.split(".");let y=a;for(let m=0;y&&m<o.length;m++)y=y[o[m]];return y}}function i(a){return a instanceof p.URI}function t(a){return a&&a.uri instanceof p.URI&&a.languageId&&typeof a.languageId=="string"}function c(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function g(a){return a&&a.uri instanceof p.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function E(a){if(i(a))return{resource:a};if(t(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(c(a))return{overrideIdentifier:a.languageId};if(g(a))return{resource:a.uri};if(a===null)return{resource:null}}let $=class{constructor(n,o,y){this.a=n.getProxy(L.$VJ.MainThreadConfiguration),this.c=o,this.b=y,this.d=new P.$Eg,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new s(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,o){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(n,o))}};e.$6ac=$,e.$6ac=$=Ke([Ve(0,u.$XL),Ve(1,C.$5ac),Ve(2,b.$4i)],$);class s{constructor(n,o,y,m){this.a=new F.$ed,this.b=n,this.f=m,this.c=o,this.e=l.$sn.parse(y),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,o){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$sn.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(o,y))}getConfiguration(n,o,y){const m=E(o)||{},I=this.g(n?f(this.e.getValue(void 0,m,this.c.workspace),n):this.e.getValue(void 0,m,this.c.workspace));n&&this.h(n,m,y?.identifier);function k(h){if(h==null)return null;if(typeof h=="boolean")return h?2:5;switch(h){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const r={has(h){return typeof f(I,h)<"u"},get:(h,v)=>{this.h(n?`${n}.${h}`:h,m,y?.identifier);let R=f(I,h);if(typeof R>"u")R=v;else{let W;const V=(U,B)=>{if((0,d.$kf)(U)){let O;const N=()=>{W=W||(0,w.$Um)(I),O=O||f(W,B)};return new Proxy(U,{get:(ee,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return N(),()=>O;if(W)return O=O||f(W,B),O[Y];const Ee=ee[Y];return typeof Y=="string"?V(Ee,`${B}.${Y}`):Ee},set:(ee,Y,Ee)=>(N(),O&&(O[Y]=Ee),!0),deleteProperty:(ee,Y)=>(N(),O&&delete O[Y],!0),defineProperty:(ee,Y,Ee)=>(N(),O&&Object.defineProperty(O,Y,Ee),!0)})}return Array.isArray(U)?(0,w.$Um)(U):U};R=V(R,h)}return R},update:(h,v,R,W)=>{h=n?`${n}.${h}`:h;const V=k(R);return v!==void 0?this.b.$updateConfigurationOption(V,h,v,m,W):this.b.$removeConfigurationOption(V,h,m,W)},inspect:h=>{h=n?`${n}.${h}`:h;const v=this.e.inspect(h,m,this.c.workspace);if(v)return{key:h,defaultValue:(0,w.$Um)(v.policy?.value??v.default?.value),globalValue:(0,w.$Um)(v.user?.value??v.application?.value),workspaceValue:(0,w.$Um)(v.workspace?.value),workspaceFolderValue:(0,w.$Um)(v.workspaceFolder?.value),defaultLanguageValue:(0,w.$Um)(v.default?.override),globalLanguageValue:(0,w.$Um)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,w.$Um)(v.workspace?.override),workspaceFolderLanguageValue:(0,w.$Um)(v.workspaceFolder?.override),languageIds:(0,w.$Um)(v.overrideIdentifiers)}}};return typeof I=="object"&&(0,w.$Xm)(r,I,!1),Object.freeze(r)}g(n){const o=y=>(0,d.$kf)(y)?new Proxy(y,{get:(m,I)=>o(m[I]),set:(m,I,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(m,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(m,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return o(n)}h(n,o,y){const m=S.$jn.test(n)?4:this.d.get(n),I=y?`[${y.value}] `:"";if(m===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,o){const y=new l.$un(n,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,I)=>y.affectsConfiguration(m,E(I))})}k(n){return n.reduce((o,y)=>(o.set(y[0],y[1]),o),new Map)}}e.$7ac=s,e.$8ac=(0,D.$Ah)("IExtHostConfiguration")}),define(Ae[112],Re([1,0,2,13,5,3,7,33,59,34,21,62,17,27,4,12,22,14,80,215,9]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=e.$5bc=e.$4bc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var $;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})($||($={}));var s;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(s||(s={}));var a;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(a||(a={}));var n;(function(V){function U(N){if(N){const ee=N;return ee&&!!ee.process}else return!1}V.is=U;function B(N){if(N==null)return;const ee={process:N.process,args:N.args};return N.options&&(ee.options=a.from(N.options)),ee}V.from=B;function O(N){if(N!=null)return new A.$GK(N.process,N.args,N.options)}V.to=O})(n||(n={}));var o;(function(V){function U(O){if(O!=null)return O}V.from=U;function B(O){if(O!=null)return O}V.to=B})(o||(o={}));var y;(function(V){function U(N){if(N){const ee=N;return ee&&(!!ee.commandLine||!!ee.command)}else return!1}V.is=U;function B(N){if(N==null)return;const ee={};return N.commandLine!==void 0?ee.commandLine=N.commandLine:(ee.command=N.command,ee.args=N.args),N.options&&(ee.options=o.from(N.options)),ee}V.from=B;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$HK(N.commandLine,N.options):new A.$HK(N.command,N.args?N.args:[],N.options)}V.to=O})(y||(y={}));var m;(function(V){function U(N){if(N){const ee=N;return ee&&ee.customExecution==="customExecution"}else return!1}V.is=U;function B(N){return{customExecution:"customExecution"}}V.from=B;function O(N,ee){return ee.get(N)}V.to=O})(m||(e.CustomExecutionDTO=m={}));var I;(function(V){function U(B,O){let N;return B.scope!==void 0&&typeof B.scope!="number"?N=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=g.$$F),{id:B._id,workspaceFolder:N}}V.from=U})(I||(e.TaskHandleDTO=I={}));var k;(function(V){function U(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}V.from=U})(k||(k={}));var r;(function(V){function U(N,ee){if(N==null)return[];const Y=[];for(const Ee of N){const ke=B(Ee,ee);ke&&Y.push(ke)}return Y}V.fromMany=U;function B(N,ee){if(N==null)return;let Y;N.execution instanceof A.$GK?Y=n.from(N.execution):N.execution instanceof A.$HK?Y=y.from(N.execution):N.execution&&N.execution instanceof A.$IK&&(Y=m.from(N.execution));const Ee=$.from(N.definition);let ke;return N.scope?typeof N.scope=="number"?ke=N.scope:ke=N.scope.uri:ke=A.TaskScope.Workspace,!Ee||!ke?void 0:{_id:N._id,definition:Ee,name:N.name,source:{extensionId:ee.identifier.value,label:N.source,scope:ke},execution:Y,isBackground:N.isBackground,group:k.from(N.group),presentationOptions:s.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}V.from=B;async function O(N,ee,Y){if(N==null)return;let Ee;n.is(N.execution)?Ee=n.to(N.execution):y.is(N.execution)?Ee=y.to(N.execution):m.is(N.execution)&&(Ee=m.to(N._id,Y));const ke=$.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await ee.resolveWorkspaceFolder(w.URI.revive(N.source.scope)):Pe=A.TaskScope.Workspace),!ke||!Pe)return;const Z=new A.$JK(ke,Pe,N.name,N.source.label,Ee,N.problemMatchers);return N.isBackground!==void 0&&(Z.isBackground=N.isBackground),N.group!==void 0&&(Z.group=A.$FK.from(N.group._id),Z.group&&N.group.isDefault&&(Z.group=new A.$FK(Z.group.id,Z.group.label),N.group.isDefault===!0&&(Z.group.isDefault=N.group.isDefault))),N.presentationOptions&&(Z.presentationOptions=s.to(N.presentationOptions)),N._id&&(Z._id=N._id),N.detail&&(Z.detail=N.detail),Z}V.to=O})(r||(e.TaskDTO=r={}));var h;(function(V){function U(O){return O}V.from=U;function B(O){if(O)return Object.assign(Object.create(null),O)}V.to=B})(h||(h={}));class v{#e;constructor(U,B,O){this._id=B,this.a=O,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let R=class{constructor(U,B,O,N,ee,Y,Ee,ke){this.q=new C.$ed,this.r=new C.$ed,this.s=new C.$ed,this.t=new C.$ed,this.a=U.getProxy(L.$VJ.MainThreadTask),this.b=O,this.c=N,this.d=ee,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=ke,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,B,O){if(!O)return new A.$XJ(()=>{});const N=this.w();return this.j.set(N,{type:B,provider:O,extension:U}),this.a.$registerTaskProvider(N,B),new A.$XJ(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(U,B){this.a.$registerTaskSystem(U,B)}fetchTasks(U){return this.a.$fetchTasks(h.from(U)).then(async B=>{const O=[];for(const N of B){const ee=await r.to(N,this.b,this.m);ee&&O.push(ee)}return O})}get taskExecutions(){const U=[];return this.k.forEach(B=>U.push(B)),U}terminateTask(U){if(!(U instanceof v))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,B,O){const N=this.m.get(U.id);N&&(this.o.set(U.id,N),this.e.attachPtyToTerminal(B,await N.callback(O))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const B=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const B=await this.y(U.id);this.s.fire({execution:B,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const B=await this.y(U.id);this.t.fire({execution:B,exitCode:U.exitCode})}$provideTasks(U,B){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));const N=[],ee=(0,F.$yg)(()=>O.provider.provideTasks(P.CancellationToken.None)).then(Y=>this.u(B,N,O,Y));return new Promise(Y=>{ee.then(Ee=>{Promise.all(N).then(()=>{Y(Ee)})})})}async $resolveTask(U,B){const O=this.j.get(U);if(!O)return Promise.reject(new Error("no handler found"));if(B.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await r.to(B,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const ee=await O.provider.resolveTask(N,P.CancellationToken.None);if(!ee)return;this.z(ee,O);const Y=r.from(ee,O.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(ee.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(Y.execution)&&await this.x(Y,ee,!0),await this.v(Y)}w(){return this.h++}async x(U,B,O){const N=await this.a.$createTaskId(U);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,B.execution)),this.m.set(N,B.execution)}async y(U,B){if(typeof U=="string"){const ee=this.l.get(U);if(!ee)throw new E.$_("Unexpected: The specified task is missing an execution");return ee}const O=this.l.get(U.id);if(O)return O;const N=new Promise((ee,Y)=>{function Ee(ke,Pe,Z){Z?ee(new v(ke,Pe.id,Z)):Y("Unexpected: Task does not exist.")}B?Ee(this,U,B):r.to(U.task,this.b,this.m).then(ke=>Ee(this,U,ke))});return this.l.set(U.id,N),N.then(ee=>(this.k.set(U.id,ee),ee),ee=>Promise.reject(ee))}z(U,B){U._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$4bc=R,e.$4bc=R=Ke([Ve(0,u.$XL),Ve(1,b.$bM),Ve(2,l.$5ac),Ve(3,S.$9L),Ve(4,d.$8ac),Ve(5,D.$nbc),Ve(6,t.$4i),Ve(7,c.$Uac)],R);let W=class extends R{constructor(U,B,O,N,ee,Y,Ee,ke){super(U,B,O,N,ee,Y,Ee,ke),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:i.$h(0)})}async executeTask(U,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const O=r.from(B,U);if(O===void 0)throw new Error("Task is not valid");if(m.is(O.execution))await this.x(O,B,!1);else throw new E.$0;const N=await this.y(await this.a.$getTaskExecution(O),B);return this.a.$executeTask(O).catch(ee=>{throw new Error(ee)}),N}u(U,B,O,N){const ee=[];if(N)for(const Y of N){this.z(Y,O),(!Y.definition||!U[Y.definition.type])&&this.f.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=r.from(Y,O.extension);Ee&&m.is(Ee.execution)?(ee.push(Ee),B.push(this.x(Ee,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ee,extension:O.extension}}async v(U){if(m.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,B,O){}};e.$5bc=W,e.$5bc=W=Ke([Ve(0,u.$XL),Ve(1,b.$bM),Ve(2,l.$5ac),Ve(3,S.$9L),Ve(4,d.$8ac),Ve(5,D.$nbc),Ve(6,t.$4i),Ve(7,c.$Uac)],W),e.$6bc=(0,p.$Ah)("IExtHostTask")}),define(Ae[266],Re([1,0,19,21,41,37,23,58,47]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=void 0;class d{constructor(u,b,p){this.k=u,this.l=b,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&L.$qj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&L.$qj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((p,f)=>{const i=t=>{this.f++,u(t)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const c=t.toString(),g=w.$_d(c);this.j&&this.j(c,g)||this.v(i,{base:t,basename:g})}),Promise.all(b.map(t=>this.p(t,i))).then(t=>{p({limitHit:this.e,stats:t[0]||void 0})},t=>{f(new Error((0,C.$li)(t)))})})}async p(u,b){const p=new F.$od,f=this.q(u),i=this.r(),t=new S.$AI(this.k,u),c=!t.hasSiblingExcludeClauses();let g;try{this.h.add(p),g=l.$ad.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,p.token),$=g.elapsed(),s=l.$ad.create();return this.g&&!this.e||(E&&E.forEach(a=>{const n=w.$5d.relative(u.folder.path,a.path);if(c){const o=w.$_d(a.path);this.v(b,{base:u.folder,relativePath:n,basename:o});return}this.s(i,u.folder,n,b)}),this.g&&!this.e)?null:(this.u(i,t,b),{providerTime:$,postProcessTime:s.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(u){const b=(0,S.$zI)(this.k.includePattern,u.includePattern),p=(0,S.$zI)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:p,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,p,f){if(p===this.a){const t=w.$_d(this.a);this.v(f,{base:b,relativePath:this.a,basename:t})}function i(t){const c=w.$_d(t),g=w.$$d(t);let E=u[g];E||(E=u[g]=[],i(g)),E.push({base:b,relativePath:t,basename:c})}i(p)}u({rootEntries:u,pathToEntries:b},p,f){const i=this,t=this.a;function c(g){const E=(0,S.$CI)(()=>g.map($=>$.basename));for(let $=0,s=g.length;$<s;$++){const a=g[$],{relativePath:n,basename:o}=a;if(p.matchesExcludesSync(n,o,t!==o?E:void 0))continue;const y=b[n];if(y)c(y);else{if(n===t)continue;i.v(f,a)}if(i.e)break}}c(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,p,f){const i=this.c(u.cacheKey),t=new d(u,b,i&&i.token);let c=0;const g=E=>{c+=E.length,p(E.map($=>this.d($)))};return this.e(t,P.a,g,f).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:E.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new F.$od),this.b.get(u)}d(u){return u.relativePath?{resource:A.$hg(u.base,u.relativePath)}:{resource:u.base}}e(u,b,p,f){const i=f.onCancellationRequested(()=>{u.cancel()}),t=g=>{g&&(c.push(g),b>0&&c.length>=b&&(p(c),c=[]))};let c=[];return u.search(t).then(g=>(c.length&&p(c),i.dispose(),g),g=>(c.length&&p(c),i.dispose(),Promise.reject(g)))}}e.$dcc=P}),define(Ae[267],Re([1,0,18,100,37,90,28,12,19,23,15,16,2,282,168,43,14,53,103,265,47]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uJ=e.$tJ=void 0;let $=class{constructor(h,v,R,W,V){this.a=h,this.b=v,this.c=R,this.d=W,this.e=V}text(h,v,R={}){h=this.f(h,R);const W=this.a.getValue(),V=v&&v.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(v?.map(t.$Vh),R),type:2,contentPattern:h,previewOptions:R.previewOptions,maxFileSize:R.maxFileSize,usePCRE2:W.search.usePCRE2||V||!1,beforeContext:R.beforeContext,afterContext:R.afterContext,userDisabledExcludesAndIgnoreFiles:R.disregardExcludeSettings&&R.disregardIgnoreFiles}}f(h,v){const R=this.a.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const W={...h,wordSeparators:R.editor.wordSeparators};return this.j(h,v)&&(W.isCaseSensitive=!0),this.k(h)&&(W.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),W}file(h,v={}){return{...this.h(h,v),type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey}}g(h,v){return h?(h=Array.isArray(h)?h.map(y):y(h),v?this.parseSearchPaths(h):{pattern:a(...Array.isArray(h)?h:[h])}):{}}h(h=[],v={}){const R=this.g(v.includePattern,v.expandPatterns),W=this.g(v.excludePattern,v.expandPatterns),V=h.length>1,U=(R.searchPaths&&R.searchPaths.length?R.searchPaths.map(N=>this.q(N,v,W)):h.map(N=>this.r(N,v,W,V))).filter(N=>!!N),B={_reason:v._reason,folderQueries:U,usingSearchPaths:!!(R.searchPaths&&R.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:W.pattern,includePattern:R.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const N=w.$Eb(w.$Ob(this.c.groups.map(Ee=>Ee.editors.map(ke=>ke.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const ee=N.filter(Ee=>(0,E.$qI)(B,Ee.fsPath)),Y=this.i(ee);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...B,...Y}}const O=v.extraFileResources&&v.extraFileResources.filter(N=>(0,E.$qI)(B,N.fsPath));return B.extraFileResources=O&&O.length?O:void 0,B}i(h){const v=[],R=new A.$yi,W={};let V=!1;return h.forEach(U=>{if(U.scheme===l.Schemas.walkThrough)return;if((0,d.$lg)(U)){const O=this.b.getWorkspaceFolder(U)?.uri??U.with({path:S.$$d(U.fsPath)});let N=R.get(O);N||(V=!0,N={folder:O,includePattern:{}},v.push(N),R.set(O,N));const ee=S.$0d(O.fsPath,U.fsPath);(0,D.$tf)(N.includePattern)[ee.replace(/\\/g,"/")]=!0}else U.fsPath&&(V=!0,W[U.fsPath]=!0)}),{folderQueries:v,includePattern:W,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(h,v){if(v.isSmartCase){if(h.isRegExp){if(P.$_e(h.pattern,!0))return!0}else if(P.$_e(h.pattern))return!0}return!!h.isCaseSensitive}k(h){return h.isMultiline||h.isRegExp&&(0,b.$hC)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const v=Y=>S.$7d(Y)||/^\.\.?([\/\\]|$)/.test(Y),W=(Array.isArray(h)?h:n(h)).map(Y=>{const Ee=this.e.resolvedUserHome;return Ee?(0,L.$gA)(Y,Ee.scheme===l.Schemas.file?Ee.fsPath:Ee.path):Y}),V=F.$I(W,Y=>v(Y)?"searchPaths":"exprSegments"),U=(V.exprSegments||[]).map(Y=>P.$ue(Y,"/")).map(Y=>P.$ue(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),o(Y))),B={},O=this.m(V.searchPaths||[]);O&&O.length&&(B.searchPaths=O);const N=w.$Ob(U),ee=a(...N);return ee&&(B.pattern=ee),B}l(h,v){return v.disregardExcludeSettings?void 0:(0,E.$pI)(h,!v.disregardSearchExcludeSettings)}m(h){if(!h||!h.length)return[];const v=h.flatMap(W=>{let{pathPortion:V,globPortion:U}=s(W);return U&&(U=m(U)),this.n(V).flatMap(O=>this.o(O,U))}),R=new Map;return v.forEach(W=>{const V=W.searchPath.toString(),U=R.get(V);U?W.pattern&&(U.pattern=U.pattern||{},U.pattern[W.pattern]=!0):R.set(V,{searchPath:W.searchPath,pattern:W.pattern?a(W.pattern):void 0})}),Array.from(R.values())}n(h){if(S.$7d(h)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==l.Schemas.file?[{searchPath:v[0].uri.with({path:h})}]:[{searchPath:u.URI.file(S.$6d(h))}]}if(this.b.getWorkbenchState()===2){const v=this.b.getWorkspace().folders[0].uri;if(h=y(h),h.startsWith("../")||h===".."){const W=S.$5d.resolve(v.path,h);return[{searchPath:v.with({path:W})}]}const R=m(h);return[{searchPath:v,pattern:R}]}else{if(h==="./"||h===".\\")return[];{const v=h.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(V=>{const U=v.match(new RegExp(`^${P.$pe(V.name)}(?:/(.*)|$)`));return U?{match:U,folder:V}:null}).filter(D.$qf);if(W.length)return W.map(V=>{const U=V.match[1];return{searchPath:V.folder.uri,pattern:U&&m(U)}});{const V=h.match(/\.[\/\\](.+)[\/\\]?/),U=V?V[1]:h,B=p.localize(0,null,U);throw new Error(B)}}}}o(h,v){const R=h.pattern&&v?`${h.pattern}/${v}`:h.pattern||v,W=[{searchPath:h.searchPath,pattern:R}];return R&&!R.endsWith("**")&&W.push({searchPath:h.searchPath,pattern:R+"/**"}),W}q(h,v,R){const W=this.r((0,t.$Vh)(h.searchPath),v,R,!1);return W?{...W,includePattern:h.pattern}:null}r(h,v,R,W){let V;const U=u.URI.isUri(h)?h:h.uri;if(R.searchPaths){const Y=R.searchPaths.filter(Ee=>(0,d.$ag)(Ee.searchPath,U))[0];if(Y&&!Y.pattern)return null;Y&&(V=Y.pattern)}const B=this.a.getValue({resource:U}),N={...this.l(B,v)||{},...V||{}},ee=u.URI.isUri(h)?(0,d.$eg)(h):h.name;return{folder:U,folderName:W?ee:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!B.search.followSymlinks}}};e.$tJ=$,e.$tJ=$=Ke([Ve(0,f.$7h),Ve(1,t.$Jh),Ve(2,c.$4C),Ve(3,i.$4i),Ve(4,g.$rJ)],$);function s(r){const h=r.match(/[\*\{\}\(\)\[\]\?]/);if(h){const v=h.index,R=r.substr(0,v).match(/[/|\\][^/\\]*$/);if(R){let W=r.substr(0,R.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:r.substr((R.index||0)+1)}}}return{pathPortion:r}}function a(...r){return r.length?r.reduce((h,v)=>(h[v]=!0,h),Object.create(null)):void 0}function n(r){return C.$oj(r,",").map(h=>h.trim()).filter(h=>!!h.length)}function o(r){return[`**/${r}/**`,`**/${r}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function y(r){return r.replace(/\\/g,"/")}function m(r){return y(r).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(r){return r.replace(/([?*[\]])/g,"[$1]")}function k(r,h){r=w.$Jb(r,W=>W.toString());const v=[],R=h.getWorkspace();return r&&r.forEach(W=>{let V;if(h.getWorkbenchState()===2)V=(0,d.$jg)(R.folders[0].uri,W),V&&V!=="."&&(V="./"+V);else{const U=h.getWorkspaceFolder(W);if(U){const B=U.name;if(R.folders.filter(N=>N.name===B).length===1){const N=(0,d.$jg)(U.uri,W);N===""?V=`./${U.name}`:V=`./${U.name}/${N}`}else V=W.fsPath}}V&&v.push(I(V))}),v}e.$uJ=k}),define(Ae[268],Re([1,0,23,2,21,9,4,267,47,53]),function(be,e,w,F,C,L,A,l,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlb=e.$plb=void 0;const P=7e3;function D(f,i){const t=i.activationEvents;if(!t)return Promise.resolve(void 0);const c=[],g=[];for(const o of t)if(/^workspaceContains:/.test(o)){const y=o.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||f.forceUsingSearch?g.push(y):c.push(y)}if(c.length===0&&g.length===0)return Promise.resolve(void 0);let E;const $=new Promise((o,y)=>{E=o}),s=o=>E({activationEvent:o}),a=Promise.all(c.map(o=>u(f,o,s))).then(()=>{}),n=b(f,i.identifier,g,s);return Promise.all([a,n]).then(()=>{E(void 0)}),$}e.$plb=D;async function u(f,i,t){for(const c of f.folders)if(await f.exists(w.$hg(F.URI.revive(c),i))){t(`workspaceContains:${i}`);return}}async function b(f,i,t,c){if(t.length===0)return Promise.resolve(void 0);const g=new C.$od,E=f.checkExists(f.folders,t,g.token),$=setTimeout(async()=>{g.cancel(),f.logService.info(`Not activating extension '${i.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},P);let s=!1;try{s=await E}catch(a){L.$2(a)||L.$Y(a)}g.dispose(),clearTimeout($),s&&c(`workspaceContains:${t.join(",")}`)}function p(f,i,t,c){const g=f.get(A.$zh),E=f.get(S.$hI),s=g.createInstance(l.$tJ).file(i.map(a=>(0,d.$Vh)(F.URI.revive(a))),{_reason:"checkExists",includePattern:t,exists:!0});return E.fileSearch(s,c).then(a=>!!a.limitHit,a=>L.$2(a)?!1:Promise.reject(a))}e.$qlb=p}),define(Ae[35],Re([1,0,149,19,87,23,13,6,48,2,14,3,34,210,84,33,26,107,9,20,25,189,7,97,4,27,85,17,71,86,62,5,268,83,191,12,81,58,22,82]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E,$,s,a,n,o,y,m,I,k,r,h,v,R,W,V,U,B,O,N){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=e.$Abc=e.$zbc=e.$ybc=void 0,e.$ybc=(0,n.$Ah)("IHostUtils");let Y=ee=class extends l.$jc{constructor(ie,z,q,le,we,ve,me,De,ne,he,se,oe){super(),this.X=oe,this.a=this.B(new h.$ed),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=q,this.f=me,this.j=le,this.m=we,this.s=ve,this.t=ne,this.u=he,this.w=se,this.y=this.g.getProxy(D.$VJ.MainThreadWorkspace),this.z=this.g.getProxy(D.$VJ.MainThreadTelemetry),this.C=this.g.getProxy(D.$VJ.MainThreadExtensionService),this.D=new A.$Eg,this.F=new A.$Eg,this.G=new A.$Eg,this.H=new A.$Eg,this.I=new ce(this.f.extensions.activationEvents),this.L=new t.$i3b(this.I,this.f.extensions.allExtensions);const fe=new g.$Vl(this.f.extensions.myExtensions);this.J=new t.$i3b(this.I,ue(this.L,fe)),O.$s&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new p.$fbc(this.g,this.s),this.N=new R.$rbc(this.g),this.O=De,this.h=ie.createChild(new I.$yh([p.$gbc,this.M],[R.$sbc,this.N])),this.P=this.B(new b.$ebc(this.J,this.L,{onExtensionActivationError:(Ie,M,K)=>{this.C.$onExtensionActivationError(Ie,c.$1(M),K)},actualActivateExtension:async(Ie,M)=>{if(t.$i3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,M),new b.$dbc;const K=this.J.getExtensionDescription(Ie);return this.db(K,M)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(ie){c.$Y(ie)}}async Y(){this.O.onWillDeactivateAll();let ie=[];try{ie=this.J.getAllExtensionDescriptions().map(we=>we.identifier).filter(we=>this.isActivated(we)).map(we=>this.cb(we))}catch{}await Promise.all(ie)}terminate(ie,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${ie}`),this.s.flush(),this.u.dispose(),this.P.dispose(),c.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const q=this.Y();Promise.race([(0,A.$Gg)(5e3),q]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(ie){return this.G.isOpen()?this.P.isActivated(ie):!1}async getExtension(ie){const z=await this.C.$getExtension(ie);return z&&{...z,identifier:new g.$Ul(z.identifier.value),extensionLocation:d.URI.revive(z.extensionLocation)}}Z(ie,z){return this.P.activateByEvent(ie,z)}$(ie,z){return this.P.activateById(ie,z)}activateByIdWithErrors(ie,z){return this.$(ie,z).then(()=>{const q=this.P.getActivatedExtension(ie);if(q.activationFailed)return Promise.reject(q.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(ie=>this.J)}getExtensionExports(ie){if(this.G.isOpen())return this.P.getActivatedExtension(ie).exports;try{return this.P.getActivatedExtension(ie).exports}catch{return null}}async ab(ie){if(ie.scheme===V.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(ie.fsPath);return d.URI.file(z)}return ie}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(ie=>new ye(ie))),this.Q}async bb(ie){const z=S.$Gh.forUris(q=>L.$$f.ignorePathCasing(q));return await Promise.all(ie.map(async q=>{if(this.ub(q)){const le=await this.ab(q.extensionLocation);z.set(le,q)}})),z}cb(ie){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(ie))return z;const q=this.P.getActivatedExtension(ie);if(!q)return z;try{typeof q.module.deactivate=="function"&&(z=Promise.resolve(q.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${ie.value}':`),this.s.error(le)}try{(0,l.$ec)(q.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this.s.error(le)}return z}async db(ie,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(ie.identifier):await this.C.$onWillActivateExtension(ie.identifier),this.fb(ie,z).then(q=>{const le=q.activationTimes;return this.C.$onDidActivateExtension(ie.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,z),this.eb(ie,z,"success",le),q},q=>{throw this.eb(ie,z,"failure"),q})}eb(ie,z,q,le){const we=ke(ie,z);this.z.$publicLog2("extensionActivationTimes",{...we,...le||{},outcome:q})}fb(ie,z){const q=ke(ie,z);this.z.$publicLog2("activatePlugin",q);const le=this.ub(ie);if(!le)return Promise.resolve(new b.$cbc(b.$_ac.NONE));this.s.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${ie.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const we=new b.$abc(z.startup);return Promise.all([this.vb(ie,(0,L.$hg)(ie.extensionLocation,le),we),this.gb(ie)]).then(ve=>(C.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),ee.hb(this.s,ie.identifier,ve[0],ve[1],we))).then(ve=>(C.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),ve))}gb(ie){const z=new $.$ibc(ie,this.M),q=new $.$hbc(ie.identifier.value,!1,this.M),le=new W.$tbc(ie,this.N),we=ie.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,ve=this.f.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([z.whenReady,q.whenReady,this.O.whenReady]).then(()=>{const me=this;let De,ne;const he=(0,i.$OF)(ie,"ipc")?this.f.messagePorts?.get(g.$Ul.toKey(ie.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:q,secrets:le,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(se){return F.$8d(ie.extensionLocation.fsPath,se)},get storagePath(){return me.O.workspaceValue(ie)?.fsPath},get globalStoragePath(){return me.O.globalValue(ie).fsPath},get logPath(){return F.$8d(me.f.logsLocation.fsPath,ie.identifier.value)},get logUri(){return d.URI.joinPath(me.f.logsLocation,ie.identifier.value)},get storageUri(){return me.O.workspaceValue(ie)},get globalStorageUri(){return me.O.globalValue(ie)},get extensionMode(){return we},get extension(){return De===void 0&&(De=new Z(me,ie.identifier,ie,ve,!1)),De},get extensionRuntime(){return(0,i.$PF)(ie,"extensionRuntime"),me.extensionRuntime},get environmentVariableCollection(){return me.u.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!ne){if(!he)return;const se=h.Event.buffer(h.Event.fromDOMEventEmitter(he,"message",oe=>oe.data));he.start(),ne={onDidReceiveMessage:se,postMessage:he.postMessage.bind(he)}}return ne}})})}static hb(ie,z,q,le,we){return q=q||{activate:void 0,deactivate:void 0},this.ib(ie,z,q,le,we).then(ve=>new b.$bbc(!1,null,we.build(),q,ve,le.subscriptions))}static ib(ie,z,q,le,we){if(typeof q.activate=="function")try{we.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${z.value}`);const ve=typeof global=="object"?global:self,me=q.activate.apply(ve,[le]);return we.activateCallStop(),we.activateResolveStart(),Promise.resolve(me).then(De=>(we.activateResolveStop(),De))}catch(ve){return Promise.reject(ve)}else return Promise.resolve(q)}jb(ie,z){this.$(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:z}).then(void 0,q=>{this.s.error(q)})}kb(ie,z=0){const le=Date.now();(0,O.$A)(()=>{for(let we=z;we<ie.length;we+=1){const ve=ie[we];for(const me of ve.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-le>50){this.kb(ie,we);break}else this.jb(ve,me)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(ie=>{const z=ie.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),q=this.J.getAllExtensionDescriptions();if(z)this.kb(q);else for(const le of q)if(le.activationEvents)for(const we of le.activationEvents)we==="onStartupFinished"&&this.jb(le,we)})}mb(){const ie=this.Z("*",!0).then(void 0,ve=>{this.s.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.nb(ve.added)));const z=this.j.workspace?this.j.workspace.folders:[],q=this.nb(z),le=this.pb(),we=Promise.all([le,ie,q]).then(()=>{});return Promise.race([we,(0,A.$Gg)(1e4)]).then(()=>{this.lb()}),we}nb(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(ie,z))).then(()=>{})}async ob(ie,z){if(this.isActivated(z.identifier))return;const q=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:ie.map(ve=>ve.uri),forceUsingSearch:q||!this.c.fsExists,exists:ve=>this.c.fsExists(ve.fsPath),checkExists:(ve,me,De)=>this.y.$checkExists(ve,me,De)},we=await(0,v.$plb)(le,z);if(we)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:we.activationEvent}).then(void 0,ve=>this.s.error(ve))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(ie){throw console.error(ie),ie}}async qb(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:z}=this.f.environment;if(!ie||!z)throw new Error(w.localize(0,null));const q=await this.vb(null,z,new b.$abc(!1));if(!q||typeof q.run!="function")throw new Error(w.localize(1,null,z.toString()));return new Promise((le,we)=>{const ve=(ne,he)=>{ne?(O.$s&&this.s.error("Test runner called back with error",ne),we(ne)):(O.$s&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof he=="number"&&he>0?1:0))},me=(0,L.$8f)(z),De=q.run(me,ve);De&&De.then&&De.then(()=>{O.$s&&this.s.info("Test runner finished successfully."),le(0)}).catch(ne=>{O.$s&&this.s.error("Test runner finished with error",ne),we(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Gg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,z){return this.R[ie]=z,(0,l.$hc)(()=>{delete this.R[ie]})}async getRemoteExecServer(ie){const{resolver:z}=await this.sb(ie);return z?.resolveExecServer?.(ie,{resolveAttempt:0})}async sb(ie){const z=ie.indexOf("+");if(z===-1)throw new s.$4J("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const q=ie.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${q}`,!1),{authorityPrefix:q,resolver:this.R[q]}}async $resolveAuthority(ie,z){const q=B.$ad.create(!1),le=()=>`[resolveAuthority(${(0,a.$Mk)(ie)},${z})][${q.elapsed()}ms] `,we=X=>this.s.info(`${le()}${X}`),ve=X=>this.s.warn(`${le()}${X}`),me=(X,J=void 0)=>this.s.error(`${le()}${X}`,J),De=X=>{if(X instanceof s.$4J)return{type:"error",error:{code:X._code,message:X._message,detail:X._detail}};throw X},ne=async X=>{we(`activating resolver for ${X}...`);const{resolver:J,authorityPrefix:x}=await this.sb(X);if(!J)throw me(`no resolver for ${x}`),new s.$4J(`No remote extension installed to resolve ${x}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:X}},he=ie.split(/@|%40/g).reverse();we(`activating remote resolvers ${he.join(" -> ")}`);let se;try{se=await Promise.all(he.map(ne)).catch(async X=>{if(!(X instanceof s.$4J)||X._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw X;return ve(`resolving nested authorities failed: ${X.message}`),[await ne(ie)]})}catch(X){return De(X)}const oe=new A.$Qg;oe.cancelAndSet(()=>we("waiting..."),1e3);let fe,Ie;for(const[X,{authorityPrefix:J,resolver:x,remoteAuthority:ae}]of se.entries())try{if(X===se.length-1)we("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${J}`),fe=await x.resolve(ae,{resolveAttempt:z,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${J}`),we("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,s.$3J.isManagedResolvedAuthority(fe)?fe:void 0));else{if(we(`invoking resolveExecServer() for ${ae}`),C.mark(`code/extHost/willResolveExecServer/${J}`),Ie=await x.resolveExecServer?.(ae,{resolveAttempt:z,execServer:Ie}),!Ie)throw new s.$4J(`Exec server was not available for ${ae}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(Le){return C.mark(`code/extHost/didResolveAuthorityError/${J}`),me("returned an error",Le),oe.dispose(),De(Le)}oe.dispose();const M={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},K={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};we(`returned ${s.$3J.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let G;if(s.$3J.isManagedResolvedAuthority(fe)){const X=z;this.X.setFactory(X,fe.makeConnection),G={authority:ie,connectTo:new a.$Jk(X),connectionToken:fe.connectionToken}}else G={authority:ie,connectTo:new a.$Kk(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:G,options:K,tunnelInformation:M}}}async $getCanonicalURI(ie,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,a.$Mk)(ie)})`);const{resolver:q}=await this.sb(ie);if(!q)return null;const le=d.URI.revive(z);if(typeof q.getCanonicalURI>"u")return le;const we=await(0,A.$yg)(()=>q.getCanonicalURI(le));return we||le}$startExtensionHost(ie){ie.toAdd.forEach(le=>le.extensionLocation=d.URI.revive(le.extensionLocation));const{globalRegistry:z,myExtensions:q}=Ee(this.I,this.L,this.J,ie);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(ie,z){return z===1?this.D.wait().then(q=>this.Z(ie,!1)):this.G.wait().then(q=>this.Z(ie,!1))}async $activate(ie,z){return await this.G.wait(),this.J.getExtensionDescription(ie)?(await this.$(ie,z),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(ve=>ve.extensionLocation=d.URI.revive(ve.extensionLocation));const{globalRegistry:z,myExtensions:q}=Ee(this.I,this.L,this.J,ie),le=await this.bb(q);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(z.getAllExtensionDescriptions()),this.J.set(q),O.$s&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const z=E.$Ed.alloc(ie),q=Math.random()%256;for(let le=0;le<ie;le++)z.writeUInt8(q,le);return z}async $updateRemoteConnectionData(ie){this.W=ie,this.a.fire()}};e.$zbc=Y,e.$zbc=Y=ee=Ke([Ve(0,n.$zh),Ve(1,e.$ybc),Ve(2,m.$XL),Ve(3,f.$5ac),Ve(4,u.$8ac),Ve(5,P.$4i),Ve(6,o.$bM),Ve(7,y.$lbc),Ve(8,k.$jsb),Ve(9,r.$nbc),Ve(10,U.$vbc),Ve(11,N.$wbc)],Y);function Ee($e,ie,z,q){$e.addActivationEvents(q.addActivationEvents);const le=new t.$i3b($e,ie.getAllExtensionDescriptions());le.deltaExtensions(q.toAdd,q.toRemove);const we=new g.$Vl(z.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of q.myToRemove)we.delete(me);for(const me of q.myToAdd)we.add(me);const ve=ue(le,we);return{globalRegistry:le,myExtensions:ve}}function ke($e,ie){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(ie=>ie.identifier.value).join(",")}e.$Abc=(0,n.$Ah)("IExtHostExtensionService");class Z{#e;#t;#i;constructor(ie,z,q,le,we){this.#e=ie,this.#t=z,this.#i=q.identifier,this.id=q.identifier.value,this.extensionUri=q.extensionLocation,this.extensionPath=F.$6d((0,L.$8f)(q.extensionLocation)),this.packageJSON=q,this.extensionKind=le,this.isFromDifferentExtensionHost=we}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Bbc=Z;function ue($e,ie){return $e.getAllExtensionDescriptions().filter(z=>ie.has(z.identifier))}class ye{constructor(ie){this.a=ie}setSearchTree(ie){this.a=ie}findSubstr(ie){return this.a.findSubstr(ie)}forEach(ie){return this.a.forEach(ie)}}e.$Cbc=ye;class ce{constructor(ie){this.a=new g.$Wl,this.addActivationEvents(ie)}readActivationEvents(ie){return this.a.get(ie.identifier)}addActivationEvents(ie){for(const z of Object.keys(ie))this.a.set(z,ie[z])}}}),define(Ae[269],Re([1,0,87,2,3,34,26,20,17,27,4,35,14,15]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;let f=class{constructor(E,$,s,a,n,o,y){this.c=E,this.d=$,this.e=s,this.f=a,this.g=n,this.h=o,this.i=y,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const E=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const $=await this.g.getExtensionPathIndex();this.register(new t(this.c,$,this.d,E,this.i)),this.register(this.e.createInstance(i)),this.h.remote.isRemote&&this.register(this.e.createInstance(c,$,this.h.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const $ of E.nodeModuleName)this.a.set($,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push($=>E.alternativeModuleName($))}};e.$Ycc=f,e.$Ycc=f=Ke([Ve(2,P.$zh),Ve(3,L.$8ac),Ve(4,D.$Abc),Ve(5,d.$bM),Ve(6,u.$4i)],f);let i=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(E){if(E.environment.appRoot&&p.a.size){const $=(0,b.$pe)(this.c(E.environment.appRoot.fsPath)),s="[a-z0-9_.-]",a=`@${s}+\\/${s}+|${s}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${$}/${n}\\/)(${a})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const $=this.b.exec(this.c(E));if(!$)return;const[,s,a,n]=$,o=p.a.get(a);if(o!==void 0)return console.warn(`${a} as been renamed to ${o}, please update your imports`),s+o+n}c(E){return E.replace(/\\/g,"/")}};i=p=Ke([Ve(0,d.$bM)],i);class t{constructor(E,$,s,a,n){this.c=E,this.d=$,this.e=s,this.f=a,this.g=n,this.nodeModuleName="vscode",this.a=new l.$Wl}load(E,$){const s=this.d.findSubstr($);if(s){let a=this.a.get(s.identifier);return a||(a=this.c(s,this.e,this.f),this.a.set(s.identifier,a)),a}if(!this.b){let a="";this.d.forEach((n,o)=>a+=`	${o} -> ${n.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${$}. These are the extension path mappings: 
${a}`),this.b=this.c(A.$JF,this.e,this.f)}return this.b}}let c=class{constructor(E,$,s){this.e=E,this.f=$,this.nodeModuleName=["open","opn"],this.d=s.getProxy(C.$VJ.MainThreadTelemetry);const a=s.getProxy(C.$VJ.MainThreadWindow);this.c=(n,o)=>{const y=F.URI.parse(n);return o?this.g(n,o):y.scheme==="http"||y.scheme==="https"?a.$openUri(y,n,{allowTunneling:!0}):y.scheme==="mailto"||y.scheme===this.f?a.$openUri(y,n,{}):this.g(n,o)}}load(E,$,s){const a=this.e.findSubstr($);return a&&(this.a=a.identifier.value,this.h()),this.b=s(E),this.c}g(E,$){return this.i(),this.b(E,$)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};c=Ke([Ve(2,S.$XL)],c)}),define(Ae[113],Re([1,0,65,6,19,74,4,59,60,35,7,33,201,34]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0,e.$9bc=(0,A.$Ah)("IExtHostVariableResolverProvider");class p extends u.$YM{constructor(t,c,g,E,$,s,a){function n(){if(g){const o=g.activeEditor();if(o)return o.document.uri;const y=E.tabGroups.all.find(m=>m.isActive)?.activeTab;if(y!==void 0){if(y.input instanceof P.$EL||y.input instanceof P.$JL)return y.input.modified;if(y.input instanceof P.$DL||y.input instanceof P.$IL||y.input instanceof P.$GL)return y.input.uri}}}super({getFolderUri:o=>{const y=s.folders.filter(m=>m.name===o);if(y&&y.length>0)return y[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(o,y)=>$.getConfiguration(void 0,o).get(y),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=n();if(o)return C.$6d(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const o=n();if(o){const y=c.getWorkspaceFolder(o);if(y)return C.$6d(y.uri.fsPath)}}},getSelectedText:()=>{if(g){const o=g.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(g){const o=g.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>t.getExtension(o)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(L.env))}}let f=class extends F.$jc{constructor(t,c,g,E,$){super(),this.b=t,this.c=c,this.g=g,this.h=E,this.j=$,this.a=new w.$T(async()=>{const s=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,s,n,this.m())})}getResolver(){return this.a.value}m(){}};e.$0bc=f,e.$0bc=f=Ke([Ve(0,d.$Abc),Ve(1,D.$5ac),Ve(2,l.$9L),Ve(3,b.$8ac),Ve(4,S.$7bc)],f)}),define(Ae[114],Re([1,0,13,5,2,4,3,60,35,17,7,33,194,196,34,113]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=e.$acc=e.$_bc=e.$$bc=void 0,e.$$bc=(0,L.$Ah)("IExtHostDebugService");let i=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,n,o,y,m,I){this.E=n,this.F=o,this.G=y,this.H=m,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$ed,this.n=new F.$ed,this.o=new F.$ed,this.u=new F.$ed,this.k=a.getProxy(A.$VJ.MainThreadDebugService),this.y=new F.$ed,this.A=new F.$ed,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(r=>{this.J(k)}),this.J(k)})}asDebugSourceUri(a,n){const o=a;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let y=`debug:${encodeURIComponent(o.path||"")}`,m="?";return n&&(y+=`${m}session=${encodeURIComponent(n.id)}`,m="&"),y+=`${m}ref=${o.sourceReference}`,C.URI.parse(y)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(a){const n=[];for(const o of a.getAllExtensionDescriptions())if(o.contributes){const y=o.contributes.debuggers;if(y&&y.length>0)for(const m of y)(0,b.$lF)(m)&&n.push(m.type)}this.k.$registerDebugTypes(n)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const a=[];return this.w.forEach(n=>a.push(n)),a}addBreakpoints(a){const n=a.filter(m=>{const I=m.id;return this.w.has(I)?!1:(this.w.set(I,m),!0)});this.U(n,[],[]);const o=[],y=new Map;for(const m of n)if(m instanceof P.$XK){let I=y.get(m.location.uri.toString());I||(I={type:"sourceMulti",uri:m.location.uri,lines:[]},y.set(m.location.uri.toString(),I),o.push(I)),I.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof P.$YK&&o.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(a){const n=a.filter(I=>this.w.delete(I.id));this.U([],n,[]);const o=n.filter(I=>I instanceof P.$XK).map(I=>I.id),y=n.filter(I=>I instanceof P.$YK).map(I=>I.id),m=n.filter(I=>I instanceof P.$ZK).map(I=>I.id);return this.k.$unregisterBreakpoints(o,y,m)}startDebugging(a,n,o){return this.k.$startDebugging(a?a.uri:void 0,n,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,n,o){if(!n)return new P.$XJ(()=>{});const y=this.d++;return this.f.push({type:a,handle:y,provider:n}),this.k.$registerDebugConfigurationProvider(a,o,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,y),new P.$XJ(()=>{this.f=this.f.filter(m=>m.provider!==n),this.k.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory(a,n,o){if(!o)return new P.$XJ(()=>{});if(!this.Q(a,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.N(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:n,handle:y,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(n,y),new P.$XJ(()=>{this.h=this.h.filter(m=>m.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory(a,n){if(!n)return new P.$XJ(()=>{});const o=this.i++;return this.j.push({type:a,handle:o,factory:n}),new P.$XJ(()=>{this.j=this.j.filter(y=>y.factory!==n)})}async $runInTerminal(a,n){return Promise.resolve(void 0)}async $substituteVariables(a,n){let o;const y=await this.W(a);return y&&(o={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,n)}K(a,n){if(a.type==="implementation")return new E(a.implementation)}L(){}async $startDASession(a,n){const o=this,y=await this.V(n);return this.S(this.N(y.type),y).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const I=this.M(m),k=this.K(I,y);if(!k)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const r=k;return this.B.set(a,r),this.R(y).then(h=>(h&&this.C.set(a,h),r.onMessage(async v=>{if(v.type==="request"&&v.command==="handshake"){const R=v,W={type:"response",seq:0,command:R.command,request_seq:R.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(R.arguments.value);W.body={signature:V},r.sendResponse(W)}else throw new Error("no signer")}catch(V){W.success=!1,W.message=V.message,r.sendResponse(W)}}else h&&h.onDidSendMessage&&h.onDidSendMessage(v),v=(0,b.$qF)(v,!0),o.k.$acceptDAMessage(a,v)}),r.onError(v=>{h&&h.onError&&h.onError(v),this.k.$acceptDAError(a,v.name,v.message,v.stack)}),r.onExit(v=>{h&&h.onExit&&h.onExit(v??void 0,void 0),this.k.$acceptDAExit(a,v??void 0,void 0)}),h&&h.onWillStartSession&&h.onWillStartSession(),r.startSession()))})}$sendDAMessage(a,n){n=(0,b.$pF)(n,!1);const o=this.C.get(a);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(n),this.B.get(a)?.sendMessage(n)}$stopDASession(a){const n=this.C.get(a);this.C.delete(a),n&&n.onWillStopSession&&n.onWillStopSession();const o=this.B.get(a);return this.B.delete(a),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const n=[],o=[],y=[];if(a.added)for(const m of a.added){const I=m.id;if(I&&!this.w.has(I)){let k;if(m.type==="function")k=new P.$YK(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")k=new P.$ZK(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const r=C.URI.revive(m.uri);k=new P.$XK(new P.$0J(r,new P.$YJ(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,P.$VK)(k,I),this.w.set(I,k),n.push(k)}}if(a.removed)for(const m of a.removed){const I=this.w.get(m);I&&(this.w.delete(m),o.push(I))}if(a.changed){for(const m of a.changed)if(m.id){const I=this.w.get(m.id);if(I){if(I instanceof P.$YK&&m.type==="function"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.functionName=m.functionName}else if(I instanceof P.$XK&&m.type==="source"){const k=I;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.location=new P.$0J(C.URI.revive(m.uri),new P.$YJ(m.line,m.character))}y.push(I)}}}this.U(n,o,y)}async $acceptStackFrameFocus(a){let n;const o=a.sessionId?await this.V(a.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");a.kind==="thread"?n=new P.$6K(o,a.threadId):n=new P.$5K(o,a.threadId,a.frameId),this.z=n,this.A.fire(this.z)}$provideDebugConfigurations(a,n,o){return(0,w.$yg)(async()=>{const y=this.P(a);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(n);return y.provideDebugConfigurations(m,o)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration(a,n,o,y){return(0,w.$yg)(async()=>{const m=this.P(a);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(n);return m.resolveDebugConfiguration(I,o,y)})}$resolveDebugConfigurationWithSubstitutedVariables(a,n,o,y){return(0,w.$yg)(async()=>{const m=this.P(a);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(n);return m.resolveDebugConfigurationWithSubstitutedVariables(I,o,y)})}async $provideDebugAdapter(a,n){const o=this.O(a);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.V(n);return this.S(o,y).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(a){const n=await this.V(a);this.m.fire(n)}async $acceptDebugSessionTerminated(a){const n=await this.V(a);n&&(this.n.fire(n),this.l.delete(n.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,n){(await this.V(a))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(a,n){const y={session:await this.V(a),event:n.event,body:n.body};this.u.fire(y)}M(a){if(a instanceof P.$1K)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.$2K)return{type:"server",port:a.port,host:a.host};if(a instanceof P.$3K)return{type:"pipeServer",path:a.path};if(a instanceof P.$4K)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}N(a){const n=this.h.filter(o=>o.type===a);if(n.length>0)return n[0].factory}O(a){const n=this.h.filter(o=>o.handle===a);if(n.length>0)return n[0].factory}P(a){const n=this.f.filter(o=>o.handle===a);if(n.length>0)return n[0].provider}Q(a,n){if(a.contributes){const o=a.contributes.debuggers;if(o&&o.length>0){for(const y of o)if(y.label&&y.type&&y.type===n)return!0}}return!1}R(a){const o=a.configuration.type,y=this.j.filter(m=>m.type===o||m.type==="*").map(m=>(0,w.$yg)(()=>m.factory.createDebugAdapterTracker(a)).then(I=>I,I=>null));return Promise.race([Promise.all(y).then(m=>{const I=m.filter(k=>!!k);if(I.length>0)return new g(I)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(a,n){const o=n.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new P.$2K(o));if(a){const m=await this.F.getExtensionRegistry();return(0,w.$yg)(()=>a.createDebugAdapterDescriptor(n,this.T(n,m))).then(I=>{if(I)return I})}const y=await this.F.getExtensionRegistry();return Promise.resolve(this.T(n,y))}T(a,n){}U(a,n,o){(a.length>0||n.length>0||o.length>0)&&this.y.fire(Object.freeze({added:a,removed:n,changed:o}))}async V(a){if(a)if(typeof a=="string"){const n=this.l.get(a);if(n)return n}else{let n=this.l.get(a.id);if(!n){const o=await this.W(a.folderUri),y=a.parent?this.l.get(a.parent):void 0;n=new t(this.k,a.id,a.type,a.name,o,a.configuration,y),this.l.set(n.id,n),this.k.$sessionCached(n.id)}return n}throw new Error("cannot find session")}W(a){if(a){const n=C.URI.revive(a);return this.E.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};e.$_bc=i,e.$_bc=i=Ke([Ve(0,d.$XL),Ve(1,D.$5ac),Ve(2,S.$Abc),Ve(3,p.$8ac),Ve(4,l.$7bc),Ve(5,f.$9bc)],i);class t{constructor(a,n,o,y,m,I,k){this.d=a,this.f=n,this.g=o,this.h=y,this.i=m,this.j=I,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,n){return this.d.$customDebugAdapterRequest(this.f,a,n)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.$acc=t;class c{constructor(a){this.value=Object.freeze({append(n){a.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.$bcc=c;class g{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(n=>n.onError?n.onError(a):void 0)}onExit(a,n){this.d.forEach(o=>o.onExit?o.onExit(a,n):void 0)}}class E extends u.$ucb{constructor(a){super(),this.h=a,a.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let $=class extends i{constructor(a,n,o,y,m,I){super(a,n,o,y,m,I)}};e.$ccc=$,e.$ccc=$=Ke([Ve(0,d.$XL),Ve(1,D.$5ac),Ve(2,S.$Abc),Ve(3,p.$8ac),Ve(4,l.$7bc),Ve(5,f.$9bc)],$)}),define(Ae[270],Re([1,0,9,87,2,3,261,14,70,71,27,173,17,55,35,57]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=void 0;class i{static async installEarlyHandler(g){Error.stackTraceLimit=100;const E=g.get(l.$4i),s=g.get(u.$XL).getProxy(L.$VJ.MainThreadErrors);w.setUnexpectedErrorHandler(a=>{E.error(a);const n=w.$1(a);s.$onUnexpectedError(n)})}static async installFullHandler(g){const E=g.get(l.$4i),$=g.get(u.$XL),s=g.get(p.$Abc),a=g.get(f.$fM),n=$.getProxy(L.$VJ.MainThreadExtensionService),o=$.getProxy(L.$VJ.MainThreadErrors),y=await s.getExtensionPathIndex(),m=new WeakMap;function I(h,v){if(m.has(h))return m.get(h).stack;let R="",W,V;for(const B of v)R+=`
	at ${B.toString()}`,V=B.getFileName(),!W&&V&&(W=y.findSubstr(C.URI.file(V)));const U=`${h.name||"Error"}: ${h.message||""}${R}`;return m.set(h,{extensionIdentifier:W?.identifier,stack:U}),U}const k=Symbol("prepareStackTrace wrapped");let r=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return r},set(h){if(h===I||!h||h[k]){r=h||I;return}r=function(v,R){return I(v,R),h.call(Error,v,R)},Object.assign(r,{[k]:!0})}}),w.setUnexpectedErrorHandler(h=>{E.error(h);const v=w.$1(h),R=m.get(h);if(!R?.extensionIdentifier){o.$onUnexpectedError(v);return}n.$onExtensionRuntimeError(R.extensionIdentifier,v);const W=a.onExtensionError(R.extensionIdentifier,h);E.trace("forwarded error to extension?",W,R)})}}e.$Zcc=i;class t{constructor(g,E,$,s,a){this.a=$,this.b=new A.$r3b(g,null,s),E=t.e(E,this.b);const n=new d.$yh(...(0,S.$mr)());n.set(P.$bM,{_serviceBrand:void 0,...E,messagePorts:a}),n.set(u.$XL,new u.$YL(this.b)),n.set(b.$2ac,new b.$3ac(s)),n.set(p.$ybc,$);const o=new D.$5p(n,!0);o.invokeFunction(i.installEarlyHandler),this.d=o.invokeFunction(y=>y.get(l.$4i)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=o.invokeFunction(y=>y.get(p.$Abc)),this.c.initialize(),o.invokeFunction(i.installFullHandler)}async asBrowserUri(g){const E=this.b.getProxy(L.$VJ.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri(g))}terminate(g){this.c.terminate(g)}static e(g,E){g.extensions.allExtensions.forEach(s=>{s.extensionLocation=C.URI.revive(E.transformIncomingURIs(s.extensionLocation))}),g.environment.appRoot=C.URI.revive(E.transformIncomingURIs(g.environment.appRoot));const $=g.environment.extensionDevelopmentLocationURI;return $&&(g.environment.extensionDevelopmentLocationURI=$.map(s=>C.URI.revive(E.transformIncomingURIs(s)))),g.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs(g.environment.workspaceStorageHome)),g.environment.extensionTelemetryLogResource=C.URI.revive(E.transformIncomingURIs(g.environment.extensionTelemetryLogResource)),g.nlsBaseUrl=C.URI.revive(E.transformIncomingURIs(g.nlsBaseUrl)),g.logsLocation=C.URI.revive(E.transformIncomingURIs(g.logsLocation)),g.workspace=E.transformIncomingURIs(g.workspace),g}}e.$1cc=t}),define(Ae[271],Re([1,0,18,13,21,41,12,19,23,2,47]),function(be,e,w,F,C,L,A,l,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=e.$fcc=e.$ecc=void 0;class D{constructor(c,g,E,$){this.d=c,this.e=g,this.f=E,this.g=$,this.a=null,this.b=!1,this.c=0}search(c,g){const E=this.d.folderQueries||[],$=new C.$od(g);return new Promise((s,a)=>{this.a=new b(c);let n=!1;const o=(y,m)=>{if(!n&&!this.b){const I=this.h(y);f(y)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,n=!0,$.cancel(),y=this.j(y,this.d.maxResults-this.c));const k=this.h(y);this.c+=k,(k>0||!f(y))&&this.a.add(y,m)}};Promise.all(E.map((y,m)=>this.k(y,I=>o(I,m),$.token))).then(y=>{$.dispose(),this.a.flush();const m=y.some(I=>!!I&&!!I.limitHit);s({limitHit:this.b||m,messages:(0,w.$Ob)(y.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},y=>{$.dispose();const m=(0,L.$li)(y);a(new Error(m))})})}h(c){return f(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,g){const E=Array.isArray(c.ranges)?c.ranges:[c.ranges],$=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:E.slice(0,g),preview:{matches:$.slice(0,g),text:c.preview.text},uri:c.uri}}async k(c,g,E){const $=new P.$AI(this.d,c),s=[],a={report:y=>{if(!this.l(y))return;const m=c.folder.scheme===A.Schemas.file?(0,P.$BI)(()=>this.f.readdir(S.$gg(y.uri))):void 0,I=S.$jg(c.folder,y.uri);if(I){const k=$.includedInQuery(I,l.$_d(I),m);(0,F.$sg)(k)?s.push(k.then(r=>{r&&g(y)})):k&&g(y)}}},n=this.n(c),o=await this.e.provideTextSearchResults(u(this.d.contentPattern),n,a,E);return s.length&&await Promise.all(s),o}l(c){if(f(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const g=(0,P.$zI)(this.d.includePattern,c.includePattern),E=(0,P.$zI)(this.d.excludePattern,c.excludePattern),$={folder:d.URI.from(c.folder),excludes:E,includes:g,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return $.usePCRE2=this.d.usePCRE2,$}}e.$ecc=D;function u(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class b{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new i(512,g=>this.g(g))}add(c,g){this.d&&(this.b!==g||!S.$ag(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=g,this.d={resource:c.uri,results:[]}),this.d.results.push(p(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$fcc=b;function p(t){return f(t)?{preview:{matches:(0,w.$Yb)(t.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:t.preview.text},ranges:(0,w.$Yb)(t.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function f(t){return!!t.preview}e.$gcc=f;class i{static{this.a=4e3}static{this.b=50}constructor(c,g){this.g=c,this.h=g,this.c=0,this.d=[],this.e=0}addItem(c,g){c&&this.j(c,g)}addItems(c,g){c&&this.k(c,g)}j(c,g){this.d.push(c),this.e+=g,this.l()}k(c,g){this.d=this.d.concat(c),this.e+=g,this.l()}l(){this.c<i.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},i.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$hcc=i}),define(Ae[115],Re([1,0,6,3,4,266,17,55,14,2,271]),function(be,e,w,F,C,L,A,l,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=e.$jcc=e.$icc=void 0,e.$icc=(0,C.$Ah)("IExtHostSearch");let D=class{constructor(f,i,t){this.k=f,this.l=i,this.n=t,this.c=this.k.getProxy(F.$VJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$dcc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,i){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const t=this.d++;return this.e.set(t,i),this.c.$registerTextSearchProvider(t,this.o(f)),(0,w.$hc)(()=>{this.g.delete(f),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(f,i){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const t=this.d++;return this.h.set(t,i),this.c.$registerFileSearchProvider(t,this.o(f)),(0,w.$hc)(()=>{this.i.delete(f),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(f,i,t,c){const g=u(t),E=this.h.get(f);if(E)return this.j.fileSearch(g,E,$=>{this.c.$handleFileMatch(f,i,$.map(s=>s.resource))},c);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,i,t,c){const g=this.e.get(f);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const E=u(t);return this.q(E,g).search(s=>this.c.$handleTextMatch(f,i,s),c)}$enableExtensionHostSearch(){}q(f,i){return new P.$ecc(f,i,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$jcc=D,e.$jcc=D=Ke([Ve(0,A.$XL),Ve(1,l.$2ac),Ve(2,S.$4i)],D);function u(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(f=>d.URI.revive(f))}}e.$kcc=u;function b(p){return{...p,folder:d.URI.revive(p.folder)}}}),define(Ae[272],Re([1,0,21,9,5,29,2,136,283,125,134,38,3,79,225,224,31,226,34,228,229,230,204,231,59,35,233,234,239,240,242,110,208,248,249,251,84,62,253,211,8,7,52,256,63,109,33,20,199,238,51,108,112,114,115,14,55,17,27,243,197,86,80,218,254,85,61,259,257,258,219,39,252,255,83,60,57,244,111,245,12,95,207,190,236,6,26,195,81,186,246,247,220,235,206,237,82,250,221,222,223,217,232]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E,$,s,a,n,o,y,m,I,k,r,h,v,R,W,V,U,B,O,N,ee,Y,Ee,ke,Pe,Z,ue,ye,ce,$e,ie,z,q,le,we,ve,me,De,ne,he,se,oe,fe,Ie,M,K,G,X,J,x,ae,Le,je,Xe,He,et,Ze,_e,it,tt,ze,st,_,Q,pe,Ue,Ne,Qe,nt,gt,vt,Mt,Qt,Vt,wt,Tt,Ot,Jt,Pt,At,Nt,Ut,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;function Bt(at){const ut=at.get(ne.$bM),Ht=at.get(Le.$Rac),Ct=at.get(G.$kbc),kt=at.get(o.$Abc),ht=at.get(ue.$5ac),St=at.get(Ze.$fM),Lt=at.get(c.$8ac),Et=at.get(me.$2ac),qe=at.get(De.$XL),zt=at.get(U.$gbc),Ce=at.get(K.$lbc),Fe=at.get(ve.$5i),ge=at.get(ve.$4i),H=at.get(oe.$jsb),Me=at.get(fe.$Uac),Be=at.get(Z.$Ybc),Ge=at.get(He.$sbc),We=at.get(et.$7bc),xe=at.get(Ot.$wbc);qe.set(u.$WJ.ExtHostFileSystemInfo,Ht),qe.set(u.$WJ.ExtHostLogLevelServiceShape,Fe),qe.set(u.$WJ.ExtHostWorkspace,ht),qe.set(u.$WJ.ExtHostConfiguration,Lt),qe.set(u.$WJ.ExtHostExtensionService,kt),qe.set(u.$WJ.ExtHostStorage,zt),qe.set(u.$WJ.ExtHostTunnelService,H),qe.set(u.$WJ.ExtHostWindow,Be),qe.set(u.$WJ.ExtHostSecretState,Ge),qe.set(u.$WJ.ExtHostTelemetry,St),qe.set(u.$WJ.ExtHostEditorTabs,We),qe.set(u.$WJ.ExtHostManagedSockets,xe);const pt=qe.set(u.$WJ.ExtHostDecorations,at.get(z.$3bc)),bt=qe.set(u.$WJ.ExtHostDocumentsAndEditors,at.get(n.$9L)),dt=qe.set(u.$WJ.ExtHostCommands,at.get(i.$hM)),ft=qe.set(u.$WJ.ExtHostTerminalService,at.get(B.$nbc)),mt=qe.set(u.$WJ.ExtHostDebugService,at.get(le.$$bc)),gi=qe.set(u.$WJ.ExtHostSearch,at.get(we.$icc)),Kt=qe.set(u.$WJ.ExtHostTask,at.get(q.$6bc)),Ei=qe.set(u.$WJ.ExtHostOutputService,at.get(h.$Ibc)),Wt=qe.set(u.$WJ.ExtHostLocalization,at.get(nt.$vbc)),mi=qe.set(u.$WJ.ExtHostUrls,new ke.$Rbc(qe)),It=qe.set(u.$WJ.ExtHostDocuments,new a.$Pac(qe,bt)),ki=qe.set(u.$WJ.ExtHostDocumentContentProviders,new $.$0ac(qe,bt,ge)),Vi=qe.set(u.$WJ.ExtHostDocumentSaveParticipant,new s.$$ac(ge,It,qe.getProxy(u.$VJ.MainThreadBulkEdits))),Dt=qe.set(u.$WJ.ExtHostNotebook,new he.$occ(qe,dt,bt,It,Ct)),ti=qe.set(u.$WJ.ExtHostNotebookDocuments,new Q.$Gcc(Dt)),$i=qe.set(u.$WJ.ExtHostNotebookEditors,new _.$Fcc(ge,Dt)),si=qe.set(u.$WJ.ExtHostNotebookKernels,new _e.$Ccc(qe,ut,Dt,dt,ge)),Di=qe.set(u.$WJ.ExtHostNotebookRenderers,new tt.$Ecc(qe,Dt)),Si=qe.set(u.$WJ.ExtHostNotebookDocumentSaveParticipant,new wt.$Mcc(ge,Dt,qe.getProxy(u.$VJ.MainThreadBulkEdits))),Rt=qe.set(u.$WJ.ExtHostEditors,new O.$Pbc(qe,bt)),pi=qe.set(u.$WJ.ExtHostTreeViews,new N.$Qbc(qe.getProxy(u.$VJ.MainThreadTreeViews),dt,ge)),Ii=qe.set(u.$WJ.ExtHostEditorInsets,new ce.$Zbc(qe.getProxy(u.$VJ.MainThreadEditorInsets),Rt,ut.remote)),oi=qe.set(u.$WJ.ExtHostDiagnostics,new g.$Tac(qe,ge,Ht,bt)),ai=qe.set(u.$WJ.ExtHostLanguages,new k.$Fbc(qe,It,dt.converter,Et)),ct=qe.set(u.$WJ.ExtHostLanguageFeatures,new I.$Xac(qe,Et,It,dt,oi,ge,Me,St)),qi=qe.set(u.$WJ.ExtHostFileSystem,new y.$Dbc(qe,ct)),Yt=qe.set(u.$WJ.ExtHostFileSystemEventService,new m.$Ebc(qe,ge,bt)),ii=qe.set(u.$WJ.ExtHostQuickOpen,(0,R.$Kbc)(qe,ht,dt)),bi=qe.set(u.$WJ.ExtHostSCM,new W.$Mbc(qe,dt,It,ge)),Ci=qe.set(u.$WJ.ExtHostQuickDiff,new Mt.$Jcc(qe,Et)),Ki=qe.set(u.$WJ.ExtHostShare,new Jt.$Occ(qe,Et)),Pi=qe.set(u.$WJ.ExtHostComments,(0,t.$1ac)(qe,dt,It)),vi=qe.set(u.$WJ.ExtHostProgress,new v.$Jbc(qe.getProxy(u.$VJ.MainThreadProgress))),Ji=qe.set(u.$WJ.ExtHosLabelService,new $e.$1bc(qe)),Ai=qe.set(u.$WJ.ExtHostTheming,new se.$pcc(qe)),ci=qe.set(u.$WJ.ExtHostAuthentication,new Ie.$qcc(qe)),Hi=qe.set(u.$WJ.ExtHostTimeline,new M.$scc(qe,dt)),wi=qe.set(u.$WJ.ExtHostWebviews,new Pe.$Ubc(qe,ut.remote,ht,ge,Me)),Ri=qe.set(u.$WJ.ExtHostWebviewPanels,new x.$ucc(qe,wi,ht)),cn=qe.set(u.$WJ.ExtHostCustomEditors,new J.$vcc(qe,It,Ce,wi,Ri)),Fi=qe.set(u.$WJ.ExtHostWebviewViews,new X.$tcc(qe,wi)),ni=qe.set(u.$WJ.ExtHostTesting,new je.$xcc(qe,dt,bt)),un=qe.set(u.$WJ.ExtHostUriOpeners,new Xe.$Bcc(qe)),ln=qe.set(u.$WJ.ExtHostProfileContentHandlers,new vt.$Icc(qe));qe.set(u.$WJ.ExtHostInteractive,new pe.$Hcc(qe,Dt,bt,dt,ge));const Gi=qe.set(u.$WJ.ExtHostInlineChat,new Vt.$Lcc(qe,dt,It,ge)),fi=qe.set(u.$WJ.ExtHostChatProvider,new Pt.$Pcc(qe,ge)),Xi=qe.set(u.$WJ.ExtHostChatSlashCommands,new At.$Qcc(qe,fi,ge)),Qi=qe.set(u.$WJ.ExtHostChatVariables,new Nt.$Rcc(qe)),ui=qe.set(u.$WJ.ExtHostChat,new Qt.$Kcc(qe,ge)),Yi=qe.set(u.$WJ.ExtHostAiRelatedInformation,new Ut.$Scc(qe)),Mi=qe.set(u.$WJ.ExtHostAiEmbeddingVector,new qt.$Tcc(qe)),Zi=qe.set(u.$WJ.ExtHostIssueReporter,new Tt.$Ncc(qe)),Zt=qe.set(u.$WJ.ExtHostStatusBar,new V.$Obc(qe,dt.converter)),yi=Object.values(u.$WJ);qe.assertRegistered(yi);const hn=new ae.$wcc(qe,bt),Gt=new f.$Zac(qe),li=new r.$Gbc(qe,ge),Ti=new E.$9ac(qe);return p.$Yac.register(dt),function(Oe,_t,Li){const $t=function(){let te=!Oe.isUnderDevelopment;function de(){te||(ge.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")de();else{const yt=rt;typeof yt.scheme>"u"&&de(),typeof yt.exclusive=="boolean"&&(0,Ne.$PF)(Oe,"documentFiltersExclusive")}return rt}}(),_i={getSession(te,de,Te){return ci.getSession(Oe,te,de,Te)},getSessions(te,de){return(0,Ne.$PF)(Oe,"authGetSessions"),ci.getSessions(Oe,te,de)},async hasSession(te,de){return(0,Ne.$PF)(Oe,"authSession"),!!await ci.getSession(Oe,te,de,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(te,de,Te,rt){return ci.registerAuthenticationProvider(te,de,Te,rt)}},xi={registerCommand(te,de,Te){return dt.registerCommand(!0,te,de,Te,void 0,Oe)},registerTextEditorCommand(te,de,Te){return dt.registerCommand(!0,te,(...rt)=>{const yt=Rt.getActiveTextEditor();if(!yt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}return yt.edit(Ft=>{de.apply(Te,[yt,Ft,...rt])}).then(Ft=>{Ft||ge.warn("Edits from command "+te+" were not applied.")},Ft=>{ge.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,Oe)},registerDiffInformationCommand:(te,de,Te)=>((0,Ne.$PF)(Oe,"diffCommand"),dt.registerCommand(!0,te,async(...rt)=>{const yt=bt.activeEditor(!0);if(!yt){ge.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await Rt.getDiffInformation(yt.id);de.apply(Te,[Ft,...rt])},void 0,void 0,Oe)),executeCommand(te,...de){return dt.executeCommand(te,...de)},getCommands(te=!1){return dt.getCommands(te)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return ft.getDefaultShell(!1)},get onDidChangeShell(){return ft.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ne.$PF)(Oe,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ne.$PF)(Oe,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ze.$eM)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,de){return Ze.$dM.validateSender(te),St.instantiateLogger(Oe,te,de)},openExternal(te,de){return Be.openUri(te,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ut.environment.appUriScheme)return mi.createAppUri(te);try{return await Be.asExternalUri(te,{allowTunneling:!!ut.remote.authority})}catch(de){if((0,st.$GT)(te,ze.Schemas.http)||(0,st.$GT)(te,ze.Schemas.https))return te;throw de}},get remoteName(){return(0,ie.$Ok)(ut.remote.authority)},get remoteAuthority(){return(0,Ne.$PF)(Oe,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return ge.getLevel()},get onDidChangeLogLevel(){return ge.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Ne.$PF)(Oe,"handleIssueUri"),Zi.registerIssueUriRequestHandler(Oe,te)},get appQuality(){return(0,Ne.$PF)(Oe,"resolvers"),ut.quality},get appCommit(){return(0,Ne.$PF)(Oe,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(te,de,Te){return ni.createTestController(Oe,te,de,Te)},createTestObserver(){return(0,Ne.$PF)(Oe,"testObserver"),ni.createTestObserver()},runTests(te){return(0,Ne.$PF)(Oe,"testObserver"),ni.runTests(te)},get onDidChangeTestResults(){return(0,Ne.$PF)(Oe,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Ne.$PF)(Oe,"testObserver"),ni.results}},hi=ut.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,tn={getExtension(te,de){(0,Ne.$OF)(Oe,"extensionsAny")||(de=!1);const Te=_t.mine.getExtensionDescription(te);if(Te)return new o.$Bbc(kt,Oe.identifier,Te,hi,!1);if(de){const rt=_t.all.getExtensionDescription(te);if(rt)return new o.$Bbc(kt,Oe.identifier,rt,hi,!0)}},get all(){const te=[];for(const de of _t.mine.getAllExtensionDescriptions())te.push(new o.$Bbc(kt,Oe.identifier,de,hi,!1));return te},get allAcrossExtensionHosts(){(0,Ne.$PF)(Oe,"extensionsAny");const te=new ye.$Vl(_t.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),de=[];for(const Te of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Te.identifier);de.push(new o.$Bbc(kt,Oe.identifier,Te,hi,rt))}return de},get onDidChange(){return(0,Ne.$OF)(Oe,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Oe.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(te,de){return ai.changeLanguage(te.uri,de)},match(te,de){const Te=It.getDocumentData(de.uri)?.notebook;return(0,P.$bF)(ee.LanguageSelector.from(te),de.uri,de.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,de,Te){return ct.registerCodeActionProvider(Oe,$t(te),de,Te)},registerDocumentPasteEditProvider(te,de,Te){return(0,Ne.$PF)(Oe,"documentPaste"),ct.registerDocumentPasteEditProvider(Oe,$t(te),de,Te)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Oe,$t(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Oe,$t(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Oe,$t(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Oe,$t(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Oe,$t(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Oe,$t(te),de,Oe.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Oe,$t(te),de,Oe.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Oe,$t(te),de,Oe.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Oe,$t(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Oe,$t(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Oe,$t(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Oe,$t(te),de)},registerDocumentSymbolProvider(te,de,Te){return ct.registerDocumentSymbolProvider(Oe,$t(te),de,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Oe,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Oe,$t(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Oe,$t(te),de)},registerOnTypeFormattingEditProvider(te,de,Te,...rt){return ct.registerOnTypeFormattingEditProvider(Oe,$t(te),de,[Te].concat(rt))},registerDocumentSemanticTokensProvider(te,de,Te){return ct.registerDocumentSemanticTokensProvider(Oe,$t(te),de,Te)},registerDocumentRangeSemanticTokensProvider(te,de,Te){return ct.registerDocumentRangeSemanticTokensProvider(Oe,$t(te),de,Te)},registerSignatureHelpProvider(te,de,Te,...rt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Oe,$t(te),de,Te):ct.registerSignatureHelpProvider(Oe,$t(te),de,typeof Te>"u"?[]:[Te,...rt])},registerCompletionItemProvider(te,de,...Te){return ct.registerCompletionItemProvider(Oe,$t(te),de,Te)},registerInlineCompletionItemProvider(te,de,Te){return de.handleDidShowCompletionItem&&(0,Ne.$PF)(Oe,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Ne.$PF)(Oe,"inlineCompletionsAdditions"),Te&&(0,Ne.$PF)(Oe,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Oe,$t(te),de,Te)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Oe,$t(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Oe,$t(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Oe,$t(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Oe,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Oe,te,de)},registerTypeHierarchyProvider(te,de){return ct.registerTypeHierarchyProvider(Oe,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Oe,te,de),getTokenInformationAtPosition(te,de){return(0,Ne.$PF)(Oe,"tokenInformation"),ai.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return ct.registerInlayHintsProvider(Oe,te,de)},createLanguageStatusItem(te,de){return ai.createLanguageStatusItem(Oe,te,de)},registerDocumentDropEditProvider(te,de,Te){return ct.registerDocumentOnDropEditProvider(Oe,te,de,(0,Ne.$OF)(Oe,"dropMetadata")?Te:void 0)}},rn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,de,Te){const rt=await(A.URI.isUri(te)?Promise.resolve(sn.openTextDocument(te)):Promise.resolve(te));return Rt.showTextDocument(rt,de,Te)},createTextEditorDecorationType(te){return Rt.createTextEditorDecorationType(Oe,te)},onDidChangeActiveTextEditor(te,de,Te){return Rt.onDidChangeActiveTextEditor(te,de,Te)},onDidChangeVisibleTextEditors(te,de,Te){return Rt.onDidChangeVisibleTextEditors(te,de,Te)},onDidChangeTextEditorSelection(te,de,Te){return Rt.onDidChangeTextEditorSelection(te,de,Te)},onDidChangeTextEditorOptions(te,de,Te){return Rt.onDidChangeTextEditorOptions(te,de,Te)},onDidChangeTextEditorVisibleRanges(te,de,Te){return Rt.onDidChangeTextEditorVisibleRanges(te,de,Te)},onDidChangeTextEditorViewColumn(te,de,Te){return Rt.onDidChangeTextEditorViewColumn(te,de,Te)},onDidCloseTerminal(te,de,Te){return ft.onDidCloseTerminal(te,de,Te)},onDidOpenTerminal(te,de,Te){return ft.onDidOpenTerminal(te,de,Te)},onDidChangeActiveTerminal(te,de,Te){return ft.onDidChangeActiveTerminal(te,de,Te)},onDidChangeTerminalDimensions(te,de,Te){return(0,Ne.$PF)(Oe,"terminalDimensions"),ft.onDidChangeTerminalDimensions(te,de,Te)},onDidChangeTerminalState(te,de,Te){return ft.onDidChangeTerminalState(te,de,Te)},onDidWriteTerminalData(te,de,Te){return(0,Ne.$PF)(Oe,"terminalDataWriteEvent"),ft.onDidWriteTerminalData(te,de,Te)},onDidExecuteTerminalCommand(te,de,Te){return(0,Ne.$PF)(Oe,"terminalExecuteCommandEvent"),ft.onDidExecuteTerminalCommand(te,de,Te)},get state(){return Be.getState(Oe)},onDidChangeWindowState(te,de,Te){return Be.onDidChangeWindowState(te,de,Te)},showInformationMessage(te,...de){return li.showMessage(Oe,L.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return li.showMessage(Oe,L.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return li.showMessage(Oe,L.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Te){return ii.showQuickPick(Oe,te,de,Te)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,de){return ii.showInput(te,de)},showOpenDialog(te){return Ti.showOpenDialog(Oe,te)},showSaveDialog(te){return Ti.showSaveDialog(te)},createStatusBarItem(te,de,Te){let rt,yt,Ft;return typeof te=="string"?(rt=te,yt=de,Ft=Te):(yt=te,Ft=de),Zt.createStatusBarEntry(Oe,rt,yt,Ft)},setStatusBarMessage(te,de){return Zt.setStatusBarMessage(te,de)},withScmProgress(te){return Me.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),vi.withProgress(Oe,{location:Y.ProgressLocation.SourceControl},(de,Te)=>te({report(rt){}}))},withProgress(te,de){return vi.withProgress(Oe,te,de)},createOutputChannel(te,de){return Ei.createOutputChannel(te,de,Oe)},createWebviewPanel(te,de,Te,rt){return Ri.createWebviewPanel(Oe,te,de,Te,rt)},createWebviewTextEditorInset(te,de,Te,rt){return(0,Ne.$PF)(Oe,"editorInsets"),Ii.createWebviewEditorInset(te,de,Te,rt,Oe)},createTerminal(te,de,Te){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):ft.createTerminalFromOptions(te):ft.createTerminal(te,de,Te)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTerminalProfileProvider(te,de){return ft.registerProfileProvider(Oe,te,de)},registerTerminalQuickFixProvider(te,de){return(0,Ne.$PF)(Oe,"terminalQuickFixProvider"),ft.registerTerminalQuickFixProvider(te,Oe.identifier.value,de)},registerTreeDataProvider(te,de){return pi.registerTreeDataProvider(te,de,Oe)},createTreeView(te,de){return pi.createTreeView(te,de,Oe)},registerWebviewPanelSerializer:(te,de)=>Ri.registerWebviewPanelSerializer(Oe,te,de),registerCustomEditorProvider:(te,de,Te={})=>cn.registerCustomEditorProvider(Oe,te,de,Te),registerFileDecorationProvider(te){return pt.registerFileDecorationProvider(te,Oe)},registerUriHandler(te){return mi.registerUriHandler(Oe,te)},createQuickPick(){return ii.createQuickPick(Oe)},createInputBox(){return ii.createInputBox(Oe)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(te,de,Te){return Ai.onDidChangeActiveColorTheme(te,de,Te)},registerWebviewViewProvider(te,de,Te){return Fi.registerWebviewViewProvider(Oe,te,de,Te?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Te){return Dt.onDidChangeActiveNotebookEditor(te,de,Te)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Te){return $i.onDidChangeNotebookEditorSelection(te,de,Te)},onDidChangeNotebookEditorVisibleRanges(te,de,Te){return $i.onDidChangeNotebookEditorVisibleRanges(te,de,Te)},showNotebookDocument(te,de){return Dt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Te){return(0,Ne.$PF)(Oe,"externalUriOpener"),un.registerExternalUriOpener(Oe.identifier,te,de,Te)},registerProfileContentHandler(te,de){return(0,Ne.$PF)(Oe,"profileContentHandlers"),ln.registrProfileContentHandler(Oe,te,de)},registerQuickDiffProvider(te,de,Te,rt){return(0,Ne.$PF)(Oe,"quickDiffProvider"),Ci.registerQuickDiffProvider($t(te),de,Te,rt)},get tabGroups(){return We.tabGroups},registerShareProvider(te,de){return(0,Ne.$PF)(Oe,"shareProvider"),Ki.registerShareProvider($t(te),de)}},sn={get rootPath(){return Me.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(te){throw new F.$7("rootPath")},getWorkspaceFolder(te){return ht.getWorkspaceFolder(te)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(te){throw new F.$7("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(te){throw new F.$7("workspaceFile")},updateWorkspaceFolders:(te,de,...Te)=>ht.updateWorkspaceFolders(Oe,te,de||0,...Te),onDidChangeWorkspaceFolders:function(te,de,Te){return ht.onDidChangeWorkspace(te,de,Te)},asRelativePath:(te,de)=>ht.getRelativePath(te,de),findFiles:(te,de,Te,rt)=>ht.findFiles(te,de,Te,Oe.identifier,rt),findTextInFiles:(te,de,Te,rt)=>{(0,Ne.$PF)(Oe,"findTextInFiles");let yt,Ft;return typeof de=="object"?(yt=de,Ft=Te):(yt={},Ft=de,rt=Te),ht.findTextInFiles(te,yt||{},Ft,Oe.identifier,rt)},save:te=>((0,Ne.$PF)(Oe,"saveEditor"),ht.save(te)),saveAs:te=>((0,Ne.$PF)(Oe,"saveEditor"),ht.saveAs(te)),saveAll:te=>ht.saveAll(te),applyEdit(te,de){return hn.applyWorkspaceEdit(te,Oe,de)},createFileSystemWatcher:(te,de,Te,rt)=>Yt.createFileSystemWatcher(ht,Oe,te,de,Te,rt),get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new F.$7("textDocuments")},openTextDocument(te){let de;const Te=te;if(typeof te=="string")de=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))de=Promise.resolve(te);else if(!Te||typeof Te=="object")de=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(rt=>It.ensureDocumentData(rt).then(yt=>yt.document))},onDidOpenTextDocument:(te,de,Te)=>It.onDidAddDocument(te,de,Te),onDidCloseTextDocument:(te,de,Te)=>It.onDidRemoveDocument(te,de,Te),onDidChangeTextDocument:(te,de,Te)=>It.onDidChangeDocument(te,de,Te),onDidSaveTextDocument:(te,de,Te)=>It.onDidSaveDocument(te,de,Te),onWillSaveTextDocument:(te,de,Te)=>Vi.getOnWillSaveTextDocumentEvent(Oe)(te,de,Te),get notebookDocuments(){return Dt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,de){let Te;if(A.URI.isUri(te))Te=te,await Dt.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await Dt.createNotebookDocument({viewType:te,content:de}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,de,Te){return ti.onDidSaveNotebookDocument(te,de,Te)},onDidChangeNotebookDocument(te,de,Te){return ti.onDidChangeNotebookDocument(te,de,Te)},onWillSaveNotebookDocument(te,de,Te){return Si.getOnWillSaveNotebookDocumentEvent(Oe)(te,de,Te)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(te,de,Te,rt){return Dt.registerNotebookSerializer(Oe,te,de,Te,(0,Ne.$OF)(Oe,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,de,Te)=>Li.onDidChangeConfiguration(te,de,Te),getConfiguration(te,de){return de=arguments.length===1?void 0:de,Li.getConfiguration(te,de,Oe)},registerTextDocumentContentProvider(te,de){return ki.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Me.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Oe,te,de)),registerFileSystemProvider(te,de,Te){return(0,Ue.$gc)(qi.registerFileSystemProvider(Oe,te,de,Te),Ct.addFileSystemProvider(te,de,Te))},get fs(){return Ct.value},registerFileSearchProvider:(te,de)=>((0,Ne.$PF)(Oe,"fileSearchProvider"),gi.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Ne.$PF)(Oe,"textSearchProvider"),gi.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Ne.$PF)(Oe,"resolvers"),kt.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Ne.$PF)(Oe,"resolvers"),Ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ne.$PF)(Oe,"resolvers"),kt.getRemoteExecServer(te)),onDidCreateFiles:(te,de,Te)=>Yt.onDidCreateFile(te,de,Te),onDidDeleteFiles:(te,de,Te)=>Yt.onDidDeleteFile(te,de,Te),onDidRenameFiles:(te,de,Te)=>Yt.onDidRenameFile(te,de,Te),onWillCreateFiles:(te,de,Te)=>Yt.getOnWillCreateFileEvent(Oe)(te,de,Te),onWillDeleteFiles:(te,de,Te)=>Yt.getOnWillDeleteFileEvent(Oe)(te,de,Te),onWillRenameFiles:(te,de,Te)=>Yt.getOnWillRenameFileEvent(Oe)(te,de,Te),openTunnel:te=>((0,Ne.$PF)(Oe,"tunnels"),H.openTunnel(Oe,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Ne.$PF)(Oe,"tunnels"),H.getTunnels()},onDidChangeTunnels:(te,de,Te)=>((0,Ne.$PF)(Oe,"tunnels"),H.onDidChangeTunnels(te,de,Te)),registerPortAttributesProvider:(te,de)=>((0,Ne.$PF)(Oe,"portsAttributes"),H.registerPortsAttributesProvider(te,de)),registerTunnelProvider:(te,de)=>((0,Ne.$PF)(Oe,"tunnelFactory"),H.registerTunnelProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Ne.$PF)(Oe,"timeline"),Hi.registerTimelineProvider(te,de,Oe.identifier,dt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:te=>((0,Ne.$PF)(Oe,"workspaceTrust"),ht.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Te)=>ht.onDidGrantWorkspaceTrust(te,de,Te),registerEditSessionIdentityProvider:(te,de)=>((0,Ne.$PF)(Oe,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(te,de)),onWillCreateEditSessionIdentity:(te,de,Te)=>((0,Ne.$PF)(Oe,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(Oe)(te,de,Te)),registerCanonicalUriProvider:(te,de)=>((0,Ne.$PF)(Oe,"canonicalUriProvider"),ht.registerCanonicalUriProvider(te,de)),getCanonicalUri:(te,de,Te)=>((0,Ne.$PF)(Oe,"canonicalUriProvider"),ht.provideCanonicalUri(te,de,Te))},fn={get inputBox(){return Me.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Oe)},createSourceControl(te,de,Te){return bi.createSourceControl(Oe,te,de,Te)}},on={createCommentController(te,de){return Pi.createCommentController(Oe,te,de)}},an={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(te,de,Te){return mt.onDidStartDebugSession(te,de,Te)},onDidTerminateDebugSession(te,de,Te){return mt.onDidTerminateDebugSession(te,de,Te)},onDidChangeActiveDebugSession(te,de,Te){return mt.onDidChangeActiveDebugSession(te,de,Te)},onDidReceiveDebugSessionCustomEvent(te,de,Te){return mt.onDidReceiveDebugSessionCustomEvent(te,de,Te)},onDidChangeBreakpoints(te,de,Te){return mt.onDidChangeBreakpoints(te,de,Te)},onDidChangeStackFrameFocus(te,de,Te){return(0,Ne.$PF)(Oe,"debugFocus"),mt.onDidChangeStackFrameFocus(te,de,Te)},registerDebugConfigurationProvider(te,de,Te){return mt.registerDebugConfigurationProvider(te,de,Te||Qe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return mt.registerDebugAdapterDescriptorFactory(Oe,te,de)},registerDebugAdapterTrackerFactory(te,de){return mt.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?mt.startDebugging(te,de,{parentSession:Te}):mt.startDebugging(te,de,Te||{})},stopDebugging(te){return mt.stopDebugging(te)},addBreakpoints(te){return mt.addBreakpoints(te)},removeBreakpoints(te){return mt.removeBreakpoints(te)},asDebugSourceUri(te,de){return mt.asDebugSourceUri(te,de)}},Oi={registerTaskProvider:(te,de)=>Kt.registerTaskProvider(Oe,te,de),fetchTasks:te=>Kt.fetchTasks(te),executeTask:te=>Kt.executeTask(Oe,te),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(te,de,Te)=>Kt.onDidStartTask(te,de,Te),onDidEndTask:(te,de,Te)=>Kt.onDidEndTask(te,de,Te),onDidStartTaskProcess:(te,de,Te)=>Kt.onDidStartTaskProcess(te,de,Te),onDidEndTaskProcess:(te,de,Te)=>Kt.onDidEndTaskProcess(te,de,Te)},Ni={createNotebookController(te,de,Te,rt,yt){return si.createNotebookController(Oe,te,de,Te,rt,(0,Ne.$OF)(Oe,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(te,de)=>Dt.registerNotebookCellStatusBarItemProvider(Oe,te,de),createRendererMessaging(te){return Di.createRendererMessaging(Oe,te)},createNotebookControllerDetectionTask(te){return(0,Ne.$PF)(Oe,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Oe,te)},registerKernelSourceActionProvider(te,de){return(0,Ne.$PF)(Oe,"notebookKernelSource"),si.registerKernelSourceActionProvider(Oe,te,de)},onDidChangeNotebookCellExecutionState(te,de,Te){return(0,Ne.$PF)(Oe,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,de,Te)}},zi={t(...te){if(typeof te[0]=="string"){const de=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return Wt.getMessage(Oe.identifier.value,{message:de,args:Te})}return Wt.getMessage(Oe.identifier.value,te[0])},get bundle(){return Wt.getBundle(Oe.identifier.value)},get uri(){return Wt.getBundleUri(Oe.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(te,de){return(0,Ne.$PF)(Oe,"interactive"),Gi.registerProvider(Oe,te,de={label:de?.label??Oe.displayName??Oe.name})},registerInteractiveSessionProvider(te,de){return(0,Ne.$PF)(Oe,"interactive"),ui.registerChatProvider(Oe,te,de)},addInteractiveRequest(te){return(0,Ne.$PF)(Oe,"interactive"),ui.addChatRequest(te)},sendInteractiveRequestToProvider(te,de){return(0,Ne.$PF)(Oe,"interactive"),ui.sendInteractiveRequestToProvider(te,de)},get onDidPerformUserAction(){return(0,Ne.$PF)(Oe,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(te,de){return(0,Ne.$PF)(Oe,"interactive"),ui.transferChatSession(te,de)}},ji={getRelatedInformation(te,de){return(0,Ne.$PF)(Oe,"aiRelatedInformation"),Yi.getRelatedInformation(Oe,te,de)},registerRelatedInformationProvider(te,de){return(0,Ne.$PF)(Oe,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Oe,te,de)},registerEmbeddingVectorProvider(te,de){return(0,Ne.$PF)(Oe,"aiRelatedInformation"),Mi.registerEmbeddingVectorProvider(Oe,te,de)}},Ui={registerChatResponseProvider(te,de,Te){return(0,Ne.$PF)(Oe,"chatProvider"),fi.registerProvider(Oe.identifier,te,de,Te)},registerSlashCommand(te,de,Te){return(0,Ne.$PF)(Oe,"chatSlashCommands"),Xi.registerCommand(Oe.identifier,te,de,Te??{description:""})},requestChatAccess(te){return(0,Ne.$PF)(Oe,"chatRequestAccess"),fi.requestChatResponseProvider(Oe.identifier,te)},registerVariable(te,de,Te){return(0,Ne.$PF)(Oe,"chatVariables"),Qi.registerVariableResolver(Oe,te,de,Te)},registerMappedEditsProvider(te,de){return(0,Ne.$PF)(Oe,"mappedEditsProvider"),ct.registerMappedEditsProvider(Oe,te,de)}};return{version:ut.version,ai:ji,authentication:_i,commands:xi,comments:on,chat:Ui,debug:an,env:en,extensions:tn,interactive:di,l10n:zi,languages:nn,notebooks:Ni,scm:fn,tasks:Oi,tests:dn,window:rn,workspace:sn,Breakpoint:Y.$WK,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatMessage:Y.$ML,ChatMessageRole:Y.ChatMessageRole,ChatVariableLevel:Y.ChatVariableLevel,CallHierarchyIncomingCall:Y.$jK,CallHierarchyItem:Y.$iK,CallHierarchyOutgoingCall:Y.$kK,CancellationError:F.$3,CancellationTokenSource:w.$od,CandidatePortSource:u.CandidatePortSource,CodeAction:Y.$eK,CodeActionKind:Y.$fK,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$lK,Color:Y.$yK,ColorInformation:Y.$zK,ColorPresentation:Y.$AK,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CompletionItem:Y.$sK,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$tK,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$IK,DebugAdapterExecutable:Y.$1K,DebugAdapterInlineImplementation:Y.$4K,DebugAdapterNamedPipeServer:Y.$3K,DebugAdapterServer:Y.$2K,DebugConfigurationProviderTriggerKind:Qe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$_J,DiagnosticRelatedInformation:Y.$$J,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$XJ,DocumentHighlight:Y.$bK,DocumentHighlightKind:Y.DocumentHighlightKind,DocumentLink:Y.$xK,DocumentSymbol:Y.$dK,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$7K,InlineValueText:Y.$8K,InlineValueVariableLookup:Y.$9K,InlineValueEvaluatableExpression:Y.$0K,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:C.$ed,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$hL,FileDecoration2:Y.$hL,FileSystemError:Y.$_K,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:Y.$aL,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$YK,InlineCompletionItem:Y.$uK,InlineCompletionList:Y.$vK,Hover:Y.$aK,IndentAction:d.IndentAction,Location:Y.$0J,MarkdownString:Y.$mK,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:Y.$nK,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$YJ,ProcessExecution:Y.$GK,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$gL,Range:Y.$ZJ,RelativePattern:Y.$UK,Selection:Y.$1J,SelectionRange:Y.$hK,SemanticTokens:Y.$dL,SemanticTokensBuilder:Y.$cL,SemanticTokensEdit:Y.$eL,SemanticTokensEdits:Y.$fL,SemanticTokensLegend:Y.$bL,ShellExecution:Y.$HK,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$pK,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$oK,SnippetString:Y.$9J,SourceBreakpoint:Y.$XK,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$cK,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$JK,TaskGroup:Y.$FK,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$BK,TerminalQuickFixExecuteTerminalCommand:Y.$DK,TerminalQuickFixOpener:Y.$CK,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$EK,TerminalExitReason:Y.TerminalExitReason,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$5J,SnippetTextEdit:Y.$7J,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$TK,ThemeIcon:Y.$SK,TreeItem:Y.$KK,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$CL,UIKind:b.UIKind,Uri:A.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$8J,DocumentDropEdit:Y.$QK,DocumentPasteEdit:Y.$RK,InlayHint:Y.$rK,InlayHintLabelPart:Y.$qK,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$4J,ResolvedAuthority:Y.$2J,ManagedResolvedAuthority:Y.$3J,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$rL,NotebookRange:Y.$jL,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$kL,NotebookData:Y.$lL,NotebookRendererScript:Y.$pL,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$nL,NotebookCellOutputItem:Y.$mL,NotebookCellStatusBarItem:Y.$oL,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$6J,NotebookKernelSourceAction:Y.$qL,PortAttributes:Y.$tL,LinkedEditingRanges:Y.$sL,TestResultState:Y.TestResultState,TestRunRequest:Y.$uL,TestMessage:Y.$vL,TestMessage2:Y.$vL,TestTag:Y.$wL,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Y.$PK,DataTransferItem:Y.$LK,CoveredCount:Y.$xL,FileCoverage:Y.$yL,StatementCoverage:Y.$zL,BranchCoverage:Y.$AL,FunctionCoverage:Y.$BL,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$DL,TabInputTextDiff:Y.$EL,TabInputTextMerge:Y.$FL,TabInputCustom:Y.$GL,TabInputNotebook:Y.$IL,TabInputNotebookDiff:Y.$JL,TabInputWebview:Y.$HL,TabInputTerminal:Y.$KL,TabInputInteractiveWindow:Y.$LL,TelemetryTrustedValue:Ee.$$n,LogLevel:ve.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Y.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Y.$5K,ThreadFocus:Y.$6K,NotebookCodeActionKind:Y.$gK,RelatedInformationType:Y.RelatedInformationType}}}e.$Ucc=Bt}),define(Ae[273],Re([1,0,70,110,33,108,34,31,59,62,112,114,115,84,86,80,109,61,39,83,57,60,241,14,113,81,82]),function(be,e,w,F,C,L,A,l,S,d,P,D,u,b,p,f,i,t,c,g,E,$,s,a,n,o,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$lr)(o.$vbc,o.$ubc,1),(0,w.$lr)(a.$5i,s.$Vcc,1),(0,w.$lr)(f.$Uac,f.$Vac,1),(0,w.$lr)(l.$hM,l.$gM,0),(0,w.$lr)(A.$8ac,A.$6ac,0),(0,w.$lr)(t.$kbc,t.$jbc,0),(0,w.$lr)(D.$$bc,D.$ccc,0),(0,w.$lr)(L.$3bc,L.$2bc,0),(0,w.$lr)(S.$9L,S.$8L,0),(0,w.$lr)(y.$wbc,y.$xbc,0),(0,w.$lr)(c.$Rac,c.$Qac,0),(0,w.$lr)(F.$Ibc,F.$Hbc,1),(0,w.$lr)(u.$icc,u.$jcc,0),(0,w.$lr)(b.$gbc,b.$fbc,0),(0,w.$lr)(P.$6bc,P.$5bc,0),(0,w.$lr)(d.$nbc,d.$qbc,0),(0,w.$lr)(p.$jsb,p.$ksb,0),(0,w.$lr)(i.$Ybc,i.$Xbc,0),(0,w.$lr)(C.$5ac,C.$4ac,0),(0,w.$lr)(g.$sbc,g.$rbc,0),(0,w.$lr)(E.$fM,E.$cM,0),(0,w.$lr)($.$7bc,$.$8bc,0),(0,w.$lr)(n.$9bc,n.$0bc,0)}),define(Ae[274],Re([1,0,272,35,2,269,7,13,260]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class d extends L.$Ycc{j(){}getModule(b,p){for(const f of this.b){const i=f(b);if(i){b=i;break}}if(this.a.has(b))return this.a.get(b).load(b,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends F.$zbc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(S.$4ec);const b=this.h.invokeFunction(w.$Ucc);this.r=this.h.createInstance(d,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,p,f){p=p.with({path:D(p.path,".js")});const i=b?.identifier.value;i&&performance.mark(`code/extHost/willFetchExtensionCode/${i}`);const t=C.URI.revive(await this.C.$asBrowserUri(p)),c=await fetch(t.toString(!0));if(i&&performance.mark(`code/extHost/didFetchExtensionCode/${i}`),c.status!==200)throw new Error(c.statusText);const g=await c.text(),E=`${p.toString(!0)}#vscode-extension`,$=`${g}
//# sourceURL=${E}`;let s;try{s=new Function("module","exports","require",$)}catch(y){throw console.error(i?`Loading code for extension ${i} failed: ${y.message}`:`Loading code failed: ${y.message}`),console.error(`${p.toString(!0)}${typeof y.line=="number"?` line ${y.line}`:""}${typeof y.column=="number"?` column ${y.column}`:""}`),console.error(y),y}b&&await this.w.initializeLocalizedMessages(b);const a={},n={exports:a},o=y=>{const m=this.r.getModule(y,p);if(m===void 0)throw new Error(`Cannot load module '${y}'`);return m};try{return f.codeLoadingStart(),i&&performance.mark(`code/extHost/willLoadExtensionCode/${i}`),s(n,a,o),n.exports!==a?n.exports:a}finally{i&&performance.mark(`code/extHost/didLoadExtensionCode/${i}`),f.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+b;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Gg)(10)}}e.$5ec=P;function D(u,b){return u.endsWith(b)?u:u+b}}),define(Ae[275],Re([1,0,69,70,14,35,188,85,274]),function(be,e,w,F,C,L,A,l,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$lr)(C.$4i,new w.$xh(A.$Xcc,[!0],!0)),(0,F.$lr)(L.$Abc,S.$5ec,0),(0,F.$lr)(l.$lbc,l.$mbc,0)}),define(Ae[284],Re([1,0,25,5,79,270,262,19,87,12,2,273,275]),function(be,e,w,F,C,L,A,l,S,d,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(s){return/^(file|vscode-remote):/i.test(s)}const p=fetch.bind(self);function f(s){self.fetch=async function(a,n){return a instanceof Request||b(String(a))&&(a=(await s(P.URI.parse(String(a)))).toString(!0)),p(a,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,n,o,y,m){(async()=>(b(n.toString())&&(n=(await s(P.URI.parse(n.toString()))).toString(!0)),super.open(a,n,o??!0,y,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(a,n){if(/^file:/i.test(a.toString()))a=d.$1f.uriToBrowserUri(P.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const y=`(${function(r){function h(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const v=fetch.bind(self);self.fetch=function(W,V){return W instanceof Request?v(W,V):v(h(W),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,V,U,B,O){return super.open(W,h(V),U??!0,B,O)}};const R=importScripts.bind(self);self.importScripts=(...W)=>{R(...W.map(h))},R(r)}.toString()}('${a}'))`;n=n||{},n.name=n.name||l.$_d(a.toString());const m=new Blob([y],{type:"application/javascript"}),I=URL.createObjectURL(m);return new s(I,n)}}else self.Worker=class extends A.$6ec{constructor(s,a){super(u,s,{name:l.$_d(s.toString()),...a})}};const i=new class{constructor(){this.pid=void 0}exit(s){D()}};class t{constructor(){const a=new MessageChannel,n=new F.$ed;let o=!1;u(a.port2,[a.port2]),a.port1.onmessage=y=>{const{data:m}=y;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const I=w.$Ed.wrap(new Uint8Array(m,0,m.byteLength));if((0,C.$4l)(I,2)){o=!0,g("received terminate message from renderer");return}n.fire(I)},this.protocol={onMessage:n.event,send:y=>{if(!o){const m=y.buffer.buffer.slice(y.buffer.byteOffset,y.buffer.byteOffset+y.buffer.byteLength);a.port1.postMessage(m,[m])}}}}}function c(s){return new Promise(a=>{const n=s.onMessage(o=>{n.dispose();const y=JSON.parse(o.toString());s.send((0,C.$3l)(0)),a({protocol:s,initData:y})});s.send((0,C.$3l)(1))})}let g=s=>D();function E(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function $(){S.mark("code/extHost/willConnectToRenderer");const s=new t;return{onmessage(a){E(a)&&c(s.protocol).then(n=>{S.mark("code/extHost/didWaitForInitData");const o=new L.$1cc(n.protocol,n.initData,i,null,a.data);f(y=>o.asBrowserUri(y)),g=y=>o.terminate(y)})}}}e.create=$})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bccfade64adb249f57c8fcf03cba41609f76ce5c/core/vs/workbench/api/worker/extensionHostWorker.js.map
